PROMPT -- CREANDO PAQUETE SIS --;
CREATE OR REPLACE PACKAGE Sis IS
   PROCEDURE crea_secuencias(
    SISTEMA VARCHAR2 );
   ---------------------------------------------------------------------------------
   PROCEDURE borra_secuencias(
    SISTEMA VARCHAR2 );
   ----------------------------------------------------------------------------------
   PROCEDURE borra_sistema(
    SISTEMA  VARCHAR2 );
   --------------------------------------------------------------------------------
   PROCEDURE cambio_dni(SISTEMA VARCHAR2, DNI_ACTUAL VARCHAR2, DNI_NUEVO VARCHAR2);
   --------------------------------------------------------------------------------
   PROCEDURE cambio_dni_pendientes(SISTEMA VARCHAR2, DNI_ACTUAL VARCHAR2, DNI_NUEVO VARCHAR2);
   --------------------------------------------------------------------------------
   PROCEDURE cambio_dni_borra(SISTEMA VARCHAR2, DNI_ACTUAL VARCHAR2, DNI_NUEVO VARCHAR2);
   --------------------------------------------------------------------------------
   PROCEDURE TRASPASO_TAREAS(SISTEMA VARCHAR2, DNI_ACTUAL VARCHAR2, DNI_NUEVO VARCHAR2);
    --------------------------------------------------------------------------------
   PROCEDURE TRASPASO_TAREAS_PENDIENTES(SISTEMA VARCHAR2, DNI_ACTUAL VARCHAR2, DNI_NUEVO VARCHAR2);
 END Sis ;
/

CREATE OR REPLACE PACKAGE BODY Sis IS
PROCEDURE CREA_SECUENCIAS(sistema IN VARCHAR2 ) IS
   c1 BINARY_INTEGER;
   SEC_CREATE VARCHAR2(128);
   SEC_GRANT_ALT VARCHAR2(128);
   SEC_GRANT_SEL VARCHAR2(128);

-- 1. CON EL USUARIO SYSTEM EJECUTAR "GRANT create sequence TO DUMBO;"
-- PARA QUE EL USUARIO DUMBO TENGA PERMISO DE CREACION DE SECUENCIAS.
-- 2. CON EL USUARIO DUMBO EJECUTAR "GRANT EXECUTE ON CREA_SECUENCIAS TO JV_DUMBO;"
-- PARA QUE EL USUARIO JV_DUMBO TENGA PERMISO DE EJECUCION DE ESTE PROCEDIEMIENTO.

BEGIN
   c1 := dbms_sql.open_cursor;

   -- CREACION DE SECUENCIA PARA TAREAS
   SEC_CREATE := 'CREATE SEQUENCE '||SISTEMA||'_TAR_D7_TAREAS START WITH 1 INCREMENT BY 1 MINVALUE 1 NOCACHE NOCYCLE';
   SEC_GRANT_ALT := 'GRANT ALTER ON  '||SISTEMA||'_TAR_D7_TAREAS TO JV_DUMBO';
   SEC_GRANT_SEL := 'GRANT SELECT ON '||SISTEMA||'_TAR_D7_TAREAS TO JV_DUMBO';
   BEGIN
      dbms_sql.parse(c1, SEC_CREATE, dbms_sql.native);
      dbms_sql.parse(c1, SEC_GRANT_ALT, dbms_sql.native);
      dbms_sql.parse(c1, SEC_GRANT_SEL, dbms_sql.native);
   EXCEPTION WHEN OTHERS THEN NULL;
   END;


   -- CREACION DE SECUENCIA PARA CATEGORIAS
   SEC_CREATE := 'CREATE SEQUENCE '||SISTEMA||'_CAT_D7_CATEGORIAS START WITH 1 INCREMENT BY 1 MINVALUE 1 NOCACHE NOCYCLE';
   SEC_GRANT_ALT := 'GRANT ALTER ON  '||SISTEMA||'_CAT_D7_CATEGORIAS TO JV_DUMBO';
   SEC_GRANT_SEL := 'GRANT SELECT ON '||SISTEMA||'_CAT_D7_CATEGORIAS TO JV_DUMBO';
   BEGIN
      dbms_sql.parse(c1, SEC_CREATE, dbms_sql.native);
      dbms_sql.parse(c1, SEC_GRANT_ALT, dbms_sql.native);
      dbms_sql.parse(c1, SEC_GRANT_SEL, dbms_sql.native);
   EXCEPTION WHEN OTHERS THEN NULL;
   END;


   -- CREACION DE SECUENCIA PARA SISTEMAS_NOTICIAS
   SEC_CREATE := 'CREATE SEQUENCE '||SISTEMA||'_SNO_D7_SISTEMAS_NOTICIAS START WITH 1 INCREMENT BY 1 MINVALUE 1 NOCACHE NOCYCLE';
   SEC_GRANT_ALT := 'GRANT ALTER ON  '||SISTEMA||'_SNO_D7_SISTEMAS_NOTICIAS TO JV_DUMBO';
   SEC_GRANT_SEL := 'GRANT SELECT ON '||SISTEMA||'_SNO_D7_SISTEMAS_NOTICIAS TO JV_DUMBO';
   BEGIN
      dbms_sql.parse(c1, SEC_CREATE, dbms_sql.native);
      dbms_sql.parse(c1, SEC_GRANT_ALT, dbms_sql.native);
      dbms_sql.parse(c1, SEC_GRANT_SEL, dbms_sql.native);
   EXCEPTION WHEN OTHERS THEN NULL;
   END;

   dbms_sql.close_cursor(c1);
END;

PROCEDURE BORRA_SECUENCIAS(sistema IN VARCHAR2 ) IS
   c1 BINARY_INTEGER;
   SEC_DROP VARCHAR2(64);


-- CON EL USUARIO DUMBO EJECUTAR "GRANT EXECUTE ON BORRA_SECUENCIAS TO JV_DUMBO;"
-- PARA QUE EL USUARIO JV_DUMBO TENGA PERMISO DE EJECUCION DE ESTE PROCEDIEMIENTO


BEGIN
   c1 := dbms_sql.open_cursor;

   -- BORRA SECUENCIA TAREAS
   SEC_DROP := 'DROP SEQUENCE '||SISTEMA||'_TAR_D7_TAREAS';
   BEGIN
   dbms_sql.parse(c1, SEC_DROP, dbms_sql.native);
   EXCEPTION WHEN OTHERS THEN NULL;
   END;


   -- BORRA SECUENCIA PARA CATEGORIAS
    SEC_DROP := 'DROP SEQUENCE '||SISTEMA||'_CAT_D7_CATEGORIAS';
    BEGIN
    dbms_sql.parse(c1, SEC_DROP, dbms_sql.native);
    EXCEPTION WHEN OTHERS THEN NULL;
   END;

   -- BORRA SECUENCIA SISTEMAS_NOTICIAS
   SEC_DROP := 'DROP SEQUENCE '||SISTEMA||'_SNO_D7_SISTEMAS_NOTICIAS';
   BEGIN
     dbms_sql.parse(c1, SEC_DROP, dbms_sql.native);
   EXCEPTION WHEN OTHERS THEN NULL;
   END;


   dbms_sql.close_cursor(c1);
END;

PROCEDURE BORRA_SISTEMA(sistema IN VARCHAR2) IS

-- CON EL USUARIO DUMBO EJECUTAR "GRANT EXECUTE ON BORRA_SISTEMA  TO JV_DUMBO;"
-- PARA QUE EL USUARIO JV_DUMBO TENGA PERMISO DE EJECUCION DE ESTE PROCEDIEMIENTO

BEGIN

   -- BORRA TABLA D7_SISTEMAS NOTICIAS
   DELETE FROM D7_SISTEMAS_NOTICIAS WHERE SNO_SIS_COD=   SISTEMA ;

   -- BORRA TABLA D7_FILTROS_USUARIO
   DELETE FROM D7_FILTROS_USUARIO  WHERE FIL_SIS_COD=   SISTEMA ;

   -- BORRA TABLA D7_SECCIONES_MAXIMOS
   DELETE FROM D7_SECCIONES_MAXIMOS WHERE MAX_SIS_COD = SISTEMA ;

   -- BORRA TABLA D7_APLICACIONES_MAXIMOS
   DELETE FROM D7_APLICACIONES_MAXIMOS WHERE AMA_SIS_COD = SISTEMA ;

   -- BORRA TABLA D7_PARAMETROS_MAXIMOS
   DELETE FROM D7_PARAMETROS_MAXIMOS WHERE PMX_SIS_COD = SISTEMA ;

   -- BORRA TABLA D7_INFORMATICOS_PERFILES
   DELETE FROM D7_INFORMATICOS_PERFILES WHERE IPE_SIS_COD = SISTEMA ;

   -- BORRA TABLA D7_APLICACIONES_INFORMATICOS
   DELETE FROM D7_APLICACIONES_INFORMATICOS WHERE AIN_SIS_COD = SISTEMA ;

   -- BORRA TABLA D7_PARAMETROS
   DELETE FROM D7_PARAMETROS WHERE PAR_SIS_COD = SISTEMA ;

   -- BORRA TABLA D7_APLICACIONES_PARAMETROS
   DELETE FROM D7_APLICACIONES_PARAMETROS WHERE APA_SIS_COD = SISTEMA ;

   -- BORRA TABLA D7_PERFILES
   DELETE FROM D7_PERFILES WHERE PER_SIS_COD = SISTEMA ;

   -- BORRA TABLA D7_TAREAS_MOVIMIENTOS
   DELETE FROM D7_TAREAS_MOVIMIENTOS WHERE TMO_SIS_COD = SISTEMA ;

   -- BORRA TABLA D7_TAREAS_ALERTAS
   DELETE FROM D7_TAREAS_ALERTAS WHERE TAL_SIS_COD = SISTEMA ;

   -- BORRA TABLA D7_TAREAS_PROGRAMADAS
   DELETE FROM D7_TAREAS_PROGRAMADAS WHERE TPR_SIS_COD =  SISTEMA ;

   -- BORRA TABLA D7_TAREAS_SEGUIMIENTOS
   DELETE FROM D7_TAREAS_SEGUIMIENTOS WHERE TSE_SIS_COD = SISTEMA ;

   -- BORRA TABLA D7_USUARIOS_GRUPOS
   DELETE FROM D7_USUARIOS_GRUPOS WHERE UGR_SIS_COD = SISTEMA ;

   -- BORRA TABLA D7_GRUPOS_USUARIOS
   DELETE FROM D7_GRUPOS_USUARIOS WHERE GRU_SIS_COD = SISTEMA ;

   -- BORRA TABLA D7_GRUPOS_USUARIOS
   DELETE FROM D7_GRUPOS_USUARIOS WHERE GRU_SIS_COD = SISTEMA ;

   -- BORRA TABLA D7_TAREAS
   DELETE FROM D7_TAREAS WHERE TAR_SIS_COD = SISTEMA ;

   -- BORRA TABLA D7_PRIORIDADES
   DELETE FROM D7_PRIORIDADES WHERE PRI_SIS_COD = SISTEMA ;

   -- BORRA TABLA D7_APLICACIONES
   DELETE FROM D7_APLICACIONES WHERE APL_SIS_COD =  SISTEMA ;

   -- BORRA TABLA D7_INFORMATICOS
   DELETE FROM D7_INFORMATICOS WHERE INF_SIS_COD =  SISTEMA ;

   -- BORRA TABLA D7_GRUPO_COSTES
   DELETE FROM D7_GRUPOS_COSTES WHERE GCO_SIS_COD = SISTEMA ;

   -- BORRA TABLA D7_CATEGORIAS
   DELETE FROM D7_CATEGORIAS WHERE CAT_SIS_COD =  SISTEMA ;

   -- BORRA TABLA D7_SECCIONES
   DELETE FROM D7_SECCIONES WHERE SEC_SIS_COD = SISTEMA ;

   -- BORRA TABLA D7_TIPOS_TAREAS
   DELETE FROM D7_TIPOS_TAREAS WHERE TIP_SIS_COD =  SISTEMA ;

   -- BORRA TABLA D7_PLANTILLAS_NOTIFICACIONES
   DELETE FROM D7_PLANTILLAS_NOTIFICACIONES WHERE PLN_SIS_COD =  SISTEMA ;

   -- BORRA TABLA D7_SISTEMAS
   DELETE FROM D7_SISTEMAS WHERE SIS_COD = SISTEMA  ;

   COMMIT;
  --   EXCEPTION WHEN OTHERS THEN ROLLBACK;
END;

--TRASPASA TAREAS PENDIENTES Y NO PENDIENTES
PROCEDURE CAMBIO_DNI(SISTEMA IN VARCHAR2, DNI_ACTUAL IN VARCHAR2, DNI_NUEVO IN VARCHAR2) IS
 BEGIN
    UPDATE D7_TAREAS SET TAR_INF_COD=DNI_NUEVO WHERE TAR_INF_COD=DNI_ACTUAL AND TAR_SIS_COD=SISTEMA;
    UPDATE D7_USUARIOS_GRUPOS SET UGR_USU_COD=DNI_NUEVO WHERE UGR_USU_COD=DNI_ACTUAL AND UGR_SIS_COD=SISTEMA;
	UPDATE D7_SECCIONES SET SEC_ID_RESPON=DNI_NUEVO WHERE SEC_ID_RESPON=DNI_ACTUAL AND SEC_SIS_COD=SISTEMA;
	UPDATE D7_TAREAS_MOVIMIENTOS SET TMO_INF_COD=DNI_NUEVO WHERE TMO_INF_COD=DNI_ACTUAL AND TMO_SIS_COD=SISTEMA;
    UPDATE D7_APLICACIONES_INFORMATICOS SET AIN_INF_COD=DNI_NUEVO WHERE AIN_INF_COD=DNI_ACTUAL AND AIN_SIS_COD=SISTEMA;
	UPDATE D7_INFORMATICOS_PERFILES SET IPE_INF_COD=DNI_NUEVO WHERE IPE_INF_COD=DNI_ACTUAL AND IPE_SIS_COD=SISTEMA;
	COMMIT;
 END;
 --TRASPASA SOLO PENDIENTES
 PROCEDURE CAMBIO_DNI_PENDIENTES(SISTEMA IN VARCHAR2, DNI_ACTUAL IN VARCHAR2, DNI_NUEVO IN VARCHAR2) IS
 BEGIN
    UPDATE D7_TAREAS SET TAR_INF_COD=DNI_NUEVO WHERE TAR_INF_COD=DNI_ACTUAL AND TAR_SIS_COD=SISTEMA AND TAR_ESTADO NOT IN ('R','F');--NO RESUELTAS Y NO RESUELTAS CON SUBTAREAS
    UPDATE D7_USUARIOS_GRUPOS SET UGR_USU_COD=DNI_NUEVO WHERE UGR_USU_COD=DNI_ACTUAL AND UGR_SIS_COD=SISTEMA;
	UPDATE D7_SECCIONES SET SEC_ID_RESPON=DNI_NUEVO WHERE SEC_ID_RESPON=DNI_ACTUAL AND SEC_SIS_COD=SISTEMA;
	UPDATE D7_TAREAS_MOVIMIENTOS SET TMO_INF_COD=DNI_NUEVO WHERE TMO_INF_COD=DNI_ACTUAL AND TMO_SIS_COD=SISTEMA;
    UPDATE D7_APLICACIONES_INFORMATICOS SET AIN_INF_COD=DNI_NUEVO WHERE AIN_INF_COD=DNI_ACTUAL AND AIN_SIS_COD=SISTEMA;
	UPDATE D7_INFORMATICOS_PERFILES SET IPE_INF_COD=DNI_NUEVO WHERE IPE_INF_COD=DNI_ACTUAL AND IPE_SIS_COD=SISTEMA;
	COMMIT;
 END;
PROCEDURE CAMBIO_DNI_BORRA(SISTEMA IN VARCHAR2, DNI_ACTUAL IN VARCHAR2, DNI_NUEVO IN VARCHAR2) IS
 BEGIN
    --UPDATE D7_INFORMATICOS SET INF_COD=DNI_NUEVO WHERE INF_COD=DNI_ACTUAL AND INF_SIS_COD=SISTEMA;
    UPDATE D7_TAREAS SET TAR_INF_COD=DNI_NUEVO WHERE TAR_INF_COD=DNI_ACTUAL AND TAR_SIS_COD=SISTEMA;
    UPDATE D7_USUARIOS_GRUPOS SET UGR_USU_COD=DNI_NUEVO WHERE UGR_USU_COD=DNI_ACTUAL AND UGR_SIS_COD=SISTEMA;
	UPDATE D7_SECCIONES SET SEC_ID_RESPON=DNI_NUEVO WHERE SEC_ID_RESPON=DNI_ACTUAL AND SEC_SIS_COD=SISTEMA;
	UPDATE D7_TAREAS_MOVIMIENTOS SET TMO_INF_COD=DNI_NUEVO WHERE TMO_INF_COD=DNI_ACTUAL AND TMO_SIS_COD=SISTEMA;
    UPDATE D7_APLICACIONES_INFORMATICOS SET AIN_INF_COD=DNI_NUEVO WHERE AIN_INF_COD=DNI_ACTUAL AND AIN_SIS_COD=SISTEMA;
	UPDATE D7_INFORMATICOS_PERFILES SET IPE_INF_COD=DNI_NUEVO WHERE IPE_INF_COD=DNI_ACTUAL AND IPE_SIS_COD=SISTEMA;
	COMMIT;
	DELETE D7_INFORMATICOS WHERE INF_COD=DNI_ACTUAL AND INF_SIS_COD=SISTEMA;
	COMMIT;

 END;

--TRASPASA TODAS LAS TAREAS
PROCEDURE TRASPASO_TAREAS(SISTEMA IN VARCHAR2, DNI_ACTUAL IN VARCHAR2, DNI_NUEVO IN VARCHAR2) IS
 BEGIN
     UPDATE D7_TAREAS SET TAR_INF_COD=DNI_NUEVO WHERE TAR_INF_COD=DNI_ACTUAL AND TAR_SIS_COD=SISTEMA;
	 COMMIT;
 END;
--SOLO TRASPASA LAS PENDIENTES
 PROCEDURE TRASPASO_TAREAS_PENDIENTES(SISTEMA IN VARCHAR2, DNI_ACTUAL IN VARCHAR2, DNI_NUEVO IN VARCHAR2) IS
 BEGIN
     UPDATE D7_TAREAS SET TAR_INF_COD=DNI_NUEVO WHERE TAR_INF_COD=DNI_ACTUAL AND TAR_SIS_COD=SISTEMA AND TAR_ESTADO NOT IN ('R','F');--NO RESUELTAS Y NO RESUELTAS CON SUBTAREAS
	 COMMIT;
 END;

END Sis;
/

/* COMO USUARIO DUMBO */
GRANT EXECUTE ON SIS TO JV_DUMBO;

