PROMPT -- CREANDO PAQUETE ALERTAS --;
CREATE OR REPLACE PACKAGE Alertas IS
   PROCEDURE Enviar_Alertas;
    --El procedimiento generar_alertas llama a todos los procedimientos para
	--generar las alertas de nivel 1,2,3 de pendientes y planificadas
	PROCEDURE Generar_Alertas(SISTEMA VARCHAR2);
    ---------------------------------------------------------------------
    PROCEDURE Alertas_pendientes_nivel_1(
    SISTEMA VARCHAR2 );
    ---------------------------------------------------------------------
    PROCEDURE Alertas_pendientes_nivel_2(
    SISTEMA VARCHAR2 );
    ---------------------------------------------------------------------
	 PROCEDURE Alertas_pendientes_nivel_3(
    SISTEMA VARCHAR2 );
    ---------------------------------------------------------------------
	   PROCEDURE Alertas_planificadas_nivel_1(
    SISTEMA VARCHAR2 );
    ---------------------------------------------------------------------
		   PROCEDURE Alertas_planificadas_nivel_2(
    SISTEMA VARCHAR2 );
    ---------------------------------------------------------------------
		   PROCEDURE Alertas_planificadas_nivel_3(
    SISTEMA VARCHAR2 );
    ---------------------------------------------------------------------
	FUNCTION orden_sec(sistema IN VARCHAR2, sec IN VARCHAR2) RETURN NUMBER;
	FUNCTION Dias_Laborables(start_date IN DATE, end_date IN DATE) RETURN NUMBER;
	FUNCTION Dias_Laborables2(start_date IN DATE, end_date IN DATE) RETURN NUMBER;
	FUNCTION dias_habiles(fecha in date,dias in number) return number;

END Alertas;
/

CREATE OR REPLACE PACKAGE BODY Alertas IS

FUNCTION Dias_Laborables(start_date IN DATE, end_date IN DATE)
RETURN NUMBER
IS
 retval NUMBER(15,7);
 new_start_date DATE;
 new_end_date DATE;
 bdaystart NUMBER(15,15);
 bdayend NUMBER(15,15);
BEGIN
--new_start_date := TO_DATE(TO_CHAR(start_date,'ddmmyyyy'));
--new_end_date := TO_DATE(TO_CHAR(end_date,'ddmmyyyy'));
-- set defaults for business day start and end. Can be overridden per region
bdaystart := 7/24;
bdayend := 21/24;
--new_start_date := new_start_date + 9/24;
--new_end_date := new_end_date + 9/24;
new_start_date := start_date;
new_end_date := end_date;
bdaystart := 7.5/24;
bdayend := 20.5/24;
/*
bdaystart := 7/24;
bdayend := 17/24;
new_start_date := new_start_date + 9/24;
new_end_date := new_end_date + 9/24;
bdaystart := 9/24;
bdayend := 18.5/24;
*/
--Start After end of day, make start be start of next day
IF new_start_date-TRUNC(new_start_date)>bdayend THEN
 new_start_date := TRUNC(new_start_date+1)+bdaystart;
END IF;
--Start before start of day, make start be start of same day
IF new_start_date-TRUNC(new_start_date) < bdaystart THEN
 new_start_date := TRUNC(new_start_date) + bdaystart;
END IF;
--Start Saturday, make start be Monday start of day
IF TO_CHAR(new_start_date,'D')=7 THEN
 new_start_date := TRUNC(new_start_date+2)+bdaystart;
END IF;
--Start Sunday, make start be Monday start of day
IF TO_CHAR(new_start_date,'D')=1 THEN
 new_start_date := TRUNC(new_start_date+1)+bdaystart;
END IF;
-- end after end of day, make end be end of day same day
IF new_end_date-TRUNC(new_end_date) > bdayend THEN
 new_end_date := TRUNC(new_end_date) + bdayend;
END IF;
-- end before start of day, make end be start of day the same day
IF new_end_date-TRUNC(new_end_date) < bdaystart THEN
 new_end_date := TRUNC(new_end_date) + bdaystart;
END IF;
--end on Saturday, make it be the end of the day on Friday
IF TO_CHAR(new_end_date,'D')=7 THEN
 new_end_date := TRUNC(new_end_date-1) + bdayend;
END IF;
--end on Sunday, make it be the end of the day on Friday
IF TO_CHAR(new_end_date,'D')=1 THEN
 new_end_date := TRUNC(new_end_date-2) + bdayend;
END IF;
--factor out weekend days
retval := new_end_date - new_start_date -
((TRUNC(new_end_date,'D') - TRUNC(new_start_date,'D'))/7)*2;
-- if holidays were to be calculated, the calculation would go here
-- if end is during nonbusiness hours, difference could be negative
IF retval < 0 THEN
 retval := 0;
END IF;
RETURN(retval);
END;

FUNCTION Dias_Laborables2(start_date IN DATE, end_date IN DATE) RETURN NUMBER IS
semini varchar2(3);
semfin varchar2(3);
fini date;
ffin date;
fines number(5);
festivos number(3);
BEGIN

fini := start_date;
ffin := end_date;

if to_char(fini,'D')>5 then
   fini := fini + 8 - to_char(fini,'D');
end if;

if to_char(ffin,'D')>5 then
   ffin := ffin - (to_char(ffin,'D') - 5);
end if;
fines := floor((ffin-fini)/7);
if to_char(fini,'D')>to_char(ffin,'D')  then
	 fines := fines + 1;
end if;
/*
semini := to_char(fini,'IW');
semfin := to_char(ffin,'IW');

fines := semfin-semini;
if (fines<0) then
	 fines := 52+fines;
end if;
*/
festivos := pkd7_personal.cuenta_festivos(fini,ffin);

RETURN ceil(ffin-fini)-(fines*2)-festivos;
END;

FUNCTION orden_sec(sistema IN VARCHAR2, sec IN VARCHAR2)
RETURN NUMBER
IS orden_sec NUMBER(7);
BEGIN
DECLARE CURSOR raices IS SELECT ROWNUM, sec_cod FROM D7_SECCIONES WHERE sec_sis_cod=sistema AND sec_sec_cod=sec_cod;
BEGIN
           SELECT SUM(100*LEVEL) INTO orden_sec FROM D7_SECCIONES s1
               WHERE s1.sec_sis_cod = sistema
          START WITH s1.sec_cod = sec AND sec_sis_cod=sistema
          CONNECT BY PRIOR s1.sec_cod = s1.sec_sec_cod
          AND s1.sec_sis_cod=sistema
          AND s1.sec_cod != s1.sec_sec_cod;
END;
RETURN(ORDEN_SEC);
END;


PROCEDURE Generar_Alertas (SISTEMA VARCHAR2) IS
BEGIN
   Alertas_pendientes_nivel_1(SISTEMA);
    Alertas_pendientes_nivel_2(SISTEMA);
    Alertas_pendientes_nivel_3(SISTEMA);
    Alertas_planificadas_nivel_1(SISTEMA);
    Alertas_planificadas_nivel_2(SISTEMA);
    Alertas_planificadas_nivel_3(SISTEMA);
END;

PROCEDURE Enviar_Alertas IS
CURSOR sistemas IS
	   SELECT sis_cod 
	   FROM D7_SISTEMAS 
	   WHERE sis_ind_int='I' 
	   AND sis_cod!='DEF';
cod VARCHAR2(3);
BEGIN

	 OPEN sistemas;
	 FETCH sistemas INTO cod;
	 WHILE sistemas%FOUND LOOP
	 	   Generar_Alertas(cod);
		   Pkd7_Mail.Notificar_Alertas(cod);
		   FETCH sistemas INTO cod;
	 END LOOP;
	 CLOSE sistemas;

END;

-- ================================
-- ALERTAS PARA TAREAS PENDIENTES
-- ================================

PROCEDURE Alertas_Pendientes_Nivel_1 (SISTEMA VARCHAR2) IS
 CURSOR C_TAREAS  IS
        SELECT T.TAR_SIS_COD, T.TAR_PRI_COD, T.TAR_TIP_COD, T.TAR_APL_COD, T.TAR_COD, T.TAR_FECCREA,
         NVL(AM.AMA_DIAS, (SELECT NVL(MAX(SAM.AMA_DIAS),0) FROM DUMBO.D7_APLICACIONES_MAXIMOS SAM
                              WHERE SAM.AMA_SIS_COD(+)=T.TAR_SIS_COD
                                AND SAM.AMA_TIP_COD(+)=T.TAR_TIP_COD
                                AND SAM.AMA_APL_COD(+)=T.TAR_APL_COD))
        FROM DUMBO.D7_TAREAS T, D7_APLICACIONES_MAXIMOS AM
         WHERE TAR_SIS_COD=SISTEMA
		 AND TAR_APL_COD != 'MIGRACION'
        AND TAR_ESTADO IN ('A','X')   -- TAREA ASIGNADA O RECHAZADO
         AND TAR_TIP_COD IN ('I','P')  -- TIPO DE TAREA INCIDENCIA O PETICION (EN PROBLEMAS NO HAY ALERTAS)
         AND (TAR_PRI_COD NOT IN ('P') OR TAR_PRI_COD IS NULL) -- TIPO DE PRIORIDAD DISTINTO DE PLANIFICADA
         AND AM.AMA_SIS_COD(+)=T.TAR_SIS_COD
         AND AM.AMA_TIP_COD(+)=T.TAR_TIP_COD
         AND AM.AMA_APL_COD(+)=T.TAR_APL_COD
         AND AM.AMA_PRI_COD(+)=T.TAR_PRI_COD
         AND Alertas.DIAS_LABORABLES2(TAR_FECCREA,SYSDATE)>= NVL(AM.AMA_DIAS, (SELECT NVL(MAX(SAM.AMA_DIAS),0) FROM DUMBO.D7_APLICACIONES_MAXIMOS SAM
                                                                          WHERE SAM.AMA_SIS_COD(+)=T.TAR_SIS_COD
                                                                            AND SAM.AMA_TIP_COD(+)=T.TAR_TIP_COD
                                                                            AND SAM.AMA_APL_COD(+)=T.TAR_APL_COD))
         AND NOT EXISTS (SELECT '*' FROM DUMBO.D7_TAREAS_ALERTAS
                         WHERE TAR_SIS_COD=TAL_SIS_COD
                           AND TAR_COD=TAL_TAR_COD
                           AND TAL_NIVEL='1');
WNIVEL VARCHAR2(1);

BEGIN
 WNIVEL:='1'; -- NIVEL DE ALERTA 1
 FOR v_t IN c_tareas LOOP
  BEGIN
    INSERT INTO D7_TAREAS_ALERTAS VALUES (SISTEMA , V_T.TAR_COD, TO_NUMBER(WNIVEL), SYSDATE, WNIVEL, 'N');
        EXCEPTION WHEN DUP_VAL_ON_INDEX THEN NULL;
  END;
 END LOOP;
 COMMIT;

END;

------------------------------------------------------------------------------------------------------------------------------
PROCEDURE Alertas_Pendientes_Nivel_2 (SISTEMA VARCHAR2 ) IS
 CURSOR C_TAREAS  IS
        SELECT T.TAR_SIS_COD, T.TAR_PRI_COD, T.TAR_TIP_COD, T.TAR_APL_COD, T.TAR_COD, T.TAR_FECCREA,
         NVL(SM.MAX_DIAS, (SELECT NVL(MAX(SSM.MAX_DIAS),0) FROM DUMBO.D7_SECCIONES_MAXIMOS SSM
                              WHERE SSM.MAX_SIS_COD(+)=T.TAR_SIS_COD
                                AND SSM.MAX_TIP_COD(+)=T.TAR_TIP_COD
                                AND SSM.MAX_SEC_COD(+)=A.APL_SEC_COD)),
         A.APL_SEC_COD
        FROM DUMBO.D7_TAREAS T, D7_SECCIONES_MAXIMOS SM, D7_APLICACIONES A
         WHERE TAR_SIS_COD=SISTEMA
		 AND TAR_APL_COD != 'MIGRACION'
        AND TAR_ESTADO IN ('A','X') -- TAREA ASIGNADA O RECHAZADO
         AND TAR_TIP_COD IN ('I','P')  -- TIPO DE TAREA INCIDENCIA O PETICION (EN PROBLEMAS NO HAY ALERTAS)
         AND (TAR_PRI_COD NOT IN ('P') OR TAR_PRI_COD IS NULL) -- TIPO DE PRIORIDAD DISTINTO DE PLANIFICADA
         AND A.APL_SIS_COD=T.TAR_SIS_COD
         AND A.APL_COD=T.TAR_APL_COD
         AND (SM.MAX_SEC_COD=A.APL_SEC_COD OR SM.MAX_SEC_COD IS NULL)
         AND SM.MAX_SIS_COD(+)=T.TAR_SIS_COD
         AND SM.MAX_PRI_COD(+)=T.TAR_PRI_COD
         AND SM.MAX_TIP_COD(+)=T.TAR_TIP_COD
         AND Alertas.DIAS_LABORABLES2(TAR_FECCREA,SYSDATE)>=  NVL(SM.MAX_DIAS, (SELECT NVL(MAX(SSM.MAX_DIAS),0) FROM DUMBO.D7_SECCIONES_MAXIMOS SSM
                                                                          WHERE SSM.MAX_SIS_COD(+)=T.TAR_SIS_COD
                                                                            AND SSM.MAX_TIP_COD(+)=T.TAR_TIP_COD
                                                                            AND SSM.MAX_SEC_COD(+)=A.APL_SEC_COD))
         AND NOT EXISTS (SELECT '*' FROM DUMBO.D7_TAREAS_ALERTAS
                          WHERE TAR_SIS_COD=TAL_SIS_COD
                             AND TAR_COD=TAL_TAR_COD
                            AND TAL_NIVEL='2');

         WNIVEL VARCHAR2(1);

BEGIN
 WNIVEL:='2'; -- NIVEL DE ALERTA 2
 FOR v_t IN c_tareas LOOP
     BEGIN
       INSERT INTO D7_TAREAS_ALERTAS VALUES (SISTEMA , V_T.TAR_COD, TO_NUMBER(WNIVEL), SYSDATE, WNIVEL, 'N');
         EXCEPTION WHEN DUP_VAL_ON_INDEX THEN NULL;
     END;
 END LOOP;
 COMMIT;
END;

------------------------------------------------------------------------------------------------------------------------------
PROCEDURE Alertas_Pendientes_Nivel_3 (SISTEMA VARCHAR2 ) IS
 CURSOR C_TAREAS  IS
        SELECT T.TAR_SIS_COD, T.TAR_PRI_COD, T.TAR_TIP_COD, T.TAR_COD, T.TAR_FECCREA,         NVL(PM.PMX_DIAS, (SELECT NVL(MAX(SPM.PMX_DIAS),0) FROM DUMBO.D7_PARAMETROS_MAXIMOS SPM
                              WHERE SPM.PMX_SIS_COD(+)=T.TAR_SIS_COD
                                AND SPM.PMX_TIP_COD(+)=T.TAR_TIP_COD))
        FROM DUMBO.D7_TAREAS T, D7_PARAMETROS_MAXIMOS PM
         WHERE TAR_SIS_COD=SISTEMA
		 AND TAR_APL_COD != 'MIGRACION'
        AND TAR_ESTADO IN ('A','X')   -- TAREA ASIGNADA O RECHAZADO
         AND TAR_TIP_COD IN ('I','P')  -- TIPO DE TAREA INCIDENCIA O PETICION (EN PROBLEMAS NO HAY ALERTAS)
         AND (TAR_PRI_COD NOT IN ('P') OR TAR_PRI_COD IS NULL) -- TIPO DE PRIORIDAD DISTINTO DE PLANIFICADA
         AND PM.PMX_SIS_COD(+)=T.TAR_SIS_COD
         AND PM.PMX_TIP_COD(+)=T.TAR_TIP_COD
         AND PM.PMX_PRI_COD(+)=T.TAR_PRI_COD
         AND Alertas.DIAS_LABORABLES2(TAR_FECCREA,SYSDATE)>=NVL(PM.PMX_DIAS, (SELECT NVL(MAX(SPM.PMX_DIAS),0) FROM DUMBO.D7_PARAMETROS_MAXIMOS SPM
                                                                      WHERE SPM.PMX_SIS_COD(+)=T.TAR_SIS_COD
                                                                        AND SPM.PMX_TIP_COD(+)=T.TAR_TIP_COD))
         AND NOT EXISTS (SELECT '*' FROM DUMBO.D7_TAREAS_ALERTAS
                          WHERE TAR_SIS_COD=TAL_SIS_COD
                             AND TAR_COD=TAL_TAR_COD
                            AND TAL_NIVEL='3');
WNIVEL VARCHAR2(1);
BEGIN
 WNIVEL:='3'; -- NIVEL DE ALERTA 3
 FOR v_t IN c_tareas LOOP
     BEGIN
       INSERT INTO D7_TAREAS_ALERTAS VALUES (SISTEMA , V_T.TAR_COD, TO_NUMBER(WNIVEL), SYSDATE, WNIVEL, 'N');
         EXCEPTION WHEN DUP_VAL_ON_INDEX THEN NULL;
     END;
 END LOOP;
 COMMIT;
END;




-- ================================
-- ALERTAS PARA TAREAS PLANIFICADAS
-- ================================

PROCEDURE Alertas_Planificadas_Nivel_1 (SISTEMA VARCHAR2) IS
 CURSOR C_TAREAS  IS
        SELECT T.TAR_SIS_COD, T.TAR_PRI_COD, T.TAR_TIP_COD, T.TAR_APL_COD, T.TAR_COD, T.TAR_PLANIF,
         NVL(AM.AMA_DIAS, (SELECT NVL(MAX(SAM.AMA_DIAS),0) FROM DUMBO.D7_APLICACIONES_MAXIMOS SAM
                              WHERE SAM.AMA_SIS_COD(+)=T.TAR_SIS_COD
                                AND SAM.AMA_TIP_COD(+)=T.TAR_TIP_COD
                                AND SAM.AMA_APL_COD(+)=T.TAR_APL_COD))
        FROM DUMBO.D7_TAREAS T, D7_APLICACIONES_MAXIMOS AM
         WHERE TAR_SIS_COD=SISTEMA
		 AND TAR_APL_COD != 'MIGRACION'
        AND TAR_ESTADO IN ('A','X')   -- TAREA ASIGNADA O RECHAZADO
         AND TAR_TIP_COD IN ('I','P')  -- TIPO DE TAREA INCIDENCIA O PETICION (EN PROBLEMAS NO HAY ALERTAS)
         AND (TAR_PRI_COD IN ('P') OR TAR_PRI_COD IS NULL) -- TIPO DE PRIORIDAD IGUAL A PLANIFICADA
         AND AM.AMA_SIS_COD(+)=T.TAR_SIS_COD
         AND AM.AMA_TIP_COD(+)=T.TAR_TIP_COD
         AND AM.AMA_APL_COD(+)=T.TAR_APL_COD
         AND AM.AMA_PRI_COD(+)=T.TAR_PRI_COD
         AND Alertas.DIAS_LABORABLES2(TAR_PLANIF,SYSDATE)>= NVL(AM.AMA_DIAS, (SELECT NVL(MAX(SAM.AMA_DIAS),0) FROM DUMBO.D7_APLICACIONES_MAXIMOS SAM
                                                                          WHERE SAM.AMA_SIS_COD(+)=T.TAR_SIS_COD
                                                                            AND SAM.AMA_TIP_COD(+)=T.TAR_TIP_COD
                                                                            AND SAM.AMA_APL_COD(+)=T.TAR_APL_COD))
         AND NOT EXISTS (SELECT '*' FROM DUMBO.D7_TAREAS_ALERTAS
                         WHERE TAR_SIS_COD=TAL_SIS_COD
                           AND TAR_COD=TAL_TAR_COD
                           AND TAL_NIVEL='1');
WNIVEL VARCHAR2(1);

BEGIN
 WNIVEL:='1'; -- NIVEL DE ALERTA 1
 FOR v_t IN c_tareas LOOP
  BEGIN
    INSERT INTO D7_TAREAS_ALERTAS VALUES (SISTEMA , V_T.TAR_COD, TO_NUMBER(WNIVEL), SYSDATE, WNIVEL, 'N');
        EXCEPTION WHEN DUP_VAL_ON_INDEX THEN NULL;
  END;
 END LOOP;
 COMMIT;

END;

------------------------------------------------------------------------------------------------------------------------------
PROCEDURE Alertas_Planificadas_Nivel_2 (SISTEMA VARCHAR2 ) IS
 CURSOR C_TAREAS  IS
        SELECT T.TAR_SIS_COD, T.TAR_PRI_COD, T.TAR_TIP_COD, T.TAR_APL_COD, T.TAR_COD, T.TAR_PLANIF,
         NVL(SM.MAX_DIAS, (SELECT NVL(MAX(SSM.MAX_DIAS),0) FROM DUMBO.D7_SECCIONES_MAXIMOS SSM
                              WHERE SSM.MAX_SIS_COD(+)=T.TAR_SIS_COD
                                AND SSM.MAX_TIP_COD(+)=T.TAR_TIP_COD
                                AND SSM.MAX_SEC_COD(+)=A.APL_SEC_COD)),
         A.APL_SEC_COD
        FROM DUMBO.D7_TAREAS T, D7_SECCIONES_MAXIMOS SM, D7_APLICACIONES A
         WHERE TAR_SIS_COD=SISTEMA
		 AND TAR_APL_COD != 'MIGRACION'
        AND TAR_ESTADO IN ('A','X')   -- TAREA ASIGNADA O RECHAZADO
         AND TAR_TIP_COD IN ('I','P')  -- TIPO DE TAREA INCIDENCIA O PETICION (EN PROBLEMAS NO HAY ALERTAS)
         AND (TAR_PRI_COD IN ('P') OR TAR_PRI_COD IS NULL) -- TIPO DE PRIORIDAD IGUAL A PLANIFICADA
         AND A.APL_SIS_COD=T.TAR_SIS_COD
         AND A.APL_COD=T.TAR_APL_COD
         AND (SM.MAX_SEC_COD=A.APL_SEC_COD OR SM.MAX_SEC_COD IS NULL)
         AND SM.MAX_SIS_COD(+)=T.TAR_SIS_COD
         AND SM.MAX_PRI_COD(+)=T.TAR_PRI_COD
         AND SM.MAX_TIP_COD(+)=T.TAR_TIP_COD
         AND Alertas.DIAS_LABORABLES2(TAR_PLANIF,SYSDATE)>=  NVL(SM.MAX_DIAS, (SELECT NVL(MAX(SSM.MAX_DIAS),0) FROM DUMBO.D7_SECCIONES_MAXIMOS SSM
                                                                          WHERE SSM.MAX_SIS_COD(+)=T.TAR_SIS_COD
                                                                            AND SSM.MAX_TIP_COD(+)=T.TAR_TIP_COD
                                                                            AND SSM.MAX_SEC_COD(+)=A.APL_SEC_COD))
         AND NOT EXISTS (SELECT '*' FROM DUMBO.D7_TAREAS_ALERTAS
                          WHERE TAR_SIS_COD=TAL_SIS_COD
                             AND TAR_COD=TAL_TAR_COD
                            AND TAL_NIVEL='2');

         WNIVEL VARCHAR2(1);

BEGIN
 WNIVEL:='2'; -- NIVEL DE ALERTA 2
 FOR v_t IN c_tareas LOOP
     BEGIN
       INSERT INTO D7_TAREAS_ALERTAS VALUES (SISTEMA , V_T.TAR_COD, TO_NUMBER(WNIVEL), SYSDATE, WNIVEL, 'N');
         EXCEPTION WHEN DUP_VAL_ON_INDEX THEN NULL;
     END;
 END LOOP;
 COMMIT;
END;

------------------------------------------------------------------------------------------------------------------------------
PROCEDURE Alertas_Planificadas_Nivel_3 (SISTEMA VARCHAR2 ) IS
 CURSOR C_TAREAS  IS
        SELECT T.TAR_SIS_COD, T.TAR_PRI_COD, T.TAR_TIP_COD, T.TAR_COD, T.TAR_PLANIF,         NVL(PM.PMX_DIAS, (SELECT NVL(MAX(SPM.PMX_DIAS),0) FROM DUMBO.D7_PARAMETROS_MAXIMOS SPM
                              WHERE SPM.PMX_SIS_COD(+)=T.TAR_SIS_COD
                                AND SPM.PMX_TIP_COD(+)=T.TAR_TIP_COD))
        FROM DUMBO.D7_TAREAS T, D7_PARAMETROS_MAXIMOS PM
         WHERE TAR_SIS_COD=SISTEMA
		 AND TAR_APL_COD != 'MIGRACION'
        AND TAR_ESTADO IN ('A','X')   -- TAREA ASIGNADA O RECHAZADO
         AND TAR_TIP_COD IN ('I','P')  -- TIPO DE TAREA INCIDENCIA O PETICION (EN PROBLEMAS NO HAY ALERTAS)
         AND (TAR_PRI_COD IN ('P') OR TAR_PRI_COD IS NULL) -- TIPO DE PRIORIDAD IGUAL A PLANIFICADA
         AND PM.PMX_SIS_COD(+)=T.TAR_SIS_COD
         AND PM.PMX_TIP_COD(+)=T.TAR_TIP_COD
         AND PM.PMX_PRI_COD(+)=T.TAR_PRI_COD
         AND Alertas.DIAS_LABORABLES2(TAR_PLANIF,SYSDATE)>=NVL(PM.PMX_DIAS, (SELECT NVL(MAX(SPM.PMX_DIAS),0) FROM DUMBO.D7_PARAMETROS_MAXIMOS SPM
                                                                      WHERE SPM.PMX_SIS_COD(+)=T.TAR_SIS_COD
                                                                        AND SPM.PMX_TIP_COD(+)=T.TAR_TIP_COD))
         AND NOT EXISTS (SELECT '*' FROM DUMBO.D7_TAREAS_ALERTAS
                          WHERE TAR_SIS_COD=TAL_SIS_COD
                             AND TAR_COD=TAL_TAR_COD
                            AND TAL_NIVEL='3');
WNIVEL VARCHAR2(1);
BEGIN
 WNIVEL:='3'; -- NIVEL DE ALERTA 3
 FOR v_t IN c_tareas LOOP
     BEGIN
       INSERT INTO D7_TAREAS_ALERTAS VALUES (SISTEMA , V_T.TAR_COD, TO_NUMBER(WNIVEL), SYSDATE, WNIVEL, 'N');
         EXCEPTION WHEN DUP_VAL_ON_INDEX THEN NULL;
     END;
 END LOOP;
 COMMIT;
END;

FUNCTION dias_habiles(fecha in date,dias in number) return number is
naturales number := dias;
habiles number := dias;
begin
	 loop
	 	 select alertas.dias_laborables2(fecha,fecha+naturales) into habiles from dual;
		 exit when (habiles>=dias);
	 	 naturales := naturales+1;
	 end loop;
	 return naturales;
end;

END Alertas;
/

GRANT EXECUTE ON ALERTAS TO JV_DUMBO;
