PROMPT -- CREANDO PAQUETE FMETRICAS --;
CREATE OR REPLACE PACKAGE Fmetricas  IS
   FUNCTION Calcula_Dias(fecini  DATE, fecfin  DATE) RETURN NUMBER;
   -----------------------------------------------------------------------
   FUNCTION Calcula_Espera(sistema varchar2, tarea  varchar2) RETURN NUMBER;
   -----------------------------------------------------------------------
   FUNCTION es_ancestro(sistema varchar2, ancestro varchar2, nodo  varchar2) RETURN VARCHAR2;
   -----------------------------------------------------------------------
   FUNCTION tiene_tareas_gestor(sistema varchar2, nodo  varchar2, estado IN VARCHAR2, gestor IN VARCHAR2) RETURN VARCHAR2;
   -----------------------------------------------------------------------
   FUNCTION tiene_tareas_maestro(sistema varchar2, nodo  varchar2, estado IN VARCHAR2) RETURN VARCHAR2;
   -----------------------------------------------------------------------
   FUNCTION Atencion (sistema  VARCHAR2, tramo_bajo IN VARCHAR2,tramo_alto IN VARCHAR2, gestor IN VARCHAR2, tipo   VARCHAR2, fecini   DATE, fecfin DATE , apl   VARCHAR2, inf   VARCHAR2, usu  VARCHAR2, cat  VARCHAR2, grusu  VARCHAR2, sec  VARCHAR2) RETURN NUMBER;
   -----------------------------------------------------------------------
   FUNCTION Atencion_Desglose (sistema VARCHAR2, tramo_bajo IN VARCHAR2,tramo_alto IN VARCHAR2, gestor IN VARCHAR2, tipo VARCHAR2, fecini DATE, fecfin DATE, desglose VARCHAR2, Desglose_cod VARCHAR2, apl VARCHAR2, inf VARCHAR2, usu VARCHAR2, cat VARCHAR2, grusu VARCHAR2, sec VARCHAR2) RETURN NUMBER;
   -----------------------------------------------------------------------
   FUNCTION Atencion_Desglose_Tm (sistema VARCHAR2,tramo_bajo IN VARCHAR2,tramo_alto IN VARCHAR2, gestor IN VARCHAR2, tipo VARCHAR2, fecini DATE, fecfin DATE, desglose VARCHAR2 , Desglose_cod VARCHAR2, apl VARCHAR2, inf VARCHAR2, usu VARCHAR2, cat VARCHAR2, grusu VARCHAR2, sec VARCHAR2) RETURN NUMBER;
   -----------------------------------------------------------------------
   FUNCTION Atencion_Tm (sistema VARCHAR2, tramo_bajo IN VARCHAR2,tramo_alto IN VARCHAR2, gestor IN VARCHAR2, tipo VARCHAR2, fecini DATE, fecfin DATE, apl VARCHAR2, inf VARCHAR2, usu VARCHAR2, cat VARCHAR2, grusu VARCHAR2, sec VARCHAR2) RETURN NUMBER;
   -----------------------------------------------------------------------
   FUNCTION Dedicacion (sistema VARCHAR2, tramo_bajo IN VARCHAR2,tramo_alto IN VARCHAR2, gestor VARCHAR2, tipo VARCHAR2, fecini DATE, fecfin DATE ,  apl VARCHAR2, inf VARCHAR2, usu VARCHAR2, cat VARCHAR2, grusu VARCHAR2, sec VARCHAR2) RETURN NUMBER;
   -----------------------------------------------------------------------
   FUNCTION Dedicacion_Desglose (sistema VARCHAR2, tramo_bajo IN VARCHAR2,tramo_alto IN VARCHAR2,  gestor VARCHAR2, tipo VARCHAR2, fecini DATE, fecfin DATE, desglose VARCHAR2, Desglose_cod VARCHAR2, apl VARCHAR2, inf VARCHAR2, usu VARCHAR2, cat VARCHAR2, grusu VARCHAR2, sec VARCHAR2) RETURN NUMBER;
   -----------------------------------------------------------------------
   FUNCTION Dedicacion_Desglose_Tm (sistema VARCHAR2, tramo_bajo IN VARCHAR2,tramo_alto IN VARCHAR2, gestor VARCHAR2, tipo VARCHAR2, fecini DATE, fecfin DATE, desglose VARCHAR2 , Desglose_cod VARCHAR2, apl VARCHAR2, inf VARCHAR2, usu VARCHAR2, cat VARCHAR2, grusu VARCHAR2, sec VARCHAR2) RETURN NUMBER;
   -----------------------------------------------------------------------
   FUNCTION Dedicacion_Tm (sistema VARCHAR2, tramo_bajo IN VARCHAR2,tramo_alto IN VARCHAR2, gestor VARCHAR2, tipo VARCHAR2, fecini DATE, fecfin DATE, apl VARCHAR2, inf VARCHAR2, usu VARCHAR2, cat VARCHAR2, grusu VARCHAR2, sec VARCHAR2) RETURN NUMBER;
   -----------------------------------------------------------------------
   FUNCTION Estado (sistema VARCHAR2, estado VARCHAR2, gestor VARCHAR2,tipo VARCHAR2, fecini DATE, fecfin DATE , apl VARCHAR2, inf VARCHAR2, usu VARCHAR2, cat VARCHAR2, grusu VARCHAR2, Sec VARCHAR2) RETURN NUMBER;
   -----------------------------------------------------------------------
   FUNCTION Estado_Desglose (sistema VARCHAR2, estado VARCHAR2, gestor VARCHAR2,tipo VARCHAR2, fecini DATE, fecfin DATE, desglose VARCHAR2, Desglose_cod VARCHAR2, apl VARCHAR2, inf VARCHAR2, usu VARCHAR2, cat VARCHAR2, grusu VARCHAR2, Sec VARCHAR2) RETURN NUMBER;
   -----------------------------------------------------------------------
   FUNCTION YDias_Estadistico (sistema VARCHAR2, estado VARCHAR2,dias VARCHAR2,prioridad VARCHAR2, gestor IN VARCHAR2, tipo VARCHAR2, fecini DATE, fecfin DATE, Desglose_cod VARCHAR2, Sec VARCHAR2) RETURN NUMBER;
   -----------------------------------------------------------------------
   FUNCTION Desviacion_Estadistico (sistema VARCHAR2,desv VARCHAR2,prioridad VARCHAR2, gestor IN VARCHAR2, tipo VARCHAR2, fecini DATE, fecfin DATE, Sec VARCHAR2) RETURN NUMBER;
   -----------------------------------------------------------------------
   FUNCTION TopXUsu (sistema VARCHAR2, estado VARCHAR2, gestor IN VARCHAR2, usu VARCHAR2,tipo VARCHAR2, fecini DATE, fecfin DATE, desglose_cod IN VARCHAR2, Sec IN VARCHAR2) RETURN NUMBER;
   -----------------------------------------------------------------------
   FUNCTION TopXGruUsu (sistema VARCHAR2, estado VARCHAR2, gestor IN VARCHAR2, gru VARCHAR2,tipo VARCHAR2, fecini DATE, fecfin DATE, desglose_cod IN VARCHAR2, Sec IN VARCHAR2) RETURN NUMBER;
   -----------------------------------------------------------------------
   FUNCTION TopXApl (sistema VARCHAR2, estado VARCHAR2, gestor IN VARCHAR2, apl VARCHAR2,tipo VARCHAR2, fecini DATE, fecfin DATE, desglose_cod IN VARCHAR2, Sec IN VARCHAR2) RETURN NUMBER;
   -----------------------------------------------------------------------
	 FUNCTION TipoAsignacion (sistema varchar2,tarea number) return varchar2;

	 -- NUEVAS METRICAS --

   function isAsignadaDirecta(sistema in varchar2,tarea in number) return varchar2;
   function isAsignadaPorColaAP(sistema in varchar2,tarea in number) return varchar2;
   function isAsignadaPorColaG(sistema in varchar2,tarea in number) return varchar2;
   function isReasignada(sistema in varchar2,tarea in number) return varchar2;
   function tipoAsigna(sistema in varchar2,tarea in number,mitipo in varchar2) return varchar2;
   function tiempoEspera(sistema in varchar2,tarea in number) return number;
   function franjaMinutos(tiempo in number) return number;
   function franjaDias(tipo in varchar2,tiempo in number) return number;
   function franjaTareas(tareas in number) return number;

   function primeraFechaPrevista(sistema in varchar2,tarea in number) return date;

   function cerradaEnTiempo(sistema in varchar2,tarea in number) return varchar2;

 END Fmetricas;
/

CREATE OR REPLACE PACKAGE BODY Fmetricas IS

FUNCTION Calcula_Dias(fecini IN DATE, fecfin IN DATE)
RETURN NUMBER
 IS dias NUMBER(7,2);
   wtar_feccrea DATE;
  BEGIN
 WTAR_FECCREA :=TO_DATE( FECini,'DD-MM-YY');
	 DIAS:= 0;
    WHILE  wtar_feccrea <  fecfin LOOP
	    wtar_feccrea:= wtar_feccrea + 1;
	    IF RTRIM((TO_CHAR(WTAR_FECCREA,'DAY'))) NOT IN ('SBADO','DOMINGO' ) THEN  DIAS:= DIAS+1;
	    END IF;
	 END LOOP;
	RETURN(dias);
  END;

-----------------------------------------------------------------------
FUNCTION Calcula_Espera(sistema IN VARCHAR2, TAREA IN VARCHAR2)
RETURN NUMBER
 IS dias NUMBER(7,2);
   WDIAFIN DATE;
   CURSOR C_MOVTAREA IS SELECT * FROM DUMBO.D7_TAREAS_MOVIMIENTOS  WHERE  TMO_SIS_COD=SISTEMA AND TMO_TAR_COD=TAREA ORDER BY TMO_COD;
  BEGIN
   DIAS:=0;
   FOR V_MOV IN C_MOVTAREA LOOP
   	  IF V_MOV.TMO_TIPO_MOV='W' THEN
	     BEGIN
	  	   SELECT TMO_FECHA_MOV INTO WDIAFIN FROM DUMBO.D7_TAREAS_MOVIMIENTOS
		     WHERE  TMO_SIS_COD=SISTEMA AND TMO_TAR_COD=TAREA AND TMO_COD=V_MOV.TMO_COD+1;
		   DIAS:=DIAS+FMETRICAS.CALCULA_DIAS(V_MOV.TMO_FECHA_MOV,WDIAFIN);
		 EXCEPTION WHEN NO_DATA_FOUND THEN NULL;
		 END;
      END IF;
	END LOOP;
	RETURN(dias);
  END;
-----------------------------------------------------------------------
FUNCTION TIENE_TAREAS_GESTOR(SISTEMA IN VARCHAR2, NODO IN VARCHAR2, ESTADO IN VARCHAR2, GESTOR IN VARCHAR2)
 RETURN VARCHAR2 IS SITIENE VARCHAR2(1);
 BEGIN
	 DECLARE CURSOR C_HIJOS IS
	  SELECT sec_cod, sec_id_respon FROM d7_secciones s1
		     START WITH sec_cod=NODO
			   AND sec_sis_cod=SISTEMA
	           CONNECT BY PRIOR SEC_COD=SEC_SEC_COD
			   AND sec_cod<>sec_sec_cod;
	 WSITIENE NUMBER;
	 BEGIN
	  SITIENE:='N';
      --En esta primera parte se comprueba si el nodo est en algun raiz de las que es
	  --responsable el gestor y si esto se cumple de devuelve directamente un sitiene = 'S'
	  DECLARE CURSOR C_PADRES IS
	  	  SELECT sec_cod FROM DUMBO.D7_SECCIONES
	  	   	  START WITH sec_id_respon = GESTOR AND sec_sis_cod = SISTEMA
		  	  CONNECT BY PRIOR sec_cod=sec_sec_cod
			  AND sec_sis_cod= SISTEMA
			  AND sec_cod != sec_sec_cod;
	  BEGIN
	  FOR V_NODO IN C_PADRES LOOP
	 	 BEGIN
			 IF V_NODO.SEC_COD = NODO THEN
			   BEGIN
			     SITIENE:='S';
				 RETURN(SITIENE);
				END;
			 END IF;
		 END;
	  END LOOP;
	  END;
	  --En esta segunda parte comprobamos que tega datos o que sea responsable de la seccion
	  --por ser resposable de una aplicacin asociada a la seccion
	  FOR V_HIJOS IN C_HIJOS LOOP
	     BEGIN
		  SELECT COUNT(*) INTO WSITIENE FROM D7_TAREAS, D7_APLICACIONES, D7_APLICACIONES_INFORMATICOS
		   WHERE TAR_SIS_COD = SISTEMA
		     AND TAR_SIS_COD = APL_SIS_COD
			 AND TAR_ESTADO = NVL(ESTADO,TAR_ESTADO)
		     AND TAR_APL_COD = APL_COD
		     AND APL_SEC_COD = V_HIJOS.SEC_COD
			 --Restricciones de Gestor (o que sea responsable de seccin o que sea responsable
			 -- de una aplicacin dependiente de la seccin)
			 AND TAR_SIS_COD = AIN_SIS_COD
			 AND AIN_APL_COD = APL_COD
			 AND ((AIN_INF_COD = GESTOR AND AIN_RESPONSABLE = 'Y') OR V_HIJOS.SEC_ID_RESPON = GESTOR);
	         EXCEPTION WHEN NO_DATA_FOUND THEN WSITIENE:=0;
	     END;
	     IF WSITIENE>0 THEN
		   BEGIN
		     SITIENE:='S';
			 RETURN(SITIENE);
			END;
		 END IF;
	   END LOOP;
	 END;
   	 RETURN(SITIENE);
END;
-----------------------------------------------------------------------
FUNCTION TIENE_TAREAS_MAESTRO(SISTEMA IN VARCHAR2, NODO IN VARCHAR2, ESTADO IN VARCHAR2)
 RETURN VARCHAR2 IS SITIENE VARCHAR2(1);
 BEGIN
	 DECLARE CURSOR C_HIJOS IS
	  SELECT sec_cod FROM d7_secciones s1
		     START WITH sec_cod=NODO
			   AND sec_sis_cod=SISTEMA
	           CONNECT BY PRIOR SEC_COD=SEC_SEC_COD
			   AND sec_cod<>sec_sec_cod ;
	 WSITIENE NUMBER;
	 BEGIN
	 SITIENE:='N';
	   FOR V_HIJOS IN C_HIJOS LOOP
	     BEGIN
		  SELECT COUNT(*) INTO WSITIENE FROM D7_TAREAS, D7_APLICACIONES
		   WHERE TAR_SIS_COD=SISTEMA
		     AND TAR_SIS_COD=APL_SIS_COD
			 AND TAR_ESTADO = NVL(ESTADO,TAR_ESTADO)
		     AND TAR_APL_COD=APL_COD
             AND APL_SEC_COD=V_HIJOS.SEC_COD;
			 EXCEPTION WHEN NO_DATA_FOUND THEN WSITIENE:=0;
	     END;
	     IF WSITIENE>0 THEN
		   BEGIN
		     SITIENE:='S';
			 RETURN(SITIENE);
			END;
		 END IF;
	   END LOOP;
	 END;
   	 RETURN(SITIENE);
END;
-----------------------------------------------------------------------
FUNCTION ES_ANCESTRO(sistema IN VARCHAR2, ancestro IN VARCHAR2, nodo IN VARCHAR2)
RETURN VARCHAR2 is PARIENTE varchar2(1);
BEGIN
    BEGIN
		SELECT 'S' INTO PARIENTE FROM d7_secciones
		  WHERE sec_cod=ancestro AND sec_sis_cod=sistema
		    AND sec_cod in (SELECT sec_sec_cod FROM d7_secciones s1
		  					  START WITH sec_cod=nodo and sec_sis_cod=sistema
							  CONNECT BY PRIOR sec_sec_cod=sec_cod and sec_cod<>sec_sec_cod);
		EXCEPTION WHEN NO_DATA_FOUND THEN PARIENTE:='N';
	END;
	RETURN(PARIENTE);
END;
-----------------------------------------------------------------------
FUNCTION Atencion
(sistema IN VARCHAR2, tramo_bajo IN VARCHAR2,tramo_alto IN VARCHAR2, gestor IN VARCHAR2, tipo IN  VARCHAR2, fecini IN DATE, fecfin IN DATE , apl IN VARCHAR2, inf IN VARCHAR2, usu IN VARCHAR2, cat IN VARCHAR2, grusu IN VARCHAR2, sec IN VARCHAR2)
RETURN NUMBER
 IS  suma NUMBER(10,2);
  BEGIN
   SELECT COUNT(*)
    INTO suma
   FROM DUMBO.D7_TAREAS t
    WHERE tar_sis_cod = sistema
    --Eliminamos las tareas con tiempo 0 y las subtareas cuya suma de tiempos es la misma que el tiempo de la tarea padre
    AND tar_estado = 'R'
    AND tar_horas_res > 0
    --   permite eliminar de la seleccin las tareas tiempo de resolucin sea el mismo en el padre, que en la suma
    --   de los hijos (se elimina el padre, para no duplicar informacin).
    --	Solamente se coge un nivel de herencia puesto que se comprobarn todas las tareas, esto es que en cada tarea
    --	se comprobarn sus hijos que son los nicos que importan(y no los hijos de los hijos).
    AND t.tar_horas_res > (SELECT NVL(SUM(t1.tar_horas_res),0) FROM DUMBO.D7_TAREAS t1
		                      WHERE t1.tar_sis_cod = sistema
							    AND t1.tar_padre_tar_cod=t.tar_cod)

    -- Restriccin cuando se introduce una FECHA de inicio o fin o la dos
	AND TO_DATE(tar_feccrea,'DD-MM-YY')>= TO_DATE(NVL(fecini,tar_feccrea),'DD-MM-YY')
    AND TO_DATE(tar_feccrea,'DD-MM-YY')<= TO_DATE(NVL(fecfin,tar_feccrea),'DD-MM-YY')
    -- Restriccin del TRAMO
    AND Fmetricas.Calcula_Dias(tar_feccrea,tar_fecfin) > DECODE(tramo_bajo,'X',Fmetricas.Calcula_Dias(tar_feccrea,tar_fecfin)-1,tramo_bajo)
    AND Fmetricas.Calcula_Dias(tar_feccrea,tar_fecfin) <= DECODE(tramo_alto,'X',Fmetricas.Calcula_Dias(tar_feccrea,tar_fecfin),tramo_alto)
    AND tar_tip_cod = DECODE(tipo,'INC+PET',tar_tip_cod, tipo)
    AND tar_tip_cod IN ('P','I')
    AND tar_inf_cod=NVL(inf,tar_inf_cod)
	AND tar_usu_cod=NVL(usu,tar_usu_cod)
	--AND tar_apl_cod=NVL(apl,tar_apl_cod)
	AND tar_apl_cod in (
   	   		   	   	   select apl_cod from DUMBO.d7_aplicaciones
					   where apl_sis_cod = sistema
					   and NVL(apl_padre_apl_cod,'NULL') = NVL(apl,NVL(apl_padre_apl_cod,'NULL'))
					   union
			   		   select NVL(apl,'*') from dual
			  		   )
    -- Restriccin para el GESTOR, para Maestro e Informatico no afecta
	AND tar_apl_cod IN (SELECT apl_cod FROM DUMBO.D7_APLICACIONES
	  		 			 WHERE apl_Sis_Cod = sistema
		 				 AND EXISTS (SELECT '*' FROM DUMBO.D7_APLICACIONES_INFORMATICOS
		 							 WHERE Ain_Sis_Cod = sistema
		 								 AND Apl_Cod = ain_apl_cod
 		 								 AND Ain_Inf_Cod = NVL(gestor,Ain_Inf_cod)
                    					 AND Ain_Responsable =DECODE(gestor,NULL,Ain_Responsable,'Y'))
			 						  OR(apl_sis_cod = sistema AND apl_sec_cod IN (SELECT sec_cod FROM DUMBO.D7_SECCIONES
		           						 			   		   	   			   	  START WITH sec_id_respon = NVL(gestor,sec_id_respon) AND sec_sis_cod = sistema
		        						 										  CONNECT BY PRIOR sec_cod=sec_sec_cod
		           						 										  AND sec_sis_cod= sistema
		           						 										  AND sec_cod != sec_sec_cod
			 							 										  UNION
			       						 										  SELECT sec_cod FROM DUMBO.D7_SECCIONES
		           						 										  WHERE apl_sec_cod=sec_cod
			       						 										  AND sec_id_respon = NVL(gestor,sec_id_respon)
			 	  						 										  AND sec_sis_cod= sistema
										 										  )
				  						 )
						 )
	 --Restriccin de CATEGORAS
	 AND (DECODE(tar_cat_cod,NULL,'NULL',tar_cat_cod) = DECODE(cat,NULL,'NULL',cat) OR  tar_cat_cod IN  (SELECT cat_cod FROM DUMBO.D7_CATEGORIAS
																							 	 		 	WHERE cat_sis_cod = sistema
									          			 	 		 						 	 		 	START WITH cat_cod = NVL(cat,cat_cod) AND cat_sis_cod = sistema
									          			 													CONNECT BY PRIOR cat_cod=cat_cat_cod
									          			 													AND cat_sis_cod= sistema
									          			 													AND cat_cod != cat_cat_cod
																											 )
			)
   --Si se introduce una SECCIN por la que filtrar(la relacion entre tareas y secciones son aplicaciones).
   --Tambin se incluyen las hijas de esta seccin introducida
   AND (tar_apl_cod IS NULL OR EXISTS (SELECT  apl_cod  FROM DUMBO.D7_APLICACIONES
	 			   	  	 					  WHERE apl_sis_cod = sistema
												 AND tar_apl_cod = apl_cod
				   		 						 AND apl_sec_cod IN ( SELECT sec_cod FROM DUMBO.D7_SECCIONES
									 											     WHERE sec_sis_cod = sistema
		          					 												 START WITH sec_cod = NVL(Sec,sec_cod) AND sec_sis_cod = sistema
		          					 												 CONNECT BY PRIOR sec_cod = sec_sec_cod
		          					 												 AND sec_sis_cod= sistema
		          					 												 AND sec_cod != sec_sec_cod
																					  )
																 )
			 )
     -- Restriccin de GRUPOS DE USUARIOS
	AND ((select count(*) from DUMBO.D7_Grupos_usuarios where gru_sis_cod = sistema) = '0'
				OR EXISTS (SELECT '*' FROM DUMBO.D7_USUARIOS_GRUPOS
	 			WHERE tar_usu_cod = DECODE(grusu,NULL,tar_usu_cod,ugr_usu_cod)
				AND ugr_sis_cod = sistema
				--Mediante esta select tambien se contendran los subGrupos de Usuarios
				AND  ugr_gru_cod = NVL(grusu,ugr_gru_cod )
				AND ugr_gru_cod IN  (SELECT gru_cod FROM DUMBO.D7_GRUPOS_USUARIOS
													 WHERE gru_sis_cod = sistema
													 AND gru_cod IN (SELECT gru_cod FROM DUMBO.D7_GRUPOS_USUARIOS
		          									 START WITH gru_cod = NVL(grusu,gru_cod) AND gru_sis_cod = sistema
		          									 CONNECT BY PRIOR gru_cod = gru_cod_cod
		          									 AND gru_sis_cod= sistema
		          									 AND gru_cod != gru_cod_cod)
									)
			)
 			);
   RETURN(suma);
  END;

-----------------------------------------------------------------------
FUNCTION Atencion_Desglose
(sistema IN VARCHAR2, tramo_bajo IN VARCHAR2,tramo_alto IN VARCHAR2, gestor IN VARCHAR2, tipo IN  VARCHAR2, fecini IN DATE, fecfin IN DATE, desglose IN VARCHAR2, Desglose_cod IN VARCHAR2, apl IN VARCHAR2, inf IN VARCHAR2, usu IN VARCHAR2, cat IN VARCHAR2, grusu IN VARCHAR2, sec IN VARCHAR2)
RETURN NUMBER
 IS  suma NUMBER(10,2) ;
 BEGIN
   SELECT COUNT(*)
    INTO suma
   FROM DUMBO.D7_TAREAS t
    WHERE tar_sis_cod = sistema
    --Eliminamos las tareas con tiempo 0 y las subtareas cuya suma de tiempos es la misma que el tiempo de la tarea padre
    AND tar_estado = 'R'
    AND tar_horas_res > 0
    --   permite eliminar de la seleccin las tareas tiempo de resolucin sea el mismo en el padre, que en la suma
    --   de los hijos (se elimina el padre, para no duplicar informacin).
    --	Solamente se coge un nivel de herencia puesto que se comprobarn todas las tareas, esto es que en cada tarea
    --	se comprobarn sus hijos que son los nicos que importan(y no los hijos de los hijos).
    AND t.tar_horas_res > (SELECT NVL(SUM(t1.tar_horas_res),0) FROM DUMBO.D7_TAREAS t1
		                      WHERE t1.tar_sis_cod = sistema
							    AND t1.tar_padre_tar_cod=t.tar_cod)

	-- Restriccin cuando se introduce una FECHA de inicio o fin o la dos
	AND TO_DATE(tar_feccrea,'DD-MM-YY')>= TO_DATE(NVL(fecini,tar_feccrea),'DD-MM-YY')
    AND TO_DATE(tar_feccrea,'DD-MM-YY')<= TO_DATE(NVL(fecfin,tar_feccrea),'DD-MM-YY')
    -- Restriccin del TRAMO
    AND Fmetricas.Calcula_Dias(tar_feccrea,tar_fecfin) > DECODE(tramo_bajo,'X',Fmetricas.Calcula_Dias(tar_feccrea,tar_fecfin)-1,tramo_bajo)
    AND Fmetricas.Calcula_Dias(tar_feccrea,tar_fecfin) <= DECODE(tramo_alto,'X',Fmetricas.Calcula_Dias(tar_feccrea,tar_fecfin),tramo_alto)
   -- AND DECODE(desglose,'A',tar_apl_cod,'C', tar_cat_cod ,'U',tar_usu_cod,'I',tar_inf_cod,'G','gru','S','sec')= DECODE(desglose,'G','gru','S','sec',Desglose_cod)
    AND DECODE(desglose,'A',tar_apl_cod,'C', tar_cat_cod ,'I',tar_inf_cod,'U','usu','G','gru','S','sec')= DECODE(desglose,'U','usu','G','gru','S','sec',Desglose_cod)
    AND ((desglose = 'U' AND decode(tar_usu_cod,'EXTERNO',tar_email_copia,tar_usu_cod) = Desglose_cod
				 )
						OR desglose != 'U'
			)
	AND ((desglose = 'S' AND tar_apl_cod in (select apl_cod from DUMBO.D7_aplicaciones
				  						   	  where apl_sis_cod = sistema
											  and apl_sec_cod = Desglose_cod))
						OR desglose != 'S'
			)
	AND ((desglose = 'G' AND exists (select ugr_usu_cod from DUMBO.D7_usuarios_grupos
				  						   	  where ugr_sis_cod = sistema
											  and tar_usu_cod = ugr_usu_cod
											  and ugr_gru_cod = Desglose_cod))
						OR desglose != 'G'
			)
	AND tar_tip_cod = DECODE(tipo,'INC+PET',tar_tip_cod, tipo)
    AND tar_tip_cod IN ('P','I')
    AND tar_inf_cod=NVL(inf,tar_inf_cod)
	AND tar_usu_cod=NVL(usu,tar_usu_cod)
	--AND tar_apl_cod=NVL(apl,tar_apl_cod)
	AND tar_apl_cod in (
   	   		   	   	   select apl_cod from DUMBO.d7_aplicaciones
					   where apl_sis_cod = sistema
					   and NVL(apl_padre_apl_cod,'NULL') = NVL(apl,NVL(apl_padre_apl_cod,'NULL'))
					   union
			   		   select NVL(apl,'*') from dual
			  		   )
    -- Restriccin para GESTOR, para informtico y maestro no afecta
	AND tar_apl_cod IN (SELECT apl_cod FROM DUMBO.D7_APLICACIONES
	  		 				  WHERE apl_Sis_Cod = sistema
		 					 AND EXISTS (SELECT '*' FROM DUMBO.D7_APLICACIONES_INFORMATICOS
		 					 	 				WHERE Ain_Sis_Cod = sistema
		 					 					AND Apl_Cod = ain_apl_cod
 		 					 					AND Ain_Inf_Cod = NVL(gestor,Ain_Inf_cod)
                    		 					AND Ain_Responsable =DECODE(gestor,NULL,Ain_Responsable,'Y')
						 )
			 			 OR(apl_sis_cod = sistema AND apl_sec_cod IN (SELECT sec_cod FROM DUMBO.D7_SECCIONES
		           			 			  		  	  			  	 		 START WITH sec_id_respon = NVL(gestor,sec_id_respon) AND sec_sis_cod = sistema
		        			 												 CONNECT BY PRIOR sec_cod=sec_sec_cod
		           			 												 AND sec_sis_cod= sistema
		           			 												 AND sec_cod != sec_sec_cod
			 				 												 UNION
			       			 												 SELECT sec_cod FROM DUMBO.D7_SECCIONES
		           		     												 WHERE apl_sec_cod=sec_cod
			       			 												 AND sec_id_respon = NVL(gestor,sec_id_respon)
			 	  			 												 AND sec_sis_cod= sistema)
				  	 												 )
					 		 )
   -- Restriccin de CATEGORAS
   AND (DECODE(tar_cat_cod,NULL,'NULL',tar_cat_cod) = DECODE(cat,NULL,'NULL',cat) OR  tar_cat_cod IN  (SELECT cat_cod FROM DUMBO.D7_CATEGORIAS
																	 WHERE cat_sis_cod = sistema
		          			 										 START WITH cat_cod = NVL(cat,cat_cod) AND cat_sis_cod = sistema
		          			 										 CONNECT BY PRIOR cat_cod=cat_cat_cod
		          		     										 AND cat_sis_cod= sistema
		          		     										 AND cat_cod != cat_cat_cod
																 )
		 )
   --Si se introduce una SECCIN por la que filtrar(la relacion entre tareas y secciones son aplicaciones).
   --Tambin se incluyen las hijas de esta seccin introducida
   AND (tar_apl_cod IS NULL OR EXISTS (SELECT  apl_cod  FROM DUMBO.D7_APLICACIONES
	 			   	  	 					   		   		    WHERE apl_sis_cod = sistema
																AND tar_apl_cod = apl_cod
				   		 										AND apl_sec_cod IN ( SELECT sec_cod FROM DUMBO.D7_SECCIONES
									 											     WHERE sec_sis_cod = sistema
		          					 												 START WITH sec_cod = NVL(Sec,sec_cod) AND sec_sis_cod = sistema
		          					 												 CONNECT BY PRIOR sec_cod = sec_sec_cod
		          					 												 AND sec_sis_cod= sistema
		          					 												 AND sec_cod != sec_sec_cod
																					  )
																 )
			 )
	-- Restriccin de GRUPOS DE USUARIOS
	AND ((select count(*) from DUMBO.D7_Grupos_usuarios where gru_sis_cod = sistema) = '0'
				OR EXISTS (SELECT '*' FROM DUMBO.D7_USUARIOS_GRUPOS
	 			WHERE tar_usu_cod = DECODE(grusu,NULL,tar_usu_cod,ugr_usu_cod)
				AND ugr_sis_cod = sistema
				--Mediante esta select tambien se contendran los subGrupos de Usuarios
				AND  ugr_gru_cod = NVL(grusu,ugr_gru_cod )
				AND ugr_gru_cod IN  (SELECT gru_cod FROM DUMBO.D7_GRUPOS_USUARIOS
										 WHERE gru_sis_cod = sistema
										 AND gru_cod IN (SELECT gru_cod FROM DUMBO.D7_GRUPOS_USUARIOS
		          						 	 		 		  START WITH gru_cod = NVL(grusu,gru_cod) AND gru_sis_cod = sistema
		          						 					  CONNECT BY PRIOR gru_cod = gru_cod_cod
		          						 					  AND gru_sis_cod= sistema
		          						 					  AND gru_cod != gru_cod_cod) )
			)
 		 );
  RETURN(SUMA);
  END;

-----------------------------------------------------------------------
FUNCTION Atencion_Desglose_Tm
(sistema IN VARCHAR2, tramo_bajo IN VARCHAR2,tramo_alto IN VARCHAR2, gestor IN VARCHAR2, tipo IN  VARCHAR2, fecini IN DATE, fecfin IN DATE, desglose IN VARCHAR2 , Desglose_cod IN VARCHAR2, apl IN VARCHAR2, inf IN VARCHAR2, usu IN VARCHAR2, cat IN VARCHAR2, grusu IN VARCHAR2, sec IN VARCHAR2)
RETURN NUMBER
 IS  cantidad  NUMBER(10,2) ;
  BEGIN
   SELECT SUM(Fmetricas.Calcula_Dias(tar_feccrea,tar_fecfin))/COUNT(*)
    INTO cantidad
   FROM DUMBO.D7_TAREAS t
    WHERE tar_sis_cod = sistema
    --Eliminamos las tareas con tiempo 0 y las subtareas cuya suma de tiempos es la misma que el tiempo de la tarea padre
    AND tar_estado = 'R'
    AND tar_horas_res > 0
    --   permite eliminar de la seleccin las tareas tiempo de resolucin sea el mismo en el padre, que en la suma
    --   de los hijos (se elimina el padre, para no duplicar informacin).
    --	Solamente se coge un nivel de herencia puesto que se comprobarn todas las tareas, esto es que en cada tarea
    --	se comprobarn sus hijos que son los nicos que importan(y no los hijos de los hijos).
    AND t.tar_horas_res > (SELECT NVL(SUM(t1.tar_horas_res),0) FROM DUMBO.D7_TAREAS t1
		                      WHERE t1.tar_sis_cod = sistema
							    AND t1.tar_padre_tar_cod=t.tar_cod)
    -- Restriccin cuando se introduce una FECHA de inicio o fin o la dos
	AND TO_DATE(tar_feccrea,'DD-MM-YY')>= TO_DATE(NVL(fecini,tar_feccrea),'DD-MM-YY')
    AND TO_DATE(tar_feccrea,'DD-MM-YY')<= TO_DATE(NVL(fecfin,tar_feccrea),'DD-MM-YY')
    -- Restriccin del TRAMO
    AND Fmetricas.Calcula_Dias(tar_feccrea,tar_fecfin) > DECODE(tramo_bajo,'X',Fmetricas.Calcula_Dias(tar_feccrea,tar_fecfin)-1,tramo_bajo)
    AND Fmetricas.Calcula_Dias(tar_feccrea,tar_fecfin) <= DECODE(tramo_alto,'X',Fmetricas.Calcula_Dias(tar_feccrea,tar_fecfin),tramo_alto)
    --AND DECODE(desglose,'A',tar_apl_cod,'C', tar_cat_cod ,'U',tar_usu_cod,'I',tar_inf_cod,'G','gru','S','sec')= DECODE(desglose,'G','gru','S','sec',Desglose_cod)
    AND DECODE(desglose,'A',tar_apl_cod,'C', tar_cat_cod ,'I',tar_inf_cod,'U','usu','G','gru','S','sec')= DECODE(desglose,'U','usu','G','gru','S','sec',Desglose_cod)
    AND ((desglose = 'U' AND decode(tar_usu_cod,'EXTERNO',tar_email_copia,tar_usu_cod) = Desglose_cod
				 )
						OR desglose != 'U'
			)
	AND ((desglose = 'S' AND tar_apl_cod in (select apl_cod from DUMBO.D7_aplicaciones
				  						   	  where apl_sis_cod = sistema
											  and apl_sec_cod = Desglose_cod))
						OR desglose != 'S'
			)
	AND ((desglose = 'G' AND exists (select ugr_usu_cod from DUMBO.D7_usuarios_grupos
				  						   	  where ugr_sis_cod = sistema
											  and tar_usu_cod = ugr_usu_cod
											  and ugr_gru_cod = Desglose_cod))
						OR desglose != 'G'
			)
    AND tar_tip_cod = DECODE(tipo,'INC+PET',tar_tip_cod, tipo)
    AND tar_tip_cod IN ('P','I')
    AND tar_inf_cod=NVL(inf,tar_inf_cod)
	AND tar_usu_cod=NVL(usu,tar_usu_cod)
	--AND tar_apl_cod=NVL(apl,tar_apl_cod)
	AND tar_apl_cod in (
   	   		   	   	   select apl_cod from DUMBO.d7_aplicaciones
					   where apl_sis_cod = sistema
					   and NVL(apl_padre_apl_cod,'NULL') = NVL(apl,NVL(apl_padre_apl_cod,'NULL'))
					   union
			   		   select NVL(apl,'*') from dual
			  		   )
    --Restriccin para el GESTOR, no influye a informticos ni a maestros
	AND tar_apl_cod IN (SELECT apl_cod FROM DUMBO.D7_APLICACIONES
	  		 				 WHERE apl_Sis_Cod = sistema
		 					 AND EXISTS (SELECT '*' FROM DUMBO.D7_APLICACIONES_INFORMATICOS
		 					 WHERE Ain_Sis_Cod = sistema
		 					 AND Apl_Cod = ain_apl_cod
 		 					 AND Ain_Inf_Cod = NVL(gestor,Ain_Inf_cod)
                    		 AND Ain_Responsable =DECODE(gestor,NULL,Ain_Responsable,'Y'))
			 			  OR(apl_sis_cod = sistema AND apl_sec_cod IN (SELECT sec_cod FROM DUMBO.D7_SECCIONES
		           			 			   		   	   			   	   START WITH sec_id_respon = NVL(gestor,sec_id_respon) AND sec_sis_cod = sistema
		        			 										   CONNECT BY PRIOR sec_cod=sec_sec_cod
		           			 										   AND sec_sis_cod= sistema
		           			 										   AND sec_cod != sec_sec_cod
			 				 										  UNION
			       			 										   SELECT sec_cod FROM DUMBO.D7_SECCIONES
		           			 										   WHERE apl_sec_cod=sec_cod
			       			 										   AND sec_id_respon = NVL(gestor,sec_id_respon)
			 	  			 										   AND sec_sis_cod= sistema)
				  			 )
						 )
	 -- Restriccin de CATEGORAS
	 AND (DECODE(tar_cat_cod,NULL,'NULL',tar_cat_cod) = DECODE(cat,NULL,'NULL',cat) OR  tar_cat_cod IN  (SELECT cat_cod FROM DUMBO.D7_CATEGORIAS
																										   WHERE cat_sis_cod = sistema
													          			 								   START WITH cat_cod = NVL(cat,cat_cod) AND cat_sis_cod = sistema
													          			 								   CONNECT BY PRIOR cat_cod=cat_cat_cod
													          			 								   AND cat_sis_cod= sistema
													          			 								   AND cat_cod != cat_cat_cod
						 																				   )
		 )
    --Si se introduce una SECCIN por la que filtrar(la relacion entre tareas y secciones son aplicaciones).
    --Tambin se incluyen las hijas de esta seccin introducida
    AND (tar_apl_cod IS NULL OR EXISTS (SELECT  apl_cod  FROM DUMBO.D7_APLICACIONES
	 			   	  	 					   		   		    WHERE apl_sis_cod = sistema
																AND tar_apl_cod = apl_cod
				   		 										AND apl_sec_cod IN ( SELECT sec_cod FROM DUMBO.D7_SECCIONES
									 											     WHERE sec_sis_cod = sistema
		          					 												 START WITH sec_cod = NVL(Sec,sec_cod) AND sec_sis_cod = sistema
		          					 												 CONNECT BY PRIOR sec_cod = sec_sec_cod
		          					 												 AND sec_sis_cod= sistema
		          					 												 AND sec_cod != sec_sec_cod
																					  )
																 )
			 )
    -- Restriccin de GRUPOS DE USUARIOS
	AND ((select count(*) from DUMBO.D7_Grupos_usuarios where gru_sis_cod = sistema) = '0'
				OR EXISTS (SELECT '*' FROM DUMBO.D7_USUARIOS_GRUPOS
	 			WHERE tar_usu_cod = DECODE(grusu,NULL,tar_usu_cod,ugr_usu_cod)
				AND ugr_sis_cod = sistema
				--Mediante esta select tambien se contendran los subGrupos de Usuarios
				AND  ugr_gru_cod = NVL(grusu,ugr_gru_cod )
				AND ugr_gru_cod IN  (SELECT gru_cod FROM DUMBO.D7_GRUPOS_USUARIOS
											 WHERE gru_sis_cod = sistema
											 AND gru_cod IN (SELECT gru_cod FROM DUMBO.D7_GRUPOS_USUARIOS
		          							 	 		 	START WITH gru_cod = NVL(grusu,gru_cod) AND gru_sis_cod = sistema
		          							 				CONNECT BY PRIOR gru_cod = gru_cod_cod
		          							 				AND gru_sis_cod= sistema
		          							 				AND gru_cod != gru_cod_cod)
									  )
						)
 				 );
  RETURN(cantidad);
  END;

-----------------------------------------------------------------------
FUNCTION Atencion_Tm
(sistema IN VARCHAR2, tramo_bajo IN VARCHAR2,tramo_alto IN VARCHAR2, gestor IN VARCHAR2, tipo IN  VARCHAR2, fecini IN DATE, fecfin IN DATE, apl IN VARCHAR2, inf IN VARCHAR2, usu IN VARCHAR2, cat IN VARCHAR2, grusu IN VARCHAR2, sec IN VARCHAR2)
RETURN NUMBER
 IS  suma NUMBER(10,2); -- Si el tramo es null(tiempo medios totales) para eso estan las dos ultimas condiciones de los DECODE de dias
					    -- para permitir que no se tenga en cuenta el tramo
  BEGIN
   SELECT SUM(Fmetricas.Calcula_Dias(tar_feccrea,tar_fecfin))/COUNT(*)
    INTO suma
   FROM DUMBO.D7_TAREAS t
    WHERE tar_sis_cod = sistema
    --Eliminamos las que tienen tiempo 0 y las subtareas cuya suma de tiempos es la misma que el tiempo de la tarea padre
    AND tar_estado = 'R'
    AND tar_horas_res > 0
    --   permite eliminar de la seleccin las tareas tiempo de resolucin sea el mismo en el padre, que en la suma
    --   de los hijos (se elimina el padre, para no duplicar informacin).
    --	Solamente se coge un nivel de herencia puesto que se comprobarn todas las tareas, esto es que en cada tarea
    --	se comprobarn sus hijos que son los nicos que importan(y no los hijos de los hijos).
    AND t.tar_horas_res > (SELECT NVL(SUM(t1.tar_horas_res),0) FROM DUMBO.D7_TAREAS t1
		                      WHERE t1.tar_sis_cod = sistema
							    AND t1.tar_padre_tar_cod=t.tar_cod)
    -- Restriccin cuando se introduce una FECHA de inicio o fin o la dos
	AND TO_DATE(tar_feccrea,'DD-MM-YY')>= TO_DATE(NVL(fecini,tar_feccrea),'DD-MM-YY')
    AND TO_DATE(tar_feccrea,'DD-MM-YY')<= TO_DATE(NVL(fecfin,tar_feccrea),'DD-MM-YY')
    -- Restriccin del TRAMO
    AND Fmetricas.Calcula_Dias(tar_feccrea,tar_fecfin) > DECODE(tramo_bajo,'X',Fmetricas.Calcula_Dias(tar_feccrea,tar_fecfin)-1,tramo_bajo)
    AND Fmetricas.Calcula_Dias(tar_feccrea,tar_fecfin) <= DECODE(tramo_alto,'X',Fmetricas.Calcula_Dias(tar_feccrea,tar_fecfin),tramo_alto)
    AND tar_tip_cod = DECODE(tipo,'INC+PET',tar_tip_cod, tipo)
    AND tar_tip_cod IN ('P','I')
    AND tar_inf_cod=NVL(inf,tar_inf_cod)
	AND tar_usu_cod=NVL(usu,tar_usu_cod)
	--AND tar_apl_cod=NVL(apl,tar_apl_cod)
	AND tar_apl_cod in (
   	   		   	   	   select apl_cod from DUMBO.d7_aplicaciones
					   where apl_sis_cod = sistema
					   and NVL(apl_padre_apl_cod,'NULL') = NVL(apl,NVL(apl_padre_apl_cod,'NULL'))
					   union
			   		   select NVL(apl,'*') from dual
			  		   )
    -- Restriccin para GESTOR, no afecta para informtico y maestro
	AND tar_apl_cod IN (SELECT apl_cod FROM DUMBO.D7_APLICACIONES
	  		 				  WHERE apl_Sis_Cod = sistema
		 					  AND EXISTS (SELECT '*' FROM DUMBO.D7_APLICACIONES_INFORMATICOS
		 									 WHERE Ain_Sis_Cod = sistema
		 									 AND Apl_Cod = ain_apl_cod
 		 								   	 AND Ain_Inf_Cod = NVL(gestor,Ain_Inf_cod)
                    						 AND Ain_Responsable =DECODE(gestor,NULL,Ain_Responsable,'Y')
										 )
			 				  OR(apl_sis_cod = sistema AND  apl_sec_cod IN (SELECT sec_cod FROM DUMBO.D7_SECCIONES
		           												      			 START WITH sec_id_respon = NVL(gestor,sec_id_respon) AND sec_sis_cod = sistema
		        												      			 CONNECT BY PRIOR sec_cod=sec_sec_cod
		           												      			 AND sec_sis_cod= sistema
		           												      			 AND sec_cod != sec_sec_cod
			 																  UNION
			       																 SELECT sec_cod FROM DUMBO.D7_SECCIONES
		           												      			 WHERE apl_sec_cod=sec_cod
			       										            			 AND sec_id_respon = NVL(gestor,sec_id_respon)
			 	  										            			 AND sec_sis_cod= sistema
																			 )
				  				 )
						 )
   -- Restriccines para CATEGORAS
   AND (DECODE(tar_cat_cod,NULL,'NULL',tar_cat_cod) = DECODE(cat,NULL,'NULL',cat) OR  tar_cat_cod IN  (SELECT cat_cod FROM DUMBO.D7_CATEGORIAS
																						   	   		   	  WHERE cat_sis_cod = sistema
							          				 	 		 						   	   		   	  START WITH cat_cod = NVL(cat,cat_cod) AND cat_sis_cod = sistema
							          									    							  CONNECT BY PRIOR cat_cod=cat_cat_cod
							          									    							  AND cat_sis_cod= sistema
							          									    							  AND cat_cod != cat_cat_cod
												               						  	   				  )
		 )
   --Si se introduce una SECCIN por la que filtrar(la relacion entre tareas y secciones son aplicaciones).
   --Tambin se incluyen las hijas de esta seccin introducida
   AND (tar_apl_cod IS NULL OR EXISTS (SELECT  apl_cod  FROM DUMBO.D7_APLICACIONES
	 			   	  	 					   		   		    WHERE apl_sis_cod = sistema
																AND tar_apl_cod = apl_cod
				   		 										AND apl_sec_cod IN ( SELECT sec_cod FROM DUMBO.D7_SECCIONES
									 											     WHERE sec_sis_cod = sistema
		          					 												 START WITH sec_cod = NVL(Sec,sec_cod) AND sec_sis_cod = sistema
		          					 												 CONNECT BY PRIOR sec_cod = sec_sec_cod
		          					 												 AND sec_sis_cod= sistema
		          					 												 AND sec_cod != sec_sec_cod
																					  )
																 )
			 )
	-- Restriccin con GRUPOS DE USUARIOS
	AND ((select count(*) from DUMBO.D7_Grupos_usuarios where gru_sis_cod = sistema) = '0'
				OR EXISTS (SELECT '*' FROM DUMBO.D7_USUARIOS_GRUPOS
	 			WHERE tar_usu_cod = DECODE(grusu,NULL,tar_usu_cod,ugr_usu_cod)
				AND ugr_sis_cod = sistema
				--Mediante esta select tambien se contendran los subGrupos de Usuarios
				AND  ugr_gru_cod = NVL(grusu,ugr_gru_cod )
				AND ugr_gru_cod IN  (SELECT gru_cod FROM DUMBO.D7_GRUPOS_USUARIOS
										 WHERE gru_sis_cod = sistema
										 AND gru_cod IN (SELECT gru_cod FROM DUMBO.D7_GRUPOS_USUARIOS
		          						 START WITH gru_cod = NVL(grusu,gru_cod) AND gru_sis_cod = sistema
		          						 CONNECT BY PRIOR gru_cod = gru_cod_cod
		          						 AND gru_sis_cod= sistema
		          						 AND gru_cod != gru_cod_cod)
									)
						)
 				 );
  RETURN(suma);
END;

-----------------------------------------------------------------------
FUNCTION Dedicacion
(sistema IN VARCHAR2, tramo_bajo IN VARCHAR2,tramo_alto IN VARCHAR2, gestor IN VARCHAR2, tipo IN  VARCHAR2, fecini IN DATE, fecfin IN DATE,   apl IN VARCHAR2, inf IN VARCHAR2, usu IN VARCHAR2, cat IN VARCHAR2, grusu IN VARCHAR2, Sec IN VARCHAR2)
RETURN NUMBER
 IS suma NUMBER(10,2);
--La descripcin de los parmetros es la siguiente:
	 --sistema : sistema sobre el que se realiza la metrica.
	 --tramo: tramo(de horas de resolucin de tarea) en el que se va a encuadrar la mtrica('T0','T1','T2' o 'T3')
	 --gestor: Indica el cdigo del Gestor que realiza la mtrica, si no la realiza el Gestor ser NULL
	 --tipo: podr ser INCIDENCIA O PETICION O NULL(En este caso ser incidencias+peticiones)
	 --fecini: Se podr introducir una fecha de inicio sobre la cual capar las tareas de la mtrica
	 --fecfin: Se podr introducir una fecha de fin sobre la cual capar las tareas de la mtrica.
	 -- apl,Inf,usu,cat,grusu,sec: Parmetros que especifican una cierta aplicacion, informatico,usuario,
		    --categoria, grupoUsuario o seccion respectivamente sobre que se encuentre en todas las tareas
		    --resultado de la mtrica. Si no se introduce el parmetro no se hace la restriccin
	 		-- Inf: ser tambin utilizado cuando la mtrica la realiza el informatico puesto que slo podr ver las
		   	   --tareas que tengan asociado a l como informatico entonces este parmetro se reutilizar.
  BEGIN
   SELECT COUNT(*)
    INTO suma
   FROM DUMBO.D7_TAREAS t
    WHERE tar_sis_cod = sistema
    --Eliminamos las tareas con tiempo 0 y las subtareas cuya suma de tiempos es la misma que el tiempo de la tarea padre
    AND tar_estado = 'R'
    AND tar_horas_res > 0
    --   permite eliminar de la seleccin las tareas tiempo de resolucin sea el mismo en el padre, que en la suma
    --   de los hijos (se elimina el padre, para no duplicar informacin).
    --	Solamente se coge un nivel de herencia puesto que se comprobarn todas las tareas, esto es que en cada tarea
    --	se comprobarn sus hijos que son los nicos que importan(y no los hijos de los hijos).
    AND t.tar_horas_res > (SELECT NVL(SUM(t1.tar_horas_res),0) FROM DUMBO.D7_TAREAS t1
		                      WHERE t1.tar_sis_cod = sistema
							    AND t1.tar_padre_tar_cod=t.tar_cod)

	-- Restriccin cuando se introduce una FECHA de inicio o fin o la dos
	AND TO_DATE(tar_feccrea,'DD-MM-YY')>= TO_DATE(NVL(fecini,tar_feccrea),'DD-MM-YY')
    AND TO_DATE(tar_feccrea,'DD-MM-YY')<= TO_DATE(NVL(fecfin,tar_feccrea),'DD-MM-YY')
    -- Restriccin del TRAMO
	AND tar_horas_res >  DECODE(tramo_bajo,'X',tar_horas_res-1,tramo_bajo)
    AND tar_horas_res <= DECODE(tramo_alto,'X',tar_horas_res,tramo_alto)
    AND tar_tip_cod = DECODE(tipo,'INC+PET',tar_tip_cod, tipo)
    AND tar_tip_cod IN ('P','I')
    AND tar_inf_cod=NVL(inf,tar_inf_cod)
	AND tar_usu_cod=NVL(usu,tar_usu_cod)
	--AND tar_apl_cod=NVL(apl,tar_apl_cod)
	AND tar_apl_cod in (
   	   		   	   	   select apl_cod from DUMBO.d7_aplicaciones
					   where apl_sis_cod = sistema
					   and NVL(apl_padre_apl_cod,'NULL') = NVL(apl,NVL(apl_padre_apl_cod,'NULL'))
					   union
			   		   select NVL(apl,'*') from dual
			  		   )
	-- Restriccin para el GESTOR, para Maestro e Informatico no afecta
    AND tar_apl_cod IN (SELECT apl_cod FROM DUMBO.D7_APLICACIONES
	  		 				 WHERE apl_Sis_Cod = sistema
		 					 AND EXISTS (SELECT '*' FROM DUMBO.D7_APLICACIONES_INFORMATICOS
		 									 WHERE Ain_Sis_Cod = sistema
		 									  AND Apl_Cod = ain_apl_cod
 		 								   	 AND Ain_Inf_Cod = NVL(gestor,Ain_Inf_cod)
                    						 AND Ain_Responsable =DECODE(gestor,NULL,Ain_Responsable,'Y'))
			 				 OR(apl_sis_cod = sistema AND apl_sec_cod IN (SELECT sec_cod FROM DUMBO.D7_SECCIONES
		           												      		 START WITH sec_id_respon = NVL(gestor,sec_id_respon) AND sec_sis_cod = sistema
		        												      		 CONNECT BY PRIOR sec_cod=sec_sec_cod
		           												      		 AND sec_sis_cod= sistema
		           												      		 AND sec_cod != sec_sec_cod
			 															    UNION
			       															 SELECT sec_cod FROM DUMBO.D7_SECCIONES
		           												      		 WHERE apl_sec_cod=sec_cod
			       										            		 AND sec_id_respon = NVL(gestor,sec_id_respon)
			 	  										            		 AND sec_sis_cod= sistema
																		  )
				  				  )
						 )
	 -- Restriccin de CATEGORAS
	 AND (DECODE(tar_cat_cod,NULL,'NULL',tar_cat_cod) = DECODE(cat,NULL,'NULL',cat) OR  tar_cat_cod IN  (SELECT cat_cod FROM DUMBO.D7_CATEGORIAS
	 	 											  														 WHERE cat_sis_cod = sistema
										          			 	 		 					   	   		   	  START WITH cat_cod = NVL(cat,cat_cod) AND cat_sis_cod = sistema
										          			 								   				  CONNECT BY PRIOR cat_cod=cat_cat_cod
										          			 								   				  AND cat_sis_cod= sistema
										          			 								   				  AND cat_cod != cat_cat_cod
																									     )
		 )
   --Si se introduce una SECCIN por la que filtrar(la relacion entre tareas y secciones son aplicaciones).
   --Tambin se incluyen las hijas de esta seccin introducida
   AND (tar_apl_cod IS NULL OR EXISTS (SELECT  apl_cod  FROM DUMBO.D7_APLICACIONES
	 			   	  	 					   		   		    WHERE apl_sis_cod = sistema
																AND tar_apl_cod = apl_cod
				   		 										AND apl_sec_cod IN ( SELECT sec_cod FROM DUMBO.D7_SECCIONES
									 											     WHERE sec_sis_cod = sistema
		          					 												 START WITH sec_cod = NVL(Sec,sec_cod) AND sec_sis_cod = sistema
		          					 												 CONNECT BY PRIOR sec_cod = sec_sec_cod
		          					 												 AND sec_sis_cod= sistema
		          					 												 AND sec_cod != sec_sec_cod
																					  )
																 )
			 )
	-- Restriccin de GRUPOS DE USUARIOS
	AND ((select count(*) from DUMBO.D7_Grupos_usuarios where gru_sis_cod = sistema) = '0'
				OR EXISTS (SELECT '*' FROM DUMBO.D7_USUARIOS_GRUPOS
	 			WHERE tar_usu_cod = DECODE(grusu,NULL,tar_usu_cod,ugr_usu_cod)
				AND ugr_sis_cod = sistema
				--Mediante esta select tambien se contendran los subGrupos de Usuarios
				AND  ugr_gru_cod = NVL(grusu,ugr_gru_cod )
				AND ugr_gru_cod IN  (SELECT gru_cod FROM DUMBO.D7_GRUPOS_USUARIOS
										 WHERE gru_sis_cod = sistema
										 AND gru_cod IN (SELECT gru_cod FROM DUMBO.D7_GRUPOS_USUARIOS
		          											 START WITH gru_cod = NVL(grusu,gru_cod) AND gru_sis_cod = sistema
		          											 CONNECT BY PRIOR gru_cod = gru_cod_cod
		          											 AND gru_sis_cod= sistema
		          											 AND gru_cod != gru_cod_cod
														 )
									 )
						)
 				 );
   RETURN(suma);
  END;

-----------------------------------------------------------------------
FUNCTION Dedicacion_Desglose
(sistema IN VARCHAR2, tramo_bajo IN VARCHAR2,tramo_alto IN VARCHAR2, gestor IN VARCHAR2, tipo IN  VARCHAR2, fecini IN DATE, fecfin IN DATE, desglose IN VARCHAR2, Desglose_cod IN VARCHAR2, apl IN VARCHAR2, inf IN VARCHAR2, usu IN VARCHAR2, cat IN VARCHAR2, grusu IN VARCHAR2, Sec IN VARCHAR2)
RETURN NUMBER
 IS  suma NUMBER(10,2);
--La descripcin de los parmetros es la siguiente:
	 --sistema : sistema sobre el que se realiza la metrica.
	 --tramo: tramo(de horas de resolucin de tarea) en el que se va a encuadrar la mtrica('T0','T1','T2' o 'T3')
	 --gestor: Indica el cdigo del Gestor que realiza la mtrica, si no la realiza el Gestor ser NULL
	 --tipo: podr ser INCIDENCIA O PETICION O NULL(En este caso ser incidencias+peticiones)
	 --fecini: Se podr introducir una fecha de inicio sobre la cual capar las tareas de la mtrica
	 --fecfin: Se podr introducir una fecha de fin sobre la cual capar las tareas de la mtrica.
	 --deglose: Se introduce el tipo de desglose si es por aplicacion,catergora....
	 --Desglose_cod: Como ser llamada desde fuera, este parmetro ser una aplicacin dada o una categora...
			--dependiendo del desglose.
	 -- apl,Inf,usu,cat,grusu,sec: Parmetros que especifican una cierta aplicacion, informatico,usuario,
		    --categoria, grupoUsuario o seccion respectivamente sobre que se encuentre en todas las tareas
		    --resultado de la mtrica. Si no se introduce el parmetro no se hace la restriccin
	 -- Inf: ser tambin utilizado cuando la mtrica la realiza el informatico puesto que slo podr ver las
		   --tareas que tengan asociado a l como informatico entonces este parmetro se reutilizar.
 BEGIN
   SELECT COUNT(*)
    INTO suma
   FROM DUMBO.D7_TAREAS t
    WHERE tar_sis_cod = sistema
    --Eliminamos las tareas con tiempo 0 y las subtareas cuya suma de tiempos es la misma que el tiempo de la tarea padre
    AND tar_estado = 'R'
    AND tar_horas_res > 0
    --   permite eliminar de la seleccin las tareas tiempo de resolucin sea el mismo en el padre, que en la suma
    --   de los hijos (se elimina el padre, para no duplicar informacin).
    --	Solamente se coge un nivel de herencia puesto que se comprobarn todas las tareas, esto es que en cada tarea
    --	se comprobarn sus hijos que son los nicos que importan(y no los hijos de los hijos).
    AND t.tar_horas_res > (SELECT NVL(SUM(t1.tar_horas_res),0) FROM DUMBO.D7_TAREAS t1
		                      WHERE t1.tar_sis_cod = sistema
							    AND t1.tar_padre_tar_cod=t.tar_cod)

	-- Restriccin cuando se introduce una FECHA de inicio o fin o la dos
	AND TO_DATE(tar_feccrea,'DD-MM-YY')>= TO_DATE(NVL(fecini,tar_feccrea),'DD-MM-YY')
    AND TO_DATE(tar_feccrea,'DD-MM-YY')<= TO_DATE(NVL(fecfin,tar_feccrea),'DD-MM-YY')
    -- Restriccin del TRAMO
	AND tar_horas_res >  DECODE(tramo_bajo,'X',tar_horas_res-1,tramo_bajo)
    AND tar_horas_res <= DECODE(tramo_alto,'X',tar_horas_res,tramo_alto)
	--AND DECODE(desglose,'A',tar_apl_cod,'C', tar_cat_cod ,'U',tar_usu_cod,'I',tar_inf_cod,'G','gru','S','sec')= DECODE(desglose,'G','gru','S','sec',Desglose_cod)
    AND DECODE(desglose,'A',tar_apl_cod,'C', tar_cat_cod ,'I',tar_inf_cod,'U','usu','G','gru','S','sec')= DECODE(desglose,'U','usu','G','gru','S','sec',Desglose_cod)
    AND ((desglose = 'U' AND decode(tar_usu_cod,'EXTERNO',tar_email_copia,tar_usu_cod) = Desglose_cod
				 )
						OR desglose != 'U'
			)
    AND ((desglose = 'S' AND tar_apl_cod in (select apl_cod from DUMBO.D7_aplicaciones
				  						   	  where apl_sis_cod = sistema
											  and apl_sec_cod = Desglose_cod))
						OR desglose != 'S'
			)
	AND ((desglose = 'G' AND exists (select ugr_usu_cod from DUMBO.D7_usuarios_grupos
				  						   	  where ugr_sis_cod = sistema
											  and tar_usu_cod = ugr_usu_cod
											  and ugr_gru_cod = Desglose_cod))
						OR desglose != 'G'
			)
	AND tar_tip_cod = DECODE(tipo,'INC+PET',tar_tip_cod, tipo)
    AND tar_tip_cod IN ('P','I')
    AND tar_inf_cod=NVL(inf,tar_inf_cod)
	AND tar_usu_cod=NVL(usu,tar_usu_cod)
	--AND tar_apl_cod=NVL(apl,tar_apl_cod)
	AND tar_apl_cod in (
   	   		   	   	   select apl_cod from DUMBO.d7_aplicaciones
					   where apl_sis_cod = sistema
					   and NVL(apl_padre_apl_cod,'NULL') = NVL(apl,NVL(apl_padre_apl_cod,'NULL'))
					   union
			   		   select NVL(apl,'*') from dual
			  		   )
    -- Restriccin para el GESTOR, no influye a informticos ni a maestros
	AND tar_apl_cod IN (SELECT apl_cod FROM DUMBO.D7_APLICACIONES
	  		 			 WHERE apl_Sis_Cod = sistema
		 				 AND EXISTS (SELECT '*' FROM DUMBO.D7_APLICACIONES_INFORMATICOS
		 				  	 		  WHERE Ain_Sis_Cod = sistema
		 				  			  AND Apl_Cod = ain_apl_cod
 		 				  			  AND Ain_Inf_Cod = NVL(gestor,Ain_Inf_cod)
                    	  			  AND Ain_Responsable =DECODE(gestor,NULL,Ain_Responsable,'Y'))
			 			 OR(apl_sis_cod = sistema AND apl_sec_cod IN (SELECT sec_cod FROM DUMBO.D7_SECCIONES
		           												      	 START WITH sec_id_respon = NVL(gestor,sec_id_respon) AND sec_sis_cod = sistema
		        												      	 CONNECT BY PRIOR sec_cod=sec_sec_cod
		           												      	 AND sec_sis_cod= sistema
		           												      	 AND sec_cod != sec_sec_cod
			 															 UNION
			       														 SELECT sec_cod FROM DUMBO.D7_SECCIONES
		           												      	 WHERE apl_sec_cod=sec_cod
			       										            	 AND sec_id_respon = NVL(gestor,sec_id_respon)
			 	  										            	 AND sec_sis_cod= sistema
																		 )
				  			 )
					 )
	 --Restriccin de CATEGORAS
	 AND (DECODE(tar_cat_cod,NULL,'NULL',tar_cat_cod) = DECODE(cat,NULL,'NULL',cat) OR  tar_cat_cod IN  (SELECT cat_cod FROM DUMBO.D7_CATEGORIAS
																			   WHERE cat_sis_cod = sistema
		          			 												   START WITH cat_cod = NVL(cat,cat_cod) AND cat_sis_cod = sistema
		          			 												   CONNECT BY PRIOR cat_cod=cat_cat_cod
		          			 												   AND cat_sis_cod= sistema
		          			 												   AND cat_cod != cat_cat_cod
						  										)
		 )
   --Si se introduce una SECCIN por la que filtrar(la relacion entre tareas y secciones son aplicaciones).
   --Tambin se incluyen las hijas de esta seccin introducida
   AND (tar_apl_cod IS NULL OR EXISTS (SELECT  apl_cod  FROM DUMBO.D7_APLICACIONES
	 			   	  	 					   		   		    WHERE apl_sis_cod = sistema
																AND tar_apl_cod = apl_cod
				   		 										AND apl_sec_cod IN ( SELECT sec_cod FROM DUMBO.D7_SECCIONES
									 											     WHERE sec_sis_cod = sistema
		          					 												 START WITH sec_cod = NVL(Sec,sec_cod) AND sec_sis_cod = sistema
		          					 												 CONNECT BY PRIOR sec_cod = sec_sec_cod
		          					 												 AND sec_sis_cod= sistema
		          					 												 AND sec_cod != sec_sec_cod
																					  )
																 )
			 )
	-- Restriccin de GRUPOS DE USUARIOS
	AND ((select count(*) from DUMBO.D7_Grupos_usuarios where gru_sis_cod = sistema) = '0'
				OR EXISTS (SELECT '*' FROM DUMBO.D7_USUARIOS_GRUPOS
	 			WHERE tar_usu_cod = DECODE(grusu,NULL,tar_usu_cod,ugr_usu_cod)
				AND ugr_sis_cod = sistema
				--Mediante esta select tambien se contendran los subGrupos de Usuarios
				AND  ugr_gru_cod = NVL(grusu,ugr_gru_cod )
				AND ugr_gru_cod IN  (SELECT gru_cod FROM DUMBO.D7_GRUPOS_USUARIOS
										 WHERE gru_sis_cod = sistema
										 AND gru_cod IN (SELECT gru_cod FROM DUMBO.D7_GRUPOS_USUARIOS
		          						 START WITH gru_cod = NVL(grusu,gru_cod) AND  gru_sis_cod = sistema
		          						 CONNECT BY PRIOR gru_cod = gru_cod_cod
		          						 AND gru_sis_cod= sistema
		          						 AND gru_cod != gru_cod_cod)
									)
						)
 				 );
  RETURN(suma);
  END;

-----------------------------------------------------------------------
FUNCTION Dedicacion_Desglose_Tm
(sistema IN VARCHAR2, tramo_bajo IN VARCHAR2,tramo_alto IN VARCHAR2, gestor IN VARCHAR2, tipo IN  VARCHAR2, fecini IN DATE, fecfin IN DATE, desglose IN VARCHAR2 , Desglose_cod IN VARCHAR2, apl IN VARCHAR2, inf IN VARCHAR2, usu IN VARCHAR2, cat IN VARCHAR2, grusu IN VARCHAR2, sec IN VARCHAR2)
RETURN NUMBER
 IS  cantidad  NUMBER(10,2);
--La descripcin de los parmetros es la siguiente:
	 --sistema : sistema sobre el que se realiza la metrica.
	 --tramo: tramo(de horas de resolucin de tarea) en el que se va a encuadrar la mtrica('T0','T1','T2' o 'T3')
	 --gestor: Indica el cdigo del Gestor que realiza la mtrica, si no la realiza el Gestor ser NULL
	 --tipo: podr ser INCIDENCIA O PETICION O NULL(En este caso ser incidencias+peticiones)
	 --fecini: Se podr introducir una fecha de inicio sobre la cual capar las tareas de la mtrica
	 --fecfin: Se podr introducir una fecha de fin sobre la cual capar las tareas de la mtrica.
	 --deglose: Se introduce el tipo de desglose si es por aplicacion,catergora....
	 --Desglose_cod: Como ser llamada desde fuera, este parmetro ser una aplicacin dada o una categora...
			--dependiendo del desglose.
	 -- apl,Inf,usu,cat,grusu,sec: Parmetros que especifican una cierta aplicacion, informatico,usuario,
		    --categoria, grupoUsuario o seccion respectivamente sobre que se encuentre en todas las tareas
		    --resultado de la mtrica. Si no se introduce el parmetro no se hace la restriccin
	 -- Inf: ser tambin utilizado cuando la mtrica la realiza el informatico puesto que slo podr ver las
		   --tareas que tengan asociado a l como informatico entonces este parmetro se reutilizar.
  BEGIN
   SELECT SUM(tar_horas_res)/COUNT(*)
    INTO cantidad
   FROM DUMBO.D7_TAREAS t
    WHERE tar_sis_cod = sistema
    --Eliminamos las que tienen tiempo 0 y las subtareas cuya suma de tiempos es la misma que el tiempo de la tarea padre
    AND tar_estado = 'R'
    AND tar_horas_res > 0
    --   permite eliminar de la seleccin las tareas tiempo de resolucin sea el mismo en el padre, que en la suma
    --   de los hijos (se elimina el padre, para no duplicar informacin).
    --	Solamente se coge un nivel de herencia puesto que se comprobarn todas las tareas, esto es que en cada tarea
    --	se comprobarn sus hijos que son los nicos que importan(y no los hijos de los hijos).
    AND t.tar_horas_res > (SELECT NVL(SUM(t1.tar_horas_res),0) FROM DUMBO.D7_TAREAS t1
		                      WHERE t1.tar_sis_cod = sistema
							    AND t1.tar_padre_tar_cod=t.tar_cod)
    -- Restriccin cuando se introduce una FECHA de inicio o fin o la dos
	AND TO_DATE(tar_feccrea,'DD-MM-YY')>= TO_DATE(NVL(fecini,tar_feccrea),'DD-MM-YY')
    AND TO_DATE(tar_feccrea,'DD-MM-YY')<= TO_DATE(NVL(fecfin,tar_feccrea),'DD-MM-YY')
    -- Restriccin del TRAMO
	AND tar_horas_res >  DECODE(tramo_bajo,'X',tar_horas_res-1,tramo_bajo)
    AND tar_horas_res <= DECODE(tramo_alto,'X',tar_horas_res,tramo_alto)
    --AND DECODE(desglose,'A',tar_apl_cod,'C', tar_cat_cod ,'U',tar_usu_cod,'I',tar_inf_cod,'G','gru','S','sec')= DECODE(desglose,'G','gru','S','sec',Desglose_cod)
 	AND DECODE(desglose,'A',tar_apl_cod,'C', tar_cat_cod ,'I',tar_inf_cod,'U','usu','G','gru','S','sec')= DECODE(desglose,'U','usu','G','gru','S','sec',Desglose_cod)
    AND ((desglose = 'U' AND decode(tar_usu_cod,'EXTERNO',tar_email_copia,tar_usu_cod) = Desglose_cod
				 )
						OR desglose != 'U'
			)
    AND ((desglose = 'S' AND tar_apl_cod in (select apl_cod from DUMBO.D7_aplicaciones
				  						   	  where apl_sis_cod = sistema
											  and apl_sec_cod = Desglose_cod))
						OR desglose != 'S'
			)
	AND ((desglose = 'G' AND exists (select ugr_usu_cod from DUMBO.D7_usuarios_grupos
				  						   	  where ugr_sis_cod = sistema
											  and tar_usu_cod = ugr_usu_cod
											  and ugr_gru_cod = Desglose_cod))
						OR desglose != 'G'
			)
    AND tar_tip_cod = DECODE(tipo,'INC+PET',tar_tip_cod, tipo)
    AND tar_tip_cod IN ('P','I')
    AND tar_inf_cod=NVL(inf,tar_inf_cod)
	AND tar_usu_cod=NVL(usu,tar_usu_cod)
	--AND tar_apl_cod=NVL(apl,tar_apl_cod)
	AND tar_apl_cod in (
   	   		   	   	   select apl_cod from DUMBO.d7_aplicaciones
					   where apl_sis_cod = sistema
					   and NVL(apl_padre_apl_cod,'NULL') = NVL(apl,NVL(apl_padre_apl_cod,'NULL'))
					   union
			   		   select NVL(apl,'*') from dual
			  		   )
    -- Restriccin para GESTOR, no influye para informaticos ni maestros
	AND tar_apl_cod IN (SELECT apl_cod FROM DUMBO.D7_APLICACIONES
	  		 			 WHERE apl_Sis_Cod = sistema
		 				 AND EXISTS (SELECT '*' FROM DUMBO.D7_APLICACIONES_INFORMATICOS
		 				  	 		  WHERE Ain_Sis_Cod = sistema
		 				  			  AND Apl_Cod = ain_apl_cod
 		 				  			  AND Ain_Inf_Cod = NVL(gestor,Ain_Inf_cod)
                    	  			  AND Ain_Responsable =DECODE(gestor,NULL,Ain_Responsable,'Y'))
			 			 OR(apl_sis_cod = sistema AND apl_sec_cod IN (SELECT sec_cod FROM DUMBO.D7_SECCIONES
		           												      	 START WITH sec_id_respon = NVL(gestor,sec_id_respon) AND sec_sis_cod = sistema
		        												      	 CONNECT BY PRIOR sec_cod=sec_sec_cod
		           												      	 AND sec_sis_cod= sistema
		           												      	 AND sec_cod != sec_sec_cod
			 															 UNION
			       														 SELECT sec_cod FROM DUMBO.D7_SECCIONES
		           												      	 WHERE apl_sec_cod=sec_cod
			       										            	 AND sec_id_respon = NVL(gestor,sec_id_respon)
			 	  										            	 AND sec_sis_cod= sistema
																		 )
				  			 )
					 )
	 -- Restriccin de CATEGORAS
	 AND (DECODE(tar_cat_cod,NULL,'NULL',tar_cat_cod) = DECODE(cat,NULL,'NULL',cat) OR  tar_cat_cod IN  (SELECT cat_cod FROM DUMBO.D7_CATEGORIAS
																										 WHERE cat_sis_cod = sistema
			          												       								 START WITH cat_cod = NVL(cat,cat_cod) AND cat_sis_cod = sistema
			          												       								 CONNECT BY PRIOR cat_cod=cat_cat_cod
			          												       								 AND cat_sis_cod= sistema
			          												       								 AND cat_cod != cat_cat_cod
																									 	 )
			)
   --Si se introduce una SECCIN por la que filtrar(la relacion entre tareas y secciones son aplicaciones).
   --Tambin se incluyen las hijas de esta seccin introducida
   AND (tar_apl_cod IS NULL OR EXISTS (SELECT  apl_cod  FROM DUMBO.D7_APLICACIONES
	 			   	  	 					   		   		    WHERE apl_sis_cod = sistema
																AND tar_apl_cod = apl_cod
				   		 										AND apl_sec_cod IN ( SELECT sec_cod FROM DUMBO.D7_SECCIONES
									 											     WHERE sec_sis_cod = sistema
		          					 												 START WITH sec_cod = NVL(Sec,sec_cod) AND sec_sis_cod = sistema
		          					 												 CONNECT BY PRIOR sec_cod = sec_sec_cod
		          					 												 AND sec_sis_cod= sistema
		          					 												 AND sec_cod != sec_sec_cod
																					  )
																 )
			 )
	-- Restriccin de GRUPOS DE USUARIOS
	AND ((select count(*) from DUMBO.D7_Grupos_usuarios where gru_sis_cod = sistema) = '0'
				OR EXISTS (SELECT '*' FROM DUMBO.D7_USUARIOS_GRUPOS
	 			WHERE tar_usu_cod = DECODE(grusu,NULL,tar_usu_cod,ugr_usu_cod)
				AND ugr_sis_cod = sistema
				--Mediante esta select tambien se contendran los subGrupos de Usuarios
				AND  ugr_gru_cod = NVL(grusu,ugr_gru_cod )
				AND ugr_gru_cod IN  (SELECT gru_cod FROM DUMBO.D7_GRUPOS_USUARIOS
										 WHERE gru_sis_cod = sistema
										 AND gru_cod IN (SELECT gru_cod FROM DUMBO.D7_GRUPOS_USUARIOS
		          											 START WITH gru_cod = NVL(grusu,gru_cod) AND gru_sis_cod = sistema
		          											 CONNECT BY PRIOR gru_cod = gru_cod_cod
		          											 AND gru_sis_cod= sistema
		          											 AND gru_cod != gru_cod_cod
														 )
									 )
						)
 				 );
  RETURN(cantidad);
  END;

-----------------------------------------------------------------------
FUNCTION Dedicacion_Tm
(sistema IN VARCHAR2, tramo_bajo IN VARCHAR2,tramo_alto IN VARCHAR2, gestor IN VARCHAR2, tipo IN  VARCHAR2, fecini IN DATE, fecfin IN DATE, apl IN VARCHAR2, inf IN VARCHAR2, usu IN VARCHAR2, cat IN VARCHAR2, grusu IN VARCHAR2, Sec IN VARCHAR2)
 RETURN NUMBER
 IS  suma NUMBER(10,2);
   --La descripcin de los parmetros es la siguiente:
	 --sistema : sistema sobre el que se realiza la metrica.
	 --tramo: tramo(de horas de resolucin de tarea) en el que se va a encuadrar la mtrica('T0','T1','T2' o 'T3')
	 --gestor: Indica el cdigo del Gestor que realiza la mtrica, si no la realiza el Gestor ser NULL
	 --tipo: podr ser INCIDENCIA O PETICION O NULL(En este caso ser incidencias+peticiones)
	 --fecini: Se podr introducir una fecha de inicio sobre la cual capar las tareas de la mtrica
	 --fecfin: Se podr introducir una fecha de fin sobre la cual capar las tareas de la mtrica.
	 -- apl,Inf,usu,cat,grusu,sec: Parmetros que especifican una cierta aplicacion, informatico,usuario,
		    --categoria, grupoUsuario o seccion respectivamente sobre que se encuentre en todas las tareas
		    --resultado de la mtrica. Si no se introduce el parmetro no se hace la restriccin
	 -- Inf: ser tambin utilizado cuando la mtrica la realiza el informatico puesto que slo podr ver las
		   --tareas que tengan asociado a l como informatico entonces este parmetro se reutilizar.
   BEGIN
   SELECT SUM(tar_horas_res)/COUNT(*)
    INTO suma
   FROM DUMBO.D7_TAREAS t
    WHERE tar_sis_cod = sistema
    --Eliminamos las que tienen tiempo 0 y las subtareas cuya suma de tiempos es la misma que el tiempo de la tarea padre
    AND tar_estado = 'R'
    AND tar_horas_res > 0
    --   permite eliminar de la seleccin las tareas tiempo de resolucin sea el mismo en el padre, que en la suma
    --   de los hijos (se elimina el padre, para no duplicar informacin).
    --	Solamente se coge un nivel de herencia puesto que se comprobarn todas las tareas, esto es que en cada tarea
    --	se comprobarn sus hijos que son los nicos que importan(y no los hijos de los hijos).
    AND t.tar_horas_res > (SELECT NVL(SUM(t1.tar_horas_res),0) FROM DUMBO.D7_TAREAS t1
		                      WHERE t1.tar_sis_cod = sistema
							    AND t1.tar_padre_tar_cod=t.tar_cod)

	-- Restriccin cuando se introduce una FECHA de inicio o fin o la dos
	AND TO_DATE(tar_feccrea,'DD-MM-YY')>= TO_DATE(NVL(fecini,tar_feccrea),'DD-MM-YY')
    AND TO_DATE(tar_feccrea,'DD-MM-YY')<= TO_DATE(NVL(fecfin,tar_feccrea),'DD-MM-YY')
    -- Restriccin del TRAMO
	AND tar_horas_res >  DECODE(tramo_bajo,'X',tar_horas_res-1,tramo_bajo)
    AND tar_horas_res <= DECODE(tramo_alto,'X',tar_horas_res,tramo_alto)
    AND tar_tip_cod = DECODE(tipo,'INC+PET',tar_tip_cod, tipo)
    AND tar_tip_cod IN ('P','I')
    AND tar_inf_cod=NVL(inf,tar_inf_cod)
	AND tar_usu_cod=NVL(usu,tar_usu_cod)
	--AND tar_apl_cod=NVL(apl,tar_apl_cod)
	AND tar_apl_cod in (
   	   		   	   	   select apl_cod from DUMBO.d7_aplicaciones
					   where apl_sis_cod = sistema
					   and NVL(apl_padre_apl_cod,'NULL') = NVL(apl,NVL(apl_padre_apl_cod,'NULL'))
					   union
			   		   select NVL(apl,'*') from dual
			  		   )
    -- Restriccin para GESTOR, no afecta a informticos ni a maestros
	AND tar_apl_cod IN (SELECT apl_cod FROM DUMBO.D7_APLICACIONES
	  		 			 WHERE apl_Sis_Cod = sistema
		 				 AND EXISTS (SELECT '*' FROM DUMBO.D7_APLICACIONES_INFORMATICOS
		 				  	 		  WHERE Ain_Sis_Cod = sistema
		 				  			  AND Apl_Cod = ain_apl_cod
 		 				  			  AND Ain_Inf_Cod = NVL(gestor,Ain_Inf_cod)
                    	  			  AND Ain_Responsable =DECODE(gestor,NULL,Ain_Responsable,'Y'))
			 			 OR(apl_sis_cod = sistema AND apl_sec_cod IN (SELECT sec_cod FROM DUMBO.D7_SECCIONES
		           												      	 START WITH sec_id_respon = NVL(gestor,sec_id_respon) AND sec_sis_cod = sistema
		        												      	 CONNECT BY PRIOR sec_cod=sec_sec_cod
		           												      	 AND sec_sis_cod= sistema
		           												      	 AND sec_cod != sec_sec_cod
			 															 UNION
			       														 SELECT sec_cod FROM DUMBO.D7_SECCIONES
		           												      	 WHERE apl_sec_cod=sec_cod
			       										            	 AND sec_id_respon = NVL(gestor,sec_id_respon)
			 	  										            	 AND sec_sis_cod= sistema
																		 )
				  			 )
					 )
	 AND (DECODE(tar_cat_cod,NULL,'NULL',tar_cat_cod) = DECODE(cat,NULL,'NULL',cat) OR  tar_cat_cod IN  (SELECT cat_cod FROM DUMBO.D7_CATEGORIAS
												          												     WHERE cat_sis_cod = sistema
																											 START WITH cat_cod = NVL(cat,cat_cod) AND cat_sis_cod = sistema
												          												     CONNECT BY PRIOR cat_cod=cat_cat_cod
												          												     AND cat_sis_cod= sistema
												          												     AND cat_cod != cat_cat_cod
																										 )
		 )
   --Si se introduce una SECCIN por la que filtrar(la relacion entre tareas y secciones son aplicaciones).
   --Tambin se incluyen las hijas de esta seccin introducida
   AND (tar_apl_cod IS NULL OR EXISTS (SELECT  apl_cod  FROM DUMBO.D7_APLICACIONES
	 			   	  	 					   		   		    WHERE apl_sis_cod = sistema
																AND tar_apl_cod = apl_cod
				   		 										AND apl_sec_cod IN ( SELECT sec_cod FROM DUMBO.D7_SECCIONES
									 											     WHERE sec_sis_cod = sistema
		          					 												 START WITH sec_cod = NVL(Sec,sec_cod) AND sec_sis_cod = sistema
		          					 												 CONNECT BY PRIOR sec_cod = sec_sec_cod
		          					 												 AND sec_sis_cod= sistema
		          					 												 AND sec_cod != sec_sec_cod
																					  )
																 )
			 )
	-- Restriccin para GRUPOS DE USUARIOS
	AND ((select count(*) from DUMBO.D7_Grupos_usuarios where gru_sis_cod = sistema) = '0'
				OR EXISTS (SELECT '*' FROM DUMBO.D7_USUARIOS_GRUPOS
	 			WHERE tar_usu_cod = DECODE(grusu,NULL,tar_usu_cod,ugr_usu_cod)
				AND ugr_sis_cod = sistema
				--Mediante esta select tambien se contendran los subGrupos de Usuarios
				AND  ugr_gru_cod = NVL(grusu,ugr_gru_cod )
				AND ugr_gru_cod IN  (SELECT gru_cod FROM DUMBO.D7_GRUPOS_USUARIOS
										 WHERE gru_sis_cod = sistema
										 AND gru_cod IN (SELECT gru_cod FROM DUMBO.D7_GRUPOS_USUARIOS
		          											 START WITH gru_cod = NVL(grusu,gru_cod) AND gru_sis_cod = sistema
		          											 CONNECT BY PRIOR gru_cod = gru_cod_cod
		          											 AND gru_sis_cod= sistema
		          											 AND gru_cod != gru_cod_cod)
									 )
					)
 				 );
  RETURN(suma);
  END;

-----------------------------------------------------------------------
FUNCTION Estado (sistema IN VARCHAR2, estado IN VARCHAR2, gestor IN VARCHAR2, tipo IN  VARCHAR2, fecini IN DATE, fecfin IN DATE , apl IN VARCHAR2, inf IN VARCHAR2, usu IN VARCHAR2, cat IN VARCHAR2, grusu IN VARCHAR2, Sec IN VARCHAR2)
RETURN NUMBER
 IS  suma NUMBER(10,2);
  --La descripcin de los parmetros es la siguiente:
	 --sistema : sistema sobre el que se realiza la metrica.
	 --gestor: Indica el cdigo del Gestor que realiza la mtrica, si no la realiza el Gestor ser NULL
	 --tipo: podr ser INCIDENCIA O PETICION O NULL(En este caso ser incidencias+peticiones)
	 --fecini: Se podr introducir una fecha de inicio sobre la cual capar las tareas de la mtrica
	 --fecfin: Se podr introducir una fecha de fin sobre la cual capar las tareas de la mtrica.
	 -- apl,Inf,usu,cat,grusu,sec: Parmetros que especifican una cierta aplicacion, informatico,usuario,
		    --categoria, grupoUsuario o seccion respectivamente sobre que se encuentre en todas las tareas
		    --resultado de la mtrica. Si no se introduce el parmetro no se hace la restriccin
	 -- Inf: ser tambin utilizado cuando la mtrica la realiza el informatico puesto que slo podr ver las
		   --tareas que tengan asociado a l como informatico entonces este parmetro se reutilizar.
  BEGIN
   SELECT COUNT(*)
    INTO suma
   FROM DUMBO.D7_TAREAS t
   WHERE tar_sis_cod = sistema
   AND tar_estado = NVL(estado,tar_estado)
   AND ((tar_estado='R'
        AND tar_horas_res > 0.0
          --   permite eliminar de la seleccin las tareas tiempo de resolucin sea el mismo en el padre, que en la suma
          --   de los hijos (se elimina el padre, para no duplicar informacin).
          --	Solamente se coge un nivel de herencia puesto que se comprobarn todas las tareas, esto es que en cada tarea
          --	se comprobarn sus hijos que son los nicos que importan(y no los hijos de los hijos).
          AND t.tar_horas_res > (SELECT NVL(SUM(t1.tar_horas_res),0) FROM DUMBO.D7_TAREAS t1
		                      WHERE t1.tar_sis_cod = sistema
							    AND t1.tar_padre_tar_cod=t.tar_cod)) OR tar_estado<>'R')

   -- Restriccin cuando se introduce una FECHA de inicio o fin o la dos
   AND TO_DATE(tar_feccrea,'DD-MM-YY')>= TO_DATE(NVL(fecini,tar_feccrea),'DD-MM-YY')
   AND TO_DATE(tar_feccrea,'DD-MM-YY')<= TO_DATE(NVL(fecfin,tar_feccrea),'DD-MM-YY')
   AND tar_tip_cod = DECODE(tipo,'INC+PET',tar_tip_cod, tipo)
   AND tar_tip_cod IN ('P','I')
   AND tar_inf_cod=NVL(inf,tar_inf_cod)
   AND tar_usu_cod=NVL(usu,tar_usu_cod)
--   AND (tar_apl_cod=NVL(apl,tar_apl_cod) OR tar_apl_cod IS NULL)
   AND tar_apl_cod in (
   	   		   	   	   select apl_cod from DUMBO.d7_aplicaciones
					   where apl_sis_cod = sistema
					   and NVL(apl_padre_apl_cod,'NULL') = NVL(apl,NVL(apl_padre_apl_cod,'NULL'))
					   union
			   		   select NVL(apl,'*') from dual
			  		   )
   -- Restriccin para GESTOR, no influye ni a informticos ni a maestros
   AND (DECODE(tar_apl_cod,NULL,'1','A')= DECODE (gestor,NULL,'1','G')  OR  tar_apl_cod IN (SELECT apl_cod FROM DUMBO.D7_APLICACIONES
	 		 						  	  			  	 								   	  	 		 WHERE apl_Sis_Cod = sistema
	 																					   			 AND EXISTS (SELECT '*' FROM DUMBO.D7_APLICACIONES_INFORMATICOS
		 									   	   		  									   	     		  		WHERE Ain_Sis_Cod = sistema
		 									   												   				  		AND Apl_Cod = ain_apl_cod
 		 								   					  								   				  		AND Ain_Inf_Cod = NVL(gestor,Ain_Inf_cod)
                    												     						   			        AND Ain_Responsable =DECODE(gestor,NULL,Ain_Responsable,'Y'))
			 																				             OR(apl_sis_cod = sistema AND apl_sec_cod IN (SELECT sec_cod FROM DUMBO.D7_SECCIONES
		           												      							  			  			  		  	  			  	 START WITH sec_id_respon = NVL(gestor,sec_id_respon) AND sec_sis_cod = sistema
		        												      										  										  CONNECT BY PRIOR sec_cod=sec_sec_cod
		           												      										  										  AND sec_sis_cod= sistema
		           												      										  										  AND sec_cod != sec_sec_cod
			 																								  										  UNION
			       																							  										  SELECT sec_cod FROM DUMBO.D7_SECCIONES
		           												      										  										  WHERE apl_sec_cod=sec_cod
			       										            										  										  AND sec_id_respon = NVL(gestor,sec_id_respon)
			 	  										            										  										  AND sec_sis_cod= sistema
																																					  )
				  										  									 				 )
																							       )
		 )
   -- Restriccin para CATEGORAS
   --DECODE(tar_cat_cod,NULL,'NULL',tar_cat_cod) = DECODE(cat,NULL,'NULL',cat)
   AND (DECODE(tar_cat_cod,NULL,'NULL',tar_cat_cod) = DECODE(cat,NULL,'NULL',cat) OR tar_cat_cod IN (SELECT cat_cod FROM DUMBO.D7_CATEGORIAS
																					  	  		  	     WHERE cat_sis_cod = sistema
							          												       				 START WITH cat_cod = NVL(cat,cat_cod) AND cat_sis_cod = sistema
							          												       				 CONNECT BY PRIOR cat_cod=cat_cat_cod
							          												       				 AND cat_sis_cod= sistema
							          												       				 AND cat_cod != cat_cat_cod
																									  )
		 )
   --Si se introduce una SECCIN por la que filtrar(la relacion entre tareas y secciones son aplicaciones).
   --Tambin se incluyen las hijas de esta seccin introducida
   AND (tar_apl_cod IS NULL OR EXISTS (SELECT  apl_cod  FROM DUMBO.D7_APLICACIONES
	 			   	  	 					   		   		    WHERE apl_sis_cod = sistema
																AND tar_apl_cod = apl_cod
			   		 										    AND apl_sec_cod IN ( SELECT sec_cod FROM DUMBO.D7_SECCIONES
									 											     WHERE sec_sis_cod = sistema
		          					 												 START WITH sec_cod = NVL(Sec,sec_cod) AND sec_sis_cod = sistema
																					 CONNECT BY PRIOR sec_cod = sec_sec_cod
		          					 												 AND sec_sis_cod= sistema
		          					 												 AND sec_cod != sec_sec_cod
																				  )
																 )
			 )
	-- Restriccin para GRUPOS DE USUARIOS
	AND ((select count(*) from DUMBO.D7_Grupos_usuarios where gru_sis_cod = sistema) = '0'
				OR EXISTS (SELECT '*' FROM DUMBO.D7_USUARIOS_GRUPOS
	 			WHERE tar_usu_cod = DECODE(grusu,NULL,tar_usu_cod,ugr_usu_cod)
				AND ugr_sis_cod = sistema
				--Mediante esta select tambien se contendran los subGrupos de Usuarios
				AND  ugr_gru_cod = NVL(grusu,ugr_gru_cod )
	    		AND ugr_gru_cod IN  (SELECT gru_cod FROM DUMBO.D7_GRUPOS_USUARIOS
										 WHERE gru_sis_cod = sistema
										 AND gru_cod IN (SELECT gru_cod FROM DUMBO.D7_GRUPOS_USUARIOS
		          											 START WITH gru_cod = NVL(grusu,gru_cod) AND gru_sis_cod = sistema
		          											 CONNECT BY PRIOR gru_cod = gru_cod_cod
		          											 AND gru_sis_cod= sistema
		          											 AND gru_cod != gru_cod_cod
														 )
									 )
									 )
 				 );
   RETURN(suma);
  END;

-----------------------------------------------------------------------
FUNCTION Estado_Desglose
 (sistema IN VARCHAR2, estado IN VARCHAR2, gestor IN VARCHAR2, tipo IN  VARCHAR2, fecini IN DATE, fecfin IN DATE, desglose IN VARCHAR2 , Desglose_cod IN VARCHAR2, apl IN VARCHAR2, inf IN VARCHAR2, usu IN VARCHAR2, cat IN VARCHAR2, grusu IN VARCHAR2, Sec IN VARCHAR2)
RETURN NUMBER
 IS  cantidad NUMBER(10,2);
  BEGIN
   SELECT COUNT(*)
   INTO cantidad
   FROM DUMBO.D7_TAREAS t
   WHERE tar_sis_cod = sistema
   AND tar_estado = NVL(estado,tar_estado)
   AND ((tar_estado='R'
          AND tar_horas_res > 0.0
          --   permite eliminar de la seleccin las tareas tiempo de resolucin sea el mismo en el padre, que en la suma
          --   de los hijos (se elimina el padre, para no duplicar informacin).
          --	Solamente se coge un nivel de herencia puesto que se comprobarn todas las tareas, esto es que en cada tarea
          --	se comprobarn sus hijos que son los nicos que importan(y no los hijos de los hijos).
          AND t.tar_horas_res > (SELECT NVL(SUM(t1.tar_horas_res),0) FROM DUMBO.D7_TAREAS t1
		                      WHERE t1.tar_sis_cod = sistema
							    AND t1.tar_padre_tar_cod=t.tar_cod)) or tar_estado<>'R')

   -- Restriccin cuando se introduce una FECHA de inicio o fin o la dos
   AND TO_DATE(tar_feccrea,'DD-MM-YY')>= TO_DATE(NVL(fecini,tar_feccrea),'DD-MM-YY')
   AND TO_DATE(tar_feccrea,'DD-MM-YY')<= TO_DATE(NVL(fecfin,tar_feccrea),'DD-MM-YY')
   AND DECODE(desglose,'A',tar_apl_cod,'C', tar_cat_cod ,'I',tar_inf_cod,'U','usu','G','gru','S','sec')= DECODE(desglose,'U','usu','G','gru','S','sec',Desglose_cod)
   AND ((desglose = 'U' AND decode(tar_usu_cod,'EXTERNO',tar_email_copia,tar_usu_cod) = Desglose_cod
				 )
						OR desglose != 'U'
			)
   AND ((desglose = 'S' AND exists (select apl_cod from DUMBO.D7_aplicaciones
				  						   	  where apl_sis_cod = sistema
											  and tar_apl_cod = apl_cod
											  and apl_sec_cod = Desglose_cod))
						OR desglose != 'S'
			)
	AND ((desglose = 'G' AND exists (select ugr_usu_cod from DUMBO.D7_usuarios_grupos
				  						   	  where ugr_sis_cod = sistema
											  and tar_usu_cod = ugr_usu_cod
											  and ugr_gru_cod = Desglose_cod))
						OR desglose != 'G'
			)
   --   AND tar_apl_cod=NVL(apl,tar_apl_cod)
   AND tar_tip_cod = DECODE(tipo,'INC+PET',tar_tip_cod, tipo)
   AND tar_tip_cod IN ('P','I')
   AND tar_inf_cod=NVL(inf,tar_inf_cod)
   AND tar_usu_cod=NVL(usu,tar_usu_cod)
   AND tar_apl_cod in (
   	   		   	   	   select apl_cod from DUMBO.d7_aplicaciones
					   where apl_sis_cod = sistema
					   and NVL(apl_padre_apl_cod,'NULL') = NVL(apl,NVL(apl_padre_apl_cod,'NULL'))
					   union
			   		   select NVL(apl,'*') from dual
			  		   )
   -- Restriccin de GESTOR, no influye a informticos ni a maestros
   AND tar_apl_cod IN (SELECT apl_cod FROM DUMBO.D7_APLICACIONES
	  		 			 WHERE apl_Sis_Cod = sistema
		 				 AND EXISTS (SELECT '*' FROM DUMBO.D7_APLICACIONES_INFORMATICOS
		 				  	 		  WHERE Ain_Sis_Cod = sistema
		 				  			  AND Apl_Cod = ain_apl_cod
 		 				  			  AND Ain_Inf_Cod = NVL(gestor,Ain_Inf_cod)
                    	  			  AND Ain_Responsable =DECODE(gestor,NULL,Ain_Responsable,'Y'))
			 			 OR(apl_sis_cod = sistema AND apl_sec_cod IN (SELECT sec_cod FROM DUMBO.D7_SECCIONES
		           												      	 START WITH sec_id_respon = NVL(gestor,sec_id_respon) AND sec_sis_cod = sistema
		        												      	 CONNECT BY PRIOR sec_cod=sec_sec_cod
		           												      	 AND sec_sis_cod= sistema
		           												      	 AND sec_cod != sec_sec_cod
			 															 UNION
			       														 SELECT sec_cod FROM DUMBO.D7_SECCIONES
		           												      	 WHERE apl_sec_cod=sec_cod
			       										            	 AND sec_id_respon = NVL(gestor,sec_id_respon)
			 	  										            	 AND sec_sis_cod= sistema
																		 )
				  			 )
					 )
   -- Restriccin de CATEGORAS
   AND (DECODE(tar_cat_cod,NULL,'NULL',tar_cat_cod) = DECODE(cat,NULL,'NULL',cat) OR  tar_cat_cod IN  (SELECT cat_cod FROM DUMBO.D7_CATEGORIAS
																										 WHERE cat_sis_cod = sistema
											          				 									 START WITH cat_cod = NVL(cat,cat_cod) AND cat_sis_cod = sistema
											          				 									 CONNECT BY PRIOR cat_cod=cat_cat_cod
											          				 									 AND cat_sis_cod= sistema
											          				 									 AND cat_cod != cat_cat_cod
															 									 		)
		 )
   --Si se introduce una SECCIN por la que filtrar(la relacion entre tareas y secciones son aplicaciones).
   --Tambin se incluyen las hijas de esta seccin introducida
   AND (tar_apl_cod IS NULL OR EXISTS (SELECT  apl_cod  FROM DUMBO.D7_APLICACIONES
	 			   	  	 					   		   		    WHERE apl_sis_cod = sistema
																AND tar_apl_cod = apl_cod
				   		 										AND apl_sec_cod IN ( SELECT sec_cod FROM DUMBO.D7_SECCIONES
									 											     WHERE sec_sis_cod = sistema
		          					 												 START WITH sec_cod = NVL(Sec,sec_cod) AND sec_sis_cod = sistema
		          					 												 CONNECT BY PRIOR sec_cod = sec_sec_cod
		          					 												 AND sec_sis_cod= sistema
		          					 												 AND sec_cod != sec_sec_cod
																					  )
																 )
			 )
	-- Restriccin de GRUPOS DE USUARIOS
	AND ((select count(*) from DUMBO.D7_Grupos_usuarios where gru_sis_cod = sistema) = '0'
				OR EXISTS (SELECT '*' FROM DUMBO.D7_USUARIOS_GRUPOS
	 			WHERE tar_usu_cod = DECODE(grusu,NULL,tar_usu_cod,ugr_usu_cod)
				AND ugr_sis_cod = sistema
				--Mediante esta select tambien se contendran los subGrupos de Usuarios
				AND  ugr_gru_cod = NVL(grusu,ugr_gru_cod )
				AND ugr_gru_cod IN  (SELECT gru_cod FROM DUMBO.D7_GRUPOS_USUARIOS
										 WHERE gru_sis_cod = sistema
										 AND gru_cod IN (SELECT gru_cod FROM DUMBO.D7_GRUPOS_USUARIOS
		          											 START WITH gru_cod = NVL(grusu,gru_cod) AND gru_sis_cod = sistema
		          											 CONNECT BY PRIOR gru_cod = gru_cod_cod
		          											 AND gru_sis_cod= sistema
		          											 AND gru_cod != gru_cod_cod
														 )
									 )
					)
 				 );
  RETURN(cantidad);
  END;
-----------------------------------------------------------------------
FUNCTION  YDias_Estadistico
 (sistema IN VARCHAR2, estado IN VARCHAR2, dias VARCHAR2,prioridad VARCHAR2, gestor IN VARCHAR2, tipo IN  VARCHAR2, fecini IN DATE, fecfin IN DATE, Desglose_cod IN VARCHAR2,Sec IN VARCHAR2)
RETURN NUMBER
 IS  cantidad NUMBER(10,2);
  --La descripcin de los parmetros es la siguiente:
	 --sistema : sistema sobre el que se realiza la metrica.
	 --gestor: Indica el cdigo del Gestor que realiza la mtrica, si no la realiza el Gestor ser NULL
	 --tipo: podr ser INCIDENCIA O PETICION O NULL(En este caso ser incidencias+peticiones)
	 --fecini: Se podr introducir una fecha de inicio sobre la cual capar las tareas de la mtrica
	 --fecfin: Se podr introducir una fecha de fin sobre la cual capar las tareas de la mtrica.
	 --Sec: Parmetro  que especifica  una cierta  SECCIN introducida como filtro
  BEGIN
   SELECT COUNT(*)
   INTO cantidad
   FROM DUMBO.D7_TAREAS t
   WHERE tar_sis_cod = sistema
   AND tar_estado != 'N'
   AND tar_estado != 'R'
   AND ((estado = 'PENDIENTES'
   	   		  AND tar_estado IN ('P','A','X','W')) or (estado != 'PENDIENTES' AND tar_estado = estado))
   --Permite el desglose por seccin
   AND tar_apl_cod in (select apl_cod from DUMBO.D7_aplicaciones
				  		where apl_sis_cod = sistema
						and apl_sec_cod = NVL(Desglose_cod,apl_sec_cod))
   -- Restriccin cuando se introduce una FECHA de inicio o fin o la dos
   AND TO_DATE(tar_feccrea,'DD-MM-YY')>= TO_DATE(NVL(fecini,tar_feccrea),'DD-MM-YY')
   AND TO_DATE(tar_feccrea,'DD-MM-YY')<= TO_DATE(NVL(fecfin,tar_feccrea),'DD-MM-YY')
   AND Fmetricas.Calcula_Dias(tar_feccrea,sysdate) - Fmetricas.Calcula_ESPERA(tar_sis_cod,tar_cod)> dias
   --Si realizas la query deglosando por prioridades
   AND DECODE(prioridad,NULL,NVL(tar_pri_cod,'pri'),prioridad) = NVL(tar_pri_cod,'pri')
   AND tar_tip_cod = NVL(tipo,tar_tip_cod)
   --Cuando el GESTOR realiza la mtrica debe ver todas las tareas realacionadas con el mediante las
   --aplicaciones o las secciones
   AND tar_apl_cod IN (SELECT apl_cod FROM DUMBO.D7_APLICACIONES
	  		 			 WHERE apl_Sis_Cod = sistema
		 				 AND EXISTS (SELECT '*' FROM DUMBO.D7_APLICACIONES_INFORMATICOS
		 				  	 		  WHERE Ain_Sis_Cod = sistema
		 				  			  AND Apl_Cod = ain_apl_cod
 		 				  			  AND Ain_Inf_Cod = NVL(gestor,Ain_Inf_cod)
                    	  			  AND Ain_Responsable =DECODE(gestor,NULL,Ain_Responsable,'Y'))
			 			 OR(apl_sis_cod = sistema AND apl_sec_cod IN (SELECT sec_cod FROM DUMBO.D7_SECCIONES
		           												      	 START WITH sec_id_respon = NVL(gestor,sec_id_respon) AND sec_sis_cod = sistema
		        												      	 CONNECT BY PRIOR sec_cod=sec_sec_cod
		           												      	 AND sec_sis_cod= sistema
		           												      	 AND sec_cod != sec_sec_cod
			 															 UNION
			       														 SELECT sec_cod FROM DUMBO.D7_SECCIONES
		           												      	 WHERE apl_sec_cod=sec_cod
			       										            	 AND sec_id_respon = NVL(gestor,sec_id_respon)
			 	  										            	 AND sec_sis_cod= sistema
																		 )
				  			 )
					 )
   --Si se introduce una seccin por la que filtrar(la relacion entre tareas y secciones son aplicaciones).
   --Tambin se incluyen las hijas de esta seccin introducida
   AND (tar_apl_cod IS NULL OR EXISTS (SELECT  apl_cod  FROM DUMBO.D7_APLICACIONES
	 			   	  	 					   		   		    WHERE apl_sis_cod = sistema
																AND tar_apl_cod = apl_cod
				   		 										AND apl_sec_cod IN ( SELECT sec_cod FROM DUMBO.D7_SECCIONES
									 											     WHERE sec_sis_cod = sistema
		          					 												 START WITH sec_cod = NVL(Sec,sec_cod) AND sec_sis_cod = sistema
		          					 												 CONNECT BY PRIOR sec_cod = sec_sec_cod
		          					 												 AND sec_sis_cod= sistema
		          					 												 AND sec_cod != sec_sec_cod
																					  )
																 )
			 );
  RETURN(cantidad);
  END;
 -----------------------------------------------------------------------
FUNCTION Desviacion_Estadistico
 (sistema IN VARCHAR2,desv VARCHAR2,prioridad VARCHAR2, gestor IN VARCHAR2, tipo IN  VARCHAR2, fecini IN DATE, fecfin IN DATE,Sec IN VARCHAR2)
RETURN NUMBER
 IS  cantidad NUMBER(10,2);
  --La descripcin de los parmetros es la siguiente:
	 --sistema : sistema sobre el que se realiza la metrica.
	 --gestor: Indica el cdigo del Gestor que realiza la mtrica, si no la realiza el Gestor ser NULL
	 --tipo: podr ser INCIDENCIA O PETICION O NULL(En este caso ser incidencias+peticiones)
	 --fecini: Se podr introducir una fecha de inicio sobre la cual capar las tareas de la mtrica
	 --fecfin: Se podr introducir una fecha de fin sobre la cual capar las tareas de la mtrica.
	 --Sec: Parmetro  que especifica  una cierta  SECCIN introducida como filtro
  BEGIN
   SELECT COUNT(*)
   INTO cantidad
   FROM DUMBO.D7_TAREAS t
   WHERE tar_sis_cod = sistema
   AND tar_estado = 'R'
   AND ((tar_estado='R'
          AND tar_horas_res > 0.0
          --   permite eliminar de la seleccin las tareas tiempo de resolucin sea el mismo en el padre, que en la suma
          --   de los hijos (se elimina el padre, para no duplicar informacin).
          --   Solamente se coge un nivel de herencia puesto que se comprobarn todas las tareas, esto es que en cada tarea
          --   se comprobarn sus hijos que son los nicos que importan(y no los hijos de los hijos).
          AND t.tar_horas_res > (SELECT NVL(SUM(t1.tar_horas_res),0) FROM DUMBO.D7_TAREAS t1
		                      WHERE t1.tar_sis_cod = sistema
							    AND t1.tar_padre_tar_cod=t.tar_cod)) or tar_estado<>'R')

   AND tar_apl_cod in (select apl_cod from DUMBO.D7_aplicaciones
   	   			   		  	where apl_sis_cod = sistema
							and apl_sec_cod = NVL(Sec,apl_sec_cod)
						  )
   -- Restriccin cuando se introduce una FECHA de inicio o fin o la dos
   AND TO_DATE(tar_feccrea,'DD-MM-YY')>= TO_DATE(NVL(fecini,tar_feccrea),'DD-MM-YY')
   AND TO_DATE(tar_feccrea,'DD-MM-YY')<= TO_DATE(NVL(fecfin,tar_feccrea),'DD-MM-YY')

   --Eliminamos la posible opcin de que el divisor de nulo
   AND (Fmetricas.Calcula_Dias(tar_feccrea,tar_fecfin)*7) >0
   --Desde encuadrarse en una desviacin dada desde parmetro
   AND (100*tar_horas_res)/(Fmetricas.Calcula_Dias(tar_feccrea,tar_fecfin)*7) > desv

   --No contrar aquellas tareas que tienen prioridad planificada
   AND tar_pri_cod != 'P'
   --Si realizas la query deglosando por prioridades
   AND DECODE(prioridad,NULL,NVL(tar_pri_cod,'pri'),prioridad) = NVL(tar_pri_cod,'pri')
   AND tar_tip_cod = NVL(tipo,tar_tip_cod)
   AND tar_tip_cod IN ('P','I')
   --No contar aquellas tareas que en algn momento de su vida han estado en estado de espera.
   AND tar_cod NOT IN (SELECT tmo_tar_cod FROM DUMBO.D7_TAREAS_MOVIMIENTOS
   	   		   	   	  		  WHERE tmo_sis_cod = sistema
							  AND tmo_tar_cod = tar_cod
							  AND tmo_tipo_mov = 'W'
					   )
   --Cuando el GESTOR realiza la mtrica debe ver todas las tareas realacionadas con el mediante las
   --aplicaciones o las secciones
    AND tar_apl_cod IN (SELECT apl_cod FROM DUMBO.D7_APLICACIONES
	  		 			 WHERE apl_Sis_Cod = sistema
		 				 AND EXISTS (SELECT '*' FROM DUMBO.D7_APLICACIONES_INFORMATICOS
		 				  	 		  WHERE Ain_Sis_Cod = sistema
		 				  			  AND Apl_Cod = ain_apl_cod
 		 				  			  AND Ain_Inf_Cod = NVL(gestor,Ain_Inf_cod)
                    	  			  AND Ain_Responsable =DECODE(gestor,NULL,Ain_Responsable,'Y'))
			 			 OR(apl_sis_cod = sistema AND apl_sec_cod IN (SELECT sec_cod FROM DUMBO.D7_SECCIONES
		           												      	 START WITH sec_id_respon = NVL(gestor,sec_id_respon) AND sec_sis_cod = sistema
		        												      	 CONNECT BY PRIOR sec_cod=sec_sec_cod
		           												      	 AND sec_sis_cod= sistema
		           												      	 AND sec_cod != sec_sec_cod
			 															 UNION
			       														 SELECT sec_cod FROM DUMBO.D7_SECCIONES
		           												      	 WHERE apl_sec_cod=sec_cod
			       										            	 AND sec_id_respon = NVL(gestor,sec_id_respon)
			 	  										            	 AND sec_sis_cod= sistema
																		 )
				  			 )
					 )
   --Si se introduce una seccin por la que filtrar(la relacion entre tareas y secciones son aplicaciones).
   --Tambin se incluyen las hijas de esta seccin introducida
   AND (tar_apl_cod IS NULL OR EXISTS (SELECT  apl_cod  FROM DUMBO.D7_APLICACIONES
	 			   	  	 					   		   		    WHERE apl_sis_cod = sistema
																AND tar_apl_cod = apl_cod
				   		 										AND apl_sec_cod IN ( SELECT sec_cod FROM DUMBO.D7_SECCIONES
									 											     WHERE sec_sis_cod = sistema
		          					 												 START WITH sec_cod = NVL(Sec,sec_cod) AND sec_sis_cod = sistema
		          					 												 CONNECT BY PRIOR sec_cod = sec_sec_cod
		          					 												 AND sec_sis_cod= sistema
		          					 												 AND sec_cod != sec_sec_cod
																					  )
																 )
			 );
  RETURN(cantidad);
  END;
 -----------------------------------------------------------------------
FUNCTION TopXUsu (sistema IN VARCHAR2, estado IN VARCHAR2, gestor IN VARCHAR2, usu IN VARCHAR2, tipo IN  VARCHAR2, fecini IN DATE, fecfin IN DATE, desglose_cod IN VARCHAR2, Sec IN VARCHAR2)
RETURN NUMBER
 IS  suma NUMBER(10,2);
  --La descripcin de los parmetros es la siguiente:
	 --sistema : sistema sobre el que se realiza la metrica.
	 --gestor: Indica el cdigo del Gestor que realiza la mtrica, si no la realiza el Gestor ser NULL
	 --tipo: podr ser INCIDENCIA O PETICION O NULL(En este caso ser incidencias+peticiones)
	 --fecini: Se podr introducir una fecha de inicio sobre la cual capar las tareas de la mtrica
	 --fecfin: Se podr introducir una fecha de fin sobre la cual capar las tareas de la mtrica.
	 --Sec: Parmetro  que especifica  una cierta  SECCIN introducida como filtro
  BEGIN
   SELECT COUNT(*)
    INTO suma
   FROM DUMBO.D7_TAREAS t
   WHERE tar_sis_cod = sistema
   AND tar_estado != 'N'
   AND tar_estado = NVL(estado,tar_estado)
   --Permite realizar el desglose de la metrica por seccin (no se ha creado una nueva funcin
   -- puesto que el desglose en esta mtrica solo se puede realizar por seccion )
   AND EXISTS (select '*' from DUMBO.D7_aplicaciones
				  	where apl_sis_cod = sistema
					and tar_apl_cod = apl_cod
					and apl_sec_cod = NVL(desglose_cod,apl_sec_cod)
			  )
   AND decode(tar_usu_cod,'EXTERNO',tar_email_copia,tar_usu_cod)= NVL(usu,decode(tar_usu_cod,'EXTERNO',tar_email_copia,tar_usu_cod))
   -- Restriccin cuando se introduce una FECHA de inicio o fin o la dos
   AND TO_DATE(tar_feccrea,'DD-MM-YY')>= TO_DATE(NVL(fecini,tar_feccrea),'DD-MM-YY')
   AND TO_DATE(tar_feccrea,'DD-MM-YY')<= TO_DATE(NVL(fecfin,tar_feccrea),'DD-MM-YY')
   AND tar_tip_cod IN ('P','I')
   AND tar_tip_cod=NVL(tipo,tar_tip_cod)
   --Cuando el GESTOR realiza la mtrica debe ver todas las tareas realacionadas con el mediante las
   --aplicaciones o las secciones
    AND tar_apl_cod IN (SELECT apl_cod FROM DUMBO.D7_APLICACIONES
	  		 			 WHERE apl_Sis_Cod = sistema
		 				 AND EXISTS (SELECT '*' FROM DUMBO.D7_APLICACIONES_INFORMATICOS
		 				  	 		  WHERE Ain_Sis_Cod = sistema
		 				  			  AND Apl_Cod = ain_apl_cod
 		 				  			  AND Ain_Inf_Cod = NVL(gestor,Ain_Inf_cod)
                    	  			  AND Ain_Responsable =DECODE(gestor,NULL,Ain_Responsable,'Y'))
			 			 OR(apl_sis_cod = sistema AND apl_sec_cod IN (SELECT sec_cod FROM DUMBO.D7_SECCIONES
		           												      	 START WITH sec_id_respon = NVL(gestor,sec_id_respon) AND sec_sis_cod = sistema
		        												      	 CONNECT BY PRIOR sec_cod=sec_sec_cod
		           												      	 AND sec_sis_cod= sistema
		           												      	 AND sec_cod != sec_sec_cod
			 															 UNION
			       														 SELECT sec_cod FROM DUMBO.D7_SECCIONES
		           												      	 WHERE apl_sec_cod=sec_cod
			       										            	 AND sec_id_respon = NVL(gestor,sec_id_respon)
			 	  										            	 AND sec_sis_cod= sistema
																		 )
				  			 )
					 )
   --Si se introduce una SECCIN por la que filtrar(la relacion entre tareas y secciones son aplicaciones).
   --Tambin se incluyen las hijas de esta seccin introducida
   AND (tar_apl_cod IS NULL OR EXISTS (SELECT  apl_cod  FROM DUMBO.D7_APLICACIONES
	 			   	  	 					   		   		    WHERE apl_sis_cod = sistema
																AND tar_apl_cod = apl_cod
				   		 										AND apl_sec_cod IN ( SELECT sec_cod FROM DUMBO.D7_SECCIONES
									 											     WHERE sec_sis_cod = sistema
		          					 												 START WITH sec_cod = NVL(Sec,sec_cod) AND sec_sis_cod = sistema
		          					 												 CONNECT BY PRIOR sec_cod = sec_sec_cod
		          					 												 AND sec_sis_cod= sistema
		          					 												 AND sec_cod != sec_sec_cod
																					  )
																 )
			 )
   ORDER BY suma DESC;
   RETURN(suma);
  END;

-----------------------------------------------------------------------
FUNCTION TopXGruUsu (sistema IN VARCHAR2, estado IN VARCHAR2, gestor IN VARCHAR2, gru IN VARCHAR2, tipo IN  VARCHAR2, fecini IN DATE, fecfin IN DATE, desglose_cod IN VARCHAR2, Sec IN VARCHAR2)
RETURN NUMBER
 IS  suma NUMBER(10,2);
  --La descripcin de los parmetros es la siguiente:
	 --sistema : sistema sobre el que se realiza la metrica.
	 --gestor: Indica el cdigo del Gestor que realiza la mtrica, si no la realiza el Gestor ser NULL
	 --tipo: podr ser INCIDENCIA O PETICION O NULL(En este caso ser incidencias+peticiones)
	 --fecini: Se podr introducir una fecha de inicio sobre la cual capar las tareas de la mtrica
	 --fecfin: Se podr introducir una fecha de fin sobre la cual capar las tareas de la mtrica.
	 --Sec: Parmetro  que especifica  una cierta  SECCIN introducida como filtro
  BEGIN
   SELECT COUNT(*)
    INTO suma
   FROM DUMBO.D7_TAREAS t
   WHERE tar_sis_cod = sistema
   AND tar_estado != 'N'
   AND tar_estado = NVL(estado,tar_estado)
   --Permite realizar el desglose de la metrica por seccin (no se ha creado una nueva funcin
   -- puesto que el desglose en esta mtrica solo se puede realizar por seccion )
   AND EXISTS (select '*' from DUMBO.D7_aplicaciones
				  	where apl_sis_cod = sistema
					and tar_apl_cod = apl_cod
					and apl_sec_cod = NVL(desglose_cod,apl_sec_cod)
			  )
   --Permite saber las tareas de un cierto grupo de usuario pasdo por parmetro "gru"
   AND exists (select ugr_usu_cod from DUMBO.D7_usuarios_grupos
   	   		  	where ugr_sis_cod = sistema
   	   		  	and ugr_gru_cod = gru
				and tar_usu_cod = ugr_usu_cod
			  )

   -- Restriccin cuando se introduce una FECHA de inicio o fin o la dos
   AND TO_DATE(tar_feccrea,'DD-MM-YY')>= TO_DATE(NVL(fecini,tar_feccrea),'DD-MM-YY')
   AND TO_DATE(tar_feccrea,'DD-MM-YY')<= TO_DATE(NVL(fecfin,tar_feccrea),'DD-MM-YY')
   AND tar_tip_cod=NVL(tipo,tar_tip_cod)
   AND tar_tip_cod IN ('P','I')
   --Cuando el GESTOR realiza la mtrica debe ver todas las tareas realacionadas con el mediante las
   --aplicaciones o las secciones
    AND tar_apl_cod IN (SELECT apl_cod FROM DUMBO.D7_APLICACIONES
	  		 			 WHERE apl_Sis_Cod = sistema
		 				 AND EXISTS (SELECT '*' FROM DUMBO.D7_APLICACIONES_INFORMATICOS
		 				  	 		  WHERE Ain_Sis_Cod = sistema
		 				  			  AND Apl_Cod = ain_apl_cod
 		 				  			  AND Ain_Inf_Cod = NVL(gestor,Ain_Inf_cod)
                    	  			  AND Ain_Responsable =DECODE(gestor,NULL,Ain_Responsable,'Y'))
			 			 OR(apl_sis_cod = sistema AND apl_sec_cod IN (SELECT sec_cod FROM DUMBO.D7_SECCIONES
		           												      	 START WITH sec_id_respon = NVL(gestor,sec_id_respon) AND sec_sis_cod = sistema
		        												      	 CONNECT BY PRIOR sec_cod=sec_sec_cod
		           												      	 AND sec_sis_cod= sistema
		           												      	 AND sec_cod != sec_sec_cod
			 															 UNION
			       														 SELECT sec_cod FROM DUMBO.D7_SECCIONES
		           												      	 WHERE apl_sec_cod=sec_cod
			       										            	 AND sec_id_respon = NVL(gestor,sec_id_respon)
			 	  										            	 AND sec_sis_cod= sistema
																		 )
				  			 )
					 )
   --Si se introduce una SECCIN por la que filtrar(la relacion entre tareas y secciones son aplicaciones).
   --Tambin se incluyen las hijas de esta seccin introducida
   AND (tar_apl_cod IS NULL OR EXISTS (SELECT  apl_cod  FROM DUMBO.D7_APLICACIONES
	 			   	  	 					   		   		    WHERE apl_sis_cod = sistema
																AND tar_apl_cod = apl_cod
				   		 										AND apl_sec_cod IN ( SELECT sec_cod FROM DUMBO.D7_SECCIONES
									 											     WHERE sec_sis_cod = sistema
		          					 												 START WITH sec_cod = NVL(Sec,sec_cod) AND sec_sis_cod = sistema
		          					 												 CONNECT BY PRIOR sec_cod = sec_sec_cod
		          					 												 AND sec_sis_cod= sistema
		          					 												 AND sec_cod != sec_sec_cod
																					  )
																 )
			 )
   ORDER BY suma DESC;
   RETURN(suma);
  END;

-----------------------------------------------------------------------
FUNCTION TopXApl(sistema IN VARCHAR2, estado IN VARCHAR2, gestor IN VARCHAR2, apl  IN VARCHAR2, tipo IN  VARCHAR2, fecini IN DATE, fecfin IN DATE, desglose_cod IN VARCHAR2, Sec IN VARCHAR2)
RETURN NUMBER
 IS  suma NUMBER(10,2);
  --La descripcin de los parmetros es la siguiente:
	 --sistema : sistema sobre el que se realiza la metrica.
	 --gestor: Indica el cdigo del Gestor que realiza la mtrica, si no la realiza el Gestor ser NULL
	 --tipo: podr ser INCIDENCIA O PETICION O NULL(En este caso ser incidencias+peticiones)
	 --fecini: Se podr introducir una fecha de inicio sobre la cual capar las tareas de la mtrica
	 --fecfin: Se podr introducir una fecha de fin sobre la cual capar las tareas de la mtrica.
	 --Sec: Parmetro  que especifica  una cierta  SECCIN introducida como filtro
  BEGIN
   SELECT COUNT(*)
    INTO suma
   FROM DUMBO.D7_TAREAS t
   WHERE tar_sis_cod = sistema
   AND tar_estado != 'N'
   AND tar_estado = NVL(estado,tar_estado)
   AND tar_apl_cod = NVL(apl, tar_apl_cod)
    --Permite realizar el desglose de la metrica por seccin (no se ha creado una nueva funcin
   -- puesto que el desglose en esta mtrica solo se puede realizar por seccion )
   AND EXISTS (select '*' from DUMBO.D7_aplicaciones
				  	where apl_sis_cod = sistema
					and tar_apl_cod = apl_cod
					and apl_sec_cod = NVL(desglose_cod,apl_sec_cod)
			  )
   -- Restriccin cuando se introduce una FECHA de inicio o fin o la dos
   AND TO_DATE(tar_feccrea,'DD-MM-YY')>= TO_DATE(NVL(fecini,tar_feccrea),'DD-MM-YY')
   AND TO_DATE(tar_feccrea,'DD-MM-YY')<= TO_DATE(NVL(fecfin,tar_feccrea),'DD-MM-YY')
   AND tar_tip_cod=NVL(tipo,tar_tip_cod)
   AND tar_tip_cod IN ('P','I')
   --Cuando el GESTOR realiza la mtrica debe ver todas las tareas realacionadas con el mediante las
   --aplicaciones o las secciones
   AND tar_apl_cod IN (SELECT apl_cod FROM DUMBO.D7_APLICACIONES
	  		 			 WHERE apl_Sis_Cod = sistema
		 				 AND EXISTS (SELECT '*' FROM DUMBO.D7_APLICACIONES_INFORMATICOS
		 				  	 		  WHERE Ain_Sis_Cod = sistema
		 				  			  AND Apl_Cod = ain_apl_cod
 		 				  			  AND Ain_Inf_Cod = NVL(gestor,Ain_Inf_cod)
                    	  			  AND Ain_Responsable =DECODE(gestor,NULL,Ain_Responsable,'Y'))
			 			 OR(apl_sis_cod = sistema AND apl_sec_cod IN (SELECT sec_cod FROM DUMBO.D7_SECCIONES
		           												      	 START WITH sec_id_respon = NVL(gestor,sec_id_respon) AND sec_sis_cod = sistema
		        												      	 CONNECT BY PRIOR sec_cod=sec_sec_cod
		           												      	 AND sec_sis_cod= sistema
		           												      	 AND sec_cod != sec_sec_cod
			 															 UNION
			       														 SELECT sec_cod FROM DUMBO.D7_SECCIONES
		           												      	 WHERE apl_sec_cod=sec_cod
			       										            	 AND sec_id_respon = NVL(gestor,sec_id_respon)
			 	  										            	 AND sec_sis_cod= sistema
																		 )
				  			 )
					 )
   --Si se introduce una SECCIN por la que filtrar(la relacion entre tareas y secciones son aplicaciones).
   --Tambin se incluyen las hijas de esta seccin introducida
   AND (tar_apl_cod IS NULL OR EXISTS (SELECT  apl_cod  FROM DUMBO.D7_APLICACIONES
	 			   	  	 					   		   		    WHERE apl_sis_cod = sistema
																AND tar_apl_cod = apl_cod
				   		 										AND apl_sec_cod IN ( SELECT sec_cod FROM DUMBO.D7_SECCIONES
									 											     WHERE sec_sis_cod = sistema
		          					 												 START WITH sec_cod = NVL(Sec,sec_cod) AND sec_sis_cod = sistema
		          					 												 CONNECT BY PRIOR sec_cod = sec_sec_cod
		          					 												 AND sec_sis_cod= sistema
		          					 												 AND sec_cod != sec_sec_cod
																					  )
																 )
			 )
   ORDER BY suma DESC;
   RETURN(suma);
  END;

-----------------------------------------------------------------------
FUNCTION TipoAsignacion (sistema varchar2,tarea number) return varchar2 is
tar d7_tareas%rowtype;
mov d7_tareas_movimientos%rowtype;
cursor movs(sist in varchar2, tarcod in number) is
			 select *
			 from d7_tareas_movimientos
			 where tmo_sis_cod=sist
			 and tmo_tar_cod=tarcod;
begin
		 begin
		 select * into tar
		 from d7_tareas
		 where tar_sis_cod=sistema
		 and tar_cod=tarea;
		 exception when no_data_found then
				 return 'NOEXISTE';
		 end;
		 if tar.tar_tip_cod in ('P','I') then
				open movs(sistema,tarea);
				fetch movs into mov;
				while movs%found loop
							if mov.tmo_tipo_mov='U' and mov.tmo_valor_anterior is null then
								 return 'AsigDirecta';
							end if;
							if mov.tmo_tipo_mov='U' and mov.tmo_valor_anterior like 'Estado: P%' then
								 return 'PorCola';
							end if;
							if mov.tmo_tipo_mov='U' and mov.tmo_valor_anterior = 'Informtico: ' then
								 return 'PorColaApl';
							end if;
							fetch movs into mov;
				end loop;
				close movs;
			  if tar.tar_estado='P' or tar.tar_estado='N' then return 'NoAsignada'; end if;
				if tar.tar_estado='A' or tar.tar_estado='W' or tar.tar_estado='X' or tar.tar_estado='R' then return 'AsigDirecta'; end if;
				return 'NSNC';
		 else return 'PROG-PROB';
		 end if;
end;



	   function isAsignadaDirecta(sistema in varchar2,tarea in number) return varchar2 is
	   num number(10);
	   begin
			select count(*) into num
			from dumbo.d7_tareas
			where tar_sis_cod=sistema
			and tar_cod = tarea
			and (select tmo_fecha_mov from dumbo.d7_tareas_movimientos where tmo_sis_cod=tar_sis_cod and tmo_tipo_mov='U' and tmo_tar_cod=tar_cod and rownum=1) - tar_feccrea < 0.00006;
			if (num>0) then return 'Directa';
			else return 'Resto';
			end if;
	   end;

	   function isAsignadaPorColaAP(sistema in varchar2,tarea in number) return varchar2 is
	   num number(10);
	   begin
			select count(*) into num
			from dumbo.d7_tareas
			where tar_sis_cod=sistema
			and tar_cod = tarea
			and exists (select tmo_inf_cod from dumbo.d7_tareas_movimientos,dumbo.d7_aplicaciones_informaticos,dumbo.d7_aplicaciones where apl_cod=ain_apl_cod and ain_inf_cod=tmo_inf_cod and apl_tipo_asig='C' and tmo_sis_cod=tar_sis_cod and tmo_tipo_mov='U' and tmo_tar_cod=tar_cod and apl_sis_cod=tar_sis_cod and ain_sis_cod=tar_sis_cod and rownum=1)
			and isAsignadaDirecta(tar_sis_cod,tar_cod)='Resto';
			if (num>0) then return 'Por Cola Apl.';
			else return 'Resto';
			end if;
	   end;

	   function isAsignadaPorColaG(sistema in varchar2,tarea in number) return varchar2 is
	   num number(10);
	   begin
			select count(*) into num
			from dumbo.d7_tareas
			where tar_sis_cod=sistema
			and tar_cod = tarea
			and isAsignadaPorColaAP(tar_sis_cod,tar_cod)='Resto'
			and (exists (select tmo_inf_cod
			 		    from dumbo.d7_tareas_movimientos,dumbo.d7_informaticos_perfiles
			 			where tmo_sis_cod=tar_sis_cod and tmo_tipo_mov='U' and tmo_tar_cod=tar_cod and rownum=1 and ipe_inf_cod=tmo_inf_cod and ipe_per_cod='31')
				 or (isAsignadaDirecta(tar_sis_cod,tar_cod)='Resto'));
			if (num>0) then return 'Por Cola Gen.';
			else return 'Resto';
			end if;
	   end;

	   function isReasignada(sistema in varchar2,tarea in number) return varchar2 is
	   num number(10);
	   begin
			select count(*) into num
			from dumbo.d7_tareas
			where tar_sis_cod=sistema
			and tar_cod = tarea
			and (select count(*) from dumbo.d7_tareas_movimientos where tmo_tipo_mov='R' and tmo_tar_cod=tar_cod and tmo_sis_cod=tar_sis_cod and substr(tmo_valor_anterior,instr(tmo_valor_anterior,'Aplicacin:')+length('Aplicacin:')+1) not in (tar_apl_cod,'MIGRACION') and tmo_inf_cod!=tar_inf_cod)>0;
			if (num>0) then return 'Reasignadas';
			else return 'Resto';
			end if;
	   end;


	   function tipoAsigna(sistema in varchar2,tarea in number,mitipo in varchar2) return varchar2 is
	   tipo varchar2(20);
	   begin
	   		tipo := isAsignadaDirecta(sistema,tarea);
			if (tipo='Resto') then
			   tipo := isAsignadaPorColaAP(sistema,tarea);
			   if (tipo='Resto') then
			   	  tipo := isAsignadaPorColaG(sistema,tarea);
			   end if;
			end if;
			if (mitipo is null) then return tipo; end if;
			if (mitipo=tipo) then return tipo;
			else return 'Resto';
			end if;
	   end;

	   function tiempoEspera(sistema in varchar2,tarea in number) return number is
	   tiempo number(15,3) := 0;
	   fecha date;
	   sigFecha date;
	   valor d7_tareas_movimientos.TMO_VALOR_ANTERIOR%type;
	   cambiaEstado varchar2(1);
	   tipoMov varchar2(1);
	   cursor esperas(st in varchar2,t in number) is
	   		  select tmo_fecha_mov
			  from d7_tareas_movimientos
			  where tmo_sis_cod=st
			  and tmo_tar_cod=t
			  and tmo_tipo_mov = 'W'
			  order by tmo_fecha_mov;

	   cursor nextMov(st in varchar2,t in number,f in date) is
	   		  select tmo_tipo_mov,tmo_fecha_mov,tmo_valor_anterior
			  from d7_tareas_movimientos
			  where tmo_sis_cod=st
			  and tmo_tar_cod=t
			  and tmo_fecha_mov > f
			  order by tmo_fecha_mov;
	   begin

	   		open esperas(sistema,tarea);
			fetch esperas into fecha;
			while esperas%found loop
				  -- Tengo la fecha de la primera espera.
				  cambiaEstado := 'N';
				  open nextMov(sistema,tarea,fecha);
				  fetch nextMov into tipoMov,sigFecha,valor;
				  while nextMov%found and cambiaEstado='N' loop
				  		if valor like '%Estado:%' or tipoMov='F' then
						   tiempo := tiempo + (sigFecha-fecha);
						   cambiaEstado := 'S';
						end if;
				  		fetch nextMov into tipoMov,sigFecha,valor;
				  end loop;
				  close nextMov;
				  if cambiaEstado='N' then
				  	 -- Se ha puesto en espera y en espera continua...
					 tiempo := tiempo + (sysdate-fecha);
				  end if;
				  fetch esperas into fecha;
			end loop;
	   		close esperas;
			return tiempo;

	   end;

	   function franjaMinutos(tiempo in number) return number is
	   num number(10,3);
	   begin
	   		num := tiempo*60;
			if num<=15 then
			   num := 15;
			elsif num<=30 then
			   num:=30;
			elsif num<=60 then
			   num:=60;
			elsif num<=90 then
			   num:=90;
			elsif num<=120 then
			   num:=120;
			elsif num<180 then
			   num:=180;
			else num := 200;
			end if;
			return num;
	   end;

	   function franjaDias(tipo in varchar2,tiempo in number) return number is
	   num number(10,4);
	   begin
	   		num := abs(tiempo);
			if (tipo='A') then
			    num := num*24;
				if num<=3 then
				   num := 10;
				elsif num<=6 then
				   num:=20;
				elsif num<=12 then
				   num:=30;
				elsif num<=24 then
				   num:=40;
				elsif num<=48 then
				   num:=50;
				elsif num<=(5*24) then
				   num:=60;
				elsif num<=(7*24) then
				   num:=70;
				elsif num<=(15*24) then
				   num:=80;
				elsif num<(30*24) then
				   num:=90;
				else num := 100;
				end if;
			else
				if num<=1 then
				   num := 1;
				elsif num<=7 then
				   num:=7;
				elsif num<=15 then
				   num:=15;
				elsif num<=30 then
				   num:=30;
				elsif num<=60 then
				   num:=60;
				elsif num<90 then
				   num:=90;
				else num := 100;
				end if;
			end if;
			return num;
	   end;

	   function franjaTareas(tareas in number) return number is
	   num number(10);
	   begin
	   		num := floor(((abs(tareas)*100)/100)/50)*50;
			if num>=500 then
			   num := 500;
			end if;
			return num;
	   end;


	   function primeraFechaPrevista(sistema in varchar2,tarea in number) return date is
	   cursor cambioPrioridad(sist in varchar2,tar in number) is
			select decode(tmo_tipo_mov,'D',substr(tmo_valor_anterior,12,1),substr(tmo_valor_anterior,17,10))
			from d7_tareas_movimientos
			where tmo_sis_cod=sist
			and tmo_tar_cod = tar
			and ((tmo_tipo_mov='D' and length(tmo_valor_anterior)>11) or (tmo_tipo_mov='L' and length(tmo_valor_anterior)>16))
			order by tmo_cod;
		fecha date;
		prioridad varchar2(1);
		prioridadOrg varchar2(10);
		tipo varchar2(1);
	   begin

			open cambioPrioridad(sistema,tarea);
			fetch cambioPrioridad into prioridadOrg;
			close cambioPrioridad;

			select tar_feccrea,nvl(tar_pri_cod,'M'),tar_tip_cod into fecha,prioridad,tipo
			from d7_tareas
			where tar_sis_cod=sistema
			and tar_cod=tarea;

			if prioridadOrg is null then prioridadOrg := prioridad; end if;
			if length(prioridadOrg)=1 then
			   -- Lo primero que se hizo fue ponerle una prioridad !!
				select fecha+alertas.dias_habiles(fecha,pm.PMX_DIAS) into fecha
				from d7_parametros_maximos pm
				where pm.PMX_SIS_COD=sistema
				and pm.PMX_TIP_COD=tipo
				and pm.PMX_PRI_COD=prioridadOrg;
			else
				-- Lo primero que se hizo fue planificar !!
				fecha := to_date(prioridadOrg,'dd/mm/yyyy')+1;
			end if;

	   		return fecha;

	   exception when no_data_found then
	   		return null;
	   end;


	   function cerradaEnTiempo(sistema in varchar2,tarea in number) return varchar2 is
	   cursor cambioPrioridad(sist in varchar2,tar in number) is
			select decode(tmo_tipo_mov,'D',substr(tmo_valor_anterior,12,1),substr(tmo_valor_anterior,17,10))
			from d7_tareas_movimientos
			where tmo_sis_cod=sist
			and tmo_tar_cod = tar
			and ((tmo_tipo_mov='D' and length(tmo_valor_anterior)>11) or (tmo_tipo_mov='L' and length(tmo_valor_anterior)>16))
			order by tmo_cod;
		fecha date;
		prioridad varchar2(1);
		prioridadOrg varchar2(10);
		tipo varchar2(1);
		fechaFin date;
	   begin

			open cambioPrioridad(sistema,tarea);
			fetch cambioPrioridad into prioridadOrg;
			close cambioPrioridad;

			select tar_feccrea,nvl(tar_pri_cod,'M'),tar_tip_cod,tar_fecfin into fecha,prioridad,tipo,fechaFin
			from d7_tareas
			where tar_sis_cod=sistema
			and tar_cod=tarea;

			if prioridadOrg is null then prioridadOrg := prioridad; end if;
			if length(prioridadOrg)=1 then
			   -- Lo primero que se hizo fue ponerle una prioridad !!
				select fecha+alertas.dias_habiles(fecha,pm.PMX_DIAS)+1 into fecha
				from d7_parametros_maximos pm
				where pm.PMX_SIS_COD=sistema
				and pm.PMX_TIP_COD=tipo
				and pm.PMX_PRI_COD=prioridadOrg;
			else
				-- Lo primero que se hizo fue planificar !!
				fecha := to_date(prioridadOrg,'dd/mm/yyyy')+1;
			end if;

	   		if (fecha>fechaFin) then return 'S'; end if;
			return 'N';

	   exception when no_data_found then
	   		return null;
	   end;

END Fmetricas;
/

GRANT EXECUTE ON FMETRICAS TO JV_DUMBO;
