PROMPT -- CREANDO PAQUETE PKD7_TAREAS --;
CREATE OR REPLACE PACKAGE Pkd7_Tareas IS

	   FUNCTION alta_tarea(sistema IN VARCHAR2,
	   					   tipo IN VARCHAR2 DEFAULT 'P',
	   					   uscod IN VARCHAR2,
						   infcod IN VARCHAR2,
						   aplcod IN VARCHAR2,
	   					   asunto IN VARCHAR2,
						   descr IN VARCHAR2,
						   ubica IN VARCHAR2,
						   copia IN VARCHAR2,
						   urgente IN VARCHAR2,
						   fecmax IN DATE,
						   tare_padre IN NUMBER DEFAULT NULL,edif in varchar2 default null,telefono in varchar2 default null) RETURN NUMBER;

	   FUNCTION alta_tarea_con_prioridad(sistema IN VARCHAR2,
	   					   tipo IN VARCHAR2 DEFAULT 'P',
	   					   uscod IN VARCHAR2,
						   infcod IN VARCHAR2,
						   aplcod IN VARCHAR2,
	   					   asunto IN VARCHAR2,
						   descr IN VARCHAR2,
						   ubica IN VARCHAR2,
						   copia IN VARCHAR2,
						   urgente IN VARCHAR2,
						   prioridad IN VARCHAR2,
						   fecmax IN DATE,
						   tare_padre IN NUMBER DEFAULT NULL) RETURN NUMBER;
						   
	   FUNCTION finaliza_tarea(sistema IN VARCHAR2,
	   						   cod IN NUMBER,
							   texto IN VARCHAR2,
							   categoria IN VARCHAR2,
							   horas_res IN NUMBER,
							   coste_mat IN NUMBER DEFAULT 0) RETURN NUMBER;

		FUNCTION isSubSeccion(sec IN VARCHAR2,secPadre IN VARCHAR2,sist IN VARCHAR2) RETURN VARCHAR2;

		PROCEDURE movimiento_tarea(sistema IN VARCHAR2,cod IN NUMBER,texto IN VARCHAR2,tipo IN VARCHAR2, valor IN VARCHAR2);
		
		PROCEDURE asignar_tarea(sistema IN VARCHAR2,cod IN NUMBER,informatico IN VARCHAR2);
		
		PROCEDURE pasar_espera(sistema IN VARCHAR2,cod IN NUMBER,motivo IN VARCHAR2);
		PROCEDURE quitar_espera(sistema IN VARCHAR2,cod IN NUMBER,motivo IN VARCHAR2);
		
	   FUNCTION alta_dumbo_rapido(sistema IN VARCHAR2,
	   					   tipo IN VARCHAR2 DEFAULT 'P',
	   					   uscod IN VARCHAR2,
						   infcod IN VARCHAR2,
						   aplcod IN VARCHAR2,
	   					   asunto IN VARCHAR2,
						   descr IN VARCHAR2,
						   soluc IN VARCHAR2,
						   ubica IN VARCHAR2,
						   copia IN VARCHAR2,
						   urgente IN VARCHAR2,
						   fecmax IN DATE,
						   tare_padre IN NUMBER DEFAULT NULL,
						   horas_res IN NUMBER,
						   coste_mat IN NUMBER) RETURN NUMBER;
		
		FUNCTION fechaAlerta(sist IN VARCHAR2,cod IN NUMBER) RETURN DATE;
		
		FUNCTION listaCategorias(sistema in varchar2, seccion in varchar2,tipo in varchar2) RETURN SYS_REFCURSOR;
		
		PROCEDURE reasignar_tarea(sistema IN VARCHAR2,cod IN NUMBER,informatico IN VARCHAR2,motivo in varchar2);
		
		PROCEDURE anular_tarea(sistema IN VARCHAR2,cod IN NUMBER,motivo in varchar2);
		
		PROCEDURE planificar_tarea(sistema IN VARCHAR2,cod IN NUMBER,fecha in date,motivo in varchar2);
		
END;
/

CREATE OR REPLACE PACKAGE BODY Pkd7_Tareas AS
	   
	   
	   FUNCTION alta_dumbo_rapido(sistema IN VARCHAR2,
	   					   tipo IN VARCHAR2 DEFAULT 'P',
	   					   uscod IN VARCHAR2,
						   infcod IN VARCHAR2,
						   aplcod IN VARCHAR2,
	   					   asunto IN VARCHAR2,
						   descr IN VARCHAR2,
						   soluc IN VARCHAR2,
						   ubica IN VARCHAR2,
						   copia IN VARCHAR2,
						   urgente IN VARCHAR2,
						   fecmax IN DATE,
						   tare_padre IN NUMBER DEFAULT NULL,
						   horas_res IN NUMBER,
						   coste_mat IN NUMBER) RETURN NUMBER IS
		tarea NUMBER;
		cate NUMBER;
		ok NUMBER;
		BEGIN
			 tarea := alta_tarea(sistema,tipo,uscod,infcod,aplcod,asunto,descr,ubica,copia,urgente,fecmax,tare_padre);
			 IF tarea!=0 THEN
			    SELECT cat_cod INTO cate
				FROM D7_CATEGORIAS 
				WHERE cat_sis_cod=sistema 
				AND cat_tip_cod=tipo 
				AND cat_descrip='DUMBO RPIDO';
			    ok := Pkd7_Tareas.finaliza_tarea(sistema,tarea,soluc,cate,horas_res,coste_mat);
			 END IF;
			 RETURN tarea;
		END;
						   
	   
	   FUNCTION alta_tarea_con_prioridad(sistema IN VARCHAR2,
	   					   tipo IN VARCHAR2 DEFAULT 'P',
	   					   uscod IN VARCHAR2,
						   infcod IN VARCHAR2,
						   aplcod IN VARCHAR2,
	   					   asunto IN VARCHAR2,
						   descr IN VARCHAR2,
						   ubica IN VARCHAR2,
						   copia IN VARCHAR2,
						   urgente IN VARCHAR2,
						   prioridad IN VARCHAR2,
						   fecmax IN DATE,
						   tare_padre IN NUMBER DEFAULT NULL) RETURN NUMBER IS
		tarea NUMBER;
		BEGIN
			 tarea := alta_tarea(sistema,tipo,uscod,infcod,aplcod,asunto,descr,ubica,copia,urgente,fecmax,tare_padre);
			 IF tarea!=0 THEN
			    Pkd7_Tareas.movimiento_tarea (sistema, tarea, 'Cambio de prioridad', 'U',NULL);
			 	UPDATE D7_TAREAS SET tar_pri_cod=prioridad WHERE tar_sis_cod = sistema AND tar_cod=tarea;
			 END IF;
			 RETURN tarea;
		END;
						  
	   
	   FUNCTION alta_tarea(sistema IN VARCHAR2,
	   					   tipo IN VARCHAR2 DEFAULT 'P',
	   					   uscod IN VARCHAR2,
						   infcod IN VARCHAR2,
						   aplcod IN VARCHAR2,
	   					   asunto IN VARCHAR2,
						   descr IN VARCHAR2,
						   ubica IN VARCHAR2,
						   copia IN VARCHAR2,
						   urgente IN VARCHAR2,
						   fecmax IN DATE,
						   tare_padre IN NUMBER DEFAULT NULL,edif in varchar2 default null,telefono in varchar2 default null) RETURN NUMBER IS
						   
	     codTarea D7_TAREAS.TAR_COD%TYPE;
		 infoCod D7_TAREAS.Tar_INF_COD%TYPE := infcod;
		 estado VARCHAR2(1) := 'P';
		 tipoAsig VARCHAR2(1);
		 ausente VARCHAR2(1);
		 controla_ausencia VARCHAR2(1);
		 correo VARCHAR2(240);
		 miUsuario VARCHAR2(200) := uscod;
		 miCopia D7_TAREAS.tar_email_copia%TYPE := copia;
		 cnt number(10);
		 cntAux number(10);
		 conta number(2);
		 recibe_dumbo D7_TAREAS.Tar_INF_COD%TYPE;
		 tipoMovimiento VARCHAR2(3) := 'UI';
		 
		 CURSOR porPesos(si in varchar2,apl IN VARCHAR2) IS
		 		SELECT ain_inf_cod
				FROM dumbo.D7_APLICACIONES_INFORMATICOS
				WHERE ain_apl_cod=apl
				and ain_sis_cod=si
				ORDER BY (SELECT COUNT(*) FROM dumbo.D7_TAREAS WHERE tar_inf_cod=ain_inf_cod AND tar_estado IN ('A','W','X'));
				
		 CURSOR porResp(si in varchar2,apl IN VARCHAR2) IS
			    SELECT ain_inf_cod
			    FROM dumbo.D7_APLICACIONES_INFORMATICOS
			    WHERE ain_apl_cod=apl
				and ain_sis_cod=si
			    ORDER BY DECODE(ain_responsable,'Y',0,1),ain_prioridad,(SELECT COUNT(*) FROM dumbo.D7_TAREAS WHERE tar_inf_cod=ain_inf_cod AND tar_estado IN ('A','W','X'));
		
		 CURSOR porUbica(si in varchar2,apl in varchar2, ed in varchar2) is
		 		select ain_inf_cod,(select count(*) from dumbo.d7_tareas where tar_inf_cod=ain_inf_cod and tar_estado in ('A','W','X','P')) as cont
				from dumbo.d7_aplicaciones_informaticos,dumbo.d7_zonas_informaticos,dumbo.d7_zonas_edificios,dumbo.d7_informaticos
				where ain_sis_cod=si and ain_apl_cod=apl and zoned_ed_codigo=ed and inf_estado='V'
				and ain_inf_cod=zoninf_inf_cod and zoninf_zon_codigo=zoned_zon_codigo 
				and zoned_sis_cod=ain_sis_cod and zoninf_sis_cod=ain_sis_cod
				and ain_inf_cod = inf_cod and inf_estado='V' and ain_sis_cod=inf_sis_cod
				order by decode(zoninf_responsable,'S',0,'Y',0,1),nvl(zoninf_prioridad,0),cont;
		 
		
	   BEGIN
	   
	   		IF aplcod IS NOT NULL AND (infoCod IS NULL OR LENGTH(infoCod)=0) THEN

			   	 tipoMovimiento := 'UD';
				 SELECT apl_tipo_asig INTO tipoAsig 
				 FROM D7_APLICACIONES
				 WHERE APL_SIS_COD=sistema AND APL_COD=aplcod;
				 
				 BEGIN
			  		 SELECT PAR_VALOR INTO controla_ausencia
					 FROM D7_PARAMETROS
					 WHERE PAR_SIS_COD=sistema
					 AND PAR_PARAMETRO='PAR_CONTROL_AUSENCIAS';
				 EXCEPTION WHEN NO_DATA_FOUND THEN
				 	 controla_ausencia := 'N';
				 END;
				 
				 IF tipoAsig='P' THEN
				 
				 	  conta:=1;
	 				  recibe_dumbo:=null;
					  
				 	  ausente := 'S';
				 	  OPEN porPesos(sistema,aplcod);
					  FETCH porPesos INTO infoCod;
					  WHILE porPesos%FOUND AND ausente='S' LOOP
					  		IF (infoCod!=miUsuario) THEN
					  		   	  IF conta=1 THEN
								  	 recibe_dumbo:=infoCod;
								  END IF;	
								  conta:=conta+1;
								  IF controla_ausencia='S' THEN
					  		   	  	 EXECUTE IMMEDIATE 'select decode(nvl(ES_DIA_TRABAJO_PENDVAL('''||infoCod||''',sysdate),''TRUE''),''TRUE'',''N'',''S'') from dual' INTO ausente;
								  ELSE ausente := 'N';
								  END IF;
								  IF ausente = 'S' THEN infoCod := recibe_dumbo; END IF;
							END IF;
					  END LOOP;
				 
				 END IF;
				 
				 IF tipoAsig='R' THEN
				 
				 	  conta:=1;
	 				  recibe_dumbo:=null;
					  
				 	  ausente := 'S';
				 	  OPEN porResp(sistema,aplcod);
					  FETCH porResp INTO infoCod;
					  WHILE porResp%FOUND AND ausente='S' LOOP
					  		IF (infoCod!=miUsuario) THEN
						  		IF conta=1 THEN
									recibe_dumbo:=infoCod;
								END IF;	
								conta:=conta+1;
								IF controla_ausencia='S' THEN
						  		   EXECUTE IMMEDIATE 'select decode(nvl(ES_DIA_TRABAJO_PENDVAL('''||infoCod||''',sysdate),''TRUE''),''TRUE'',''N'',''S'') from dual' INTO ausente;
								ELSE ausente := 'N';
								END IF;
								IF ausente = 'S' THEN infoCod := recibe_dumbo; END IF;
							END IF;
					  END LOOP;

				 END IF;
				 	 
				 IF tipoAsig='U' THEN
				 	
				 	  conta:=1;
	 				  recibe_dumbo:=null;
					  cntAux:=null;
					  
				 	  ausente := 'S';
				 	  OPEN porUbica(sistema,aplcod,edif);
					  FETCH porUbica INTO infoCod,cnt;
					  WHILE porUbica%FOUND AND ausente='S' LOOP
					  		IF (infoCod!=miUsuario) THEN
						  		IF conta=1 THEN
									recibe_dumbo:=infoCod;
									cntAux:=cnt;
								END IF;	
								conta:=conta+1;
								IF controla_ausencia='S' THEN
						  		   EXECUTE IMMEDIATE 'select decode(nvl(ES_DIA_TRABAJO_PENDVAL('''||infoCod||''',sysdate),''TRUE''),''TRUE'',''N'',''S'') from dual' INTO ausente;
								ELSE ausente := 'N';
								END IF;
								IF ausente = 'S' THEN 
								   infoCod := recibe_dumbo;
								   cnt := cntAux;
								END IF;
							END IF;
					  END LOOP;

				 END IF;
				 	
			END IF;
	   
	   		IF infoCod IS NOT NULL AND LENGTH(infoCod)>0 THEN estado := 'A'; END IF;
			
			BEGIN
			  SELECT par_valor INTO correo
			  FROM D7_PARAMETROS
			  WHERE par_sis_cod=sistema
			  AND par_parametro='PAR_CORREO_DUMBO';
			  
			  IF uscod LIKE '%@%' THEN
			   -- Parece un correo.
			   IF uscod LIKE '%@'||SUBSTR(correo,INSTR(correo,'@')+1)
			   	  OR uscod LIKE '%.'||SUBSTR(correo,INSTR(correo,'@')+1) THEN
			  	   miUsuario := NVL(Pkd7_Mail.identificador_from_mail(uscod),uscod);
			   END IF;
			   IF miUsuario LIKE '%@%' THEN
			   	   -- Es un correo externo o interno pero sin DNI asociado.
				   IF copia IS NULL OR LENGTH(copia)>0 THEN
				      miCopia := uscod;
				   ELSE
				   	  miCopia := uscod||','||copia;
				   END IF;
				   miUsuario := 'EXTERNO';
			   END IF;
			
			  ELSE
			    -- Si es un DNI debe existir en afiliaciones.
			  	BEGIN
				 SELECT afi_identificador INTO miUsuario 
				 FROM afiliaciones
				 WHERE afi_identificador=uscod;
				EXCEPTION WHEN NO_DATA_FOUND THEN
				 RETURN 0;
				END;
			  END IF;
			  
			  IF infcod IS NOT NULL THEN
				  IF infcod LIKE '%@%' THEN
				   -- Parece un correo.
				   IF infcod LIKE '%@'||SUBSTR(correo,INSTR(correo,'@')+1)
				   	  OR infcod LIKE '%.'||SUBSTR(correo,INSTR(correo,'@')+1) THEN
					  infoCod := NVL(Pkd7_Mail.identificador_from_mail(infcod),infcod);
				   END IF;
				   IF infoCod LIKE '%@%' THEN
				   	   -- Es un correo externo.
					   -- No se permite.
					   RETURN 0;
				   END IF;
				  END IF;
				    -- El DNI debe existir en informaticos.
			  	  BEGIN
					 SELECT inf_cod INTO infoCod 
					 FROM D7_INFORMATICOS
					 WHERE inf_cod=infoCod
					 AND inf_sis_cod=sistema
					 AND inf_estado='V';
				  EXCEPTION WHEN NO_DATA_FOUND THEN
					 RETURN 0;
				  END;
			  END IF;
			  
			  IF (infoCod=miUsuario) THEN
				   BEGIN
				   		SELECT Sec_Id_Respon INTO miUsuario
						FROM D7_Secciones
						WHERE Sec_Sis_Cod=sistema
						AND Sec_Cod in (SELECT Inf_Sec_Cod 
							FROM D7_Informaticos
							WHERE Inf_Sis_Cod = sistema
							AND Inf_Cod = infoCod);
					END;
				END IF; 
			  
			END;

			EXECUTE IMMEDIATE 'select '||sistema||'_tar_d7_tareas.nextval from dual' INTO codTarea;
	   
	   		BEGIN
			
	   		INSERT INTO D7_TAREAS (TAR_SIS_COD,TAR_COD,TAR_TIP_COD,
			TAR_ASUNTO,TAR_USU_COD,TAR_APL_COD,TAR_INF_COD,TAR_FECCREA,TAR_ESTADO,TAR_DESCRIP,
			TAR_URGENCIA,TAR_FECMAX_RESOL,TAR_UBICACION,TAR_EMAIL_COPIA,TAR_PADRE_TAR_COD,TAR_EDUBICACION, TAR_TELEFONO)
			VALUES (sistema,codTarea,tipo,asunto,miUsuario,aplcod,infoCod,SYSDATE,estado,descr,urgente,fecmax,ubica,miCopia,tare_padre,edif,telefono);
			
			EXCEPTION WHEN OTHERS THEN
					  DBMS_OUTPUT.PUT_LINE(SQLERRM(SQLCODE));
			END;
			IF estado='A' THEN
			   Pkd7_Tareas.movimiento_tarea (sistema, codTarea,'Asignacin de tarea',tipoMovimiento,NULL);
			   Pkd7_Mail.enviarMail(sistema,codTarea,'Asig');
			END IF;
			
	   		RETURN codTarea;
			
	   EXCEPTION WHEN OTHERS THEN
	   	    RETURN 0;	
	   END;
	   
	   PROCEDURE pasar_espera(sistema IN VARCHAR2,cod IN NUMBER,motivo IN VARCHAR2) IS
	   BEGIN
	        UPDATE D7_TAREAS SET tar_estado='W',tar_descrip_segui=motivo WHERE tar_sis_cod=sistema AND tar_cod=cod;
	   		Pkd7_Tareas.movimiento_tarea (sistema,cod,motivo, 'W',NULL);
			Pkd7_Mail.enviarMail(sistema,cod,'Esp');
	   END;

	   PROCEDURE quitar_espera(sistema IN VARCHAR2,cod IN NUMBER,motivo IN VARCHAR2) IS
	   BEGIN
	   		UPDATE D7_TAREAS SET tar_estado='A',tar_descrip_segui=motivo WHERE tar_sis_cod=sistema AND tar_cod=cod;
	   		Pkd7_Tareas.movimiento_tarea (sistema, cod,motivo, 'N',NULL);
			Pkd7_Mail.enviarMail(sistema,cod,'Reac');
	   END;
	   
	   FUNCTION finaliza_tarea(sistema IN VARCHAR2,
	   						   cod IN NUMBER,
							   texto IN VARCHAR2,
							   categoria IN VARCHAR2,
							   horas_res IN NUMBER,
							   coste_mat IN NUMBER) RETURN NUMBER IS

		coste_info NUMBER(8,2) := 0;
		coste_sub NUMBER(8,2) := 0;
		coste_total NUMBER(8,2) := 0;
	   BEGIN
	   
	   		SELECT NVL(SUM(tar_coste_eco),0) INTO coste_sub
			FROM D7_TAREAS
			WHERE tar_padre_tar_cod=cod
			AND tar_sis_cod=sistema;

			BEGIN
				 SELECT gco_coste INTO coste_info
				 FROM D7_INFORMATICOS,D7_GRUPOS_COSTES
				 WHERE inf_sis_cod=sistema
				 AND gco_sis_cod=sistema
				 AND gco_cod=inf_gco_cod
				 AND inf_cod=(SELECT tar_inf_cod FROM D7_TAREAS WHERE tar_sis_cod=sistema AND tar_cod=cod);
			EXCEPTION WHEN NO_DATA_FOUND THEN
			   coste_info := 0;
			END;
	   
	   		coste_total := (horas_res*coste_info) + coste_sub;
	   
	   	    UPDATE D7_TAREAS SET    tar_estado='R',tar_descrip_segui=texto,
				   			 	 										tar_fecfin=SYSDATE,TAR_HORAS_RES=horas_res,
																		TAR_COSTE_ECO=coste_total,TAR_COSTE_MAT=coste_mat,
																		tar_cat_cod=categoria
			WHERE tar_sis_cod=sistema AND tar_cod=cod;
			
			Pkd7_Tareas.movimiento_tarea (sistema, cod, texto, 'F',NULL);
			
			Pkd7_Mail.enviarMail(sistema,cod,'Reso');
			
			RETURN 1;

	   EXCEPTION WHEN OTHERS THEN
			RETURN 0;
	   END;
	    
		PROCEDURE asignar_tarea(sistema IN VARCHAR2,cod IN NUMBER,informatico IN VARCHAR2) IS
		BEGIN
			 UPDATE D7_TAREAS SET tar_inf_cod=informatico
			 WHERE tar_sis_cod=sistema AND tar_cod=cod;
			 IF SQL%ROWCOUNT = 1 THEN
			 	movimiento_tarea(sistema,cod,'Asignacin de tarea.','UI',NULL);
			 END IF; 
		END;
		
		PROCEDURE movimiento_tarea(sistema IN VARCHAR2,cod IN NUMBER,texto IN VARCHAR2,tipo IN VARCHAR2, valor IN VARCHAR2) IS
				  code D7_TAREAS_MOVIMIENTOS.tmo_cod%TYPE := NULL;
		BEGIN
		
		
			SELECT NVL(MAX(tmo_cod),0)+1 INTO code
			FROM D7_TAREAS_MOVIMIENTOS
			WHERE tmo_sis_cod=sistema
			AND tmo_tar_cod=cod;

			INSERT INTO D7_TAREAS_MOVIMIENTOS 
			(TMO_SIS_COD,TMO_TAR_COD,TMO_COD,TMO_FECHA_MOV,TMO_TIPO_MOV,TMO_DESCRIP_MOV,TMO_INF_COD,TMO_VALOR_ANTERIOR)
			VALUES (sistema, cod, code, SYSDATE,tipo, texto, (SELECT tar_inf_cod FROM D7_TAREAS WHERE tar_sis_cod=sistema AND tar_cod=cod),valor);
		
		END;
		
		
	   FUNCTION isSubSeccion(sec IN VARCHAR2,secPadre IN VARCHAR2,sist IN VARCHAR2) RETURN VARCHAR2 IS
	     padre VARCHAR2(10);
	   BEGIN
	   		-- Si coinciden es correcto.
	   		IF (sec=secPadre) THEN
	   		   RETURN 'S';
			END IF;
			-- Miro el padre de la seccion 
			SELECT NVL(sec_sec_cod,sec_cod) INTO padre 
			FROM D7_SECCIONES
			WHERE sec_cod = sec AND sec_sis_cod = sist;
			-- Si es igual es de primer nivel.
			IF (padre=sec) THEN
			   RETURN 'N';
			END IF;
			IF (padre=secPadre) THEN
			   RETURN 'S';
			END IF;
			RETURN isSubSeccion(padre,secPadre,sist);
	   EXCEPTION WHEN NO_DATA_FOUND THEN
			 RETURN 'N';
	   END;

	   FUNCTION fechaAlerta(sist IN VARCHAR2,cod IN NUMBER) RETURN DATE IS
	   tarea D7_TAREAS%ROWTYPE;
	   dias D7_APLICACIONES_MAXIMOS.AMA_DIAS%TYPE;
	   --controla_ausencia VARCHAR2(1);
	   fecha date;
	   fecha_org date;
	   diasreales number(3);
	   --ausente varchar2(1);
	   BEGIN
	   
	   		SELECT * INTO tarea
			FROM D7_TAREAS
			WHERE tar_sis_cod=sist
			AND tar_cod=cod;
			
			BEGIN
			
				 SELECT ama_dias INTO dias
				 FROM D7_APLICACIONES_MAXIMOS
				 WHERE ama_sis_cod=sist
				 AND ama_apl_cod=tarea.tar_apl_cod
				 AND ama_tip_cod=tarea.tar_tip_cod
				 AND ama_pri_cod=tarea.tar_pri_cod;
				 
			EXCEPTION WHEN NO_DATA_FOUND THEN
					  -- No Tiene Prioridad !!
					 dias := 2;
			END;
			
			IF tarea.tar_pri_cod='P' THEN fecha_org := tarea.tar_planif;
			ELSE fecha_org := tarea.tar_feccrea; END IF;
			diasreales := dias;
			while Alertas.Dias_Laborables2(fecha_org,fecha_org+diasreales)<dias loop
				diasreales := diasreales + (dias-Alertas.Dias_Laborables2(fecha_org,fecha_org+diasreales));
			end loop;
			fecha := fecha_org+diasreales;
				
			RETURN fecha;
			
		  EXCEPTION WHEN NO_DATA_FOUND THEN
				  RETURN SYSDATE;
	   END;
		 
		 FUNCTION listaCategorias(sistema in varchar2, seccion in varchar2,tipo in varchar2) RETURN SYS_REFCURSOR
		 IS
		    mi_cursor SYS_refcursor;
				v_sqlstatement VARCHAR2(2000);
		 BEGIN
  	 			v_sqlstatement := 'select cat_cod,cat_descrip from d7_categorias where cat_sis_cod='''||sistema||''' and cat_sec_cod='''||seccion||''' and cat_estado=''V'' and cat_tip_cod='''||tipo||'''';
  				OPEN mi_cursor FOR v_sqlstatement;
          return(mi_cursor);
     END;		 


		PROCEDURE reasignar_tarea(sistema IN VARCHAR2,cod IN NUMBER,informatico IN VARCHAR2,motivo in varchar2) IS
		BEGIN
			 UPDATE D7_TAREAS SET tar_inf_cod=nvl(informatico,tar_inf_cod),tar_descrip_segui=nvl(motivo,tar_descrip_segui)
			 WHERE tar_sis_cod=sistema AND tar_cod=cod;
			 IF SQL%ROWCOUNT = 1 THEN
			 	movimiento_tarea(sistema,cod,'Resignacin de tarea.','RI',NULL);
			 END IF; 
			 Pkd7_Mail.enviarMail(sistema,cod,'Reas');
		END;

		PROCEDURE anular_tarea(sistema IN VARCHAR2,cod IN NUMBER,motivo in varchar2) IS
		BEGIN
			 UPDATE D7_TAREAS SET tar_estado='N',tar_descrip_segui=nvl(motivo,tar_descrip_segui)
			 WHERE tar_sis_cod=sistema AND tar_cod=cod;
			 IF SQL%ROWCOUNT = 1 THEN
			 	movimiento_tarea(sistema,cod,'Anulacin de tarea.','A',NULL);
			 END IF; 
			 Pkd7_Mail.enviarMail(sistema,cod,'UsuAnu');
		END;
   
		PROCEDURE planificar_tarea(sistema IN VARCHAR2,cod IN NUMBER,fecha in date,motivo in varchar2) IS
		BEGIN
			 UPDATE D7_TAREAS SET tar_planif=fecha,tar_pri_cod='P',tar_descrip_segui=nvl(motivo,tar_descrip_segui)
			 WHERE tar_sis_cod=sistema AND tar_cod=cod;
			 IF SQL%ROWCOUNT = 1 THEN
			 	movimiento_tarea(sistema,cod,'Cambio Fecha de Planificacin de tarea.','L',NULL);
			 END IF; 
			 Pkd7_Mail.enviarMail(sistema,cod,'UsuPlanif');
		END;

END;
/

GRANT EXECUTE ON PKD7_TAREAS TO JV_DUMBO;
