PROMPT -- CREANDO JAVA SOURCE SENDMAIL --;
CREATE OR REPLACE AND RESOLVE JAVA SOURCE NAMED "SendMail" AS
public class SendMail {
   // Sender, Recipient, CCRecipient, and BccRecipient are comma-
   // separated lists of addresses;
   // Body can span multiple CR/LF-separated lines;
   // Attachments is a ///-separated list of file names;
	
   public static int Send(String SMTPServer,
                          String Sender,
                          String Recipient,
                          String CcRecipient,
                          String BccRecipient,
                          String Subject,
                          String Body,
                          String ErrorMessage,
                          String Attachments) {

      // Error status;
      int ErrorStatus = 0;

    // create some properties and get the default Session;
    java.util.Properties props = new java.util.Properties();
    props.put("mail.smtp.host", SMTPServer);
    javax.mail.Session session = javax.mail.Session.getDefaultInstance(props, null);

       try {
          // create a message;
       	javax.mail.internet.MimeMessage msg = new javax.mail.internet.MimeMessage(session);

          // extracts the senders and adds them to the message;
          // Sender is a comma-separated list of e-mail addresses as
          // per RFC822;
          {
          	javax.mail.internet.InternetAddress[] TheAddresses =
             	javax.mail.internet.InternetAddress.parse(Sender);
             msg.addFrom(TheAddresses);
          }

	 // extract the recipients and assign them to the message;
          // Recipient is a comma-separated list of e-mail addresses
          // as per RFC822;
          {
          	javax.mail.internet.InternetAddress[] TheAddresses =
          		javax.mail.internet.InternetAddress.parse(Recipient);
             msg.addRecipients(javax.mail.Message.RecipientType.TO,
                               TheAddresses);
          }

	 // extract the Cc-recipients and assign them to the
          // message;
          // CcRecipient is a comma-separated list of e-mail
          // addresses as per RFC822;
          if (null != CcRecipient) {
          	javax.mail.internet.InternetAddress[] TheAddresses =
          		javax.mail.internet.InternetAddress.parse(CcRecipient);
             msg.addRecipients(javax.mail.Message.RecipientType.CC,
                               TheAddresses);
          }

	 // extract the Bcc-recipients and assign them to the
          // message;
          // BccRecipient is a comma-separated list of e-mail
          // addresses as per RFC822;
          if (null != BccRecipient) {
          	javax.mail.internet.InternetAddress[] TheAddresses =
          		javax.mail.internet.InternetAddress.parse(BccRecipient);
             msg.addRecipients(javax.mail.Message.RecipientType.BCC,
                               TheAddresses);
          }

          // subject field;
          msg.setSubject(Subject);

          // create the Multipart to be added the parts to;
          javax.mail.Multipart mp = new javax.mail.internet.MimeMultipart();

          // create and fill the first message part;
          {
          	javax.mail.internet.MimeBodyPart mbp = new javax.mail.internet.MimeBodyPart();
             mbp.setContent(Body,"text/html");

             // attach the part to the multipart;
             mp.addBodyPart(mbp);
          }

          // attach the files to the message;
          if (null != Attachments) {
             int StartIndex = 0, PosIndex = 0;
             while (-1 != (PosIndex = Attachments.indexOf("///",
                                                    StartIndex))) {
                // create and fill other message parts;
             	javax.mail.internet.MimeBodyPart mbp = new javax.mail.internet.MimeBodyPart();
             	javax.activation.FileDataSource fds =
                new javax.activation.FileDataSource(Attachments.substring(StartIndex,
                                                         PosIndex));
                mbp.setDataHandler(new javax.activation.DataHandler(fds));
                mbp.setFileName(fds.getName());
                mp.addBodyPart(mbp);
                PosIndex += 3;
                StartIndex = PosIndex;
             }
             // last, or only, attachment file;
             if (StartIndex < Attachments.length()) {
             	javax.mail.internet.MimeBodyPart mbp = new javax.mail.internet.MimeBodyPart();
             	javax.activation.FileDataSource fds =
              new javax.activation.FileDataSource(Attachments.substring(StartIndex));
                mbp.setDataHandler(new javax.activation.DataHandler(fds));
                mbp.setFileName(fds.getName());
                mp.addBodyPart(mbp);
             }
          }

          // add the Multipart to the message;
          msg.setContent(mp);

          // set the Date: header;
          msg.setSentDate(new java.util.Date());

          // send the message;
          javax.mail.Transport.send(msg);
       } catch (javax.mail.MessagingException MsgException) {
            ErrorMessage = MsgException.toString();
            Exception TheException = null;
            if ((TheException = MsgException.getNextException()) !=
                                                               null)
               ErrorMessage = ErrorMessage + "\n" +
                                 TheException.toString();
           ErrorStatus = 1;
       }
       return ErrorStatus;
   }
public static int Send(String SMTPServer,
                       String Sender,
                       String Recipient,
                       String CcRecipient,
                       String BccRecipient,
                       String Subject,
                       java.sql.Clob Body,
                       String ErrorMessage,
                       String Attachments) {
	try {
		String body = Body.getSubString(1,(int)Body.length());
		return Send(SMTPServer,
					Sender,
					Recipient,
					CcRecipient,
					BccRecipient,
					Subject,
					body,
					ErrorMessage,
					Attachments);
	} catch (Exception e) {
		ErrorMessage = e + ", " + e.getMessage();
		return 1;
	}
}
};
/
