PROMPT -- CREANDO PAQUETE PKD7_PROGRAMADO --;
CREATE OR REPLACE package PKD7_PROGRAMADO is
	   procedure revisar_tareas;
	   function activaTarea(cod in number) return varchar2;
	   procedure informe_usuarios;
end;
/

CREATE OR REPLACE PACKAGE BODY Pkd7_Programado AS

	   PROCEDURE revisar_tareas IS
	   	  sist D7_TAREAS.TAR_SIS_COD%TYPE;
		  uscod D7_TAREAS.TAR_USU_COD%TYPE;
		  aplcod D7_TAREAS.TAR_APL_COD%TYPE;
		  infcod D7_TAREAS.TAR_INF_COD%TYPE;
		  asunto D7_TAREAS.TAR_ASUNTO%TYPE;
		  descr D7_TAREAS.TAR_DESCRIP%TYPE;
		  ubica D7_TAREAS.TAR_UBICACION%TYPE;
		  copia D7_TAREAS.TAR_EMAIL_COPIA%TYPE;
		  urg D7_TAREAS.TAR_URGENCIA%TYPE;
		  fecmax D7_TAREAS.TAR_FECMAX_RESOL%TYPE;
		  cod D7_TAREAS.TAR_COD%TYPE;
		  ultima D7_TAREAS_PROGRAMADAS.TPR_TAREAS_GENERADAS%TYPE;
		  tarea D7_TAREAS.TAR_COD%TYPE;
	      CURSOR tareas IS
	   		  SELECT CEIL(((SYSDATE-tpr_fecha_inicio)*24)/tpr_intervalo_horas),tpr_sis_cod,tpr_tar_cod
			  FROM D7_TAREAS_PROGRAMADAS
			  WHERE NVL(tpr_tareas_generadas,0)<CEIL(((SYSDATE-tpr_fecha_inicio)*24)/tpr_intervalo_horas)
			  AND SYSDATE > tpr_fecha_inicio AND SYSDATE < tpr_fecha_fin
			  AND ((tpr_findesemana='N' AND TO_CHAR(SYSDATE,'D') NOT IN (6,7)) OR tpr_findesemana='S')
			  AND activaTarea(tpr_tar_cod)='S'
			  FOR UPDATE;

	   BEGIN
	   
	   		OPEN tareas;
			FETCH tareas INTO ultima,sist,cod;
	   		WHILE tareas%FOUND LOOP
			  -- Busco la tarea origen si no est ANULADA !!  
			  SELECT TAR_USU_COD,TAR_INF_COD,TAR_APL_COD,TAR_ASUNTO,TAR_DESCRIP,TAR_UBICACION,
			  		 TAR_EMAIL_COPIA,TAR_URGENCIA,TAR_FECMAX_RESOL 
					 INTO uscod,infcod,aplcod,asunto,descr,ubica,copia,urg,fecmax
			  FROM D7_TAREAS
			  WHERE tar_sis_cod = sist AND tar_cod = cod AND tar_estado!='N';
			  -- Actualizo las tareas generadas 
		      UPDATE D7_TAREAS_PROGRAMADAS SET tpr_tareas_generadas = ultima WHERE CURRENT OF tareas;
			  -- Creo la Subtarea 
			  tarea := Pkd7_Tareas.alta_tarea(sist,'P',uscod,infcod,aplcod,asunto,descr,ubica,copia,urg,fecmax,cod);
			 -- Continuo 
			 FETCH tareas INTO ultima,sist,cod;
			END LOOP;
			CLOSE tareas;
	   		COMMIT;
	   END;
	   
	   FUNCTION activaTarea(cod IN NUMBER) RETURN VARCHAR2 IS
	   			ret VARCHAR2(1);
	   BEGIN
			SELECT 'S' INTO ret
			FROM D7_TAREAS_PROGRAMADAS,D7_TAREAS
			WHERE tpr_tar_cod=cod AND tar_cod=cod
			AND tpr_sis_cod=tar_sis_cod
			AND SYSDATE > tpr_fecha_inicio 
			AND SYSDATE < tpr_fecha_fin
			AND tar_estado!='N';
			RETURN ret;
	   EXCEPTION WHEN NO_DATA_FOUND THEN
	        RETURN 'N';
	   END;


	   PROCEDURE informe_usuarios IS
	   
	     sistema VARCHAR2(3);
		 usuario VARCHAR2(200);
	   
	   	 tablaPendiente VARCHAR2(32000):='<table border="1" cellpadding="2" cellspacing="0" width="550"><tr><td width="50"><b>Cdigo</b></td><td width="350"><b>Descripcin</b></td><td width="50"><b>Informtico</b></td><td width="50"><b>Fecha</b></td></tr>#FILA-PENDIENTE#</table>';
	   	 tablaEspera VARCHAR2(32000):='<table border="1" cellpadding="2" cellspacing="0" width="550"><tr><td width="50"><b>Cdigo</b></td><td width="350"><b>Descripcin</b></td><td width="50"><b>Informtico</b></td><td width="50"><b>Fecha</b></td></tr>#FILA-ESPERA#</table>';
		 tablaPlanificada VARCHAR2(32000):='<table border="1" cellpadding="2" cellspacing="0" width="600"><tr><td width="50"><b>Cdigo</b></td><td width="350"><b>Descripcin</b></td><td width="50"><b>Informtico</b></td><td width="50"><b>Fecha</b></td><td width="100"><b>Planificacin</b></td></tr>#FILA-PLANIFICADA#</table>';
		 
		 filaPendiente VARCHAR2(32000):='';
		 filaEspera VARCHAR2(32000):='';
		 filaPlanificada VARCHAR2(32000):='';
		 
		 filaPendientePlantilla VARCHAR2(2000):='<tr><td>#TAR-COD-PEND#</td><td>#TAR-DESCRIP#</td><td>#INFORMATICO#</td><td>#FECHA-PEND#</td></tr>';
		 filaEsperaPlantilla VARCHAR2(2000):='<tr><td>#TAR-COD-ESP#</td><td>#TAR-DESCRIP#</td><td>#INFORMATICO#</td><td>#FECHA-ESP#</td></tr>';
		 filaPlanificadaPlantilla VARCHAR2(2000):='<tr><td>#TAR-COD-PLAN#</td><td>#TAR-DESCRIP#</td><td>#INFORMATICO#</td><td>#FECHA-CREA#</td><td>#FECHA-PLAN#</td></tr>';
	   
	   	 plantilla VARCHAR2(32000);
	   
	     filaTarea D7_TAREAS%ROWTYPE;
	 
	 	 informatico VARCHAR2(200);
		 
	   	 n_error NUMBER;
	   	 server VARCHAR2(50);
   		 emisor VARCHAR2(11);
		 urlimg VARCHAR2(100);
		 color VARCHAR2(100);
		 icono VARCHAR2(100);
		 pie VARCHAR2(100);
		 
		 miTar D7_TAREAS.TAR_COD%TYPE;
	   
	     CURSOR usuarioInforme IS
		   SELECT DISTINCT tar_sis_cod,DECODE(tar_usu_cod,'EXTERNO',SUBSTR(tar_email_copia,0,DECODE(INSTR(tar_email_copia,','),0,LENGTH(tar_email_copia),INSTR(tar_email_copia,',')-1)),tar_usu_cod)
		   FROM D7_TAREAS
		   WHERE tar_estado IN ('P','A','X','W')
		   AND tar_apl_cod!='MIGRACION'
		   AND NOT EXISTS 
		   	   (SELECT '*' 
			    FROM D7_USUARIOS_NOTIFICACIONES
				WHERE uno_user = DECODE(tar_usu_cod,'EXTERNO',SUBSTR(tar_email_copia,0,DECODE(INSTR(tar_email_copia,','),0,LENGTH(tar_email_copia),INSTR(tar_email_copia,',')-1)),tar_usu_cod));
	   
	   	 CURSOR pendientes(sist IN VARCHAR2,usu IN VARCHAR2) IS
		   SELECT *
		   FROM D7_TAREAS
		   WHERE tar_sis_cod=sist AND tar_estado IN ('P','A','X')
		   AND tar_apl_cod!='MIGRACION'
		   AND (tar_usu_cod=usu OR SUBSTR(tar_email_copia,0,DECODE(INSTR(tar_email_copia,','),0,LENGTH(tar_email_copia),INSTR(tar_email_copia,',')-1))=usu)
		   AND NVL(tar_pri_cod,'X')!='P';
		   
	   	 CURSOR espera(sist IN VARCHAR2,usu IN VARCHAR2) IS
		   SELECT *
		   FROM D7_TAREAS
		   WHERE tar_sis_cod=sist AND tar_estado IN ('W')
		   AND tar_apl_cod!='MIGRACION'
		   AND (tar_usu_cod=usu OR SUBSTR(tar_email_copia,0,DECODE(INSTR(tar_email_copia,','),0,LENGTH(tar_email_copia),INSTR(tar_email_copia,',')-1))=usu)
		   AND NVL(tar_pri_cod,'X')!='P';
		   
	   	 CURSOR planificadas(sist IN VARCHAR2,usu IN VARCHAR2) IS
		   SELECT *
		   FROM D7_TAREAS
		   WHERE tar_sis_cod=sist AND tar_estado IN ('P','A','X','W')
		   AND tar_apl_cod!='MIGRACION'
		   AND (tar_usu_cod=usu OR SUBSTR(tar_email_copia,0,DECODE(INSTR(tar_email_copia,','),0,LENGTH(tar_email_copia),INSTR(tar_email_copia,',')-1))=usu)
		   AND NVL(tar_pri_cod,'X')='P';
	   
	   BEGIN
	   		--dbms_output.put_line('INICIO INFORME DE USUARIOS...');
	   		OPEN usuarioInforme;
			FETCH usuarioInforme INTO sistema,usuario;
			WHILE usuarioInforme%FOUND LOOP
				  -- TAREAS PENDIENTES 
				  --dbms_output.put_line('INFORME DE USUARIO: '||usuario);
				  --dbms_output.put_line('Tareas pendientes...');
				  miTar := '';
				  OPEN pendientes(sistema,usuario);
				  FETCH pendientes INTO filaTarea;
				  WHILE pendientes%FOUND LOOP
				  		filaPendiente := filaPendiente||filaPendientePlantilla;
						filaPendiente := REPLACE(filaPendiente,'#FECHA-PEND#',TO_CHAR(filaTarea.tar_feccrea,'dd/mm/yyyy'));
						filaPendiente := REPLACE(filaPendiente,'#TAR-COD-PEND#',filaTarea.tar_cod);
				  		filaPendiente := REPLACE(filaPendiente,'#TAR-DESCRIP#',filaTarea.tar_descrip);
						IF filaTarea.tar_inf_cod IS NOT NULL THEN
						   informatico := Pkd7_Mail.mail_from_identificador(filaTarea.tar_inf_cod);
						ELSE informatico := 'Pendiente de Asignar';
						END IF;
				  		filaPendiente := REPLACE(filaPendiente,'#INFORMATICO#',informatico);
						IF miTar IS NULL THEN miTar := filaTarea.tar_cod; END IF;
				  		FETCH pendientes INTO filaTarea;
				  END LOOP;
				  CLOSE pendientes;
			
				  IF LENGTH(filaPendiente)=0 THEN
				  	 filaPendiente := '<tr><td colspan=\"4\"><CENTER>Sin resultados</CENTER></td><tr>';
				  END IF;

				  -- TAREAS EN ESPERA  
				  --dbms_output.put_line('Tareas en espera...');
				  OPEN espera(sistema,usuario);
				  FETCH espera INTO filaTarea;
				  WHILE espera%FOUND LOOP
				  		filaEspera := filaEspera||filaEsperaPlantilla;
						filaEspera := REPLACE(filaEspera,'#FECHA-ESP#',TO_CHAR(filaTarea.tar_feccrea,'dd/mm/yyyy'));
						filaEspera := REPLACE(filaEspera,'#TAR-COD-ESP#',filaTarea.tar_cod);
				  		filaEspera := REPLACE(filaEspera,'#TAR-DESCRIP#',filaTarea.tar_descrip);
						SELECT dat_email INTO informatico FROM d7_datos_personales WHERE dat_identificador = filaTarea.tar_inf_cod;
				  		filaEspera := REPLACE(filaEspera,'#INFORMATICO#',informatico);
						IF miTar IS NULL THEN miTar := filaTarea.tar_cod; END IF;
				  		FETCH espera INTO filaTarea;
				  END LOOP;
				  CLOSE espera;
			
				  IF LENGTH(filaEspera)=0 THEN
				  	 filaEspera := '<tr><td colspan=\"4\"><CENTER>Sin resultados</CENTER></td><tr>';
				  END IF;

				  -- TAREAS PLANIFICADAS  
				  --dbms_output.put_line('Tareas planificadas...');
				  OPEN planificadas(sistema,usuario);
				  FETCH planificadas INTO filaTarea;
				  WHILE planificadas%FOUND LOOP
				  		filaPlanificada := filaPlanificada||filaPlanificadaPlantilla;
						filaPlanificada := REPLACE(filaPlanificada,'#FECHA-CREA#',TO_CHAR(filaTarea.tar_feccrea,'dd/mm/yyyy'));
						filaPlanificada := REPLACE(filaPlanificada,'#FECHA-PLAN#',TO_CHAR(filaTarea.tar_planif,'dd/mm/yyyy'));
						filaPlanificada := REPLACE(filaPlanificada,'#TAR-COD-PLAN#',filaTarea.tar_cod);
				  		filaPlanificada := REPLACE(filaPlanificada,'#TAR-DESCRIP#',filaTarea.tar_descrip);
						IF filaTarea.tar_inf_cod IS NOT NULL THEN
						   informatico := Pkd7_Mail.mail_from_identificador(filaTarea.tar_inf_cod);
						ELSE informatico := 'Pendiente de Asignar';
						END IF;
				  		filaPlanificada := REPLACE(filaPlanificada,'#INFORMATICO#',informatico);
						IF miTar IS NULL THEN miTar := filaTarea.tar_cod; END IF;
				  		FETCH planificadas INTO filaTarea;
				  END LOOP;
				  CLOSE planificadas;
			
				  IF LENGTH(filaPlanificada)=0 THEN
				  	 filaPlanificada := '<tr><td colspan=\"4\"><CENTER>Sin resultados</CENTER></td><tr>';
				  END IF;

				  --dbms_output.put_line('Construyendo plantilla...');
				  
		    	  SELECT pln_texto INTO plantilla
				  FROM D7_PLANTILLAS_NOTIFICACIONES
				  WHERE pln_sis_cod = sistema
				  AND pln_nombre = 'NotUsuInfor.html'; 

				  plantilla := REPLACE(plantilla,'#SISTEMA#','DUMBO');
    			  plantilla := REPLACE(plantilla,'#TABLA-PENDIENTES#',REPLACE(tablaPendiente,'#FILA-PENDIENTE#',filaPendiente));
    			  plantilla := REPLACE(plantilla,'#TABLA-ESPERA#',REPLACE(tablaEspera,'#FILA-ESPERA#',filaEspera));
    			  plantilla := REPLACE(plantilla,'#TABLA-PLANIFICADA#',REPLACE(tablaPlanificada,'#FILA-PLANIFICADA#',filaPlanificada));

	   			  SELECT PAR_VALOR INTO server FROM D7_PARAMETROS WHERE PAR_SIS_COD = sistema AND PAR_PARAMETRO='PAR_HOST_MAIL';
	   			  SELECT PAR_VALOR INTO emisor FROM D7_PARAMETROS WHERE PAR_SIS_COD = sistema AND PAR_PARAMETRO='PAR_CORREO_DUMBO';
	   			  SELECT PAR_VALOR INTO color FROM D7_PARAMETROS WHERE PAR_SIS_COD = sistema AND PAR_PARAMETRO='PAR_IND_COLOR';
	   			  SELECT PAR_VALOR INTO icono FROM D7_PARAMETROS WHERE PAR_SIS_COD = sistema AND PAR_PARAMETRO='PAR_IND_ICONO';
	   			  SELECT PAR_VALOR INTO urlimg FROM D7_PARAMETROS WHERE PAR_SIS_COD = sistema AND PAR_PARAMETRO='PAR_URL_IMG_NOTIF';
	   			  SELECT PAR_VALOR INTO pie FROM D7_PARAMETROS WHERE PAR_SIS_COD = sistema AND PAR_PARAMETRO='PAR_PIE_NOTIF';
				  
				  plantilla := REPLACE(plantilla,'#IMAGEN#',urlimg||'NotInfAsig.gif');
				  plantilla := REPLACE(plantilla,'#PIE#',pie);
				  plantilla := REPLACE(plantilla,'#PINCHE#',Pkd7_Mail.createUrlPinche(sistema,miTar,'dumbo7/inicio.rechazarInformeTarea'));
			
	        	  IF icono = 'N' THEN plantilla := REPLACE(plantilla,'visibility: visible','visibility: hidden'); END IF;
	        	  IF color = 'N' THEN plantilla := REPLACE(plantilla,'background-color: #FFFF00','background-color: #FFFFFF'); END IF;

				  IF INSTR(usuario,'@')=0 THEN
				  	 usuario := Pkd7_Mail.mail_from_identificador(usuario);
				  END IF;
				  
				  --dbms_output.put_line('Envio Informe: '||usuario);
				  n_error := Pkd7_Sendmail.send(server,emisor,usuario,NULL,NULL,'DUMBO7: Seccin de Atencin a USUARIOS',plantilla,NULL,NULL);
				  
				  COMMIT;
				  
				  FETCH usuarioInforme INTO sistema,usuario;
				  
			END LOOP; 
	   		CLOSE usuarioInforme;
	   		
	   END;
	   
END;
/

