PROMPT -- CREANDO PAQUETE PKD7_MAIL --;
set define off;
CREATE OR REPLACE PACKAGE Pkd7_Mail IS
   -- Tipo Asig para Asignacin y Tipo Reso Para Resolucin.
   FUNCTION mail_from_identificador(iden IN VARCHAR2) RETURN VARCHAR2;
   FUNCTION identificador_from_mail(mail IN VARCHAR2) RETURN VARCHAR2;
   FUNCTION createUrlPinche(sist IN VARCHAR2,cod IN VARCHAR2,ope IN VARCHAR2) RETURN VARCHAR2;
   PROCEDURE enviarMail(sistema IN VARCHAR2,cod IN VARCHAR2,tipo IN VARCHAR2);
   PROCEDURE enviarmail_alerta(sistema IN VARCHAR2, nivel IN VARCHAR2);
   PROCEDURE Notificar_Alertas(sistema IN VARCHAR2);
END;
/

CREATE OR REPLACE PACKAGE BODY Pkd7_Mail AS

   FUNCTION mail_from_identificador(iden IN VARCHAR2) RETURN VARCHAR2 IS
	mail VARCHAR2(100) := '';
	BEGIN
	 select afi_email into mail
	 from afiliaciones_dumbo
	 where afi_identificador = iden;
	 RETURN mail;
	exception when no_data_found then
		return mail;
	END;
   
   FUNCTION identificador_from_mail(mail IN VARCHAR2) RETURN VARCHAR2 IS
	dni VARCHAR2(10);
	usermail VARCHAR2(200);
	BEGIN
		IF INSTR(mail,'@')=0 THEN usermail := mail;
		ELSE usermail := SUBSTR(mail,0,INSTR(mail,'@')-1);
		END IF;
		BEGIN
			 SELECT alias_dni INTO dni
			 FROM D7_ALIAS_CORREO
			 WHERE alias_correo = LOWER(usermail);
		EXCEPTION WHEN NO_DATA_FOUND THEN
			begin
			 	select afi_identificador into dni
			 	from afiliaciones_dumbo
			 	where afi_email = mail;
			exception when no_data_found then
				return dni;
			end;
		END;
	 	RETURN dni;
	END;

	--Procedimiento que notifica las alertas de nivel 1,2 y 3
	PROCEDURE Notificar_Alertas(sistema IN VARCHAR2) IS
	BEGIN
		 enviarmail_alerta(sistema,'1');
		 enviarmail_alerta(sistema,'2');
		 enviarmail_alerta(sistema,'3');
	END;

	
	FUNCTION createUrlPinche(sist IN VARCHAR2,cod IN VARCHAR2,ope IN VARCHAR2) RETURN VARCHAR2 IS
	url VARCHAR2(1000);
	cadena VARCHAR2(30):='X';
	BEGIN
		 SELECT PAR_VALOR INTO url
		 FROM D7_PARAMETROS
		 WHERE PAR_SIS_COD=sist AND PAR_PARAMETRO='PAR_URL_IMG_NOTIF';
		 url := REPLACE(url,'plantillas/imagenes/','servlet/dumbo7.Dumbo7');
		 
 		 WHILE LENGTH(cadena)=1 LOOP
	 	 BEGIN
		 
		 	 cadena := Pkd7_Random.rndstring(25);

			 BEGIN
			 	SELECT 'X' INTO cadena
				FROM D7_CLAVES_NOTIFICACIONES
				WHERE cln_cadena = cadena;
			 EXCEPTION WHEN NO_DATA_FOUND THEN
			 	INSERT INTO D7_CLAVES_NOTIFICACIONES (CLN_CADENA,CLN_SIS_COD,CLN_TAR_COD,CLN_FECHA,CLN_OPERACION)
			 	VALUES (cadena,sist,cod,SYSDATE,ope);
			 END;
			 
		 END;
		 END LOOP;

		 RETURN url||'?module=dumbo7/inicio.doit&code='||cadena;
	
	END;
	
	
    PROCEDURE enviarMail(sistema IN VARCHAR2,cod IN VARCHAR2,tipo IN VARCHAR2) IS
	   		n_error NUMBER;
	   		server VARCHAR2(250);
	   		emisor VARCHAR2(250);
	   		receptorInfo VARCHAR2(2000);
	   		receptorUser VARCHAR2(2000);
	   		asunto VARCHAR2(2000);
	   		asuntoT VARCHAR2(2000);
	   		texto VARCHAR2(4000);
	   		copia VARCHAR2(2000):=NULL;
			urlimg VARCHAR2(250);
			color VARCHAR2(250);
			icono VARCHAR2(250);
			tareas VARCHAR2(250);
			pie VARCHAR2(250);
			pie1 VARCHAR2(250);
			coste VARCHAR2(250);
			mtexto VARCHAR2(200) := 'En este momento, este t&eacute;cnico tiene previamente pendientes de atender #NUM-INC# incidencia/s y #NUM-PET# petici&oacute;n/es.';
			MsjRecordatorio VARCHAR2(500) := 'Le recordamos que en cualquier momento puede visualizar el n&uacute;mero de sus tareas pendientes, as&iacute; como modificarlas y dar otras nuevas de alta desde la direcci&oacute;n ';
			filaTarea D7_TAREAS%ROWTYPE;
			nombreInform VARCHAR2(200);
			nombreUsuario VARCHAR2(200);
			numPeticiones NUMBER;
			numIncidencias NUMBER;
			tipTarea VARCHAR2(100);
			CURSOR plantillas(sist IN VARCHAR2,tip IN VARCHAR2) IS
				   SELECT pln_nombre,pln_texto
				   FROM D7_PLANTILLAS_NOTIFICACIONES
				   WHERE pln_sis_cod = sist
				   AND UPPER(pln_nombre) LIKE '%'||UPPER(tip)||'.HTML';


	   BEGIN

  	      -- Obtengo datos del servidor y emisor de correo , etc...!!
           BEGIN
			 SELECT PAR_VALOR INTO color FROM D7_PARAMETROS WHERE PAR_SIS_COD = sistema AND PAR_PARAMETRO='PAR_IND_COLOR';
		     EXCEPTION WHEN NO_DATA_FOUND THEN INSERT INTO D7_ERRORES_ALERTAS VALUES (sistema, 0, 0, 'No existe el parametro PAR_IND_COLOR para el sistema',SYSDATE);
		   END;
           BEGIN
		     SELECT PAR_VALOR INTO icono FROM D7_PARAMETROS WHERE PAR_SIS_COD = sistema AND PAR_PARAMETRO='PAR_IND_ICONO';
		     EXCEPTION WHEN NO_DATA_FOUND THEN INSERT INTO D7_ERRORES_ALERTAS VALUES (sistema, 0, 0, 'No existe el parametro PAR_IND_ICONO para el sistema',SYSDATE);
		   END;
           BEGIN
	         SELECT PAR_VALOR INTO urlimg FROM D7_PARAMETROS WHERE PAR_SIS_COD = sistema AND PAR_PARAMETRO='PAR_URL_IMG_NOTIF';
		     EXCEPTION WHEN NO_DATA_FOUND THEN INSERT INTO D7_ERRORES_ALERTAS VALUES (sistema, 0, 0, 'No existe el parametro PAR_URL_IMG_NOTIF para el sistema',SYSDATE);
		   END;
		   BEGIN
	   		  SELECT PAR_VALOR INTO coste FROM D7_PARAMETROS WHERE PAR_SIS_COD = sistema AND PAR_PARAMETRO='PAR_IND_COSTE';
		      EXCEPTION WHEN NO_DATA_FOUND THEN INSERT INTO D7_ERRORES_ALERTAS VALUES (sistema, 0, 0, 'No existe el parametro PAR_IND_COSTE para el sistema',SYSDATE);
		   END;
 	 	   BEGIN
		     SELECT PAR_VALOR INTO server FROM DUMBO.D7_PARAMETROS WHERE PAR_SIS_COD = sistema AND PAR_PARAMETRO='PAR_HOST_MAIL';
		     EXCEPTION WHEN NO_DATA_FOUND THEN INSERT INTO D7_ERRORES_ALERTAS VALUES (sistema, 0, 0, 'No existe el parametro PAR_HOST_MAIL para el sistema',SYSDATE);
		   END;
   	       BEGIN
		     SELECT PAR_VALOR INTO emisor FROM DUMBO.D7_PARAMETROS WHERE PAR_SIS_COD = sistema AND PAR_PARAMETRO='PAR_CORREO_DUMBO';
		     EXCEPTION WHEN NO_DATA_FOUND THEN INSERT INTO D7_ERRORES_ALERTAS VALUES (sistema, 0, 0, 'No existe el parametro PAR_CORREO_DUMBO para el sistema ',SYSDATE );
		   END;
		   BEGIN
		     SELECT PAR_VALOR INTO pie FROM DUMBO.D7_PARAMETROS WHERE PAR_SIS_COD = sistema AND PAR_PARAMETRO='PAR_PIE_NOTIF';
	         EXCEPTION WHEN NO_DATA_FOUND THEN INSERT INTO D7_ERRORES_ALERTAS VALUES (sistema, 0, 0, 'No existe el parametro PAR_PIE_NOTIF para el sistema ',SYSDATE);
		   END;
		   BEGIN
		     SELECT PAR_VALOR INTO pie1 FROM DUMBO.D7_PARAMETROS WHERE PAR_SIS_COD = sistema AND PAR_PARAMETRO='PAR_DIR_DUMBO';
	         EXCEPTION WHEN NO_DATA_FOUND THEN INSERT INTO D7_ERRORES_ALERTAS VALUES (sistema, 0, 0, 'No existe el parametro PAR_DIR_DUMBO para el sistema ',SYSDATE);
		   END;
		   BEGIN
		     SELECT PAR_VALOR INTO tareas FROM DUMBO.D7_PARAMETROS WHERE PAR_SIS_COD = sistema AND PAR_PARAMETRO='PAR_IND_TAREAS';
		     EXCEPTION WHEN NO_DATA_FOUND THEN INSERT INTO D7_ERRORES_ALERTAS VALUES (sistema, 0, 0, 'No existe el parametro PAR_IND_TAREAS para el sistema ',SYSDATE);
		   END;

	   	-- Obtengo receptores a raz del cdigo de tarea !!
		SELECT * INTO filaTarea
		FROM D7_TAREAS
		WHERE tar_sis_cod=sistema AND tar_cod=cod;

		SELECT tip_descrip INTO tipTarea
		FROM D7_TIPOS_TAREAS
		WHERE tip_sis_cod = sistema AND tip_cod=filaTarea.tar_tip_cod;

		SELECT Pkd7_Mail.mail_from_identificador(dat_identificador) AS dat_email,dat_nombre||' '||dat_apellidos INTO receptorInfo,nombreInform
		FROM D7_DATOS_PERSONALES
		WHERE dat_identificador = filaTarea.tar_inf_cod;

		BEGIN
			SELECT Pkd7_Mail.mail_from_identificador(dat_identificador) AS dat_email,dat_nombre||' '||dat_apellidos INTO receptorUser,nombreUsuario
			FROM D7_DATOS_PERSONALES
			WHERE dat_identificador = filaTarea.tar_usu_cod;
		EXCEPTION WHEN NO_DATA_FOUND THEN
		  -- Se trara de un Usuario EXTERNO !!!
		    copia := filaTarea.tar_email_copia;
		    n_error := INSTR(copia,',');
			IF n_error = 0 THEN n_error := LENGTH(copia); END IF;
			receptorUser := SUBSTR(copia,0,n_error);
			copia := SUBSTR(copia,INSTR(copia,',')+1);
			nombreUsuario := receptorUser;
		END;

		-- Obtengo la plantilla a partir del tipo de Correo !!
		OPEN plantillas(sistema,tipo);
		FETCH plantillas INTO asunto,texto;
		WHILE plantillas%FOUND LOOP
 		    asuntoT := 'Notificacion';
			-- Sustituyo los datos en la plantilla. Slo son 3 plantillas !!
			IF asunto = 'NotUsuAsig.html' THEN asuntoT := 'Notificacion de asignacion de tarea';
			ELSIF asunto = 'NotUsuReso.html' THEN asuntoT := 'Resolucion de tarea';
			ELSIF asunto = 'NotInfAsig.html' THEN asuntoT := 'Asignacion Tarea';
			ELSIF asunto = 'NotInfReas.html' THEN asuntoT := 'Reasignacion Tarea';
			ELSIF asunto = 'NotUsuReas.html' THEN asuntoT := 'Reasignacion Tarea';
			ELSIF asunto = 'NotInfAnu.html' THEN asuntoT := 'Anulacion Tarea';
			ELSIF asunto = 'NotUsuAnu.html' THEN asuntoT := 'Anulacion Tarea';
			ELSIF asunto = 'NotUsuPlanif.html' THEN asuntoT := 'Cambio Planificacion Tarea';
			ELSIF asunto = 'NotInfReac.html' THEN asuntoT := 'Reactivacion de tarea en espera';
			ELSIF asunto = 'NotUsuReac.html' THEN asuntoT := 'Reactivacion de tarea en espera';
			ELSIF asunto = 'NotUsuEsp.html' THEN asuntoT := 'Paso de tarea a espera';
			END IF;

			texto := REPLACE(texto,'#IMAGEN#',urlimg||'NotInfAsig.gif');
			texto := REPLACE(texto,'#PIE#',pie);
			texto := REPLACE(texto,'#DIR-PIE#',pie1);

	        IF icono = 'N' THEN texto := REPLACE(texto,'visibility: visible','visibility: hidden'); END IF;
	        IF color = 'N' THEN texto := REPLACE(texto,'background-color: #FFFF00','background-color: #FFFFFF'); END IF;

			IF filaTarea.tar_pri_cod='P' THEN texto := REPLACE(texto,'#TAREA#','Programada');
			ELSE texto := REPLACE(texto,'#TAREA#','Programada');
			END IF;

			texto := REPLACE(texto,'#INC-PET#',tipTarea);
			IF filaTarea.tar_padre_tar_cod is null then
	    	   texto := REPLACE(texto,'#NUM#',cod);
			ELSE texto := REPLACE(texto,'#NUM#',cod||' ('||filaTarea.tar_padre_tar_cod||')');
			END IF;
			
			IF asunto LIKE '%Esp%' THEN
         	   texto := REPLACE(texto,'#FECHA-ESP#',TO_CHAR(SYSDATE,'dd/mm/yyyy hh24:mi:ss'));
         	   texto := REPLACE(texto,'#TEX-ESP#',filaTarea.tar_descrip_segui);
			   texto := REPLACE(texto,'#PINCHE#',createUrlPinche(sistema,cod,'dumbo7/inicio.rechazarEsperaTarea'));
			   texto := REPLACE(texto,'#INFORMATICO#',nombreInform);
			END IF;
			
		  	IF asunto LIKE '%Planif%' then
			   texto := REPLACE(texto,'#FECHA-PLANIF#',to_char(filaTarea.tar_planif,'dd/mm/yyyy'));
			   texto := REPLACE(texto,'#PINCHE#',createUrlPinche(sistema,cod,'dumbo7/inicio.rechazarPlanificacionTarea'));
			   texto := REPLACE(texto,'#INFORMATICO#',nombreInform);
		  	END IF;
			
			IF asunto LIKE '%Anu%' THEN
         	   texto := REPLACE(texto,'#TEX-ANU#',filaTarea.tar_descrip_segui);
			   texto := REPLACE(texto,'#PINCHE#',createUrlPinche(sistema,cod,'dumbo7/inicio.rechazarAnulacionTarea'));
			   texto := REPLACE(texto,'#INFORMATICO#',nombreInform);
			END IF;

		 	IF asunto LIKE '%Reac%' THEN
	       	   texto := REPLACE(texto,'#TEX-REAC#',filaTarea.tar_descrip_segui);
			END IF;

		  	IF asunto LIKE '%Reas%' THEN
	       	   texto := REPLACE(texto,'#TEX-REAS#',filaTarea.tar_descrip_segui);
			END IF;

			IF asunto LIKE '%Asig%' OR  asunto LIKE '%Reac%' OR asunto LIKE '%Reas%' OR asunto LIKE '%Planif%' THEN
	       	   texto := REPLACE(texto,'#USUARIO#',nombreUsuario);
	       	   IF asunto LIKE '%Usu%' OR  asunto LIKE '%Reac%' OR asunto LIKE '%Reas%'  THEN
			   	  texto := REPLACE(texto,'#INFORMATICO#',nombreInform);
			   END IF;
			END IF;

			texto := REPLACE(texto,'#EXT#',filaTarea.tar_telefono);
			texto := REPLACE(texto,'#UBICACION#',filaTarea.tar_ubicacion);
	    	texto := REPLACE(texto,'#APLICACION#',filaTarea.tar_apl_cod);
	    	texto := REPLACE(texto,'#ASUNTO#',filaTarea.tar_asunto);
	    	texto := REPLACE(texto,'#TEXTO#',filaTarea.tar_descrip);
			texto := REPLACE(texto,'#REC#',MsjRecordatorio);

	    	IF asunto LIKE '%Reso%' THEN
			   texto := REPLACE(texto,'#CATEGORIA#',filaTarea.tar_cat_cod);
			   texto := REPLACE(texto,'#TEX-RESOL#',filaTarea.tar_descrip_segui);
			   texto := REPLACE(texto,'#PINCHE#',createUrlPinche(sistema,cod,'dumbo7/inicio.rechazarResolucionTarea'));
			   texto := REPLACE(texto,'#INFORMATICO#',nombreInform);
			   IF coste = 'N' THEN
	           	  texto := REPLACE(texto,'#HORAS#','');
	          	  texto := REPLACE(texto,'#COSTE#','');
			   ELSE
	           	   texto := REPLACE(texto,'#HORAS#',filaTarea.tar_horas_res);
	          	   texto := REPLACE(texto,'#COSTE#',filaTarea.tar_coste_eco||' '||filaTarea.tar_coste_mat);
			   END IF;

			END IF;

			IF asunto LIKE '%UsuAsig%' OR asunto LIKE '%Reac%' OR asunto like '%Reas%' THEN
        	   IF NVL(tareas,'S') = 'N' THEN 
			   	  texto := REPLACE(texto,'#TAR-PEN#',' ');
        	   ELSE
					SELECT COUNT(*) INTO numPeticiones
					FROM D7_TAREAS
					WHERE tar_estado IN ('A','W','X')
					AND tar_tip_cod = 'P'
					AND tar_sis_cod=sistema
					AND tar_inf_cod = filaTarea.tar_inf_cod;
	
					SELECT COUNT(*) INTO numIncidencias
					FROM D7_TAREAS
					WHERE tar_estado IN ('A','W','X')
					AND tar_tip_cod = 'I'
					AND tar_sis_cod=sistema
					AND tar_inf_cod = filaTarea.tar_inf_cod;
	
					mtexto := REPLACE(mtexto,'#NUM-PET#',numPeticiones);
		      		mtexto := REPLACE(mtexto,'#NUM-INC#',numIncidencias);
		      		mtexto := REPLACE(mtexto,'#INFORMATICO#',nombreInform);
	
					texto := REPLACE(texto,'#USUARIO#',nombreUsuario);
			    	texto := REPLACE(texto,'#INFORMATICO#',nombreInform);
		      		texto := REPLACE(texto,'#TAR-PEN#',mtexto);
	    	   END IF;
			END IF;

		 	IF asunto LIKE '%Usu%' THEN
	           n_error := Pkd7_Sendmail.send(server,emisor,receptorUser,copia,NULL,asuntoT,texto,NULL,NULL);
		 	ELSE
		       n_error := Pkd7_Sendmail.send(server,emisor,receptorInfo,NULL,NULL,asuntoT,texto,NULL,NULL);
			END IF;

			FETCH plantillas INTO asunto,texto;

		END LOOP;
		
		--COMMIT;

	   EXCEPTION WHEN OTHERS THEN
	     n_error := 1;

	   END;
-------------------------------------------------------------
	   --Procedimiento para el envo de alertas por correo agrupando.
	   --Obtiene la plantilla de base de datos, sustituye los valores dinmicos por los
	   --correctos y obtiene una lista de receptores de correo a partir del nivel de la
	   --alerta, la tarea y el sistema.

	   PROCEDURE enviarmail_alerta(sistema IN VARCHAR2,nivel in varchar2) IS
	   	server VARCHAR2(250);
	   	emisor VARCHAR2(250);
	   	texto VARCHAR2(32700);
			textopla VARCHAR2(32700);
      textopen VARCHAR2(32700);
			cuerpopla VARCHAR2(32700);
			cuerpopen VARCHAR2(32700);
			cabeza varchar2(32700);
			fin varchar2(32700);
			listatareas varchar2(32700);
			listasuper varchar2(32700);
			tareas VARCHAR2(250);
			pie VARCHAR2(250);
			pie1 VARCHAR2(250);
			informatico varchar2(10) := 'X';
			receptores varchar2(500);
			misreceptores varchar2(500);
			recp varchar2(150);
			fechaMovimiento DATE;
			dias NUMBER(4,1);
			n_error NUMBER;
			aplicacion varchar2(10) := 'X';
			seccion varchar2(10) := 'X';
			numcorreos number(6) := 0;
			
			--Para nivel 1,2,3. Obtiene el mail del informatico que tiene asignada la tarea
			CURSOR C_DATOS_INF IS 
				SELECT tal_cod,di.dat_nombre||' '||di.dat_apellidos as infnom,
					   trim(nvl(du.dat_nombre,decode(instr(tar_email_copia,','),0,tar_email_copia,substr(tar_email_copia,0,instr(tar_email_copia,',')-1)))||' '||du.dat_apellidos) as usunom,
					   t.*,apl_sec_cod,nvl(tip_descrip,'SIN TIPO') as tip,nvl(pri_descrip,'SIN PRIORIDAD') as pri
				FROM DUMBO.D7_TAREAS_ALERTAS,DUMBO.D7_TAREAS t,DUMBO.D7_APLICACIONES,D7_DATOS_PERSONALES du,D7_DATOS_PERSONALES di,D7_Tipos_tareas,d7_prioridades
				WHERE tal_sis_cod=sistema
				AND tal_notif='N'
				AND tal_nivel=nivel
				AND tar_sis_cod=sistema
				AND tal_tar_cod=tar_cod
				AND tar_apl_cod=apl_cod
				and apl_sis_cod=sistema
				AND di.dat_identificador=tar_inf_cod
				AND du.dat_identificador(+)=tar_usu_cod
				and tip_sis_cod(+)=sistema
				and tip_cod(+)=tar_tip_cod
				and pri_sis_cod(+)=sistema
				and pri_cod(+)=tar_pri_cod
				order by tar_inf_cod;

			-- Para nivel 1,2 y 3 tb. se envan alertas a los responsables de aplicacion. 
			CURSOR C_DATOS_APL IS 
				SELECT tal_cod,di.dat_nombre||' '||di.dat_apellidos as infnom,
					   trim(nvl(du.dat_nombre,decode(instr(tar_email_copia,','),0,tar_email_copia,substr(tar_email_copia,0,instr(tar_email_copia,',')-1)))||' '||du.dat_apellidos) as usunom,
						 nvl(decode(tar_usu_cod,'EXTERNO','',pkd7_mail.mail_from_identificador(tar_usu_cod)),substr(tar_email_copia||',',1,instr(tar_email_copia||',',',')-1)) as emailusu,
					   t.*,apl_sec_cod,nvl(tip_descrip,'SIN TIPO') as tip,nvl(pri_descrip,'SIN PRIORIDAD') as pri
				FROM DUMBO.D7_TAREAS_ALERTAS,DUMBO.D7_TAREAS t,DUMBO.D7_APLICACIONES,D7_DATOS_PERSONALES du,D7_DATOS_PERSONALES di,D7_Tipos_tareas,d7_prioridades
				WHERE tal_sis_cod=sistema
				AND tal_notif='N'
				AND tal_nivel=nivel
				AND tar_sis_cod=sistema
				AND tal_tar_cod=tar_cod
				AND tar_apl_cod=apl_cod
				and apl_sis_cod=sistema
				AND di.dat_identificador=tar_inf_cod
				AND du.dat_identificador(+)=tar_usu_cod
				and tip_sis_cod(+)=sistema
				and tip_cod(+)=tar_tip_cod
				and pri_sis_cod(+)=sistema
				and pri_cod(+)=tar_pri_cod
				order by tar_apl_cod;

			-- Para nivel 2 y 3 tb. se envan alertas a los responsables de seccion. 
			CURSOR C_DATOS_SEC IS 
				SELECT tal_cod,di.dat_nombre||' '||di.dat_apellidos as infnom,
					   trim(nvl(du.dat_nombre,decode(instr(tar_email_copia,','),0,tar_email_copia,substr(tar_email_copia,0,instr(tar_email_copia,',')-1)))||' '||du.dat_apellidos) as usunom,
						 nvl(decode(tar_usu_cod,'EXTERNO','',pkd7_mail.mail_from_identificador(tar_usu_cod)),substr(tar_email_copia||',',1,instr(tar_email_copia||',',',')-1)) as emailusu,
					   t.*,apl_sec_cod,nvl(tip_descrip,'SIN TIPO') as tip,nvl(pri_descrip,'SIN PRIORIDAD') as pri
				FROM DUMBO.D7_TAREAS_ALERTAS,DUMBO.D7_TAREAS t,DUMBO.D7_APLICACIONES,D7_DATOS_PERSONALES du,D7_DATOS_PERSONALES di,D7_Tipos_tareas,d7_prioridades
				WHERE tal_sis_cod=sistema
				AND tal_notif='N'
				AND tal_nivel=nivel
				AND tar_sis_cod=sistema
				AND tal_tar_cod=tar_cod
				AND tar_apl_cod=apl_cod
				and apl_sis_cod=sistema
				AND di.dat_identificador=tar_inf_cod
				AND du.dat_identificador(+)=tar_usu_cod
				and tip_sis_cod(+)=sistema
				and tip_cod(+)=tar_tip_cod
				and pri_sis_cod(+)=sistema
				and pri_cod(+)=tar_pri_cod
				order by apl_sec_cod;
				
			CURSOR RESP_APL(sist in varchar2,aplcod in varchar2,aplseccod in varchar2) is
				   select pkd7_mail.mail_from_identificador(ain_inf_cod)
				   from d7_aplicaciones_informaticos
				   where ain_apl_cod=aplcod
				   and ain_sis_cod=sist
				   and ain_responsable='Y'
				   MINUS
				   (SELECT (select pkd7_mail.mail_from_identificador(sec_id_Respon) from d7_secciones where sec_cod=s1.sec_sec_cod AND sec_sis_cod=sist) 
				   FROM DUMBO.D7_SECCIONES s1
				   WHERE sec_sis_cod=sist
				   START WITH sec_cod=aplseccod AND sec_sis_cod=sist
				   CONNECT BY PRIOR sec_sec_cod=sec_cod
				   AND sec_cod<>sec_sec_cod
				   UNION
				   SELECT pkd7_mail.mail_from_identificador(sec_id_Respon)
				   FROM DUMBO.D7_SECCIONES
				   WHERE sec_cod=aplseccod
				   AND sec_sis_cod=sist);

			CURSOR RESP_SEC(sist in varchar2,aplseccod in varchar2) is
				   SELECT (select pkd7_mail.mail_from_identificador(sec_id_Respon) from d7_secciones where sec_cod=s1.sec_sec_cod AND sec_sis_cod=sist) 
				   FROM DUMBO.D7_SECCIONES s1
				   WHERE sec_sis_cod=sist
				   START WITH sec_cod=aplseccod AND sec_sis_cod=sist
				   CONNECT BY PRIOR sec_sec_cod=sec_cod
				   AND sec_cod<>sec_sec_cod
				   UNION
				   SELECT pkd7_mail.mail_from_identificador(sec_id_Respon)
				   FROM DUMBO.D7_SECCIONES
				   WHERE sec_cod=aplseccod
				   AND sec_sis_cod=sist;
				
			CURSOR RESP_MAESTRO(sist in varchar2) is
				   SELECT pkd7_mail.mail_from_identificador(ipe_inf_cod) 
				   FROM  D7_INFORMATICOS_PERFILES
				   WHERE ipe_sis_cod=sist
				   AND ipe_per_cod='01'
					 union
					 select 'viceconomi@um.es' from dual
					 minus 
					 select 'jholler@um.es' from dual;

				
				
	   BEGIN
		   --Inicializacion de variables
		   server:='';
		   emisor:='';
		   texto:='';

		   -- Obtengo datos del servidor y emisor de correo , etc...!!
			SELECT
			(SELECT PAR_VALOR FROM DUMBO.D7_PARAMETROS WHERE PAR_SIS_COD = sistema AND PAR_PARAMETRO='PAR_HOST_MAIL'),
			(SELECT PAR_VALOR FROM DUMBO.D7_PARAMETROS WHERE PAR_SIS_COD = sistema AND PAR_PARAMETRO='PAR_CORREO_DUMBO'),
			(SELECT PAR_VALOR FROM DUMBO.D7_PARAMETROS WHERE PAR_SIS_COD = sistema AND PAR_PARAMETRO='PAR_PIE_NOTIF'),
			(SELECT PAR_VALOR FROM DUMBO.D7_PARAMETROS WHERE PAR_SIS_COD = sistema AND PAR_PARAMETRO='PAR_DIR_DUMBO'),
			(SELECT PAR_VALOR FROM DUMBO.D7_PARAMETROS WHERE PAR_SIS_COD = sistema AND PAR_PARAMETRO='PAR_IND_TAREAS')
			into server,emisor,pie,pie1,tareas
			from dual;

			-- Obtengo las plantillas para planificada y no.
		     SELECT  pln_texto INTO textopla 
			 FROM DUMBO.D7_PLANTILLAS_NOTIFICACIONES
			 WHERE PLN_NOMBRE='AlertasPlanificadasInf.html'
			 AND pln_sis_cod=sistema;
			
			 cuerpopla := substr(textopla,instr(textopla,'<font face="Arial">'));
			 cuerpopla := substr(cuerpopla,0,instr(cuerpopla,'<p>&nbsp;</p>')-1);
			
		     SELECT  pln_texto INTO textopen 
			 FROM DUMBO.D7_PLANTILLAS_NOTIFICACIONES
			 WHERE PLN_NOMBRE='AlertasPendientesInf.html'
			 AND pln_sis_cod=sistema;

			 cuerpopen := substr(textopen,instr(textopen,'<font face="Arial">'));
			 cabeza := substr(textopen,0,instr(textopen,'<font face="Arial">')-1);
			 fin := substr(cuerpopen,instr(cuerpopen,'<p>&nbsp;</p>'));
			 cuerpopen := substr(cuerpopen,0,instr(cuerpopen,'<p>&nbsp;</p>')-1);
			 fin := REPLACE(fin,'#PIE#',pie);
			 fin := REPLACE(fin,'#DIR-PIE#',pie1);
			
		  	-- Envio para los informaticos
			FOR V_INF IN C_DATOS_INF LOOP
			    --dbms_output.put_line('Notifico tarea['||informatico||']['||length(texto)||']: '||v_inf.tar_cod);
			   -- Itero por cada una de las tareas.
			   -- Pero envo un nico correo para cada informtico.
			   IF informatico != v_inf.tar_inf_cod or length(texto)>30000 then
			   	  if informatico != 'X' then
			      	 BEGIN
					   texto := cabeza||texto||fin;
					   numcorreos := numcorreos+1; 
				  	   n_error := Pkd7_Sendmail.send(server,'Sistema dumbo <'||emisor||'>',receptores,NULL,NULL,'DUMBO7: Resumen Alertas Nivel '||nivel||'.Informtico.',texto,NULL,NULL);
	              	 EXCEPTION WHEN OTHERS THEN
		          	   n_error := 1;
		             END;
				  end if;
			   	  informatico := v_inf.tar_inf_cod;
				  receptores:= pkd7_mail.mail_from_identificador(v_inf.tar_inf_cod);
				  texto := '';
			   END IF;
			   -- Obtengo la plantilla a partir del tipo de la prioridad 
	     	   IF v_inf.tar_pri_cod='P' THEN texto := texto||'<center><hr width="70%"></center>'||cuerpopla;
			   ELSE texto := texto||'<center><hr width="70%"></center>'||cuerpopen;
			   END IF;
			   
			    texto := REPLACE(texto,'#CODIGO_TAREA#',v_inf.tar_cod);
		      	texto:=REPLACE (texto,'#FECHA_CREACION#',v_inf.tar_feccrea);
			    texto:=REPLACE (texto,'#TEXTO_TAREA#',v_inf.tar_descrip);
				texto:=REPLACE (texto,'#TAR_ASUNTO#',v_inf.tar_asunto );
	            texto:=REPLACE (texto,'#CORREO_DUMBO#',EMISOR );
				texto:=REPLACE (texto,'#NIVEL#',NIVEL);

	            IF  v_inf.tar_pri_cod= 'P' THEN
			      texto:=REPLACE (texto,'#FECHA_PLANIFICACION#',v_inf.tar_planif );
				END IF;
			   
			   
			    texto:=REPLACE (texto,'#TIPO_TAREA#',v_inf.tip);
			    texto:=REPLACE (texto,'#PRIORIDAD#',v_inf.pri);

	            BEGIN
					SELECT tmo_fecha_mov INTO fechaMovimiento
					FROM D7_TAREAS_MOVIMIENTOS
					WHERE tmo_sis_cod = v_inf.tar_sis_cod
			    	AND tmo_tar_cod = v_inf.tar_cod
					and rownum=1
 					order by tmo_fecha_mov asc;
				EXCEPTION WHEN NO_DATA_FOUND THEN 
					fechaMovimiento := v_inf.tar_feccrea;
				END;

			    texto:=REPLACE (texto,'#FECHA_MOVIMIENTO#',fechaMovimiento );
		        texto:=REPLACE (texto,'#INFORMATICO#',v_inf.infnom);
			    texto:=REPLACE (texto,' #SOLICITANTE#',v_inf.usunom);

 				-- Cogemos los dias maximos para la plantilla
	 	        IF  nivel = '1' THEN
			 	-- Cogemos los dias maximos para NIVEL 1 
				  BEGIN
				    SELECT ama_dias INTO dias 
					FROM D7_APLICACIONES_MAXIMOS
			        WHERE ama_sis_cod = v_inf.tar_sis_cod
				    AND ama_apl_cod = v_inf.tar_apl_cod
				    AND ama_tip_cod = v_inf.tar_tip_cod
				    AND ama_pri_cod = v_inf.tar_pri_cod;
				  EXCEPTION WHEN NO_DATA_FOUND THEN
			      	    SELECT MAX(AMA_DIAS) INTO DIAS 
						FROM DUMBO.D7_APLICACIONES_MAXIMOS
		  				WHERE AMA_SIS_COD=V_INF.TAR_SIS_COD
						AND AMA_TIP_COD=V_INF.TAR_TIP_COD
						AND AMA_APL_COD=V_INF.TAR_APL_COD;
	              END;
				END IF;

			 	-- Cogemos los dias maximos para NIVEL 2 
				IF nivel = '2' THEN
				  BEGIN
				    SELECT max_dias INTO dias 
					FROM D7_SECCIONES_MAXIMOS
				    WHERE max_sis_cod = v_inf.tar_sis_cod
			        AND max_tip_cod = v_inf.tar_tip_cod
				    AND max_pri_cod = v_inf.tar_pri_cod
				    AND max_sec_cod = v_inf.apl_sec_cod;
                  EXCEPTION WHEN  NO_DATA_FOUND THEN
					 	 SELECT MAX(MAX_DIAS) INTO DIAS 
						 FROM DUMBO.D7_SECCIONES_MAXIMOS
 		                 WHERE MAX_SIS_COD=V_INF.TAR_SIS_COD
		                 AND MAX_TIP_COD=V_INF.TAR_TIP_COD
		                 AND MAX_SEC_COD=V_INF.APL_SEC_COD;
	              END;
  			    END IF;

	               -- Cogemos los dias maximos para NIVEL 3 
			    IF  nivel = '3' THEN
	 	          BEGIN
				    SELECT pmx_dias INTO dias 
					FROM D7_PARAMETROS_MAXIMOS
				    WHERE pmx_sis_cod = v_inf.tar_sis_cod
				    AND pmx_tip_cod = v_inf.tar_tip_cod
				    AND pmx_pri_cod = v_inf.tar_pri_cod ;
			      EXCEPTION WHEN  NO_DATA_FOUND THEN
  			  	         SELECT MAX(PMX_DIAS) INTO DIAS 
						 FROM DUMBO.D7_PARAMETROS_MAXIMOS
		                 WHERE PMX_SIS_COD=V_inf.TAR_SIS_COD
		                 AND PMX_TIP_COD=V_inf.TAR_TIP_COD;
				  END;
			    END IF;
				texto:=REPLACE (texto,'#EXCESO_DIAS#',dias );
			   
			END LOOP; -- END LOOP V_INF 
			-- Para el ultimo 
			IF length(texto)>0 THEN
	      	BEGIN
			  texto := cabeza||texto||fin; 
			  numcorreos := numcorreos+1; 
		  	  n_error := Pkd7_Sendmail.send(server,'Sistema dumbo <'||emisor||'>',receptores,NULL,NULL,'DUMBO7: Resumen Alertas Nivel '||nivel||'.Informtico.',texto,NULL,NULL);
            EXCEPTION WHEN OTHERS THEN
          	  n_error := 1;
            END;
			END IF;
			
			
		     SELECT  pln_texto INTO textopen 
			 FROM DUMBO.D7_PLANTILLAS_NOTIFICACIONES
			 WHERE PLN_NOMBRE='AlertasPendientesRespon.html'
			 AND pln_sis_cod=sistema;
			
			 textopen := replace(textopen,'#NIVEL#',nivel);
			 textopen := replace(textopen,'#PIE#',pie);
			 textopen := REPLACE(textopen,'#DIR-PIE#',pie1);
			
		  	-- Envio para los responsables
			FOR V_APL IN C_DATOS_APL LOOP
			   -- Itero por cada una de las tareas.
			   -- Pero envo un nico correo para cada responsable de aplicacion.
			   IF aplicacion != v_apl.tar_apl_cod  or length(listatareas)>30000 then
			   	  if aplicacion != 'X' then
			      	 BEGIN
			    	 listatareas:='<table border="1" bordercolor="#C0C0C0">'||
							 '<tr>'||
							 '	<td><b>TAREA</b></td>'||
							 '	<td><b>APLICACION</b></td>'||
							 '	<td><b>TIPO</b></td>'||
							 '	<td><b>PRIORIDAD</b></td>'||
							 '  <td><b>F.SOLICITUD</b></td>'||
							 '  <td><b>F.ASIGNACIN</b></td>'||
							 '  <td><b>F.MXIMA</b></td>'||
							 '  <td><b>DAS</b></td>'||
							 '  <td><b>INFORMTICO</b></td>'||
							 '	<td><b>SOLICITANTE</b></td>'||
							 '</tr>'
							 ||listatareas||
							 '</table>';
							 
					   texto := replace(textopen,'#LISTADO_TAREAS#',listatareas);
					   numcorreos := numcorreos+1; 
				  	   n_error := Pkd7_Sendmail.send(server,'Sistema dumbo <'||emisor||'>',receptores,NULL,NULL,'DUMBO7: Resumen Alertas Nivel '||nivel||'.Responsable Apl.',texto,NULL,NULL);
	              	 EXCEPTION WHEN OTHERS THEN
		          	   n_error := 1;
		             END;
				  end if;
			   	  aplicacion := v_apl.tar_apl_cod;
				  if nivel != '1' then
				  	 seccion := v_apl.apl_sec_cod;
				  else seccion := ''; end if;
				  receptores := 'X';
				  open resp_apl(sistema,aplicacion,seccion);
				  fetch resp_apl into recp;
				  while resp_apl%found loop
				    if receptores='X' then receptores:=recp;
					else receptores := receptores||','||recp;
					end if;
				    fetch resp_apl into recp;
				  end loop;
				  close resp_apl;
				  listatareas := '';
			   END IF;

	            BEGIN
					SELECT tmo_fecha_mov INTO fechaMovimiento
					FROM D7_TAREAS_MOVIMIENTOS
					WHERE tmo_sis_cod = v_apl.tar_sis_cod
			    	AND tmo_tar_cod = v_apl.tar_cod
					and rownum=1
 					order by tmo_fecha_mov asc;
				EXCEPTION WHEN NO_DATA_FOUND THEN 
					fechaMovimiento := v_apl.tar_feccrea;
				END;

 				-- Cogemos los dias maximos para la plantilla
	 	        IF  nivel = '1' THEN
			 	-- Cogemos los dias maximos para NIVEL 1
				  BEGIN
				    SELECT ama_dias INTO dias 
					FROM D7_APLICACIONES_MAXIMOS
			        WHERE ama_sis_cod = v_apl.tar_sis_cod
				    AND ama_apl_cod = v_apl.tar_apl_cod
				    AND ama_tip_cod = v_apl.tar_tip_cod
				    AND ama_pri_cod = v_apl.tar_pri_cod;
				  EXCEPTION WHEN NO_DATA_FOUND THEN
			      	    SELECT MAX(AMA_DIAS) INTO DIAS 
						FROM DUMBO.D7_APLICACIONES_MAXIMOS
		  				WHERE AMA_SIS_COD=V_apl.TAR_SIS_COD
						AND AMA_TIP_COD=V_apl.TAR_TIP_COD
						AND AMA_APL_COD=V_apl.TAR_APL_COD;
	              END;
				END IF;

			 	-- Cogemos los dias maximos para NIVEL 2
				IF nivel = '2' THEN
				  BEGIN
				    SELECT max_dias INTO dias 
					FROM D7_SECCIONES_MAXIMOS
				    WHERE max_sis_cod = v_apl.tar_sis_cod
			        AND max_tip_cod = v_apl.tar_tip_cod
				    AND max_pri_cod = v_apl.tar_pri_cod
				    AND max_sec_cod = v_apl.apl_sec_cod;
                  EXCEPTION WHEN  NO_DATA_FOUND THEN
					 	 SELECT MAX(MAX_DIAS) INTO DIAS 
						 FROM DUMBO.D7_SECCIONES_MAXIMOS
 		                 WHERE MAX_SIS_COD=V_apl.TAR_SIS_COD
		                 AND MAX_TIP_COD=V_apl.TAR_TIP_COD
		                 AND MAX_SEC_COD=V_apl.APL_SEC_COD;
	              END;
  			    END IF;

	               -- Cogemos los dias maximos para NIVEL 3
			    IF  nivel = '3' THEN
	 	          BEGIN
				    SELECT pmx_dias INTO dias 
					FROM D7_PARAMETROS_MAXIMOS
				    WHERE pmx_sis_cod = v_apl.tar_sis_cod
				    AND pmx_tip_cod = v_apl.tar_tip_cod
				    AND pmx_pri_cod = v_apl.tar_pri_cod ;
			      EXCEPTION WHEN  NO_DATA_FOUND THEN
  			  	         SELECT MAX(PMX_DIAS) INTO DIAS 
						 FROM DUMBO.D7_PARAMETROS_MAXIMOS
		                 WHERE PMX_SIS_COD=V_apl.TAR_SIS_COD
		                 AND PMX_TIP_COD=V_apl.TAR_TIP_COD;
				  END;
			    END IF;

			    listatareas := listatareas||'<tr>'||
							   '  <td>'||v_apl.tar_cod||'</td>'||
							   '  <td>'||v_apl.tar_apl_cod||'</td>'||
							   '  <td>'||v_apl.tip||'</td>'||
							   '  <td>'||v_apl.pri||'</td>'||
							   '  <td>'||v_apl.tar_feccrea||'</td>'||
							   '  <td>'||fechaMovimiento||'</td>'||
							   '  <td>'||nvl(to_char(v_apl.tar_planif,'dd/mm/yyyy'),'&nbsp;')||'</td>'||
							   '  <td>'||dias||'</td>'||
							   '  <td>'||pkd7_mail.mail_from_identificador(v_apl.tar_inf_cod)||'</td>'||
							   '  <td>'||v_apl.emailusu||'</td>'||
							   '</tr>'||
							   '<tr><td colspan="10"><b>ASUNTO: </b>'||v_apl.tar_asunto||'</td></tr>';

				IF nivel = '1' THEN			   
			       -- La alerta ya ha sido notificada.
				   update d7_tareas_alertas set tal_notif = 'S' 
				   where tal_sis_cod=v_apl.tar_sis_cod
				   and tal_tar_cod = v_apl.tar_cod
				   and tal_cod=v_apl.tal_cod;
				END IF;
							   
							   
			END LOOP; -- END LOOP V_INF 
			-- Para el ultimo 
			IF length(listatareas)>0 THEN
	      	 BEGIN
	    	 listatareas:='<table border="1" bordercolor="#C0C0C0">'||
					 '<tr>'||
					 '	<td><b>TAREA</b></td>'||
					 '	<td><b>APLICACION</b></td>'||
					 '	<td><b>TIPO</b></td>'||
					 '	<td><b>PRIORIDAD</b></td>'||
					 '  <td><b>F.SOLICITUD</b></td>'||
					 '  <td><b>F.ASIGNACIN</b></td>'||
					 '  <td><b>F.MXIMA</b></td>'||
					 '  <td><b>DAS</b></td>'||
					 '  <td><b>INFORMTICO</b></td>'||
					 '	<td><b>SOLICITANTE</b></td>'||
					 '</tr>'
					 ||listatareas||
					 '</table>';
					 
			   texto := replace(textopen,'#LISTADO_TAREAS#',listatareas);
				numcorreos := numcorreos+1; 
		  	   n_error := Pkd7_Sendmail.send(server,'Sistema dumbo <'||emisor||'>',receptores,NULL,NULL,'DUMBO7: Resumen Alertas Nivel '||nivel||'.Responsable Apl.',texto,NULL,NULL);
			   listatareas := '';
              EXCEPTION WHEN OTHERS THEN
          	   n_error := 1;
             END;
			END IF;

			if nivel = '3' then
			  misreceptores := 'X';
			  open resp_maestro(sistema);
			  fetch resp_maestro into recp;
			  while resp_maestro%found loop
			    if misreceptores='X' then misreceptores:=recp;
				else misreceptores := misreceptores||','||recp;
				end if;
			    fetch resp_maestro into recp;
			  end loop;
			  close resp_maestro;
			end if;


			if nivel = '2' or nivel = '3' then
			listasuper := '';
		  	-- Envio para los responsables de seccion 
			FOR V_SEC IN C_DATOS_SEC LOOP
			   -- Itero por cada una de las tareas.
			   -- Pero envo un nico correo para cada responsable de seccion.
			   IF seccion != v_sec.apl_sec_cod or length(listatareas)>30000 then
			   	  if seccion != 'X'  then
			      	 BEGIN
					 if nivel='3' then
					    if length(listasuper)>30000 then
				    	 listasuper:='<table border="1" bordercolor="#C0C0C0">'||
								 '<tr>'||
								 '	<td><b>TAREA</b></td>'||
								 '	<td><b>APLICACION</b></td>'||
								 '	<td><b>TIPO</b></td>'||
								 '	<td><b>PRIORIDAD</b></td>'||
								 '  <td><b>F.SOLICITUD</b></td>'||
								 '  <td><b>F.ASIGNACIN</b></td>'||
								 '  <td><b>F.MXIMA</b></td>'||
								 '  <td><b>DAS</b></td>'||
								 '  <td><b>INFORMTICO</b></td>'||
								 '	<td><b>SOLICITANTE</b></td>'||
								 '</tr>'
								 ||listasuper||
								 '</table>';
						   texto := replace(textopen,'#LISTADO_TAREAS#',listasuper);
								   numcorreos := numcorreos+1; 
					  	   n_error := Pkd7_Sendmail.send(server,'Sistema dumbo <'||emisor||'>',misreceptores,NULL,NULL,'DUMBO7: Resumen Alertas Nivel '||nivel||'.Responsable Maestro.',texto,NULL,NULL);
						   listasuper := '';
						end if; 
					 	listasuper := listasuper||listatareas; 
					 end if;
			    	 listatareas:='<table border="1" bordercolor="#C0C0C0">'||
							 '<tr>'||
							 '	<td><b>TAREA</b></td>'||
							 '	<td><b>APLICACION</b></td>'||
							 '	<td><b>TIPO</b></td>'||
							 '	<td><b>PRIORIDAD</b></td>'||
							 '  <td><b>F.SOLICITUD</b></td>'||
							 '  <td><b>F.ASIGNACIN</b></td>'||
							 '  <td><b>F.MXIMA</b></td>'||
							 '  <td><b>DAS</b></td>'||
							 '  <td><b>INFORMTICO</b></td>'||
							 '	<td><b>SOLICITANTE</b></td>'||
							 '</tr>'
							 ||listatareas||
							 '</table>';
					   texto := replace(textopen,'#LISTADO_TAREAS#',listatareas);
					   numcorreos := numcorreos+1; 
				  	   n_error := Pkd7_Sendmail.send(server,'Sistema dumbo <'||emisor||'>',receptores,NULL,NULL,'DUMBO7: Resumen Alertas Nivel '||nivel||'.Responsable Sec.',texto,NULL,NULL);
	              	 EXCEPTION WHEN OTHERS THEN
		          	   n_error := 1;
		             END;
				  end if;
			   	  seccion := v_sec.apl_sec_cod;
				  receptores := 'X';
				  open resp_sec(sistema,seccion);
				  fetch resp_sec into recp;
				  while resp_sec%found loop
				    if receptores='X' then receptores:=recp;
					else receptores := receptores||','||recp;
					end if;
				    fetch resp_sec into recp;
				  end loop;
				  close resp_sec;
				  listatareas := '';
			   END IF;

	            BEGIN
					SELECT tmo_fecha_mov INTO fechaMovimiento
					FROM D7_TAREAS_MOVIMIENTOS
					WHERE tmo_sis_cod = v_sec.tar_sis_cod
			    	AND tmo_tar_cod = v_sec.tar_cod
					and rownum=1
 					order by tmo_fecha_mov asc;
				EXCEPTION WHEN NO_DATA_FOUND THEN 
					fechaMovimiento := v_sec.tar_feccrea;
				END;

			 	-- Cogemos los dias maximos para NIVEL 2
				IF nivel = '2' THEN
				  BEGIN
				    SELECT max_dias INTO dias 
					FROM D7_SECCIONES_MAXIMOS
				    WHERE max_sis_cod = v_sec.tar_sis_cod
			        AND max_tip_cod = v_sec.tar_tip_cod
				    AND max_pri_cod = v_sec.tar_pri_cod
				    AND max_sec_cod = v_sec.apl_sec_cod;
                  EXCEPTION WHEN  NO_DATA_FOUND THEN
					 	 SELECT MAX(MAX_DIAS) INTO DIAS 
						 FROM DUMBO.D7_SECCIONES_MAXIMOS
 		                 WHERE MAX_SIS_COD=V_sec.TAR_SIS_COD
		                 AND MAX_TIP_COD=V_sec.TAR_TIP_COD
		                 AND MAX_SEC_COD=V_sec.APL_SEC_COD;
	              END;
  			    END IF;

	               -- Cogemos los dias maximos para NIVEL 3
			    IF  nivel = '3' THEN
	 	          BEGIN
				    SELECT pmx_dias INTO dias 
					FROM D7_PARAMETROS_MAXIMOS
				    WHERE pmx_sis_cod = v_sec.tar_sis_cod
				    AND pmx_tip_cod = v_sec.tar_tip_cod
				    AND pmx_pri_cod = v_sec.tar_pri_cod ;
			      EXCEPTION WHEN  NO_DATA_FOUND THEN
  			  	         SELECT MAX(PMX_DIAS) INTO DIAS 
						 FROM DUMBO.D7_PARAMETROS_MAXIMOS
		                 WHERE PMX_SIS_COD=V_sec.TAR_SIS_COD
		                 AND PMX_TIP_COD=V_sec.TAR_TIP_COD;
				  END;
			    END IF;

			    listatareas := listatareas||'<tr>'||
							   '  <td>'||v_sec.tar_cod||'</td>'||
							   '  <td>'||v_sec.tar_apl_cod||'</td>'||
							   '  <td>'||v_sec.tip||'</td>'||
							   '  <td>'||v_sec.pri||'</td>'||
							   '  <td>'||v_sec.tar_feccrea||'</td>'||
							   '  <td>'||fechaMovimiento||'</td>'||
							   '  <td>'||nvl(to_char(v_sec.tar_planif,'dd/mm/yyyy'),'&nbsp;')||'</td>'||
							   '  <td>'||dias||'</td>'||
							   '  <td>'||pkd7_mail.mail_from_identificador(v_sec.tar_inf_cod)||'</td>'||
							   '  <td>'||v_sec.emailusu||'</td>'||
							   '</tr>'||
							   '<tr><td colspan="10"><b>ASUNTO: </b>'||v_sec.tar_asunto||'</td></tr>';

			    -- La alerta ya ha sido notificada.
				update d7_tareas_alertas set tal_notif = 'S' 
				where tal_sis_cod=v_sec.tar_sis_cod
				and tal_tar_cod = v_sec.tar_cod
				and tal_cod=v_sec.tal_cod;
			   
			END LOOP; -- END LOOP V_INF 
			-- Para el ultimo 
			IF length(listatareas)>0 THEN
	      	 BEGIN
			 if nivel='3' then 
			 	listasuper := listasuper||listatareas; 
		    	 listasuper:='<table border="1" bordercolor="#C0C0C0">'||
						 '<tr>'||
						 '	<td><b>TAREA</b></td>'||
						 '	<td><b>APLICACION</b></td>'||
						 '	<td><b>TIPO</b></td>'||
						 '	<td><b>PRIORIDAD</b></td>'||
						 '  <td><b>F.SOLICITUD</b></td>'||
						 '  <td><b>F.ASIGNACIN</b></td>'||
						 '  <td><b>F.MXIMA</b></td>'||
						 '  <td><b>DAS</b></td>'||
						 '  <td><b>INFORMTICO</b></td>'||
						 '	<td><b>SOLICITANTE</b></td>'||
						 '</tr>'
						 ||listasuper||
						 '</table>';
				   texto := replace(textopen,'#LISTADO_TAREAS#',listasuper);
						   numcorreos := numcorreos+1; 
			  	   n_error := Pkd7_Sendmail.send(server,'Sistema dumbo <'||emisor||'>',misreceptores,NULL,NULL,'DUMBO7: Resumen Alertas Nivel '||nivel||'.Responsable Maestro.',texto,NULL,NULL);
			 end if;
	    	 listatareas:='<table border="1" bordercolor="#C0C0C0">'||
					 '<tr>'||
					 '	<td><b>TAREA</b></td>'||
					 '	<td><b>APLICACION</b></td>'||
					 '	<td><b>TIPO</b></td>'||
					 '	<td><b>PRIORIDAD</b></td>'||
					 '  <td><b>F.SOLICITUD</b></td>'||
					 '  <td><b>F.ASIGNACIN</b></td>'||
					 '  <td><b>F.MXIMA</b></td>'||
					 '  <td><b>DAS</b></td>'||
					 '  <td><b>INFORMTICO</b></td>'||
					 '	<td><b>SOLICITANTE</b></td>'||
					 '</tr>'
					 ||listatareas||
					 '</table>';
			   texto := replace(textopen,'#LISTADO_TAREAS#',listatareas);
					   numcorreos := numcorreos+1; 
		  	   n_error := Pkd7_Sendmail.send(server,'Sistema dumbo <'||emisor||'>',receptores,NULL,NULL,'DUMBO7: Resumen Alertas Nivel '||nivel||'.Responsable Sec.',texto,NULL,NULL);
             EXCEPTION WHEN OTHERS THEN
          	   n_error := 1;
             END;
			END IF;
			END IF; -- nivel 
			 
			--dbms_output.put_line('Enviados: '||numcorreos);
			 
       END;

END;
/

GRANT EXECUTE ON PKD7_MAIL TO JV_DUMBO;

set define on;
