PROMPT -- CREO PAQUETE PKD7_PERSONAL --;

CREATE OR REPLACE PACKAGE Pkd7_Personal IS

   FUNCTION Telefono_Personal(dni IN VARCHAR2) RETURN VARCHAR2;
   FUNCTION tipo_personal(dni IN VARCHAR2) RETURN VARCHAR2;
   FUNCTION depto_personal(dni IN VARCHAR2) RETURN VARCHAR2;
   FUNCTION centro_personal(dni IN VARCHAR2) RETURN VARCHAR2;
   FUNCTION isPdiVigente(dni IN VARCHAR2) RETURN VARCHAR2;
   FUNCTION isPasVigente(dni IN VARCHAR2) RETURN VARCHAR2;
   FUNCTION seccionesInformatico(sistema in varchar2,info in varchar2) return varchar2;
   FUNCTION seccionPadre(sistema in varchar2,sec in varchar2) return varchar2;
   FUNCTION cuenta_festivos(fini in date,ffin in date) return number;
   PROCEDURE ubicacion_tlf(dni in varchar2,ubi out varchar2,tlf out varchar2,edif out varchar2);
   function CAMBIA_DESCRIPCION(dsc in varchar2) return varchar2;
   FUNCTION ubicacion_dni(dni in varchar2) return varchar2;
	 
END;
/

CREATE OR REPLACE PACKAGE BODY Pkd7_Personal AS

   FUNCTION Telefono_Personal(dni IN VARCHAR2) RETURN VARCHAR2 IS
   			numero d7_telefonos_dumbo.GPER_NUMERO%TYPE;
		    todos VARCHAR2(200) := '';
			CURSOR tlfs(dni IN VARCHAR2) IS
				   SELECT GPER_NUMERO
				   FROM d7_telefonos_dumbo
				   WHERE GPER_AFI_IDENTIFICADOR=dni
				   ORDER BY GPER_FECHA DESC;

		BEGIN

			 OPEN tlfs(dni);
			 FETCH tlfs INTO numero;
			 WHILE tlfs%FOUND LOOP
			 	   IF LENGTH(todos)>0 THEN
			  	     todos := todos||' '||numero;
				   ELSE
			  	     todos := numero;
				   END IF;
				   FETCH tlfs INTO numero;
			 END LOOP;
			 CLOSE tlfs;

			 RETURN todos;

	    END;

   FUNCTION tipo_personal(dni IN VARCHAR2) RETURN VARCHAR2 IS
   			numero VARCHAR2(3);
		    todos VARCHAR2(200) := '';
			CURSOR tipos(iden IN VARCHAR2) IS
				   SELECT NVL(per_cat_codigo,'-')
				   FROM personal_dumbo
				   WHERE per_afi_identificador=dni;

		BEGIN

			 OPEN tipos(dni);
			 FETCH tipos INTO numero;
			 WHILE tipos%FOUND LOOP
			 	   IF LENGTH(todos)>0 THEN
			  	     todos := todos||' '||numero;
				   ELSE
			  	     todos := numero;
				   END IF;
				   FETCH tipos INTO numero;
			 END LOOP;
			 CLOSE tipos;

			 RETURN todos;

	    END;

   FUNCTION depto_personal(dni IN VARCHAR2) RETURN VARCHAR2 IS
   			numero VARCHAR2(100);
		    todos VARCHAR2(500) := '';
			CURSOR tipos(iden IN VARCHAR2) IS
				   SELECT NVL(dep_nombre,'')
				   FROM departamentos_dumbo,personal_dumbo
				   WHERE dep_codigo(+)=PER_DEP_CODIGO
				   AND per_afi_identificador=dni;

		BEGIN

			 OPEN tipos(dni);
			 FETCH tipos INTO numero;
			 WHILE tipos%FOUND LOOP
			 	   IF LENGTH(todos)>0 THEN
			  	     todos := todos||' '||numero;
				   ELSE
			  	     todos := numero;
				   END IF;
				   FETCH tipos INTO numero;
			 END LOOP;
			 CLOSE tipos;

			 RETURN todos;

	    END;

   FUNCTION centro_personal(dni IN VARCHAR2) RETURN VARCHAR2 IS
   			numero VARCHAR2(100);
		    todos VARCHAR2(500) := '';
			CURSOR tipos(iden IN VARCHAR2) IS
				   SELECT NVL(ced_nombre,'')
				   FROM centros_dumbo,personal_dumbo
				   WHERE ced_codigo(+)=PER_CED_CODIGO
				   AND per_afi_identificador=dni;

		BEGIN

			 OPEN tipos(dni);
			 FETCH tipos INTO numero;
			 WHILE tipos%FOUND LOOP
			 	   IF LENGTH(todos)>0 THEN
			  	     todos := todos||' '||numero;
				   ELSE
			  	     todos := numero;
				   END IF;
				   FETCH tipos INTO numero;
			 END LOOP;
			 CLOSE tipos;

			 RETURN todos;

	    END;

   FUNCTION isPdiVigente(dni IN VARCHAR2) RETURN VARCHAR2 IS
   rdo VARCHAR2(1);
   BEGIN

		SELECT 'S' INTO rdo
		FROM personal_dumbo
		WHERE per_afi_identificador=dni
		AND per_cat_codigo='PDI';
		RETURN rdo;
	EXCEPTION WHEN NO_DATA_FOUND THEN
   		RETURN 'N';
   END;

   FUNCTION isPasVigente(dni IN VARCHAR2) RETURN VARCHAR2 IS
   rdo VARCHAR2(1);
   BEGIN
		SELECT 'S' INTO rdo
		FROM personal_dumbo
		WHERE per_afi_identificador=dni
		AND per_cat_codigo='PAS';
		RETURN rdo;
	EXCEPTION WHEN NO_DATA_FOUND THEN
   		RETURN 'N';
   END;

	 FUNCTION seccionPadre(sistema in varchar2,sec in varchar2) return varchar2 is
	 msec varchar2(10);
	 begin
	 			select sec_sec_cod into msec
				from d7_secciones
				where sec_sis_cod=sistema
				and sec_cod = sec;
				if msec=sec then return null;
				else return msec;
				end if;
	 end;


	 FUNCTION seccionesInformatico(sistema in varchar2,info in varchar2) return varchar2 is
	 cursor secciones(sist in varchar2,inf in varchar2) is
	 			select sys_connect_by_path(sec_cod,'/')
				from d7_secciones
				where sec_sis_cod=sist
				and seccionPadre(sec_sis_cod,sec_cod) is null
				start with sec_cod in ((select distinct apl_sec_cod
				from d7_aplicaciones
				where apl_cod in
				(select ain_apl_cod
				from d7_aplicaciones_informaticos a
				where a.AIN_SIS_COD=sist
				and ain_inf_cod = inf)))
				connect by prior seccionPadre(sec_sis_cod,sec_cod)=sec_cod
				order by sec_cod;
                                
		secs varchar2(1000) := '';
		sec varchar2(100);

	 begin

	 			open secciones(sistema,info);
				fetch secciones into sec;
				while secciones%FOUND loop
							secs := sec||','||secs;
							fetch secciones into sec;
				end loop;
				close secciones;
				return secs;
	 end;

    FUNCTION cuenta_festivos(fini in date,ffin in date) return number is
    -- Cuenta los dias festivos entre dos fechas, 
    -- requiere acceso al calendario laboral esto es un ejemplo bsico !!
    begin
        return mod((ffin-fini),7);
    end;

	 PROCEDURE ubicacion_tlf(dni in varchar2,ubi out varchar2,tlf out varchar2,edif out varchar2) is
	 ub varchar2(1000);
	 tl varchar2(15);
	 ed varchar2(5);
	 begin
			SELECT NVL(depto_personal(afi_identificador),centro_personal(afi_identificador))||', '||NVL(ed_nombre,''),telefono_personal(afi_identificador),ed_codigo into ub,tl,ed
			FROM afiliaciones_dumbo,d7_edificios_dumbo,personal_dumbo
			WHERE afi_identificador=dni
                        and afi_identificador=per_afi_identificador
                        and per_ed_codigo=ed_codigo;
			ubi := ub; tlf := tl; edif := ed;
	 exception when no_data_found then
		   ubi := ub; tlf := tl; edif := ed;
	 end;
	 
	 function CAMBIA_DESCRIPCION(dsc in varchar2) return varchar2 is
	 		  TYPE string_array IS TABLE OF VARCHAR2(100);
			  cadenas string_array := string_array('Facultad de','Edificio Universitario','Edificio');
	 begin
			  	 FOR i IN cadenas.FIRST..cadenas.LAST LOOP
				 	 	   if instr(dsc,cadenas(i))=1 then return substr(dsc,length(cadenas(i))+2)||' ('||cadenas(i)||')'; end if;
			     END LOOP;
			     return dsc;
	 end;
	 
	 FUNCTION ubicacion_dni(dni in varchar2) return varchar2 is
	 code varchar2(4);
	 begin
			SELECT per_ed_codigo into code
			FROM personal_dumbo
			WHERE per_afi_identificador=dni;
                        return code;
	 exception when no_data_found then
		return code;
	 end;
	 
END;
/


GRANT EXECUTE ON  DUMBO.PKD7_PERSONAL TO JV_DUMBO;
