PROMPT -- CREO LA TABLA PERSONAL_DUMBO --;
CREATE TABLE DUMBO.PERSONAL_DUMBO
(
  PER_AFI_IDENTIFICADOR  VARCHAR2(8 BYTE),
  PER_CAT_CODIGO         VARCHAR2(3 BYTE),
  PER_DEP_CODIGO      	 VARCHAR2(4 BYTE),
  PER_CED_CODIGO         VARCHAR2(4 BYTE),
  PER_ED_CODIGO          VARCHAR2(4 BYTE),
  CONSTRAINT PK_PER PRIMARY KEY (PER_AFI_IDENTIFICADOR,PER_CAT_CODIGO)
    USING INDEX 
    TABLESPACE DUMBO
    PCTFREE    10
    INITRANS   2
    MAXTRANS   255
    STORAGE    (
                INITIAL          40K
                NEXT             40K
                MINEXTENTS       1
                MAXEXTENTS       505
                PCTINCREASE      50
                FREELISTS        1
                FREELIST GROUPS  1
               )
)
TABLESPACE DUMBO
PCTUSED    40
PCTFREE    10
INITRANS   1
MAXTRANS   255
STORAGE    (
            INITIAL          40K
            NEXT             40K
            MINEXTENTS       1
            MAXEXTENTS       505
            PCTINCREASE      50
            FREELISTS        1
            FREELIST GROUPS  1
            BUFFER_POOL      DEFAULT
           )
LOGGING 
NOCACHE
NOPARALLEL;

COMMENT ON TABLE DUMBO.PERSONAL_DUMBO IS 'Tabla que recoge los datos laborales de los empleados de la universidad.';

COMMENT ON COLUMN DUMBO.PERSONAL_DUMBO.PER_AFI_IDENTIFICADOR IS 'Dni del empleado.';

COMMENT ON COLUMN DUMBO.PERSONAL_DUMBO.PER_CAT_CODIGO IS 'Indica si el empleado es PAS  PDI';

COMMENT ON COLUMN DUMBO.PERSONAL_DUMBO.PER_DEP_CODIGO IS 'Departamento al que pertenece (para PDI).';

COMMENT ON COLUMN DUMBO.PERSONAL_DUMBO.PER_CED_CODIGO IS 'Centro en el que trabaja (para PAS).';

COMMENT ON COLUMN DUMBO.PERSONAL_DUMBO.PER_ED_CODIGO IS 'Edificio en el que trabaja.';

GRANT SELECT ON  DUMBO.PERSONAL_DUMBO TO JV_DUMBO;
