PROMPT -- CREO TABLA D7_EDIFICIOS_DUMBO --;
CREATE TABLE DUMBO.D7_EDIFICIOS_DUMBO
(
  ED_CODIGO  VARCHAR2(4 BYTE),
  ED_NOMBRE  VARCHAR2(100 BYTE),
  ED_ZON_CODIGO  VARCHAR2(4 BYTE),
  CONSTRAINT PK_EDS PRIMARY KEY (ED_CODIGO)
    USING INDEX 
    TABLESPACE DUMBO
    PCTFREE    10
    INITRANS   2
    MAXTRANS   255
    STORAGE    (
                INITIAL          40K
                NEXT             40K
                MINEXTENTS       1
                MAXEXTENTS       505
                PCTINCREASE      50
                FREELISTS        1
                FREELIST GROUPS  1
               )
)
TABLESPACE DUMBO
PCTUSED    40
PCTFREE    10
INITRANS   1
MAXTRANS   255
STORAGE    (
            INITIAL          40K
            NEXT             40K
            MINEXTENTS       1
            MAXEXTENTS       505
            PCTINCREASE      50
            FREELISTS        1
            FREELIST GROUPS  1
            BUFFER_POOL      DEFAULT
           )
LOGGING 
NOCACHE
NOPARALLEL;

COMMENT ON TABLE DUMBO.D7_EDIFICIOS_DUMBO IS 'Tabla de edificios de la universidad.';

COMMENT ON COLUMN DUMBO.D7_EDIFICIOS_DUMBO.ED_CODIGO IS 'Codigo del edificio.';

COMMENT ON COLUMN DUMBO.D7_EDIFICIOS_DUMBO.ED_NOMBRE IS 'Nombre del edificio.';

COMMENT ON COLUMN DUMBO.D7_EDIFICIOS_DUMBO.ED_ZON_CODIGO IS 'Zona en la que se ubica.';

GRANT SELECT ON  DUMBO.D7_EDIFICIOS_DUMBO TO JV_DUMBO;
