PROMPT -- CREO TABLA D7_ZONAS_DUMBO --;

CREATE TABLE DUMBO.D7_ZONAS_DUMBO
(
  ZON_CODIGO  VARCHAR2(4 BYTE),
  ZON_NOMBRE  VARCHAR2(100 BYTE),
  CONSTRAINT PK_ZON PRIMARY KEY (ZON_CODIGO)
    USING INDEX 
    TABLESPACE DUMBO
    PCTFREE    10
    INITRANS   2
    MAXTRANS   255
    STORAGE    (
                INITIAL          40K
                NEXT             40K
                MINEXTENTS       1
                MAXEXTENTS       505
                PCTINCREASE      50
                FREELISTS        1
                FREELIST GROUPS  1
               )
)
TABLESPACE DUMBO
PCTUSED    40
PCTFREE    10
INITRANS   1
MAXTRANS   255
STORAGE    (
            INITIAL          40K
            NEXT             40K
            MINEXTENTS       1
            MAXEXTENTS       505
            PCTINCREASE      50
            FREELISTS        1
            FREELIST GROUPS  1
            BUFFER_POOL      DEFAULT
           )
LOGGING 
NOCACHE
NOPARALLEL;

COMMENT ON TABLE DUMBO.D7_ZONAS_DUMBO IS 'Tabla de zonas de la universidad.';

COMMENT ON COLUMN DUMBO.D7_ZONAS_DUMBO.ZON_CODIGO IS 'Codigo de la zona.';

COMMENT ON COLUMN DUMBO.D7_ZONAS_DUMBO.ZON_NOMBRE IS 'Nombre de la zona.';

GRANT SELECT ON  DUMBO.D7_ZONAS_DUMBO TO JV_DUMBO;
