PROMPT -- CREO TABLA D7_TELEFONOS_DUMBO --;

CREATE TABLE DUMBO.D7_TELEFONOS_DUMBO
(
  GPER_AFI_IDENTIFICADOR	VARCHAR2(8 BYTE), 
  GPER_NUMERO				VARCHAR2(9 BYTE), 
  GPER_FECHA				DATE,
  CONSTRAINT PK_TEL PRIMARY KEY (GPER_AFI_IDENTIFICADOR,GPER_NUMERO)
    USING INDEX 
    TABLESPACE DUMBO
    PCTFREE    10
    INITRANS   2
    MAXTRANS   255
    STORAGE    (
                INITIAL          40K
                NEXT             40K
                MINEXTENTS       1
                MAXEXTENTS       505
                PCTINCREASE      50
                FREELISTS        1
                FREELIST GROUPS  1
               )
)
TABLESPACE DUMBO
PCTUSED    40
PCTFREE    10
INITRANS   1
MAXTRANS   255
STORAGE    (
            INITIAL          40K
            NEXT             40K
            MINEXTENTS       1
            MAXEXTENTS       505
            PCTINCREASE      50
            FREELISTS        1
            FREELIST GROUPS  1
            BUFFER_POOL      DEFAULT
           )
LOGGING 
NOCACHE
NOPARALLEL;

COMMENT ON TABLE DUMBO.D7_TELEFONOS_DUMBO IS 'Listn telefnico de la universidad.';

COMMENT ON COLUMN DUMBO.D7_TELEFONOS_DUMBO.GPER_AFI_IDENTIFICADOR IS 'Dni del empleado.';

COMMENT ON COLUMN DUMBO.D7_TELEFONOS_DUMBO.GPER_NUMERO IS 'Nmero de telfono asociado.';

COMMENT ON COLUMN DUMBO.D7_TELEFONOS_DUMBO.GPER_FECHA IS 'Fecha desde la que est vigente.';

GRANT SELECT ON  DUMBO.D7_TELEFONOS_DUMBO TO JV_DUMBO;
