PROMPT -- CREO LA TABLA D7_FESTIVOS --;
CREATE TABLE DUMBO.D7_FESTIVOS
(
  FES_ANYO		NUMBER(4), 
  FES_NUMFESTIVO	NUMBER(7),
  FES_DIA		DATE,
  CONSTRAINT PK_FES PRIMARY KEY (FES_ANYO,FES_NUMFESTIVO)
    USING INDEX 
    TABLESPACE DUMBO
    PCTFREE    10
    INITRANS   2
    MAXTRANS   255
    STORAGE    (
                INITIAL          40K
                NEXT             40K
                MINEXTENTS       1
                MAXEXTENTS       505
                PCTINCREASE      50
                FREELISTS        1
                FREELIST GROUPS  1
               )
)
TABLESPACE DUMBO
PCTUSED    40
PCTFREE    10
INITRANS   1
MAXTRANS   255
STORAGE    (
            INITIAL          40K
            NEXT             40K
            MINEXTENTS       1
            MAXEXTENTS       505
            PCTINCREASE      50
            FREELISTS        1
            FREELIST GROUPS  1
            BUFFER_POOL      DEFAULT
           )
LOGGING 
NOCACHE
NOPARALLEL;

COMMENT ON TABLE DUMBO.D7_FESTIVOS IS 'Calendario de das festivos.';

COMMENT ON COLUMN DUMBO.D7_FESTIVOS.FES_ANYO IS 'Ao de la fecha.';

COMMENT ON COLUMN DUMBO.D7_FESTIVOS.FES_NUMFESTIVO IS 'Nmero de festivo.';

COMMENT ON COLUMN DUMBO.D7_FESTIVOS.FES_DIA IS 'Fecha del festivo.';

GRANT SELECT ON  DUMBO.D7_FESTIVOS TO JV_DUMBO;
