PROMPT -- CREO TABLA D7_SISTEMAS --;
CREATE TABLE DUMBO.D7_SISTEMAS
(
  SIS_COD       VARCHAR2(3 BYTE)                NOT NULL,
  SIS_ANAGRAMA  VARCHAR2(15 BYTE)               NOT NULL,
  SIS_DESCRIP   VARCHAR2(250 BYTE)              NOT NULL,
  SIS_URL       VARCHAR2(250 BYTE),
  SIS_IND_INT   VARCHAR2(1 BYTE)                NOT NULL,
  CONSTRAINT AVCON_832298_SIS_I_000 CHECK (SIS_IND_INT IN ('E', 'I')),
  CONSTRAINT PK_D7_SISTEMAS PRIMARY KEY (SIS_COD)
    USING INDEX 
    TABLESPACE DUMBO
    PCTFREE    10
    INITRANS   2
    MAXTRANS   255
    STORAGE    (
                INITIAL          40K
                NEXT             40K
                MINEXTENTS       1
                MAXEXTENTS       505
                PCTINCREASE      50
                FREELISTS        1
                FREELIST GROUPS  1
               )
)
TABLESPACE DUMBO
PCTUSED    40
PCTFREE    10
INITRANS   1
MAXTRANS   255
STORAGE    (
            INITIAL          40K
            NEXT             40K
            MINEXTENTS       1
            MAXEXTENTS       505
            PCTINCREASE      50
            FREELISTS        1
            FREELIST GROUPS  1
            BUFFER_POOL      DEFAULT
           )
LOGGING 
NOCACHE
NOPARALLEL;

COMMENT ON TABLE DUMBO.D7_SISTEMAS IS 'Tabla que recoge los sistemas propietarios de la informacin de dumbo';

COMMENT ON COLUMN DUMBO.D7_SISTEMAS.SIS_COD IS 'Cdigo identificativo del sistema';

COMMENT ON COLUMN DUMBO.D7_SISTEMAS.SIS_ANAGRAMA IS 'Anagrama identificativo del sistema';

COMMENT ON COLUMN DUMBO.D7_SISTEMAS.SIS_DESCRIP IS 'Texto descriptivo del sistema que debe aparecer en el aplicativo';

COMMENT ON COLUMN DUMBO.D7_SISTEMAS.SIS_URL IS 'url de conexin al sistema';

COMMENT ON COLUMN DUMBO.D7_SISTEMAS.SIS_IND_INT IS 'Indicador del si el sistema es interno o externo a dumbo';

GRANT DELETE, INSERT, SELECT, UPDATE ON  DUMBO.D7_SISTEMAS TO JV_DUMBO;