PROMPT -- CREO TABLA D7_SISTEMAS_NOTICIAS --;
CREATE TABLE DUMBO.D7_SISTEMAS_NOTICIAS
(
  SNO_SIS_COD  VARCHAR2(3 BYTE)                 NOT NULL,
  SNO_COD      NUMBER(5)                        NOT NULL,
  SNO_FECHA    DATE                             NOT NULL,
  SNO_ASUNTO   VARCHAR2(50 BYTE)                NOT NULL,
  SNO_TEXTO    VARCHAR2(250 BYTE)               NOT NULL,
  SNO_URL      VARCHAR2(250 BYTE),
  SNO_IND_GEN  VARCHAR2(1 BYTE)                 NOT NULL,
  SNO_IND_CAR  VARCHAR2(1 BYTE)					NOT NULL,
  SNO_FECHA_INI DATE                            NOT NULL,
  SNO_FECHA_FIN DATE                            NOT NULL,
  CONSTRAINT AVCON_832317_SNO_I_000 CHECK (SNO_IND_GEN IN ('G', 'P')),
  CONSTRAINT CHK_CARACTER CHECK (sno_ind_car IN ('P','I')),
  CONSTRAINT PK_SISTEMAS_NOTICIAS PRIMARY KEY (SNO_SIS_COD, SNO_COD)
    USING INDEX 
    TABLESPACE DUMBO
    PCTFREE    10
    INITRANS   2
    MAXTRANS   255
    STORAGE    (
                INITIAL          40K
                NEXT             40K
                MINEXTENTS       1
                MAXEXTENTS       505
                PCTINCREASE      50
                FREELISTS        1
                FREELIST GROUPS  1
               ),
  CONSTRAINT FK_SISTEMAS_NOTIF_SISTEMAS FOREIGN KEY (SNO_SIS_COD) 
    REFERENCES DUMBO.D7_SISTEMAS (SIS_COD)
)
TABLESPACE DUMBO
PCTUSED    40
PCTFREE    10
INITRANS   1
MAXTRANS   255
STORAGE    (
            INITIAL          40K
            NEXT             40K
            MINEXTENTS       1
            MAXEXTENTS       505
            PCTINCREASE      50
            FREELISTS        1
            FREELIST GROUPS  1
            BUFFER_POOL      DEFAULT
           )
LOGGING 
NOCACHE
NOPARALLEL;

COMMENT ON TABLE DUMBO.D7_SISTEMAS_NOTICIAS IS 'Noticias de inters vinculadas al sistema';

COMMENT ON COLUMN DUMBO.D7_SISTEMAS_NOTICIAS.SNO_SIS_COD IS 'Cdigo identificativo sistema que da de alta la noticia';

COMMENT ON COLUMN DUMBO.D7_SISTEMAS_NOTICIAS.SNO_COD IS 'Cdigo identificativo de la noticia';

COMMENT ON COLUMN DUMBO.D7_SISTEMAS_NOTICIAS.SNO_FECHA IS 'Fecha registro noticia';

COMMENT ON COLUMN DUMBO.D7_SISTEMAS_NOTICIAS.SNO_ASUNTO IS 'Titular o asunto de la noticia';

COMMENT ON COLUMN DUMBO.D7_SISTEMAS_NOTICIAS.SNO_TEXTO IS 'Texto que recoge la noticia';

COMMENT ON COLUMN DUMBO.D7_SISTEMAS_NOTICIAS.SNO_URL IS 'url vinculada a la noticia';

COMMENT ON COLUMN DUMBO.D7_SISTEMAS_NOTICIAS.SNO_IND_GEN IS 'Indicador de si la noticia es de ndole general o particular al sistema';

GRANT DELETE, INSERT, SELECT, UPDATE ON  DUMBO.D7_SISTEMAS_NOTICIAS TO JV_DUMBO;