PROMPT -- CREO TABLA D7_SECCIONES --;
CREATE TABLE DUMBO.D7_SECCIONES
(
  SEC_SIS_COD    VARCHAR2(3 BYTE)               NOT NULL,
  SEC_COD        VARCHAR2(10 BYTE)              NOT NULL,
  SEC_DESCRIP    VARCHAR2(50 BYTE)              NOT NULL,
  SEC_ID_RESPON  VARCHAR2(8 BYTE)               NOT NULL,
  SEC_SEC_COD    VARCHAR2(10 BYTE)              NOT NULL,
  SEC_ESTADO     VARCHAR2(1 BYTE)               NOT NULL,
  CONSTRAINT AVCON_821872_SEC_E_000 CHECK (SEC_ESTADO IN ('V', 'N')),
  CONSTRAINT PK_D7_SECCIONES PRIMARY KEY (SEC_SIS_COD, SEC_COD)
    USING INDEX 
    TABLESPACE DUMBO
    PCTFREE    10
    INITRANS   2
    MAXTRANS   255
    STORAGE    (
                INITIAL          40K
                NEXT             40K
                MINEXTENTS       1
                MAXEXTENTS       505
                PCTINCREASE      50
                FREELISTS        1
                FREELIST GROUPS  1
               ),
  CONSTRAINT FK_SECCIONES_SECCIONES FOREIGN KEY (SEC_SIS_COD, SEC_SEC_COD) 
    REFERENCES DUMBO.D7_SECCIONES (SEC_SIS_COD,SEC_COD),
  CONSTRAINT FK_SECCIONES_SISTEMAS FOREIGN KEY (SEC_SIS_COD) 
    REFERENCES DUMBO.D7_SISTEMAS (SIS_COD)
)
TABLESPACE DUMBO
PCTUSED    40
PCTFREE    10
INITRANS   1
MAXTRANS   255
STORAGE    (
            INITIAL          40K
            NEXT             40K
            MINEXTENTS       1
            MAXEXTENTS       505
            PCTINCREASE      50
            FREELISTS        1
            FREELIST GROUPS  1
            BUFFER_POOL      DEFAULT
           )
LOGGING 
NOCACHE
NOPARALLEL;

COMMENT ON TABLE DUMBO.D7_SECCIONES IS 'Tabla que recoge las Secciones/subsecciones del sistema propietario';

COMMENT ON COLUMN DUMBO.D7_SECCIONES.SEC_COD IS 'Cdigo identificativo de la seccin';

COMMENT ON COLUMN DUMBO.D7_SECCIONES.SEC_DESCRIP IS 'Denominacin de la seccin';

COMMENT ON COLUMN DUMBO.D7_SECCIONES.SEC_ID_RESPON IS 'Responsable de la seccin';

COMMENT ON COLUMN DUMBO.D7_SECCIONES.SEC_SEC_COD IS 'Seccin padre de la que depende';

COMMENT ON COLUMN DUMBO.D7_SECCIONES.SEC_ESTADO IS 'Indicador de vigencia de la seccin';

GRANT DELETE, INSERT, SELECT, UPDATE ON  DUMBO.D7_SECCIONES TO JV_DUMBO;