PROMPT -- CREO TABLA D7_APLICACIONES --;
CREATE TABLE DUMBO.D7_APLICACIONES
(
  APL_SIS_COD    VARCHAR2(3 BYTE)               NOT NULL,
  APL_COD        VARCHAR2(10 BYTE)              NOT NULL,
  APL_DESCRIP    VARCHAR2(240 BYTE)             NOT NULL,
  APL_DETALLE    VARCHAR2(2000 BYTE)            NOT NULL,
  APL_TIPO_ASIG  VARCHAR2(1 BYTE)               NOT NULL,
  APL_SEC_COD    VARCHAR2(10 BYTE)              NOT NULL,
  APL_ESTADO     VARCHAR2(1 BYTE)               NOT NULL,
  APL_CARACTER   VARCHAR2(1 BYTE)	            NOT NULL,
  APL_PADRE_APL_COD VARCHAR2(10 BYTE),
  APL_CORREO_RESP    VARCHAR2(1 BYTE),
  APL_CORREO_INF     VARCHAR2(1 BYTE),
  APL_URL			VARCHAR2(250 BYTE), 
  APL_URL_INFO		VARCHAR2(250 BYTE),
  CONSTRAINT AVCON_822139_APL_E_000 CHECK (APL_ESTADO IN ('V', 'N')),
  CONSTRAINT AVCON_822139_APL_T_000 CHECK (APL_TIPO_ASIG IN ('P', 'R','C','U')),
  CONSTRAINT AVCON_822139_APL_R_000 CHECK (APL_CARACTER IN ('E', 'I')),
  CONSTRAINT PK_D7_APLICACIONES PRIMARY KEY (APL_SIS_COD, APL_COD)
    USING INDEX 
    TABLESPACE DUMBO
    PCTFREE    10
    INITRANS   2
    MAXTRANS   255
    STORAGE    (
                INITIAL          40K
                NEXT             40K
                MINEXTENTS       1
                MAXEXTENTS       505
                PCTINCREASE      50
                FREELISTS        1
                FREELIST GROUPS  1
               ),
  CONSTRAINT FK_APLICACION_APLIC FOREIGN KEY (APL_SIS_COD, APL_PADRE_APL_COD) 
    REFERENCES DUMBO.D7_APLICACIONES (APL_SIS_COD,APL_COD),
  CONSTRAINT FK_APLICACION_SECCIONES FOREIGN KEY (APL_SIS_COD, APL_SEC_COD) 
    REFERENCES DUMBO.D7_SECCIONES (SEC_SIS_COD,SEC_COD),
  CONSTRAINT FK_APLICACION_SISTEMAS FOREIGN KEY (APL_SIS_COD) 
    REFERENCES DUMBO.D7_SISTEMAS (SIS_COD)
)
TABLESPACE DUMBO
PCTUSED    40
PCTFREE    10
INITRANS   1
MAXTRANS   255
STORAGE    (
            INITIAL          40K
            NEXT             40K
            MINEXTENTS       1
            MAXEXTENTS       505
            PCTINCREASE      50
            FREELISTS        1
            FREELIST GROUPS  1
            BUFFER_POOL      DEFAULT
           )
LOGGING 
NOCACHE
NOPARALLEL;

COMMENT ON TABLE DUMBO.D7_APLICACIONES IS 'Tabla que recoge las aplicaciones/servicios del sistema propietario';

COMMENT ON COLUMN DUMBO.D7_APLICACIONES.APL_COD IS 'Cdigo identificador de la aplicacin/servicio';

COMMENT ON COLUMN DUMBO.D7_APLICACIONES.APL_DESCRIP IS 'Denominacin de la aplicacin/servicio';

COMMENT ON COLUMN DUMBO.D7_APLICACIONES.APL_TIPO_ASIG IS 'Tipo asignacin automtica de tarea a informticos de la aplicacin (Puede ser "por pesos" o "por asignacin a responsable")';

COMMENT ON COLUMN DUMBO.D7_APLICACIONES.APL_SEC_COD IS 'Cdigo de seccin a la que esta vinculada la aplicacin/servicio';

COMMENT ON COLUMN DUMBO.D7_APLICACIONES.APL_ESTADO IS 'Estado de vigencia de la aplicacin/servicio en el sistema';

COMMENT ON COLUMN DUMBO.D7_APLICACIONES.APL_PADRE_APL_COD IS 'Aplicacin de 1er nivel si la tiene.';

COMMENT ON COLUMN DUMBO.D7_APLICACIONES.APL_CORREO_RESP IS 'Indica si se quiere que se remitan correos al responsable de las finalizaciones de tareas.';

COMMENT ON COLUMN DUMBO.D7_APLICACIONES.APL_CORREO_INF IS 'Indica si se quiere que se remitan correos a los informaticos al recibir una tarea. Valido para asig. por cola.';

COMMENT ON COLUMN DUMBO.D7_APLICACIONES.APL_URL IS 'URL Vinculada a la aplicacin/servicio.';

COMMENT ON COLUMN DUMBO.D7_APLICACIONES.APL_URL_INF IS 'URL Informativa de la aplicacin/servicio.';

GRANT DELETE, INSERT, SELECT, UPDATE ON  DUMBO.D7_APLICACIONES TO JV_DUMBO;