PROMPT -- CREO TABLA D7_FILTROS_USUARIO --;
CREATE TABLE DUMBO.D7_FILTROS_USUARIO
(
  FIL_SIS_COD  VARCHAR2(3 BYTE)                 NOT NULL,
  FIL_USU_COD  VARCHAR2(8 BYTE)                 NOT NULL,
  FIL_COD      NUMBER(2)                        NOT NULL,
  FIL_FILTRO   VARCHAR2(4000 BYTE)              NOT NULL,
  CONSTRAINT PK_FILTROS_USUARIO PRIMARY KEY (FIL_SIS_COD, FIL_USU_COD, FIL_COD)
    USING INDEX 
    TABLESPACE DUMBO
    PCTFREE    10
    INITRANS   2
    MAXTRANS   255
    STORAGE    (
                INITIAL          40K
                NEXT             40K
                MINEXTENTS       1
                MAXEXTENTS       505
                PCTINCREASE      50
                FREELISTS        1
                FREELIST GROUPS  1
               ),
  CONSTRAINT FK_FILTROS_USUARIO_SISTEMAS FOREIGN KEY (FIL_SIS_COD) 
    REFERENCES DUMBO.D7_SISTEMAS (SIS_COD)
)
TABLESPACE DUMBO
PCTUSED    40
PCTFREE    10
INITRANS   1
MAXTRANS   255
STORAGE    (
            INITIAL          40K
            NEXT             40K
            MINEXTENTS       1
            MAXEXTENTS       505
            PCTINCREASE      50
            FREELISTS        1
            FREELIST GROUPS  1
            BUFFER_POOL      DEFAULT
           )
LOGGING 
NOCACHE
NOPARALLEL;

COMMENT ON TABLE DUMBO.D7_FILTROS_USUARIO IS 'Tabla que recoge los filtros de usuario para cada listado.';

COMMENT ON COLUMN DUMBO.D7_FILTROS_USUARIO.FIL_USU_COD IS 'Usuario que define el filtro.';

COMMENT ON COLUMN DUMBO.D7_FILTROS_USUARIO.FIL_COD IS 'Cdigo identificativo del listado';

COMMENT ON COLUMN DUMBO.D7_FILTROS_USUARIO.FIL_FILTRO IS 'Codificacin del filtro.';

GRANT DELETE, INSERT, SELECT, UPDATE ON  DUMBO.D7_FILTROS_USUARIO TO JV_DUMBO;