PROMPT -- CREO TABLA D7_GRUPOS_COSTES --;
CREATE TABLE DUMBO.D7_GRUPOS_COSTES
(
  GCO_SIS_COD  VARCHAR2(3 BYTE)                 NOT NULL,
  GCO_COD      VARCHAR2(5 BYTE)                 NOT NULL,
  GCO_DESCRIP  VARCHAR2(50 BYTE),
  GCO_COSTE    NUMBER(6,2),
  GCO_HORAS    NUMBER(3,2),
  GCO_ESTADO   VARCHAR2(1 BYTE),
  CONSTRAINT AVCON_822129_GCO_E_000 CHECK (GCO_ESTADO IN ('V', 'N')),
  CONSTRAINT PK_D7_GRUPOS_COSTES PRIMARY KEY (GCO_SIS_COD, GCO_COD)
    USING INDEX 
    TABLESPACE DUMBO
    PCTFREE    10
    INITRANS   2
    MAXTRANS   255
    STORAGE    (
                INITIAL          40K
                NEXT             40K
                MINEXTENTS       1
                MAXEXTENTS       505
                PCTINCREASE      50
                FREELISTS        1
                FREELIST GROUPS  1
               ),
  CONSTRAINT FK_GRUPOS_COS_SISTEMAS FOREIGN KEY (GCO_SIS_COD) 
    REFERENCES DUMBO.D7_SISTEMAS (SIS_COD)
)
TABLESPACE DUMBO
PCTUSED    40
PCTFREE    10
INITRANS   1
MAXTRANS   255
STORAGE    (
            INITIAL          40K
            NEXT             40K
            MINEXTENTS       1
            MAXEXTENTS       505
            PCTINCREASE      50
            FREELISTS        1
            FREELIST GROUPS  1
            BUFFER_POOL      DEFAULT
           )
LOGGING 
NOCACHE
NOPARALLEL;

COMMENT ON TABLE DUMBO.D7_GRUPOS_COSTES IS 'Tabla que recoge los distintos grupos de coste econmico de informticos';

COMMENT ON COLUMN DUMBO.D7_GRUPOS_COSTES.GCO_COD IS 'Cdigo identificativo del grupo de coste';

COMMENT ON COLUMN DUMBO.D7_GRUPOS_COSTES.GCO_DESCRIP IS 'Denominacin del grupo de coste';

COMMENT ON COLUMN DUMBO.D7_GRUPOS_COSTES.GCO_COSTE IS 'Coste del personal del grupo';

COMMENT ON COLUMN DUMBO.D7_GRUPOS_COSTES.GCO_HORAS IS 'Horas asignadas al personal del grupo';

COMMENT ON COLUMN DUMBO.D7_GRUPOS_COSTES.GCO_ESTADO IS 'Estado de vigencia del grupo de coste';

GRANT DELETE, INSERT, SELECT, UPDATE ON  DUMBO.D7_GRUPOS_COSTES TO JV_DUMBO;