PROMPT -- CREO TABLA D7_GRUPOS_USUARIOS --;
CREATE TABLE DUMBO.D7_GRUPOS_USUARIOS
(
  GRU_SIS_COD  VARCHAR2(3 BYTE)                 NOT NULL,
  GRU_COD      VARCHAR2(10 BYTE)                NOT NULL,
  GRU_DESCRIP  VARCHAR2(30 BYTE)                NOT NULL,
  GRU_COD_COD  VARCHAR2(10 BYTE),
  CONSTRAINT PK_D7_GRUPOS_USUARIOS PRIMARY KEY (GRU_SIS_COD, GRU_COD)
    USING INDEX 
    TABLESPACE DUMBO
    PCTFREE    10
    INITRANS   2
    MAXTRANS   255
    STORAGE    (
                INITIAL          40K
                NEXT             40K
                MINEXTENTS       1
                MAXEXTENTS       505
                PCTINCREASE      50
                FREELISTS        1
                FREELIST GROUPS  1
               ),
  CONSTRAINT FK_GRUPOS_GRUPOS_USUARIOS FOREIGN KEY (GRU_SIS_COD, GRU_COD_COD) 
    REFERENCES DUMBO.D7_GRUPOS_USUARIOS (GRU_SIS_COD,GRU_COD),
  CONSTRAINT FK_GRUPOS_USU_SISTEMAS FOREIGN KEY (GRU_SIS_COD) 
    REFERENCES DUMBO.D7_SISTEMAS (SIS_COD)
)
TABLESPACE DUMBO
PCTUSED    40
PCTFREE    10
INITRANS   1
MAXTRANS   255
STORAGE    (
            INITIAL          40K
            NEXT             40K
            MINEXTENTS       1
            MAXEXTENTS       505
            PCTINCREASE      50
            FREELISTS        1
            FREELIST GROUPS  1
            BUFFER_POOL      DEFAULT
           )
LOGGING 
NOCACHE
NOPARALLEL;

COMMENT ON TABLE DUMBO.D7_GRUPOS_USUARIOS IS 'Tabla que recoge los grupos de usuarios finales';

COMMENT ON COLUMN DUMBO.D7_GRUPOS_USUARIOS.GRU_COD IS 'Cdigo identificativo del grupo de usuarios';

COMMENT ON COLUMN DUMBO.D7_GRUPOS_USUARIOS.GRU_DESCRIP IS 'Denominacin del grupo de usuarios';

COMMENT ON COLUMN DUMBO.D7_GRUPOS_USUARIOS.GRU_COD_COD IS 'grupo de usuarios padre';

GRANT DELETE, INSERT, SELECT, UPDATE ON  DUMBO.D7_GRUPOS_USUARIOS TO JV_DUMBO;