PROMPT -- CREO TABLA D7_INFORMATICOS --;
CREATE TABLE DUMBO.D7_INFORMATICOS
(
  INF_SIS_COD  VARCHAR2(3 BYTE)                 NOT NULL,
  INF_COD      VARCHAR2(8 BYTE)                 NOT NULL,
  INF_ESTADO   VARCHAR2(1 BYTE)                 NOT NULL,
  INF_SEC_COD  VARCHAR2(10 BYTE)                NOT NULL,
  INF_GCO_COD  VARCHAR2(5 BYTE)                 NOT NULL,
  CONSTRAINT AVCON_822013_INF_E_000 CHECK (INF_ESTADO IN ('V', 'N')),
  CONSTRAINT PK_D7_INFORMATICOS PRIMARY KEY (INF_SIS_COD, INF_COD)
    USING INDEX 
    TABLESPACE DUMBO
    PCTFREE    10
    INITRANS   2
    MAXTRANS   255
    STORAGE    (
                INITIAL          40K
                NEXT             40K
                MINEXTENTS       1
                MAXEXTENTS       505
                PCTINCREASE      50
                FREELISTS        1
                FREELIST GROUPS  1
               ),
  CONSTRAINT FK_INFORMATICOS_GRUPOS_COSTE FOREIGN KEY (INF_SIS_COD, INF_GCO_COD) 
    REFERENCES DUMBO.D7_GRUPOS_COSTES (GCO_SIS_COD,GCO_COD),
  CONSTRAINT FK_INFORMATICOS_SECCIONES FOREIGN KEY (INF_SIS_COD, INF_SEC_COD) 
    REFERENCES DUMBO.D7_SECCIONES (SEC_SIS_COD,SEC_COD),
  CONSTRAINT FK_INFORMATIC_SISTEMAS FOREIGN KEY (INF_SIS_COD) 
    REFERENCES DUMBO.D7_SISTEMAS (SIS_COD)
)
TABLESPACE DUMBO
PCTUSED    40
PCTFREE    10
INITRANS   1
MAXTRANS   255
STORAGE    (
            INITIAL          40K
            NEXT             40K
            MINEXTENTS       1
            MAXEXTENTS       505
            PCTINCREASE      50
            FREELISTS        1
            FREELIST GROUPS  1
            BUFFER_POOL      DEFAULT
           )
LOGGING 
NOCACHE
NOPARALLEL;

COMMENT ON TABLE DUMBO.D7_INFORMATICOS IS 'Tabla que recoge los informticos del sistema';

COMMENT ON COLUMN DUMBO.D7_INFORMATICOS.INF_COD IS 'Cdigo identificativo del informtico';

COMMENT ON COLUMN DUMBO.D7_INFORMATICOS.INF_ESTADO IS 'Estado de vigencia del informtico';

COMMENT ON COLUMN DUMBO.D7_INFORMATICOS.INF_SEC_COD IS 'Cdigo identificativo de la seccin de 1er nivel a la que est vinculado el informtico';

COMMENT ON COLUMN DUMBO.D7_INFORMATICOS.INF_GCO_COD IS 'cdigo identificativo del grupo de coste al que pertenece el informtico';

GRANT DELETE, INSERT, SELECT, UPDATE ON  DUMBO.D7_INFORMATICOS TO JV_DUMBO;