PROMPT -- CREO TABLA D7_APLICACIONES_INFORMATICOS --;
CREATE TABLE DUMBO.D7_APLICACIONES_INFORMATICOS
(
  AIN_SIS_COD      VARCHAR2(3 BYTE)             NOT NULL,
  AIN_APL_COD      VARCHAR2(10 BYTE)            NOT NULL,
  AIN_INF_COD      VARCHAR2(8 BYTE)             NOT NULL,
  AIN_RESPONSABLE  VARCHAR2(1 BYTE),
  AIN_PRIORIDAD    NUMBER(2),
  CONSTRAINT PK_D7_APLICACIONES_INFORMATIC PRIMARY KEY (AIN_SIS_COD, AIN_APL_COD, AIN_INF_COD)
    USING INDEX 
    TABLESPACE DUMBO
    PCTFREE    10
    INITRANS   2
    MAXTRANS   255
    STORAGE    (
                INITIAL          40K
                NEXT             40K
                MINEXTENTS       1
                MAXEXTENTS       505
                PCTINCREASE      50
                FREELISTS        1
                FREELIST GROUPS  1
               ),
  CONSTRAINT FK_APLICACION_INFORMATICOS FOREIGN KEY (AIN_SIS_COD, AIN_INF_COD) 
    REFERENCES DUMBO.D7_INFORMATICOS (INF_SIS_COD,INF_COD),
  CONSTRAINT FK_APLIC_INFOR__APLICACIONES FOREIGN KEY (AIN_SIS_COD, AIN_APL_COD) 
    REFERENCES DUMBO.D7_APLICACIONES (APL_SIS_COD,APL_COD)
)
TABLESPACE DUMBO
PCTUSED    40
PCTFREE    10
INITRANS   1
MAXTRANS   255
STORAGE    (
            INITIAL          40K
            NEXT             40K
            MINEXTENTS       1
            MAXEXTENTS       505
            PCTINCREASE      50
            FREELISTS        1
            FREELIST GROUPS  1
            BUFFER_POOL      DEFAULT
           )
LOGGING 
NOCACHE
NOPARALLEL;

COMMENT ON TABLE DUMBO.D7_APLICACIONES_INFORMATICOS IS 'Tabla que recoge los informticos vinculados a una aplicacin/servicio';

COMMENT ON COLUMN DUMBO.D7_APLICACIONES_INFORMATICOS.AIN_APL_COD IS 'Cdigo identificativo de la aplicacin/servicio';

COMMENT ON COLUMN DUMBO.D7_APLICACIONES_INFORMATICOS.AIN_INF_COD IS 'Cdigo identificativo del informtico';

COMMENT ON COLUMN DUMBO.D7_APLICACIONES_INFORMATICOS.AIN_RESPONSABLE IS 'indicador de si el informtico es responsable de la aplicacin/servicio';

COMMENT ON COLUMN DUMBO.D7_APLICACIONES_INFORMATICOS.AIN_PRIORIDAD IS 'Orden de prioridad como responsable aplicacin/servicio';

GRANT DELETE, INSERT, SELECT, UPDATE ON  DUMBO.D7_APLICACIONES_INFORMATICOS TO JV_DUMBO;
