PROMPT -- CREO TABLA D7_PERFILES --;
CREATE TABLE DUMBO.D7_PERFILES
(
  PER_SIS_COD  VARCHAR2(3 BYTE)                 NOT NULL,
  PER_COD      VARCHAR2(3 BYTE)                 NOT NULL,
  PER_DESCRIP  VARCHAR2(240 BYTE)               NOT NULL,
  PER_ESTADO   VARCHAR2(1 BYTE)                 NOT NULL,
  CONSTRAINT AVCON_823215_PER_E_000 CHECK (PER_ESTADO IN ('V', 'N')),
  CONSTRAINT PK_D7_PERFILES PRIMARY KEY (PER_SIS_COD, PER_COD)
    USING INDEX 
    TABLESPACE DUMBO
    PCTFREE    10
    INITRANS   2
    MAXTRANS   255
    STORAGE    (
                INITIAL          40K
                NEXT             40K
                MINEXTENTS       1
                MAXEXTENTS       505
                PCTINCREASE      50
                FREELISTS        1
                FREELIST GROUPS  1
               ),
  CONSTRAINT FK_PERFILES_SISTEMAS FOREIGN KEY (PER_SIS_COD) 
    REFERENCES DUMBO.D7_SISTEMAS (SIS_COD)
)
TABLESPACE DUMBO
PCTUSED    40
PCTFREE    10
INITRANS   1
MAXTRANS   255
STORAGE    (
            INITIAL          40K
            NEXT             40K
            MINEXTENTS       1
            MAXEXTENTS       505
            PCTINCREASE      50
            FREELISTS        1
            FREELIST GROUPS  1
            BUFFER_POOL      DEFAULT
           )
LOGGING 
NOCACHE
NOPARALLEL;

COMMENT ON TABLE DUMBO.D7_PERFILES IS 'Tabla que recoge los distintos perfiles de usuario en DUMBO (usuario, oreja, informtico, gestor informtico, maestro)';

COMMENT ON COLUMN DUMBO.D7_PERFILES.PER_COD IS 'Cdigo identificativo del perfil de usuario';

COMMENT ON COLUMN DUMBO.D7_PERFILES.PER_DESCRIP IS 'Denominacin del perfil de usuario';

COMMENT ON COLUMN DUMBO.D7_PERFILES.PER_ESTADO IS 'Estado de vigencia del perfil de usuario en el sistema';

GRANT DELETE, INSERT, SELECT, UPDATE ON  DUMBO.D7_PERFILES TO JV_DUMBO;
