PROMPT -- CREO TABLA D7_PRIORIDADES --;
CREATE TABLE DUMBO.D7_PRIORIDADES
(
  PRI_SIS_COD  VARCHAR2(3 BYTE)                 NOT NULL,
  PRI_COD      VARCHAR2(1 BYTE)                 NOT NULL,
  PRI_DESCRIP  VARCHAR2(240 BYTE)               NOT NULL,
  CONSTRAINT PK_D7_PRIORIDADES PRIMARY KEY (PRI_SIS_COD, PRI_COD)
    USING INDEX 
    TABLESPACE DUMBO
    PCTFREE    10
    INITRANS   2
    MAXTRANS   255
    STORAGE    (
                INITIAL          40K
                NEXT             40K
                MINEXTENTS       1
                MAXEXTENTS       505
                PCTINCREASE      50
                FREELISTS        1
                FREELIST GROUPS  1
               ),
  CONSTRAINT FK_PRIORIDADES_SISTEMAS FOREIGN KEY (PRI_SIS_COD) 
    REFERENCES DUMBO.D7_SISTEMAS (SIS_COD)
)
TABLESPACE DUMBO
PCTUSED    40
PCTFREE    10
INITRANS   1
MAXTRANS   255
STORAGE    (
            INITIAL          40K
            NEXT             40K
            MINEXTENTS       1
            MAXEXTENTS       505
            PCTINCREASE      50
            FREELISTS        1
            FREELIST GROUPS  1
            BUFFER_POOL      DEFAULT
           )
LOGGING 
NOCACHE
NOPARALLEL;

COMMENT ON TABLE DUMBO.D7_PRIORIDADES IS 'Tabla que recoge las prioridades en DUMBO para resolucin de tareas';

COMMENT ON COLUMN DUMBO.D7_PRIORIDADES.PRI_COD IS 'Cdigo identificativo de la prioridad';

COMMENT ON COLUMN DUMBO.D7_PRIORIDADES.PRI_DESCRIP IS 'Denominacin de la prioridad';

GRANT DELETE, INSERT, SELECT, UPDATE ON  DUMBO.D7_PRIORIDADES TO JV_DUMBO;
