PROMPT -- CREO TABLA D7_TIPOS_TAREAS --;
CREATE TABLE DUMBO.D7_TIPOS_TAREAS
(
  TIP_SIS_COD  VARCHAR2(3 BYTE)                 NOT NULL,
  TIP_COD      VARCHAR2(1 BYTE)                 NOT NULL,
  TIP_DESCRIP  VARCHAR2(240 BYTE)               NOT NULL,
  CONSTRAINT PK_D7_TIPOS_TAREAS PRIMARY KEY (TIP_SIS_COD, TIP_COD)
    USING INDEX 
    TABLESPACE DUMBO
    PCTFREE    10
    INITRANS   2
    MAXTRANS   255
    STORAGE    (
                INITIAL          40K
                NEXT             40K
                MINEXTENTS       1
                MAXEXTENTS       505
                PCTINCREASE      50
                FREELISTS        1
                FREELIST GROUPS  1
               ),
  CONSTRAINT FK_TIPOS_TAREA_SISTEMAS FOREIGN KEY (TIP_SIS_COD) 
    REFERENCES DUMBO.D7_SISTEMAS (SIS_COD)
)
TABLESPACE DUMBO
PCTUSED    40
PCTFREE    10
INITRANS   1
MAXTRANS   255
STORAGE    (
            INITIAL          40K
            NEXT             40K
            MINEXTENTS       1
            MAXEXTENTS       505
            PCTINCREASE      50
            FREELISTS        1
            FREELIST GROUPS  1
            BUFFER_POOL      DEFAULT
           )
LOGGING 
NOCACHE
NOPARALLEL;

COMMENT ON TABLE DUMBO.D7_TIPOS_TAREAS IS 'Tabla que recoge los distintos tipos de tarea del sistema (peticiones/incidencias/problemas)';

COMMENT ON COLUMN DUMBO.D7_TIPOS_TAREAS.TIP_COD IS 'Cdigo identificativo del tipo de tarea';

COMMENT ON COLUMN DUMBO.D7_TIPOS_TAREAS.TIP_DESCRIP IS 'Denominacin del tipo de tarea';

GRANT DELETE, INSERT, SELECT, UPDATE ON  DUMBO.D7_TIPOS_TAREAS TO JV_DUMBO;
