PROMPT -- CREO TABLA D7_APLICACIONES_MAXIMOS --;
CREATE TABLE DUMBO.D7_APLICACIONES_MAXIMOS
(
  AMA_SIS_COD  VARCHAR2(3 BYTE)                 NOT NULL,
  AMA_TIP_COD  VARCHAR2(1 BYTE)                 NOT NULL,
  AMA_APL_COD  VARCHAR2(10 BYTE)                NOT NULL,
  AMA_PRI_COD  VARCHAR2(1 BYTE)                 NOT NULL,
  AMA_DIAS     NUMBER(4,1)                      NOT NULL,
  CONSTRAINT PK_APLICACIONES_MAXIMOS PRIMARY KEY (AMA_SIS_COD, AMA_TIP_COD, AMA_APL_COD, AMA_PRI_COD)
    USING INDEX 
    TABLESPACE DUMBO
    PCTFREE    10
    INITRANS   2
    MAXTRANS   255
    STORAGE    (
                INITIAL          40K
                NEXT             40K
                MINEXTENTS       1
                MAXEXTENTS       505
                PCTINCREASE      50
                FREELISTS        1
                FREELIST GROUPS  1
               ),
  CONSTRAINT FK_APLICACION_MAX_APLICACION FOREIGN KEY (AMA_SIS_COD, AMA_APL_COD) 
    REFERENCES DUMBO.D7_APLICACIONES (APL_SIS_COD,APL_COD),
  CONSTRAINT FK_APLICACION_MAX_TIPTAR FOREIGN KEY (AMA_SIS_COD, AMA_TIP_COD) 
    REFERENCES DUMBO.D7_TIPOS_TAREAS (TIP_SIS_COD,TIP_COD),
  CONSTRAINT FK_APLIC_MAX_PRIORIDAD FOREIGN KEY (AMA_SIS_COD, AMA_PRI_COD) 
    REFERENCES DUMBO.D7_PRIORIDADES (PRI_SIS_COD,PRI_COD)
)
TABLESPACE DUMBO
PCTUSED    40
PCTFREE    10
INITRANS   1
MAXTRANS   255
STORAGE    (
            INITIAL          40K
            NEXT             40K
            MINEXTENTS       1
            MAXEXTENTS       505
            PCTINCREASE      50
            FREELISTS        1
            FREELIST GROUPS  1
            BUFFER_POOL      DEFAULT
           )
LOGGING 
NOCACHE
NOPARALLEL;

COMMENT ON TABLE DUMBO.D7_APLICACIONES_MAXIMOS IS 'Tabla que recoge los das mximos de resolucin para cada aplicacin y tipo de tarea';

COMMENT ON COLUMN DUMBO.D7_APLICACIONES_MAXIMOS.AMA_TIP_COD IS 'Identificador del tipo de tarea';

COMMENT ON COLUMN DUMBO.D7_APLICACIONES_MAXIMOS.AMA_APL_COD IS 'Identificador de la aplicacin/servicio';

COMMENT ON COLUMN DUMBO.D7_APLICACIONES_MAXIMOS.AMA_PRI_COD IS 'Identificador de la prioridad de la tarea';

COMMENT ON COLUMN DUMBO.D7_APLICACIONES_MAXIMOS.AMA_DIAS IS 'Das mximo resolucin tarea (peticin/incidencia) segn prioridad para generacin alertas';

GRANT DELETE, INSERT, SELECT, UPDATE ON  DUMBO.D7_APLICACIONES_MAXIMOS TO JV_DUMBO;