PROMPT -- CREO TABLA D7_APLICACIONES_PARAMETROS --;
CREATE TABLE DUMBO.D7_APLICACIONES_PARAMETROS
(
  APA_SIS_COD    VARCHAR2(3 BYTE)               NOT NULL,
  APA_APL_COD    VARCHAR2(10 BYTE)              NOT NULL,
  APA_TIP_COD    VARCHAR2(1 BYTE)               NOT NULL,
  APA_URGENCIA   VARCHAR2(1 BYTE),
  APA_PRIORIDAD  VARCHAR2(1 BYTE),
  CONSTRAINT AVCON_823110_APA_P_000 CHECK (APA_PRIORIDAD IN ('A', 'M', 'B', 'P')),
  CONSTRAINT AVCON_823110_APA_U_000 CHECK (APA_URGENCIA IN ('U', 'N')),
  CONSTRAINT PK_D7_APLICACIONES_PARAMETROS PRIMARY KEY (APA_SIS_COD, APA_APL_COD, APA_TIP_COD)
    USING INDEX 
    TABLESPACE DUMBO
    PCTFREE    10
    INITRANS   2
    MAXTRANS   255
    STORAGE    (
                INITIAL          40K
                NEXT             40K
                MINEXTENTS       1
                MAXEXTENTS       505
                PCTINCREASE      50
                FREELISTS        1
                FREELIST GROUPS  1
               ),
  CONSTRAINT FK_APLICACION_PAR_APLICACION FOREIGN KEY (APA_SIS_COD, APA_APL_COD) 
    REFERENCES DUMBO.D7_APLICACIONES (APL_SIS_COD,APL_COD),
  CONSTRAINT FK_APLICACION_PAR_TIPOS_TAR FOREIGN KEY (APA_SIS_COD, APA_TIP_COD) 
    REFERENCES DUMBO.D7_TIPOS_TAREAS (TIP_SIS_COD,TIP_COD)
)
TABLESPACE DUMBO
PCTUSED    40
PCTFREE    10
INITRANS   1
MAXTRANS   255
STORAGE    (
            INITIAL          40K
            NEXT             40K
            MINEXTENTS       1
            MAXEXTENTS       505
            PCTINCREASE      50
            FREELISTS        1
            FREELIST GROUPS  1
            BUFFER_POOL      DEFAULT
           )
LOGGING 
NOCACHE
NOPARALLEL;

COMMENT ON TABLE DUMBO.D7_APLICACIONES_PARAMETROS IS 'Tabla que recoge los valores por defecto de urgencia y prioridad para las tareas de una determinada aplicacin y tipo';

COMMENT ON COLUMN DUMBO.D7_APLICACIONES_PARAMETROS.APA_APL_COD IS 'Identificador de la aplicacin/servicio';

COMMENT ON COLUMN DUMBO.D7_APLICACIONES_PARAMETROS.APA_TIP_COD IS 'Identificador del tipo de tarea';

COMMENT ON COLUMN DUMBO.D7_APLICACIONES_PARAMETROS.APA_URGENCIA IS 'Urgencia por defecto de la tarea';

COMMENT ON COLUMN DUMBO.D7_APLICACIONES_PARAMETROS.APA_PRIORIDAD IS 'Prioridad por defecto de la tarea';

GRANT DELETE, INSERT, SELECT, UPDATE ON  DUMBO.D7_APLICACIONES_PARAMETROS TO JV_DUMBO;
