PROMPT -- CREO TABLA D7_CATEGORIAS --;
CREATE TABLE DUMBO.D7_CATEGORIAS
(
  CAT_SIS_COD     VARCHAR2(3 BYTE)              NOT NULL,
  CAT_COD         NUMBER(3)                     NOT NULL,
  CAT_DESCRIP     VARCHAR2(240 BYTE)            NOT NULL,
  CAT_ESTADO      VARCHAR2(1 BYTE)              NOT NULL,
  CAT_TIP_COD     VARCHAR2(1 BYTE)              NOT NULL,
  CAT_SEC_COD     VARCHAR2(10 BYTE)             NOT NULL,
  CAT_CAT_COD     NUMBER(3),
  CAT_TIEMPO_EST  NUMBER(7,2),
  CONSTRAINT AVCON_822847_CAT_E_000 CHECK (CAT_ESTADO IN ('V', 'N')),
  CONSTRAINT PK_D7_CATEGORIAS PRIMARY KEY (CAT_SIS_COD, CAT_COD)
    USING INDEX 
    TABLESPACE DUMBO
    PCTFREE    10
    INITRANS   2
    MAXTRANS   255
    STORAGE    (
                INITIAL          40K
                NEXT             40K
                MINEXTENTS       1
                MAXEXTENTS       505
                PCTINCREASE      50
                FREELISTS        1
                FREELIST GROUPS  1
               ),
  CONSTRAINT FK_CATEGORIAS_CATEGORIAS FOREIGN KEY (CAT_SIS_COD, CAT_CAT_COD) 
    REFERENCES DUMBO.D7_CATEGORIAS (CAT_SIS_COD,CAT_COD),
  CONSTRAINT FK_CATEGORIAS_SECCIONES FOREIGN KEY (CAT_SIS_COD, CAT_SEC_COD) 
    REFERENCES DUMBO.D7_SECCIONES (SEC_SIS_COD,SEC_COD),
  CONSTRAINT FK_CATEGORIAS_SISTEMAS FOREIGN KEY (CAT_SIS_COD) 
    REFERENCES DUMBO.D7_SISTEMAS (SIS_COD),
  CONSTRAINT FK_CATEGORIAS_TIPOS_TAR FOREIGN KEY (CAT_SIS_COD, CAT_TIP_COD) 
    REFERENCES DUMBO.D7_TIPOS_TAREAS (TIP_SIS_COD,TIP_COD)
)
TABLESPACE DUMBO
PCTUSED    40
PCTFREE    10
INITRANS   1
MAXTRANS   255
STORAGE    (
            INITIAL          40K
            NEXT             40K
            MINEXTENTS       1
            MAXEXTENTS       505
            PCTINCREASE      50
            FREELISTS        1
            FREELIST GROUPS  1
            BUFFER_POOL      DEFAULT
           )
LOGGING 
NOCACHE
NOPARALLEL;

COMMENT ON TABLE DUMBO.D7_CATEGORIAS IS 'Tabla que recoge las categoras de resolucin de tareas segn seccin y tipo de tarea';

COMMENT ON COLUMN DUMBO.D7_CATEGORIAS.CAT_COD IS 'Cdigo identificativo de la categora de resolucin';

COMMENT ON COLUMN DUMBO.D7_CATEGORIAS.CAT_DESCRIP IS 'Denominacin de la categora';

COMMENT ON COLUMN DUMBO.D7_CATEGORIAS.CAT_ESTADO IS 'Estado de vigencia de la categora en el sistema';

COMMENT ON COLUMN DUMBO.D7_CATEGORIAS.CAT_TIP_COD IS 'tipo de tarea al que se vincula la categora';

COMMENT ON COLUMN DUMBO.D7_CATEGORIAS.CAT_SEC_COD IS 'seccin a la que se vincula la categora';

COMMENT ON COLUMN DUMBO.D7_CATEGORIAS.CAT_CAT_COD IS 'categora de resolucin padre';

GRANT DELETE, INSERT, SELECT, UPDATE ON  DUMBO.D7_CATEGORIAS TO JV_DUMBO;
