PROMPT -- CREO TABLA D7_INFORMATICOS_PERFILES --;
CREATE TABLE DUMBO.D7_INFORMATICOS_PERFILES
(
  IPE_SIS_COD  VARCHAR2(3 BYTE)                 NOT NULL,
  IPE_INF_COD  VARCHAR2(8 BYTE)                 NOT NULL,
  IPE_PER_COD  VARCHAR2(3 BYTE)                 NOT NULL,
  CONSTRAINT PK_INFORMATICOS_PERFILES PRIMARY KEY (IPE_SIS_COD, IPE_INF_COD, IPE_PER_COD)
    USING INDEX 
    TABLESPACE DUMBO
    PCTFREE    10
    INITRANS   2
    MAXTRANS   255
    STORAGE    (
                INITIAL          40K
                NEXT             40K
                MINEXTENTS       1
                MAXEXTENTS       505
                PCTINCREASE      50
                FREELISTS        1
                FREELIST GROUPS  1
               ),
  CONSTRAINT FK_INFORMAT_PERF_INFORMATICOS FOREIGN KEY (IPE_SIS_COD, IPE_INF_COD) 
    REFERENCES DUMBO.D7_INFORMATICOS (INF_SIS_COD,INF_COD),
  CONSTRAINT FK_INFORMAT_PERF_PERFILES FOREIGN KEY (IPE_SIS_COD, IPE_PER_COD) 
    REFERENCES DUMBO.D7_PERFILES (PER_SIS_COD,PER_COD)
)
TABLESPACE DUMBO
PCTUSED    40
PCTFREE    10
INITRANS   1
MAXTRANS   255
STORAGE    (
            INITIAL          40K
            NEXT             40K
            MINEXTENTS       1
            MAXEXTENTS       505
            PCTINCREASE      50
            FREELISTS        1
            FREELIST GROUPS  1
            BUFFER_POOL      DEFAULT
           )
LOGGING 
NOCACHE
NOPARALLEL;

COMMENT ON TABLE DUMBO.D7_INFORMATICOS_PERFILES IS 'Tabla que recoge los perfiles de un informtico';

COMMENT ON COLUMN DUMBO.D7_INFORMATICOS_PERFILES.IPE_INF_COD IS 'Cdigo identificativo del informtico';

COMMENT ON COLUMN DUMBO.D7_INFORMATICOS_PERFILES.IPE_PER_COD IS 'Cdigo identificativo del perfil asignado al informtico';

GRANT DELETE, INSERT, SELECT, UPDATE ON  DUMBO.D7_INFORMATICOS_PERFILES TO JV_DUMBO;
