PROMPT -- CREO TABLA D7_PARAMETROS --;
CREATE TABLE DUMBO.D7_PARAMETROS
(
  PAR_SIS_COD      VARCHAR2(3 BYTE)             NOT NULL,
  PAR_PARAMETRO    VARCHAR2(25 BYTE)            NOT NULL,
  PAR_VALOR        VARCHAR2(100 BYTE),
  PAR_DESCRIPCION  VARCHAR2(250 BYTE),
  PRIMARY KEY (PAR_SIS_COD, PAR_PARAMETRO)
    USING INDEX 
    TABLESPACE DUMBO
    PCTFREE    10
    INITRANS   2
    MAXTRANS   255
    STORAGE    (
                INITIAL          16K
                NEXT             16K
                MINEXTENTS       1
                MAXEXTENTS       505
                PCTINCREASE      50
                FREELISTS        1
                FREELIST GROUPS  1
               ),
  CONSTRAINT FK_PARAMETROS_SISTEMAS FOREIGN KEY (PAR_SIS_COD) 
    REFERENCES DUMBO.D7_SISTEMAS (SIS_COD)
)
TABLESPACE DUMBO
PCTUSED    40
PCTFREE    10
INITRANS   1
MAXTRANS   255
STORAGE    (
            INITIAL          16K
            NEXT             16K
            MINEXTENTS       1
            MAXEXTENTS       121
            PCTINCREASE      50
            FREELISTS        1
            FREELIST GROUPS  1
            BUFFER_POOL      DEFAULT
           )
LOGGING 
NOCACHE
NOPARALLEL;

COMMENT ON TABLE DUMBO.D7_PARAMETROS IS 'Tabla parmetros del sistema propietario';

COMMENT ON COLUMN DUMBO.D7_PARAMETROS.PAR_PARAMETRO IS 'Nombre del parmetro.';

COMMENT ON COLUMN DUMBO.D7_PARAMETROS.PAR_VALOR IS 'Valor del parmetro.';

COMMENT ON COLUMN DUMBO.D7_PARAMETROS.PAR_DESCRIPCION IS 'Descripcin del parmetro.';

GRANT DELETE, INSERT, SELECT, UPDATE ON  DUMBO.D7_PARAMETROS TO JV_DUMBO;
