PROMPT -- CREO TABLA D7_PARAMETROS_MAXIMOS --;
CREATE TABLE DUMBO.D7_PARAMETROS_MAXIMOS
(
  PMX_SIS_COD  VARCHAR2(3 BYTE)                 NOT NULL,
  PMX_TIP_COD  VARCHAR2(1 BYTE)                 NOT NULL,
  PMX_PRI_COD  VARCHAR2(1 BYTE)                 NOT NULL,
  PMX_DIAS     NUMBER(4,1)                      NOT NULL,
  CONSTRAINT PK_D7_PARAMETROS_MAXIMOS PRIMARY KEY (PMX_SIS_COD, PMX_TIP_COD, PMX_PRI_COD)
    USING INDEX 
    TABLESPACE DUMBO
    PCTFREE    10
    INITRANS   2
    MAXTRANS   255
    STORAGE    (
                INITIAL          40K
                NEXT             40K
                MINEXTENTS       1
                MAXEXTENTS       505
                PCTINCREASE      50
                FREELISTS        1
                FREELIST GROUPS  1
               ),
  CONSTRAINT FK_PARAMETROS_MAX_PRIORIDAD FOREIGN KEY (PMX_SIS_COD, PMX_PRI_COD) 
    REFERENCES DUMBO.D7_PRIORIDADES (PRI_SIS_COD,PRI_COD),
  CONSTRAINT FK_PARAMETROS_MAX_SISTEMAS FOREIGN KEY (PMX_SIS_COD) 
    REFERENCES DUMBO.D7_SISTEMAS (SIS_COD),
  CONSTRAINT FK_PARAMETROS_MAX_TIPOS_TAR FOREIGN KEY (PMX_SIS_COD, PMX_TIP_COD) 
    REFERENCES DUMBO.D7_TIPOS_TAREAS (TIP_SIS_COD,TIP_COD)
)
TABLESPACE DUMBO
PCTUSED    40
PCTFREE    10
INITRANS   1
MAXTRANS   255
STORAGE    (
            INITIAL          40K
            NEXT             40K
            MINEXTENTS       1
            MAXEXTENTS       505
            PCTINCREASE      50
            FREELISTS        1
            FREELIST GROUPS  1
            BUFFER_POOL      DEFAULT
           )
LOGGING 
NOCACHE
NOPARALLEL;

COMMENT ON TABLE DUMBO.D7_PARAMETROS_MAXIMOS IS 'Tabla que recoge a nivel de sistema los das mximos para resolucin de tareas segn prioridad y tipo de tarea';

COMMENT ON COLUMN DUMBO.D7_PARAMETROS_MAXIMOS.PMX_SIS_COD IS 'Identificador del propietario del sistema';

COMMENT ON COLUMN DUMBO.D7_PARAMETROS_MAXIMOS.PMX_TIP_COD IS 'Identificador del tipo de tarea';

COMMENT ON COLUMN DUMBO.D7_PARAMETROS_MAXIMOS.PMX_PRI_COD IS 'Cdigo identificador de la prioridad';

COMMENT ON COLUMN DUMBO.D7_PARAMETROS_MAXIMOS.PMX_DIAS IS 'Das mximo resolucin tarea (peticin/incidencia) segn prioridad para generacin alertas';

GRANT DELETE, INSERT, SELECT, UPDATE ON  DUMBO.D7_PARAMETROS_MAXIMOS TO JV_DUMBO;
