PROMPT -- CREO TABLA D7_SECCIONES_MAXIMOS --;
CREATE TABLE DUMBO.D7_SECCIONES_MAXIMOS
(
  MAX_SIS_COD  VARCHAR2(3 BYTE)                 NOT NULL,
  MAX_SEC_COD  VARCHAR2(10 BYTE)                NOT NULL,
  MAX_TIP_COD  VARCHAR2(1 BYTE)                 NOT NULL,
  MAX_PRI_COD  VARCHAR2(1 BYTE)                 NOT NULL,
  MAX_DIAS     NUMBER(4,1)                      NOT NULL,
  CONSTRAINT PK_D7_SECCIONES_MAXIMOS PRIMARY KEY (MAX_SIS_COD, MAX_SEC_COD, MAX_TIP_COD, MAX_PRI_COD)
    USING INDEX 
    TABLESPACE DUMBO
    PCTFREE    10
    INITRANS   2
    MAXTRANS   255
    STORAGE    (
                INITIAL          40K
                NEXT             40K
                MINEXTENTS       1
                MAXEXTENTS       505
                PCTINCREASE      50
                FREELISTS        1
                FREELIST GROUPS  1
               ),
  CONSTRAINT FK_SECCIONES_MAX_PRIORIDADES FOREIGN KEY (MAX_SIS_COD, MAX_PRI_COD) 
    REFERENCES DUMBO.D7_PRIORIDADES (PRI_SIS_COD,PRI_COD),
  CONSTRAINT FK_SECCIONES_MAX_SECCIONES FOREIGN KEY (MAX_SIS_COD, MAX_SEC_COD) 
    REFERENCES DUMBO.D7_SECCIONES (SEC_SIS_COD,SEC_COD),
  CONSTRAINT FK_SECCIONES_MAX_TIPOS_TAR FOREIGN KEY (MAX_SIS_COD, MAX_TIP_COD) 
    REFERENCES DUMBO.D7_TIPOS_TAREAS (TIP_SIS_COD,TIP_COD)
)
TABLESPACE DUMBO
PCTUSED    40
PCTFREE    10
INITRANS   1
MAXTRANS   255
STORAGE    (
            INITIAL          40K
            NEXT             40K
            MINEXTENTS       1
            MAXEXTENTS       505
            PCTINCREASE      50
            FREELISTS        1
            FREELIST GROUPS  1
            BUFFER_POOL      DEFAULT
           )
LOGGING 
NOCACHE
NOPARALLEL;

COMMENT ON TABLE DUMBO.D7_SECCIONES_MAXIMOS IS 'Tabla que recoge los das mximos para resolucin de tareas segn tipo de tarea, seccin y prioridad';

COMMENT ON COLUMN DUMBO.D7_SECCIONES_MAXIMOS.MAX_SEC_COD IS 'Cdigo identificativo de la seccin';

COMMENT ON COLUMN DUMBO.D7_SECCIONES_MAXIMOS.MAX_TIP_COD IS 'Cdigo identificativo del tipo de tarea';

COMMENT ON COLUMN DUMBO.D7_SECCIONES_MAXIMOS.MAX_PRI_COD IS 'Cdigo identificativo de la prioridad';

COMMENT ON COLUMN DUMBO.D7_SECCIONES_MAXIMOS.MAX_DIAS IS 'Das mximo resolucin tarea (peticin/incidencia) segn prioridad y seccin para generacin alertas';

GRANT DELETE, INSERT, SELECT, UPDATE ON  DUMBO.D7_SECCIONES_MAXIMOS TO JV_DUMBO;
