PROMPT -- CREO TABLA D7_TAREAS_ALERTAS --;
CREATE TABLE DUMBO.D7_TAREAS_ALERTAS
(
  TAL_SIS_COD     VARCHAR2(3 BYTE)              NOT NULL,
  TAL_TAR_COD     NUMBER(8)                     NOT NULL,
  TAL_COD         NUMBER(2)                     NOT NULL,
  TAL_FEC_ALERTA  DATE                          NOT NULL,
  TAL_NIVEL       VARCHAR2(1 BYTE)              NOT NULL,
  TAL_NOTIF       VARCHAR2 (1 BYTE),
  CONSTRAINT AVCON_824171_TAL_N_000 CHECK (TAL_NIVEL IN ('1', '2', '3')),
  CONSTRAINT PK_TAREAS_ALERTAS PRIMARY KEY (TAL_SIS_COD, TAL_TAR_COD, TAL_COD)
    USING INDEX 
    TABLESPACE DUMBO
    PCTFREE    10
    INITRANS   2
    MAXTRANS   255
    STORAGE    (
                INITIAL          40K
                NEXT             40K
                MINEXTENTS       1
                MAXEXTENTS       505
                PCTINCREASE      50
                FREELISTS        1
                FREELIST GROUPS  1
               ),
  CONSTRAINT FK_TAREAS_ALERTAS_TAREAS FOREIGN KEY (TAL_SIS_COD, TAL_TAR_COD) 
    REFERENCES DUMBO.D7_TAREAS (TAR_SIS_COD,TAR_COD)
)
TABLESPACE DUMBO
PCTUSED    40
PCTFREE    10
INITRANS   1
MAXTRANS   255
STORAGE    (
            INITIAL          40K
            NEXT             40K
            MINEXTENTS       1
            MAXEXTENTS       505
            PCTINCREASE      50
            FREELISTS        1
            FREELIST GROUPS  1
            BUFFER_POOL      DEFAULT
           )
LOGGING 
NOCACHE
NOPARALLEL;

COMMENT ON TABLE DUMBO.D7_TAREAS_ALERTAS IS 'Tabla que recoge las alertas generadas sobre una tarea';

COMMENT ON COLUMN DUMBO.D7_TAREAS_ALERTAS.TAL_TAR_COD IS 'Cdigo identificativo de la tarea';

COMMENT ON COLUMN DUMBO.D7_TAREAS_ALERTAS.TAL_COD IS 'Cdigo identificativo de la alelrta segn tarea';

COMMENT ON COLUMN DUMBO.D7_TAREAS_ALERTAS.TAL_FEC_ALERTA IS 'Fecha en la que se genera la alerta';

COMMENT ON COLUMN DUMBO.D7_TAREAS_ALERTAS.TAL_NIVEL IS 'Nivel de alerta (aplicacin, seccin, maestro)';

COMMENT ON COLUMN D7_TAREAS_ALERTAS.TAL_NOTIF IS 'Cdigo para saber si ha sido notificado o no';

GRANT DELETE, INSERT, SELECT, UPDATE ON  DUMBO.D7_TAREAS_ALERTAS TO JV_DUMBO;
