PROMPT -- CREO TABLA D7_TAREAS_MOVIMIENTOS --;
CREATE TABLE DUMBO.D7_TAREAS_MOVIMIENTOS
(
  TMO_SIS_COD      VARCHAR2(3 BYTE)             NOT NULL,
  TMO_TAR_COD      NUMBER(8)                    NOT NULL,
  TMO_COD          NUMBER(3)                    NOT NULL,
  TMO_FECHA_MOV    DATE                         NOT NULL,
  TMO_TIPO_MOV     VARCHAR2(3 BYTE)             NOT NULL,
  TMO_DESCRIP_MOV  VARCHAR2(4000 BYTE)          NOT NULL,
  TMO_INF_COD      VARCHAR2(8 BYTE),
  TMO_VALOR_ANTERIOR VARCHAR2(4000 BYTE),
  TMO_VALOR_NUEVO VARCHAR2(4000 BYTE),
  CONSTRAINT PK_TAREAS_MOVIMIENTOS PRIMARY KEY (TMO_SIS_COD, TMO_TAR_COD, TMO_COD)
    USING INDEX 
    TABLESPACE DUMBO
    PCTFREE    10
    INITRANS   2
    MAXTRANS   255
    STORAGE    (
                INITIAL          40K
                NEXT             40K
                MINEXTENTS       1
                MAXEXTENTS       505
                PCTINCREASE      50
                FREELISTS        1
                FREELIST GROUPS  1
               ),
  CONSTRAINT FK_TAREAS_MOVIM_TAREAS FOREIGN KEY (TMO_SIS_COD, TMO_TAR_COD) 
    REFERENCES DUMBO.D7_TAREAS (TAR_SIS_COD,TAR_COD)
)
TABLESPACE DUMBO
PCTUSED    40
PCTFREE    10
INITRANS   1
MAXTRANS   255
STORAGE    (
            INITIAL          40K
            NEXT             40K
            MINEXTENTS       1
            MAXEXTENTS       505
            PCTINCREASE      50
            FREELISTS        1
            FREELIST GROUPS  1
            BUFFER_POOL      DEFAULT
           )
LOGGING 
NOCACHE
NOPARALLEL;

COMMENT ON TABLE DUMBO.D7_TAREAS_MOVIMIENTOS IS 'Tabla que recoge los movimientos/cambios  realizados sobre una tarea';

COMMENT ON COLUMN DUMBO.D7_TAREAS_MOVIMIENTOS.TMO_TAR_COD IS 'Cdigo identificativo de la tarea';

COMMENT ON COLUMN DUMBO.D7_TAREAS_MOVIMIENTOS.TMO_COD IS 'Cdigo identificativo del movimiento segn tarea';

COMMENT ON COLUMN DUMBO.D7_TAREAS_MOVIMIENTOS.TMO_FECHA_MOV IS 'Fecha en la que se ha realizado el movimiento';

COMMENT ON COLUMN DUMBO.D7_TAREAS_MOVIMIENTOS.TMO_TIPO_MOV IS 'Tipo de movimiento realizado';

COMMENT ON COLUMN DUMBO.D7_TAREAS_MOVIMIENTOS.TMO_DESCRIP_MOV IS 'Texto/descripcin movimiento realizado';

COMMENT ON COLUMN DUMBO.D7_TAREAS_MOVIMIENTOS.TMO_INF_COD IS 'Cdigo identificador del informtico que realiza el cambio';

GRANT DELETE, INSERT, SELECT, UPDATE ON  DUMBO.D7_TAREAS_MOVIMIENTOS TO JV_DUMBO;
