PROMPT -- CREO TABLA D7_TAREAS_PROGRAMADAS --;
CREATE TABLE DUMBO.D7_TAREAS_PROGRAMADAS
(
  TPR_SIS_COD           VARCHAR2(3 BYTE)        NOT NULL,
  TPR_TAR_COD           NUMBER(8)               NOT NULL,
  TPR_FECHA_INICIO      DATE,
  TPR_FECHA_FIN         DATE,
  TPR_INTERVALO_HORAS   NUMBER(5),
  TPR_FINDESEMANA       VARCHAR2(1 BYTE),
  TPR_TAREAS_GENERADAS  NUMBER(5),
  CONSTRAINT PK_D7_TAREAS_PROG PRIMARY KEY (TPR_SIS_COD, TPR_TAR_COD)
    USING INDEX 
    TABLESPACE DUMBO
    PCTFREE    10
    INITRANS   2
    MAXTRANS   255
    STORAGE    (
                INITIAL          40K
                NEXT             40K
                MINEXTENTS       1
                MAXEXTENTS       505
                PCTINCREASE      50
                FREELISTS        1
                FREELIST GROUPS  1
               ),
  CONSTRAINT FK_TAREAS_PROG_TAREAS FOREIGN KEY (TPR_SIS_COD, TPR_TAR_COD) 
    REFERENCES DUMBO.D7_TAREAS (TAR_SIS_COD,TAR_COD)
)
TABLESPACE DUMBO
PCTUSED    40
PCTFREE    10
INITRANS   1
MAXTRANS   255
STORAGE    (
            INITIAL          40K
            NEXT             40K
            MINEXTENTS       1
            MAXEXTENTS       505
            PCTINCREASE      50
            FREELISTS        1
            FREELIST GROUPS  1
            BUFFER_POOL      DEFAULT
           )
LOGGING 
NOCACHE
NOPARALLEL;

COMMENT ON TABLE DUMBO.D7_TAREAS_PROGRAMADAS IS 'Tabla que recoge informacin especfica de las tareas programadas';

COMMENT ON COLUMN DUMBO.D7_TAREAS_PROGRAMADAS.TPR_TAR_COD IS 'Cdigo identificativo de la tarea';

COMMENT ON COLUMN DUMBO.D7_TAREAS_PROGRAMADAS.TPR_FECHA_INICIO IS 'Fecha inicio primera tarea programada';

COMMENT ON COLUMN DUMBO.D7_TAREAS_PROGRAMADAS.TPR_FECHA_FIN IS 'Fecha finalizacin tarea programada';

COMMENT ON COLUMN DUMBO.D7_TAREAS_PROGRAMADAS.TPR_INTERVALO_HORAS IS 'intervalo en das/horas para crear subatareas programadas';

COMMENT ON COLUMN DUMBO.D7_TAREAS_PROGRAMADAS.TPR_FINDESEMANA IS 'Indicador de si hay que crear subtareas programadas en fin de semana';

GRANT DELETE, INSERT, SELECT, UPDATE ON  DUMBO.D7_TAREAS_PROGRAMADAS TO JV_DUMBO;
