PROMPT -- CREO TABLA D7_TAREAS_SEGUIMIENTOS --;
CREATE TABLE DUMBO.D7_TAREAS_SEGUIMIENTOS
(
  TSE_SIS_COD     VARCHAR2(3 BYTE)              NOT NULL,
  TSE_TAR_COD     NUMBER(8)                     NOT NULL,
  TSE_COD         NUMBER(3)                     NOT NULL,
  TSE_FECHA_ALTA  DATE                          NOT NULL,
  TSE_DESCRIP     VARCHAR2(2000 BYTE)           NOT NULL,
  TSE_USU_COD 	  VARCHAR2(8 BYTE),
  TSE_DEDICACION  NUMBER(7,2),
  CONSTRAINT PK_TAREAS_SEGUIMIENTOS PRIMARY KEY (TSE_SIS_COD, TSE_TAR_COD, TSE_COD)
    USING INDEX 
    TABLESPACE DUMBO
    PCTFREE    10
    INITRANS   2
    MAXTRANS   255
    STORAGE    (
                INITIAL          40K
                NEXT             40K
                MINEXTENTS       1
                MAXEXTENTS       505
                PCTINCREASE      50
                FREELISTS        1
                FREELIST GROUPS  1
               ),
  CONSTRAINT FK_TAREAS_SEGUIM_TAREAS FOREIGN KEY (TSE_SIS_COD, TSE_TAR_COD) 
    REFERENCES DUMBO.D7_TAREAS (TAR_SIS_COD,TAR_COD)
)
TABLESPACE DUMBO
PCTUSED    40
PCTFREE    10
INITRANS   1
MAXTRANS   255
STORAGE    (
            INITIAL          40K
            NEXT             40K
            MINEXTENTS       1
            MAXEXTENTS       505
            PCTINCREASE      50
            FREELISTS        1
            FREELIST GROUPS  1
            BUFFER_POOL      DEFAULT
           )
LOGGING 
NOCACHE
NOPARALLEL;

COMMENT ON TABLE DUMBO.D7_TAREAS_SEGUIMIENTOS IS 'Tabla que recoge el cuaderno de bitcora de los informticos en relacin a una tarea';

COMMENT ON COLUMN DUMBO.D7_TAREAS_SEGUIMIENTOS.TSE_TAR_COD IS 'Cdigo identificativo de la tarea';

COMMENT ON COLUMN DUMBO.D7_TAREAS_SEGUIMIENTOS.TSE_COD IS 'Cdigo identificativo del seguimiento para la tarea';

COMMENT ON COLUMN DUMBO.D7_TAREAS_SEGUIMIENTOS.TSE_FECHA_ALTA IS 'Fecha alta apunte';

COMMENT ON COLUMN DUMBO.D7_TAREAS_SEGUIMIENTOS.TSE_DESCRIP IS 'descripcin del apunte realizado';

COMMENT ON COLUMN DUMBO.D7_TAREAS_SEGUIMIENTOS.TSE_USU_COD IS 'Identificador del usuario que ha escrito el apunte (si no es uno mismo).';

COMMENT ON COLUMN DUMBO.D7_TAREAS_SEGUIMIENTOS.TSE_DEDICACION IS 'Tiempo parcial dedicado a la tarea.';

GRANT DELETE, INSERT, SELECT, UPDATE ON  DUMBO.D7_TAREAS_SEGUIMIENTOS TO JV_DUMBO;
