PROMPT -- CREO TABLA D7_TAREAS_VINCULADAS --;
CREATE TABLE DUMBO.D7_TAREAS_VINCULADAS
(
  TVI_SIS_COD       VARCHAR2(3 BYTE)            NOT NULL,
  TVI_TAR_COD       NUMBER(8)                   NOT NULL,
  TVI_VINC_TAR_COD  NUMBER(8)                   NOT NULL,
  CONSTRAINT PK_D7_TAREAS_VINC PRIMARY KEY (TVI_SIS_COD, TVI_TAR_COD, TVI_VINC_TAR_COD)
    USING INDEX 
    TABLESPACE DUMBO
    PCTFREE    10
    INITRANS   2
    MAXTRANS   255
    STORAGE    (
                INITIAL          40K
                NEXT             40K
                MINEXTENTS       1
                MAXEXTENTS       505
                PCTINCREASE      50
                FREELISTS        1
                FREELIST GROUPS  1
               ),
  CONSTRAINT FK_TAREAS_VINC_TAREAS1 FOREIGN KEY (TVI_SIS_COD, TVI_TAR_COD) 
    REFERENCES DUMBO.D7_TAREAS (TAR_SIS_COD,TAR_COD),
  CONSTRAINT FK_TAREAS_VINC_TAREAS2 FOREIGN KEY (TVI_SIS_COD, TVI_VINC_TAR_COD) 
    REFERENCES DUMBO.D7_TAREAS (TAR_SIS_COD,TAR_COD)
)
TABLESPACE DUMBO
PCTUSED    40
PCTFREE    10
INITRANS   1
MAXTRANS   255
STORAGE    (
            INITIAL          40K
            NEXT             40K
            MINEXTENTS       1
            MAXEXTENTS       505
            PCTINCREASE      50
            FREELISTS        1
            FREELIST GROUPS  1
            BUFFER_POOL      DEFAULT
           )
LOGGING 
NOCACHE
NOPARALLEL;

COMMENT ON TABLE DUMBO.D7_TAREAS_VINCULADAS IS 'Tabla que recoge informacin especfica de las tareas programadas';

COMMENT ON COLUMN DUMBO.D7_TAREAS_VINCULADAS.TVI_TAR_COD IS 'Cdigo identificativo de la tarea problema';

COMMENT ON COLUMN DUMBO.D7_TAREAS_VINCULADAS.TVI_VINC_TAR_COD IS 'Cdigo identificativo de la tarea vinculada al problema';

GRANT DELETE, INSERT, SELECT, UPDATE ON  DUMBO.D7_TAREAS_VINCULADAS TO JV_DUMBO;
