PROMPT -- CREO TABLA D7_USUARIOS_GRUPOS --;
CREATE TABLE DUMBO.D7_USUARIOS_GRUPOS
(
  UGR_SIS_COD  VARCHAR2(3 BYTE)                 NOT NULL,
  UGR_GRU_COD  VARCHAR2(10 BYTE)                NOT NULL,
  UGR_USU_COD  VARCHAR2(8 BYTE)                 NOT NULL,
  CONSTRAINT PK_D7_USUARIOS_GRUPOS PRIMARY KEY (UGR_SIS_COD, UGR_USU_COD)
    USING INDEX 
    TABLESPACE DUMBO
    PCTFREE    10
    INITRANS   2
    MAXTRANS   255
    STORAGE    (
                INITIAL          40K
                NEXT             40K
                MINEXTENTS       1
                MAXEXTENTS       505
                PCTINCREASE      50
                FREELISTS        1
                FREELIST GROUPS  1
               ),
  CONSTRAINT FK_USUARIOS_GRU_GRUPOS_USU FOREIGN KEY (UGR_SIS_COD, UGR_GRU_COD) 
    REFERENCES DUMBO.D7_GRUPOS_USUARIOS (GRU_SIS_COD,GRU_COD)
)
TABLESPACE DUMBO
PCTUSED    40
PCTFREE    10
INITRANS   1
MAXTRANS   255
STORAGE    (
            INITIAL          40K
            NEXT             40K
            MINEXTENTS       1
            MAXEXTENTS       505
            PCTINCREASE      50
            FREELISTS        1
            FREELIST GROUPS  1
            BUFFER_POOL      DEFAULT
           )
LOGGING 
NOCACHE
NOPARALLEL;

COMMENT ON TABLE DUMBO.D7_USUARIOS_GRUPOS IS 'Tabla que recoge los usuarios que componen un grupo de usuarios';

COMMENT ON COLUMN DUMBO.D7_USUARIOS_GRUPOS.UGR_GRU_COD IS 'Cdigo identificativo del grupo de usuarios';

COMMENT ON COLUMN DUMBO.D7_USUARIOS_GRUPOS.UGR_USU_COD IS 'Cdigo identificativo del usuario';

GRANT DELETE, INSERT, SELECT, UPDATE ON  DUMBO.D7_USUARIOS_GRUPOS TO JV_DUMBO;
