PROMPT -- CREO TABLA D7_USUARIOS_NOTIFICACIONES --;
CREATE TABLE DUMBO.D7_USUARIOS_NOTIFICACIONES
(
  UNO_SIS_COD VARCHAR2(3 BYTE)                   NOT NULL,
  UNO_USER    VARCHAR2(240 BYTE)                 NOT NULL,
  UNO_FECHA   DATE                               NOT NULL,
  CONSTRAINT PK_USUARIOS_NOTIF PRIMARY KEY (UNO_SIS_COD,UNO_USER)
    USING INDEX 
    TABLESPACE DUMBO
    PCTFREE    10
    INITRANS   2
    MAXTRANS   255
    STORAGE    (
                INITIAL          40K
                NEXT             40K
                MINEXTENTS       1
                MAXEXTENTS       505
                PCTINCREASE      50
                FREELISTS        1
                FREELIST GROUPS  1
               ),
  CONSTRAINT FK_UNO_SISTEMAS FOREIGN KEY (UNO_SIS_COD) 
   REFERENCES DUMBO.D7_SISTEMAS (SIS_COD)
)
TABLESPACE DUMBO
PCTUSED    40
PCTFREE    10
INITRANS   1
MAXTRANS   255
STORAGE    (
            INITIAL          40K
            NEXT             40K
            MINEXTENTS       1
            MAXEXTENTS       505
            PCTINCREASE      50
            FREELISTS        1
            FREELIST GROUPS  1
            BUFFER_POOL      DEFAULT
           )
LOGGING 
NOCACHE
NOPARALLEL;

COMMENT ON TABLE DUMBO.D7_USUARIOS_NOTIFICACIONES IS 'Usuarios que no desean recibir notificaciones peridicas';

COMMENT ON COLUMN DUMBO.D7_USUARIOS_NOTIFICACIONES.UNO_USER IS 'Cdigo identificativo del usuario';

COMMENT ON COLUMN DUMBO.D7_USUARIOS_NOTIFICACIONES.UNO_FECHA IS 'fecha en la que se solicita dejar de recibir notificaciones';

GRANT DELETE, INSERT, SELECT, UPDATE ON  DUMBO.D7_USUARIOS_NOTIFICACIONES TO JV_DUMBO;
