PROMPT -- CREO TABLA D7_CLAVES_NOTIFICACIONES --;
CREATE TABLE DUMBO.D7_CLAVES_NOTIFICACIONES 
( 
  CLN_CADENA     VARCHAR2 (25)  NOT NULL, 
  CLN_SIS_COD    VARCHAR2 (3)  NOT NULL, 
  CLN_TAR_COD    NUMBER (8)  NOT NULL, 
  CLN_FECHA      DATE  NOT NULL, 
  CLN_OPERACION  VARCHAR2 (100)  NOT NULL,
  CONSTRAINT PK_CLV_NOTIF PRIMARY KEY (CLN_CADENA)
    USING INDEX 
    TABLESPACE DUMBO
    PCTFREE    10
    INITRANS   2
    MAXTRANS   255
    STORAGE    (
                INITIAL          40K
                NEXT             40K
                MINEXTENTS       1
                MAXEXTENTS       505
                PCTINCREASE      50
                FREELISTS        1
                FREELIST GROUPS  1
               ),
  CONSTRAINT FK_CLV_NOTIF_SISTEMAS FOREIGN KEY (CLN_SIS_COD) 
   REFERENCES DUMBO.D7_SISTEMAS (SIS_COD))
TABLESPACE DUMBO
PCTUSED    40
PCTFREE    10
INITRANS   1
MAXTRANS   255
STORAGE    (
            INITIAL          40K
            NEXT             40K
            MINEXTENTS       1
            MAXEXTENTS       505
            PCTINCREASE      50
            FREELISTS        1
            FREELIST GROUPS  1
            BUFFER_POOL      DEFAULT
           )
LOGGING 
NOCACHE
NOPARALLEL;
 
COMMENT ON TABLE DUMBO.D7_CLAVES_NOTIFICACIONES IS 'Tabla para acceso directo desde email.';

COMMENT ON COLUMN DUMBO.D7_CLAVES_NOTIFICACIONES.CLN_SIS_COD IS 'Cdigo identificativo del sistema';

COMMENT ON COLUMN DUMBO.D7_CLAVES_NOTIFICACIONES.CLN_TAR_COD IS 'Cdigo identificativo de la tarea';

COMMENT ON COLUMN DUMBO.D7_CLAVES_NOTIFICACIONES.CLN_CADENA IS 'Cadena aleatoria para acceso y clave primaria';

COMMENT ON COLUMN DUMBO.D7_CLAVES_NOTIFICACIONES.CLN_FECHA IS 'Fecha del enlace de acceso valido 15 dias';

COMMENT ON COLUMN DUMBO.D7_CLAVES_NOTIFICACIONES.CLN_OPERACION IS 'Operacion a realizar';

GRANT DELETE, INSERT, SELECT, UPDATE ON  DUMBO.D7_CLAVES_NOTIFICACIONES TO JV_DUMBO;
