PROMPT -- CREO TABLA D7_PLANTILLAS_NOTIFICACIONES --;
CREATE TABLE DUMBO.D7_PLANTILLAS_NOTIFICACIONES
(
  PLN_SIS_COD    VARCHAR2(3 BYTE)               NOT NULL,
  PLN_NOMBRE     VARCHAR2(30 BYTE)               NOT NULL,
  PLN_TEXTO      VARCHAR2(4000 BYTE)              NOT NULL,
  CONSTRAINT PK_PLN_NOTIF PRIMARY KEY (PLN_SIS_COD, PLN_NOMBRE)
    USING INDEX 
    TABLESPACE DUMBO
    PCTFREE    10
    INITRANS   2
    MAXTRANS   255
    STORAGE    (
                INITIAL          40K
                NEXT             40K
                MINEXTENTS       1
                MAXEXTENTS       505
                PCTINCREASE      50
                FREELISTS        1
                FREELIST GROUPS  1
               ),
  CONSTRAINT FK_PLN_NOTIF_SISTEMAS FOREIGN KEY (PLN_SIS_COD) 
    REFERENCES DUMBO.D7_SISTEMAS (SIS_COD)
)
TABLESPACE DUMBO
PCTUSED    40
PCTFREE    10
INITRANS   1
MAXTRANS   255
STORAGE    (
            INITIAL          40K
            NEXT             40K
            MINEXTENTS       1
            MAXEXTENTS       505
            PCTINCREASE      50
            FREELISTS        1
            FREELIST GROUPS  1
            BUFFER_POOL      DEFAULT
           )
LOGGING 
NOCACHE
NOPARALLEL;

COMMENT ON TABLE DUMBO.D7_PLANTILLAS_NOTIFICACIONES IS 'Tabla para almacenar las plantillas email.';

COMMENT ON COLUMN DUMBO.D7_PLANTILLAS_NOTIFICACIONES.PLN_SIS_COD IS 'Cdigo identificativo del sistema';

COMMENT ON COLUMN DUMBO.D7_PLANTILLAS_NOTIFICACIONES.PLN_NOMBRE IS 'Nombre Plantilla';

COMMENT ON COLUMN DUMBO.D7_PLANTILLAS_NOTIFICACIONES.PLN_TEXTO IS 'Contenido de la plantilla';

GRANT DELETE, INSERT, SELECT, UPDATE ON  DUMBO.D7_PLANTILLAS_NOTIFICACIONES TO JV_DUMBO;

