PROMPT -- CREO TABLA D7_ERRORES_ALERTAS --;
CREATE TABLE DUMBO.D7_ERRORES_ALERTAS 
( 
  ERR_SIS_COD  VARCHAR2 (3)  NOT NULL, 
  ERR_TAR_COD  NUMBER (5)    NOT NULL, 
  ERR_NIVEL    VARCHAR2 (1)  NOT NULL, 
  ERR_TEXTO    VARCHAR2 (4000), 
  ERR_FEC      DATE          NOT NULL, 
  CONSTRAINT PK_ERRORES_ALERTAS
  PRIMARY KEY ( ERR_SIS_COD, ERR_TAR_COD, ERR_NIVEL, ERR_FEC ) 
    USING INDEX 
     TABLESPACE INDDUMBO PCTFREE 10
     STORAGE ( INITIAL 40K NEXT 40K PCTINCREASE 50 )) 
 TABLESPACE DUMBO
   PCTFREE 10   PCTUSED 40
   INITRANS 1   MAXTRANS 255
 STORAGE ( 
   INITIAL 10K NEXT 10K PCTINCREASE 50
   MINEXTENTS 1 MAXEXTENTS 121 )
   NOCACHE; 

COMMENT ON TABLE DUMBO.D7_ERRORES_ALERTAS IS 'Tabla para almacenar los errores del job de generacin de alertas';

COMMENT ON COLUMN DUMBO.D7_ERRORES_ALERTAS.ERR_TAR_COD IS 'Tarea en la que se genera el error';

COMMENT ON COLUMN DUMBO.D7_ERRORES_ALERTAS.ERR_NIVEL IS 'Nivel de alerta generada';

COMMENT ON COLUMN DUMBO.D7_ERRORES_ALERTAS.ERR_TEXTO IS 'Info del error';

COMMENT ON COLUMN DUMBO.D7_ERRORES_ALERTAS.ERR_FEC IS 'Fecha del error';

GRANT DELETE, INSERT, SELECT, UPDATE ON  DUMBO.D7_ERRORES_ALERTAS TO JV_DUMBO;
