PROMPT -- CREO TABLA D7_ALIAS_CORREO --;
CREATE TABLE DUMBO.D7_ALIAS_CORREO
(
  ALIAS_SIS_COD  VARCHAR2(3 BYTE)               NOT NULL,
  ALIAS_CORREO   VARCHAR2(80 BYTE)              NOT NULL,
  ALIAS_DNI      VARCHAR2(10 BYTE)              NOT NULL,
  CONSTRAINT PK_ALIAS_CORREO PRIMARY KEY (ALIAS_SIS_COD, ALIAS_CORREO)
    USING INDEX 
    TABLESPACE DUMBO
    PCTFREE    10
    INITRANS   2
    MAXTRANS   255
    STORAGE    (
                INITIAL          40K
                NEXT             40K
                MINEXTENTS       1
                MAXEXTENTS       505
                PCTINCREASE      50
                FREELISTS        1
                FREELIST GROUPS  1
               ),
  CONSTRAINT FK_ALIAS_CORREO_SISTEMAS FOREIGN KEY (ALIAS_SIS_COD) 
    REFERENCES DUMBO.D7_SISTEMAS (SIS_COD)
)
TABLESPACE DUMBO
PCTUSED    40
PCTFREE    10
INITRANS   1
MAXTRANS   255
STORAGE    (
            INITIAL          40K
            NEXT             40K
            MINEXTENTS       1
            MAXEXTENTS       505
            PCTINCREASE      50
            FREELISTS        1
            FREELIST GROUPS  1
            BUFFER_POOL      DEFAULT
           )
LOGGING 
NOCACHE
NOPARALLEL;

COMMENT ON TABLE DUMBO.D7_ALIAS_CORREO IS 'Almacena alias para cuentas de correo de uso comn, evita conocer la cuenta de una persona, basta con conocer el alias del puesto';

COMMENT ON COLUMN DUMBO.D7_ALIAS_CORREO.ALIAS_CORREO IS 'Alias de correo';

COMMENT ON COLUMN DUMBO.D7_ALIAS_CORREO.ALIAS_DNI IS 'Dni del usuario asociado al alias';

GRANT DELETE, INSERT, SELECT, UPDATE ON  DUMBO.D7_ALIAS_CORREO TO JV_DUMBO;
