PROMPT -- CREO TABLA D7_ZONAS --;
CREATE TABLE DUMBO.D7_ZONAS
(
  ZON_SIS_COD      VARCHAR2(3 BYTE)             NOT NULL,
  ZON_CODIGO       VARCHAR2(3 BYTE)             NOT NULL,
  ZON_DESCRIPCION  VARCHAR2(80 BYTE)            NOT NULL,
  CONSTRAINT PK_ZONAS PRIMARY KEY (ZON_SIS_COD, ZON_CODIGO)
    USING INDEX 
    TABLESPACE INDDUMBO
    PCTFREE    10
    INITRANS   2
    MAXTRANS   255
    STORAGE    (
                INITIAL          40K
                NEXT             40K
                MINEXTENTS       1
                MAXEXTENTS       505
                PCTINCREASE      50
                FREELISTS        1
                FREELIST GROUPS  1
               )
)
TABLESPACE DUMBO
PCTUSED    40
PCTFREE    10
INITRANS   1
MAXTRANS   255
STORAGE    (
            INITIAL          40K
            NEXT             40K
            MINEXTENTS       1
            MAXEXTENTS       505
            PCTINCREASE      50
            FREELISTS        1
            FREELIST GROUPS  1
            BUFFER_POOL      DEFAULT
           )
LOGGING 
NOCACHE
NOPARALLEL;

COMMENT ON TABLE DUMBO.D7_ZONAS IS 'Zonas para asignar tareas por ubicacin';

COMMENT ON COLUMN DUMBO.D7_ZONAS.ZON_CODIGO IS 'Cdigo de la Zona';

COMMENT ON COLUMN DUMBO.D7_ZONAS.ZON_DESCRIPCION IS 'Descripcin de la Zona';

GRANT DELETE, INSERT, SELECT, UPDATE ON  DUMBO.D7_ZONAS TO JV_DUMBO;
