PROMPT -- CREO TABLA D7_ZONAS_EDIFICIOS --;
CREATE TABLE DUMBO.D7_ZONAS_EDIFICIOS
(
  ZONED_SIS_COD     VARCHAR2(3 BYTE)            NOT NULL,
  ZONED_ZON_CODIGO  VARCHAR2(3 BYTE)            NOT NULL,
  ZONED_ED_CODIGO   VARCHAR2(3 BYTE)            NOT NULL,
  CONSTRAINT PK_ZONAS_EDIFICIOS PRIMARY KEY (ZONED_SIS_COD, ZONED_ZON_CODIGO, ZONED_ED_CODIGO)
    USING INDEX 
    TABLESPACE INDDUMBO
    PCTFREE    10
    INITRANS   2
    MAXTRANS   255
    STORAGE    (
                INITIAL          40K
                NEXT             40K
                MINEXTENTS       1
                MAXEXTENTS       505
                PCTINCREASE      50
                FREELISTS        1
                FREELIST GROUPS  1
               ),
  CONSTRAINT FK_ZONED_ZON FOREIGN KEY (ZONED_SIS_COD, ZONED_ZON_CODIGO) 
    REFERENCES DUMBO.D7_ZONAS (ZON_SIS_COD,ZON_CODIGO)
)
TABLESPACE DUMBO
PCTUSED    40
PCTFREE    10
INITRANS   1
MAXTRANS   255
STORAGE    (
            INITIAL          40K
            NEXT             40K
            MINEXTENTS       1
            MAXEXTENTS       505
            PCTINCREASE      50
            FREELISTS        1
            FREELIST GROUPS  1
            BUFFER_POOL      DEFAULT
           )
LOGGING 
NOCACHE
NOPARALLEL;

COMMENT ON TABLE DUMBO.D7_ZONAS_EDIFICIOS IS 'Edificios asignados a cada una de las zonas';

COMMENT ON COLUMN DUMBO.D7_ZONAS_EDIFICIOS.ZONED_ZON_CODIGO IS 'Cdigo de la Zona';

COMMENT ON COLUMN DUMBO.D7_ZONAS_EDIFICIOS.ZONED_ED_CODIGO IS 'Cdigo del edificio';

GRANT DELETE, INSERT, SELECT, UPDATE ON  DUMBO.D7_ZONAS_EDIFICIOS TO JV_DUMBO;
