PROMPT -- CREO TABLA D7_ZONAS_INFORMATICOS --;
CREATE TABLE DUMBO.D7_ZONAS_INFORMATICOS
(
  ZONINF_SIS_COD     VARCHAR2(3 BYTE)           NOT NULL,
  ZONINF_ZON_CODIGO  VARCHAR2(3 BYTE)           NOT NULL,
  ZONINF_INF_COD     VARCHAR2(8 BYTE)           NOT NULL,
  ZONINF_RESPONSABLE  VARCHAR2(1 BYTE),
  ZONINF_PRIORIDAD    NUMBER(2),
  CONSTRAINT PK_ZONAS_INFORMATICOS PRIMARY KEY (ZONINF_SIS_COD, ZONINF_ZON_CODIGO, ZONINF_INF_COD)
    USING INDEX 
    TABLESPACE INDDUMBO
    PCTFREE    10
    INITRANS   2
    MAXTRANS   255
    STORAGE    (
                INITIAL          40K
                NEXT             40K
                MINEXTENTS       1
                MAXEXTENTS       505
                PCTINCREASE      50
                FREELISTS        1
                FREELIST GROUPS  1
               ),
  CONSTRAINT FK_ZONINF_ZON FOREIGN KEY (ZONINF_SIS_COD, ZONINF_ZON_CODIGO) 
    REFERENCES DUMBO.D7_ZONAS (ZON_SIS_COD,ZON_CODIGO)
)
TABLESPACE DUMBO
PCTUSED    40
PCTFREE    10
INITRANS   1
MAXTRANS   255
STORAGE    (
            INITIAL          40K
            NEXT             40K
            MINEXTENTS       1
            MAXEXTENTS       505
            PCTINCREASE      50
            FREELISTS        1
            FREELIST GROUPS  1
            BUFFER_POOL      DEFAULT
           )
LOGGING 
NOCACHE
NOPARALLEL;

COMMENT ON TABLE DUMBO.D7_ZONAS_INFORMATICOS IS 'Informaticos asignados a cada una de las zonas';

COMMENT ON COLUMN DUMBO.D7_ZONAS_INFORMATICOS.ZONINF_ZON_CODIGO IS 'Cdigo de la Zona';

COMMENT ON COLUMN DUMBO.D7_ZONAS_INFORMATICOS.ZONINF_INF_COD IS 'Cdigo del informatico';

COMMENT ON COLUMN DUMBO.D7_ZONAS_INFORMATICOS.ZONINF_RESPONSABLE IS 'Indica si es responsable de la zona';

COMMENT ON COLUMN DUMBO.D7_ZONAS_INFORMATICOS.ZONINF_PRIORIDAD IS 'Indica el orden de prioridad para asignar tareas';

GRANT DELETE, INSERT, SELECT, UPDATE ON  DUMBO.D7_ZONAS_INFORMATICOS TO JV_DUMBO;
