PROMPT -- CREO TABLA D7_PLANTILLAS --;
CREATE TABLE DUMBO.D7_PLANTILLAS
(
	PLA_SIS_COD 		VARCHAR2(3) 	NOT NULL,
	PLA_COD 			NUMBER(3) 		NOT NULL,
	PLA_TITULO 			VARCHAR2(240) 	NOT NULL,
 	PLA_IND_INTERNA 	VARCHAR2(1) 	NOT NULL,
 	PLA_IND_SOLDUMBO 	VARCHAR2(1) 	NOT NULL,
	PLA_ESTADO 			VARCHAR2(1) 	NOT NULL,
	PLA_APL_COD 		VARCHAR2(10),
	PLA_URL_EXTERNA 	VARCHAR2(240),
	CONSTRAINT AVCON_973460_PLA_I_000 CHECK (PLA_IND_INTERNA IN ('E', 'I')),
	CONSTRAINT PK_D7_PLANTILLAS PRIMARY KEY (PLA_SIS_COD, PLA_COD)
    USING INDEX 
    TABLESPACE DUMBO
    PCTFREE    10
    INITRANS   2
    MAXTRANS   255
    STORAGE    (
                INITIAL          40K
                NEXT             40K
                MINEXTENTS       1
                MAXEXTENTS       505
                PCTINCREASE      50
                FREELISTS        1
                FREELIST GROUPS  1
               ),
  CONSTRAINT FK_PLANTILLAS_SISTEMAS FOREIGN KEY (PLA_SIS_COD) 
    REFERENCES DUMBO.D7_SISTEMAS (SIS_COD),
  CONSTRAINT FK_PLANTILLAS_APLICACIONES FOREIGN KEY (PLA_SIS_COD, PLA_APL_COD) 
    REFERENCES DUMBO.D7_APLICACIONES (APL_SIS_COD,APL_COD)
)
TABLESPACE DUMBO
PCTUSED    40
PCTFREE    10
INITRANS   1
MAXTRANS   255
STORAGE    (
            INITIAL          40K
            NEXT             40K
            MINEXTENTS       1
            MAXEXTENTS       505
            PCTINCREASE      50
            FREELISTS        1
            FREELIST GROUPS  1
            BUFFER_POOL      DEFAULT
           )
LOGGING 
NOCACHE
NOPARALLEL;

COMMENT ON TABLE D7_PLANTILLAS IS 'Tabla que recoge las plantillas de solicitud vinculadas a un sistema de DUMBO'

COMMENT ON COLUMN D7_PLANTILLAS.PLA_SIS_COD IS 'Cdigo identificativo de sistema'

COMMENT ON COLUMN D7_PLANTILLAS.PLA_COD IS 'cdigo identificativo de plantilla'

COMMENT ON COLUMN D7_PLANTILLAS.PLA_TITULO IS 'ttulo de la plantilla'

COMMENT ON COLUMN D7_PLANTILLAS.PLA_IND_INTERNA IS 'indicador de si la plantilla es interna (generado por dumbo) o externa (se llama a una url que recoge la plantilla)'

COMMENT ON COLUMN D7_PLANTILLAS.PLA_IND_SOLDUMBO IS 'Indicador que marca si la plantilla debe aparecer cimi servicio especfico dentro del formulario inicial de solicitud de tarea en dumbo'

COMMENT ON COLUMN D7_PLANTILLAS.PLA_ESTADO IS 'estado de vigencia de la plantilla'

COMMENT ON COLUMN D7_PLANTILLAS.PLA_APL_COD IS 'cdigo identificativo de la aplicacin a la que est vinculada el dumbo'

COMMENT ON COLUMN D7_PLANTILLAS.PLA_URL_EXTERNA IS 'tabla que recoge la url correspondiente a la plantilla de caracter externo'

GRANT DELETE, INSERT, SELECT, UPDATE ON  DUMBO.D7_PLANTILLAS TO JV_DUMBO;
