PROMPT -- CREO TABLA D7_APLICACIONES_FAQS_GRUPOS --;
CREATE TABLE DUMBO.D7_APLICACIONES_FAQS_GRUPOS
(
  FGR_SIS_COD  VARCHAR2(3 BYTE)                 NOT NULL,
  FGR_APL_COD  VARCHAR2(10 BYTE)                NOT NULL,
  FGR_COD      NUMBER(3)                        NOT NULL,
  FGR_TEXTO    VARCHAR2(240 BYTE)               NOT NULL,
  FGR_ESTADO   VARCHAR2(1 BYTE)                 NOT NULL,
  FGR_ORDEN    NUMBER(3)                        NOT NULL,
  FGR_FGR_COD  NUMBER(3),
  CONSTRAINT PK_FAQGRUPOS PRIMARY KEY (FGR_SIS_COD, FGR_APL_COD, FGR_COD)
    USING INDEX 
    TABLESPACE DUMBO
    PCTFREE    10
    INITRANS   2
    MAXTRANS   255
    STORAGE    (
                INITIAL          40K
                NEXT             40K
                MINEXTENTS       1
                MAXEXTENTS       505
                PCTINCREASE      50
                FREELISTS        1
                FREELIST GROUPS  1
               ),
  CONSTRAINT FK_FAQGRUPOS_APLICAC FOREIGN KEY (FGR_SIS_COD, FGR_APL_COD) 
    REFERENCES DUMBO.D7_APLICACIONES (APL_SIS_COD,APL_COD)
)
TABLESPACE DUMBO
PCTUSED    40
PCTFREE    10
INITRANS   1
MAXTRANS   255
STORAGE    (
            INITIAL          40K
            NEXT             40K
            MINEXTENTS       1
            MAXEXTENTS       505
            PCTINCREASE      50
            FREELISTS        1
            FREELIST GROUPS  1
            BUFFER_POOL      DEFAULT
           )
LOGGING 
NOCACHE
NOPARALLEL;

COMMENT ON TABLE DUMBO.D7_APLICACIONES_FAQS_GRUPOS IS 'TABLA QUE RECOGE LOS APARTADOS EN LOS QUE ESTN AGRUPADOS LAS FAQS DE UNA APLICACIN';

COMMENT ON COLUMN DUMBO.D7_APLICACIONES_FAQS_GRUPOS.FGR_SIS_COD IS 'CDIGO IDENTIFICATIVO DEL SISTEMA';

COMMENT ON COLUMN DUMBO.D7_APLICACIONES_FAQS_GRUPOS.FGR_APL_COD IS 'CDIGO IDENTIFICATIVO DE LA APLICACIN';

COMMENT ON COLUMN DUMBO.D7_APLICACIONES_FAQS_GRUPOS.FGR_COD IS 'CDIGO IDENTIFICATIVO DEL APARTADO DE AGRUPACIN DE FAQS';

COMMENT ON COLUMN DUMBO.D7_APLICACIONES_FAQS_GRUPOS.FGR_TEXTO IS 'TEXTO DEL APARTADO DE AGRUPACIN DE FAQS';

COMMENT ON COLUMN DUMBO.D7_APLICACIONES_FAQS_GRUPOS.FGR_ESTADO IS 'ESTADO DE VIGENCIA EN EL SISTEMA';

COMMENT ON COLUMN DUMBO.D7_APLICACIONES_FAQS_GRUPOS.FGR_ORDEN IS 'ORDEN EN QUE DEBEN APARECER LOS APARTADOS';

COMMENT ON COLUMN DUMBO.D7_APLICACIONES_FAQS_GRUPOS.FGR_FGR_COD IS 'CDIGO DE APARTADO PADRE';

GRANT DELETE, INSERT, SELECT, UPDATE ON  DUMBO.D7_APLICACIONES_FAQS_GRUPOS TO JV_DUMBO;

