PROMPT -- CREO TABLA D7_APLICACIONES_FAQS --;
CREATE TABLE DUMBO.D7_APLICACIONES_FAQS
(
  FAQ_SIS_COD   VARCHAR2(3 BYTE)                NOT NULL,
  FAQ_COD       NUMBER(5)                       NOT NULL,
  FAQ_APL_COD   VARCHAR2(10 BYTE)               NOT NULL,
  FAQ_ASUNTO    VARCHAR2(240 BYTE)              NOT NULL,
  FAQ_TEXTO     VARCHAR2(4000 BYTE)             NOT NULL,
  FAQ_ESTADO    VARCHAR2(1 BYTE)                NOT NULL,
  FAQ_FECALTA   DATE                            NOT NULL,
  FAQ_USERALTA  VARCHAR2(8 BYTE)                NOT NULL,
  FAQ_ORDEN     NUMBER(5),
  FAQ_FGR_COD   NUMBER(3)                       NOT NULL,
  CONSTRAINT PK_APLFAQS PRIMARY KEY (FAQ_SIS_COD, FAQ_APL_COD, FAQ_COD)
    USING INDEX 
    TABLESPACE DUMBO
    PCTFREE    10
    INITRANS   2
    MAXTRANS   255
    STORAGE    (
                INITIAL          40K
                NEXT             40K
                MINEXTENTS       1
                MAXEXTENTS       505
                PCTINCREASE      50
                FREELISTS        1
                FREELIST GROUPS  1
               ),
  CONSTRAINT FK_APLFAQS_APLICAC FOREIGN KEY (FAQ_SIS_COD, FAQ_APL_COD) 
    REFERENCES DUMBO.D7_APLICACIONES (APL_SIS_COD,APL_COD),
  CONSTRAINT FK_APLFAQS_FAQGRUPOS FOREIGN KEY (FAQ_SIS_COD, FAQ_APL_COD, FAQ_FGR_COD) 
    REFERENCES DUMBO.D7_APLICACIONES_FAQS_GRUPOS (FGR_SIS_COD,FGR_APL_COD,FGR_COD),
  CONSTRAINT FK_APLFAQS_INFORMAT FOREIGN KEY (FAQ_SIS_COD, FAQ_USERALTA) 
    REFERENCES DUMBO.D7_INFORMATICOS (INF_SIS_COD,INF_COD)
)
TABLESPACE DUMBO
PCTUSED    40
PCTFREE    10
INITRANS   1
MAXTRANS   255
STORAGE    (
            INITIAL          40K
            NEXT             40K
            MINEXTENTS       1
            MAXEXTENTS       505
            PCTINCREASE      50
            FREELISTS        1
            FREELIST GROUPS  1
            BUFFER_POOL      DEFAULT
           )
LOGGING 
NOCACHE
NOPARALLEL;

COMMENT ON TABLE DUMBO.D7_APLICACIONES_FAQS IS 'TABLA QUE RECOGE LAS FAQS VINCULADAS A UNA APLICACIN';

COMMENT ON COLUMN DUMBO.D7_APLICACIONES_FAQS.FAQ_SIS_COD IS 'CDIGO IDENTIFICATIVO DE SISTEMA';

COMMENT ON COLUMN DUMBO.D7_APLICACIONES_FAQS.FAQ_COD IS 'CDIGO IDENTIFICATIVO DE FAQ';

COMMENT ON COLUMN DUMBO.D7_APLICACIONES_FAQS.FAQ_APL_COD IS 'CDIGO IDENTIFICATIVO DE APLICACIN';

COMMENT ON COLUMN DUMBO.D7_APLICACIONES_FAQS.FAQ_ASUNTO IS 'ASUNTO DE LA FAQ';

COMMENT ON COLUMN DUMBO.D7_APLICACIONES_FAQS.FAQ_TEXTO IS 'TEXTO INFORMATIVO DE LA FAQ';

COMMENT ON COLUMN DUMBO.D7_APLICACIONES_FAQS.FAQ_ESTADO IS 'ESTADO DE VIGENCIA DE LA FAQ';

COMMENT ON COLUMN DUMBO.D7_APLICACIONES_FAQS.FAQ_FECALTA IS 'FECHA EN QUE SE HA DADO DE ALTA LA FAQ';

COMMENT ON COLUMN DUMBO.D7_APLICACIONES_FAQS.FAQ_USERALTA IS 'TCNICO QUE HA DADO DE ALTA LA FAQ';

COMMENT ON COLUMN DUMBO.D7_APLICACIONES_FAQS.FAQ_ORDEN IS 'ORDEN EN QUE DEBE APARECER LA FAQ';

COMMENT ON COLUMN DUMBO.D7_APLICACIONES_FAQS.FAQ_FGR_COD IS 'CDIGO DEL APARTADO EN QUE SE DEBE ENGLOBAR LA FAQ';

GRANT DELETE, INSERT, SELECT, UPDATE ON  DUMBO.D7_APLICACIONES_FAQS TO JV_DUMBO;
