PROMPT -- CREO TABLA D7_SECCIONES_APART_FICHAS --;
CREATE TABLE DUMBO.D7_SECCIONES_APART_FICHAS
(
  APF_SEC_COD          VARCHAR2(10 BYTE)        NOT NULL,
  APF_SIS_COD          VARCHAR2(3 BYTE)         NOT NULL,
  APF_COD              NUMBER(2)                NOT NULL,
  APF_ETIQUETA         VARCHAR2(100 BYTE)       NOT NULL,
  APF_IND_OBLIGATORIO  VARCHAR2(1 BYTE)         NOT NULL,
  APF_ORDEN            NUMBER(2)                NOT NULL,
  CONSTRAINT PK_APARFICHAS PRIMARY KEY (APF_SIS_COD, APF_SEC_COD, APF_COD)
    USING INDEX 
    TABLESPACE DUMBO
    PCTFREE    10
    INITRANS   2
    MAXTRANS   255
    STORAGE    (
                INITIAL          40K
                NEXT             40K
                MINEXTENTS       1
                MAXEXTENTS       505
                PCTINCREASE      50
                FREELISTS        1
                FREELIST GROUPS  1
               ),
  CONSTRAINT FK_APARFICHAS_D7_SECCIONES FOREIGN KEY (APF_SIS_COD, APF_SEC_COD) 
    REFERENCES DUMBO.D7_SECCIONES (SEC_SIS_COD,SEC_COD)
)
TABLESPACE DUMBO
PCTUSED    40
PCTFREE    10
INITRANS   1
MAXTRANS   255
STORAGE    (
            INITIAL          40K
            NEXT             40K
            MINEXTENTS       1
            MAXEXTENTS       505
            PCTINCREASE      50
            FREELISTS        1
            FREELIST GROUPS  1
            BUFFER_POOL      DEFAULT
           )
LOGGING 
NOCACHE
NOPARALLEL;

COMMENT ON TABLE DUMBO.D7_SECCIONES_APART_FICHAS IS 'tabla que recoge segn seccin los apartados que componen las fichas informativas de las aplicaciones vinculadas a las mismas';

COMMENT ON COLUMN DUMBO.D7_SECCIONES_APART_FICHAS.APF_SEC_COD IS 'cdigo identificativo de seccin';

COMMENT ON COLUMN DUMBO.D7_SECCIONES_APART_FICHAS.APF_SIS_COD IS 'cdigo identificativo del sistema al que esta vinculada la seccin';

COMMENT ON COLUMN DUMBO.D7_SECCIONES_APART_FICHAS.APF_COD IS 'cdigo identificativo de apartado';

COMMENT ON COLUMN DUMBO.D7_SECCIONES_APART_FICHAS.APF_ETIQUETA IS 'etiqueta que describe el apartado';

COMMENT ON COLUMN DUMBO.D7_SECCIONES_APART_FICHAS.APF_IND_OBLIGATORIO IS 'indicador de si el apartado es de cumplimentacin obligatoria o no';

COMMENT ON COLUMN DUMBO.D7_SECCIONES_APART_FICHAS.APF_ORDEN IS 'orden en que se debe mostrar el apartado dentro de la ficha';

GRANT DELETE, INSERT, SELECT, UPDATE ON  DUMBO.D7_SECCIONES_APART_FICHAS TO JV_DUMBO;
