PROMPT -- CREA TABLA D7_APLICACIONES_FICHAS --;
CREATE TABLE DUMBO.D7_APLICACIONES_FICHAS
(
  FIC_SIS_COD       VARCHAR2(3 BYTE)            NOT NULL,
  FIC_APL_COD       VARCHAR2(10 BYTE)           NOT NULL,
  FIC_APF_COD       NUMBER(2)                   NOT NULL,
  FIC_APF_TEXTO     VARCHAR2(4000 BYTE)         NOT NULL,
  FIC_SEC_COD       VARCHAR2(10 BYTE)           NOT NULL,
  FIC_FECACTUALIZA  DATE                        NOT NULL,
  CONSTRAINT FK_APLFICHAS PRIMARY KEY (FIC_SIS_COD, FIC_APL_COD, FIC_APF_COD)
    USING INDEX 
    TABLESPACE DUMBO
    PCTFREE    10
    INITRANS   2
    MAXTRANS   255
    STORAGE    (
                INITIAL          40K
                NEXT             40K
                MINEXTENTS       1
                MAXEXTENTS       505
                PCTINCREASE      50
                FREELISTS        1
                FREELIST GROUPS  1
               ),
  CONSTRAINT FK_APLFICHAS_APARFICHAS FOREIGN KEY (FIC_SIS_COD, FIC_SEC_COD, FIC_APF_COD) 
    REFERENCES DUMBO.D7_SECCIONES_APART_FICHAS (APF_SIS_COD,APF_SEC_COD,APF_COD),
  CONSTRAINT FK_APLFICHAS_APLICACIONES FOREIGN KEY (FIC_SIS_COD, FIC_APL_COD) 
    REFERENCES DUMBO.D7_APLICACIONES (APL_SIS_COD,APL_COD)
)
TABLESPACE DUMBO
PCTUSED    40
PCTFREE    10
INITRANS   1
MAXTRANS   255
STORAGE    (
            INITIAL          40K
            NEXT             40K
            MINEXTENTS       1
            MAXEXTENTS       505
            PCTINCREASE      50
            FREELISTS        1
            FREELIST GROUPS  1
            BUFFER_POOL      DEFAULT
           )
LOGGING 
NOCACHE
NOPARALLEL;

COMMENT ON TABLE DUMBO.D7_APLICACIONES_FICHAS IS 'tabla que recoge las fichas informativas de cada aplicacin';

COMMENT ON COLUMN DUMBO.D7_APLICACIONES_FICHAS.FIC_SIS_COD IS 'cdigo de sistema';

COMMENT ON COLUMN DUMBO.D7_APLICACIONES_FICHAS.FIC_APL_COD IS 'cdigo identificativo de aplicacin';

COMMENT ON COLUMN DUMBO.D7_APLICACIONES_FICHAS.FIC_APF_COD IS 'cdigo identificativo de apartado';

COMMENT ON COLUMN DUMBO.D7_APLICACIONES_FICHAS.FIC_APF_TEXTO IS 'texto informativo del apartado';

COMMENT ON COLUMN DUMBO.D7_APLICACIONES_FICHAS.FIC_SEC_COD IS 'cdigo identificativo de seccin';

COMMENT ON COLUMN DUMBO.D7_APLICACIONES_FICHAS.FIC_FECACTUALIZA IS 'FECHA LTIMA ACTUALIZACIN';

GRANT DELETE, INSERT, SELECT, UPDATE ON  DUMBO.D7_APLICACIONES_FICHAS TO JV_DUMBO;
