PROMPT -- CREO TABLA D7_TURNOS --;
CREATE TABLE DUMBO.D7_TURNOS
(
  TUR_SIS_COD          VARCHAR2(3 BYTE)         NOT NULL,
  TUR_COD              NUMBER(3)                NOT NULL,
  TUR_HORAINI          DATE                     NOT NULL,
  TUR_HORAFIN          DATE                     NOT NULL,
  TUR_NUM_TECNICOS     NUMBER(2)                NOT NULL,
  TUR_ESTADO           VARCHAR2(1 BYTE)         NOT NULL,
  TUR_FECINI_VIGENCIA  DATE                     NOT NULL,
  TUR_FECFIN_VIGENCIA  DATE,
  CONSTRAINT CHK_TUR_ESTADO CHECK (tur_estado in ('V','N')),
  CONSTRAINT PK_TURNOS PRIMARY KEY (TUR_SIS_COD, TUR_COD)
    USING INDEX 
    TABLESPACE DUMBO
    PCTFREE    10
    INITRANS   2
    MAXTRANS   255
    STORAGE    (
                INITIAL          40K
                NEXT             40K
                MINEXTENTS       1
                MAXEXTENTS       505
                PCTINCREASE      50
                FREELISTS        1
                FREELIST GROUPS  1
               ),
  CONSTRAINT FK_TURNOS_SISTEMAS FOREIGN KEY (TUR_SIS_COD) 
    REFERENCES DUMBO.D7_SISTEMAS (SIS_COD)
)
TABLESPACE DUMBO
PCTUSED    40
PCTFREE    10
INITRANS   1
MAXTRANS   255
STORAGE    (
            INITIAL          40K
            NEXT             40K
            MINEXTENTS       1
            MAXEXTENTS       505
            PCTINCREASE      50
            FREELISTS        1
            FREELIST GROUPS  1
            BUFFER_POOL      DEFAULT
           )
LOGGING 
NOCACHE
NOPARALLEL;

COMMENT ON TABLE DUMBO.D7_TURNOS IS 'tabla que recoge los distintos turnos de OREJAS de un sistema';

COMMENT ON COLUMN DUMBO.D7_TURNOS.TUR_SIS_COD IS 'cdigo identificativo de un sistema';

COMMENT ON COLUMN DUMBO.D7_TURNOS.TUR_COD IS 'cdigo identificativo de turno';

COMMENT ON COLUMN DUMBO.D7_TURNOS.TUR_HORAINI IS 'hora inicio turno';

COMMENT ON COLUMN DUMBO.D7_TURNOS.TUR_HORAFIN IS 'hora fin turno';

COMMENT ON COLUMN DUMBO.D7_TURNOS.TUR_NUM_TECNICOS IS 'nmero de tcnicos que cubren un turno';

COMMENT ON COLUMN DUMBO.D7_TURNOS.TUR_ESTADO IS 'estado vigencia del turno(VIGENTE/NO VIGENTE)';

COMMENT ON COLUMN DUMBO.D7_TURNOS.TUR_FECINI_VIGENCIA IS 'Fecha inicio vigencia del turno';

COMMENT ON COLUMN DUMBO.D7_TURNOS.TUR_FECFIN_VIGENCIA IS 'fecha fin vigencia del turno';

GRANT DELETE, INSERT, SELECT, UPDATE ON  DUMBO.D7_TURNOS TO JV_DUMBO;
