PROMPT -- CREO TABLA D7_INFORMATICOS_VIGENCIA --;
CREATE TABLE DUMBO.D7_INFORMATICOS_VIGENCIA
(
  INFV_SIS_COD       VARCHAR2(3 BYTE)           NOT NULL,
  INFV_INF_COD       VARCHAR2(8 BYTE)           NOT NULL,
  INFV_FECHA_INICIO  DATE                       NOT NULL,
  INFV_FECHA_FIN     DATE,
  CONSTRAINT PK_INFORMATICOS_VIGENCIA PRIMARY KEY (INFV_SIS_COD, INFV_INF_COD, INFV_FECHA_INICIO)
    USING INDEX 
    TABLESPACE DUMBO
    PCTFREE    10
    INITRANS   2
    MAXTRANS   255
    STORAGE    (
                INITIAL          40K
                NEXT             40K
                MINEXTENTS       1
                MAXEXTENTS       505
                PCTINCREASE      50
                FREELISTS        1
                FREELIST GROUPS  1
               ),
  CONSTRAINT FK_INFORM_VIGENCIA_INFORM FOREIGN KEY (INFV_SIS_COD, INFV_INF_COD) 
    REFERENCES DUMBO.D7_INFORMATICOS (INF_SIS_COD,INF_COD),
  CONSTRAINT FK_INFORM_VIGENCIA_SISTEMAS FOREIGN KEY (INFV_SIS_COD) 
    REFERENCES DUMBO.D7_SISTEMAS (SIS_COD)
)
TABLESPACE DUMBO
PCTUSED    40
PCTFREE    10
INITRANS   1
MAXTRANS   255
STORAGE    (
            INITIAL          40K
            NEXT             40K
            MINEXTENTS       1
            MAXEXTENTS       505
            PCTINCREASE      50
            FREELISTS        1
            FREELIST GROUPS  1
            BUFFER_POOL      DEFAULT
           )
LOGGING 
NOCACHE
NOPARALLEL;

COMMENT ON TABLE DUMBO.D7_INFORMATICOS_VIGENCIA IS 'Tabla que recoge la fecha de vigencia de los distintos informaticos';

COMMENT ON COLUMN DUMBO.D7_INFORMATICOS_VIGENCIA.INFV_SIS_COD IS 'Cdigo identificativo de sistema';

COMMENT ON COLUMN DUMBO.D7_INFORMATICOS_VIGENCIA.INFV_INF_COD IS 'cdigo identificativo del informtico';

COMMENT ON COLUMN DUMBO.D7_INFORMATICOS_VIGENCIA.INFV_FECHA_INICIO IS 'fecha de inicio de vigencia';

COMMENT ON COLUMN DUMBO.D7_INFORMATICOS_VIGENCIA.INFV_FECHA_FIN IS 'fecha fin de vigencia';

GRANT DELETE, INSERT, SELECT, UPDATE ON  DUMBO.D7_INFORMATICOS_VIGENCIA TO JV_DUMBO;
