package dumbo7.administracion.aplicaciones;

import dumbo7.mano.Mejorativo;
import dumbo7.utils.*;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import dumbo7.utils.ldap.LDAPUser;
import dumbo7.utils.ldap.LDAPUtil;
import dumbo7.administracion.*;
import org.hibernate.*;
import org.hibernate.criterion.Expression;

import java.util.*;
import java.sql.*;
import java.io.UnsupportedEncodingException;
import java.math.BigDecimal;
import java.net.URLDecoder;

/**
 * @author Universidad de Murcia - ATICA
 *
 */

public class GestorAplicaciones extends GestorAdministracion {
	// Cdigo de Gestor de Grupo para todos los sistemas
	private static String codigoGestor = "11";
	protected List aplicaciones = null;
	protected List aplicacionesHijas = null;
	protected List secciones = null;
	protected List aplicacionesInformaticos = null;
	protected List aplicacionesInformaticosVigentes = null;
	protected List aplicacionesMaximos = null;
	protected List seccionesMaximos = null;
	protected List aplicacionesParametros = null;
	protected List informaticos = null;
	protected List prioridades = null;
	protected List tiposTareas = null;
	protected List Tareas = null;
	protected List datosPersonales = null;
	protected List subSecciones = null;
	private Integer numerodehijos;
	private Integer codigo;
	private D7Aplicaciones aplicacion = null;
	private String[] responsables = null;// contiene los informticos
											// (identificador) responsables de
											// la nueva aplicacin.
	private String[] TiposTar = null; // Variable para reconocer los tipos de
										// tarea para crear la tabla aplicacione
										// parametros
	private String[] Urgencias = null;
	private String[] Prioridades = null;
	private String[] priCod = null;
	private String[] ttarCod = null;
	private String[] maxdias = null;
	private String[] datos = null;// Datos usados por
									// ListaDatosPersonalesSeleccion
	private String[] restric = null;// Si vale 1 se restringe el listado de los
									// datosPersonales a solamente los
									// informticos que no estn asociados a la
									// aplicacin
	private String ResponsablesOp = null;// Si vale Traspasar, se traspasarn
											// los informticos (menos el de
											// mayor prioridad) de la aplicacin
											// padre a la hija
	// Si vale Eliminar, se eliminarn los informticos (menos el de mayor
	// prioridad) de la aplicacin padre.
	private Boolean tienehijos;
	private ApartadosFaqs apartados;
	private Faqs aplfaqs;
	private List d7faqs;
	private List d7apartados;
	private List d7fichas;
	private FichaAplicacion fichas;
	private List d7apartadosfichas;

	private D7Aplicaciones aplicacionsel;

	private String CodigoAplicacion = null;
	private String CodigoSeccion = null;
	private String apl = null;
	private String prio = null;
	private String responflag = null;

	// Parametros para el filtrado de aplicaciones segn seccin y caracter
	private String seccionCode = null;
	private String caracter = null;// Si es distinto de null, se filtrar por
									// el cdigo del carcter indicado
	private boolean flagFiltrado = false;
	private boolean modifica = false;

	// Guardamos booleanos para ver que cual se graba y cual se modifica
	private Vector aplicacionesmaximosUpdate = new Vector();

	/** CONSTRUCTOR */
	public GestorAplicaciones() {
	}

	public void setFlagFiltrado(String flagFiltrado) {
		if (flagFiltrado != null && flagFiltrado.equals("0"))
			this.flagFiltrado = false;
		else if (flagFiltrado != null && flagFiltrado.equals("1"))
			this.flagFiltrado = true;
		else
			this.flagFiltrado = false;
	}

	public void setCaracterCode(String caracter) {
		this.caracter = caracter;
	}

	public void setSeccionCode(String seccionCode) {
		this.seccionCode = seccionCode;
	}

	public void setModifica(String modifica) {
		if (modifica != null && modifica.equals("0"))
			this.modifica = false;
		else if (modifica != null && modifica.equals("1"))
			this.modifica = true;
		else
			this.modifica = false;
	}

	/** METODOS DE LISTA PARA EL MAPEO */
	// Devuelve todos los datos personales de todos los informticos (no tiene
	// en cuenta sistema)
	public void listaDatosPersonales(Session conn) {
		try {
			Query q = conn.createQuery(getQuery("AllDatosPersonales"));
			q = q.setString("sist", user.getDatosMenu().idSelected());
			datosPersonales = (List) q.list();
		} catch (Exception ex) {
			setErrorMessage("Error al listar datos personales.");
		}
	}

	// Bsqueda a partir de los datos introducidos por setDatos
	public void listaDatosPersonalesApellidos(Session conn) {
		Query q = null;
		Query q2 = null;
		try {
			if (datos[0].indexOf("@") > 0) {
				datosPersonales = new ArrayList();
				datos[0] = datos[0].substring(0, datos[0].length() - 1);
				Vector v = LDAPUtil.findUsersByMail(datos[0] + "*");
				Enumeration en = v.elements();
				while (en.hasMoreElements()) {
					// Hasta aqu vamos bien, saca los tios del LDAP con correo
					// como el del patrn.
					LDAPUser ldu = (LDAPUser) en.nextElement();
					q = conn.createQuery(getQuery("DatosPersonalesDNI"));
					q = q.setString("sist", user.getDatosMenu().idSelected());
					q = q.setString("dat", ldu.getDni());
					if (!q.list().isEmpty()) {
						datosPersonales.add(q.list().get(0));
					}
				}
			} else {
				String patron = datos[0];
				q = conn.createQuery(getQuery("DatosPersonalesApellidos"));
				String nom = patron.substring(0, patron.indexOf("/"));
				String ape = patron.substring(patron.indexOf("/") + 1, patron
						.length());
				q = q.setString("ape", "%" + ape + "%");
				q = q.setString("nom", "%" + nom + "%");
				q = q.setString("sist", user.getDatosMenu().idSelected());
				datosPersonales = (List) q.list();
			}

		} catch (Exception ex) {
			setErrorMessage("Error al listar datos personales.");
		}
	}

	// Devuelve los datos personales de un informtico dado su identificador
	// (codigo)
	public void listaDatosPersonalesDNI(Session conn, String Codigo) {
		Query q = null;
		try {
			q = conn.createQuery(getQuery("DatosPersonalesDNI"));
			q = q.setString("dat", Codigo);
			q = q.setString("sist", user.getDatosMenu().idSelected());
			datosPersonales = (List) q.list();
			if (datosPersonales.isEmpty()) {
				setErrorMessage(user.traduce(
						"dumbo7/administracion/aplicaciones", "Informtico",
						user.getDatosMenu().idSelected())
						+ " incorrecto o ya Asignado");
			}
		} catch (Exception ex) {
			setErrorMessage("Error al listar datos personales.");
		}
	}

	public void listaAplicacionesFiltrado(Session conn) {
		String cadena = new String();
		try {
			if (flagFiltrado) {
				if (caracter != null && seccionCode == null) {
					Query q = conn
							.createQuery(getQuery("AplicacionesCaracter"));
					q = q.setString("sist", user.getDatosMenu().idSelected());
					q = q.setString("caracter", caracter);
					aplicaciones = (List) q.list();
				}
				if (caracter == null && seccionCode != null) {
					// Rellena la lista subSecciones
					listaSubSeccionesRecursiva(conn, seccionCode);
					// Recogemos los cdigos de las secciones
					for (int i = 0; i < subSecciones.size(); i++) {
						cadena = cadena
								+ "'"
								+ ((D7Secciones) subSecciones.get(i))
										.getSecCod() + "'" + ",";
					}
					cadena = cadena.substring(0, cadena.length() - 1);// Eliminamos
																		// la
																		// ltima
																		// coma

					Query q = conn.createQuery(getQuery("AplicacionesSeccion")
							.replaceAll(":secciones", "(" + cadena + ")"));
					q = q.setString("sist", user.getDatosMenu().idSelected());
					aplicaciones = (List) q.list();
				}
				if (caracter != null && seccionCode != null) {
					// Rellena la lista subSecciones
					listaSubSeccionesRecursiva(conn, seccionCode);
					// Recogemos los cdigos de las secciones
					for (int i = 0; i < subSecciones.size(); i++) {
						cadena = cadena
								+ "'"
								+ ((D7Secciones) subSecciones.get(i))
										.getSecCod() + "'" + ",";
					}
					cadena = cadena.substring(0, cadena.length() - 1);// Eliminamos
																		// la
																		// ltima
																		// coma
					Query q = conn.createQuery(getQuery(
							"AplicacionesSeccionCaracter").replaceAll(
							":secciones", "(" + cadena + ")"));
					q = q.setString("sist", user.getDatosMenu().idSelected());
					q = q.setString("caracter", caracter);
					aplicaciones = (List) q.list();
				}
			} else {
				listaAplicaciones(conn);

			}

		} catch (Exception ex) {
			System.out.println("2" + ex);
			setErrorMessage("Error al listar aplicaciones.");
		}
	}

	// Lista todas las subsecciones de una seccion
	public void listaSubSeccionesRecursiva(Session conn, String seccion) {
		PreparedStatement pstmt;
		subSecciones = new Vector();

		try {
			String q = getQuery("SubSecciones");

			q = q.replaceAll(":sist", user.getDatosMenu().idSelected());
			q = q.replaceAll(":sec", seccion);
			pstmt = conn.connection().prepareStatement(q);
			ResultSet rs = pstmt.executeQuery();

			while (rs.next()) {
				D7Secciones secci = new D7Secciones();
				secci.setSecSisCod(rs.getString(1));
				secci.setSecCod(rs.getString(2));
				secci.setSecDescrip(rs.getString(3));
				secci.setSecIdRespon(rs.getString(4));
				secci.setSecSecCod(rs.getString(5));
				secci.setSecEstado(rs.getString(6));
				subSecciones.add(secci);
			}

			rs.close();
			pstmt.close();
		} catch (Exception ex) {
			setErrorMessage("Error al listar secciones " + ex);
			System.out.println("1" + ex);
		}
	}

	public void listaAplicaciones(Session conn) {
		try {
			Query q = conn.createQuery(getQuery("AllAplicaciones"));
			q = q.setString("sist", user.getDatosMenu().idSelected());
			aplicaciones = (List) q.list();

		} catch (Exception ex) {
			setErrorMessage("Error al listar aplicaciones.");
		}
	}

	public void listaAplicacionesVigentes(Session conn) {
		try {
			Query q = conn.createQuery(getQuery("AllAplicacionesVigentes"));
			q = q.setString("sist", user.getDatosMenu().idSelected());
			aplicaciones = (List) q.list();

		} catch (Exception ex) {
			setErrorMessage("Error al listar aplicaciones.");
		}
	}

	public void listaAplicacionesPadreVigentes(Session conn) {
		try {
			/*
			 * Query q =
			 * conn.createQuery(getQuery("AllAplicacionesPadreVigentes")); q =
			 * q.setString("sist",user.getDatosMenu().idSelected());
			 * aplicaciones = (List)q.list();
			 */

			Criteria ct = conn.createCriteria(D7Aplicaciones.class);

			ct = ct.add(Expression.sql("APL_SIS_COD = 'D7'"));
			ct = ct.add(Expression
					.sql("APL_ESTADO = 'V' AND APL_PADRE_APL_COD IS NULL"));

			aplicaciones = ct.list();

		} catch (Exception ex) {
			setErrorMessage("Error al listar aplicaciones padre.");
		}
	}

	public void QueryAplicaciones(Session conn, D7Aplicaciones apli) {
		try {
			Query q = conn.createQuery(getQuery("Aplicaciones"));
			q = q.setString("sist", user.getDatosMenu().idSelected());
			q = q.setString("cod", apli.getAplCod());
			aplicaciones = (List) q.list();

		} catch (Exception ex) {
			setErrorMessage("Error al listar aplicacin.");
		}
	}

	public void QueryAplicacionsel(Session conn, D7Aplicaciones apli) {
		try {
			Query q = conn.createQuery(getQuery("Aplicaciones"));
			q = q.setString("sist", user.getDatosMenu().idSelected());
			q = q.setString("cod", apli.getAplCod());

			aplicacionsel = (D7Aplicaciones) q.list().get(0);

		} catch (Exception ex) {
			setErrorMessage("Error al listar aplicacin.");
		}
	}

	public void QueryAplicacionesHijas(Session conn, D7Aplicaciones apli) {
		try {
			Query q = conn.createQuery(getQuery("AplicacionesHijas"));
			q = q.setString("sist", user.getDatosMenu().idSelected());
			q = q.setString("cod", apli.getAplCod());
			aplicacionesHijas = (List) q.list();

		} catch (Exception ex) {
			setErrorMessage("Error al listar aplicacin.");
		}
	}

	// Lista todas las secciones
	public void listaSecciones(Session conn) {
		try {
			Query q = conn.createQuery(getQuery("AllSecciones"));
			q = q.setString("sist", user.getDatosMenu().idSelected());
			secciones = (List) q.list();

		} catch (Exception ex) {
			setErrorMessage("Error al listar secciones.");
		}
	}

	// Lista todas las secciones maximos de una seccion dada por "code"
	public void QueryTienehijos(Session conn, D7Aplicaciones apli) {
		try {

			int cod = 0;
			PreparedStatement pstmt = null;
			ResultSet rs = null;
			String qry = "SELECT count(*) FROM DUMBO.D7_APLICACIONES WHERE APL_PADRE_APL_COD='"
					+ apli.getAplCod() + "'";
			pstmt = conn.connection().prepareStatement(qry);
			rs = pstmt.executeQuery();
			if (rs.next()) {
				cod = rs.getInt(1);
				tienehijos = Boolean.FALSE;
				if (cod > 0) {
					tienehijos = Boolean.TRUE;
				}

			}

		} catch (Exception ex) {
			setErrorMessage("Alta de nuevo grupo:" + ex + ";");
		}
	}

	public void QueryNumerodehijos(Session conn, D7Aplicaciones apli) {
		try {

			D7AplicacionesFaqs aux = (D7AplicacionesFaqs) d7faqs.get(0);
			int cod = 0;
			PreparedStatement pstmt = null;
			ResultSet rs = null;
			String qry = "SELECT count(*) FROM DUMBO.D7_APLICACIONES_FAQS WHERE FAQ_FGR_COD="
					+ aux.getFaqfgrcod()
					+ " AND FAQ_APL_COD='"
					+ apli.getAplCod() + "'";
			pstmt = conn.connection().prepareStatement(qry);
			rs = pstmt.executeQuery();
			if (rs.next()) {
				cod = rs.getInt(1);
				numerodehijos = new Integer(cod);
			}

		} catch (Exception ex) {
			setErrorMessage("Numero de hijos :" + ex + ";");
		}
	}

	public void listaSeccionesMaximos(Session conn, String code) {
		try {
			Query q = conn.createQuery(getQuery("SeccionesMaximosSeccion"));
			q = q.setString("sist", user.getDatosMenu().idSelected());
			q = q.setString("sec", code);
			seccionesMaximos = (List) q.list();

		} catch (Exception ex) {
			setErrorMessage("Error al listar secciones mximos.");
		}
	}

	public void listaInformaticos(Session conn) {
		try {
			Query q = conn.createQuery(getQuery("AllInformaticos"));
			q = q.setString("sist", user.getDatosMenu().idSelected());
			informaticos = (List) q.list();

		} catch (Exception ex) {
			setErrorMessage("Error al listar "
					+ user.traduce("dumbo7/administracion/aplicaciones",
							"informtico", user.getDatosMenu().idSelected())
					+ ".");
		}
	}

	public void listaPrioridades(Session conn) {
		try {
			Query q = conn.createQuery(getQuery("AllPrioridades"));
			q = q.setString("sist", user.getDatosMenu().idSelected());
			prioridades = (List) q.list();

		} catch (Exception ex) {
			setErrorMessage("Error al listar propiedades.");
		}
	}

	public void listaTipoTareas(Session conn) {
		try {
			Query q = conn.createQuery(getQuery("TiposTareas"));
			q = q.setString("sist", user.getDatosMenu().idSelected());
			tiposTareas = (List) q.list();

		} catch (Exception ex) {
			setErrorMessage("Error al listar tipos tareas.");
		}
	}

	public void QueryTareas(Session conn, D7Aplicaciones apli) {
		try {
			Query q = conn.createQuery(getQuery("Tareas"));
			q = q.setString("sist", user.getDatosMenu().idSelected());
			q = q.setString("cod", apli.getAplCod());
			Tareas = (List) q.list();

		} catch (Exception ex) {
			setErrorMessage("Error al obtener tareas.");
		}
	}

	public void QueryTareasPendientes(Session conn, D7Aplicaciones apli) {
		try {
			Query q = conn.createQuery(getQuery("TareasPendientes"));
			q = q.setString("sist", user.getDatosMenu().idSelected());
			q = q.setString("cod", apli.getAplCod());
			Tareas = (List) q.list();

		} catch (Exception ex) {
			setErrorMessage("Error al obtener tareas.");
		}
	}

	public void QueryAplicacionesInformaticos(Session conn, D7Aplicaciones apli) {
		try {
			Query q = conn.createQuery(getQuery("AplicacionesInformaticos"));
			q = q.setString("sist", user.getDatosMenu().idSelected());
			q = q.setString("cod", apli.getAplCod());
			aplicacionesInformaticos = (List) q.list();
			CodigoAplicacion = apli.getAplCod();

		} catch (Exception ex) {
			setErrorMessage("Error al obtener aplicaciones informticos.");
		}
	}

	public void listaAplicacionesInformaticosNoResponsables(Session conn,
			String codigo) {
		try {
			Query q = conn
					.createQuery(getQuery("AplicacionesInformaticosNoResponsables"));
			q = q.setString("sist", user.getDatosMenu().idSelected());
			q = q.setString("cod", codigo);
			aplicacionesInformaticos = (List) q.list();
		} catch (Exception ex) {
			setErrorMessage("Error al obtener aplicaciones informticos.");
		}
	}

	// Necesaria para comprobar al asignar informaticos si ya estan todos los
	// informaticos vigentes asignados (Se mapea dentro de
	// aplicacionesInformaticosVigentes)
	public void QueryAplicacionesInformaticosVigentes(Session conn,
			D7Aplicaciones apli) {
		try {
			Query q = conn
					.createQuery(getQuery("AplicacionesInformaticosVigentes"));
			q = q.setString("sist", user.getDatosMenu().idSelected());
			q = q.setString("cod", apli.getAplCod());
			aplicacionesInformaticosVigentes = (List) q.list();

		} catch (Exception ex) {
			setErrorMessage("Error al obtener aplicaciones informticos vigentes.");
		}
	}

	public void QueryUnaAplicacionInformaticos(Session conn, D7Aplicaciones apli) {
		try {
			Query q = conn.createQuery(getQuery("UnaAplicacionInformaticos"));
			q = q.setString("sist", user.getDatosMenu().idSelected());
			q = q.setString("cod", apli.getAplCod());
			informaticos = (List) q.list();

		} catch (Exception ex) {
			setErrorMessage("Error al obtener aplicacin");
		}
	}

	public void QueryDatosPersonalesAplicacion(Session conn, D7Aplicaciones apli) {
		try {
			Query q = conn.createQuery(getQuery("DatosPersonalesAplicacion"));
			q = q.setString("sist", user.getDatosMenu().idSelected());
			q = q.setString("cod", apli.getAplCod());
			datosPersonales = (List) q.list();

		} catch (Exception ex) {
			setErrorMessage("Error al obtener informticos asociados a la aplicacin.");
		}
	}

	public void QueryAplicacionesMaximos(Session conn, D7Aplicaciones apli) {
		Vector nuevasPrioridades, nuevasTiposTareas, viejasPrioridades, viejasTiposTareas;
		D7AplicacionesMaximos am;
		boolean existe = false;
		int sizePrioridades, sizeTipoTareas;

		am = new D7AplicacionesMaximos();
		nuevasPrioridades = new Vector();// Guardamos objetos tipo
											// D7Prioridades, las nuevas
											// prioridades

		viejasPrioridades = new Vector();// Guardamos objetos tipo
											// D7Prioridades, las prioridades
											// que ya estaban
		viejasTiposTareas = new Vector();// Guardamos objetos tipo
											// D7TiposTareas, los tipostareas
											// que ya estaban

		try {
			// query que devuelve todas las aplicaciones_maximos que hay creadas
			// para una seccin
			Query q1 = conn.createQuery(getQuery("AplicacionesMaximos"));
			q1 = q1.setString("sist", user.getDatosMenu().idSelected());
			q1 = q1.setString("cod", apli.getAplCod());
			aplicacionesMaximos = (List) q1.list();

			// query que devuelve todas las prioridades que hay creadas
			Query q2 = conn.createQuery(getQuery("AllPrioridades"));
			q2 = q2.setString("sist", user.getDatosMenu().idSelected());
			prioridades = (List) q2.list();

		} catch (Exception ex) {
			setErrorMessage("Error al obtener aplicaciones mximos");
		}
		// Comprobamos si se aadieron prioridades nuevas tras la creacion de la
		// seccion
		sizePrioridades = prioridades.size();// variable que guarda el numero
												// de prioridades existentes
												// (por si luego se borra alguna
												// que no cambie este valor)

		for (int i = 0; i < sizePrioridades; i++) {
			for (int j = 0; j < aplicacionesMaximos.size(); j++) {
				if (((D7AplicacionesMaximos) aplicacionesMaximos.get(j))
						.getAmaPriCod().equals(
								((D7Prioridades) prioridades.get(i))
										.getPriCod()))
					existe = true;
			}
			if (!existe)
				nuevasPrioridades.add(prioridades.get(i));// Si la seccion no
															// tiene esta
															// prioridad la
															// aado al grupo de
															// nuevas
			else
				viejasPrioridades.add(prioridades.get(i));// Si la seccion si
															// tiene esta
															// prioridad la
															// aado al grupo de
															// viejas

			existe = false;
		}

		for (int i = 0; i < nuevasPrioridades.size(); i++) {
			for (int j = 0; j < viejasTiposTareas.size(); j++) {
				am = new D7AplicacionesMaximos();
				am.setAmaSisCod(user.getDatosMenu().idSelected());
				am.setAmaAplCod(apli.getAplCod());
				am.setAmaPriCod(((D7Prioridades) nuevasPrioridades.get(i))
						.getPriCod());
				am.setAmaTipCod(((D7TiposTareas) viejasTiposTareas.get(j))
						.getTipCod());
				am.setAmaDias(new BigDecimal(1));
				aplicacionesMaximos.add(am);

				// se guarda cuando se crea para luego solo hacer update
				saveam(conn, am);
			}
		}

	}

	// mtodos comunes para aplicaciones_maximos
	public void saveam(Session conn, D7AplicacionesMaximos am) {
		try {
			conn.save(am);
			conn.flush();
			conn.connection().commit();
		} catch (Exception e) {
			setErrorMessage("Error al crear seccionesMaximos. Compruebe que los datos introducidos son los correctos.");
		}
	}

	public void listaApartados(Session conn, D7Aplicaciones apli) {
		try {

			// Query q = conn.createQuery(getQuery("DiasFestivos"));
			// diasFestivos = (List)q.list();

			Criteria ct = conn.createCriteria(D7AplicacionesFaqsGrupos.class);

			ct = ct.add(Expression.eq("fgraplcod", apli.getAplCod()));
			ct = ct.add(Expression.eq("fgrsiscod", user.getDatosMenu()
					.idSelected()));

			d7apartados = ct.list();
		} catch (Exception ex) {
			setErrorMessage("Listado de apartados: "
					+ ((ex.getCause() != null) ? ex.getCause() : ex));
		}

	}

	public void muestraFaq(Session conn, D7AplicacionesFaqs apli) {
		try {

			// Query q = conn.createQuery(getQuery("DiasFestivos"));
			// diasFestivos = (List)q.list();

			Criteria ct = conn.createCriteria(D7AplicacionesFaqs.class);

			ct = ct.add(Expression.eq("faqaplcod", apli.getFaqaplcod()));
			ct = ct.add(Expression.eq("faqcod", apli.getFaqcod()));
			ct = ct.add(Expression.eq("faqsiscod", user.getDatosMenu()
					.idSelected()));

			d7faqs = ct.list();
		} catch (Exception ex) {
			setErrorMessage("Listado de apartados: "
					+ ((ex.getCause() != null) ? ex.getCause() : ex));
		}

	}

	public void listaFaqs(Session conn, D7Aplicaciones apli) {
		try {

			// Query q = conn.createQuery(getQuery("DiasFestivos"));
			// diasFestivos = (List)q.list();

			Criteria ct = conn.createCriteria(D7AplicacionesFaqs.class);

			ct = ct.add(Expression.eq("faqaplcod", apli.getAplCod()));
			ct = ct.add(Expression.eq("faqsiscod", user.getDatosMenu()
					.idSelected()));

			d7faqs = ct.list();
		} catch (Exception ex) {
			setErrorMessage("Listado de apartados: "
					+ ((ex.getCause() != null) ? ex.getCause() : ex));
		}

	}

	public void BuscaFaqporAplicacion(Session conn, String code) {
		try {

			// Query q = conn.createQuery(getQuery("DiasFestivos"));
			// diasFestivos = (List)q.list();

			Criteria ct = conn.createCriteria(D7Aplicaciones.class);
			ct = ct.add(Expression.sql("apl_cod LIKE '%'||upper('" + code
					+ "')||'%' OR upper(apl_descrip) LIKE '%'||upper('" + code
					+ "')||'%'"));
			ct = ct.add(Expression.eq("AplSisCod", user.getDatosMenu()
					.idSelected()));

			aplicaciones = ct.list();
		} catch (Exception ex) {
			setErrorMessage("Busca Faq por Aplicacion: "
					+ ((ex.getCause() != null) ? ex.getCause() : ex));
		}

	}

	public void listaApartadosFicha(Session conn, D7Aplicaciones seccion) {
		try {

			// Query q = conn.createQuery(getQuery("DiasFestivos"));
			// diasFestivos = (List)q.list();


			
			PreparedStatement pstmt = null;
			ResultSet rs = null;

			pstmt = conn.connection().prepareStatement(
					getQuery("apartadosfichasec"));
			pstmt.setString(1, seccion.getAplSecCod());
			pstmt.setString(2, user.getDatosMenu().idSelected());
			
			pstmt.setString(3, user.getDatosMenu().idSelected());
			rs = pstmt.executeQuery();
			d7apartadosfichas = new ArrayList();
			boolean primera = true;
			boolean seguir = true;
			int orden = 0;
			while (rs.next() && seguir) {
				if (primera){
					orden = rs.getInt(1);
					primera = false;
				}else{
					if(orden!= rs.getInt(1)){
						seguir= false;
					}
					
				}
				
				D7SeccionesApartFichas m = new D7SeccionesApartFichas();
				
				m.setApfseccod(rs.getString(2));
				m.setApfsiscod(rs.getString(3));
				m.setApfcod( new Integer(rs.getString(4)));
				m.setApfindobligatorio(rs.getString(5));
				m.setApforden( new Integer(rs.getString(6)));
				m.setApfetiqueta(rs.getString(7));
				
				d7apartadosfichas.add(m);
			}
			rs.close();
			pstmt.close();
			
			
			
			/*	CodigoSeccion = seccion.getAplSecCod();

			Criteria ct = conn.createCriteria(D7SeccionesApartFichas.class);

			ct = ct.add(Expression.eq("apfseccod", seccion.getAplSecCod()));
			ct = ct.add(Expression.eq("apfsiscod", user.getDatosMenu()
					.idSelected()));

			d7apartadosfichas = ct.list();*/
			
			
			
			
		} catch (Exception ex) {
			setErrorMessage("Listado de apartados de fichas: "
					+ ((ex.getCause() != null) ? ex.getCause() : ex));
		}

	}

	public void listaFichaAplicacion(Session conn, D7Aplicaciones apli) {
		try {

			// Query q = conn.createQuery(getQuery("DiasFestivos"));
			// diasFestivos = (List)q.list();

			Criteria ct = conn.createCriteria(D7AplicacionesFichas.class);
			ct = ct.add(Expression.eq("ficaplcod", apli.getAplCod()));
			ct = ct.add(Expression.eq("ficseccod", apli.getAplSecCod()));
			ct = ct.add(Expression.eq("ficsiscod", user.getDatosMenu()
					.idSelected()));

			d7fichas = ct.list();
		} catch (Exception ex) {
			setErrorMessage("Lista fichas de aplicacion: "
					+ ((ex.getCause() != null) ? ex.getCause() : ex));
		}

	}
	

	public void BuscaFaqporTexto(Session conn, String texto) {
		try {

			// Query q = conn.createQuery(getQuery("DiasFestivos"));
			// diasFestivos = (List)q.list();

			Criteria ct = conn.createCriteria(D7AplicacionesFaqs.class);
			ct = ct.add(Expression.sql("FAQ_TEXTO LIKE '%'||upper('" + texto
					+ "')||'%' OR FAQ_ASUNTO LIKE '%'||upper('" + texto
					+ "')||'%'"));
			ct = ct.add(Expression.eq("faqsiscod", user.getDatosMenu()
					.idSelected()));

			d7faqs = ct.list();
		} catch (Exception ex) {
			setErrorMessage("Busca faq por texto: "
					+ ((ex.getCause() != null) ? ex.getCause() : ex));
		}

	}
	
	public void BuscaFichaporTexto(Session conn, String texto) {
		try {

			// Query q = conn.createQuery(getQuery("DiasFestivos"));
			// diasFestivos = (List)q.list();

			Criteria ct = conn.createCriteria(D7AplicacionesFichas.class);
			ct = ct.add(Expression.sql("FIC_APF_TEXTO LIKE '%'||upper('" + texto
					+ "')||'%' "));
			ct = ct.add(Expression.eq("faqsiscod", user.getDatosMenu()
					.idSelected()));

			d7fichas = ct.list();
		} catch (Exception ex) {
			setErrorMessage("Busca ficha por texto: "
					+ ((ex.getCause() != null) ? ex.getCause() : ex));
		}

	}
	

	public void ListaAplicacionesdeResponsable(Session conn) {
		try {

			// Query q = conn.createQuery(getQuery("DiasFestivos"));
			// diasFestivos = (List)q.list();
			PreparedStatement pstmt = null;
			ResultSet rs = null;

			pstmt = conn.connection().prepareStatement(
					getQuery("ListaAplicacionesdeResponsable"));
			pstmt.setString(1, user.getDatosMenu().idSelected());
			pstmt.setString(2, user.getDatosMenu().idSelected());
			pstmt.setString(3, user.getDatosMenu().idSelected());
			pstmt.setString(4, user.getDatosMenu().idSelected());
			pstmt.setString(5, user.getIdentificador());
			pstmt.setString(6, user.getIdentificador());
			pstmt.setString(7, user.getDatosMenu().idSelected());
			pstmt.setString(8, user.getDatosMenu().idSelected());
			rs = pstmt.executeQuery();
			aplicaciones = new ArrayList();

			while (rs.next()) {

				D7Aplicaciones m = new D7Aplicaciones();
				m.setAplSisCod(rs.getString(1));
				m.setAplCod(rs.getString(2));
				m.setAplDescrip(rs.getString(3));
				m.setAplTipoAsig(rs.getString(4));
				m.setAplSecCod(rs.getString(5));
				m.setAplEstado(rs.getString(6));
				m.setAplDetalle(rs.getString(7));
				m.setAplCaracter(rs.getString(8));
				m.setAplPadreAplCod(rs.getString(9));
				m.setAplCorreoResp(rs.getString(10));
				m.setAplCorreoInf(rs.getString(11));
				m.setUrl(rs.getString(12));
				m.setUrlinfo(rs.getString(13));
				aplicaciones.add(m);
			}
			rs.close();
			pstmt.close();

			pstmt = conn.connection().prepareStatement(
					getQuery("seccionesDeResponsable"));
			pstmt.setString(1, user.getIdentificador());
			pstmt.setString(2, user.getDatosMenu().idSelected());
			pstmt.setString(3, user.getDatosMenu().idSelected());
			rs = pstmt.executeQuery();
			secciones = new ArrayList();

			while (rs.next()) {
				
				D7Secciones m = new D7Secciones();
				m.setSecSisCod(rs.getString(1));
				m.setSecCod(rs.getString(2));
				m.setSecDescrip(rs.getString(3));
				m.setSecIdRespon(rs.getString(4));
				m.setSecSecCod(rs.getString(5));
				m.setSecEstado(rs.getString(6));

				secciones.add(m);
			}
			rs.close();
			pstmt.close();

			/*
			 * 
			 * 
			 * Criteria ct3 = conn.createCriteria(D7Secciones.class); ct3 =
			 * ct3.add(Expression.eq("SecIdRespon", user.getIdentificador()));
			 * ct3 = ct3.add(Expression.eq("SecSisCod",
			 * user.getDatosMenu().idSelected()));
			 * 
			 * 
			 * secciones = ct3.list();
			 * 
			 * 
			 */
			/*
			 * Criteria ct = conn.createCriteria(D7Aplicaciones.class);
			 * 
			 * ct =
			 * ct.add(Expression.sql("APL_SIS_COD='"+user.getDatosMenu().idSelected()+"'
			 * AND (APL_COD IN (SELECT A.APL_COD FROM dumbo.d7_aplicaciones A
			 * INNER JOIN dumbo.d7_aplicaciones I ON (A.APL_COD =
			 * I.APL_PADRE_APL_COD OR I.APL_COD = A.APL_PADRE_APL_COD OR
			 * I.APL_COD=A.APL_COD)AND
			 * I.APL_SIS_COD='"+user.getDatosMenu().idSelected()+"' AND
			 * A.APL_SIS_COD='"+user.getDatosMenu().idSelected()+"' AND
			 * I.APL_COD IN(SELECT AIN_APL_COD from
			 * DUMBO.D7_APLICACIONES_INFORMATICOS WHERE AIN_SIS_COD
			 * ='"+user.getDatosMenu().idSelected()+"' AND AIN_INF_COD =
			 * '"+user.getIdentificador()+"' AND AIN_RESPONSABLE ='Y' ))OR
			 * APL_SEC_COD IN( SELECT SEC_COD FROM DUMBO.D7_SECCIONES WHERE
			 * SEC_ID_RESPON='"+user.getIdentificador()+"'))")); aplicaciones =
			 * ct.list();
			 */
			Criteria ct2 = conn
					.createCriteria(D7AplicacionesInformaticos.class);

			ct2 = ct2.add(Expression.eq("AinInfCod", user.getIdentificador()));
			ct2 = ct2.add(Expression.eq("AinSisCod", user.getDatosMenu()
					.idSelected()));
			ct2 = ct2.add(Expression.eq("AinResponsable", "Y"));

			aplicacionesInformaticos = ct2.list();

		} catch (Exception ex) {
			setErrorMessage("Busca faq por texto: "
					+ ((ex.getCause() != null) ? ex.getCause() : ex));
		}

	}

	public void listarAplicacionesBusqueda(Session conn) {
		try {

			// List h= null;

			// for (int i=0; i<horarios.size(); i++) {
			// h.add(((D7Horarios)horarios.get(i)).getHorInfCod());
			// }
			if (0 < d7faqs.size() || 0< d7fichas.size()) {
				String codigo = new String();
				if(0< d7faqs.size()){
				for (int i = 0; i < d7faqs.size(); i++) {
					codigo = codigo
							+ "'"
							+ ((D7AplicacionesFaqs) d7faqs.get(i))
									.getFaqaplcod() + "'" + ",";
				}
				}
				if(0< d7fichas.size()){
					for (int i = 0; i < d7fichas.size(); i++) {
						codigo = codigo
								+ "'"
								+ ((D7AplicacionesFichas) d7fichas.get(i))
										.getFicaplcod() + "'" + ",";
					}
					}
				codigo = codigo.substring(0, codigo.length() - 1);// Eliminamos
																	// la ltima
																	// coma

				Criteria ct = conn.createCriteria(D7Aplicaciones.class);
				ct = ct.add(Expression.sql(" APL_COD IN (" + codigo
						+ ") OR APL_PADRE_APL_COD IN (" + codigo + ")"));

				aplicaciones = ct.list();

			}
		} catch (Exception ex) {
			setErrorMessage("listaraplicaciones Busqueda: "
					+ ((ex.getCause() != null) ? ex.getCause() : ex));
		}

	}

	public void QueryAplicacionesParametros(Session conn, D7Aplicaciones apli) {
		boolean existe = false;
		int sizeTipoTareas;
		Vector nuevasTiposTareas = new Vector();// Guardamos objetos tipo
												// D7TiposTareas, los nuevos
												// tipostareas
		Vector viejasTiposTareas = new Vector();// Guardamos objetos tipo
												// D7TiposTareas, los
												// tipostareas que ya estaban

		try {
			Query q1 = conn.createQuery(getQuery("AplicacionesParametros"));
			q1 = q1.setString("sist", user.getDatosMenu().idSelected());
			q1 = q1.setString("cod", apli.getAplCod());
			aplicacionesParametros = (List) q1.list();

			// query que devuelve todos los tipostareas que hay creados
			Query q2 = conn.createQuery(getQuery("TiposTareas"));
			q2 = q2.setString("sist", user.getDatosMenu().idSelected());
			tiposTareas = (List) q2.list();

			// Comprobamos si se aadieron tipos_tareas nuevas tras la creacion
			// de la seccion
			sizeTipoTareas = tiposTareas.size();

			for (int i = 0; i < sizeTipoTareas; i++) {
				for (int j = 0; j < aplicacionesParametros.size(); j++) {
					if (((D7AplicacionesParametros) aplicacionesParametros
							.get(j)).getApaTipCod().equals(
							((D7TiposTareas) tiposTareas.get(i)).getTipCod()))
						existe = true;
				}
				if (!existe)
					nuevasTiposTareas.add(tiposTareas.get(i));// Si la seccion
																// no tiene este
																// tipotarea La
																// aado al
																// grupo de
																// nuevas
				else
					viejasTiposTareas.add(tiposTareas.get(i));// La aado al
																// grupo de
																// viejas

				existe = false;
			}

			// por cada tipotarea nueva creamos aplicaciones parmetros como
			// prioridad por defecto "media"
			D7AplicacionesParametros ap;
			for (int i = 0; i < nuevasTiposTareas.size(); i++) {
				ap = new D7AplicacionesParametros();

				ap.setApaAplCod(apli.getAplCod());
				//
				ap.setApaPrioridad(D7Prioridades.MEDIA);
				ap.setApaSisCod(user.getDatosMenu().idSelected());
				ap.setApaTipCod(((D7TiposTareas) nuevasTiposTareas.get(i))
						.getTipCod());
				ap.setApaUrgencia("N");// Por defecto, no urgente

				aplicacionesParametros.add(ap);
				// se guarda cuando se crea para luego solo hacer update
				saveap(conn, ap);

			}
		} catch (Exception ex) {
			setErrorMessage("Error al obtener parmetros.");
		}
	}

	// metodos comunes para aplicaciones_parametros
	public void saveap(Session conn, D7AplicacionesParametros ap) {
		try {
			conn.save(ap);
			conn.flush();
			conn.connection().commit();
		} catch (Exception e) {
			setErrorMessage("Error al crear seccin. Compruebe que los datos introducidos son los correctos.");
		}
	}

	public void updateap(Session conn, D7AplicacionesParametros ap) {
		try {
			conn.update(ap);
			conn.flush();
			conn.connection().commit();
		} catch (Exception e) {
			setErrorMessage("Error al crear seccin. Compruebe que los datos introducidos son los correctos.");
		}
	}

	// -------------------------------------------

	/** METODOS GET */
	public Boolean getTienehijos() {
		return tienehijos;
	}

	public Integer getNumerodehijos() {
		return numerodehijos;
	}

	public Integer getCodigo() {
		return codigo;
	}

	public D7Aplicaciones getAplicacionsel() {
		return aplicacionsel;
	}

	public List getD7apartados() {
		return d7apartados;
	}

	public List getD7apartadosfichas() {
		return d7apartadosfichas;
	}

	public List getD7fichas() {
		return d7fichas;
	}
	
	public List getD7faqs() {
		return d7faqs;
	}

	public List getAplicaciones() {
		return aplicaciones;
	}

	public List getSecciones() {
		return secciones;
	}

	public List getAplicacionesInformaticos() {
		return aplicacionesInformaticos;
	}

	public List getAplicacionesInformaticosVigentes() {
		return aplicacionesInformaticosVigentes;
	}

	public List getAplicacionesMaximos() {
		return aplicacionesMaximos;
	}

	public List getSeccionesMaximos() {
		return seccionesMaximos;
	}

	public List getAplicacionesParametros() {
		return aplicacionesParametros;
	}

	public List getInformaticos() {
		return informaticos;
	}

	public List getPrioridades() {
		return prioridades;
	}

	public List getTipoTareas() {
		return tiposTareas;
	}

	public List getDatosPersonales() {
		return datosPersonales;
	}

	// Mtodo para fijar los apellidos para realizar la bsqueda del informtico
	public void setDatos(String[] datos) {
		this.datos = datos;
	}

	// Mtodo para pasar un array con los responsables de la nueva aplicacin
	public void setResponsables(String[] responsables) {
		this.responsables = responsables;
	}

	// Indicador de si el informatico a modificar es responsable (modificar
	// responsables)
	public void setResponFlag(String responflag) {
		this.responflag = responflag;

	}

	// Prioridad del informatico modificado (modificar responsables)
	public void setPrioridad(String prio) {
		this.prio = prio;

	}

	// Prioridad del informatico modificado (modificar responsables)
	public void setAplicacion(String apl) {
		this.apl = apl;
	}

	// Mtodo para introducir la operacin a realizar (operacin con
	// responsables) al hacer que una aplicacin se convierta en subaplicacin
	// de otra.
	public void setResponsablesOp(String ResponsablesOp) {
		this.ResponsablesOp = ResponsablesOp;
	}

	/* guardamos la secuenci de apartados */
	public void setApartados(ApartadosFaqs entrada) {

		apartados = entrada;

		d7apartados = apartados.pasarApartados();

	}

	/* guardamos la secuenci de apartados */
	public void setFichas(FichaAplicacion entrada) {

		fichas = entrada;

		d7fichas = fichas.pasarFichas();

	}

	public void setAplfaqs(Faqs entrada) {

		aplfaqs = entrada;
		d7faqs = aplfaqs.pasarFaqs();
	}

	
	public void saveListaFichasdos(Session conn) {
		try {

			D7AplicacionesFichas fichaActual;
			if (d7fichas.size() > 0) {
				for (int i = 0; i < d7fichas.size(); i++) {

					fichaActual = (D7AplicacionesFichas) d7fichas.get(i);
					fichaActual.setFicaplcod(CodigoAplicacion);
					
					saveFicha(conn, fichaActual);

				}
			}

		} catch (Exception ex) {

		}

	}
	
	public void saveListaFichas(Session conn) {
		try {

			D7AplicacionesFichas fichaActual;
			if (d7fichas.size() > 0) {
				for (int i = 0; i < d7fichas.size(); i++) {

					fichaActual = (D7AplicacionesFichas) d7fichas.get(i);
					
					
					saveFicha(conn, fichaActual);

				}
			}

		} catch (Exception ex) {

		}

	}

	public void saveApartadosFaqs(Session conn) {
		try {
			D7AplicacionesFaqsGrupos grupoactual;
			D7AplicacionesFaqs faqactual;
			if (d7apartados.size() > 0) {
				for (int i = 0; i < d7apartados.size(); i++) {

					grupoactual = (D7AplicacionesFaqsGrupos) d7apartados.get(i);
					grupoactual.setFgraplcod(CodigoAplicacion);
					grupoactual.setFgrsiscod(user.getDatosMenu().idSelected());
					saveApartado(conn, grupoactual);

				}
			}

			if (d7faqs.size() > 0) {
				for (int i = 0; i < d7faqs.size(); i++) {

					faqactual = (D7AplicacionesFaqs) d7faqs.get(i);
					faqactual.setFaqaplcod(CodigoAplicacion);
					faqactual.setFaqsiscod(user.getDatosMenu().idSelected());
					faqactual.setFaquseralta(user.getIdentificador());
					faqactual.setFaqfecalta(new Date());
					saveFaq(conn, faqactual);

				}
			}

		} catch (Exception ex) {

		}

	}

	public void saveFaq(Session conn, D7AplicacionesFaqs grupo) {
		String qry = "";

		grupo.setFaqtexto(URLDecoder.decode(grupo.getFaqtexto()));
		grupo.setFaqasunto(URLDecoder.decode(grupo.getFaqasunto()));
		int largo = 0;
		try {

			if (grupo.getFaqcod() == null) {

				int cod = 0;
				PreparedStatement pstmt = null;
				ResultSet rs = null;
				qry = "SELECT MAX(FAQ_COD) FROM DUMBO.D7_APLICACIONES_FAQS WHERE FAQ_SIS_COD='"
						+ user.getDatosMenu().idSelected()
						+ "' AND FAQ_APL_COD='" + grupo.getFaqaplcod() + "'";
				pstmt = conn.connection().prepareStatement(qry);
				rs = pstmt.executeQuery();
				if (rs.next()) {
					cod = rs.getInt(1) + 1;
					codigo = new Integer(cod);
					grupo.setFaqcod(new Integer(cod));

				}
				Transaction tx = conn.beginTransaction();
				grupo.setFaqsiscod(user.getDatosMenu().idSelected());
				grupo.setFaquseralta(user.getIdentificador());
				grupo.setFaqfecalta(new Date());
				conn.save(grupo);
				tx.commit();

			} else {

				Criteria ct = conn.createCriteria(D7AplicacionesFaqs.class);

				ct = ct.add(Expression.eq("faqsiscod", grupo.getFaqsiscod()));
				ct = ct.add(Expression.eq("faqaplcod", grupo.getFaqaplcod()));
				ct = ct.add(Expression.sql("faq_cod="
						+ grupo.getFaqcod().toString() + " "));
				List l = ct.list();

				if (l != null && l.size() > 0) {

					Transaction tx = conn.beginTransaction();
					D7AplicacionesFaqs aux = (D7AplicacionesFaqs) l.get(0);
					if (!grupo.getFaqcod().equals("")) {

						aux.setFaqasunto(grupo.getFaqasunto());
						aux.setFaqtexto(grupo.getFaqtexto());
						aux.setFaqestado(grupo.getFaqestado());

						/*if ((!aux.getFaqorden().equals(grupo.getFaqorden()))
								|| (!aux.getFaqfgrcod().equals(
										grupo.getFaqfgrcod()))) {
							D7AplicacionesFaqs aux2 = new D7AplicacionesFaqs();
							aux2.setFaqcod(aux.getFaqcod());
							aux2.setFaqaplcod(aux.getFaqaplcod());
							aux2.setFaqsiscod(aux.getFaqsiscod());
							aux2.setFaqfgrcod(aux.getFaqfgrcod());
							aux2.setFaqorden(aux.getFaqorden());
							modificarorden(conn, aux2, grupo);
						}*/

						aux.setFaqfgrcod(grupo.getFaqfgrcod());
						aux.setFaqorden(grupo.getFaqorden());

						conn.saveOrUpdate(aux);
						tx.commit();
					}

				} else {
					if (grupo.getFaqfgrcod().equals(new Integer(0))) {
						grupo.setFaqfgrcod(null);
					}
					Transaction tx = conn.beginTransaction();
					grupo.setFaqsiscod(user.getDatosMenu().idSelected());
					grupo.setFaquseralta(user.getIdentificador());
					grupo.setFaqfecalta(new Date());
					conn.save(grupo);
					tx.commit();

				}

			}

			setErrorMessage("Se aadieron los datos correctamente");

		} catch (Exception ex) {
			setErrorMessage("Save faq:" + ex + ";" + qry + " largo: " + largo);
		}
	}

	public void savecabficha(Session conn, D7Aplicaciones apli){
		try{
			apli.setAplDetalle(URLDecoder.decode(apli.getAplDetalle()));
			
			} catch (Exception ex) {
				String aux="";
				String aux2="'";
				for (int x=0; x < apli.getAplDetalle().length(); x++) {
					  if ((int)apli.getAplDetalle().charAt(x) < 128 && (int)apli.getAplDetalle().charAt(x) != 13 && (int)apli.getAplDetalle().charAt(x) != 10)
					    aux += apli.getAplDetalle().charAt(x);
					  aux2 += (int)apli.getAplDetalle().charAt(x)+"' '";
					}
				
				
					aux = aux.replaceAll("%uF0B7", "");
					apli.setAplDetalle(URLDecoder.decode(aux));
				
					
				
				
				
			}
		
			try{
				apli.setAplDescrip(URLDecoder.decode(apli.getAplDescrip()));
				
				} catch (Exception ex) {
					String aux="";
					String aux2="'";
					for (int x=0; x < apli.getAplDescrip().length(); x++) {
						  if ((int)apli.getAplDescrip().charAt(x) < 128 && (int)apli.getAplDescrip().charAt(x) != 13 && (int)apli.getAplDescrip().charAt(x) != 10)
						    aux += apli.getAplDescrip().charAt(x);
						  aux2 += (int)apli.getAplDescrip().charAt(x)+"' '";
						}
					
					
						aux = aux.replaceAll("%uF0B7", "");
						apli.setAplDescrip(URLDecoder.decode(aux));
					
						
					
					
					
				}
			
		
		try{
			Criteria ct = conn.createCriteria(D7Aplicaciones.class);
			
			ct = ct.add(Expression.eq("AplSisCod", user.getDatosMenu().idSelected()));
			ct = ct.add(Expression.eq("AplCod", apli.getAplCod()));
			List l = ct.list();

			if (l != null && l.size() > 0) {
				Transaction tx = conn.beginTransaction();
				D7Aplicaciones aux = (D7Aplicaciones) l.get(0);

				
				
				
				
				aux.setAplDescrip(apli.getAplDescrip());
				aux.setAplDetalle(apli.getAplDetalle());
				aux.setUrl(apli.getUrl());
				aux.setUrlinfo(apli.getUrlinfo());
				conn.saveOrUpdate(aux);
				tx.commit();
				
			}
			
			
		}catch(Exception ex){
			setErrorMessage("Save Cabecera Ficha:" + ex);
		}
		
		
		
	}
	
	public void saveFicha(Session conn, D7AplicacionesFichas grupo) {
		String qry = "";
		try{
		grupo.setFicapftexto(URLDecoder.decode(grupo.getFicapftexto()));
		
		} catch (Exception ex) {
			String aux="";
			String aux2="'";
			for (int x=0; x < grupo.getFicapftexto().length(); x++) {
				  if ((int)grupo.getFicapftexto().charAt(x) < 128 && (int)grupo.getFicapftexto().charAt(x) != 13 && (int)grupo.getFicapftexto().charAt(x) != 10)
				    aux += grupo.getFicapftexto().charAt(x);
				  aux2 += (int)grupo.getFicapftexto().charAt(x)+"' '";
				}
			
			
				aux = aux.replaceAll("%uF0B7", "");
				grupo.setFicapftexto(URLDecoder.decode(aux));
			
				
			
			
			
		}

		int largo = 0;
		try {
			if(grupo.getFicapftexto()!=null && grupo.getFicapftexto().length()>0){
			Criteria ct = conn.createCriteria(D7AplicacionesFichas.class);

			ct = ct.add(Expression.eq("ficsiscod", grupo.getFicsiscod()));
			ct = ct.add(Expression.eq("ficaplcod", grupo.getFicaplcod()));
			ct = ct.add(Expression.sql("fic_apf_cod="+ grupo.getFicapfcod().toString() + " "));
			List l = ct.list();

			if (l != null && l.size() > 0) {
					qry="ya existe";
				Transaction tx = conn.beginTransaction();
				D7AplicacionesFichas aux = (D7AplicacionesFichas) l.get(0);

				aux.setFicsiscod(grupo.getFicsiscod());
				aux.setFicaplcod(grupo.getFicaplcod());
				aux.setFicapfcod(grupo.getFicapfcod());
				aux.setFicapftexto(grupo.getFicapftexto());
				aux.setFicseccod(grupo.getFicseccod());
				aux.setFicfecactualiza(new Date());

				conn.saveOrUpdate(aux);
				tx.commit();

			} else {
				qry="no existe";
				Transaction tx = conn.beginTransaction();
				grupo.setFicfecactualiza(new Date());
				conn.save(grupo);
				tx.commit();

			}

			//setErrorMessage("Se aadieron los datos correctamente");
			}else{
				Criteria ct = conn.createCriteria(D7AplicacionesFichas.class);

				ct = ct.add(Expression.eq("ficsiscod", grupo.getFicsiscod()));
				ct = ct.add(Expression.eq("ficaplcod", grupo.getFicaplcod()));
				ct = ct.add(Expression.eq("ficapfcod", grupo.getFicapfcod()));
				setErrorMessage("se va ha eliminar");
				List l = ct.list();
				if (l != null && l.size() > 0) {
					setErrorMessage("se elimina uno");
					Transaction tx = conn.beginTransaction();
					conn.delete(l.get(0));
					tx.commit();
				}	
				
				
				
			
			}
			
		} catch (Exception ex) {
			setErrorMessage("Save ficha:" + grupo.getFicapftexto()+ "acon apli:"+ grupo.getFicapfcod()+"' contexto:'"+qry);
		}
	}

	public void modificarorden(Session conn, D7AplicacionesFaqs auxiliar,
			D7AplicacionesFaqs grupo) {
		String qry = "";
		try {

			Criteria ct = conn.createCriteria(D7AplicacionesFaqs.class);
			Transaction tx = conn.beginTransaction();
			D7AplicacionesFaqs aux;
			List l;
			int i;
			if (auxiliar.getFaqfgrcod() != grupo.getFaqfgrcod()) {
				ct = ct
						.add(Expression
								.eq("faqsiscod", auxiliar.getFaqsiscod()));
				ct = ct
						.add(Expression
								.eq("faqaplcod", auxiliar.getFaqaplcod()));
				ct = ct
						.add(Expression
								.eq("faqfgrcod", auxiliar.getFaqfgrcod()));
				ct = ct.add(Expression.sql("faq_orden>"
						+ auxiliar.getFaqorden().toString() + " "));
				l = ct.list();

				for (i = 0; i < l.size(); i++) {
					aux = (D7AplicacionesFaqs) l.get(i);
					aux.setFaqorden(new Integer(
							aux.getFaqorden().intValue() - 1));
					conn.saveOrUpdate(aux);

				}
				ct = conn.createCriteria(D7AplicacionesFaqs.class);
				ct = ct.add(Expression.eq("faqsiscod", grupo.getFaqsiscod()));
				ct = ct.add(Expression.eq("faqaplcod", grupo.getFaqaplcod()));
				ct = ct.add(Expression.eq("faqfgrcod", grupo.getFaqfgrcod()));
				ct = ct.add(Expression.sql("faq_orden>="
						+ grupo.getFaqorden().toString() + " "));
				l = ct.list();

				for (i = 0; i < l.size(); i++) {
					aux = (D7AplicacionesFaqs) l.get(i);
					aux.setFaqorden(new Integer(
							aux.getFaqorden().intValue() + 1));
					conn.saveOrUpdate(aux);

				}

			} else {
				if (auxiliar.getFaqorden().intValue() > grupo.getFaqorden()
						.intValue()) {
					ct = ct.add(Expression.eq("faqsiscod", auxiliar
							.getFaqsiscod()));
					ct = ct.add(Expression.eq("faqaplcod", auxiliar
							.getFaqaplcod()));
					ct = ct.add(Expression.eq("faqfgrcod", auxiliar
							.getFaqfgrcod()));
					ct = ct.add(Expression.sql("faq_orden>="
							+ grupo.getFaqorden().toString()
							+ " AND faq_orden<="
							+ auxiliar.getFaqorden().toString() + " "));
					l = ct.list();

					for (i = 0; i < l.size(); i++) {
						aux = (D7AplicacionesFaqs) l.get(i);
						aux.setFaqorden(new Integer(aux.getFaqorden()
								.intValue() + 1));
						conn.saveOrUpdate(aux);

					}

				}
				ct = conn.createCriteria(D7AplicacionesFaqs.class);
				ct = ct.add(Expression.eq("faqsiscod", grupo.getFaqsiscod()));
				ct = ct.add(Expression.eq("faqaplcod", grupo.getFaqaplcod()));
				ct = ct.add(Expression.eq("faqfgrcod", grupo.getFaqfgrcod()));
				ct = ct.add(Expression.sql("faq_orden<="
						+ grupo.getFaqorden().toString() + " AND faq_orden>="
						+ auxiliar.getFaqorden().toString() + " "));
				l = ct.list();

				for (i = 0; i < l.size(); i++) {
					aux = (D7AplicacionesFaqs) l.get(i);
					aux.setFaqorden(new Integer(
							aux.getFaqorden().intValue() - 1));
					conn.saveOrUpdate(aux);

				}

			}

			tx.commit();

		} catch (Exception ex) {
			setErrorMessage("Modifica orden faq:" + ex + ";" + qry);
		}
	}

	public void modificarordenApart(Session conn,
			D7AplicacionesFaqsGrupos auxiliar, D7AplicacionesFaqsGrupos grupo) {
		String qry = "";
		try {

			Criteria ct = conn.createCriteria(D7AplicacionesFaqsGrupos.class);
			Transaction tx = conn.beginTransaction();
			D7AplicacionesFaqsGrupos aux;
			List l;
			int i;
			if (auxiliar.getFgrfgrcod() != grupo.getFgrfgrcod()) {
				ct = ct
						.add(Expression
								.eq("fgrsiscod", auxiliar.getFgrsiscod()));
				ct = ct
						.add(Expression
								.eq("fgraplcod", auxiliar.getFgraplcod()));
				ct = ct
						.add(Expression
								.eq("fgrfgrcod", auxiliar.getFgrfgrcod()));
				ct = ct.add(Expression.sql("fgr_orden>"
						+ auxiliar.getFgrorden().toString() + " "));
				l = ct.list();

				for (i = 0; i < l.size(); i++) {
					aux = (D7AplicacionesFaqsGrupos) l.get(i);
					aux.setFgrorden(new Integer(
							aux.getFgrorden().intValue() - 1));
					conn.saveOrUpdate(aux);

				}
				ct = conn.createCriteria(D7AplicacionesFaqsGrupos.class);
				ct = ct.add(Expression.eq("fgrsiscod", grupo.getFgrsiscod()));
				ct = ct.add(Expression.eq("fgraplcod", grupo.getFgraplcod()));
				ct = ct.add(Expression.eq("fgrfgrcod", grupo.getFgrfgrcod()));
				ct = ct.add(Expression.sql("fgr_orden>="
						+ grupo.getFgrorden().toString() + " "));
				l = ct.list();

				for (i = 0; i < l.size(); i++) {
					aux = (D7AplicacionesFaqsGrupos) l.get(i);
					aux.setFgrorden(new Integer(
							aux.getFgrorden().intValue() + 1));
					conn.saveOrUpdate(aux);

				}

			} else {
				if (auxiliar.getFgrorden().intValue() > grupo.getFgrorden()
						.intValue()) {
					ct = ct.add(Expression.eq("fgrsiscod", auxiliar
							.getFgrsiscod()));
					ct = ct.add(Expression.eq("fgraplcod", auxiliar
							.getFgraplcod()));
					ct = ct.add(Expression.eq("fgrfgrcod", auxiliar
							.getFgrfgrcod()));
					ct = ct.add(Expression.sql("fgr_orden>="
							+ grupo.getFgrorden().toString()
							+ " AND fgr_orden<="
							+ auxiliar.getFgrorden().toString() + " "));
					l = ct.list();

					for (i = 0; i < l.size(); i++) {
						aux = (D7AplicacionesFaqsGrupos) l.get(i);
						aux.setFgrorden(new Integer(aux.getFgrorden()
								.intValue() + 1));
						conn.saveOrUpdate(aux);

					}

				}
				ct = conn.createCriteria(D7AplicacionesFaqs.class);
				ct = ct.add(Expression.eq("fgrsiscod", grupo.getFgrsiscod()));
				ct = ct.add(Expression.eq("fgraplcod", grupo.getFgraplcod()));
				ct = ct.add(Expression.eq("fgrfgrcod", grupo.getFgrfgrcod()));
				ct = ct.add(Expression.sql("fgr_orden<="
						+ grupo.getFgrorden().toString() + " AND fgr_orden>="
						+ auxiliar.getFgrorden().toString() + " "));
				l = ct.list();

				for (i = 0; i < l.size(); i++) {
					aux = (D7AplicacionesFaqsGrupos) l.get(i);
					aux.setFgrorden(new Integer(
							aux.getFgrorden().intValue() - 1));
					conn.saveOrUpdate(aux);

				}

			}

			tx.commit();

		} catch (Exception ex) {
			setErrorMessage("Modifica orden Apartado:" + ex + ";" + qry);
		}
	}

	public void saveApartado(Session conn, D7AplicacionesFaqsGrupos grupo) {
		String qry = "";
		String salida = "";
		System.out.println(grupo.getFgrtexto());
		System.out.println(URLDecoder.decode(grupo.getFgrtexto()));
		grupo.setFgrtexto(URLDecoder.decode(grupo.getFgrtexto()));

		try {

			if (grupo.getFgrcod() == null) {

				int cod = 0;
				PreparedStatement pstmt = null;
				ResultSet rs = null;
				qry = "SELECT MAX(FGR_COD) FROM DUMBO.D7_APLICACIONES_FAQS_GRUPOS WHERE FGR_SIS_COD='"
						+ user.getDatosMenu().idSelected()
						+ "' AND FGR_APL_COD='" + grupo.getFgraplcod() + "'";
				pstmt = conn.connection().prepareStatement(qry);
				rs = pstmt.executeQuery();
				if (rs.next()) {
					cod = rs.getInt(1) + 1;
					codigo = new Integer(cod);
					grupo.setFgrcod(new Integer(cod));

				}
				grupo.setFgrsiscod(user.getDatosMenu().idSelected());

				Transaction tx = conn.beginTransaction();

				conn.save(grupo);
				tx.commit();

			} else {

				Criteria ct = conn
						.createCriteria(D7AplicacionesFaqsGrupos.class);

				ct = ct.add(Expression.eq("fgrsiscod", grupo.getFgrsiscod()));
				ct = ct.add(Expression.eq("fgraplcod", grupo.getFgraplcod()));
				ct = ct.add(Expression.sql(" fgr_cod="
						+ grupo.getFgrcod().toString() + " "));
				List l = ct.list();

				if (l != null && l.size() > 0) {

					Transaction tx = conn.beginTransaction();
					D7AplicacionesFaqsGrupos aux = (D7AplicacionesFaqsGrupos) l
							.get(0);
					if (!grupo.getFgrcod().equals("")) {

						aux.setFgrestado(grupo.getFgrestado());
						if (aux.getFgrestado().equals("N")) {
							Criteria ct3 = conn
									.createCriteria(D7AplicacionesFaqsGrupos.class);
							ct3 = ct3.add(Expression.eq("fgrfgrcod", grupo
									.getFgrcod()));
							ct3 = ct3.add(Expression.eq("fgraplcod", grupo
									.getFgraplcod()));
							ct3 = ct3.add(Expression.eq("fgrsiscod", grupo
									.getFgrsiscod()));
							ct3 = ct3.add(Expression.eq("fgrestado", "V"));
							List l3 = ct3.list();

							Criteria ct2 = conn
									.createCriteria(D7AplicacionesFaqs.class);
							ct2 = ct2.add(Expression.eq("faqfgrcod", grupo
									.getFgrcod()));
							ct2 = ct2.add(Expression.eq("faqaplcod", grupo
									.getFgraplcod()));
							ct2 = ct2.add(Expression.eq("faqsiscod", grupo
									.getFgrsiscod()));
							ct2 = ct2.add(Expression.eq("faqestado", "V"));

							List l2 = ct2.list();
							if ((l3 != null && l3.size() > 0)
									|| (l2 != null && l2.size() > 0)) {

								setErrorMessage("Apartado matiene estado a vigente por tener faqs o apartados vigentes. ");
								aux.setFgrestado("V");
							}
						}
/*
						if ((!aux.getFgrorden().equals(grupo.getFgrorden()))
								|| (!aux.getFgrfgrcod().equals(
										grupo.getFgrfgrcod()))) {
							D7AplicacionesFaqsGrupos aux2 = new D7AplicacionesFaqsGrupos();
							aux2.setFgrcod(aux.getFgrcod());
							aux2.setFgraplcod(aux.getFgraplcod());
							aux2.setFgrsiscod(aux.getFgrsiscod());
							aux2.setFgrfgrcod(aux.getFgrfgrcod());
							aux2.setFgrorden(aux.getFgrorden());
							modificarordenApart(conn, aux2, grupo);
						}*/

						aux.setFgrfgrcod(grupo.getFgrfgrcod());
						aux.setFgrorden(grupo.getFgrorden());
						aux.setFgrtexto(grupo.getFgrtexto());

						conn.saveOrUpdate(aux);
						tx.commit();
					}

				} else {
					if (grupo.getFgrfgrcod().equals(new Integer(0))) {
						grupo.setFgrfgrcod(null);
					}
					Transaction tx = conn.beginTransaction();

					conn.save(grupo);
					tx.commit();

				}

			}

			setErrorMessage(getErrorMessage()
					+ "  Se aadieron los datos correctamente");

		} catch (Exception ex) {
			setErrorMessage("Save Apartado:" + ex + ";" + qry);
		}
	}

	/** CREAS LAS SECUENCIAS DE LOS ARRAYS Y DA DE ALTA LA APLICACION */
	public void saveAplicacion(Session conn, D7Aplicaciones apli) {

		apli.setAplSisCod(user.getDatosMenu().idSelected());
		CodigoAplicacion = apli.getAplCod();
		CodigoSeccion = apli.getAplSecCod();

		aplicacion = apli;
		D7AplicacionesInformaticos ai = null;
		Transaction tx = null;

		try {
			// Creamos transaccin para poder hacer revert si hubo erro en alg
			// mtodo
			tx = conn.beginTransaction();
			conn.save(aplicacion);
			saveAplicacionParametros(conn);
			saveAplicacionMaximos(conn);
			for (int i = 0; i < responsables.length; i++) {
				ai = new D7AplicacionesInformaticos();
				ai.setAinSisCod(user.getDatosMenu().idSelected());
				ai.setAinAplCod(CodigoAplicacion);
				ai.setAinInfCod(responsables[i]);
				ai.setAinResponsable("Y");
				// Se pasan desde la pgina los informticos responsables
				// ordenados por orden de prioridad
				// (La prioridad es el ndice del array en ste caso)
				int index = i + 1;
				ai.setAinPrioridad(new Integer(index));
				saveInformaticoAplicacion(conn, ai);
			}
			tx.commit();

			aplicacion = null;
			setErrorMessage("La aplicacin ha sido creada correctamente.");

		} catch (Exception ex) {
			tx.rollback();
			setErrorMessage(ex.toString());
		}
	}

	/** MODIFICACION DE APLICACIONES */
	public void updateAplicacion(Session conn, D7Aplicaciones apli) {
		List aplicacionesInformaticosEliminar;
		// Las aplicaciones no tiene autoreferencias
		CodigoAplicacion = apli.getAplCod();
		apli.setAplSisCod(user.getDatosMenu().idSelected());

		Transaction tx = null;
		try {
			tx = conn.beginTransaction();
			if (ResponsablesOp != null) {
				Query q;
				q = conn
						.createQuery(getQuery("AplicacionesInformaticosNoResponsables"));
				q = q.setString("sist", user.getDatosMenu().idSelected());
				q = q.setString("cod", apli.getAplPadreAplCod());
				aplicacionesInformaticosEliminar = (List) q.list();
				// La opcin traspasar traspasa todos los informticos
				// vinculados menos el mximo responsable.
				if (ResponsablesOp.equals("Traspasar")) {
					// Borramos primero todos los informticos no responsables
					// de la aplicacin padre.
					for (int i = 0; i < aplicacionesInformaticosEliminar.size(); i++) {
						conn
								.delete((D7AplicacionesInformaticos) aplicacionesInformaticosEliminar
										.get(i));
						conn.flush();
					}
					D7AplicacionesInformaticos ai;
					for (int i = 0; i < aplicacionesInformaticosEliminar.size(); i++) {
						ai = (D7AplicacionesInformaticos) aplicacionesInformaticosEliminar
								.get(i);
						ai.setAinAplCod(apli.getAplCod());
						conn.saveOrUpdate(ai);
						conn.flush();
					}

				}// La opcin eliminar elimina todos los informticos
					// vinculados menos el mximo responsable.
				if (ResponsablesOp.equals("Eliminar")) {

					/*
					 * q =
					 * conn.createQuery(getQuery("AplicacionesResponsableMenosMaxResponsable"));
					 * q = q.setString("sist",user.getDatosMenu().idSelected());
					 * q = q.setString("cod",apli.getAplPadreAplCod());
					 * aplicacionesInformaticosEliminar = (List)q.list();
					 * for(int i=0; i<aplicacionesInformaticosEliminar.size();i++) {
					 * conn.delete((D7AplicacionesInformaticos)aplicacionesInformaticosEliminar.get(i)); }
					 */
					for (int i = 0; i < aplicacionesInformaticosEliminar.size(); i++) {
						conn
								.delete((D7AplicacionesInformaticos) aplicacionesInformaticosEliminar
										.get(i));
					}
				}
			}
			// Cambiamos de seccion tambin a todas las hijas de esta aplicacin
			if (modifica == true) {
				this.QueryAplicacionesHijas(conn, apli);
				if (!aplicacionesHijas.isEmpty()) {
					for (int i = 0; i < aplicacionesHijas.size(); i++) {
						D7Aplicaciones ap = (D7Aplicaciones) aplicacionesHijas
								.get(i);
						ap.setAplSecCod(apli.getAplSecCod());
						conn.save(ap);
					}
				}
			}
			conn.update(apli);
			tx.commit();
			setErrorMessage("La aplicacin ha sido modificada correctamente.");
		} catch (Exception ex) {
			tx.rollback();
			System.out.println(ex);
			setErrorMessage("Error al actualizar aplicacin");
		}

	}

	/** BAJA DE APLICACIONES */
	public void removeAplicacion(Session conn, D7Aplicaciones apli) {
		// no se puede borrar si tiene asignada alguna tarea ?
		this.QueryTareas(conn, apli);
		if (Tareas.isEmpty()) {
			this.QueryAplicaciones(conn, apli);
			try {
				// Comprobamos si hay INFORMTICOS asociados y en caso de ser
				// as los borramos
				this.QueryAplicacionesInformaticos(conn, apli);
				if (!aplicacionesInformaticos.isEmpty()) {
					Iterator it = aplicacionesInformaticos.iterator();
					while (it.hasNext()) {
						conn.delete((D7AplicacionesInformaticos) it.next());
						conn.flush();
						conn.connection().commit();
					}
				}
				// Compruebo si hay entradas en la tabla Aplicaciones PARMETROS
				// y en caso de ser as los elimino
				this.QueryAplicacionesParametros(conn, apli);
				if (!aplicacionesParametros.isEmpty()) {
					Iterator it = aplicacionesParametros.iterator();
					while (it.hasNext()) {
						conn.delete((D7AplicacionesParametros) it.next());
						conn.flush();
						conn.connection().commit();
					}
				}
				// Compruebo si hay entradas en la tabla Aplicaciones MAXIMOS y
				// en caso de ser as los elimino
				this.QueryAplicacionesMaximos(conn, apli);
				if (!aplicacionesMaximos.isEmpty()) {
					Iterator it = aplicacionesMaximos.iterator();
					while (it.hasNext()) {
						conn.delete((D7AplicacionesMaximos) it.next());
						conn.flush();
						conn.connection().commit();
					}
				}

				aplicacion = (D7Aplicaciones) aplicaciones.get(0);// Si hemos
																	// recargado
																	// la pagina
																	// despues
																	// de haber
																	// borrado
																	// salta
																	// excepcion
																	// nullpointer

				conn.delete(aplicacion);
				conn.flush();
				conn.connection().commit();

				// Eliminar perfil gestor cuando el informtico ya no sea
				// responsable de ninguna aplicacin o seccin
				if (!aplicacionesInformaticos.isEmpty()) {
					Iterator it = aplicacionesInformaticos.iterator();
					while (it.hasNext()) {
						eliminaPerfilGestor(conn,
								(D7AplicacionesInformaticos) it.next());
					}
				}
				aplicaciones.remove(aplicacion);

				prioridades = null;
				tiposTareas = null;
				setErrorMessage("La aplicacin ha sido eliminada correctamente.");

			} catch (IndexOutOfBoundsException nex) {
				setErrorMessage("No se puede eliminar una Aplicacion que no existe (ERROR al Recargar)");
			} catch (Exception ex) {
				aplicaciones.remove(aplicacion);
				setErrorMessage("exception: " + ex);
			}
		} else {
			setErrorMessage("No se puede eliminar la Aplicacin porque tiene alguna TAREA asociada");
		}
	}

	/** CAMBIO DE ESTADO DE LA APLICACION */
	public void changeState(Session conn, D7Aplicaciones apli) {
		apli.setAplSisCod(user.getDatosMenu().idSelected());
		aplicacion = apli;

		this.QueryAplicaciones(conn, apli);
		aplicacion = (D7Aplicaciones) aplicaciones.get(0);

		try {
			if (aplicacion.getAplEstado().equals("V")) {
				aplicacion.setAplEstado("N");
			} else {
				aplicacion.setAplEstado("V");
			}
			conn.update(aplicacion);
			conn.flush();
			conn.connection().commit();
			// Elimino la aplicacion para que no se mape aun despues de haberle
			// cambiado el estado,
			// Esto error solo ocurre cuando una seccin es su padre debido a
			// las condiciones de la primera llamada recursiva
			aplicaciones.remove(aplicacion);

			this.QueryTareasPendientes(conn, apli);
			setErrorMessage("Se ha realizado el cambio de estado correctamente");

			if (!Tareas.isEmpty() && aplicacion.getAplEstado().equals("N")) {
				setErrorMessage("Atencin!, la aplicacin a la que cambi el estado tiene tareas pendientes.");
			}
		} catch (Exception ex) {
			setErrorMessage("Error al cambiar estado");
		}
	}

	/** ASIGNACION DE INFORMTICO A APLICACION (AL CREAR LA APLICACIN) */
	public void saveInformaticoAplicacion(Session conn,
			D7AplicacionesInformaticos infApli) throws Exception {
		List perfiles;

		infApli.setAinSisCod(user.getDatosMenu().idSelected());
		if (infApli.getAinAplCod() == null) {
			infApli.setAinAplCod(CodigoAplicacion);
		}
		try {
			conn.save(infApli);
			// Cada vez que se asigna un informtico responsable a una
			// aplicacin, se le activa el perfil de gestor (slo si no lo tena
			// activo).
			// Clave primara para perfil gestor (sistema,codigoGestor)
			if (infApli.getAinResponsable().equals("Y")) {
				Query q = conn.createQuery(getQuery("PerfilGestorInformatico"));
				q = q.setString("sist", user.getDatosMenu().idSelected());
				q = q.setString("inf", infApli.getAinInfCod());
				q = q.setString("cod", codigoGestor);
				perfiles = (List) q.list();
				if (perfiles.size() == 0) {
					D7InformaticosPerfiles ip = new D7InformaticosPerfiles();
					ip.setIpeInfCod(infApli.getAinInfCod());
					ip.setIpePerCod(codigoGestor);
					ip.setIpeSisCod(user.getDatosMenu().idSelected());
					conn.save(ip);
				}
			}
			infApli = null;
		} catch (Exception ex) {
			throw new Exception("Error al asociar informticos: " + ex);
		}
	}

	/** PARA AADIR INFORMTICOS TRAS CREAR LA APLICACIN */
	// Vincula un informatico a una aplicacion
	public void updateInformaticoAplicacion(Session conn,
			D7AplicacionesInformaticos infApli) {
		List perfiles;

		infApli.setAinSisCod(user.getDatosMenu().idSelected());
		if (infApli.getAinAplCod() == null) {
			infApli.setAinAplCod(CodigoAplicacion);
		}
		try {
			conn.save(infApli);
			conn.flush();
			conn.connection().commit();
			// Cada vez que se asigna un informtico responsable a una
			// aplicacin, se le activa el perfil de gestor (slo si no lo tena
			// activo).
			// Clave primara para perfil gestor (sistema,codigoGestor)
			if (infApli.getAinResponsable().equals("Y")) {
				Query q = conn.createQuery(getQuery("PerfilGestorInformatico"));
				q = q.setString("sist", user.getDatosMenu().idSelected());
				q = q.setString("inf", infApli.getAinInfCod());
				q = q.setString("cod", codigoGestor);
				perfiles = (List) q.list();
				if (perfiles.size() == 0) {
					D7InformaticosPerfiles ip = new D7InformaticosPerfiles();
					ip.setIpeInfCod(infApli.getAinInfCod());
					ip.setIpePerCod(codigoGestor);
					ip.setIpeSisCod(user.getDatosMenu().idSelected());
					conn.save(ip);
					conn.flush();
					conn.connection().commit();
				}
			}
			infApli = null;
		} catch (Exception ex) {
			setErrorMessage("No se pudo asociar el informtico a la aplicacin. Compruebe los datos introducidos");
		}
	}

	// Modifica un informatico vinculado a una aplicacion
	public void modificarResponsable(Session conn, String Codigo) {
		List perfiles;

		D7AplicacionesInformaticos ai = new D7AplicacionesInformaticos();
		try {

			// D7AplicacionesInformaticos ai = new D7AplicacionesInformaticos();
			ai.setAinSisCod(user.getDatosMenu().idSelected());
			ai.setAinInfCod(Codigo);
			if (prio.length() == 0) {
				ai.setAinPrioridad(null);
			} else {
				ai.setAinPrioridad(new Integer(prio));
			}
			ai.setAinResponsable(responflag);
			ai.setAinAplCod(apl);

			conn.update(ai);
			conn.flush();
			conn.connection().commit();
			// Cada vez que se asigna un informtico responsable a una
			// aplicacin, se le activa el perfil de gestor (slo si no lo tena
			// activo).
			// Clave primara para perfil gestor (sistema,codigoGestor)
			if (responflag.equals("Y")) {
				Query q = conn.createQuery(getQuery("PerfilGestorInformatico"));
				q = q.setString("sist", user.getDatosMenu().idSelected());
				q = q.setString("inf", Codigo);
				q = q.setString("cod", codigoGestor);
				perfiles = (List) q.list();
				if (perfiles.size() == 0) {
					D7InformaticosPerfiles ip = new D7InformaticosPerfiles();
					ip.setIpeInfCod(Codigo);
					ip.setIpePerCod(codigoGestor);
					ip.setIpeSisCod(user.getDatosMenu().idSelected());
					conn.save(ip);
					conn.flush();
					conn.connection().commit();
				}
			}
		} catch (Exception ex) {
			setErrorMessage("No se pudo modificar el responsable");
			System.out.println(ex);
		}

	}

	public void removeApartado(Session conn, D7AplicacionesFaqsGrupos al) {
		try {

			Criteria ct = conn.createCriteria(D7AplicacionesFaqsGrupos.class);

			ct = ct.add(Expression.eq("fgrfgrcod", al.getFgrcod()));
			ct = ct.add(Expression.eq("fgraplcod", al.getFgraplcod()));
			ct = ct.add(Expression.eq("fgrsiscod", al.getFgrsiscod()));
			List l = ct.list();

			Criteria ct2 = conn.createCriteria(D7AplicacionesFaqs.class);
			ct2 = ct2.add(Expression.eq("faqfgrcod", al.getFgrcod()));
			ct2 = ct2.add(Expression.eq("faqaplcod", al.getFgraplcod()));
			ct2 = ct2.add(Expression.eq("faqsiscod", al.getFgrsiscod()));

			List l2 = ct2.list();
			if ((l != null && l.size() > 0) || (l2 != null && l2.size() > 0)) {

				setErrorMessage("Apartado Contine hijos");
			} else {

				Criteria ct3 = conn
						.createCriteria(D7AplicacionesFaqsGrupos.class);

				ct3 = ct3.add(Expression.eq("fgrsiscod", al.getFgrsiscod()));
				ct3 = ct3.add(Expression.eq("fgraplcod", al.getFgraplcod()));
				ct3 = ct3.add(Expression.eq("fgrcod", al.getFgrcod()));

				List l3 = ct3.list();

				if (l3 != null && l3.size() > 0) {
					Transaction tx = conn.beginTransaction();
					conn.delete(l3.get(0));
					tx.commit();
				}
				setErrorMessage("Apartado Eliminado correctamente");

			}

		} catch (Exception ex) {
			setErrorMessage("Eliminar Apartado: " + ex);
		}
	}

	public void removeFaq(Session conn, D7AplicacionesFaqs al) {
		try {

			Criteria ct = conn.createCriteria(D7AplicacionesFaqs.class);

			ct = ct.add(Expression.eq("faqsiscod", al.getFaqsiscod()));
			ct = ct.add(Expression.eq("faqaplcod", al.getFaqaplcod()));
			ct = ct.add(Expression.eq("faqcod", al.getFaqcod()));

			List l = ct.list();
			if (l != null && l.size() > 0) {
				Transaction tx = conn.beginTransaction();
				conn.delete(l.get(0));
				tx.commit();
			}
			setErrorMessage("Faq Eliminada correctamente");
		} catch (Exception ex) {
			setErrorMessage("Eliminar Faqs: " + ex);
		}
	}

	/** ELIMINACIN DE UNA ASOCIACION INFORMTICOS-APLICACION */
	public void removeInformaticoAplicacion(Session conn,
			D7AplicacionesInformaticos infApli) {
		infApli.setAinSisCod(user.getDatosMenu().idSelected());

		try {
			conn.delete(infApli);
			conn.flush();
			conn.connection().commit();
			eliminaPerfilGestor(conn, infApli);
			infApli = null;
		} catch (Exception ex) {
			setErrorMessage("No se pudo eliminar la aplicacin");
		}
	}

	// Mtodo que comprueba si el Informtico est asociado a alguna seccin o
	// alguna aplicacin.
	// En caso negativo, se le eliminar el perfil de gestor de grupo, excepto
	// si es el nico perfil que tiene.
	public void eliminaPerfilGestor(Session conn,
			D7AplicacionesInformaticos infApli) {
		List seccionesRespon = null, aplicacionesRespon = null, perfilesRespon = null;
		try {
			Query q1 = conn
					.createQuery(getQuery("CompruebaResponsableSeccion"));
			q1 = q1.setString("sist", user.getDatosMenu().idSelected());
			q1 = q1.setString("inf", infApli.getAinInfCod());
			seccionesRespon = (List) q1.list();

			Query q2 = conn
					.createQuery(getQuery("CompruebaResponsableAplicacion"));
			q2 = q2.setString("sist", user.getDatosMenu().idSelected());
			q2 = q2.setString("inf", infApli.getAinInfCod());
			aplicacionesRespon = (List) q2.list();

			Query q3 = conn.createQuery(getQuery("listaPerfilesInformatico"));
			q3 = q3.setString("sist", user.getDatosMenu().idSelected());
			q3 = q3.setString("inf", infApli.getAinInfCod());
			// Si era responsable de aplicacion o seccion y solo tiene un
			// perfil, este es el perfil gestor y no se debe eliminar
			perfilesRespon = (List) q3.list();

			// Si ambos listados dieron como resultado 0, el infomtico no es
			// responsable de ninguna seccin o aplicacin.
			// Se puede eliminar su perfil de gestor de grupo
			// (codigoGestor="11")
			if ((seccionesRespon.size() == 0)
					&& (aplicacionesRespon.size() == 0)
					&& (perfilesRespon.size()) != 1) {
				for (int i = 0; i < perfilesRespon.size(); i++) {
					if (((D7InformaticosPerfiles) perfilesRespon.get(i))
							.getIpePerCod().equals(codigoGestor)) {
						conn.delete(((D7InformaticosPerfiles) perfilesRespon
								.get(i)));
						conn.flush();
						conn.connection().commit();
					}
				}
			}
		} catch (Exception e) {
			setErrorMessage("Error al eliminar perfil de Gestor de grupo");
		}

	}

	/** GUARDO LOS DATOS DE LAS APLICACIONES PARAMETROS */
	public void setTiposTar(String[] tar) {
		TiposTar = tar;
	}

	public void setUrgencia(String[] Urg) {
		Urgencias = Urg;
	}

	public void setPrioridad(String[] Pri) {
		Prioridades = Pri;
	}

	public void saveAplicacionParametros(Session conn) throws Exception {

		if (TiposTar == null)
			return;
		D7AplicacionesParametros[] apliParam = new D7AplicacionesParametros[TiposTar.length];

		for (int i = 0; i < TiposTar.length; i++) {
			apliParam[i] = new D7AplicacionesParametros();
			apliParam[i].setApaSisCod(user.getDatosMenu().idSelected());
			apliParam[i].setApaAplCod(CodigoAplicacion);
			apliParam[i].setApaTipCod(TiposTar[i]);
			apliParam[i].setApaPrioridad(Prioridades[i]);
			apliParam[i].setApaUrgencia(Urgencias[i]);

			try {
				conn.save(apliParam[i]);
			} catch (Exception e) {
				throw new Exception(
						"Error al guardar Parmetros de Aplicacin: " + e);
			}
		}
		apliParam = null;
	}

	public void updateAplicacionParametros(Session conn) {
		D7AplicacionesParametros[] apliParam = new D7AplicacionesParametros[TiposTar.length];

		for (int i = 0; i < TiposTar.length; i++) {
			apliParam[i] = new D7AplicacionesParametros();
			apliParam[i].setApaSisCod(user.getDatosMenu().idSelected());
			apliParam[i].setApaAplCod(CodigoAplicacion);
			apliParam[i].setApaTipCod(TiposTar[i]);
			apliParam[i].setApaPrioridad(Prioridades[i]);
			apliParam[i].setApaUrgencia(Urgencias[i]);

			try {
				conn.update(apliParam[i]);
				conn.flush();
				conn.connection().commit();
			} catch (Exception e) {
				setErrorMessage("Excepcion al guardar Aplicaciones Parmetros "
						+ e);
			}
		}
		apliParam = null;
	}

	/** GUARDO LOS DATOS DE LAS APLICACIONES MAXIMOS */
	public void setPrioridadesCod(String[] priCod) {
		this.priCod = priCod;
	}

	public void setTipoTareasCod(String[] ttarCod) {
		this.ttarCod = ttarCod;
	}

	public void setMaxDias(String[] maxdias) {
		this.maxdias = maxdias;
	}

	// Mtodo para almacenar los das mximos para generar alertas en la
	// aplicacin
	public void saveAplicacionMaximos(Session conn) throws Exception {
		D7AplicacionesMaximos[] apliMax = new D7AplicacionesMaximos[priCod.length];

		for (int i = 0; i < priCod.length; i++) {
			apliMax[i] = new D7AplicacionesMaximos();
			apliMax[i].setAmaSisCod(user.getDatosMenu().idSelected());
			apliMax[i].setAmaAplCod(CodigoAplicacion);
			apliMax[i].setAmaTipCod(ttarCod[i]);
			apliMax[i].setAmaPriCod(priCod[i]);
			apliMax[i].setAmaDias(new BigDecimal(maxdias[i]));

			try {
				conn.save(apliMax[i]);
			} catch (Exception e) {
				throw new Exception("Error al guardar secciones_maximos " + e);
			}
		}
		apliMax = null;
	}

	public void updateAplicacionMaximos(Session conn) {
		D7AplicacionesMaximos[] apliMax = new D7AplicacionesMaximos[priCod.length];

		for (int i = 0; i < priCod.length; i++) {
			apliMax[i] = new D7AplicacionesMaximos();
			apliMax[i].setAmaSisCod(user.getDatosMenu().idSelected());
			apliMax[i].setAmaAplCod(CodigoAplicacion);
			apliMax[i].setAmaTipCod(ttarCod[i]);
			apliMax[i].setAmaPriCod(priCod[i]);
			apliMax[i].setAmaDias(new BigDecimal(maxdias[i]));
			try {
				conn.update(apliMax[i]);
				conn.flush();
				conn.connection().commit();
			} catch (Exception e) {
				setErrorMessage("Excepcion al guardar secciones_maximos " + e);
			}
		}
		apliMax = null;
	}
}// Fin del GestorAplicaciones
