<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet version="1.0" 
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:xforms="http://www.w3.org/2002/xforms">

<xsl:param name="servlet"/>	
<xsl:param name="menu"/>
<xsl:param name="aplCod"/>
<xsl:param name="pestanya"/>

<xsl:variable name="miSeccion"/>
<xsl:variable name="Tarea"/>
<xsl:variable name="Urgencia"/>
<xsl:variable name="Prioridad"/>
<xsl:variable name="tipotareacod"/>
<xsl:variable name="tipotareades"/>
<xsl:variable name="CodigoPrioridad"/>
<xsl:variable name="CodigoTipoTarea"/>
<!--Parametros para mantener filtro-->
<xsl:param name="flag_filtrado"/>
<xsl:param name="Caracter"/>
<xsl:param name="SeccionCod"/>

<xsl:include href="dumbo7/utils/xsl/utils.xsl"/>
	
<xsl:template match="XMLROOT">


<html lang="es">
     <xsl:call-template name="headComun">
         <xsl:with-param name="jscript">
         <script type="text/javascript" src="../js/uitabs/jquery-1.2.3.pack.js"></script>
         <script type="text/javascript" src="../js/modificar.js"></script>
         <script src="../js/uitabs/ui.tabs.pack.js" type="text/javascript"></script>
         <script type="text/javascript" src="../js/filtrar.js"></script>
         <link rel="stylesheet" href="../js/uitabs/ui.tabs.css" type="text/css" media="print, projection, screen"/>
         
            <script languaje="JavaScript">
            var srvName = '<xsl:value-of select="$servlet"/>';
             var aplCod = '<xsl:value-of select="$aplCod"/>';
             var secCod = '<xsl:value-of select="DATA/APLICACIONES/APLICACION/@SECCION"/>';
             var modo = "consulta";
               $(document).ready(function(){
   					$('#container-1 ul').tabs();
   					
   					<xsl:choose>
                	<xsl:when test="$pestanya=''">
                $("#container-1 ul").tabs("select", 0);
                	</xsl:when>
                	<xsl:otherwise>
                $("#container-1 ul").tabs("select", <xsl:value-of select="$pestanya"/>);                	</xsl:otherwise>
                </xsl:choose>
                cargaarbolsin('');
                cargaarbolcon('');
                cargaFicha();
                

  				});
            	function mostrarfaq(asunto, texto){
            		document.modificar.asunto.value = asunto;
            		document.modificar.texto.value = texto;
            		
            		
            	
            	}
                function mostrarError(error){
					alert(error);
				}
				function mantenerFiltro(url)
				{
					var filtrado = '<xsl:value-of select="$flag_filtrado"/>'
					var caracter = '<xsl:value-of select="$Caracter"/>'
					var seccionCod = '<xsl:value-of select="$SeccionCod"/>'
					
					url = url.concat("&amp;flag_filtrado=");
					url = url.concat(filtrado);
					if(caracter!="")
					{
						url = url.concat("&amp;Caracter=");
						url = url.concat(caracter);
					}
					if(seccionCod!="")
					{
						url = url.concat("&amp;SeccionCod=");
						url = url.concat(seccionCod);
					}
					
					window.location.href=url;		
				}
            </script>
			<script LANGUAJE="JavaScript" src="../js/OnMouse.js"></script>
         </xsl:with-param>
	   </xsl:call-template>


<body>
	
	<xsl:call-template name="menuComun">
		<xsl:with-param name="NAME" select="concat(DATA/APLICACIONES/USER/@NAME,concat('(',concat(DATA/APLICACIONES/USER/@LOGIN,')')))"/>
		<xsl:with-param name="MENU" select="DATA/MENU"/>
		<xsl:with-param name="SELECT" select="$menu"/>
		<xsl:with-param name="HELP">administracion.xml#1.1</xsl:with-param>
	</xsl:call-template>

<xsl:call-template name="pieComun"/>
</body>
</html>
</xsl:template>

<xsl:template name="cuerpo">
	<xsl:for-each select="DATA/APLICACIONES">
		<xsl:if test="not(@ERROR='')">
			<script>mostrarError('<xsl:value-of select="@ERROR"/>')</script>
			</xsl:if>
	</xsl:for-each>

<table align="center" border="0" cellpadding="5" cellspacing="5" width="775" height="16" summary="Modificacin de una Aplicacion">


	<tr><td width="650" colspan="3" class="cab1">&#187;Detalle de la aplicacin&#160;
		<!--For Para poder mostrar la descripcion en la cabecera de la tabla-->
		<xsl:for-each select="DATA/APLICACIONES/APLICACION[@CODIGO=$aplCod]">
			&quot;<xsl:value-of select="@DESCRIPCION"/>&quot;
		</xsl:for-each>
	 </td></tr>
	<tr><td colspan="3">
		
		 <div id="container-1">
			<ul>
                <li><a href="#DATOS"><span>Datos de la aplicacion</span></a></li>
                <li><a href="#ESTRUCTURA"><span>Estructura de Faqs</span></a></li>
                <li><a href="#FAQS"><span>Faqs</span></a></li>
                <li><a href="#FICHAS"><span>Ficha</span></a></li>
            </ul>
		
		<!--Parametro para saber cuando asignas un informatico que no tienes que volver al index sino al modificar-->
		<div id="DATOS" class="seccion">	
		<form action="{$servlet}" METHOD="POST" name="modificar">
		<input type="hidden" name="module"/>
		<input type="hidden" name="aplCod" value="{$aplCod}"/>
		<table class="cont" id="aplicaciones" border="0" cellpadding="3" cellspacing="1" width="100%">
		<xsl:for-each select="DATA/APLICACIONES/APLICACION[@CODIGO = $aplCod]">
				<tr>
					<td class="cabe" align="left" colspan="5"><b>Datos de la aplicacin</b></td>
				</tr>
				<tr class="administracion">
					<td align="left" colspan="5"><b>Cdigo:</b>&#160;<xsl:value-of select="@CODIGO"/>
					</td>		
				</tr>
				<tr class="administracion">
					<td align="left" colspan="5"><b>Descripcin:</b>&#160;<xsl:value-of select="@DESCRIPCION"/>
					</td>		
				</tr>
				<tr class="administracion">
					<td align="left" colspan="5"><b>Detalle:</b>&#160;<xsl:value-of select="@DETALLE"/>
					</td>		
				</tr>
				<tr class="administracion">
					<td align="left" colspan="5"><b>Caracter:</b>&#160;
						<xsl:if test="@CARACTER = 'I'">Interno</xsl:if>	
						<xsl:if test="@CARACTER = 'E'">Externo</xsl:if>
					</td>
				</tr>	
				<tr class="administracion">
					<td align="left" colspan="5"><b>Tipo de Asignacin:</b>&#160;
						<xsl:if test="@TIPO_ASIGNACION = 'P'">Por Pesos</xsl:if>	
						<xsl:if test="@TIPO_ASIGNACION = 'R'">A Responsable</xsl:if>
						<xsl:if test="@TIPO_ASIGNACION = 'C'">Por cola de aplicaciones</xsl:if>
						<xsl:if test="@TIPO_ASIGNACION = 'U'">Por Ubicacin</xsl:if>
					</td>
				</tr>	
				<xsl:if test="@TIPO_ASIGNACION = 'R'">
					<tr class="administracion">
						<td align="left" colspan="5"><b>Mandar correo a responsable(s):</b>&#160;
							<xsl:if test="(@CORREO = 'S')">Si</xsl:if>	
							<xsl:if test="(@CORREO = 'N') or not(@CORREO)">No</xsl:if>		
						</td>
					</tr>	
				</xsl:if>	
				<xsl:if test="@TIPO_ASIGNACION = 'C'">
					<tr class="administracion">
						<td align="left" colspan="5"><b>Mandar correo a informticos:</b>&#160;
							<xsl:if test="(@CORREO_INF = 'S') or not(@CORREO_INF)">Si</xsl:if>	
							<xsl:if test="(@CORREO_INF = 'N')">No</xsl:if>		
						</td>
					</tr>	
				</xsl:if>			
				<tr class="administracion">
					<td align="left" colspan="5"><b>Seccin:</b>&#160;
					<xsl:variable name="miSeccion" select="@SECCION"/>
						<xsl:for-each select="../SECCION">
							<xsl:if test="@CODIGO=$miSeccion">
								<xsl:value-of select="@DESCRIPCION"/>
							</xsl:if>
						</xsl:for-each>
					</td>
				</tr>
				<tr class="administracion">
					<td align="left" colspan="5"><b>Estado:</b>&#160;
						<xsl:if test="@ESTADO = 'V'">Vigente</xsl:if>	
						<xsl:if test="@ESTADO = 'N'">No Vigente</xsl:if>
					</td>		
				</tr>
				<tr class="administracion">
					<td align="left" colspan="5"><b>Url:</b>&#160;
						<xsl:value-of select="@URL"/>	
						
					</td>		
				</tr>
				
				<tr class="administracion">
					<td align="left" colspan="5"><b>Url informativa:</b>&#160;
						<xsl:value-of select="@URLINFO"/>	
						
					</td>		
				</tr>	
					
			<!--Se muestran dinmicamente los tipos de tarea-->
			<xsl:for-each select="../TIPO_TAREA">
				<!--Variable para almacenar los tipos de tarea y despues poder identificarlos-->
				<xsl:variable name="Tarea"><xsl:value-of select="@CODIGO"/></xsl:variable>
				<tr class="administracion">
					<td width="15%" align="left"><b><xsl:value-of select="@DESCRIPCION"/></b></td>
					<td width="35%" align="left">Urgente por defecto:
						<xsl:if test="count(../APLICACIONES_PARAMETROS[@URGENCIA and @TIPO_TAREA=$Tarea])= 0">
							Sin urgencia
						</xsl:if>
						<xsl:for-each select="../APLICACIONES_PARAMETROS[@TIPO_TAREA=$Tarea]">
							<xsl:if test="@URGENCIA = 'U'">S</xsl:if>
							<xsl:if test="@URGENCIA = 'N'">No</xsl:if>
						</xsl:for-each>
					</td>
					<td width="60%" align="left">Prioridad por defecto:
						<xsl:if test="count(../APLICACIONES_PARAMETROS[@PRIORIDAD and @TIPO_TAREA=$Tarea])= 0">
							Sin prioridad
						</xsl:if>
						<xsl:for-each select="../APLICACIONES_PARAMETROS[@TIPO_TAREA=$Tarea]">
							<xsl:variable name="Prioridad"><xsl:value-of select="@PRIORIDAD"/></xsl:variable>
							<xsl:for-each select="../PRIORIDADES[@CODIGO = $Prioridad]">
								<xsl:value-of select="@DESCRIPCION"/>
							</xsl:for-each>
						</xsl:for-each>
					</td>
				</tr>
			</xsl:for-each>
				<tr><td colspan="3">
			<table class="cont" align="center" border="0" cellpadding="3" cellspacing="1" width="600" >	
				<tr>
					<td align="left" class="cabe" colspan="5"><b>Alertas para aplicaciones</b></td>
				</tr>
				<tr class="administracion">
					<td align="center" colspan="2"><b>Tipos Tareas</b></td>
					<td align="center" colspan="2"><b>Prioridades</b></td>
					<td align="center"><b>Das Mximos</b></td>
				</tr>
			
				<tr class="administracion">
					<td align="center"><b>Cdigo</b></td>
					<td align="center"><b>Descripcin</b></td>
					<td align="center"><b>Cdigo</b></td>
					<td align="center"><b>Descripcin</b></td>
					<td align="center">&#160;</td>
				</tr>
				
					<xsl:for-each select="../APLICACIONES_MAXIMOS">
							<!--Dentro de secciones maximos no se guarda la descripcion. Para mostrarla, se mapean las prioridades y los tipos tareas-->
							<!--Guardamos los codigos en dos variables para luego poder identificarlas y mostrar su descripcion-->
							<xsl:variable name="CodigoTipoTarea"><xsl:value-of select="@TIPO_TAREA"/></xsl:variable> 
							<xsl:variable name="CodigoPrioridad"><xsl:value-of select="@PRIORIDAD_TAREA"/></xsl:variable>
							<tr class="administracion" onmouseover="javascript:onMouse(this,'true');" onmouseout="javascript:onMouse(this,'false');">
								<td align="center"><xsl:value-of select="@TIPO_TAREA"/></td>
								<xsl:for-each select="../TIPO_TAREA">
										<xsl:if test="(@CODIGO=$CodigoTipoTarea)">
											<td><xsl:value-of select="@DESCRIPCION"/></td>
										</xsl:if>
								</xsl:for-each>
								<td align="center"><xsl:value-of select="@PRIORIDAD_TAREA"/></td>
								<xsl:for-each select="../PRIORIDADES">
										<xsl:if test="(@CODIGO=$CodigoPrioridad)">
											<td><xsl:value-of select="@DESCRIPCION"/></td>
										</xsl:if>
								</xsl:for-each>
								<td align="center"><xsl:value-of select="@DIAS"/></td>
							</tr>
					</xsl:for-each>
				
					
				</table>
			</td></tr>
		</xsl:for-each>	
	</table>
	</form>
	</div>
	<form action="{$servlet}" METHOD="POST" name="apli">
<input type="hidden" name="pestanya" value="0"/>
	<div id="ESTRUCTURA" class="seccion">
		<div id="tablasin">
		
		</div>
			
			
			


		<div id="tablaCargaApart">
		
		
		
		</div>
		
		

						</div>
						
						
						
						<div id="FAQS"  class="seccion">
		
		
		<div id="tablacon">
		
		</div>
		
		<div id="tablacargafaq">
		
		</div>

		</div>
		<div id="FICHAS" class="seccion">
		
			<table class="cont">
			<tbody>
				<tr class="cabe">
					<td colspan="2">Ficha de Aplicacion</td>
					
				</tr>
				<tr class="administracion">
					<td>Cdigo de Aplicacin</td>
					<td><xsl:value-of select="DATA/APLICACIONES/APLICACION/@CODIGO"/></td>
				</tr>
				<tr class="administracion">
					<td width="15%">Descripcin</td>
					<td><xsl:value-of select="DATA/APLICACIONES/APLICACION/@DESCRIPCION"/></td>
				</tr>
				<tr class="administracion">
					<td>Detalle</td>
					<td><xsl:value-of select="DATA/APLICACIONES/APLICACION/@DETALLE"/></td>
				</tr>
				<tr class="administracion">
					<td>Url</td>
					<td><xsl:value-of select="DATA/APLICACIONES/APLICACION/@URL"/></td>
				</tr>
				<tr class="administracion">
					<td>Url informativa</td>
					<td><xsl:value-of select="DATA/APLICACIONES/APLICACION/@URLINFO"/></td>
				</tr>
			</tbody>
			
			
			</table>
			<div id="apartfichas">
			
			</div>

		</div>
	</form>
		</div>
		<table class="cont">
		<tr class="administracion"><td align="center" colspan="6">
					<!--<input type="submit" class="boton" value="Volver" onclick="javascript:document.modificar.module.value='dumbo7/administracion/aplicaciones.formModificar.cancelar'"/> -->
				<form>
					<input type="button" class="boton" value="Volver" onclick="javascript:mantenerFiltro('?module=dumbo7/administracion/aplicaciones.formModificar.cancelar')"/>
					</form>
				</td></tr>
		</table>
	
	</td></tr>
</table>

</xsl:template>
<xsl:template name="carpetarecursiva">
<xsl:param name="profundo"/>
<xsl:param name="codigo"/>

<xsl:for-each select="../APARTADOS[@FGRFGRCOD = $codigo]">
<xsl:sort select="@FGRORDEN"/>
<tr class="administracion">
			<td vigencia="{@FGRESTADO}" class="padre" id="{@FGRCOD}" prof="{$profundo + 1}" style="padding-left: {15* number($profundo)}px;" padre="{@FGRFGRCOD}"><img style="display: none;" border="0" class="plus" src="../dumbo7/utils/table/carpetaCerrada.gif"/><img border="0" class="minus" src="../dumbo7/utils/table/carpetaAbierta.gif"/></td>
			<td colspan="2">
			<xsl:value-of select="@FGRTEXTO"/>
			</td>
			
			 
			
				<td>
				<xsl:choose>
					<xsl:when test="@FGRESTADO = 'N'">
					<img border="0" alt="No Vigente" src="../graficos/iconos/no_vigente.gif"/>
					</xsl:when>
					<xsl:otherwise>
						<img border="0" alt="Vigente" src="../graficos/iconos/vigente.gif"/>
					</xsl:otherwise>
				</xsl:choose>
				
				</td>
			
			
			
			
			
			</tr>

			<xsl:call-template name="carpetarecursiva">
					<xsl:with-param name="profundo" select="number($profundo)+1" />
					<xsl:with-param name="codigo" select="@FGRCOD"/>
			</xsl:call-template>


</xsl:for-each>
<xsl:for-each select="../FAQS[@FAQFGRCOD = $codigo]">
<xsl:sort select="@FAQORDEN"/>
<tr class="administracion">
<td vigencia="{@FAQESTADO}" class="hijo" id="1" prof="{$profundo+1}" padre="{@FAQFGRCOD}">

<img style="padding-left: {15* (number($profundo))}px;" border="0" class="fichero" src="../dumbo7/utils/table/file.gif"/></td><td colspan="2"><a style="text-align:left; background:none" href="javascript:mostrarfaq('{@FAQASUNTO}','{@FAQTEXTO}',{@FAQFGRCOD},'{@FAQORDEN}','{@FAQESTADO}','{@FAQSISCOD}',{@FAQCOD},'{@FAQAPLCOD}')"><xsl:value-of select="@FAQASUNTO"/></a>
</td>
<td>
			<xsl:choose>
				<xsl:when test="@FAQESTADO = 'N'">
				<img border="0" alt="No Vigente" src="../graficos/iconos/no_vigente.gif"/>
				</xsl:when>
				
				<xsl:otherwise>
					<img border="0" alt="Vigente" src="../graficos/iconos/vigente.gif"/>
				</xsl:otherwise>
			
			
			</xsl:choose>
</td>
</tr>


</xsl:for-each>

</xsl:template>
<xsl:template name="tabular">

<xsl:param name="profundo"/>
<xsl:param name="tabulado"/>
			&#160;&#160;&#160;
			<xsl:if test="$profundo>= $tabulado">
			<xsl:call-template name="tabular">
					<xsl:with-param name="profundo" select="$profundo" />
					<xsl:with-param name="tabulado" select="number($tabulado)+1"/>
			</xsl:call-template>
			</xsl:if>

</xsl:template>

</xsl:stylesheet>
	