<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet version="1.0" 
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:xforms="http://www.w3.org/2002/xforms">
	
<xsl:param name="servlet"/>	
<xsl:param name="menu"/>
<xsl:param name="aplCod"/>
<!--Parametros para mantener filtro-->
<xsl:param name="flag_filtrado"/>
<xsl:param name="Caracter"/>
<xsl:param name="SeccionCod"/>	

<xsl:include href="dumbo7/utils/xsl/utils.xsl"/>
	
<xsl:template match="XMLROOT">

	<html lang="es">
     <xsl:call-template name="headComun">
         <xsl:with-param name="jscript">
             <SCRIPT LANGUAGE="JavaScript">
				function mantenerFiltro(url)
				{
					var filtrado = '<xsl:value-of select="$flag_filtrado"/>'
					var caracter = '<xsl:value-of select="$Caracter"/>'
					var seccionCod = '<xsl:value-of select="$SeccionCod"/>'
					
					url = url.concat("&amp;flag_filtrado=");
					url = url.concat(filtrado);
					if(caracter!="")
					{
						url = url.concat("&amp;Caracter=");
						url = url.concat(caracter);
					}
					if(seccionCod!="")
					{
						url = url.concat("&amp;SeccionCod=");
						url = url.concat(seccionCod);
					}
					
					window.location.href=url;		
				}
				function abrirPopup(url)
				{
					newWindow = window.open(url,'_blanck',"height=230,width=450,status=no,toolbar=no,menubar=no,location=no,scrollbars=no");				
					newWindow.moveTo(self.screen.width/4,self.screen.height/4);
				}  
				<!--function cerrar(){
					document.listado.submit();
				}-->
            </SCRIPT>
			<script LANGUAJE="JavaScript" src="../js/OnMouse.js"></script>
         </xsl:with-param>
	   </xsl:call-template>

<body>
		
	<xsl:call-template name="menuComun">
		<xsl:with-param name="NAME" select="concat(DATA/APLICACIONES/USER/@NAME,concat('(',concat(DATA/APLICACIONES/USER/@LOGIN,')')))"/>
		<xsl:with-param name="MENU" select="DATA/MENU"/>
		<xsl:with-param name="SELECT" select="$menu"/>
		<xsl:with-param name="HELP">administracion.xml#1.1</xsl:with-param>
	</xsl:call-template>

<xsl:call-template name="pieComun"/>
</body>
</html>

</xsl:template>

<xsl:template name="cuerpo">

	<table align="center" border="0" cellpadding="5" cellspacing="5" width="775" summary="Esta tabla contiene un listado de INFORMATICOS asociados ">
	<tr><td width="700" colspan="2" class="cab1">&#187;<xsl:call-template name="traduce"><xsl:with-param name="id" select="'Informticos'"/></xsl:call-template> vinculados a 
		<!--For Para poder mostrar la descripcion en la cabecera de la tabla-->
		<xsl:for-each select="DATA/APLICACIONES/APLICACION[@CODIGO=$aplCod]">		
			&quot;<xsl:value-of select="@DESCRIPCION"/>&quot; 		
		</xsl:for-each>
	</td></tr>
	<tr><td>
		<form action="{$servlet}" METHOD="POST" name="listado">
			<input type="hidden" name="module" value="dumbo7/administracion/aplicaciones.formListarInformaticos.indice"/>
			<table class="cont" border="0" cellpadding="3" cellspacing="1" width="100%" summary="Tabla para crear seccion">
				<tr>
					<td class="cabe" width="30"><b><font face="Verdana" size="2">Identificador</font></b></td>
					<td class="cabe" width="500"><b><font face="Verdana" size="2">Apellidos, Nombre</font></b></td>
					<td class="cabe" width="130"><b><font face="Verdana" size="2">Email</font></b></td>
					<td class="cabe" width="100"><b><font face="Verdana" size="2">Tlf</font></b></td>
					<td class="cabe" width="100" align="center"><b><font face="Verdana" size="2">Prioridad</font></b></td>
					<td class="cabe" width="100" align="center"><b><font face="Verdana" size="2">Respon</font></b></td>
				</tr>

				<xsl:for-each select="DATA/APLICACIONES/DATOS_PERSONALES">
					<xsl:sort select="@APELLIDOS"/>
					<tr class="administracion" onmouseover="javascript:onMouse(this,'true');" onmouseout="javascript:onMouse(this,'false');">
					
						<xsl:variable name="codInf"><xsl:value-of select="@IDENTIFICADOR"/></xsl:variable> 
						
						<xsl:for-each select="../APLICACIONES_INFORMATICOS[@INFORMATICO=$codInf]">
							<xsl:variable name="codAplInf"><xsl:value-of select="@INFORMATICO"/></xsl:variable> 
							
								<xsl:for-each select="../INFORMATICOS[@CODIGO=$codAplInf]">
	
								<!--Si el estado es vigente se muestran los datos en color normal-->
								<!--Si el estado es vigente se muestran los datos en color normal-->
								<xsl:if test="@ESTADO = 'V'">
									<td width="30"><xsl:value-of select="$codAplInf"/></td>
									<td width="200">
										<a title="{../DATOS_PERSONALES[@IDENTIFICADOR=$codInf]/@APELLIDOS}, {../DATOS_PERSONALES[@IDENTIFICADOR=$codInf]/@NOMBRE}"  href="javascript:abrirPopup('?module=dumbo7/inicio.detalleUser&amp;user={$codInf}')">
											<xsl:value-of select="../DATOS_PERSONALES[@IDENTIFICADOR=$codInf]/@APELLIDOS"/>,&#160;<xsl:value-of select="../DATOS_PERSONALES[@IDENTIFICADOR=$codInf]/@NOMBRE"/>
										</a>	
									</td>
									<td width="150">
										<label title="{../DATOS_PERSONALES[@IDENTIFICADOR=$codAplInf]/@EMAIL}">
												<!--SI TIENE MENOS DE 20 CARACTERES-->
												<xsl:if test="24>=string-length(../DATOS_PERSONALES[@IDENTIFICADOR=$codAplInf]/@EMAIL)">								
													<xsl:value-of select="../DATOS_PERSONALES[@IDENTIFICADOR=$codAplInf]/@EMAIL"/>
												</xsl:if>
												<!--SI TIENE MAS DE 20 CARACTERES-->
												<xsl:if test="string-length(../DATOS_PERSONALES[@IDENTIFICADOR=$codAplInf]/@EMAIL)>24">
													<xsl:value-of select="concat(substring(../DATOS_PERSONALES[@IDENTIFICADOR=$codAplInf]/@EMAIL,0,24) ,'...')"/>
												</xsl:if>
										</label>
									</td>
									<td width="100"><xsl:value-of select="../DATOS_PERSONALES[@IDENTIFICADOR=$codAplInf]/@TELEFONO"/></td>
								<!--</xsl:for-each>-->
								<td width="100" align="center"><xsl:value-of select="../APLICACIONES_INFORMATICOS[@INFORMATICO=$codInf]/@PRIORIDAD"/></td>
								<td width="100" align="center">
									<xsl:if test="../APLICACIONES_INFORMATICOS[@INFORMATICO=$codInf]/@RESPONSABLE = 'Y'">
										Si
									</xsl:if>
									<xsl:if test="../APLICACIONES_INFORMATICOS[@INFORMATICO=$codInf]/@RESPONSABLE = 'N'">
										No
									</xsl:if>
								</td>
							</xsl:if>
							<xsl:variable name="traducido"><xsl:call-template name="traduce"><xsl:with-param name="id" select="'informtico'"/></xsl:call-template></xsl:variable>
							<xsl:variable name="Traducido"><xsl:call-template name="traduce"><xsl:with-param name="id" select="'Informtico'"/></xsl:call-template></xsl:variable>
							
							<!--Si el estado es no vigente se muestran los datos en color rojo-->
							<xsl:if test="../INFORMATICOS[@CODIGO=$codAplInf]/@ESTADO = 'N'">
									<td width="30"><label title="{$Traducido} no vigente"><font color="#999999"><xsl:value-of select="$codAplInf"/></font></label></td>
									<td width="200">
										<label title="{$Traducido} no vigente">
											<a title="{$Traducido} no vigente"  href="javascript:abrirPopup('?module=dumbo7/inicio.detalleUser&amp;user={$codInf}')">
												<font color="#999999"><xsl:value-of select="../DATOS_PERSONALES[@IDENTIFICADOR=$codInf]/@APELLIDOS"/>,&#160;<xsl:value-of select="../DATOS_PERSONALES[@IDENTIFICADOR=$codInf]/@NOMBRE"/></font>
											</a>
										</label>
									</td>
									<td width="150">
										<label title="{../DATOS_PERSONALES[@IDENTIFICADOR=$codAplInf]/@EMAIL}">
												<!--SI TIENE MENOS DE 20 CARACTERES-->
												<xsl:if test="24>=string-length(../DATOS_PERSONALES[@IDENTIFICADOR=$codAplInf]/@EMAIL)">								
													<font color="#999999"><xsl:value-of select="../DATOS_PERSONALES[@IDENTIFICADOR=$codAplInf]/@EMAIL"/></font>
												</xsl:if>
												<!--SI TIENE MAS DE 20 CARACTERES-->
												<xsl:if test="string-length(../DATOS_PERSONALES[@IDENTIFICADOR=$codAplInf]/@EMAIL)>24">
													<font color="#999999"><xsl:value-of select="concat(substring(../DATOS_PERSONALES[@IDENTIFICADOR=$codAplInf]/@EMAIL,0,24) ,'...')"/></font>
												</xsl:if>
										</label>
									</td>
									<td width="100"><label title="{$Traducido} no vigente"><font color="#999999"><xsl:value-of select="../DATOS_PERSONALES[@IDENTIFICADOR=$codAplInf]/@TELEFONO"/></font></label></td>
								<td width="100" align="center"><label title="{$Traducido} no vigente"><font color="#999999"><xsl:value-of select="../APLICACIONES_INFORMATICOS[@INFORMATICO=$codInf]/@PRIORIDAD"/></font></label></td>
								<td width="100" align="center">
									<xsl:if test="../APLICACIONES_INFORMATICOS[@INFORMATICO=$codInf]/@RESPONSABLE = 'Y'">
										<label title="{$Traducido} no vigente"><font color="#999999">Si</font></label>
									</xsl:if>
									<xsl:if test="../APLICACIONES_INFORMATICOS[@INFORMATICO=$codInf]/@RESPONSABLE = 'N'">
										<label title="{$Traducido} no vigente"><font color="#999999">No</font></label>
									</xsl:if>
								</td>
							</xsl:if>
							</xsl:for-each>
						</xsl:for-each>
						</tr>
						
						
					</xsl:for-each>
					

				<xsl:if test="count(DATA/APLICACIONES/APLICACIONES_INFORMATICOS)=0">
					<tr>
						<td align="center" colspan="6">* No hay {$traducido} vinculados a esta aplicacin.</td>
					</tr>
				</xsl:if>
				<tr class="administracion" align="center"><td colspan="6">
					<CENTER><!--<input type="submit" class="boton" value="Volver"/>-->
					<!--<input type="button" class="boton" value="Volver" onclick="javascript:cerrar()"/>-->
					<input type="button" class="boton" value="Volver" onclick="javascript:mantenerFiltro('?module=dumbo7/administracion/aplicaciones.formAsignarInformaticos.cancelar')"/>
					</CENTER></td></tr>
		
			</table>
		</form>
</td></tr>
</table>
</xsl:template>
</xsl:stylesheet>
	