<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet version="1.0" 
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:xforms="http://www.w3.org/2002/xforms">

<xsl:param name="servlet"/>	
<xsl:param name="menu"/>
<!--Variables para mantener el filtro-->
<xsl:param name="flag_filtrado"/>
<xsl:param name="Caracter"/>
<xsl:param name="SeccionCod"/>
<!--"mostrar" es un flag para el filtrado de aplicaciones (muestra 'todos' o muestra solo los vigentes (''))-->
<xsl:param name="mostrar"/>

<xsl:variable name="seccion"/>
	
<xsl:include href="dumbo7/utils/xsl/utils.xsl"/>

<xsl:template match="XMLROOT">

<html lang="es">

     <xsl:call-template name="headComun">
		<xsl:with-param name="arbol" select="true()"/>
	    <xsl:with-param name="jscript">
		<script type="text/javascript" src="../js/uitabs/jquery-1.2.3.pack.js"></script>
		<script type="text/javascript" src="../js/aplicaciones.js"></script>

			<script LANGUAJE="JavaScript">
			$(document).ready(function(){
               inicio();
                
                

  				});
			
			
			
				function mostrarError(error){
					alert(error);
				}
				function CambiarEstado(url,estado){
					if (confirm("Est seguro de cambiar el estado a " + estado + "?"))
					{
						 //window.open(url,"_self");
						 mantenerFiltro(url);
					}
				}
				function mantenerFiltro(url)
				{
					var filtrado = '<xsl:value-of select="$flag_filtrado"/>'
					var mostrar = '<xsl:value-of select="$mostrar"/>'
					
					url = url.concat("&amp;flag_filtrado=");
					url = url.concat(filtrado);
					if(document.aplicaciones.Caracter.options[document.aplicaciones.Caracter.selectedIndex].value!="")
					{
						url = url.concat("&amp;Caracter=");
						url = url.concat(document.aplicaciones.Caracter.options[document.aplicaciones.Caracter.selectedIndex].value);
					}
					if(document.aplicaciones.SeccionCod.options[document.aplicaciones.SeccionCod.selectedIndex].value!="")
					{
						url = url.concat("&amp;SeccionCod=");
						url = url.concat(document.aplicaciones.SeccionCod.options[document.aplicaciones.SeccionCod.selectedIndex].value);
					}
					url = url.concat("&amp;mostrar=");
					url = url.concat(mostrar);
					window.location.href=url;		
				}
				function filtrar(url)
				{
					var filtrado = '<xsl:value-of select="$flag_filtrado"/>'
					var mostrar = '<xsl:value-of select="$mostrar"/>'
					if (filtrado == 1){filtrado = 0;}
					else              {filtrado = 1;}
					
					if(document.aplicaciones.Caracter.options[document.aplicaciones.Caracter.selectedIndex].value!="" || document.aplicaciones.SeccionCod.options[document.aplicaciones.SeccionCod.selectedIndex].value!="" )
					{
						if(filtrado!=0)
						{
							url = url.concat("&amp;flag_filtrado=");
							url = url.concat(filtrado);
							if(document.aplicaciones.Caracter.options[document.aplicaciones.Caracter.selectedIndex].value!="")
							{
								url = url.concat("&amp;Caracter=");
								url = url.concat(document.aplicaciones.Caracter.options[document.aplicaciones.Caracter.selectedIndex].value);
							}
							if(document.aplicaciones.SeccionCod.options[document.aplicaciones.SeccionCod.selectedIndex].value!="")
							{
								url = url.concat("&amp;SeccionCod=");
								url = url.concat(document.aplicaciones.SeccionCod.options[document.aplicaciones.SeccionCod.selectedIndex].value);
							}
						}
						url = url.concat("&amp;mostrar=");
						url = url.concat(mostrar);
						window.location.href=url;
					}
					else
					{
						alert("Introduzca un parmetro de filtrado");
					}
				}
				//Funcin que muestra informaticos vigentes o no vigentes, manteniendo el filtro por seccion y caracter
				function mostrarInformaticos(url)
				{
					var filtrado = '<xsl:value-of select="$flag_filtrado"/>'
					if(filtrado!=0)
					{
						url = url.concat("&amp;flag_filtrado=");
						url = url.concat(filtrado);
						if(document.aplicaciones.Caracter.options[document.aplicaciones.Caracter.selectedIndex].value!="")
						{
							url = url.concat("&amp;Caracter=");
							url = url.concat(document.aplicaciones.Caracter.options[document.aplicaciones.Caracter.selectedIndex].value);
						}
						if(document.aplicaciones.SeccionCod.options[document.aplicaciones.SeccionCod.selectedIndex].value!="")
						{
							url = url.concat("&amp;SeccionCod=");
							url = url.concat(document.aplicaciones.SeccionCod.options[document.aplicaciones.SeccionCod.selectedIndex].value);
						}
					}
					window.open(url,"_parent");
				}
            </script>
			<script LANGUAJE="JavaScript" src="../js/aplicaciones/PreguntaBorrar.js"></script>
			<script LANGUAJE="JavaScript" src="../js/OnMouse.js"></script>
         </xsl:with-param>
	   </xsl:call-template>

<body>
		
	<xsl:call-template name="menuComun">
		<xsl:with-param name="NAME" select="concat(DATA/APLICACIONES/USER/@NAME,concat('(',concat(DATA/APLICACIONES/USER/@LOGIN,')')))"/>
		<xsl:with-param name="MENU" select="DATA/MENU"/>
		<xsl:with-param name="SELECT" select="$menu"/>
		<xsl:with-param name="HELP">administracion.xml#1.1</xsl:with-param>
	</xsl:call-template>

<xsl:call-template name="pieComun"/>
</body>
</html>

</xsl:template>

<xsl:template name="cuerpo">
<xsl:variable name="traducido"><xsl:call-template name="traduce"><xsl:with-param name="id" select="'informtico'"/></xsl:call-template></xsl:variable>
<table  align="center" border="0" cellpadding="5" cellspacing="5" width="775" height="16" summary="Esta tabla contiene una lista de Aplicaciones">
<form action="{$servlet}" METHOD="GET" name="aplicaciones">
	<tr>
		<td class="cab1" style="width:30%">&#187;Listado de aplicaciones</td>
		<!--Si el flag es distinto de 1, quiere decir que se deben introducir los valores para filtrar-->
		<td align="right">
			<xsl:if test="$flag_filtrado!=1">
				<select name="SeccionCod" size="1">
					<option value="">-Filtrar Seccin-</option>
					<!--Llamamos a la plantilla para indexar las categoras.-->
 					<xsl:call-template name="muestraSeccion">
					<xsl:with-param name="nodo" select="DATA/APLICACIONES"/>
					</xsl:call-template>
				</select>&#160;
				<select name="Caracter" size="1">
					<option	value="">-Filtrar Carcter-</option>
					<option	value="I">Interno</option>
					<option	value="E">Externo</option>
				</select>&#160;
				<a href="javascript:filtrar('?module=dumbo7/administracion/aplicaciones.index')"><img border="0" src="../graficos/iconos/ico_filtroOff.gif" alt="Activar filtrado por carcter"/></a>				
			</xsl:if>
			<!--Si el flag es 1, quiere decir que ya ha habido una consulta con resultado.
				En este caso, los select solo contienen los datos con los que se realizo la consulta-->
			<xsl:if test="$flag_filtrado=1">
				<select name="SeccionCod" size="1">
					<xsl:if test="count(DATA/APLICACIONES/SECCION[@CODIGO=$SeccionCod])=0">
						<option value="">-Sin Valor-</option>
					</xsl:if>
					<xsl:for-each select="DATA/APLICACIONES/SECCION[@CODIGO=$SeccionCod]">
						<option value="{$SeccionCod}"><xsl:value-of select="@DESCRIPCION"/></option>
					</xsl:for-each>
				</select>&#160;
				<select name="Caracter" size="1">
					<xsl:if test="$Caracter='I'">
						<option	value="I" selected="true">Interno</option>
					</xsl:if>
					<xsl:if test="$Caracter='E'">
						<option	value="E" selected="true">Externo</option>
					</xsl:if>
					<xsl:if test="$Caracter=''">
						<option	value="" selected="true">-Sin Valor-</option>
					</xsl:if>
				</select>&#160;
				<a href="javascript:filtrar('?module=dumbo7/administracion/aplicaciones.index')"><img border="0" src="../graficos/iconos/ico_filtroOn.gif" alt="Desactivar filtrado por carcter"/></a>				
			</xsl:if>
		</td>
		<td>
		<input type="text" class="filtro" value=""/>
		</td>
		<td width="20" style="align:center">
			<xsl:if test="count(DATA/APLICACIONES/APLICACION[@ESTADO='N'])>0">
				<xsl:if test="$mostrar='todos'">
					<a href="JavaScript:mostrarInformaticos('{$servlet}?module=dumbo7/administracion/aplicaciones.index')">Mostrar Vigentes</a>
				</xsl:if>
				<xsl:if test="$mostrar=''">
					<a href="JavaScript:mostrarInformaticos('{$servlet}?module=dumbo7/administracion/aplicaciones.index&amp;mostrar=todos');">Mostrar Todas</a>
				</xsl:if>
			</xsl:if>
		</td>
		<td width="20" style="align:center">
			<a href="javascript:mantenerFiltro('?module=dumbo7/administracion/aplicaciones.index.nueva')">Insertar Aplicacin</a>
		</td>
	</tr>
	<tr><td colspan="5">






<table class="cont" cellspacing="1" cellpadding="3" border="0">

<!-- cabecera de la tabla -->
<tr>
<td class="cabe" width="4%" align="center">
</td>

<td width="4%" align="center" colspan="2" class="cabe"><b><font size="2" face="Verdana">Estado</font>
      </b>
</td>

<td width="4%" align="center" class="cabe"><b><font size="2" face="Verdana">Asig</font>
</b>
</td>
<td width="4%" align="center" class="cabe"><b><font size="2" face="Verdana">Car</font>
</b>
</td>

<td width="4%" class="cabe"><b><font size="2" face="Verdana">Cd</font>
</b>
</td>

<td width="30%" class="cabe"><b><font size="2" face="Verdana">Descripcin</font>
</b>
</td>
<td width="30%" class="cabe"><b><font size="2" face="Verdana">Seccin </font>
                           </b>
                        </td>
<td colspan="5" class="cabe"/>
</tr>



	<xsl:for-each select="DATA/APLICACIONES/APLICACION[count(@PADRE)=0 and ((@ESTADO='V' and $mostrar='') or ($mostrar='todos'))]">
	<xsl:sort select="@CODIGO"/>
	
		<xsl:variable name="seccion" select="@SECCION"/>
		<xsl:variable name="padre" select="@CODIGO"/>
		<tr>
		<xsl:choose>
			<xsl:when test="count(../APLICACION[@PADRE=$padre])>0">
			<xsl:attribute name="bgcolor">#EEF2F6</xsl:attribute>
			<xsl:attribute name="class">nodopadre</xsl:attribute>
			</xsl:when>
			<xsl:when test="@CARACTER='I'">
			<xsl:attribute name="bgcolor">#FFFFFF</xsl:attribute>
			<xsl:attribute name="class">nodolibre</xsl:attribute>
			</xsl:when>
			<xsl:otherwise>
			<xsl:attribute name="bgcolor">#f2f0e3</xsl:attribute>
			<xsl:attribute name="class">nodolibre</xsl:attribute>
			</xsl:otherwise>
		</xsl:choose>
			
		<td>
		<xsl:if test="count(../APLICACION[@PADRE=$padre])>0">
		<xsl:attribute name="class">padre</xsl:attribute>
		</xsl:if>
		
		
		<xsl:if test="count(../APLICACION[@PADRE=$padre])!=0">
		<center>
		
		<img border="0" src="../dumbo7/utils/table/plus.gif" class="plus"/>
		<img border="0" src="../dumbo7/utils/table/minus.gif" class="minus" style="display: none;"/>
		</center>
		</xsl:if>
		</td>
		<td>
		<center>
		<xsl:choose>
		<xsl:when test="@ESTADO='V'">
					<img  border="0" src="../graficos/iconos/vigente.gif" alt="Vigente"/>
		</xsl:when>		
				<xsl:otherwise>
					 <img border="0" src="../graficos/iconos/no_vigente.gif" alt="No Vigente"/>
				</xsl:otherwise>
		
		
		</xsl:choose>
		<!-- <img border="0" alt="Vigente" src="../graficos/iconos/vigente.gif"/> -->
		</center>
		</td>
		<td>
		</td>
	
		<td>
		<center>
		<xsl:choose>
		
		<xsl:when test="@TIPO_ASIGNACION = 'P'">
					<img border="0" src="../graficos/iconos/balanza.gif" alt="Asignacin por Pesos"/>
				</xsl:when>	
				<xsl:when test="@TIPO_ASIGNACION = 'R'">
					<img border="0" src="../graficos/iconos/responsables.gif" alt="Asignacin por Responsable"/>
				</xsl:when>
				<xsl:otherwise>
					<img border="0" src="../graficos/iconos/cola.gif" alt="Asignacin por cola de aplicaciones"/>
				</xsl:otherwise>
		<!--  <img border="0" alt="Asignacin por cola de aplicaciones" src="../graficos/iconos/cola.gif"/>-->
		</xsl:choose>
		</center>
		</td>
		
		<td>
		<center>
		<xsl:choose>
		<xsl:when test="@CARACTER = 'I'">
					<img border="0" src="../graficos/iconos/caracter_interno_ico.gif" alt="Carcter interno"/>
				</xsl:when>
				<xsl:otherwise>
					<img border="0" src="../graficos/iconos/caracter_externo_ico.gif" alt="Carcter externo"/>
				</xsl:otherwise>
		
		</xsl:choose>
		
		
		<!-- <img border="0" alt="Carcter interno" src="../graficos/iconos/caracter_interno_ico.gif"/> -->
        </center>
		</td>	
		<td>
		<xsl:value-of select="@CODIGO"/>
		</td>
		<td>
	<center>	
	<a title="{@DETALLE}" href="javascript:mantenerFiltro('?module=dumbo7/administracion/aplicaciones.index.verDetalle&amp;aplCod={@CODIGO}')"><xsl:value-of select="@DESCRIPCION"/></a>
		</center>
		</td>

		<td>
		<xsl:value-of select="../SECCION[@CODIGO=$seccion]/@DESCRIPCION"/>
		
		</td>
		<td>
		<center>
		<a href="javascript:mantenerFiltro('?module=dumbo7/administracion/aplicaciones.index.AsignarInformaticos&amp;aplCod={@CODIGO}')"><img  border="0" src="../graficos/iconos/Informatico+-.gif" alt="Vincular/Desvincular {$traducido}"/></a>
		</center>
		</td>
		
		<td>
		<center>
							<a href="javascript:mantenerFiltro('?module=dumbo7/administracion/aplicaciones.index.listarAplInformaticos&amp;aplCod={@CODIGO}')"><img  border="0" src="../graficos/iconos/Informatico.gif" alt="Consultar {$traducido}"/></a>
		</center>
		</td>
		<xsl:variable name="codpadre" select="@CODIGO"/>
		<td>
		<center>
		
<xsl:choose>
		
		<xsl:when test="count(../APLICACION[@PADRE=$codpadre])>0">
		<img border="0" alt="No se puede cambiar el estado, debido a dependencias con subaplicaciones." src="../graficos/iconos/CambiarEstado_off.gif"/>
		</xsl:when>
		<xsl:when test="@ESTADO='V'">
		<a href="JavaScript:CambiarEstado('{$servlet}?module=dumbo7/administracion/aplicaciones.index.cambiar&amp;aplCod={@CODIGO}','NO VIGENTE');"><img border="0" src="../graficos/iconos/CambiarEstadoNV.gif" alt="Cambiar Estado de Aplicacin a NO VIGENTE"/></a>
		</xsl:when>
		<xsl:otherwise>
		<a href="JavaScript:CambiarEstado('{$servlet}?module=dumbo7/administracion/aplicaciones.index.cambiar&amp;aplCod={@CODIGO}','VIGENTE');"><img border="0" src="../graficos/iconos/CambiarEstadoV.gif" alt="Cambiar Estado de Aplicacin a VIGENTE"/></a>
		</xsl:otherwise>
</xsl:choose>
		</center>
		</td>
		<td>
		<center>
		<CENTER><a href="javascript:mantenerFiltro('?module=dumbo7/administracion/aplicaciones.index.modificar&amp;aplCod={@CODIGO}')"><img  border="0" src="../graficos/iconos/modificar.gif" alt="Modificar Aplicacin"/></a></CENTER>
		</center>
		</td>
		<td>
		<center>
		<xsl:choose>
			<xsl:when test="count(../APLICACION[@PADRE=$codpadre])>0">
			<img border="0" alt="Eliminar Aplicacin" src="../graficos/iconos/eliminar_off.gif"/>
			
			</xsl:when>
			<xsl:otherwise>
							<a href="javascript:validar('?module=dumbo7/administracion/aplicaciones.index.eliminar&amp;aplCod={@CODIGO}',arrayDescripcion['{@CODIGO}']);"><img border="0" src="../graficos/iconos/eliminar.gif" alt="Eliminar Aplicacin"/></a>
			</xsl:otherwise>
		</xsl:choose>
		
		</center>
		</td>


		</tr>
	 <xsl:call-template name="hijas">
				<xsl:with-param name="codpadre" select="@CODIGO" />
		</xsl:call-template>

	</xsl:for-each>

</table>
</td>
</tr>
</form>
</table>

</xsl:template>


<!--Plantillas para poner las hijas-->
<xsl:template name="hijas">
<xsl:param name="codpadre" />
<xsl:variable name="traducido"><xsl:call-template name="traduce"><xsl:with-param name="id" select="'informtico'"/></xsl:call-template></xsl:variable>
	<xsl:for-each select="../APLICACION[@PADRE=$codpadre and ((@ESTADO='V' and $mostrar='') or ($mostrar='todos'))]">
<xsl:variable name="seccion" select="@SECCION"/>
		<xsl:variable name="padre" select="@CODIGO"/>
		<tr style="display: none;">
		<xsl:choose>
		<xsl:when test="@CARACTER='I'">
			<xsl:attribute name="bgcolor">#FFFFFF</xsl:attribute>
			
			</xsl:when>
			<xsl:otherwise>
			<xsl:attribute name="bgcolor">#f2f0e3</xsl:attribute>
			
			</xsl:otherwise>
			</xsl:choose>
		<td class="hijo">
		
		<xsl:if test="count(../APLICACION[@PADRE=$padre])!=0">
		<center>
		
		<img border="0" onclick="expandcontent(this,'arb.2');" src="../dumbo7/utils/table/plus.gif" class="showstate" id="img.arb.2"/>
		</center>
		</xsl:if>
		</td>
		<td>
		</td>
		<td>
		<center>
		<xsl:choose>
		<xsl:when test="@ESTADO='V'">
					<img  border="0" src="../graficos/iconos/vigente.gif" alt="Vigente"/>
		</xsl:when>		
				<xsl:otherwise>
					 <img border="0" src="../graficos/iconos/no_vigente.gif" alt="No Vigente"/>
				</xsl:otherwise>
		
		
		</xsl:choose>
		<!-- <img border="0" alt="Vigente" src="../graficos/iconos/vigente.gif"/> -->
		</center>
		</td>
		
	
		<td>
		<center>
		<xsl:choose>
		
		<xsl:when test="@TIPO_ASIGNACION = 'P'">
					<img border="0" src="../graficos/iconos/balanza.gif" alt="Asignacin por Pesos"/>
				</xsl:when>	
				<xsl:when test="@TIPO_ASIGNACION = 'R'">
					<img border="0" src="../graficos/iconos/responsables.gif" alt="Asignacin por Responsable"/>
				</xsl:when>
				<xsl:otherwise>
					<img border="0" src="../graficos/iconos/cola.gif" alt="Asignacin por cola de aplicaciones"/>
				</xsl:otherwise>
		<!--  <img border="0" alt="Asignacin por cola de aplicaciones" src="../graficos/iconos/cola.gif"/>-->
		</xsl:choose>
		</center>
		</td>
		
		<td>
		<center>
		<xsl:choose>
		<xsl:when test="@CARACTER = 'I'">
					<img border="0" src="../graficos/iconos/caracter_interno_ico.gif" alt="Carcter interno"/>
				</xsl:when>
				<xsl:otherwise>
					<img border="0" src="../graficos/iconos/caracter_externo_ico.gif" alt="Carcter externo"/>
				</xsl:otherwise>
		
		</xsl:choose>
		
		
		<!-- <img border="0" alt="Carcter interno" src="../graficos/iconos/caracter_interno_ico.gif"/> -->
        </center>
		</td>	
		<td>
		<xsl:value-of select="@CODIGO"/>
		</td>
		<td>
	<center>	
	<a title="{@DETALLE}" href="javascript:mantenerFiltro('?module=dumbo7/administracion/aplicaciones.index.verDetalle&amp;aplCod={@CODIGO}')"><xsl:value-of select="@DESCRIPCION"/></a>
		</center>
		</td>

		<td>
		<xsl:value-of select="../SECCION[@CODIGO=$seccion]/@DESCRIPCION"/>
		
		</td>
		<td>
		<center>
		<a href="javascript:mantenerFiltro('?module=dumbo7/administracion/aplicaciones.index.AsignarInformaticos&amp;aplCod={@CODIGO}')"><img  border="0" src="../graficos/iconos/Informatico+-.gif" alt="Vincular/Desvincular {$traducido}"/></a>
		</center>
		</td>
		
		<td>
		<center>
							<a href="javascript:mantenerFiltro('?module=dumbo7/administracion/aplicaciones.index.listarAplInformaticos&amp;aplCod={@CODIGO}')"><img  border="0" src="../graficos/iconos/Informatico.gif" alt="Consultar {$traducido}"/></a>
		</center>
		</td>
		<xsl:variable name="codpadre" select="@CODIGO"/>
		<td>
		<center>
		
<xsl:choose>
		
		<xsl:when test="count(../APLICACION[@PADRE=$codpadre])>0">
		<img border="0" alt="No se puede cambiar el estado, debido a dependencias con subaplicaciones." src="../graficos/iconos/CambiarEstado_off.gif"/>
		</xsl:when>
		<xsl:when test="@ESTADO='V'">
		<a href="JavaScript:CambiarEstado('{$servlet}?module=dumbo7/administracion/aplicaciones.index.cambiar&amp;aplCod={@CODIGO}','NO VIGENTE');"><img border="0" src="../graficos/iconos/CambiarEstadoNV.gif" alt="Cambiar Estado de Aplicacin a NO VIGENTE"/></a>
		</xsl:when>
		<xsl:otherwise>
		<a href="JavaScript:CambiarEstado('{$servlet}?module=dumbo7/administracion/aplicaciones.index.cambiar&amp;aplCod={@CODIGO}','VIGENTE');"><img border="0" src="../graficos/iconos/CambiarEstadoV.gif" alt="Cambiar Estado de Aplicacin a VIGENTE"/></a>
		</xsl:otherwise>
</xsl:choose>
		</center>
		</td>
		<td>
		<center>
		<CENTER><a href="javascript:mantenerFiltro('?module=dumbo7/administracion/aplicaciones.index.modificar&amp;aplCod={@CODIGO}')"><img  border="0" src="../graficos/iconos/modificar.gif" alt="Modificar Aplicacin"/></a></CENTER>
		</center>
		</td>
		<td>
		<center>
		<xsl:choose>
			<xsl:when test="count(../APLICACION[@PADRE=$codpadre])>0">
			<img border="0" alt="Eliminar Aplicacin" src="../graficos/iconos/eliminar_off.gif"/>
			
			</xsl:when>
			<xsl:otherwise>
							<a href="javascript:validar('?module=dumbo7/administracion/aplicaciones.index.eliminar&amp;aplCod={@CODIGO}',arrayDescripcion['{@CODIGO}']);"><img border="0" src="../graficos/iconos/eliminar.gif" alt="Eliminar Aplicacin"/></a>
			</xsl:otherwise>
		</xsl:choose>
		
		</center>
		</td>


		</tr>

	</xsl:for-each>


</xsl:template>

<xsl:template name="muestraSeccion">
<xsl:param name="nodo"/>
[1]
    <xsl:for-each select="$nodo/SECCION[@CODIGO=@PADRE]">
        <xsl:sort select="@CODIGO"/>
        <option value="{@CODIGO}"><xsl:value-of select="@DESCRIPCION"/></option>
        <xsl:call-template name="sacaSubSeccion">
            <xsl:with-param name="seccion" select="$nodo"/>
            <xsl:with-param name="codigo_padre" select="@CODIGO"/>
            <xsl:with-param name="espacio" select="'&#160;&#160;'"/>
        </xsl:call-template>
    </xsl:for-each>
</xsl:template>

<xsl:template name="sacaSubSeccion">
<xsl:param name="seccion"/>
<xsl:param name="codigo_padre"/>
<xsl:param name="espacio"/>

    <xsl:for-each select="$seccion/SECCION[@PADRE=$codigo_padre and @PADRE!=@CODIGO]">
        <xsl:sort select="@CODIGO"/>
        <option value="{@CODIGO}"><xsl:value-of select="$espacio"/><xsl:value-of select="@DESCRIPCION"/></option>
        <xsl:call-template name="sacaSubSeccion">
            <xsl:with-param name="seccion" select="$seccion"/>
            <xsl:with-param name="codigo_padre" select="@CODIGO"/>
            <xsl:with-param name="espacio" select="concat($espacio,'&#160;&#160;')"/>
        </xsl:call-template>
    </xsl:for-each>
</xsl:template>


</xsl:stylesheet>
