<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet version="1.0" 
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:xforms="http://www.w3.org/2002/xforms">
	
<xsl:param name="servlet"/>	

<xsl:param name="modulo"/>
<xsl:param name="infCod"/>
<xsl:param name="aplCod"/>
<!--Parametros para mantener filtro-->
<xsl:param name="flag_filtrado"/>
<xsl:param name="Caracter"/>
<xsl:param name="SeccionCod"/>	

<xsl:template match="XMLROOT">
<HTML>
	<script>
	//Activa/Desactiva el desplegable de prioridad dependiendo de si es responsable o no
	function ActivarDesactivar()
	{
		document.apli.ainPrioridad.disabled=!document.apli.ainPrioridad.disabled
		if(document.apli.ainPrioridad.disabled)
		{
			document.apli.ainPrioridad.Value = "";
		}
	}
	//devuelve  0--> prioridad ya puesta
	//			1--> prioridad fuera de rango
	//			2--> OK
	function compruebaPrioridad(prio){
		var cont=0;
		<xsl:for-each select="DATA/APLICACIONES/APLICACIONES_INFORMATICOS">
			if(prio=='<xsl:value-of select="@PRIORIDAD"/>')
			{
				cont=cont+1;						
			}
		</xsl:for-each>
		if(cont!=0){
			cont=0;
			return 0;	
		}
		if ((prio &lt; 1) || (prio > 99)) return 1;
		return 2;
	}
	//Actualizamos los datos modificados
	function actualizar()
	{
		var filtrado = '<xsl:value-of select="$flag_filtrado"/>'
		var caracter = '<xsl:value-of select="$Caracter"/>'
		var seccionCod = '<xsl:value-of select="$SeccionCod"/>'
		
		url = '?module=dumbo7/administracion/aplicaciones.popupModificarResponsable.actualizar';
		url = url.concat("&amp;infCod=");
		url = url.concat(document.apli.infCod.value);
		url = url.concat("&amp;responflag=");
		url = url.concat(document.apli.ainResponsable.value);
		url = url.concat("&amp;prio=");
		if(document.apli.ainResponsable.value=='Y')
		{
			var valor=compruebaPrioridad(document.apli.ainPrioridad.value);
			if (valor == 0){
				alert("Esa prioridad ya est asignada, introduzca otra.");
				return;
			}
			else{
				if (valor == 1){
					alert("Prioridad fuera de rango, debe estar entre 1 y 99.");
					return;
				}
			}
			url = url.concat(document.apli.ainPrioridad.value);
		}
		url = url.concat("&amp;aplCod=");
		url = url.concat(document.apli.aplCod.value);
		
		url = url.concat("&amp;flag_filtrado=");
		url = url.concat(filtrado);
		if(caracter!="")
		{
			url = url.concat("&amp;Caracter=");
			url = url.concat(caracter);
		}
		if(seccionCod!="")
		{
			url = url.concat("&amp;SeccionCod=");
			url = url.concat(seccionCod);
		}
		window.opener.location.href=url;
		window.close();
	}
	</script>
  <HEAD>
    <META HTTP-EQUIV="expires" CONTENT="01 01 1900 GMT"/>
    <META HTTP-EQUIV="Pragma" CONTENT="NO-CACHE"/>
    <TITLE>DUMBO7: Modificar Responsable</TITLE>
	<link REL="stylesheet" HREF="../estilosD.css" TYPE="text/css"/>
  </HEAD>
<body>
<center>
	<form name="apli" action="{$servlet}" METHOD="POST">
	<input type="hidden" name="module"/>
	<input type="hidden" name="infCod" value="{$infCod}"/>
	<input type="hidden" name="aplCod" value="{$aplCod}"/>
	
	<table class="contout" width="90%">
		<tr class="peticion"><td colspan="5" align="left"><b>Detalle Usuario:&#160;</b><i><xsl:value-of select="DATA/APLICACIONES/DATOS_PERSONALES/@EMAIL"/></i></td></tr>
		<tr>
			<td align="left">
				<b>Id:</b></td><td align="left" colspan="4"><xsl:value-of select="DATA/APLICACIONES/DATOS_PERSONALES/@IDENTIFICADOR"/>
			</td>
		</tr>
		<tr>
			<td align="left"><b>Nombre:</b></td><td align="left" colspan="4"><xsl:value-of select="DATA/APLICACIONES/DATOS_PERSONALES/@APELLIDOS"/>,&#160;<xsl:value-of select="DATA/APLICACIONES/DATOS_PERSONALES/@NOMBRE"/></td>
		</tr>
		<tr>
			<td align="left"><b>Email:</b></td><td align="left" colspan="4"><xsl:value-of select="DATA/APLICACIONES/DATOS_PERSONALES/@EMAIL"/></td>
		</tr>
		<tr>
			<td align="left"><b>Telefono:</b></td><td align="left" colspan="4"><xsl:value-of select="DATA/APLICACIONES/DATOS_PERSONALES/@TELEFONO"/></td>
		</tr>
		<tr>
			<td width="15%" align="left"><b>Responsable:</b></td>
			<td width="35%" align="left">
				<select name="ainResponsable" size="1" onChange="javascript:ActivarDesactivar()">
					<xsl:for-each select="DATA/APLICACIONES/APLICACIONES_INFORMATICOS[@INFORMATICO=$infCod]">
						<!--Si no es responsable aparece marcado por defecto el No, y si adems no quedan prioridades libres, el si no aparecera-->
						<xsl:if test="@RESPONSABLE='N'">
							<option value="N">No</option>
							<option value="Y">S</option>
						</xsl:if>
						<xsl:if test="@RESPONSABLE='Y'">
							<option value="Y">S</option>
							<xsl:if test="count(../APLICACIONES_INFORMATICOS[@PRIORIDAD])>1">
								<option value="N">No</option>
							</xsl:if>
						</xsl:if>	
					</xsl:for-each>
				</select>
			</td>	
			
			<td width="10%" align="left"><b>Prioridad:</b></td>
			<td width="30%" align="left">
				<!--Si es responsable, aparece activada de forma inicial la prioridad-->
				<xsl:for-each select="DATA/APLICACIONES/APLICACIONES_INFORMATICOS[@INFORMATICO=$infCod]">
					<xsl:if test="@RESPONSABLE='Y'">
						<input type="text" name="ainPrioridad" value="{@PRIORIDAD}"></input>
					</xsl:if>
					<!--Si no es responsable, aparece desactivada de forma inicial la prioridad-->
					<xsl:if test="@RESPONSABLE='N'">
						<input type="text" name="ainPrioridad" disabled="true"></input>
					</xsl:if>
				</xsl:for-each>
			</td>
			<td width="10%" align="right">
				<input type="button" class="boton" value="Actualizar" onclick="javascript:actualizar()"/>
			</td>
		</tr>
		<tr><td colspan="5">&#160;</td></tr>
		<tr><td colspan="5" align="center">
			<input class="boton" type="button" value="Cerrar" onclick="top.close();"/>&#160;
		</td></tr>
	</table>
	</form>
</center>
</body>
</HTML>

</xsl:template>
</xsl:stylesheet>
	