<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet version="1.0" 
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:xforms="http://www.w3.org/2002/xforms">
	
<xsl:param name="servlet"/>
<xsl:param name="menu"/>	
<xsl:param name ="select"/>
<xsl:param name="catCod"/>
<!--Variables para mantener el filtrado-->
<xsl:param name="flag_filtrado"/>
<xsl:param name="seccionCode"/>
<xsl:param name="tipoTareaCode"/>

<xsl:include href="dumbo7/utils/xsl/utils.xsl"/>
	
<xsl:template match="XMLROOT">

<html lang="es">

<xsl:call-template name="headComun">
	<xsl:with-param name="jscript">
		<script LANGUAJE="JavaScript">
			function mostrarError(error){
				alert(error);
			}
			function mantenerFiltro(url)
			{
				var filtrado = '<xsl:value-of select="$flag_filtrado"/>'
				var seccionCode = '<xsl:value-of select="$seccionCode"/>'
				var tipoTareaCode = '<xsl:value-of select="$tipoTareaCode"/>'
				
				url = url.concat("&amp;flag_filtrado=");
				url = url.concat(filtrado);
				if(seccionCode!="")
				{
					url = url.concat("&amp;seccionCode=");
					url = url.concat(seccionCode);
				}
				if(tipoTareaCode!="")
				{
					url = url.concat("&amp;tipoTareaCode=");
					url = url.concat(tipoTareaCode);
				}
				
				window.location.href=url;		
			}
		</script>
	</xsl:with-param>
</xsl:call-template>

<body>

	<xsl:call-template name="menuComun">
		<xsl:with-param name="NAME" select="concat(DATA/CATEGORIAS/USER/@NAME,concat('(',concat(DATA/CATEGORIAS/USER/@LOGIN,')')))"/>
		<xsl:with-param name="MENU" select="DATA/MENU"/>
		<xsl:with-param name="SELECT" select="$menu"/>
		<xsl:with-param name="HELP">administracion.xml#1.2</xsl:with-param>
	</xsl:call-template>

<xsl:call-template name="pieComun"/>
	</body>
	</html>
</xsl:template>

<xsl:template name="cuerpo">
	<xsl:for-each select="DATA/CATEGORIAS">
		<xsl:if test="not(@ERROR='')">
			<script>mostrarError('<xsl:value-of select="@ERROR"/>')</script>
			</xsl:if>
	</xsl:for-each>
	<table align="center" border="0" cellpadding="5" cellspacing="5" width="775" summary="Tabla para crear seccion">
	<tr><td width="700" colspan="2" class="cab1">&#187;DETALLE DE LA CATEGORA 
	<!--For Para poder mostrar la descripcion en la cabecera de la tabla-->
		<xsl:for-each select="DATA/CATEGORIAS/CATEGORIA">
			<xsl:if test="@CODIGO = $catCod">
				"<xsl:value-of select="@DESCRIPCION"/>"
			</xsl:if>
		</xsl:for-each>	
	</td></tr>
	<tr><td colspan="2">
		<form action="{$servlet}" METHOD="POST" name="modificar">
		<input type="hidden" name="module"/>
		<input type="hidden" name="catCod" value="{$catCod}"/>
		<input type="hidden" name="tipo" value="volver"/>
		
		<table class="cont" align="center" border="0" cellpadding="3" cellspacing="1" width="90%" summary="Tabla para crear categoria">
		<tr>
			<td class="cabe" align="left" colspan="5"><b>Datos de la categora</b></td>
		</tr>
		<xsl:for-each select="DATA/CATEGORIAS/CATEGORIA[@CODIGO = $catCod]">
			<tr class="administracion">
				<td align="left" width="12"><b>Cdigo:</b></td>
				<td align="left" width="500"><xsl:value-of select="$catCod"/></td>
			</tr>
			<tr class="administracion">
				<td align="left" width="12"><b>Descripcin:</b></td>
				<td align="left" width="500"><xsl:value-of select="@DESCRIPCION"/></td>
			</tr>
			<tr class="administracion">
				<td align="left" width="15"><b>Tipo&#160;de&#160;Tarea:</b></td>
				<td align="left" width="500"><xsl:variable name="miTipoTarea" select="@TIPO_TAREA"/>
					<xsl:for-each select="../TIPO_TAREA">
						<xsl:if test="@CODIGO=$miTipoTarea">
							<xsl:value-of select="@DESCRIPCION"/>
						</xsl:if>
					</xsl:for-each>
					
				</td>
			</tr>
			
		<tr class="administracion">
			<td align="left" width="15"><b>Seccin:</b></td>
			<!--Ayuda: "lista de secciones activas"-->
			<td align="left" width="500"><xsl:variable name="miSeccion" select="@SECCION"/>
				<xsl:for-each select="../SECCION">
					<xsl:if test="@CODIGO=$miSeccion">
						<xsl:value-of select="@DESCRIPCION"/>
					</xsl:if>
				</xsl:for-each>
				</td>
			</tr>
			
			<!--Seleccin de categoria padre-->
			<tr class="administracion">
				<td align="left" width="15"><b>Padre:</b></td>
				<td align="left" width="500">
						<xsl:variable name="parent"><xsl:value-of select="@PADRE"/></xsl:variable> 
						<xsl:variable name="Estado"><xsl:value-of select="@ESTADO"/></xsl:variable> 
						<xsl:choose>
							<!--Si tu no eres tu padre entonces puedes depender de cualquier categora-->
							<xsl:when test="(@CODIGO!=@PADRE)">			
								<!--Debe aparecer seleccionado la categora padre a la que ya estamos asignados-->
								<xsl:for-each select="../CATEGORIA">
									<xsl:if test="(@CODIGO=$parent)">
										<xsl:value-of select="@DESCRIPCION"/>
									</xsl:if>
								</xsl:for-each>
							</xsl:when>
							<xsl:otherwise>
							<!--Si tu eres tu padre entonces slo puedes depender de categorias que tambien esten autorreferenciadas-->
								-Categora Raz-
							</xsl:otherwise>	
							<!--Nota: Si una categoria valida pasa a depender de una categoria no validad, cambia su estado a no valido (por medio de triggers se propaga en la BD)-->
						</xsl:choose>
				</td>
			</tr>
			<tr class="administracion">
				<td align="left" width="15"><b>Estado:</b></td>
				<td align="left" width="500">
					<xsl:if test="(@ESTADO = 'V')">
						Vigente
					</xsl:if>
					<xsl:if test="(@ESTADO = 'N')">
						No Vigente
					</xsl:if>
				</td>
			</tr>
			
			<tr class="administracion">
				<td align="left" width="15"><b>Tiempo Estimado:</b></td>
				<td align="left" width="500">
					<xsl:value-of select="@TIEMPO_ESTIMADO"/>
					<xsl:if test="count(@TIEMPO_ESTIMADO)=0"> - </xsl:if>					

				</td>
			</tr>
			
			<tr class="administracion">
				<td colspan="5" align="center">
				<input type="button" class="boton" value="Volver" onclick="javascript:mantenerFiltro('?module=dumbo7/administracion/categorias.formCategoriaDetalle.volver')"/></td>
			</tr>				
		</xsl:for-each>			
		</table>

		</form>
	</td></tr>
	</table>
	<p>&#160;</p>	
	
	
	
</xsl:template>

</xsl:stylesheet>

