<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet version="1.0" 
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:xforms="http://www.w3.org/2002/xforms">
	
<xsl:param name="servlet"/>
<xsl:param name="menu"/>	
<xsl:param name ="select"/>
<xsl:param name="catCod"/>
<!--Variables para mantener el filtrado-->
<xsl:param name="flag_filtrado"/>
<xsl:param name="seccionCode"/>
<xsl:param name="tipoTareaCode"/>

<xsl:include href="dumbo7/utils/xsl/utils.xsl"/>
	
<xsl:template match="XMLROOT">

<html lang="es">

<xsl:call-template name="headComun">
	<xsl:with-param name="jscript">
		<script LANGUAJE="JavaScript">
			//Funcin para activar la variable de cambios y as notificarlos (si la variable es false, no se mostrar mensaje de cambios ni se har submit)
			function cambiosRealizados()
			{
				document.modificar.checkCambios.value="true";
			}
			function mostrarError(error){
				alert(error);
			}
			function cerrar_volver(){
					document.modificar.module.value='dumbo7/administracion/categorias.formModificar.cancelar';				
					document.modificar.submit();
			}
			
		</script>
		<script language="JavaScript" src="../js/categorias/CompruebaModificaCategoria.js"></script>
	</xsl:with-param>
</xsl:call-template>

<body>

	<xsl:call-template name="menuComun">
		<xsl:with-param name="NAME" select="concat(DATA/CATEGORIAS/USER/@NAME,concat('(',concat(DATA/CATEGORIAS/USER/@LOGIN,')')))"/>
		<xsl:with-param name="MENU" select="DATA/MENU"/>
		<xsl:with-param name="SELECT" select="$menu"/>
		<xsl:with-param name="HELP">administracion.xml#1.2.2</xsl:with-param>
	</xsl:call-template>


<xsl:call-template name="pieComun"/>
	</body>
	</html>
</xsl:template>

<xsl:template name="cuerpo">
	<xsl:for-each select="DATA/CATEGORIAS">
		<xsl:if test="not(@ERROR='')">
			<script>mostrarError('<xsl:value-of select="@ERROR"/>')</script>
			</xsl:if>
	</xsl:for-each>
	<table align="center" border="0" cellpadding="5" cellspacing="5" width="775" summary="Tabla para crear seccion">
	<tr><td width="700" colspan="2" class="cab1">&#187;Modificar categora 
	<!--For Para poder mostrar la descripcion en la cabecera de la tabla-->
		<xsl:for-each select="DATA/CATEGORIAS/CATEGORIA">
			<xsl:if test="@CODIGO = $catCod">
				"<xsl:value-of select="@DESCRIPCION"/>"
			</xsl:if>
		</xsl:for-each>	
	</td></tr>
	<tr><td colspan="2">
		<form action="{$servlet}" METHOD="POST" name="modificar">
		<input type="hidden" name="module"/>
		<input type="hidden" name="checkCambios" size="20" value="false"/>
		<input type="hidden" name="flag_filtrado" value="{$flag_filtrado}"/>
		<!--Tipo tarea o Seccion pueden ser nulos, si lo son no han de introducirse en el formulario para que el filtro 
		funcione correctamente.-->
		<xsl:if test="$seccionCode!=''">
			<input type="hidden" name="seccionCode" value="{$seccionCode}"/>
		</xsl:if>
		<xsl:if test="$tipoTareaCode!=''">		
			<input type="hidden" name="tipoTareaCode" value="{$tipoTareaCode}"/>
		</xsl:if>
		<input type="hidden" name="catCod" value="{$catCod}"/>
		<input type="hidden" name="tipo" value="volver"/>
		
		<table class="cont" align="center" border="0" cellpadding="3" cellspacing="1" width="90%" summary="Tabla para crear categoria">
		<tr>
			<td class="cabe" align="left" colspan="5"><b>Datos de la categora</b></td>
		</tr>
		<xsl:for-each select="DATA/CATEGORIAS/CATEGORIA[@CODIGO = $catCod]">
			<!--El estado, la seccion y el tipo de tarea no se muestran pero deben pasarse para que no sea nulo-->
			<input type="hidden" name="catEstado" value="{@ESTADO}"/>
			<input type="hidden" name="catTipCod" value="{@TIPO_TAREA}"/>
			<input type="hidden" name="catSecCod" value="{@SECCION}"/>
			<tr class="administracion">
				<td align="left">Cdigo:</td>
				<td align="left"><xsl:value-of select="$catCod"/></td>
			</tr>
			
			<tr class="administracion">
				<td align="left">Descripcin&#160;(*):</td>
				<td align="left"><input type="text" name="catDescrip" size="80" maxlength="50" value="{@DESCRIPCION}" onChange="javascript:cambiosRealizados();"/></td>
			</tr>
			<!--Seleccin de categoria padre-->
			<tr class="administracion">
				<td align="left">Padre&#160;(*):</td>
				<td align="left">
					<select name="catCatCod" size="1" onChange="javascript:cambiosRealizados();">
						<!--Si tu no eres tu padre entonces puedes depender de cualquier categora-->
						<option value="{$catCod}" selected="true">-Categora Raz-</option>
						<!--Llamamos a la plantilla para indexar las categoras.-->
						<xsl:call-template name="muestraCategoria">
						<xsl:with-param name="nodo" select=".."/>
						<xsl:with-param name="padre_categoria_modificar" select="@PADRE"/>
						<xsl:with-param name="categoria_modificar" select="$catCod"/>								
						</xsl:call-template>
					</select>
				</td>
			</tr>			
			<tr class="administracion">
				<td align="left">Tiempo Estimado:</td>
				<td align="left"><input type="text" name="catTiempoEst" size="8" maxlength="8" value="{@TIEMPO_ESTIMADO}" onChange="javascript:cambiosRealizados();"/></td>
			</tr>
			<tr class="administracion"><td align="left" colspan="4"><font size="-1" color="red">(*) campos obligatorios.</font></td></tr>
			<tr class="administracion">
				<td colspan="5" align="center">
				<input type="button" class="boton" value="Aceptar" onclick="javascript:CompruebaModificaCategoria()" />&#160;
				<input type="button" class="boton" value="Cancelar" onclick="javascript:cerrar_volver()"/></td>
			</tr>	
		</xsl:for-each>			
		</table>

		</form>
	</td></tr>
	</table>
	<p>&#160;</p>	
</xsl:template>

<!--Plantillas para recorrer las diferentes categorias indexandolas-->
<xsl:template name="muestraCategoria">
<xsl:param name="nodo"/>
<xsl:param name="padre_categoria_modificar"/><!--El padre que tiene debe aparecer seleccionado por defecto-->
<xsl:param name="categoria_modificar"/><!--La propia categoria no debe aparecer-->
    <xsl:for-each select="$nodo/CATEGORIA[@CODIGO=@PADRE]">
        <xsl:sort select="@DESCRIPCION"/>
		<xsl:if test="@ESTADO='V' and @CODIGO!=$categoria_modificar and @CODIGO!=$padre_categoria_modificar">
	        <option value="{@CODIGO}"><xsl:value-of select="@DESCRIPCION"/></option>
		</xsl:if>
		<xsl:if test="@ESTADO='V' and @CODIGO!=$categoria_modificar and @CODIGO=$padre_categoria_modificar">
	        <option value="{@CODIGO}" selected="true"><xsl:value-of select="@DESCRIPCION"/></option>
		</xsl:if>
        <xsl:call-template name="sacaSubCategoria">
			<xsl:with-param name="padre_categoria_modificar" select="$padre_categoria_modificar"/>
			<xsl:with-param name="categoria_modificar" select="$categoria_modificar"/>		
            <xsl:with-param name="categoria" select="$nodo"/>
            <xsl:with-param name="codigo_padre" select="@CODIGO"/>
            <xsl:with-param name="espacio" select="'&#160;&#160;'"/>
        </xsl:call-template>
    </xsl:for-each>
</xsl:template>

<xsl:template name="sacaSubCategoria">
<xsl:param name="categoria"/>
<xsl:param name="codigo_padre"/>
<xsl:param name="padre_categoria_modificar"/><!--La categoria padre ya sale seleccionada por defecto-->
<xsl:param name="categoria_modificar"/><!--el codigo de la propia categoria no aparece-->
<xsl:param name="espacio"/>
    <xsl:for-each select="$categoria/CATEGORIA[@PADRE=$codigo_padre and @PADRE!=@CODIGO]">
        <xsl:sort select="@DESCRIPCION"/>
		<xsl:if test="@ESTADO='V' and @CODIGO!=$categoria_modificar and @CODIGO!=$padre_categoria_modificar">
	        <option value="{@CODIGO}"><xsl:value-of select="$espacio"/><xsl:value-of select="@DESCRIPCION"/></option>
		</xsl:if>
		<xsl:if test="@ESTADO='V' and @CODIGO!=$categoria_modificar and @CODIGO=$padre_categoria_modificar">
	        <option value="{@CODIGO}" selected="true"><xsl:value-of select="$espacio"/><xsl:value-of select="@DESCRIPCION"/></option>
		</xsl:if>
        <xsl:call-template name="sacaSubCategoria">
			<xsl:with-param name="padre_categoria_modificar" select="$padre_categoria_modificar"/>
			<xsl:with-param name="categoria_modificar" select="$categoria_modificar"/>		
            <xsl:with-param name="categoria" select="$categoria"/>
            <xsl:with-param name="codigo_padre" select="@CODIGO"/>
            <xsl:with-param name="espacio" select="concat($espacio,'&#160;&#160;')"/>
        </xsl:call-template>
    </xsl:for-each>
</xsl:template>

</xsl:stylesheet>

