<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet version="1.0" 
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:xforms="http://www.w3.org/2002/xforms">
	
<xsl:param name="servlet"/>
<xsl:param name="menu"/>	
<xsl:param name ="select"/>
<xsl:variable name="tipotareacod"/>
<xsl:variable name="tipotareades"/>
<!--Variables para mantener el filtrado-->
<xsl:param name="flag_filtrado"/>
<xsl:param name="seccionCode"/>
<xsl:param name="tipoTareaCode"/>

<xsl:include href="dumbo7/utils/xsl/utils.xsl"/>
	
<xsl:template match="XMLROOT">

<html lang="es">

<xsl:call-template name="headComun">
	<xsl:with-param name="jscript">
		<script LANGUAJE="JavaScript">
						
			function mostrarError(error)
			{
				alert(error);
			}
			function cerrar_volver()
			{
				document.nueva.module.value='dumbo7/administracion/categorias.formNueva.cancelar';
				document.nueva.submit();
			}
			
			//Si es una categoria de primer nivel (no tiene ninguna categoria padre), puede elegir libremente seccion y tipo tarea. Todo tal y como esta.
		    //Si no es una categoria de primer nivel, automaticamente se selecciona la seccion y tipo tarea de la categoria padre sin dejar otra opcion.
			function compruebaPadre(code)
			{
				var i=0;
				//Borramos el contenido anterior
				for(i=0;i&lt;document.nueva.catTipCod.length;i++)
				{
					document.nueva.catTipCod.options[i].value = "";
					document.nueva.catTipCod.options[i].text = "";
				}
				document.nueva.catTipCod.length = 0;
				for(i=0;i&lt;document.nueva.catSecCod.length;i++)
				{
					document.nueva.catSecCod.options[i].value = "";
					document.nueva.catSecCod.options[i].text = "";
				}
				document.nueva.catSecCod.length = 0;
				
				//Si el codigo no es -1, no es una categoria raiz. Tenemos que restringir la seleccion	
				if(code!=-1)
				{
					<xsl:for-each select="DATA/CATEGORIAS/CATEGORIA">
						if(code=='<xsl:value-of select="@CODIGO"/>')
						{
							<xsl:variable name="tipotareacod"><xsl:value-of select="@TIPO_TAREA"/></xsl:variable>
							<xsl:for-each select="../TIPO_TAREA[@CODIGO=$tipotareacod]">
								document.nueva.catTipCod.length = document.nueva.catTipCod.length + 1;
								document.nueva.catTipCod.options[document.nueva.catTipCod.length-1].value = '<xsl:value-of select="@CODIGO"/>';
								document.nueva.catTipCod.options[document.nueva.catTipCod.length-1].text = '<xsl:value-of select="@DESCRIPCION"/>';
							</xsl:for-each>
							<xsl:variable name="seccioncod"><xsl:value-of select="@SECCION"/></xsl:variable>
							<xsl:for-each select="../SECCION[@CODIGO=$seccioncod]">
								document.nueva.catSecCod.length = document.nueva.catSecCod.length + 1;
								document.nueva.catSecCod.options[document.nueva.catSecCod.length-1].value = '<xsl:value-of select="@CODIGO"/>';
								document.nueva.catSecCod.options[document.nueva.catSecCod.length-1].text = '<xsl:value-of select="@DESCRIPCION"/>';
							</xsl:for-each> 
						}
					</xsl:for-each>
				}
				else //Si el codigo es -1, podemos seleccionar cualquier seccion y cualquier tipo tarea
				{
					document.nueva.catTipCod.length = document.nueva.catTipCod.length + 1;
					document.nueva.catTipCod.options[document.nueva.catTipCod.length-1].value = '';
					document.nueva.catTipCod.options[document.nueva.catTipCod.length-1].text = '-Introduzca un tipo tarea-';
					
					document.nueva.catSecCod.length = document.nueva.catSecCod.length + 1;
					document.nueva.catSecCod.options[document.nueva.catSecCod.length-1].value = '';
					document.nueva.catSecCod.options[document.nueva.catSecCod.length-1].text = '-Introduzca una seccion-';
					
					
					<xsl:for-each select="DATA/CATEGORIAS/TIPO_TAREA">
						<xsl:sort select="@DESCRIPCION"/>
						document.nueva.catTipCod.length = document.nueva.catTipCod.length + 1;
						document.nueva.catTipCod.options[document.nueva.catTipCod.length-1].value = '<xsl:value-of select="@CODIGO"/>';
						document.nueva.catTipCod.options[document.nueva.catTipCod.length-1].text = '<xsl:value-of select="@DESCRIPCION"/>';
					</xsl:for-each>
					<xsl:for-each select="DATA/CATEGORIAS/SECCION">
						<xsl:sort select="@DESCRIPCION"/>
						document.nueva.catSecCod.length = document.nueva.catSecCod.length + 1;
						document.nueva.catSecCod.options[document.nueva.catSecCod.length-1].value = '<xsl:value-of select="@CODIGO"/>';
						document.nueva.catSecCod.options[document.nueva.catSecCod.length-1].text = '<xsl:value-of select="@DESCRIPCION"/>';
					</xsl:for-each> 
				}
			}
		</script>
		<script language="JavaScript" src="../js/categorias/CompruebaAltaCategoria.js"></script>
	</xsl:with-param>
</xsl:call-template>

<body>

	<xsl:call-template name="menuComun">
		<xsl:with-param name="NAME" select="concat(DATA/CATEGORIAS/USER/@NAME,concat('(',concat(DATA/CATEGORIAS/USER/@LOGIN,')')))"/>
		<xsl:with-param name="MENU" select="DATA/MENU"/>
		<xsl:with-param name="SELECT" select="$menu"/>
		<xsl:with-param name="HELP">administracion.xml#1.2.1</xsl:with-param>
	</xsl:call-template>


<xsl:call-template name="pieComun"/>
	</body>
	</html>
</xsl:template>

<xsl:template name="cuerpo">
	<xsl:for-each select="DATA/CATEGORIAS">
		<xsl:if test="not(@ERROR='')">
			<script>mostrarError('<xsl:value-of select="@ERROR"/>')</script>
			</xsl:if>
	</xsl:for-each>
	<table align="center" border="0" cellpadding="5" cellspacing="5" width="775" summary="Tabla para crear seccion">
	<tr><td width="450" colspan="2" class="cab1">&#187;Nueva categora</td></tr>
	<tr><td colspan="2">
		<form action="{$servlet}" METHOD="GET" name="nueva">
		<input type="hidden" name="module"/>
		<input type="hidden" name="flag_filtrado" value="{$flag_filtrado}"/>
		<!--Tipo tarea o Seccion pueden ser nulos, si lo son no han de introducirse en el formulario para que el filtro 
		funcione correctamente.-->
		<xsl:if test="$seccionCode!=''">
			<input type="hidden" name="seccionCode" value="{$seccionCode}"/>
		</xsl:if>
		<xsl:if test="$tipoTareaCode!=''">		
			<input type="hidden" name="tipoTareaCode" value="{$tipoTareaCode}"/>
		</xsl:if>
		<table class="cont" align="center" border="0" cellpadding="3" cellspacing="1" width="100%" summary="Tabla para crear categoria">
			<tr>
				<td class="cabe" align="left" colspan="5"><b>Datos de la categora</b></td>
			</tr>
			<tr class="administracion">
				<td align="left" width="20%">Descripcin&#160;(*):</td>
				<td align="left" width="80"><input type="text" name="catDescrip" size="51" maxlength="50"/></td>
			</tr>
			<tr class="administracion">
				<td align="left" width="20%">Padre&#160;(*):</td>
				<td align="left" width="10">
					<select name="catCatCod" size="1" onchange="compruebaPadre(this.options[this.selectedIndex].value)">
						<option value="-1">-Categora Raz-</option>
						<!--Llamamos a la plantilla para indexar las categoras.-->
						<xsl:call-template name="muestraCategoria">
						<xsl:with-param name="nodo" select="DATA/CATEGORIAS"/>
						</xsl:call-template>
					</select>
				</td>
			</tr>
			<tr class="administracion">
				<td align="left" width="20%">Tipo&#160;de&#160;Tarea&#160;(*):</td>
				<td align="left" width="80">
					<select name="catTipCod" size="1">
						<option value="">-Introduzca un tipo tarea-</option>
						<xsl:for-each select="DATA/CATEGORIAS/TIPO_TAREA">
							<xsl:sort select="@DESCRIPCION"/>
							<option value="{@CODIGO}"><xsl:value-of select="@DESCRIPCION"/></option>
						</xsl:for-each>
					</select>
				</td>
			</tr>
			
			<tr class="administracion">
				<td align="left" width="20%">Seccin&#160;(*):</td>
				<!--Ayuda: "lista de secciones activas"-->
				<td align="left" width="80">
					<select name="catSecCod" size="1">
						<option value="">-Introduzca una seccin-</option>
						<xsl:for-each select="DATA/CATEGORIAS/SECCION">
							<xsl:sort select="@DESCRIPCION"/>
							<xsl:if test="@ESTADO='V'">
								<option value="{@CODIGO}"><xsl:value-of select="@DESCRIPCION"/></option>
							</xsl:if>
						</xsl:for-each>
					</select>
				</td>
			</tr>
			<tr class="administracion">
				<td align="left" width="20%">Estado&#160;(*):</td>
				<td align="left" width="80"><select name="catEstado" size="1"><option value="V">Vigente</option><option value="N">No&#160;Vigente</option></select></td>
			</tr>
			
			<tr class="administracion">
				<td align="left" width="20%">Tiempo Estimado:</td>
				<td align="left" width="80"><input type="text" name="catTiempoEst" size="8" maxlength="8"/></td>
			</tr>
			<tr class="administracion"><td align="left" colspan="4"><font size="-1" color="red">(*) campos obligatorios.</font></td></tr>
			<tr class="administracion">
				<td colspan="5" align="center">
				<input type="button" class="boton" value="Aceptar" onclick="javascript:CompruebaAltaCategoria()" />&#160;
				<input type="button" class="boton" value="Cancelar" onclick="javascript:cerrar_volver()"/></td>
			</tr>				
		</table>
		</form>
	</td></tr>
	</table>
	<p>&#160;</p>	
	
	
	
</xsl:template>

<!--Plantillas para recorrer las diferentes categorias indexandolas-->
<xsl:template name="muestraCategoria">
<xsl:param name="nodo"/>
    <xsl:for-each select="$nodo/CATEGORIA[@CODIGO=@PADRE]">
        <xsl:sort select="@DESCRIPCION"/>
		<xsl:if test="@ESTADO='V'">
	        <option value="{@CODIGO}"><xsl:value-of select="@DESCRIPCION"/></option>
		</xsl:if>
        <xsl:call-template name="sacaSubCategoria">
            <xsl:with-param name="categoria" select="$nodo"/>
            <xsl:with-param name="codigo_padre" select="@CODIGO"/>
            <xsl:with-param name="espacio" select="'&#160;&#160;'"/>
        </xsl:call-template>
    </xsl:for-each>
</xsl:template>

<xsl:template name="sacaSubCategoria">
<xsl:param name="categoria"/>
<xsl:param name="codigo_padre"/>
<xsl:param name="espacio"/>
    <xsl:for-each select="$categoria/CATEGORIA[@PADRE=$codigo_padre and @PADRE!=@CODIGO]">
        <xsl:sort select="@DESCRIPCION"/>
		<xsl:if test="@ESTADO='V'">
	        <option value="{@CODIGO}"><xsl:value-of select="$espacio"/><xsl:value-of select="@DESCRIPCION"/></option>
		</xsl:if>
        <xsl:call-template name="sacaSubCategoria">
            <xsl:with-param name="categoria" select="$categoria"/>
            <xsl:with-param name="codigo_padre" select="@CODIGO"/>
            <xsl:with-param name="espacio" select="concat($espacio,'&#160;&#160;')"/>
        </xsl:call-template>
    </xsl:for-each>
</xsl:template>



</xsl:stylesheet>

