<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet version="1.0" 
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:xforms="http://www.w3.org/2002/xforms">

<xsl:param name="servlet"/>	
<xsl:param name="menu"/>
<xsl:variable name="seccion"/>

<!--Variables para mantener el filtrado-->
<xsl:param name="flag_filtrado"/>
<xsl:param name="seccionCode"/>
<xsl:param name="tipoTareaCode"/>
<!--"mostrar" es un flag para el filtrado de aplicaciones (muestra 'todos' o muestra solo los vigentes (''))-->
<xsl:param name="mostrar"/>
	
<xsl:include href="dumbo7/utils/xsl/utils.xsl"/>
<xsl:template match="XMLROOT">

<html lang="es">
     <xsl:call-template name="headComun">
	 <xsl:with-param name="arbol" select="'Categorias'"/>
         <xsl:with-param name="jscript">
			<script LANGUAJE="JavaScript">
				function mantenerFiltro(url)
				{
					var filtrado = '<xsl:value-of select="$flag_filtrado"/>'
					var mostrar = '<xsl:value-of select="$mostrar"/>'
					url = url.concat("&amp;flag_filtrado=");
					url = url.concat(filtrado);
					if(document.categorias.Seccion.options[document.categorias.Seccion.selectedIndex].value!="")
					{
						url = url.concat("&amp;seccionCode=");
						url = url.concat(document.categorias.Seccion.options[document.categorias.Seccion.selectedIndex].value);
					}
					if(document.categorias.Tipo.options[document.categorias.Tipo.selectedIndex].value!="")
					{
						url = url.concat("&amp;tipoTareaCode=");
						url = url.concat(document.categorias.Tipo.options[document.categorias.Tipo.selectedIndex].value);
					}
					url = url.concat("&amp;mostrar=");
					url = url.concat(mostrar);					
					window.location.href=url;
				}
				function mostrarError(error){
					alert(error);
				}
				function CambiarEstado(url,estado){
					if (confirm("Est seguro de cambiar el estado a " + estado + "?"))
					{
						mantenerFiltro(url);
						 //window.open(url,"_self");
					}
				}

				//Funcin para el filtrado de las categorias en el listado principal
				function filtrar(url)
				{
					var filtrado = '<xsl:value-of select="$flag_filtrado"/>'
					var mostrar = '<xsl:value-of select="$mostrar"/>'
					if (filtrado == 1){filtrado = 0;}
					else              {filtrado = 1;}
					
					if(document.categorias.Seccion.options[document.categorias.Seccion.selectedIndex].value!="" || document.categorias.Tipo.options[document.categorias.Tipo.selectedIndex].value!="")
					{
						if(filtrado!=0)
						{
							url = url.concat("&amp;flag_filtrado=");
							url = url.concat(filtrado);
							
							if(document.categorias.Seccion.options[document.categorias.Seccion.selectedIndex].value!="")
							{
								url = url.concat("&amp;seccionCode=");
								url = url.concat(document.categorias.Seccion.options[document.categorias.Seccion.selectedIndex].value);
							}
							if(document.categorias.Tipo.options[document.categorias.Tipo.selectedIndex].value!="")
							{
								url = url.concat("&amp;tipoTareaCode=");
								url = url.concat(document.categorias.Tipo.options[document.categorias.Tipo.selectedIndex].value);
							}
						}
						url = url.concat("&amp;mostrar=");
						url = url.concat(mostrar);
						window.location.href=url;
					}
					else
					{
						alert("Introduzca un parmetro de filtrado");
					}
				}  
				//Funcin que muestra las categorias vigentes o no vigentes, manteniendo el filtro por seccion y caracter
				function mostrarCategorias(url)
				{
					var filtrado = '<xsl:value-of select="$flag_filtrado"/>'
					if(filtrado!=0)
					{
						url = url.concat("&amp;flag_filtrado=");
						url = url.concat(filtrado);
						if(document.categorias.Seccion.options[document.categorias.Seccion.selectedIndex].value!="")
						{
							url = url.concat("&amp;seccionCode=");
							url = url.concat(document.categorias.Seccion.options[document.categorias.Seccion.selectedIndex].value);
						}
						if(document.categorias.Tipo.options[document.categorias.Tipo.selectedIndex].value!="")
						{
							url = url.concat("&amp;tipoTareaCode=");
							url = url.concat(document.categorias.Tipo.options[document.categorias.Tipo.selectedIndex].value);
						}
					}
					window.open(url,"_parent");
				}               
            </script>
			<script LANGUAJE="JavaScript" src="../js/categorias/PreguntaBorrar.js"></script>
			<script LANGUAJE="JavaScript" src="../js/OnMouse.js"></script>
			</xsl:with-param>
	   </xsl:call-template>

<body>
		
	<xsl:call-template name="menuComun">
		<xsl:with-param name="NAME" select="concat(DATA/CATEGORIAS/USER/@NAME,concat('(',concat(DATA/CATEGORIAS/USER/@LOGIN,')')))"/>
		<xsl:with-param name="MENU" select="DATA/MENU"/>
		<xsl:with-param name="SELECT" select="$menu"/>
		<xsl:with-param name="HELP">administracion.xml#1.2</xsl:with-param>
	</xsl:call-template>

<xsl:call-template name="pieComun"/>
</body>
</html>

</xsl:template>

<xsl:template name="cuerpo">
		<xsl:for-each select="DATA/CATEGORIAS">
			<xsl:if test="not(@ERROR='')">
				<script>mostrarError('<xsl:value-of select="@ERROR"/>')</script>
				</xsl:if>
		</xsl:for-each>
	
	<table align="center" border="0" cellpadding="5" cellspacing="5" width="775"  summary="Esta tabla contiene una lista de categoras">
	<form action="{$servlet}" METHOD="GET" name="categorias">
	 <tr>
		<td class="cab1" style="width:30%">&#187;Listado de categoras</td>
		<!--Si el flag es distinto de 1, quiere decir que se deben introducir los valores para filtrar-->
		<td width="65%" align="right">
			<xsl:if test="$flag_filtrado!=1 or string-length($flag_filtrado)=0">
				<select name="Seccion" size="1">
					<option	value="">-Filtrar Seccion-</option>
					<xsl:for-each select="DATA/CATEGORIAS/SECCION">
						<xsl:sort select="@DESCRIPCION"/>
						<option value="{@CODIGO}"><xsl:value-of select="@DESCRIPCION"/></option>
					</xsl:for-each>
				</select>	
				<select name="Tipo" size="1">
					<option	value="">-Filtrar tipo de tarea-</option>
					<xsl:for-each select="DATA/CATEGORIAS/TIPO_TAREA">
						<xsl:sort select="@DESCRIPCION"/>
						<option value="{@CODIGO}"><xsl:value-of select="@DESCRIPCION"/></option>
					</xsl:for-each>
				</select>
				<a href="javascript:filtrar('?module=dumbo7/administracion/categorias.index')"><img border="0" src="../graficos/iconos/ico_filtroOff.gif" alt="Activar filtrado por seccin y tipo de tarea"/></a>				
			</xsl:if>
			<!--Si el flag es 1, quiere decir que ya ha habido una consulta con resultado.
				En este caso, los select solo contienen los datos con los que se realizo la consulta-->
			<xsl:if test="$flag_filtrado=1">
				<select name="Seccion" size="1">
					<xsl:if test="count(DATA/CATEGORIAS/SECCION[@CODIGO=$seccionCode])!=0">
						<xsl:for-each select="DATA/CATEGORIAS/SECCION[@CODIGO=$seccionCode]">
							<option value="{@CODIGO}"><xsl:value-of select="@DESCRIPCION"/></option>
						</xsl:for-each>
					</xsl:if>
					<xsl:if test="count(DATA/CATEGORIAS/SECCION[@CODIGO=$seccionCode])=0">
						<option value="">-Sin valor-</option>
					</xsl:if>
				</select>	
				<select name="Tipo" size="1">
					<xsl:if test="count(DATA/CATEGORIAS/TIPO_TAREA[@CODIGO=$tipoTareaCode])!=0">
						<xsl:for-each select="DATA/CATEGORIAS/TIPO_TAREA[@CODIGO=$tipoTareaCode]">
							<option value="{@CODIGO}"><xsl:value-of select="@DESCRIPCION"/></option>
						</xsl:for-each>
					</xsl:if>
					<xsl:if test="count(DATA/CATEGORIAS/TIPO_TAREA[@CODIGO=$tipoTareaCode])=0">
						<option value="">-Sin valor-</option>
					</xsl:if>
				</select>
				<a href="javascript:filtrar('?module=dumbo7/administracion/categorias.index')"><img border="0" src="../graficos/iconos/ico_filtroOn.gif" alt="Desactivar filtrado por seccin y tipo de tarea"/></a>				
			</xsl:if>
		</td>
		<td width="20" style="align:center">
			<xsl:if test="count(DATA/CATEGORIAS/CATEGORIA[@ESTADO='N'])>0">
				<xsl:if test="$mostrar='todos'">
					<a href="JavaScript:mostrarCategorias('{$servlet}?module=dumbo7/administracion/categorias.index')">Mostrar Vigentes</a>
				</xsl:if>
				<xsl:if test="$mostrar=''">
					<a href="JavaScript:mostrarCategorias('{$servlet}?module=dumbo7/administracion/categorias.index&amp;mostrar=todos');">Mostrar Todas</a>
				</xsl:if>
			</xsl:if>
		</td>
		<td width="10%" align="center">
			<a href="javascript:mantenerFiltro('?module=dumbo7/administracion/categorias.index.nueva')">Insertar Categora</a>
		</td>
	</tr>
		<tr>
			<td colspan="4">
			<table  class="cont" align="center" id="categorias" border="0" cellpadding="3" cellspacing="1" style="border-collapse: collapse" width="100%"  summary="Esta tabla contiene una lista de categoras">
			<tr>		
				<!--Cabecera de la tabla (cuidado con los anchos y con los anchos de los campos dentro del bucle) -->
				<SCRIPT>
					<!--Para guardar la descripcin y pasarlo a los javascript de tal forma que se respeten las tildes en los string-->
					var arrayDescripcion = new Array();
				</SCRIPT>
				<td class="cabe" width="20"><b><font face="Verdana" size="2">Est</font></b></td>
				<td class="cabe" width="550"><b><font face="Verdana" size="2">Codigo/Descripcin</font></b></td>
				<td class="cabe" width="450"><b><font face="Verdana" size="2">Seccin </font></b></td>	
				<td class="cabe" width="90" align="center"><b><font face="Verdana" size="2">Tipo</font></b></td>	
				<td class="cabe" width="90" align="center"><b><font face="Verdana" size="2">T. Est. </font></b></td>	
				<td class="cabe" colspan="3"> </td>
			
				<!--Se diferencia entre dos llamadas para as poder ponerle una clase distinta a un elemento
					que tenga hijos (este tendr clase switchcontent )
					y un elemento que no tenga hijos (Este elemento no tendr clase sera '')

					Esto es necesario para un buen funcionamiento del rbol.
				-->
				<!--Filtro que muestra solo las categoras vigentes-->
				<xsl:if test="$mostrar=''">
					<xsl:for-each select="DATA/CATEGORIAS/CATEGORIA[((@CODIGO='00') or (@CODIGO=@PADRE))and @ESTADO='V']">
						<xsl:sort select="@DESCRIPCION"/>
						<xsl:variable name="codigo2"><xsl:value-of select="@CODIGO"/></xsl:variable>
						<xsl:choose>
							<xsl:when test="(count(../CATEGORIA[@PADRE = $codigo2 and @CODIGO != $codigo2])>0)">	
								<xsl:call-template name="muestraCategoria">
									<xsl:with-param name="tab" select="concat('arb.',position())"/>
									<xsl:with-param name="tabimg" select="concat('img.arb.',position())"/>
									<xsl:with-param name="clase" select="'switchcontent'"/>
									<xsl:with-param name="code" select="@CODIGO"/>
									<xsl:with-param name="parent" select="@PADRE"/>
									<xsl:with-param name="seccion" select="@SECCION"/>
								</xsl:call-template>					
							</xsl:when>
							<xsl:otherwise>
								<xsl:call-template name="muestraCategoria">
									<xsl:with-param name="tab" select="''"/>
									<xsl:with-param name="tabimg" select="''"/>
									<xsl:with-param name="clase" select="'switchcontent'"/>
									<xsl:with-param name="code" select="@CODIGO"/>
									<xsl:with-param name="parent" select="@PADRE"/>
									<xsl:with-param name="seccion" select="@SECCION"/>
								</xsl:call-template>
							</xsl:otherwise>
						</xsl:choose>
					</xsl:for-each>
				</xsl:if>
				<!--Filtro que todas las categoras-->
				<xsl:if test="$mostrar='todos'">
					<xsl:for-each select="DATA/CATEGORIAS/CATEGORIA[(@CODIGO='00') or (@CODIGO=@PADRE)]">
						<xsl:sort select="@DESCRIPCION"/>
						<xsl:variable name="codigo2"><xsl:value-of select="@CODIGO"/></xsl:variable>
						<xsl:choose>
							<xsl:when test="(count(../CATEGORIA[@PADRE = $codigo2 and @CODIGO != $codigo2])>0)">	
								<xsl:call-template name="muestraCategoria">
									<xsl:with-param name="tab" select="concat('arb.',position())"/>
									<xsl:with-param name="tabimg" select="concat('img.arb.',position())"/>
									<xsl:with-param name="clase" select="'switchcontent'"/>
									<xsl:with-param name="code" select="@CODIGO"/>
									<xsl:with-param name="parent" select="@PADRE"/>
									<xsl:with-param name="seccion" select="@SECCION"/>
								</xsl:call-template>					
							</xsl:when>
							<xsl:otherwise>
								<xsl:call-template name="muestraCategoria">
									<xsl:with-param name="tab" select="''"/>
									<xsl:with-param name="tabimg" select="''"/>
									<xsl:with-param name="clase" select="'switchcontent'"/>
									<xsl:with-param name="code" select="@CODIGO"/>
									<xsl:with-param name="parent" select="@PADRE"/>
									<xsl:with-param name="seccion" select="@SECCION"/>
								</xsl:call-template>
							</xsl:otherwise>
						</xsl:choose>
					</xsl:for-each>
				</xsl:if>
				<xsl:if test="count(DATA/CATEGORIAS/CATEGORIA)=0">
					<tr>
						<td colspan="8" align="center" class="administracion"> No hay Categoras.</td>
					</tr>
				</xsl:if>
			</tr>
		</table></td></tr>
		</form>
	</table>
	<p>&#160;</p>	
</xsl:template>

<xsl:template name="muestraCategoria">
<xsl:param name="code"/>
<xsl:param name="parent"/>
<xsl:param name="tab"/>
<xsl:param name="tabimg"/>
<xsl:param name="clase"/>
		<SCRIPT>
			<!--Se guarda la descripcin para pasarla al javascript de borrar de tal forma que se respeten las tildes en los string-->
			arrayDescripcion['<xsl:value-of select="@CODIGO"/>'] = <xsl:call-template name="entrecomillaDescripcion"><xsl:with-param name="descripcion" select="@DESCRIPCION"/></xsl:call-template>;
		</SCRIPT>
		<xsl:variable name="codigo"><xsl:value-of select="@CODIGO"/></xsl:variable>
		<tr id="{$tab}" onmouseover="javascript:onMouse(this,'true');" onmouseout="javascript:onMouse(this,'false');"><xsl:if test="(count(../CATEGORIA[@PADRE = $codigo and @CODIGO != $codigo])>0)"><xsl:attribute name="class"><xsl:value-of select="$clase"/></xsl:attribute></xsl:if>
			
			<td width="15" align="center">
				<xsl:if test="@ESTADO='V'">
					<img border="0" src="../graficos/iconos/vigente.gif" alt="Vigente"/>
				</xsl:if>
				<xsl:if test="@ESTADO='N'">
					<img border="0" src="../graficos/iconos/no_vigente.gif" alt="No vigente"/>
				</xsl:if>		
			</td>
			
			<xsl:variable name="estilo">
				<!--<xsl:value-of select="concat(concat('padding-left:',(string-length($tab)-5) div 4),'cm')"/>-->
				<xsl:value-of select="concat(concat('padding-left:',(string-length(translate($tab,'0123456789',''))-3)* 0.25),'cm')"/>
			</xsl:variable>

			<td style="{$estilo}">
				
				<!--Compruebo si tiene padre para mostrar la jerarquia-->
				<xsl:if test="(count(../CATEGORIA[@PADRE = $codigo and @CODIGO != $codigo])>0)">		
					<img id="{$tabimg}" class="showstate" border="0" src="../dumbo7/utils/table/minus.gif" onClick="expandcontent(this,'{$tab}');"/>&#160;<xsl:value-of select="@CODIGO"/>&#160;
				</xsl:if>
				
				<!--Si no tiene hijos, se aade un icono empty-->
				<xsl:if test="(count(../CATEGORIA[@PADRE = $codigo and @CODIGO != $codigo])=0)">		
					<img id="{$tabimg}" border="0" src="../dumbo7/utils/table/empty.gif"/>&#160;&#160;<xsl:value-of select="@CODIGO"/>&#160;
				</xsl:if>
				<!--muestra un substring de la descripcin-->								
				<!--<a title="{@DESCRIPCION}" href="{$servlet}?module=dumbo7/administracion/categorias.index.verDetalle&amp;catCod={@CODIGO}">-->
				<a title="{@DESCRIPCION}" href="javascript:mantenerFiltro('?module=dumbo7/administracion/categorias.index.verDetalle&amp;catCod={@CODIGO}')"><xsl:value-of select="@DESCRIPCION"/></a>
			</td>
		
			<!--muestra un substring de la descripcin de la seccin-->
				<td width="300">
					<xsl:variable name="seccion"><xsl:value-of select="@SECCION"/></xsl:variable> 	
					<xsl:for-each select="../SECCION">
						<!--Si la seccin est vigente, se muestra en color normal-->
						<xsl:if test="@ESTADO='V'">
							<xsl:if test="@CODIGO=$seccion">
								<label title="{@DESCRIPCION}">
								<!--SI LA DESCRIPCION TIENE MENOS DE 25 CARACTERES-->
								<xsl:if test="25>=string-length(@DESCRIPCION)">								
									<xsl:value-of select="@DESCRIPCION"/>
								</xsl:if>
								<!--SI LA DESCRIPCION TIENE MAS DE 25 CARACTERES-->
								<xsl:if test="string-length(@DESCRIPCION)>25">
									<xsl:value-of select="concat(substring(@DESCRIPCION,0,25),'...')"/>
								</xsl:if>
								</label>	
							</xsl:if>
						<!--Si la seccin no est vigente, se muestra en color gris-->
						</xsl:if><xsl:if test="@ESTADO='N'">
							<xsl:if test="@CODIGO=$seccion">
								<label title="{@DESCRIPCION}">
								<!--SI LA DESCRIPCION TIENE MENOS DE 25 CARACTERES-->
								<xsl:if test="25>=string-length(@DESCRIPCION)">								
									<font color="#999999"><xsl:value-of select="@DESCRIPCION"/></font>
								</xsl:if>
								<!--SI LA DESCRIPCION TIENE MAS DE 25 CARACTERES-->
								<xsl:if test="string-length(@DESCRIPCION)>25">
									<font color="#999999"><xsl:value-of select="concat(substring(@DESCRIPCION,0,25),'...')"/></font>
								</xsl:if>
								</label>	
							</xsl:if>
						</xsl:if>
					</xsl:for-each>
				</td>	
				
				<!--muestra un substring de la descripcin del Tipo Tarea-->
				<td width="90" align="center">
					<xsl:variable name="tipoTarea"><xsl:value-of select="@TIPO_TAREA"/></xsl:variable> 	
					<xsl:for-each select="../TIPO_TAREA">
						
						<xsl:if test="@CODIGO=$tipoTarea">
							<label title="{@DESCRIPCION}">
							<!--SI LA DESCRIPCION TIENE MENOS DE 4 CARACTERES-->
							<xsl:if test="4>=string-length(@DESCRIPCION)">								
								<xsl:value-of select="@DESCRIPCION"/>
							</xsl:if>
							<!--SI LA DESCRIPCION TIENE MAS DE 4 CARACTERES-->
							<xsl:if test="string-length(@DESCRIPCION)>4">
								<xsl:value-of select="substring(@DESCRIPCION,0,4)"/>
							</xsl:if>
						</label>	
						</xsl:if>
					</xsl:for-each>
				</td>		
				<td width="130" align="center">
					<xsl:variable name="tiempoEstimado"><xsl:value-of select="@TIEMPO_ESTIMADO"/></xsl:variable>
					<xsl:value-of select="@TIEMPO_ESTIMADO"/>
					<xsl:if test="count(@TIEMPO_ESTIMADO)=0"> - </xsl:if>					
				</td>

			<xsl:choose>
					<!--Si tinenes 0 hijos a valido(que es lo mismo que no tener hijos) y (el estado de tu padre es Valido) =>> puedo cambiar MI estado-->
					<xsl:when test="(count(../CATEGORIA[(@ESTADO='V')and (@PADRE=$code)])= 0)
									and((../CATEGORIA[(@ESTADO='V') and (@CODIGO=$parent)]))">		
							<td width="20"><CENTER>
								
								<xsl:if test="@ESTADO='V'">
									 <a href="JavaScript:CambiarEstado('{$servlet}?module=dumbo7/administracion/categorias.index.cambiar&amp;catCod={@CODIGO}','NO VIGENTE');"><img border="0" src="../graficos/iconos/CambiarEstadoNV.gif" alt="Cambiar Estado de la Categora a NO VIGENTE"/></a>
								</xsl:if>
								<xsl:if test="@ESTADO='N'">
									 <a href="JavaScript:CambiarEstado('{$servlet}?module=dumbo7/administracion/categorias.index.cambiar&amp;catCod={@CODIGO}','VIGENTE');"><img border="0" src="../graficos/iconos/CambiarEstadoV.gif" alt="Cambiar Estado de la Categora a VIGENTE"/></a>
								</xsl:if>
							</CENTER></td>
					</xsl:when>
					<!--Si soy mi propio padre(AUTOREFERENCIA) y tengo 0 hijos a valido(que es lo mismo qu eno tener hijos)=>> puedo cambiar MI estado-->
					<!--El count = 1 significa que como mnimo siempre la condicion de estado = V la cumplo yo(Por la autoreferencia)-->
					<xsl:when test="((count(../CATEGORIA[(@ESTADO='V') and (@PADRE=$code)]) = 1) or (count(../CATEGORIA[(@ESTADO='V') and (@PADRE=$code)]) = 0)) and (../CATEGORIA[(@CODIGO = $code) and (@PADRE=$code)])">			
						 <td width="20"><CENTER>
								<xsl:if test="@ESTADO='V'">
									 <a href="JavaScript:CambiarEstado('{$servlet}?module=dumbo7/administracion/categorias.index.cambiar&amp;catCod={@CODIGO}','NO VIGENTE');"><img border="0" src="../graficos/iconos/CambiarEstadoNV.gif" alt="Cambiar Estado de la Categora a NO VIGENTE"/></a>
								</xsl:if>
								<xsl:if test="@ESTADO='N'">
									 <a href="JavaScript:CambiarEstado('{$servlet}?module=dumbo7/administracion/categorias.index.cambiar&amp;catCod={@CODIGO}','VIGENTE');"><img border="0" src="../graficos/iconos/CambiarEstadoV.gif" alt="Cambiar Estado de la Categora a VIGENTE"/></a>
								</xsl:if>
							</CENTER></td>
					</xsl:when>
					<xsl:otherwise>
					 <td width="20" >
						<CENTER><img border="0" src="../graficos/iconos/CambiarEstado_off.gif" alt="Cambiar Estado"/></CENTER>
					</td>
				</xsl:otherwise>
			</xsl:choose>

			<td width="20" ><CENTER><a href="javascript:mantenerFiltro('?module=dumbo7/administracion/categorias.index.modificar&amp;catCod={@CODIGO}&amp;catSecCod={@SECCION}&amp;catTipCod={@TIPO_TAREA}')"><img border="0" src="../graficos/iconos/modificar.gif" alt="Modificar Categora"/></a></CENTER></td>
			<!--Se encarga de contar los nodos que no tienes hijos y, si es as, aadirles la etiqueta de eliminar-->
			<xsl:if test="count(../CATEGORIA[(@PADRE=$code) and (@CODIGO!=$code)])=0">
				<!--Solo hay que pasarle al javascript ?module=dumbo7/administracion/secciones.index.eliminar&amp;secCod={@CODIGO}' para que encuentre la URL correcta para borrar-->
				 <td width="20" ><CENTER><a href="javascript:validar('?module=dumbo7/administracion/categorias.index.eliminar&amp;catCod={@CODIGO}',arrayDescripcion['{@CODIGO}']);"><img border="0" src="../graficos/iconos/eliminar.gif" alt="Eliminar Categora"/></a></CENTER></td>
			</xsl:if>
			
			<xsl:if test="count(../CATEGORIA[(@PADRE=$code) and (@CODIGO!=$code)])!=0">
				<!--Solo hay que pasarle al javascript ?module=dumbo7/administracion/secciones.index.eliminar&amp;secCod={@CODIGO}' para que encuentre la URL correcta para borrar-->
				 <td width="20"><CENTER><img border="0" src="../graficos/iconos/eliminar_off.gif" alt="Eliminar Categora"/></CENTER></td>
			</xsl:if>
			
		</tr>
	<!--Filtro que muestra solo las categoras vigentes-->
	<xsl:if test="$mostrar=''">
		<xsl:for-each select="../CATEGORIA[((@PADRE=$code) and not(@PADRE=@CODIGO)) and @ESTADO='V']">
			<xsl:sort select="@DESCRIPCION"/>
				<xsl:call-template name="muestraCategoria">
					<xsl:with-param name="code" select="@CODIGO"/>
					<xsl:with-param name="parent" select="@PADRE"/>
					<xsl:with-param name="clase" select="'switchcontent'"/>
					<xsl:with-param name="tab" select="concat($tab,concat('.',position()))"/>
					<xsl:with-param name="tabimg" select="concat($tabimg,concat('.',position()))"/>
					<xsl:with-param name="seccion" select="@SECCION"/>
				</xsl:call-template>					
		</xsl:for-each>
	</xsl:if>
	<!--Filtro que todas las categoras-->
	<xsl:if test="$mostrar='todos'">
		<xsl:for-each select="../CATEGORIA[(@PADRE=$code) and not(@PADRE=@CODIGO)]">
			<xsl:sort select="@DESCRIPCION"/>
				<xsl:call-template name="muestraCategoria">
					<xsl:with-param name="code" select="@CODIGO"/>
					<xsl:with-param name="parent" select="@PADRE"/>
					<xsl:with-param name="clase" select="'switchcontent'"/>
					<xsl:with-param name="tab" select="concat($tab,concat('.',position()))"/>
					<xsl:with-param name="tabimg" select="concat($tabimg,concat('.',position()))"/>
					<xsl:with-param name="seccion" select="@SECCION"/>
				</xsl:call-template>					
		</xsl:for-each>
	</xsl:if>
		
</xsl:template>
</xsl:stylesheet>
	