package dumbo7.administracion.empresas;

import dumbo7.utils.*;
import dumbo7.utils.ldap.LDAPUser;
import dumbo7.utils.ldap.LDAPUtil;
import dumbo7.administracion.*;
import org.hibernate.*;

import java.util.*;
import java.sql.*;
import java.math.BigDecimal;


/**
 * @author rgs
 *
 * Gestor de Administracin de Dumbo
 * 
 */

public class GestorEmpresas extends GestorAdministracion {
	
	protected List empresas = null;
	protected List empresasAplicaciones = null; 
	protected List datosInformaticosVinculados = null;
	protected List aplicacionesVinculadas = null;
	protected List informaticosVinculados = null;
	protected List secciones = null;
	protected List aplicaciones = null;
	protected List datosPersonales = null;
	/**Variables necesarias*/
	public String patron = "";
	public String empresa = "";
	/**CONSTRUCTOR*/
	public GestorEmpresas() {}

	/**METODOS GET*/
	public List getEmpresas() {return empresas;}
	public List getAplicacionesVinculadas() {return aplicacionesVinculadas;}
	public List getDatosInformaticosVinculados() {return datosInformaticosVinculados;}
	public List getInformaticosVinculados() {return informaticosVinculados;}
	public List getSecciones() {return secciones;}
	public List getAplicaciones() {return aplicaciones;}
	public List getDatosPersonales() {return datosPersonales;}
	
	/**METODOS SET*/
	public void setPatron(String patron){ this.patron = patron;}
	public void setEmpresa(String empresa){ this.empresa = empresa;}
	
	/**METODOS DE LISTADOS*/
	//Listado de todas las empresas
	public void listaEmpresas(Session conn)
	{
		Query q = null;
		try
		{
			q = conn.createQuery(getQuery("AllEmpresas"));
			q = q.setString("sist",user.getDatosMenu().idSelected());
			empresas  = (List)q.list();
		}
		catch (Exception ex)
		{
			setErrorMessage("Error al listar empresas.");
			System.out.println(ex);
		}
	}
	//Listado de todas las aplicaciones de una empresa
	public void listaAplicacionesVigentesNoVinculadas(Session conn, D7Empresas emp)
	{
		Query q = null;
		try
		{
			q = conn.createQuery(getQuery("AplicacionesVigentesNoVinculadas"));
			q = q.setString("sist",user.getDatosMenu().idSelected());
			q = q.setString("emp",emp.getEmpEmail());
			aplicaciones  = (List)q.list();
		}
		catch (Exception ex)
		{
			setErrorMessage("Error al listar aplicaciones.");
		}
	}
	//Listado de todas las aplicaciones de una empresa
	public void listaSeccionesVigentes(Session conn)
	{
		Query q = null;
		try
		{
			q = conn.createQuery(getQuery("SeccionesVigentes"));
			q = q.setString("sist",user.getDatosMenu().idSelected());
			secciones  = (List)q.list();
		}
		catch (Exception ex)
		{
			setErrorMessage("Error al listar secciones." + ex);
		}
	}
	//Listado de todas las aplicaciones de una empresa
	public void listaEmpresaAplicaciones(Session conn,D7Empresas emp)
	{
		Query q = null;
		try
		{
			q = conn.createQuery(getQuery("AplicacionesVinculadasEmpresa"));
			q = q.setString("sist",user.getDatosMenu().idSelected());
			q = q.setString("emp",emp.getEmpEmail());
			aplicacionesVinculadas  = (List)q.list();
		}
		catch (Exception ex)
		{
			System.out.println(ex);
			setErrorMessage("Error al listar aplicaciones vinculadas a empresa.");
		}
	}
	//Listado de una empresa a partir de su cdigo
	public void QueryEmpresa(Session conn,D7Empresas emp)
	{
		try
		{
			Query q = conn.createQuery(getQuery("UnaEmpresa"));
			q = q.setString("sist",user.getDatosMenu().idSelected());
			q = q.setString("emp",emp.getEmpEmail());
			empresas  = (List)q.list();
		}
		catch (Exception ex)
		{
			setErrorMessage("Error al obtener datos de la empresa.");
		}
	}
	//Listado de una empresa a partir de su cdigo
	public void QueryEmpresasAplicacion(Session conn,D7Empresas emp)
	{
		try
		{
			Query q = conn.createQuery(getQuery("EmpresasAplicacion"));
			q = q.setString("sist",user.getDatosMenu().idSelected());
			q = q.setString("emp",emp.getEmpEmail());
			aplicacionesVinculadas  = (List)q.list();
		}
		catch (Exception ex)
		{
			setErrorMessage("Error al obtener aplicaciones vinculadas a empresa.");
		}
	}
	
	/********Vinculacin con informaticos ********/
	public void listaDatosInformaticosVinculados(Session conn, D7Empresas emp){
	    Query q = null;
		try{
			q = conn.createQuery(getQuery("DatosInformaticosVinculadosEmpresa"));
			q = q.setString("sist",user.getDatosMenu().idSelected());
			q = q.setString("emp",emp.getEmpEmail());
			datosInformaticosVinculados  = (List)q.list();
		}
		catch (Exception ex)
		{
			System.out.println(ex);
			setErrorMessage("Error al listar informaticos vinculados a empresa.");
		}
	}
	/********Vinculacin con informaticos ********/
	public void listaInformaticosVinculados(Session conn, D7Empresas emp){
	    Query q = null;
		try{
			q = conn.createQuery(getQuery("InformaticosVinculadosEmpresa"));
			q = q.setString("sist",user.getDatosMenu().idSelected());
			q = q.setString("emp",emp.getEmpEmail());
			informaticosVinculados  = (List)q.list();
			
		}
		catch (Exception ex)
		{
			System.out.println(ex);
			setErrorMessage("Error al listar informaticos vinculados a empresa.");
		}
	}
	/********Bsquedas de Informticos(ACTIVOS) a travs del CORREO y de los APELLIDOS*********/
	public void listaDatosPersonalesApellidos(Session conn){
	    Query q = null;
		Query q2 = null;
		try{
			if (patron.indexOf("@")>0){
				datosPersonales = new ArrayList();
			    patron = patron.substring(0,patron.length()-1);
			    Vector v = LDAPUtil.findUsersByMail(patron+"*");
			    Enumeration en = v.elements();
			    while (en.hasMoreElements()) {
		          // Hasta aqu vamos bien, saca los tios del LDAP con correo como el del patrn.
		          LDAPUser ldu = (LDAPUser)en.nextElement();
		          q = conn.createQuery(getQuery("DatosPersonalesDNI"));
		          q = q.setString("sist",user.getDatosMenu().idSelected());
		          q = q.setString("dat",ldu.getDni());
		          if(!q.list().isEmpty()){
		          	datosPersonales.add(q.list().get(0));
		          }
			    }  
			}
			else{
				String nombre = patron.substring(0, patron.indexOf("/"));
				String apellido = patron.substring(patron.indexOf("/")+1, patron.length());
				
			  	q = conn.createQuery(getQuery("DatosPersonalesApellidos"));
				q = q.setString("ape","%"+apellido+"%");
				q = q.setString("nom","%"+nombre+"%");
				q = q.setString("sist",user.getDatosMenu().idSelected());
				q = q.setString("emp",this.empresa);
				datosPersonales  = (List)q.list();
			}	
		}
		catch (Exception ex){
			setErrorMessage("Error al listar datos personales.");
		}
	}
	/*******Bsquedas de Informticos (ACTIVOS) a traves del DNI****************/
	public void BuscaDatosPersonalesDNI (Session conn, String codigo){
	    Query q = null;
	    try{
	        q = conn.createQuery(getQuery("ConsultaInformaticoDNI"));
	        q = q.setString("sist",user.getDatosMenu().idSelected());
	        q = q.setString("dat",codigo);
	        q = q.setString("emp",this.empresa);
	        datosPersonales  = (List)q.list();
	    }
        catch (Exception ex){
			setErrorMessage("Error al listar datos personales.");
		}
	}
	/*******Bsquedas de Informticos (ACTIVOS) a traves del DNI****************/
	public void listaDatosPersonalesDNI (Session conn, String codigo){
	    Query q = null;
	    try{
	        q = conn.createQuery(getQuery("DatosPersonalesDNI"));
	        q = q.setString("sist",user.getDatosMenu().idSelected());
	        q = q.setString("dat",codigo);
	        datosPersonales  = (List)q.list();
	    }
        catch (Exception ex){
			setErrorMessage("Error al listar datos personales.");
		}
	}
	
	/**METODOS PARA MODIFICAR TABLAS*/
	//Guardar empresa en base de datos
	public void saveEmpresa(Session conn, D7Empresas emp)
	{
		Transaction tx = null;
		try 
		{	
			//Creamos transaccin para poder hacer revert si hubo erro en alg mtodo
			tx = conn.beginTransaction();
				
				emp.setEmpSisCod(user.getDatosMenu().idSelected());
				conn.save(emp);
				
			tx.commit();
			
			setErrorMessage("La empresa ha sido creada correctamente.");
			emp = null;
		}
		catch (Exception ex)
		{
			setErrorMessage("Error al crear empresa: " + ex.toString());
			tx.rollback();  
		}	
	}
	//Mtodo para actualizar los datos de una empresa
	public void updateEmpresa(Session conn, D7Empresas emp)
	{
		try 
		{
			emp.setEmpSisCod(user.getDatosMenu().idSelected());
			conn.update(emp);
			conn.flush();
			conn.connection().commit();
			setErrorMessage("Los datos de la empresa han sido modificado correctamente.");
		}
		catch (Exception ex)
		{
			setErrorMessage("Error al modificar los datos de la empresa: "+ex);
		}
	}
	//Mtodo para actualizar las aplicaciones vinculadas a una empresa
	public void updateEmpresaAplicaciones(Session conn, D7EmpresasAplicaciones ea)
	{
		try 
		{
			ea.setEapSisCod(user.getDatosMenu().idSelected());
			conn.save(ea);
			conn.flush();
			conn.connection().commit();
			setErrorMessage("La aplicacin ha sido vinculada correctamente.");
		}
		catch (Exception ex)
		{
			setErrorMessage("Error al modificar los datos de la empresa: "+ex);
		}
	}
	//Borrar empresa de base de datos
	public void removeEmpresa(Session conn, D7Empresas emp)
	{
		Transaction tx = null;
		D7Empresas empresa = null;
		QueryEmpresa(conn,emp);
		QueryEmpresasAplicacion(conn,emp);
		empresa = (D7Empresas) empresas.get(0);//Si hemos recargado la pagina despues de haber borrado salta excepcion nullpointer
		
		try
		{
			//Creamos transaccin para poder hacer revert si hubo erro en alg mtodo
			tx = conn.beginTransaction();
				for(int i=0;i<aplicacionesVinculadas.size();i++)
				{
					conn.delete((D7EmpresasAplicaciones)aplicacionesVinculadas.get(i));
				}
				conn.delete(empresa);
			tx.commit();
			empresas.remove(empresa);
			empresas = null;
			aplicacionesVinculadas=null;
			
			setErrorMessage("La empresa ha sido eliminada correctamente.");
		}
		catch (IndexOutOfBoundsException nex)
		{
			setErrorMessage("No se puede eliminar una empresa que no existe (ERROR al Recargar)");
		}
		catch (Exception ex)
		{
			tx.rollback();
			empresas.remove(empresa);
			setErrorMessage("exception: "+ ex);
		}
	}
	//Mtodo para eliminar aplicacin vinculada 
	public void removeEmpresaAplicaciones(Session conn, D7EmpresasAplicaciones ea)
	{
		try 
		{
			ea.setEapSisCod(user.getDatosMenu().idSelected());
			conn.delete(ea);
			conn.flush();
			conn.connection().commit();
			setErrorMessage("La aplicacin ha sido eliminada correctamente.");
		}
		catch (Exception ex)
		{
			setErrorMessage("Error al eliminar aplicacin: "+ex);
		}
	}
	
	
	public void saveEmpresaInformatico(Session conn, D7EmpresasInformaticos  ei){
	   try{
	    	
		ei.setEinSisCod(user.getDatosMenu().idSelected());
		conn.save(ei);
		conn.flush();
		conn.connection().commit();		
		
		setErrorMessage("La asociacin ha sido creada correctamente.");
		ei = null;
		}
		catch (Exception ex)
		{
		    String informatico = user.traduce("dumbo7/administracion/empresas","informtico",user.getDatosMenu().idSelected());
			setErrorMessage("Error al asociar "+ informatico +"a empresa: " + ex.toString());
		}	
	}
	public void removeEmpresaInformatico(Session conn, D7EmpresasInformaticos  ei){
	    String informatico = user.traduce("dumbo7/administracion/empresas","informtico",user.getDatosMenu().idSelected());
	    try{
		    	
			ei.setEinSisCod(user.getDatosMenu().idSelected());
			conn.delete(ei);
			conn.flush();
			conn.connection().commit();		
			
			setErrorMessage("El " + informatico + " ha sido eliminado correctamente");
			ei = null;
			}
			catch (Exception ex)
			{
			    setErrorMessage("Error al eliminar el "+ informatico + ": " + ex.toString());
			}	
	}
	public void updateEmpresaInformatico(Session conn, D7EmpresasInformaticos  ei){
		   try{
		    	
			ei.setEinSisCod(user.getDatosMenu().idSelected());
			conn.update(ei);
			conn.flush();
			conn.connection().commit();		
			
			setErrorMessage("La asociacin ha sido modificada correctamente.");
			ei = null;
			}
			catch (Exception ex)
			{
			    String informatico = user.traduce("dumbo7/administracion/empresas","informtico",user.getDatosMenu().idSelected());
				setErrorMessage("Error al modificar la asociacin del "+ informatico +"a empresa: " + ex.toString());
			}	
		}
}//Fin del GestorAplicaciones
