<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet version="1.0" 
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:xforms="http://www.w3.org/2002/xforms">

<xsl:param name="servlet"/>	
<xsl:param name="menu"/>
<xsl:param name="empEmail"/>
<!--Include para los template que se encargan de jerarquizar el select de categoras-->
<xsl:include href="dumbo7/metricas/html/ArbolEnSelect.xsl"/>

<xsl:include href="dumbo7/utils/xsl/utils.xsl"/>
	
<xsl:template match="XMLROOT">

<html lang="es">
     <xsl:call-template name="headComun">
         <xsl:with-param name="jscript">
             <SCRIPT LANGUAGE="JavaScript">
				//Funcin para vincular aplicaciones a empresas
				function vincular()
				{
					if(document.empresa.eapAplCod.value!='')
					{
						document.empresa.module.value='dumbo7/administracion/empresas.formAsignarAplicaciones.aceptar';
						document.empresa.submit();
					}
					else
					{
						alert('Debe indicar una aplicacin.');
					}
				}
				//
				function EliminarAplicacion(url,descripcion)
				{
					if(confirm("Est seguro de que desea eliminar la aplicacin " + descripcion + "?"))
					{
						window.location.href=url;
					}
				}
				<!--Para que si tenemos un unico campo de texto no haga submit al pulsar enter-->
				function pulsar(e)
				{ 
					tecla = (document.all) ? e.keyCode :e.which; 
					return (tecla!=13); 
				} 
								
				function mostrarError(error){
					alert(error);
				}
				function cerrar_volver()
				{
					document.empresa.module.value='dumbo7/administracion/empresas.formAsignarAplicaciones.cancelar';				
					document.empresa.submit();
				}
				function buscar_aplicacion()
				{
					i=0;
					document.empresa.eapAplCod.value = document.empresa.eapAplCod.value.toUpperCase();
					for(i; i &lt; document.empresa.eapAplCodSelect.length; i++)
					{
						if(document.empresa.eapAplCodSelect.options[i].value==document.empresa.eapAplCod.value)
						{
							document.empresa.eapAplCodSelect.options[i].selected="true";
							return 0;
						}
					}
					alert("La aplicacin " + document.empresa.eapAplCod.value + " no existe o ya est vinculada.");
					document.empresa.eapAplCod.value = '';
				}
				function actualiza_eapAplCod()
				{
					if(document.empresa.eapAplCodSelect.value!=-1)
					{
						document.empresa.eapAplCod.value = document.empresa.eapAplCodSelect.value;
					}
					else
					{
						document.empresa.eapAplCod.value = ''
					}
				}
            </SCRIPT>
			<script LANGUAJE="JavaScript" src="../js/OnMouse.js"></script>
         </xsl:with-param>
	   </xsl:call-template>


<body>
		
	<xsl:call-template name="menuComun">
		<xsl:with-param name="NAME" select="concat(DATA/EMPRESAS/USER/@NAME,concat('(',concat(DATA/EMPRESAS/USER/@LOGIN,')')))"/>
		<xsl:with-param name="MENU" select="DATA/MENU"/>
		<xsl:with-param name="SELECT" select="$menu"/>
		<xsl:with-param name="HELP">administracion.xml#1.11.5</xsl:with-param>
	</xsl:call-template>

<xsl:call-template name="pieComun"/>
</body>
</html>

</xsl:template>

<xsl:template name="cuerpo">
	<xsl:for-each select="DATA/EMPRESAS">
		<xsl:if test="not(@ERROR='')">
			<script>mostrarError('<xsl:value-of select="@ERROR"/>')</script>
			</xsl:if>
	</xsl:for-each>

<table align="center" border="0" cellpadding="5" cellspacing="5" width="775" summary="Asignacin de Aplicaciones a Empresas">
<tr><td width="700" colspan="2" class="cab1">&#187;Vincular aplicaciones a
	<!--For Para poder mostrar la descripcion en la cabecera de la tabla-->
		<xsl:for-each select="DATA/EMPRESAS/EMPRESA[@EMAIL=$empEmail]">
			"<xsl:value-of select="@NOMBRE"/>"
		</xsl:for-each>	</td></tr>
<tr><td colspan="2">
	<form action="{$servlet}" METHOD="POST" name="empresa">
	<input type="hidden" name="eapEmpEmail" value="{$empEmail}"/>
	<input type="hidden" name="empEmail" value="{$empEmail}"/>
	<input type="hidden" name="module"/>
	<table class="cont" border="0" cellpadding="3" cellspacing="1" width="100%" summary="Asignacin de Informticos a Aplicaciones">
				<SCRIPT>
					var arrayDescripiones = new Array();
				</SCRIPT>	
				<tr>
					<td class="cabe" width="12%"><b><font face="Verdana" size="2">Cdigo</font></b></td>
					<td class="cabe" width="55%"><b><font face="Verdana" size="2">Descripcin</font></b></td>
					<td class="cabe" width="30%"><b><font face="Verdana" size="2">Seccin</font></b></td>
					<td class="cabe" align="center"></td>
				</tr>

				<xsl:for-each select="DATA/EMPRESAS/APLICACION_VINCULADA">
					<xsl:sort select="@CODIGO"/>
					<tr class="administracion" onmouseover="javascript:onMouse(this,'true');" onmouseout="javascript:onMouse(this,'false');">
						<SCRIPT>
							arrayDescripiones['<xsl:value-of select="@CODIGO"/>'] = "<xsl:value-of select="@DESCRIPCION"/>";
						</SCRIPT>
						<td><xsl:value-of select="@CODIGO"/></td>
						<td><xsl:value-of select="@DESCRIPCION"/></td>
						<td>
							<xsl:variable name="secCod"><xsl:value-of select="@SECCION"/></xsl:variable> 
							<xsl:for-each select="../SECCION[@CODIGO=$secCod]">
								<xsl:value-of select="@DESCRIPCION"/>
							</xsl:for-each>
						</td>
						<td><a href="javascript:EliminarAplicacion('?module=dumbo7/administracion/empresas.formAsignarAplicaciones.eliminar&amp;eapEmpEmail={$empEmail}&amp;eapAplCod={@CODIGO}&amp;empEmail={$empEmail}',arrayDescripiones['{@CODIGO}'])"><img border="0" src="../graficos/iconos/eliminar.gif" alt="Eliminar"/></a></td>
					</tr>
			</xsl:for-each>
			<xsl:if test="count(DATA/EMPRESAS/APLICACION_VINCULADA)=0">
				<tr class="administracion">
					<td align="center" colspan="4">* No hay aplicaciones asociadas a esta empresa.</td>
				</tr>
			</xsl:if>
		<tr>
		<table class="cont" align="center" border="0" cellpadding="3" cellspacing="1" width="90%" summary="Asignacin de aplicaciones a empresas">
		<tr>
			<td class="cabe" align="left" colspan="3"><b>Vincular aplicacin</b></td>
		</tr>
		<xsl:if test="count(DATA/EMPRESAS/APLICACION)!=0">
			<tr class="administracion">
				<td>
					<input type="text" name="eapAplCod" size="14"  maxlength="10" onChange="buscar_aplicacion()"/>&#160;
					<select name="eapAplCodSelect" size="1" onChange="actualiza_eapAplCod()">
						<xsl:call-template name="muestraAplicaciones">
							<xsl:with-param name="nodo" select="DATA/EMPRESAS"/>
							<xsl:with-param name="espacio" select="'&#160;'"/>
						</xsl:call-template>
					</select>&#160;
					<input type="button" class="boton" value="Vincular" onclick="javascript:vincular()"/>
				</td>
			</tr>
		</xsl:if>
		<xsl:if test="count(DATA/EMPRESAS/APLICACION)=0">
			<tr class="administracion"><td align="center">* No hay ms empresas para asignar.</td></tr>
		</xsl:if>
		<tr class="administracion">
			<td colspan="3" align="center">
				<input type="button" class="boton" value="Volver" onclick="javascript:cerrar_volver()"/>
			</td>
		</tr>
	</table>
	</tr>
</table>
</form>
</td></tr>
</table>

<p>&#160;</p>

</xsl:template>
</xsl:stylesheet>
	