<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet version="1.0" 
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:xforms="http://www.w3.org/2002/xforms">

<xsl:param name="servlet"/>	
<xsl:param name="menu"/>

<xsl:param name="empEmail"/>

<xsl:include href="dumbo7/utils/xsl/utils.xsl"/>
	
<xsl:template match="XMLROOT">

<html lang="es">
     <xsl:call-template name="headComun">
         <xsl:with-param name="jscript">
			<script LANGUAJE="JavaScript">
				//Funcin para activar la variable de cambios y as notificarlos (si la variable es false, no se mostrar mensaje de cambios ni se har submit)
				function cerrar()
				{
					document.empresa.module.value='dumbo7/administracion/empresas.formNueva.cancelar'
					document.empresa.submit();
				}
			</script>
         </xsl:with-param>
	   </xsl:call-template>
<body>
		
	<xsl:call-template name="menuComun">
		<xsl:with-param name="NAME" select="concat(DATA/EMPRESAS/USER/@NAME,concat('(',concat(DATA/EMPRESAS/USER/@LOGIN,')')))"/>
		<xsl:with-param name="MENU" select="DATA/MENU"/>
		<xsl:with-param name="SELECT" select="$menu"/>
		<xsl:with-param name="HELP">administracion.xml#1.11.2</xsl:with-param>
	</xsl:call-template>

<xsl:call-template name="pieComun"/>
</body>
</html>

</xsl:template>

<xsl:template name="cuerpo">
<table align="center" border="0" cellpadding="5" cellspacing="5" width="775" summary="Esta tabla contien el formulario para la creacin de la nueva empresa">
<tr><td width="150" colspan="2" class="cab1">&#187;Detalle empresa 
	<!--For Para poder mostrar la descripcion en la cabecera de la tabla-->
		<xsl:for-each select="DATA/EMPRESAS/EMPRESA[@EMAIL=$empEmail]">
			"<xsl:value-of select="@NOMBRE"/>"
		</xsl:for-each>	</td></tr>
<tr><td colspan="2">
	<form action="{$servlet}" METHOD="POST" name="empresa">
	<input type="hidden" name="module"/>
	<input type="hidden" name="checkCambios" size="20" value="false"/>
	<input type="hidden" name="empEmail" value="{$empEmail}"/>
	<table class="cont" align="center" border="0" cellpadding="3" cellspacing="1" width="90%" summary="Esta tabla contiene el formulario para la creacin de la nueva empresa">
		<tr>
			<td class="cabe" align="left" colspan="4"><b>Datos de la empresa</b></td>
		</tr>
		<tr class="administracion">
			<td width="14%"><b>Nombre&#160;:</b></td>
			<td colspan="3"><xsl:value-of select="DATA/EMPRESAS/EMPRESA/@NOMBRE"/></td>
		</tr>
		<tr class="administracion">
			<td><b>CIF&#160;:</b></td>
			<td colspan="3"><xsl:value-of select="DATA/EMPRESAS/EMPRESA/@CIF"/></td>
		</tr>
		<tr class="administracion">
			<td><b>Direccin:</b></td>
			<td colspan="3"><xsl:value-of select="DATA/EMPRESAS/EMPRESA/@DIRECCION"/></td>
		</tr>
		<tr class="administracion">
			<td><b>Poblacin:</b></td>
			<td colspan="3"><xsl:value-of select="DATA/EMPRESAS/EMPRESA/@POBLACION"/></td>
		</tr>
		<tr class="administracion">
			<td><b>Provincia:</b></td>
			<td colspan="3"><xsl:value-of select="DATA/EMPRESAS/EMPRESA/@PROVINCIA"/></td>
		</tr>
		<tr class="administracion">
			<td><b>Cdigo&#160;postal:</b></td>
			<td colspan="3"><xsl:value-of select="DATA/EMPRESAS/EMPRESA/@CODIGO_POSTAL"/></td>
		</tr>
		<tr class="cabe">
			<td colspan="4"><b>Datos de contacto</b></td>
		</tr>
		<tr class="administracion">
			<td><b>Contacto&#160;1:</b></td>
			<td width="36%"><xsl:value-of select="DATA/EMPRESAS/EMPRESA/@CONTACTO1"/></td>
			<td width="12%"><b>Telefono&#160;1:</b></td>
			<td><xsl:value-of select="DATA/EMPRESAS/EMPRESA/@TELEFONO1"/></td>
		</tr>
		<tr class="administracion">
			<td><b>Contacto&#160;2:</b></td>
			<td><xsl:value-of select="DATA/EMPRESAS/EMPRESA/@CONTACTO2"/></td>
			<td><b>Telefono&#160;2:</b></td>
			<td><xsl:value-of select="DATA/EMPRESAS/EMPRESA/@TELEFONO2"/></td>
		</tr>
		<tr class="administracion">
			<td><b>Correo:</b></td>
			<td colspan="3"><xsl:value-of select="DATA/EMPRESAS/EMPRESA/@EMAIL"/></td>
		</tr>
		<tr class="cabe">
			<td colspan="4"><b>Observaciones</b></td>
		</tr>
		<tr class="administracion">
			<xsl:if test="count(DATA/EMPRESAS/EMPRESA/@OBSERVACIONES)!=0">
				<td colspan="4">
					<xsl:value-of select="DATA/EMPRESAS/EMPRESA/@OBSERVACIONES"/>
				</td>
			</xsl:if>
			<xsl:if test="count(DATA/EMPRESAS/EMPRESA/@OBSERVACIONES)=0">
				<td colspan="4" align="center">
					Sin observaciones.
				</td>
			</xsl:if>
		</tr>
		<tr class="administracion">
			<td colspan="4" align="center">
			<input type="button" class="boton" value="Cancelar" onclick="javascript:cerrar()"/></td>
		</tr>		
	</table>
	</form>
</td></tr>
</table>

</xsl:template>
</xsl:stylesheet>
	