<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet version="1.0" 
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:xforms="http://www.w3.org/2002/xforms">

<xsl:param name="servlet"/>	
<xsl:param name="menu"/>

<xsl:include href="dumbo7/utils/xsl/utils.xsl"/>

<xsl:template match="XMLROOT">

<html lang="es">
     <xsl:call-template name="headComun">
	    <xsl:with-param name="jscript">
			<script LANGUAJE="JavaScript">
				function mostrarError(error)
				{
					alert(error);
				}
			</script>
			<script LANGUAJE="JavaScript" src="../js/empresas/PreguntaBorrar.js"></script>
			<script LANGUAJE="JavaScript" src="../js/OnMouse.js"></script>
         </xsl:with-param>
	   </xsl:call-template>

<body>
		
	<xsl:call-template name="menuComun">
		<xsl:with-param name="NAME" select="concat(DATA/EMPRESAS/USER/@NAME,concat('(',concat(DATA/EMPRESAS/USER/@LOGIN,')')))"/>
		<xsl:with-param name="MENU" select="DATA/MENU"/>
		<xsl:with-param name="SELECT" select="$menu"/>
		<xsl:with-param name="HELP">administracion.xml#1.11</xsl:with-param>
	</xsl:call-template>

<xsl:call-template name="pieComun"/>
</body>
</html>

</xsl:template>

<xsl:template name="cuerpo">
	<xsl:for-each select="DATA/EMPRESAS">
		<xsl:if test="not(@ERROR='')">
			<script>mostrarError('<xsl:value-of select="@ERROR"/>')</script>
			</xsl:if>
	</xsl:for-each>


<table  align="center" border="0" cellpadding="5" cellspacing="5" width="775" height="16" summary="Esta tabla contiene una lista de empresas">
<form action="{$servlet}" METHOD="GET" name="empresas">
	<tr>
		<td class="cab1" style="width:90%">&#187;Listado de empresas</td>
		<td style="align:center">
			<a href="{$servlet}?module=dumbo7/administracion/empresas.index.nueva">Insertar Empresa</a>
		</td>
	</tr>
	<tr><td colspan="2">
	<table class="cont" border="0" cellpadding="3" cellspacing="1" width="100%">
		<tr>		
			<!--Cabecera-->
			<td class="cabe" width="10%" align="center"><b><font face="Verdana" size="2"></font>CIF</b></td>
			<td class="cabe" width="40%" align="center"><b><font face="Verdana" size="2"></font>Empresa</b></td>
			<td class="cabe" width="24%" align="center"><b><font face="Verdana" size="2"></font>Correo</b></td>
			<td class="cabe" width="10%" align="center"><b><font face="Verdana" size="2"></font>Telefono</b></td>
			<td class="cabe" width="18%" align="center"><b><font face="Verdana" size="2"></font></b></td>
		</tr>
		<SCRIPT>
			<!--Para guardar el nombre y pasarlo a los javascript de tal forma que se respeten las tildes en los string-->
			var arrayNombre = new Array();
		</SCRIPT>	
		<!--Recorremos el nodo empresas para encontrar todos los nodos de tipo empresa y mostralos-->
		<xsl:for-each select="DATA/EMPRESAS/EMPRESA">
			<xsl:sort select="@DESCRIPCION"/>
			<SCRIPT>
				<!--Se guarda el nombre para pasarlo al javascript de borrar de tal forma que se respeten las tildes en los string-->
				arrayNombre['<xsl:value-of select="@EMAIL"/>'] = <xsl:call-template name="entrecomillaDescripcion"><xsl:with-param name="descripcion" select="@NOMBRE"/></xsl:call-template>;
			</SCRIPT>
			<tr class="administracion" onmouseover="javascript:onMouse(this,'true');" onmouseout="javascript:onMouse(this,'false');">
				<td><xsl:value-of select="@CIF"/></td>
				<td><a href="{$servlet}?module=dumbo7/administracion/empresas.index.detalle&amp;empEmail={@EMAIL}"><xsl:value-of select="@NOMBRE"/></a></td>
				<td><xsl:value-of select="@EMAIL"/></td>
				<td><xsl:value-of select="@TELEFONO1"/></td>
				<!--Operaciones disponibles-->
				<td align="center">
					<xsl:variable name="traducido"><xsl:call-template name="traduce"><xsl:with-param name="id" select="'informtico'"/></xsl:call-template></xsl:variable>
					<a href="{$servlet}?module=dumbo7/administracion/empresas.index.asignarInformaticos&amp;empEmail={@EMAIL}"><img  border="0" src="../graficos/iconos/Informatico+-.gif" alt="Vincular/Desvincular {$traducido}"/></a>&#160;	
					<a href="{$servlet}?module=dumbo7/administracion/empresas.index.asignar&amp;empEmail={@EMAIL}"><img border="0" src="../graficos/iconos/aplicacion_vincular.gif" alt="Vincular/Desvincular aplicaciones"/></a>&#160;
					<a href="{$servlet}?module=dumbo7/administracion/empresas.index.modificar&amp;empEmail={@EMAIL}"><img border="0" src="../graficos/iconos/modificar.gif" alt="Modificar Empresa"/></a>&#160;
					<a href="javascript:validar('?module=dumbo7/administracion/empresas.index.eliminar&amp;empEmail={@EMAIL}',arrayNombre['{@EMAIL}']);"><img border="0" src="../graficos/iconos/eliminar.gif" alt="Eliminar Empresa"/></a>
				</td>
			</tr>
		</xsl:for-each>
		<!--Si no hay empresas en este sistema-->
		<xsl:if test="count(DATA/EMPRESAS/EMPRESA)=0">
			<tr>
				<td class="administracion" colspan="5" align="center"> No hay Empresas.</td>
			</tr>
		</xsl:if>
		
	</table></td></tr>
</form>
</table>
</xsl:template>

</xsl:stylesheet>
