package dumbo7.administracion.gruposcostes;

import dumbo7.utils.*;
import dumbo7.administracion.*;
import org.hibernate.*;
import org.hibernate.exception.ConstraintViolationException;

import atica.frameweb.query.*;
import java.sql.*;
import java.util.*;
import java.math.BigDecimal;
import java.math.BigInteger;
/**
 * @author Universidad de Murcia - ATICA
 *
 */

public class GestorGruposCostes extends GestorAdministracion {
	
	public GestorGruposCostes() {}
	
	//Las listas son necesarias para el mapeo (hace return de estas variables en los metodos get)
	protected List grupoCostes = null;
	private D7GruposCostes grupoCoste = null;	
	private String codigoNuevoGrupoCoste = null;//Se usa tanto para crear nuevas secciones como para hacer update
	
		
	
	
	//	Metodos get necesarios para el mapeo
	public List getGrupoCostes() { return grupoCostes; }
	
	public void setGrupoCoste(Session conn,D7GruposCostes gco) {
		gco.setGcoSisCod(user.getDatosMenu().idSelected);
		grupoCoste =gco;
	}
		 
	public void listaGruposCostes(Session conn) {
		try {
					
			Query q = conn.createQuery(getQuery("AllGruposCostes"));
			q = q.setString("sist",user.getDatosMenu().idSelected());
			grupoCostes  = (List)q.list();
			
		} catch (Exception ex) {
			logger.error(ex.getMessage());
		}
	}
	
	public void saveGrupoCoste(Session conn) {
		try {
			if(grupoCoste == null){
				setErrorMessage("NO SE HAN INTRODUCIDO TODOS LOS CAMPOS");
			}
			else{
			conn.save(grupoCoste);
			conn.flush();
			conn.connection().commit();
			codigoNuevoGrupoCoste = grupoCoste.getGcoCod();
			grupoCoste = null;
			setErrorMessage("El grupo de coste ha sido creado correctamente");
			}
		} catch (Exception ex) {
			setErrorMessage("Introduzca los valores correctamente");
		}
	}
	
	

	//Borra un grupo de costes en BD
	public void removeGrupoCoste(Session conn, D7GruposCostes gco) {
		List gruposcostes;
		try
		{
	
			//obtengo el grupo de coste que deseo eliminar	
			
			Query q = conn.createQuery(getQuery("GrupoCostes"));
			q = q.setString("sist",user.getDatosMenu().idSelected());
			q = q.setString("cod",gco.getGcoCod());
			gruposcostes  = (List)q.list();			
			//Si hemos recargado la pagina despues de haber borrado salta excepcion nullpointer	
			grupoCoste = (D7GruposCostes) gruposcostes.get(0);
			conn.delete(grupoCoste);
			conn.flush();
			conn.connection().commit();
			
			gruposcostes.remove(grupoCoste); //para evitar que se vuelva a mapear

			setErrorMessage("El Grupo de Coste se ha eliminado correctamente.");
		
		}
		catch (ConstraintViolationException cve)
		{
			setErrorMessage("Existen tablas dependientes.");
		}
		catch (Exception ex)
		{
			setErrorMessage("Grupo de Coste ya eliminado.");			
		}
	}	
	
	
//	Actualiza un grupocoste en BD
	public void updateGrupoCoste(Session conn,D7GruposCostes gco) {
		try 
		{						
			gco.setGcoSisCod(user.getDatosMenu().idSelected());
			conn.update(gco);
			conn.flush();
			conn.connection().commit();
			setErrorMessage("El Grupo de Coste ha sido modificado correctamente.");

		} catch (Exception ex) {
			setErrorMessage("Error al modificar el grupo de coste");
		}
	}
	
//	Invierte el estado de un grupocoste. De Vigente a no Vigente (Valido a no valido) y de No Vigente a Vigente (no valido a valido)
	public void changeState(Session conn, D7GruposCostes gco) {
	
		try {
			gco.setGcoSisCod(user.getDatosMenu().idSelected());
			grupoCoste=gco;
			//obtengo el grupo de coste al que deseo cambiar el estado	
			Query q = conn.createQuery(getQuery("GrupoCostes"));
			q = q.setString("sist",user.getDatosMenu().idSelected());
			q = q.setString("cod",gco.getGcoCod());
			grupoCostes  = (List)q.list();		
			grupoCoste = (D7GruposCostes) grupoCostes.get(0);
		
			//si el estado es vigente se cambia a no vigente
			if (grupoCoste.getGcoEstado().equals("V"))
			{
				grupoCoste.setGcoEstado("N");
				compruebaVinculos(conn,gco);
			}
			//si el estado es no vigente se cambia a vigente
			else 
				grupoCoste.setGcoEstado("V");

			conn.update(grupoCoste);
			grupoCostes.remove(grupoCoste);//para evitar que se vuelva a mapear			
			conn.flush();
			conn.connection().commit();	
		}
		catch (Exception ex)
		{
			setErrorMessage("Error al cambiar estado");
		}
	}
	//Comprueba si un grupo de costes tiene vinculos con algn informtico. Si es as, mapea un mensaje de error.
	public void compruebaVinculos (Session conn, D7GruposCostes gco)
	{
		List infor;
		
		try
		{
			Query q1 = conn.createQuery(getQuery("GCostesInformaticos"));
			q1 = q1.setString("sist",user.getDatosMenu().idSelected());
			q1 = q1.setString("gco",gco.getGcoCod());
			infor  = (List)q1.list();
			
			if( infor.size()!=0)
			{
				setErrorMessage("Atencin!, El grupo de costes al que acaba de cambiar el estado tiene " + user.traduce("dumbo7/administracion/gruposcostes","informticos",user.getDatosMenu().idSelected()) + " vinculados.");
			}
			
			infor = null;
		}
		catch(Exception ex)
		{
			setErrorMessage("Error al comprobar vinculos");
		}
	}
}