<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet version="1.0" 
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:xforms="http://www.w3.org/2002/xforms">

<xsl:param name="servlet"/>	
<xsl:param name="menu"/>
<!--"mostrar" es un flag para el filtrado de grupos de coste (muestra 'todos' o muestra solo los vigentes (''))-->
<xsl:param name="mostrar"/>

<xsl:include href="dumbo7/utils/xsl/utils.xsl"/>
	
<xsl:template match="XMLROOT">
<html lang="es">
	<xsl:call-template name="headComun">
		 <xsl:with-param name="jscript">
			<script LANGUAJE="JavaScript">
				function validar(url,des)
				{
					if (confirm("Est seguro de eliminar el grupo de costes \n "+des+" ?"))
					{
						var mostrar = '<xsl:value-of select="$mostrar"/>'
						url = url.concat("&amp;mostrar=");
						url = url.concat(mostrar);
						window.open(url,"_self");
					}
				}
				function mostrarError(error){
					alert(error);
				}
				function CambiarEstado(url,estado)
				{
					if (confirm("Est seguro de cambiar el estado a " + estado + "?"))
					{
						var mostrar = '<xsl:value-of select="$mostrar"/>'
						url = url.concat("&amp;mostrar=");
						url = url.concat(mostrar);
						window.open(url,"_self");
					}
				}
				function mostrarTodo(url){
					window.open(url,"_parent");				
				}  
			</script>
			<script LANGUAJE="JavaScript" src="../js/OnMouse.js"></script>
		</xsl:with-param>
	 </xsl:call-template>
<body>

	
	<xsl:call-template name="menuComun">
		<xsl:with-param name="NAME" select="concat(DATA/GRUPOS_COSTES/USER/@NAME,concat('(',concat(DATA/GRUPOS_COSTES/USER/@LOGIN,')')))"/>
		<xsl:with-param name="MENU" select="DATA/MENU"/>
		<xsl:with-param name="SELECT" select="$menu"/>
		<xsl:with-param name="HELP">administracion.xml#1.6</xsl:with-param>
	</xsl:call-template>

<xsl:call-template name="pieComun"/>
	</body>
	</html>
</xsl:template>
<xsl:template name="cuerpo">
	<xsl:for-each select="DATA/GRUPOS_COSTES">
		<xsl:if test="not(@ERROR='')">
			<script>mostrarError('<xsl:value-of select="@ERROR"/>')</script>
			</xsl:if>
	</xsl:for-each>

<table align="center" border="0" cellpadding="5" cellspacing="5" width="775"  summary="Esta tabla contiene una lista de gruposcostes">
	<tr>
		<td width="65%" class="cab1">&#187;Listado de grupos de costes</td>
		<xsl:if test="count(DATA/GRUPOS_COSTES/GRUPO_COSTE[@ESTADO='N'])>0">
			<xsl:if test="$mostrar='todos'">
				<td width="20%" align="center">	
					<a href="{$servlet}?module=dumbo7/administracion/gruposcostes.index">Mostrar Vigentes</a>
				</td>
			</xsl:if>
			<xsl:if test="$mostrar=''">
				<td width="20%" align="center">	
					<a href="JavaScript:mostrarTodo('{$servlet}?module=dumbo7/administracion/gruposcostes.index&amp;mostrar=todos');">Mostrar Todas</a>
				</td>
			</xsl:if>
		</xsl:if>
		<td width="15%" align="center"><a href="{$servlet}?module=dumbo7/administracion/gruposcostes.index.nueva">Insertar Grupo</a></td>
	</tr>
	<tr><td colspan="4">
		<table class="cont" border="0" cellpadding="3" cellspacing="1" width="100%">
		<tr>		
			<!--Cabecera de la tabla (cuidado con los anchos y con los anchos de los campos dentro del bucle) -->
			<td class="cabe" width="30"><b><font face="Verdana" size="2">Est</font></b></td>
			<td class="cabe" width="80" align="center"><b><font face="Verdana" size="2">Cdigo</font></b></td>
			<td class="cabe" width="350"><b><font face="Verdana" size="2">Descripcin</font></b></td>
			<td class="cabe" width="80" align="center"><b><font face="Verdana" size="2">Coste/hora</font></b></td>
			<td class="cabe" width="60" align="center"><b><font face="Verdana" size="2">Horas</font></b></td>
			<td class="cabe" colspan="3"></td>

			</tr>
			<SCRIPT>
				<!--Para guardar la descripcin y pasarlo a los javascript de tal forma que se respeten las tildes en los string-->
				var arrayDescripcion = new Array();
			</SCRIPT>	
			<xsl:if test="count(DATA/GRUPOS_COSTES/GRUPO_COSTE)=0">
				<tr>
					<td class="administracion" colspan="8" align="center"> No hay Grupos de Costes.</td>
				</tr>
			</xsl:if>
			<!--Muestra todos los grupos de coste-->
			<xsl:if test="$mostrar='todos'">
				<xsl:for-each select="DATA/GRUPOS_COSTES/GRUPO_COSTE">
					 <xsl:call-template name="muestraGruposCoste"/>
				</xsl:for-each>
			</xsl:if>
			<xsl:if test="$mostrar=''">
				<xsl:for-each select="DATA/GRUPOS_COSTES/GRUPO_COSTE[@ESTADO='V']">
					<xsl:call-template name="muestraGruposCoste"/>
				</xsl:for-each>
			</xsl:if>
	</table>
</td></tr>
</table>
</xsl:template>

<xsl:template name="muestraGruposCoste">
	<tr class="administracion" onmouseover="javascript:onMouse(this,'true');" onmouseout="javascript:onMouse(this,'false');">						
		<SCRIPT>
			arrayDescripcion['<xsl:value-of select="@CODIGO"/>'] = <xsl:call-template name="entrecomillaDescripcion"><xsl:with-param name="descripcion" select="@DESCRIPCION"/></xsl:call-template>;
		</SCRIPT>
		<td width="30" align="center"> 
			<xsl:if test="@ESTADO='V'">
				<img  border="0" src="../graficos/iconos/vigente.gif" alt="Vigente"/>
			</xsl:if>
			<xsl:if test="@ESTADO='N'">
				<img border="0" src="../graficos/iconos/no_vigente.gif" alt="No Vigente"/>
			</xsl:if>
		</td>
		<td width="80" align="center"><xsl:value-of select="@CODIGO"/></td>
		<td width="350">
			<!--muestra un substring de la descripcin-->
			<a title="{@DESCRIPCION}" href="{$servlet}?module=dumbo7/administracion/gruposcostes.index.verDetalle&amp;gcoCod={@CODIGO}">
				<!--SI LA DESCRIPCION TIENE MENOS DE 42 CARACTERES-->
				<xsl:if test="42>=string-length(@DESCRIPCION)">								
					<xsl:value-of select="@DESCRIPCION"/>
				</xsl:if>
				<!--SI LA DESCRIPCION TIENE MAS DE 42 CARACTERES-->
				<xsl:if test="string-length(@DESCRIPCION)>42">
					<xsl:value-of select="concat(substring(@DESCRIPCION,0,42),'...')"/>
				</xsl:if>
			</a>	
		</td>			
		<td width="80" align="center"><xsl:value-of select="@COSTE"/></td>			
		<td width="60" align="center"><xsl:value-of select="@HORAS"/></td>
							
		<td width="20"><CENTER>
			<xsl:if test="@ESTADO='V'">
				 <a href="JavaScript:CambiarEstado('{$servlet}?module=dumbo7/administracion/gruposcostes.index.cambiar&amp;gcoCod={@CODIGO}','NO VIGENTE');"><img border="0" src="../graficos/iconos/CambiarEstadoNV.gif" alt="Cambiar Estado de Grupo a NO VIGENTE"/></a>
			</xsl:if>
			<xsl:if test="@ESTADO='N'">
				 <a href="JavaScript:CambiarEstado('{$servlet}?module=dumbo7/administracion/gruposcostes.index.cambiar&amp;gcoCod={@CODIGO}','VIGENTE');"><img border="0" src="../graficos/iconos/CambiarEstadoV.gif" alt="Cambiar Estado de Grupo a VIGENTE"/></a>
			</xsl:if>
		</CENTER></td>
		
		<td width="20" align="center"><a href="{$servlet}?module=dumbo7/administracion/gruposcostes.index.modificar&amp;gcoCod={@CODIGO}"><img  border="0" src="../graficos/iconos/modificar.gif" alt="Modificar Grupo Costes"/></a></td>		
		<td width="20" align="center"><a href="javascript:validar('?module=dumbo7/administracion/gruposcostes.index.eliminar&amp;gcoCod={@CODIGO}',arrayDescripcion['{@CODIGO}']);"><img border="0" src="../graficos/iconos/eliminar.gif" alt="Eliminar Grupo Costes"/></a></td>
	</tr>
</xsl:template>

</xsl:stylesheet>
	