package dumbo7.administracion.gruposusuarios;

import dumbo7.utils.*;
import dumbo7.utils.ldap.LDAPUser;
import dumbo7.utils.ldap.LDAPUtil;
import dumbo7.administracion.*;
import org.hibernate.*;


import java.math.BigDecimal;
import java.sql.*;
import java.util.*;


/**
 * @author prc
 *
 * Gestor de Administracin de Dumbo
 * 
 */

public class GestorGruposUsuarios extends GestorAdministracion {
	
	public GestorGruposUsuarios() {}
	
	//Las listas son necesarias para el mapeo (hace return de estas variables en los metodos get)
	protected List grupoUsuarios = null;
	protected List usuarioGrupos = null;
	protected List datosPersonales = null;
	protected List datosPersonalesSeleccion = null;
	//Contiene los subgrupos de usuarios de un grupo
	protected Vector subGrupo = null;
		
	private D7GruposUsuarios grupoUsuario = null;
	private D7GruposUsuarios grupoUsuarioGrupo = null;
	private D7UsuariosGrupos usuarioGrupo = null;
	private D7GruposUsuarios UngrupoUsuario = null;
	
	
	private String codigoNuevoGrupoUsuario = null;//Se usa tanto para crear nuevos grupos como para hacer update
	private String  codigoGrupo=null;//se usa para asociar usarios a grupos
	private String [] datos = null;//Datos usados por ListaDatosPersonalesSeleccion
	private String [] Sel = null;
	private String [] DNI = null;
	
	private String [] codigosUsuarios=null;//Necesario para poder pasar una lista de usuarios a la hora de crear el grupo
	private String codigoUsuario=null;//Necesario para las busquedas
	private String CodigoGrupoUsuario = null;
	
//	Metodos get necesarios para el mapeo
	public List getGrupoUsuarios() { return grupoUsuarios; }
	public List getUsuarioGrupos() { return usuarioGrupos; }
	public List getDatosPersonales() { return datosPersonales; }
	public List getDatosPersonalesSeleccion() { return datosPersonalesSeleccion; }
	
	//Mtodo para fijar el codigo del usuario cuando se aade un nuevo usuario
	public void setCodigoUsuario(String codUsu)
	{
		codigoUsuario = codUsu;
	}
	//Obtiene un array con todos los usuarios que se desean aadir al crear el grupo
	public void setCodigosUsuarios(String [] codigosUsuarios)
	{
		this.codigosUsuarios = codigosUsuarios;
	}
	//Mtodo para fijar los apellidos para realizar la bsqueda del informtico
	public void setDatos(String [] datos)
	{
		this.datos = datos;
	}
	//La variable Sel puede ser 1 o 2.
	//Si Sel=1, la bsqueda se debe de realizar por DNI (la variable DNI contendra un identificador)
	//Si Sel=2, la bsqueda se debe de realizar por Correo (la variable DNI contendra un correo)
	public void setSel(String [] Sel)
	{
		this.Sel = Sel;
	}
	//Mtodo para fijar el DNI para realizar la bsqueda del informtico
	public void setDNI(String [] DNI)
	{
		this.DNI = DNI;
	}
	//Mtodo para fijar el Grupo sobre el que realizamos modificaciones
	public void setGrupo(String gru)
	{
		codigoGrupo=gru;
	}
	
	//Devuelve todos los datos personales de todos los usuarios (no tiene en cuenta sistema)
	/*public void listaDatosPersonales(Session conn)
	{
		try
		{
			Query q = conn.createQuery(getQuery("AllDatosPersonales"));
			q = q.setString("sist",user.getDatosMenu().idSelected());
			datosPersonales  = (List)q.list();
		}
		catch (Exception ex)
		{
			logger.error(ex.getMessage());
		}
	}*/
	//Bsqueda a partir de los datos introducidos por setDatos
	public void listaDatosPersonalesSeleccion(Session conn)
	{
		try
		{
			if (datos[0].indexOf("@")>0)
			{
				datosPersonales = new ArrayList();
			    datos[0] = datos[0].substring(0,datos[0].length()-1);
			    Vector v = LDAPUtil.findUsersByMail(datos[0]+"*");
			    Enumeration en = v.elements();
			    while (en.hasMoreElements()) {
			          // Hasta aqu vamos bien, saca los tios del LDAP con correo como el del patrn.
			          LDAPUser ldu = (LDAPUser)en.nextElement();
			          Query q = conn.createQuery(getQuery("DatosPersonalesDNI"));
			          q = q.setString("sist",user.getDatosMenu().idSelected());
			          q = q.setString("dat",ldu.getDni());
			          if(!q.list().isEmpty()){
			          	datosPersonales.add(q.list().get(0));
			          }
			    }  
			}
			else
			{
				String patron = datos[0];
				Query q = conn.createQuery(getQuery("DatosPersonales"));
				String nom = patron.substring(0, patron.indexOf("/"));
				String ape = patron.substring(patron.indexOf("/")+1, patron.length());
				q = q.setString("nom","%"+nom+"%");
				q = q.setString("ape","%"+ape+"%");
				q = q.setString("sist",user.getDatosMenu().idSelected());
				datosPersonales  = (List)q.list();
			}
		}
		catch (Exception ex)
		{
			logger.error(ex.getMessage());
		}
	}

	public void listaDatosPersonalesDNI(Session conn, String Codigo)
	{
		try
		{
			Query q = conn.createQuery(getQuery("DatosPersonalesDNI"));
			q = q.setString("dat",Codigo);
			q = q.setString("sist",user.getDatosMenu().idSelected());
			datosPersonales  = (List)q.list();
		}
		catch (Exception ex)
		{
			logger.error(ex.getMessage());
		}
	}
	//Mtodo que lista todos los GruposUsuarios
	public void listaGruposUsuarios(Session conn)
	{ 
		try 
		{			
			Query q = conn.createQuery(getQuery("AllGruposUsuarios"));
			q = q.setString("sist",user.getDatosMenu().idSelected());
			grupoUsuarios  = (List)q.list();		
		}
		catch (Exception ex)
		{
			logger.error(ex.getMessage());
		}
	}
	//Lista los usuarios dentro de un solo grupo
	public void listaUsuariosGrupo(Session conn,D7GruposUsuarios gru)
	{
		try
		{
			Query q1 = conn.createQuery(getQuery("AllUsuarios"));
			q1 = q1.setString("sist",user.getDatosMenu().idSelected());
			q1=q1.setString("gruCod",gru.getGruCod());
			usuarioGrupos  = (List)q1.list();	
		}
		catch(Exception ex)
		{
			logger.error(ex.getMessage());
		}
	}
	//Lista los datos personales de los usuarios dentro de un solo grupo
	public void listaDatosPersonalesUsuariosGrupos(Session conn,D7GruposUsuarios gru)
	{
		try
		{
			Query q1 = conn.createQuery(getQuery("DatosPersonalesUnGrupo"));
			q1 = q1.setString("sist",user.getDatosMenu().idSelected());
			q1=q1.setString("gruCod",gru.getGruCod());
			datosPersonales  = (List)q1.list();	
		}
		catch(Exception ex)
		{
			logger.error(ex.getMessage());
			System.out.println(ex);
		}
		
	}
	//Lista los grupos de usuarios y sus subGrupos. Tambien lista los usuarios asociados a ese conjunto de grupos
	public void listaGruposUsuariosRecursiva (Session conn,D7GruposUsuarios gru)
	{
		listaUnGruposUsuarios(conn,gru.getGruCod());
		listaSubgrupos(conn,gru);
		grupoUsuarios.addAll(subGrupo);
		
//		Listamos las aplicaciones vinculadas a secciones en las que el informtico es responsable
		String cadena = new String();
		
		//Recogemos los cdigos de las secciones
		for(int i=0;i<grupoUsuarios.size();i++)
		{
			cadena = cadena + "'" + ((D7GruposUsuarios)grupoUsuarios.get(i)).getGruCod() + "'" + ",";
		}
		cadena = cadena.substring(0,cadena.length()-1);//Eliminamos la ltima coma
		try
		{
			Query q = conn.createQuery(getQuery("UsuariosGrupos").replaceAll(":grupo","("+cadena+")"));
			q = q.setString("sist",user.getDatosMenu().idSelected());
			usuarioGrupos  = (List)q.list();
			Query q2 = conn.createQuery(getQuery("DatosPersonalesUsuariosGrupos").replaceAll(":grupo","("+cadena+")"));
			q2 = q2.setString("sist",user.getDatosMenu().idSelected());
			datosPersonales  = (List)q2.list();
		}
		catch(Exception ex)
		{logger.error(ex.getMessage());}
		
	}
	
	
	//Lista todos los subgrupos de un grupo
	public void listaSubgrupos(Session conn,D7GruposUsuarios gru)
	{
		PreparedStatement pstmt;
		subGrupo = new Vector();

		try
		{
			String q = getQuery("subGrupos");
			q = q.replaceAll(":sist",user.getDatosMenu().idSelected());
			q = q.replaceAll(":gru", gru.getGruCod());
			pstmt = conn.connection().prepareStatement(q);
			ResultSet rs = pstmt.executeQuery();

			while (rs.next())
			{
	 	    	D7GruposUsuarios grup = new D7GruposUsuarios();
	 	    	//gru_sis_cod, gru_cod, gru_descrip, gru_cod_cod
	 	    	grup.setGruSisCod(rs.getString(1));
	 	    	grup.setGruCod(rs.getString(2));
	 	    	grup.setGruDescrip(rs.getString(3));
	 	    	grup.setGruCodCod(rs.getString(4));
	 	    	subGrupo.add(grup);
	 	    }
	 	    rs.close();
	 	    pstmt.close();
		}
		catch (Exception ex)
		{
			setErrorMessage("Error al listar secciones.");
			System.out.println(ex);
		}
	}
	//Lista todas las secciones, menos las que se encuentran en el vector subSecciones.
	//Una seccion padre no puede pasar a depender de ninguna de las secciones que dependen de ella directa o indirectamente
	public void listaGruposRestriccion(Session conn)
	{
		String cadena = new String();
		//Recogemos los cdigos de las secciones
		for(int i=0;i<subGrupo.size();i++)
		{
			cadena = cadena + "'" + ((D7GruposUsuarios)subGrupo.get(i)).getGruCod() + "'" + ",";
		}
		if(cadena.length()!=0)
		{
			cadena = cadena.substring(0,cadena.length()-1);//Eliminamos la ltima coma
			try
			{
				Query q = conn.createQuery(getQuery("GruposRestriccion").replaceAll(":grupos","("+cadena+")"));
				q = q.setString("sist",user.getDatosMenu().idSelected());
				grupoUsuarios  = (List)q.list();
			}
			catch (Exception ex)
			{
				logger.error(ex.getMessage());user.getDatosMenu().idSelected();
			}
		}
		else
		{
			//Si no tiene subsecciones puede depender de cualquier seccion
			listaGruposUsuarios(conn);
		}
	}
	
	//Mtodo que lista un GruposUsuarios
	public void listaUnGruposUsuarios(Session conn,String codigo)
	{ 
		try 
		{
			
			Query q = conn.createQuery(getQuery("UnGruposUsuarios"));
			q = q.setString("sist",user.getDatosMenu().idSelected());
			q=q.setString("gruCod",codigo);
			grupoUsuarios  = (List)q.list();		
		}
		catch (Exception ex)
		{
			logger.error(ex.getMessage());
		}
	}
	
	//Mtodo que lista todoso los UsuariosGrupos
	/*public void listaUsuariosGrupos(Session conn) {
		 
		try {
			Query q = conn.createQuery(getQuery("AllUsuariosGrupos"));
			q = q.setString("sist",user.getDatosMenu().idSelected());
			usuarioGrupos  = (List)q.list();
			
		} catch (Exception ex) {
			logger.error(ex.getMessage());
		}
	}*/
	
	
	/**DA DE ALTA AL GRUPO USUARIO*/
	public void saveGrupoUsuario(Session conn,D7GruposUsuarios gru)
	{
		int gruCod = 0;
		Transaction tx = null;
		D7UsuariosGrupos ug = null;
				
		gru.setGruSisCod(user.getDatosMenu().idSelected());
		CodigoGrupoUsuario= gru.getGruCod();
		codigoGrupo= gru.getGruCod();
		if(gru.getGruCodCod().equals("-Grupo Raiz-"))
			gru.setGruCodCod(CodigoGrupoUsuario);
		
		grupoUsuario = gru;
			
		try
		{
			//creamos la transaccin para crear todos los usuario introducidos al grear el grupo de usuarios
			tx = conn.beginTransaction();
				conn.save(grupoUsuario);
				for(int i=0; i<codigosUsuarios.length;i++)
				{
					ug = new D7UsuariosGrupos();
					ug.setUgrSisCod(user.getDatosMenu().idSelected());
					ug.setUgrGruCod(gru.getGruCod());
					ug.setUgrUsuCod(codigosUsuarios[i]);
					saveUsuarioGrupo(conn,ug);
				}
			tx.commit();			
		
			grupoUsuario = null;
			setErrorMessage("El grupo de usuarios ha sido creado correctamente");
		}
		catch (Exception ex)
		{
			setErrorMessage("GestorGruposUsuarios: "+ex);
			tx.rollback();
		}
	}
	
	/**ASIGNACION DE USUARIOS A GRUPOS USUARIOS AL CREAR GRUPO DE USUARIOS*/
	public void saveUsuarioGrupo(Session conn, D7UsuariosGrupos ugr) throws Exception
	{
		try
		{
			conn.save(ugr);
			ugr = null;
		}
		catch (Exception exc)
		{
			throw new Exception("Error al crear el usuario " + ugr.getUgrUsuCod());
		}
		
	}
	
	/**ASIGNACION DE USUARIOS SUELTOS A GRUPOS USUARIOS (Desde vincular nuevos miembros a grupo)*/
	public void saveUsuarioGrupoSuelto(Session conn, D7UsuariosGrupos ugr)
	{
		ugr.setUgrSisCod(user.getDatosMenu().idSelected());
		if (ugr.getUgrGruCod() == null)
		{
			ugr.setUgrGruCod(codigoGrupo);
		}
		if (ugr.getUgrUsuCod() == null)
		{
			ugr.setUgrUsuCod(codigoUsuario);
		}
		try
		{
			conn.save(ugr);
			conn.flush();
			conn.connection().commit();
			ugr = null;
		}
		catch (Exception exc)
		{
			setErrorMessage("Error al vincular nuevo usuario: "+exc);
		}
		
	}
	
	/**BAJA DE GRUPOS USUARIOS*/
	public void removeGrupoUsuario(Session conn, D7GruposUsuarios gru)
	{
		List usuariosGrupo;
		Transaction tx = null;
		
		try
		{
			Query q = conn.createQuery(getQuery("UnGruposUsuarios"));
			q = q.setString("sist",user.getDatosMenu().idSelected());
			q=q.setString("gruCod",gru.getGruCod());
			grupoUsuarios  = (List)q.list();
			
			Query q2 = conn.createQuery(getQuery("AllUsuarios"));
			q2 = q2.setString("sist",user.getDatosMenu().idSelected());
			q2=q2.setString("gruCod",gru.getGruCod());
			usuariosGrupo  = (List)q2.list();
	
	
			//Creamos transaccin para poder hacer revert si hubo erro en algn mtodo
			tx = conn.beginTransaction();
				
				for(int i=0; i<usuariosGrupo.size();i++)
				{
					conn.delete((D7UsuariosGrupos) usuariosGrupo.get(i));
				}
			
				//Elimino el grupo de usuario
				grupoUsuario = (D7GruposUsuarios)grupoUsuarios.get(0);//Si hemos recargado la pagina despues de haber borrado salta excepcion nullpointer
				conn.delete(grupoUsuario);
				grupoUsuarios.remove(grupoUsuario);

			tx.commit();
				
			//Elimino el grupousuario para que no se mape aun despues de haberla eliminado
			setErrorMessage("El Grupo de Usuarios ha sido eliminado correctamente");

		}
		catch (NullPointerException npe)
		{
			setErrorMessage("Grupo de Usuario ya eliminado");
		}
		catch (IndexOutOfBoundsException npe)
		{
			setErrorMessage("Grupo de Usuario ya eliminado");
		}
		catch (Exception ex)
		{
			setErrorMessage("No se pudo eliminar el grupo usuario:  " + grupoUsuario.getGruCod()+ " (Dependencias existentes con :Usuarios)");
			tx.rollback();
			//Elimino el grupousuario para que no se mape aun despues de haberla eliminado
		}
	}
	
	/**BAJA DE USUARIOS GRUPOS*/
	public void removeUsuarioGrupo(Session conn, D7UsuariosGrupos ugr)
	{
		try
		{
			Query q = conn.createQuery(getQuery("UnUsuarioGrupo"));
			q = q.setString("sist",user.getDatosMenu().idSelected());
			q=q.setString("ugrCod",ugr.getUgrUsuCod());
			usuarioGrupos  = (List)q.list();
		
		//usuarioGrupos = (conn.createQuery("from usuariogrupo in class dumbo7.utils.D7UsuariosGrupos where usuariogrupo.UgrSisCod = :sist and usuariogrupo.UgrUsuCod = :cod").setString("sist",user.getDatosMenu().idSelected()).setString("cod",ugr.getUgrUsuCod())).list();
		
			//Elimino el grupo de usuario
			usuarioGrupo = (D7UsuariosGrupos)usuarioGrupos.get(0);//Si hemos recargado la pagina despues de haber borrado salta excepcion nullpointer
			conn.delete(usuarioGrupo);
			conn.flush();
			conn.connection().commit();
			
			//Elimino el grupousuario para que no se mape aun despues de haberla eliminado
			usuarioGrupos.remove(usuarioGrupo);			
			
		}
		catch (NullPointerException npe) {
			setErrorMessage("Usuario ya eliminado");
			usuarioGrupos.remove(usuarioGrupo);
		}
		catch (Exception ex)
		{
			setErrorMessage("No se pudo eliminar el usuario.  ");
			usuarioGrupos.remove(usuarioGrupo);
		}
		
		
	}

	/**MODIFICACION GRUPO USUARIOS**/	
	public void updateGrupoUsuario(Session conn, D7GruposUsuarios gru)
	{
		try 
		{
			gru.setGruSisCod(user.getDatosMenu().idSelected());
			conn.update(gru);
			conn.flush();
			conn.connection().commit();
			setErrorMessage("El grupo de coste ha sido modificado correctamente");
		}
		catch (Exception ex)
		{
			setErrorMessage("Error al modificar el grupo de usuarios: "+ex);
		}
	}
}