<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet version="1.0" 
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:xforms="http://www.w3.org/2002/xforms">
	
<xsl:param name="servlet"/>	
<xsl:param name="menu"/>
<xsl:param name="gruCod"/>
<xsl:variable name="parent"/>


<xsl:include href="dumbo7/utils/xsl/utils.xsl"/>
	
<xsl:template match="XMLROOT">
<html lang="es">
	<xsl:call-template name="headComun">
		 <xsl:with-param name="jscript">
			<script LANGUAJE="JavaScript">
				<!--Para que si tenemos un unico campo de texto no haga submit al pulsar enter-->
				function pulsar(e)
				{ 
					tecla = (document.all) ? e.keyCode :e.which; 
					return (tecla!=13); 
				} 
				
				//Funcin para activar la variable de cambios y as notificarlos (si la variable es false, no se mostrar mensaje de cambios ni se har submit)
				function cambiosRealizados()
				{
					document.modificar.checkCambios.value="true";
				}
				function mostrarError(error){
					alert(error);
				}
				function cerrar_cancelar(){
					document.modificar.module.value='dumbo7/administracion/gruposusuarios.formModificar.cancelar';				
					document.modificar.submit();
				}
				
			</script>
			<script LANGUAJE="JavaScript" src="../js/gruposusuarios/CompruebaModificaGrupoUsuarios.js"></script>
		</xsl:with-param>
	 </xsl:call-template>
<body>

	
	<xsl:call-template name="menuComun">
		<xsl:with-param name="NAME" select="concat(DATA/GRUPOS_USUARIOS/USER/@NAME,concat('(',concat(DATA/GRUPOS_USUARIOS/USER/@LOGIN,')')))"/>
		<xsl:with-param name="MENU" select="DATA/MENU"/>
		<xsl:with-param name="SELECT" select="$menu"/>
		<xsl:with-param name="HELP">administracion.xml#1.7.3</xsl:with-param>
	</xsl:call-template>

<xsl:call-template name="pieComun"/>
	</body>
	</html>
</xsl:template>
<xsl:template name="cuerpo">
	<xsl:for-each select="DATA/GRUPOS_USUARIOS">
		<xsl:if test="not(@ERROR='')">
			<script>mostrarError('<xsl:value-of select="@ERROR"/>')</script>
			</xsl:if>
	</xsl:for-each>
<table align="center" border="0" cellpadding="5" cellspacing="5" width="775" summary="Esta tabla contiene un grupousurio">
	<tr>
		<td width="550" colspan="2" class="cab1">&#187;Modificar grupo de usuarios
		<!--For Para poder mostrar la descripcion en la cabecera de la tabla-->
		<xsl:for-each select="DATA/GRUPOS_USUARIOS/GRUPO_USUARIO[@CODIGO=$gruCod]">			
				&quot;<xsl:value-of select="@DESCRIPCION"/>&quot; 			
		</xsl:for-each>
</td></tr>
	<tr>
		<td colspan="2">
			<form action="{$servlet}" METHOD="POST" name="modificar">
				<xsl:for-each select="DATA/GRUPOS_USUARIOS/GRUPO_USUARIO">
					<xsl:if test="@CODIGO = $gruCod">
						<input type="hidden" name="module"/>
						<input type="hidden" name="gruCod" size="20" value="{@CODIGO}" readonly="true"/>
						<input type="hidden" name="checkCambios" size="20" value="false"/>
						<table class="cont" align="center" border="0" cellpadding="3" cellspacing="1" width="90%">
							<tr>
								<td class="cabe" align="left" colspan="5"><b>Datos del grupo</b></td>
							</tr>
							<tr class="administracion">
								<td width="10%">Codigo&#160;(*):</td>
								<td><xsl:value-of select="$gruCod"/></td>
							</tr>
							<tr class="administracion">
								<td width="10%">Descripcion&#160;(*):</td>
								<td><input type="text" name="gruDescrip" size="35" maxlength="30" value="{@DESCRIPCION}" onkeypress="return pulsar(event)" onChange="javascript:cambiosRealizados();"/></td>
							</tr>
							<tr class="administracion">
								<td width="10%">Padre:</td>
								<td>
								<select name="gruCodCod" size="1" onChange="javascript:cambiosRealizados();">
									<!--Si tu no eres tu padre entonces puedes depender de cualquier categora-->
									<option value="{$gruCod}" selected="true">-Grupo Raz-</option>
									<!--Llamamos a la plantilla para indexar las categoras.-->
									<xsl:call-template name="muestraGrupo">
									<xsl:with-param name="nodo" select=".."/>
									<xsl:with-param name="padre_grupo_modificar" select="@PADRE"/>
									<xsl:with-param name="grupo_modificar" select="$gruCod"/>								
									</xsl:call-template>
								</select>
							</td>
							</tr>
							<tr class="administracion"><td colspan="4"><font size="-1" color="red">(*) campos obligatorios.</font></td></tr>							
							<!--Tabla para la presentacin de los usuarios y con opcin de eliminar-->
							<tr class="administracion">
								<td colspan="5" align="center">
									<input type="button" class="boton" value="Aceptar" onclick="javascript:CompruebaModificaGrupoUsuarios()" />&#160;
									<input type="button" class="boton" value="Cancelar" onclick="javascript:cerrar_cancelar()"/>					
								</td>
							</tr>
						</table>
				</xsl:if>
			</xsl:for-each>
		</form>
	</td>
</tr>
</table>
<p>&#160;</p>
</xsl:template>

<!--Plantillas para recorrer los diferentes grupos de usuarios indexandolos-->
<xsl:template name="muestraGrupo">
<xsl:param name="nodo"/>
<xsl:param name="padre_grupo_modificar"/><!--El padre que tiene debe aparecer seleccionado por defecto-->
<xsl:param name="grupo_modificar"/><!--El propio grupo no debe aparecer-->
    <xsl:for-each select="$nodo/GRUPO_USUARIO[@CODIGO=@PADRE]">
        <xsl:sort select="@DESCRIPCION"/>
		<xsl:if test="@CODIGO!=$grupo_modificar and @CODIGO!=$padre_grupo_modificar">
	        <option value="{@CODIGO}"><xsl:value-of select="@DESCRIPCION"/></option>
		</xsl:if>
		<xsl:if test="@CODIGO!=$grupo_modificar and @CODIGO=$padre_grupo_modificar">
	        <option value="{@CODIGO}" selected="true"><xsl:value-of select="@DESCRIPCION"/></option>
		</xsl:if>
        <xsl:call-template name="sacaSubGrupo">
			<xsl:with-param name="padre_grupo_modificar" select="$padre_grupo_modificar"/>
			<xsl:with-param name="grupo_modificar" select="$grupo_modificar"/>		
            <xsl:with-param name="grupo" select="$nodo"/>
            <xsl:with-param name="codigo_padre" select="@CODIGO"/>
            <xsl:with-param name="espacio" select="'&#160;&#160;'"/>
        </xsl:call-template>
    </xsl:for-each>
</xsl:template>

<xsl:template name="sacaSubGrupo">
<xsl:param name="grupo"/>
<xsl:param name="codigo_padre"/>
<xsl:param name="padre_grupo_modificar"/><!--El grupo padre ya sale seleccionada por defecto-->
<xsl:param name="grupo_modificar"/><!--el codigo del propio grupo no aparece-->
<xsl:param name="espacio"/>
    <xsl:for-each select="$grupo/GRUPO_USUARIO[@PADRE=$codigo_padre and @PADRE!=@CODIGO]">
        <xsl:sort select="@DESCRIPCION"/>
		<xsl:if test="@CODIGO!=$grupo_modificar and @CODIGO!=$padre_grupo_modificar">
	        <option value="{@CODIGO}"><xsl:value-of select="$espacio"/><xsl:value-of select="@DESCRIPCION"/></option>
		</xsl:if>
		<xsl:if test="@CODIGO!=$grupo_modificar and @CODIGO=$padre_grupo_modificar">
	        <option value="{@CODIGO}" selected="true"><xsl:value-of select="$espacio"/><xsl:value-of select="@DESCRIPCION"/></option>
		</xsl:if>
        <xsl:call-template name="sacaSubGrupo">
			<xsl:with-param name="padre_grupo_modificar" select="$padre_grupo_modificar"/>
			<xsl:with-param name="grupo_modificar" select="$grupo_modificar"/>		
            <xsl:with-param name="grupo" select="$grupo"/>
            <xsl:with-param name="codigo_padre" select="@CODIGO"/>
            <xsl:with-param name="espacio" select="concat($espacio,'&#160;&#160;')"/>
        </xsl:call-template>
    </xsl:for-each>
</xsl:template>

</xsl:stylesheet>
	