<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet version="1.0" 
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:xforms="http://www.w3.org/2002/xforms">

<xsl:param name="servlet"/>	
<xsl:param name="menu"/>

<xsl:include href="dumbo7/utils/xsl/utils.xsl"/>
	
<xsl:template match="XMLROOT">
<html lang="es">
	<xsl:call-template name="headComun">
		<xsl:with-param name="arbol" select="'GruposUsuarios'"/>
	    <xsl:with-param name="jscript">
			<script LANGUAJE="JavaScript">
				function mostrarError(error){
					alert(error);
				}
			</script>
			<script LANGUAJE="JavaScript" src="../js/gruposusuarios/PreguntaBorrar.js"></script>
			<script LANGUAJE="JavaScript" src="../js/OnMouse.js"></script>
			</xsl:with-param>
	 </xsl:call-template>
<body>

	
	<xsl:call-template name="menuComun">
		<xsl:with-param name="NAME" select="concat(DATA/GRUPOS_USUARIOS/USER/@NAME,concat('(',concat(DATA/GRUPOS_USUARIOS/USER/@LOGIN,')')))"/>
		<xsl:with-param name="MENU" select="DATA/MENU"/>
		<xsl:with-param name="SELECT" select="$menu"/>
		<xsl:with-param name="HELP">administracion.xml#1.7</xsl:with-param>
	</xsl:call-template>

<xsl:call-template name="pieComun"/>
	</body>
	</html>
</xsl:template>
<xsl:template name="cuerpo">
	<xsl:for-each select="DATA/GRUPOS_USUARIOS">
		<xsl:if test="not(@ERROR='')">
			<script>mostrarError('<xsl:value-of select="@ERROR"/>')</script>
			</xsl:if>
	</xsl:for-each>

<table align="center" border="0" cellpadding="5" cellspacing="5" width="775" height="16" summary="Esta tabla contiene una lista de gruposusuarios">
	<tr>
		<td width="85%" class="cab1">&#187;Listado de grupos de usuarios</td>
		<td align="center" width="15%"><a href="{$servlet}?module=dumbo7/administracion/gruposusuarios.index.nueva">Insertar Grupo</a></td>
	</tr>
	<tr><td colspan="2">
		<table class="cont" border="0" cellpadding="3" cellspacing="1" width="100%">
		<tr>		
			<!--Cabecera de la tabla (cuidado con los anchos y con los anchos de los campos dentro del bucle) -->
			<SCRIPT>
				<!--Para guardar la descripcin y pasarlo a los javascript de tal forma que se respeten las tildes en los string-->
				var arrayDescripcion = new Array();
			</SCRIPT>
			<td class="cabe" width="400"><b><font face="Verdana" size="2">Cdigo/Descripcin</font></b></td>
			<td class="cabe" colspan="3"></td>
			
			<!--Se diferencia entre dos llamadas para as poder ponerle una clase distinta a un elemento
					que tenga hijos (este tendr clase switchcontent )
					y un elemento que no tenga hijos (Este elemento no tendr calse sera '')

					Esto es necesario para un buen funcionamiento del rbol.
				-->		
			<xsl:for-each select="DATA/GRUPOS_USUARIOS/GRUPO_USUARIO[(@CODIGO=@PADRE)]">
				<xsl:sort select="@DESCRIPCION"/>
				<xsl:variable name="codigo2"><xsl:value-of select="@CODIGO"/></xsl:variable>
				<xsl:choose>
					<xsl:when test="(count(../GRUPO_USUARIO[@PADRE = $codigo2 and @CODIGO != $codigo2])>0)">	
						<xsl:call-template name="muestraGrupoUsuario">
							<xsl:with-param name="tab" select="concat('arb.',position())"/>
							<xsl:with-param name="tabimg" select="concat('img.arb.',position())"/>
							<xsl:with-param name="code" select="@CODIGO"/>
							<xsl:with-param name="clase" select="'switchcontent'"/>
							<xsl:with-param name="parent" select="@PADRE"/>
						</xsl:call-template>					
					</xsl:when>
					<xsl:otherwise>
						<xsl:call-template name="muestraGrupoUsuario">
							<xsl:with-param name="tab" select="''"/>
							<xsl:with-param name="tabimg" select="''"/>
							<xsl:with-param name="code" select="@CODIGO"/>
							<xsl:with-param name="clase" select="'switchcontent'"/>
							<xsl:with-param name="parent" select="@PADRE"/>
						</xsl:call-template>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:for-each>
			
			<xsl:if test="count(DATA/GRUPOS_USUARIOS/GRUPO_USUARIO)=0">
				<tr class="administracion">
					<td colspan="4" align="center"> No hay Usuarios.</td>
				</tr>
			</xsl:if>
		</tr>
	</table></td></tr>
</table>


</xsl:template>

<xsl:template name="muestraGrupoUsuario">
<xsl:param name="code"/>
<xsl:param name="parent"/>
<xsl:param name="tab"/>
<xsl:param name="tabimg"/>
<xsl:param name="clase"/>

		<SCRIPT>
			<!--Se guarda la descripcin para pasarla al javascript de borrar de tal forma que se respeten las tildes en los string-->
			arrayDescripcion['<xsl:value-of select="@CODIGO"/>'] = <xsl:call-template name="entrecomillaDescripcion"><xsl:with-param name="descripcion" select="@DESCRIPCION"/></xsl:call-template>;
		</SCRIPT>

		<tr id="{$tab}" bgcolor= "#F2F0E3" onmouseover="javascript:onMouse(this,'true');" onmouseout="javascript:onMouse(this,'false');">	
		<xsl:variable name="codigo"><xsl:value-of select="@CODIGO"/></xsl:variable>
		<xsl:if test="(count(../GRUPO_USUARIO[@PADRE = $codigo and @CODIGO != $codigo])>0)"><xsl:attribute name="class"><xsl:value-of select="$clase"/></xsl:attribute></xsl:if>
			<!-- JJSM modificamos el calculo del padding-left a longitud del tab - 5 (antes era 4)-->	
			<xsl:variable name="estilo">
				<!--<xsl:value-of select="concat(concat('padding-left:',(string-length($tab)-5) div 4),'cm')"/>-->
				<xsl:value-of select="concat(concat('padding-left:',(string-length(translate($tab,'0123456789',''))-3)* 0.25),'cm')"/>
			</xsl:variable>
			<td style="{$estilo}" width="400">
				<!--Compruebo si tiene padre para mostrar la jerarquia-->
				<xsl:if test="(count(../GRUPO_USUARIO[@PADRE = $codigo and @CODIGO != $codigo])>0)">		
					<img id="{$tabimg}" class="showstate" border="0" src="../dumbo7/utils/table/minus.gif" onClick="expandcontent(this,'{$tab}');"/>
				</xsl:if>
				<!--Si no tiene hijos, se aade un icono empty-->
				<!--<xsl:variable name="codigo"><xsl:value-of select="@CODIGO"/></xsl:variable>-->
				<xsl:if test="(count(../GRUPO_USUARIO[@PADRE = $codigo and @CODIGO != $codigo])=0)">		
					<img id="{$tabimg}" class="showstate" border="0" src="../dumbo7/utils/table/empty.gif" onClick="expandcontent(this,'{$tab}');"/>
				</xsl:if>
				
				<xsl:value-of select="@CODIGO"/>
				&#160;
				<!--muestra un substring de la descripcin-->								
				<a title="Consulta Usuarios" href="{$servlet}?module=dumbo7/administracion/gruposusuarios.index.listarUsu&amp;gruCod={@CODIGO}">
					<xsl:value-of select="@DESCRIPCION"/>
				</a>
				</td>

			<td width="20">
				<CENTER>
					<a href="{$servlet}?module=dumbo7/administracion/gruposusuarios.index.AsignarUsuarios&amp;gruCod={@CODIGO}"><img border="0" src="../graficos/iconos/GrupoUsuarios+-.gif" alt="Asignar/Eliminar Usuarios"/></a>
				</CENTER>
			</td>
			<td width="20" align="center"><a href="{$servlet}?module=dumbo7/administracion/gruposusuarios.index.modificar&amp;gruCod={@CODIGO}"><img  border="0" src="../graficos/iconos/modificar.gif" alt="Modificar Grupo Usuarios"/></a></td>

			<!--Solo se pueden eliminar los que no tienen hijos -->
			<!--Se encarga de contar los nodos que no tienes hijos y, si es as, aadirles la etiqueta de eliminar-->
			<xsl:if test="count(../GRUPO_USUARIO[(@PADRE=$code) and (@CODIGO!=$code)])=0">
				<!--Solo hay que pasarle al javascript ?module=dumbo7/administracion/secciones.index.eliminar&amp;secCod={@CODIGO}' para que encuentre la URL correcta para borrar-->
				 <td width="20" ><CENTER><a href="javascript:validar('?module=dumbo7/administracion/gruposusuarios.index.eliminar&amp;gruCod={@CODIGO}',arrayDescripcion['{@CODIGO}']);"><img border="0" src="../graficos/iconos/eliminar.gif" alt="Eliminar Grupo Usuarios"/></a></CENTER></td>
			</xsl:if>
			
			<xsl:if test="count(../GRUPO_USUARIO[(@PADRE=$code) and (@CODIGO!=$code)])!=0">
				<!--Solo hay que pasarle al javascript ?module=dumbo7/administracion/secciones.index.eliminar&amp;secCod={@CODIGO}' para que encuentre la URL correcta para borrar-->
				 <td width="20"><CENTER><img border="0" src="../graficos/iconos/eliminar_off.gif" alt="Eliminar GrupoUsuarios"/></CENTER></td>
			</xsl:if>
		</tr>
		
		<xsl:for-each select="../GRUPO_USUARIO[(@PADRE=$code) and not(@PADRE=@CODIGO)]">
			<xsl:sort select="@DESCRIPCION"/>
			<xsl:call-template name="muestraGrupoUsuario">
				<xsl:with-param name="code" select="@CODIGO"/>
				<xsl:with-param name="parent" select="@PADRE"/>
				<xsl:with-param name="clase" select="'switchcontent'"/>
				<xsl:with-param name="tab" select="concat($tab,concat('.',position()))"/>
				<xsl:with-param name="tabimg" select="concat($tabimg,concat('.',position()))"/>
			</xsl:call-template>					
		</xsl:for-each>
</xsl:template>

</xsl:stylesheet>




	