package dumbo7.administracion.informaticos;

import dumbo7.utils.*;
import dumbo7.utils.ldap.LDAPUser;
import dumbo7.utils.ldap.LDAPUtil;
import dumbo7.administracion.*;
import org.hibernate.*;
import org.hibernate.type.Type;
import atica.frameweb.query.*;

import java.math.BigDecimal;
import java.sql.*;

import java.util.*;

/**
 * @author prc
 *
 * Gestor de Administracin de Categorias
 * 
 */


public class GestorInformaticos extends GestorAdministracion {
	
	public GestorInformaticos() {}
		
	protected List informaticos = null;
	protected List secciones = null;
	protected List grupoCostes = null;
	protected List perfiles = null;
	protected List aplicaciones = null;
	protected List informaticoPerfiles = null;
	protected List informaticoAplicaciones = null;
	protected List datosPersonales = null;
	protected List datosPersonalesSel = null;
	protected boolean error=false;

	private D7Informaticos informatico;
	private boolean flagFiltrado;
	private String seccionCode;
	
	protected String [] perfCheck, gcCheck,seccionCheck, datos, DNI, Sel;
	protected String actualId = null;
	protected String nuevoId = null;
	protected String pendientesFlag = null;//Si vale 1 se traspasan solo pendientes, si vale 0 se traspasan todas (menos en el caso de eliminar informatico que se traspasan todas)
	
//	Listado de informaticos	
	public void listaInformaticosCompleto(Session conn)
	{
		try
		{
			Query q = conn.createQuery(getQuery("InformaticosCompletos"));
			q = q.setString("sist",user.getDatosMenu().idSelected());
			informaticos  = (List)q.list();
		}
		catch (Exception ex)
		{
			logger.error(ex.getMessage());
		}
	}
	
	
	//Devuelve todos los datos personales de todos los informticos
	public void listaDatosPersonales(Session conn)
	{
		try
		{
			Query q = conn.createQuery(getQuery("AllDatosPersonales"));
			q = q.setString("sist",user.getDatosMenu().idSelected());
			datosPersonales  = (List)q.list();
		}
		catch (Exception ex)
		{
			logger.error(ex.getMessage());
		}
	}
	
	//Bsqueda a partir de los datos introducidos por setDatos
	public void listaDatosPersonalesSeleccion(Session conn)
	{
		PreparedStatement pstmt = null;
		ResultSet rs = null;
		try
		{
			String sist = user.getDatosMenu().idSelected();
			datosPersonales = new ArrayList();
			
			if (datos[0].indexOf("@")>0)
			{
				datos[0] = datos[0].substring(0,datos[0].length()-1);
			    Vector v = LDAPUtil.findUsersByMail(datos[0]+"*");
			    Enumeration en = v.elements();
			    while (en.hasMoreElements())
			    {
			          // Hasta aqu vamos bien, saca los tios del LDAP con correo como el del patrn.
			         LDAPUser ldu = (LDAPUser)en.nextElement();
			          String dat = ldu.getDni();
			         /* Query q = conn.createQuery(getQuery("DatosPersonalesDNI"));
			          q = q.setString("sist",user.getDatosMenu().idSelected());
			          q = q.setString("dat",ldu.getDni());
			          if(!q.list().isEmpty()){
			          	datosPersonales.add(q.list().get(0));
			          }*/
			          String myQuery = getQuery("DatosPersonalesDNIConRelacion");
						pstmt = conn.connection().prepareStatement(myQuery);
						pstmt.setString(1,dat);
						pstmt.setString(2,sist);
						rs = pstmt.executeQuery();
						//if (rs.getInt(1)!=0) datosPersonales.add(rs.getString(0));
						while (rs.next()) {
							D7DatosPersonales dp = new D7DatosPersonales();
							dp.setDatIdentificador(rs.getString(1));
							dp.setDatNombre(rs.getString(2));
							dp.setDatApellidos(rs.getString(3));
							dp.setDatEmail(rs.getString(4));
							
							datosPersonales.add(dp);
						}
			    }  
			}
			else
			{
				/*Query q = conn.createQuery(getQuery("DatosPersonales"));
				q = q.setString("dat","%"+datos[0]+"%");
				q = q.setString("sist",user.getDatosMenu().idSelected());
				datosPersonales  = (List)q.list();*/
				String patron = datos[0].toString();
				String nom = patron.substring(0, patron.indexOf("/"));
				String ape = patron.substring(patron.indexOf("/")+1, patron.length());
				
				
				String myQuery = getQuery("DatosPersonalesConRelacion");
				pstmt = conn.connection().prepareStatement(myQuery);
				pstmt.setString(1,"%"+ape.replace(' ','%')+"%");
				pstmt.setString(2,"%"+nom.replace(' ','%')+"%");
				pstmt.setString(3,sist);
				rs = pstmt.executeQuery();

				while (rs.next()) {
					D7DatosPersonales dp = new D7DatosPersonales();
					dp.setDatIdentificador(rs.getString(1));
					dp.setDatNombre(rs.getString(2));
					dp.setDatApellidos(rs.getString(3));
					dp.setDatEmail(rs.getString(4));
					
					datosPersonales.add(dp);
				}
			}
		}
		catch (Exception ex)
		{
			System.out.println(""+ex);
			logger.error(ex.getMessage());
		} finally {
			try {
				if (rs!=null) rs.close();
				if (pstmt!=null) pstmt.close();
			} catch (Exception exx) {}
		}
	}
	
	public void listaDatosPersonalesDNI(Session conn, String Codigo)
	{
		try
		{
			Query q = conn.createQuery(getQuery("DatosPersonalesDNI"));
			q = q.setString("dat",Codigo);
			q = q.setString("sist",user.getDatosMenu().idSelected());
			datosPersonales  = (List)q.list();
		}
		catch (Exception ex)
		{
			logger.error(ex.getMessage());
		}
	}
	
	public void listaDatosPersonalesDNITraspaso(Session conn)
	{
		try
		{
			Query q = conn.createQuery(getQuery("DatosPersonalesDNITraspaso"));
			if(Sel[0].equals("1"))
			{
				q = q.setString("dat",DNI[0]);
			}
			if(Sel[0].equals("2"))
			{
				q = q.setString("dat",D7Conversor.convierteMail(conn,DNI[0]));
			}
			q = q.setString("sist",user.getDatosMenu().idSelected());
			datosPersonales  = (List)q.list();
			
		}
		catch (Exception ex)
		{
			logger.error(ex.getMessage());
		}
	}
	
	public void AlllistaDatosPersonalesApellidos(Session conn, String Codigo)
	{
		try
		{
			Query q = conn.createQuery(getQuery("AllDatosPersonalesTraspaso"));
			q = q.setString("dat","%"+Codigo+"%");
			datosPersonales  = (List)q.list();
		}
		catch (Exception ex)
		{
			logger.error(ex.getMessage());
		}
	}
	public void AlllistaDatosPersonalesDNI(Session conn, String Codigo)
	{
		try
		{
			Query q = conn.createQuery(getQuery("AllDatosPersonalesDNI"));
			q = q.setString("dat",Codigo);
			datosPersonales  = (List)q.list();
		}
		catch (Exception ex)
		{
			logger.error(ex.getMessage());
		}
	}
	
	//Listado de informaticos	
	public void listaInformaticos(Session conn)
	{
		try
		{
			if(!flagFiltrado)
			{
				Query q = conn.createQuery(getQuery("AllInformaticos"));
				q = q.setString("sist",user.getDatosMenu().idSelected());
				informaticos  = (List)q.list();
			}
			else
			{
				Query q = conn.createQuery(getQuery("InformaticosSeccion"));
				q = q.setString("sist",user.getDatosMenu().idSelected());
				q = q.setString("sec",seccionCode);
				informaticos  = (List)q.list();
			}
		}
		catch (Exception ex)
		{
			logger.error(ex.getMessage());
		}
	}
	//Listado de un informtico	
	public void listaInformaticoDatos(Session conn, D7Informaticos inf)
	{
		try
		{
			Query q = conn.createQuery(getQuery("DatosPersonalesUnInformatico"));
			q = q.setString("dat",inf.getInfCod());
			datosPersonales  = (List)q.list();
		}
		catch (Exception ex)
		{
			logger.error(ex.getMessage());
		}
	}
	
	//Listado de secciones. Util para ver de que seccion dependen los informaticos
	public void listaSeccionesPrimerNivel(Session conn)
	{
		String codigo;
		codigo = new String();
		try
		{
			Query q = conn.createQuery(getQuery("SeccionesPrimerNivel"));
			q = q.setString("sist",user.getDatosMenu().idSelected());
			secciones  = (List)q.list();
			
		}
		catch (Exception ex)
		{
			logger.error(ex.getMessage());
		}
	}
	
	public void listaSeccionesHataSegundoNivel(Session conn)
	{
		PreparedStatement pstmt= null;
		ResultSet rs = null;
		secciones = new ArrayList();
		try
		{
			String q = getQuery("SeccionesPrimerySegundoNivel");
			q = q.replaceAll(":sist",user.getDatosMenu().idSelected());
			
			pstmt = conn.connection().prepareStatement(q);
			rs = pstmt.executeQuery();

			while (rs.next()) {
				D7Secciones se = new D7Secciones();
				se.setSecSisCod(rs.getString(1));
				se.setSecCod(rs.getString(2));
				se.setSecDescrip(rs.getString(3));
				se.setSecIdRespon(rs.getString(4));
				se.setSecSecCod(rs.getString(5));
				se.setSecEstado(rs.getString(6));
				
				secciones.add(se);
			}
			
	} catch (Exception ex) {
		setErrorMessage("GestorInformaticos[listaSeccionesHataSegundoNivel]: "+ex);
	} finally {
		try {
			if (rs!=null) rs.close();
			if (pstmt!=null) pstmt.close();
		} catch (Exception exx) {}
	}
}
	
	//Listado de los grupos de costes
	public void listaGrupoCostes(Session conn)
	{
		 
		try
		{
			Query q = conn.createQuery(getQuery("GruposCostes"));
			q = q.setString("sist",user.getDatosMenu().idSelected());
			grupoCostes  = (List)q.list();
		}
		catch (Exception ex)
		{
			logger.error(ex.getMessage());
		}
	}
	
	//Listado de los pefiles. Si usa a la hora de crear un informatico (se le deben asignar unos perfiles al ser creado)
	public void listaPerfiles(Session conn)
	{
		 
		try
		{
			Query q = conn.createQuery(getQuery("Perfiles"));
			q = q.setString("sist",user.getDatosMenu().idSelected());
			perfiles  = (List)q.list();
		}
		catch (Exception ex)
		{
			logger.error(ex.getMessage());
		}
	}
	
	//Listado de todas las D7Aplicaciones
	public void listaAplicaciones(Session conn)
	{
		 
		try
		{
			Query q = conn.createQuery(getQuery("Aplicaciones"));
			q = q.setString("sist",user.getDatosMenu().idSelected());
			aplicaciones  = (List)q.list();
		}
		catch (Exception ex)
		{
			logger.error(ex.getMessage());
		}
	}
	
	//Listado de los perfiles asociados a un informatico
	public void listaInformaticoPerfiles(Session conn)
	{
		try
		{
			Query q = conn.createQuery(getQuery("InformaticoPerfiles"));
			q = q.setString("sist",user.getDatosMenu().idSelected());
			q = q.setString("inf",informatico.getInfCod());
			informaticoPerfiles  = (List)q.list();
		}
		catch (Exception ex)
		{
			logger.error(ex.getMessage());
		}
	}
	
	//Listado de las D7AplicacionesInformatico asociadas a un informatico
	public void listaInformaticoAplicaciones(Session conn, D7Informaticos inf)
	{
		try
		{
			Query q = conn.createQuery(getQuery("InformaticoAplicaciones"));
			q = q.setString("sist",user.getDatosMenu().idSelected());
			q = q.setString("inf",inf.getInfCod());
			informaticoAplicaciones  = (List)q.list();
		}
		catch (Exception ex)
		{
			logger.error(ex.getMessage());
		}
	}
//	Listado de las D7Aplicaciones asociadas a un informatico
	public void listaAplicacionesInformatico(Session conn, D7Informaticos inf)
	{
		try
		{
			Query q = conn.createQuery(getQuery("AplicacionesInformatico"));
			q = q.setString("sist",user.getDatosMenu().idSelected());
			q = q.setString("inf",inf.getInfCod());
			aplicaciones  = (List)q.list();
		}
		catch (Exception ex)
		{
			logger.error(ex.getMessage());
		}
	}
		
	//Metodos get() para el mapeo
	public List getInformaticos() { return informaticos; }
	public List getSecciones() { return secciones; }
	public List getGrupocostes() { return grupoCostes; }
	public List getPerfiles() { return perfiles; }
	public List getAplicaciones() { return aplicaciones; }
	public List getPerfilesinformatico() { return informaticoPerfiles; }
	public List getAplicacionesinformatico() { return informaticoAplicaciones; }
	public List getDatosPersonales() { return datosPersonales; }
	
	//Metodo set() para obtener PendientesFlag. Flag indicador de si se desean transpasar solo las tareas pendientes
	//(Nota: menos en el caso de traspaso y eliminacion que se traspasaran todas las tareas)
	public void setPendientesFlag(String pendientesFlag)
	{
		this.pendientesFlag = pendientesFlag;
	}
	//Metodo set() para obtener un informatico
	public void setInformatico(D7Informaticos inf)
	{
		inf.setInfSisCod(user.getDatosMenu().idSelected());
		informatico = inf;
	}
	
	//	Metodo set() para obtener el id de un informatico que se va a traspasar
	public void setInfActualTraspaso(String cod)
	{
			actualId=cod;
	}
//	Metodo set() para obtener el id de un informatico al que se va a traspasar
	public void setInfNuevoTraspaso(String cod)
	{		
			nuevoId=cod;
	}

	//Traspasa las Tareas de un informatico a otro
	public void traspasarTareas(Connection conn)
	{
		PreparedStatement pstmt = null;
		String query1;
		
		if(pendientesFlag.equals("1")) query1 = "begin DUMBO.SIS.TRASPASO_TAREAS_PENDIENTES(?,?,?); end;";
		else query1 = "begin DUMBO.SIS.TRASPASO_TAREAS(?,?,?); end;";
		
		try
		{
			CallableStatement stmt1 = conn.prepareCall(query1);
					
			//Pasamos el sistema, dni_actual, dni_nuevo
			stmt1.setString(1, user.getDatosMenu().idSelected());
			stmt1.setString(2, actualId);
			stmt1.setString(3, nuevoId);
					
			//Ejecutamos la sentencia
			stmt1.execute();
			stmt1.close();
			setErrorMessage("Se han traspasado las tareas correctamente");
		}
		catch(SQLException sqle)
		{
			setErrorMessage("Error al traspasar tareas");
		}
	}
	
	
	public void crearInformatico(Session conn)
	{
		//obtengo el informatico actual
		try
		{
				
			Query q2 = conn.createQuery(getQuery("UnInformatico"));
			q2 = q2.setString("sist",user.getDatosMenu().idSelected());
			q2 = q2.setString("cod",actualId);
			informaticos= (List)q2.list();
			D7Informaticos informaticoActual=(D7Informaticos)informaticos.get(0);
			
			//Creo un informatico nuevo
			D7Informaticos informaticoNuevo=new D7Informaticos();
			informaticoNuevo.setInfCod(nuevoId);
			informaticoNuevo.setInfEstado(informaticoActual.getInfEstado());
			informaticoNuevo.setInfGcoCod(informaticoActual.getInfGcoCod());
			informaticoNuevo.setInfSisCod(informaticoActual.getInfSisCod());
			informaticoNuevo.setInfSecCod(informaticoActual.getInfSecCod());
			
			conn.save(informaticoNuevo);
			conn.flush();
			conn.connection().commit();
		}
		catch(Exception e)
		{
			setErrorMessage("Error al crear " + user.traduce("dumbo7/administracion/informaticos","informtico",user.getDatosMenu().idSelected()));
		}	
		
	}
	// cambia el identificador de un informatico en todo el esquema, cuando el nuevo id no pertenece a un informatico
	public void CambioDni(Connection conn)
	{
		String query1;
		
		if(pendientesFlag.equals("1")) query1 = "begin DUMBO.SIS.CAMBIO_DNI_PENDIENTES(?,?,?); end;";
		else query1 = "begin DUMBO.SIS.CAMBIO_DNI(?,?,?); end;";
		
		try
		{
			CallableStatement stmt1 = conn.prepareCall(query1);
					
			//Pasamos el sistema, dni_actual, dni_nuevo
			stmt1.setString(1, user.getDatosMenu().idSelected());
			stmt1.setString(2, actualId);
			stmt1.setString(3, nuevoId);
					
			//Ejecutamos la sentencia
			stmt1.execute();
			stmt1.close();
			setErrorMessage("Se ha realizado el traspaso de identificador correctamente");
		}
		catch(SQLException sqle)
		{
			setErrorMessage("Error al traspasar tareas");
		}		
	}
	
	//cambia el identificador de un informatico en todo el esquema, cuando el nuevo id no pertenece a un informatico
	//borra el informatico original
	
	public void cambioDniBorra(Connection conn)
	{
		PreparedStatement pstmt = null;
		
		String query1 = "begin DUMBO.SIS.CAMBIO_DNI_BORRA(?,?,?); end;";
		try
		{
			CallableStatement stmt1 = conn.prepareCall(query1);
					
			//Pasamos el sistema, dni_actual, dni_nuevo
			stmt1.setString(1, user.getDatosMenu().idSelected());
			stmt1.setString(2, actualId);
			stmt1.setString(3, nuevoId);
					
			//Ejecutamos la sentencia
			stmt1.execute();
			stmt1.close();
			setErrorMessage("Se ha realizado el traspaso de identificador en todo el sistema y eliminado al " + user.traduce("dumbo7/administracion/informaticos","informtico",user.getDatosMenu().idSelected()) +" correctamente");
		}
		catch(SQLException sqle)
		{
			setErrorMessage("Error al traspasar tareas");
			System.out.println(sqle);
		}

	}
	
	
	//Metodo set() para obtener una seccin seleccionada
	public void setSeccion(String [] seccionCheck)
	{
	    this.seccionCheck = seccionCheck;
	}
	//Mtodos set para el filtrado en index
	public void setFlagFiltrado(String flagFiltrado)
	{
		if(flagFiltrado!=null && flagFiltrado.equals("0")) this.flagFiltrado = false;
		else if(flagFiltrado!=null && flagFiltrado.equals("1")) this.flagFiltrado = true;
		else this.flagFiltrado = false;
	}
	//Seccin por la que se filtrar en el listado principal si flag filtrado es true.
	public void setSeccionCode(String seccionCode)
	{
		this.seccionCode = seccionCode;
	}
	
	//Metodo set() para la creacion de los perfiles de informatico
	public void setPerfilesCheck(String [] perfCheck)
	{
		this.perfCheck = perfCheck;
	}
	
	//Metodo para obtener un grupo de costes seleccionado y posteriormente asignarlo a un informatico
	public void setGrupoCostes(String [] gcCheck)
	{
		this.gcCheck = gcCheck;
	}
	//Mtodo para fijar los apellidos para realizar la bsqueda del informtico
	public void setDatos(String [] datos)
	{
		this.datos = datos;
	}
	
	//Actualiza la seccin
	public void UpdateSeccion(Session conn, D7Informaticos inf)
	{
		try 
		{
			Query q = conn.createQuery(getQuery("UnInformatico"));
			q = q.setString("sist",user.getDatosMenu().idSelected());
			q = q.setString("cod",inf.getInfCod());
			informaticos  = (List)q.list();
			
			informatico = (D7Informaticos) informaticos.get(0);
			informatico.setInfSecCod(seccionCheck[0]);
			conn.update(informatico);
			conn.flush();
			conn.connection().commit();
			//informaticos.remove(informatico);

		}
		catch (NullPointerException npe)
		{
			setErrorMessage("Ha actualizado asignando una seccin no vigente");
			informaticos.remove(informatico);
		}
		catch (Exception ex)
		{
			setErrorMessage("GestorInformaticos: "+ex);
		}
	}
	
	
	//Reasignar los perfiles al informatico seleccionado
	public void updatePerfiles(Session conn, D7Informaticos inf)
	{
			informatico = inf;
			//Primero borro todos los perfiles asociados a ese informatico
			if (perfCheck!=null)
			{
				//informaticoPerfiles = (conn.createQuery("from informaticoperfiles in class dumbo7.utils.D7InformaticosPerfiles where informaticoperfiles.IpeSisCod = :sist and informaticoperfiles.IpeInfCod = :inf").setString("sist","D7")).setString("inf",inf.getInfCod()).list();
				try
				{
					Query q = conn.createQuery(getQuery("PerfilesUnInformatico"));
					q = q.setString("sist",user.getDatosMenu().idSelected());
					q = q.setString("inf",inf.getInfCod());
					informaticoPerfiles  = (List)q.list();
				}
				catch(Exception ex){setErrorMessage("Error al actualizar Perfiles");}
				
				
				for (int i=0; i<informaticoPerfiles.size();i++)
				{
					conn.delete( (D7InformaticosPerfiles)informaticoPerfiles.get(i));
				}
				//Creacin de perfiles
				createPerfiles(conn);
				setErrorMessage("Perfiles actualizados correctamente.");
				
			}
			else setErrorMessage("Error en perfil. Introducir como mnimo uno.");
	
	}
	public void savePerfiles(Session conn)
	{
		if (perfCheck!=null)
		{
			//Creacin de perfiles
			createPerfiles(conn);
		}
		else
		{
			setErrorMessage("Error en perfil. Introducir como mnimo uno.");
		}
	}
	
	//Metodo comn para updatePerfiles y savePerfiles. Crea los perfiles (si como mnimo se introdujo uno)
	public void createPerfiles(Session conn)
	{
		D7InformaticosPerfiles [] ip= new D7InformaticosPerfiles[perfCheck.length];
		
		for(int i=0; i < perfCheck.length ; i++)
		{
			ip[i] = new D7InformaticosPerfiles();
			ip[i].setIpeSisCod(user.getDatosMenu().idSelected());
			ip[i].setIpeInfCod(informatico.getInfCod());
			ip[i].setIpePerCod(perfCheck[i]);
			try
			{
			conn.save(ip[i]);
			conn.flush();
			conn.connection().commit();
			}
			catch(Exception e)
			{
				setErrorMessage("Error al crear " + user.traduce("dumbo7/administracion/informaticos","informtico",user.getDatosMenu().idSelected()) +". El cdigo " + informatico.getInfCod() + " ya est en uso o no es vlido.");
			}
		}
	}
	
	//Tras setGrupoCostes(), actualiza el grupo de costes del informatico
	public void UpdateGrupoCostes(Session conn, D7Informaticos inf)
	{
		try 
		{
			Query q = conn.createQuery(getQuery("UnInformatico"));
			q = q.setString("sist",user.getDatosMenu().idSelected());
			q = q.setString("cod",inf.getInfCod());
			informaticos  = (List)q.list();
			
			
			informatico = (D7Informaticos) informaticos.get(0);
			informatico.setInfGcoCod(gcCheck[0]);
			conn.update(informatico);
			conn.flush();
			conn.connection().commit();
			informaticos.remove(informatico);

		}
		catch (NullPointerException npe)
		{
			setErrorMessage("Ha actualizado asignando un grupo de costes no vigente");
			informaticos.remove(informatico);
		}
		catch (Exception ex)
		{
			setErrorMessage("GestorInformaticos: "+ex);
		}
	}
		
	//Guarda un informatico en BD
	public void saveInformatico(Session conn)
	{
		try
		{
			if(perfCheck!=null) //Si no hubo error al crear los perfiles, se guarda el informatico
			{
				Query q = conn.createQuery(getQuery("DatosPersonalesDNI"));
				q = q.setString("dat",informatico.getInfCod());
				q = q.setString("sist",user.getDatosMenu().idSelected());
				datosPersonales  = (List)q.list();
				//Si el DNI no existe en la tabla datos personales, esa persona no existe y no puede ser informtico
				if(datosPersonales.size()!=0)
				{
					conn.save(informatico);
					conn.flush();
					conn.connection().commit();
					setErrorMessage("El " + user.traduce("dumbo7/administracion/informaticos","informtico",user.getDatosMenu().idSelected()) +" ha sido creado correctamente");
				}
				else
				{
					setErrorMessage("Se ha introducido un DNI errneo. Compruebe que los datos son correctos");
				}
			}
		}
		catch (Exception ex)
		{
			setErrorMessage("GestorSolicitudes: "+ex);
			setErrorMessage("Error al crear " + user.traduce("dumbo7/administracion/informaticos","informtico",user.getDatosMenu().idSelected()));
		}
	}
	
	//Actualiza un informatico en BD
	public void updateInformatico(Session conn) {
		try {
			conn.update(informatico);
			conn.flush();
			conn.connection().commit();
			setErrorMessage("El "+user.traduce("dumbo7/administracion/informaticos","informtico",user.getDatosMenu().idSelected()) +"ha sido modificado correctamente");

		} catch (Exception ex) {
			setErrorMessage("GestorSolicitudes: "+ex);
			setErrorMessage("Error al modificar " + user.traduce("dumbo7/administracion/informaticos","informtico",user.getDatosMenu().idSelected()));
		}
	}
	
		
	//Borra un informatico en BD. Debe tener en cuenta:
	//- Si tiene perfiles asociados, se deben borrar
	//- Si tras borrar los perfiles no se puede borrar el informatico (tiene ms dependencias), debe recuperar los perfiles
	/*public void deleteInformatico(Session conn, D7Informaticos inf)
	{
		List seccionesInformatico = null;//Almacena las secciones de las que un informtico es responsable 
		try
		{
			Query q = conn.createQuery(getQuery("UnInformatico"));
			q = q.setString("sist",user.getDatosMenu().idSelected());
			q = q.setString("cod",inf.getInfCod());
			informaticos  = (List)q.list();
			
			Query q1 = conn.createQuery(getQuery("PerfilesUnInformatico"));
			q1 = q1.setString("sist",user.getDatosMenu().idSelected());
			q1 = q1.setString("inf",inf.getInfCod());
			informaticoPerfiles  = (List)q1.list();
			
			Query q2 = conn.createQuery(getQuery("InformaticoSecciones"));
			q2 = q2.setString("sist",user.getDatosMenu().idSelected());
			q2 = q2.setString("inf",inf.getInfCod());
			seccionesInformatico  = (List)q2.list();

			//Si no es reponsable de ninguna seccin se puede eliminar
			if (seccionesInformatico.size() == 0)
			{
				//Elimino los Perfiles del informatico
				for (int i=0; i<informaticoPerfiles.size();i++)
				{
					conn.delete( (D7InformaticosPerfiles)informaticoPerfiles.get(i));
				}
				//Elimino el informatico (Si salta existen dependencias, salta excepcin y debo volver a introducir los perfiles)
				informatico = (D7Informaticos) informaticos.get(0);//Si hemos recargado la pagina despues de haber borrado salta excepcion nullpointer
				conn.delete(informatico);
				//Si existen tablas dependientes de la seccion no salta excepcion si no se hace flush() y commit()
				conn.flush();
				conn.connection().commit();
				
				informaticos.remove(informatico);
			}
			else
			{
				setErrorMessage("No se pudo eliminar el informtico. Es responsable de "+seccionesInformatico.size()+" secciones." );
			}
		}
		catch (NullPointerException npe)
		{
			setErrorMessage("Seccin ya eliminada");
		}
		catch (Exception ex)
		{
			if (informatico != null)
			{
				setErrorMessage("No se pudo eliminar el informtico. Existen tablas dependientes");
				//Ademas de los perfiles existian otras dependencias. Reintroducimos los perfiles
				for (int i=0; i<informaticoPerfiles.size();i++)
				{
					conn.save( (D7InformaticosPerfiles)informaticoPerfiles.get(i));
				}
	
				try
				{
				conn.flush();
				conn.connection().commit();
				informaticos.remove(informatico);
				conn.flush();
				conn.connection().commit();
				}
				catch(Exception e)
				{setErrorMessage("Error al borrar");}
			}
		}
	}*/
public void deleteInformatico(Session conn, D7Informaticos inf)
{
	Transaction tx = null;
	List seccionesInformatico = null;//Almacena las secciones de las que un informtico es responsable 
	try
	{
		//obtengo el informatico
		Query q = conn.createQuery(getQuery("UnInformatico"));
		q = q.setString("sist",user.getDatosMenu().idSelected());
		q = q.setString("cod",inf.getInfCod());
		informaticos  = (List)q.list();
		
		//los perfiles del informatico
		Query q1 = conn.createQuery(getQuery("PerfilesUnInformatico"));
		q1 = q1.setString("sist",user.getDatosMenu().idSelected());
		q1 = q1.setString("inf",inf.getInfCod());
		informaticoPerfiles  = (List)q1.list();
		
		//las secciones dependientes del informatico
		Query q2 = conn.createQuery(getQuery("InformaticoSecciones"));
		q2 = q2.setString("sist",user.getDatosMenu().idSelected());
		q2 = q2.setString("inf",inf.getInfCod());
		seccionesInformatico  = (List)q2.list();

		//Si no es reponsable de ninguna seccin se puede eliminar
		if (seccionesInformatico.size() == 0)
		{
			//Creamos transaccin para poder hacer revert si hubo erro en alg mtodo
			tx = conn.beginTransaction();
				//Elimino los Perfiles del informatico
				for (int i=0; i<informaticoPerfiles.size();i++)
				{
					conn.delete( (D7InformaticosPerfiles)informaticoPerfiles.get(i));
				}
				//Elimino el informatico (Si salta existen dependencias, salta excepcin y debo volver a introducir los perfiles)
				informatico = (D7Informaticos) informaticos.get(0);//Si hemos recargado la pagina despues de haber borrado salta excepcion nullpointer
				conn.delete(informatico);
								
				informaticos.remove(informatico);
			//Si existen tablas dependientes de la seccion salta excepcion en commit()
			tx.commit();
		}
		else
		{
			setErrorMessage("No se pudo eliminar el " + user.traduce("dumbo7/administracion/informaticos","informtico",user.getDatosMenu().idSelected())+". Es responsable de "+seccionesInformatico.size()+" secciones." );
		}
	}
	catch (NullPointerException npe)
	{
		setErrorMessage("Seccin ya eliminada");
	}
	catch (Exception ex)
	{
		seccionesInformatico = null;
		informaticos= null;
		informaticoPerfiles = null;
		System.out.println(ex);
		setErrorMessage("No se pudo eliminar "+ user.traduce("dumbo7/administracion/informaticos","informtico",user.getDatosMenu().idSelected()) +". Existen tablas dependientes");
		tx.rollback();		 
	}
}

	
	//Invierte el estado de un informatico. De Vigente a no Vigente (Valido a no valido) y de No Vigente a Vigente (no valido a valido)
	public void changeState(Session conn, D7Informaticos inf) {
		inf.setInfSisCod(user.getDatosMenu().idSelected());
		informatico=inf;
		try
		{
			Query q = conn.createQuery(getQuery("UnInformatico"));
			q = q.setString("sist",user.getDatosMenu().idSelected());
			q = q.setString("cod",informatico.getInfCod());
			informaticos  = (List)q.list();
			
			informatico = (D7Informaticos) informaticos.get(0);
		
			if (informatico.getInfEstado().equals("V"))
			{
				informatico.setInfEstado("N");
				compruebaResponsable(conn,inf);
				pasaNoVigente(conn, informatico);
			}
			else
			{
				informatico.setInfEstado("V");
				pasaVigente(conn, informatico);
			}
			if (error==false){
				conn.update(informatico);
				conn.flush();
				conn.connection().commit();
				if (informatico.getInfEstado()=="N") setErrorMessage("Actualizacin a estado no vigente correcta.");
				else setErrorMessage("Actualizacin a estado vigente correcta.");
			}
			//Elimino la seccin para que no se mape aun despues de haberle cambiado el estado,
			//Esto error solo ocurre cuando una seccin es su padre debido a las condiciones de la primera llamada recursiva
			//informaticos.remove(informatico);
		}
		catch (Exception ex)
		{
			setErrorMessage("Error al intentar cambiar estado");
		}
	}
	
	public void pasaNoVigente(Session conn, D7Informaticos inf){
		List infVigentes=null;
		D7InformaticosVigencia informaticoVigencia;
		try{
			Query q = conn.createQuery(getQuery("InformaticoVigencia"));
			q = q.setString("sist",inf.getInfSisCod());
			q = q.setString("cod",inf.getInfCod());
			infVigentes  = (List)q.list();
			
			if (infVigentes.size()==0) return;
			
			informaticoVigencia=(D7InformaticosVigencia) infVigentes.get(0);
			informaticoVigencia.setInfvFechaFin(new java.util.Date());
			
			conn.update(informaticoVigencia);
			conn.flush();
			conn.connection().commit();
		}
		catch (Exception ex)
		{
			error=true;
			informatico.setInfEstado("V");
			setErrorMessage("Error al intentar cambiar estado");
		}
	}
	
	public void pasaVigente(Session conn, D7Informaticos inf){
		try{
//			Creo un informatico vigencia nuevo
			D7InformaticosVigencia informaticoVigencia=new D7InformaticosVigencia();
			informaticoVigencia.setInfvSisCod(inf.getInfSisCod());
			informaticoVigencia.setInfvInfCod(inf.getInfCod());
			informaticoVigencia.setInfvFechaIni(new java.util.Date());
			informaticoVigencia.setInfvFechaFin(null);
			
			conn.save(informaticoVigencia);
			conn.flush();
			conn.connection().commit();
		}
		catch (Exception ex)
		{
			error=true;
			informatico.setInfEstado("N");
			setErrorMessage("Error al intentar cambiar estado");
		}
	}
	//Comprueba si un informtico es responsable de una seccin o de una aplicacin.
	//En caso afirmativo, lanza un setErrorMessage.
	public void compruebaResponsable (Session conn, D7Informaticos inf)
	{
		List apli, secc;
		
		try
		{
			Query q1 = conn.createQuery(getQuery("InformaticoAplicacionesResponsable"));
			q1 = q1.setString("sist",user.getDatosMenu().idSelected());
			q1 = q1.setString("inf",inf.getInfCod());
			apli  = (List)q1.list();
			
			Query q2 = conn.createQuery(getQuery("InformaticoSecciones"));
			q2 = q2.setString("sist",user.getDatosMenu().idSelected());
			q2 = q2.setString("inf",inf.getInfCod());
			secc  = (List)q2.list();
			
			//Si es el nico informtico vigente vinculado a una aplicacin, se debe advertir de esto.
			PreparedStatement pstmt;
			
			String q = getQuery("AplicacionesVigentesInformaticoSQL");
			
			q = q.replaceAll(":sist",user.getDatosMenu().idSelected());
			q = q.replaceAll(":inf",inf.getInfCod());
			
			pstmt = conn.connection().prepareStatement(q);
			ResultSet rs = pstmt.executeQuery();
			
			String AplicacionesSinResponsable ="\\n\\nLas siguientes aplicaciones ya no tienen ningn informtico vigente:\\n";
			int i = 0;
			while (rs.next())
			{
				i++;
				AplicacionesSinResponsable = AplicacionesSinResponsable.concat("-"+rs.getString(1)+"\\n");
	 	    }
			if(i==0)
			{
				AplicacionesSinResponsable ="";
			}
		
	 	    rs.close();
	 	    pstmt.close();
			
	 	    if( (apli.size()!=0) && (secc.size()!=0))
			{
				setErrorMessage("Atencin!, El "+user.traduce("dumbo7/administracion/informaticos","informtico",user.getDatosMenu().idSelected())+" al que ha cambiado el estado es responsable de secciones y aplicaciones." + AplicacionesSinResponsable);
			}
			else if(apli.size()!=0)
			{
				setErrorMessage("Atencin!, El "+user.traduce("dumbo7/administracion/informaticos","informtico",user.getDatosMenu().idSelected())+" al que ha cambiado el estado es responsable de aplicaciones." + AplicacionesSinResponsable);
			}
			else if( secc.size()!=0)
			{
				setErrorMessage("Atencin!, El "+user.traduce("dumbo7/administracion/informaticos","informtico",user.getDatosMenu().idSelected())+" al que ha cambiado el estado es responsable de secciones");
			}
			else
			{
				setErrorMessage("Actualizacin a estado no vigente correcta.");
			}
			
			apli = null;
			secc = null;
		}
		catch(Exception ex)
		{
			System.out.println(ex);
			//No es importante mostrar nada en esta excepcin. El mtodo es slo para informar.
		}
	}
	
}
