<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet version="1.0" 
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:xforms="http://www.w3.org/2002/xforms">
	
<xsl:param name="servlet"/>
<xsl:param name="menu"/>	
<xsl:param name="infCod"/>
<!--Variables para mantener el filtrado-->
<xsl:param name="flag_filtrado"/>
<xsl:param name="seccionCode"/>

<xsl:include href="dumbo7/utils/xsl/utils.xsl"/>
	
<xsl:template match="XMLROOT">

<html lang="es">
	<xsl:call-template name="headComun">
		 <xsl:with-param name="jscript">
			<script LANGUAJE="JavaScript">
				function mostrarError(error){
					alert(error);
				}
			</script>
			<script LANGUAJE="JavaScript" src="../js/OnMouse.js"></script>
		</xsl:with-param>
	 </xsl:call-template>
	
<body>
	<xsl:call-template name="menuComun">
		<xsl:with-param name="NAME" select="concat(DATA/INFORMATICOS/USER/@NAME,concat('(',concat(DATA/INFORMATICOS/USER/@LOGIN,')')))"/>
		<xsl:with-param name="MENU" select="DATA/MENU"/>
		<xsl:with-param name="SELECT" select="$menu"/>
		<xsl:with-param name="HELP">administracion.xml#1.3</xsl:with-param>
	</xsl:call-template>


<xsl:call-template name="pieComun"/>
	</body>
	</html>
</xsl:template>

<xsl:template name ="cuerpo">
	<xsl:for-each select="DATA/INFORMATICOS">
			<xsl:if test="not(@ERROR='')">
				<script>mostrarError('<xsl:value-of select="@ERROR"/>')</script>
				</xsl:if>
	</xsl:for-each>
	<table align="center" border="0" cellpadding="5" cellspacing="5" width="775" summary="Tabla para modificar los grupos de costes">
	<!--Cabecera de la tabla. Muestra los datos personales del informtico que se est examinando-->
	<tr><td width="650" colspan="2" class="cab1">&#187;Asignar grupo de costes a <xsl:call-template name="traduce"><xsl:with-param name="id" select="'informtico'"/></xsl:call-template>
		<xsl:for-each select="DATA/INFORMATICOS/DATOS_PERSONALES[@IDENTIFICADOR=$infCod]">
			"<xsl:value-of select="@APELLIDOS"/>,&#160;<xsl:value-of select="@NOMBRE"/>"
		</xsl:for-each></td></tr>
		
	<tr><td colspan="2" align="center">
		<form action="{$servlet}" METHOD="POST" name="GC">
		<input type="hidden" name="flag_filtrado" value="{$flag_filtrado}"/>
		<xsl:if test="$seccionCode!=''">
			<input type="hidden" name="seccionCode" value="{$seccionCode}"/>
		</xsl:if>
		<input type="hidden" name="infCod" size="20" value="{$infCod}" readonly="true"/>
		<input type="hidden" name="module" value="dumbo7/administracion/informaticos.formGC.aceptar"/>
	<table class="cont" border="0" cellpadding="3" cellspacing="1" width="100%" summary="Esta tabla contiene los grupos de costes">
		<tr class="cabe">
			<td width="5">&#160;</td>
			<td width="5"><b>Est</b></td>	
			<td width="50"><b>Cdigo</b></td>
			<td align="left" width="420"><b>Descripcin</b></td>	
			<td width="40" align="center"><b>Coste</b></td>
			<td width="40" align="center"><b>Horas</b></td>		
		</tr>
		<!--Slo se mostrarn los grupos de costes activos, excepto cuando el grupo de costes asociado est no vigente.
				En este ltimo caso tambin se mostrar.-->			
		<xsl:for-each select="DATA/INFORMATICOS/GRUPO_COSTES">
			<xsl:variable name="CodigoGrupoCoste"><xsl:value-of select="@CODIGO"/></xsl:variable> 
			<xsl:variable name="Descripcion"><xsl:value-of select="@DESCRIPCION"/></xsl:variable> 
			<xsl:variable name="Coste"><xsl:value-of select="@COSTE"/></xsl:variable> 
			<xsl:variable name="Horas"><xsl:value-of select="@HORAS"/></xsl:variable> 
			<!--Para colocar el radio button:
					* Se coloca siempre que el grupo de costes est activo
					* Se coloca cuando el grupo de costes est inactivo y sea el grupo de costes asociado
					* Se marca (checked) siempre que sea el grupo de costes asociado-->
			<xsl:if test="@ESTADO='V'">
				<tr class="administracion" onmouseover="javascript:onMouse(this,'true');" onmouseout="javascript:onMouse(this,'false');">
					<td width="25">
						<xsl:for-each select="../INFORMATICO">
							<xsl:choose>
								<xsl:when test="@CODIGO=$infCod and $CodigoGrupoCoste=@GRUPO">
									<input name="GrupoCostesCheck" type="radio" value="{$CodigoGrupoCoste}" checked="true"/>
								</xsl:when>
								<xsl:when test="@CODIGO=$infCod and $CodigoGrupoCoste!=@GRUPO">
									<input name="GrupoCostesCheck" type="radio" value="{$CodigoGrupoCoste}"/>
								</xsl:when>
							</xsl:choose>
						</xsl:for-each>
					</td>
					<td width="5" align="center">
						<img border="0" src="../graficos/iconos/vigente.gif" alt="Vigente"/>
					</td>
					<td width="50" align="center">
						<xsl:value-of select="@CODIGO"/>
					</td>
					<td align="left" width="420">
						<xsl:value-of select="$Descripcion"/>
					</td>
					<td width="40" align="center">
						<xsl:value-of select="$Coste"/>
					</td>
					<td width="40" align="center">
						<xsl:value-of select="$Horas"/>
					</td>
				</tr>
			</xsl:if>
			<xsl:if test="@ESTADO='N'">
				<xsl:for-each select="../INFORMATICO">
					<xsl:if test="@CODIGO=$infCod and $CodigoGrupoCoste=@GRUPO">
						<tr class="administracion" onmouseover="javascript:onMouse(this,'true');" onmouseout="javascript:onMouse(this,'false');">
							<td width="25">
								<input name="GrupoCostesCheck" type="radio" value="{$CodigoGrupoCoste}" checked="true" disabled="true"/>
							</td>
							<td width="5" align="center">
								<img border="0" src="../graficos/iconos/no_vigente.gif" alt="No vigente"/>
							</td>
							<td width="50" align="center">
								<xsl:value-of select="$CodigoGrupoCoste"/>
							</td>							
							<td align="left" width="420">
								<xsl:value-of select="$Descripcion"/>
							</td>
							<td width="40" align="center">
								<xsl:value-of select="$Coste"/>
							</td>
							<td width="40" align="center">
								<xsl:value-of select="$Horas"/>
							</td>						
						</tr>
					</xsl:if>
				</xsl:for-each>
			</xsl:if>
		</xsl:for-each>
		<tr class="administracion"><td colspan="6" align="center">
				<input type="submit" class="boton" value="Aceptar" onclick="document.GC.module.value='dumbo7/administracion/informaticos.formGC.aceptar'" />&#160;
				<input type="submit" class="boton" value="Cancelar" onclick="javascript:document.GC.module.value='dumbo7/administracion/informaticos.formGC.cancelar'"/>
		</td></tr>		
	</table>
	</form>
</td></tr>
</table>
<p>&#160;</p>	
</xsl:template>

</xsl:stylesheet>
	