<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet version="1.0" 
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:xforms="http://www.w3.org/2002/xforms">
	
<xsl:param name="servlet"/>
<xsl:param name="menu"/>	
<xsl:param name="infCod"/>
<!--Variables para mantener el filtrado-->
<xsl:param name="flag_filtrado"/>
<xsl:param name="seccionCode"/>

<xsl:include href="dumbo7/utils/xsl/utils.xsl"/>
	
<xsl:template match="XMLROOT">
<html lang="es">
	<xsl:call-template name="headComun">
		 <xsl:with-param name="jscript">
			<script LANGUAJE="JavaScript">
				function mostrarError(error){
					alert(error);
				}
			</script>
			<script LANGUAJE="JavaScript" src="../js/OnMouse.js"></script>
		</xsl:with-param>
	 </xsl:call-template>
<body>
	<xsl:call-template name="menuComun">
		<xsl:with-param name="NAME" select="concat(DATA/INFORMATICOS/USER/@NAME,concat('(',concat(DATA/INFORMATICOS/USER/@LOGIN,')')))"/>
		<xsl:with-param name="MENU" select="DATA/MENU"/>
		<xsl:with-param name="SELECT" select="$menu"/>
		<xsl:with-param name="HELP">administracion.xml#1.3.1</xsl:with-param>
	</xsl:call-template>


<xsl:call-template name="pieComun"/>
	</body>
	</html>
</xsl:template>

<xsl:template name ="cuerpo">
	<xsl:for-each select="DATA/INFORMATICOS">
			<xsl:if test="not(@ERROR='')">
				<script>mostrarError('<xsl:value-of select="@ERROR"/>')</script>
				</xsl:if>
	</xsl:for-each>

	<table align="center" border="0" cellpadding="5" cellspacing="5" width="775" summary="Esta tabla contiene una seccion">
	<!--Cabecera de la tabla. Muestra los datos personales del informtico que se est examinando-->
	<tr><td width="650" colspan="2" class="cab1">&#187;Aplicaciones asociadas al <xsl:call-template name="traduce"><xsl:with-param name="id" select="'informtico'"/></xsl:call-template>
		<xsl:for-each select="DATA/INFORMATICOS/DATOS_PERSONALES[@IDENTIFICADOR=$infCod]">
			"<xsl:value-of select="@APELLIDOS"/>,&#160;<xsl:value-of select="@NOMBRE"/>"
		</xsl:for-each></td></tr>
			
	<tr>
		<td>
		<form action="{$servlet}" METHOD="POST" name="listado">
			<input type="hidden" name="flag_filtrado" value="{$flag_filtrado}"/>
			<xsl:if test="$seccionCode!=''">
				<input type="hidden" name="seccionCode" value="{$seccionCode}"/>
			</xsl:if>
			<input type="hidden" name="infCod" size="20" value="{$infCod}" readonly="true"/>
			<input type="hidden" name="module" value="dumbo7/administracion/informaticos.formListarAplicaciones.indice"/>
				<table class="cont" border="0" cellpadding="3" cellspacing="1" width="100%" summary="Esta tabla contiene lista de aplicaciones">
				<tr class="cabe">
					<td width="30" align="center"><b><font face="Verdana" size="2">Est</font></b></td>
					<td width="50" align="left"><b><font face="Verdana" size="2">Cd</font></b></td>
					<td width="400"><b><font face="Verdana" size="2">Descripcin</font></b></td>
					<td width="80" align="center"><b><font face="Verdana" size="2">Responsable</font></b></td>
					<td width="80" align="center"><b><font face="Verdana" size="2">Prioridad</font></b></td>
				</tr>
				<!--Buscar todos los InformaticoAplicacion que coincida con el informatico-->
				<xsl:for-each select="DATA/INFORMATICOS/INFORMATICO_APLICACION">
					<xsl:if test="@INFORMATICO = $infCod">	
						<!--Para cada informaticoAplicacion entrar en Aplicaciones y buscar la aplicacion relacionada para poder mostrar los datos de la aplicacion relacionada con el informatico-->
						<xsl:variable name="CodigoAplicacion"><xsl:value-of select="@APLICACION"/></xsl:variable> 
						<xsl:variable name="Responsable"><xsl:value-of select="@RESPONSABLE"/></xsl:variable> 
						<xsl:variable name="CodigoPrioridad"><xsl:value-of select="@PRIORIDAD"/></xsl:variable> 
						<xsl:for-each select="../APLICACION">	
							<xsl:if test="@CODIGO = $CodigoAplicacion">	
								<tr class="administracion" onmouseover="javascript:onMouse(this,'true');" onmouseout="javascript:onMouse(this,'false');">
									<td width="30">
										<xsl:if test="@ESTADO='V'">
											<CENTER><img border="0" src="../graficos/iconos/vigente.gif" alt="Vigente"/></CENTER>
										</xsl:if>
										<xsl:if test="@ESTADO='N'">
											<CENTER><img border="0" src="../graficos/iconos/no_vigente.gif" alt="No vigente"/></CENTER>
										</xsl:if>	
									</td>
									<!--Si el estado de la aplicacin es vigente aparece en color normal
									Si el estado de la aplicacin es no vigente aparece en color gris-->
									<xsl:if test="@ESTADO='V'">
										<td width="50"><xsl:value-of select="@CODIGO"/></td>
										<td width="400"><xsl:value-of select="@DESCRIPCION"/></td>
									</xsl:if>
									<xsl:if test="@ESTADO='N'">
										<td width="50"><font color="#999999"><xsl:value-of select="@CODIGO"/></font></td>
										<td width="400"><font color="#999999"><xsl:value-of select="@DESCRIPCION"/></font></td>
									</xsl:if>
																										
									<xsl:if test="$Responsable='Y'">
										<td width="80" align="center">Si</td>
									</xsl:if>
									<xsl:if test="$Responsable='N'">
										<td width="80" align="center">No</td>
									</xsl:if>
									<td width="80" align="center"><xsl:value-of select="$CodigoPrioridad"/></td>
								</tr>
							</xsl:if>
						</xsl:for-each>
					</xsl:if>
				</xsl:for-each>
				<xsl:if test="count(DATA/INFORMATICOS/INFORMATICO_APLICACION[@INFORMATICO=$infCod])= 0">	
						<tr class="administracion"><td colspan="5"><CENTER>No hay aplicaciones asociadas a este <xsl:call-template name="traduce"><xsl:with-param name="id" select="'informtico'"/></xsl:call-template>.</CENTER></td></tr>
				</xsl:if>
				<tr class="administracion" align="center"><td colspan="5"><CENTER><input type="submit" class="boton" value="Volver"/></CENTER></td></tr>
		</table>
		</form>
		</td>
		</tr>
		</table>
		
	<p>&#160;</p>
	
</xsl:template>

</xsl:stylesheet>
	