<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet version="1.0" 
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:xforms="http://www.w3.org/2002/xforms">
	
<xsl:param name="servlet"/>
<xsl:param name="menu"/>	
<!--Variables para mantener el filtrado-->
<xsl:param name="flag_filtrado"/>
<xsl:param name="seccionCode"/>

<xsl:include href="dumbo7/utils/xsl/utils.xsl"/>
	
<xsl:template match="XMLROOT">

<html lang="es">
	<xsl:call-template name="headComun">
		 <xsl:with-param name="jscript">
			<script LANGUAJE="JavaScript">
				<!--Para que si tenemos un unico campo de texto no haga submit al pulsar enter-->
				function pulsar(e)
				{ 
					tecla = (document.all) ? e.keyCode :e.which; 
					return (tecla!=13); 
				} 
				<!--Variables que indican si las busquedas por usuario o por informatico han dado un resultado incorrecto-->
				var DatosIncorrectos = true;
				
				function cerrar_volver()
				{
					document.nueva.module.value='dumbo7/administracion/informaticos.formNueva.cancelar'; 
					document.nueva.submit();
				}
				function busquedaGenerica(url)
				{
					url = url.concat("&amp;modulo=informaticos.formNueva.buscarApellidos");
					idInput = 'InfApe';
					url = url.concat("&amp;tipo=USR");
					newWindow = window.open(url,'_blanck',"width=600,height=400,left=100,top=100,status=no,toolbar=no,menubar=no,location=no");
				}
				function actualiza(v,doc)
				{
					DatosIncorrectos = false;
					document.nueva.infCod.value = v;
					var txt = doc.getElementById(v).innerHTML;
					var n = txt.indexOf('>');
					txt = txt.substring(n+1);
					n = txt.indexOf('&lt;');
					txt = txt.substring(0,n);
					document.getElementById(idInput).innerHTML = txt;
				}
				function mostrarError(error)
				{
					alert(error);
				}
				function buscaDNI(DNI)
				{
					var url = '<xsl:value-of select="$servlet"/>?module=dumbo7/administracion/informaticos.formNueva.buscarDNI&amp;Codigo='+DNI;
			
					http_req = false;
			
					if (window.XMLHttpRequest){
						http_req = new XMLHttpRequest();
						if (http_req.overrideMimeType){
							http_req.overrideMimeType('text/xml');
						}
					}
					else if (window.ActiveXObject){
						try{
							http_req = new ActiveXObject("Msxml2.XMLHTTP");
						}catch (e){
							try{
								http_req = new ActiveXObject("Microsoft.XMLHTTP");
							}catch (e){}
						}
					}
			
					if (!http_req){
						alert('Falla: No es posible crear una instancia XMLHTTP');
						return false;
					}
					http_req.onreadystatechange = resuelveDNI;
					http_req.open('GET', url, true);
					http_req.send(null);
				}
			
				function resuelveDNI()
				{
					if (http_req.readyState == 4){
						if (http_req.status == 200){
							var text = http_req.responseText;
							var n = text.indexOf('&lt;'+'!--');
							if (n>=0) text = text.substring(0,n);
							var m = text.indexOf('.dtd">');
							if (m>=0) text = text.substring(m+6,text.length);
							eval(text);
						}
						else{
							alert('Hubo problemas con la peticin.');
						}
					}
				}//-->
				
			</script>
	<script language="JavaScript" src="../js/informaticos/CompruebaAltaInformatico.js"></script>
		</xsl:with-param>
	 </xsl:call-template>
	
<body>
	
	<xsl:call-template name="menuComun">
		<xsl:with-param name="NAME" select="concat(DATA/INFORMATICOS/USER/@NAME,concat('(',concat(DATA/INFORMATICOS/USER/@LOGIN,')')))"/>
		<xsl:with-param name="MENU" select="DATA/MENU"/>
		<xsl:with-param name="SELECT" select="$menu"/>
		<xsl:with-param name="HELP">administracion.xml#1.3</xsl:with-param>
	</xsl:call-template>

<xsl:call-template name="pieComun"/>
	</body>
	</html>
</xsl:template>

<xsl:template name ="cuerpo">
	
	<xsl:for-each select="DATA/INFORMATICOS">
			<xsl:if test="not(@ERROR='')">
				<script>mostrarError('<xsl:value-of select="@ERROR"/>')</script>
				</xsl:if>
		</xsl:for-each>
	
	<table align="center" border="0" cellpadding="5" cellspacing="5" width="775" summary="Esta tabla contiene una lista de Informticos">
	<tr><td width="50%" colspan="2" class="cab1">&#187;Nuevo <xsl:call-template name="traduce"><xsl:with-param name="id" select="'informtico'"/></xsl:call-template></td></tr>
	<tr><td colspan="2">
		<form action="{$servlet}" METHOD="POST" name="nueva">
		<input type="hidden" name="flag_filtrado" value="{$flag_filtrado}"/>
		<xsl:if test="$seccionCode!=''">
			<input type="hidden" name="seccionCode" value="{$seccionCode}"/>
		</xsl:if>
		<table class="cont" align="center" border="0" cellpadding="3" cellspacing="1" width="90%" summary="Tabla para crear Informticos">
			<tr>
				<td class="cabe" align="left" colspan="5">
					<input type="hidden" name="module" value="dumbo7/administracion/informaticos.formNueva.aceptar"/>
					<b>Datos del <xsl:call-template name="traduce"><xsl:with-param name="id" select="'informtico'"/></xsl:call-template></b>
				</td>
			</tr>
			<!--Seccin del formulario para introducir los datos del nuevo informtico
			Contiene ayudas para la bsqueda por dni, correo y apellidos. La bsqueda se realiza entre 
			informticos y no informticos-->
			<tr class="administracion">
				<td align="left">Identificador:</td>
				<td align="left">
					<input type="text" name="infCod" size="10" maxlength="8" onkeypress="return pulsar(event)" onChange="javascript:buscaDNI(this.value);"/>
					&#160;
					<a href="javascript:busquedaGenerica('?module=dumbo7/administracion/informaticos.index.buscarGenerico');">
						<img id="Busqueda" style="display:inline" border="0" src="../graficos/iconos/ampliar.gif" alt="Realizar Bsqueda"/>
					</a>
				</td>
			</tr>
			<tr class="administracion">
				<td align="left"></td>
				<td align="left" id="InfApe"></td>
			</tr>
			<tr class="administracion">
				<td align="left" width="12%">Estado&#160;(*):</td>
				<td align="left" width="80%"><select name="infEstado" size="1"><option value="V">Vigente</option><option value="N">No&#160;Vigente</option></select></td>
			</tr>
			<tr class="administracion">
				<td align="left" width="12%">Seccin&#160;(*):</td>
				<td align="left" width="80%">
					<select name="infSecCod" size="1">
						<option value="">-Introduzca una seccin-</option>
						<xsl:for-each select="DATA/INFORMATICOS/SECCION">
							<!--Slo se mapean las seccion de primer nivel, y slo se mostrarn las que se encuentren vigentes-->
							<xsl:if test="@ESTADO='V'">
								<option value="{@CODIGO}"><xsl:value-of select="@DESCRIPCION"/></option>
							</xsl:if>
						</xsl:for-each>
					</select>
				</td>
			</tr>
			<tr class="administracion">
				<td align="left" width="12%">Grupo&#160;(*):</td>
				<td align="left" width="80%">
				<select name="infGcoCod" size="1">
					<option value="">-Introduzca un grupo-</option>
					<xsl:for-each select="DATA/INFORMATICOS/GRUPO_COSTES">
						<xsl:if test="@ESTADO='V'">
							<option value="{@CODIGO}"><xsl:value-of select="@DESCRIPCION"/></option>
						</xsl:if>
					</xsl:for-each>
				</select>
				</td>
			</tr>
			<!--Operaciones sobre Perfiles de Informaticos-->
			<!--Se debe crear, como minimo, un perfil para cada informatico-->
			<tr class="cabe">
				<td align="left" colspan="4"><b>Perfiles para el nuevo informtico&#160;(*)</b></td>
			</tr>
			
			<xsl:for-each select="DATA/INFORMATICOS/PERFIL">
				<xsl:if test="@ESTADO='V'">
					<tr class="administracion">
						<td align="left" colspan="2">
							<input type="hidden" name="PerfilesCod" value="{@CODIGO}" readonly="true"/>					
							<input type="checkbox" class="checkbox" name="PerfilesCheck" value="{@CODIGO}"/>&#160;
							<xsl:value-of select="@CODIGO"/>&#160;&#160;
							<xsl:value-of select="@DESCRIPCION"/>
						</td>
					</tr>
				</xsl:if>
			</xsl:for-each>
			<tr class="administracion"><td align="left" colspan="4"><font size="-1" color="red">(*) campos obligatorios.</font></td></tr>
				<tr class="administracion">
				<td colspan="5" align="center">
				<input type="button" class="boton" value="Aceptar" onclick="javascript:CompruebaAltaInformatico()" />&#160;
				<input type="button" class="boton" value="Cancelar" onclick="javascript:cerrar_volver()"/></td>
			</tr>		
		</table>
		</form>
			
	</td></tr>
	</table>
	
	<p>&#160;</p>
	
</xsl:template>
</xsl:stylesheet>
