<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet version="1.0" 
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:xforms="http://www.w3.org/2002/xforms">
	
<xsl:param name="servlet"/>
<xsl:param name="menu"/>	
<xsl:param name="infCod"/>
<!--Variables para mantener el filtrado-->
<xsl:param name="flag_filtrado"/>
<xsl:param name="seccionCode"/>

<xsl:include href="dumbo7/utils/xsl/utils.xsl"/>
	
<xsl:template match="XMLROOT">

<html lang="es">
	<xsl:call-template name="headComun">
		 <xsl:with-param name="jscript">
			<script LANGUAJE="JavaScript">
				function mostrarError(error){
					alert(error);
				}
				function onMouse(objeto,valor){
					if(valor == 'true'){objeto.bgColor = '#E2E2E2';}
					else{objeto.bgColor = '#F2F0E3';}
				}
				
				function comprueba_perfil(){
					i = 0;
					n=0;
					while(document.perfiles.PerfilesCheck.length >i){
						if(document.perfiles.PerfilesCheck[i].checked){
							n=n+1;						
						}
		
						i = i+1;
					}
					if(n>0)
					{
						document.perfiles.module.value='dumbo7/administracion/informaticos.formPerfil.aceptar';
						document.perfiles.submit();
					}
					else
					{
						alert("Debe seleccionar por lo menos un perfil");
						return 0;
					}					
				}
			</script>
		
		</xsl:with-param>
	 </xsl:call-template>

<body>
	<xsl:call-template name="menuComun">
		<xsl:with-param name="NAME" select="concat(DATA/INFORMATICOS/USER/@NAME,concat('(',concat(DATA/INFORMATICOS/USER/@LOGIN,')')))"/>
		<xsl:with-param name="MENU" select="DATA/MENU"/>
		<xsl:with-param name="SELECT" select="$menu"/>
		<xsl:with-param name="HELP">administracion.xml#1.3.2</xsl:with-param>
	</xsl:call-template>


<xsl:call-template name="pieComun"/>
	</body>
	</html>
</xsl:template>

<xsl:template name ="cuerpo">
	<xsl:for-each select="DATA/INFORMATICOS">
			<xsl:if test="not(@ERROR='')">
				<script>mostrarError('<xsl:value-of select="@ERROR"/>')</script>
				</xsl:if>
	</xsl:for-each>
	<table align="center" border="0" cellpadding="5" cellspacing="5" width="775" summary="Esta tabla contiene una lista de perfiles">
	<!--Cabecera de la tabla. Muestra los datos personales del informtico que se est examinando-->
	<tr><td width="650" colspan="2" class="cab1">&#187;Perfiles asociados al <xsl:call-template name="traduce"><xsl:with-param name="id" select="'informtico'"/></xsl:call-template>
		<xsl:for-each select="DATA/INFORMATICOS/DATOS_PERSONALES[@IDENTIFICADOR=$infCod]">
			"<xsl:value-of select="@APELLIDOS"/>,&#160;<xsl:value-of select="@NOMBRE"/>"
		</xsl:for-each></td></tr>
		
	<tr><td colspan="2">
		<form action="{$servlet}" METHOD="POST" name="perfiles">
		<input type="hidden" name="flag_filtrado" value="{$flag_filtrado}"/>
		<xsl:if test="$seccionCode!=''">
			<input type="hidden" name="seccionCode" value="{$seccionCode}"/>
		</xsl:if>
		<input type="hidden" name="infCod" size="20" value="{$infCod}" readonly="true"/>
		<input type="hidden" name="module" value="dumbo7/administracion/informaticos.formPerfil.aceptar"/>
		<table class="cont" align="center" border="0" cellpadding="3" cellspacing="1" width="90%" summary="Esta tabla contiene una lista de perfiles">
		<tr class="cabe">
			<td></td>
			<td><b>Estado</b></td>
			<td><b>Cdigo</b></td>
			<td><b>Descripcin</b></td>
		</tr>
		<!--Solo se deben mostrar los perfiles asociados a ese informatico (ya se controla al obtener la lista)
			Ademas, deben aparecer marcados si estan asociados y desmarcados si no lo estan.
			Los no vigentes no se aparecern, as al actualizar aparecern como desmarcados y se eliminarn-->
			<xsl:for-each select="DATA/INFORMATICOS/PERFIL">
				<xsl:variable name="CodigoPerfil"><xsl:value-of select="@CODIGO"/></xsl:variable> 
				<xsl:variable name="EstadoPerfil"><xsl:value-of select="@ESTADO"/></xsl:variable> 
				<xsl:variable name="DescripcionPerfil"><xsl:value-of select="@DESCRIPCION"/></xsl:variable> 
				
				<xsl:choose>
					<xsl:when test="count(../INFORMATICO_PERFIL[(@PERFIL=$CodigoPerfil)])!=0">
						<tr class="administracion" onmouseover="javascript:onMouse(this,'true');" onmouseout="javascript:onMouse(this,'false');">
							<xsl:if test="$EstadoPerfil='V'">
								<td width="20">
									<input type="checkbox" class="checkbox" name="PerfilesCheck" value="{@CODIGO}" checked="true"/>
								</td>
					
								<td width="30">
									 <img  border="0" src="../graficos/iconos/vigente.gif" alt="Vigente"/>
								</td>
								
								<td width="70">
									<xsl:value-of select="$CodigoPerfil"/>
								</td>
							
								<td width="570">
									<xsl:value-of select="$DescripcionPerfil"/>
								</td>
							</xsl:if>
						</tr>
					</xsl:when>
					<xsl:otherwise>
						<tr class="administracion" onmouseover="javascript:onMouse(this,'true');" onmouseout="javascript:onMouse(this,'false');">
							<xsl:if test="$EstadoPerfil='V'">
								<td width="20">
									<input type="checkbox" class="checkbox" name="PerfilesCheck" value="{@CODIGO}"/>
								</td>
							
								<td width="30">
									 <img  border="0" src="../graficos/iconos/vigente.gif" alt="Vigente"/>
								</td>
								
								<td width="70">
									<xsl:value-of select="$CodigoPerfil"/>
								</td>
							
								<td width="570">
									<xsl:value-of select="$DescripcionPerfil"/>
								</td>
							</xsl:if>
						</tr>
					</xsl:otherwise>
				</xsl:choose>
				
			</xsl:for-each>
			<tr class="administracion">
				<td colspan="5" align="center">
				<input type="button" class="boton" value="Aceptar" onclick="javascript:comprueba_perfil()"/>&#160;
				<input type="submit" class="boton" value="Cancelar" onclick="javascript:document.perfiles.module.value='dumbo7/administracion/informaticos.formPerfil.cancelar'"/></td>
			</tr>		
		</table>
		</form>
			
	</td></tr>
	</table>
	
	<p>&#160;</p>
	
</xsl:template>

</xsl:stylesheet>
	