<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet version="1.0" 
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:xforms="http://www.w3.org/2002/xforms">
	
<xsl:param name="servlet"/>
<xsl:param name="menu"/>	
<xsl:param name="infCod"/>
<!--Variables para mantener el filtrado-->
<xsl:param name="flag_filtrado"/>
<xsl:param name="seccionCode"/>

<xsl:include href="dumbo7/utils/xsl/utils.xsl"/>
	
<xsl:template match="XMLROOT">

<html lang="es">
	<xsl:call-template name="headComun">
	<xsl:with-param name="arbol" select="'Secciones'"/>
		 <xsl:with-param name="jscript">
			<script LANGUAJE="JavaScript">
				function mostrarError(error){
					alert(error);
				}
			</script>
			<script LANGUAJE="JavaScript" src="../js/OnMouse.js"></script>		
		</xsl:with-param>
	 </xsl:call-template>
<body>
	<xsl:call-template name="menuComun">
		<xsl:with-param name="NAME" select="concat(DATA/INFORMATICOS/USER/@NAME,concat('(',concat(DATA/INFORMATICOS/USER/@LOGIN,')')))"/>
		<xsl:with-param name="MENU" select="DATA/MENU"/>
		<xsl:with-param name="SELECT" select="$menu"/>
		<xsl:with-param name="HELP">administracion.xml#1.3</xsl:with-param>
	</xsl:call-template>


<xsl:call-template name="pieComun"/>
	</body>
	</html>
</xsl:template>

<xsl:template name ="cuerpo">
	<xsl:for-each select="DATA/INFORMATICOS">
			<xsl:if test="not(@ERROR='')">
				<script>mostrarError('<xsl:value-of select="@ERROR"/>')</script>
				</xsl:if>
	</xsl:for-each>
	<br/>
	<table align="center" border="0" cellpadding="5" cellspacing="5" width="775" summary="Tabla para modificar la seccin asociada">
	<!--Cabecera de la tabla. Muestra los datos personales del informtico que se est examinando-->
	<tr><td width="650" colspan="2" class="cab1">&#187;Asignar seccin al <xsl:call-template name="traduce"><xsl:with-param name="id" select="'informticos'"/></xsl:call-template> 
		<xsl:for-each select="DATA/INFORMATICOS/DATOS_PERSONALES[@IDENTIFICADOR=$infCod]">
			&quot;<xsl:value-of select="@APELLIDOS"/>,&#160;<xsl:value-of select="@NOMBRE"/>&quot;
		</xsl:for-each>
		</td></tr>
	<tr><td colspan="2">
		<form action="{$servlet}" METHOD="POST" name="seccion">
		<input type="hidden" name="flag_filtrado" value="{$flag_filtrado}"/>
		<xsl:if test="$seccionCode!=''">
			<input type="hidden" name="seccionCode" value="{$seccionCode}"/>
		</xsl:if>
		<input type="hidden" name="infCod" size="20" value="{$infCod}" readonly="true"/>
		<input type="hidden" name="module" value="dumbo7/administracion/informaticos.formSeccion.aceptar"/>
		<table class="cont" align="center" border="0" cellpadding="3" cellspacing="1" width="100%" summary="Tabla para asociar seccin a informtico">
			<tr class="cabe">
				<td width="20">&#160;</td>
				<td width="30" align="center"><b>Est</b></td>	
				<td align="left" width="30"><b>Cdigo</b></td>
				<td align="left" width="250"><b>Descripcin</b></td>	
				<td align="left" width="300"><b>Responsable</b></td>
				
				<xsl:for-each select="DATA/INFORMATICOS/SECCION[(@CODIGO='00') or (@CODIGO=@PADRE)]">
						<xsl:sort select="@DESCRIPCION"/>
						<xsl:variable name="codigo2"><xsl:value-of select="@CODIGO"/></xsl:variable>
						<xsl:choose>
							<xsl:when test="(count(../SECCION[@PADRE = $codigo2 and @CODIGO != $codigo2])>0)">	
								<xsl:call-template name="muestraSeccion">
									<xsl:with-param name="tab" select="concat('arb.',position())"/>
									<xsl:with-param name="tabimg" select="concat('img.arb.',position())"/>
									<xsl:with-param name="code" select="@CODIGO"/>
									<xsl:with-param name="clase" select="'switchcontent'"/>
									<xsl:with-param name="parent" select="@PADRE"/>
									<xsl:with-param name="respon" select="@RESPONSABLE"/>
								</xsl:call-template>					
							</xsl:when>
							<xsl:otherwise>
								<xsl:call-template name="muestraSeccion">
									<xsl:with-param name="tab" select="''"/>
									<xsl:with-param name="tabimg" select="''"/>
									<xsl:with-param name="code" select="@CODIGO"/>
									<xsl:with-param name="clase" select="'switchcontent'"/>
									<xsl:with-param name="parent" select="@PADRE"/>
									<xsl:with-param name="respon" select="@RESPONSABLE"/>
								</xsl:call-template>
							</xsl:otherwise>
						</xsl:choose>
					</xsl:for-each>
			</tr>
		<tr class="administracion"><td colspan="6" align="center">
				<input type="submit" class="boton" value="Aceptar" onclick="document.seccion.module.value='dumbo7/administracion/informaticos.formSeccion.aceptar'" />&#160;
				<input type="submit" class="boton" value="Cancelar" onclick="javascript:document.seccion.module.value='dumbo7/administracion/informaticos.formSeccion.cancelar'"/>
		</td></tr>		
	</table>
	</form>
</td></tr>
</table>
</xsl:template>

<xsl:template name="muestraSeccion">
<xsl:param name="code"/>
<xsl:param name="parent"/>
<xsl:param name="tab"/>
<xsl:param name="tabimg"/>
<xsl:param name="respon"/>
<xsl:param name="clase"/>
		<xsl:variable name="CodigoSeccion"><xsl:value-of select="@CODIGO"/></xsl:variable> 
		<xsl:variable name="Descripcion"><xsl:value-of select="@DESCRIPCION"/></xsl:variable> 
		<xsl:variable name="codInf"><xsl:value-of select="@RESPONSABLE"/></xsl:variable> 
		<!--Slo se mostrarn las secciones activas, excepto cuando la seccin asociada est no vigente.
			En este ltimo caso tambin se mostrar.-->			
		<!--Para colocar el radio button:
			* Se coloca siempre que la seccin est activa
			* Se coloca cuando la seccin est inactiva y sea la seccin asociada
			* Se marca siempre que sea la seccin asociada-->
			<xsl:if test="@ESTADO='V'">
				<tr id="{$tab}" class="administracion" onMouseOver="javascript:onMouse(this,'true');" onMouseOut="javascript:onMouse(this,'false');"><xsl:if test="(count(../SECCION[@PADRE = $CodigoSeccion and @CODIGO != $CodigoSeccion])>0)"><xsl:attribute name="class"><xsl:value-of select="$clase"/></xsl:attribute></xsl:if>
					<td align="left" width="20">
						<xsl:for-each select="../INFORMATICO">
							<xsl:choose>
								<xsl:when test="@CODIGO=$infCod and $CodigoSeccion=@SECCION">
									<input name="SeccionCheck" type="radio" value="{$CodigoSeccion}" checked="true"/>
								</xsl:when>
								<xsl:when test="@CODIGO=$infCod and $CodigoSeccion!=@SECCION">
									<input name="SeccionCheck" type="radio" value="{$CodigoSeccion}"/>
								</xsl:when>
							</xsl:choose>
						</xsl:for-each>
					</td>
					<td width="30" align="center">
						<img border="0" src="../graficos/iconos/vigente.gif" alt="Vigente"/>
					</td>
					<xsl:variable name="estilo">
						<!--<xsl:value-of select="concat(concat('padding-left:',(string-length($tab)-5) div 4),'cm')"/>-->
						<xsl:value-of select="concat(concat('padding-left:',(string-length(translate($tab,'0123456789',''))-3)* 0.25),'cm')"/>
					</xsl:variable>
					<td style="{$estilo}" width="390">
					<!--Compruebo si tiene padre para mostrar la jerarquia-->
						<xsl:if test="(count(../SECCION[@PADRE = $CodigoSeccion and @CODIGO != $CodigoSeccion])>0)">		
							<img id="{$tabimg}" class="showstate" border="0" src="../dumbo7/utils/table/minus.gif" onClick="expandcontent(this,'{$tab}');"/>
						</xsl:if>
						<!--Si no tiene hijos, se aade un icono empty-->
						<xsl:if test="(count(../SECCION[@PADRE = $CodigoSeccion and @CODIGO != $CodigoSeccion])=0)">		
							<img id="{$tabimg}" border="0" src="../dumbo7/utils/table/empty.gif"/>&#160;
						</xsl:if>
						<xsl:value-of select="@CODIGO"/>
					</td>
					<td align="left" width="250">
						<label title="{@DESCRIPCION}">
							<!--SI LA DESCRIPCION TIENE MENOS DE 25 CARACTERES-->
							<xsl:if test="25>=string-length(@DESCRIPCION)">								
								<xsl:value-of select="@DESCRIPCION"/>
							</xsl:if>
							<!--SI LA DESCRIPCION TIENE MAS DE 25 CARACTERES-->
							<xsl:if test="string-length(@DESCRIPCION)>25">
								<xsl:value-of select="concat(substring(@DESCRIPCION,0,25),'...')"/>
							</xsl:if>
						</label>
					</td>
					<td align="left" width="300" colspan="2">
						<!--Recorremos el mapeo de datosPersonales, buscando los datos personales del informtico codInf-->
						<xsl:for-each select="../DATOS_PERSONALES[@IDENTIFICADOR=$codInf]">
							<xsl:value-of select="@APELLIDOS"/>, <xsl:value-of select="@NOMBRE"/>
						</xsl:for-each>
					</td>
				</tr>
			</xsl:if>
			<xsl:if test="@ESTADO='N'">
				<xsl:for-each select="../INFORMATICO">
					<xsl:if test="@CODIGO=$infCod and $CodigoSeccion=@SECCION">
						<tr class="administracion" onmouseover="javascript:onMouse(this,'true');" onmouseout="javascript:onMouse(this,'false');">
							<td align="left" width="20">
								<input name="SeccionCheck" type="radio" value="{$CodigoSeccion}" checked="true" disabled="true"/>
							</td>
							<td width="30" align="center">
								<img border="0" src="../graficos/iconos/no_vigente.gif" alt="No vigente"/>
							</td>
							<td align="left" width="30">
								<xsl:value-of select="$CodigoSeccion"/>
							</td>
							<td align="left" width="250">
								<label title="{$Descripcion}">
								<!--SI LA DESCRIPCION TIENE MENOS DE 25 CARACTERES-->
								<xsl:if test="25>=string-length($Descripcion)">								
									<xsl:value-of select="$Descripcion"/>
								</xsl:if>
								<!--SI LA DESCRIPCION TIENE MAS DE 25 CARACTERES-->
								<xsl:if test="string-length($Descripcion)>25">
									<xsl:value-of select="concat(substring($Descripcion,0,25),'...')"/>
								</xsl:if>
								</label>
							</td>
							<td align="left" width="300" colspan="2">
								<!--Recorremos el mapeo de datosPersonales, buscando los datos personales del informtico codInf-->
								<xsl:for-each select="../DATOS_PERSONALES[@IDENTIFICADOR=$codInf]">
									<xsl:value-of select="@APELLIDOS"/>, <xsl:value-of select="@NOMBRE"/>
								</xsl:for-each>
							</td>									
						</tr>
					</xsl:if>	
				</xsl:for-each>
			</xsl:if>
			<xsl:for-each select="../SECCION[(@PADRE=$code) and not(@PADRE=@CODIGO)]">
			<xsl:sort select="@DESCRIPCION"/>
				<xsl:call-template name="muestraSeccion">
					<xsl:with-param name="code" select="@CODIGO"/>
					<xsl:with-param name="parent" select="@PADRE"/>
					<xsl:with-param name="respon" select="@RESPONSABLE"/>
					<xsl:with-param name="clase" select="'switchcontent'"/>
					<xsl:with-param name="tab" select="concat($tab,concat('.',position()))"/>
					<xsl:with-param name="tabimg" select="concat($tabimg,concat('.',position()))"/>
				</xsl:call-template>					
		</xsl:for-each>
</xsl:template>

</xsl:stylesheet>
	