<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet version="1.0" 
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:xforms="http://www.w3.org/2002/xforms">

<xsl:param name="servlet"/>	
<xsl:param name="menu"/>
<!--"mostrar" es un flag para el filtrado de informticos (muestra 'todos' o muestra solo los vigentes (''))-->
<xsl:param name="mostrar"/>
<!--Variables para mantener el filtrado-->
<xsl:param name="flag_filtrado"/>
<xsl:param name="seccionCode"/>

<xsl:variable name="seccion"/>
<xsl:variable name="codInf"/>
<xsl:variable name="grupocoste"/>

<xsl:include href="dumbo7/utils/xsl/utils.xsl"/>
	
<xsl:template match="XMLROOT">

<html lang="es">
	<xsl:call-template name="headComun">
		 <xsl:with-param name="jscript">
			<script LANGUAJE="JavaScript">
				function validar(url,apellido,nombre)
				{
					if (confirm("Est seguro de eliminar el informtico " + apellido +", "+ nombre +"  ?"))
						{
							var mostrar = '<xsl:value-of select="$mostrar"/>'
							url = url.concat("&amp;mostrar=");
							url = url.concat(mostrar);
							mantenerFiltro(url);
							//window.open(url,"_self");
						}
				}
				function mostrarError(error){
					alert(error);
				}
				function CambiarEstado(url,estado)
				{
					if (confirm("Est seguro de cambiar el estado a " + estado + "?"))
					{
						var mostrar = '<xsl:value-of select="$mostrar"/>'
						url = url.concat("&amp;mostrar=");
						url = url.concat(mostrar);
						//window.open(url,"_parent");
						mantenerFiltro(url);
					}
				}
				function mostrarInformaticos(url)
				{
					var filtrado = '<xsl:value-of select="$flag_filtrado"/>'
					if(filtrado!=0)
					{
						url = url.concat("&amp;flag_filtrado=");
						url = url.concat(filtrado);
						if(document.informaticos.Seccion.options[document.informaticos.Seccion.selectedIndex].value!="")
						{
							url = url.concat("&amp;seccionCode=");
							url = url.concat(document.informaticos.Seccion.options[document.informaticos.Seccion.selectedIndex].value);
						}
					}
					window.open(url,"_parent");
				}
				function abrirPopup(url)
				{
					newWindow = window.open(url,'_blanck',"height=230,width=450,status=no,toolbar=no,menubar=no,location=no,scrollbars=no");				
					newWindow.moveTo(self.screen.width/4,self.screen.height/4);
				}  
				//Funcin para el filtrado de los informticos en el listado principal
				function filtrar(url)
				{
					var filtrado = '<xsl:value-of select="$flag_filtrado"/>'
					var mostrar = '<xsl:value-of select="$mostrar"/>'
					if (filtrado == 1){filtrado = 0;}
					else              {filtrado = 1;}
					
					if(document.informaticos.Seccion.options[document.informaticos.Seccion.selectedIndex].value!="")
					{
						if(filtrado!=0)
						{
							url = url.concat("&amp;flag_filtrado=");
							url = url.concat(filtrado);
							
							if(document.informaticos.Seccion.options[document.informaticos.Seccion.selectedIndex].value!="")
							{
								url = url.concat("&amp;seccionCode=");
								url = url.concat(document.informaticos.Seccion.options[document.informaticos.Seccion.selectedIndex].value);
							}
						}
						url = url.concat("&amp;mostrar=");
						url = url.concat(mostrar);
						window.location.href=url;
					}
					else
					{
						alert("Introduzca un parmetro de filtrado");
					}
				} 
				function mantenerFiltro(url)
				{
					var filtrado = '<xsl:value-of select="$flag_filtrado"/>'
					var mostrar = '<xsl:value-of select="$mostrar"/>'
					url = url.concat("&amp;flag_filtrado=");
					url = url.concat(filtrado);
					if(document.informaticos.Seccion.options[document.informaticos.Seccion.selectedIndex].value!="")
					{
						url = url.concat("&amp;seccionCode=");
						url = url.concat(document.informaticos.Seccion.options[document.informaticos.Seccion.selectedIndex].value);
					}
					url = url.concat("&amp;mostrar=");
					url = url.concat(mostrar);					
					window.location.href=url;
				}
			</script>
		<script LANGUAJE="JavaScript" src="../js/OnMouse.js"></script>
		</xsl:with-param>
	 </xsl:call-template>

<body>

	<xsl:call-template name="menuComun">
		<xsl:with-param name="NAME" select="concat(DATA/INFORMATICOS/USER/@NAME,concat('(',concat(DATA/INFORMATICOS/USER/@LOGIN,')')))"/>
		<xsl:with-param name="MENU" select="DATA/MENU"/>
		<xsl:with-param name="SELECT" select="$menu"/>
		<xsl:with-param name="HELP">administracion.xml#1.3</xsl:with-param>
	</xsl:call-template>

<xsl:call-template name="pieComun"/>
	</body>
	</html>
</xsl:template>

<xsl:template name="cuerpo">
			
		<xsl:for-each select="DATA/INFORMATICOS">
			<xsl:if test="not(@ERROR='')">
				<script>mostrarError('<xsl:value-of select="@ERROR"/>')</script>
				</xsl:if>
		</xsl:for-each>
	
	<table align="center" border="0" cellpadding="5" cellspacing="5" width="780" summary="Esta tabla contiene una lista de Informticos">
		<form action="{$servlet}" METHOD="GET" name="informaticos">		
		<tr cellspacing="0">
			<td width="50%" class="cab1">&#187;Listado de <xsl:call-template name="traduce"><xsl:with-param name="id" select="'informticos'"/></xsl:call-template></td>
			<!--Si el flag es distinto de 1, quiere decir que se deben introducir los valores para filtrar-->
			<td width="65%" align="right">
				<xsl:if test="$flag_filtrado!=1 or string-length($flag_filtrado)=0">
					<select name="Seccion" size="1">
						<option	value="">-Filtrar Seccion-</option>
						<xsl:for-each select="DATA/INFORMATICOS/SECCION[@CODIGO=@PADRE]">
							<xsl:sort select="@DESCRIPCION"/>
							<option value="{@CODIGO}"><xsl:value-of select="@DESCRIPCION"/></option>
						</xsl:for-each>
					</select>	
					<a href="javascript:filtrar('?module=dumbo7/administracion/informaticos.index')"><img border="0" src="../graficos/iconos/ico_filtroOff.gif" alt="Activar filtrado por seccin y tipo de tarea"/></a>				
				</xsl:if>
				<!--Si el flag es 1, quiere decir que ya ha habido una consulta con resultado.
					En este caso, los select solo contienen los datos con los que se realizo la consulta-->
				<xsl:if test="$flag_filtrado=1">
					<select name="Seccion" size="1">
						<xsl:if test="count(DATA/INFORMATICOS/SECCION[@CODIGO=$seccionCode])!=0">
							<xsl:for-each select="DATA/INFORMATICOS/SECCION[@CODIGO=$seccionCode]">
								<option value="{@CODIGO}"><xsl:value-of select="@DESCRIPCION"/></option>
							</xsl:for-each>
						</xsl:if>
					</select>	
					<a href="javascript:filtrar('?module=dumbo7/administracion/informaticos.index')"><img border="0" src="../graficos/iconos/ico_filtroOn.gif" alt="Desactivar filtrado por seccin y tipo de tarea"/></a>				
				</xsl:if>
			</td>
			<xsl:if test="count(DATA/INFORMATICOS/INFORMATICO[@ESTADO='N'])>0">
				<xsl:if test="$mostrar='todos'">
					<td width="20%" align="center">	
						<a href="JavaScript:mostrarInformaticos('{$servlet}?module=dumbo7/administracion/informaticos.index');">Mostrar Vigentes</a>
					</td>
				</xsl:if>
				<xsl:if test="$mostrar=''">
					<td width="20%" align="center">	
						<a href="JavaScript:mostrarInformaticos('{$servlet}?module=dumbo7/administracion/informaticos.index&amp;mostrar=todos');">Mostrar Todos</a>
					</td>
				</xsl:if>
			</xsl:if>
			<td width="20%" align="center">
				<a href="javaScript:mantenerFiltro('{$servlet}?module=dumbo7/administracion/informaticos.index.nueva')">Insertar <xsl:call-template name="traduce"><xsl:with-param name="id" select="'informtico'"/></xsl:call-template></a>
			</td>
		</tr>
		<tr><td colspan="4">
		<table class="cont" border="0" cellpadding="3" cellspacing="1" width="100%" summary="Esta tabla contiene los Informticos">
			<!--Cabecera de la tabla (cuidado con los anchos y con los anchos de los campos dentro del bucle) -->
			<td class="cabe" width="20"><b><font face="Verdana" size="2">Est</font></b></td>			
			<td class="cabe" width="60"><b><font face="Verdana" size="2">Id</font></b></td>
			<td class="cabe" align="left" width="205"><b><font face="Verdana" size="2">Apellidos, Nombre</font></b></td>
			<td class="cabe" align="left" width="145"><b><font face="Verdana" size="2">Seccin</font></b></td>
			<td class="cabe" width="40" align="center"><b><font face="Verdana" size="2">Costes</font></b></td>	
			<td class="cabe" width="110"><b><font face="Verdana" size="2"></font></b></td>
			
			<SCRIPT>
				var arrayNombres = new Array();
				var arrayApellidos = new Array();
			</SCRIPT>	
			
			<!-- Comprobamos si existe algun informatico mapeado (tabla no vacia)-->
			<xsl:if test="count(DATA/INFORMATICOS/INFORMATICO)=0">
				<tr class="administracion">
					<td colspan="6" align="center"> No hay <xsl:call-template name="traduce"><xsl:with-param name="id" select="'informticos'"/></xsl:call-template>.</td>
				</tr>
			</xsl:if>
			<xsl:for-each select="DATA/INFORMATICOS/DATOS_PERSONALES">
				<xsl:sort select="@APELLIDOS"/>
				<xsl:variable name="codInf"><xsl:value-of select="@IDENTIFICADOR"/></xsl:variable> 
				<SCRIPT>
					arrayNombres['<xsl:value-of select="@IDENTIFICADOR"/>'] = <xsl:call-template name="entrecomillaDescripcion"><xsl:with-param name="descripcion" select="@NOMBRE"/></xsl:call-template>;
					arrayApellidos['<xsl:value-of select="@IDENTIFICADOR"/>'] = <xsl:call-template name="entrecomillaDescripcion"><xsl:with-param name="descripcion" select="@APELLIDOS"/></xsl:call-template>;
				</SCRIPT>	
	
				<!--Filtro que muestra todos los informticos-->
				<xsl:if test="$mostrar='todos'">
					<xsl:for-each select="../INFORMATICO[@CODIGO=$codInf]">
						 <xsl:call-template name="muestraInformaticos">
							<xsl:with-param name="codInf" select="$codInf"/>
							<xsl:with-param name="seccion" select="@SECCION"/>
							<xsl:with-param name="grupocoste" select="@GRUPO"/>
						</xsl:call-template>
					</xsl:for-each>
				</xsl:if>
				<!--Filtro que muestra todos los informticos vigentes-->
				<xsl:if test="$mostrar=''">
					<xsl:for-each select="../INFORMATICO[@CODIGO=$codInf and @ESTADO='V']">
						 <xsl:call-template name="muestraInformaticos">
							<xsl:with-param name="codInf" select="$codInf"/>
							<xsl:with-param name="seccion" select="@SECCION"/>
							<xsl:with-param name="grupocoste" select="@GRUPO"/>
						</xsl:call-template>
					</xsl:for-each>
				</xsl:if>	
			</xsl:for-each>
		
		</table>
		</td></tr>
		</form>
	</table>
	
</xsl:template>

<xsl:template name="muestraInformaticos">
<xsl:param name="codInf"/>
<xsl:param name="seccion"/>
<xsl:param name="grupocoste"/>
<tr class="administracion" onmouseover="javascript:onMouse(this,'true');" onmouseout="javascript:onMouse(this,'false');">
	<td><CENTER>
		<xsl:if test="@ESTADO='V'">
			<img border="0" src="../graficos/iconos/vigente.gif" alt="Vigente"/>
		</xsl:if>
		<xsl:if test="@ESTADO='N'">
			<img border="0" src="../graficos/iconos/no_vigente.gif" alt="No vigente"/>
		</xsl:if>	
	</CENTER></td>
	<td width="60"><xsl:value-of select="@CODIGO"/></td>
	<!--muestra un substring de apellidos,nombre-->
	<td align="left">
	<!--Recorremos el mapeo de datosPersonales, buscando los datos personales del informtico codInf-->
		<a title="{../DATOS_PERSONALES[@IDENTIFICADOR=$codInf]/@APELLIDOS}, {../DATOS_PERSONALES[@IDENTIFICADOR=$codInf]/@NOMBRE}"  href="javascript:abrirPopup('?module=dumbo7/inicio.detalleUser&amp;user={$codInf}')">
			<xsl:value-of select="../DATOS_PERSONALES[@IDENTIFICADOR=$codInf]/@APELLIDOS"/>,&#160;<xsl:value-of select="../DATOS_PERSONALES[@IDENTIFICADOR=$codInf]/@NOMBRE"/>
		</a>	
	</td>
	<!--Muestra un substring de la descripcin de la seccin-->
	<td align="left">
		<xsl:for-each select="../SECCION[@CODIGO=$seccion]">
			<a title="{@DESCRIPCION}" href="javascript:mantenerFiltro('{$servlet}?module=dumbo7/administracion/informaticos.index.verseccion&amp;infCod={$codInf}')">
				<!--Si la seccin est vigente, aparece en color normal-->
				<xsl:if test="@ESTADO='V'">
					<!--SI LA DESCRIPCION TIENE MENOS DE 19 CARACTERES-->
					<xsl:if test="19>=string-length(@DESCRIPCION)">								
						<xsl:value-of select="@DESCRIPCION"/>
					</xsl:if>
					<!--SI LA DESCRIPCION TIENE MAS DE 19 CARACTERES-->
					<xsl:if test="string-length(@DESCRIPCION)>19">
						<xsl:value-of select="concat(substring(@DESCRIPCION,0,19),'...')"/>
					</xsl:if>
				</xsl:if>
				<!--Si la seccin est no vigente, aparece en color rojo normal-->
				<xsl:if test="@ESTADO='N'">
					<!--SI LA DESCRIPCION TIENE MENOS DE 19 CARACTERES-->
					<xsl:if test="19>=string-length(@DESCRIPCION)">								
						<b><font color="#999999"><xsl:value-of select="@DESCRIPCION"/></font></b>
					</xsl:if>
					<!--SI LA DESCRIPCION TIENE MAS DE 19 CARACTERES-->
					<xsl:if test="string-length(@DESCRIPCION)>19">
						<b><font color="#999999"><xsl:value-of select="concat(substring(@DESCRIPCION,0,19),'...')"/></font></b>
					</xsl:if>
				</xsl:if>
			</a>	
		</xsl:for-each>
	</td>
	<td align="center">
		<xsl:for-each select="../GRUPO_COSTES[@CODIGO=$grupocoste]">
			<xsl:if test="@ESTADO='V'">
				<a href="javascript:mantenerFiltro('{$servlet}?module=dumbo7/administracion/informaticos.index.vergc&amp;infCod={$codInf}')" title="{@DESCRIPCION}">
				<xsl:value-of select="@CODIGO"/>
				</a>
			</xsl:if>
			<xsl:if test="@ESTADO='N'">
				<a href="javascript:mantenerFiltro('{$servlet}?module=dumbo7/administracion/informaticos.index.vergc&amp;infCod={$codInf}')" title="{@DESCRIPCION}">
				<b><font color="#999999"><xsl:value-of select="@CODIGO"/></font></b>
				</a>
			</xsl:if>
		</xsl:for-each>
	</td>
	<xsl:variable name="traducido"><xsl:call-template name="traduce"><xsl:with-param name="id" select="'informatico'"/></xsl:call-template></xsl:variable>
	<td>
		<a href="javaScript:mantenerFiltro('{$servlet}?module=dumbo7/administracion/informaticos.index.traspasar&amp;infCod={@CODIGO}')" title="Traspaso"><img border="0" src="../graficos/iconos/next.gif" alt="Traspasar Tareas"/></a>
		&#160;
		<a href="javaScript:mantenerFiltro('{$servlet}?module=dumbo7/administracion/informaticos.index.veraplicaciones&amp;infCod={@CODIGO}')" title="Aplicaciones"><img border="0" src="../graficos/iconos/Aplicacion.gif" alt="Listar Aplicaciones"/></a>
		&#160;
		<a href="javaScript:mantenerFiltro('{$servlet}?module=dumbo7/administracion/informaticos.index.verperfil&amp;infCod={@CODIGO}')" title="Perfiles"><img border="0" src="../graficos/iconos/Perfil.gif" alt="Asignar/Eliminar Perfiles"/></a>
		&#160;
		<xsl:if test="@ESTADO='V'">
			 <a href="JavaScript:CambiarEstado('{$servlet}?module=dumbo7/administracion/informaticos.index.cambiar&amp;infCod={@CODIGO}','NO VIGENTE');" title="Pasar a No Vigente"><img border="0" src="../graficos/iconos/CambiarEstadoNV.gif" alt="Cambiar Estado del {$traducido} a NO VIGENTE"/></a>
		</xsl:if>
		<xsl:if test="@ESTADO='N'">
			 <a href="JavaScript:CambiarEstado('{$servlet}?module=dumbo7/administracion/informaticos.index.cambiar&amp;infCod={@CODIGO}','VIGENTE');" title="Pasar a Vigente"><img border="0" src="../graficos/iconos/CambiarEstadoV.gif" alt="Cambiar Estado del {$traducido} a VIGENTE"/></a>
		</xsl:if>
		&#160;
		<a href="javascript:validar('?module=dumbo7/administracion/informaticos.index.eliminar&amp;infCod={@CODIGO}',arrayApellidos['{@CODIGO}'],arrayNombres['{@CODIGO}']);" title="Eliminar"><img border="0" src="../graficos/iconos/eliminar.gif" alt="Eliminar {$traducido}"/></a>
	</td>
</tr>

</xsl:template>

</xsl:stylesheet>