/*
 * 
 *
 */
package dumbo7.administracion.noticias;

import dumbo7.utils.*;
import dumbo7.administracion.*;
import org.hibernate.*;

import atica.frameweb.query.*;
import org.apache.log4j.*;
import atica.frameweb.utils.*;
import java.util.*;

import dumbo7.utils.ldap.*;
import org.hibernate.*;
import java.sql.*;

import dumbo7.utils.*;
import javax.servlet.http.*;
import java.io.*;
import java.math.BigDecimal;


/**
 * @author Universidad de Murcia - ATICA
 *
 */

public class GestorNoticias extends GestorAdministracion {
	private List noticias;
	private D7SistemasNoticias noticia;
	private java.util.Date Date;
	/**CONSTRUCTOR*/
	public GestorNoticias() {}
	
	/**METODOS DE LISTA PARA EL MAPEO*/
	public void listaNoticias(Session conn) {
		try{
			Query q = conn.createQuery(getQuery("AllNoticias"));
			q = q.setString("sist",user.getDatosMenu().idSelected());
			noticias  = (List)q.list();
		} catch (Exception ex) {
			setErrorMessage("GestorNoticias[Lectura de BBDD]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
	}
	public void QueryNoticias(Session conn,D7SistemasNoticias noti){
		try {
			Query q = conn.createQuery(getQuery("Noticias"));
			q = q.setString("sist",user.getDatosMenu().idSelected());
			q = q.setString("cod",noti.getSnoCod().toString());
			noticias  = (List)q.list();
			
		} catch (Exception ex) {
			setErrorMessage("GestorNoticias[Lectura de BBDD]: "+((ex.getCause()!=null)?ex.getCause():ex));logger.error(ex.getMessage());
		}
	}	
	
	/**METODOS GET*/
	public List getNoticia() {return noticias;}
			
	/**CREAS LAS SECUENCIAS DE LOS ARRAYS Y DA DE ALTA LA NOTICIA*/
	public void saveNoticia(Session conn,D7SistemasNoticias noti) {
		int NotCod = 0;
		PreparedStatement pstmt = null;
		ResultSet rs = null;
		try{
			try {
				String qry = getQuery("NextCodigoNoticia");
				qry = qry.replaceFirst("sistema",user.getDatosMenu().idSelected());
				pstmt = conn.connection().prepareStatement(qry);
				rs = pstmt.executeQuery();
				if (rs.next()) {
					NotCod = rs.getInt(1);
				}
			} catch (Exception ex) {
				logger.fatal("Error BD: "+ex);
			
			} finally {
				if (pstmt!=null) pstmt.close();
				if (rs!=null) rs.close();
			}
		}catch(Exception ex) {
			logger.fatal("Error BD: "+ex);
		}
		noti.setSnoSisCod(user.getDatosMenu().idSelected());
		noti.setSnoCod(new Integer(NotCod));
		noti.setSnoFecha(new java.util.Date());
		try {
			conn.save(noti);
			conn.flush();
			conn.connection().commit();
			noticia = null;
			setErrorMessage("La noticia ha sido creada correctamente");
			
		} catch (Exception ex) {
			//setErrorMessage("GestorNoticias: "+ex);
			setErrorMessage("Error al crear la noticia");
		}
	}
	/**MODIFICACION DE NOTICIAS*/
	public void updateNoticia(Session conn, D7SistemasNoticias noti) {
		noti.setSnoSisCod(user.getDatosMenu().idSelected());
		
		try 
		{
			conn.update(noti);
			conn.flush();
			conn.connection().commit();
			setErrorMessage("La noticia ha sido modificada correctamente");
		}
		catch (Exception ex)
		{
			setErrorMessage("GestorNoticias: "+ex);
			setErrorMessage("Error al modificar la noticia");
		}
		
	}
	
	/**BAJA DE NOTICIAS*/
	public void removeNoticia(Session conn,D7SistemasNoticias noti){
		
		this.QueryNoticias(conn,noti);
		noticia = (D7SistemasNoticias)noticias.get(0);//Si hemos recargado la pagina despues de haber borrado salta excepcion nullpointer
		try{
			conn.delete(noticia);
			conn.flush();
			conn.connection().commit();
			noticias.remove(noticia);			//Elimino la noticia para que no se mape aun despues de haberla eliminado
			setErrorMessage("La noticia ha sido eliminada correctamente");
		}
		catch (IndexOutOfBoundsException nex){
			setErrorMessage("No se puede eliminar una Noticia que no existe(ERROR al Recargar)");
		}
		catch(Exception ex){
			setErrorMessage("GestorNoticias: "+ex);
		}
	}
	
}//Fin del GestorAplicaciones
