<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet version="1.0" 
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:xforms="http://www.w3.org/2002/xforms">

<xsl:param name="servlet"/>	
<xsl:param name="menu"/>
	
<xsl:include href="dumbo7/utils/xsl/utils.xsl"/>
<xsl:template match="XMLROOT">

<html lang="es">
     <xsl:call-template name="headComun">
         <xsl:with-param name="jscript">
			<script LANGUAJE="JavaScript">
				function mostrarError(error){
					alert(error);
				}
				function validar(url,des){
					if (confirm("Esta seguro de eliminar la Noticia con Asunto '"+des+"'")){ 
						window.open(url,"_self");
					}
				}
            </script>
			<script LANGUAJE="JavaScript" src="../js/OnMouse.js"></script>
		</xsl:with-param>
	   </xsl:call-template>

<body>
	<xsl:call-template name="menuComun">
		<xsl:with-param name="NAME" select="concat(DATA/NOTICIAS/USER/@NAME,concat('(',concat(DATA/NOTICIAS/USER/@LOGIN,')')))"/>
		<xsl:with-param name="MENU" select="DATA/MENU"/>
		<xsl:with-param name="SELECT" select="$menu"/>
		<xsl:with-param name="HELP">administracion.xml#1.8</xsl:with-param>
	</xsl:call-template>

<xsl:call-template name="pieComun"/>
</body>
</html>

</xsl:template>

<xsl:template name="cuerpo">
	<xsl:for-each select="DATA/NOTICIAS">
		<xsl:if test="not(@ERROR='')">
			<script>mostrarError('<xsl:value-of select="@ERROR"/>')</script>
			</xsl:if>
	</xsl:for-each>

<table align="center" border="0" cellpadding="5" cellspacing="5" width="775" height="16" summary="Esta tabla contiene una lista de Noticias">
	<tr>
		<td width="85%" class="cab1">&#187;Listado de noticias</td>
		<td align="center" width="15%"><a href="{$servlet}?module=dumbo7/administracion/noticias.index.nueva">Insertar Noticia</a></td>
	</tr>
	<tr><td colspan="2">
	<table class="cont" border="0" cellpadding="3" cellspacing="1" width="100%">
		<tr>		
			<!--Cabecera de la tabla (cuidado con los anchos y con los anchos de los campos dentro del bucle) -->
			<td class="cabe" width="35"><b><font face="Verdana" size="2">Fecha</font></b></td>
			<td class="cabe" width="40"><b><font face="Verdana" size="2">Indole</font></b></td>
			<td class="cabe" width="40"><b><font face="Verdana" size="2">Carcter</font></b></td>
			<td class="cabe"><b><font face="Verdana" size="2">Asunto</font></b></td>
			<td class="cabe" colspan="2"></td>
			
			<SCRIPT>
				<!--Para guardar la descripcin y pasarlo a los javascript de tal forma que se respeten las tildes en los string-->
				var arrayAsunto = new Array();
			</SCRIPT>	
			
			<xsl:for-each select="DATA/NOTICIAS/NOTICIA">
			<tr class="administracion" onmouseover="javascript:onMouse(this,'true');" onmouseout="javascript:onMouse(this,'false');">
				<SCRIPT>
					arrayAsunto['<xsl:value-of select="@CODIGO"/>'] = <xsl:call-template name="entrecomillaDescripcion"><xsl:with-param name="descripcion" select="@ASUNTO"/></xsl:call-template>;
				</SCRIPT>
				<td width="35"><xsl:call-template name="date2String2"><xsl:with-param name="fecha" select="@FECHA"/></xsl:call-template></td>
				<CENTER><td width="40">
						<xsl:if test="@GENERAL = 'G'">
							General
						</xsl:if>	
						<xsl:if test="@GENERAL = 'P'">
							Particular
						</xsl:if>
				</td></CENTER>
				<CENTER><td width="40">
						<xsl:if test="@CARACTER = 'I'">
							<xsl:call-template name="traduce"><xsl:with-param name="id" select="'Informticos'"/></xsl:call-template>
						</xsl:if>	
						<xsl:if test="@CARACTER = 'P'">
							Pblica
						</xsl:if>
				</td></CENTER>			
				<td width="500"><a href="{$servlet}?module=dumbo7/administracion/noticias.index.ampliar&amp;snoCod={@CODIGO}"><xsl:value-of select="@ASUNTO"/></a></td>			
				<td width="20" align="center"><a href="{$servlet}?module=dumbo7/administracion/noticias.index.modificar&amp;snoCod={@CODIGO}"><img  border="0" src="../graficos/iconos/modificar.gif" alt="Modificar Noticia"/></a></td>
				<td width="20" align="center"><a href="javascript:validar('?module=dumbo7/administracion/noticias.index.eliminar&amp;snoCod={@CODIGO}',arrayAsunto['{@CODIGO}']);"><img border="0" src="../graficos/iconos/eliminar.gif" alt="Eliminar Noticia"/></a></td>
			</tr>
			
			</xsl:for-each>
			<xsl:if test="count(DATA/NOTICIAS/NOTICIA)=0">
				<tr>
					<td colspan="4" align="center"> No hay Noticias.</td>
				</tr>
			</xsl:if>
		</tr>
	</table></td></tr>
</table>
</xsl:template>

</xsl:stylesheet>
	