/*
 * 
 *
 */
package dumbo7.administracion.parametros;

import dumbo7.utils.*;
import dumbo7.administracion.*;
import org.hibernate.*;

import atica.frameweb.query.*;

import java.math.BigDecimal;
import java.sql.*;
import java.util.*;

/**
 * @author Universidad de Murcia - ATICA
 *
 */

public class GestorParametros extends GestorAdministracion {
	
	protected List parametros = null; 
	protected List prioridades = null;
	protected List tiposTareas = null;
	protected List parametrosMaximos = null;
	
	private String [] Param;
	private String [] Valores;
	private String [] priCod = null;
	private String [] ttarCod = null;
	private String [] maxdias = null;
	
	/**CONSTRUCTOR*/
	public GestorParametros() {}
	
	
	/**MTODOS SET PARA LA RECOGIDA DE LOS PARAMETROS Y SUS VALORES*/
	public void setParametros(String[] p){Param = p;}
	public void setValores(String [] v){Valores = v;}
	
	/**MTODOS SET PARA LA RECOGIDA DE PARAMETROS MAXIMOS*/
	public void setPrioridadesCod(String [] priCod){this.priCod = priCod;}
	public void setTipoTareasCod(String [] ttarCod){this.ttarCod= ttarCod;}
	public void setMaxDias(String [] maxdias){this.maxdias = maxdias;}
		
	/**MTODOS GET PARA EL MAPEO*/
	public List getParametros(){return parametros;}
	public List getPrioridades(){return prioridades;}
	public List getTipoTareas() {return tiposTareas; }
	public List getParametrosMaximos() {return parametrosMaximos; }
	
	/**METODOS DE LISTA PARA EL MAPEO*/
	public void listaParametros(Session conn)
	{
		try
		{
			Query q = conn.createQuery(getQuery("AllParametros"));
			q = q.setString("sist",user.getDatosMenu().idSelected());
			parametros  = (List)q.list();
					
		}
		catch (Exception ex)
		{
			setErrorMessage("GestorParametros[Lectura de BBDD]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
	}
	public void listaPrioridades(Session conn)
	{
		try
		{
			Query q = conn.createQuery(getQuery("AllPrioridades"));
			q = q.setString("sist",user.getDatosMenu().idSelected());
			prioridades  = (List)q.list();
		}
		catch (Exception ex)
		{
			setErrorMessage("GestorParametros[Lectura de BBDD]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
	}
	public void listaTipoTareas(Session conn){
		try{
			Query q = conn.createQuery(getQuery("AllTiposTareas"));
			q = q.setString("sist",user.getDatosMenu().idSelected());
			tiposTareas  = (List)q.list();
		
		} catch (Exception ex) {
			setErrorMessage("GestorParametros[Lectura de BBDD]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
	}
	
	//Mtodo que lista todos los parmetros mximos que existan, ms las nuevas combinaciones de
	//prioridades y tipos tareas (si existen ...)
	public void listaParametrosMaximos(Session conn)
	{
		Vector nuevasPrioridades, nuevasTiposTareas, viejasPrioridades,viejasTiposTareas;
		D7ParametrosMaximos pm;
		boolean existe = false;
		int sizePrioridades, sizeTipoTareas;
		
		pm = new D7ParametrosMaximos();
		nuevasPrioridades = new Vector();//Guardamos objetos tipo D7Prioridades, las nuevas prioridades
		nuevasTiposTareas = new Vector();//Guardamos objetos tipo D7TiposTareas, los nuevos tipostareas
		
		viejasPrioridades = new Vector();//Guardamos objetos tipo D7Prioridades, las prioridades que ya estaban
		viejasTiposTareas = new Vector();//Guardamos objetos tipo D7TiposTareas, los tipostareas que ya estaban
		
		try
		{
			
			//query que devuelve todas los parametros_maximos que hay creadas para una seccin
			Query q1 = conn.createQuery(getQuery("AllParametrosMaximos"));
			q1 = q1.setString("sist",user.getDatosMenu().idSelected());
			parametrosMaximos  = (List)q1.list();
			//query que devuelve todas las prioridades que hay creadas
			listaPrioridades(conn);
			//query que devuelve todos los tipostareas que hay creados		
			listaTipoTareas(conn);
		}
		catch(Exception ex)
		{
			setErrorMessage("Error al listar parmetros mximos");
		}
		//Comprobamos si se aadieron prioridades nuevas tras la creacion de la seccion
		sizePrioridades = prioridades.size();//variable que guarda el numero de prioridades existentes (por si luego se borra alguna que no cambie este valor)
		for (int i=0; i<sizePrioridades;i++)
		{
			for(int j=0; j<parametrosMaximos.size();j++)
			{
				if( ((D7ParametrosMaximos)parametrosMaximos.get(j)).getPmxPriCod().equals( ((D7Prioridades)prioridades.get(i)).getPriCod()))
					existe=true;
			}
			if(!existe)
				nuevasPrioridades.add( prioridades.get(i));//Si la seccion no tiene esta prioridad la aado al grupo de nuevas
			else
				viejasPrioridades.add( prioridades.get(i));//Si la seccion si tiene esta prioridad la aado al grupo de viejas
			
			existe=false;
		}
		
		//Comprobamos si se aadieron tipos_tareas nuevas tras la creacion de la seccion
		sizeTipoTareas = tiposTareas.size(); 
		for (int i=0; i<sizeTipoTareas;i++)
		{
			for(int j=0; j<parametrosMaximos.size();j++)
			{
				if( ((D7ParametrosMaximos)parametrosMaximos.get(j)).getPmxTipCod().equals( ((D7TiposTareas)tiposTareas.get(i)).getTipCod()))
					existe=true;
			}
			if(!existe)
				nuevasTiposTareas.add( tiposTareas.get(i));//Si la seccion no tiene este tipotarea La aado al grupo de nuevas
			else
				viejasTiposTareas.add( tiposTareas.get(i));//La aado al grupo de viejas
		
			existe=false;
		}
				
		//por cada prioridad nueva creamos tantas secciones maximos como tipostareas teniamos
		for (int i=0;i<nuevasPrioridades.size();i++)
		{
			for (int j=0;j<viejasTiposTareas.size();j++)
			{
				pm = new D7ParametrosMaximos();
				pm.setPmxSisCod(user.getDatosMenu().idSelected());
				pm.setPmxPriCod(((D7Prioridades)nuevasPrioridades.get(i)).getPriCod());
				pm.setPmxTipCod(((D7TiposTareas)viejasTiposTareas.get(j)).getTipCod());
				pm.setPmxDias(new BigDecimal(1));
				parametrosMaximos.add(pm);
				
				//se guarda cuando se crea para luego solo hacer update
				savepm(conn,pm);
			}
		}
		
		//por cada tipotarea nueva creamos tantas secciones maximos como prioridades teniamos
		for (int i=0;i<nuevasTiposTareas.size();i++)
		{
			for (int j=0;j<viejasPrioridades.size();j++)
			{
				pm = new D7ParametrosMaximos();
				pm.setPmxSisCod(user.getDatosMenu().idSelected());
				pm.setPmxPriCod(((D7Prioridades)viejasPrioridades.get(j)).getPriCod());
				pm.setPmxTipCod(((D7TiposTareas)nuevasTiposTareas.get(i)).getTipCod());
				pm.setPmxDias(new BigDecimal(1));
				parametrosMaximos.add(pm);				
				
				//se guarda cuando se crea para luego solo hacer update
				savepm(conn,pm);
			}
		}
		
		//Por ultimo, las prioridades nuevas con los tipostareas nuevos
		for (int i=0;i<nuevasTiposTareas.size();i++)
		{
			for (int j=0;j<nuevasPrioridades.size();j++)
			{
				pm = new D7ParametrosMaximos();
				pm.setPmxSisCod(user.getDatosMenu().idSelected());
				pm.setPmxPriCod(((D7Prioridades)nuevasPrioridades.get(j)).getPriCod());
				pm.setPmxTipCod(((D7TiposTareas)nuevasTiposTareas.get(i)).getTipCod());
				pm.setPmxDias(new BigDecimal(1));
				parametrosMaximos.add(pm);
				
				//se guarda cuando se crea para luego solo hacer update
				savepm(conn,pm);
			}
		}
	}
	//mtodo comn para parametros_maximos 
	public void savepm(Session conn,D7ParametrosMaximos pm)
	{
		try
		{
			conn.save(pm);
			conn.flush();
			conn.connection().commit();
		}
		catch(Exception e)
		{
			setErrorMessage("Error al crear seccin. Compruebe que los datos introducidos son los correctos.");
		}
	}
	
	/**METODO PARA ACTUALIZAR EL VALOR DE LOS PARAMETROS EN BBDD*/
	public void ActualizaParametros(Session conn){
		this.listaParametros(conn);
		Iterator it = this.parametros.iterator();
		
		while(it.hasNext()){
			D7Parametros par = (D7Parametros)it.next();
			for(int i=0; i<Param.length; i++){
				if(par.getParParametro().equals(Param[i])){
					par.setParValor(Valores[i]);
					try 
					{
						conn.update(par);
						conn.flush();
						conn.connection().commit();
					}
					catch (Exception ex)
					{
						setErrorMessage("Error al actualizar parmetros.");
					}
				}
			}
		}
		parametros = null;
	}//Fin del acualiza Parametros
	
	
	
	public void ActualizaParametrosMaximos(Session conn){		
		
		D7ParametrosMaximos [] ParamMax = new D7ParametrosMaximos[priCod.length];		

		for(int i=0; i < priCod.length ; i++)
		{
			ParamMax[i] = new D7ParametrosMaximos();
			ParamMax[i].setPmxSisCod(user.getDatosMenu().idSelected());
			ParamMax[i].setPmxTipCod(ttarCod[i]);
			ParamMax[i].setPmxPriCod(priCod[i]);
			ParamMax[i].setPmxDias(new BigDecimal(maxdias[i]));
			
			try
			{
				conn.update(ParamMax[i]);
				conn.flush();
				conn.connection().commit();
			}
			catch(Exception e)
			{
				setErrorMessage("Excepcion al Actualizar Parametros-Maximos" + e);
			}
		}
		ParamMax = null;
	}
}//Fin del GestorParametros
