<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet version="1.0" 
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:xforms="http://www.w3.org/2002/xforms">

<xsl:param name="servlet"/>	
<xsl:param name="menu"/>

<xsl:variable name="tipotareacod"/>
<xsl:variable name="tipotareades"/>
<xsl:variable name="CodigoPrioridad"/>
<xsl:variable name="CodigoTipoTarea"/>

<xsl:include href="dumbo7/utils/xsl/utils.xsl"/>
<xsl:template match="XMLROOT">

<html lang="es">
     <xsl:call-template name="headComun">
         <xsl:with-param name="jscript">
			<script LANGUAJE="JavaScript">
				function mostrarError(error){
					alert(error);
				}
                function enviar()
				 {
					i = 0;
					while(document.modificarParametros.parValor.length >i)
					{
						document.modificarParametros.parValor[i].value = allTrim(document.modificarParametros.parValor[i].value);
						if(document.modificarParametros.parParametro[i].value!="PAR_PRIORIDAD")
						{
							if(document.modificarParametros.parValor[i].value.length==0)
							{
								alert("Debe rellenar el campo vaco"+ document.modificarParametros.parValor[i].value)
								document.modificarParametros.parValor[i].focus() 
								return 0;
							}
						}
						if(document.modificarParametros.parValor[i].value.length > 250){
							alert("El campo no puede contener mas que 250 caracteres")
							document.modificarParametros.parValor[i].focus() 
							return 0;
						}
						i = i+1;
					}	
					
					document.modificarParametros.module.value='dumbo7/administracion/parametros.ActualizaParametros.Guardar'
					document.modificarParametros.submit();
				}
				
				//funciones para eliminar espacios en blanco
				function lTrim(sStr)
				{ 
					while (sStr.charAt(0) == " ")  
					sStr = sStr.substr(1, sStr.length - 1); 
					return sStr; 
				} 
				
				function rTrim(sStr)
				{ 
					while (sStr.charAt(sStr.length - 1) == " ")  
					sStr = sStr.substr(0, sStr.length - 1); 
					return sStr; 
				} 
				
				function allTrim(sStr)
				{ 
					return rTrim(lTrim(sStr)); 
				} 
			</script>
			<script LANGUAJE="JavaScript" src="../js/OnMouse.js"></script>
		</xsl:with-param>
	   </xsl:call-template>



<body>
	<xsl:call-template name="menuComun">
		<xsl:with-param name="NAME" select="concat(DATA/PARAMETROS/USER/@NAME,concat('(',concat(DATA/PARAMETROS/USER/@LOGIN,')')))"/>
		<xsl:with-param name="MENU" select="DATA/MENU"/>
		<xsl:with-param name="SELECT" select="$menu"/>
		<xsl:with-param name="HELP">administracion.xml#1.5.1</xsl:with-param>
	</xsl:call-template>
<xsl:call-template name="pieComun"/>
	</body>
	</html>
</xsl:template>

<xsl:template name="cuerpo">
	<xsl:variable name="parametros" select="DATA/PARAMETROS[count(/XMLROOT/DATA/PARAMETROS)]"/>
	
		<xsl:for-each select="DATA/PARAMETROS">
		<xsl:if test="not(@ERROR='')">
			<script>mostrarError('<xsl:value-of select="@ERROR"/>')</script>
			</xsl:if>
	</xsl:for-each>

<table align="center" border="0" cellpadding="5" cellspacing="5" width="780" height="16" summary="Esta tabla contiene una lista de Parametros">
	<tr><td width="300" colspan="2" class="cab1">&#187;Parmetros del sistema</td></tr>
		<tr><td>
		<table class="cont" border="0" cellpadding="3" cellspacing="1" width="100%">
			<tr class="cabe">
				<!--Cabecera de la tabla (cuidado con los anchos y con los anchos de los campos dentro del bucle) -->
				<td width="60%"><b><font face="Verdana" size="2">Descripcin</font></b></td>
				<td width="40%"><b><font face="Verdana" size="2">Valor&#160;Actual</font></b></td>
			</tr>
				<form action="{$servlet}" METHOD="POST" name="modificarParametros">
				<input type="hidden" name="module" value="dumbo7/administracion/parametros.ActualizaParametros.Guardar"/>
				<xsl:for-each select="$parametros/PARAMETRO">
				<tr class="administracion" onmouseover="javascript:onMouse(this,'true');" onmouseout="javascript:onMouse(this,'false');">
					<td width="60%">
						<xsl:value-of select="@DESCRIPCION"/>
					</td>
					<td width="40%">
					<xsl:choose>
							<xsl:when test="(@PARAMETRO = 'PAR_CONTROL_AUSENCIAS')or (@PARAMETRO = 'PAR_IND_COSTE')or
										(@PARAMETRO = 'PAR_IND_ICONO')or (@PARAMETRO = 'PAR_IND_COLOR') or
										(@PARAMETRO = 'PAR_IND_TAREAS') or (@PARAMETRO = 'PAR_URGENCIA')">			
							<input type="hidden" name="parParametro" value="{@PARAMETRO}" readonly="true"/>
							<select name="parValor" size="1">
								<xsl:if test="@VALOR = 'S'">
									<option value="S">SI</option>						
									<option value="N">NO</option>
								</xsl:if>	
								<xsl:if test="@VALOR = 'N'">
									<option value="N">NO</option>
									<option value="S">SI</option>
								</xsl:if>
							</select>		
						</xsl:when>
						<xsl:when test="(@PARAMETRO = 'PAR_PRIORIDAD')">
							<xsl:variable name="CodigoPrioridad"><xsl:value-of select="@VALOR"/></xsl:variable>
							<input type="hidden" name="parParametro" value="PAR_PRIORIDAD" readonly="true"/>
							<select name="parValor" size="1">
								<!--Si se introdujo 'sin prioridad' se ejecuta lo siguiente-->
								<xsl:if test="not(@VALOR)">
									<option value="">-Sin prioridad-</option>
									<xsl:for-each select="../PRIORIDADES">
										<option value="{@CODIGO}"><xsl:value-of select="@DESCRIPCION"/></option>						
									</xsl:for-each>
								</xsl:if>
								<!--Si no se introdujo 'sin prioridad' se ejecuta lo siguiente-->								
								<xsl:for-each select="../PRIORIDADES[@CODIGO=$CodigoPrioridad]">
									<option value="{@CODIGO}"><xsl:value-of select="@DESCRIPCION"/></option>
									<option value="">-Sin prioridad-</option>						
								</xsl:for-each>					
								<xsl:for-each select="../PRIORIDADES[@CODIGO!=$CodigoPrioridad]">
									<option value="{@CODIGO}"><xsl:value-of select="@DESCRIPCION"/></option>						
								</xsl:for-each>
							</select>							
						</xsl:when>
						<xsl:otherwise><!-- Cuando (@VALOR != 'S') and (@VALOR != 'N')-->
							<input type="text" name="parValor" value="{@VALOR}" size="55"/>
							<input type="hidden" name="parParametro" value="{@PARAMETRO}" readonly="true"/>
						</xsl:otherwise>
					</xsl:choose>	
					</td>
				</tr>				
				</xsl:for-each>
				</form>
				<xsl:if test="count($parametros/PARAMETRO)=0">
					<tr>
						<td width="2"><b></b></td>
						<td width="48">No hay Parametros.</td>
					</tr>
				</xsl:if>
				<tr class="administracion">
					<td colspan="2" align="center">
						<form action="{$servlet}" METHOD="POST" name="volver">
							<INPUT CLASS="boton" TYPE="button" VALUE="Aceptar" OnClick="javascript:enviar()"/>&#160;
							<input type="hidden" name="module" value="dumbo7/administracion/parametros.ActualizaParametros.Volver" readonly="true"/>
							<INPUT CLASS="boton" TYPE="submit" VALUE="Cancelar"/>
						</form>
					</td>
				</tr>
		</table>
		</td></tr>
	</table>
</xsl:template>

</xsl:stylesheet>
	