<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet version="1.0" 
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:xforms="http://www.w3.org/2002/xforms">

<xsl:param name="servlet"/>	
<xsl:param name="menu"/>

<xsl:variable name="tipotareacod"/>
<xsl:variable name="tipotareades"/>
<xsl:variable name="CodigoPrioridad"/>
<xsl:variable name="CodigoTipoTarea"/>

<xsl:include href="dumbo7/utils/xsl/utils.xsl"/>
<xsl:template match="XMLROOT">

<html lang="es">
     <xsl:call-template name="headComun">
         <xsl:with-param name="jscript">
			<script LANGUAJE="JavaScript">
				function mostrarError(error){
					alert(error);
				}
            </script>
			<script LANGUAJE="JavaScript" src="../js/OnMouse.js"></script>
		</xsl:with-param>
	   </xsl:call-template>

<body>
	<xsl:call-template name="menuComun">
		<xsl:with-param name="NAME" select="concat(DATA/PARAMETROS/USER/@NAME,concat('(',concat(DATA/PARAMETROS/USER/@LOGIN,')')))"/>
		<xsl:with-param name="MENU" select="DATA/MENU"/>
		<xsl:with-param name="SELECT" select="$menu"/>
		<xsl:with-param name="HELP">administracion.xml#1.5</xsl:with-param>
	</xsl:call-template>
<xsl:call-template name="pieComun"/>
	</body>
	</html>
</xsl:template>

<xsl:template name="cuerpo">
	<xsl:variable name="parametros" select="DATA/PARAMETROS[count(/XMLROOT/DATA/PARAMETROS)]"/>
	
		<xsl:for-each select="DATA/PARAMETROS">
		<xsl:if test="not(@ERROR='')">
			<script>mostrarError('<xsl:value-of select="@ERROR"/>')</script>
			</xsl:if>
	</xsl:for-each>

<table align="center" border="0" cellpadding="5" cellspacing="5" width="780" height="16" summary="Esta tabla contiene una lista de Parametros">
	<tr><td width="300" colspan="2" class="cab1">&#187;Listado de parmetros</td></tr>
	<tr><td>
		<table class="cont" border="0" cellpadding="3" cellspacing="1" width="100%">
		<tr>
			<!--Cabecera de la tabla (cuidado con los anchos y con los anchos de los campos dentro del bucle) -->
			<!--<td width="25" align="center"><b><font face="Verdana" size="2">Parmetro<xsl:value-of select="$parametros"/></font></b></td>-->
			<td class="cabe" width="320"><b><font face="Verdana" size="2">Descripcin</font></b></td>
			<td class="cabe" width="60"><b><font face="Verdana" size="2">Valor&#160;Actual</font></b></td>
			<xsl:if test="count(DATA/PARAMETROS/PARAMETRO)=0">
				<tr>
					<td class="administracion" colspan="5" align="center"> No hay parmetros.</td>
				</tr>
			</xsl:if>
			<xsl:for-each select="$parametros/PARAMETRO">
			<tr class="administracion" onmouseover="javascript:onMouse(this,'true');" onmouseout="javascript:onMouse(this,'false');">
				
				<td width="420">
					<xsl:value-of select="@DESCRIPCION"/>
				</td>

				<td width="250">
				<xsl:choose>
					<xsl:when test="(@PARAMETRO = 'PAR_DIR_PLANTILLAS')">			
						<xsl:if test="40>=string-length(@VALOR)">								
							<xsl:value-of select="@VALOR"/>
						</xsl:if>
						<!--SI LA DESCRIPCION TIENE MAS DE 40 CARACTERES-->
						<xsl:if test="string-length(@VALOR)>40">
							<label title="{@VALOR}"><xsl:value-of select="concat(substring(@VALOR,0,40),'...')"/></label>
						</xsl:if>
					</xsl:when>
						<xsl:when test="(@PARAMETRO = 'PAR_CONTROL_AUSENCIAS')or (@PARAMETRO = 'PAR_IND_COSTE')or
									(@PARAMETRO = 'PAR_IND_ICONO')or (@PARAMETRO = 'PAR_IND_COLOR') or
									(@PARAMETRO = 'PAR_IND_TAREAS')">			
						<xsl:if test="@VALOR = 'S'">SI</xsl:if>
						<xsl:if test="@VALOR = 'N'">NO</xsl:if>				
					</xsl:when>
					<xsl:when test="(@PARAMETRO = 'PAR_PRIORIDAD')">
						<xsl:variable name="CodigoPrioridad"><xsl:value-of select="@VALOR"/></xsl:variable>
						<!--Si se introdujo 'sin prioridad' se ejecuta lo siguiente-->
						<xsl:if test="not(@VALOR)">
							<option value="">-Sin prioridad-</option>
						</xsl:if>
						<!--Si no se introdujo 'sin prioridad' se ejecuta lo siguiente-->
						<xsl:for-each select="../PRIORIDADES[@CODIGO=$CodigoPrioridad]">
								<xsl:value-of select="@DESCRIPCION"/>
						</xsl:for-each>					
					</xsl:when>
					<xsl:otherwise><!-- Cuando (@VALOR != 'S') and (@VALOR != 'N')-->
						<xsl:if test="40>=string-length(@VALOR)">								
							<xsl:value-of select="@VALOR"/>
						</xsl:if>
						<!--SI LA DESCRIPCION TIENE MAS DE 40 CARACTERES-->
						<xsl:if test="string-length(@VALOR)>40">
							<label title="{@VALOR}"><xsl:value-of select="concat(substring(@VALOR,0,40),'...')"/></label>
						</xsl:if>
					</xsl:otherwise>
				</xsl:choose>	
				</td>
			</tr>				
			</xsl:for-each>
			<xsl:if test="count($parametros/PARAMETRO)=0">
				<tr>
					<td width="2"><b></b></td>
					<td width="48">No hay Parametros.</td>
				</tr>
			</xsl:if>
		
		<table class="cont" border="0" cellpadding="3" cellspacing="1" style="border-collapse: collapse" width="90%" align="center">	
		<tr>
			<td class="cabe" align="left" colspan="5"><b>Alertas generales</b></td>
		</tr>
		<tr>
			<td class="administracion" align="center" colspan="2"><b>Tipos Tareas</b></td>
			<td class="administracion" align="center" colspan="2"><b>Prioridades</b></td>
			<td class="administracion" align="center"><b>Dias Mximos</b></td>
		</tr>
			
		<tr>
			<td class="administracion" align="center"><b>Cdigo</b></td>
			<td class="administracion" align="center"><b>Descripcin</b></td>
			<td class="administracion" align="center"><b>Cdigo</b></td>
			<td class="administracion" align="center"><b>Descripcin</b></td>
			<td class="administracion" align="center">&#160;</td>
		</tr>
				
		<xsl:for-each select="$parametros/PARAMETROS_MAXIMOS">
			<tr class="administracion" onmouseover="javascript:onMouse(this,'true');" onmouseout="javascript:onMouse(this,'false');">
				<!--Dentro de Parametros maximos no se guarda la descripcion. Para mostrarla, se mapean las prioridades y los tipos tareas-->
				<!--Guardamos los codigos en dos variables para luego poder identificarlas y mostrar su descripcion-->
				<xsl:variable name="CodigoTipoTarea"><xsl:value-of select="@TIPO_TAREA"/></xsl:variable> 
				<xsl:variable name="CodigoPrioridad"><xsl:value-of select="@PRIORIDAD_TAREA"/></xsl:variable>
				<td align="center">
					<input type="hidden" name="tipotareasCod" value="{@TIPO_TAREA}" readonly="true"/>
					<input type="hidden" name="prioridadesCod" value="{@PRIORIDAD_TAREA}" readonly="true"/>
					<xsl:value-of select="@TIPO_TAREA"/>
				</td>
				<xsl:for-each select="../TIPO_TAREA">
						<xsl:if test="(@CODIGO=$CodigoTipoTarea)">
							<td><xsl:value-of select="@DESCRIPCION"/></td>
						</xsl:if>
				</xsl:for-each>
				<td align="center"><xsl:value-of select="@PRIORIDAD_TAREA"/></td>
				<xsl:for-each select="../PRIORIDADES">
						<xsl:if test="(@CODIGO=$CodigoPrioridad)">
							<td><xsl:value-of select="@DESCRIPCION"/></td>
						</xsl:if>
				</xsl:for-each>
				<td align="center"><xsl:value-of select="@DIAS"/></td>
			</tr>
		</xsl:for-each>
				
		<form action="{$servlet}" METHOD="GET" name="index">
		<input type="hidden" name="module" value="dumbo7/administracion/parametros.index.actualizar"/>
		<tr class="administracion"><td colspan="6" align="center">
			<INPUT CLASS="boton" TYPE="submit" VALUE="ModificarParametros" onclick="javascript:index.module.value='dumbo7/administracion/parametros.index.actualizarParam'"/>
			&#160;&#160;<INPUT CLASS="boton" TYPE="submit" VALUE="ModificarParametrosMaximos" onclick="javascript:index.module.value='dumbo7/administracion/parametros.index.actualizarParamMax'"/>
		</td></tr>
		</form>
		</table>
	</tr>
	</table>
	
	</td></tr>
</table>
</xsl:template>

</xsl:stylesheet>
	