<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet version="1.0" 
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:xforms="http://www.w3.org/2002/xforms">
	
<xsl:param name="servlet"/>
<xsl:param name="menu"/>
<xsl:param name="secCod"/>
<xsl:include href="dumbo7/utils/xsl/utils.xsl"/>
	
<xsl:template match="XMLROOT">
<html lang="es">

	<xsl:call-template name="headComun">
	<xsl:with-param name="jscript">
		<script LANGUAJE="JavaScript">
			function mostrarError(error){
				alert(error);
			}
			function onMouse(objeto,valor){
					if(valor == 'true'){objeto.bgColor = '#E2E2E2';}
					else{objeto.bgColor = '#F2F0E3';}
			} 
			
			function ActivarVincular(codigo,long){
				if(codigo == '1'){
					document.listado.aplSecCod[0].disabled=!document.listado.aplSecCod[0].disabled;
					document.listado.aplSecCod.disabled=!document.listado.aplSecCod.disabled;
										
					if(long == '1'){
						document.listado.codSeccion.value=1;
					}
					else{
						document.listado.codSeccion[0].value=1;
					}
				}	
				else{
					document.listado.aplSecCod[codigo-1].disabled=!document.listado.aplSecCod[codigo-1].disabled;
					document.listado.codSeccion[codigo-1].value=1;
				}

			}
			
			function cerrar_aceptar(){
				document.listado.module.value='dumbo7/administracion/secciones.formListarAplicaciones.vincular';
				document.listado.submit();
			}
			
			function cerrar_volver(){
				document.listado.module.value='dumbo7/administracion/secciones.formModificar.cancelar';
				document.listado.submit();
			}
						
		</script>
	
	</xsl:with-param>
</xsl:call-template>


<body>

<xsl:call-template name="menuComun">
	<xsl:with-param name="NAME" select="concat(DATA/SECCIONES/USER/@NAME,concat('(',concat(DATA/SECCIONES/USER/@LOGIN,')')))"/>
	<xsl:with-param name="MENU" select="DATA/MENU"/>
	<xsl:with-param name="SELECT" select="$menu"/>
	<xsl:with-param name="HELP">administracion.xml#1.4.2</xsl:with-param>
</xsl:call-template>

<xsl:call-template name="pieComun"/>
	</body>
	</html>
</xsl:template>

<xsl:template name="cuerpo">
	<xsl:for-each select="DATA/SECCIONES">
		<xsl:if test="not(@ERROR='')">
			<script>mostrarError('<xsl:value-of select="@ERROR"/>')</script>
			</xsl:if>
	</xsl:for-each>
	
	<table align="center" border="0" cellpadding="5" cellspacing="5" width="775" summary="Esta tabla contiene un listado de aplicaciones asociadas ">
	<tr><td width="700" colspan="2" class="cab1">&#187;Aplicaciones asociadas a&#160; 
		<!--For Para poder mostrar la descripcion en la cabecera de la tabal-->
		<xsl:for-each select="DATA/SECCIONES/SECCION">
			<xsl:if test="@CODIGO = $secCod">
				"<xsl:value-of select="@DESCRIPCION"/>" 
			</xsl:if>
		</xsl:for-each>				
		</td></tr>
	<tr><td>
		
		<form action="{$servlet}" METHOD="POST" name="listado">
			<table class="cont" align="center" border="0" cellpadding="3" cellspacing="1" width="90%" summary="Tabla para crear seccion">
				<tr class="cabe">
					<td width="25" colspan="2">
						<input type="hidden" name="module" value="dumbo7/administracion/secciones.formListarAplicaciones.indice"/>
						<b><font face="Verdana" size="2">&#160;</font></b>
					</td>
					<td width="60"><b><font face="Verdana" size="2">Cdigo</font></b></td>
					<td width="500"><b><font face="Verdana" size="2">Descripcin</font></b></td>
					<td width="25"><b><font face="Verdana" size="2">&#160;</font></b></td>
					<td width="25"><b><font face="Verdana" size="2">&#160;</font></b></td>
				</tr>
				<xsl:for-each select="DATA/SECCIONES/APLICACION[@SECCION = $secCod]">
					<xsl:sort select="@CODIGO"/>
						<tr class="administracion" onmouseover="javascript:onMouse(this,'true');" onmouseout="javascript:onMouse(this,'false');">
							<td width="25"><CENTER>
								<input type="hidden" name="aplCod" value="{@CODIGO}" readonly="true"/>
								<xsl:if test="@ESTADO='V'">
									<img  border="0" src="../graficos/iconos/vigente.gif" alt="Vigente"/>
								</xsl:if>
								<xsl:if test="@ESTADO='N'">
									 <img border="0" src="../graficos/iconos/no_vigente.gif" alt="No Vigente"/>
								</xsl:if>
							</CENTER></td>
							<td width="25"><CENTER>
								<xsl:if test="@TIPO_ASIGNACION = 'P'">
									<img border="0" src="../graficos/iconos/balanza.gif" alt="Por Pesos"/>
								</xsl:if>	
								<xsl:if test="@TIPO_ASIGNACION = 'R'">
									<img border="0" src="../graficos/iconos/responsables.gif" alt="Responsable"/>
								</xsl:if>
							</CENTER></td>
							
							<CENTER><td width="60"><xsl:value-of select="@CODIGO"/></td></CENTER>
							<CENTER><td width="500"><xsl:value-of select="@DESCRIPCION"/></td></CENTER>
							<td width="20" >
								<input type="hidden" name="codSeccion" value="0" readonly="true"/>
								<xsl:variable name="index"><xsl:value-of select="position()"/></xsl:variable>
								<xsl:variable name="long"><xsl:value-of select="count(../APLICACION[@SECCION=$secCod])"/></xsl:variable>  
								<CENTER><a href="javascript:ActivarVincular({$index},{$long});"><img border="0" src="../graficos/iconos/modificar.gif" alt="Cambiar asignacin Seccin"/></a></CENTER>
							</td>
							<td width="10">
								<select name="aplSecCod" size="1" disabled="true">
									<xsl:call-template name="muestraSeccion">
										<xsl:with-param name="nodo" select=".."/>
										<!--Debe aparecer seleccionado la seccin a la que ya estamos asignados-->
										<xsl:with-param name="seccion_aplicacion" select="@SECCION"/>
									</xsl:call-template>
								</select>
							</td>
						</tr>
				</xsl:for-each>
				<xsl:if test="count(DATA/SECCIONES/APLICACION[@SECCION=$secCod])= 0">	
						<tr class="administracion"><td colspan="6"><CENTER>*No hay aplicaciones asociadas a esta Seccin</CENTER></td></tr>
				</xsl:if>
				<tr class="administracion" align="center"><td colspan="7">
					<input type="button" class="boton" value="Aceptar" onclick="javascript:cerrar_aceptar()" />&#160;
					<input type="submit" class="boton" value="Volver" onclick="javascript:document.listado.module.value='dumbo7/administracion/secciones.formModificar.cancelar'"/> 
				</td></tr>
		</table>
		</form>
		</td>
		</tr>
		</table>
	<p>&#160;</p>	
</xsl:template>

<!--Plantillas para recorrer las diferentes secciones indexandolas-->
<!--Debe aparecer como seleccionada, la seccion vinculada actualmente a la aplicacion-->
<xsl:template name="muestraSeccion">
<xsl:param name="nodo"/>
<xsl:param name="seccion_aplicacion"/>
    <xsl:for-each select="$nodo/SECCION[@CODIGO=@PADRE]">
        <xsl:sort select="@DESCRIPCION"/>
		<xsl:if test="@ESTADO='V' and @CODIGO!=$seccion_aplicacion">
	        <option value="{@CODIGO}"><xsl:value-of select="@DESCRIPCION"/></option>
		</xsl:if>
		<xsl:if test="@ESTADO='V' and @CODIGO=$seccion_aplicacion">
	        <option value="{@CODIGO}" selected="true"><xsl:value-of select="@DESCRIPCION"/></option>
		</xsl:if>
        <xsl:call-template name="sacaSubSeccion">
            <xsl:with-param name="seccion" select="$nodo"/>
			<xsl:with-param name="seccion_aplicacion" select="$seccion_aplicacion"/>
            <xsl:with-param name="codigo_padre" select="@CODIGO"/>
            <xsl:with-param name="espacio" select="'&#160;&#160;'"/>
        </xsl:call-template>
    </xsl:for-each>
</xsl:template>

<xsl:template name="sacaSubSeccion">
<xsl:param name="seccion_aplicacion"/>
<xsl:param name="seccion"/>
<xsl:param name="codigo_padre"/>
<xsl:param name="espacio"/>
    <xsl:for-each select="$seccion/SECCION[@PADRE=$codigo_padre and @PADRE!=@CODIGO]">
        <xsl:sort select="@DESCRIPCION"/>
		<xsl:if test="@ESTADO='V' and @CODIGO!=$seccion_aplicacion">
	        <option value="{@CODIGO}"><xsl:value-of select="$espacio"/><xsl:value-of select="@DESCRIPCION"/></option>
		</xsl:if>
		<xsl:if test="@ESTADO='V' and @CODIGO=$seccion_aplicacion">
	        <option value="{@CODIGO}" selected="true"><xsl:value-of select="$espacio"/><xsl:value-of select="@DESCRIPCION"/></option>
		</xsl:if>
        <xsl:call-template name="sacaSubSeccion">
            <xsl:with-param name="seccion" select="$seccion"/>
            <xsl:with-param name="codigo_padre" select="@CODIGO"/>
            <xsl:with-param name="espacio" select="concat($espacio,'&#160;&#160;')"/>
        </xsl:call-template>
    </xsl:for-each>
</xsl:template>


</xsl:stylesheet>
	