<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet version="1.0" 
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:xforms="http://www.w3.org/2002/xforms">
	
<xsl:param name="servlet"/>	
<xsl:param name="menu"/>
<xsl:variable name="clase2"/>
<!--"mostrar" es un flag para el filtrado de secciones (muestra 'todos' o muestra solo los vigentes (''))-->
<xsl:param name="mostrar"/>

<xsl:include href="dumbo7/utils/xsl/utils.xsl"/>

<xsl:template match="XMLROOT">


<html lang="es"> 
	<xsl:call-template name="headComun">
	<xsl:with-param name="arbol" select="'Secciones'"/>
		 <xsl:with-param name="jscript">
			<script LANGUAJE="JavaScript">
				function validar(url,des)
				{
					if (confirm("Est seguro de eliminar la Seccin " +des+"?"))
					{
						var mostrar = '<xsl:value-of select="$mostrar"/>'
						url = url.concat("&amp;mostrar=");
						url = url.concat(mostrar);
						window.open(url,"_self");
					}
				}
				function mostrarError(error){
					alert(error);
				}
				function CambiarEstado(url,estado)
				{
					if (confirm("Est seguro de cambiar el estado a " + estado + "?"))
					{
						var mostrar = '<xsl:value-of select="$mostrar"/>'
						url = url.concat("&amp;mostrar=");
						url = url.concat(mostrar);
						window.open(url,"_self");
					}
				}
				function abrirPopup(url)
				{
					newWindow = window.open(url,'_blanck',"height=230,width=450,status=no,toolbar=no,menubar=no,location=no,scrollbars=no");				
					newWindow.moveTo(self.screen.width/4,self.screen.height/4);
				}
				function mostrarTodo(url){
					window.open(url,"_parent");				
				}  
			</script>
			<script LANGUAJE="JavaScript" src="../js/OnMouse.js"></script>
			</xsl:with-param>
	 </xsl:call-template>
<body>

	
	<xsl:call-template name="menuComun">
		<xsl:with-param name="NAME" select="concat(DATA/SECCIONES/USER/@NAME,concat('(',concat(DATA/SECCIONES/USER/@LOGIN,')')))"/>
		<xsl:with-param name="MENU" select="DATA/MENU"/>
		<xsl:with-param name="SELECT" select="$menu"/>
		<xsl:with-param name="HELP">administracion.xml#1.4</xsl:with-param>
	</xsl:call-template>

<xsl:call-template name="pieComun"/>
	</body>
	</html>
</xsl:template>

<xsl:template name="cuerpo">
		<xsl:for-each select="DATA/SECCIONES">
			<xsl:if test="not(@ERROR='')">
				<script>mostrarError('<xsl:value-of select="@ERROR"/>')</script>
				</xsl:if>
		</xsl:for-each>
	
	<table align="center" border="0" cellpadding="5" cellspacing="5" width="780" summary="Esta tabla contiene una lista de secciones">
	<tr>
		<td width="80%" class="cab1">&#187;Listado de secciones</td>
		<xsl:if test="count(DATA/SECCIONES/SECCION[@ESTADO='N'])>0">
			<xsl:if test="$mostrar='todos'">
				<td width="20%" align="center">	
					<a href="{$servlet}?module=dumbo7/administracion/secciones.index">Mostrar Vigentes</a>
				</td>
			</xsl:if>
			<xsl:if test="$mostrar=''">
				<td width="20%" align="center">	
					<a href="JavaScript:mostrarTodo('{$servlet}?module=dumbo7/administracion/secciones.index&amp;mostrar=todos');">Mostrar Todas</a>
				</td>
			</xsl:if>
		</xsl:if>
		<td width="20%" align="center"><a href="{$servlet}?module=dumbo7/administracion/secciones.index.nueva">Insertar Seccin</a></td>
	</tr>
		<tr><td colspan="3">
			<table class="cont" id="secciones" border="0" cellpadding="3" cellspacing="1" style="border-collapse: collapse" width="100%"  summary="Esta tabla contiene una lista de secciones">
			<tr>		
				<SCRIPT>
					<!--Para guardar la descripcin y pasarlo a los javascript de tal forma que se respeten las tildes en los string-->
					var arrayDescripcion = new Array();
				</SCRIPT>
				<!--Cabecera de la tabla (cuidado con los anchos y con los anchos de los campos dentro del bucle) -->
				<td width="20" class="cabe"><b><font face="Verdana" size="2">Est</font></b></td>
				<td width="390" class="cabe"><b><font face="Verdana" size="2">&#160;&#160;&#160;Cdigo/Descripcin</font></b></td>
				<td width="210" class="cabe"><b><font face="Verdana" size="2">Responsable</font></b></td>
				<td colspan="4" class="cabe"></td>	
				<!--Se diferencia entre dos llamadas para as poder ponerle una clase distinta a un elemento
					que tenga hijos (este tendr clase switchcontent )
					y un elemento que no tenga hijos (Este elemento no tendr calse sera '')

					Esto es necesario para un buen funcionamiento del rbol.
				-->
				<!--Filtro que muestra todas las secciones-->
				<xsl:if test="$mostrar='todos'">
					<xsl:for-each select="DATA/SECCIONES/SECCION[(@CODIGO='00') or (@CODIGO=@PADRE)]">
						<xsl:sort select="@DESCRIPCION"/>
						<xsl:variable name="codigo2"><xsl:value-of select="@CODIGO"/></xsl:variable>
						<xsl:choose>
							<xsl:when test="(count(../SECCION[@PADRE = $codigo2 and @CODIGO != $codigo2])>0)">	
								<xsl:call-template name="muestraSeccion">
									<xsl:with-param name="tab" select="concat('arb.',position())"/>
									<xsl:with-param name="tabimg" select="concat('img.arb.',position())"/>
									<xsl:with-param name="code" select="@CODIGO"/>
									<xsl:with-param name="clase" select="'switchcontent'"/>
									<xsl:with-param name="parent" select="@PADRE"/>
									<xsl:with-param name="respon" select="@RESPONSABLE"/>
								</xsl:call-template>					
							</xsl:when>
							<xsl:otherwise>
								<xsl:call-template name="muestraSeccion">
									<xsl:with-param name="tab" select="''"/>
									<xsl:with-param name="tabimg" select="''"/>
									<xsl:with-param name="code" select="@CODIGO"/>
									<xsl:with-param name="clase" select="'switchcontent'"/>
									<xsl:with-param name="parent" select="@PADRE"/>
									<xsl:with-param name="respon" select="@RESPONSABLE"/>
								</xsl:call-template>
							</xsl:otherwise>
						</xsl:choose>
					</xsl:for-each>
				</xsl:if>
				<!--Filtro que muestra todos los informticos vigentes-->
				<xsl:if test="$mostrar=''">
					<xsl:for-each select="DATA/SECCIONES/SECCION[((@CODIGO='00') or (@CODIGO=@PADRE)) and @ESTADO='V']">
						<xsl:sort select="@DESCRIPCION"/>
						<xsl:variable name="codigo2"><xsl:value-of select="@CODIGO"/></xsl:variable>
						<xsl:choose>
							<xsl:when test="(count(../SECCION[@PADRE = $codigo2 and @CODIGO != $codigo2])>0)">	
								<xsl:call-template name="muestraSeccion">
									<xsl:with-param name="tab" select="concat('arb.',position())"/>
									<xsl:with-param name="tabimg" select="concat('img.arb.',position())"/>
									<xsl:with-param name="code" select="@CODIGO"/>
									<xsl:with-param name="clase" select="'switchcontent'"/>
									<xsl:with-param name="parent" select="@PADRE"/>
									<xsl:with-param name="respon" select="@RESPONSABLE"/>
								</xsl:call-template>					
							</xsl:when>
							<xsl:otherwise>
								<xsl:call-template name="muestraSeccion">
									<xsl:with-param name="tab" select="''"/>
									<xsl:with-param name="tabimg" select="''"/>
									<xsl:with-param name="code" select="@CODIGO"/>
									<xsl:with-param name="clase" select="'switchcontent'"/>
									<xsl:with-param name="parent" select="@PADRE"/>
									<xsl:with-param name="respon" select="@RESPONSABLE"/>
								</xsl:call-template>
							</xsl:otherwise>
						</xsl:choose>
					</xsl:for-each>
				</xsl:if>
			
				<xsl:if test="count(DATA/SECCIONES/SECCION)=0">
					<tr class="administracion">
						<td colspan="7" align="center"> No hay Secciones.</td>
					</tr>
				</xsl:if>
			</tr>
		</table></td></tr>
	</table>
	<p>&#160;</p>	
</xsl:template>
<xsl:template name="muestraSeccion">
<xsl:param name="code"/>
<xsl:param name="parent"/>
<xsl:param name="tab"/>
<xsl:param name="tabimg"/>
<xsl:param name="respon"/>
<xsl:param name="clase"/>
		<SCRIPT>
			<!--Se guarda la descripcin para pasarla al javascript de borrar de tal forma que se respeten las tildes en los string-->
			arrayDescripcion['<xsl:value-of select="@CODIGO"/>'] = <xsl:call-template name="entrecomillaDescripcion"><xsl:with-param name="descripcion" select="@DESCRIPCION"/></xsl:call-template>;
		</SCRIPT>
		<xsl:variable name="codigo"><xsl:value-of select="@CODIGO"/></xsl:variable>
		<tr id="{$tab}" bgcolor= "#F2F0E3" onMouseOver="javascript:onMouse(this,'true');" onMouseOut="javascript:onMouse(this,'false');"><xsl:if test="(count(../SECCION[@PADRE = $codigo and @CODIGO != $codigo])>0)"><xsl:attribute name="class"><xsl:value-of select="$clase"/></xsl:attribute></xsl:if>
			<td width="15" align="center">
				<xsl:if test="@ESTADO='V'">
					<img border="0" src="../graficos/iconos/vigente.gif" alt="Vigente"/>
				</xsl:if>
				<xsl:if test="@ESTADO='N'">
					<img border="0" src="../graficos/iconos/no_vigente.gif" alt="No vigente"/>
				</xsl:if>
			</td>
			<!-- JJSM modificamos el calculo del padding-left a longitud del tab - 5 (antes era 4)-->		
			<xsl:variable name="estilo">
				<!--<xsl:value-of select="concat(concat('padding-left:',(string-length($tab)-5) div 4),'cm')"/>-->
				<xsl:value-of select="concat(concat('padding-left:',(string-length(translate($tab,'0123456789',''))-3)* 0.25),'cm')"/>
			</xsl:variable>
			<td style="{$estilo}" width="390">
				
				<!--Compruebo si tiene padre para mostrar la jerarquia-->
				<xsl:if test="(count(../SECCION[@PADRE = $codigo and @CODIGO != $codigo])>0)">		
					<img id="{$tabimg}" class="showstate" border="0" src="../dumbo7/utils/table/minus.gif" onClick="expandcontent(this,'{$tab}');"/>
				</xsl:if>
				<!--Si no tiene hijos, se aade un icono empty-->
				<xsl:if test="(count(../SECCION[@PADRE = $codigo and @CODIGO != $codigo])=0)">		
					<img id="{$tabimg}" border="0" src="../dumbo7/utils/table/empty.gif"/>&#160;
				</xsl:if>
				
				<xsl:value-of select="@CODIGO"/>
				&#160;
				<!--muestra un substring de la descripcin-->								
				<a title="{@DESCRIPCION}" href="{$servlet}?module=dumbo7/administracion/secciones.index.verDetalle&amp;secCod={@CODIGO}">
					<xsl:value-of select="@DESCRIPCION"/>
				</a>	
			</td>
						
			<!--muestra un substring de apellidos,nombre-->
			<td width="210">
				<!--Si el estado es vigente se muestran los datos en color normal-->
				<xsl:for-each select="../INFORMATICO[@CODIGO=$respon]">
					<xsl:if test="@ESTADO = 'V'">
						<!--Recorremos el mapeo de datosPersonales, buscando los datos personales del informtico codInf-->
						<xsl:for-each select="../DATOS_PERSONALES[@IDENTIFICADOR=$respon]">
						<a title="{@APELLIDOS}, {@NOMBRE}" href="javascript:abrirPopup('?module=dumbo7/inicio.detalleUser&amp;user={@IDENTIFICADOR}')">
							<!--<label title="{@APELLIDOS}, {@NOMBRE}">-->
								<!--SI TIENE MENOS DE 25 CARACTERES-->
								<xsl:if test="25>=string-length(concat(@APELLIDOS,concat(', ', @NOMBRE)))">								
									<xsl:value-of select="@APELLIDOS"/>,&#160;<xsl:value-of select="@NOMBRE"/>
								</xsl:if>
								<!--SI TIENE MAS DE 25 CARACTERES-->
								<xsl:if test="string-length(concat(@APELLIDOS,concat(', ', @NOMBRE)))>25">
									<xsl:value-of select="concat(substring( concat(@APELLIDOS,concat(', ', @NOMBRE)),0,25) ,'...')"/>
								</xsl:if>
							<!--</label>-->
						</a>
						</xsl:for-each>
					</xsl:if>
					<!--Si el estado es no vigente se muestran los datos en color rojo-->
					<xsl:if test="@ESTADO = 'N'">
						<!--Recorremos el mapeo de datosPersonales, buscando los datos personales del informtico codInf-->
						<xsl:for-each select="../DATOS_PERSONALES[@IDENTIFICADOR=$respon]">
						<a title="{@APELLIDOS}, {@NOMBRE}" href="javascript:abrirPopup('?module=dumbo7/inicio.detalleUser&amp;user={@IDENTIFICADOR}')">
							<!--<label title="{@APELLIDOS}, {@NOMBRE}">-->
								<!--SI TIENE MENOS DE 25 CARACTERES-->
								<xsl:if test="25>=string-length(concat(@APELLIDOS,concat(', ', @NOMBRE)))">								
									<font color="#999999"><xsl:value-of select="@APELLIDOS"/>,&#160;<xsl:value-of select="@NOMBRE"/></font>
								</xsl:if>
								<!--SI TIENE MAS DE 25 CARACTERES-->
								<xsl:if test="string-length(concat(@APELLIDOS,concat(', ', @NOMBRE)))>25">
									<font color="#999999"><xsl:value-of select="concat(substring( concat(@APELLIDOS,concat(', ', @NOMBRE)),0,25) ,'...')"/></font>
								</xsl:if>
							<!--</label>-->
							</a>
						</xsl:for-each>
					</xsl:if>
				</xsl:for-each>
			</td>
			
			<td width="20"><a href="{$servlet}?module=dumbo7/administracion/secciones.index.listarApli&amp;secCod={@CODIGO}"><img border="0" src="../graficos/iconos/Aplicacion.gif" alt="Aplicaciones"/></a></td>

			<xsl:choose>
					<!--Si tinenes 0 hijos a valido(que es lo mismo que no tener hijos) y (el estado de tu padre es Valido) =>> puedo cambiar MI estado-->
					<xsl:when test="(count(../SECCION[(@ESTADO='V')and (@PADRE=$code)])= 0) and 
									((../SECCION[(@ESTADO='V') and (@CODIGO=$parent)]))">			
							<td width="20"><CENTER>
								<xsl:if test="@ESTADO='V'">
									 <a href="JavaScript:CambiarEstado('{$servlet}?module=dumbo7/administracion/secciones.index.cambiar&amp;secCod={@CODIGO}','NO VIGENTE');"><img border="0" src="../graficos/iconos/CambiarEstadoNV.gif" alt="Cambiar Estado de la Seccin a NO VIGENTE"/></a>
								</xsl:if>
								<xsl:if test="@ESTADO='N'">
									 <a href="JavaScript:CambiarEstado('{$servlet}?module=dumbo7/administracion/secciones.index.cambiar&amp;secCod={@CODIGO}','VIGENTE');"><img border="0" src="../graficos/iconos/CambiarEstadoV.gif" alt="Cambiar Estado de la Seccin a VIGENTE"/></a>
								</xsl:if>
							</CENTER></td>
					</xsl:when>
					<!--Si soy mi propio padre(AUTOREFERENCIA) y tengo 0 hijos a valido(que es lo mismo qu eno tener hijos)=>> puedo cambiar MI estado-->
					<!--El count = 1 significa que como mnimo siempre la condicion de estado = V la cumplo yo(Por la autoreferencia)-->
					<xsl:when test="((count(../SECCION[(@ESTADO='V') and (@PADRE=$code)]) = 1) or (count(../SECCION[(@ESTADO='V') and (@PADRE=$code)]) = 0)) and (../SECCION[(@CODIGO = $code) and (@PADRE=$code)])">			
						 <td width="20"><CENTER>
								<xsl:if test="@ESTADO='V'">
									 <a href="JavaScript:CambiarEstado('{$servlet}?module=dumbo7/administracion/secciones.index.cambiar&amp;secCod={@CODIGO}','NO VIGENTE');"><img border="0" src="../graficos/iconos/CambiarEstadoNV.gif" alt="Cambiar Estado de la Seccin a NO VIGENTE"/></a>
								</xsl:if>
								<xsl:if test="@ESTADO='N'">
									 <a href="JavaScript:CambiarEstado('{$servlet}?module=dumbo7/administracion/secciones.index.cambiar&amp;secCod={@CODIGO}','VIGENTE');"><img border="0" src="../graficos/iconos/CambiarEstadoV.gif" alt="Cambiar Estado de la Seccin a VIGENTE"/></a>
								</xsl:if>
							</CENTER></td>
					</xsl:when>
					
					<xsl:otherwise>
					 <td width="20" >
							<CENTER><img border="0" src="../graficos/iconos/CambiarEstado_off.gif" alt="No se puede cambiar el estado, debido a dependencias con subsecciones."/></CENTER>
					</td>
				</xsl:otherwise>
			</xsl:choose>

			<td width="20" ><CENTER><a href="{$servlet}?module=dumbo7/administracion/secciones.index.modificar&amp;secCod={@CODIGO}"><img border="0" src="../graficos/iconos/modificar.gif" alt="Modificar Seccin"/></a></CENTER></td>
			<!--Se encarga de contar los nodos que no tienes hijos y, si es as, aadirles la etiqueta de eliminar-->
			<xsl:if test="count(../SECCION[(@PADRE=$code) and (@CODIGO!=$code)])=0">
				<!--Solo hay que pasarle al javascript ?module=dumbo7/administracion/secciones.index.eliminar&amp;secCod={@CODIGO}' para que encuentre la URL correcta para borrar-->
				 <td width="20" ><CENTER><a href="javascript:validar('?module=dumbo7/administracion/secciones.index.eliminar&amp;secCod={@CODIGO}',arrayDescripcion['{@CODIGO}']);"><img border="0" src="../graficos/iconos/eliminar.gif" alt="Eliminar Seccin"/></a></CENTER></td>
			</xsl:if>
			
			<xsl:if test="count(../SECCION[(@PADRE=$code) and (@CODIGO!=$code)])!=0">
				<!--Solo hay que pasarle al javascript ?module=dumbo7/administracion/secciones.index.eliminar&amp;secCod={@CODIGO}' para que encuentre la URL correcta para borrar-->
				 <td width="20"><CENTER><img border="0" src="../graficos/iconos/eliminar_off.gif" alt="No se puede eliminar la seccin, debido a dependencias con subsecciones."/></CENTER></td>
			</xsl:if>
					
		</tr>
	<!--Filtro que muestra todas las secciones-->
	<xsl:if test="$mostrar='todos'">
		<xsl:for-each select="../SECCION[(@PADRE=$code) and not(@PADRE=@CODIGO)]">
			<xsl:sort select="@DESCRIPCION"/>
				<xsl:call-template name="muestraSeccion">
					<xsl:with-param name="code" select="@CODIGO"/>
					<xsl:with-param name="parent" select="@PADRE"/>
					<xsl:with-param name="respon" select="@RESPONSABLE"/>
					<xsl:with-param name="clase" select="'switchcontent'"/>
					<xsl:with-param name="tab" select="concat($tab,concat('.',position()))"/>
					<xsl:with-param name="tabimg" select="concat($tabimg,concat('.',position()))"/>
				</xsl:call-template>					
		</xsl:for-each>
	</xsl:if>
	<!--Filtro que muestra las secciones vigentes-->
	<xsl:if test="$mostrar=''">
		<xsl:for-each select="../SECCION[((@PADRE=$code) and not(@PADRE=@CODIGO))and @ESTADO='V']">
			<xsl:sort select="@DESCRIPCION"/>
				<xsl:call-template name="muestraSeccion">
					<xsl:with-param name="code" select="@CODIGO"/>
					<xsl:with-param name="parent" select="@PADRE"/>
					<xsl:with-param name="respon" select="@RESPONSABLE"/>
					<xsl:with-param name="clase" select="'switchcontent'"/>
					<xsl:with-param name="tab" select="concat($tab,concat('.',position()))"/>
					<xsl:with-param name="tabimg" select="concat($tabimg,concat('.',position()))"/>
				</xsl:call-template>					
		</xsl:for-each>
	</xsl:if>
</xsl:template>


</xsl:stylesheet>
	