/*
 * 
 *
 */
package dumbo7.administracion.sistemas;

import dumbo7.utils.*;
import dumbo7.utils.ldap.LDAPUser;
import dumbo7.utils.ldap.LDAPUtil;
import dumbo7.administracion.*;

import org.hibernate.*;

import atica.frameweb.query.*;
import java.sql.*;
import java.util.*;
import java.math.BigDecimal;
import java.math.BigInteger;

import atica.frameweb.xml.XMLUtil;
import atica.frameweb.xml.XMLUtil;
import org.w3c.dom.Document;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.w3c.dom.NamedNodeMap;
import org.w3c.dom.Element;
import java.io.*;


/**
 * @author Universidad de Murcia - ATICA
 *
 */

public class GestorSistemas extends GestorAdministracion {
	
	public GestorSistemas() {}
	
	private String Sistema;
	//Variables necesarias para crear los registros Secciones_Maximos
	protected String [] datos,Maestro;
	//Si se detecto algn error a la hora de crear el sistema, se activa a true y sirve para advertir a los siguientes
	//mtodos para que no sigan creando tablas o secuencias.
	protected boolean error = false;
	//Las listas son necesarias para el mapeo (hace return de estas variables en los metodos get)
	protected List sistemas = null;
	protected List parametros = null;
	protected List prioridades = null;
	protected List tipostareas = null;
	protected List datosPersonales = null;
	protected List perfiles = null;
	protected List plantillas = null;


	public void listaSistemas(Session conn)
	{
		try
		{
			Query q = conn.createQuery(getQuery("AllSistemas"));
			sistemas  = (List)q.list();
			
		}
		catch (Exception ex)
		{
			logger.error(ex.getMessage());user.getDatosMenu().idSelected();
		}
	}
	public void listaUnSistema(Session conn, D7Sistemas sist)
	{
		try
		{
			Query q = conn.createQuery(getQuery("UnSistema"));
			q.setString("sist",sist.getSisCod());
			sistemas  = (List)q.list();
			//Guardamos el sistema para poder usarlo ms adelante
			Sistema = sist.getSisCod();
						
		}
		catch (Exception ex)
		{
			logger.error(ex.getMessage());user.getDatosMenu().idSelected();
		}
	}
	//Lista los datos personales de los usuarios maestros vinculados al sistema
	public void listaMaestrosDatosPersonales(Session conn, D7Sistemas sist)
	{
		try
		{
			Query q = conn.createQuery(getQuery("MaestroDatosPersonales"));
			q.setString("sist",sist.getSisCod());
			datosPersonales  = (List)q.list();
			
		}
		catch (Exception ex)
		{
			logger.error(ex.getMessage());user.getDatosMenu().idSelected();
		}
	}
	
    //Bsqueda a partir de los datos introducidos por setDatos, no devolviendo los que ya son maestros
	public void listaDatosPersonalesSeleccion(Session conn)
	{
		try
		{
			if (datos[0].indexOf("@")>0)
			{
				datosPersonales = new ArrayList();
			    datos[0] = datos[0].substring(0,datos[0].length()-1);
			    Vector v = LDAPUtil.findUsersByMail(datos[0]+"*");
			    Enumeration en = v.elements();
			    while (en.hasMoreElements()) {
			          // Hasta aqu vamos bien, saca los tios del LDAP con correo como el del patrn.
			          LDAPUser ldu = (LDAPUser)en.nextElement();
			          Query q = conn.createQuery(getQuery("DatosPersonalesDNI"));
			          q = q.setString("dat",ldu.getDni());
			          if(!q.list().isEmpty()){
			          	datosPersonales.add(q.list().get(0));
			          }
			    }  
			}
			else
			{
				String patron = datos[0];
				Query q = conn.createQuery(getQuery("DatosPersonales"));
				String nom = patron.substring(0, patron.indexOf("/"));
				String ape = patron.substring(patron.indexOf("/")+1, patron.length());
				q = q.setString("nom","%"+nom+"%");
				q = q.setString("ape","%"+ape+"%");
				datosPersonales  = (List)q.list();
			}
		}
		catch (Exception ex)
		{
			logger.error(ex.getMessage());
		}
	}
	
	//Devuelve los datos personales del informatico, no Maestro, identificado por su DNI (Codigo)
	public void listaDatosPersonalesDNI(Session conn, String Codigo)
	{
		try
		{
			Query q = conn.createQuery(getQuery("DatosPersonalesDNI"));
			q = q.setString("dat",Codigo);
			datosPersonales  = (List)q.list();
		}
		catch (Exception ex)
		{
			logger.error(ex.getMessage());
		}
	}
	
	
	//Mtodo para fijar los apellidos para realizar la bsqueda del informtico
	public void setDatos(String [] datos)
	{
		this.datos = datos;
	}
	
	//Mtodo para fijar el usuario que ser maestro del sistema
	public void setMaestro(String [] Maestro)
	{
		this.Maestro = Maestro;
	}
	
	//Metodos get necesarios para el mapeo
	public List getSistemas() { return sistemas; }
	public List getDatosPersonales() { return datosPersonales; }
	
	public void saveSistema(Session conn, D7Sistemas sist)
	{
		Transaction tx = null;
		try 
		{	
			//Creamos transaccin para poder hacer revert si hubo erro en alg mtodo
			tx = conn.beginTransaction();

				conn.save(sist);
				//Si el sistema es "externo", no se debe crear nada. Es simplemente un enlace
				if(sist.getSisIndInt().equals("I"))
				{
					ParametrosDefecto(conn,sist);
					PrioridadesDefecto(conn,sist);
					TiposTareasDefecto(conn,sist);
					NotificacionesDefecto(conn,sist);
					PerfilesDefecto(conn,sist);
					//No alterar el orden de los siguientes mtodos. (Restriccin de clave ajena)
					creaSeccionInicial(conn,sist);
					grupoCostesInicial(conn,sist);
					creaMaestro(conn,sist);
					crearCategoriasRapidas(conn,sist);
				}
				//aadimos al men
				CreaEntradaAccess(sist);
			tx.commit();
			
			setErrorMessage("El sistema ha sido creado correctamente.");
			sist = null;
		}
		catch (Exception ex)
		{
			System.out.println(ex);
			setErrorMessage("Error al crear sistema. " + ex.toString());
			tx.rollback();  
			error = true;
		}
		
	}
	
	public void crearCategoriasRapidas(Session conn,D7Sistemas sist) throws Exception {
		try {
			D7Categorias cat = new D7Categorias();
			cat.setCatSisCod(sist.getSisCod());
			cat.setCatCod(D7Categorias.CAT_DUMBO_RAPIDO_INC);
			cat.setCatCatCod(D7Categorias.CAT_DUMBO_RAPIDO_INC);
			cat.setCatDescrip("DUMBO RPIDO");
			cat.setCatEstado("N");
			cat.setCatSecCod(D7Secciones.SECCION_INICIAL);
			cat.setCatTipCod(D7TiposTareas.INCIDENCIA);
			conn.save(cat);
			/*cat = new D7Categorias();
			cat.setCatSisCod(sist.getSisCod());
			cat.setCatCod(D7Categorias.CAT_DUMBO_RAPIDO_INC);
			cat.setCatCatCod(D7Categorias.CAT_DUMBO_RAPIDO_INC);
			cat.setCatDescrip("DUMBO RPIDO");
			cat.setCatEstado("N");
			cat.setCatSecCod(D7Secciones.SECCION_INICIAL);
			cat.setCatTipCod(D7TiposTareas.INCIDENCIA);
			conn.save(cat);*/
		} catch (Exception ex) {
			throw new Exception ("Error crear categoras rpidas. " + ex);
		}
	}
	
	//Crea una seccin inicial, ya que hace falta para crear el primer usuario maestro
	public void creaSeccionInicial(Session conn, D7Sistemas sist) throws Exception
	{
		try
		{
			//Creamos la seccion inicial
			D7Secciones seccion= new D7Secciones();
			seccion.setSecCod(D7Secciones.SECCION_INICIAL);
			seccion.setSecDescrip("SECCIN INICIAL");
			seccion.setSecEstado("V");
			seccion.setSecIdRespon(Maestro[0]);
			seccion.setSecSecCod(D7Secciones.SECCION_INICIAL);
			seccion.setSecSisCod(sist.getSisCod());
			conn.save(seccion);
						
			//query que devuelve todas las prioridades que hay creadas
			Query q2 = conn.createQuery(getQuery("AllPrioridades"));
			q2 = q2.setString("sist",user.getDatosMenu().idSelected());
			prioridades  = (List)q2.list();
			
			//query que devuelve los tipos tareas(peticion/incidencia)		
			Query q3 = conn.createQuery(getQuery("TipoTareas"));
			q3 = q3.setString("sist",user.getDatosMenu().idSelected());
			tipostareas  = (List)q3.list();
			
			//Creamos las secciones maximos para incidencia, peticion y para cada prioridad
			D7SeccionesMaximos sm = null;
						
			for(int i=0; i<prioridades.size();i++)
			{
				for (int j=0;j<tipostareas.size();j++)
				{
					sm = new D7SeccionesMaximos();
					sm.setMaxSisCod(sist.getSisCod());
					sm.setMaxSecCod(D7Secciones.SECCION_INICIAL);
					sm.setMaxPriCod(((D7Prioridades)prioridades.get(i)).getPriCod());
					sm.setMaxTipCod(((D7TiposTareas)tipostareas.get(j)).getTipCod());
					sm.setMaxDias(new BigDecimal(1));
										
					//se guarda cuando se crea para luego solo hacer update
					conn.save(sm);
				}
			}
		}
		catch(Exception ex)
		{
			throw new Exception ("Error crear seccin inicial. " + ex);
		}
	}
	//Crea un grupo de costes inicial, ya qye hace falta para crear el primer usuario maestro
	public void grupoCostesInicial(Session conn, D7Sistemas sist) throws Exception
	{
		try
		{
			D7GruposCostes gc = new D7GruposCostes();
			gc.setGcoCod(D7GruposCostes.GRUPO_INICIAL);
			gc.setGcoDescrip("GRUPO COSTES INICIAL");
			gc.setGcoEstado("V");
			gc.setGcoHoras(new BigDecimal(1));
			gc.setGcoCoste(new BigDecimal(1));
			gc.setGcoSisCod(sist.getSisCod());
			conn.save(gc);
		}
		catch(Exception ex)
		{
			throw new Exception ("Error crear grupo de costes inicial.");
		}
		
	}
	//Crea el primer usuario maestro para el nuevo sistema.
	public void creaMaestro(Session conn, D7Sistemas sist) throws Exception
	{
		try
		{
			//Creamos el informtico
			D7Informaticos informatico = new D7Informaticos();
			informatico.setInfCod(Maestro[0]);
			informatico.setInfSisCod(sist.getSisCod());
			informatico.setInfEstado("V");
			informatico.setInfSecCod(D7Secciones.SECCION_INICIAL);
			informatico.setInfGcoCod(D7GruposCostes.GRUPO_INICIAL);
			conn.save(informatico);
			//Creamos el informtico perfil maestro (Cdigo 11) para el informtico
			D7InformaticosPerfiles ip = new D7InformaticosPerfiles();
			ip.setIpeInfCod(Maestro[0]);
			ip.setIpePerCod("01");
			ip.setIpeSisCod(sist.getSisCod());
			conn.save(ip);
			
		}
		catch(Exception ex)
		{
			throw new Exception ("Error crear grupo de costes inicial.");
		}
		
	}
	//Obtiene los perfiles por defecto y crea unos nuevos para el nuevo sistema a partir de ellos
	public void PerfilesDefecto(Session conn, D7Sistemas sist) throws Exception
	{
		try
		{
			//Si obtienen los parmetros
			Query q = conn.createQuery(getQuery("PerfilesDefecto"));
			perfiles  = (List)q.list();
			D7Perfiles per;
			
			//Vamos guardando cada perfil con el cdigo del nuevo sistema
			for(int i=0;i<perfiles.size();i++)
			{
				//El perfil 88 corresponde al superadministrador que administra los sistemas. Slo pertenece a DEF
				if( !((D7Perfiles)perfiles.get(i)).getPerCod().equals("88"))
				{
					per = new D7Perfiles();
					per.setPerSisCod(sist.getSisCod());
					per.setPerEstado(((D7Perfiles)perfiles.get(i)).getPerEstado());
					per.setPerDescrip( ((D7Perfiles)perfiles.get(i)).getPerDescrip());
					per.setPerCod(((D7Perfiles)perfiles.get(i)).getPerCod());
					conn.save(per);
				}
			}
			
		}
		catch(Exception ex)
		{
			throw new Exception ("Error al inicializar perfiles por defecto.");
		}
	}
	//Obtiene los parmetros por defecto, los asocia a un sistema y los guarda en BD
	public void ParametrosDefecto(Session conn, D7Sistemas sist) throws Exception
	{
		try
		{
			//Si obtienen los parmetros
			Query q = conn.createQuery(getQuery("ParametrosDefecto"));
			parametros  = (List)q.list();
			D7Parametros par;
		
			//Vamos guardando cada parmetro con el cdigo del nuevo sistema
			for(int i=0;i<parametros.size();i++)
			{
				par = new D7Parametros();
				par.setParSisCod(sist.getSisCod());
				par.setParParametro(((D7Parametros)parametros.get(i)).getParParametro());
				par.setParDescripcion( ((D7Parametros)parametros.get(i)).getParDescripcion());
				par.setParValor(((D7Parametros)parametros.get(i)).getParValor());
				conn.save(par);
			}

		}
		catch(Exception ex)
		{
			throw new Exception ("Error al inicializar parmetros por defecto.");
		}
	}
	
	//Obtiene las prioridades por defecto, las asocia a un sistema y las guarda en BD
	public void PrioridadesDefecto(Session conn, D7Sistemas sist) throws Exception
	{
		try
		{
			//Si obtienen los parmetros
			Query q = conn.createQuery(getQuery("PrioridadesDefecto"));
			prioridades  = (List)q.list();
			D7Prioridades pri;
		
			//Vamos guardando cada parmetro con el cdigo del nuevo sistema
			for(int i=0;i<prioridades.size();i++)
			{
				pri = new D7Prioridades();
				pri.setPriSisCod(sist.getSisCod());
				pri.setPriCod(((D7Prioridades)prioridades.get(i)).getPriCod());
				pri.setPriDescrip(((D7Prioridades)prioridades.get(i)).getPriDescrip());
								
				conn.save(pri);
			//	conn.flush();
			//	conn.connection().commit();
			}

		}
		catch(Exception ex)
		{
			throw new Exception ("Error al inicializar prioridades por defecto.");
		}
	}
	//Obtiene los TiposTareas por defecto, los asocia a un sistema y los guarda en BD
	public void NotificacionesDefecto(Session conn, D7Sistemas sist) throws Exception
	{
		try
		{
			Query q = conn.createQuery(getQuery("PlantillasDefecto"));
			plantillas  = (List)q.list();
			D7PlantillasNotificaciones pn;
		
			//Vamos guardando cada plantilla con el cdigo del nuevo sistema
			for(int i=0;i<plantillas.size();i++)
			{
				pn = new D7PlantillasNotificaciones();
				pn.setPlnSisCod(sist.getSisCod());
				pn.setPlnNombre(((D7PlantillasNotificaciones)plantillas.get(i)).getPlnNombre());
				pn.setPlnTexto(((D7PlantillasNotificaciones)plantillas.get(i)).getPlnNombre());
								
				conn.save(pn);
			}
			
		}
		catch(Exception ex)
		{
			throw new Exception ("Error al inicializar plantillas por defecto.");
		}
	}
	public void TiposTareasDefecto(Session conn, D7Sistemas sist) throws Exception
	{
		try
		{
			//Si obtienen los parmetros
			Query q = conn.createQuery(getQuery("TiposTareasDefecto"));
			tipostareas  = (List)q.list();
			D7TiposTareas tip;
		
			//Vamos guardando cada parmetro con el cdigo del nuevo sistema
			for(int i=0;i<tipostareas.size();i++)
			{
				tip = new D7TiposTareas();
				tip.setTipSisCod(sist.getSisCod());
				tip.setTipCod(((D7TiposTareas)tipostareas.get(i)).getTipCod());
				tip.setTipDescrip(((D7TiposTareas)tipostareas.get(i)).getTipDescrip());
		
				conn.save(tip);
			//	conn.flush();
			//	conn.connection().commit();
			}

		}
		catch(Exception ex)
		{
			throw new Exception ("Error al inicializar tipos tareas por defecto.");
		}
	}
	
	//Modifica el fichero access.xml de /classes para que aparezca el sistema en el menu (Crea la entrada)
	public void CreaEntradaAccess(D7Sistemas sist) throws Exception
	{
		try
		{
			//Modificacin del fichero user.access.xml para que aparezca el sistema en el men de forma automtica
			//Importante!, los cambios los hace en /classes, no en /src 
			Document doc = XMLUtil.parse(this.getClass().getResource("../../user/access.xml").openStream());
			
			// Creo el Nodo Action
		    Element n = doc.createElement("ACTION");
		    n.setAttribute("NAME",sist.getSisDescrip());
		    // Creo el Nodo Role
		    Element r = doc.createElement("ROLE");
		    r.setAttribute("NAME","USUARIO");
		    // Aado Role a Action
		    n.appendChild(r);
		    // Aado Action a MODULE
		    Node module = XMLUtil.selectSingleNode(doc,"MODULE","PACKAGE","dumbo7/user");
		    module.appendChild(n);
		    //doc.getFirstChild().insertBefore(n,doc.getFirstChild().getFirstChild());
		 
		    //Guardamos el nuevo documento
			FileOutputStream out2 = new FileOutputStream(this.getClass().getResource("../../user/access.xml").getFile());
			XMLUtil.saveDocument(doc,out2);
		}
		catch(Exception ex)
		{
			throw new Exception ("Error al actualizar men. " + ex);
		}
	}
	//Elimina una entrada del fichero access.xml (para eliminar un sistema del menu)
	public void BorraEntradaAccess(D7Sistemas sist) throws Exception
	{
		try
		{
			//Modificacin del fichero user.access.xml para que aparezca el sistema en el men de forma automtica
			//Importante!, los cambios los hace en /classes, no en /src 
			Document doc = XMLUtil.parse(this.getClass().getResource("../../user/access.xml").openStream());
			Element e = doc.getDocumentElement();
			
			//Node module = doc.getFirstChild();
		    Node module = XMLUtil.selectSingleNode(doc,"MODULE","PACKAGE","dumbo7/user");
			
			Node borrar= XMLUtil.selectSingleNode(module,"ACTION","NAME",sist.getSisDescrip());
			module.removeChild(borrar);
			
		    //Guardamos el nuevo documento
			FileOutputStream out2 = new FileOutputStream(this.getClass().getResource("../../user/access.xml").getFile());
			XMLUtil.saveDocument(doc,out2);
		}
		catch(Exception ex)
		{
			throw new Exception ("Error al actualizar men. " + ex);
		}
		
	}
	//Modifica una entrada del fichero access.xml (Modificar un sistema del menu)
	public void ModificarEntradaAccess(D7Sistemas SistemaAntiguo, D7Sistemas SistemaNuevo) throws Exception
	{
		try
		{
			BorraEntradaAccess(SistemaAntiguo);
			CreaEntradaAccess(SistemaNuevo);
		}
		catch(Exception ex)
		{
			throw new Exception ("Error al actualizar men. " + ex);
		}
		
	}
	
	//Llama a procedimiento almacenado en BD que crea las secuencias necesarias para la administracin del sistema
	public void crearSecuencias(Connection conn, D7Sistemas sist)
	{
		PreparedStatement pstmt = null;
		
		//Si el sistema es "interno" se crean secuencias.
		if(!error && sist.getSisIndInt().equals("I"))
		{
			String query1 = "begin DUMBO.SIS.Crea_secuencias(?); end;";
						
			try
			{
				CallableStatement stmt1 = conn.prepareCall(query1);
		
				//Pasamos el sistema
				stmt1.setString(1, sist.getSisCod());
						
				//Ejecutamos la sentencia
				stmt1.execute();
				
			}
			catch(SQLException sqle)
			{
				setErrorMessage("Error al crear secuencias ");
				borrarSecuencias(conn,sist);
			}
		}
	}
	//Mtodo que llama a procedimiento almacenado y elimina las secuencias del sistema
	public void borrarSecuencias(Connection conn, D7Sistemas sist)
	{
		PreparedStatement pstmt = null;
		
		if(!error)
		{
			
			String query1 = "begin DUMBO.SIS.Borra_secuencias(?); end;";
			try
			{
				CallableStatement stmt1 = conn.prepareCall(query1);
						
				//Pasamos el sistema
				stmt1.setString(1, sist.getSisCod());
						
				//Ejecutamos la sentencia
				stmt1.execute();
				
			}
			catch(SQLException sqle)
			{setErrorMessage("Error al borrar secuencias");}
		}
	}
	//Mtodo que llama a procedimiento almacenado y elimina las secuencias del sistema
	public void borrarSistemaCascada(Connection conn, D7Sistemas sist)
	{
		PreparedStatement pstmt = null;
		
		if(!error)
		{
			String query1 = "begin DUMBO.SIS.Borra_sistema(?); end;";
			try
			{
				CallableStatement stmt1 = conn.prepareCall(query1);
						
				//Pasamos el sistema
				stmt1.setString(1, sist.getSisCod());
						
				//Ejecutamos la sentencia
				stmt1.execute();
				stmt1.close();
				
			}
			catch(SQLException sqle)
			{setErrorMessage("Error al borrar sistema");}
		}
	}
	//Borra un sistema en cascada y todas sus secuencias
	public void removeSistema(Connection conn, D7Sistemas sist)
	{
		try
		{
			borrarSistemaCascada(conn,sist);
			borrarSecuencias(conn,sist);
			BorraEntradaAccess(sist);
			setErrorMessage("Sistema eliminado correctamente.");
			sist = null;
		}
		catch(Exception ex)
		{
			error = true;
			setErrorMessage(ex.toString());
		}
	}

	public void updateSistema(Session conn, D7Sistemas sist)
	{
		try
		{
			Query q = conn.createQuery(getQuery("UnSistema"));
			q.setString("sist",sist.getSisCod());
			sistemas  = (List)q.list();
			D7Sistemas sistAntiguo = (D7Sistemas)(sistemas.get(0));
			
			//Modificamos access.xml usando la descripcion antigua y la nueva (si ha cambiado la descripcion)
			if(!sistAntiguo.getSisDescrip().equals(sist.getSisDescrip()))
				ModificarEntradaAccess(sistAntiguo,sist);
			
			sistAntiguo.setSisCod(sist.getSisCod());
			sistAntiguo.setSisAnagrama(sist.getSisAnagrama());
			sistAntiguo.setSisDescrip(sist.getSisDescrip());
			sistAntiguo.setSisIndInt(sist.getSisIndInt());
			sistAntiguo.setSisUrl(sist.getSisUrl());
			
			conn.update(sistAntiguo);
			conn.flush();
			conn.connection().commit();
			
			sistAntiguo = null;
			sistemas = null;
			
			/*setErrorMessage("Sistema modificado correctamente. Si ha modificado la descripcin, compruebe que el fichero dumbo7.user.access.xml contiene la lnea:" +
					"                                                                                                                                                                 " +
					"<ACTION NAME=\""+sist.getSisDescrip()+"\"> <ROLE NAME=\"TODOS\"/> </ACTION>");*/
		}
		catch(Exception e)
		{
			setErrorMessage("Error al crear modificar sistema. Compruebe que los datos introducidos son correctos.");
		}
	}
}
