<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet version="1.0" 
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:xforms="http://www.w3.org/2002/xforms">

<xsl:param name="servlet"/>	
<xsl:param name="menu"/>
<xsl:variable name="seccion"/>
	
<xsl:include href="dumbo7/utils/xsl/utils.xsl"/>
<xsl:template match="XMLROOT">

<html lang="es">
     <xsl:call-template name="headComun">
         <xsl:with-param name="jscript">
			<script>
				function onMouse(objeto,valor)
				{
					if(valor == 'true'){objeto.className = 'administracion2';}
					else{objeto.className = 'administracion';}
				} 
			</script>
			<script LANGUAJE="JavaScript" src="../js/sistemas/PreguntaBorrar.js"/>
         </xsl:with-param>
	   </xsl:call-template>

<body>
	<xsl:call-template name="menuComun">
		<xsl:with-param name="NAME" select="concat(DATA/SISTEMAS/USER/@NAME,concat('(',concat(DATA/SISTEMAS/USER/@LOGIN,')')))"/>
		<xsl:with-param name="MENU" select="DATA/MENU"/>
		<xsl:with-param name="SELECT" select="$menu"/>
		<xsl:with-param name="HELP">administracion.xml#1.9</xsl:with-param>
	</xsl:call-template>
<xsl:call-template name="pieComun"/>
</body>
</html>

</xsl:template>

<xsl:template name="cuerpo">
	<xsl:for-each select="DATA/SISTEMAS">
		<xsl:if test="not(@ERROR='')">
			<script>alert('<xsl:value-of select="@ERROR"/>')</script>
			</xsl:if>
	</xsl:for-each>

<table align="center" border="0" cellpadding="5" cellspacing="5" width="775" height="16" summary="Esta tabla contiene una lista de Sistemas">
	<tr>
		<td width="80%" class="cab1">&#187;Listado de sistemas</td>
		<td align="center" width="20%"><a href="{$servlet}?module=dumbo7/administracion/sistemas.index.nueva">Insertar Sistema</a></td>
		
	</tr>
	<tr><td colspan="2">
	<table class="cont" border="0" cellpadding="3" cellspacing="1" width="100%">
		<tr>		
			<!--Cabecera de la tabla (cuidado con los anchos y con los anchos de los campos dentro del bucle) -->
			<td class="cabe" width="5%"><b><font face="Verdana" size="2">Cdigo</font></b></td>
			<td class="cabe" width="20%"><b><font face="Verdana" size="2">Anagrama</font></b></td>
			<td class="cabe" width="36%"><b><font face="Verdana" size="2">Descripcin</font></b></td>	
			<td class="cabe" width="30%"><b><font face="Verdana" size="2">URL</font></b></td>
			<td class="cabe" colspan="3"></td>
			<SCRIPT>
				<!--Para guardar la descripcin y pasarlo a los javascript de tal forma que se respeten las tildes en los string-->
				var arrayDescripcion = new Array();
			</SCRIPT>	
			
			<xsl:for-each select="DATA/SISTEMAS/SISTEMA">
			<xsl:sort select="@DESCRIPCION"/>
				<tr class="administracion" onmouseover="javascript:onMouse(this,'true');" onmouseout="javascript:onMouse(this,'false');">
					<SCRIPT>
						arrayDescripcion['<xsl:value-of select="@CODIGO"/>'] = <xsl:call-template name="entrecomillaDescripcion"><xsl:with-param name="descripcion" select="@DESCRIPCION"/></xsl:call-template>;
					</SCRIPT>
					<td><xsl:value-of select="@CODIGO"/></td>
					<td><xsl:value-of select="@ANAGRAMA"/></td>
					<td>
						<!--muestra un substring de la descripcin-->
						<a href="{$servlet}?module=dumbo7/administracion/sistemas.index.verDetalle&amp;sisCod={@CODIGO}">
							<xsl:value-of select="@DESCRIPCION"/>
						</a>	
					</td>
					<td>
						<label title="{@URL}">
							<!--SI LA DESCRIPCION TIENE MENOS DE 35 CARACTERES-->
							<xsl:if test="35>=string-length(@URL)">								
								<xsl:value-of select="@URL"/>
							</xsl:if>
							<!--SI LA DESCRIPCION TIENE MAS DE 35 CARACTERES-->
							<xsl:if test="string-length(@URL)>35">
								<xsl:value-of select="concat(substring(@URL,0,35),'...')"/>
							</xsl:if>
						</label>
					</td>
					<td width="3%"><a href="{$servlet}?module=dumbo7/administracion/sistemas.index.listarMaestros&amp;sisCod={@CODIGO}"><img  border="0" src="../graficos/iconos/Informatico.gif" alt="Consultar Maestros"/></a></td>
					<td width="3%"><CENTER><a href="{$servlet}?module=dumbo7/administracion/sistemas.index.modificar&amp;sisCod={@CODIGO}"><img border="0" src="../graficos/iconos/modificar.gif" alt="Modificar Sistema"/></a></CENTER></td>
					<td width="3%"><CENTER><a href="javascript:validar('?module=dumbo7/administracion/sistemas.index.eliminar&amp;sisCod={@CODIGO}&amp;sisDescrip={@DESCRIPCION}',arrayDescripcion['{@CODIGO}']);"><img border="0" src="../graficos/iconos/eliminar.gif" alt="Eliminar Sistema"/></a></CENTER></td>
				</tr>
			</xsl:for-each>
			<xsl:if test="count(DATA/SISTEMAS/SISTEMA)=0">
				<tr>
					<td class="administracion" colspan="7" align="center"> No hay Sistemas.</td>
				</tr>
			</xsl:if>
		</tr>
	</table></td></tr>
</table>
</xsl:template>

</xsl:stylesheet>
	