package dumbo7.administracion.zonas;

import dumbo7.utils.*;
import dumbo7.utils.ldap.LDAPUser;
import dumbo7.utils.ldap.LDAPUtil;
import dumbo7.administracion.*;
import org.hibernate.*;

import atica.frameweb.utils.GeneralManager;

import java.util.*;
import java.sql.*;
import java.math.BigDecimal;


public class GestorZonas extends GestorAdministracion {

	//	Si se detecto algn error a la hora de crear el sistema, se activa a true y sirve para advertir a los siguientes
	//mtodos para que no sigan creando tablas o secuencias.
	protected boolean error = false;
	
	protected List zonas = null; 
	protected List zonasEdificios = null;
	protected List espacios = null;
	protected List edificios = null;
	protected List zonasInformaticos = null;
	protected List informaticos = null;
	protected List datosPersonales = null;
	protected List zonasReales = null;
	
	private D7Zonas zona = null;
	private String [] datos = null;//Datos usados por ListaDatosPersonalesSeleccion
	private String [] informZona = null;//contiene los informticos de la nueva zona.
	//private String [] responsables = null;
	private String [] edifZona = null;//contiene los edificios de la nueva zona.
	private String prio = null;
	private String responflag = null;
	private Integer zon = null;
	
	private Integer CodigoZona = null;
	
	public GestorZonas() {}

	/**METODOS DE LISTA PARA EL MAPEO*/
	//Devuelve todos los datos personales de todos los informticos (no tiene en cuenta sistema)
	public void listaDatosPersonales(Session conn)
	{
		try
		{
			Query q = conn.createQuery(getQuery("AllDatosPersonales"));
			q = q.setString("sist",user.getDatosMenu().idSelected());
			datosPersonales  = (List)q.list();
		}
		catch (Exception ex)
		{
			setErrorMessage("Error al listar datos personales.");
		}
	}
	//Bsqueda a partir de los datos introducidos por setDatos
	public void listaDatosPersonalesApellidos(Session conn)
	{
		Query q = null;
		try
		{
			if (datos[0].indexOf("@")>0)
			{
				datosPersonales = new ArrayList();
			    datos[0] = datos[0].substring(0,datos[0].length()-1);
			    Vector v = LDAPUtil.findUsersByMail(datos[0]+"*");
			    Enumeration en = v.elements();
			    while (en.hasMoreElements()) {
			          // Hasta aqu vamos bien, saca los tios del LDAP con correo como el del patrn.
			          LDAPUser ldu = (LDAPUser)en.nextElement();
			          q = conn.createQuery(getQuery("DatosPersonalesDNI"));
			          q = q.setString("sist",user.getDatosMenu().idSelected());
			          q = q.setString("dat",ldu.getDni());
			          if(!q.list().isEmpty()){
			          	datosPersonales.add(q.list().get(0));
			          }
			    }  
			}
			else
			{
				String patron = datos[0];
				q = conn.createQuery(getQuery("DatosPersonalesApellidos"));
				String nom = patron.substring(0, patron.indexOf("/"));
				String ape = patron.substring(patron.indexOf("/")+1, patron.length());
				q = q.setString("ape","%"+ape+"%");
				q = q.setString("nom","%"+nom+"%");
				q = q.setString("sist",user.getDatosMenu().idSelected());
				datosPersonales  = (List)q.list();
			}	
		}
		catch (Exception ex)
		{
			setErrorMessage("Error al listar datos personales.");
		}
	}
	
//	Devuelve los datos personales de un informtico dado su identificador (codigo)
	public void listaDatosPersonalesDNI(Session conn, String Codigo)
	{
		Query q = null;
		try
		{
			q = conn.createQuery(getQuery("DatosPersonalesDNI"));
			q = q.setString("dat",Codigo);
			q = q.setString("sist",user.getDatosMenu().idSelected());
			datosPersonales  = (List)q.list();
			if(datosPersonales.isEmpty()){setErrorMessage(user.traduce("dumbo7/administracion/zonas","Informtico",user.getDatosMenu().idSelected()) + " incorrecto o ya Asignado");}
		}
		catch (Exception ex)
		{
			setErrorMessage("Error al listar datos personales.");
		}
	}
	
//	Prioridad del informatico modificado (modificar responsables)
	public void setPrioridad(String prio)
	{
		this.prio = prio;	
	}
	
//	Indicador de si el informatico a modificar es responsable (modificar responsables)
	public void setResponFlag(String responflag)
	{
		this.responflag = responflag; 
		
	}
	
	public void listaZonas(Session conn){
		try{
			Query q = conn.createQuery(getQuery("AllZonas"));
			q = q.setString("sist",user.getDatosMenu().idSelected());
			zonas  = (List)q.list();
		
		}
		catch (Exception ex)
		{
			System.out.println("2"+ex);
			setErrorMessage("Error al listar zonas.");
		}
	}
	
	public void listaZonasReales(Session conn){
		PreparedStatement pstmt = null;
		ResultSet rs = null;
		String myQuery = null;
		zonasReales = new ArrayList();
		try{
			myQuery = getQuery("AllZonasReales");
			pstmt = conn.connection().prepareStatement(myQuery);
			rs = pstmt.executeQuery();
			while (rs.next()) {
				zonasReales.add(new Zona(rs.getString(1),rs.getString(2)));
			}
		}
		catch (Exception ex)
		{
			System.out.println("2"+ex);
			setErrorMessage("Error al listar zonas reales.");
		} finally {
			try {
				if (rs!=null) rs.close();
				if (pstmt!=null) pstmt.close();
			} catch (Exception exx) {}
		}
	}
	
	public void listaEspacios(Session conn){
		PreparedStatement pstmt = null;
		ResultSet rs = null;
		String myQuery = null;
		espacios = new ArrayList();
		try{
			myQuery = getQuery("AllEspacios");
			pstmt = conn.connection().prepareStatement(myQuery);
			rs = pstmt.executeQuery();
			while (rs.next()) {
				espacios.add(new Espacio(rs.getString(1),rs.getString(2)));
			}
			
		}
		catch (Exception ex)
		{
			System.out.println("2"+ex);
			setErrorMessage("Error al listar espacios.");
		} finally {
			try {
				if (rs!=null) rs.close();
				if (pstmt!=null) pstmt.close();
			} catch (Exception exx) {}
		}
	}
	
	public void QueryZonas(Session conn,D7Zonas zon){
		try {
			Query q = conn.createQuery(getQuery("Zonas"));
			q = q.setString("sist",user.getDatosMenu().idSelected());
			q = q.setString("cod",zon.getZonCodigo().toString());
			zonas  = (List)q.list();
			
		}
		catch (Exception ex)
		{
			setErrorMessage("Error al listar zona.");
		}
	}
	
	public void listaInformaticos(Session conn)
	{
		try
		{	
			Query q = conn.createQuery(getQuery("AllInformaticos"));
			q = q.setString("sist",user.getDatosMenu().idSelected());
			informaticos  = (List)q.list();
		
		}
		catch (Exception ex)
		{
			setErrorMessage("Error al listar " + user.traduce("dumbo7/administracion/zonas","informtico",user.getDatosMenu().idSelected()) + ".");
		}
	}
	
	public void listaEdificios(Session conn)
	{
		try
		{
			Query q = conn.createQuery(getQuery("AllEdificios"));
			q = q.setString("sist",user.getDatosMenu().idSelected());
			edificios  = (List)q.list();
		
		}
		catch (Exception ex)
		{
			setErrorMessage("Error al listar edificios.");
		}
	}
	
	public void QueryZonasInformaticos(Session conn,D7Zonas zon)
	{
		Query q = null;
		try {
			q = conn.createQuery(getQuery("ZonasInformaticos"));
			q = q.setString("sist",user.getDatosMenu().idSelected());
			q = q.setString("cod",zon.getZonCodigo().toString());
			zonasInformaticos = (List)q.list();
			CodigoZona = zon.getZonCodigo();
			
		}
		catch (Exception ex)
		{
			setErrorMessage("Error al obtener zonas informticos.");
		}
	}
	
	public void QueryZonasEdificios(Session conn,D7Zonas zon)
	{
		Query q = null;
		try {
			q = conn.createQuery(getQuery("ZonasEdificios"));
			q = q.setString("sist",user.getDatosMenu().idSelected());
			q = q.setString("cod",zon.getZonCodigo().toString());
			
			zonasEdificios  = (List)q.list();
			CodigoZona = zon.getZonCodigo();
		}
		catch (Exception ex)
		{
			setErrorMessage("Error al obtener zonas edificios.");
		}
	}
	
	public void QueryEspaciosZona(Session conn,String code)
	{
		PreparedStatement pstmt = null;
		ResultSet rs = null;
		String myQuery = null;
		espacios = new ArrayList();
		try{
			myQuery = getQuery("EspaciosZona");
			pstmt = conn.connection().prepareStatement(myQuery);
			pstmt.setString(1,code);
			rs = pstmt.executeQuery();
			while (rs.next()) {
				espacios.add(new Espacio(rs.getString(1),rs.getString(2)));
			}
			
		}
		catch (Exception ex)
		{
			System.out.println("2"+ex);
			setErrorMessage("Error al listar espacios.");
		} finally {
			try {
				if (rs!=null) rs.close();
				if (pstmt!=null) pstmt.close();
			} catch (Exception exx) {}
		}
	}
	
	public void QueryUnaZonaInformaticos(Session conn,D7Zonas zon)
	{
		try {
			Query q = conn.createQuery(getQuery("UnaZonaInformaticos"));
			q = q.setString("sist",user.getDatosMenu().idSelected());
			q = q.setString("cod",zon.getZonCodigo().toString());
			informaticos  = (List)q.list();
			
		}
		catch (Exception ex)
		{
			setErrorMessage("Error al obtener zona");
		}
	}
	public void QueryDatosPersonalesZona(Session conn,D7Zonas zon)
	{
		try {
			Query q = conn.createQuery(getQuery("DatosPersonalesZona"));
			q = q.setString("sist",user.getDatosMenu().idSelected());
			q = q.setString("cod",zon.getZonCodigo().toString());
			datosPersonales  = (List)q.list();
			
		}
		catch (Exception ex)
		{
			setErrorMessage("Error al obtener informticos asociados a la zona.");
		}
	}	

	public void buscaNombreEspacios(Session conn, String code){
		PreparedStatement pstmt = null;
		ResultSet rs = null;
		String myQuery = null;
		try{
			this.listaEdificios(conn);
			
		}
		catch (Exception ex)
		{
			System.out.println("2"+ex);
			setErrorMessage("Error al listar espacios.");
		} finally {
			try {
				if (rs!=null) rs.close();
				if (pstmt!=null) pstmt.close();
			} catch (Exception exx) {}
		}
	}
	
	/**METODOS GET*/
	public List getZonas() {return zonas;}
	public List getZonasInformaticos(){return zonasInformaticos;}
	public List getZonasEdificios(){return zonasEdificios;}
	public List getInformaticos(){return informaticos;}
	public List getEspacios(){return espacios;}
	public List getDatosPersonales() { return datosPersonales; }
	public List getZonasReales(){return zonasReales;}
	
//	Mtodo para fijar los apellidos para realizar la bsqueda del informtico
	public void setDatos(String [] datos)
	{
		this.datos = datos;
	}
	
//	Mtodo para fijar los espacios 
	public void setEspacios(List espacios)
	{
		this.espacios = espacios;
	}
	
//	Mtodo para pasar un array con los informaticos de la nueva zona
	public void setInformaticos(String [] informZona)
	{
		this.informZona = informZona;
	}
	
//	Mtodo para pasar un array con los informaticos de la nueva zona
	/*public void setResponsables(String [] responsables)
	{
		this.responsables = responsables;
	}*/
	
//	Mtodo para pasar un array con los edificios de la nueva zona
	public void setEdificios(String [] edifZona)
	{
		this.edifZona = edifZona;
	}
	
	public void setZona(Integer zon)
	{
		this.zon = zon;
	}
	
	/**CREAS LAS SECUENCIAS DE LOS ARRAYS Y DA DE ALTA LA ZONA*/
	public void saveZona(Session conn,D7Zonas zon) {
		zon.setZonSisCod(user.getDatosMenu().idSelected());		
		CodigoZona= zon.getZonCodigo();
		zona = zon;
		D7ZonasInformaticos zi= null;
		D7ZonasEdificios ze= null;
		Transaction tx = null;
		
		try
		{
			//Creamos transaccin para poder hacer revert si hubo erro en alg mtodo
			tx = conn.beginTransaction();
				conn.save(zona);
				if ((informZona.length > 0) && (!informZona[0].equals("-1"))){
					for(int i=0; i<informZona.length;i++)
					{
						String [] elem=informZona[i].split("-");
						
						zi = new D7ZonasInformaticos();
						zi.setZoninfSisCod(user.getDatosMenu().idSelected());
						zi.setZoninfZonCodigo(CodigoZona);
						zi.setZoninfInfCod(elem[0]);
						if (elem[1].trim().equals("No")) {
							zi.setZoninfPrioridad(null);
							zi.setZoninfResponsable("N");
						}
						else{
							Integer pri = new Integer(elem[2]);
							zi.setZoninfPrioridad(pri);
							zi.setZoninfResponsable("Y");
						}
						saveInformaticoZona(conn,zi);
					}
				}
				if ((edifZona.length > 0) && (!edifZona[0].equals("-1"))){
					for(int i=0; i<edifZona.length;i++)
					{
						ze = new D7ZonasEdificios();
						ze.setZonedSisCod(user.getDatosMenu().idSelected());
						ze.setZonedZonCodigo(CodigoZona);
						ze.setZonedEdCodigo(edifZona[i]);
					
						saveEdificioZona(conn,ze);
					}
				}
			tx.commit();
			
			zona = null;
			setErrorMessage("La zona ha sido creada correctamente.");
		}
		catch (Exception ex)
		{
			tx.rollback();
			setErrorMessage(ex.toString());
		}
	}
	
	/**MODIFICACION DE ZONAS*/
	public void updateZona(Session conn, D7Zonas zon)
	{
		CodigoZona = zon.getZonCodigo();
		zon.setZonSisCod(user.getDatosMenu().idSelected());
		
		conn.update(zon);
		conn.flush();
		
		setErrorMessage("La zona ha sido modificada correctamente.");	
	}
	
	/** BAJA DE ZONAS */
	public void removeZona(Session conn, D7Zonas zon) {
		this.QueryZonas(conn, zon);
		try {
			// Comprobamos si hay INFORMTICOS asociados y en caso de ser as los borramos
			this.QueryZonasInformaticos(conn, zon);
			if (!zonasInformaticos.isEmpty()) {
			//if (zonasInformaticos!=null){
				Iterator it = zonasInformaticos.iterator();
				while (it.hasNext()) {
					conn.delete((D7ZonasInformaticos) it.next());
					conn.flush();
					conn.connection().commit();
				}
			}
			// Comprobamos si hay EDIFICIOS asociados y en caso de ser as los borramos
			this.QueryZonasEdificios(conn, zon);
			if (!zonasEdificios.isEmpty()) {
				Iterator it = zonasEdificios.iterator();
				while (it.hasNext()) {
					conn.delete((D7ZonasEdificios) it.next());
					conn.flush();
					conn.connection().commit();
				}
			}

			zona = (D7Zonas) zonas.get(0);// Si hemos recargado la pagina despues de haber borrado salta excepcion nullpointer
			conn.delete(zona);
			conn.flush();
			conn.connection().commit();

			zonas.remove(zona);

			setErrorMessage("La zona ha sido eliminada correctamente.");

		} catch (IndexOutOfBoundsException nex) {
			setErrorMessage("No se puede eliminar una zona que no existe (ERROR al Recargar)");
		} catch (Exception ex) {
			zonas.remove(zona);
			setErrorMessage("exception: " + ex);
		}
	}
	
	
	/** ASIGNACION DE INFORMTICO A ZONA (AL CREAR LA ZONA) */
	public void saveInformaticoZona(Session conn, D7ZonasInformaticos infZon) throws Exception
	{
		
		infZon.setZoninfSisCod(user.getDatosMenu().idSelected());
		if (infZon.getZoninfZonCodigo() == null)
		{
			infZon.setZoninfZonCodigo(CodigoZona);
			infZon.setZoninfPrioridad(infZon.getZoninfPrioridad());
			infZon.setZoninfResponsable(infZon.getZoninfResponsable());
		}
		try
		{
			conn.save(infZon);
			infZon = null;
		}
		catch (Exception ex)
		{
			throw new Exception("Error al asociar informticos: "+ ex);
		}
	}
	
	/** PARA AADIR INFORMTICOS TRAS CREAR LA ZONA */
	// Vincula un informatico a una zona
	public void updateInformaticoZona(Session conn, D7ZonasInformaticos infZon) throws Exception{
				
		CodigoZona= infZon.getZoninfZonCodigo();
		D7ZonasInformaticos zi= null;
		Transaction tx = null;
		
		try
		{
			//Creamos transaccin para poder hacer revert si hubo error en algn mtodo
			tx = conn.beginTransaction();
			
			zi = new D7ZonasInformaticos();
			zi.setZoninfSisCod(user.getDatosMenu().idSelected());
			zi.setZoninfZonCodigo(CodigoZona);
			zi.setZoninfInfCod(infZon.getZoninfInfCod());
			zi.setZoninfPrioridad(infZon.getZoninfPrioridad());
			zi.setZoninfResponsable(infZon.getZoninfResponsable());
					
			saveInformaticoZona(conn,zi);
			
			tx.commit();
			setErrorMessage("El informaticos se ha asociado correctamente.");
		}
		catch (Exception ex)
		{
			tx.rollback();
			setErrorMessage(ex.toString());
		}
	}
		 
	/** ELIMINACIN DE UNA ASOCIACION INFORMTICOS-ZONA */
	public void removeInformaticoZona(Session conn, D7ZonasInformaticos infZon){
		infZon.setZoninfSisCod(user.getDatosMenu().idSelected());
		
		try
		{
			conn.delete(infZon);
			conn.flush();
			conn.connection().commit();
			infZon =null;
		}
		catch (Exception ex)
		{
			setErrorMessage("No se pudo eliminar el informatico de la zona");
		}
	}
	
	/** ASIGNACION DE EDIFICIOS A ZONA (AL CREAR LA ZONA) */
	public void saveEdificioZona(Session conn, D7ZonasEdificios edifZon) throws Exception
	{	
		edifZon.setZonedSisCod(user.getDatosMenu().idSelected());
		if (edifZon.getZonedZonCodigo() == null)
		{
			edifZon.setZonedZonCodigo(CodigoZona);
		}
		try
		{
			conn.save(edifZon);
			edifZon = null;
		}
		catch (Exception ex)
		{
			throw new Exception("Error al asociar edificios: "+ ex);
		}
	}
	
	/** PARA AADIR EDIFICIOS TRAS CREAR LA ZONA */
	public void updateEdificioZona(Session conn, D7ZonasEdificios edifZon) {
		
		CodigoZona= edifZon.getZonedZonCodigo();
		D7ZonasEdificios ze= null;
		Transaction tx = null;
		
		try
		{
			if ((edifZona.length > 0) && (!edifZona[0].equals("-1"))){
			//Creamos transaccin para poder hacer revert si hubo error en algn mtodo
			tx = conn.beginTransaction();
			
				for(int i=0; i<edifZona.length;i++)
				{
					ze = new D7ZonasEdificios();
					ze.setZonedSisCod(user.getDatosMenu().idSelected());
					ze.setZonedZonCodigo(CodigoZona);
					ze.setZonedEdCodigo(edifZona[i]);
					
					saveEdificioZona(conn,ze);
				}
			tx.commit();
			setErrorMessage("Los edificios se han asociado correctamente.");
			}
		}
		catch (Exception ex)
		{
			tx.rollback();
			setErrorMessage(ex.toString());
		}
	}
		 
	/** ELIMINACIN DE UNA ASOCIACION EDIFICIO-ZONA */
	public void removeEdificioZona(Session conn, D7ZonasEdificios edifZon){
		edifZon.setZonedSisCod(user.getDatosMenu().idSelected());
		
		try
		{
			conn.delete(edifZon);
			conn.flush();
			conn.connection().commit();
			edifZon =null;
		}
		catch (Exception ex)
		{
			setErrorMessage("No se pudo eliminar el edificio de la zona");
		}
	}
	
//	Modifica un informatico vinculado a una aplicacion
	public void modificarResponsable(Session conn, String Codigo)
	{
		D7ZonasInformaticos zi= new D7ZonasInformaticos();
		try
		{
			zi.setZoninfSisCod(user.getDatosMenu().idSelected());
			zi.setZoninfZonCodigo(zon);
			zi.setZoninfInfCod(Codigo);
			
			if(prio.length()==0){ zi.setZoninfPrioridad(null);
			}else{zi.setZoninfPrioridad(new Integer(prio));}
			
			zi.setZoninfResponsable(responflag);
					
			conn.update(zi);
			conn.flush();
			conn.connection().commit();
			setErrorMessage("El informaticos se ha modificado correctamente.");
		}
		catch (Exception ex)
		{
			setErrorMessage("No se pudo modificar el responsable");
			System.out.println(ex);
		}
	}
}