<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet version="1.0" 
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:xforms="http://www.w3.org/2002/xforms">

<xsl:param name="servlet"/>	
<xsl:param name="menu"/>
<xsl:param name="zonCodigo"/>

<xsl:include href="dumbo7/utils/xsl/utils.xsl"/>
	
<xsl:template match="XMLROOT">

<html lang="es">
     <xsl:call-template name="headComun">
         <xsl:with-param name="jscript">
         	<SCRIPT LANGUAGE="JavaScript" SRC="/forja/jquery/jquery.js"></SCRIPT>
            <SCRIPT LANGUAGE="JavaScript">
            	$(document).ready(function(){
            		$("div#edificios").load("<xsl:value-of select="$servlet"/>",{module:"dumbo7/administracion/zonas.datosEdificio", code:document.zon.ZonaCod.options[0].value});		
            		$("select[@name=ZonaCod]").change(function(){
						codigo = $(this).val(); 
						$("div#edificios").load("<xsl:value-of select="$servlet"/>",{module:"dumbo7/administracion/zonas.datosEdificio", code:codigo});		
					});
				});
				
             	function abre(url){
					window.location.href=url;		
				}
				function cerrar(){
					document.zon.module.value='dumbo7/administracion/zonas.formZonasEdificios.cancelar'; 
					document.zon.submit();
				}
				function EliminarEdificio(url){
					if (confirm("Est seguro de que desea eliminar el edificio?")){
						abre(url);
					}
				}
				function cerrar_aceptar(){		
					document.zon.module.value='dumbo7/administracion/zonas.formZonasEdificios.aceptar'; 
					
					//Recorremos todo el registro y los seleccionamos todos antes de mandarlo con el submit
					for (var i=0; i&lt;document.zon.edificiosZona2.length; i++){
					 	document.zon.edificiosZona2.options[i].selected=true;
					}
					
					document.zon.submit();
				} 
				
				var DatosIncorrectos = false;
				function buscaEd(ed)
				{
					for (var j = 0; j &lt;= Codigos.length-1;j++) {
						if (Codigos[j]==ed) DatosIncorrectos = true;
					}
				}
				
				var indice=0;
				function addEd()
				{
					var fromList = document.zon.edificiosZona;
					if (fromList.selectedIndex&lt;0) { alert('Seleccione un edificio.'); return; }
					
					for ( i = 0; i &lt;= fromList.length-1;i++) {
    					if (fromList.options[i].selected) {
    						var txt = fromList.options[i].text;
    						var sel = fromList.options[i].value;
    						var lon=document.zon.edificiosZona2.length;
    						fromList.options[i].selected=false;
    						for(var j=0; j&lt;lon; j++){
								if(document.zon.edificiosZona2.options[j].value==sel){ 
									alert('El edificio ya est aadido.');
									return;
								}
							}
							buscaEd(sel);
							if(DatosIncorrectos==true){ 
								alert('El edificio '+txt+' ya est aadido.');
								DatosIncorrectos = false;
								return;
							}
							if (lon==1){
								if (document.zon.edificiosZona2.options[0].value=='-1')	lon=0;
							} 
							document.zon.edificiosZona2.options[lon] = new Option( txt, sel);
							indice++;
						}
					}
				}
				
				function delEd(obj)
				{
					var insel = obj.selectedIndex;
					if (insel&lt;0) { alert('Seleccione un edificio para borrar.'); return; }
					var sel = obj.options[insel].value;
					if (sel=='-1') { alert('No hay edificios para eliminar.'); return; }
					while (insel>=0)
					{
						delUnEd(obj);
						insel = obj.selectedIndex;
					}
				}
								
				function delUnEd(obj)
				{
					var insel = obj.selectedIndex;
					if (indice==1)
					{
						var opt = new Option('&lt;-- Aada aqu los edificios -->');
						opt.value = '-1';
						obj.options[0] = opt;
						obj.length = indice;
						indice = 0;
					}
					else
					{
						for (var i=insel; i&lt;indice-1; i++)
						{
							var incremento = i + 1;
							var txt2 = obj.options[incremento].text;
							var sel2 = obj.options[incremento].value;
							var opt = new Option(txt2);
							opt.value = sel2;
							opt.selected = obj.options[i+1].selected;
							obj.options[i] = opt;
						}
						obj.length = indice-1;
						indice = obj.length;
					}
				}
			
				
            </SCRIPT>
			<script LANGUAJE="JavaScript" src="../js/OnMouse.js"></script>
         </xsl:with-param>
	   </xsl:call-template>
<body>
		
	<xsl:call-template name="menuComun">
		<xsl:with-param name="NAME" select="concat(DATA/ZONAS/USER/@NAME,concat('(',concat(DATA/ZONAS/USER/@LOGIN,')')))"/>
		<xsl:with-param name="MENU" select="DATA/MENU"/>
		<xsl:with-param name="SELECT" select="$menu"/>
		<xsl:with-param name="HELP">administracion.xml#1.10.4</xsl:with-param>
	</xsl:call-template>

<xsl:call-template name="pieComun"/>
</body>
</html>

</xsl:template>

<xsl:template name="cuerpo">
<xsl:if test="not(DATA/ZONAS/@ERROR='')">
	<script>mostrarError('<xsl:value-of select="@ERROR"/>')</script>
</xsl:if>

<table align="center" border="0" cellpadding="5" cellspacing="5" width="775" summary="Asignacin de Edificios a Zonas">
<tr><td width="700" colspan="2" class="cab1">&#187;Vincular edificios a
	<!--For Para poder mostrar la zona en la cabecera de la tabla-->
		<xsl:for-each select="DATA/ZONAS/ZONAS">
			<xsl:if test="@CODIGO = $zonCodigo">
				"<xsl:value-of select="@DESCRIPCION"/>"
			</xsl:if>
		</xsl:for-each></td></tr>
<tr><td colspan="2">
	<form action="{$servlet}" METHOD="POST" name="zon">
	<input type="hidden" name="zonedZonCodigo" value="{$zonCodigo}"/>
	<input type="hidden" name="zonedEdCodigo"/>
	<input type="hidden" name="zonCodigo" value="{$zonCodigo}"/>
	<input type="hidden" name="module"/>
	<input type="hidden" name="cod"/>
	<table class="cont" border="0" cellpadding="3" cellspacing="1" width="100%" summary="Asignacin de Edificios a Zonas">
		<tr>
			<td class="cabe" width="20%"><b><font face="Verdana" size="2">Id</font></b></td>
			<td class="cabe" width="70%"><b><font face="Verdana" size="2">Descripcin</font></b></td>
			<td class="cabe" width="10%" align="center" colspan="2"></td>
		</tr>
		<SCRIPT>
			var Codigos = new Array();
			var k=0;
		</SCRIPT>	
		<xsl:for-each select="DATA/ZONAS/ZONAS_EDIFICIOS">
			<xsl:sort select="@EDIFICIO"/>
			<tr class="administracion" onmouseover="javascript:onMouse(this,'true');" onmouseout="javascript:onMouse(this,'false');">
				<xsl:variable name="codEd"><xsl:value-of select="@EDIFICIO"/></xsl:variable> 
				<xsl:for-each select="../ESPACIOS[@CODIGO=$codEd]">
					<SCRIPT>
						Codigos[k] = "<xsl:value-of select="@CODIGO"/>";
						k++;
					</SCRIPT>
					<xsl:variable name="zonedEdCodigo"><xsl:value-of select="@CODIGO"/></xsl:variable> 
					<td width="30"><xsl:value-of select="@CODIGO"/></td>
					<td width="200"><xsl:value-of select="@NOMBRE"/></td>
					<td width="3%" height="16"><a href="javascript:EliminarEdificio('?module=dumbo7/administracion/zonas.formZonasEdificios.eliminarEdificio&amp;zonedEdCodigo={$codEd}&amp;zonedZonCodigo={$zonCodigo}&amp;zonCodigo={$zonCodigo}')"><img border="0" src="../graficos/iconos/eliminar.gif" alt="Eliminar"/></a></td>	
				</xsl:for-each>
			</tr>
		</xsl:for-each>
		<xsl:if test="count(DATA/ZONAS/ZONAS_EDIFICIOS[(@ZONA=$zonCodigo)])=0">
			<tr class="administracion">
				<td align="center" colspan="8">* No hay edificios asociados a esta zona.</td>
			</tr>
		</xsl:if>
		<tr>
			<table class="cont" align="center" border="0" cellpadding="3" cellspacing="1" width="90%" summary="Asignacin de Informticos a Zonas">
				<tr>
					<td class="cabe" align="left" colspan="20"><b>Vincular edificios</b></td>
				</tr>	
				<tr>
					<tr>
						<td class="administracion" align="left" colspan="30">
							ZONAS&#160;:
							<select name="ZonaCod" size="1">
								<xsl:call-template name="muestraZona">
									<xsl:with-param name="nodo" select="DATA/ZONAS"/>
								</xsl:call-template>
							</select>&#160;
							<!--  <div id="zonasReales">
							</div>-->
						</td>
					</tr>
					<tr>
						<td class="administracion" colspan="4">
							Edificios asociados a la zona seleccionada:
							<div id="edificios">
							</div>
						</td>
						<td class="administracion" colspan="4">
							<input onclick="javascript:addEd()" value="Aadir" class="boton" type="button"/>
						</td>
						<td class="administracion" colspan="4">
							Edificios aadidos a la zona 
							<xsl:for-each select="DATA/ZONAS/ZONAS">
								<xsl:if test="@CODIGO = $zonCodigo">
									"<xsl:value-of select="@DESCRIPCION"/>"
								</xsl:if>
							</xsl:for-each>:
							<select name="edificiosZona2" size="10" multiple="yes" font-size="10px">
								<option value="-1">&lt;-- No se han aadido edificios --></option>
							</select>
						</td>
						<td class="administracion" colspan="4">
							<input onclick="javascript:delEd(document.zon.edificiosZona2)" value="Eliminar" class="boton" type="button"/>
						</td>
					</tr>
				</tr>
				<tr class="administracion">
					<td colspan="20" align="center">
						<input type="button" class="boton" value="Aceptar" onclick="javascript:cerrar_aceptar()" />&#160;
						<input type="button" class="boton" value="Cancelar" onclick="javascript:cerrar()"/>
					</td>
				</tr>	
			</table>
		</tr>
	</table>
</form>
</td></tr>
</table>
<p>&#160;</p>
</xsl:template>

<!--Plantillas para recorrer las diferentes zonas -->
<xsl:template name="muestraZona">
	<xsl:param name="nodo"/>
   	<xsl:for-each select="DATA/ZONAS/ZONAS_REALES">	
			<xsl:sort select="number(@CODIGO)" data-type="number"/>
   	    	<option value="{@CODIGO}"><xsl:value-of select="@NOMBRE"/></option>
		</xsl:for-each>
</xsl:template>
</xsl:stylesheet>