<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet version="1.0" 
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:xforms="http://www.w3.org/2002/xforms">
	
<xsl:param name="servlet"/>	
<xsl:param name="menu"/>

<xsl:include href="dumbo7/utils/xsl/utils.xsl"/>

<xsl:template match="XMLROOT">
<html lang="es">
     <xsl:call-template name="headComun">
		<xsl:with-param name="arbol" select="true()"/>
	    <xsl:with-param name="jscript">
			<script LANGUAJE="JavaScript">
				function mostrarError(error){
					alert(error);
				}
				
				function abre(url){
					window.location.href=url;		
				}
				
				function validar(url,des){
					if (confirm("Est seguro de eliminar la zona " +des+"  ?")){
						abre(url);
					}
				}
            </script>
			<script LANGUAJE="JavaScript" src="../js/OnMouse.js"></script>
         </xsl:with-param>
	   </xsl:call-template>
<body>
	<xsl:call-template name="menuComun">
		<xsl:with-param name="NAME" select="concat(DATA/ZONAS/USER/@NAME,concat('(',concat(DATA/ZONAS/USER/@LOGIN,')')))"/>
		<xsl:with-param name="MENU" select="DATA/MENU"/>
		<xsl:with-param name="SELECT" select="$menu"/>
		<xsl:with-param name="HELP">administracion.xml#1.10</xsl:with-param>
	</xsl:call-template>
	<xsl:call-template name="pieComun"/>
</body>
</html>
</xsl:template>

<xsl:template name="cuerpo">
<xsl:if test="not(DATA/ZONAS/@ERROR='')">
	<script>mostrarError('<xsl:value-of select="@ERROR"/>')</script>
</xsl:if>

<table  align="center" border="0" cellpadding="5" cellspacing="5" width="775" height="16" summary="Esta tabla contiene una lista de zonas">
<form action="{$servlet}" METHOD="GET" name="zonas">
	<tr>
		<td class="cab1" style="width:30%">&#187;Listado de Zonas</td>
		<td width="20" style="align:center">
			<a href="javascript:abre('?module=dumbo7/administracion/zonas.index.nueva')">Insertar Zona</a>
		</td>
	</tr>
	<tr><td colspan="5">
	<table class="cont" border="0" cellpadding="3" cellspacing="1" width="100%">
		<tr>		
			<!--Cabecera de la tabla (cuidado con los anchos y con los anchos de los campos dentro del bucle) -->
			<td class="cabe" width="4%" align="center"><b><font face="Verdana" size="2">Cdigo</font></b></td>
			<td class="cabe" width="50%"><b><font face="Verdana" size="2">Descripcin</font></b></td>
			<td class="cabe" colspan="4"> </td>
			
			<SCRIPT>
				<!--Para guardar la descripcin y pasarlo a los javascript de tal forma que se respeten las tildes en los string-->
				var arrayDescripcion = new Array();
			</SCRIPT>	
		
			<!-- Se muestran todas las zonas-->
				<xsl:for-each select="DATA/ZONAS/ZONAS">
				<xsl:sort select="number(@CODIGO)" data-type="number"/>
					<SCRIPT>
						<!--Se guarda la descripcin para pasarla al javascript de borrar de tal forma que se respeten las tildes en los string-->
						arrayDescripcion['<xsl:value-of select="@CODIGO"/>'] = <xsl:call-template name="entrecomillaDescripcion"><xsl:with-param name="descripcion" select="@DESCRIPCION"/></xsl:call-template>;
					</SCRIPT>
					<xsl:call-template name="muestraZonas">
						<xsl:with-param name="zonCodigo" select="@CODIGO"/>	
					</xsl:call-template>						
				</xsl:for-each>
			<xsl:if test="count(DATA/ZONAS/ZONAS)=0">
				<tr>
					<td class="administracion" colspan="13" align="center"> No hay Zonas.</td>
				</tr>
			</xsl:if>
		</tr>
	</table></td></tr>
</form>
</table>
</xsl:template>

<xsl:template name="muestraZonas">
<xsl:param name="code"/>

		<xsl:variable name="Codigo"><xsl:value-of select="@CODIGO"/></xsl:variable>
		<tr bgcolor= "#F2F0FF">
		<xsl:if test="(count(../ZONAS)!=0)"></xsl:if>
			
			<td><xsl:value-of select="@CODIGO"/></td>
			<td>
				<!--muestra un substring de la descripcin-->
				<xsl:value-of select="@DESCRIPCION"/>	
			</td>	
			<td width="4%"><CENTER>
					<a href="javascript:abre('?module=dumbo7/administracion/zonas.index.ZonasInformaticos&amp;zonCodigo={@CODIGO}')"><img  border="0" src="../graficos/iconos/Informatico.gif" alt="Consultar/Modificar Informaticos"/></a>
				</CENTER></td>
			<xsl:for-each select="../ZONA">
				<xsl:sort select="@CODIGO"/>
				<SCRIPT>
					<!--Se guarda la descripcin para pasarla al javascript de borrar de tal forma que se respeten las tildes en los string-->
					arrayDescripcion['<xsl:value-of select="@CODIGO"/>'] = <xsl:call-template name="entrecomillaDescripcion"><xsl:with-param name="descripcion" select="@DESCRIPCION"/></xsl:call-template>;
				</SCRIPT>
				<xsl:call-template name="muestraZonas">
						<xsl:with-param name="zonCodigo" select="@CODIGO"/>	
					</xsl:call-template>					
			</xsl:for-each>
		<td width="4%">
			<CENTER><a href="javascript:abre('?module=dumbo7/administracion/zonas.index.ZonasEdificios&amp;zonCodigo={@CODIGO}')"><img  border="0" src="../graficos/iconos/icono_casa.gif" alt="Consultar/Modificar Edificios"/></a></CENTER>
		</td>
		<td width="4%">
			<CENTER><a href="javascript:abre('?module=dumbo7/administracion/zonas.index.modificar&amp;zonCodigo={@CODIGO}')"><img  border="0" src="../graficos/iconos/modificar.gif" alt="Consultar/Modificar Zona"/></a></CENTER>
		</td>
		<td width="4%">
			<CENTER><a href="javascript:validar('?module=dumbo7/administracion/zonas.index.eliminar&amp;zonCodigo={@CODIGO}',arrayDescripcion['{@CODIGO}']);"><img border="0" src="../graficos/iconos/eliminar.gif" alt="Eliminar Zona"/></a></CENTER>
		</td>
	</tr>
</xsl:template>
</xsl:stylesheet>