
package dumbo7.alertas;


import atica.frameweb.utils.*;
import java.sql.*;
import java.sql.Types.*;
import org.hibernate.*;
import org.hibernate.criterion.Expression;

import java.util.*;
import java.text.SimpleDateFormat;

import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import dumbo7.*;
import dumbo7.user.DumboUser;
import dumbo7.utils.*;
import dumbo7.atencion.*;
/**
 * @author Universidad de Murcia - ATICA
 *
 */

public class GestorAlertas extends GeneralManager {
	
	private List tareas,parametros,prioridades,datosPersonales,movimientos,numeroAlertas;
	private D7Tareas solicitud = null;
	private String rutaAnexos = "";
	public List categorias;
	public Vector anexos = new Vector();
	//Las listas siguientes contienen las secciones de las que un informtico es responsable (con subsecciones) y
	//las secciones a las que estn vinculadas las aplicaciones de las que el informtico es reponsable.
	private List secciones = new Vector();
	private List subSecciones;
	private List seccionesResponsable;
	private List seccionesResponsableSecciones;
	private List seccionesResponsableAplicaciones;
	//Las listas siguiente contienen las aplicaciones en las que el informtico es responsable y las aplicaciones
	//vinculadas a las secciones y subsecciones en las que el informtico es responsable.
	private List aplicaciones = new Vector();
	private List aplicacionesVinculado;
	private List aplicacionesResponsableAplicaciones;
	private List aplicacionesResponsableSecciones;
	
	private String NivelAlertas;//Nivel de Alertas del usuario
	private String NotificarCheck;//Checkbox del formulario formGenerar. Si esta activo, al generar las alertas se realizarn notificaciones
	private String res;//Si se quiere eliminar del informe las alertas de tareas resueltas, noResueltas sera !=null y res valdr "and tareas.TarEstado not in ('R')"
	private String PendientePlanificada;//Si es Pendiente contendra "not in ('P')" y si es planificada contendra "in ('P')"
	//Segn el nivel:
	//Si nivel 1: -Se restringe la busqueda a las alertas de nivel 1 del informtico que realiza el listado
	//Si nivel 2: -Se restringe la busqueda a las alertas de nivel 2 relacionadas con aplicaciones o secciones donde el informatico es responsable
	//Si nivel 3: -El maestro no tiene restricciones, ve todas las alertas de nivel 3.
	private String NivelRestriccion;
	private String fechaActual;
	private String [] Fechas; // [0] Desde , [1] Hasta
	private String tipo, historico,ordenarAplCheck,restringirAplCheck,aplicacion;
	private String ordenarSecCheck,restringirSecCheck,seccion;
		
	public GestorAlertas() {}
	
	public List getTareas() { return tareas; }
	public List getCategorias() { return categorias; }
	public D7Tareas getSolicitud() { return solicitud; }
	public Vector getAnexos() { return anexos; }
	public List getAplicaciones() { return aplicaciones; }
	public List getNumeroAlertas() {return numeroAlertas; }
	public List getMovimientos() { return movimientos; }
	public List getPrioridades() { return prioridades; }
	public List getDatosPersonales() { return datosPersonales;}
	public List getAplicacionesVinculadas() { return aplicacionesVinculado; }
	public List getSecciones() { return secciones; }
	public List getSeccionesResponsable() { return seccionesResponsable; }
	public List getParametros() { return parametros; }
	public String getFechaActual(){	return fechaActual;	}
	
	//OPERACIONES PARA NIVEL 1 Y SUPERIORES
	//Metodo set() para obtener el Nivel de Alertas permitido para el usuario
	public void setNivelAlertas(String [] NivelAlertas)
	{if (NivelAlertas!=null)this.NivelAlertas = NivelAlertas[0];}
	
	//Metodo set() para obtener si es Pendiente o Planificada
	/*public void setNoResueltas(String [] noResueltas)
	{if (noResueltas!=null)this.noResueltas = noResueltas[0];}*/
	
	//Metdo set() para obtener la fecha de inicio y fin del histrico
	public void setFechas(String [] Fechas)
	{this.Fechas = Fechas;}
	//Metodo set() para obtener si es Pendiente o Planificada
	public void setTipo(String [] tipo)
	{if (tipo!=null)this.tipo = tipo[0];}
	//Metodo set() para obtener el valor del checkbox historico (si no est marcado, valor "null")
	public void setHistorico(String [] historico)
	{if (historico!=null)this.historico = historico[0];}
	//Metodo set() para obtener el valor del checkbox ordenarApl (si no est marcado, valor "null"). Si != null, ordena por aplicacion
	public void setOrdenarAplCheck(String [] ordenarAplCheck)
	{if (ordenarAplCheck!=null)this.ordenarAplCheck = ordenarAplCheck[0];}
	//Metodo set() para obtener el valor del checkbox restringirApl (si no est marcado, valor "null"). Si !=null, restringe el listado a la aplicacin obtenida por setRestringirAplicacion
	public void setRestringirAplCheck(String [] restringirAplCheck)
	{if (restringirAplCheck!=null)this.restringirAplCheck = restringirAplCheck[0];}
	//Metodo set() para obtener el valor de la aplicacion que se desea restringir
	public void setRestringirAplicacion(String [] aplicacion)
	{if (aplicacion!=null)this.aplicacion = aplicacion[0];}
	
	//OPERACIONES PARA NIVEL 2 Y SUPERIORES
	//Metodo set() para obtener el valor del checkbox ordenarSec (si no est marcado, valor "null"). Si != null, ordena por aplicacion
	public void setOrdenarSecCheck(String [] ordenarSecCheck)
	{if (ordenarSecCheck!=null)this.ordenarSecCheck = ordenarSecCheck[0];}
	//Metodo set() para obtener el valor del checkbox restringirSec (si no est marcado, valor "null"). Si !=null, restringe el listado a la aplicacin obtenida por setRestringirAplicacion
	public void setRestringirSecCheck(String [] restringirSecCheck)
	{if (restringirSecCheck!=null)this.restringirSecCheck = restringirSecCheck[0];}
	//Metodo set() para obtener el valor de la seccion que se desea restringir
	public void setRestringirSeccion(String [] seccion)
	{if (seccion!=null)this.seccion = seccion[0];}
	
	//Lista las prioridades del sistema
	public void listaPrioridades(Session conn)
	{
		try
		{
			Query q = conn.createQuery(getQuery("AllPrioridades"));
			q = q.setString("sist",user.getDatosMenu().idSelected());
			prioridades  = (List)q.list();
		}
		catch (Exception ex)
		{
			setErrorMessage("Error al obtener prioridades " + ex);
		}
	}
	
	public void listaCategorias(Session conn) {
		try
		{
			Query q = conn.createQuery(getQuery("AllCategorias"));
			q = q.setString("sist",user.getDatosMenu().idSelected());
			categorias  = (List)q.list();
		} catch (Exception ex) {
			setErrorMessage("GestorAtencion[listCategorias]: "+ex);
		}
	}
	
	//Listado de las aplicaciones
	public void listaAplicaciones(Session conn)
	{
		try
		{
			Query q = conn.createQuery(getQuery("AllAplicaciones"));
			q = q.setString("sist",user.getDatosMenu().idSelected());
			aplicaciones  = (List)q.list();
		
		}
		catch (Exception ex)
		{
			setErrorMessage("Error al obtener aplicaciones " + ex);
		}
	}
	//Listado de las aplicaciones de las que un informatico es responsable
	public void listaAplicacionesInformatico(Session conn)
	{
		try
		{
			Query q = conn.createQuery(getQuery("AplicacionesInformatico"));
			q = q.setString("sist",user.getDatosMenu().idSelected());
			q = q.setString("inf",user.getIdentificador());
			aplicacionesVinculado  = (List)q.list();
		
		}
		catch (Exception ex)
		{
			setErrorMessage("Error al obtener aplicaciones " + ex);
		}
	}
	//Lista los datos personales de los solicitantes de las tareas asignadas a un informatico 
	public void ListaDatosPersonalesSolicitantes(Session conn)
	{
		try
		{
			Query q = conn.createQuery(getQuery("DatosPersonalesSolicitante"));
			q = q.setString("sist",user.getDatosMenu().idSelected());
			q = q.setString("inf",user.getIdentificador());
			datosPersonales  = (List)q.list();
		
		}
		catch (Exception ex)
		{
			setErrorMessage("Error al obtener datos personales del solicitante " + ex);
		}
	}
	
	public void ListaDatosPersonalesSolicitante2(Session conn)
	{
		try
		{
			String cadena = "";
			//Recogemos los dni`s de los usuarios solicitantes de tareas, para mostrar luego sus datos personales
			for(int i=0;i<tareas.size();i++)
			{
				cadena = cadena.concat("'" +((D7Tareas)((Object[])tareas.get(i))[1]).getTarUsuCod()) + "'" + ",";
			}
			if (cadena != "") {
				cadena = cadena.substring(0,cadena.length()-1);//Eliminamos la ltima coma
				Query q = conn.createQuery(getQuery("DatosPersonalesSolicitante2").replaceAll(":soli","("+cadena+")"));
				datosPersonales  = (List)q.list();
			}
			else		
				datosPersonales=null;
		}
		catch (Exception ex)
		{
			setErrorMessage("Error al obtener datos personales del solicitante " + ex);
		}
	}
	//Lista los ultimos movimientos de las tareas asignadas a un informatico.
	//El mtodo se ha modificado para ser utilizado despus de ejecutar listaTareas.
	//Utiliza el resultado de listaTareas para generar una cadena que se incluir en la query como condicin.
	public void ListaMovimientosTareasInformatico(Session conn)
	{
		try
		{
			Query q = conn.createQuery(getQuery("MovimientosTareasInformatico"));
			q = q.setString("sist",user.getDatosMenu().idSelected());
			q = q.setString("inf",user.getIdentificador());
			movimientos  = (List)q.list();
		
		}
		catch (Exception ex)
		{
			System.out.println(ex);
			setErrorMessage("Error al obtener datos personales del solicitante (Movimientos Tareas Informatico)");
		}
	}
	//Lista los ultimos movimientos de las tareas del sistema 
	public void ListaMovimientosTareas(Session conn)
	{
		try
		{
			Query q = conn.createQuery(getQuery("MovimientosTareas"));
			q = q.setString("sist",user.getDatosMenu().idSelected());
			movimientos  = (List)q.list();
		
		}
		catch (Exception ex)
		{
			System.out.println(ex);
			setErrorMessage("Error al obtener datos personales del solicitante (Movimientos Tareas sistema)");
		}
	}
	//
	public void ListaNumeroAlertasTarea(Session conn)
	{
		try
		{
			Query q = conn.createQuery(getQuery("NumeroAlertasTarea"));
			q = q.setString("sist",user.getDatosMenu().idSelected());
			q = q.setString("inf",user.getIdentificador());
			numeroAlertas  = (List)q.list();
		
		}
		catch (Exception ex)
		{
			System.out.println(ex);
			setErrorMessage("Error al obtener el numero de alertas por tarea");
		}
	}

	//Listado de las aplicaciones de las que un informatico es responsable (por aplicacion o por ser responsable de seccion)
	public void listaAplicacionesResponsable(Session conn)
	{
		//listaSeccionesNivel2(conn);
		//IMPORTANTE: para que seccionesResponsableSecciones != se debe ejecutar primero listaSeccionesNivel2
		Query q = null;
		try
		{
			//Listamos primero las aplicaciones en las que el informtico es responsable
			q = conn.createQuery(getQuery("AplicacionesResponsable"));
			q = q.setString("sist",user.getDatosMenu().idSelected());
			q = q.setString("inf",user.getIdentificador());
			aplicacionesResponsableAplicaciones  = (List)q.list();
			
			//Listamos las aplicaciones vinculadas a secciones en las que el informtico es responsable
			String cadena = new String();
			
			//Tiene que ser al menos responsable de una seccin para poder buscar las aplicaciones vinculadas a dicha seccion
			if(seccionesResponsableSecciones.size()>0)
			{
				//Recogemos los cdigos de las secciones
				for(int i=0;i<seccionesResponsableSecciones.size();i++)
				{
					cadena = cadena + "'" + ((D7Secciones)seccionesResponsableSecciones.get(i)).getSecCod() + "'" + ",";
				}
				cadena = cadena.substring(0,cadena.length()-1);//Eliminamos la ltima coma
				
				q = conn.createQuery(getQuery("AplicacionesSecciones").replaceAll(":secciones","("+cadena+")"));
				q = q.setString("sist",user.getDatosMenu().idSelected());
				aplicacionesResponsableSecciones = (List)q.list();
			
				//Aadimos las aplicaciones en las que es responsable el informtico
				for (int i=0; i<aplicacionesResponsableSecciones.size();i++)
				{
					D7Aplicaciones app = ((D7Aplicaciones)aplicacionesResponsableSecciones.get(i));
					if (!app.getClass().getName().equals("dumbo7.utils.D7Aplicaciones")) {
						D7Aplicaciones apl = new D7Aplicaciones();
						apl.setAplCod(app.getAplCod());
						aplicacionesResponsableSecciones.set(i,apl);
					}
					boolean existe = false;
					//comprobamos si ya existe, si es as, no lo aadimos
					for (int j=0; j<aplicaciones.size();j++)
					{
						//Si coinciden los codigos de seccion son la misma
						if (((D7Aplicaciones)aplicaciones.get(j)).getAplCod().equals(((D7Aplicaciones)aplicacionesResponsableSecciones.get(i)).getAplCod()))
						{
							existe = true;
							break;
						}
					}
					if(!existe)
					{
						aplicaciones.add(aplicacionesResponsableSecciones.get(i));
					}
				}
			}
			//Aadimos las aplicaciones vinculadas a secciones donde el informtico es responsable
			for (int i=0; i<aplicacionesResponsableAplicaciones.size();i++)
			{
				boolean existe = false;
				//comprobamos si ya existe, si es as, no lo aadimos
				for (int j=0; j<aplicaciones.size();j++)
				{
					if (((D7Aplicaciones)aplicaciones.get(j)).getAplCod().equals(((D7Aplicaciones)aplicacionesResponsableAplicaciones.get(i)).getAplCod()))
					{
						existe = true;
						break;
					}
				}
				if(!existe)
				{
					aplicaciones.add(aplicacionesResponsableAplicaciones.get(i));
				}
			}
		}
		catch (Exception ex)
		{
			setErrorMessage("Error al obtener aplicaciones " + ex);
		}
	}
	
	//Listado de las secciones
	public void listaSecciones(Session conn)
	{
		try
		{
			Query q = conn.createQuery(getQuery("AllSecciones"));
			q = q.setString("sist",user.getDatosMenu().idSelected());
			secciones  = (List)q.list();
		}
		catch (Exception ex)
		{
			setErrorMessage("Error al obtener secciones " + ex);
		}
	}
	public void listaSeccionesNivel2(Session conn)
	{
		seccionesResponsable = new Vector();
		
		listaSeccionesInformaticoRecursiva(conn);
		listaSeccionesAplicaciones(conn);
		
		//Aadimos las secciones en las que es responsable el informtico
		for (int i=0; i<seccionesResponsableSecciones.size();i++)
		{
			boolean existe = false;
			//comprobamos si ya existe, si es as, no lo aadimos
			for (int j=0; j<seccionesResponsable.size();j++)
			{
				//Si coinciden los codigos de seccion son la misma
				if (((D7Secciones)seccionesResponsable.get(j)).getSecCod().equals(((D7Secciones)seccionesResponsableSecciones.get(i)).getSecCod()))
				{
					existe = true;
					break;
				}
			}
			if(!existe)
			{
				seccionesResponsable.add(seccionesResponsableSecciones.get(i));
			}
		}
		//Aadimos las secciones vinculadas a aplicaciones donde el informtico es responsable
		for (int i=0; i<seccionesResponsableAplicaciones.size();i++)
		{
			boolean existe = false;
			//comprobamos si ya existe, si es as, no lo aadimos
			for (int j=0; j<secciones.size();j++)
			{
				if (((D7Secciones)secciones.get(j)).getSecCod().equals(((D7Secciones)seccionesResponsableAplicaciones.get(i)).getSecCod()))
				{
					existe = true;
					break;
				}
			}
			if(!existe)
			{
				seccionesResponsable.add(seccionesResponsableAplicaciones.get(i));
			}
		}
	}
	//Listado de las secciones y subsecciones en las que un informtico es responsable
	//Deja almacenado el resultado en la lista secciones.
	public void listaSeccionesInformaticoRecursiva(Session conn)
	{
		PreparedStatement pstmt;
		seccionesResponsableSecciones = new Vector();

		try
		{
			String q = getQuery("SeccionesInformatico");
			
			q = q.replaceAll(":sist",user.getDatosMenu().idSelected());
			q = q.replaceAll(":inf",user.getIdentificador());
			pstmt = conn.connection().prepareStatement(q);
			ResultSet rs = pstmt.executeQuery();
			
			while (rs.next()) {
	 	    	D7Secciones secci = new D7Secciones();
	 	    	secci.setSecSisCod(rs.getString(1));
	 	    	secci.setSecCod(rs.getString(2));
	 	    	secci.setSecDescrip(rs.getString(3));
	 	    	secci.setSecIdRespon(rs.getString(4));
	 	    	secci.setSecSecCod(rs.getString(5));
	 	    	secci.setSecEstado(rs.getString(6));
	 	    	seccionesResponsableSecciones.add(secci);
	 	    }
			
			
	 	    rs.close();
	 	    pstmt.close();
		}
		catch (Exception ex)
		{
			setErrorMessage("Error al listar secciones "  + ex);
			System.out.println(ex);
		}
	}
	//	Listado de las aplicaciones para las que el informatico puede consultar las alertas, bien porque es 
	// responsable de la misma o bien porque es responsable de la seccion en cuestion
	public void listaAplicacionesSeccionesResponsable(Session conn)
	{
		PreparedStatement pstmt;
		aplicacionesResponsableSecciones = new Vector();

		try
		{
			aplicaciones.clear();
			String q = getQuery("AplicacionesSeccionesResponsable");
			
			q = q.replaceAll(":sist",user.getDatosMenu().idSelected());
			q = q.replaceAll(":inf",user.getIdentificador());
			pstmt = conn.connection().prepareStatement(q);
			ResultSet rs = pstmt.executeQuery();
			//En aplicacionesResponsableSecciones tenemos las aplicaciones de la secciones de las que el informatico es responsable
			while (rs.next()) {
	 	    	D7Aplicaciones apl = new D7Aplicaciones();
	 	    	apl.setAplSisCod(rs.getString(1));
	 	    	apl.setAplCod(rs.getString(2));
	 	    	apl.setAplDescrip(rs.getString(3));
	 	    	apl.setAplTipoAsig(rs.getString(4));
	 	    	apl.setAplSecCod(rs.getString(4));
	 	    	apl.setAplEstado(rs.getString(5));
	 	    	apl.setAplDetalle(rs.getString(6));
	 	    	apl.setAplCaracter(rs.getString(7));
	 	    	apl.setAplPadreAplCod(rs.getString(8));
	 	    	apl.setAplCorreoResp(rs.getString(9));
	 	    	apl.setAplCorreoInf(rs.getString(10));
	 	    	aplicacionesResponsableSecciones.add(apl);
	 	    }
			
			//En aplicacionesResponsableAplicaciones tenemos las aplicaciones de las que el informatico es responsable
			Query q1 = null;
			q1 = conn.createQuery(getQuery("AplicacionesResponsable"));
			q1 = q1.setString("sist",user.getDatosMenu().idSelected());
			q1 = q1.setString("inf",user.getIdentificador());
			aplicacionesResponsableAplicaciones  = (List)q1.list();
			
			//En aplicaciones las metemos todas sin repetir
			for (int i=0; i<aplicacionesResponsableSecciones.size();i++){
				boolean existe = false;
				//comprobamos si ya existe, si es as, no lo aadimos
				for (int j=0; j<aplicaciones.size();j++){
					//Si coinciden los codigos de aplicacion son la misma
					if (((D7Aplicaciones)aplicaciones.get(j)).getAplCod().equals(((D7Aplicaciones)aplicacionesResponsableSecciones.get(i)).getAplCod()))
					{
						existe = true;
						break;
					}
				}
				if(!existe)
				{
					aplicaciones.add(aplicacionesResponsableSecciones.get(i));
				}
			}
			
			for (int i=0; i<aplicacionesResponsableAplicaciones.size();i++){
				boolean existe = false;
				//comprobamos si ya existe, si es as, no lo aadimos
				for (int j=0; j<aplicaciones.size();j++){
					//Si coinciden los codigos de aplicacion son la misma
					if (((D7Aplicaciones)aplicaciones.get(j)).getAplCod().equals(((D7Aplicaciones)aplicacionesResponsableAplicaciones.get(i)).getAplCod()))
					{
						existe = true;
						break;
					}
				}
				if(!existe)
				{
					aplicaciones.add(aplicacionesResponsableAplicaciones.get(i));
				}
			}
						
	 	    rs.close();
	 	    pstmt.close();
		}
		catch (Exception ex)
		{
			setErrorMessage("[listaAplicacionesSeccionesResponsable]:Error al listar aplicaciones "  + ex);
			System.out.println(ex);
		}
	}
	//Lista todas las subsecciones de una seccion
	public void listaSubSeccionesRecursiva(Session conn, String seccion)
	{
		PreparedStatement pstmt;
		subSecciones = new Vector();

		try
		{
			String q = getQuery("SubSecciones");
			
			q = q.replaceAll(":sist",user.getDatosMenu().idSelected());
			q = q.replaceAll(":sec",seccion);
			pstmt = conn.connection().prepareStatement(q);
			ResultSet rs = pstmt.executeQuery();
			
			while (rs.next()) {
	 	    	D7Secciones secci = new D7Secciones();
	 	    	secci.setSecSisCod(rs.getString(1));
	 	    	secci.setSecCod(rs.getString(2));
	 	    	secci.setSecDescrip(rs.getString(3));
	 	    	secci.setSecIdRespon(rs.getString(4));
	 	    	secci.setSecSecCod(rs.getString(5));
	 	    	secci.setSecEstado(rs.getString(6));
	 	    	subSecciones.add(secci);
	 	    }
			
	 	    rs.close();
	 	    pstmt.close();
		}
		catch (Exception ex)
		{
			setErrorMessage("Error al listar secciones "  + ex);
			System.out.println(ex);
		}
	}
	
	//Listado de las secciones vinculadas a aplicaciones en las que el informtico es responsable
	public void listaSeccionesAplicaciones(Session conn)
	{
		seccionesResponsableAplicaciones = new Vector();
		try
		{
			Query q = conn.createQuery(getQuery("SeccionesAplicaciones"));
			q = q.setString("sist",user.getDatosMenu().idSelected());
			q = q.setString("inf",user.getIdentificador());
			seccionesResponsableAplicaciones  = (List)q.list();
		}
		catch (Exception ex)
		{
			setErrorMessage("Error al obtener secciones "  + ex);
			System.out.println(ex);
		}
	}

	public void listaTareas(Session conn)
	{
		String fechaHistoricoDesde, fechaHistoricoHasta;
		java.util.Date date;
		date = new java.util.Date();
		
		//fechaActual = fechaActual();
		
		//fechaHistorico hace falta inicializarlo. Lo inicializo a fecha actual, aunque luego lo cambia a lo pasado por request
		fechaHistoricoDesde = null;
		fechaHistoricoHasta = null;
		if(historico!=null)
		{
			if(Fechas[0].length() != 0){fechaHistoricoDesde = Fechas[0];}
			if(Fechas[1].length() != 0){fechaHistoricoHasta = Fechas[1];}	
		}

		try
		{
			//Condiciones dependiendo si es Pendiente o Planificada
			//Lista Alertas de Tareas Pendientes
			if(this.tipo.equals("Pe"))
			{
				PendientePlanificada = getQuery("PendientesCond");
			}
			//Lista Alertas de Tareas Planificadas
			if(this.tipo.equals("Pl"))
			{
				PendientePlanificada = getQuery("PlanificadasCond");
			}
			//Condiciones dependiendo del nivel
			//Si es nivel 1, restriccin de informtico
			if(this.NivelAlertas.equals("1"))
			{
				NivelRestriccion = getQuery("informaticoCond");
			}
			//Si es nivel 2, restriccin de aplicacin y seccin (y subsecciones)
			if(this.NivelAlertas.equals("2"))
			{
				//Obtenemos las secciones y subsecciones en las que el informtico es responsable
				listaAplicacionesSeccionesResponsable(conn);
				//listaSeccionesInformaticoRecursiva(conn);
				NivelRestriccion = getQuery("AplicacionCond");
				//Cadena contiene todas las aplicaciones de las que el informtico es responsable
				String cadena = new String();
				
				//Recogemos los cdigos de las secciones
				for(int i=0;i<aplicaciones.size();i++)
				{
					cadena = cadena + "'" + ((D7Aplicaciones)aplicaciones.get(i)).getAplCod() + "'" + ",";
				}
				//Si hay al menos una seccin
				cadena = cadena.substring(0,cadena.length()-1);//Eliminamos la ltima coma
				NivelRestriccion = NivelRestriccion.replaceAll(":aplicaciones","("+cadena+")");
			}
			//Si es nivel 3, no hay restriccion
			if(this.NivelAlertas.equals("3"))
			{
				NivelRestriccion = " ";
			}
			if(historico==null)
			{
				//Si no se desea historico se muestran todas las NO RESUELTAS desde el principio hasta el fin.
				res = getQuery("NoResueltasCond");
				listaHistorico(conn,null,null);
			}
			else if (historico!=null)
			{
				//Si se desea historico se mostraran solo las RESUELTAS
				res = getQuery("ResueltasCond");
				listaHistorico(conn,fechaHistoricoDesde,fechaHistoricoHasta);
			}
		
		}
		catch(Exception ex){System.out.println("listaTareas " + ex.toString());}
	}
	
	public void listaTareas2(Session conn)
	{
		Query q = null;
		try
		{
				q = conn.createQuery(getQuery("HistoricoCompleto") + getQuery("NoResueltasCond") + getQuery("OrdenCodigoTarea"));
				q = q.setString("sist",user.getDatosMenu().idSelected());
				q = q.setString("nivel","3");
				tareas  = (List)q.list();
		}
		catch(Exception ex){System.out.println("listaTareas2 " + ex.toString());}
	}
	
	public void obtenFechaActual(Session conn){
		java.util.Date date = new java.util.Date();
		    
		java.text.DateFormat sdf = new java.text.SimpleDateFormat("dd/MM/yyyy");
		this.fechaActual = sdf.format(date).toString();
	}

	//Listado de un histrico de las alertas
	public void listaHistorico (Session conn, String fechaD, String fechaH)
	{
		Query q = null;
		String cadena = new String();
		try
		{
			//Si ambos son nulos se listaran todas las alertas DESDE EL PRINCIPIO HASTA EL FINAL
			if (fechaH==null && fechaD==null)
			{
				if(ordenarAplCheck==null && ordenarSecCheck==null)
				{
					q = conn.createQuery(getQuery("HistoricoCompleto") + PendientePlanificada + res + NivelRestriccion + getQuery("OrdenFechaCond"));
				}
				else if (ordenarAplCheck!=null)
				{	
					if(restringirAplCheck==null)
					{
						q = conn.createQuery(getQuery("HistoricoCompleto") + PendientePlanificada + res + NivelRestriccion + getQuery("OrdenAplicacionCond"));
					}
					else
					{
						q = conn.createQuery(getQuery("HistoricoCompleto")+ getQuery("RestringirAplicacionCond")+ PendientePlanificada + res + NivelRestriccion + getQuery("OrdenFechaCond"));
						q = q.setString("apli",aplicacion);
					}
				}
				else if (ordenarSecCheck!=null)
				{
					if(restringirSecCheck==null)
					{
						q = conn.createQuery(getQuery("HistoricoCompletoSeccion") + PendientePlanificada + res + NivelRestriccion + getQuery("OrdenSeccionCond"));
					}
					else
					{
						//Rellena la lista subSecciones
						listaSubSeccionesRecursiva(conn, seccion);
						//Recogemos los cdigos de las secciones
						for(int i=0;i<subSecciones.size();i++)
						{
							cadena = cadena + "'" + ((D7Secciones)subSecciones.get(i)).getSecCod() + "'" + ",";
						}
						cadena = cadena.substring(0,cadena.length()-1);//Eliminamos la ltima coma
						q = conn.createQuery(getQuery("HistoricoCompletoSeccion")+ getQuery("RestringirSeccionCond").replaceAll(":secciones","("+cadena+")") + PendientePlanificada + res + NivelRestriccion + getQuery("OrdenFechaCond"));
						
					}
				}
				q = q.setString("sist",user.getDatosMenu().idSelected());
				q = q.setString("nivel",NivelAlertas);
			}
			
			//Si la fecha "hasta" es null, se listan DESDE fechaD HASTA EL FINAL
			else if (fechaH==null)
			{
				if(ordenarAplCheck==null && ordenarSecCheck==null)
				{
					q = conn.createQuery(getQuery("HistoricoCompleto")+ getQuery("HistoricoDesdeCond") + PendientePlanificada + res + NivelRestriccion + getQuery("OrdenFechaCond"));
				}
				else if (ordenarAplCheck!=null)
				{	
					if(restringirAplCheck==null)
					{
						q = conn.createQuery(getQuery("HistoricoCompleto")+ getQuery("HistoricoDesdeCond") + PendientePlanificada + res + NivelRestriccion + getQuery("OrdenAplicacionCond"));
					}
					else
					{
						q = conn.createQuery(getQuery("HistoricoCompleto")+ getQuery("RestringirAplicacionCond")+ getQuery("HistoricoDesdeCond") + PendientePlanificada + res + NivelRestriccion + getQuery("OrdenFechaCond"));
						q = q.setString("apli",aplicacion);
					}
				}
				else if (ordenarSecCheck!=null)
				{
					if(restringirSecCheck==null)
					{
						q = conn.createQuery(getQuery("HistoricoCompletoSeccion")+ getQuery("HistoricoDesdeCond") + PendientePlanificada + res + NivelRestriccion + getQuery("OrdenSeccionCond"));
					}
					else
					{
						//Rellena la lista subSecciones
						listaSubSeccionesRecursiva(conn, seccion);
						//Recogemos los cdigos de las secciones
						for(int i=0;i<subSecciones.size();i++)
						{
							cadena = cadena + "'" + ((D7Secciones)subSecciones.get(i)).getSecCod() + "'" + ",";
						}
						cadena = cadena.substring(0,cadena.length()-1);//Eliminamos la ltima coma
											
						q = conn.createQuery(getQuery("HistoricoCompletoSeccion")+ getQuery("RestringirSeccionCond").replaceAll(":secciones","("+cadena+")") + getQuery("HistoricoDesdeCond") + PendientePlanificada + res + NivelRestriccion + getQuery("OrdenFechaCond"));
					}
				}
				q = q.setString("sist",user.getDatosMenu().idSelected());
				q = q.setString("nivel",NivelAlertas);
				q = q.setString("fecha", fechaD);
			}
			
			//Si la fecha "desde" es null, se listan DESDE EL PRINCIPIO HASTA fechaH
			else if (fechaD==null)
			{
				if(ordenarAplCheck==null && ordenarSecCheck==null)
				{
					q = conn.createQuery(getQuery("HistoricoCompleto")+ getQuery("HistoricoHastaCond") + PendientePlanificada + res + NivelRestriccion + getQuery("OrdenFechaCond"));
				}
				else if (ordenarAplCheck!=null)
				{	
					if(restringirAplCheck==null)
					{
						q = conn.createQuery(getQuery("HistoricoCompleto")+ getQuery("HistoricoHastaCond") + PendientePlanificada + res + NivelRestriccion + getQuery("OrdenAplicacionCond"));
					}
					else
					{
						q = conn.createQuery(getQuery("HistoricoCompleto")+ getQuery("RestringirAplicacionCond")+ getQuery("HistoricoHastaCond") + PendientePlanificada + res + NivelRestriccion + getQuery("OrdenFechaCond"));
						q = q.setString("apli",aplicacion);
					}
				}
				else if (ordenarSecCheck!=null)
				{
					if(restringirSecCheck==null)
					{
						q = conn.createQuery(getQuery("HistoricoCompletoSeccion")+ getQuery("HistoricoHastaCond") + PendientePlanificada + res + NivelRestriccion + getQuery("OrdenSeccionCond"));
					}
					else
					{
						//Rellena la lista subSecciones
						listaSubSeccionesRecursiva(conn, seccion);
						//Recogemos los cdigos de las secciones
						for(int i=0;i<subSecciones.size();i++)
						{
							cadena = cadena + "'" + ((D7Secciones)subSecciones.get(i)).getSecCod() + "'" + ",";
						}
						cadena = cadena.substring(0,cadena.length()-1);//Eliminamos la ltima coma
						q = conn.createQuery(getQuery("HistoricoCompletoSeccion")+ getQuery("RestringirSeccionCond").replaceAll(":secciones","("+cadena+")") + getQuery("HistoricoHastaCond") + PendientePlanificada + res + NivelRestriccion + getQuery("OrdenFechaCond"));
					}
				}
				q = q.setString("sist",user.getDatosMenu().idSelected());
				q = q.setString("nivel",NivelAlertas);
				q = q.setString("fecha", fechaH);
				
			}
			
			//Ni fechaH ni fechaD son null, HISTORICO ENTRE DOS FECHAS INTRODUCIDAS
			else
			{				
				q = conn.createQuery(getQuery("HistoricoCompleto")+ getQuery("HistoricoEntre") + PendientePlanificada + res + NivelRestriccion + getQuery("OrdenFechaCond"));
				
				if(ordenarAplCheck==null && ordenarSecCheck==null)
				{
					q = conn.createQuery(getQuery("HistoricoCompleto")+ getQuery("HistoricoEntre") + PendientePlanificada + res + NivelRestriccion + getQuery("OrdenFechaCond"));
				}
				else if (ordenarAplCheck!=null)
				{	
					if(restringirAplCheck==null)
					{
						q = conn.createQuery(getQuery("HistoricoCompleto")+ getQuery("HistoricoEntre") + PendientePlanificada + res + NivelRestriccion + getQuery("OrdenAplicacionCond"));
					}
					else
					{
						q = conn.createQuery(getQuery("HistoricoCompleto")+ getQuery("RestringirAplicacionCond")+ getQuery("HistoricoEntre") + PendientePlanificada + res + NivelRestriccion + getQuery("OrdenFechaCond"));
						q = q.setString("apli",aplicacion);
					}
				}
				else if (ordenarSecCheck!=null)
				{
					if(restringirSecCheck==null)
					{
						q = conn.createQuery(getQuery("HistoricoCompletoSeccion")+ getQuery("HistoricoEntre") + PendientePlanificada + res + NivelRestriccion + getQuery("OrdenSeccionCond"));
					}
					else
					{
						//Rellena la lista subSecciones
						listaSubSeccionesRecursiva(conn, seccion);
						//Recogemos los cdigos de las secciones
						for(int i=0;i<subSecciones.size();i++)
						{
							cadena = cadena + "'" + ((D7Secciones)subSecciones.get(i)).getSecCod() + "'" + ",";
						}
						cadena = cadena.substring(0,cadena.length()-1);//Eliminamos la ltima coma
						q = conn.createQuery(getQuery("HistoricoCompletoSeccion")+ getQuery("RestringirSeccionCond").replaceAll(":secciones","("+cadena+")") + getQuery("HistoricoEntre") + PendientePlanificada + res + NivelRestriccion + getQuery("OrdenFechaCond"));
						
					}
				}
				q = q.setString("sist",user.getDatosMenu().idSelected());
				q = q.setString("nivel",NivelAlertas);
				q = q.setString("fechaH", fechaH);
				q = q.setString("fechaD", fechaD);
			}
			
			if(this.NivelAlertas.equals("1") || this.NivelAlertas.equals("2"))
			{
				q = q.setString("inf",user.getIdentificador());
			}
			tareas  = (List)q.list();
			
				
		}
		catch(Exception e)
		{
			System.out.println(e);
			setErrorMessage("Fecha Introducida no vlida " + e);
		}
	}

	//Mtodo que llama a procedimientos almacenados en BBDD para generar y notificar las alertas del sistema sobre el que se est trabajando
	public void generarAlertas(Connection conn)
	{
		//A ambos procedimientos almacenados se les pasa el sistema como argumento
		String query1 = "begin DUMBO.ALERTAS.Generar_Alertas(?); end;";
		String query2 = "begin DUMBO.Pkd7_Mail.Notificar_Alertas(?); end;";
		
		try
		{
			CallableStatement stmt1 = conn.prepareCall(query1);
			CallableStatement stmt2 = conn.prepareCall(query2);
			
			//register the type of the out param - an Oracle specific type
						
			//set the in param
			stmt1.setString(1, user.getDatosMenu().idSelected());
			stmt2.setString(1, user.getDatosMenu().idSelected());
			
			//execute and retrieve the result set
			stmt1.execute();
			stmt2.execute();

			//ResultSet rs = (ResultSet)stmt1.getObject(1);
						
		}
		catch(SQLException sqle)
		{System.out.println(sqle);}
	}
	
	public void listaParametros(Session conn){
		try
		{
			Query q = conn.createQuery(getQuery("Parametros"));
			q = q.setString("sist",user.getDatosMenu().idSelected());
			parametros = (List)q.list();
		}
		catch (Exception ex)
		{
			setErrorMessage("Error al listar parmetros");
			System.out.println(ex);
		}
	}

	private dumbo7.gestion.dumbos.GestorDumbos gDumbos = null;
	
	public void setContextPath(HttpServlet servlet,HttpServletRequest req,HttpServletResponse res) {
		gDumbos = new dumbo7.gestion.dumbos.GestorDumbos();
		gDumbos.setUser(user);
		gDumbos.setContextPath(servlet, req, res);
	}
	
	public void detalleSolicitud(Session conn,String code) {
		gDumbos.detalleSolicitud(conn, code);
		solicitud = gDumbos.getSolicitud();
		anexos = GestorGenerico.getAnexosTarea(gDumbos.rutaAnexos,solicitud);
	}
	
}
