<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet version="1.0"
     xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	 xmlns:xforms="http://www.w3.org/2002/xforms" 
     xmlns:fo="http://www.w3.org/1999/XSL/Format" >

<xsl:param name="servlet"/>
<xsl:param name="menu"/>

<xsl:param name="NivelAlertas"/>
<!-- Nivel alertas
	 1  Informatico
	 2  Gestor
	 3  Maestro
-->
<xsl:param name="TipoCheck"/>
<!-- TipoCheck
	Tareas Pendientes=Pe 
	Tareas Planificadas=Pl
-->
<xsl:param name="Historico"/>
<!-- Historico=hist-->

<xsl:param name="FechasD"/>
<xsl:param name="FechasH"/>

<!--<xsl:param name="noresueltas"/>-->
<!-- noresueltas=res-->

<xsl:param name="ordenar"/>
<!-- ordenar=ord-->

<xsl:param name="restringir"/>
<!--restringir=rest-->
<xsl:param name="TarAplCod"/>
	
	
<xsl:include href="dumbo7/utils/xsl/utils.xsl"/>

<xsl:template match="XMLROOT">
	<fo:root>
		<fo:layout-master-set >

			<fo:simple-page-master master-name="simple"
					page-height="21cm" 
					page-width="29.7cm"
					margin-top="0.5cm" 
					margin-bottom="1.5cm" 
					margin-left="2cm" 
					margin-right="2cm">
				<fo:region-body border="0.25pt solid silver" margin-top="1cm" margin-bottom="0.5cm"/>
				<fo:region-before border="0.25pt solid silver" />
				<fo:region-after extent="0.5cm"/>
			</fo:simple-page-master>
		</fo:layout-master-set>

<fo:page-sequence master-reference="simple" >
				
		<fo:static-content flow-name="xsl-region-before">
    <fo:block background-color="#000000">
	<!--CABECERA DUMBO-->
    </fo:block>
  </fo:static-content>
		
		<!--PIE DUMBO-->
		<fo:static-content flow-name="xsl-region-after">
			<fo:table>
				<fo:table-column column-number="1"/>
				<fo:table-column column-number="2"/>
				<fo:table-column column-number="3"/>
		
				<fo:table-body>
					<fo:table-row>
						<!--Pie de pgina-->
						<fo:table-cell number-columns-spanned="2">
							<!--Lo pone en la primera pgina-->
							 <fo:block text-align="left" font-size="8pt">
								<!--(C) 2005. ATICA. Vicerrectorado de Investigacin y Nuevas Tecnologas-->
								[<xsl:call-template name="traduce"><xsl:with-param name="id" select="'INFORMTICO'"/></xsl:call-template>]&#160;<xsl:value-of select="DATA/ALERTAS/PARAMETRO[@PARAMETRO='PAR_PIE_NOTIF']/@VALOR"/>
							</fo:block>
							<!--Lo pone en las siguientes-->
							 <fo:block text-align="left" font-size="8pt"  break-before="page">
								[<xsl:call-template name="traduce"><xsl:with-param name="id" select="'INFORMTICO'"/></xsl:call-template>]&#160;<xsl:value-of select="DATA/ALERTAS/PARAMETRO[@PARAMETRO='PAR_PIE_NOTIF']/@VALOR"/>
							</fo:block>
						</fo:table-cell>
						
						<!--Numeracin del pie-->
						<fo:table-cell>
							<!--Lo pone en la primera pgina-->
			               <fo:block text-align="right" font-size="8pt">
					          &#160;<fo:page-number/>
			               </fo:block>
						   <!--Lo pone en las siguientes-->
						   <fo:block text-align="right" font-size="8pt" break-before="page"> 
		                     &#160;<fo:page-number/>
					       </fo:block>
						</fo:table-cell>
					</fo:table-row>
				</fo:table-body>
			</fo:table>
          </fo:static-content>
		<fo:flow flow-name="xsl-region-body">
			<xsl:apply-templates/>
		</fo:flow>
</fo:page-sequence>
	</fo:root>	
</xsl:template>

<!--CUERPO PDF-->
<xsl:template match="DATA">
	<fo:block text-align="right"><fo:external-graphic src="/www/dumbo/web_dumbo/graficos/dumboD7.jpg" width="6cm" height="2cm"/></fo:block>
	<fo:block text-align="center" font-size="16">&#160;</fo:block>
	<fo:block text-align="center" font-size="22" color="#000000" text-decoration="underline">INFORME ALERTAS
		<fo:inline>&#160;</fo:inline>
		<xsl:if test="$NivelAlertas='1'">
						<fo:inline>&#160;INFORMATICO</fo:inline>
					</xsl:if>
					<xsl:if test="$NivelAlertas='2' ">
						<fo:inline>&#160;GESTOR</fo:inline>
					</xsl:if>
					<xsl:if test="$NivelAlertas='3' ">
						<fo:inline>&#160;MAESTRO</fo:inline>
					</xsl:if></fo:block>
	<fo:block text-align="center" font-size="16">&#160;</fo:block>

	<fo:table border="0.5pt solid silver" padding="5pt">
		
		<fo:table-column column-number="1"/>
		<fo:table-column column-number="2"/>
		
		<fo:table-body>
			<fo:table-row>
				<fo:table-cell>
					<fo:block  text-align="left" font-size="9px">&#8226;Listado de tareas&#160; 
						<xsl:if test="$TipoCheck='Pl' ">
								<fo:inline font-style="italic">Planificadas</fo:inline></xsl:if>
						<xsl:if test="$TipoCheck='Pe' ">
								<fo:inline font-style="italic">Pendientes</fo:inline></xsl:if>

					</fo:block>
				</fo:table-cell>

				<fo:table-cell>
					<fo:block  text-align="left" font-size="9px">
					<xsl:if test="$Historico='hist' ">&#8226; Histrico
					
					
						<xsl:if test="$FechasD!='' ">
								&#160;&#160;&#160;Desde:
								<fo:inline font-style="italic"><xsl:value-of select="$FechasD"/>&#160;&#160;</fo:inline>
						</xsl:if>
						<xsl:if test="$FechasD='' ">
								Desde:<fo:inline font-style="italic">Inicio</fo:inline>
						</xsl:if>
						
						<xsl:if test="$FechasH!='' ">
								&#160;Hasta:
								<fo:inline font-style="italic"><xsl:value-of select="$FechasH"/></fo:inline>
						</xsl:if>
						
						
						<xsl:if test="$FechasH='' ">
								Hasta:<fo:inline font-style="italic">Final</fo:inline>
						</xsl:if>
						
						<fo:inline font-style="italic"> &#160; </fo:inline>
					</xsl:if></fo:block>
					
					<fo:block  text-align="left" font-size="9px">
						<xsl:if test="$ordenar='ord' ">&#8226; Ordenar por aplicaciones</xsl:if>
					</fo:block>
				</fo:table-cell>
				</fo:table-row>
				<fo:table-row>
				<fo:table-cell>
					<fo:block text-align="left" font-size="9px">
						&#160;
					</fo:block>
				</fo:table-cell>
				<fo:table-cell>
					<fo:block text-align="left" font-size="9px">
						<xsl:if test="$restringir='rest' ">&#8226; Mostrar slo aplicacin
							<fo:inline font-style="italic">
								<xsl:for-each select="ALERTAS/APLICACION">		
									<xsl:if test="@CODIGO = $TarAplCod"> 
										<xsl:value-of select="@DESCRIPCION"/>			
									</xsl:if>
								</xsl:for-each>
							</fo:inline>
						</xsl:if>
					</fo:block>
				</fo:table-cell>

			</fo:table-row>
		</fo:table-body>
	</fo:table>
			
	<fo:block text-align="center" font-size="16">&#160;</fo:block>
	
	<xsl:apply-templates/>
	
</xsl:template>

<xsl:template match="ALERTAS">
		<!--Inicializacin de las columnas-->
		<fo:table border="0.25pt solid silver">
		<fo:table-column column-number="1" column-width="20mm"/>
		<fo:table-column column-number="2" column-width="20mm"/>
		<fo:table-column column-number="3" column-width="25mm"/>
		<fo:table-column column-number="4" column-width="35mm"/>
		<fo:table-column column-number="5" column-width="35mm"/>
		<fo:table-column column-number="6" column-width="45mm"/>
		<fo:table-column column-number="7" column-width="35mm"/>
		<fo:table-column column-number="8" column-width="40mm"/>

		<xsl:if test="count(TAREAS)=0">
			<fo:table-body background-color="#000000">
				<fo:table-row>
					<fo:table-cell number-columns-spanned="9">
						<fo:block font-weight="bold" color="#FFFFFF" 
							text-align="center" font-size="9pt">Sin Resultados</fo:block>
					</fo:table-cell>
				</fo:table-row>
			</fo:table-body>
		</xsl:if>

		<xsl:for-each select="TAREAS/TAREAS">
			<!--Primera Cabera-->
			<xsl:if test="position()=1">
				
			<fo:table-header background-color="#000000">
				<fo:table-row>
					<fo:table-cell>
						<fo:block font-weight="bold" color="#FFFFFF" 
							text-align="center" font-size="10pt">Cdigo
						</fo:block>
					</fo:table-cell>
					<fo:table-cell>
						<fo:block font-weight="bold" color="#FFFFFF" 
							text-align="center" font-size="10pt">Tipo
						</fo:block>
					</fo:table-cell>
					<!--La prioridad slo aparece en informes de pendientes-->
					<xsl:if test="$TipoCheck='Pe'">
						<fo:table-cell>
							<fo:block font-weight="bold" color="#FFFFFF" 
								text-align="center" font-size="10pt">Prioridad
							</fo:block>
						</fo:table-cell>
					</xsl:if>
					<fo:table-cell>
						<fo:block color="#FFFFFF" font-weight="bold"
							text-align="center" font-size="10pt">Estado
						</fo:block>
					</fo:table-cell>
					<fo:table-cell>
					<fo:block color="#FFFFFF" font-weight="bold"
							text-align="center" font-size="10pt">F.Solicitud
						</fo:block>
					</fo:table-cell>
					<fo:table-cell>
					<fo:block color="#FFFFFF" font-weight="bold"
							text-align="center" font-size="10pt">F.Asignacin
						</fo:block>
					</fo:table-cell>
					<!--La fecha prevista de resolucin slo aparece en informes de planificadas-->
					<xsl:if test="$TipoCheck='Pl'">
						<fo:table-cell>
							<fo:block font-weight="bold" color="#FFFFFF" 
								text-align="center" font-size="10pt">F. Prevista Resol.
							</fo:block>
						</fo:table-cell>
					</xsl:if>
					<fo:table-cell>
					<fo:block color="#FFFFFF" font-weight="bold"
							text-align="center" font-size="10pt">F.Alarma
						</fo:block>
					</fo:table-cell>
					<fo:table-cell>
					<fo:block color="#FFFFFF" font-weight="bold"
							text-align="center" font-size="10pt">N.Alarmas
						</fo:block>
					</fo:table-cell>
				</fo:table-row>			
			</fo:table-header>
			
			</xsl:if>
								
			<fo:table-body text-align="left" start-indent="3pt">
			<!--Datos primera cabecera-->
				<fo:table-row>
					<fo:table-cell>
						<fo:block font-size="9pt" 
							start-indent="0pt"		 
							font-family="sans-serif" 
							line-height="12pt"
							space-after.optimum="0pt"
							text-align="center">
							<xsl:value-of select="@CODIGO"/> 
						</fo:block>
					</fo:table-cell>
					<fo:table-cell>
						<fo:block font-size="9pt" 
							start-indent="0pt"		 
							font-family="sans-serif" 
							line-height="12pt"
							space-after.optimum="0pt"
							text-align="center">
							<xsl:value-of select="@TIPO_TAREA"/> 
						</fo:block>
					</fo:table-cell>
					<!--La prioridad slo aparece en informes de pendientes-->
					<xsl:if test="$TipoCheck='Pe'">
						<fo:table-cell>
							<fo:block font-size="9pt" 
								start-indent="0pt"		 
								font-family="sans-serif" 
								line-height="12pt"
								space-after.optimum="0pt"
								text-align="center">
								<xsl:call-template name="prioridad"/>
							</fo:block>
						</fo:table-cell>
					</xsl:if>
					<fo:table-cell>
						<fo:block font-size="9pt" 
							start-indent="0pt"		 
							font-family="sans-serif" 
							line-height="12pt"
							space-after.optimum="0pt"
							text-align="left">
							<xsl:choose>
								<xsl:when test="@ESTADO='P'">Pendiente asignacin</xsl:when>
								<xsl:when test="@ESTADO='A'">Asignada</xsl:when>
								<xsl:when test="@ESTADO='W'">En espera</xsl:when>
								<xsl:when test="@ESTADO='N'">Anulada</xsl:when>
								<xsl:when test="@ESTADO='R'">Resuelta</xsl:when>
								<xsl:when test="@ESTADO='X'">Rechazada</xsl:when>
								<xsl:when test="@ESTADO='F'">Res con subtareas</xsl:when>
							</xsl:choose>   
						</fo:block>
					</fo:table-cell>
					
					<fo:table-cell>
						<fo:block font-size="9pt" 
							start-indent="0pt"		 
							font-family="sans-serif" 
							line-height="12pt"
							space-after.optimum="0pt"
							text-align="center">
							<xsl:call-template name="date2String2"><xsl:with-param name="fecha" select="@FECHA_CREACION"/></xsl:call-template>																		
						</fo:block>
					</fo:table-cell>
					<fo:table-cell>
						<fo:block font-size="9pt" 
							start-indent="0pt"		 
							font-family="sans-serif" 
							line-height="12pt"
							space-after.optimum="0pt"
							text-align="center">
							<xsl:call-template name="movimiento"/>
						</fo:block>
					</fo:table-cell>
					<!--La fecha prevista de resolucin slo aparece en informes de planificadas-->
					<xsl:if test="$TipoCheck='Pl'">
						<fo:table-cell>
							<fo:block font-size="9pt" 
								start-indent="0pt"		 
								font-family="sans-serif" 
								line-height="12pt"
								space-after.optimum="0pt"
								text-align="center">
								<xsl:call-template name="date2String2"><xsl:with-param name="fecha" select="@PLANIFICACION"/></xsl:call-template>
							</fo:block>
						</fo:table-cell>
					</xsl:if>
					<fo:table-cell>
						<fo:block font-size="9pt" 
							start-indent="0pt"		 
							font-family="sans-serif" 
							line-height="12pt"
							space-after.optimum="0pt"
							text-align="center">
							<xsl:call-template name="date2String2"><xsl:with-param name="fecha" select="../TAREAS_ALERTAS/@FECHA_ALERTA"/></xsl:call-template>
						</fo:block>
					</fo:table-cell>
					<fo:table-cell>
						<fo:block font-size="9pt" 
							start-indent="0pt"		 
							font-family="sans-serif" 
							line-height="12pt"
							space-after.optimum="0pt"
							text-align="center">
							<xsl:call-template name="numero_alertas"/>
						</fo:block>
					</fo:table-cell>
				</fo:table-row>
			</fo:table-body>
				
			<xsl:if test="position()=1">
			<!--Segunda cabecera-->
			<fo:table-body background-color="#000000">
				<fo:table-row>
					<fo:table-cell>
						<fo:block color="#FFFFFF" font-weight="bold"
							text-align="left" font-size="10pt">
							&#160;
						</fo:block>
					</fo:table-cell>
					<fo:table-cell number-columns-spanned="2">
						<fo:block color="#FFFFFF" font-weight="bold"
							text-align="left" font-size="10pt">
							Aplicacin
						</fo:block>
					</fo:table-cell>
					<fo:table-cell number-columns-spanned="2">
						<fo:block color="#FFFFFF" font-weight="bold"
							text-align="left" font-size="10pt">
							Solicitante
						</fo:block>
					</fo:table-cell>
					<fo:table-cell number-columns-spanned="2">
						<fo:block color="#FFFFFF" font-weight="bold"
							text-align="left" font-size="10pt">
							Asunto
						</fo:block>
					</fo:table-cell>
				</fo:table-row>
			</fo:table-body>
			</xsl:if>

			<fo:table-body text-align="left" start-indent="3pt">
				<!--Datos segunda cabecera-->
				<fo:table-row>
					<fo:table-cell>
						<fo:block font-size="9pt" 
							start-indent="0pt"		 
							font-family="sans-serif" 
							line-height="12pt"
							space-after.optimum="0pt"
							text-align="left">
							&#160;
						</fo:block>
					</fo:table-cell>
					<fo:table-cell number-columns-spanned="2">
						<fo:block font-size="9pt" 
							start-indent="0pt"		 
							font-family="sans-serif" 
							line-height="12pt"
							space-after.optimum="0pt"
							text-align="left">
							<xsl:value-of select="@APLICACION"/>
							<!--<xsl:call-template name="aplicacion"/>-->
						</fo:block>
					</fo:table-cell>
					<fo:table-cell number-columns-spanned="2">
						<fo:block font-size="9pt" 
							start-indent="0pt"		 
							font-family="sans-serif" 
							line-height="12pt"
							space-after.optimum="0pt"
							text-align="left">
							<xsl:call-template name="solicitante"/>
							<!--<xsl:value-of select="@USUARIO"/> -->
						</fo:block>
					</fo:table-cell>

					<fo:table-cell number-columns-spanned="3">
						<fo:block font-size="9pt" 
							start-indent="0pt"		 
							font-family="sans-serif" 
							line-height="12pt"
							space-after.optimum="0pt"
							text-align="left">
							<xsl:value-of select="@ASUNTO"/> 
						</fo:block>
					</fo:table-cell>
				</fo:table-row>
				<fo:table-row>
					<fo:table-cell number-columns-spanned="8">
						<fo:block border-bottom="1pt solid #808080"/>
					</fo:table-cell>
				</fo:table-row>
			</fo:table-body>
			
			</xsl:for-each>
	</fo:table>
</xsl:template>

<xsl:template name="prioridad">
	<xsl:variable name="CodigoPrioridad"><xsl:value-of select="@PRIORIDAD"/></xsl:variable>
	<xsl:if test="count(../../PRIORIDAD[@CODIGO = $CodigoPrioridad])= 0">	
		Sin prioridad
	</xsl:if> 
	<xsl:for-each select="../../PRIORIDAD">		
		<xsl:if test="@CODIGO = $CodigoPrioridad"> 
			<xsl:value-of select="@DESCRIPCION"/>			
		</xsl:if>
	</xsl:for-each>
</xsl:template>

<xsl:template name="solicitante">
	<xsl:variable name="CodigoUsuario"><xsl:value-of select="@USUARIO"/></xsl:variable> 
	<xsl:for-each select="../../DATOS_PERSONALES">
		<xsl:if test="@IDENTIFICADOR=$CodigoUsuario">
			<xsl:value-of select="@APELLIDOS"/>,&#160;<xsl:value-of select="@NOMBRE"/>
		</xsl:if>
	</xsl:for-each>
</xsl:template>
	
<xsl:template name="cuerpo">	
</xsl:template>

<xsl:template name="movimiento">
	<!--Mostramos el ultimo movimiento de la tarea, aunque puede que la tarea no este asignada y no tenga ningun movimiento-->
	<xsl:variable name="CodigoTarea"><xsl:value-of select="@CODIGO"/></xsl:variable> 
	<xsl:if test="count(../../MOVIMIENTOS[@TAREA=$CodigoTarea])=0">
		Sin asignar
	</xsl:if>
	<xsl:for-each select="../../MOVIMIENTOS">
		<xsl:if test="@TAREA=$CodigoTarea">
			<xsl:call-template name="date2String2"><xsl:with-param name="fecha" select="@FECHA"/></xsl:call-template>
		</xsl:if>
	</xsl:for-each>
</xsl:template>

<xsl:template name="numero_alertas">
	<xsl:variable name="CodigoTarea"><xsl:value-of select="@CODIGO"/></xsl:variable> 
	<!--Mostramos el nivel de la alerta de mayor nivel de la tarea-->
	<xsl:for-each select="../../ALERTA_MAXNIVEL ">
		<xsl:if test="@TAREA=$CodigoTarea">
			<xsl:value-of select="@NIVEL"/>
		</xsl:if>
	</xsl:for-each>
</xsl:template>

</xsl:stylesheet>

