<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet version="1.0"
     xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	 xmlns:xforms="http://www.w3.org/2002/xforms" 
     xmlns:fo="http://www.w3.org/1999/XSL/Format" >

<xsl:param name="servlet"/>
<xsl:param name="menu"/>

<xsl:include href="dumbo7/utils/xsl/utils.xsl"/>

<xsl:template match="XMLROOT">
	<fo:root>
		<fo:layout-master-set >

			<fo:simple-page-master master-name="simple"
					page-height="21cm" 
					page-width="29.7cm"
					margin-top="0.5cm" 
					margin-bottom="1.5cm" 
					margin-left="2cm" 
					margin-right="2cm">
				<fo:region-body border="0.25pt solid silver" margin-top="1cm" margin-bottom="0.5cm"/>
				<fo:region-before border="0.25pt solid silver" />
				<fo:region-after extent="0.5cm"/>
			</fo:simple-page-master>
		</fo:layout-master-set>

<fo:page-sequence master-reference="simple" >
				
  <fo:static-content flow-name="xsl-region-before">
    <fo:block background-color="#000000">
	<!--CABECERA DUMBO-->
    </fo:block>
  </fo:static-content>
		<!--PIE DUMBO-->
		<fo:static-content flow-name="xsl-region-after">
			<fo:table>
				<fo:table-column column-number="1"/>
				<fo:table-body>
					<fo:table-row>
						<!--Numeracin del pie-->
						<fo:table-cell>
							<!--Lo pone en la primera pgina-->
			               <fo:block text-align="center" font-size="8pt">
					          &#160;Pgina <fo:page-number/>  &#160;de <fo:page-number-citation ref-id="last-page"/>
					       </fo:block>
						   <!--Lo pone en las siguientes-->
						   <fo:block text-align="center" font-size="8pt" break-before="page"> 
		                     &#160; Pgina <fo:page-number/>  &#160;de <fo:page-number-citation ref-id="last-page"/>
					       </fo:block>
						</fo:table-cell>
					</fo:table-row>
				</fo:table-body>
			</fo:table>
          </fo:static-content>
		<fo:flow flow-name="xsl-region-body">
			<xsl:apply-templates/>
			<fo:block id="last-page"/>
		</fo:flow>
</fo:page-sequence>
	</fo:root>	
</xsl:template>

<!--CUERPO PDF-->
<xsl:template match="DATA">
	<fo:block text-align="left" font-size="22" color="#000000">&#160;&#160;&#160;RESUMEN ALERTAS NIVEL 3</fo:block>
	<fo:block text-align="right"><xsl:value-of select="ALERTAS/@FECHA-ACTUAL"/></fo:block>
	<xsl:apply-templates/>
</xsl:template>

<xsl:template match="ALERTAS">
		<!--Inicializacin de las columnas-->
		<fo:table border="0.25pt solid silver">
		<fo:table-column column-number="1" column-width="70mm"/> <!--Informtico-->
		<fo:table-column column-number="2" column-width="25mm"/> <!--Aplicacin-->
		<fo:table-column column-number="3" column-width="22mm"/> <!--Fecha-->
		<fo:table-column column-number="4" column-width="14mm"/> <!--Cdigo-->		
		<fo:table-column column-number="5" column-width="14mm"/> <!--Tipo-->
		<fo:table-column column-number="6" column-width="55mm"/> <!--Asunto-->
		<fo:table-column column-number="7" column-width="14mm"/> <!--Estado-->
		<fo:table-column column-number="8" column-width="25mm"/> <!--Prioridad (Fecha planificacin)-->
		<fo:table-column column-number="9" column-width="22mm"/> <!--Fecha Alerta-->
		
		<xsl:if test="count(TAREAS)=0">
			<fo:table-body background-color="#000000">
				<fo:table-row>
					<fo:table-cell number-columns-spanned="11">
						<fo:block font-weight="bold" color="#FFFFFF" 
							text-align="center" font-size="9pt">Sin Resultados</fo:block>
					</fo:table-cell>
				</fo:table-row>
			</fo:table-body>
		</xsl:if>

		<xsl:if test="count(TAREAS/TAREAS)!= 0">
			<xsl:for-each select="TAREAS/TAREAS">
				<!--Primera Cabecera-->
				<xsl:if test="position()=1">
				<fo:table-header background-color="#000000">
					<fo:table-row>
						<fo:table-cell>
							<fo:block font-weight="bold" color="#FFFFFF" 
								text-align="left" font-size="10pt">Apellidos, Nombre
							</fo:block>
						</fo:table-cell>
						<fo:table-cell>
							<fo:block color="#FFFFFF" font-weight="bold"
								text-align="left" font-size="10pt">Aplicacin
							</fo:block>
						</fo:table-cell>
						<fo:table-cell>
							<fo:block color="#FFFFFF" font-weight="bold"
								text-align="center" font-size="10pt">Fecha
							</fo:block>
						</fo:table-cell>
						<fo:table-cell>
							<fo:block color="#FFFFFF" font-weight="bold"
								text-align="left" font-size="10pt">Cdigo
							</fo:block>
						</fo:table-cell>
						<fo:table-cell>
							<fo:block font-weight="bold" color="#FFFFFF"
								text-align="center" font-size="10pt">Tipo
							</fo:block>
						</fo:table-cell>
						<fo:table-cell>
							<fo:block font-weight="bold" color="#FFFFFF"
								text-align="left" font-size="10pt">Asunto
							</fo:block>
						</fo:table-cell>
						<fo:table-cell>
							<fo:block color="#FFFFFF" font-weight="bold"
								text-align="left" font-size="10pt">Estado
							</fo:block>
						</fo:table-cell>
						<fo:table-cell>
							<fo:block font-weight="bold" color="#FFFFFF" 
								text-align="center" font-size="10pt">Prioridad
							</fo:block>
						</fo:table-cell>
						<fo:table-cell>
						<fo:block color="#FFFFFF" font-weight="bold"
								text-align="center" font-size="10pt">F.Alerta
							</fo:block>
						</fo:table-cell>
					</fo:table-row>
				</fo:table-header>
				</xsl:if>
				<fo:table-body text-align="left" start-indent="3pt">
					<!--Datos-->
					<fo:table-row>	
						<fo:table-cell>
							<fo:block font-size="9pt" 
								start-indent="0pt"		 
								font-family="sans-serif" 
								line-height="12pt"
								space-after.optimum="0pt"
								text-align="left">
								<xsl:value-of select="../DATOSPERSONALES/@APELLIDOS"/>,&#160;<xsl:value-of select="../DATOSPERSONALES/@NOMBRE"/>
							</fo:block>
						</fo:table-cell>
						<fo:table-cell>
							<fo:block font-size="9pt" 
								start-indent="0pt"		 
								font-family="sans-serif" 
								line-height="12pt"
								space-after.optimum="0pt"
								text-align="left">
								&#160;<xsl:value-of select="@APLICACION"/>
							</fo:block>
						</fo:table-cell>
						<fo:table-cell>
							<fo:block font-size="9pt" 
								start-indent="0pt"		 
								font-family="sans-serif" 
								line-height="12pt"
								space-after.optimum="0pt"
								text-align="center">
								<xsl:call-template name="date2String2"><xsl:with-param name="fecha" select="@FECHA_CREACION"/></xsl:call-template>																		
							</fo:block>
						</fo:table-cell>
						<fo:table-cell>
							<fo:block font-size="9pt" 
								start-indent="0pt"		 
								font-family="sans-serif" 
								line-height="12pt"
								space-after.optimum="0pt"
								text-align="center">
								<xsl:value-of select="@CODIGO"/>
							</fo:block>
						</fo:table-cell>
						<fo:table-cell>
							<fo:block font-size="9pt" 
								start-indent="0pt"		 
								font-family="sans-serif" 
								line-height="12pt"
								space-after.optimum="0pt"
								text-align="center">
								<xsl:value-of select="@TIPO_TAREA"/>
							</fo:block>
						</fo:table-cell>
						<fo:table-cell>
							<fo:block font-size="9pt" 
								start-indent="0pt"		 
								font-family="sans-serif" 
								line-height="12pt"
								space-after.optimum="0pt"
								text-align="left">
								<xsl:value-of select="@ASUNTO"/>
							</fo:block>
						</fo:table-cell>
						<fo:table-cell>
							<fo:block font-size="9pt" 
								start-indent="0pt"		 
								font-family="sans-serif" 
								line-height="12pt"
								space-after.optimum="0pt"
								text-align="center">
								<xsl:value-of select="@ESTADO"/>
							</fo:block>
						</fo:table-cell>
						<fo:table-cell>
							<fo:block font-size="9pt" 
								start-indent="0pt"		 
								font-family="sans-serif" 
								line-height="12pt"
								space-after.optimum="0pt"
								text-align="center">
								<xsl:value-of select="@PRIORIDAD"/>
								<xsl:if test="@PRIORIDAD='P'">
									&#160;<xsl:call-template name="date2String2"><xsl:with-param name="fecha" select="@PLANIFICACION"/></xsl:call-template>
								</xsl:if>
							</fo:block>
						</fo:table-cell>
						<fo:table-cell>
							<fo:block font-size="9pt" 
								start-indent="0pt"		 
								font-family="sans-serif" 
								line-height="12pt"
								space-after.optimum="0pt"
								text-align="center">
								<xsl:call-template name="date2String2"><xsl:with-param name="fecha" select="../TAREAS_ALERTAS/@FECHA_ALERTA"/></xsl:call-template>
							</fo:block>
						</fo:table-cell>
					</fo:table-row>
				</fo:table-body>		
				<fo:table-body text-align="left" start-indent="3pt">
					<fo:table-row>
						<fo:table-cell number-columns-spanned="9">
							<fo:block border-bottom="1pt solid #808080"/>
						</fo:table-cell>
					</fo:table-row>
				</fo:table-body>
			</xsl:for-each>
		</xsl:if>
	</fo:table>
</xsl:template>

<xsl:template name="cuerpo">
		
</xsl:template>
</xsl:stylesheet>