<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet version="1.0" 
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:xforms="http://www.w3.org/2002/xforms">
	
<xsl:param name="servlet"/>	
<xsl:param name="menu"/>
<xsl:param name="code"/>

<xsl:include href="dumbo7/utils/xsl/utils.xsl"/>

<xsl:template match="XMLROOT">
<html>
	<xsl:call-template name="headComun">
		<xsl:with-param name="solicitudes" select="DATA/DUMBOS/SOLICITUD"/>
		<xsl:with-param name="jscript">
			<SCRIPT LANGUAGE="JavaScript">
			function printDetalle(code) {
				document.imprimeDetalle.selected.value = code;
				document.imprimeDetalle.submit();
			}
			function verHistorial(code) {
				var w = window.open('about:blank','Historial','width=700,height=350,left=100,top=100,scrollbars=yes');
				document.formHist.selected.value = code;
				document.formHist.target = w.name;
				document.formHist.submit();
				w.focus();
			}
			function download(tarea,fecha,file,tipo) {
				document.downAnexo.anexo.value = fecha.substring(3,5)+'-'+fecha.substring(6,10)+'/'+tipo+'AnexoTarea_'+tarea.trim()+'_'+file.trim();
				document.downAnexo.submit();
			}
			</SCRIPT>
		</xsl:with-param>
	</xsl:call-template>
<body>
<xsl:variable name="claseTarea">
	<xsl:choose>
		<xsl:when test="DATA/ALERTAS/SOLICITUD/@TIPO_TAREA='P'">Peticin</xsl:when>
		<xsl:when test="DATA/ALERTAS/SOLICITUD/@TIPO_TAREA='I'">Incidencia</xsl:when>
		<xsl:when test="DATA/ALERTAS/SOLICITUD/@TIPO_TAREA='B'">Problema</xsl:when>
		<xsl:when test="DATA/ALERTAS/SOLICITUD/@TIPO_TAREA='A'">Programada</xsl:when>
		<xsl:when test="DATA/ALERTAS/SOLICITUD/@TIPO_TAREA='R'">Dumbo Rpido</xsl:when>
		<xsl:otherwise>Tipo <xsl:value-of select="DATA/ALERTAS/SOLICITUD/@TIPO_TAREA"/></xsl:otherwise>
	</xsl:choose>
</xsl:variable>
<table class="cab1det">
<tr>
	<xsl:if test="count(DATA/ALERTAS/SOLICITUD)=0">
		<td align="left" width="1%"><img src="../graficos/iconos/A.gif"/></td>
	</xsl:if>
	<xsl:if test="count(DATA/ALERTAS/SOLICITUD)>0">
		<td align="left" width="1%"><img src="../graficos/iconos/{DATA/ALERTAS/SOLICITUD/@ESTADO}.gif"/></td>
	</xsl:if>
	<td align="left" width="70%" valing="top">Detalle Tarea:&#160;<i><xsl:value-of select="$claseTarea"/></i></td>
	<td align="right" width="100%"><a href="javascript:printDetalle('{$code}');"><img title="Imprimir Tarea" src="../graficos/iconos/imprimir_ico.gif" border="0"/></a>&#160;&#160;<a href="javascript:verHistorial('{$code}');"><img title="Ver Historial" src="../graficos/iconos/historial_ico.gif" border="0"/></a>&#160;&#160;</td>
</tr>
</table>
<table class="contdet">
	<xsl:for-each select="DATA/ALERTAS/SOLICITUD">

		<tr class="cabe"><td><strong>Datos Tarea</strong></td></tr>
		<tr class="cont">
			<td>
				<i>&#183;&#160;C&#243;digo:</i>&#160;<xsl:value-of select="@CODIGO"/>&#160;&#160;<xsl:if test="string-length(@PADRE)>0">(<xsl:value-of select="@PADRE"/>)&#160;&#160;</xsl:if>
				<i>&#160;Fecha:</i>&#160;<xsl:call-template name="date2String"><xsl:with-param name="fecha"><xsl:value-of select="@FECHA_CREACION"/></xsl:with-param></xsl:call-template><br/>
				<i>&#160;Solicitante:</i>&#160;<xsl:value-of select="@USUNOMBRE"/>&#160;(<xsl:value-of select="@USUEMAIL"/>)<br/>
				<i>&#160;<xsl:call-template name="traduce"><xsl:with-param name="id" select="'Informatico'"/></xsl:call-template>:</i>&#160;<xsl:if test="string-length(@INFEMAIL)>0"><xsl:value-of select="@INFNOMBRE"/>&#160;(<xsl:value-of select="@INFEMAIL"/>)</xsl:if>
			</td>
		</tr>
		<tr class="cabe"><td><strong>Informacin Tarea</strong></td></tr>
		<tr class="cont">
		<td>
			<table>
		<tr class="cont">
			<td>
				<i>&#160;Asunto:</i>&#160;<xsl:value-of select="@ASUNTO"/><input type="hidden" name="tarAsunHidden" value="{@ASUNTO}"/>
			</td>
		</tr>
		<tr class="cont">
			<td>
				<i>&#160;Texto Tarea:</i>
					<div style="padding-left:0.2cm;padding-top:0.2cm;width:730px;height:80px;overflow:auto;background-color: #FFFFD9;">
						<pre><xsl:value-of select="@DESCRIPCION"/></pre>
				</div>
			</td>
		</tr>
		<xsl:if test="@ESTADO='P'">
		<tr class="cont">
			<td>
				<i>&#160;Texto Seguimiento:</i>
				<br/>
				<div style="padding-left:0.2cm;padding-top:0.2cm;width:730px;height:80px;overflow:auto;background-color: #FFFFD9;">
						<pre><xsl:value-of select="@DESCRIPCION_SEGUIMIENTO"/></pre>
				</div>
			</td>
		</tr>
		</xsl:if>
		<tr class="cont">
			<td>
				<i>&#160;Urgencia:</i>&#160;
				<xsl:choose>
					<xsl:when test="@ESTADO='P'">
						<SELECT NAME="tarUrgencia" SIZE="1">
							<OPTION VALUE="N"><xsl:if test="@URGENCIA='N'"><xsl:attribute name="selected">true</xsl:attribute></xsl:if>No Urgente</OPTION>
							<OPTION VALUE="U"><xsl:if test="@URGENCIA='U'"><xsl:attribute name="selected">true</xsl:attribute></xsl:if>Urgente</OPTION>
						</SELECT>
					</xsl:when>
					<xsl:otherwise>
						<xsl:if test="@URGENCIA='N'">No Urgente</xsl:if>
						<xsl:if test="@URGENCIA='U'">Urgente</xsl:if>
					</xsl:otherwise>
				</xsl:choose>
				<xsl:if test="not(@TIPO_TAREA='I')">
				&#160;&#160;
				<i>&#160;Fecha Max. Resol.:</i>&#160;
					<xsl:choose>
						<xsl:when test="@ESTADO='P'">
							<input type="text" name="tarFecmaxResol" id="f_tarFecmaxResol" onChange="changeDate(this,'La Fecha Mxima de Resolucin ')"><xsl:attribute name="value"><xsl:call-template name="date2String2"><xsl:with-param name="fecha"><xsl:value-of select="@FECHA_MAX_RESOLUCION"/></xsl:with-param></xsl:call-template></xsl:attribute></input>
							<img src="../graficos/iconos/calendario_ico.gif" id="f_trigger_a"
							style="cursor: pointer; border: 1px solid red;"
							title="Selecciona Fecha Mxima de Resolucin"
							onmouseover="this.style.background='red';"
							onmouseout="this.style.background=''"/>
						</xsl:when>
						<xsl:otherwise>
							<xsl:call-template name="date2String2"><xsl:with-param name="fecha"><xsl:value-of select="@FECHA_MAX_RESOLUCION"/></xsl:with-param></xsl:call-template>
						</xsl:otherwise>
					</xsl:choose>
				</xsl:if>
				&#160;&#160;
				<span id="emc"><i>&#160;Copia:</i>&#160;<xsl:value-of select="translate(@EMAIL_COPIA,',',' ')"/></span>
				&#160;&#160;
				<i>&#160;Tlfn.Contacto:</i>&#160;<xsl:value-of select="@TELEFONO"/>
			</td>
		</tr>
		<tr class="cont">
			<td>
				<i>&#160;Ubicacin:</i>
				<xsl:if test="string-length(@UBICACION)>0">
				<div style="padding-left:0.2cm;padding-top:0.2cm;width:730px;height:80px;overflow:auto;background-color: #FFFFD9;">
						<pre><xsl:value-of select="@UBICACION"/></pre>
				</div>
				</xsl:if>
			</td>
		</tr>
		<tr class="cont">
			<xsl:variable name="cod"><xsl:value-of select="@CODIGO"/></xsl:variable>
			<td><xsl:choose>
					<xsl:when test="count(../ANEXOS[@tipo='S'])>0">
						<table>
						<tr>
							<td valign="top"><i>Anexos</i><br/>
							<xsl:for-each select="../ANEXOS">
								<xsl:choose>
									<xsl:when test="../ANEXOS/codigo=$cod and tipo='S'">
										<a href="javascript:download('{codigo}','{fecha}','{nombre}','');"><xsl:value-of select="nombre"/>&#160;<xsl:value-of select="size"/></a><br/> 
									</xsl:when>
									</xsl:choose>
								</xsl:for-each>
							</td>
							<td valign="top">
							<xsl:choose>
								<xsl:when test="../ANEXOS/codigo!=$cod and tipo='S'">
								<i>Anexos Tarea Padre</i><br/>
								<xsl:for-each select="../ANEXOS">
								<xsl:choose>
									<xsl:when test="../ANEXOS/codigo!=$cod and tipo='S'">
									<a href="javascript:download('{codigo}','{fecha}','{nombre}','');"><xsl:value-of select="nombre"/>&#160;<xsl:value-of select="size"/></a><br/> 
									</xsl:when>
									</xsl:choose>
								</xsl:for-each>
							</xsl:when>
							</xsl:choose>
							</td>
						</tr>
						</table>
					</xsl:when>
					<xsl:otherwise>
						<i>&#160;Anexos:</i>&#160;&#160;
					</xsl:otherwise>
				</xsl:choose>
			</td>
		</tr>
		</table>
		</td>
		</tr>
		
		<tr class="cabe"><td><strong>Gestin Tarea</strong></td></tr>
		<tr class="cont">
		<td>
		<table>
		<tr class="cont">
			<td>
				<table>
				<tr>
					<td>
						<i>&#160;Aplicacin:</i>
						<xsl:value-of select="@APLICACION"/><input type="hidden" name="tarAplCod" value="{@APLICACION}"/>
					</td>
				</tr>
				</table>
			</td>
		</tr>
		<tr class="cont">
			<td>
				<table>
				<tr>
					<td>
						<i>&#160;Categora:</i>
						<xsl:value-of select="@CATEGORIADESC"/><input type="hidden" name="cat" value="{@CATEGORIADESC}"/>
					</td>
				</tr>
				</table>
			</td>
		</tr>
		<tr class="cont">
			<td>
				<i>&#160;Texto&#160;Seguimiento:</i><br/>
				<div style="padding-left:0.2cm;padding-top:0.2cm;width:730px;height:80px;overflow:auto;background-color: #FFFFD9;">
						<pre><xsl:value-of select="@DESCRIPCION_SEGUIMIENTO"/></pre>
				</div>
			</td>
		</tr>
		<tr class="cont">
			<td valign="top">
				<xsl:variable name="cod"><xsl:value-of select="@CODIGO"/></xsl:variable>
				<xsl:choose>
					<xsl:when test="../ANEXOS/tipo='P'">
						<table>
						<tr>
							<td valign="top"><i>Anexos Pblicos</i><br/>
								<xsl:for-each select="../ANEXOS">
								<xsl:choose>
									<xsl:when test="../ANEXOS/codigo=$cod and tipo='P'">
										<a href="javascript:download('{codigo}','{fecha}','{nombre}','{tipo}');"><xsl:value-of select="nombre"/>&#160;<xsl:value-of select="size"/></a><br/> 
									</xsl:when>
									</xsl:choose>
								</xsl:for-each>
							</td>
							<td valign="top">
							<xsl:choose>
								<xsl:when test="../ANEXOS/codigo!=$cod and tipo='P'">
								<i>Anexos Pblicos Tarea Padre</i><br/>
								<xsl:for-each select="../ANEXOS">
								<xsl:choose>
									<xsl:when test="../ANEXOS/codigo!=$cod and tipo='P'">
									<a href="javascript:download('{codigo}','{fecha}','{nombre}','{tipo}');"><xsl:value-of select="nombre"/>&#160;<xsl:value-of select="size"/></a><br/> 
									</xsl:when>
									</xsl:choose>
								</xsl:for-each>
							</xsl:when>
							</xsl:choose>
							</td>
						</tr>
						</table>
					</xsl:when>
				</xsl:choose>
			</td>
		</tr>
		<tr class="cont">
			<td><i>&#160;Prioridad:</i>&#160;
				<xsl:value-of select="@PRIORIDADDESC"/><input type="hidden" name="tarPrio" value="{@PRIORIDADDESC}"/>
				<label id="fpr"><xsl:attribute name="style"><xsl:if test="not(@PRIORIDAD) or (@PRIORIDAD!='P')">display:none;</xsl:if></xsl:attribute>&#160;&#160;<i>&#160;Fecha Prevista:</i>&#160;
					<xsl:call-template name="date2String2"><xsl:with-param name="fecha"><xsl:value-of select="@PLANIFICACION"/></xsl:with-param></xsl:call-template>
				</label>
				<xsl:if test="(@ESTADO='R' or @ESTADO='F')">
					&#160;<i>&#160;Fecha Fin:</i>&#160;
					<xsl:call-template name="date2String"><xsl:with-param name="fecha"><xsl:value-of select="@FECHA_FIN"/></xsl:with-param></xsl:call-template>
				</xsl:if>
			</td>
		</tr>
		</table>
		</td></tr>
		</xsl:for-each>
		<tr class="cont">
			<td><input align="right" class="boton" type="button" value="Cerrar" onclick="top.close();"/>&#160;</td>
		</tr>
</table>
<form name="formHist" action="{$servlet}" method="post">
	<input type="hidden" name="module" value="dumbo7/atencion.verHistorial"/>
	<input type="hidden" name="menu" value="{$menu}"/>
	<input type="hidden" name="selected" value=""/>
</form>
<form name="imprimeDetalle" action="{$servlet}" method="post">
	<input type="hidden" name="module" value="dumbo7/atencion.imprimeDetalle"/>
	<input type="hidden" name="menu" value="{$menu}"/>
	<input type="hidden" name="selected" value=""/>
</form>
<form name="downAnexo" action="{$servlet}" method="post">
	<input type="hidden" name="module" value="dumbo7/atencion.download"/>
	<input type="hidden" name="anexo" value=""/>
</form>
</body>
</html>
</xsl:template>
<xsl:template name="cuerpo">
</xsl:template>
</xsl:stylesheet>
