<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet version="1.0" 
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:xforms="http://www.w3.org/2002/xforms">

<!--Formulario para Maestros (Nivel Alertas 3). Slo se mostrarn Alertas de ste nivel-->
<xsl:param name="Nivel"><xsl:value-of select="3"/></xsl:param> 
<!--Include para los template que se encargan de jerarquizar el select de categoras-->
<xsl:include href="dumbo7/metricas/html/ArbolEnSelect.xsl"/>	

<xsl:param name="servlet"/>	
<xsl:param name="menu"/>

<xsl:include href="dumbo7/utils/xsl/utils.xsl"/>
<xsl:template match="XMLROOT">

<html lang="es">
     <xsl:call-template name="headComun">
		<xsl:with-param name="calendar" select="not(contains($menu,'Inc'))"/>
		<xsl:with-param name="jscript">
			<script LANGUAJE="JavaScript" src="../js/CompruebaFecha.js"></script>
			<script LANGUAJE="JavaScript">
						
				function mostrarError(error){
					alert(error);
				}  
         
				function EnviarAPDF(url){
					newWindow = window.open(url,'_blanck');
				}
				
            </script>
		</xsl:with-param>
	   </xsl:call-template>
<body>
	<xsl:call-template name="menuComun">
		<xsl:with-param name="NAME" select="concat(DATA/ALERTAS/USER/@NAME,concat('(',concat(DATA/ALERTAS/USER/@LOGIN,')')))"/>
		<xsl:with-param name="MENU" select="DATA/MENU"/>
		<xsl:with-param name="SELECT" select="$menu"/>
		<xsl:with-param name="HELP">alertas.xml#9.3.2</xsl:with-param>
	</xsl:call-template>
	
<xsl:call-template name="pieComun"/>
	</body>
	</html>
</xsl:template>

<xsl:template name="cuerpo">
	<xsl:for-each select="DATA/ALERTAS">
		<xsl:if test="not(@ERROR='')">
			<script>mostrarError('<xsl:value-of select="@ERROR"/>')</script>
		</xsl:if>
	</xsl:for-each>
	<table align="center" border="0" cellpadding="3" cellspacing="1" width="250" height="16" summary="Esta tabla contiene informes de alertas">
		<tr><td width="300" colspan="2" class="cab1">Resumen de alertas de nivel 3</td></tr>
		<tr><td>
		<form action="{$servlet}" METHOD="GET" name="informes">
		<input type="hidden" name="module" value="dumbo7/alertas.index.resumenAlertasMaestro"/>
			<table class="cont" id="informes" border="0" cellpadding="3" cellspacing="1" style="border-collapse: collapse" width="70" height="16" summary="Esta tabla contiene informes de alertas">
				<tr class="administracion">
					<td align="center"><input type="button" class="boton" value="Generar PDF" onclick="javascript:EnviarAPDF('?module=dumbo7/alertas.index.resumenAlertas');"/></td>
				</tr>
			</table>
		</form>
		</td></tr>
	</table>

</xsl:template>

</xsl:stylesheet>
	