
package dumbo7.alias;


import atica.frameweb.utils.*;
import org.hibernate.*;
import org.hibernate.criterion.*;
import java.util.*;

import dumbo7.utils.*;

/**
 * @author Universidad de Murcia - ATICA
 *
 */

public class GestorAlias extends GeneralManager {
	
	private List alias;
	protected List datosPersonales = null;
	
	public GestorAlias() {}
	
	public List getAlias() { return alias; }
	public List getDatosPersonales() { return datosPersonales; }
	
	public void listarAlias(Session conn) {
		Criteria ct = conn.createCriteria(D7AliasCorreo.class);
		ct = ct.add(Expression.eq("AliasSisCod",user.getDatosMenu().idSelected()));
		alias = ct.list();
	}
	
	public void borrarAlias(Session conn,D7AliasCorreo al) {
		try {
			Criteria ct = conn.createCriteria(D7AliasCorreo.class);
			ct = ct.add(Expression.eq("AliasSisCod",al.getAliasSisCod()));
			ct = ct.add(Expression.eq("AliasCorreo",al.getAliasCorreo()));
			List l = ct.list();
			if (l!=null && l.size()>0) {
				Transaction tx = conn.beginTransaction();
				conn.delete(l.get(0));
				tx.commit();
			}
		} catch (Exception ex) {
			setErrorMessage("BorrarAlias: "+ex);
		}
	}

	public void insertarAlias(Session conn,D7AliasCorreo al) {
		try {
			Transaction tx = conn.beginTransaction();
			conn.save(al);
			tx.commit();
		} catch (Exception ex) {
			setErrorMessage("CrearAlias: "+ex);
		}
	}
	
	public void modificarAlias(Session conn,D7AliasCorreo al) {
		try {
			Criteria ct = conn.createCriteria(D7AliasCorreo.class);
			ct = ct.add(Expression.eq("AliasSisCod",al.getAliasSisCod()));
			ct = ct.add(Expression.eq("AliasCorreo",al.getAliasCorreo()));
			List l = ct.list();
			if (l!=null && l.size()>0) {
				Transaction tx = conn.beginTransaction();
				D7AliasCorreo ali = (D7AliasCorreo)l.get(0);
				if (!al.getAliasDni().equals("")){
					if (al.getAliasDni().equals("null")) return; //Cuando pulsa cancelar
					Query q = conn.createQuery(getQuery("DatosPersonales").replaceAll(":dniAlias","('"+al.getAliasDni()+"')"));
					datosPersonales  = (List)q.list();
					if (!datosPersonales.isEmpty()){
						ali.setAliasDni(al.getAliasDni());
						conn.saveOrUpdate(ali);
						tx.commit();
					}else{
						setErrorMessage("El DNI introducido no es vlido.");
					}
				}else{
					setErrorMessage("Debe introducir un nuevo dni.");
				}
			}
		} catch (Exception ex) {
			setErrorMessage("ModificarAlias: "+ex);
		}
	}
	
	public void listarNombreAlias(Session conn) {
		try {
			if (alias==null || alias.size()==0) return;
			String dniAlias = new String();
			for (int i=0; i<alias.size(); i++) {
				dniAlias = dniAlias + "'" + ((D7AliasCorreo)alias.get(i)).getAliasDni() + "'" + ",";
			}
			dniAlias = dniAlias.substring(0,dniAlias.length()-1);//Eliminamos la ltima coma
			
			Query q = conn.createQuery(getQuery("DatosPersonales").replaceAll(":dniAlias","("+dniAlias+")"));
			datosPersonales  = (List)q.list();
			
		} catch (Exception ex) {
			setErrorMessage("listarNombreAlias: "+ex);
		}
	}
}
