<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet version="1.0" 
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:xforms="http://www.w3.org/2002/xforms">

<xsl:param name="servlet"/>	
<xsl:param name="menu"/>

	
<xsl:include href="dumbo7/utils/xsl/utils.xsl"/>
	
<xsl:template match="XMLROOT">

<html lang="es">
     <xsl:call-template name="headComun">
         <xsl:with-param name="jscript">
			<script LANGUAJE="JavaScript">
				function borrar(sis,al) {
					if (confirm('Se va a eliminar el alias: '+al+'.\nEst Seguro?')) {
						document.formDel.aliasSisCod.value = sis;
						document.formDel.aliasCorreo.value = al;
						document.formDel.submit();
					}
				}
				function modificar(sis,al) {
					if (confirm('Se va a modificar el alias: '+al+'.\nEst Seguro?')) {
						var dni = prompt('Introduzca el nuevo dni:','');
						document.formUpd.aliasSisCod.value = sis;
						document.formUpd.aliasCorreo.value = al;
						document.formUpd.aliasDni.value = dni;
						document.formUpd.submit();
					}
				}
				<xsl:if test="string-length(DATA/ALIAS/@ERROR)>0">
					alert('<xsl:value-of select="DATA/ALIAS/@ERROR"/>');
				</xsl:if>
            </script>
         </xsl:with-param>
	   </xsl:call-template>
<body>
	
	
	<xsl:call-template name="menuComun">
		<xsl:with-param name="NAME" select="concat(DATA/ALIAS/USER/@NAME,concat('(',concat(DATA/ALIAS/USER/@LOGIN,')')))"/>
		<xsl:with-param name="MENU" select="DATA/MENU"/>
		<xsl:with-param name="SELECT" select="$menu"/>
		<xsl:with-param name="HELP">administracion.xml#1.12</xsl:with-param>
	</xsl:call-template>
	
	<xsl:call-template name="pieComun"/>
	
</body>
</html>
</xsl:template>

<xsl:template name="cuerpo">
<form name="formUpd" action="{$servlet}" method="post">
<input type="hidden" name="module" value="dumbo7/alias.modificarAlias"/>
<input type="hidden" name="aliasSisCod" value=""/>
<input type="hidden" name="aliasCorreo" value=""/>
<input type="hidden" name="aliasDni" value=""/>
</form>
<form name="formDel" action="{$servlet}" method="post">
<input type="hidden" name="module" value="dumbo7/alias.borrarAlias"/>
<input type="hidden" name="aliasSisCod" value=""/>
<input type="hidden" name="aliasCorreo" value=""/>
</form>
<br/>
<table class="contout">
<tr class="peticion">
	<td><strong>Listado de Alias Para Direcciones de Correo</strong></td>
	<td align="center"><a href="{$servlet}?module=dumbo7/alias.nuevoAlias">Nuevo Alias</a></td>
</tr>
<tr><td colspan="2">
<table>
<tr class="titulo">
	<td>Alias</td>
	<td>Dni</td>
	<td>Nombre</td>
	<td>&#160;</td>
</tr>
<xsl:if test="count(DATA/ALIAS/ALIAS)=0">
	<tr><td colspan="6">No hay alias disponibles.</td></tr>
</xsl:if>
<xsl:for-each select="DATA/ALIAS/ALIAS">
	<xsl:sort select="@CORREO"/>
	<tr>
		<td><xsl:value-of select="@CORREO"/></td>
		<td><xsl:value-of select="@DNI"/></td>
		<xsl:variable name="dni"><xsl:value-of select="@DNI"/></xsl:variable> 
		<xsl:for-each select="../DATOS_PERSONALES[@IDENTIFICADOR=$dni]">
			<td><xsl:value-of select="@APELLIDOS"/>,&#160;<xsl:value-of select="@NOMBRE"/></td>
		</xsl:for-each>
		<td>
			<form name="acDel" action="{$servlet}" method="post">
			<input type="hidden" name="module" value="dumbo7/alias.borrarAlias"/>
			<input type="hidden" name="aliasSisCod" value="{@SISTEMA}"/>
			<input type="hidden" name="aliasCorreo" value="{@CORREO}"/>
			&#160;<input type="button" class="boton" value="Eliminar" onclick="borrar('{@SISTEMA}','{@CORREO}');"/>
			</form>
		</td>
		<td>
			<form name="acUpd" action="{$servlet}" method="post">
			&#160;<input type="button" class="boton" value="Modificar" onclick="modificar('{@SISTEMA}','{@CORREO}');"/>
			</form>
		</td>
	</tr>
</xsl:for-each>
</table>
</td></tr>
</table>
</xsl:template>

</xsl:stylesheet>
	