/*
 * 
 *
 */
package dumbo7.atencion;

import java.io.*;
import java.math.BigDecimal;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.util.*;
import java.util.zip.ZipEntry;
import java.util.zip.ZipOutputStream;

import javax.servlet.*;
import javax.servlet.http.*;

import org.apache.log4j.*;
import org.hibernate.*;
import org.hibernate.criterion.*;
import dumbo7.*;
import dumbo7.user.*;
import dumbo7.utils.*;
import dumbo7.user.FiltroUsuario;
import atica.frameweb.utils.*;
import dumbo7.administracion.zonas.Espacio;
import dumbo7.notificaciones.GestorNotificaciones;
import dumbo7.solicitudes.*;

/**
 * @author Universidad de Murcia - ATICA
 *
 */

public class GestorAtencion extends GeneralManager implements FilenameFilter {
	
	static Logger logger = Logger.getLogger(GestorAtencion.class);
	
	public List aplicaciones = null, prioridades = null, categorias = null, secciones = null;
	public String message = "";
	public D7Tareas solicitud = null;
	public Vector anexos = new Vector();
	public String rutaAnexos = "";
	public List movimientos = null;
	//public List tareasHijas = null;
	public List responsables = null;
	public D7GruposCostes grupoCoste = null;
	public List seguimientos = null;
	public FiltroUsuario filtro = null;
	private D7Tareas subtar = null;
	private D7DatosPersonales solicitante = null;
	protected List informaticos = null; //Variable que se rellenar si el usuario solicitante de la tarea es informatico
	public D7DatosTrabajador datosTrabajador = null;
	protected List datosTrabajadores = null;
	protected java.math.BigDecimal dedicacion=null;
	protected String texto="";
	private boolean correo=false;
	private static String miCodigo="";
	public Espacio ubicSoli=null;

	public GestorAtencion() {}
	
	public FiltroUsuario getFiltro() { return filtro; }

	public D7DatosPersonales getSolicitante() { return solicitante; }
	public D7DatosTrabajador getDatosTrabajador() { return datosTrabajador; }
	public List getInformaticos(){return informaticos;}
	
	public void setDetalle(String ajx) {
		if (ajx!=null && ajx.equals("1")) solicitud = new D7Tareas();
	}
	
	public void listSecciones(Session conn) {
		try {
			// Solo las secciones del detalle
			if (solicitud==null || solicitud.getTarAplCod()==null) {
				secciones = GestorAuxiliar.getListaSecciones(user,conn);
			} else {
				secciones = new ArrayList();
				obtenerRaizSecciones(conn,solicitud.getAplicacion().getAplSecCod(),secciones);
				obtenerSeccionesHijas(conn,solicitud.getAplicacion().getAplSecCod(),secciones);
			}
		} catch (Exception ex) {
			setErrorMessage("GestorAtencion[listSecciones]: "+ex);
		}
	}
	public List getSecciones() {
		return secciones;
	}

	public void listAplicacionesSinParam(Session conn) {
		try {
			// Solo saco la aplicacin del detalle !!
			if (solicitud==null || solicitud.getTarAplCod()==null) {
				aplicaciones = GestorAuxiliar.getListaAplicaciones(user,conn);
				// Cojo los parmetros asociados a las aplicaciones !!
				for (int k=0; k<aplicaciones.size(); k++) {
					((D7Aplicaciones)aplicaciones.get(k)).setAplicaciones_param(new HashSet());
				}
			} else {
				Criteria ct = conn.createCriteria(D7Aplicaciones.class);
				ct = ct.add(Expression.eq("AplSisCod",user.getDatosMenu().idSelected()));
				ct = ct.add(Expression.eq("AplCod",solicitud.getTarAplCod()));
				List l = ct.list();
				if (l!=null && l.size()>0) {
					D7Aplicaciones apl = (D7Aplicaciones)l.get(0);
					apl.getAplicaciones_param().size();
					aplicaciones = new ArrayList();
					aplicaciones.add(apl);
				}
			}
		} catch (Exception ex) {
			setErrorMessage("GestorAtencion[listAplicaciones]: "+ex);
		}
	}
	
	public void listAplicaciones(Session conn) {
		try {
			// Solo saco la aplicacin del detalle !!
			if (solicitud!=null || solicitud.getTarAplCod()!=null) {
				Criteria ct = conn.createCriteria(D7Aplicaciones.class);
				ct = ct.add(Expression.eq("AplSisCod",user.getDatosMenu().idSelected()));
				ct = ct.add(Expression.eq("AplCod",solicitud.getTarAplCod()));
				List l = ct.list();
				if (l!=null && l.size()>0) {
					D7Aplicaciones apl = (D7Aplicaciones)l.get(0);
					apl.getAplicaciones_param().size();
					aplicaciones = new ArrayList();
					aplicaciones.add(apl);
				}
			}
			/*else {
				aplicaciones = GestorAuxiliar.getListaAplicaciones(user,conn);
				// Cojo los parmetros asociados a las aplicaciones !!
				for (int k=0; k<aplicaciones.size(); k++) {
					Set s = ((D7Aplicaciones)aplicaciones.get(k)).getAplicaciones_param();
					s.size();
				}
			}*/
		} catch (Exception ex) {
			setErrorMessage("GestorAtencion[listAplicaciones]: "+ex);
		}
	}
	public List getAplicaciones() {
		return aplicaciones;
	}
	
	public void listPrioridades(Session conn) {
		try {
			prioridades = GestorAuxiliar.getListaPrioridades(user,conn);
		} catch (Exception ex) {
			setErrorMessage("GestorAtencion[listPrioridades]: "+ex);
		}
	}
	public List getPrioridades() {
		return prioridades;
	}
	public List getDatosTrabajadores() { 
		return datosTrabajadores; 
	}
	public Espacio getUbicSoli() { return ubicSoli; }

	public void listCategorias(Session conn) {
		try {
			// Slo las categoras de la seccin o subsecciones de aplicacin
			if (solicitud!=null && solicitud.getTarAplCod()!=null) {
				categorias = new ArrayList();
				listCategoriasSecciones(conn,secciones);
			} 
			/*else {
				categorias = GestorAuxiliar.getListaCategorias(user,conn);
			}*/
		} catch (Exception ex) {
			setErrorMessage("GestorAtencion[listCategorias]: "+ex);
		}
	}
	
	private void obtenerRaizSecciones(Session conn,String sec,List secs) {
		Criteria ct = conn.createCriteria(D7Secciones.class);
		ct = ct.add(Expression.eq("SecSisCod",user.getDatosMenu().idSelected()));
		ct = ct.add(Expression.eq("SecCod",sec));
		List l = ct.list();
		if (l!=null && l.size()>0) {
			// Incluyo la seccin y su padre.
			D7Secciones seccion = (D7Secciones) l.get(0);
			secs.add(seccion.clonarSeccion());
			if (seccion.getSecSecCod()!=null && !seccion.getSecSecCod().equals(seccion.getSecCod()))
				obtenerRaizSecciones(conn,seccion.getSecSecCod(),secs);
		}
	}

	private void obtenerSeccionesHijas(Session conn,String sec,List secs) {
		Criteria ct = conn.createCriteria(D7Secciones.class);
		ct = ct.add(Expression.eq("SecSisCod",user.getDatosMenu().idSelected()));
		ct = ct.add(Expression.eq("SecSecCod",sec));
		List l = ct.list();
		if (l!=null && l.size()>0) {
			// Incluyo las hijas.
			Iterator it = l.iterator();
			while (it.hasNext()) {
				D7Secciones seccion = (D7Secciones) it.next();
				if (!seccion.getSecSecCod().equals(seccion.getSecCod())) {
					secs.add(seccion.clonarSeccion());
					obtenerSeccionesHijas(conn,seccion.getSecCod(),secs);
				}
			}
		}
	}
	public void listCategoriasSecciones(Session conn,List secs) {
		if (secs==null || secs.size()<=0) return;
		Iterator t = secs.iterator();
		while (t.hasNext()) {
			D7Secciones sec = (D7Secciones)t.next();
			Criteria ct = conn.createCriteria(D7Categorias.class);
			ct = ct.add(Expression.eq("CatSisCod",sec.getSecSisCod()));
			ct = ct.add(Expression.eq("CatSecCod",sec.getSecCod()));
			List l = ct.list();
			if (l!=null && l.size()>0) {
				Iterator tt = l.iterator();
				while (tt.hasNext()) categorias.add((D7Categorias)tt.next());
			}
		}
	}
	
	public List getCategorias() {
		return categorias;
	}
	
	public String getMessage() { return message; }
	
	public void setContextPath(HttpServlet servlet,HttpServletRequest req,HttpServletResponse res) {
		try {
			rutaAnexos = GestorGenerico.getContextPath(user,servlet,false);
		} catch (Exception ex) {
			setErrorMessage("GestorAtencion[setContextPath]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
	}
	
	public void readAnexo(Hashtable anexo) {
		if (anexo!=null) {
			String name = (String) anexo.get("filename");
			if ((name!=null) && !name.equals("")) {
				int n = name.lastIndexOf("/");
				if (n<0) n = name.lastIndexOf("\\");
				name = name.substring(n+1);
				anexo.put("filename",name);
				anexos.addElement(anexo);
			}
		}
	}
	
	
	public void detalleSolicitud(Session conn,String code) {
		try {
			if ((code==null) || code.equals("")) return;
			Query q = conn.createQuery(getQuery("DetalleTarea"));
			//Query q = conn.getNamedQuery("TareasUsuario");
			q = q.setString("sist",user.getDatosMenu().idSelected());
			q = q.setString("code",code);
			solicitud = (D7Tareas)q.list().get(0);
			if (!solicitud.getTarUsuCod().equals(DumboUser.CODIGO_EXTERNO)) solicitud.getDatosUser().setDatEmail(D7Conversor.convierteIdentificador(conn,solicitud.getTarUsuCod()));
			solicitud.tieneSubtareasNoFinalizadas();
			solicitud.setSubtareas(new HashSet());
			
			if (solicitud.getTarBloqueado().equals("N")) {
				// No est bloqueado, lo bloqueo a R.
				solicitud.setTarBloqueado("R",user.getIdentificador());
			} else if (solicitud.getTarBloqueado().equals("R") && !solicitud.bloqueoExpired() && !solicitud.esMiBloqueo(user.getIdentificador())) {
				// Esta bloqueado a R por otro usuario y sin expirar, lo pongo a S con su Id
				if (!solicitud.getIdBloqueo().equals(null))	solicitud.setTarBloqueado("S",solicitud.getIdBloqueo());
				else solicitud.setTarBloqueado("S",user.getIdentificador());
				//solicitud.setTarBloqueado("S");
				//Menos en el caso de que est a S, no sea mio y no haya expirado siempre se pone a R
			} else if (solicitud.getTarBloqueado().equals("R") || solicitud.esMiBloqueo(user.getIdentificador()) || solicitud.bloqueoExpired()) {
				// Est bloqueado a R, pero ha expirado o es mi propio bloqueo, actualizo el bloqueo.
				solicitud.setTarBloqueado("R",user.getIdentificador());
			}
			
			// Veo si la tarea est caducada !!
			java.sql.PreparedStatement pstmt = null;
			java.sql.ResultSet rs = null;
			
			try {
				pstmt = conn.connection().prepareStatement(getQuery("tareaCaducada"));
				pstmt.setString(1,code);
				pstmt.setString(2,user.getDatosMenu().idSelected());
				rs = pstmt.executeQuery();
				if (rs.next()) solicitud.setTarCaducada(rs.getString(1));
				rs.close(); pstmt.close();
				
				pstmt = conn.connection().prepareStatement(getQuery("tareaTotales"));
				pstmt.setString(1,code);
				pstmt.setString(2,user.getDatosMenu().idSelected());
				rs = pstmt.executeQuery();
				if (rs.next()) solicitud.setTarTotales(rs.getString(1));
				
				//lo aado para poder rechazar las subtareas que son rechazables desde Atender
				pstmt = conn.connection().prepareStatement(getQuery("tareaRechazable"));
				pstmt.setString(1,user.getDatosMenu().idSelected());
				pstmt.setString(2,code);
				pstmt.setString(3,user.getDatosMenu().idSelected());
				rs = pstmt.executeQuery();
				if (rs.next()) {
					if (Integer.parseInt(rs.getString(1))<0) solicitud.setTarRechazar("S");
					else solicitud.setTarRechazar("N");
				} else solicitud.setTarRechazar("N");
				
				if (solicitud.getTarEstado().equals(D7Tareas.FINALIZADA) || solicitud.getTarEstado().equals(D7Tareas.RECHAZADA)) {
					// Si es el detalle de una tarea finalizada o rechazada incluye el texto de fin.
					Criteria ct = conn.createCriteria(D7TareasMovimientos.class);
					ct = ct.add(Expression.eq("TmoSisCod",user.getDatosMenu().idSelected()));
					ct = ct.add(Expression.eq("TmoTarCod",solicitud.getTarCod()));
					ct = ct.add(Expression.eq("TmoTipoMov",D7TareasMovimientos.FINALIZAR_TAREA));
					movimientos = ct.list();
				}
				
			} catch (Exception ex) {
				throw ex;
			} finally {
				try {
					if (rs!=null) rs.close();
					if (pstmt!=null) pstmt.close();
				} catch (Exception exc) {}
			}

			anexos = GestorGenerico.getAnexosTarea(rutaAnexos,solicitud);

		} catch (Exception ex) {
			setErrorMessage("GestorAtencion[detalleSolicitud]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
	}
	
	public void listaDatosSolicitante(Session conn, String code){
		Query q;
		try {
			if ((code==null) || code.equals("")) return;
			miCodigo=code;
			if (solicitud==null) detalleSolicitud(conn,code);
			q = conn.createQuery(getQuery("DatosSolicitante2"));
			q = q.setString("code",solicitud.getTarUsuCod());
			datosTrabajador  = (D7DatosTrabajador)q.list().get(0);
			
		}catch (Exception ex) {
			setErrorMessage("GestorAtencion[listaDatosSolicitante]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
	}
	
	public void listaDatosSolicitante(Session conn){
		try {
			listaDatosSolicitante(conn,this.miCodigo);
		}catch (Exception ex) {
			setErrorMessage("GestorAtencion[listaDatosSolicitante]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
	}
	
	public void ubicacionSolicitante(Session conn) {
		PreparedStatement pstmt = null;
		ResultSet rs = null;
		String myQuery = null;
		try {
			
			if (datosTrabajador.getDatIdentificador()!=null && !datosTrabajador.getDatIdentificador().equals("")) {
				// Miro el Edificio en el que se Ubica este DNI
				myQuery = getQuery("UbicacionDni2");
				pstmt = conn.connection().prepareStatement(myQuery);
				pstmt.setString(1,datosTrabajador.getDatIdentificador());
				rs = pstmt.executeQuery();
				if (rs.next()) ubicSoli = new Espacio(rs.getString(1),rs.getString(2));
			}
		}
		catch (Exception ex)
		{
			System.out.println("2"+ex);
			setErrorMessage("Error al listar espacios.");
		} finally {
			try {
				if (rs!=null) rs.close();
				if (pstmt!=null) pstmt.close();
			} catch (Exception exx) {}
		}
	}
	
	public void detalleSolicitante(Session conn) {
		Criteria ct = conn.createCriteria(D7DatosPersonales.class);
		ct = ct.add(Restrictions.eq("DatIdentificador",solicitud.getTarUsuCod()));
		List l = ct.list();
		if (l!=null && l.size()>0) {
			solicitante = (D7DatosPersonales)l.get(0);
			java.sql.PreparedStatement pstmt = null;
			java.sql.ResultSet rs = null;
			try {
				pstmt = conn.connection().prepareStatement(getQuery("DatosSolicitante"));
				pstmt.setString(1,solicitante.getDatIdentificador());
				rs = pstmt.executeQuery();
				if (rs.next()) {
					solicitante.setDatEmail(rs.getString(1));
					solicitante.setDatDepartamento(rs.getString(2));
					solicitante.setDatTelefono(rs.getString(3));
				}
			} catch (Exception ex) {
				setErrorMessage("GestorAtencion[detalleSolicitante]: "+((ex.getCause()!=null)?ex.getCause():ex));
			} finally {
				try {
					if (rs!=null) rs.close();
					if (pstmt!=null) pstmt.close();
				} catch(Exception exx) {}
			}
		}
	}
	
	//Esta funcion se utiliza para dos cosas: por un lado para ver si el usuario que solicita la tarea es informatico
	//(en cuyo caso lo informar en el detalle) y por otro para ver si el user lo es (para texto de seguimiento dividido)
	public void esInformatico(Session conn) {
		try {
			if (solicitud==null || solicitud.getTarUsuCod()==null) return;
			//En la cadena usuarios metemos los dnis del solicitante y del user, para comprobar
			String usuarios = "('" + solicitud.getTarUsuCod()+ "','"+user.getIdentificador()+"')";
				
			Query q = conn.createQuery(getQuery("SonInformaticos").replaceAll(":usuarios",usuarios));
			q = q.setString("sist",solicitud.getTarSisCod());
			if (q.list().size() ==0) {
				informaticos  = null;
			} else {
				informaticos  = q.list();
			}
		}catch (Exception ex) {
			setErrorMessage("GestorAtencion[esInformatico]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
	}
	
	//Esta funcion se utiliza para obtener la ltima entrada de bitcora para esta tarea
	public void ultimaBitacora(Session conn) {
		seguimientos = new ArrayList();
		try {
			if (solicitud==null) return;
			Criteria ct = conn.createCriteria(D7TareasSeguimientos.class);
			ct = ct.add(Expression.eq("TseSisCod",user.getDatosMenu().idSelected()));
			ct = ct.add(Expression.eq("TseTarCod",solicitud.getTarCod()));
			ct.addOrder(Order.desc("TseFechaAlta"));
			List l = ct.list();
			seguimientos.add(l.get(0));
		}catch (Exception ex) {
			setErrorMessage("GestorAtencion[ultimaBitacora]: "+((ex.getCause()!=null)?ex.getCause():ex));
		} 
	}
	
	public void obtenListadoAplicaciones(Session conn,String code) {
		if ((code==null) || code.equals("")) return;
		listAplicaciones(conn);
	}
	public void obtenListadoPrioridades(Session conn,String code) {
		if ((code==null) || code.equals("")) return;
		listPrioridades(conn);
	}
	public void obtenListadoCategorias(Session conn,String code) {
		if ((code==null) || code.equals("")) return;
		listCategorias(conn);
	}
	public void obtenListadoSecciones(Session conn,String code) {
		if ((code==null) || code.equals("")) return;
		listSecciones(conn);
	}
	public void obtenListadoSeccionesCategorias(Session conn,String code) {
		if ((code==null) || code.equals("")) return;
		listSecciones(conn);
		listCategorias(conn);
	}

	public void obtenListadoGruposCostes(Session conn,String code) {
		//if ((code==null) || code.equals("")) return;
		obtenerGrupoCoste(conn);
	}
	
	
	public D7Tareas getSolicitud() { return solicitud; }
	
	public void filtroListAtender(Session conn) {
		setPageSize(new Integer(filtro.getTamPag()).intValue());
		if (filtro.getFormato().equals(FiltroUsuario.FORMATO_LISTA) && solicitud==null) listAtender(conn);
		solicitud = null;
	}
	
	public void listAtender(Session conn) {
		try {

			setPageSize(new Integer(filtro.getTamPag()).intValue());
			Hashtable params = new Hashtable();
			params.put("1",user.getDatosMenu().idSelected());
			params.put("2",user.getIdentificador());
			boolean subtareas = false;
			if (filtro.getVerSubtareas((DumboUser)user)) {
				if ((filtro.getSubtareas()==null) || filtro.getSubtareas().equals("S")) {
					subtareas = true;
				}
			}
			filtro.setTipo(FiltroUsuario.LISTA_ATENDER);
			List l = aplicaFiltroSQL(conn,"TareasInformaticoPendientesSQL",subtareas,FiltroUsuario.LISTA_ATENDER,params);
			setCollection(l);
			
		} catch (Exception ex) {
			setErrorMessage("GestorAtencion[listAtender]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
	}
	
	public void filtroListAtendidas(Session conn) {
		setPageSize(new Integer(filtro.getTamPag()).intValue());
		if (filtro.getFormato().equals(FiltroUsuario.FORMATO_LISTA) && solicitud==null) listAtendidas(conn);
		solicitud = null;
	}
	
	public void listAtendidas(Session conn) {
		try {

			setPageSize(new Integer(filtro.getTamPag()).intValue());
			Hashtable params = new Hashtable();
			params.put("1",user.getDatosMenu().idSelected());
			params.put("2",user.getIdentificador());
			boolean subtareas = false;
			if (filtro.getVerSubtareas((DumboUser)user)) {
				if ((filtro.getSubtareas()==null) || filtro.getSubtareas().equals("S")) {
					subtareas = true;
				}
			}
			filtro.setTipo(FiltroUsuario.LISTA_ATENDIDAS);
			List l = aplicaFiltroSQL(conn,"TareasInformaticoResueltasSQL",subtareas,FiltroUsuario.LISTA_ATENDIDAS,params);
			setCollection(l);
			
		} catch (Exception ex) {
			setErrorMessage("GestorAtencion[listAtendidas]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
	}

	public void downloadAnexo(HttpServlet servlet,HttpServletRequest req,HttpServletResponse res,String anexo) {
		try {

			String txt = req.getRealPath("");
			String base = txt.substring(0,txt.lastIndexOf(File.separator))+File.separator+"upload"+File.separator;
			File f = new File(base);
			if (!f.exists()) throw new Exception("El Fichero Indicado no Existe.");
			String baseSistema = base+user.getDatosMenu().idSelected()+File.separator;
			f = new File(baseSistema);
			if (!f.exists()) throw new Exception("El Fichero Indicado no Existe.");
			rutaAnexos = baseSistema;
			File down = new File(baseSistema+File.separator+anexo);
			if (!down.exists()) { //throw new Exception("El Fichero Indicado no Existe.");
				// El fichero indicado no existe puede que contenga caracteres extraos
				String nm = baseSistema+File.separator+anexo.substring(0,anexo.indexOf("/"));
				message = anexo.substring(anexo.lastIndexOf("/")+1);
				File [] files = new File(nm).listFiles(this);
				if (files!=null && files[0]!=null) down = files[0];
				else throw new Exception("El Fichero Indicado no Existe.");
			}
			ServletOutputStream out = res.getOutputStream();
			res.setContentType("application/unknown");
			String nombreAnexo = anexo.substring(anexo.lastIndexOf("/")+1);
			nombreAnexo = nombreAnexo.substring(nombreAnexo.indexOf(GestorGenerico.UPLOAD_PREFIX)+GestorGenerico.UPLOAD_PREFIX.length()+1);
			nombreAnexo = nombreAnexo.substring(nombreAnexo.indexOf("_")+1);
			res.setHeader("Content-Disposition","attachment; filename=\""+nombreAnexo+"\"");
			FileInputStream in = new FileInputStream(down);
			byte [] buffer = new byte[1024];
			int n = in.read(buffer,0,1024);
			while (n==1024) {
				out.write(buffer,0,n);
				n = in.read(buffer,0,1024);
			}
			out.write(buffer,0,n);
			out.close(); in.close();
			
		} catch (Exception ex) {
			setErrorMessage("GestorAtencion[listAtendidas]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
	}
		
	public void asignar(Session conn,D7Tareas tar) {
		Transaction tx = null;
		String textoNuevo="";
		String tipoAsignacion="";
		String movimiento="";
		try {
			// Busco la tarea Original
			tx = conn.beginTransaction();
			Query q = conn.createQuery(getQuery("GetTarea"));
			q.setString("tarCod",""+tar.getTarCod());
			q.setString("sist",user.getDatosMenu().idSelected());
			D7Tareas original = (D7Tareas)q.list().get(0);
			String textoActual = user.traduce("dumbo7/user","Informtico",user.getDatosMenu().idSelected())+": "+original.getTarInfEmail();
			if (original.getTarInfCod()!=null && !original.getTarInfCod().equals("")) throw new Exception("La tarea ya ha sido asignada al "+textoActual);

			// Si cambia la aplicacin se modifica la prioridad !!
			if (tar.getTarAplCod()==null || tar.getTarAplCod().equals("-1")) tar.setTarAplCod(original.getTarAplCod());
			else if (!tar.getTarAplCod().equals(original.getTarAplCod())) original.setTarPriCod(GestorSolicitudes.getPrioridadAplicacion(conn,(DumboUser)user,tar.getTarAplCod(),tar.getTarTipCod()));
			
			if ((tar.getTarInfCod()==null) || tar.getTarInfCod().equals("")) {
				// La asignacin es por aplicacin
				GestorSolicitudes gsol = new GestorSolicitudes();
				gsol.setUser(user);
				//String inform = gsol.asignarInformaticoAplicacion(conn,tar.getTarAplCod(),tar.getTarEDUbicacion(),original.getTarUsuCod());
				String inform = gsol.asignarInformaticoAplicacion(conn,tar.getTarAplCod(),tar.getTarEDUbicacion(),original.getTarUsuCod());
				if (inform.equals("cambiaSolicitante")){
					//Debemos buscar el responsable de la seccion a la que pertenece el user y ponerle de solicitante de la tarea
					Query q1 = conn.createQuery(getQuery("responsableSeccionUser"));
					q1 = q1.setString("sist",user.getDatosMenu().idSelected());
					q1 = q1.setString("info",original.getTarUsuCod());
					String resp=((D7Secciones)q1.list().get(0)).getSecIdRespon();
					original.setTarInfCod(original.getTarUsuCod());
					original.setTarUsuCod(resp);
					original.setTarEstado(D7Tareas.ASIGNADA);
					textoNuevo = user.traduce("dumbo7/user","Informtico",user.getDatosMenu().idSelected())+": "+original.getTarInfEmail();
					movimiento=D7TareasMovimientos.ASIGNAR_APLICACIONES_DIRECTA;
				}else if (inform!=null) {
					original.setTarAplCod(tar.getTarAplCod());
					if (!inform.equals("")) {
						original.setTarInfCod(inform);
						original.setTarEstado(D7Tareas.ASIGNADA);
						textoNuevo = user.traduce("dumbo7/user","Informtico",user.getDatosMenu().idSelected())+": "+original.getTarInfEmail();
						movimiento=D7TareasMovimientos.ASIGNAR_APLICACIONES_DIRECTA;
					} else {
						original.setTarInfCod(null);
						original.setTarEstado(D7Tareas.PENDIENTE);
					}
				} else throw new Exception("La tarea no ha podido ser asignada ya que no hay informticos asociados a la aplicacin escogida.");
			} else {
				// La asignacin es directa a informtico con aplicacin !!
				String mailInf = tar.getTarInfCod().toLowerCase();
				textoNuevo = user.traduce("dumbo7/user","Informtico",user.getDatosMenu().idSelected())+": "+mailInf;
				tar.setTarInfCod(D7Conversor.convierteMail(conn,mailInf));
				
				// La asignacin de cola es libre, basta con ser informtico.
				Query q2 = conn.createQuery(getQuery("esInformatico"));
				q2 = q2.setString("sist",user.getDatosMenu().idSelected());
				q2 = q2.setString("info",tar.getTarInfCod());
				List inf = q2.list();
				String mensaje = " no es un informtico del sistema.";

				if (inf==null || inf.size()==0) throw new Exception("El usuario "+mailInf+mensaje);
				original.setTarAplCod(tar.getTarAplCod());
				original.setTarInfCod(tar.getTarInfCod());
				original.setTarEstado(D7Tareas.ASIGNADA);
				//Se ha puesto la aplicacin y el informatico a quien reasignar
				movimiento=D7TareasMovimientos.ASIGNAR_APLICACIONES_DIRECTA;
			}
			original.setTarDescripSegui(tar.getTarDescripSegui());
			original.setTarEDUbicacion(tar.getTarEDUbicacion());
			conn.saveOrUpdate(original);
			tx.commit();
			
			if (movimiento!="") GestorGenerico.registrarMovimiento(conn,user,""+tar.getTarCod(),tar.getTarDescripSegui(),movimiento,textoActual,textoNuevo);
			
			//GestorGenerico.registrarMovimiento(conn,user,""+tar.getTarCod(),tar.getTarDescripSegui(),tipoAsignacion,textoActual,textoNuevo);
			if (original.getTarInfCod()!=null) 
				GestorGenerico.enviarNotificacion(conn,user,original,new String[]{GestorGenerico.NotificacionInformaticoAsignacion,GestorGenerico.NotificacionUsuarioAsignacion});
			else GestorGenerico.enviarNotificacion(conn,user,original,new String[]{GestorGenerico.NotificacionInformaticoAsignacionCola});
			
		} catch (Exception ex) {
			if (tx!=null) tx.rollback();
			setErrorMessage("GestorAtencion[Asignar]: "+((ex.getCause()!=null)?ex.getCause().getMessage():ex.getMessage()));
		}
	}
	
	public void reasignar(Session conn,D7Tareas tar) {
		Transaction tx = null;
		String textoNuevo="";
		String tipoAsignacion="";
		try {
			// Busco la tarea Original
			tx = conn.beginTransaction();
			Query q = conn.createQuery(getQuery("GetTarea"));
			q.setString("tarCod",""+tar.getTarCod());
			q.setString("sist",user.getDatosMenu().idSelected());
			D7Tareas original = (D7Tareas)q.list().get(0);
			String textoActual = user.traduce("dumbo7/user","Informtico",user.getDatosMenu().idSelected())+": "+original.getTarInfEmail();

			if (tar.getTarAplCod()==null || tar.getTarAplCod().equals("-1")) tar.setTarAplCod(original.getTarAplCod());
			else if (!tar.getTarAplCod().equals(original.getTarAplCod())) { 
				Criteria ct = conn.createCriteria(D7TareasMovimientos.class);
				ct = ct.add(Expression.eq("TmoSisCod",user.getDatosMenu().idSelected()));
				ct = ct.add(Expression.eq("TmoTarCod",original.getTarCod()));
				ct = ct.add(Expression.eq("TmoTipoMov",D7TareasMovimientos.CAMBIAR_PRIORIDAD));
				List l = ct.list();
				// Si cambia la aplicacin se modifica la prioridad !!
				// Pero slo si no se ha modificado previamente que en ese caso se mantiene.
				if (l==null || l.size()<=0) original.setTarPriCod(GestorSolicitudes.getPrioridadAplicacion(conn,(DumboUser)user,tar.getTarAplCod(),tar.getTarTipCod()));
			}
			
			if ((tar.getTarInfCod()==null) || tar.getTarInfCod().equals("")) {
				// La asignacin es por aplicacin
				GestorSolicitudes gsol = new GestorSolicitudes();
				gsol.setUser(user);
				//String inform = gsol.asignarInformaticoAplicacion(conn,tar.getTarAplCod(),tar.getTarEDUbicacion(),original.getTarUsuCod());
				String inform = gsol.asignarInformaticoAplicacion(conn,tar.getTarAplCod(),tar.getTarEDUbicacion(),original.getTarUsuCod());
				if (inform.equals("cambiaSolicitante")){
					//Debemos buscar el responsable de la seccion a la que pertenece el user y ponerle de solicitante de la tarea
					Query q1 = conn.createQuery(getQuery("responsableSeccionUser"));
					q1 = q1.setString("sist",user.getDatosMenu().idSelected());
					q1 = q1.setString("info",original.getTarUsuCod());
					String resp=((D7Secciones)q1.list().get(0)).getSecIdRespon();
					original.setTarInfCod(original.getTarUsuCod());
					original.setTarUsuCod(resp);
					textoNuevo = user.traduce("dumbo7/user","Informtico",user.getDatosMenu().idSelected())+": "+D7Conversor.convierteIdentificador(conn,original.getTarInfCod())+"Aplicacin: "+original.getTarAplCod();
					tipoAsignacion=D7TareasMovimientos.REASIGNAR_DIRECTA;
				}else if (inform!=null) {
					textoActual += " Aplicacin: "+original.getTarAplCod();
					original.setTarAplCod(tar.getTarAplCod());
					if (!inform.equals("")) {
						original.setTarInfCod(inform);
						textoNuevo = user.traduce("dumbo7/user","Informtico",user.getDatosMenu().idSelected())+": "+D7Conversor.convierteIdentificador(conn,original.getTarInfCod())+"Aplicacin: "+original.getTarAplCod();
						tipoAsignacion=D7TareasMovimientos.REASIGNAR_DIRECTA;
					}
					else {
						original.setTarInfCod(null);
						original.setTarEstado(D7Tareas.PENDIENTE);
						textoNuevo = "Informtico: Sin Asignar Aplicacin: "+original.getTarAplCod();
						tipoAsignacion=D7TareasMovimientos.REASIGNAR_APLICACIONES;
					}
				} else throw new Exception("La tarea no ha podido ser asignada ya que no hay informticos asociados a la aplicacin escogida.");
			} else {
				// La asignacin es directa a informtico con aplicacin !!
				String mailInf = tar.getTarInfCod().toLowerCase();
				textoNuevo="Informtico :"+mailInf;
				tar.setTarInfCod(D7Conversor.convierteMail(conn,mailInf));
				
				Query q2 = conn.createQuery(getQuery("esResponsableAplicacion"));
				q2 = q2.setString("sist",user.getDatosMenu().idSelected());
				q2 = q2.setString("resp",user.getIdentificador());
				q2 = q2.setString("apl",original.getTarAplCod());
				List inf = q2.list();
				String mensaje = "";
				if (inf==null || inf.size()==0) {
					// No Es responsable, el informtico debe pertenecer a la aplicacin.
					q2 = conn.createQuery(getQuery("esInformaticoAplicacion"));
					q2 = q2.setString("sist",user.getDatosMenu().idSelected());
					q2 = q2.setString("info",tar.getTarInfCod());
					q2 = q2.setString("apl",tar.getTarAplCod());
					inf = q2.list();
					mensaje = " no es un informtico perteneciente a la aplicacin dada.";
				} else {
					// Es responsable basta con ser informtico.
					q2 = conn.createQuery(getQuery("esInformatico"));
					q2 = q2.setString("sist",user.getDatosMenu().idSelected());
					q2 = q2.setString("info",tar.getTarInfCod());
					inf = q2.list();
					mensaje = " no es un informtico del sistema.";
				}
				tipoAsignacion=D7TareasMovimientos.REASIGNAR_DIRECTA_COMPLETA;
				if (inf==null || inf.size()==0) throw new Exception("El usuario "+mailInf+mensaje);
				//if (GestorSolicitudes.estaAusente(conn,tar.getTarInfCod(),(DumboUser)user)) throw new Exception("El usuario "+mailInf+" est ausente, no puede asignarle tareas directamente.");
				textoActual += " Aplicacin: "+original.getTarAplCod();
				original.setTarAplCod(tar.getTarAplCod());
				original.setTarInfCod(tar.getTarInfCod());
			}
			String desc="";
			if (notEmpty(tar.getTarDescrip())) desc=original.getTarDescripSegui();
			
			if (notEmpty(tar.getTarPlanif())) original.setTarPlanif(tar.getTarPlanif());
			if (notEmpty(tar.getTarCatCod())) original.setTarCatCod(tar.getTarCatCod());
			if (notEmpty(tar.getTarPriCod())) original.setTarPriCod(tar.getTarPriCod());
			if (notEmpty(tar.getTarDescrip())) original.setTarDescripSegui(tar.getTarDescrip());
			original.setTarEDUbicacion(tar.getTarEDUbicacion());
			conn.saveOrUpdate(original);
			tx.commit();
			
			if (notEmpty(desc)) GestorGenerico.registrarMovimiento(conn,user,""+original.getTarCod(),"Cambio en el texto de seguimiento.",D7TareasMovimientos.MODIFICAR_TAREA,desc,tar.getTarDescrip());
			
			GestorGenerico.registrarMovimiento(conn,user,""+tar.getTarCod(),tar.getTarDescripSegui(),tipoAsignacion,textoActual,textoNuevo);
			
			//Ahora metemos en bitcora el motivo de reasignacion
			String usuario=user.getIdentificador();
			if (((DumboUser)user).getUsuarioOriginal()!=null) 
				usuario=((DumboUser)user).getUsuarioOriginal().getDataIdentifier(conn);
			GestorGenerico.registrarSoloSeguimiento(conn,user,""+tar.getTarCod(),"Reasignacin de tarea: "+tar.getTarDescripSegui(),tar.getTarHorasRes(),usuario);
			
			//GestorGenerico.registrarSoloSeguimiento(conn,user,""+tar.getTarCod(),tar.getTarDescripSegui());
			if (original.getTarInfCod()!=null)
				GestorGenerico.enviarNotificacion(conn,user,original,new String[]{GestorGenerico.NotificacionInformaticoReasignacion,GestorGenerico.NotificacionUsuarioReasignacion});
			else GestorGenerico.enviarNotificacion(conn,user,original,new String[]{GestorGenerico.NotificacionInformaticoAsignacionCola});

			
		} catch (Exception ex) {
			if (tx!=null) tx.rollback();
			setErrorMessage("GestorAtencion[Reasignar]: "+((ex.getCause()!=null)?ex.getCause().getMessage():ex.getMessage()));
		}
	}

	public void historialSolicitud(Session conn,String code) {
		try {
			if ((code==null) || code.equals("")) return;
			Query q = conn.createQuery(getQuery("HistorialTarea"));
			q = q.setString("sist",user.getDatosMenu().idSelected());
			q = q.setString("code",code);
			movimientos = q.list();
		} catch (Exception ex) {
			setErrorMessage("GestorAtencion[historialSolicitud]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
	}
	
	public List getMovimientos() { return movimientos; }
	public List getSeguimientos() { return seguimientos; }
	
	public void pasarWaiting(Session conn,D7Tareas tar) {
		Transaction tx = null;
		try {
			
			String usuario=user.getIdentificador();
			if (((DumboUser)user).getUsuarioOriginal()!=null) usuario=((DumboUser)user).getUsuarioOriginal().getDataIdentifier(conn);
			
			tx = conn.beginTransaction();
			Query q = conn.createQuery(getQuery("GetTarea"));
			q.setString("tarCod",""+tar.getTarCod());
			q.setString("sist",user.getDatosMenu().idSelected());
			D7Tareas original = (D7Tareas)q.list().get(0);
			if (original.getTarEstado().equals(D7Tareas.EN_ESPERA)) throw new Exception("La tarea ya estaba en espera.");
			String textoActual = "Estado: "+original.getTarEstado();
			original.setTarEstado(D7Tareas.EN_ESPERA);
			String textoNuevo = "Estado: "+original.getTarEstado();
			if (notEmpty(tar.getTarAplCod())) original.setTarAplCod(tar.getTarAplCod());
			if (notEmpty(tar.getTarPlanif())) original.setTarPlanif(tar.getTarPlanif());
			if (notEmpty(tar.getTarCatCod())) original.setTarCatCod(tar.getTarCatCod());
			if (notEmpty(tar.getTarPriCod())) original.setTarPriCod(tar.getTarPriCod());
			if (notEmpty(tar.getTarDescrip())) original.setTarDescripSegui(tar.getTarDescrip());
			conn.saveOrUpdate(original);
			tx.commit();
		
			GestorGenerico.registrarMovimiento(conn,user,""+tar.getTarCod(),tar.getTarDescripSegui(),D7TareasMovimientos.PASAR_WAITING,textoActual,textoNuevo);
			GestorGenerico.enviarNotificacion(conn,user,original,new String[]{GestorGenerico.NotificacionUsuarioEspera});
			if (notEmpty(tar.getTarDescrip())) GestorGenerico.registrarSoloSeguimiento(conn,user,""+tar.getTarCod(),tar.getTarDescrip(),null, usuario);
			
			setErrorMessage("La Tarea ha pasado a estado de espera.");
			
		} catch (Exception ex) {
			if (tx!=null) tx.rollback();
			setErrorMessage("GestorAtencion[pasarWaiting]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
	}
	
	public void pasarNoWaiting(Session conn,D7Tareas tar) {
		Transaction tx = null;
		try {
			String usuario=user.getIdentificador();
			if (((DumboUser)user).getUsuarioOriginal()!=null) usuario=((DumboUser)user).getUsuarioOriginal().getDataIdentifier(conn);

			tx = conn.beginTransaction();
			Query q = conn.createQuery(getQuery("GetTarea"));
			q.setString("tarCod",""+tar.getTarCod());
			q.setString("sist",user.getDatosMenu().idSelected());
			D7Tareas original = (D7Tareas)q.list().get(0);
			if (!original.getTarEstado().equals(D7Tareas.EN_ESPERA)) throw new Exception("La tarea no estaba en espera.");
			String textoActual = "Estado: "+original.getTarEstado();
			original.setTarEstado(GestorGenerico.estadoPrevio(conn,user,tar.getTarCod()));
			String textoNuevo = "Estado: "+original.getTarEstado();
			if (notEmpty(tar.getTarAplCod())) original.setTarAplCod(tar.getTarAplCod());
			if (notEmpty(tar.getTarPlanif())) original.setTarPlanif(tar.getTarPlanif());
			if (notEmpty(tar.getTarCatCod())) original.setTarCatCod(tar.getTarCatCod());
			if (notEmpty(tar.getTarPriCod())) original.setTarPriCod(tar.getTarPriCod());
			if (notEmpty(tar.getTarDescrip())) original.setTarDescripSegui(tar.getTarDescrip());
			conn.saveOrUpdate(original);
			tx.commit();
			
			GestorGenerico.registrarMovimiento(conn,user,""+tar.getTarCod(),tar.getTarDescripSegui(),D7TareasMovimientos.PASAR_NOWAITING,textoActual,textoNuevo);
			GestorGenerico.enviarNotificacion(conn,user,original,new String[]{GestorGenerico.NotificacionUsuarioReactivacion});
			if (notEmpty(tar.getTarDescrip())) GestorGenerico.registrarSoloSeguimiento(conn,user,""+tar.getTarCod(),tar.getTarDescrip(),null,usuario);
			
			setErrorMessage("La Tarea ha dejado de estar en espera.");
			
		} catch (Exception ex) {
			if (tx!=null) tx.rollback();
			setErrorMessage("GestorAtencion[pasarNoWaiting]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
	}

	public void pasarPeticion(Session conn,D7Tareas tar) {
		try {
			String usuario=user.getIdentificador();
			if (((DumboUser)user).getUsuarioOriginal()!=null) usuario=((DumboUser)user).getUsuarioOriginal().getDataIdentifier(conn);
			
			Transaction tx = conn.beginTransaction();
			Query q = conn.createQuery(getQuery("GetTarea"));
			q.setString("tarCod",""+tar.getTarCod());
			q.setString("sist",user.getDatosMenu().idSelected());
			D7Tareas original = (D7Tareas)q.list().get(0);
			if (original.getTarTipCod().equals(D7TiposTareas.PETICION)) throw new Exception("La tarea ya es una peticin.");
			String desc=original.getTarDescripSegui();
			
			String textoActual = "Tipo Tarea: "+original.getTarTipCod();
			original.setTarTipCod(D7TiposTareas.PETICION);
			String textoNuevo = "Tipo Tarea: "+original.getTarTipCod();
			original.setTarDescripSegui(tar.getTarDescripSegui());
			original.setTarCatCod(null);
			if (notEmpty(tar.getTarAplCod())) original.setTarAplCod(tar.getTarAplCod());
			if (notEmpty(tar.getTarPlanif())) original.setTarPlanif(tar.getTarPlanif());
			if (notEmpty(tar.getTarPriCod())) original.setTarPriCod(tar.getTarPriCod());
			if (notEmpty(tar.getTarDescrip())) original.setTarDescripSegui(tar.getTarDescrip());
			conn.saveOrUpdate(original);
			tx.commit();
		
			if (notEmpty(desc)) GestorGenerico.registrarMovimiento(conn,user,""+original.getTarCod(),"Cambio en el texto de seguimiento.",D7TareasMovimientos.MODIFICAR_TAREA,desc,tar.getTarDescrip());
			GestorGenerico.registrarMovimiento(conn,user,""+tar.getTarCod(),tar.getTarDescripSegui(),D7TareasMovimientos.PASAR_PETICION,textoActual,textoNuevo);
			if (notEmpty(tar.getTarDescrip())) GestorGenerico.registrarSoloSeguimiento(conn,user,""+tar.getTarCod(),tar.getTarDescrip(),null,usuario);
			
			setErrorMessage("La Tarea ha sido pasada a Peticin con xito.");
			
		} catch (Exception ex) {
			setErrorMessage("GestorAtencion[pasarPeticion]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
	}
	
	public void pasarIncidencia(Session conn,D7Tareas tar) {
		try {
			String usuario=user.getIdentificador();
			if (((DumboUser)user).getUsuarioOriginal()!=null) usuario=((DumboUser)user).getUsuarioOriginal().getDataIdentifier(conn);
			
			Transaction tx = conn.beginTransaction();
			Query q = conn.createQuery(getQuery("GetTarea"));
			q.setString("tarCod",""+tar.getTarCod());
			q.setString("sist",user.getDatosMenu().idSelected());
			D7Tareas original = (D7Tareas)q.list().get(0);
			if (original.getTarTipCod().equals(D7TiposTareas.INCIDENCIA)) throw new Exception("La tarea ya es una incidencia.");
			String desc=original.getTarDescripSegui();
			
			String textoActual = "Tipo Tarea: "+original.getTarTipCod();
			original.setTarTipCod(D7TiposTareas.INCIDENCIA);
			String textoNuevo = "Tipo Tarea: "+original.getTarTipCod();
			original.setTarDescripSegui(tar.getTarDescripSegui());
			original.setTarCatCod(null);
			if (notEmpty(tar.getTarAplCod())) original.setTarAplCod(tar.getTarAplCod());
			if (notEmpty(tar.getTarPlanif())) original.setTarPlanif(tar.getTarPlanif());
			if (notEmpty(tar.getTarPriCod())) original.setTarPriCod(tar.getTarPriCod());
			if (notEmpty(tar.getTarDescrip())) original.setTarDescripSegui(tar.getTarDescrip());
			conn.saveOrUpdate(original);
			tx.commit();
			
			if (notEmpty(desc)) GestorGenerico.registrarMovimiento(conn,user,""+original.getTarCod(),"Cambio en el texto de seguimiento.",D7TareasMovimientos.MODIFICAR_TAREA,desc,tar.getTarDescrip());
		
			GestorGenerico.registrarMovimiento(conn,user,""+tar.getTarCod(),tar.getTarDescripSegui(),D7TareasMovimientos.PASAR_INCIDENCIA,textoActual,textoNuevo);
			if (notEmpty(tar.getTarDescrip())) GestorGenerico.registrarSoloSeguimiento(conn,user,""+tar.getTarCod(),tar.getTarDescrip(),null,usuario);
			
			setErrorMessage("La Tarea ha sido pasada a Incidencia con xito.");
			
		} catch (Exception ex) {
			setErrorMessage("GestorAtencion[pasarIncidencia]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
	}
	
	public void datosFinalizarSubTarea(HttpServlet servlet,HttpServletRequest req,HttpServletResponse res) {
		String mot = ((String[])req.getAttribute("motivo"))[0];
		if (mot==null) mot="";
		if (!mot.equals("")) {
			subtar = new D7Tareas();
			subtar.setTarDescripSegui(mot);
			String txt = "";
			txt = ((String[])req.getAttribute("coste"))[0];
			if (txt!=null && !txt.equals("")) subtar.setTarCosteEco(new java.math.BigDecimal(txt));
			txt = ((String[])req.getAttribute("material"))[0];
			if (txt!=null && !txt.equals("")) subtar.setTarCosteMat(new java.math.BigDecimal(txt));
			txt = ((String[])req.getAttribute("horas"))[0];
			if (txt!=null && !txt.equals("")) subtar.setTarHorasRes(new java.math.BigDecimal(txt));
			txt = ((String[])req.getAttribute("anexo"))[0];
			if (txt!=null && !txt.equals("")) subtar.setTarEstado(txt);
		}
	}
	
	public void finalizarTarea(Session conn,D7Tareas tar) {
		Transaction tx = null;
		try {
			String usuario=user.getIdentificador();
			if (((DumboUser)user).getUsuarioOriginal()!=null) usuario=((DumboUser)user).getUsuarioOriginal().getDataIdentifier(conn);
			
			tx = conn.beginTransaction();
			Query q = conn.createQuery(getQuery("GetTarea"));
			q.setString("tarCod",""+tar.getTarCod());
			q.setString("sist",user.getDatosMenu().idSelected());
			D7Tareas original = (D7Tareas)q.list().get(0);
			String textoActual = "Estado: "+original.getTarEstado();
			if (original.getTarEstado().equals(D7Tareas.FINALIZADA)) throw new Exception("La tarea ya est finalizada.");
			// Segn la accin indicada ejecuto algo con las subtareas !!
			if (tar.getTarEstado().equals(D7Tareas.FINALIZADA)) {
				// Finalizo la tarea y las subtareas
				original.setTarEstado(D7Tareas.FINALIZADA);
				finalizarSubTareas(conn,original,tar.getTarDescripSegui(),original);
			//} else if (tar.getTarEstado().equals(D7Tareas.FINALIZADA_CONSUBTAREAS)) {
				// No finaliza la tarea hasta que finalicen las subtareas
				//original.setTarEstado(D7Tareas.FINALIZADA_CONSUBTAREAS);
			} else if (tar.getTarEstado().equals(D7Tareas.ANULADA)) {
				// Debo anular todas las subtareas pendientes
				original.setTarEstado(D7Tareas.FINALIZADA);
				anularSubTareas(conn,original,"Anulada Por Finalizacin de Tarea Padre.");
			}

			// Finalizo la tarea padre si est pendiente de subtareas
			//finalizarPadrePendiente(conn,original);
			String textoNuevo = "Estado: "+original.getTarEstado();
			original.setTarDescripSegui(tar.getTarDescripSegui());
			original.setTarFecfin(new Date());
			if (tar.getTarCosteEco()!=null) original.setTarCosteEco(tar.getTarCosteEco().add(costeSubtareas(original)));
			if (tar.getTarCosteMat()!=null) original.setTarCosteMat(tar.getTarCosteMat().add(costeMaterial(original)));
			if (tar.getTarHorasRes()!=null) original.setTarHorasRes(tar.getTarHorasRes().add(horasSubtareas(original)));
			if (notEmpty(tar.getTarAplCod())) original.setTarAplCod(tar.getTarAplCod());
			if (notEmpty(tar.getTarPlanif())) original.setTarPlanif(tar.getTarPlanif());
			if (notEmpty(tar.getTarCatCod())) original.setTarCatCod(tar.getTarCatCod());
			if (notEmpty(tar.getTarPriCod())) original.setTarPriCod(tar.getTarPriCod());
			if (notEmpty(tar.getTarDescrip())) original.setTarDescripSegui(tar.getTarDescrip());
			
			conn.saveOrUpdate(original);
			tx.commit();
			
			GestorGenerico.registrarMovimiento(conn,user,""+tar.getTarCod(),tar.getTarDescripSegui(),D7TareasMovimientos.FINALIZAR_TAREA,textoActual,textoNuevo);
			if (notEmpty(tar.getTarDescrip())) GestorGenerico.registrarSoloSeguimiento(conn,user,""+tar.getTarCod(),tar.getTarDescrip(),null,usuario);
			if (original.getTarEstado().equals(D7Tareas.FINALIZADA)) {
				if (tar.getTarEmailCopia()!=null && !tar.getTarEmailCopia().trim().equals("")) GestorGenerico.enviarNotificacion(conn,user,original,new String[]{GestorGenerico.NotificacionUsuarioResolucion},GestorGenerico.toMailArray(tar.getTarEmailCopia()),rutaAnexos+GestorGenerico.getMesActual(original.getTarFeccrea())+File.separator);
				else GestorGenerico.enviarNotificacion(conn,user,original,new String[]{GestorGenerico.NotificacionUsuarioResolucion},rutaAnexos+GestorGenerico.getMesActual(original.getTarFeccrea())+File.separator);
			}
			
			setErrorMessage("La Tarea ha sido finalizada con xito.");
			
		} catch (Exception ex) {
			if (tx!=null) tx.rollback();
			setErrorMessage("GestorAtencion[finalizarTarea]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
	}

	private boolean notEmpty(Object s) { return (s!=null && !s.equals("")); }
	
	private BigDecimal costeGrupo(Session conn,D7Tareas tar) throws Exception {
		try {
			Criteria ct = conn.createCriteria(D7Informaticos.class);
			ct = ct.add(Expression.eq("InfSisCod",user.getDatosMenu().idSelected()));
			ct = ct.add(Expression.eq("InfCod",tar.getTarInfCod()));
			D7Informaticos inf = (D7Informaticos) ct.list().get(0);
			return inf.getGrupoCoste().getGcoCoste();
		} catch (Exception ex) { return new BigDecimal(0); }
	}

	private BigDecimal costeSubtareas(D7Tareas tar) throws Exception {
		try {
			Set s = tar.getSubtareas();
			if (s==null) return new BigDecimal(0);
			Iterator it = s.iterator();
			BigDecimal bd = new BigDecimal(0);
			while (it.hasNext()) {
				D7Tareas t = (D7Tareas)it.next();
				if (t.getTarCosteEco()==null) continue;
				bd = bd.add(t.getTarCosteEco());
			}
			return bd;
		} catch (Exception ex) { return new BigDecimal(0); }
	}

	private BigDecimal horasSubtareas(D7Tareas tar) throws Exception {
		try {
			Set s = tar.getSubtareas();
			if (s==null) return new BigDecimal(0);
			Iterator it = s.iterator();
			BigDecimal bd = new BigDecimal(0);
			while (it.hasNext()) {
				D7Tareas t = (D7Tareas)it.next();
				if (t.getTarHorasRes()==null) continue;
				bd = bd.add(t.getTarHorasRes());
			}
			return bd;
		} catch (Exception ex) { return new BigDecimal(0); }
	}

	private BigDecimal costeMaterial(D7Tareas tar) throws Exception {
		try {
			Set s = tar.getSubtareas();
			if (s==null) return new BigDecimal(0);
			Iterator it = s.iterator();
			BigDecimal bd = new BigDecimal(0);
			while (it.hasNext()) {
				D7Tareas t = (D7Tareas)it.next();
				if (t.getTarCosteMat()==null) continue;
				bd = bd.add(t.getTarCosteMat());
			}
			return bd;
		} catch (Exception ex) { return new BigDecimal(0); }
	}
	
	private void finalizarSubTareas(Session conn,D7Tareas tar,String motivo,D7Tareas original) throws Exception {
		Set s = tar.getSubtareas();
		if (s==null) return;
		Iterator it = s.iterator();
		while (it.hasNext()) {
			D7Tareas t = (D7Tareas)it.next();
			if (!t.getTarEstado().equals(D7Tareas.FINALIZADA) && !t.getTarEstado().equals(D7Tareas.ANULADA)) {
				finalizarSubTareas(conn,t,motivo,original);
				String textoActual = "Estado: "+t.getTarEstado()+" Categora: "+t.getTarCatDesc();
				if (t.getTarCatCod()==null) t.setTarCatCod(original.getTarCatCod());
				t.setTarEstado(D7Tareas.FINALIZADA);
				String textoNuevo = "Estado: "+t.getTarEstado()+" Categora: "+t.getTarCatDesc();
				t.setTarFecfin(new Date());
				if (subtar!=null) {
					t.setTarDescripSegui(subtar.getTarDescripSegui());
					t.setTarCosteEco(subtar.getTarHorasRes().multiply(costeGrupo(conn,t)).add(costeSubtareas(t)));
					t.setTarCosteMat(subtar.getTarCosteMat());
					t.setTarHorasRes(subtar.getTarHorasRes());
				} else {
					t.setTarDescripSegui(motivo);
				}
				GestorGenerico.registrarMovimiento(conn,user,""+t.getTarCod(),t.getTarDescripSegui(),D7TareasMovimientos.FINALIZAR_TAREA,textoActual,textoNuevo);
				//GestorGenerico.registrarSoloSeguimiento(conn,user,""+t.getTarCod(),motivo);
				conn.saveOrUpdate(t);
				if (subtar.getTarEstado().equals("1")) GestorGenerico.enviarNotificacion(conn,user,t,new String[]{GestorGenerico.NotificacionUsuarioResolucion},rutaAnexos+GestorGenerico.getMesActual(original.getTarFeccrea())+File.separator);
				else GestorGenerico.enviarNotificacion(conn,user,t,new String[]{GestorGenerico.NotificacionUsuarioResolucion});
			}
		}
	}
	
	private void anularSubTareas(Session conn,D7Tareas tar,String motivo) throws Exception {
		Set s = tar.getSubtareas();
		if (s==null) return;
		Iterator it = s.iterator();
		while (it.hasNext()) {
			D7Tareas t = (D7Tareas)it.next();
			if (!t.getTarEstado().equals(D7Tareas.FINALIZADA) && !t.getTarEstado().equals(D7Tareas.ANULADA)) {
				String textoActual = "Estado: "+t.getTarEstado();
				t.setTarEstado(D7Tareas.ANULADA);
				String textoNuevo = "Estado: "+t.getTarEstado();
				GestorGenerico.registrarMovimiento(conn,user,""+t.getTarCod(),motivo,D7TareasMovimientos.ANULAR_TAREA,textoActual,textoNuevo);
				conn.saveOrUpdate(t);
				GestorGenerico.enviarNotificacion(conn,user,t,new String[]{GestorGenerico.NotificacionUsuarioAnulacion});
				anularSubTareas(conn,t,motivo);
			}
		}
	}
	
	public void responsablesAplicacion(Session conn,String aplCod) {
		try {
			// Para saber si tiene Ubicacin esta tarea
			Criteria ct = conn.createCriteria(D7Aplicaciones.class);
			ct = ct.add(Expression.eq("AplSisCod",user.getDatosMenu().idSelected()));
			ct = ct.add(Expression.eq("AplCod",aplCod));
			List miapl = ct.list();
			if (miapl!=null && miapl.size()>0) {
				String tipoAsig = ((D7Aplicaciones)miapl.get(0)).getAplTipoAsig();
				Query q = conn.createQuery(getQuery("GetResponsablesAplicacion"));
				q.setString("code",""+aplCod);
				q.setString("sist",user.getDatosMenu().idSelected());
				responsables = q.list();
				Iterator it = responsables.iterator();
				while (it.hasNext()) {
					D7AplicacionesInformaticos dai = (D7AplicacionesInformaticos)it.next();
					dai.getDatosInform().setDatEmail(D7Conversor.convierteIdentificador(conn,dai.getAinInfCod()));
					dai.setAinAplCod(aplCod+tipoAsig);
				}
			}
			
		} catch (Exception ex) {
			setErrorMessage("GestorAtencion[responsablesAplicacion]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
	}

	public void ubicacionTarea(Session conn,String tarCod) {
		java.sql.PreparedStatement pstmt = null;
		java.sql.ResultSet rs = null;
		try {
			// Indico el Edificio al que est asignada la tarea
			// O al que est asignado el solicitante
			String codEd = "";
			pstmt = conn.connection().prepareStatement(getQuery("UbicacionTareaSol"));
			pstmt.setString(1,tarCod);
			rs = pstmt.executeQuery();
			if (rs.next()) codEd = rs.getString(1);
			solicitante = new D7DatosPersonales();
			solicitante.setDatCentro(codEd);

		} catch (Exception ex) {
			setErrorMessage("GestorAtencion[ubicacionTarea]: "+((ex.getCause()!=null)?ex.getCause():ex));
		} finally {
			try {
				if (rs!=null) rs.close();
				if (pstmt!=null) pstmt.close();
			} catch (Exception exx) {}
		}
	}

	public List getResponsables() { return responsables; }

	private boolean haCambiado(Object a,Object b) {
		if ((a==null) && (b==null)) return false;
		if (a==null) return true;
		if (b==null) return true;
		if (a instanceof java.sql.Timestamp) {
			Date d = new Date(((java.sql.Timestamp)a).getTime());
			return !d.equals(b);
		}
		return !a.equals(b);
	}
	
	public void cambiaTarea(Session conn,D7Tareas tar) {
		try {
			
			if (tar==null || tar.getTarCod()==null || tar.getTarCod().equals("")) return;

			String textoActual1="";String textoActual2="";String textoActual3="";String textoActual4="";
			String textoNuevo1="";String textoNuevo2="";String textoNuevo3="";String textoNuevo4="";
			boolean cambiado=false;
			
			String usuario=user.getIdentificador();
			if (((DumboUser)user).getUsuarioOriginal()!=null) usuario=((DumboUser)user).getUsuarioOriginal().getDataIdentifier(conn);
			
			Transaction tx = conn.beginTransaction();
			Query q = conn.createQuery(getQuery("GetTarea"));
			q.setString("tarCod",""+tar.getTarCod());
			q.setString("sist",user.getDatosMenu().idSelected());
			D7Tareas original = (D7Tareas)q.list().get(0);
			
			if (haCambiado(original.getTarCatCod(),tar.getTarCatCod())) {
				textoActual1 = "Categora: "+original.getTarCatDesc();
				original.setTarCatCod(tar.getTarCatCod());
				textoNuevo1 = "Categora: "+original.getTarCatDesc();
			}
			if (haCambiado(original.getTarPriCod(),tar.getTarPriCod())) {
				textoActual2 = "Prioridad: "+original.getTarPriDesc();
				original.setTarPriCod(tar.getTarPriCod());
				textoNuevo2 =  "Prioridad: "+original.getTarPriDesc();
			}
			if (haCambiado(original.getTarAplCod(),tar.getTarAplCod())) {
				textoActual3 = "Aplicacin: "+original.getAplicacionDesc();
				original.setTarAplCod(tar.getTarAplCod());
				textoNuevo3 = "Aplicacin: "+original.getAplicacionDesc();
			}
			if (haCambiado(original.getTarPlanif(),tar.getTarPlanif())) {
				textoActual4 = "Fecha Prevista: "+GestorGenerico.getFechaString(original.getTarPlanif());
				original.setTarPlanif(tar.getTarPlanif());
				textoNuevo4 = "Fecha Prevista: "+GestorGenerico.getFechaString(original.getTarPlanif());
			}
			if (haCambiado(original.getTarDescripSegui(),tar.getTarDescripSegui()) && tar.getTarDescripSegui()!=null && !tar.getTarDescripSegui().trim().equals("") && (tar.getTarDescripSegui().length()>1 || (tar.getTarDescripSegui().charAt(0)-0)!=160)) {
				cambiado=true;
				original.setTarDescripSegui(tar.getTarDescripSegui());
			}
				
			conn.saveOrUpdate(original);
			
			tx.commit();
			
			if (textoActual1!="") {
				GestorGenerico.registrarMovimiento(conn,user,""+tar.getTarCod(),GestorGenerico.CAMBIO_CATEGORIA,D7TareasMovimientos.CAMBIAR_CATEGORIA,textoActual1,textoNuevo1);
			}
			if (textoActual2!="") {
				GestorGenerico.registrarMovimiento(conn,user,""+tar.getTarCod(),GestorGenerico.CAMBIO_PRIORIDAD,D7TareasMovimientos.CAMBIAR_PRIORIDAD,textoActual2,textoNuevo2);
			}
			if (textoActual3!="") {
				GestorGenerico.registrarMovimiento(conn,user,""+tar.getTarCod(),GestorGenerico.CAMBIO_APLICACION,D7TareasMovimientos.CAMBIAR_APLICACION,textoActual3,textoNuevo3);
			}
			if (textoActual4!="") {
				GestorGenerico.registrarMovimiento(conn,user,""+tar.getTarCod(),GestorGenerico.CAMBIO_PLANIFICACION,D7TareasMovimientos.CAMBIAR_FECHA_PLANIF,textoActual4,textoNuevo4);
				GestorGenerico.enviarNotificacion(conn,user,original,new String[]{GestorGenerico.NotificacionUsuarioPlanificacion});
			}
			if (cambiado==true) {
				original.setTarDescripSegui(tar.getTarDescripSegui());
				GestorGenerico.registrarSoloSeguimiento(conn,user,""+tar.getTarCod(),tar.getTarDescripSegui(),null,usuario);
				GestorGenerico.enviarNotificacion(conn,user,original,new String[]{GestorGenerico.NotificacionUsuarioCambio});
			}
			
			setErrorMessage("La Tarea ha sido modificada con xito.");
			
		} catch (Exception ex) {
			setErrorMessage("GestorAtencion[cambiaTarea]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
	}

	public D7GruposCostes getGrupoCoste() {	return grupoCoste; }
	
	public void obtenerGrupoCoste(Session conn) {
		try {
			
			Criteria ct = conn.createCriteria(D7Informaticos.class);
			ct = ct.add(Expression.eq("InfSisCod",user.getDatosMenu().idSelected()));
			ct = ct.add(Expression.eq("InfCod",user.getIdentificador()));
			
			D7Informaticos inf = (D7Informaticos)ct.list().get(0);
			
			ct = conn.createCriteria(D7GruposCostes.class);
			ct = ct.add(Expression.eq("GcoSisCod",user.getDatosMenu().idSelected()));
			ct = ct.add(Expression.eq("GcoCod",inf.getInfGcoCod()));
			
			D7GruposCostes gc = (D7GruposCostes)ct.list().get(0);
			grupoCoste = new D7GruposCostes();
			grupoCoste.setGcoSisCod(gc.getGcoSisCod());
			grupoCoste.setGcoCod(gc.getGcoCod());
			grupoCoste.setGcoHoras(gc.getGcoHoras());
			grupoCoste.setGcoDescrip(gc.getGcoDescrip());
			grupoCoste.setGcoCoste(gc.getGcoCoste());
			grupoCoste.setGcoEstado(gc.getGcoEstado());
			
		} catch (Exception ex) {
			setErrorMessage("GestorAtencion[grupoCoste]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
	}

	public void anularTarea(Session conn,D7Tareas tar) {
		Transaction tx = null;
		try {
			tx = conn.beginTransaction();
			
			Query q = conn.createQuery(getQuery("GetTarea"));
			q.setString("tarCod",""+tar.getTarCod());
			q.setString("sist",user.getDatosMenu().idSelected());
			D7Tareas original = (D7Tareas)q.list().get(0);
			
			String textoActual = "Estado: "+original.getTarEstado();
			original.setTarEstado(D7Tareas.ANULADA);
			String textoNuevo = "Estado: "+original.getTarEstado();
			
			// Debo anular las subtareas !!
			anularSubTareas(conn,tar,tar.getTarDescripSegui());
			
			conn.saveOrUpdate(original);
			tx.commit();
			
			if (notEmpty(original.getTarDescrip())) GestorGenerico.registrarMovimiento(conn,user,""+original.getTarCod(),"Cambio en el texto de seguimiento.",D7TareasMovimientos.MODIFICAR_TAREA,original.getTarDescripSegui(),tar.getTarDescripSegui());
			
			GestorGenerico.registrarMovimiento(conn,user,""+tar.getTarCod(),tar.getTarDescripSegui(),D7TareasMovimientos.ANULAR_TAREA,textoActual,textoNuevo);
			GestorGenerico.enviarNotificacion(conn,user,original,new String[]{GestorGenerico.NotificacionUsuarioAnulacion});
			
			setErrorMessage("La Tarea ha sido anulada con xito.");
			
		} catch (Exception ex) {
			if (tx!=null) tx.rollback();
			setErrorMessage("GestorAtencion[anularTarea]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
	}

	public void reactivarTarea(Session conn,D7Tareas tar) {
		Transaction tx = null;
		try {
			tx = conn.beginTransaction();
			
			Query q = conn.createQuery(getQuery("GetTarea"));
			q.setString("tarCod",""+tar.getTarCod());
			q.setString("sist",user.getDatosMenu().idSelected());
			D7Tareas original = (D7Tareas)q.list().get(0);
			String textoActual = "Estado: "+original.getTarEstado();
			original.setTarEstado(D7Tareas.ASIGNADA);
			String textoNuevo = "Estado: "+original.getTarEstado();
			
			conn.saveOrUpdate(original);
			tx.commit();
			
			GestorGenerico.registrarMovimiento(conn,user,""+tar.getTarCod(),tar.getTarDescripSegui(),D7TareasMovimientos.REACTIVAR,textoActual,textoNuevo);
			GestorGenerico.enviarNotificacion(conn,user,original,new String[]{GestorGenerico.NotificacionInformaticoReactivacionAnulada});
			
			setErrorMessage("La Tarea ha sido reactivada con xito.");
			
		} catch (Exception ex) {
			if (tx!=null) tx.rollback();
			setErrorMessage("GestorAtencion[reactivarTarea]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
	}
	
	public void devolverTarea(Session conn,D7Tareas tar) {
		Transaction tx = null;
		try {
			tx = conn.beginTransaction();
			
			String usuario=user.getIdentificador();
			if (((DumboUser)user).getUsuarioOriginal()!=null) usuario=((DumboUser)user).getUsuarioOriginal().getDataIdentifier(conn);
			
			Query q = conn.createQuery(getQuery("GetTarea"));
			q.setString("tarCod",""+tar.getTarCod());
			q.setString("sist",user.getDatosMenu().idSelected());
			D7Tareas original = (D7Tareas)q.list().get(0);
			String tipoAsignacion="";
			if ((original.getTarInfCod()==null) || original.getTarInfCod().equals("")) tipoAsignacion=D7TareasMovimientos.REASIGNAR_APLICACIONES_GENERICA;
			else tipoAsignacion= D7TareasMovimientos.REASIGNAR_DIRECTA_GENERICA;
			String textoActual = "Estado: "+original.getTarEstado()+" Informtico: "+original.getTarInfEmail()+" Aplicacin: "+original.getAplicacionDesc();
			//if (notEmpty(tar.getTarDescrip())) GestorGenerico.registrarMovimiento(conn,user,""+original.getTarCod(),"Texto seguimiento nuevo: "+tar.getTarDescrip(),D7TareasMovimientos.MODIFICAR_TAREA,"Texto seguimiento antiguo: "+original.getTarDescripSegui());
			original.setTarEstado(D7Tareas.PENDIENTE);
			original.setTarInfCod(null);
			original.setTarAplCod(null);
			String textoNuevo = "Estado: "+original.getTarEstado();
			//original.setTarDescripSegui(tar.getTarDescripSegui());
			
			// Debo anular las subtareas !!
			anularSubTareas(conn,tar,tar.getTarDescripSegui());
			
			conn.saveOrUpdate(original);
			tx.commit();
			
			GestorGenerico.registrarSoloSeguimiento(conn,user,""+tar.getTarCod(),"Devolver a la cola: "+tar.getTarDescripSegui(),tar.getTarHorasRes(),usuario);
			
			GestorGenerico.registrarMovimiento(conn,user,""+tar.getTarCod(),tar.getTarDescripSegui(),tipoAsignacion,textoActual,textoNuevo);
			//GestorGenerico.registrarSoloSeguimiento(conn,user,""+tar.getTarCod(),tar.getTarDescripSegui());
			GestorGenerico.enviarNotificacion(conn,user,original,new String[]{"NotificacionUsuarioDevolverCola"});
			
			setErrorMessage("La Tarea ha sido devuelta a la cola genrica con xito.");
			
		} catch (Exception ex) {
			if (tx!=null) tx.rollback();
			setErrorMessage("GestorAtencion[devolverTarea]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
	}
	
	
	public void modificaBitacora(Session conn,D7Tareas tar) {
		try {
			String usuario=user.getIdentificador();
			if (((DumboUser)user).getUsuarioOriginal()!=null) usuario=((DumboUser)user).getUsuarioOriginal().getDataIdentifier(conn);
			Transaction tx = conn.beginTransaction();
			//int numMov = GestorGenerico.registrarSoloSeguimiento(conn,user,""+tar.getTarCod(),tar.getTarDescripSegui());
			int numMov = GestorGenerico.registrarSoloSeguimiento(conn,user,""+tar.getTarCod(),tar.getTarDescripSegui(),tar.getTarHorasRes(),usuario);
			tx.commit();

			Query q = conn.createQuery(getQuery("GetTarea"));
			q.setString("tarCod",""+tar.getTarCod());
			q.setString("sist",user.getDatosMenu().idSelected());
			D7Tareas original = (D7Tareas)q.list().get(0);
			
			//Si la entrada en bitacora la est haciendo un oreja, y no es suya la tarea, hay que mandar un correo al infomtico avisndole del cambio
			//pero si ya estaba el campo cont  a true, es porque y se ha mandado correo al cambiar seguimiento
			if (!original.getTarInfCod().equals(user.getIdentificador())){
				if (correo) GestorGenerico.enviarNotificacion(conn,user,original,new String[]{GestorGenerico.NotificacionInformaticoCambio});
				correo=false;
			}
			
			// ************************************************
			// Tratamiento de Anexos !!
			// ************************************************
			Enumeration en = anexos.elements();
			while (en.hasMoreElements()) {
				Hashtable file = (Hashtable) en.nextElement();
				File fforg = new File((String)file.get("content"));
				if (!fforg.exists()) throw new Exception("El fichero "+(String)file.get("filename")+" excede el tamao mximo permitido 15MB.");
				FileInputStream forigen = new FileInputStream(fforg);
				String nombreAnexo = GestorGenerico.getNameAnexoPrivado(rutaAnexos+GestorGenerico.getMesActual(original.getTarFeccrea())+File.separator,""+tar.getTarCod(),(String)file.get("filename"),numMov);
				
				File fd = new File(nombreAnexo);
				int copia = 1;
				while (fd.exists()) {
					if (copia>1) nombreAnexo = nombreAnexo.replaceFirst("Copia "+(copia-1)+" de","Copia "+copia+" de");
					else nombreAnexo = nombreAnexo.replaceFirst((String)file.get("filename"),"Copia "+copia+" de "+(String)file.get("filename"));
					fd = new File(nombreAnexo); copia++;
				}
				FileOutputStream fdestino = new FileOutputStream(fd);
				
				byte [] bytes = new byte[4096];
				int leido = forigen.read(bytes,0,4096);
				while (leido!=-1) {
					fdestino.write(bytes,0,leido);
					leido = forigen.read(bytes,0,4096);
				}
				forigen.close(); fdestino.close();
				fforg.delete();
			}
			
		} catch (Exception ex) {
			setErrorMessage("GestorAtencion[modificaBitacora]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
	}
	
	public void setDedicacion(String dedi){
		if (!dedi.equals("")) this.dedicacion=new java.math.BigDecimal(dedi);
	}
	
	public void setTexto(String text){
		this.texto=text;
	}
	
	public void modificaMiBitacora(Session conn,String cod) {
		try {
			String usuario=user.getIdentificador();
			if (((DumboUser)user).getUsuarioOriginal()!=null) usuario=((DumboUser)user).getUsuarioOriginal().getDataIdentifier(conn);
			Transaction tx = conn.beginTransaction();
			//int numMov = GestorGenerico.registrarSoloSeguimiento(conn,user,""+tar.getTarCod(),tar.getTarDescripSegui());
			int numMov = GestorGenerico.registrarSoloSeguimiento(conn,user,""+cod,texto,dedicacion,usuario);
			tx.commit();

			Query q = conn.createQuery(getQuery("GetTarea"));
			q.setString("tarCod",""+cod);
			q.setString("sist",user.getDatosMenu().idSelected());
			D7Tareas original = (D7Tareas)q.list().get(0);
			
			//Si la entrada en bitacora la est haciendo un oreja, y no es suya la tarea, hay que mandar un correo al infomtico avisndole del cambio
			//pero si ya estaba el campo cont  a true, es porque y se ha mandado correo al cambiar seguimiento
			if (!original.getTarInfCod().equals(user.getIdentificador())){
				if (correo) GestorGenerico.enviarNotificacion(conn,user,original,new String[]{GestorGenerico.NotificacionInformaticoCambio});
				correo=false;
			}
			
			// ************************************************
			// Tratamiento de Anexos !!
			// ************************************************
			Enumeration en = anexos.elements();
			while (en.hasMoreElements()) {
				Hashtable file = (Hashtable) en.nextElement();
				File fforg = new File((String)file.get("content"));
				if (!fforg.exists()) throw new Exception("El fichero "+(String)file.get("filename")+" excede el tamao mximo permitido 15MB.");
				FileInputStream forigen = new FileInputStream(fforg);
				String nombreAnexo = GestorGenerico.getNameAnexoPrivado(rutaAnexos+GestorGenerico.getMesActual(original.getTarFeccrea())+File.separator,""+dedicacion,(String)file.get("filename"),numMov);
				
				File fd = new File(nombreAnexo);
				int copia = 1;
				while (fd.exists()) {
					if (copia>1) nombreAnexo = nombreAnexo.replaceFirst("Copia "+(copia-1)+" de","Copia "+copia+" de");
					else nombreAnexo = nombreAnexo.replaceFirst((String)file.get("filename"),"Copia "+copia+" de "+(String)file.get("filename"));
					fd = new File(nombreAnexo); copia++;
				}
				FileOutputStream fdestino = new FileOutputStream(fd);
				
				byte [] bytes = new byte[4096];
				int leido = forigen.read(bytes,0,4096);
				while (leido!=-1) {
					fdestino.write(bytes,0,leido);
					leido = forigen.read(bytes,0,4096);
				}
				forigen.close(); fdestino.close();
				fforg.delete();
			}
			
		} catch (Exception ex) {
			setErrorMessage("GestorAtencion[modificaMiBitacora]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
	}
	
	public void modificaSeguimiento(Session conn,String cod) {
		try {
			
			Query q = conn.createQuery(getQuery("GetTarea"));
			q.setString("tarCod",""+cod);
			q.setString("sist",user.getDatosMenu().idSelected());
			D7Tareas original = (D7Tareas)q.list().get(0);
			
			String usuario=user.getIdentificador();
			if (((DumboUser)user).getUsuarioOriginal()!=null) usuario=((DumboUser)user).getUsuarioOriginal().getDataIdentifier(conn);
			
			if (haCambiado(original.getTarDescripSegui(),texto) && texto!=null && !texto.trim().equals("") && (texto.length()>1 || (texto.charAt(0)-0)!=160)) {
				GestorGenerico.registrarSoloSeguimiento(conn,user,""+cod,texto,null,usuario);
				original.setTarDescripSegui(texto);
				//Si la entrada en bitacora la est haciendo un oreja, y no es suya la tarea, hay que mandar un correo al infomtico avisndole del cambio
				if (!original.getTarInfCod().equals(user.getIdentificador())){
					//Si oreja ya era true, ya se ha mandado correo a informatico, por tanto solo se manda a usuario
					correo=true;
					GestorGenerico.enviarNotificacion(conn,user,original,new String[]{GestorGenerico.NotificacionUsuarioCambio,GestorGenerico.NotificacionInformaticoCambio});
				}
			}
		} catch (Exception ex) {
			setErrorMessage("GestorAtencion[modificaMiBitacora]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
	}
	
	public void seguimientoSolicitud(Session conn,String code) {
		try {
			if ((code==null) || code.equals("")) return;
			Query q = conn.createQuery(getQuery("SeguimientoTarea"));
			q = q.setString("sist",user.getDatosMenu().idSelected());
			q = q.setString("code",code);
			seguimientos = q.list();
			
		} catch (Exception ex) {
			setErrorMessage("GestorAtencion[seguimientoSolicitud]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
	}
	
	public void listaUsuariosSeguimiento(Session conn) {
		try {
			String usuarios = new String();
			
			for(int i=0;i<seguimientos.size();i++)
			{
				if (((D7TareasSeguimientos)seguimientos.get(i)).getTseUsuCod() != null)
					usuarios = usuarios + "'" + ((D7TareasSeguimientos)seguimientos.get(i)).getTseUsuCod() + "'" + ",";
			}
			usuarios = usuarios.substring(0,usuarios.length()-1);//Eliminamos la ltima coma
			
			Query q = conn.createQuery(getQuery("UsuariosSeguimiento").replaceAll(":usuarios","("+usuarios+")"));
			datosTrabajadores = q.list();
			
		} catch (Exception ex) {
			setErrorMessage("GestorAtencion[listaUsuariosSeguimiento]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
	}
	

	public void setFiltro(HttpServlet servlet,HttpServletRequest req,HttpServletResponse res,String tipo) {
		try {
			filtro = ((DumboUser)user).getFiltroUsuario(tipo);
			if (filtro==null) {
				filtro = new FiltroUsuario(tipo);
				((DumboUser)user).setFiltroUsuario(tipo,filtro);
			}
		} catch (Exception ex) {
			setErrorMessage("GestorAtencion[setFiltro]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
	}
	
	/*
	public Query aplicaFiltro(Session conn,String nombre,String filt) throws Exception {
		setFiltro(null,null,null,filt);
		return GestorGenerico.aplicaFiltro(conn,user,getQuery(nombre),filtro,filt);
	}
	*/
	public List aplicaFiltroSQL(Session conn,String qry,boolean sbQry,String filt,Hashtable params) throws Exception {
		setFiltro(null,null,null,filt);
		return GestorGenerico.aplicaFiltroSQL(conn,user,getQuery(qry),sbQry,filtro,filt,params,params.size());
	}
	
	public void recargaLista(HttpServlet servlet,HttpServletRequest req,HttpServletResponse res) {
		// Me cepillo el Gestor Atencin existente.
		req.getSession(true).removeAttribute("dumbo7.atencion.GestorAtencion");
	}

	public boolean accept(File fichero, String nombre) {
		// message = PREFIJO_CODE_NOMBRE
		// nombre = PREFIJO_CODE_NOMBRE
		// El prefijo no coincide
		if (!getPrefijoNombre(nombre).equals(getPrefijoNombre(message))) return false;
		if (!getCodeNombre(nombre).equals(getCodeNombre(message))) return false;
		if (Math.abs(nombre.length()-message.length())>2) return false;
		String nameOrg = getNameNombre(message);
		String nameFile = getNameNombre(nombre);
		int indFallo=0, falloInd = 0;
		for (int k=0; k<nameFile.length(); k++) {
			if (nameFile.charAt(k)!=nameOrg.charAt(k)) {
				indFallo = k;
				break;
			}
		}
		for (int k=nameFile.length()-1,j=nameOrg.length()-1; k>=0 && j>=0; k--,j--) {
			if (nameFile.charAt(k)!=nameOrg.charAt(j)) {
				falloInd = k;
				break;
			}
		}
		int fallos = Math.abs(falloInd-indFallo);
		return (fallos<=2);
	}

	private String getPrefijoNombre(String s) { return s.substring(0,s.indexOf("_")); }
	private String getCodeNombre(String s) { return s.substring(s.indexOf("_")+1,s.indexOf("_",s.indexOf("_")+1)); }
	private String getNameNombre(String s) { return s.substring(s.indexOf("_",s.indexOf("_")+1)+1); }
	
	public void updateSolicitud(Session conn,D7Tareas sol) {
		try {
			Transaction tx = conn.beginTransaction();
			Query q = conn.createQuery(getQuery("GetTarea"));
			q.setString("tarCod",""+sol.getTarCod());
			q.setString("sist",user.getDatosMenu().idSelected());
			D7Tareas original = (D7Tareas)q.list().get(0);
			String textoActual = "";
			String textoNuevo = "";
			
			textoActual += " Texto Tarea: "+original.getTarDescrip();
			original.setTarDescrip(sol.getTarDescrip());
			textoNuevo += " Texto Tarea: "+original.getTarDescrip();
			
			conn.saveOrUpdate(original);
			tx.commit();
			
			GestorGenerico.registrarMovimiento(conn,user,""+sol.getTarCod(),GestorGenerico.MODIFICA_TAREA,D7TareasMovimientos.MODIFICAR_TAREA,textoActual,textoNuevo);
			GestorGenerico.enviarNotificacion(conn,user,original,new String[]{GestorGenerico.NotificacionInformaticoCambio});
			
			setErrorMessage("La Tarea ha sido actualizada con xito.");
		} catch (Exception ex) {
			setErrorMessage("GestorAtencion[updateSolicitud]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
	}
}
