/*
 * 
 *
 */
package dumbo7.ayuda;

import java.io.IOException;

import org.apache.log4j.*;
import org.xml.sax.EntityResolver;
import org.xml.sax.InputSource;
import org.xml.sax.SAXException;

import atica.frameweb.xml.*;
import atica.frameweb.utils.*;
import javax.servlet.http.*;
import java.util.Hashtable;

/**
 * @author Universidad de Murcia - ATICA
 *
 */

public class GestorAyuda extends GeneralManager implements EntityResolver {
	
	static Logger logger = Logger.getLogger(GestorAyuda.class);
	
	private static final String PDF_TYPE = "application/pdf";
	private static final String HTML_TYPE = "text/html";
	private static final String FILENAME = "manualDumbo";
	private static final String MODULE_DIR = "modules/";
	private static final String ALL_HELP = "help.xml";
	private static final String INDEX = "dumbo7/ayuda/html/index.xsl";
	private static final String INDEXALL = "dumbo7/ayuda/html/indexAll.xsl";
	private static final String INDEXPDF = "dumbo7/ayuda/html/indexPdf.xsl";
	private static final String INDEXALLPDF = "dumbo7/ayuda/html/indexAllPdf.xsl";
	
	public GestorAyuda() {}
	
	public void muestraAyuda(HttpServlet servlet,HttpServletRequest req,HttpServletResponse res,String file) throws Exception {
		res.setContentType(HTML_TYPE);
		Hashtable h = new Hashtable();
		h.put("help",file);
		XMLUtil.mezclaDoc(this.getClass().getClassLoader(),XMLUtil.parse(getClass().getResource(MODULE_DIR+file).openStream(),this),INDEX,h,res.getOutputStream());
	}
	public void muestraAyudaPDF(HttpServlet servlet,HttpServletRequest req,HttpServletResponse res,String file) throws Exception {
		res.setContentType(HTML_TYPE);
		Hashtable h = new Hashtable();
		h.put("help",file);
		XMLUtil.mezclaFop(this.getClass().getClassLoader(),XMLUtil.parse(getClass().getResource(MODULE_DIR+file).openStream(),this),INDEXPDF,h,res,PDF_TYPE,FILENAME);
	}
	public void muestraAyudaCompleta(HttpServlet servlet,HttpServletRequest req,HttpServletResponse res) throws Exception {
		res.setContentType(HTML_TYPE);
		XMLUtil.mezclaDoc(this.getClass().getClassLoader(),XMLUtil.parse(getClass().getResource(MODULE_DIR+ALL_HELP).openStream(),this),INDEXALL,null,res.getOutputStream());
	}
	public void muestraAyudaCompletaPDF(HttpServlet servlet,HttpServletRequest req,HttpServletResponse res) throws Exception {
		res.setContentType(PDF_TYPE);
		XMLUtil.mezclaFop(this.getClass().getClassLoader(),XMLUtil.parse(getClass().getResource(MODULE_DIR+ALL_HELP).openStream(),this),INDEXALLPDF,null,res,PDF_TYPE,FILENAME);
	}
	
	public InputSource resolveEntity(String href,String base) throws SAXException,IOException {
		try {
			 InputSource is = new InputSource(getClass().getResource(MODULE_DIR+base.substring(base.lastIndexOf("/")+1)).openStream());
			 is.setEncoding(XMLUtil.ENCODING);
			 return is;
		} catch (Throwable t) { /* do nothing */ }
		return null;
	}

}
