<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:output method="html"/>
<xsl:param name="help"/>

<xsl:template match="CHAPTER/HELP">
	<xsl:call-template name="showAll">
		<xsl:with-param name="cap" select="../@CODE"/>
	</xsl:call-template>
</xsl:template>

<xsl:template match="HELP/HELP">
<html lang="es">
	<head>
		<title><xsl:value-of select="TITLE"/></title>
		<link REL="stylesheet" HREF="../ayuda.css" TYPE="text/css"/>
	</head>
	<body>
		<xsl:call-template name="showAll"/>
	</body>
</html>
</xsl:template>

<xsl:template name="showAll">
<xsl:param name="cap" select="'1'"/>
	<a name="{TITLE}"><h1><xsl:value-of select="TITLE"/></h1></a>
	<h2>ndice</h2>
	<xsl:call-template name="showIndex">
		<xsl:with-param name="items" select="INDEX"/>
		<xsl:with-param name="clase" select="1"/>
		<xsl:with-param name="cap" select="$cap"/>
	</xsl:call-template>
	<br/>
	<hr width="80%" align="left"/>
	<br/>
	<xsl:call-template name="showContent">
		<xsl:with-param name="items" select="INDEX"/>
		<xsl:with-param name="parts" select="CONTENT"/>
		<xsl:with-param name="clase" select="1"/>
		<xsl:with-param name="cap" select="$cap"/>
	</xsl:call-template>
	<p align="center">
	<xsl:choose>
	<xsl:when test="string-length($help)>0">
	<a href="dumbo7.Dumbo7?module=dumbo7/ayuda.indexPdf&amp;help={$help}">Captulo Completo en PDF</a>&#160;
	</xsl:when>
	<xsl:otherwise>
	<a href="dumbo7.Dumbo7?module=dumbo7/ayuda.indexPdf&amp;help={translate(TITLE,'ABCDEFGHIJKLMNOPQRSTUVWXYZ','abcdefghijklmnopqrstuvwxyzaeiouaeiouoouu')}.xml">Captulo Completo en PDF</a>&#160;
	</xsl:otherwise>
	</xsl:choose>
	<xsl:if test="string-length($help)>0">
	<a href="dumbo7.Dumbo7?module=dumbo7/ayuda.indexAll">Manual Completo en HTML</a>&#160;
	</xsl:if>
	<a href="dumbo7.Dumbo7?module=dumbo7/ayuda.indexAllPdf">Manual Completo en PDF</a>
	</p>
</xsl:template>

<xsl:template name="showIndex">
<xsl:param name="items"/>
<xsl:param name="clase"/>
<xsl:param name="cap" select="'1'"/>
<table width="100%">
	<xsl:for-each select="$items/ITEM">
		<tr class="ind{$clase}">
			<td class="ind{$clase}" colspan="2"><xsl:value-of select="CODE"/>.-&#160;<a class="ind{$clase}" href="#{$cap}.{CODE}"><xsl:value-of select="NAME"/></a></td>
		</tr>
		<xsl:if test="count(./ITEM)>0">
			<tr>
				<td>&#160;</td>
				<td>
					<xsl:call-template name="showIndex">
						<xsl:with-param name="items" select="."/>
						<xsl:with-param name="clase" select="$clase+1"/>
						<xsl:with-param name="cap" select="$cap"/>
					</xsl:call-template>
				</td>
			</tr>
		</xsl:if>
	</xsl:for-each>
</table>
</xsl:template>

<xsl:template name="showContent">
<xsl:param name="items"/>
<xsl:param name="parts"/>
<xsl:param name="clase"/>
<xsl:param name="cap" select="'1'"/>
<xsl:for-each select="$items/ITEM">
	<xsl:variable name="cod" select="CODE"/>
	<xsl:variable name="ptr" select="$parts//PART[@CODE=$cod and (not(@TYPE) or @TYPE='HTML')]"/>
	<table width="100%">
		<tr class="prt{$clase}"><td colspan="2"><h3><a name="{$cap}.{./CODE}"><xsl:value-of select="./CODE"/>.-</a>&#160;<xsl:value-of select="./NAME"/></h3></td></tr>
		<tr class="prt{$clase}"><td>&#160;</td><td><xsl:copy-of select="$ptr/*"/></td></tr>
		<tr><td colspan="2">&#160;</td></tr>
		<xsl:if test="count(./ITEM)>0">
			<tr>
				<td>&#160;</td>
				<td>
					<xsl:call-template name="showContent">
						<xsl:with-param name="items" select="."/>
						<xsl:with-param name="parts" select="$parts"/>
						<xsl:with-param name="clase" select="$clase+1"/>
						<xsl:with-param name="cap" select="$cap"/>
					</xsl:call-template>
				</td>
			</tr>
		</xsl:if>
		<xsl:if test="count(./ITEM)=0">
		<tr><td colspan="2" align="right">&#160;<a href="#{$items/../TITLE}">Inicio Captulo</a></td></tr>
		</xsl:if>
	</table>
</xsl:for-each>
</xsl:template>

</xsl:stylesheet>
	