<?xml version="1.0" encoding="ISO-8859-1"?>

<xsl:stylesheet version="1.0"
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
  xmlns:fo="http://www.w3.org/1999/XSL/Format">

<xsl:template match="HELPS">
  <fo:root xmlns:fo="http://www.w3.org/1999/XSL/Format">
    <fo:layout-master-set>
      <fo:simple-page-master master-name="simple"
                             page-height="29.7cm" 
                             page-width="21cm"
                             margin-top="1cm" 
                             margin-bottom="1cm" 
                             margin-left="2cm" 
                             margin-right="1.5cm">
        <fo:region-before extent="1.5cm"/>
        <fo:region-after extent="1.5cm"/>
        <fo:region-body margin-top="1.5cm"
                        margin-bottom="1.5cm"/>
      </fo:simple-page-master>
    </fo:layout-master-set>

    <fo:page-sequence master-reference="simple">
      <!-- cabecera -->
      <fo:static-content flow-name="xsl-region-before">
        <fo:block font-size="10pt" text-align="left">
			Manual de DUMBO: COMPLETO
		</fo:block>
      </fo:static-content>

      <!-- pie de pgina -->
      <fo:static-content flow-name="xsl-region-after">
        <fo:block font-size="10pt" text-align="end">Pgina <fo:page-number/></fo:block>
      </fo:static-content>

      <fo:flow flow-name="xsl-region-body">
		<fo:block font-size="16pt" font-weight="bold"
			  font-family="sans-serif"
			  background-color="gray" color="white"
			  text-align="center">
		  MANUAL DE DUMBO
		</fo:block>
		<xsl:for-each select="CHAPTER/HELP">
			<fo:block font-size="14pt" font-weight="bold"
			  font-family="sans-serif"
			  space-after.optimum="10pt"
			  space-before.optimum="10pt"
			  text-align="left" color="green">
				Captulo <xsl:value-of select="../@CODE"/>:&#160;<xsl:value-of select="TITLE"/>
			</fo:block>
			<xsl:call-template name="showIndex">
				<xsl:with-param name="items" select="INDEX"/>
				<xsl:with-param name="clase" select="1"/>
				<xsl:with-param name="cap" select="../@CODE"/>
			</xsl:call-template>
		</xsl:for-each>
		<xsl:apply-templates/>
      </fo:flow>
    </fo:page-sequence>
  </fo:root>
</xsl:template>

<xsl:template match="HELP">
<fo:block font-size="14pt" font-weight="bold"
	  font-family="sans-serif"
	  space-after.optimum="10pt"
	  space-before.optimum="12pt"
	  background-color="gray" color="white"
	  text-align="center"
	  break-before="page">
	<xsl:value-of select="TITLE"/>
</fo:block>
<xsl:call-template name="showContent">
	<xsl:with-param name="items" select="INDEX"/>
	<xsl:with-param name="parts" select="CONTENT"/>
	<xsl:with-param name="clase" select="1"/>
	<xsl:with-param name="cap" select="../@CODE"/>
</xsl:call-template>
</xsl:template>

<xsl:template name="showIndex">
<xsl:param name="items"/>
<xsl:param name="clase"/>
<xsl:param name="cap"/>
<fo:table border-width="0pt" space-before.optimum="2pt">
<!-- EL ANCHO DE LAS COLUMNAS DEBE SUMA 17.5cm -->
<fo:table-column column-width="17.5cm"/>
	<fo:table-body>
	<xsl:for-each select="$items/ITEM">
		<fo:table-row>
			<fo:table-cell border-width="0pt" border-style="solid" padding="2pt">
				<fo:block font-size="10pt" font-weight="bold"
			          font-family="sans-serif"
	        		  text-align="left">
			  	  <xsl:value-of select="CODE"/>.-&#160;<fo:inline font-weight="bold" color="blue"><xsl:value-of select="NAME"/></fo:inline>
		        </fo:block>
			</fo:table-cell>
		</fo:table-row>
		<xsl:if test="count(./ITEM)>0">
			<fo:table-row>
				<fo:table-cell border-width="0pt" border-style="solid" padding="2pt">
					<xsl:call-template name="showIndex">
						<xsl:with-param name="items" select="."/>
						<xsl:with-param name="clase" select="$clase+1"/>
						<xsl:with-param name="cap" select="$cap"/>
					</xsl:call-template>
				</fo:table-cell>
			</fo:table-row>
		</xsl:if>
	</xsl:for-each>
	</fo:table-body>
</fo:table>
</xsl:template>

<xsl:template name="showContent">
<xsl:param name="items"/>
<xsl:param name="parts"/>
<xsl:param name="clase"/>
<xsl:param name="cap"/>
<xsl:for-each select="$items/ITEM">
	<xsl:variable name="cod" select="CODE"/>
	<xsl:variable name="ptr" select="$parts//PART[@CODE=$cod and @TYPE='PDF']"/>
	<fo:table border-width="0pt" space-before.optimum="2pt">
	<!-- EL ANCHO DE LAS COLUMNAS DEBE SUMA 17.5cm -->
	<fo:table-column column-width="17.5cm"/>
		<fo:table-body>
		<fo:table-row>
			<fo:table-cell border-width="0pt" border-style="solid" padding="2pt">
				<fo:block font-size="12pt" font-weight="bold"
			          font-family="sans-serif"
					  space-after.optimum="10pt"
					  space-before.optimum="10pt"
	        		  text-align="left" id="{$cap}.{CODE}">
			  	  <xsl:value-of select="CODE"/>.-&#160;<fo:inline font-weight="bold"><xsl:value-of select="NAME"/></fo:inline>
		        </fo:block>
			</fo:table-cell>
		</fo:table-row>
		<fo:table-row>
			<fo:table-cell border-width="0pt" border-style="solid" padding="2pt">
				<xsl:copy-of select="$ptr/*"/>
			</fo:table-cell>
		</fo:table-row>
		<xsl:if test="count(./ITEM)>0">
			<fo:table-row>
				<fo:table-cell border-width="0pt" border-style="solid" padding="2pt">
					<fo:block font-size="10pt"
							  font-family="sans-serif"
							  text-align="left">
						<xsl:call-template name="showContent">
							<xsl:with-param name="items" select="."/>
							<xsl:with-param name="parts" select="$parts"/>
							<xsl:with-param name="clase" select="$clase+1"/>
							<xsl:with-param name="cap" select="$cap"/>
						</xsl:call-template>
					</fo:block>
				</fo:table-cell>
			</fo:table-row>
		</xsl:if>
		</fo:table-body>
	</fo:table>
</xsl:for-each>
</xsl:template>

</xsl:stylesheet>
	
