
package dumbo7.geshorario;

import org.apache.log4j.*;
import atica.frameweb.utils.*;
import org.hibernate.*;
import org.hibernate.criterion.*;

import java.util.*;
import java.util.Date;
import java.util.zip.ZipEntry;
import java.util.zip.ZipOutputStream;
import dumbo7.user.DumboUser;
import dumbo7.user.FiltroUsuario;
import java.sql.*;
import dumbo7.utils.*;
import dumbo7.*;
import javax.servlet.http.*;

import java.sql.CallableStatement;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.Types;



/**
 * @author pedrovp
 *
 * Gestor de horarios 
 * 
 */

public class geshorario extends GeneralManager {
	


	protected List datosPersonales = null;
	public List diasFestivos;
	public List turnos;
	public List correos;
	public List orejas;
	public List horarios;
	public List piques;
	public List horaskron ;
	public int diaSemana;
	public int largomes;
	public int dia=0;
	public int mes=0;
	public int ao=0;
	public String dni;
	public String sistema;
	public int turno;
	public boolean modificar = false;
	public boolean copiar = false;
	public geshorario() {}
	
	public boolean getCopiar(){ return copiar;}
	public List getHoraskron(){return horaskron;}
	public List getPiques(){ return piques;}
	public List getDiasFestivos() { return diasFestivos; }
	public List getTurnos() { return turnos; }
	public List getHorarios() { return horarios; }
	public List getCorreos() { return correos; }
	public List getOrejas() { return orejas; }
	public int getDiaSemana() { return diaSemana; }
	public int getMes(){return mes;}
	public int getAo(){return ao;}
	public int getDia(){return dia;}
	public boolean getModificar(){return modificar;}
	public void setcopiar(){
		
		copiar = true;
		
	}
	public void setModificar(Session conn) {
		try {
			
			Criteria ct = conn.createCriteria(D7InformaticosPerfiles.class);
			
			ct = ct.add(Expression.eq("IpeSisCod",user.getDatosMenu().idSelected()));
			ct = ct.add(Expression.eq("IpeInfCod",user.getIdentificador()));
			ct = ct.add(Expression.eq("IpePerCod","11"));
			
			List l = ct.list();
			
			
			if (l!=null && l.size()>0) {
				modificar = true;
			}else{
				modificar = false;
			}
				
		} catch (Exception ex) {
			setErrorMessage("ModificarAusencia: "+ex);
		}
		
	}
	public Date horaini;
	public Date horafin;
	
	public String getFecha(){
		String salida;

		if(mes<10){
			salida = ao + "-0" + mes;
		}else{
			salida= ao + "-" + mes;
		}
		if(dia==0){
			salida += "-diaT00:00:00.000";
		}else{
			if(dia<10){
				salida += "-0" + dia + "T00:00:00.000";
			}else{
				salida += "-" + dia + "T00:00:00.000";
			}
				
		}
		
		return salida;
	}
	public void setFechaTurno(D7Turnos al){
		if(al.getTurFecfinVigencia()!=null){
		dia = al.getTurFecfinVigencia().getDate();
		mes = al.getTurFecfinVigencia().getMonth()+1;
		ao = al.getTurFecfinVigencia().getYear()+1900;
		}else{
			dia = 0;
			mes = 0;
			ao = 0;
		}
	}
	
	public void sethoraini(Integer i){
		horaini= new Date();
		horaini.setHours(i.intValue());
		
		
		
	}
	
	
	public void sethorafin(Integer i){
		horafin = new Date();
		horafin.setHours(i.intValue());
	}
	public void setminini(Integer i){
		horaini.setMinutes(i.intValue());
	}
	public void setminfin(Integer i){
		horafin.setMinutes(i.intValue());
	}
	
	public void setfecha(){
		
		Calendar d1 = Calendar.getInstance();
		
		mes = d1.get(Calendar.MONTH)+1;
		ao = d1.get(Calendar.YEAR);

	}
	
public void setdia(java.lang.Integer ndia){
		dia = ndia.intValue();
}
	
	public void setmes(java.lang.Integer nmes){
	int mesaux = nmes.intValue();
if(mesaux>12){
	mes = 1;
	ao = ao+1;
}else if(mesaux==0)
{
	mes = 12;
	ao = ao-1;
}else
	mes = mesaux;
}

public void setao(java.lang.Integer nao){
	ao = nao.intValue();
	dia = 0;
	turno = 0;
}
	public String getNombreMes(){
		String aux="";
		switch(mes){
		case 1: aux="ENERO"; break;
		case 2: aux="FEBRERO"; break;
		case 3: aux="MARZO"; break;
		case 4: aux="ABRIL"; break;
		case 5: aux="MAYO"; break;
		case 6: aux="JUNIO"; break;
		case 7: aux="JULIO"; break;
		case 8: aux="AGOSTO"; break;
		case 9: aux="SEPTIEMBRE"; break;
		case 10: aux="OCTUBRE"; break;
		case 11: aux="NOVIEMBRE"; break;
		case 12: aux="DICIEMBRE";
		
		}
		return aux;
	}
	

	
	public List getDatosPersonales() { return datosPersonales; }
	public int getNumDiasMes() {
        int dias = 31;
        switch (mes) {
            case 2: if (bisiesto(ao)) dias=29; else dias=28;break;
            case 4: 
            case 6:
            case 9:
            case 11: dias = 30; break;
        }
        return dias;
    }
	 public static boolean bisiesto(int ao) {
	        return ((ao%4==0 && ao%100!=0) || (ao%400==0));
	    }
	 public void setdia(int ndia){
		 dia = ndia;
		 
	 }
	 public void setfecha(Date fecha){
		 
		 dia = fecha.getDate();
		 mes = fecha.getMonth()+1;
		 ao = fecha.getYear()+1900;
		 
	 }
	
	public void listarFestivos(Session conn) {
		try {
			
		//	Query q = conn.createQuery(getQuery("DiasFestivos"));
		//	diasFestivos  = (List)q.list();

			int sao;
			
			int siguiente;
			if(mes+1>12){
				siguiente =1;
				sao = ao + 1;
			}else
			{
				siguiente = mes+1;
				sao = ao;
			}
			
			Criteria ct = conn.createCriteria(D7Festivos.class);

			ct = ct.add(Expression.sql("FES_DIA >= to_date('01/" + mes + "/" + ao + "','dd/MM/yyyy')"));
			ct = ct.add(Expression.sql("FES_DIA < to_date('01/" + siguiente + "/" + sao + "','dd/MM/yyyy')"));


			
diasFestivos = ct.list();			
		} catch (Exception ex) {
			setErrorMessage("GesHorario[Listar Festivos]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
		
	}
	public void cargaTurno(Session conn, D7Turnos al){

			
	
			
			
			Criteria ct = conn.createCriteria(D7Turnos.class);
			ct = ct.add(Expression.eq("turCod", al.getTurCod()));
			ct = ct.add(Expression.eq("turSisCod", user.getDatosMenu().idSelected()));
			turnos = ct.list();
	}

	public void listadoTurnos(Session conn, D7Turnos al) {
		try {
			sistema =user.getDatosMenu().idSelected();
		//	Query q = conn.createQuery(getQuery("DiasFestivos"));
		//	diasFestivos  = (List)q.list();
			String mensaje ="";
			int sao;
			int siguiente;
			if(mes+1>12){
				siguiente =1;
				sao = ao + 1;
			}else
			{
				siguiente = mes+1;
				sao = ao;
			}
			

			Criteria ct = conn.createCriteria(D7Turnos.class);
			
			if(al.getTurEstado()!=null && al.getTurEstado().length()==1){
				mensaje += " estado "+ al.getTurEstado().length();
				ct = ct.add(Expression.sql("TUR_ESTADO = '"+ al.getTurEstado() + "'"));
			}
			
			
			
			if(al.getTurFeciniVigencia()!=null){
				mensaje += " ponermos la fecha "+ al.getTurFeciniVigencia().toString();
				dia = al.getTurFeciniVigencia().getDate();
				mes = al.getTurFeciniVigencia().getMonth()+1;
				ao = al.getTurFeciniVigencia().getYear()+1900;
				
			ct = ct.add(Expression.sql("(TUR_FECFIN_VIGENCIA > to_date('" + dia + "/" + mes + "/" + ao + "','dd/MM/yyyy')OR TUR_FECFIN_VIGENCIA is NULL)"));
			ct = ct.add(Expression.sql("TUR_FECINI_VIGENCIA <= to_date('" + dia + "/" + mes + "/" + ao + "','dd/MM/yyyy')"));

			}else{
				Date d1 =new Date();
				dia = d1.getDate();
				mes = d1.getMonth()+1;
				ao = d1.getYear()+1900;
				
				ct = ct.add(Expression.sql("(TUR_FECFIN_VIGENCIA > to_date('" + dia + "/" + mes + "/" + ao + "','dd/MM/yyyy')OR TUR_FECFIN_VIGENCIA is NULL)"));
				ct = ct.add(Expression.sql("TUR_FECINI_VIGENCIA <= to_date('" + dia + "/" + mes + "/" + ao + "','dd/MM/yyyy')"));
				
				
				
				
				
			}
			
			

			ct = ct.add(Expression.eq("turSisCod", user.getDatosMenu().idSelected()));
			
			turnos = ct.list();
			
			setErrorMessage(mensaje);
			
		} catch (Exception ex) {
			setErrorMessage("GesHorario[Listar Turnos]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
		
	}
	
	
	public void listarTurnos(Session conn, D7Turnos al) {
		try {
			sistema =user.getDatosMenu().idSelected();
		//	Query q = conn.createQuery(getQuery("DiasFestivos"));
		//	diasFestivos  = (List)q.list();
			
			int sao;
			int siguiente;
			if(mes+1>12){
				siguiente =1;
				sao = ao + 1;
			}else
			{
				siguiente = mes+1;
				sao = ao;
			}
			

			Criteria ct = conn.createCriteria(D7Turnos.class);

			if(ao!=0){
				ct = ct.add(Expression.eq("turEstado", "V"));
			if(dia==0){
			ct = ct.add(Expression.sql("(TUR_FECFIN_VIGENCIA >= to_date('01/" + mes + "/" + ao + "','dd/MM/yyyy')OR TUR_FECFIN_VIGENCIA is NULL)"));
			ct = ct.add(Expression.sql("TUR_FECINI_VIGENCIA <= to_date('01/" + siguiente + "/" + sao + "','dd/MM/yyyy')"));
			
			}else{
			ct = ct.add(Expression.sql("(TUR_FECFIN_VIGENCIA > to_date('" + dia + "/" + mes + "/" + ao + "','dd/MM/yyyy')OR TUR_FECFIN_VIGENCIA is NULL)"));
			ct = ct.add(Expression.sql("TUR_FECINI_VIGENCIA <= to_date('" + dia + "/" + mes + "/" + ao + "','dd/MM/yyyy')"));

			}
			
			}

			ct = ct.add(Expression.eq("turSisCod", user.getDatosMenu().idSelected()));
			
			if (al.getTurCod()!=null){
				
				
			}
			turnos = ct.list();
			
			
			
		} catch (Exception ex) {
			setErrorMessage("GesHorario[Listar Turnos]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
		
	}
	public void listarInformaticos(Session conn) {
		try {

			//List h= null;
			
			//for (int i=0; i<horarios.size(); i++) {
				//h.add(((D7Horarios)horarios.get(i)).getHorInfCod());
			//}
			if(0<horarios.size()){
			String dni = new String();
			for (int i=0; i<horarios.size(); i++) {
				dni = dni + "'" + ((D7Horarios)horarios.get(i)).getHorInfCod() + "'" + ",";
			}
			dni = dni.substring(0,dni.length()-1);//Eliminamos la ltima coma

			Criteria ct = conn.createCriteria(D7DatosTrabajador.class);
			ct = ct.add(Expression.sql("DAT_IDENTIFICADOR IN ("+ dni + ")"));
			
			correos = ct.list();
			
			}
		} catch (Exception ex) {
			setErrorMessage("GesHorario[Listar informaticos]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
		
	}
	
	public void listarHorarios(Session conn) {
		try {
			
		//	Query q = conn.createQuery(getQuery("DiasFestivos"));
		//	diasFestivos  = (List)q.list();

			sistema =user.getDatosMenu().idSelected();

		Date d1 = new Date(); 
	
		d1.setMonth(mes-1);
		d1.setYear(ao);
		d1.setDate(0);
		diaSemana = d1.getDay();
		
		int sao;
		
		int siguiente;
		if(mes+1>12){
			siguiente =1;
			sao = ao + 1;
		}else
		{
			siguiente = mes+1;
			sao = ao;
		}
		
			Criteria ct = conn.createCriteria(D7Horarios.class);
if(dia == 0){
			//ct = ct.add(Expression.sql("HOR_AUSENCIA IS NULL OR HOR_AUSENCIA = ''"));
			ct = ct.add(Expression.sql("HOR_FECHA >= to_date('01/" + mes + "/" + ao + "','dd/MM/yyyy') AND (HOR_AUSENCIA IS NULL OR HOR_AUSENCIA = '')"));
			ct = ct.add(Expression.sql("HOR_FECHA < to_date('01/" + siguiente + "/" + sao + "','dd/MM/yyyy')"));
}else{
	ct = ct.add(Expression.sql("HOR_FECHA = to_date('" + dia + "/" + mes + "/" + ao + "','dd/MM/yyyy')"));
}
			ct = ct.add(Expression.eq("HorSisCod", sistema));
			if (turno != 0){
				ct = ct.add(Expression.sql("HOR_TUR_COD ="+ turno));
			}
	
			if(dni!=null){
				ct = ct.add(Expression.eq("HorInfCod", dni));
			}
			
			horarios = ct.list();
			
			
			
		} catch (Exception ex) {
			setErrorMessage("GesHorario[Listar Horarios]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
		
	}
	public void insertaHorario(Session conn,D7Horarios al){
		try {
			Date d1= new Date();

			al.setHorFecmodif(d1);
			
			al.setHorUsuCod(user.getIdentificador());
			dia = al.getHorFecha().getDate();
			mes = al.getHorFecha().getMonth();
			ao = al.getHorFecha().getYear()+1900;
			
			
			Transaction tx = conn.beginTransaction();
			
			conn.save(al);
			tx.commit();
		} catch (Exception ex) {
			setErrorMessage("CrearHorario: "+ex +  " y" + user.getIdentificador().length()+"j");
		}
	}
	
	public void borrarHorario(Session conn,D7Horarios al){
		try {
			
			
			dia = al.getHorFecha().getDate();
			mes = al.getHorFecha().getMonth();
			ao = al.getHorFecha().getYear()+1900;
			
			Criteria ct = conn.createCriteria(D7Horarios.class);
			
			ct = ct.add(Expression.eq("HorSisCod",al.getHorSisCod()));
			ct = ct.add(Expression.eq("HorTurCod",al.getHorTurCod()));
			ct = ct.add(Expression.eq("HorInfCod",al.getHorInfCod()));
			ct = ct.add(Expression.eq("HorFecha",al.getHorFecha()));
			
			List l = ct.list();
			if (l!=null && l.size()>0) {
				Transaction tx = conn.beginTransaction();
				conn.delete(l.get(0));
				tx.commit();
			}
		} catch (Exception ex) {
			setErrorMessage("BorrarAlias: "+ex);
		}
	}
	public void modificarHorario(D7Horarios al){
		try {
			
			
			dia = al.getHorFecha().getDate();
			mes = al.getHorFecha().getMonth()+1;
			ao = al.getHorFecha().getYear()+1900;
			turno = al.getHorTurCod().intValue();
			dni = al.getHorInfCod();
		} catch (Exception ex) {
			setErrorMessage("BorrarAlias: "+ex);
		}
	}
	
	public void modificarAusencia(Session conn,D7Horarios al) {
		try {
			
			dia = al.getHorFecha().getDate();
			mes = al.getHorFecha().getMonth();
			ao = al.getHorFecha().getYear()+1900;
			
			Criteria ct = conn.createCriteria(D7Horarios.class);
			
			ct = ct.add(Expression.eq("HorSisCod",al.getHorSisCod()));
			ct = ct.add(Expression.eq("HorTurCod",al.getHorTurCod()));
			ct = ct.add(Expression.eq("HorInfCod",al.getHorInfCod()));
			ct = ct.add(Expression.eq("HorFecha",al.getHorFecha()));
			List l = ct.list();
			
			
			if (l!=null && l.size()>0) {
				Transaction tx = conn.beginTransaction();
				D7Horarios ali = (D7Horarios)l.get(0);
				if (!al.getHorInfCod().equals("")){
										
						ali.setHorAusencia(al.getHorAusencia());
						ali.setHorMotivo(al.getHorMotivo());
						conn.saveOrUpdate(ali);
						tx.commit();
					
					
					
				}else{
					setErrorMessage("Debe introducir un nuevo dni.");
				}
			}
		} catch (Exception ex) {
			setErrorMessage("ModificarAusencia: "+ex);
		}
	}
	public void nuevoTurno(Session conn,D7Turnos al) {
		try {
			dia = al.getTurFeciniVigencia().getDate();
			mes = al.getTurFeciniVigencia().getMonth();
			ao = al.getTurFeciniVigencia().getYear()+1900;
			if(al.getTurCod()==null){
				
				int turCod = 0;
				
	
				PreparedStatement pstmt = null;
				ResultSet rs = null;
				String qry = "SELECT MAX(TUR_COD) FROM DUMBO.D7_TURNOS";
				pstmt = conn.connection().prepareStatement(qry);
				rs = pstmt.executeQuery();
				if (rs.next()) {
						turCod = rs.getInt(1)+1;
					al.setTurCod(new Integer(turCod));
				}
				Transaction tx = conn.beginTransaction();
				
				conn.save(al);
				tx.commit();
			}else{
				
				Criteria ct = conn.createCriteria(D7Turnos.class);
				
				ct = ct.add(Expression.eq("turSisCod",al.getTurSisCod()));
				ct = ct.add(Expression.eq("turCod",al.getTurCod()));
				List l = ct.list();
				
				if (l!=null && l.size()>0) {
					Transaction tx = conn.beginTransaction();
					D7Turnos ali = (D7Turnos)l.get(0);
					if (!al.getTurCod().equals("")){
											
							ali.setTurFecfinVigencia(al.getTurFecfinVigencia());
							ali.setTurFeciniVigencia(al.getTurFeciniVigencia());
							ali.setTurHoraini(al.getTurHoraini());
							ali.setTurHorafin(al.getTurHorafin());
							ali.setTurEstado(al.getTurEstado());
							ali.setTurNumTecnicos(al.getTurNumTecnicos());
							
							conn.saveOrUpdate(ali);
							tx.commit();
						
						
						
					}else{
						setErrorMessage("El turno ya no existe");
					}
				}
				
			}
			
			
			
			
		} catch (Exception ex) {
			setErrorMessage("Alta nuevo Turno: "+ex+ ";" + al.getTurHoraini() + " : " +al.getTurHorafin());
		}
	}
	public void eliminaTurno(Session conn,D7Turnos al) {
		try {
			
			dia = al.getTurFecfinVigencia().getDate();
			mes = al.getTurFecfinVigencia().getMonth();
			ao = al.getTurFecfinVigencia().getYear()+1900;
			
			Criteria ct = conn.createCriteria(D7Turnos.class);
			
			ct = ct.add(Expression.eq("turSisCod",al.getTurSisCod()));
			ct = ct.add(Expression.eq("turCod",al.getTurCod()));
			
			
			List l = ct.list();
			
			
			if (l!=null && l.size()>0) {
				Transaction tx = conn.beginTransaction();
				D7Turnos ali = (D7Turnos)l.get(0);
				if (!al.getTurCod().equals("")){
										
						ali.setTurFecfinVigencia(al.getTurFecfinVigencia());
						
						conn.saveOrUpdate(ali);
						tx.commit();
					
					
					
				}else{
					setErrorMessage("El turno ya no existe");
				}
			}
		} catch (Exception ex) {
			setErrorMessage("Eliminar Turno: "+ex);
		}
	}

	public void listarkron(Session conn, D7Piquesexternos al) {
		try {
			
		//	Query q = conn.createQuery(getQuery("DiasFestivos"));
		//	diasFestivos  = (List)q.list();

			dia = al.getFechahora().getDate();
			mes = al.getFechahora().getMonth();
			ao = al.getFechahora().getYear()+1900;			

			Criteria ct = conn.createCriteria(D7Piquesexternos.class);
			
			ct = ct.add(Expression.sql("(PIQ_FECHAHORA > to_date('" + dia + "/" + mes + "/" + ao + "','dd/MM/yyyy')OR TUR_FECFIN_VIGENCIA is NULL)"));
			ct = ct.add(Expression.sql("PIQ_FECHAHORA <= to_date('" + dia + "/" + mes + "/" + ao + "','dd/MM/yyyy')"));
			ct = ct.add(Expression.eq("Dni",al.getDni()));
			piques = ct.list();		
		} catch (Exception ex) {
			setErrorMessage("GesHorario[piques kron]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
		
	}
	
	public void trabajado(Session conn) {
		try {
			
		//	Query q = conn.createQuery(getQuery("DiasFestivos"));
		//	diasFestivos  = (List)q.list();
			String identificador;
			int sao;
			horaskron = new ArrayList();
			int siguiente;
			Integer m;
			if(mes+1>12){
				siguiente =1;
				sao = ao + 1;
			}else
			{
				siguiente = mes+1;
				sao = ao;
			}			
			Criteria ct = conn.createCriteria(D7Piquesexternos.class);
			String estado="E";
			int minutos=0;
			boolean primero;
			Date d1 = new Date();
			Date d2 = new Date();
			for (int i=0; i<correos.size(); i++) {
				
				identificador = ((D7DatosTrabajador)correos.get(i)).getDatIdentificador();
				
				ct = ct.add(Expression.sql("PIQ_FECHAHORA >= to_date('01/" + mes + "/" + ao + "','dd/MM/yyyy')"));
				ct = ct.add(Expression.sql("PIQ_FECHAHORA < to_date('01/" + siguiente + "/" + sao + "','dd/MM/yyyy')"));
				
				ct = ct.add(Expression.eq("Dni",identificador));
				piques = ct.list();
				primero=true;
				minutos =0;
			
				for(int j=0; j<piques.size(); j++){
				if(primero){
					if(((D7Piquesexternos)piques.get(j)).getEntsal().equals("E")){
						d1=((D7Piquesexternos)piques.get(j)).getFechahora();
						d2=((D7Piquesexternos)piques.get(j)).getFechahora();
						primero = false;
						estado = "E";
					}
				}else{
				
				
								if(((D7Piquesexternos)piques.get(j)).getEntsal().equals("E")){
																if(d1.getDate()==d2.getDate()){
																	if(estado.equals("S")){
																		minutos += (d2.getHours()*60)-(d1.getHours()*60)+d2.getMinutes()-d1.getMinutes();
																		d1=((D7Piquesexternos)piques.get(j)).getFechahora();
																		d2=((D7Piquesexternos)piques.get(j)).getFechahora();
																		estado = "E";
																	}
																	
																	
																}else{
																	if(estado.equals("S")){
																		minutos += (d2.getHours()*60)-(d1.getHours()*60)+d2.getMinutes()-d1.getMinutes();
																		d1=((D7Piquesexternos)piques.get(j)).getFechahora();
																		d2=((D7Piquesexternos)piques.get(j)).getFechahora();
																		estado = "E";
																	}else{
																		d1=((D7Piquesexternos)piques.get(j)).getFechahora();
																		d2=((D7Piquesexternos)piques.get(j)).getFechahora();
																		estado = "E";
																	}
																}
								}else{
														if(d1.getDate()==d2.getDate()){
															d2=((D7Piquesexternos)piques.get(j)).getFechahora();
															estado = "E";
														}else{
															if(estado.equals("S")){
																minutos += (d2.getHours()*60)-(d1.getHours()*60)+d2.getMinutes()-d1.getMinutes();
																estado = "E";
																primero= true;
														}
										
								}
						
					}//
				}//if de comprobacion si es el primero del dia

				}//fin del for piques
					m = new Integer(minutos);

					datoskron datos2 = new datoskron();
					datos2.datoskron(identificador, m);
					
					horaskron.add(datos2);
					

			}//for de informaticos
			
			

			
		} catch (Exception ex) {
			//setErrorMessage("GesHorario[TRABAJADO SEGUN KRON]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
		
	}
	
	public void listaOrejas(Session conn) {
		try {

			Criteria ct = conn.createCriteria(D7DatosTrabajador.class);
			
			ct = ct.add(Expression.sql("DAT_IDENTIFICADOR IN (select IPE_INF_COD from dumbo.d7_informaticos_perfiles where ipe_per_cod = 31)"));

			orejas = ct.list();

		} catch (Exception ex) {
			setErrorMessage("GesHorario[Listar informaticos]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
		
	}
	
	
	
	
	public void copiarSemana(Session conn,datoscopia datos) {
		CallableStatement cstmt = null;
		try {
			
			Date fcopiar = datos.getFcopia();
			Date fecha = datos.getFecha();
			setfecha(fecha);
			
			int i = fecha.getDay();
			int dinicio = fecha.getDate();
			int duracion =datos.getDuracion().intValue();
			int auxiliar = 0;
			int duracionmes = getNumDiasMes();
			
			
			Date fechaaux = new Date();
			
			
			

				if(duracionmes-fecha.getDate()<duracion){
					duracion = duracionmes-fecha.getDate()+1;
					
				}
				
			
			
			
			
			
			String fechadestino;
			if(dia<10){
				fechadestino = "0" + dia+"/";
			}else{
				fechadestino = dia+"/";
		}
			if(mes<10){
				fechadestino += "0" + mes+"/"+ao;
			}else{
				fechadestino += mes +"/"+ao;
			}
			
			
			
			
			String fechapro;
			int pdia = fcopiar.getDate();
			int pmes = fcopiar.getMonth()+1;
			int panyo = fcopiar.getYear()+1900;
			if(pdia<10){
				fechapro= "0" + pdia+"/";
			}else{
				fechapro= pdia+"/";
		}
			if(pmes<10){
				fechapro+= "0" + pmes+"/"+panyo;
			}else{
				fechapro+= pmes+"/"+panyo;
			}
		/*

			Query 	q = conn.createQuery(getQuery("borrasemana"));
			Calendar hoy = Calendar.getInstance();
			hoy.setTime(fecha);
			q = q.setDate("FECHA",hoy.getTime());
			hoy.add(Calendar.DATE,duracion);
			q = q.setDate("FECHAMAS",hoy.getTime());
			int j = 120; 
			
			j = q.executeUpdate();
					
			//	setErrorMessage(getQuery("copiarSemanas"));
			
			
			Query 	q = conn.createQuery(getQuery("borrasemana"));
				
			q = q.setString("DURANTE",duracion+"");
			q = q.setString("FECHA",fechapro);
			
			
			
			*/
		//	conn.connection().commit();
			
			cstmt = conn.connection().prepareCall(getQuery("copia_turnos"));
			cstmt.setString(1,user.getDatosMenu().idSelected());
			cstmt.setString(2,fechadestino);
			cstmt.setString(3,fechapro);
			cstmt.setString(4,user.getIdentificador());
			cstmt.setInt(5,duracion);
			cstmt.registerOutParameter(6,java.sql.Types.INTEGER);
			cstmt.registerOutParameter(7,java.sql.Types.VARCHAR);
			cstmt.execute();
			conn.connection().commit();
			//setErrorMessage("FD: "+fechadestino+" FP: "+fechapro+" B: "+cstmt.getInt(6)+" C:"+cstmt.getString(7));
			
			/*
			cstmt = conn.prepareCall(getQuery("copia_turnos"));
			cstmt.setString(1,user.getIdentificador());
			
			PreparedStatement pstmt = conn.connection().prepareStatement(getQuery("copiarSemanas"));

			pstmt.setString(1, fechadestino);
			pstmt.setString(2, fechapro);
			pstmt.setString(3, user.getIdentificador());
			pstmt.setString(4, fechapro);
			pstmt.setString(5, fechapro);
			pstmt.setInt(6, duracion);
			pstmt.setString(7, fechadestino);
			pstmt.setString(8, fechapro);
			pstmt.setString(9, fechapro);
			pstmt.setString(10, fechadestino);
			pstmt.setString(11, fechapro);
			pstmt.setString(12, fechapro);
			pstmt.setInt(13, duracion);
			pstmt.setString(14, fechadestino);
			pstmt.setString(15, fechapro);
			pstmt.setString(16, fechadestino);
			pstmt.setString(18, fechadestino);
			pstmt.setString(17, fechapro);
			pstmt.setString(19, fechapro);
			
			j = pstmt.executeUpdate();
			*/

			
			Integer ano = new Integer(fecha.getYear()+1900);
			Integer mes = new Integer(fecha.getMonth()+1);
			setao(ano);
			setmes(mes);
			
			
			
			
		} catch (Exception ex) {
			setErrorMessage("Copiar Semanas: \n"+ex+";");
		}
	}
	
	
}
