/*
 * 
 *
 */
package dumbo7.gestion;

import java.io.File;
import java.math.BigDecimal;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.util.*;

import org.apache.log4j.*;
import org.hibernate.Criteria;
import org.hibernate.Query;
import org.hibernate.Session;
import org.hibernate.Transaction;
import org.hibernate.criterion.*;

import dumbo7.GestorGenerico;
import dumbo7.atencion.GestorAtencion;
import dumbo7.atencion.GestorAuxiliar;
import dumbo7.solicitudes.GestorSolicitudes;
import dumbo7.user.*;
import dumbo7.utils.*;
import atica.frameweb.utils.*;
import javax.servlet.http.*;

/**
 * @author Universidad de Murcia - ATICA
 *
 */

public class GestorGestion extends GeneralManager {
	
	static Logger logger = Logger.getLogger(GestorGestion.class);
	
	public D7Tareas solicitud = null;
	public List aplicaciones = null, prioridades = null, categorias = null;
	public D7GruposCostes grupoCoste = null;
	public Vector vinculadas = new Vector();
	public FiltroUsuario filtro = null;
	public DumboUser nuevoUsuario = null;
	public List listaSecciones = null;
	public List listaAplicacionesInformaticos = null;
	public List aplicacionesResponsable = null;
	public List aplicacionesUsuario = null;
	public String rutaAnexos = "";
	public Vector anexos = new Vector();
	public Hashtable informSecciones = new Hashtable();
	public Hashtable informAplicaciones = new Hashtable();
	public List listadoSistemas = null;
	public List movimientos = null;
	private D7Tareas subtar = null;
	public D7DatosTrabajador datosTrabajador = null;
	protected List informaticos = null; //Variable que se rellenar si el usuario solicitante de la tarea es informatico
	public List vincTareas = null;
	public List seguimientos = null;
	private String misTareas="";
	private boolean tarNoAsignadas = false;
	
	public GestorGestion() {}

	public FiltroUsuario getFiltro() { return filtro; }
	
	public void setDetalle(String ajx) {
		if (ajx!=null && ajx.equals("1")) solicitud = new D7Tareas();
	}
	
	public void filtroListGenerica(Session conn) {
		if (filtro.getAplicaciones()==null || 
			filtro.getAplicaciones().length==0 || 
			(filtro.getAplicaciones()[0].equals("N") && filtro.getAplicaciones().length==1)) {
				ProjectionList pj = Projections.projectionList();
				pj.add(Projections.property("AplPadreAplCod"));
				Distinct dst = new Distinct(pj);
				Criteria ct = conn.createCriteria(D7Aplicaciones.class)
					.setProjection(dst)
					.add(Restrictions.eq("AplSisCod",user.getDatosMenu().idSelected()))
					.add(Restrictions.isNotNull("AplPadreAplCod"));
				List l = ct.list();
				String [] lista = new String[l.size()+1];
				lista[0]="N";
				for (int k=0; k<l.size(); k++) {
					lista[k+1]=(String)l.get(k);
				}
				filtro.setAplicaciones(lista);
		}
		setPageSize(new Integer(filtro.getTamPag()).intValue());
		if (filtro.getFormato().equals(FiltroUsuario.FORMATO_LISTA) && solicitud==null) listaPendientes(conn);
		solicitud = null;
	}

	public void filtroListAplicacion(Session conn,String apl) {
		if ((apl!=null) && !apl.equals("")) filtro.setAplicaciones(new String[]{apl});
		if (filtro.getAplicaciones()==null || filtro.getAplicaciones().length==0) { // Si no est establecido lo establezco.
			// Meto una aplicacin de usuario si existe
			if (aplicacionesUsuario!=null && aplicacionesUsuario.size()>0)
				filtro.setAplicaciones(new String[]{((D7Aplicaciones)aplicacionesUsuario.get(0)).getAplCod()});
			else {
				setErrorMessage("No est asociado a ninguna aplicacin gestionada por cola.");
				filtro.setAplicaciones(new String[]{"N"});
			}
		}
		setPageSize(new Integer(filtro.getTamPag()).intValue());
		if (filtro.getFormato().equals(FiltroUsuario.FORMATO_LISTA) && solicitud==null) listaColaAplicaciones(conn);
		solicitud = null;
	}
	
	public List getListaSistemas() { return listadoSistemas; }
	public List getMovimientos() { return movimientos; }
	public D7DatosTrabajador getDatosTrabajador() { return datosTrabajador; }
	public List getInformaticos(){return informaticos;}
	public List getVincTareas() { return vincTareas; }
	public List getSeguimientos() { return seguimientos; }
	
	public void listaDatosSolicitante(Session conn,String code) {
		GestorAtencion ga = new GestorAtencion();
		ga.setUser(user);
		ga.listaDatosSolicitante(conn, code);
		datosTrabajador = ga.getDatosTrabajador();
	}
	
	public void listaSistemas(Session conn) {
		Criteria ct = conn.createCriteria(D7Sistemas.class);
		ct.add(Expression.ne("SisCod",user.getDatosMenu().idSelected()));
		listadoSistemas = ct.list();
	}
	
	public void cambiarSistemaTarea(Session conn,D7Tareas tar) {
		Transaction tx = null;
		int tarCod = 0;
		try {
			
			tx = conn.beginTransaction();
			
			Criteria ct = conn.createCriteria(D7Tareas.class);
			ct.add(Expression.and(Expression.eq("TarSisCod",user.getDatosMenu().idSelected()),Expression.eq("TarCod",tar.getTarCod())));
			D7Tareas miTar = (D7Tareas)ct.list().get(0);

			D7Tareas nueva = new D7Tareas();
			nueva.setTarUsuCod(miTar.getTarUsuCod());
			nueva.setTarEmailCopia(miTar.getTarEmailCopia());
			nueva.setTarEstado(D7Tareas.PENDIENTE);
			nueva.setTarFecmaxResol(miTar.getTarFecmaxResol());
			nueva.setTarAsunto(miTar.getTarAsunto());
			nueva.setTarDescrip(miTar.getTarDescrip());
			nueva.setTarDescripSegui(tar.getTarDescripSegui());
			nueva.setTarTipCod(miTar.getTarTipCod());
			nueva.setTarUbicacion(miTar.getTarUbicacion());
			nueva.setTarUrgencia(miTar.getTarUrgencia());
						
			PreparedStatement pstmt = null;
			ResultSet rs = null;
			try {
				String qry = getQuery("NextCodigoTarea");
				qry = qry.replaceFirst("sistema",tar.getTarSisCod());
				pstmt = conn.connection().prepareStatement(qry);
				rs = pstmt.executeQuery();
				if (rs.next()) {
					tarCod = rs.getInt(1);
				}
			} catch (Exception ex) {
				throw ex;
			} finally {
				if (pstmt!=null) pstmt.close();
				if (rs!=null) rs.close();
			}
			
			nueva.setTarCod(new Integer(tarCod));
			nueva.setTarSisCod(tar.getTarSisCod());
			nueva.setTarFeccrea(miTar.getTarFeccrea());
			
			// ************************************************
			// Tratamiento de Anexos !!
			// ************************************************
			/* Tengo que pasar los anexosde un lado a otro !! */
			GestorGenerico.moveAnexosTarea(rutaAnexos,miTar,nueva);
			
			conn.save(nueva);
			
			// Ahora actualizo la vieja tarea, dndola por anulada !!!
			miTar.setTarEstado(D7Tareas.ANULADA);
			conn.update(miTar);
			
			setErrorMessage("La tarea ha sido enviada a la cola genrica del nuevo sistema.");
			
			tx.commit();
			
			GestorGenerico.registrarMovimiento(conn,user,""+tar.getTarCod(),tar.getTarDescripSegui(),D7TareasMovimientos.CAMBIAR_SISTEMA,"Sistemas antiguo: "+miTar.getTarSisCod(),"Sistemas nuevo: "+tar.getTarSisCod());
			
		} catch (Exception ex) {
			tx.rollback();
			//borroAnexosTarea(tarCod);
			setErrorMessage("GestorGestion[cambiarSistemaTarea]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
	}
	public void listPrioridades(Session conn) {
		try {
			prioridades = GestorAuxiliar.getListaPrioridades(user,conn);
		} catch (Exception ex) {
			setErrorMessage("GestorAtencion[listPrioridades]: "+ex);
		}
	}
	
	public List getPrioridades() {
		return prioridades;
	}

	public void listCategoria(Session conn) {
		try {
			// Slo la categora de la solicitud
			if (solicitud!=null && solicitud.getTarCatCod()!=null) {
				Criteria ct = conn.createCriteria(D7Categorias.class);
				ct = ct.add(Expression.eq("CatSisCod",user.getDatosMenu().idSelected()));
				ct = ct.add(Expression.eq("CatCod",solicitud.getTarCatCod()));
				categorias = ct.list();
			}
		} catch (Exception ex) {
			setErrorMessage("GestorAtencion[listCategorias]: "+ex);
		}
	}
	
	public void listCategorias(Session conn) {
		try {
			// Slo las categoras de la seccin o subsecciones de aplicacin
			if (solicitud==null || solicitud.getTarAplCod()==null) {
				categorias = GestorAuxiliar.getListaCategorias(user,conn);
			} else {
				categorias = new ArrayList();
				listCategoriasSecciones(conn,listaSecciones);
			}
		} catch (Exception ex) {
			setErrorMessage("GestorAtencion[listCategorias]: "+ex);
		}
	}
	
	public void listCategoriasSecciones(Session conn,List secs) {
		if (secs==null || secs.size()<=0) return;
		Iterator t = secs.iterator();
		while (t.hasNext()) {
			D7Secciones sec = (D7Secciones)t.next();
			Criteria ct = conn.createCriteria(D7Categorias.class);
			ct = ct.add(Expression.eq("CatSisCod",sec.getSecSisCod()));
			ct = ct.add(Expression.eq("CatSecCod",sec.getSecCod()));
			List l = ct.list();
			if (l!=null && l.size()>0) {
				Iterator tt = l.iterator();
				while (tt.hasNext()) categorias.add((D7Categorias)tt.next());
			}
		}
	}
	
	public List getCategorias() {
		return categorias;
	}
	
	public void listaPendientes(Session conn) {
		try {
			/*
			Query q = aplicaFiltro(conn,"TareasColaPendientes",FiltroUsuario.LISTA_GENERICA);
			q = q.setString("sist",user.getDatosMenu().idSelected());
			// Cojo las aplicaciones !!
			List l = q.list();
			for (int k=0; k<l.size(); k++) {
				D7Tareas t = (D7Tareas)l.get(k); 
				//t.getAplicacionDesc();
				t.setSubtareas(new HashSet());
			}
			setCollection(l);
			*/
			Hashtable params = new Hashtable();
			params.put("1",user.getDatosMenu().idSelected());
			List l = aplicaFiltroSQL(conn,"TareasColaPendientesSQL",false,FiltroUsuario.LISTA_GENERICA,params);
			setCollection(l);
			
		} catch (Exception ex) {
			setErrorMessage("GestorGestion[listaPendientes]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
	}
	
	public void filtroListProblemas(Session conn) {
		setPageSize(new Integer(filtro.getTamPag()).intValue());
		if (filtro.getFormato().equals(FiltroUsuario.FORMATO_LISTA) && solicitud==null) listaProblemas(conn);
		solicitud = null;
	}
	
	public void listaProblemas(Session conn) {
		try {
			/*
			Query q = aplicaFiltro(conn,"ListaProblemas",FiltroUsuario.LISTA_PROBLEMAS);
			q = q.setString("sist",user.getDatosMenu().idSelected());
			// Cojo las aplicaciones !!
			List l = q.list();
			for (int k=0; k<l.size(); k++) {
				D7Tareas t = (D7Tareas)l.get(k); 
				//t.getAplicacionDesc();
				t.setSubtareas(exploraSubtareas(conn,t));
			}
			setCollection(l);
			*/
			Hashtable params = new Hashtable();
			params.put("1",user.getDatosMenu().idSelected());
			//params.put("2",user.getIdentificador());
			boolean subtareas = false;
			if (filtro.getVerSubtareas((DumboUser)user)) {
				if ((filtro.getSubtareas()==null) || filtro.getSubtareas().equals("S")) {
					subtareas = true;
				}
			}
			List l = aplicaFiltroSQL(conn,"ListaProblemasSQL",subtareas,FiltroUsuario.LISTA_PROBLEMAS,params);
			/*
			if (filtro.getVerSubtareas((DumboUser)user)) {
			if ((filtro.getSubtareas()==null) || filtro.getSubtareas().equals("S")) {
				for (int k=0; k<l.size(); k++) {
					D7Tareas tar = (D7Tareas)l.get(k);
					tar.setSubtareas(GestorGenerico.exploraSubtareas(conn,user,tar,getQuery("SubTareasSQL"),filtro.getSubtareas().equals("S")));
				}
			}
			}
			*/
			setCollection(l);
			
		} catch (Exception ex) {
			setErrorMessage("GestorGestion[listaProblemas]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
	}
	
	public void setContextPath(HttpServlet servlet,HttpServletRequest req,HttpServletResponse res) {
		try {
			rutaAnexos = GestorGenerico.getContextPath(user,servlet,false);
		} catch (Exception ex) {
			setErrorMessage("GestorGestion[setContextPath]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
	}
	
	public void detalleSolicitud(Session conn,String code) {
		try {
			if ((code==null) || code.equals("")) return;
			Query q = conn.createQuery(getQuery("DetalleTarea"));
			q = q.setString("sist",user.getDatosMenu().idSelected());
			q = q.setString("code",code);
			solicitud = (D7Tareas)q.list().get(0);
			if (!solicitud.getTarUsuCod().equals(DumboUser.CODIGO_EXTERNO)) solicitud.getDatosUser().setDatEmail(D7Conversor.convierteIdentificador(conn,solicitud.getTarUsuCod()));
			solicitud.tieneSubtareasNoFinalizadas();
			solicitud.setSubtareas(new HashSet());
			
			if (solicitud.getTarEstado().equals(D7Tareas.FINALIZADA) || solicitud.getTarEstado().equals(D7Tareas.RECHAZADA)) {
				// Si es el detalle de una tarea finalizada o rechazada incluye el texto de fin.
				Criteria ct = conn.createCriteria(D7TareasMovimientos.class);
				ct = ct.add(Expression.eq("TmoSisCod",user.getDatosMenu().idSelected()));
				ct = ct.add(Expression.eq("TmoTarCod",solicitud.getTarCod()));
				ct = ct.add(Expression.eq("TmoTipoMov",D7TareasMovimientos.FINALIZAR_TAREA));
				movimientos = ct.list();
			}

			anexos = GestorGenerico.getAnexosTarea(rutaAnexos,solicitud);
			
		} catch (Exception ex) {
			setErrorMessage("GestorGestion[detalleSolicitud]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
	}
	
	public D7Tareas getSolicitud() { return solicitud; }
	
	public void listAplicaciones(Session conn) {
		try {
			// Solo saco la aplicacin del detalle !!
			if (solicitud!=null && solicitud.getTarAplCod()!=null) {
				Criteria ct = conn.createCriteria(D7Aplicaciones.class);
				ct = ct.add(Expression.eq("AplSisCod",user.getDatosMenu().idSelected()));
				ct = ct.add(Expression.eq("AplCod",solicitud.getTarAplCod()));
				List l = ct.list();
				if (l!=null && l.size()>0) {
					D7Aplicaciones apl = (D7Aplicaciones)l.get(0);
					apl.getAplicaciones_param().size();
					aplicaciones = new ArrayList();
					aplicaciones.add(apl);
				}
			}
			/*else {
				aplicaciones = GestorAuxiliar.getListaAplicaciones(user,conn);
				// Cojo los parmetros asociados a las aplicaciones !!
				for (int k=0; k<aplicaciones.size(); k++) {
					Set s = ((D7Aplicaciones)aplicaciones.get(k)).getAplicaciones_param();
					s.size();
				}
			} */
		} catch (Exception ex) {
			setErrorMessage("GestorAtencion[listAplicaciones]: "+ex);
		}
	}

	public void listaAplicaciones(Session conn) {
		try {
			aplicaciones = GestorAuxiliar.getListaAplicaciones(user,conn);
			// Cojo los parmetros asociados a las aplicaciones !!
			for (int k=0; k<aplicaciones.size(); k++) {
				Set s = ((D7Aplicaciones)aplicaciones.get(k)).getAplicaciones_param();
				s.size();
			}
		} catch (Exception ex) {
			setErrorMessage("GestorAtencion[listaAplicaciones]: "+ex);
		}
	}
	
	public List getAplicaciones() {	return aplicaciones; }

	public void obtenListadoAplicaciones(Session conn,String code) {
		if ((code==null) || code.equals("")) return;
		listAplicaciones(conn);
	}
	public void obtenListadoPrioridades(Session conn,String code) {
		if ((code==null) || code.equals("")) return;
		listPrioridades(conn);
	}
	public void obtenListadoCategoria(Session conn,String code) {
		if ((code==null) || code.equals("")) return;
		listCategoria(conn);
	}
	public void obtenListadoSecciones(Session conn,String code) {
		if ((code!=null) && !code.equals("")) return;
		listaSecciones(conn);
	}
	public void obtenListadoSeccionesCategorias(Session conn,String code) {
		if ((code==null) || code.equals("")) return;
		listaSecciones(conn);
		listCategorias(conn);
	}
	public void obtenListadoGruposCostes(Session conn,String code) {
		//if ((code==null) || code.equals("")) return;
		obtenerGrupoCoste(conn);
	}
	
	public void tramitar(Session conn,D7Tareas tar) {
		Transaction tx = null;
		String tipoAsignacion="";
		try {
			
			tx = conn.beginTransaction();
			Query q = conn.createQuery(getQuery("DetalleTarea"));
			q.setString("code",""+tar.getTarCod());
			q.setString("sist",user.getDatosMenu().idSelected());
			D7Tareas original = (D7Tareas)q.list().get(0);
			String textoActual = "Estado: "+original.getTarEstado();
			String infActual = user.traduce("dumbo7/user","Informtico",user.getDatosMenu().idSelected())+": "+original.getTarInfEmail();
			if (original.getTarInfCod()!=null && !original.getTarInfCod().equals("")) throw new Exception("La tarea ya ha sido asignada al "+infActual);
			
			// La asignacin es por aplicacin
			GestorSolicitudes gsol = new GestorSolicitudes();
			gsol.setUser(user);
			tipoAsignacion=D7TareasMovimientos.ASIGNAR_GENERICA_APLICACIONES;
			
			//String inform = gsol.asignarInformaticoAplicacion(conn,tar.getTarAplCod(),tar.getTarEDUbicacion(),original.getTarUsuCod());
			String inform = gsol.asignarInformaticoAplicacion(conn,tar.getTarAplCod(),tar.getTarEDUbicacion(),original.getTarUsuCod());
			//Cuando la tarea no se asigne a una aplicacion por cola
			if (!gsol.tipoAsignacion.equals(D7Aplicaciones.POR_COLA)) {	
				if (inform.equals("cambiaSolicitante")){
					//Debemos buscar el responsable de la seccion a la que pertenece el user y ponerle de solicitante de la tarea
					Query q1 = conn.createQuery(getQuery("responsableSeccionUser"));
					q1 = q1.setString("sist",user.getDatosMenu().idSelected());
					q1 = q1.setString("info",original.getTarUsuCod());
					String resp=((D7Secciones)q1.list().get(0)).getSecIdRespon();
					original.setTarInfCod(original.getTarUsuCod());
					original.setTarUsuCod(resp);
					original.setTarEstado(D7Tareas.ASIGNADA);
					tipoAsignacion=D7TareasMovimientos.ASIGNAR_GENERICA_DIRECTA;
				}else if (inform!=null) {
					if (!inform.equals("")) { 
						original.setTarInfCod(inform);
						original.setTarEstado(D7Tareas.ASIGNADA);
						tipoAsignacion=D7TareasMovimientos.ASIGNAR_GENERICA_DIRECTA;
					}
				} else throw new Exception("La tarea no ha podido ser asignada ya que no hay informticos asociados a la aplicacin escogida.");
			}
			original.setTarAplCod(tar.getTarAplCod());
			String textoNuevo = "Estado: "+original.getTarEstado();
			if (tar.getTarAplCod()!=null) original.setTarPriCod(GestorSolicitudes.getPrioridadAplicacion(conn,(DumboUser)user,tar.getTarAplCod(),tar.getTarTipCod()));
			original.setTarDescripSegui(tar.getTarDescripSegui());
			original.setTarEDUbicacion(tar.getTarEDUbicacion());
			conn.saveOrUpdate(original);
			
			//GestorGenerico.enviarNotificacion(conn,user,original,new String[]{GestorGenerico.NotificacionInformaticoAsignacion,GestorGenerico.NotificacionUsuarioAsignacion},rutaAnexos+GestorGenerico.getMesActual(original.getTarFeccrea())+File.separator);
			if (original.getTarInfCod()!=null) 
				GestorGenerico.enviarNotificacion(conn,user,original,new String[]{GestorGenerico.NotificacionInformaticoAsignacion,GestorGenerico.NotificacionUsuarioAsignacion});
			else GestorGenerico.enviarNotificacion(conn,user,original,new String[]{GestorGenerico.NotificacionInformaticoAsignacionCola});

			tx.commit();
			
			GestorGenerico.registrarMovimiento(conn,user,""+tar.getTarCod(),GestorGenerico.ASIGNACION_TAREA,tipoAsignacion,textoActual,textoNuevo);
			
			setErrorMessage("La Tarea se ha tramitado con xito.");
			
		} catch (Exception ex) {
			if (tx!=null) tx.rollback();
			setErrorMessage("GestorGestion[tramitar]: "+ex);
		}
	}
	
	public void asignarme(Session conn,D7Tareas tar) {
		Transaction tx = null;
		try {
			
			tx = conn.beginTransaction();
			Query q = conn.createQuery(getQuery("DetalleTarea"));
			q.setString("code",""+tar.getTarCod());
			q.setString("sist",user.getDatosMenu().idSelected());
			D7Tareas original = (D7Tareas)q.list().get(0);
			String textoActual = "Estado: "+original.getTarEstado();
			
			String inform = user.getIdentificador();
			
			if (inform!=null) {
				original.setTarAplCod(tar.getTarAplCod());
				if (!inform.equals("")) { 
					original.setTarInfCod(inform);
					original.setTarEstado(D7Tareas.ASIGNADA);
				}
			} else throw new Exception("La tarea no ha podido ser asignada ya que no perteneces a la aplicacin asignada.");
			conn.saveOrUpdate(original);
			String textoNuevo = original.getTarInfEmail().toLowerCase();
			tx.commit();
			
			GestorGenerico.registrarMovimiento(conn,user,""+tar.getTarCod(),GestorGenerico.ASIGNACION_TAREA,D7TareasMovimientos.ASIGNAR_APLICACIONES_DIRECTA,textoActual,textoNuevo);
			GestorGenerico.enviarNotificacion(conn,user,original,new String[]{GestorGenerico.NotificacionInformaticoAsignacion,GestorGenerico.NotificacionUsuarioAsignacion},rutaAnexos+GestorGenerico.getMesActual(original.getTarFeccrea())+File.separator);
			
			setErrorMessage("xito en la asignacin de tareas.");
			
		} catch (Exception ex) {
			if (tx!=null) tx.rollback();
			setErrorMessage("GestorGestion[asignarme]: "+ex);
		}
	}


	public void modificar(Session conn,D7Tareas tar) {
		Transaction tx = null;
		try {
			String usuario=user.getIdentificador();
			if (((DumboUser)user).getUsuarioOriginal()!=null) usuario=((DumboUser)user).getUsuarioOriginal().getDataIdentifier(conn);
			
			tx = conn.beginTransaction();
			Query q = conn.createQuery(getQuery("DetalleTarea"));
			q.setString("code",""+tar.getTarCod());
			q.setString("sist",user.getDatosMenu().idSelected());
			D7Tareas original = (D7Tareas)q.list().get(0);
			String textoActual = "Texto Tarea: "+original.getTarDescrip();
			original.setTarDescrip(tar.getTarDescrip());
			
			if (haCambiado(original.getTarDescripSegui(),tar.getTarDescripSegui()) && tar.getTarDescripSegui()!=null && !tar.getTarDescripSegui().trim().equals("") && (tar.getTarDescripSegui().length()>1 || (tar.getTarDescripSegui().charAt(0)-0)!=160)) {
				original.setTarDescripSegui(tar.getTarDescripSegui());
				GestorGenerico.registrarSoloSeguimiento(conn,user,""+tar.getTarCod(),tar.getTarDescripSegui(),null,usuario);
				GestorGenerico.enviarNotificacion(conn,user,original,new String[]{GestorGenerico.NotificacionUsuarioCambio});
			}
			
			conn.saveOrUpdate(original);
			tx.commit();
			
			GestorGenerico.registrarMovimiento(conn,user,""+tar.getTarCod(),"Cambio en el texto de seguimiento.",D7TareasMovimientos.MODIFICAR_TAREA,textoActual,tar.getTarDescrip());
			GestorGenerico.enviarNotificacion(conn,user,original,new String[]{GestorGenerico.NotificacionInformaticoCambio});
			
			setErrorMessage("La Tarea se ha modificado con xito.");
			
		} catch (Exception ex) {
			if (tx!=null) tx.rollback();
			setErrorMessage("GestorGestion[modificar]: "+ex);
		}
	}
	
	public void anular(Session conn,D7Tareas tar) {
		Transaction tx = null;
		try {
			
			tx = conn.beginTransaction();
			Query q = conn.createQuery(getQuery("DetalleTarea"));
			q.setString("code",""+tar.getTarCod());
			q.setString("sist",user.getDatosMenu().idSelected());
			D7Tareas original = (D7Tareas)q.list().get(0);
			if (original.getTarEstado().equals(D7Tareas.ANULADA)) throw new Exception("La tarea ya est anulada.");
			String textoActual = "Estado: "+original.getTarEstado();
			original.setTarEstado(D7Tareas.ANULADA);
			String textoNuevo = "Estado: "+original.getTarEstado();
			original.setTarDescripSegui(tar.getTarDescripSegui());
			
			anularSubTareas(conn,tar,tar.getTarDescripSegui());

			conn.saveOrUpdate(original);
			tx.commit();
			
			GestorGenerico.registrarMovimiento(conn,user,""+tar.getTarCod(),tar.getTarDescripSegui(),D7TareasMovimientos.ANULAR_TAREA,textoActual,textoNuevo);
			//GestorGenerico.registrarSoloSeguimiento(conn,user,""+tar.getTarCod(),tar.getTarDescripSegui());
			GestorGenerico.enviarNotificacion(conn,user,original,new String[]{GestorGenerico.NotificacionUsuarioAnulacion});
			
			setErrorMessage("La Tarea se ha anulado con xito.");
			
		} catch (Exception ex) {
			if (tx!=null) tx.rollback();
			setErrorMessage("GestorGestion[anular]: "+ex);
		}
	}
	
	public List getVinculadas() { return vinculadas; }
	/*
	public void vinculadasSolicitud(Session conn,String code) {
		try {
			vinculadas = new ArrayList();
			if ((code==null) || code.equals("")) return;
			Criteria ct = conn.createCriteria(D7TareasVinculadas.class);
			ct = ct.add(Expression.eq("TviSisCod",user.getDatosMenu().idSelected()));
			ct = ct.add(Expression.eq("TviTarCod",new Integer(code)));
			List l = ct.list();
			for (int k=0; k<l.size(); k++) {
				D7TareasVinculadas t = (D7TareasVinculadas)l.get(k);
				D7Tareas org = t.getTareaVinculada();
				D7Tareas tv = new D7Tareas();
				tv.setTarAplCod(org.getTarAplCod());
				tv.setTarAsunto(org.getTarAsunto());
				tv.setTarCod(org.getTarCod());
				tv.setTarFeccrea(org.getTarFeccrea());
				//tv.setTarInfEmail(org.getTarInfEmail());
				tv.setDatosInform(org.getDatosInform());
				tv.setTarInfCod(org.getTarInfCod());
				/*
				D7Aplicaciones aplOrg = org.getAplicacion();
				D7Aplicaciones apl = new D7Aplicaciones();
				apl.setAplCod(aplOrg.getAplCod());
				apl.setAplDescrip(aplOrg.getAplDescrip());
				tv.setAplicacion(apl);
				*/
			/*	tv.setAplicacion(org.getAplicacion());
				tv.setTarAplCod(org.getTarAplCod());
				tv.setTarEstado(org.getTarEstado());
				//tv.getAplicacionDesc();
				vinculadas.add(tv);
			}
		} catch (Exception ex) {
			setErrorMessage("GestorGestion[vinculadasSolicitud]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
	}*/

	public void anularProblema(Session conn,D7Tareas tar) {
		try {

			Transaction tx = conn.beginTransaction();
			Query q = conn.createQuery(getQuery("GetTarea"));
			q.setString("tarCod",""+tar.getTarCod());
			q.setString("sist",user.getDatosMenu().idSelected());
			D7Tareas original = (D7Tareas)q.list().get(0);
			if (original.getTarEstado().equals(D7Tareas.ANULADA)) throw new Exception("El problema ya est anulado.");
			String textoActual = "Estado: "+original.getTarEstado();
			original.setTarEstado(D7Tareas.ANULADA);
			String textoNuevo = "Estado: "+original.getTarEstado();
			
			// Debo anular las subtareas !!
			anularSubTareas(conn,tar,tar.getTarDescripSegui());
			
			conn.saveOrUpdate(original);
			tx.commit();
			
			GestorGenerico.registrarMovimiento(conn,user,""+tar.getTarCod(),tar.getTarDescripSegui(),D7TareasMovimientos.ANULAR_TAREA,textoActual,textoNuevo);
			
			setErrorMessage("El problema se ha anulado con xito.");
			
		} catch (Exception ex) {
			setErrorMessage("GestorAtencion[anularTarea]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
	}
	/*
	private void anularSubTareas(Session conn,D7Tareas tar,String motivo) throws Exception {
		Set s = tar.getSubtareas();
		if (s==null) return;
		Iterator it = s.iterator();
		while (it.hasNext()) {
			D7Tareas t = (D7Tareas)it.next();
			if (!t.getTarEstado().equals("R")) {
				String textoActual = "Estado: "+t.getTarDescrip();
				t.setTarEstado(D7Tareas.ANULADA);
				GestorGenerico.registrarMovimiento(conn,user,""+t.getTarCod(),motivo,D7TareasMovimientos.ANULAR_TAREA,textoActual);
				conn.saveOrUpdate(t);
			}
			anularSubTareas(conn,t,motivo);
		}
	}
	*/
	public void finalizarProblema(Session conn,D7Tareas tar) {
		try {

			Transaction tx = conn.beginTransaction();
			Query q = conn.createQuery(getQuery("GetTarea"));
			q.setString("tarCod",""+tar.getTarCod());
			q.setString("sist",user.getDatosMenu().idSelected());
			D7Tareas original = (D7Tareas)q.list().get(0);
			if (original.getTarEstado().equals(D7Tareas.FINALIZADA)) throw new Exception("El problema ya est finalizado.");
			String textoActual = "Estado: "+original.getTarEstado();			
			if (tar.getTarEstado().equals("N")) {
				// Debo anular las subtareas !!
				anularSubTareas(conn,original,tar.getTarDescripSegui());
				original.setTarEstado(D7Tareas.FINALIZADA);
			//} else if (tar.getTarEstado().equals("F")) {
				//original.setTarEstado(D7Tareas.FINALIZADA_CONSUBTAREAS);
			} else if (tar.getTarEstado().equals("R")) {
				finalizarSubTareas(conn,original,tar.getTarDescripSegui());
				original.setTarEstado(D7Tareas.FINALIZADA);
			}
			String textoNuevo = "Estado: "+original.getTarEstado();
			
			original.setTarDescripSegui(tar.getTarDescripSegui());
			original.setTarFecfin(new Date());
			original.setTarCosteEco(tar.getTarCosteEco());
			original.setTarCosteMat(tar.getTarCosteMat());
			original.setTarHorasRes(tar.getTarHorasRes());
			
			conn.saveOrUpdate(original);
			tx.commit();
		
			GestorGenerico.registrarMovimiento(conn,user,""+tar.getTarCod(),tar.getTarDescripSegui(),D7TareasMovimientos.FINALIZAR_TAREA,textoActual,textoNuevo);
			//GestorGenerico.registrarSoloSeguimiento(conn,user,""+tar.getTarCod(),tar.getTarDescripSegui());
			//GestorGenerico.registrarSoloSeguimiento(conn,user,""+tar.getTarCod(),tar.getTarDescripSegui());
			if (tar.getTarEmailCopia()!=null && !tar.getTarEmailCopia().trim().equals("")) GestorGenerico.enviarNotificacion(conn,user,original,new String[]{GestorGenerico.NotificacionUsuarioResolucion},GestorGenerico.toMailArray(tar.getTarEmailCopia()),rutaAnexos+GestorGenerico.getMesActual(original.getTarFeccrea())+File.separator);
			else GestorGenerico.enviarNotificacion(conn,user,original,new String[]{GestorGenerico.NotificacionUsuarioResolucion},rutaAnexos+GestorGenerico.getMesActual(original.getTarFeccrea())+File.separator);
			
			setErrorMessage("El problema se ha finalizado con xito.");
			
		} catch (Exception ex) {
			setErrorMessage("GestorGestion[finalizarProblema]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
	}
	
	private BigDecimal costeGrupo(Session conn,D7Tareas tar) throws Exception {
		try {
			Criteria ct = conn.createCriteria(D7Informaticos.class);
			ct = ct.add(Expression.eq("InfSisCod",user.getDatosMenu().idSelected()));
			ct = ct.add(Expression.eq("InfCod",tar.getTarInfCod()));
			D7Informaticos inf = (D7Informaticos) ct.list().get(0);
			return inf.getGrupoCoste().getGcoCoste();
		} catch (Exception ex) { return new BigDecimal(0); }
	}

	private BigDecimal costeSubtareas(D7Tareas tar) throws Exception {
		try {
			Set s = tar.getSubtareas();
			if (s==null) return new BigDecimal(0);
			Iterator it = s.iterator();
			BigDecimal bd = new BigDecimal(0);
			while (it.hasNext()) {
				D7Tareas t = (D7Tareas)it.next();
				if (t.getTarCosteEco()==null) continue;
				bd = bd.add(t.getTarCosteEco());
			}
			return bd;
		} catch (Exception ex) { return new BigDecimal(0); }
	}

	private BigDecimal horasSubtareas(D7Tareas tar) throws Exception {
		try {
			Set s = tar.getSubtareas();
			if (s==null) return new BigDecimal(0);
			Iterator it = s.iterator();
			BigDecimal bd = new BigDecimal(0);
			while (it.hasNext()) {
				D7Tareas t = (D7Tareas)it.next();
				if (t.getTarHorasRes()==null) continue;
				bd = bd.add(t.getTarHorasRes());
			}
			return bd;
		} catch (Exception ex) { return new BigDecimal(0); }
	}

	private BigDecimal costeMaterial(D7Tareas tar) throws Exception {
		try {
			Set s = tar.getSubtareas();
			if (s==null) return new BigDecimal(0);
			Iterator it = s.iterator();
			BigDecimal bd = new BigDecimal(0);
			while (it.hasNext()) {
				D7Tareas t = (D7Tareas)it.next();
				if (t.getTarCosteMat()==null) continue;
				bd = bd.add(t.getTarCosteMat());
			}
			return bd;
		} catch (Exception ex) { return new BigDecimal(0); }
	}
	
	private void finalizarSubTareas(Session conn,D7Tareas tar,String motivo) throws Exception {
		Set s = tar.getSubtareas();
		if (s==null) return;
		Iterator it = s.iterator();
		while (it.hasNext()) {
			D7Tareas t = (D7Tareas)it.next();
			if (!t.getTarEstado().equals(D7Tareas.FINALIZADA) && !t.getTarEstado().equals(D7Tareas.ANULADA)) {
				finalizarSubTareas(conn,t,motivo);
				String textoActual = "Estado: "+t.getTarEstado()+" Categora: "+t.getTarCatDesc();
				t.setTarCatCod(tar.getTarCatCod());
				t.setTarEstado(D7Tareas.FINALIZADA);
				String textoNuevo = "Estado: "+t.getTarEstado()+" Categora: "+t.getTarCatDesc();
				t.setTarFecfin(new Date());
				if (subtar!=null) {
					t.setTarDescripSegui(subtar.getTarDescripSegui());
					t.setTarCosteEco(subtar.getTarHorasRes().multiply(costeGrupo(conn,t)).add(costeSubtareas(t)));
					t.setTarCosteMat(subtar.getTarCosteMat());
					t.setTarHorasRes(subtar.getTarHorasRes());
				} else {
					t.setTarDescripSegui(motivo);
				}
				GestorGenerico.registrarMovimiento(conn,user,""+t.getTarCod(),t.getTarDescripSegui(),D7TareasMovimientos.FINALIZAR_TAREA,textoActual,textoNuevo);
				//GestorGenerico.registrarSoloSeguimiento(conn,user,""+t.getTarCod(),motivo);
				conn.saveOrUpdate(t);
				GestorGenerico.enviarNotificacion(conn,user,t,new String[]{GestorGenerico.NotificacionUsuarioResolucion});
			}
		}
	}
	
	private void anularSubTareas(Session conn,D7Tareas tar,String motivo) throws Exception {
		Set s = tar.getSubtareas();
		if (s==null) return;
		Iterator it = s.iterator();
		while (it.hasNext()) {
			D7Tareas t = (D7Tareas)it.next();
			if (!t.getTarEstado().equals(D7Tareas.FINALIZADA) && !t.getTarEstado().equals(D7Tareas.ANULADA)) {
				String textoActual = "Estado: "+t.getTarEstado();
				t.setTarEstado(D7Tareas.ANULADA);
				String textoNuevo = "Estado: "+t.getTarEstado();
				GestorGenerico.registrarMovimiento(conn,user,""+t.getTarCod(),motivo,D7TareasMovimientos.ANULAR_TAREA,textoActual,textoNuevo);
				conn.saveOrUpdate(t);
				GestorGenerico.enviarNotificacion(conn,user,t,new String[]{GestorGenerico.NotificacionUsuarioAnulacion});
				anularSubTareas(conn,t,motivo);
			}
		}
	}
	/*
	private Set exploraSubtareas(Session conn,D7Tareas t) throws Exception {
		HashSet s = new HashSet();
		Query sq = conn.createQuery(getQuery("SubTareas"));
		sq = sq.setString("sist",user.getDatosMenu().idSelected());
		sq = sq.setString("padre",""+t.getTarCod());
		List st = sq.list();
		for (int k=0; k<st.size(); k++) {
			D7Tareas tar = (D7Tareas)st.get(k);
			D7Tareas nt = tar.cloneTarea();
			//nt.getAplicacionDesc();
			s.add(nt);
		}
		return s;
	}
	*/
	public List aplicaFiltroSQL(Session conn,String nombre,boolean sbQry,String filt,Hashtable params) throws Exception {
		setFiltro(null,null,null,filt);
		return GestorGenerico.aplicaFiltroSQL(conn,user,getQuery(nombre),sbQry,filtro,filt,params,params.size());
	}
	/*
	public Query aplicaFiltro(Session conn,String nombre,String filt) throws Exception {
		setFiltro(filt);
		return GestorGenerico.aplicaFiltro(conn,user,getQuery(nombre),filtro,filt);
	}
	*/
	public void setFiltro(HttpServlet servlet,HttpServletRequest req,HttpServletResponse res,String tipo) {
		try {
			filtro = ((DumboUser)user).getFiltroUsuario(tipo);
			if (filtro==null) {
				filtro = new FiltroUsuario(tipo);
				((DumboUser)user).setFiltroUsuario(tipo,filtro);
			}
		} catch (Exception ex) {
			setErrorMessage("GestorGestion[setFiltro]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
	}

	public void suplantarUsuario(Session conn,String usu) {
		try {
			nuevoUsuario = new DumboUser(conn,usu,"",user.getDatosMenu().idSelected());
		} catch (Exception ex) {
			setErrorMessage("GestorGestion[suplantarUsuario]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
	}

	public void replaceUser(HttpServlet servlet,HttpServletRequest req,HttpServletResponse res) throws Exception{
		if (nuevoUsuario!=null) {
			HttpSession s = req.getSession(true);
			nuevoUsuario.setUsuarioOriginal((DumboUser)user);
			s.setAttribute("GestorInicio.getUser",nuevoUsuario);
		}
	}

	public void recuperarUser(HttpServlet servlet,HttpServletRequest req,HttpServletResponse res) {
		HttpSession s = req.getSession(true);
		s.setAttribute("GestorInicio.getUser",((DumboUser)user).getUsuarioOriginal());
	}

	public Hashtable getInformAplicaciones() { return informAplicaciones; }
	public Hashtable getInformSecciones() { return informSecciones; }
	
	public void listaUsuariosSeccion(Session conn) {
		try {
			boolean puedeGestionarCualquierSeccion = false;//user.permitidoPerfiles(user.getDatosMenu().idSelected(),"dumbo7/gestion","suplantarACualquiera");
			List l = GestorAuxiliar.getListaSecciones(user,conn);
			for (int k=0; k<l.size(); k++) {
				D7Secciones sec = (D7Secciones)l.get(k);
				if (puedeGestionarCualquierSeccion || sec.getSecIdRespon().equals(user.getIdentificador())) {
					Vector v = new Vector();
					addInformaticosSeccion(conn,sec,v,puedeGestionarCualquierSeccion,sec.getSecIdRespon());
					informSecciones.put("["+sec.getSecCod()+"] "+sec.getSecDescrip(),v);
				}
			}
		} catch (Exception ex) {
			setErrorMessage("GestorGestion[listaUsuariosSeccion]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
	}

	private void addInformaticosSeccion(Session conn,D7Secciones sec,Vector v,boolean completo,String idResp) throws Exception {
		Query q = conn.createQuery(getQuery("InformaticosSeccionResp"));
		q = q.setString("sist",user.getDatosMenu().idSelected());
		q = q.setString("seccion",sec.getSecCod());
		q = q.setString("resp",idResp);
		List l = q.list();
		if (l.size()>0) {
			for (int k=0; k<l.size(); k++) 
				if (!v.contains(l.get(k))) {
					D7DatosPersonales di = ((D7Informaticos)l.get(k)).getDatosInform();
					if (di.getDatEmail()==null || di.getDatEmail().equals("")) di.setDatEmail(D7Conversor.convierteIdentificador(conn,di.getDatIdentificador()));
					if (di.getDatIdentificador().equals(idResp)) di.addResponsable(sec.getSecCod());
					v.add(di);
				}
		}
		if (!completo) {
			Iterator it = sec.getSubsecciones().iterator();
			while (it.hasNext()) {
				D7Secciones s = (D7Secciones)it.next();
				if (!s.getSecCod().equals(sec.getSecCod()) && !s.getSecIdRespon().equals(user.getIdentificador())) {
					addInformaticosSeccion(conn,s,v,completo,s.getSecIdRespon());
				}
			}
		}
	}
	
	public void listaUsuariosAplicacion(Session conn) {
		try {
			List l = null;
			boolean puedeGestionarCualquierSeccion = false;//user.permitidoPerfiles(user.getDatosMenu().idSelected(),"dumbo7/gestion","suplantarACualquiera");
			if (puedeGestionarCualquierSeccion) {
				l = GestorAuxiliar.getListaAplicaciones(user,conn);
			} else {
				/*
				Query q = conn.createQuery("AplicacionesSeccionesResponsable");
				q = q.setString("sist",user.getDatosMenu().idSelected());
				q = q.setString("usu",user.getIdentificador());
				l = q.list();
				*/
				Query q = conn.createQuery(getQuery("AplicacionesConResponsable"));
				q = q.setString("sist",user.getDatosMenu().idSelected());
				q = q.setString("resp",user.getIdentificador());
				l = q.list();
			}
			for (int k=0; k<l.size(); k++) {
				D7Aplicaciones apl = (D7Aplicaciones)l.get(k);
				Iterator it = apl.getInformaticos().iterator();
				Vector v = new Vector();
				while (it.hasNext()) {
					D7AplicacionesInformaticos ai = (D7AplicacionesInformaticos)it.next();
					D7DatosPersonales di = ai.getDatosInform();
					if (di.getDatEmail()==null || di.getDatEmail().equals("")) di.setDatEmail(D7Conversor.convierteIdentificador(conn,di.getDatIdentificador()));
					if (ai.getAinResponsable().equals("S") || ai.getAinResponsable().equals(D7AplicacionesInformaticos.RESPONSABLE)) di.addResponsable(apl.getAplCod());
					v.add(di);
				}
				informAplicaciones.put("["+apl.getAplCod()+"] "+apl.getAplDescrip(),v);
			}
		} catch (Exception ex) {
			setErrorMessage("GestorGestion[listaUsuariosAplicacion]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
	}

	public List getListaSecciones() { return listaSecciones; }
	
	public void listaSecciones(Session conn) {
		try {
			listaSecciones = GestorAuxiliar.getListaSecciones(user,conn);
		} catch (Exception ex) {
			setErrorMessage("GestorGestion[listaSeccionesResponsable]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
	}

	public List getListaAplicacionesInformaticos() { return listaAplicacionesInformaticos; }
	public List getAplicacionesResponsable() { return aplicacionesResponsable; }

	public void listaAplicacionesResponsable(Session conn) {
		try {
			Query q = conn.createQuery(getQuery("AplicacionesResponsable"));
			q = q.setString("sist",user.getDatosMenu().idSelected());
			q = q.setString("resp",user.getIdentificador());
			aplicacionesResponsable = q.list();
		} catch (Exception ex) {
			setErrorMessage("GestorGestion[listaAplicacionesInformaticos]: "+ex);
		}
	}

	public void listaInformaticosAplicacion(Session conn,String aplcod) {
		try {
			Query q = conn.createQuery(getQuery("InformaticosAplicacion"));
			q = q.setString("sist",user.getDatosMenu().idSelected());
			q = q.setString("aplcod",aplcod);
			
			Criteria ct = conn.createCriteria(D7Aplicaciones.class);
			ct = ct.add(Expression.eq("AplSisCod",user.getDatosMenu().idSelected()));
			ct = ct.add(Expression.eq("AplCod",aplcod));
			List l = ct.list(); 
			D7Aplicaciones apl = (D7Aplicaciones)l.get(0);
			Iterator it = apl.getInformaticos().iterator();
			Vector v = new Vector();
			while (it.hasNext()) {
				D7AplicacionesInformaticos ai = (D7AplicacionesInformaticos)it.next();
				D7DatosPersonales di = ai.getDatosInform();
				if (di.getDatEmail()==null || di.getDatEmail().equals("")) di.setDatEmail(D7Conversor.convierteIdentificador(conn,di.getDatIdentificador()));
				if (ai.getAinResponsable().equals("S") || ai.getAinResponsable().equals(D7AplicacionesInformaticos.RESPONSABLE)) di.addResponsable(apl.getAplCod());
				v.add(di);
			}
			informAplicaciones.put("["+apl.getAplCod()+"] "+apl.getAplDescrip(),v);
		} catch (Exception ex) {
			setErrorMessage("GestorGestion[listaInformaticosAplicacion]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
	}

	public void listaInformaticosSeccion(Session conn,String seccion) {
		try {
			Criteria ct = conn.createCriteria(D7Secciones.class);
			ct = ct.add(Expression.eq("SecSisCod",user.getDatosMenu().idSelected()));
			ct = ct.add(Expression.eq("SecCod",seccion));
			D7Secciones sec = (D7Secciones)ct.list().get(0);
			Vector v = new Vector();
			addInformaticosSeccion(conn,sec,v,false,sec.getSecIdRespon());
			informSecciones.put("["+sec.getSecCod()+"] "+sec.getSecDescrip(),v);
		} catch (Exception ex) {
			setErrorMessage("GestorGestion[listaInformaticosSeccion]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
	}

	public void listaAplicacionesSeccion(Session conn,String seccion) {
		try {
			Query q = conn.createQuery(getQuery("AplicacionesSeccion"));
			q = q.setString("sist",user.getDatosMenu().idSelected());
			q = q.setString("seccion",seccion);
			aplicaciones = q.list();
			for (int k=0; k<aplicaciones.size(); k++) {
				Set s = ((D7Aplicaciones)aplicaciones.get(k)).getAplicaciones_param();
				s.size();
			}
		} catch (Exception ex) {
			setErrorMessage("GestorGestion[listaAplicacionesSeccion]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
	}
	
	private boolean haCambiado(Object a,Object b) {
		if ((a==null) && (b==null)) return false;
		if (a==null) return true;
		if (b==null) return true;
		return !a.equals(b);
	}
	
	public void cambiaTarea(Session conn,D7Tareas tar) {
		try {
			String usuario=user.getIdentificador();
			if (((DumboUser)user).getUsuarioOriginal()!=null) usuario=((DumboUser)user).getUsuarioOriginal().getDataIdentifier(conn);
			
			String textoActual1="";String textoActual2="";String textoActual3="";String textoActual4="";
			String textoNuevo1="";String textoNuevo2="";String textoNuevo3="";String textoNuevo4="";
			boolean cambiado=false;
			
			Transaction tx = conn.beginTransaction();
			Query q = conn.createQuery(getQuery("GetTarea"));
			q.setString("tarCod",""+tar.getTarCod());
			q.setString("sist",user.getDatosMenu().idSelected());
			D7Tareas original = (D7Tareas)q.list().get(0);
			if (haCambiado(original.getTarCatCod(),tar.getTarCatCod())) {
				textoActual1 = "Categora: "+original.getTarCatDesc();
				original.setTarCatCod(tar.getTarCatCod());
				textoNuevo1 = "Categora: "+original.getTarCatDesc();
			}
			if (haCambiado(original.getTarPriCod(),tar.getTarPriCod())) {
				textoActual2 = "Prioridad: "+original.getTarPriDesc();
				original.setTarPriCod(tar.getTarPriCod());
				textoNuevo2 =  "Prioridad: "+original.getTarPriDesc();
			}
			if (haCambiado(original.getTarAplCod(),tar.getTarAplCod())) {
				textoActual3 = "Aplicacin: "+original.getAplicacionDesc();
				original.setTarAplCod(tar.getTarAplCod());
				textoNuevo3 = "Aplicacin: "+original.getAplicacionDesc();
			}
			if (haCambiado(original.getTarPlanif(),tar.getTarPlanif())) {
				textoActual4 = "Fecha Prevista: "+GestorGenerico.getFechaString(original.getTarPlanif());
				original.setTarPlanif(tar.getTarPlanif());
				textoNuevo4 = "Fecha Prevista: "+GestorGenerico.getFechaString(original.getTarPlanif());
			}
			if (haCambiado(original.getTarDescripSegui(),tar.getTarDescripSegui()) && tar.getTarDescripSegui()!=null && !tar.getTarDescripSegui().trim().equals("") && (tar.getTarDescripSegui().length()>1 || (tar.getTarDescripSegui().charAt(0)-0)!=160)) {
				cambiado=true;
				original.setTarDescripSegui(tar.getTarDescripSegui());
			}
			conn.saveOrUpdate(original);
			
			tx.commit();
			
			if (textoActual1!="") {
				GestorGenerico.registrarMovimiento(conn,user,""+tar.getTarCod(),GestorGenerico.CAMBIO_CATEGORIA,D7TareasMovimientos.CAMBIAR_CATEGORIA,textoActual1,textoNuevo1);
			}
			if (textoActual2!="") {
				GestorGenerico.registrarMovimiento(conn,user,""+tar.getTarCod(),GestorGenerico.CAMBIO_PRIORIDAD,D7TareasMovimientos.CAMBIAR_PRIORIDAD,textoActual2,textoNuevo2);
			}
			if (textoActual3!="") {
				GestorGenerico.registrarMovimiento(conn,user,""+tar.getTarCod(),GestorGenerico.CAMBIO_APLICACION,D7TareasMovimientos.CAMBIAR_APLICACION,textoActual3,textoNuevo3);
			}
			if (textoActual4!="") {
				GestorGenerico.registrarMovimiento(conn,user,""+tar.getTarCod(),GestorGenerico.CAMBIO_PLANIFICACION,D7TareasMovimientos.CAMBIAR_FECHA_PLANIF,textoActual4,textoNuevo4);
				GestorGenerico.enviarNotificacion(conn,user,original,new String[]{GestorGenerico.NotificacionUsuarioPlanificacion});
			}
			if (cambiado==true) {
				original.setTarDescripSegui(tar.getTarDescripSegui());
				GestorGenerico.registrarSoloSeguimiento(conn,user,""+tar.getTarCod(),tar.getTarDescripSegui(),null,usuario);
				GestorGenerico.enviarNotificacion(conn,user,original,new String[]{GestorGenerico.NotificacionUsuarioCambio});
			}
			
			setErrorMessage("La Tarea ha sido modificada con xito.");
			
		} catch (Exception ex) {
			setErrorMessage("GestorAtencion[cambiaTarea]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
	}
	
	public void datosFinalizarSubTarea(HttpServlet servlet,HttpServletRequest req,HttpServletResponse res) {
		String mot = ((String[])req.getAttribute("motivo"))[0];
		if (mot==null) mot="";
		if (!mot.equals("")) {
			subtar = new D7Tareas();
			subtar.setTarDescripSegui(mot);
			String txt = "";
			txt = ((String[])req.getAttribute("coste"))[0];
			if (txt!=null && !txt.equals("")) subtar.setTarCosteEco(new java.math.BigDecimal(txt));
			txt = ((String[])req.getAttribute("material"))[0];
			if (txt!=null && !txt.equals("")) subtar.setTarCosteMat(new java.math.BigDecimal(txt));
			txt = ((String[])req.getAttribute("horas"))[0];
			if (txt!=null && !txt.equals("")) subtar.setTarHorasRes(new java.math.BigDecimal(txt));
			txt = ((String[])req.getAttribute("anexo"))[0];
			if (txt!=null && !txt.equals("")) subtar.setTarEstado(txt);
		}
	}
	
	public void finalizarTarea(Session conn,D7Tareas tar) {
		Transaction tx = null;
		try {

			tx = conn.beginTransaction();
			Query q = conn.createQuery(getQuery("GetTarea"));
			q.setString("tarCod",""+tar.getTarCod());
			q.setString("sist",user.getDatosMenu().idSelected());
			D7Tareas original = (D7Tareas)q.list().get(0);
			
			if (original.getTarEstado().equals(D7Tareas.FINALIZADA)) throw new Exception("La tarea ya est finalizada.");
			
			String textoActual = "Estado: "+original.getTarEstado();
			String textoNuevo = "Estado: "+tar.getTarEstado();
			original.setTarDescripSegui(tar.getTarDescripSegui());
			original.setTarFecfin(new Date());
			original.setTarCosteEco(tar.getTarCosteEco());
			original.setTarCosteMat(tar.getTarCosteMat());
			original.setTarHorasRes(tar.getTarHorasRes());
			conn.saveOrUpdate(original);
			tx.commit();
			
			// Segn la accin indicada ejecuto algo con las subtareas !!
			if (tar.getTarEstado().equals(D7Tareas.FINALIZADA)) {
				// Finalizo la tarea y las subtareas
				original.setTarEstado(D7Tareas.FINALIZADA);
				finalizarSubTareas(conn,original,tar.getTarDescripSegui());
			//} else if (tar.getTarEstado().equals(D7Tareas.FINALIZADA_CONSUBTAREAS)) {
				// No finaliza la tarea hasta que finalicen las subtareas
				//original.setTarEstado(D7Tareas.FINALIZADA_CONSUBTAREAS);
			} else if (tar.getTarEstado().equals(D7Tareas.ANULADA)) {
				// Debo anular todas las subtareas pendientes
				original.setTarEstado(D7Tareas.FINALIZADA);
				anularSubTareas(conn,original,"Anulada Por Finalizacin de Tarea Padre.");
			}

			// Finalizo la tarea padre si est pendiente de subtareas
			//finalizarPadrePendiente(conn,original);
			
			GestorGenerico.registrarMovimiento(conn,user,""+tar.getTarCod(),tar.getTarDescripSegui(),D7TareasMovimientos.FINALIZAR_TAREA,textoActual,textoNuevo);
			//GestorGenerico.registrarSoloSeguimiento(conn,user,""+tar.getTarCod(),tar.getTarDescripSegui());
			if (tar.getTarEmailCopia()!=null && !tar.getTarEmailCopia().trim().equals("")) GestorGenerico.enviarNotificacion(conn,user,original,new String[]{GestorGenerico.NotificacionUsuarioResolucion},GestorGenerico.toMailArray(tar.getTarEmailCopia()),rutaAnexos+GestorGenerico.getMesActual(original.getTarFeccrea())+File.separator);
			else GestorGenerico.enviarNotificacion(conn,user,original,new String[]{GestorGenerico.NotificacionUsuarioResolucion},rutaAnexos+GestorGenerico.getMesActual(original.getTarFeccrea())+File.separator);
			
			setErrorMessage("La Tarea ha sido finalizada con xito.");
			
		} catch (Exception ex) {
			if (tx!=null) tx.rollback();
			setErrorMessage("GestorGestion[finalizarTarea]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
	}
/*
	private void finalizarPadrePendiente(Session conn,D7Tareas tar) throws Exception {
		D7Tareas padre = tar.getTarPadre();
		if (padre==null) return;
		if (padre.getTarEstado().equals(D7Tareas.FINALIZADA_CONSUBTAREAS)) {
			String textoActual = "Estado: "+padre.getTarEstado();
			padre.setTarEstado(D7Tareas.FINALIZADA);
			padre.setTarDescripSegui(tar.getTarDescripSegui());
			conn.saveOrUpdate(padre);
			
			GestorGenerico.registrarMovimiento(conn,user,""+padre.getTarCod(),GestorGenerico.FINALIZA_SUBTAREA,D7TareasMovimientos.FINALIZAR_TAREA,textoActual);
			GestorGenerico.registrarSoloSeguimiento(conn,user,""+tar.getTarCod(),tar.getTarDescripSegui());
			GestorGenerico.enviarNotificacion(conn,user,padre,new String[]{GestorGenerico.NotificacionUsuarioResolucion});
			
		}
		finalizarPadrePendiente(conn,padre);
	}
*/
	public D7GruposCostes getGrupoCoste() {	return grupoCoste; }
	
	public void obtenerGrupoCoste(Session conn) {
		try {
			
			Criteria ct = conn.createCriteria(D7Informaticos.class);
			ct = ct.add(Expression.eq("InfSisCod",user.getDatosMenu().idSelected()));
			ct = ct.add(Expression.eq("InfCod",user.getIdentificador()));
			
			D7Informaticos inf = (D7Informaticos)ct.list().get(0);
			
			ct = conn.createCriteria(D7GruposCostes.class);
			ct = ct.add(Expression.eq("GcoSisCod",user.getDatosMenu().idSelected()));
			ct = ct.add(Expression.eq("GcoCod",inf.getInfGcoCod()));
			
			D7GruposCostes gc = (D7GruposCostes)ct.list().get(0);
			grupoCoste = new D7GruposCostes();
			grupoCoste.setGcoSisCod(gc.getGcoSisCod());
			grupoCoste.setGcoCod(gc.getGcoCod());
			grupoCoste.setGcoHoras(gc.getGcoHoras());
			grupoCoste.setGcoDescrip(gc.getGcoDescrip());
			grupoCoste.setGcoCoste(gc.getGcoCoste());
			grupoCoste.setGcoEstado(gc.getGcoEstado());
			
		} catch (Exception ex) {
			setErrorMessage("GestorAtencion[grupoCoste]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
	}

	public List getAplicacionesUsuario() { return aplicacionesUsuario; }
	
	public void listAplicacionesUser(Session conn) {
		try {
			
			Criteria ct = conn.createCriteria(D7AplicacionesInformaticos.class);
			ct = ct.add(Expression.eq("AinSisCod",user.getDatosMenu().idSelected()));
			ct = ct.add(Expression.eq("AinInfCod",user.getIdentificador()));
			List l = ct.list();
			aplicacionesUsuario = new ArrayList();
			for (int k=0; k<l.size(); k++) {
				D7Aplicaciones apl = ((D7AplicacionesInformaticos)l.get(k)).getAplicacion();
				if (apl.getAplTipoAsig()!=null 
						&& apl.getAplTipoAsig().equals(D7Aplicaciones.POR_COLA)
						&& (apl.getSubaplicaciones()==null || apl.getSubaplicaciones().size()==0)) {
					D7Aplicaciones mapl = new D7Aplicaciones();
					mapl.setAplCaracter(apl.getAplCaracter());
					mapl.setAplCod(apl.getAplCod());
					mapl.setAplDescrip(apl.getAplDescrip());
					mapl.setAplDetalle(apl.getAplDetalle());
					mapl.setAplEstado(apl.getAplEstado());
					mapl.setAplSecCod(apl.getAplSecCod());
					mapl.setAplSisCod(apl.getAplSisCod());
					mapl.setAplTipoAsig(apl.getAplTipoAsig());
					aplicacionesUsuario.add(mapl);
				}
			}
			
		} catch (Exception ex) {
			setErrorMessage("GestorGestion[listAplicacionesUser]: "+ex);
		}
	}

	public void listaColaAplicaciones(Session conn) {
		try {
			
			Hashtable params = new Hashtable();
			params.put("1",user.getDatosMenu().idSelected());
			List l = aplicaFiltroSQL(conn,"TareasColaAplicacionSQL",false,FiltroUsuario.LISTA_APLICACION,params);
			setCollection(l);
			
		} catch (Exception ex) {
			setErrorMessage("GestorGestion[listaColaAplicacion]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
	}
	
	public void devolverTarea(Session conn,D7Tareas tar) {
		dumbo7.atencion.GestorAtencion ga = new dumbo7.atencion.GestorAtencion();
		ga.setUser(user);
		setErrorMessage(ga.getErrorMessage());
	}

	public void recargaLista(HttpServlet servlet,HttpServletRequest req,HttpServletResponse res) {
		// Me cepillo el Gestor Atencin existente.
		req.getSession(true).removeAttribute("dumbo7.gestion.GestorGestion");
	}
	
//	Esta funcion se utiliza para dos cosas: por un lado para ver si el usuario que solicita la tarea es informatico
	//(en cuyo caso lo informar en el detalle) y por otro para ver si el user lo es (para texto de seguimiento dividido)
	public void esInformatico(Session conn) {
		try {
			if (solicitud==null || solicitud.getTarUsuCod()==null) return;
			//En la cadena usuarios metemos los dnis del solicitante y del user, para comprobar
			String usuarios = "('" + solicitud.getTarUsuCod()+ "','"+user.getIdentificador()+"')";
				
			Query q = conn.createQuery(getQuery("SonInformaticos").replaceAll(":usuarios",usuarios));
			q = q.setString("sist",solicitud.getTarSisCod());
			if (q.list().size() ==0) {
				informaticos  = null;
			} else {
				informaticos  = q.list();
			}
		}catch (Exception ex) {
			setErrorMessage("GestorGestion[esInformatico]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
	}
	
	public void filtroListaVinculadas(Session conn,String aplCod) {
		setPageSize(new Integer(filtro.getTamPag()).intValue());
		if (aplCod!=null && !aplCod.equals("") && filtro.getAplicaciones()==null) filtro.setAplicaciones(new String[]{aplCod});
		/*else if (aplCod!=null && !aplCod.equals("")) {
			String[] vinc=new String[filtro.getAplicaciones().length+1];
			String[] arrayCopia=new String[filtro.getAplicaciones().length+1];
			boolean repetido=false;
			vinc=filtro.getAplicaciones();
			for (int i=0; i<vinc.length; i++) {
				arrayCopia[i] = vinc[i];
			}
			for (int i=0; i<arrayCopia.length; i++) {
				if (arrayCopia[i].equals(aplCod)) repetido=true;
			}
			if (repetido == false) arrayCopia[filtro.getAplicaciones().length]= aplCod;
			filtro.setAplicaciones(arrayCopia);
		}*/
		if (filtro.getFormato().equals(FiltroUsuario.FORMATO_LISTA) && solicitud==null) listSolicitudesVinculadas(conn);
		solicitud = null;
	}
	
	public void listSolicitudesVinculadas(Session conn) {
		try {
			Hashtable params = new Hashtable();
			params.put("1",user.getDatosMenu().idSelected());
			boolean subtareas = false;
			if (filtro.getVerSubtareas((DumboUser)user)) {
				if ((filtro.getSubtareas()==null) || filtro.getSubtareas().equals("S")) {
					subtareas = true;
				}
			}
			List l = null;
			// Si se establece aplicacin en el filtro bien, si no nada.
			if (filtro.getAplicaciones()!=null && filtro.getAplicaciones().length>0) {
				filtro.setTipo(FiltroUsuario.LISTA_VINCULADAS);
				if (user.permitidoPerfiles(user.getDatosMenu().idSelected(),"dumbo7/gestion","vincularMaestro"))
					l = aplicaFiltroSQL(conn,"TareasUsuarioVinculadasMaestroSQL",subtareas,FiltroUsuario.LISTA_VINCULADAS,params);
				else if (user.permitidoPerfiles(user.getDatosMenu().idSelected(),"dumbo7/gestion","vincularGestor")) {
					params.put("2",user.getIdentificador());
					params.put("3",user.getIdentificador());
					params.put("4",user.getIdentificador());
					l = aplicaFiltroSQL(conn,"TareasUsuarioVinculadasGestorSQL",subtareas,FiltroUsuario.LISTA_VINCULADAS,params);
				} else {
					params.put("2",user.getIdentificador());
					params.put("3",user.getIdentificador());
					l = aplicaFiltroSQL(conn,"TareasUsuarioVinculadasInformaticoSQL",subtareas,FiltroUsuario.LISTA_VINCULADAS,params);
				}
			}
			setCollection(l);

		} catch (Exception ex) {
			setErrorMessage("GestorSolicitudes[listSolicitudesVinculadas]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
	}
	public void setVinculadas(String vic) {
		if ((vic==null) || vic.equals("")) return;
		String txt = vic;
		int n = txt.indexOf(":");
		while (n>0) {
			D7TareasVinculadas tv = new D7TareasVinculadas();
			tv.setTviSisCod(user.getDatosMenu().idSelected());
			tv.setTviVincTarCod(new Integer(txt.substring(0,n)));
			vinculadas.addElement(tv);
			txt = txt.substring(n+1);
			n = txt.indexOf(":");
		}
		D7TareasVinculadas tv = new D7TareasVinculadas();
		tv.setTviSisCod(user.getDatosMenu().idSelected());
		tv.setTviVincTarCod(new Integer(txt));
		vinculadas.addElement(tv);
	}
	
	public void savesVinculadas(Session conn, String tarCod) {
		// Inicio la transaccin.
		Transaction tx = conn.beginTransaction();
		try {
			if(tarCod!=null){
				listVinculadas(conn,tarCod);
				if (vincTareas.size()>0){
					for(int i=0;i<vincTareas.size();i++){
						conn.delete((D7TareasVinculadas)vincTareas.get(i));
						conn.flush();
					}
				}
				// Establece las tareas vinculadas al problema.
				Enumeration en = vinculadas.elements(); 
				while (en.hasMoreElements()) {
					D7TareasVinculadas tp = (D7TareasVinculadas)en.nextElement();
					tp.setTviTarCod(new Integer(tarCod));
					conn.save(tp);
				}
				// Todo Correcto !!
				tx.commit();
				listVinculadas(conn,tarCod);
			}
		} catch (Exception ex) {
			setErrorMessage("GestorGestion[saveVinculadas]: "+((ex.getCause()!=null)?ex.getCause().getMessage():ex.getMessage()));
			tx.rollback();
		}
	}
	
	public void listVinculadas(Session conn,String code){
		PreparedStatement pstmt = null;
		ResultSet rs = null;
		String myQuery = null;
		vincTareas = new ArrayList();
		try{
			myQuery = getQuery("TareasVinculadas");
			pstmt = conn.connection().prepareStatement(myQuery);
			pstmt.setString(1,user.getDatosMenu().idSelected());
			pstmt.setString(2,code);
			rs = pstmt.executeQuery();
			while (rs.next()) {
				D7TareasVinculadas tv = new D7TareasVinculadas();
				tv.setTviSisCod(rs.getString(1));
				tv.setTviTarCod(new Integer(rs.getInt(2)));
				tv.setTviVincTarCod(new Integer(rs.getString(3)));
				
				vincTareas.add(tv);
			}
		}
		catch (Exception ex)
		{
			System.out.println("2"+ex);
			setErrorMessage("Error al listar tareas vinculadas.");
		} finally {
			try {
				if (rs!=null) rs.close();
				if (pstmt!=null) pstmt.close();
			} catch (Exception exx) {}
		}
	}
	
//	Esta funcion se utiliza para obtener la ltima entrada de bitcora para esta tarea
	public void ultimaBitacora(Session conn) {
		seguimientos = new ArrayList();
		try {
			if (solicitud==null) return;
			Criteria ct = conn.createCriteria(D7TareasSeguimientos.class);
			ct = ct.add(Expression.eq("TseSisCod",user.getDatosMenu().idSelected()));
			ct = ct.add(Expression.eq("TseTarCod",solicitud.getTarCod()));
			ct.addOrder(Order.desc("TseFechaAlta"));
			List l = ct.list();
			seguimientos.add(l.get(0));
		}catch (Exception ex) {
			setErrorMessage("GestorGestion[ultimaBitacora]: "+((ex.getCause()!=null)?ex.getCause():ex));
		} 
	}
	
	public void setTareas(String tareas){
		this.misTareas=tareas;
	}
	
	public void asignameTareas(Session conn){
		try{
			if ((misTareas==null) || misTareas.equals("")) return;
			String txt = misTareas;
			int n = txt.indexOf(":");
			//Esta no se tocar se usar para saber que mensaje mostrar
			int nAux = n;
			while (n>0) {
				String code=txt.substring(0,n);
				Query q = conn.createQuery(getQuery("DetalleTarea"));
				q = q.setString("sist",user.getDatosMenu().idSelected());
				q = q.setString("code",code);
				solicitud = (D7Tareas)q.list().get(0);
				
				java.util.Set s = solicitud.getSubtareas();
				if ((s!=null) && !s.isEmpty()) {
					solicitud.setSubtareas(null);
				}
				
				//las que son solicitadas por mi no puedo asignarmelas
				if (!solicitud.getTarUsuCod().equals(user.getIdentificador())){
					asignarme(conn,solicitud);
					
					txt = txt.substring(n+1);
					n = txt.indexOf(":");
				}
				else{ 
					tarNoAsignadas=true;
					txt = txt.substring(n+1);
					n = txt.indexOf(":");
				}
			}
			String code=txt;
			Query q = conn.createQuery(getQuery("DetalleTarea"));
			q = q.setString("sist",user.getDatosMenu().idSelected());
			q = q.setString("code",code);
			solicitud = (D7Tareas)q.list().get(0);
			
			java.util.Set s = solicitud.getSubtareas();
			if ((s!=null) && !s.isEmpty()) {
				solicitud.setSubtareas(null);
			}
			
			if (!solicitud.getTarUsuCod().equals(user.getIdentificador())){
				asignarme(conn,solicitud);
			}
			else{ 
				tarNoAsignadas=true;
				txt = txt.substring(n+1);
				n = txt.indexOf(":");
			}
			if (tarNoAsignadas==true && nAux>0) setErrorMessage("Las tareas solicitadas por ti no te han sido asignadas.");
			else if (tarNoAsignadas==true) setErrorMessage("El usuario solicitante de la tarea no puede asignarse como informtico de la misma.");
		}catch (Exception ex) {
			setErrorMessage("GestorGestion[asignameTareas]: "+((ex.getCause()!=null)?ex.getCause():ex));
		} 
	}
}
