/*
 * 
 *
 */
package dumbo7.gestion.dumbos;

import java.util.*;

import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.log4j.*;
import org.hibernate.*;
import org.hibernate.criterion.Expression;
import org.hibernate.criterion.Order;

import dumbo7.*;
import dumbo7.utils.*;
import dumbo7.user.DumboUser;
import dumbo7.user.FiltroUsuario;
import dumbo7.atencion.*;

/**
 * @author Universidad de Murcia - ATICA
 *
 */

public class GestorDumbos extends GestorAtencion {
	
	static Logger logger = Logger.getLogger(GestorDumbos.class);
	static String SEPARATOR_CHAR = "|";
	public String gestCode = "";
	private List tareas,datosPersonales = null;
	private String tipo;
	private String tipoFiltro="";
	private String permisos="";
	private String fechaActual;
	private String [] Fechas; // [0] Desde , [1] Hasta
	protected List informaticoPerfiles = null;
	private List aplicacionesResponsable;
	private List aplicacionesInformaticos;
	private int nivel=1;
	private String misInformaticosDni="";
	private static String miCodeTar="";
	private static String miTipoCodigo="";
	
	public GestorDumbos() {}

	public void setGestionCodeSec(String s) { if (!(s==null) && !s.equals("")) gestCode = "S"+SEPARATOR_CHAR+s; }
	public void setGestionCodeApl(String s) { if (!(s==null) && !s.equals("")) gestCode = "A"+SEPARATOR_CHAR+s; }
	public void setGestionCodeInf(String s) { if (!(s==null) && !s.equals("")) gestCode = "I"+SEPARATOR_CHAR+s; }
	
	public List getTareas() { return tareas; }
	public List getDatosPersonales() { return datosPersonales;}
	public List getPerfilesinformatico() { return informaticoPerfiles; }
	
	public void filtroListGlobalAtender(Session conn) {
		setPageSize(new Integer(filtro.getTamPag()).intValue());
		if (filtro.getFormato().equals(FiltroUsuario.FORMATO_LISTA) && solicitud==null) listAtender(conn,gestCode);
		solicitud = null;
	}
	
	//	Metodo set() para obtener si es Pendiente o Planificada
	public void setTipo(String [] tipo)
	{if (tipo!=null)this.tipo = tipo[0];}
	
	public void setFechas(String [] Fechas)
	{this.Fechas = Fechas;}
	
	public void listAtender(Session conn,String code) {
		try {
			String codeTar;
			String tipoCodigo;
			if (!code.equals("")) {
				String miCodigo = code;
				tipoCodigo = miCodigo.substring(0,miCodigo.indexOf(SEPARATOR_CHAR));
				miTipoCodigo=tipoCodigo;
				miCodigo = miCodigo.substring(miCodigo.indexOf(SEPARATOR_CHAR)+1);
				codeTar = miCodigo.substring(0,miCodigo.indexOf(SEPARATOR_CHAR));
				miCodeTar=codeTar;
			}
			else{
				codeTar=miCodeTar;
				tipoCodigo=miTipoCodigo;
			}
			
			Hashtable params = new Hashtable();
			params.put("1",user.getDatosMenu().idSelected());
			params.put("2",codeTar);
			boolean subtareas = false;
			if (filtro.getVerSubtareas((DumboUser)user)) {
				if ((filtro.getSubtareas()==null) || filtro.getSubtareas().equals("S")) {
					subtareas = true;
				}
			}
			List l = aplicaFiltroSQL(conn,"TareasPendientesSQL"+tipoCodigo,subtareas,FiltroUsuario.LISTA_GLOBAL_ATENDER,params);
			/*
			if (filtro.getVerSubtareas((DumboUser)user)) {
			if ((filtro.getSubtareas()==null) || filtro.getSubtareas().equals("S")) {
				for (int k=0; k<l.size(); k++) {
					D7Tareas tar = (D7Tareas)l.get(k);
					tar.setSubtareas(GestorGenerico.exploraSubtareas(conn,user,tar,getQuery("SubTareasSQL"),filtro.getSubtareas().equals("S")));
				}
			}
			}
			*/
			setCollection(l);
			
		} catch (Exception ex) {
			setErrorMessage("GestorDumbos[listAtender]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
	}

	public void filtroListGlobalAtendidas(Session conn) {
		setPageSize(new Integer(filtro.getTamPag()).intValue());
		if (filtro.getFormato().equals(FiltroUsuario.FORMATO_LISTA) && solicitud==null) listAtendidas(conn,gestCode);
		solicitud = null;
	}
	
	public void restaMesAFechaActual(){
		java.util.Date date = new java.util.Date();
		
		Calendar hoy = new GregorianCalendar();
		hoy.setTime(date);
		
		hoy.add(Calendar.MONTH, -1);
		if (hoy.MONTH == 0){
			hoy.set(hoy.YEAR -1, 01, hoy.DATE, hoy.HOUR, hoy.MINUTE);
		}
		java.text.DateFormat sdf = new java.text.SimpleDateFormat("dd/MM/yyyy");
		this.fechaActual = sdf.format(hoy.getTime());
	}
	
	public void listAtendidas(Session conn,String code) {
		try {
			String codeTar;
			String tipoCodigo;
			if (!code.equals("")) {
				String miCodigo = code;
				tipoCodigo = miCodigo.substring(0,miCodigo.indexOf(SEPARATOR_CHAR));
				miTipoCodigo=tipoCodigo;
				miCodigo = miCodigo.substring(miCodigo.indexOf(SEPARATOR_CHAR)+1);
				codeTar = miCodigo.substring(0,miCodigo.indexOf(SEPARATOR_CHAR));
				miCodeTar=codeTar;
			}
			else{
				codeTar=miCodeTar;
				tipoCodigo=miTipoCodigo;
			}
			Hashtable params = new Hashtable();
			params.put("1",user.getDatosMenu().idSelected());
			params.put("2",codeTar);
			boolean subtareas = false;
			if (filtro.getVerSubtareas((DumboUser)user)) {
				if ((filtro.getSubtareas()==null) || filtro.getSubtareas().equals("S")) {
					subtareas = true;
				}
			}
			List l = aplicaFiltroSQL(conn,"TareasResueltasSQL"+tipoCodigo,subtareas,FiltroUsuario.LISTA_GLOBAL_ATENDIDAS,params);
			/*
			if (filtro.getVerSubtareas((DumboUser)user)) {
			if ((filtro.getSubtareas()==null) || filtro.getSubtareas().equals("S")) {
				for (int k=0; k<l.size(); k++) {
					D7Tareas tar = (D7Tareas)l.get(k);
					tar.setSubtareas(GestorGenerico.exploraSubtareas(conn,user,tar,getQuery("SubTareasSQL"),filtro.getSubtareas().equals("S")));
				}
			}
			}
			*/
			setCollection(l);
			
		} catch (Exception ex) {
			setErrorMessage("GestorDumbos[listAtendidas]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
	}
	
	private Set exploraSubtareas(Session conn,D7Tareas t) throws Exception {
		HashSet s = new HashSet();
		Query sq = conn.createQuery(getQuery("SubTareas"));
		sq = sq.setString("sist",user.getDatosMenu().idSelected());
		sq = sq.setString("padre",""+t.getTarCod());
		List st = sq.list();
		for (int k=0; k<st.size(); k++) {
			D7Tareas tar = (D7Tareas)st.get(k);
			D7Tareas nt = tar.cloneTarea();
			//nt.getAplicacionDesc();
			s.add(nt);
		}
		return s;
	}
	
	public void tareasSolicitante(Session conn, String soli){
		try{
			tareas = new ArrayList();
			String DniUsu = "";
			if ((soli==null) || soli.equals("")) return;
			
			//Si es un DNI, devolvera una fila con los datos personales del usuario
			if (soli.indexOf("@")>0)
				DniUsu= D7Conversor.convierteMailExterno(conn,soli.toLowerCase(),"EXTERNO");
			else			
				DniUsu=soli;
			
			String fechaHistoricoDesde= "";
			String fechaHistoricoHasta= "";
			
			if(Fechas[0].length() != 0){fechaHistoricoDesde = Fechas[0];}
			if(Fechas[1].length() != 0){fechaHistoricoHasta = Fechas[1];}	
			
			if(this.tipo.equals("Pe")){
				tipoFiltro = getQuery("PendientesCond");
			}
			else{
				if(this.tipo.equals("A")){
					tipoFiltro = getQuery("AnuladasCond");
				}
				else{
					tipoFiltro = getQuery("ResueltasCond");
				}
			}
			Query q;
			String inform="('"+user.getIdentificador()+"')";
			
			//Si el usuario solicitante introducido es el user mismo no hay restricciones, puede ver sus dumbos, por tanto ponemos ocmo un nivel 3
			if (!DniUsu.equals(user.getIdentificador())){
				if (nivel==2){
					compruebaInformaticos(conn);
					inform="("+misInformaticosDni+")";
				}
			}
			else this.nivel=3;
				
			//No ha introducido fechas para la bsqueda
			if (fechaHistoricoHasta.equals("") && fechaHistoricoDesde.equals("")){
				restaMesAFechaActual();
				if (nivel==3) 
					q = conn.createQuery(getQuery("TareasSolicitante").replaceAll(":usu","('"+DniUsu+"')") + tipoFiltro + getQuery("HistoricoDesdeCond") + getQuery("OrdenaTareas"));
				else
					q = conn.createQuery(getQuery("TareasSolicitante").replaceAll(":usu","('"+DniUsu+"')") + tipoFiltro + getQuery("HistoricoDesdeCond") + getQuery("UserInformatico").replaceAll(":inf",inform) + getQuery("OrdenaTareas"));
				q = q.setString("sist",user.getDatosMenu().idSelected());
				q = q.setString("fecha", fechaActual);
			}
			else{
				//Ha introducido solo una fecha de inicio (fecha desde)
				if (fechaHistoricoHasta.equals("")){
					if (nivel==3) 
						q = conn.createQuery(getQuery("TareasSolicitante").replaceAll(":usu","('"+DniUsu+"')") + tipoFiltro + getQuery("HistoricoDesdeCond") + getQuery("OrdenaTareas"));
					else
						q = conn.createQuery(getQuery("TareasSolicitante").replaceAll(":usu","('"+DniUsu+"')") + tipoFiltro + getQuery("HistoricoDesdeCond") + getQuery("UserInformatico").replaceAll(":inf",inform) + getQuery("OrdenaTareas"));
					q = q.setString("sist",user.getDatosMenu().idSelected());
					q = q.setString("fecha", fechaHistoricoDesde);
				}
				else{
					//Ha introducido solo una fecha de fin (fecha hasta)
					if (fechaHistoricoDesde.equals("")){
						if (nivel==3) 
							q = conn.createQuery(getQuery("TareasSolicitante").replaceAll(":usu","('"+DniUsu+"')") + tipoFiltro + getQuery("HistoricoDesdeCond") + getQuery("OrdenaTareas"));
						else
							q = conn.createQuery(getQuery("TareasSolicitante").replaceAll(":usu","('"+DniUsu+"')") + tipoFiltro + getQuery("HistoricoDesdeCond") + getQuery("UserInformatico").replaceAll(":inf",inform) + getQuery("OrdenaTareas"));
						q = q.setString("sist",user.getDatosMenu().idSelected());
						q = q.setString("fecha", fechaHistoricoHasta);
					}
					else{
						//Ha introducido ambas fechas
						if (nivel==3) 
							q = conn.createQuery(getQuery("TareasSolicitante").replaceAll(":usu","('"+DniUsu+"')") + tipoFiltro + getQuery("HistoricoDesdeCond") + getQuery("OrdenaTareas"));
						else
							q = conn.createQuery(getQuery("TareasSolicitante").replaceAll(":usu","('"+DniUsu+"')") + tipoFiltro + getQuery("HistoricoDesdeCond") + getQuery("UserInformatico").replaceAll(":inf",inform) + getQuery("OrdenaTareas"));
						q = q.setString("sist",user.getDatosMenu().idSelected());
						q = q.setString("fechaH", fechaHistoricoHasta);
						q = q.setString("fechaD", fechaHistoricoDesde);
					}
				}
			}
			tareas = (List)q.list();
			
			for(int i=0;i<tareas.size();i++){
				java.util.Set s = ((D7Tareas)tareas.get(i)).getSubtareas();
				if ((s!=null) && !s.isEmpty()) {
					((D7Tareas)tareas.get(i)).setSubtareas(null);
				}
			}
		}catch (Exception ex) {
			setErrorMessage("GestorDumbos[tareasSolicitante]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
	}
	
	public void listaDatosPersonales(Session conn){
		try{
			String dameDNI = new String();
			
			for(int i=0;i<tareas.size();i++){
				dameDNI = dameDNI + "'" + ((D7Tareas)tareas.get(i)).getTarInfCod() + "'" + ",";
				dameDNI = dameDNI + "'" + ((D7Tareas)tareas.get(i)).getTarUsuCod() + "'" + ",";
			}
				
			if (!dameDNI.equals("")) {
				dameDNI = dameDNI.substring(0,dameDNI.length()-1);//Eliminamos la ltima coma
				Query q = conn.createQuery(getQuery("DatosPersonales").replaceAll(":misDNI","("+dameDNI+")"));
				datosPersonales  = (List)q.list();
			}
			else		
				datosPersonales=null;
			
		}catch (Exception ex) {
			setErrorMessage("GestorDumbos[listaDatosPersonales]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
	}

	public void recargaLista(HttpServlet servlet,HttpServletRequest req,HttpServletResponse res) {
		// Me cepillo el Gestor Atencin existente.
		req.getSession(true).removeAttribute("dumbo7.gestion.dumbos.GestorDumbos");
	}
	
//	Listado de los perfiles asociados a un informatico
	public void listaInformaticoPerfiles(Session conn)
	{
		try
		{
			Query q = conn.createQuery(getQuery("InformaticoPerfiles"));
			q = q.setString("sist",user.getDatosMenu().idSelected());
			q = q.setString("inf",user.getIdentificador());
			informaticoPerfiles  = (List)q.list();
		}
		catch (Exception ex)
		{
			logger.error(ex.getMessage());
		}
	}
	
	//Si es Informatico, su nivel ser 1, si es gestor 2 y si es oreja o maestro ser 3
	public void compruebaPerfiles(Session conn)
	{
		try
		{
			String perfil=null;
			listaInformaticoPerfiles(conn);
			for (int i=0; i<informaticoPerfiles.size();i++){
				perfil=((D7InformaticosPerfiles)informaticoPerfiles.get(i)).getIpePerCod();
				if (perfil.equals("11")) this.nivel=2;
				if ((perfil.equals("01")) || (perfil.equals("31")) || (perfil.equals("88"))){
					this.nivel=3;
					return;
				}
			}
			
		}
		catch (Exception ex)
		{
			logger.error(ex.getMessage());
		}
	}
	
	//Si el nivel es 3, puede ver todos los dumbos, si es 1 slo en los que l forme parte (como usuario o como informtico)
	//si es 2 ver los suyos y los de sus informticos 
	public void compruebaPermisos(Session conn){
		try{
			String dniUser=user.getIdentificador();
			if (nivel==3) return;
			//Slo puede ver sus dumbos, es informtico
			if (nivel==1){
				if (solicitud.getTarInfCod()!=null){
					if ((solicitud.getTarUsuCod().equals(dniUser))  || (solicitud.getTarInfCod().equals(dniUser))){
						return;
					}
					else solicitud=null;	
				}
				else{
					if (solicitud.getTarUsuCod().equals(dniUser)){
						return;
					}
					else solicitud=null;	
				}
			}
			if (nivel==2){
				compruebaInformaticos(conn);	
			}
		}
		catch (Exception ex)
		{
			logger.error(ex.getMessage());
		}
	}
	//Hay que ver los informaticos cuyas tareas puede ver el gestor (user)
	public void compruebaInformaticos(Session conn){
		try{
			//Listamos primero las aplicaciones en las que el informtico es responsable
			Query q = conn.createQuery(getQuery("AplicacionesResponsable"));
			q = q.setString("sist",user.getDatosMenu().idSelected());
			q = q.setString("inf",user.getIdentificador());
			aplicacionesResponsable  = (List)q.list();
			
			//Listamos las aplicaciones vinculadas a secciones en las que el informtico es responsable
			String cadena = new String();
			
			//Sacamos todos los informaticos que trabajan en las aplicaciones de las que l es responsable
			if(aplicacionesResponsable.size()>0)
			{
				//Recogemos los cdigos de las secciones
				for(int i=0;i<aplicacionesResponsable.size();i++)
				{
					cadena = cadena + "'" + ((D7Aplicaciones)aplicacionesResponsable.get(i)).getAplCod() + "'" + ",";
				}
				cadena = cadena.substring(0,cadena.length()-1);//Eliminamos la ltima coma
				
				q = conn.createQuery(getQuery("AplicacionesInformaticos").replaceAll(":aplicaciones","("+cadena+")"));
				q = q.setString("sist",user.getDatosMenu().idSelected());
				aplicacionesInformaticos = (List)q.list();
			}
			
			//Si en solicitud hay algo es una busqueda por codigo, si no es por solicitante y hay q meter en una lista los dni de los informaticos
			//de la aplicaciones de las que soy responsable
			if (solicitud!=null){
				//Ahora comprobamos que el usuario solicitante o el informatico son de sus informaticos, si no, no puede ver la tarea
				if(aplicacionesInformaticos.size()>0)
				{
					String dni;
					for(int i=0;i<aplicacionesInformaticos.size();i++)
					{
						dni=((D7AplicacionesInformaticos)aplicacionesInformaticos.get(i)).getAinInfCod();
						if (solicitud.getTarInfCod()!=null){
							if ((solicitud.getTarUsuCod().equals(dni))  || (solicitud.getTarInfCod().equals(dni))) return;
						}
						else{
							if (solicitud.getTarUsuCod().equals(dni)) return;
						}
					}
					solicitud=null;
				}
			}
			else{
				if(aplicacionesInformaticos.size()>0){
					for(int i=0;i<aplicacionesInformaticos.size();i++){
						misInformaticosDni = misInformaticosDni + "'" + ((D7AplicacionesInformaticos)aplicacionesInformaticos.get(i)).getAinInfCod() + "'" + ",";
					}
					misInformaticosDni = misInformaticosDni.substring(0,misInformaticosDni.length()-1);//Eliminamos la ltima coma
				}
			}
			
		}
		catch (Exception ex)
		{
			logger.error(ex.getMessage());
		}
	}
	//Esta funcion se utiliza para obtener la ltima entrada de bitcora para esta tarea
	public void ultimaBitacora(Session conn) {
		seguimientos = new ArrayList();
		try {
			if (solicitud==null) return;
			Criteria ct = conn.createCriteria(D7TareasSeguimientos.class);
			ct = ct.add(Expression.eq("TseSisCod",user.getDatosMenu().idSelected()));
			ct = ct.add(Expression.eq("TseTarCod",solicitud.getTarCod()));
			ct.addOrder(Order.desc("TseFechaAlta"));
			List l = ct.list();
			if (l.size()>0) seguimientos.add(l.get(0));
		}catch (Exception ex) {
			setErrorMessage("GestorDumbos[ultimaBitacora]: "+((ex.getCause()!=null)?ex.getCause():ex));
		} 
	}
}
