<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet version="1.0" 
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:xforms="http://www.w3.org/2002/xforms">
	
<xsl:param name="servlet"/>	
<xsl:param name="tipo"/>
<xsl:param name="menu"/>
<xsl:param name="code"/>

<xsl:include href="dumbo7/utils/xsl/utils.xsl"/>

<xsl:template match="XMLROOT">

	<xsl:call-template name="headComun">
		<xsl:with-param name="solicitudes" select="DATA/DUMBOS/SOLICITUD"/>
	</xsl:call-template>
	
<xsl:variable name="claseTarea">
	<xsl:choose>
		<xsl:when test="DATA/DUMBOS/SOLICITUD/@TIPO_TAREA='P'">Peticin</xsl:when>
		<xsl:when test="DATA/DUMBOS/SOLICITUD/@TIPO_TAREA='I'">Incidencia</xsl:when>
		<xsl:when test="DATA/DUMBOS/SOLICITUD/@TIPO_TAREA='B'">Problema</xsl:when>
		<xsl:when test="DATA/DUMBOS/SOLICITUD/@TIPO_TAREA='A'">Programada</xsl:when>
		<xsl:when test="DATA/DUMBOS/SOLICITUD/@TIPO_TAREA='R'">Dumbo Rpido</xsl:when>
		<xsl:otherwise>Tipo <xsl:value-of select="DATA/DUMBOS/SOLICITUD/@TIPO_TAREA"/></xsl:otherwise>
	</xsl:choose>
</xsl:variable>
<table class="cab1det">
<tr>
	<xsl:if test="count(DATA/DUMBOS/SOLICITUD)=0">
		<td align="left" width="1%"><img src="../graficos/iconos/A.gif"/></td>
	</xsl:if>
	<xsl:if test="count(DATA/DUMBOS/SOLICITUD)>0">
		<td align="left" width="1%"><img src="../graficos/iconos/{DATA/DUMBOS/SOLICITUD/@ESTADO}.gif"/></td>
	</xsl:if>
	<td align="left" width="70%" valing="top">Detalle Tarea:&#160;<i><xsl:value-of select="$claseTarea"/></i></td>
	<td align="right" width="100%"><a href="javascript:printDetalle('{$code}');"><img title="Imprimir Tarea" src="../graficos/iconos/imprimir_ico.gif" border="0"/></a>&#160;&#160;<a href="javascript:verHistorial('{$code}');"><img title="Ver Historial" src="../graficos/iconos/historial_ico.gif" border="0"/></a>&#160;&#160;<a href="javascript:verSeguimiento('{$code}');"><img title="Ver Bitcora" src="../graficos/iconos/seguimiento_ico.gif" border="0"/></a>&#160;&#160;<a href="javascript:verSubTareas('{$code}');"><img title="Ver Subtareas" src="../graficos/iconos/subtarea_ico.gif" border="0"/></a>&#160;&#160;</td>
</tr>
</table>
<table class="contdet">
	<xsl:if test="count(DATA/DUMBOS/SOLICITUD)=0">
		<tr>
			<td class="gestion" colspan="13" align="center">La tarea solicitada no existe o no tiene permiso para verla. Compruebe el cdigo de la misma.</td>
		</tr>
	</xsl:if>
	<xsl:for-each select="DATA/DUMBOS/SOLICITUD">
		<tr class="cabe"><td><strong>Datos Tarea</strong></td></tr>
		<tr class="cont">
			<td>
				<i>&#183;&#160;C&#243;digo:</i>&#160;<xsl:value-of select="@CODIGO"/>&#160;&#160;<xsl:if test="string-length(@PADRE)>0">(<xsl:value-of select="@PADRE"/>)&#160;&#160;</xsl:if>
				<i>&#160;Fecha:</i>&#160;<xsl:call-template name="date2String"><xsl:with-param name="fecha"><xsl:value-of select="@FECHA_CREACION"/></xsl:with-param></xsl:call-template><br/>
				<i>&#160;Solicitante:</i>&#160;<xsl:value-of select="@USUNOMBRE"/>&#160;(<xsl:value-of select="@USUEMAIL"/>)<br/>
				<i>&#160;Tlfn.Contacto:</i>&#160;<xsl:value-of select="@TELEFONO"/>&#160;&#160;
				<i>&#160;Ubicacin:</i>&#160;<xsl:if test="string-length(@UBICACION)>0"><xsl:value-of select="@UBICACION"/></xsl:if><br/>
				<i>&#160;<xsl:call-template name="traduce"><xsl:with-param name="id" select="'Informatico'"/></xsl:call-template>:</i>&#160;<xsl:if test="string-length(@INFEMAIL)>0"><xsl:value-of select="@INFNOMBRE"/>&#160;(<xsl:value-of select="@INFEMAIL"/>)</xsl:if>
			</td>
		</tr>
		<tr class="cabe"><td><strong>Informacin Tarea</strong></td></tr>
		<tr class="cont">
		<td>
			<table>
		<tr class="cont">
			<td>
				<i>&#160;Asunto:</i>&#160;<xsl:value-of select="@ASUNTO"/><input type="hidden" name="tarAsunHidden" value="{@ASUNTO}"/>
			</td>
		</tr>
		<tr class="cont">
			<td>
				<i>&#160;Texto Tarea:</i>
					<div style="padding-left:0.2cm;padding-top:0.2cm;width:730px;height:80px;overflow:auto;background-color: #FFFFD9;">
						<pre><xsl:value-of select="@DESCRIPCION"/></pre>
				</div>
			</td>
		</tr>
		<xsl:if test="@ESTADO='P'">
		<tr class="cont">
			<td>
				<i>&#160;Texto Seguimiento:</i>
				<br/>
				<div style="padding-left:0.2cm;padding-top:0.2cm;width:730px;height:80px;overflow:auto;background-color: #FFFFD9;">
						<pre><xsl:value-of select="@DESCRIPCION_SEGUIMIENTO"/></pre>
				</div>
			</td>
		</tr>
		</xsl:if>
		<tr class="cont">
			<td>
				<i>&#160;Urgencia:</i>&#160;
				<xsl:choose>
					<xsl:when test="@ESTADO='P'">
						<SELECT NAME="tarUrgencia" SIZE="1">
							<OPTION VALUE="N"><xsl:if test="@URGENCIA='N'"><xsl:attribute name="selected">true</xsl:attribute></xsl:if>No Urgente</OPTION>
							<OPTION VALUE="U"><xsl:if test="@URGENCIA='U'"><xsl:attribute name="selected">true</xsl:attribute></xsl:if>Urgente</OPTION>
						</SELECT>
					</xsl:when>
					<xsl:otherwise>
						<xsl:if test="@URGENCIA='N'">No Urgente</xsl:if>
						<xsl:if test="@URGENCIA='U'">Urgente</xsl:if>
					</xsl:otherwise>
				</xsl:choose>
				<xsl:if test="not(@TIPO_TAREA='I')">
				&#160;&#160;
				<i>&#160;Fecha Max. Resol.:</i>&#160;
					<xsl:choose>
						<xsl:when test="@ESTADO='P'">
							<input type="text" name="tarFecmaxResol" id="f_tarFecmaxResol" onChange="changeDate(this,'La Fecha Mxima de Resolucin ')"><xsl:attribute name="value"><xsl:call-template name="date2String2"><xsl:with-param name="fecha"><xsl:value-of select="@FECHA_MAX_RESOLUCION"/></xsl:with-param></xsl:call-template></xsl:attribute></input>
							<img src="../graficos/iconos/calendario_ico.gif" id="f_trigger_a"
							style="cursor: pointer; border: 1px solid red;"
							title="Selecciona Fecha Mxima de Resolucin"
							onmouseover="this.style.background='red';"
							onmouseout="this.style.background=''"/>
						</xsl:when>
						<xsl:otherwise>
							<xsl:call-template name="date2String2"><xsl:with-param name="fecha"><xsl:value-of select="@FECHA_MAX_RESOLUCION"/></xsl:with-param></xsl:call-template>
						</xsl:otherwise>
					</xsl:choose>
				</xsl:if>
				&#160;&#160;
				<span id="emc"><i>&#160;Copia:</i>&#160;<xsl:value-of select="translate(@EMAIL_COPIA,',',' ')"/></span>
				&#160;&#160;
			</td>
		</tr>
		<tr class="cont">
			<xsl:variable name="cod"><xsl:value-of select="@CODIGO"/></xsl:variable>
			<td><xsl:choose>
					<xsl:when test="count(../ANEXOS[@TIPO='S'])>0">
						<table>
						<tr>
							<td valign="top"><i>Anexos</i><br/>
							<xsl:for-each select="../ANEXOS[@CODIGO=$cod and @TIPO='S']">
								<xsl:sort select="@NOMBRE"/>
								<a href="javascript:download('{@CODIGO}','{@FECHA}','{@NOMBRE}','');"><xsl:value-of select="@NOMBRE"/>&#160;<xsl:value-of select="@SIZE"/></a><br/> 
							</xsl:for-each>
							</td>
							<td valign="top">
							<xsl:if test="count(../ANEXOS[@CODIGO!=$cod and @TIPO='S'])>0">
								<i>Anexos Tarea Padre:</i><br/>
								<xsl:for-each select="../ANEXOS[@CODIGO!=$cod and @TIPO='S']">
									<xsl:sort select="@CODIGO"/>
									<xsl:sort select="@NOMBRE"/>
									<a href="javascript:download('{@CODIGO}','{@FECHA}','{@NOMBRE}','');"><xsl:value-of select="@NOMBRE"/>&#160;<xsl:value-of select="@SIZE"/></a><br/> 
								</xsl:for-each>
							</xsl:if>
							</td>
						</tr>
						</table>
					</xsl:when>
					<xsl:otherwise>
						<i>&#160;Anexos:</i>&#160;&#160;
					</xsl:otherwise>
				</xsl:choose>
			</td>
		</tr>
		</table>
		</td>
		</tr>
		
		<tr class="cabe"><td><strong>Gestin Tarea</strong></td></tr>
		<tr class="cont">
		<td>
		<table>
		<tr class="cont">
			<td>
				<table>
				<tr>
					<td>
						<i>&#160;Aplicacin:</i>
						<xsl:value-of select="@APLICACION"/><input type="hidden" name="tarAplCod" value="{@APLICACION}"/>
					</td>
				</tr>
				</table>
			</td>
		</tr>
		<tr class="cont">
			<td>
				<table>
				<tr>
					<td>
						<i>&#160;Categora:</i>
						<xsl:value-of select="@CATEGORIADESC"/><input type="hidden" name="cat" value="{@CATEGORIADESC}"/>
					</td>
				</tr>
				</table>
			</td>
		</tr>
		<tr class="cont">
			<td>
				<xsl:choose>
					<xsl:when test="(count(../INFORMATICO_PERFIL[@PERFIL='31'])=0) or (@ESTADO='R' or @ESTADO='F')">
						<i>&#160;&#160;&#160;Texto&#160;Seguimiento:</i><br/>
						<div style="padding-left:0.2cm;padding-top:0.2cm;width:730px;height:80px;overflow:auto;background-color: #FFFFD9;">
							<pre><xsl:value-of select="@DESCRIPCION_SEGUIMIENTO"/></pre>
						</div>
					</xsl:when>
					<xsl:otherwise>
						<table border="1">
							<tr>
								<td><strong>Dirigido al usuario:</strong></td>
								<td><strong>Dirigido al informtico:</strong></td>
							</tr>
							<tr><td valign="top">
								<table>
									<tr>
										<td><i>&#160;Texto&#160;Seguimiento:</i></td>
									</tr>
									<tr>
										<td>
											<table>
												<tr>
													<td>
														<xsl:value-of select="@DESCRIPCION_SEGUIMIENTO"/><br/>
													</td>
												</tr>
												<tr>
													<td>
														<textarea name="tarDescripSegui" rows="7" cols="75" onchange="marcaCambio('seguimiento')"/>
													</td>
												</tr>
											</table>
										</td>
									</tr>
									<tr class="cont">
										<td valign="top">
											<xsl:variable name="cod"><xsl:value-of select="@CODIGO"/></xsl:variable>
											<xsl:choose>
												<xsl:when test="count(../ANEXOS[@TIPO='P'])>0">
													<table>
														<tr>
															<td valign="top"><i>Anexos Pblicos</i><br/>
																<xsl:for-each select="../ANEXOS[@CODIGO=$cod and (@TIPO='P')]">
																	<xsl:sort select="@NOMBRE"/>
																	<a href="javascript:download('{@CODIGO}','{@FECHA}','{@NOMBRE}','{@TIPO}');"><xsl:value-of select="@NOMBRE"/>&#160;<xsl:value-of select="@SIZE"/></a>
																	&#160;<a title="Eliminar Anexo" href="javascript:suprmirAnx('{@CODIGO}','{@FECHA}','{@NOMBRE}','{@TIPO}');">[-]</a><br/>
																</xsl:for-each>
																<xsl:if test="(@ESTADO='A' or @ESTADO='W' or @ESTADO='X') and (@TIPO_TAREA='P' or @TIPO_TAREA='I')">
																	<br/><a href="javascript:mostrarAnx('{@CODIGO}','','{@TIPO_TAREA}','P');">Aadir Anexo</a><br/>
																</xsl:if>
															</td>
															<td valign="top">
																<xsl:if test="count(../ANEXOS[@CODIGO!=$cod and (@TIPO='P')])>0">
																	<i>Anexos Pblicos Tarea Padre</i><br/>
																	<xsl:for-each select="../ANEXOS[@CODIGO!=$cod and (@TIPO='P')]">
																		<xsl:sort select="@CODIGO"/>
																		<xsl:sort select="@NOMBRE"/>
																		<a href="javascript:download('{@CODIGO}','{@FECHA}','{@NOMBRE}','{@TIPO}');"><xsl:value-of select="@NOMBRE"/>&#160;<xsl:value-of select="@SIZE"/></a>
																		&#160;<a title="Eliminar Anexo" href="javascript:suprmirAnx('{@CODIGO}','{@FECHA}','{@NOMBRE}','{@TIPO}');">[-]</a><br/>
																	</xsl:for-each>
																</xsl:if>
															</td>
														</tr>
													</table>
												</xsl:when>
												<xsl:otherwise>
													<i>&#160;Anexos Pblicos:</i>&#160;&#160;<xsl:if test="(@ESTADO='A' or @ESTADO='W' or @ESTADO='X') and (@TIPO_TAREA='P' or @TIPO_TAREA='I' or @TIPO_TAREA='B')"><a href="javascript:mostrarAnx('{@CODIGO}','','{@TIPO_TAREA}','P');">Aadir Anexo</a></xsl:if>
												</xsl:otherwise>
											</xsl:choose>
										</td>
									</tr>
								</table>
							</td>
							<td valign="top">
								<table>
									<tr>
										<td><i>&#160;&#160;Texto&#160;Bitcora:</i></td>
										<td align="right"><a href="javascript:verSeguimiento('{$code}');">Abrir Bitcora</a></td>
									</tr>
									<tr>
										<td colspan="2" valign="top">
											<xsl:variable name="mcod" select="../SEGUIMIENTO/@CODIGO"/>
											<table>
												<tr><td>
													<xsl:call-template name="date2String"><xsl:with-param name="fecha"><xsl:value-of select="../SEGUIMIENTO/@FECHA_ALTA"/></xsl:with-param></xsl:call-template>
													&#160;<xsl:value-of select="../SEGUIMIENTO/@DESCRIPCION"/>
													<xsl:if test="string-length(../SEGUIMIENTO/@DEDICACION)>0">&#160;(<xsl:value-of select="../SEGUIMIENTO/@DEDICACION"/>&#160;horas)</xsl:if>
													<xsl:if test="count(../ANEXOS[@CODE=$mcod])>0">
														<xsl:for-each select="../ANEXOS[@CODE=$mcod]">
															<br/><a href="javascript:download('{@CODIGO}','{@FECHA}','{@NOMBRE}','{@TIPO}{$mcod}{@TIPO}');"><xsl:value-of select="@NOMBRE"/>&#160;<xsl:value-of select="@SIZE"/></a>
															&#160;<a title="Eliminar Anexo" href="javascript:suprmirAnx('{@CODIGO}','{@FECHA}','{@NOMBRE}','{@TIPO}{$mcod}{@TIPO}');">[-]</a>
														</xsl:for-each>
													</xsl:if>
												</td></tr>
												<tr><td>
													<textarea name="nuevaBitacora" rows="7" cols="75" onchange="marcaCambio('bitacora')"/>
												</td></tr>
											</table>
										</td>
									</tr>
									<tr class="cont">
										<td colspan="2" align="left">
											<i>&#160;Horas:</i>&#160;
											<input name="tseDedicacion" type="text" size="6"/>&#160;&#160;
											<xsl:variable name="mcod" select="../SEGUIMIENTO/@CODIGO"/>
											<xsl:variable name="mcod1">
												<xsl:if test="count(../SEGUIMIENTO)>0"><xsl:value-of select="$mcod+1"/></xsl:if>
												<xsl:if test="count(../SEGUIMIENTO)=0">0</xsl:if>		
											</xsl:variable>									
																								
											<xsl:if test="(@ESTADO='A' or @ESTADO='W' or @ESTADO='X') and (@TIPO_TAREA='P' or @TIPO_TAREA='I' or @TIPO_TAREA='B')"><a href="javascript:mostrarAnx('{@CODIGO}','','{@TIPO_TAREA}','O'+'{$mcod1}');">Aadir Anexo bitcora</a></xsl:if><br/>
											<xsl:if test="count(../ANEXOS[@CODE=$mcod1])>0">
												<xsl:for-each select="../ANEXOS[@CODE=$mcod1]">
													<a href="javascript:download('{@CODIGO}','{@FECHA}','{@NOMBRE}','{@TIPO}{$mcod}{@TIPO}');"><xsl:value-of select="@NOMBRE"/>&#160;<xsl:value-of select="@SIZE"/></a><br/>
													<!-- &#160;<a title="Eliminar Anexo" href="javascript:suprmirAnx('{@CODIGO}','{@FECHA}','{@NOMBRE}','{@TIPO}{$mcod}{@TIPO}');">[-]</a>-->
												</xsl:for-each>
												<br/><i>Estos anexos no se incluirn en bitcora hasta que no escribas un texto en la misma.</i>
											</xsl:if>
										</td>
									</tr>
								</table>
							</td></tr>
						</table>
					</xsl:otherwise>
				</xsl:choose>
			</td>
		</tr>
		<xsl:if test="(count(../INFORMATICO_PERFIL[@PERFIL='31'])=0) or (@ESTADO='R' or @ESTADO='F')">
			<tr class="cont">
				<td valign="top">
					<xsl:variable name="cod"><xsl:value-of select="@CODIGO"/></xsl:variable>
					<xsl:choose>
						<xsl:when test="count(../ANEXOS[@TIPO='P'])>0">
							<table>
							<tr>
								<td valign="top"><i>&#160;Anexos Pblicos</i><br/>
									<xsl:for-each select="../ANEXOS[@CODIGO=$cod and (@TIPO='P')]">
										<xsl:sort select="@NOMBRE"/>
										<a href="javascript:download('{@CODIGO}','{@FECHA}','{@NOMBRE}','{@TIPO}');"><xsl:value-of select="@NOMBRE"/>&#160;<xsl:value-of select="@SIZE"/></a><br/> 
									</xsl:for-each>
								</td>
								<td valign="top">
								<xsl:if test="count(../ANEXOS[@CODIGO!=$cod and (@TIPO='P')])>0">
									<i>&#160;Anexos Pblicos Tarea Padre</i><br/>
									<xsl:for-each select="../ANEXOS[@CODIGO!=$cod and (@TIPO='P')]">
										<xsl:sort select="@CODIGO"/>
										<xsl:sort select="@NOMBRE"/>
										<a href="javascript:download('{@CODIGO}','{@FECHA}','{@NOMBRE}','{@TIPO}');"><xsl:value-of select="@NOMBRE"/>&#160;<xsl:value-of select="@SIZE"/></a><br/> 
									</xsl:for-each>
								</xsl:if>
								</td>
							</tr>
							</table>
						</xsl:when>
					</xsl:choose>
				</td>
			</tr>
		</xsl:if>
			<tr class="cont">
				<td>
				<xsl:if test="not(@ESTADO='R') and not(@ESTADO='F') and count(../INFORMATICO_PERFIL[@PERFIL='31'])>0">
						&#160;<input type="button" class="boton" value="Aplicar Cambios" OnClick="aplicaCambios();"/>
				</xsl:if>
				<i>&#160;&#160;&#160;Prioridad:</i>&#160;
					<xsl:value-of select="@PRIORIDADDESC"/><input type="hidden" name="tarPrio" value="{@PRIORIDADDESC}"/>
					<label id="fpr"><xsl:attribute name="style"><xsl:if test="not(@PRIORIDAD) or (@PRIORIDAD!='P')">display:none;</xsl:if></xsl:attribute>&#160;&#160;<i>&#160;Fecha Prevista:</i>&#160;
						<xsl:call-template name="date2String2"><xsl:with-param name="fecha"><xsl:value-of select="@PLANIFICACION"/></xsl:with-param></xsl:call-template>
					</label>
					<xsl:if test="(@ESTADO='R' or @ESTADO='F')">
						<i>&#160;&#160;&#160;Fecha Fin:</i>&#160;
						<xsl:call-template name="date2String"><xsl:with-param name="fecha"><xsl:value-of select="@FECHA_FIN"/></xsl:with-param></xsl:call-template>
					</xsl:if>
				</td>
			</tr>
		</table>
		</td></tr>
		<xsl:if test="(@ESTADO='R')">
			<xsl:variable name="hrs"><xsl:choose><xsl:when test="string-length(@HORAS_RESOLUCION)>0"><xsl:value-of select="floor(number(@HORAS_RESOLUCION))"/> Hora(s) y <xsl:value-of select="round(60*(round((number(@HORAS_RESOLUCION)-floor(number(@HORAS_RESOLUCION)))*100) div 100))"/> Minutos.</xsl:when><xsl:otherwise>0 Horas.</xsl:otherwise></xsl:choose></xsl:variable>
			<xsl:variable name="cmat"><xsl:choose><xsl:when test="string-length(@COSTE_MATERIAL)>0"><xsl:value-of select="@COSTE_MATERIAL"/> Euros</xsl:when><xsl:otherwise>&#160;</xsl:otherwise></xsl:choose></xsl:variable>
			<xsl:variable name="ceco"><xsl:choose><xsl:when test="string-length(@COSTE_ECONOMICO)>0"><xsl:value-of select="@COSTE_ECONOMICO"/> Euros</xsl:when><xsl:otherwise>&#160;</xsl:otherwise></xsl:choose></xsl:variable>
			<tr><td class="cabe"><strong>Resolucin de Tarea</strong></td></tr>
			<tr class="cont">
				<td>
					<i>&#160;Texto&#160;Solucin:</i><br/>
					<div style="padding-left:0.2cm;padding-top:0.2cm;width:730px;height:80px;overflow:auto;background-color: #FFFFD9;">
							<pre><xsl:value-of select="../MOVIMIENTO/@DESCRIPCION_MOVIMIENTO"/></pre>
					</div>
				</td>
			</tr>
			<tr class="cont">
				<td>
					<i>&#160;Horas Empleadas:</i>&#160;<xsl:value-of select="$hrs"/>
					<i>&#160;Coste Econmico:</i>&#160;<xsl:value-of select="$ceco"/>
					<i>&#160;Coste Material:</i>&#160;<xsl:value-of select="$cmat"/>
				</td>
			</tr>
		</xsl:if>
		</xsl:for-each>
</table>
</xsl:template>
<xsl:template name="cuerpo">
</xsl:template>
</xsl:stylesheet>
