<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet version="1.0" 
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:xforms="http://www.w3.org/2002/xforms">
	
<xsl:param name="servlet"/>	
<xsl:param name="menu"/>

<xsl:include href="dumbo7/utils/xsl/utils.xsl"/>
<xsl:template match="XMLROOT">
	<xsl:call-template name="headComun">
		<xsl:with-param name="tareas" select="DATA/DUMBOS/TAREAS"/>
	</xsl:call-template>
	
	<table align="center" border="0" cellpadding="3" cellspacing="1" width="775" height="16" summary="Esta tabla contiene listados de tareas">
		<tr><td>
			<!--*************TABLA PARA LOS RESULTADOS DE LA BUSQUEDA****************-->
			<table class="cont" id="resultados" border="0" cellpadding="3" cellspacing="1" style="border-collapse: collapse" width="780" height="16" summary="Esta tabla contiene las tareas pendientes para el usuario en cuestin">	
				<xsl:if test="count(DATA/DUMBOS/TAREAS)= 0">
					<tr>
						<td class="gestion" colspan="13">
							No hay tareas con esas caractersticas para este usuario o no tiene permiso para verlas.
						</td>
					</tr>	
				</xsl:if>		
				<!--TAREAS PENDIENTES POR RESOLVER PARA EL USUARIO SOLICITADO-->
				<xsl:if test="count(DATA/DUMBOS/TAREAS)!= 0">
					<tr class="cabeAlertas">
						<td width="76"><strong>Cdigo</strong></td>
						<td width="100"><strong>Aplicacin</strong></td>
						<td width="350"><strong>Asunto</strong></td>
						<td width="300"><strong>Informatico</strong></td>
						<td width="100"><strong>Creada</strong></td>
						<td width="100"><strong>Prioridad</strong></td>
						<td width="100"><strong>Estado</strong></td>
					</tr>		
					<xsl:for-each select="DATA/DUMBOS/TAREAS">
						<tr class="gestion">
							<td>
								<a title="Mostrar informacin sobre tarea" href="javascript:cargaDetalle({@CODIGO})">
									<xsl:value-of select="@CODIGO"/>
								</a>	
							</td>
							<td class="celdapaipucMet"><xsl:value-of select="@APLICACION"/></td>
							<td class="celdapaipucMet"><xsl:value-of select="@ASUNTO"/></td>
							<td>
								<xsl:variable name="Infcod"><xsl:value-of select="@INFORMATICO"/></xsl:variable>
								<xsl:if test="count(../DATOSPERSONALES[IDENTIFICADOR = $Infcod])= 0">	
									Sin asignar
								</xsl:if>
								<xsl:for-each select="../DATOSPERSONALES[IDENTIFICADOR = $Infcod]">
									<xsl:value-of select="APELLIDOS"/>,&#160;<xsl:value-of select="NOMBRE"/>
								</xsl:for-each>
							</td>
							<td align="center"><xsl:call-template name="date2String2"><xsl:with-param name="fecha" select="@FECHA_CREACION"/></xsl:call-template></td>
							<td align="center">
								<xsl:variable name="prioridad"><xsl:value-of select="@PRIORIDAD"/></xsl:variable>
								<xsl:if test="count(../PRIORIDAD[@CODIGO = $prioridad])= 0">	
									Sin prioridad
								</xsl:if>
								<xsl:for-each select="../PRIORIDAD[@CODIGO = $prioridad]">
									<xsl:value-of select="@DESCRIPCION"/>
								</xsl:for-each>
							</td>
							<xsl:choose>
								<xsl:when test="@ESTADO='P'">
									<td class="celdapaipucMet_7pt" align="center">
										<img  border="0" src="../graficos/iconos/pendiente_ico.gif" alt="Pendiente de asignacin"/>
									</td>
								</xsl:when>
								<xsl:when test="@ESTADO='A'">
									<td class="celdapaipucMet_7pt" align="center">
										<img  border="0" src="../graficos/iconos/asignada_ico.gif" alt="Asignada"/>
									</td>															
								</xsl:when>
								<xsl:when test="@ESTADO='W'">
									<td class="celdapaipucMet_7pt" align="center">
										<img  border="0" src="../graficos/iconos/espera_ico.gif" alt="En espera"/>
									</td>													
								</xsl:when>
								<xsl:when test="@ESTADO='N'">
									<td class="celdapaipucMet_7pt" align="center">
										<img  border="0" src="../graficos/iconos/N.gif" alt="Anulada"/>
									</td>		
								</xsl:when>
								<xsl:when test="@ESTADO='R'">
									<td class="celdapaipucMet_7pt" align="center">
										<img  border="0" src="../graficos/iconos/resuelta_ico.gif" alt="Resuelta"/>
									</td>	
								</xsl:when>
								<xsl:when test="@ESTADO='X'">
									<td class="celdapaipucMet_7pt" align="center">
										<img  border="0" src="../graficos/iconos/rechazada_ico.gif" alt="Rechazada"/>
									</td>	
								</xsl:when>
								<xsl:when test="@ESTADO='F'">
									<td class="celdapaipucMet_7pt" align="center">
										<img  border="0" src="../graficos/iconos/F.gif" alt="Resuelta con subtareas"/>
									</td>	
								</xsl:when>
							</xsl:choose>
						</tr>
						<tr class="lineaResultados"><td colspan="8"><hr width="100%"></hr></td></tr>
						<tr><td colspan="8" id="detalle{@CODIGO}"></td></tr>
					</xsl:for-each>
				</xsl:if>
			</table>
		</td></tr>
	</table>
</xsl:template>
<xsl:template name="cuerpo">
</xsl:template>
</xsl:stylesheet>