<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet version="2.0" 
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
		
<xsl:param name="code"/>
		
<xsl:key name="miClave" match="SUBTAREA" use="@CODIGO"/>
		
<xsl:template name="inAtender">
	<xsl:call-template name="detailUser">
		<xsl:with-param name="filt" select="DATA/DUMBOS/FILTRO"/>
		<xsl:with-param name="target" select="'dumbo7/atencion.atender.detalleUser'"/>
	</xsl:call-template>
	<table id="miTabla" name="miTabla"><xsl:attribute name="class"><xsl:choose><xsl:when test="DATA/DUMBOS/FILTRO/@FORMATO='L'">contb</xsl:when><xsl:otherwise>cont</xsl:otherwise></xsl:choose></xsl:attribute>
		<thead>
		<tr class="cabe">
			<td width="1%">&#160;</td>
			<xsl:for-each select="DATA/DUMBOS/FILTRO/CAMPOS">
				<xsl:variable name="co" select="."/>
				<td><strong><xsl:call-template name="traduce"><xsl:with-param name="id"><xsl:value-of select="/XMLROOT/DATA/DUMBOS/FILTRO/CAMPOSFILTRO[key=$co]/value"/></xsl:with-param></xsl:call-template></strong></td>
			</xsl:for-each>
			<td width="1">&#160;</td>
		</tr>
		</thead>
		<tbody>
		<xsl:choose>
			<xsl:when test="DATA/DUMBOS/@ERROR=''">
				<form name="f1">
					<xsl:call-template name="insacaTarea"/>
				</form>
				<xsl:if test="count(DATA/DUMBOS/PAGINAS/ITEM)>0">
				<center>
			  	<xsl:call-template name="PIE-LISTA">
			  		<xsl:with-param name="DATOS" select="DATA/DUMBOS/PAGINAS"/>
			  		<xsl:with-param name="function"><xsl:if test="string-length($selected)>0">cambiaPagina</xsl:if></xsl:with-param>
					<xsl:with-param name="altfunction">hideDetail</xsl:with-param>
			  		<xsl:with-param name="SIZE" select="DATA/DUMBOS/FILTRO/@TAMPAG"/>
					<xsl:with-param name="DATA"><input type="hidden" name="code" value="{$code}"/></xsl:with-param>
			  	</xsl:call-template>
				</center>
				</xsl:if>
				<xsl:if test="count(DATA/DUMBOS/PAGINAS/ITEM)=0">
					<tr><td>&#160;</td><td colspan="{count(DATA/DUMBOS/FILTRO/CAMPOS)}">La lista de tareas est vaca</td></tr>
				</xsl:if>
				<!--
			  	<xsl:call-template name="PIE-SGTE">
			  		<xsl:with-param name="DATOS" select="DATA/DES/PAGINAS"/>
			  		<xsl:with-param name="IMAGE-NEXT" select="'../graficos/img/next.gif'"/>
			  		<xsl:with-param name="IMAGE-PREVIOUS" select="'../graficos/img/previous.gif'"/>
			  	</xsl:call-template>
				-->
			</xsl:when>
			<xsl:otherwise>
				Ocurri un error:<br/>
				<xsl:value-of select="DATA/DUMBOS/@ERROR"/>	
			</xsl:otherwise>
		</xsl:choose>
		</tbody>
	</table>
</xsl:template>

<xsl:template name="insacaTarea">
	<xsl:for-each select="/XMLROOT/DATA/DUMBOS/PAGINAS/ITEM[count(key('miClave',@CODIGO))=0 or count(/XMLROOT/DATA/DUMBOS/FILTRO[@SUBTAREAS='N'])>0]">
	  <xsl:variable name="micode" select="@CODIGO"/>
	  <xsl:variable name="posicion" select="position()"/>
		<xsl:variable name="estilo">
		<xsl:choose>
		<xsl:when test="./@TIPO_TAREA='B'">problema</xsl:when>
		<xsl:when test="./@TIPO_TAREA='I'">incidencia</xsl:when>
		<xsl:when test="./@TIPO_TAREA='A'">programada</xsl:when>
		<xsl:otherwise>peticion</xsl:otherwise>
		</xsl:choose>
		</xsl:variable>
		<xsl:variable name="tsp">
			<xsl:call-template name="SubTareaPend">
				<xsl:with-param name="padre" select="."/>
				<xsl:with-param name="guion" select="'-'"/>
				<xsl:with-param name="posic" select="position()"/>
			</xsl:call-template>
		</xsl:variable>
		<tr><xsl:if test="(count(./SUBTAREA)>0)"><xsl:attribute name="id">arb.<xsl:value-of select="$posicion"/></xsl:attribute><xsl:attribute name="class">switchcontent</xsl:attribute></xsl:if>
		<td id="img{@CODIGO}" width="1%" class="{$estilo}">
			<xsl:choose>
				<xsl:when test="@CODIGO=$selected"><a name="{@CODIGO}"><img src="../graficos/iconos/traspasar_ico.gif" border="0"/></a></xsl:when>
				<xsl:otherwise><font size="-2">[<xsl:value-of select="((number(../PAGE)-1)*number(/XMLROOT/DATA/DUMBOS/FILTRO/@TAMPAG))+position()"/>]</font></xsl:otherwise>
			</xsl:choose>
			<xsl:if test="@CODIGO=$selected">
				<script language="JavaScript">
					setSelectData('&lt;font size="-2">[<xsl:value-of select="((number(../PAGE)-1)*number(/XMLROOT/DATA/DUMBOS/FILTRO/@TAMPAG))+position()"/>]&lt;/font>');
				</script>
			</xsl:if>
			<!--
			<xsl:if test="count(./SUBTAREA)>0"><img id="img.arb.{position()}" src="../dumbo7/utils/table/minus.gif" class="showstate" onClick="expandcontent(this, 'arb.{position()}');"/></xsl:if>
			-->
			<xsl:if test="string-length($tsp)>0">SP</xsl:if>
		</td>
		<xsl:variable name="fila" select="."/>
		<xsl:for-each select="/XMLROOT/DATA/DUMBOS/FILTRO/CAMPOS">
			<xsl:call-template name="showColumn">
				<xsl:with-param name="columna" select="."/>
				<xsl:with-param name="fila" select="$fila"/>
				<xsl:with-param name="name"><xsl:if test="(count($fila/SUBTAREA)>0) and (position()=1)"><xsl:value-of select="$posicion"/></xsl:if></xsl:with-param>
				<xsl:with-param name="estilo"><xsl:value-of select="$estilo"/></xsl:with-param>
			</xsl:call-template>
		</xsl:for-each>
		<td width="1" class="{$estilo}">
			<xsl:if test="count(./ALERTA)>0">
				<img src="../graficos/iconos/peligro{count(./ALERTA)}.gif" title="Tarea con {count(./ALERTA)} Alertas" border="0"/>
			</xsl:if>
			<xsl:if test="$fila/@ESTADO='R' and ($fila/@CATEGORIA and not(number($fila/@CATEGORIA)>0))">
				<img src="../graficos/iconos/rapido_ico.gif" title="Dumbo Rpido" border="0"/>
			</xsl:if>
		</td>
		</tr>
		<xsl:if test="count(/XMLROOT/DATA/DUMBOS/FILTRO[not(@SUBTAREAS='N')])>0">
			<xsl:call-template name="insacaSubTarea">
				<xsl:with-param name="padre" select="."/>
				<xsl:with-param name="guion" select="'-'"/>
				<xsl:with-param name="posic" select="position()"/>
			</xsl:call-template>
		</xsl:if>
	</xsl:for-each>
</xsl:template>

<xsl:template name="insacaSubTarea">
<xsl:param name="padre"/>
<xsl:param name="guion"/>
<xsl:param name="posic"/>
	<xsl:for-each select="$padre/SUBTAREA">
		<xsl:sort select="@CODIGO"/>
		<xsl:variable name="posicion" select="concat(concat($posic,'.'),position())"/>
		<xsl:variable name="estilo">
		<xsl:choose>
		<xsl:when test="./@TIPO_TAREA='B'">problema</xsl:when>
		<xsl:when test="./@TIPO_TAREA='I'">incidencia</xsl:when>
		<xsl:when test="./@TIPO_TAREA='A'">programada</xsl:when>
		<xsl:otherwise>peticion</xsl:otherwise>
		</xsl:choose>
		</xsl:variable>
		<tr id="arb.{concat(concat($posic,'.'),position())}"><xsl:if test="(count(./SUBTAREA)>0)"><xsl:attribute name="class">switchcontent</xsl:attribute></xsl:if>
		<td width="1%" class="{$estilo}" id="img{@CODIGO}">
			<xsl:choose>
				<xsl:when test="@CODIGO=$selected"><a name="{@CODIGO}"><img src="../graficos/img/select.gif" border="0"/></a></xsl:when>
				<xsl:otherwise>&#160;</xsl:otherwise>
			</xsl:choose>
			<!--
			<xsl:if test="count(./SUBTAREA)>0"><img id="img.arb.{concat(concat($posic,'.'),position())}" src="../dumbo7/utils/table/minus.gif" class="showstate" onClick="expandcontent(this, 'arb.{concat(concat($posic,'.'),position())}');"/></xsl:if>
			-->
		</td>
		<xsl:variable name="fila" select="."/>
		<xsl:for-each select="/XMLROOT/DATA/DUMBOS/FILTRO/CAMPOS">
			<xsl:call-template name="showColumn">
				<xsl:with-param name="guion" select="$guion"/>
				<xsl:with-param name="columna" select="."/>
				<xsl:with-param name="fila" select="$fila"/>
				<xsl:with-param name="name"><xsl:if test="(count($fila/SUBTAREA)>0) and (position()=1)"><xsl:value-of select="$posicion"/></xsl:if></xsl:with-param>
				<xsl:with-param name="estilo" select="$estilo"/>
			</xsl:call-template>
		</xsl:for-each>
		<td width="1%" class="{$estilo}">&#160;</td>
		</tr>
		
		<xsl:call-template name="insacaSubTarea">
			<xsl:with-param name="padre" select="."/>
			<xsl:with-param name="guion" select="concat($guion,'-')"/>
			<xsl:with-param name="posic" select="concat(concat($posic,'.'),position())"/>
		</xsl:call-template>
		
	</xsl:for-each>
</xsl:template>

<xsl:template name="SubTareaPend">
<xsl:param name="padre"/>
<xsl:param name="guion"/>
<xsl:param name="posic"/>
<xsl:choose>
	<xsl:when test="count($padre/SUBTAREA[@ESTADO='A' or @ESTADO='P' or @ESTADO='W' or @ESTADO='X'])>0">S</xsl:when>
	<xsl:otherwise>
	<xsl:for-each select="$padre/SUBTAREA">
		<xsl:call-template name="SubTareaPend">
			<xsl:with-param name="padre" select="."/>
			<xsl:with-param name="guion" select="concat($guion,'-')"/>
			<xsl:with-param name="posic" select="concat(concat($posic,'.'),position())"/>
		</xsl:call-template>
	</xsl:for-each>
	</xsl:otherwise>
</xsl:choose>
</xsl:template>

</xsl:stylesheet>
	