<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet version="1.0" 
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:xforms="http://www.w3.org/2002/xforms">
	
<xsl:param name="servlet"/>	
<xsl:param name="menu"/>
<xsl:param name="selected"/>
<xsl:param name="page"/>
<xsl:param name="secname"/>
<xsl:param name="aplname"/>
<xsl:param name="infname"/>
<xsl:param name="ajx"/>
<xsl:param name="separator" select="'|'"/>
<xsl:param name="numItem"/>

<xsl:include href="dumbo7/utils/xsl/utils.xsl"/>
<xsl:include href="dumbo7/utils/xsl/detail.xsl"/>
<xsl:include href="dumbo7/gestion/dumbos/html/utils.xsl"/>
<xsl:include href="atica/frameweb/xml/templates/paginable.xsl"/>
<xsl:include href="dumbo7/gestion/dumbos/html/inAtender.xsl"/>

<xsl:template match="XMLROOT">
<xsl:choose>
<xsl:when test="string-length($ajx)=0">
<html lang="es">

	<xsl:call-template name="headComun">
		<xsl:with-param name="ERROR" select="DATA/DUMBOS/@ERROR"/>
		<xsl:with-param name="arbol" select="true()"/>
		<xsl:with-param name="calendar" select="true()"/>
		<xsl:with-param name="jscript">
			<SCRIPT LANGUAGE="JavaScript">
				function cambiaPagina(p) { top.recargarPage(p); }
				function hideDetail(p) { top.hideDetail(p); }
			</SCRIPT>
		</xsl:with-param>
	</xsl:call-template>

<body>
	<xsl:call-template name="showDetalleTarea">
		<xsl:with-param name="pagesize" select="/XMLROOT/DATA/DUMBOS/FILTRO/@TAMPAG"/>
		<xsl:with-param name="baseList" select="'dumbo7/gestion/dumbos.listAtendidas'"/>
		<xsl:with-param name="printList" select="'dumbo7/gestion/dumbos.printAtendidas'"/>
		<xsl:with-param name="detailinput">
			<input type="hidden" name="code"><xsl:attribute name="value"><xsl:choose><xsl:when test="string-length($secname)>0">S<xsl:value-of select="$separator"/><xsl:value-of select="$secname"/></xsl:when><xsl:when test="string-length($aplname)>0">A<xsl:value-of select="$separator"/><xsl:value-of select="$aplname"/></xsl:when><xsl:when test="string-length($infname)>0">I<xsl:value-of select="$separator"/><xsl:value-of select="$infname"/></xsl:when></xsl:choose></xsl:attribute></input>
		</xsl:with-param>
	</xsl:call-template>
	<xsl:call-template name="filtrarListado">
		<xsl:with-param name="pagesize" select="/XMLROOT/DATA/DUMBOS/FILTRO/@TAMPAG"/>
		<xsl:with-param name="list" select="'globalAtendidas'"/>
		<xsl:with-param name="reload" select="'dumbo7/gestion/dumbos.listAtendidas'"/>
		<xsl:with-param name="reloadinput">
			<input type="hidden" name="secname" value="{$secname}"/>
			<input type="hidden" name="aplname" value="{$aplname}"/>
			<input type="hidden" name="infname" value="{$infname}"/>
		</xsl:with-param>
	</xsl:call-template>
	<xsl:call-template name="showManageTarea">
		<xsl:with-param name="GRUPOS" select="DATA/DUMBOS"/>
		<xsl:with-param name="SOLICITUD" select="DATA/DUMBOS/SOLICITUD[1]"/>
		<xsl:with-param name="listado" select="'dumbo7/gestion/dumbos.listAtendidas'"/>
		<xsl:with-param name="detailinput">
			<input type="hidden" name="secname" value="{$secname}"/>
			<input type="hidden" name="aplname" value="{$aplname}"/>
			<input type="hidden" name="infname" value="{$infname}"/>
		</xsl:with-param>
	</xsl:call-template>
	<xsl:call-template name="menuComun">
		<xsl:with-param name="HELP" select="'gestion.xml#3'"/>
		<xsl:with-param name="MENU" select="DATA/MENU"/>
		<xsl:with-param name="SELECT" select="$menu"/>
		<xsl:with-param name="NAME" select="concat(DATA/DUMBOS/USER/@NAME,concat(' (',concat(DATA/DUMBOS/USER/@LOGIN,')')))"/>
	</xsl:call-template>
	<xsl:call-template name="pieComun"/>
	<xsl:if test="not($selected='')"><script language="JavaScript">testDetailExists();</script></xsl:if>
</body>
</html>
</xsl:when>
<xsl:otherwise>
	<xsl:call-template name="tablaDetalle"/>
</xsl:otherwise>
</xsl:choose>
</xsl:template>

<xsl:template name="cuerpo">
<xsl:call-template name="menuGestionGlobal">
	<xsl:with-param name="link" select="'atendidas'"/>
</xsl:call-template>
<xsl:call-template name="showCabecera">
	<xsl:with-param name="titulo" select="'Atender tareas resueltas'"/>
	<xsl:with-param name="filtro" select="DATA/DUMBOS/FILTRO"/>
</xsl:call-template>
<xsl:choose>
	<xsl:when test="DATA/DUMBOS/FILTRO/@FORMATO='L'">
			<xsl:call-template name="inAtender"/>
			<xsl:call-template name="showPieCabecera">
				<xsl:with-param name="titulo" select="'Atender tareas resueltas'"/>
			</xsl:call-template>
			<a name="detalle">&#160;</a>
			<div id="tabDet">
			<xsl:if test="not($selected='')">
				<xsl:call-template name="detailTarea">
					<xsl:with-param name="nodo" select="DATA/DUMBOS"/>
					<xsl:with-param name="tipoDetalle" select="'globalAtendidas'"/>
				</xsl:call-template>
				<script language="JavaScript">
					cargadoTextoDetalle(document.getElementById('tabDet').innerHTML.toLowerCase());
				</script>
			</xsl:if>
			</div>
	</xsl:when>
	<xsl:otherwise>
		<center>
		<xsl:variable name="code"><xsl:choose><xsl:when test="string-length($secname)>0">S<xsl:value-of select="$separator"/><xsl:value-of select="$secname"/></xsl:when><xsl:when test="string-length($aplname)>0">A<xsl:value-of select="$separator"/><xsl:value-of select="$aplname"/></xsl:when><xsl:when test="string-length($infname)>0">I<xsl:value-of select="$separator"/><xsl:value-of select="$infname"/></xsl:when></xsl:choose></xsl:variable>
		<iframe name="listado" id="listado" src="{$servlet}?module=dumbo7/gestion/dumbos.listAtendidas.resueltas&amp;code={$code}&amp;selected={$selected}&amp;page={$page}&amp;pagesize={/XMLROOT/DATA/DUMBOS/FILTRO/@TAMPAG}#{$selected}" width="90%" height="150" frameborder="0"></iframe>
		</center>
		<xsl:call-template name="showPieCabecera">
			<xsl:with-param name="titulo" select="'Atender tareas resueltas'"/>
		</xsl:call-template>
		<br/>&#160;<br/>
		<a name="detalle">&#160;</a>
		<div id="tabDet">
		<xsl:if test="not($selected='')">
			<xsl:call-template name="detailTarea">
				<xsl:with-param name="nodo" select="DATA/DUMBOS"/>
				<xsl:with-param name="tipoDetalle" select="'globalAtendidas'"/>
			</xsl:call-template>
			<script language="JavaScript">
				cargadoTextoDetalle(document.getElementById('tabDet').innerHTML.toLowerCase());
			</script>
		</xsl:if>
		</div>
	</xsl:otherwise>
</xsl:choose>
</xsl:template>

<xsl:template name="tablaDetalle">
<table class="contdet" border="0" cellpadding="1" cellspacing="1" width="100%">
	<xsl:call-template name="detailTarea">
		<xsl:with-param name="nodo" select="DATA/DUMBOS"/>
		<xsl:with-param name="tipoDetalle" select="'globalAtendidas'"/>
	</xsl:call-template>
</table>
</xsl:template>

</xsl:stylesheet>
	