package dumbo7.gestion.empresas;

import dumbo7.utils.*;
import dumbo7.utils.ldap.LDAPUser;
import dumbo7.utils.ldap.LDAPUtil;
import dumbo7.administracion.*;
import org.hibernate.*;
import org.hibernate.criterion.Expression;
import org.hibernate.exception.ConstraintViolationException;
import org.hibernate.type.Type;
import atica.frameweb.query.*;

import java.math.BigDecimal;
import java.sql.*;

import java.util.*;

/**
 * @author prc
 *
 * Gestor de Administracin de Categorias
 * 
 */


public class GestorEmpresas extends GestorAdministracion {
	
	public GestorEmpresas() {}
		
	protected List empresas = null;
	private String patron ="";
	protected List tareas = null;
		
	//Metodos get() para el mapeo
	public List getEmpresas() { return empresas; }
	public String getPatron() {return patron;}
	public List getTareas(){return tareas;}
		
		
	/**LISTA DE UN ELEMENTO*/
	
	/**OBTIENE TODAS LAS EMPRESAS*/
	public void allEmpresas(Session conn){
		try { 
			Query q = null;
			q = conn.createQuery(getQuery("allEmpresas"));
			q.setString("sist",user.getDatosMenu().idSelected());
			empresas = q.list();
		
		} catch (Exception ex) {
			setErrorMessage("GestorEmpresas[Error al obtener la lista de empresas]: "+ex);
		} 
	}
	
	
	/**OBTIENE LAS TAREAS DEL USUARIOS IDENTIFICADO POR CODE*/
	public void TareasEmpresa(Session conn, String emp){
	    try {
	        if ((emp==null) || emp.equals("")) return;
	        Query q = null;
			q = conn.createQuery(getQuery("TareasUsuario"));
			q.setString("sist",user.getDatosMenu().idSelected());
			q.setString("id",emp);
			q.setString("anulada",D7Tareas.ANULADA);
			q.setString("finalizada",D7Tareas.FINALIZADA);
			q.setString("rechazada",D7Tareas.RECHAZADA);
			q.setString("incidencia",D7TiposTareas.INCIDENCIA);
			q.setString("peticion",D7TiposTareas.PETICION);
			tareas = q.list();
		} catch (Exception ex) {
			setErrorMessage("GestorEmpresas[Error al obtener las tareas asociadas a la empresa]: "+ex);
		}
	}
	
	public void ConsultarHistorico(Session conn, String emp){
		Query q = null;
		try{
			q = conn.createQuery(getQuery("HistoricoTareas"));
			q.setString("sist",user.getDatosMenu().idSelected());
			q.setString("id",emp);
			q.setString("anulada",D7Tareas.ANULADA);
			q.setString("finalizada",D7Tareas.FINALIZADA);
			q.setString("rechazada",D7Tareas.RECHAZADA);
			q.setString("incidencia",D7TiposTareas.INCIDENCIA);
			q.setString("peticion",D7TiposTareas.PETICION);
			tareas = q.list();
		}
		catch(Exception ex){
			setErrorMessage("GestorUsuarios[HistoricoTareas]: "+ex);
		}
		
	}
	
}
