<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet version="1.0"
     xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	 xmlns:xforms="http://www.w3.org/2002/xforms" 
     xmlns:fo="http://www.w3.org/1999/XSL/Format" >

<xsl:param name="servlet"/>
<xsl:param name="menu"/>

<!--Codigo del usuario-->
<xsl:param name="selected"/>
<xsl:param name="ajx"/>
<xsl:include href="dumbo7/utils/xsl/utils.xsl"/>

<xsl:template match="XMLROOT">
	<fo:root>
		<fo:layout-master-set >

			<fo:simple-page-master master-name="simple"
					page-height="29.7cm"
					page-width="21cm"
					margin-top="0.5cm" 
					margin-bottom="1.5cm" 
					margin-left="2cm" 
					margin-right="2cm">
				<fo:region-body border="0.25pt solid silver" margin-top="1cm" margin-bottom="0.5cm"/>
				<fo:region-before border="0.25pt solid silver" />
				<fo:region-after extent="0.5cm"/>
			</fo:simple-page-master>
		</fo:layout-master-set>

<fo:page-sequence master-reference="simple" >
				
		<fo:static-content flow-name="xsl-region-before">
    <fo:block background-color="#000000">
	<!--CABECERA DUMBO-->
    </fo:block>
  </fo:static-content>
		
		<!--PIE DUMBO-->
		<fo:static-content flow-name="xsl-region-after">
			<fo:table>
				<fo:table-column column-number="1"/>
				<fo:table-column column-number="2"/>
				<fo:table-column column-number="3"/>
		
				<fo:table-body>
					<fo:table-row>
						<!--Pie de pgina-->
						<fo:table-cell number-columns-spanned="2">
							<!--Lo pone en la primera pgina-->
							 <fo:block text-align="left" font-size="8pt">
								<!--(C) 2005. ATICA. Vicerrectorado de Investigacin y Nuevas Tecnologas-->
								<xsl:value-of select="DATA/ALERTAS/PARAMETRO[@PARAMETRO='PAR_PIE_NOTIF']/@VALOR"/>
							</fo:block>
							<!--Lo pone en las siguientes-->
							 <fo:block text-align="left" font-size="8pt"  break-before="page">
								<xsl:value-of select="DATA/ALERTAS/PARAMETRO[@PARAMETRO='PAR_PIE_NOTIF']/@VALOR"/>
							</fo:block>
						</fo:table-cell>
						
						<!--Numeracin del pie-->
						<fo:table-cell>
							<!--Lo pone en la primera pgina-->
			               <fo:block text-align="right" font-size="8pt">
					          <fo:page-number/>
			               </fo:block>
						   <!--Lo pone en las siguientes-->
						   <fo:block text-align="right" font-size="8pt" break-before="page"> 
		                     <fo:page-number/>
					       </fo:block>
						</fo:table-cell>
					</fo:table-row>
				</fo:table-body>
			</fo:table>
          </fo:static-content>
		<fo:flow flow-name="xsl-region-body">
			<xsl:apply-templates/>
		</fo:flow>
</fo:page-sequence>
	</fo:root>	
</xsl:template>

<!--CUERPO PDF-->
<xsl:template match="DATA">
	<fo:external-graphic src="url('http://212.128.41.116:8080/cabecera-upctpdf.gif')" width="15cm" height="2cm"/>
	<fo:block text-align="center" font-size="16">&#160;</fo:block>
	<fo:block text-align="center" font-size="22" color="#000000" text-decoration="underline">INFORME DE TAREAS ASOCIADAS A UNA EMPRESA
	</fo:block>	
	<fo:block text-align="center" font-size="16">&#160;</fo:block>
	<fo:block text-align="center" font-size="16">&#160;</fo:block>
	<xsl:apply-templates/>
</xsl:template>

<xsl:template match="EMPRESAS">
		<!--Tabla para los datos personales-->
		<fo:table border="0.25pt solid silver">
			<fo:table-column column-number="1" column-width="25mm"/>
			<fo:table-column column-number="2" column-width="85mm"/>
			<fo:table-column column-number="3" column-width="25mm"/>
			<fo:table-column column-number="4"/>
			
			<fo:table-header background-color="#000000">
				<fo:table-row>
					<fo:table-cell number-columns-spanned="2">
						<fo:block font-weight="bold" color="#FFFFFF" 
							font-size="12pt">Datos de la empresa
						</fo:block>
					</fo:table-cell>
				</fo:table-row>
			</fo:table-header>
			<fo:table-body text-align="left" start-indent="3pt">
				<fo:table-row>
					<fo:table-cell>
						<fo:block font-size="9pt" 
							start-indent="10pt"		 
							font-family="sans-serif" 
							line-height="20pt"
							space-after.optimum="0pt"
							font-weight="bold"
							text-align="right">
							Nombre:
						</fo:block>
					</fo:table-cell>
					<fo:table-cell>
						<fo:block font-size="9pt" 
							start-indent="10pt"		 
							font-family="sans-serif" 
							line-height="20pt"
							space-after.optimum="0pt"
							text-align="left">
							<xsl:value-of select="EMPRESA[@EMAIL = $selected]/@NOMBRE"/>
						</fo:block>
					</fo:table-cell>
					<fo:table-cell>
						<fo:block font-size="9pt" 
							start-indent="10pt"		 
							font-family="sans-serif" 
							line-height="20pt"
							space-after.optimum="0pt"
							font-weight="bold"
							text-align="right">
							Cif:&#160;
						</fo:block>
					</fo:table-cell>
					<fo:table-cell>
						<fo:block font-size="9pt" 
							start-indent="10pt"		 
							font-family="sans-serif" 
							line-height="20pt"
							space-after.optimum="0pt"
							text-align="left">
								<xsl:value-of select="EMPRESA[@EMAIL = $selected]/@CIF"/>
						</fo:block>
					</fo:table-cell>
				</fo:table-row>
				<fo:table-row>
					<fo:table-cell>
						<fo:block font-size="9pt" 
							start-indent="10pt"		 
							font-family="sans-serif" 
							line-height="20pt"
							font-weight="bold"
							space-after.optimum="0pt"
							text-align="right">
								Correo:&#160;
						</fo:block>
					</fo:table-cell>
					<fo:table-cell>
						<fo:block font-size="9pt" 
							start-indent="10pt"		 
							font-family="sans-serif" 
							line-height="20pt"
							space-after.optimum="0pt"
							text-align="left">
								<xsl:value-of select="EMPRESA[@EMAIL = $selected]/@EMAIL"/>
						</fo:block>
					</fo:table-cell>
					<fo:table-cell>
						<fo:block font-size="9pt" 
							start-indent="10pt"		 
							font-family="sans-serif" 
							font-weight="bold"
							line-height="20pt"
							space-after.optimum="0pt"
							text-align="right">
								Telfono:&#160;
						</fo:block>
					</fo:table-cell>
					<fo:table-cell>
						<fo:block font-size="9pt" 
							start-indent="10pt"		 
							font-family="sans-serif" 
							line-height="20pt"
							space-after.optimum="0pt"
							text-align="left">
								<xsl:if test="count(EMPRESA[@EMAIL = $selected]/@TELEFONO1)!=0">
									<xsl:value-of select="EMPRESA[@EMAIL = $selected]/@TELEFONO1"/>
								</xsl:if>
								<xsl:if test="count(EMPRESA[@EMAIL = $selected]/@TELEFONO1)=0">
									-Sin introducir.-
								</xsl:if>
						</fo:block>
					</fo:table-cell>
				</fo:table-row>
			</fo:table-body>
		</fo:table>
		<fo:block text-align="center" font-size="16">&#160;</fo:block>
		<!--Tabla para los datos de red-->
		<fo:table border="0.25pt solid silver">
			<fo:table-column column-number="1" column-width="20mm"/>
			<fo:table-column column-number="2" column-width="40mm"/>
			<fo:table-column column-number="3" column-width="30mm"/>
			<fo:table-column column-number="4"/>
						
			<fo:table-header background-color="#000000">
				<fo:table-row>
					<fo:table-cell number-columns-spanned="6">
						<fo:block font-weight="bold" color="#FFFFFF" font-size="12pt">
							Tareas asociadas
						</fo:block>
					</fo:table-cell>
				</fo:table-row>
			</fo:table-header>
			<fo:table-body text-align="left" start-indent="3pt">
				<xsl:if test="count(TAREA)=0">
					<fo:table-row>
						<fo:table-cell>
							<fo:block font-size="9pt" 
								start-indent="10pt"		 
								font-family="sans-serif" 
								line-height="20pt"
								space-after.optimum="0pt"
								text-align="center">
								No hay tareas asociadas							
							</fo:block>
						</fo:table-cell>
					</fo:table-row>
				</xsl:if>
				<xsl:for-each select="TAREA">
					<xsl:if test="position()!=1">
						<fo:table-row>
							<fo:table-cell number-columns-spanned="6">
								<fo:block border-bottom="1pt solid #808080"/>
							</fo:table-cell>
						</fo:table-row>
					</xsl:if>
					<fo:table-row>
						<fo:table-cell>
							<fo:block font-size="9pt" 
								start-indent="10pt"		 
								font-family="sans-serif" 
								line-height="20pt"
								space-after.optimum="0pt"
								font-weight="bold"
								text-align="right">
								NTarea:&#160;
							</fo:block>
						</fo:table-cell>
						<fo:table-cell>
							<fo:block font-size="9pt" 
								start-indent="10pt"		 
								font-family="sans-serif" 
								line-height="20pt"
								space-after.optimum="0pt"
								text-align="left">
								<xsl:value-of select="TAREAS/@CODIGO"/>
							</fo:block>
						</fo:table-cell>
						<fo:table-cell>
							<fo:block font-size="9pt" 
								start-indent="10pt"		 
								font-family="sans-serif" 
								line-height="20pt"
								space-after.optimum="0pt"
								font-weight="bold"
								text-align="right">
								Aplicacion:&#160;
							</fo:block>
						</fo:table-cell>
						<fo:table-cell>
							<fo:block font-size="9pt" 
								start-indent="10pt"		 
								font-family="sans-serif" 
								line-height="20pt"
								space-after.optimum="0pt"
								text-align="left">
								<xsl:value-of select="TAREAS/@APLICACION"/>
							</fo:block>
						</fo:table-cell>
					</fo:table-row>
					<fo:table-row>
						<fo:table-cell>
							<fo:block font-size="9pt" 
								start-indent="10pt"		 
								font-family="sans-serif" 
								line-height="20pt"
								space-after.optimum="0pt"
								font-weight="bold"
								text-align="right">
								Usuario:&#160;
							</fo:block>
						</fo:table-cell>
						<fo:table-cell>
							<fo:block font-size="9pt" 
								start-indent="10pt"		 
								font-family="sans-serif" 
								line-height="20pt"
								space-after.optimum="0pt"
								text-align="left">
								<xsl:value-of select="TAREAS/@USUEMAIL"/>
							</fo:block>
						</fo:table-cell>
						<fo:table-cell>
							<fo:block font-size="9pt" 
								start-indent="10pt"		 
								font-family="sans-serif" 
								line-height="20pt"
								space-after.optimum="0pt"
								font-weight="bold"
								text-align="right">
								Informatico:&#160;
							</fo:block>
						</fo:table-cell>
						<fo:table-cell>
							<fo:block font-size="9pt" 
								start-indent="10pt"		 
								font-family="sans-serif" 
								line-height="20pt"
								space-after.optimum="0pt"
								text-align="left">
								<xsl:value-of select="TAREAS/@INFEMAIL"/>
							</fo:block>
						</fo:table-cell>
					</fo:table-row>
					
					<fo:table-row>
						<fo:table-cell>
							<fo:block font-size="9pt" 
								start-indent="10pt"		 
								font-family="sans-serif" 
								line-height="20pt"
								space-after.optimum="0pt"
								font-weight="bold"
								text-align="right">
								Estado:&#160;
							</fo:block>
						</fo:table-cell>
						<fo:table-cell>
							<fo:block font-size="9pt" 
								start-indent="10pt"		 
								font-family="sans-serif" 
								line-height="20pt"
								space-after.optimum="0pt"
								text-align="left">
								<fo:external-graphic src="C:/eclipse/workspace/Dumbov7/graficos/iconos/{@ESTADO}.gif" width="0.7cm" height="0.7cm"/>
							</fo:block>
						</fo:table-cell>
						<fo:table-cell>
							<fo:block font-size="9pt" 
								start-indent="10pt"		 
								font-family="sans-serif" 
								line-height="20pt"
								space-after.optimum="0pt"
								font-weight="bold"
								text-align="right">
								Asunto:
							</fo:block>
						</fo:table-cell>
						<fo:table-cell>
							<fo:block font-size="9pt" 
								start-indent="10pt"		 
								font-family="sans-serif" 
								line-height="20pt"
								space-after.optimum="0pt"
								text-align="left">
								<xsl:value-of select="TAREAS/@ASUNTO"/>
							</fo:block>
						</fo:table-cell>
					</fo:table-row>
				</xsl:for-each>
			</fo:table-body>
		</fo:table>
</xsl:template>

<xsl:template name="cuerpo"/>

</xsl:stylesheet>

