<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet version="1.0" 
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform">


<xsl:template name="detail">
	<xsl:param name="selected"/>
	<xsl:for-each select="DATA/EMPRESAS/EMPRESA[@EMAIL = $selected]">
		<!--Formulario para poder mostrar el detalle del informtico cuando se estn mostrando las tareas del usuario-->
		<form name="detalleUsr" action="{$servlet}" method="post">
			<input type="hidden" name="module" value="dumbo7/atencion.atender.detalleUser"/>
			<input type="hidden" name="user" value=""/>
		</form>
		<table class="cont" align="center" border="0" cellpadding="3" cellspacing="1" width="90%" summary="Esta tabla contiene el formulario para la creacin de la nueva empresa">
			<tr>
				<td class="cabe" align="left" colspan="4"><b>Datos de la empresa</b></td>
			</tr>
			<tr class="administracion">
				<td width="12%">Nombre&#160;(*):</td>
				<td colspan="3"><xsl:value-of select="@NOMBRE"/></td>
			</tr>
			<tr class="administracion">
				<td>CIF&#160;(*):</td>
				<td colspan="3"><xsl:value-of select="@CIF"/></td>
			</tr>
			<tr class="administracion">
				<td>Correo&#160;(*):</td>
				<td colspan="3"><xsl:value-of select="@EMAIL"/></td>
			</tr>
			<tr class="administracion">
				<td>Direccin:</td>
				<td colspan="3"><xsl:value-of select="@DIRECCION"/></td>
			</tr>
			<tr class="administracion">
				<td>Poblacin:</td>
				<td colspan="3"><xsl:value-of select="@POBLACION"/></td>
			</tr>
			<tr class="administracion">
				<td>Provincia:</td>
				<td colspan="3"><xsl:value-of select="@PROVINCIA"/></td>
			</tr>
			<tr class="administracion">
				<td>Cdigo postal:</td>
				<td colspan="3"><xsl:value-of select="@CODIGO_POSTAL"/></td>
			</tr>
			<tr class="cabe">
				<td colspan="4"><b>Datos de contacto</b></td>
			</tr>
			<tr class="administracion">
				<td>Contacto&#160;1:</td>
				<td width="46%"><xsl:value-of select="@CONTACTO1"/></td>
				<td width="10%">Telefono&#160;1:</td>
				<td><xsl:value-of select="@TELEFONO1"/></td>
			</tr>
			<tr class="administracion">
				<td>Contacto&#160;2:</td>
				<td><xsl:value-of select="@CONTACTO2"/></td>
				<td>Telefono&#160;2:</td>
				<td><xsl:value-of select="@TELEFONO2"/></td>
			</tr>
			<tr class="cabe">
				<td colspan="4"><b>Observaciones</b></td>
			</tr>
			<tr class="administracion">
				<td colspan="4" align="center"><TEXTAREA ROWS="8" COLS="150" NAME="empObservaciones" wrap="VIRTUAL" disabled="true"><xsl:value-of select="@OBSERVACIONES"/></TEXTAREA></td>
			</tr>
		</table>
	</xsl:for-each>
	<table class="cont" border="0" cellpadding="3" cellspacing="1" width="100%" summary="Informacin detallada">
		<tr class="cabe">
			<td colspan="9">
				<b>Tareas asociadas a la empresa</b>
			</td>
			<td>
				<a href="javascript:ConsultarHistorico();">
					<img id="historico" style="display:inline" border="0" src="../graficos/iconos/Tarhistorial_ico.gif" alt="Historial" title="Historial de Tareas"/>
				</a>
			</td>
		</tr>
		<tr class="administracion">
			<td><b>Estado</b></td>
			<td><b>Tarea</b></td>
			<td><b>Seccin</b></td>
			<td><b>Aplicacin</b></td>
			<td colspan="2"><b>Asunto</b></td>
			<td><b>Usuario</b></td>
			<td><b>Informtico</b></td>
			<td><b>Creada</b></td>
			<td><b>Prio</b></td>
		</tr>
		<xsl:for-each select="DATA/EMPRESAS/TAREA/TAREAS">
			<tr>
				<xsl:attribute name="class">
					<xsl:choose>
						<xsl:when test="@TIPO_TAREA='I'">incidencia</xsl:when>
						<xsl:when test="@TIPO_TAREA='P'">peticion</xsl:when>
					</xsl:choose>
				</xsl:attribute>
				<xsl:attribute name="onmouseover">
					<xsl:choose>
						<xsl:when test="@TIPO_TAREA='I'">javascript:onMouseInc(this,'true');</xsl:when>
						<xsl:when test="@TIPO_TAREA='P'">javascript:onMouse(this,'true');</xsl:when>
					</xsl:choose>
				</xsl:attribute>
				<xsl:attribute name="onmouseout">
					<xsl:choose>
						<xsl:when test="@TIPO_TAREA='I'">javascript:onMouseInc(this,'false');</xsl:when>
						<xsl:when test="@TIPO_TAREA='P'">javascript:onMouse(this,'false');</xsl:when>
					</xsl:choose>
				</xsl:attribute>
				<td>
					<img id="Estado" style="display:inline" border="0" src="../graficos/iconos/{@ESTADO}.gif" alt="Estado de Tarea">
						<xsl:attribute name="title"><xsl:choose><xsl:when test="@ESTADO='P'">Pendiente de Asignacin</xsl:when><xsl:when test="@ESTADO='A'">Asignada</xsl:when><xsl:when test="@ESTADO='W'">En Espera</xsl:when><xsl:when test="@ESTADO='X'">Rechazada</xsl:when><xsl:when test="@ESTADO='F'">Resuelta a la Espera de Subtareas</xsl:when></xsl:choose></xsl:attribute>
					</img>	
				</td>
				<td><xsl:value-of select="@CODIGO"/></td>
				<td><xsl:value-of select="../APLICACIONES/@SECCION"/></td>
				<td><xsl:value-of select="@APLICACION"/></td>
				<td colspan="2" title="DESCRIPCIN: {@DESCRIPCION}"><xsl:value-of select="@ASUNTO"/></td>
				<td>
					<a href="javascript:detalleUser('{@USUEMAIL}');">
						<xsl:value-of select="@USUEMAIL"/>
					</a>
				</td>
				<td>
					<xsl:choose>
						<xsl:when test="not(@INFORMATICO) and not(@APLICACION)">
							<i>En cola Global</i>
						</xsl:when>
						<xsl:when test="not(@INFORMATICO) and @APLICACION">
							<i>En cola de Aplicaciones</i>
						</xsl:when>
						<xsl:otherwise>
							<a href="javascript:detalleUser('{@INFEMAIL}');">
								<xsl:value-of select="@INFEMAIL"/>
							</a>
						</xsl:otherwise>
					</xsl:choose>
				</td>
				<td>
					<xsl:call-template name="date2String2">
						<xsl:with-param name="fecha" select="@FECHA_CREACION"/>
					</xsl:call-template>
				</td>
				<td align="center">
					<xsl:attribute name="title">
						<xsl:choose>
							<xsl:when test="@PRIORIDAD='C'">Crtica</xsl:when>
							<xsl:when test="@PRIORIDAD='A'">Alta</xsl:when>
							<xsl:when test="@PRIORIDAD='M'">Media</xsl:when>
							<xsl:when test="@PRIORIDAD='B'">Baja</xsl:when>
							<xsl:when test="@PRIORIDAD='P'">Planificada (<xsl:call-template name="date2String2"><xsl:with-param name="fecha" select="@PLANIFICACION"/></xsl:call-template>)</xsl:when>
						</xsl:choose>
					</xsl:attribute>
					<xsl:value-of select="@PRIORIDAD"/>
				</td>
			</tr>
		</xsl:for-each>
	</table>
</xsl:template>

</xsl:stylesheet>



