<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet version="1.0" 
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:xforms="http://www.w3.org/2002/xforms">
	
<xsl:param name="servlet"/>	
<xsl:param name="selected"/>	
<xsl:param name="menu"/>	

<xsl:include href="dumbo7/utils/xsl/utils.xsl"/>

<xsl:template match="XMLROOT">
	<HTML>
	  <HEAD>
		 <TITLE>DUMBO7:&#160;Historico&#160;de&#160;tareas</TITLE>
		<link REL="stylesheet" HREF="../estilosD.css" TYPE="text/css"/>
		<SCRIPT LANGUAGE="JavaScript">
			function detalleUser(usr) {
				var w = window.open('about:blank','UserDetail','width=400,height=250,left=100,top=100,scrollbars=yes');
				document.detalleUsr.target = w.name;
				document.detalleUsr.user.value = usr;
				document.detalleUsr.submit();
			}	
		</SCRIPT>
		<script LANGUAJE="JavaScript" src="../js/OnMouse.js"></script>
	  </HEAD>
	<body>
	<br/>
		<!--Formulario para poder mostrar el detalle del informtico cuando se estn mostrando las tareas del usuario-->
		<form name="detalleUsr" action="{$servlet}" method="post">
			<input type="hidden" name="module" value="dumbo7/atencion.atender.detalleUser"/>
			<input type="hidden" name="user" value=""/>
		</form>
		<table class="cont" id="red" border="0" cellpadding="3" cellspacing="1">
			<tr class="cabe">
				<td colspan="10">
					<b>Historico de Tareas asociadas al usuario <xsl:value-of select="DATA/EMPRESAS/TAREA/TAREAS/@USUEMAIL"/></b>
				</td>
			</tr>
			<tr class="administracion">
				<td><b>Estado</b></td>
				<td><b>Tarea</b></td>
				<td><b>Seccin</b></td>
				<td><b>Aplicacin</b></td>
				<td colspan="2"><b>Asunto</b></td>
				<td><b>Usuario</b></td>
				<td><b>Informtico</b></td>
				<td><b>Creada</b></td>
				<td><b>Prio</b></td>
			</tr>
			<xsl:for-each select="DATA/EMPRESAS/TAREA/TAREAS">
				<tr>
					<xsl:attribute name="class">
						<xsl:choose>
							<xsl:when test="@TIPO_TAREA='I'">incidencia</xsl:when>
							<xsl:when test="@TIPO_TAREA='P'">peticion</xsl:when>
						</xsl:choose>
					</xsl:attribute>
					<xsl:attribute name="onmouseover">
						<xsl:choose>
							<xsl:when test="@TIPO_TAREA='I'">javascript:onMouseInc(this,'true');</xsl:when>
							<xsl:when test="@TIPO_TAREA='P'">javascript:onMouse(this,'true');</xsl:when>
						</xsl:choose>
					</xsl:attribute>
					<xsl:attribute name="onmouseout">
						<xsl:choose>
							<xsl:when test="@TIPO_TAREA='I'">javascript:onMouseInc(this,'false');</xsl:when>
							<xsl:when test="@TIPO_TAREA='P'">javascript:onMouse(this,'false');</xsl:when>
						</xsl:choose>
					</xsl:attribute>
					<td>
						<img id="Estado" style="display:inline" border="0" src="../graficos/iconos/{@ESTADO}.gif" alt="Estado de Tarea">
							<xsl:attribute name="title"><xsl:choose><xsl:when test="@ESTADO='R'">Finalizada</xsl:when><xsl:when test="@ESTADO='N'">Anulada</xsl:when><xsl:when test="@ESTADO='X'">Rechazada</xsl:when><xsl:when test="@ESTADO='X'">Rechazada</xsl:when><xsl:when test="@ESTADO='F'">Resuelta a la Espera de Subtareas</xsl:when></xsl:choose></xsl:attribute>
						</img>	
					</td>
					<td><xsl:value-of select="@CODIGO"/></td>
					<td><xsl:value-of select="../APLICACIONES/@SECCION"/></td>
					<td><xsl:value-of select="@APLICACION"/></td>
					<td colspan="2" title="DESCRIPCIN: {@DESCRIPCION}    &#xd;SEGUIMIENTO: {@DESCRIPCION_SEGUIMIENTO}"><xsl:value-of select="@ASUNTO"/></td>
					<td>
						<a href="javascript:detalleUser('{@USUEMAIL}');">
							<xsl:value-of select="@USUEMAIL"/>
						</a>
					</td>
					<td>
						<a href="javascript:detalleUser('{@INFEMAIL}');">
							<xsl:value-of select="@INFEMAIL"/>
						</a>
					</td>
					<td>
						<xsl:call-template name="date2String2">
							<xsl:with-param name="fecha" select="@FECHA_CREACION"/>
						</xsl:call-template>
					</td>
					<td align="center">
						<xsl:attribute name="title">
							<xsl:choose>
								<xsl:when test="@PRIORIDAD='C'">Crtica</xsl:when>
								<xsl:when test="@PRIORIDAD='A'">Alta</xsl:when>
								<xsl:when test="@PRIORIDAD='M'">Media</xsl:when>
								<xsl:when test="@PRIORIDAD='B'">Baja</xsl:when>
								<xsl:when test="@PRIORIDAD='P'">Planificada (<xsl:call-template name="date2String2"><xsl:with-param name="fecha" select="@PLANIFICACION"/></xsl:call-template>)</xsl:when>
							</xsl:choose>
						</xsl:attribute>
						<xsl:value-of select="@PRIORIDAD"/>
					</td>
				</tr>
			</xsl:for-each>
				
		</table>
		<table border="0" cellpadding="3" cellspacing="1">
			<tr>
				<td align="center">
					<img id="incidencia" style="display:inline" border="0" src="../graficos/color_incidencia.gif" alt="Incidencia"/>
					<img id="incidencia" style="display:inline" border="0" src="../graficos/color_peticion.gif" alt="Peticion"/>
				</td>	
				<td align="center" width="400">
					<input type="button" class="boton" value="Cerrar" onclick="javascript:window.close();"/>
				</td>
			</tr>
		</table>
	</body>
	</HTML>
</xsl:template>
<xsl:template name="cuerpo"/>
</xsl:stylesheet>
	