<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet version="1.0" 
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:xforms="http://www.w3.org/2002/xforms">

<xsl:output method="html"/>

<xsl:param name="servlet"/>	
<xsl:param name="menu"/>
<xsl:param name="selected"/>
<xsl:param name="ajx"/>

<xsl:include href="dumbo7/utils/xsl/utils.xsl"/>
<xsl:include href="dumbo7/gestion/empresas/html/detalleEmpresa.xsl"/>

<xsl:template match="XMLROOT">
		<html lang="es">
			<xsl:call-template name="headComun">
				<xsl:with-param name="calendar" select="true()"/>
				<xsl:with-param name="ERROR" select="DATA/EMPRESAS/@ERROR"/>
				 <xsl:with-param name="jscript">
					<script LANGUAJE="JavaScript">
						function mostrarError(error){
							alert(error);
						}
						
						<!--Javascript para PDF-->
						function abre_PDF(url){
							url = url.concat("&amp;selected=");
							url = url.concat('<xsl:value-of select="$selected"/>');
							newWindow = window.open(url,'_blanck');
						}
						
						<!--Para mostrar el detalle de usuario-->
						function detalleUser(usr) {
							var w = window.open('about:blank','UserDetail','width=400,height=250,left=100,top=100,scrollbars=yes');
							document.detalleUsr.target = w.name;
							document.detalleUsr.user.value = usr;
							document.detalleUsr.submit();
						}
						
						<!--Funcin que se ejecuta al cambiar de empresa en el select-->
						function seleccionaEmpresa(){
							document.GestionEmpresas.ajx.value = 1;
							var sel = document.GestionEmpresas.empresas;
							document.GestionEmpresas.selected.value = sel.options[sel.selectedIndex].value;
							document.GestionEmpresas.submit();
						}
						
						<!--Muestra una pantalla con el historico de tareas asociadas a una empresa-->
						function ConsultarHistorico(){
							var url = '?module=dumbo7/gestion/empresas.index.HistoricoTareas';
							url = url.concat("&amp;selected=");
							url = url.concat('<xsl:value-of select="$selected"/>');
							newWindow = window.open(url,'_blanck',"width=750,height=400,left=100,top=100,status=no,toolbar=no,menubar=no,location=no,scrollbars=yes");
						}
						
					</script>
				<script LANGUAJE="JavaScript" src="../js/OnMouse.js"></script>
				<script LANGUAJE="JavaScript" src="../js/usuarios/Calendario.js"></script>
				<script LANGUAJE="JavaScript" src="../js/CompruebaFecha.js"></script>
				</xsl:with-param>
			 </xsl:call-template>
			
			<body>
				<xsl:call-template name="menuComun">
					<xsl:with-param name="NAME" select="concat(DATA/EMPRESAS/USER/@NAME,concat('(',concat(DATA/EMPRESAS/USER/@LOGIN,')')))"/>
					<xsl:with-param name="MENU" select="DATA/MENU"/>
					<xsl:with-param name="SELECT" select="$menu"/>
				</xsl:call-template>
				
				<xsl:call-template name="pieComun"/>
			</body>
		</html>
</xsl:template>

<xsl:template name="cuerpo">
		<xsl:for-each select="DATA/DATOS_USUARIOS">
			<xsl:if test="not(@ERROR='')">
				<script>mostrarError('<xsl:value-of select="@ERROR"/>')</script>
				</xsl:if>
		</xsl:for-each>
	<table border="0" cellpadding="5" align="center" cellspacing="5" width="780" summary="Esta tabla contiene la gestion de empresas">
	<tr>
		<td width="650" class="cab1">&#187;Gestin Empresas</td>
		<xsl:if test="$ajx = 1">
			<td width="10" align="center"><b><a href="javascript:abre_PDF('?module=dumbo7/gestion/empresas.index.informePDF');"><img border="0" src="../graficos/iconos/ico_impresora.gif" alt="Imprimir"/></a></b></td>
		</xsl:if>
	</tr>
	<tr><td colspan="2">
		<form action="{$servlet}" METHOD="POST" name="GestionEmpresas">
			<input type="hidden" name="module" value="dumbo7/gestion/empresas.index"/>
			<input type="hidden" name="selected" value="{$selected}"/>
			<input type="hidden" name="ajx"/>
			<table class="cont" id="empresas" border="0" cellpadding="3" cellspacing="1" width="100%" summary="Esta tabla contiene empresas">
				<tr class="administracion">
					<td colspan="2">
						Empresas:&#160;&#160;
						<select name="empresas" id="emp" onChange="javascript:seleccionaEmpresa();">
							<option value="">&lt;-- Seleccione una Empresa --></option>
							<xsl:for-each select="DATA/EMPRESAS/EMPRESA">
								<option value="{@EMAIL}"><xsl:value-of select="@NOMBRE"/></option>
							</xsl:for-each>
						</select>
					</td>
				</tr>
				<tr class="administracion">
					<td colspan="2">&#160;</td>
				</tr>		
			</table>
		</form>
		<xsl:if test="$ajx = '1'">
			<xsl:call-template name="detail">
				<xsl:with-param name="selected" select="$selected"/>
			</xsl:call-template>
		</xsl:if>
	</td></tr>
	</table>
	
</xsl:template>

</xsl:stylesheet>