<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet version="1.0" 
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:xforms="http://www.w3.org/2002/xforms">
	
<xsl:param name="servlet"/>	
<xsl:param name="menu"/>
<xsl:param name="selected"/>
<xsl:param name="separator" select="'|'"/>

<xsl:key name="aplPorGrupos" match="APLICACION" use="@PADRE"/>

<xsl:include href="dumbo7/utils/xsl/utils.xsl"/>
<xsl:include href="atica/frameweb/xml/templates/paginable.xsl"/>

<xsl:template match="XMLROOT">

<html lang="es">

	<xsl:call-template name="headComun">
		<xsl:with-param name="arbol" select="true()"/>
		<xsl:with-param name="calendar" select="true()"/>
		<xsl:with-param name="jscript">
			<SCRIPT LANGUAGE="JavaScript">
				function verInformaticos(cod,sec) {
					document.verinfo.aplcod.value = cod;
					document.verinfo.aplname.value = sec;
					document.verinfo.submit();
				}
				function gestiona(cod,apl) {
					document.gest.aplname.value = cod+'<xsl:value-of select="$separator"/>'+apl;
					document.gest.submit();
				}
			</SCRIPT>
		</xsl:with-param>
	</xsl:call-template>

<body>
<xsl:call-template name="menuComun">
	<xsl:with-param name="HELP" select="'gestion.xml#1.4.2'"/>
	<xsl:with-param name="MENU" select="DATA/MENU"/>
	<xsl:with-param name="SELECT" select="$menu"/>
	<xsl:with-param name="NAME" select="concat(DATA/GESTION/USER/@NAME,concat(' (',concat(DATA/GESTION/USER/@LOGIN,')')))"/>
</xsl:call-template>
<xsl:call-template name="pieComun"/>
</body>
</html>
</xsl:template>

<xsl:template name="cuerpo">
<form name="gest" action="{$servlet}" method="post">
	<input type="hidden" name="module" value="dumbo7/gestion/dumbos.listAtender"/>
	<input type="hidden" name="aplname" value=""/>
</form>
<form name="verinfo" action="{$servlet}" method="post">
	<input type="hidden" name="module" value="dumbo7/gestion.aplicaciones.informaticos"/>
	<input type="hidden" name="aplcod" value=""/>
	<input type="hidden" name="aplname" value=""/>
</form>
<br/>
<form name="f1" action="{$servlet}" method="post">
<input type="hidden" name="module" value="dumbo7/gestion.suplantaUser"/>
<input type="hidden" name="menu" value=""/>
<table class="contout">
<tr class="peticion">
	<td colspan="2"><strong>Gestin Global de Dumbos Por Aplicaciones</strong></td>
</tr>
<tr>
	<td colspan="2">
		<table cellpadding="0" cellspacing="0">
			<xsl:call-template name="sacaAplicacion">
				<xsl:with-param name="aplicaciones" select="DATA/GESTION"/>
			</xsl:call-template>
		</table>
	</td>
</tr>
</table>
</form>
</xsl:template>

<xsl:template name="sacaAplicacion">
<xsl:param name="aplicaciones"/>
	<xsl:choose>
		<xsl:when test="count(/XMLROOT/DATA/SECURITY/ACTION[@NAME='suplantarACualquiera'])>0">
			<tr><td colspan="3"><b>MAESTRO: GESTIONA DE CUALQUIER APLICACIN</b></td></tr>
			<tr><td colspan="3">&#160;</td></tr>
			<xsl:for-each select="$aplicaciones/*[(@ESTADO='V') and not(@PADRE)]">
				<xsl:sort select="@DESCRIPCION"/>
				<xsl:variable name="aplcod" select="@CODIGO"/>
				<xsl:variable name="posic" select="position()"/>
				<xsl:choose>
					<xsl:when test="count(key('aplPorGrupos',$aplcod))>0">
						<xsl:if test="@ESTADO='V'">
						<tr id="arb.{position()}" class="switchcontent">
							<td><img id="img.arb.{position()}" src="../dumbo7/utils/table/minus.gif" class="showstate" onClick="expandcontent(this, 'arb.{position()}');"/></td>
							<td>&#160;<b><xsl:value-of select="@DESCRIPCION"/></b></td>
							<td>&#160;<a href="javascript:verInformaticos('{@CODIGO}','{@DESCRIPCION}');"><xsl:call-template name="traduce"><xsl:with-param name="id" select="'Informaticos'"/></xsl:call-template></a></td>
						</tr>
						<xsl:for-each select="key('aplPorGrupos',$aplcod)">
						<xsl:sort select="@DESCRIPCION"/>
							<xsl:variable name="aplcod" select="@CODIGO"/>
							<xsl:variable name="seccod" select="@SECCION"/>
							<tr id="arb.{$posic}.{position()}">
								<td style="padding-left: 1cm;" colspan="2">&#160;<a href="javascript:gestiona('{@CODIGO}','{@DESCRIPCION}');"><xsl:value-of select="@DESCRIPCION"/></a></td>
								<td>&#160;<a href="javascript:verInformaticos('{@CODIGO}','{@DESCRIPCION}');"><xsl:call-template name="traduce"><xsl:with-param name="id" select="'Informaticos'"/></xsl:call-template></a></td>
							</tr>
						</xsl:for-each>
						</xsl:if>
					</xsl:when>
					<xsl:otherwise>
						<tr>
							<td colspan="2">&#160;<a href="javascript:gestiona('{@CODIGO}','{@DESCRIPCION}');"><xsl:value-of select="@DESCRIPCION"/></a></td>
							<td>&#160;<a href="javascript:verInformaticos('{@CODIGO}','{@DESCRIPCION}');"><xsl:call-template name="traduce"><xsl:with-param name="id" select="'Informaticos'"/></xsl:call-template></a></td>
						</tr>
					</xsl:otherwise>
				</xsl:choose>
				<tr><td colspan="3">&#160;</td></tr>
			</xsl:for-each>
		</xsl:when>
		<xsl:otherwise>
			<tr><td colspan="3"><b>APLICACIONES DE LAS QUE ES RESPONSABLE</b></td></tr>
			<tr><td colspan="3">&#160;</td></tr>
			<xsl:for-each select="$aplicaciones/APLICACION[(@ESTADO='V')]">
				<xsl:sort select="@DESCRIPCION"/>
				<xsl:variable name="aplcod" select="@CODIGO"/>
				<xsl:variable name="posic" select="position()"/>
				<xsl:variable name="padre" select="@PADRE"/>
				<xsl:variable name="isRespPadre" select="count(../INFORMATICOAPL[@APLICACION=$padre and @INFORMATICO=/XMLROOT/DATA/GESTION/USER/@ID and @RESPONSABLE='Y'])"/>
				<xsl:if test="count(../INFORMATICOAPL[@APLICACION=$aplcod and @INFORMATICO=/XMLROOT/DATA/GESTION/USER/@ID and @RESPONSABLE='Y'])>0 and $isRespPadre=0">
				<xsl:choose>
					<xsl:when test="count(key('aplPorGrupos',$aplcod))>0">
						<xsl:if test="@ESTADO='V'">
						<tr id="arb1.{position()}" class="switchcontent">
							<td><img id="img.arb1.{position()}" src="../dumbo7/utils/table/minus.gif" class="showstate" onClick="expandcontent(this, 'arb1.{position()}');"/></td>
							<td>&#160;<b><xsl:value-of select="@DESCRIPCION"/></b></td>
							<td>&#160;<a href="javascript:verInformaticos('{@CODIGO}','{@DESCRIPCION}');"><xsl:call-template name="traduce"><xsl:with-param name="id" select="'Informaticos'"/></xsl:call-template></a></td>
						</tr>
						<xsl:for-each select="key('aplPorGrupos',$aplcod)">
						<xsl:sort select="@DESCRIPCION"/>
							<xsl:variable name="aplcod" select="@CODIGO"/>
							<xsl:variable name="seccod" select="@SECCION"/>
							<tr id="arb1.{$posic}.{position()}">
								<td style="padding-left: 1cm;" colspan="2">&#160;<a href="javascript:gestiona('{@CODIGO}','{@DESCRIPCION}');"><xsl:value-of select="@DESCRIPCION"/></a></td>
								<td>&#160;<a href="javascript:verInformaticos('{@CODIGO}','{@DESCRIPCION}');"><xsl:call-template name="traduce"><xsl:with-param name="id" select="'Informaticos'"/></xsl:call-template></a></td>
							</tr>
						</xsl:for-each>
						</xsl:if>
					</xsl:when>
					<xsl:otherwise>
						<tr>
							<td colspan="2">&#160;<a href="javascript:gestiona('{@CODIGO}','{@DESCRIPCION}');"><xsl:value-of select="@DESCRIPCION"/></a></td>
							<td>&#160;<a href="javascript:verInformaticos('{@CODIGO}','{@DESCRIPCION}');"><xsl:call-template name="traduce"><xsl:with-param name="id" select="'Informaticos'"/></xsl:call-template></a></td>
						</tr>
					</xsl:otherwise>
				</xsl:choose>
				<tr><td colspan="3">&#160;</td></tr>
				</xsl:if>
			</xsl:for-each>
			<tr><td colspan="3"><b>APLICACIONES QUE PERTENECEN A SECCIONES DE LAS QUE ES RESPONSABLE</b></td></tr>
			<tr><td colspan="3">&#160;</td></tr>
			<xsl:for-each select="$aplicaciones/APLICACION[(@ESTADO='V') and not(@PADRE)]">
				<xsl:sort select="@DESCRIPCION"/>
				<xsl:variable name="aplcod" select="@CODIGO"/>
				<xsl:variable name="seccod" select="@SECCION"/>
				<xsl:variable name="aplicacion" select="."/>
				<xsl:for-each select="../SECCION[@RESPONSABLE=/XMLROOT/DATA/GESTION/USER/@ID]">
					<xsl:call-template name="subSeccion">
						<xsl:with-param name="aplicacion" select="$aplicacion"/>
					</xsl:call-template>
				</xsl:for-each>
			</xsl:for-each>
		</xsl:otherwise>
	</xsl:choose>
</xsl:template>

<xsl:template name="subSeccion">
<xsl:param name="aplicacion"/>
	<xsl:choose>
	<xsl:when test="@CODIGO=$aplicacion/@SECCION">
		<xsl:variable name="posic" select="position()"/>
		<xsl:choose>
			<xsl:when test="count(key('aplPorGrupos',$aplicacion/@CODIGO))>0">
				<xsl:if test="@ESTADO='V'">
				<tr id="arb2.{position()}" class="switchcontent">
					<td><img id="img.arb2.{position()}" src="../dumbo7/utils/table/minus.gif" class="showstate" onClick="expandcontent(this, 'arb2.{position()}');"/></td>
					<td>&#160;<b><xsl:value-of select="$aplicacion/@DESCRIPCION"/></b></td>
					<td>&#160;<a href="javascript:verInformaticos('{$aplicacion/@CODIGO}','{$aplicacion/@DESCRIPCION}');"><xsl:call-template name="traduce"><xsl:with-param name="id" select="'Informaticos'"/></xsl:call-template></a></td>
				</tr>
				<xsl:for-each select="key('aplPorGrupos',$aplicacion/@CODIGO)">
				<xsl:sort select="@DESCRIPCION"/>
					<xsl:variable name="aplcod" select="@CODIGO"/>
					<xsl:variable name="seccod" select="@SECCION"/>
					<tr id="arb2.{$posic}.{position()}">
						<td style="padding-left: 1cm;" colspan="2">&#160;<a href="javascript:gestiona('{@CODIGO}','{@DESCRIPCION}');"><xsl:value-of select="@DESCRIPCION"/></a></td>
						<td>&#160;<a href="javascript:verInformaticos('{@CODIGO}','{@DESCRIPCION}');"><xsl:call-template name="traduce"><xsl:with-param name="id" select="'Informaticos'"/></xsl:call-template></a></td>
					</tr>
				</xsl:for-each>
				</xsl:if>
			</xsl:when>
			<xsl:otherwise>
				<tr>
					<td colspan="2">&#160;<a href="javascript:gestiona('{$aplicacion/@CODIGO}','{$aplicacion/@DESCRIPCION}');"><xsl:value-of select="$aplicacion/@DESCRIPCION"/></a></td>
					<td>&#160;<a href="javascript:verInformaticos('{$aplicacion/@CODIGO}','{$aplicacion/@DESCRIPCION}');"><xsl:call-template name="traduce"><xsl:with-param name="id" select="'Informaticos'"/></xsl:call-template></a></td>
				</tr>
			</xsl:otherwise>
		</xsl:choose>
		<tr><td colspan="3">&#160;</td></tr>
	</xsl:when>
	<xsl:otherwise>
		<xsl:variable name="code" select="@CODIGO"/>
		<xsl:for-each select="../SECCION[@PADRE=$code and not(@CODIGO=$code)]">
			<xsl:call-template name="subSeccion">
				<xsl:with-param name="aplicacion" select="$aplicacion"/>
			</xsl:call-template>
		</xsl:for-each>
	</xsl:otherwise>
	</xsl:choose>
</xsl:template>

</xsl:stylesheet>
