<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet version="1.0" 
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:xforms="http://www.w3.org/2002/xforms">
	
<xsl:param name="servlet"/>	
<xsl:param name="menu"/>
<xsl:param name="secname"/>
<xsl:param name="separator" select="'|'"/>

<xsl:key name="aplPorGrupos" match="APLICACION" use="@PADRE"/>

<xsl:include href="dumbo7/utils/xsl/utils.xsl"/>
<xsl:include href="atica/frameweb/xml/templates/paginable.xsl"/>

<xsl:template match="XMLROOT">

<html lang="es">

	<xsl:call-template name="headComun">
		<xsl:with-param name="arbol" select="true()"/>
		<xsl:with-param name="calendar" select="true()"/>
		<xsl:with-param name="jscript">
			<SCRIPT LANGUAGE="JavaScript">
				function gestiona(cod,apl) {
					document.gest.aplname.value = cod+'<xsl:value-of select="$separator"/>'+apl;
					document.gest.submit();
				}
				function verInformaticos(cod,sec) {
					document.verinfo.aplcod.value = cod;
					document.verinfo.aplname.value = sec;
					document.verinfo.submit();
				}
			</SCRIPT>
		</xsl:with-param>
	</xsl:call-template>

<body>
<xsl:call-template name="menuComun">
	<xsl:with-param name="HELP" select="'gestion.xml#1.4.1'"/>
	<xsl:with-param name="MENU" select="DATA/MENU"/>
	<xsl:with-param name="SELECT" select="$menu"/>
	<xsl:with-param name="NAME" select="concat(DATA/GESTION/USER/@NAME,concat(' (',concat(DATA/GESTION/USER/@LOGIN,')')))"/>
</xsl:call-template>
<xsl:call-template name="pieComun"/>
</body>
</html>
</xsl:template>

<xsl:template name="cuerpo">
<form name="gest" action="{$servlet}" method="post">
	<input type="hidden" name="module" value="dumbo7/gestion/dumbos.listAtender"/>
	<input type="hidden" name="aplname" value=""/>
</form>
<form name="verinfo" action="{$servlet}" method="post">
	<input type="hidden" name="module" value="dumbo7/gestion.aplicaciones.informaticos"/>
	<input type="hidden" name="aplcod" value=""/>
	<input type="hidden" name="aplname" value=""/>
</form>
<br/>
<form name="f1" action="{$servlet}" method="post">
<input type="hidden" name="module" value="dumbo7/gestion.suplantaUser"/>
<input type="hidden" name="menu" value=""/>
<table class="contout">
<tr class="peticion">
	<td colspan="2"><strong>Gestin Global: Aplicaciones de Seccin</strong></td>
</tr>
<tr>
	<td colspan="2">
		<table cellpadding="0" cellspacing="0">
		<tr><td colspan="3"><b>APLICACIONES SECCIN:</b>&#160;<xsl:value-of select="$secname"/></td></tr>
		<tr><td colspan="3">&#160;</td></tr>
		<xsl:for-each select="DATA/GESTION/APLICACION">
			<xsl:sort select="@DESCRIPCION"/>
			<xsl:variable name="posic" select="position()"/>
			<xsl:choose>
				<xsl:when test="count(key('aplPorGrupos',@CODIGO))>0">
					<xsl:if test="@ESTADO='V'">
					<tr id="arb.{position()}" class="switchcontent">
						<td><img id="img.arb.{position()}" src="../dumbo7/utils/table/minus.gif" class="showstate" onClick="expandcontent(this, 'arb.{position()}');"/></td>
						<td>&#160;<b><xsl:value-of select="@DESCRIPCION"/></b></td>
						<td>&#160;<a href="javascript:verInformaticos('{@CODIGO}','{@DESCRIPCION}');"><xsl:call-template name="traduce"><xsl:with-param name="id" select="'Informaticos'"/></xsl:call-template></a></td>
					</tr>
					<xsl:for-each select="key('aplPorGrupos',@CODIGO)">
					<xsl:sort select="@DESCRIPCION"/>
						<xsl:variable name="aplcod" select="@CODIGO"/>
						<xsl:variable name="seccod" select="@SECCION"/>
						<tr id="arb.{$posic}.{position()}">
							<td style="padding-left: 1cm;" colspan="2">&#160;<a href="javascript:gestiona('{@CODIGO}','{@DESCRIPCION}');"><xsl:value-of select="@DESCRIPCION"/></a></td>
							<td>&#160;<a href="javascript:verInformaticos('{@CODIGO}','{@DESCRIPCION}');"><xsl:call-template name="traduce"><xsl:with-param name="id" select="'Informaticos'"/></xsl:call-template></a></td>
						</tr>
					</xsl:for-each>
					</xsl:if>
				</xsl:when>
				<xsl:otherwise>
					<tr>
						<td colspan="2">&#160;<a href="javascript:gestiona('{@CODIGO}','{@DESCRIPCION}');"><xsl:value-of select="@DESCRIPCION"/></a></td>
						<td>&#160;<a href="javascript:verInformaticos('{@CODIGO}','{@DESCRIPCION}');"><xsl:call-template name="traduce"><xsl:with-param name="id" select="'Informaticos'"/></xsl:call-template></a></td>
					</tr>
				</xsl:otherwise>
			</xsl:choose>
			<tr><td colspan="3">&#160;</td></tr>
		</xsl:for-each>
		</table>
	</td>
</tr>
</table>
</form>
</xsl:template>

</xsl:stylesheet>
