<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet version="1.0" 
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:xforms="http://www.w3.org/2002/xforms">
	
<xsl:param name="servlet"/>	
<xsl:param name="menu"/>
<xsl:param name="secname"/>
<xsl:param name="separator" select="'|'"/>

<xsl:key name="infDistintos" match="value" use="IDENTIFICADOR"/>

<xsl:include href="dumbo7/utils/xsl/utils.xsl"/>
<xsl:include href="atica/frameweb/xml/templates/paginable.xsl"/>

<xsl:template match="XMLROOT">

<html lang="es">

	<xsl:call-template name="headComun">
		<xsl:with-param name="calendar" select="true()"/>
		<xsl:with-param name="jscript">
			<SCRIPT LANGUAGE="JavaScript">
				function gestiona(cod,inf) {
					document.gest.infname.value = cod+'<xsl:value-of select="$separator"/>'+inf;
					document.gest.submit();
				}
			</SCRIPT>
		</xsl:with-param>
	</xsl:call-template>

<body>
<xsl:call-template name="menuComun">
	<xsl:with-param name="HELP" select="'gestion.xml#1.4.3'"/>
	<xsl:with-param name="MENU" select="DATA/MENU"/>
	<xsl:with-param name="SELECT" select="$menu"/>
	<xsl:with-param name="NAME" select="concat(DATA/GESTION/USER/@NAME,concat(' (',concat(DATA/GESTION/USER/@LOGIN,')')))"/>
</xsl:call-template>
<xsl:call-template name="pieComun"/>
</body>
</html>
</xsl:template>

<xsl:template name="cuerpo">
<form name="gest" action="{$servlet}" method="post">
	<input type="hidden" name="module" value="dumbo7/gestion/dumbos.listAtender"/>
	<input type="hidden" name="infname" value=""/>
</form>
<br/>
<form name="f1" action="{$servlet}" method="post">
<input type="hidden" name="module" value="dumbo7/gestion.suplantaUser"/>
<input type="hidden" name="menu" value=""/>
<table class="contout">
<tr class="peticion">
	<td colspan="2"><strong>Gestin Global: <xsl:call-template name="traduce"><xsl:with-param name="id" select="'Informaticos'"/></xsl:call-template>&#160;de Seccin</strong></td>
</tr>
<tr>
	<td colspan="2">
		<table cellpadding="0" cellspacing="0">
		<tr><td colspan="3"><b><xsl:call-template name="traduce"><xsl:with-param name="id" select="'INFORMATICOS'"/></xsl:call-template>&#160;SECCIN:</b>&#160;<xsl:value-of select="$secname"/></td></tr>
		<tr><td colspan="3">&#160;</td></tr>
			<xsl:for-each select="DATA/GESTION/INFORMSEC">
				<xsl:sort select="key"/>
				<xsl:if test="count(./value)>0">
					<tr><td colspan="3">SECCIN:<xsl:value-of select="./key"/></td></tr>
					<xsl:variable name="scod" select="substring-after(substring-before(./key,']'),'[')"/>
					<xsl:for-each select="./value[(generate-id() = generate-id(key('infDistintos',IDENTIFICADOR)[1]))]">
						<xsl:sort select="./APELLIDOS"/>
						<xsl:choose>
							<xsl:when test="/XMLROOT/DATA/GESTION/USER/@ID=./IDENTIFICADOR">
							<tr>
								<td>&#160;</td>
								<td>&#160;<xsl:value-of select="./EMAIL"/></td>
								<td>&#160;<xsl:value-of select="APELLIDOS"/>, <xsl:value-of select="NOMBRE"/>
									<xsl:if test="count(./RESP[.=$scod])>0">
										(Responsable)
									</xsl:if>
								</td>
							</tr>
							</xsl:when>
							<xsl:otherwise>
							<tr>
								<td>&#160;</td>
								<td>&#160;<a href="javascript:gestiona('{./IDENTIFICADOR}','{./EMAIL}');"><xsl:value-of select="./EMAIL"/></a></td>
								<td>&#160;<a href="javascript:gestiona('{./IDENTIFICADOR}','{./EMAIL}');"><xsl:value-of select="APELLIDOS"/>, <xsl:value-of select="NOMBRE"/></a>
									<xsl:if test="count(./RESP[.=$scod])>0">
										(Responsable)
									</xsl:if>
								</td>
							</tr>
							</xsl:otherwise>
						</xsl:choose>
					</xsl:for-each>
					<tr><td colspan="3">&#160;</td></tr>
				</xsl:if>
			</xsl:for-each>
		</table>
	</td>
</tr>
</table>
</form>
</xsl:template>

</xsl:stylesheet>
