<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet version="1.0" 
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:xforms="http://www.w3.org/2002/xforms">
	
<xsl:param name="servlet"/>	
<xsl:param name="menu"/>
<xsl:param name="selected"/>
<xsl:param name="separator" select="'|'"/>

<xsl:include href="dumbo7/utils/xsl/utils.xsl"/>
<xsl:include href="atica/frameweb/xml/templates/paginable.xsl"/>

<xsl:template match="XMLROOT">

<html lang="es">

	<xsl:call-template name="headComun">
		<xsl:with-param name="arbol" select="true()"/>
		<xsl:with-param name="calendar" select="true()"/>
		<xsl:with-param name="jscript">
			<SCRIPT LANGUAGE="JavaScript">
				function verInformaticos(cod,sec) {
					document.verinfo.seccion.value = cod;
					document.verinfo.secname.value = sec;
					document.verinfo.submit();
				}
				function verAplicaciones(cod,sec) {
					document.verapl.seccion.value = cod;
					document.verapl.secname.value = sec;
					document.verapl.submit();
				}
				function gestiona(cod,sec) {
					document.gest.secname.value = cod+'<xsl:value-of select="$separator"/>'+sec;
					document.gest.submit();
				}
			</SCRIPT>
		</xsl:with-param>
	</xsl:call-template>

<body>
<xsl:call-template name="menuComun">
	<xsl:with-param name="HELP" select="'gestion.xml#1.4.1'"/>
	<xsl:with-param name="MENU" select="DATA/MENU"/>
	<xsl:with-param name="SELECT" select="$menu"/>
	<xsl:with-param name="NAME" select="concat(DATA/GESTION/USER/@NAME,concat(' (',concat(DATA/GESTION/USER/@LOGIN,')')))"/>
</xsl:call-template>
<xsl:call-template name="pieComun"/>
</body>
</html>
</xsl:template>

<xsl:template name="cuerpo">
<form name="gest" action="{$servlet}" method="post">
	<input type="hidden" name="module" value="dumbo7/gestion/dumbos.listAtender"/>
	<input type="hidden" name="secname" value=""/>
</form>
<form name="verinfo" action="{$servlet}" method="post">
	<input type="hidden" name="module" value="dumbo7/gestion.secciones.informaticos"/>
	<input type="hidden" name="seccion" value=""/>
	<input type="hidden" name="secname" value=""/>
</form>
<form name="verapl" action="{$servlet}" method="post">
	<input type="hidden" name="module" value="dumbo7/gestion.secciones.aplicaciones"/>
	<input type="hidden" name="seccion" value=""/>
	<input type="hidden" name="secname" value=""/>
</form>
<br/>
<form name="f1" action="{$servlet}" method="post">
<table class="contout">
<tr class="peticion">
	<td colspan="2"><strong>Gestin Global de Dumbos Por Secciones</strong></td>
</tr>
<tr>
	<td colspan="2">
		<table cellspacing="0" cellpadding="0">
		<xsl:choose>
			<xsl:when test="count(/XMLROOT/DATA/SECURITY/ACTION[@NAME='suplantarACualquiera'])>0">
				<tr><td colspan="7"><b>MAESTRO: GESTIONA DE CUALQUIER SECCIN</b></td></tr>
			</xsl:when>
			<xsl:otherwise>
				<tr><td colspan="7"><b>SECCIONES DE LAS QUE ES RESPONSABLE</b></td></tr>
			</xsl:otherwise>
		</xsl:choose>
		<tr><td colspan="7">&#160;</td></tr>
			<xsl:call-template name="sacaSeccion">
				<xsl:with-param name="secciones" select="DATA/GESTION"/>
			</xsl:call-template>
		</table>
	</td>
</tr>
</table>
</form>
</xsl:template>

<xsl:template name="sacaSeccion">
<xsl:param name="secciones"/>
	<xsl:for-each select="$secciones/SECCION[(@ESTADO='V') and (@RESPONSABLE=/XMLROOT/DATA/GESTION/USER/@ID or (count(/XMLROOT/DATA/SECURITY/ACTION[@NAME='suplantarACualquiera'])>0)) and (@PADRE=@CODIGO or @PADRE='')]">
		<xsl:sort select="@DESCRIPCION"/>
		<xsl:variable name="miSubCode" select="@CODIGO"/>
		<tr class="incidencia">
			<xsl:choose>
				<xsl:when test="count(../SECCION[(@ESTADO='V') and (@PADRE=$miSubCode) and not(@PADRE=@CODIGO)])>0">
					<td width="1%" id="arb.{position()}" class="switchcontent">
						<img id="img.arb.{position()}" src="../dumbo7/utils/table/minus.gif" class="showstate" onClick="expandcontent(this, 'arb.{position()}');"/>
					</td>
				</xsl:when>
				<xsl:otherwise>
					<td width="1%"></td>
				</xsl:otherwise>
			</xsl:choose>
			<td><a href="javascript:gestiona('{@CODIGO}','{@DESCRIPCION}');"><xsl:value-of select="@DESCRIPCION"/></a></td>
			<td>&#160;</td>
			<td><a href="javascript:verAplicaciones('{@CODIGO}','{@DESCRIPCION}');">Aplicaciones</a></td>
			<td>&#160;</td>
			<td><a href="javascript:verInformaticos('{@CODIGO}','{@DESCRIPCION}');"><xsl:call-template name="traduce"><xsl:with-param name="id" select="'Informaticos'"/></xsl:call-template></a></td>
		</tr>
		<xsl:call-template name="sacaSubSeccionOk">
			<xsl:with-param name="secciones" select=".."/>
			<xsl:with-param name="code" select="@CODIGO"/>
			<xsl:with-param name="guion" select="'-'"/>
			<xsl:with-param name="posic" select="position()"/>
		</xsl:call-template>
		<tr><td colspan="6">&#160;</td></tr>
	</xsl:for-each>
	<xsl:if test="count(/XMLROOT/DATA/SECURITY/ACTION[@NAME='suplantarACualquiera'])=0">
		<xsl:for-each select="$secciones/SECCION[(@ESTADO='V') and not(@RESPONSABLE=/XMLROOT/DATA/GESTION/USER/@ID) and (@PADRE=@CODIGO or @PADRE='')]">
			<xsl:sort select="@DESCRIPCION"/>
			<xsl:call-template name="sacaSubSeccion">
				<xsl:with-param name="secciones" select=".."/>
				<xsl:with-param name="code" select="@CODIGO"/>
				<xsl:with-param name="guion" select="'-'"/>
				<xsl:with-param name="posic" select="position()"/>
			</xsl:call-template>
		</xsl:for-each>
	</xsl:if>
</xsl:template>

<xsl:template name="sacaSubSeccionOk">
<xsl:param name="secciones"/>
<xsl:param name="code"/>
<xsl:param name="guion"/>
<xsl:param name="posic"/>
	<xsl:for-each select="$secciones/SECCION[(@ESTADO='V') and (@PADRE=$code) and not(@PADRE=@CODIGO)]">
		<xsl:sort select="@DESCRIPCION"/>
		<xsl:variable name="miSubCode" select="@CODIGO"/>
		<tr id="arb.{$posic}.{position()}"><xsl:if test="count($secciones/SECCION[(@ESTADO='V') and (@PADRE=$miSubCode) and not(@PADRE=@CODIGO)])>0"><xsl:attribute name="class">switchcontent</xsl:attribute></xsl:if>
			<td width="1%" class="peticion">
				<xsl:attribute name="style">padding-left: <xsl:value-of select="string-length($guion) div 4"/>cm;</xsl:attribute>
				<xsl:if test="count($secciones/SECCION[(@ESTADO='V') and (@PADRE=$miSubCode) and not(@PADRE=@CODIGO)])>0">
					<img id="img.arb.{$posic}.{position()}" src="../dumbo7/utils/table/minus.gif" class="showstate" onClick="expandcontent(this, 'arb.{$posic}.{position()}');"/>
				</xsl:if>
			</td>
			<td class="peticion"><xsl:attribute name="style">padding-left: <xsl:value-of select="string-length($guion) div 4"/>cm;</xsl:attribute><a href="javascript:gestiona('{@CODIGO}','{@DESCRIPCION}');"><xsl:value-of select="@DESCRIPCION"/></a></td>
			<td class="peticion"><xsl:attribute name="style">padding-left: <xsl:value-of select="string-length($guion) div 4"/>cm;</xsl:attribute>&#160;</td>
			<td class="peticion"><xsl:attribute name="style">padding-left: <xsl:value-of select="string-length($guion) div 4"/>cm;</xsl:attribute>&#160;<a href="javascript:verAplicaciones('{@CODIGO}','{@DESCRIPCION}');">Aplicaciones</a></td>
			<td class="peticion"><xsl:attribute name="style">padding-left: <xsl:value-of select="string-length($guion) div 4"/>cm;</xsl:attribute>&#160;</td>
			<td class="peticion"><xsl:attribute name="style">padding-left: <xsl:value-of select="string-length($guion) div 4"/>cm;</xsl:attribute>&#160;<a href="javascript:verInformaticos('{@CODIGO}','{@DESCRIPCION}');"><xsl:call-template name="traduce"><xsl:with-param name="id" select="'Informaticos'"/></xsl:call-template></a></td>
		</tr>
		<xsl:call-template name="sacaSubSeccionOk">
			<xsl:with-param name="secciones" select=".."/>
			<xsl:with-param name="code" select="@CODIGO"/>
			<xsl:with-param name="guion" select="concat($guion,'-')"/>
			<xsl:with-param name="posic" select="concat(concat($posic,'.'),position())"/>
		</xsl:call-template>
	</xsl:for-each>
</xsl:template>

<xsl:template name="sacaSubSeccion">
<xsl:param name="secciones"/>
<xsl:param name="code"/>
<xsl:param name="guion"/>
<xsl:param name="posic"/>
	<xsl:for-each select="$secciones/SECCION[(@ESTADO='V') and (@RESPONSABLE=/XMLROOT/DATA/GESTION/USER/@ID) and (@PADRE=$code) and not(@PADRE=@CODIGO)]">
		<xsl:sort select="@DESCRIPCION"/>
		<xsl:variable name="miSubCode" select="@CODIGO"/>
		<tr id="arb.{$posic}.{position()}"><xsl:if test="count($secciones/SECCION[(@ESTADO='V') and (@PADRE=$miSubCode) and not(@PADRE=@CODIGO)])>0"><xsl:attribute name="class">switchcontent</xsl:attribute></xsl:if>
			<td width="1%">
				<xsl:attribute name="style">padding-left: <xsl:value-of select="string-length($guion) div 4"/>cm;</xsl:attribute>
				<xsl:if test="count($secciones/SECCION[(@ESTADO='V') and (@PADRE=$miSubCode) and not(@PADRE=@CODIGO)])>0">
					<img id="img.arb.{$posic}.{position()}" src="../dumbo7/utils/table/minus.gif" class="showstate" onClick="expandcontent(this, 'arb.{$posic}.{position()}');"/>
				</xsl:if>
			</td>
			<td><xsl:attribute name="style">padding-left: <xsl:value-of select="string-length($guion) div 4"/>cm;</xsl:attribute><a href="javascript:gestiona('{@CODIGO}','{@DESCRIPCION}');"><xsl:value-of select="@DESCRIPCION"/></a></td>
			<td><xsl:attribute name="style">padding-left: <xsl:value-of select="string-length($guion) div 4"/>cm;</xsl:attribute>&#160;</td>
			<td><xsl:attribute name="style">padding-left: <xsl:value-of select="string-length($guion) div 4"/>cm;</xsl:attribute>&#160;<a href="javascript:verAplicaciones('{@CODIGO}','{@DESCRIPCION}');">Aplicaciones</a></td>
			<td><xsl:attribute name="style">padding-left: <xsl:value-of select="string-length($guion) div 4"/>cm;</xsl:attribute>&#160;</td>
			<td><xsl:attribute name="style">padding-left: <xsl:value-of select="string-length($guion) div 4"/>cm;</xsl:attribute>&#160;<a href="javascript:verInformaticos('{@CODIGO}','{@DESCRIPCION}');"><xsl:call-template name="traduce"><xsl:with-param name="id" select="'Informaticos'"/></xsl:call-template></a></td>
		</tr>
		<xsl:call-template name="sacaSubSeccionOk">
			<xsl:with-param name="secciones" select=".."/>
			<xsl:with-param name="code" select="@CODIGO"/>
			<xsl:with-param name="guion" select="concat($guion,'-')"/>
			<xsl:with-param name="posic" select="concat(concat($posic,'.'),position())"/>
		</xsl:call-template>
	</xsl:for-each>
	<xsl:for-each select="$secciones/SECCION[(@ESTADO='V') and not(@RESPONSABLE=/XMLROOT/DATA/GESTION/USER/@ID) and (@PADRE=$code) and not(@PADRE=@CODIGO)]">
		<xsl:sort select="@DESCRIPCION"/>
		<xsl:call-template name="sacaSubSeccion">
			<xsl:with-param name="secciones" select=".."/>
			<xsl:with-param name="code" select="@CODIGO"/>
			<xsl:with-param name="guion" select="concat($guion,'-')"/>
			<xsl:with-param name="posic" select="concat(concat($posic,'.'),position())"/>
		</xsl:call-template>
	</xsl:for-each>
</xsl:template>

</xsl:stylesheet>
