<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet version="1.0" 
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:xforms="http://www.w3.org/2002/xforms">
	
<xsl:param name="servlet"/>	
<xsl:param name="menu"/>
<xsl:param name="selected"/>

<xsl:include href="dumbo7/utils/xsl/utils.xsl"/>
<xsl:include href="atica/frameweb/xml/templates/paginable.xsl"/>

<xsl:template match="XMLROOT">

<html lang="es">

	<xsl:call-template name="headComun">
		<xsl:with-param name="calendar" select="true()"/>
		<xsl:with-param name="jscript">
			<SCRIPT LANGUAGE="JavaScript">
				var srvName = '<xsl:value-of select="$servlet"/>';
				var userDom = '<xsl:value-of select="DATA/GESTION/USER/@DOMINIO"/>';
			</SCRIPT>
			<SCRIPT LANGUAGE="JavaScript" SRC="../js/utils/suplantar.js"></SCRIPT>
		</xsl:with-param>
	</xsl:call-template>

<body>
<xsl:call-template name="menuComun">
	<xsl:with-param name="HELP" select="'gestion.xml#1.5'"/>
	<xsl:with-param name="MENU" select="DATA/MENU"/>
	<xsl:with-param name="SELECT" select="$menu"/>
	<xsl:with-param name="NAME" select="concat(DATA/GESTION/USER/@NAME,concat(' (',concat(DATA/GESTION/USER/@LOGIN,')')))"/>
</xsl:call-template>
<xsl:call-template name="pieComun"/>
</body>
</html>
</xsl:template>

<xsl:template name="cuerpo">
<br/>
<form name="f1" action="{$servlet}" method="post">
<input type="hidden" name="module" value="dumbo7/gestion.suplantaUser"/>
<input type="hidden" name="menu" value="{$menu}"/>
<table class="contout">
<tr class="peticion">
	<td colspan="2"><strong>Suplantar Identidad</strong></td>
</tr>
<tr>
	<td colspan="2">
		<table cellpadding="0" cellspacing="0">
		<xsl:choose>
			<xsl:when test="count(/XMLROOT/DATA/GESTION/USER/BASEUSER)>0">
			<tr><td>Usted Est Suplantando a <xsl:value-of select="/XMLROOT/DATA/GESTION/USER/@NAME"/>, no se permite que suplante a otro.</td></tr>
			</xsl:when>
			<xsl:otherwise>
			<xsl:choose>
			<xsl:when test="count(/XMLROOT/DATA/SECURITY/ACTION[@NAME='suplantarACualquiera'])>0">
			<tr><td colspan="3"><b>MAESTRO: PUEDE SUPLANTAR A CUALQUIER USUARIO</b></td></tr>
			<tr><td colspan="3">&#160;</td></tr>
			<tr>
				<td>&#160;</td>
				<td>
					<b>Usuario:</b>&#160;
					<input type="text" name="usucod" value="" size="25" OnChange="findRequest(this,'infname');"/>&#160;
					&#160;<a href="javascript:buscaUsuario();"><img title="Buscar" src="../graficos/iconos/ampliar.gif" border="0"/></a>
				</td>
				<td><input type="submit" class="boton" value="Aceptar"/></td>
			</tr>
			<tr><td>&#160;</td><td id="infname" colspan="2">&#160;</td></tr>
			<xsl:if test="count(DATA/GESTION/INFORMSEC)>0">
			<tr class="peticion"><td colspan="3"><b><xsl:call-template name="traduce"><xsl:with-param name="id" select="'INFORMATICOS'"/></xsl:call-template>&#160;SUPLANTABLES POR SECCION</b></td></tr>
				<xsl:for-each select="DATA/GESTION/INFORMSEC">
					<xsl:sort select="key"/>
					<xsl:if test="count(value)>0">
						<tr>
							<td>&#160;</td>
							<td><b>SECCIN:</b>&#160;<xsl:value-of select="key"/></td>
							<td>&#160;</td>
						</tr>
						<xsl:for-each select="value">
							<xsl:sort select="APELLIDOS"/>
							<xsl:variable name="ids"><xsl:choose><xsl:when test="string-length(EMAIL)=0"><xsl:value-of select="IDENTIFICADOR"/></xsl:when><xsl:otherwise><xsl:value-of select="EMAIL"/></xsl:otherwise></xsl:choose></xsl:variable>
							<xsl:choose>
								<xsl:when test="/XMLROOT/DATA/GESTION/USER/@ID=./IDENTIFICADOR">
								<tr>
									<td>&#160;</td>
									<td style="padding-left:1cm;"><xsl:value-of select="$ids"/></td>
									<td><xsl:value-of select="APELLIDOS"/>,&#160;<xsl:value-of select="NOMBRE"/></td>
								</tr>
								</xsl:when>
								<xsl:otherwise>
								<tr>
									<td>&#160;</td>
									<td style="padding-left:1cm;"><a href="javascript:suplanta('{$ids}');"><xsl:value-of select="EMAIL"/></a></td>
									<td><a href="javascript:suplanta('{$ids}');"><xsl:value-of select="APELLIDOS"/>,&#160;<xsl:value-of select="NOMBRE"/></a></td>
								</tr>
								</xsl:otherwise>
							</xsl:choose>
						</xsl:for-each>
						<tr><td colspan="3">&#160;</td></tr>
					</xsl:if>
				</xsl:for-each>
			<tr><td colspan="3">&#160;</td></tr>
			</xsl:if>
			<xsl:if test="count(DATA/GESTION/INFORMAPL)>0">
			<tr class="peticion"><td colspan="3"><b><xsl:call-template name="traduce"><xsl:with-param name="id" select="'INFORMATICOS'"/></xsl:call-template>&#160;SUPLANTABLES POR APLICACIN</b></td></tr>
			<tr><td colspan="3">&#160;</td></tr>
				<xsl:for-each select="DATA/GESTION/INFORMAPL">
					<xsl:sort select="key"/>
					<xsl:if test="count(value)>0">
						<tr>
							<td>&#160;</td>
							<td><b>APLICACIN:</b>&#160;<xsl:value-of select="key"/></td>
							<td>&#160;</td>
						</tr>
						<xsl:for-each select="value">
							<xsl:sort select="APELLIDOS"/>
							<xsl:variable name="ids"><xsl:choose><xsl:when test="string-length(EMAIL)=0"><xsl:value-of select="IDENTIFICADOR"/></xsl:when><xsl:otherwise><xsl:value-of select="EMAIL"/></xsl:otherwise></xsl:choose></xsl:variable>
							<xsl:choose>
								<xsl:when test="/XMLROOT/DATA/GESTION/USER/@ID=./IDENTIFICADOR">
								<tr>
									<td>&#160;</td>
									<td style="padding-left:1cm;"><xsl:value-of select="$ids"/></td>
									<td><xsl:value-of select="APELLIDOS"/>,&#160;<xsl:value-of select="NOMBRE"/></td>
								</tr>
								</xsl:when>
								<xsl:otherwise>
								<tr>
									<td>&#160;</td>
									<td style="padding-left:1cm;"><a href="javascript:suplanta('{$ids}');"><xsl:value-of select="EMAIL"/></a></td>
									<td><a href="javascript:suplanta('{$ids}');"><xsl:value-of select="APELLIDOS"/>,&#160;<xsl:value-of select="NOMBRE"/></a></td>
								</tr>
								</xsl:otherwise>
							</xsl:choose>
						</xsl:for-each>
					<tr><td colspan="3">&#160;</td></tr>
					</xsl:if>
				</xsl:for-each>
			</xsl:if>
			</xsl:when>
			<xsl:otherwise>
			<input type="hidden" name="usucod" value=""/>
			<xsl:if test="count(DATA/GESTION/INFORMSEC)>0">
			<tr class="peticion"><td colspan="3"><b><xsl:call-template name="traduce"><xsl:with-param name="id" select="'INFORMATICOS'"/></xsl:call-template>&#160;SUPLANTABLES POR SECCION</b></td></tr>
			<tr><td colspan="3">&#160;</td></tr>
				<xsl:for-each select="DATA/GESTION/INFORMSEC">
					<xsl:sort select="key"/>
					<xsl:if test="count(value)>0">
						<tr>
							<td>&#160;</td>
							<td><b>SECCIN:</b>&#160;<xsl:value-of select="key"/></td>
							<td>&#160;</td>
						</tr>
						<xsl:for-each select="value">
							<xsl:sort select="APELLIDOS"/>
							<xsl:variable name="ids"><xsl:choose><xsl:when test="string-length(EMAIL)=0"><xsl:value-of select="IDENTIFICADOR"/></xsl:when><xsl:otherwise><xsl:value-of select="EMAIL"/></xsl:otherwise></xsl:choose></xsl:variable>
							<xsl:choose>
								<xsl:when test="/XMLROOT/DATA/GESTION/USER/@ID=./IDENTIFICADOR">
								<tr>
									<td>&#160;</td>
									<td style="padding-left:1cm;"><xsl:value-of select="$ids"/></td>
									<td><xsl:value-of select="APELLIDOS"/>,&#160;<xsl:value-of select="NOMBRE"/></td>
								</tr>
								</xsl:when>
								<xsl:otherwise>
								<tr>
									<td>&#160;</td>
									<td style="padding-left:1cm;"><a href="javascript:suplanta('{$ids}');"><xsl:value-of select="EMAIL"/></a></td>
									<td><a href="javascript:suplanta('{$ids}');"><xsl:value-of select="APELLIDOS"/>,&#160;<xsl:value-of select="NOMBRE"/></a></td>
								</tr>
								</xsl:otherwise>
							</xsl:choose>
						</xsl:for-each>
						<tr><td colspan="3">&#160;</td></tr>
					</xsl:if>
				</xsl:for-each>
			<tr><td colspan="3">&#160;</td></tr>
			</xsl:if>
			<xsl:if test="count(DATA/GESTION/INFORMAPL)>0">
			<tr class="peticion"><td colspan="3"><b><xsl:call-template name="traduce"><xsl:with-param name="id" select="'INFORMATICOS'"/></xsl:call-template>&#160;SUPLANTABLES POR APLICACIN</b></td></tr>
			<tr><td colspan="3">&#160;</td></tr>
				<xsl:for-each select="DATA/GESTION/INFORMAPL">
					<xsl:sort select="key"/>
					<xsl:if test="count(value)>0">
						<tr>
							<td>&#160;</td>
							<td><b>APLICACIN:</b>&#160;<xsl:value-of select="key"/></td>
							<td>&#160;</td>
						</tr>
						<xsl:for-each select="value">
							<xsl:sort select="APELLIDOS"/>
							<xsl:variable name="ids"><xsl:choose><xsl:when test="string-length(EMAIL)=0"><xsl:value-of select="IDENTIFICADOR"/></xsl:when><xsl:otherwise><xsl:value-of select="EMAIL"/></xsl:otherwise></xsl:choose></xsl:variable>
							<xsl:choose>
								<xsl:when test="/XMLROOT/DATA/GESTION/USER/@ID=./IDENTIFICADOR">
								<tr>
									<td>&#160;</td>
									<td style="padding-left:1cm;"><xsl:value-of select="$ids"/></td>
									<td><xsl:value-of select="APELLIDOS"/>,&#160;<xsl:value-of select="NOMBRE"/></td>
								</tr>
								</xsl:when>
								<xsl:otherwise>
								<tr>
									<td>&#160;</td>
									<xsl:variable name="ids"><xsl:choose><xsl:when test="string-length(EMAIL)=0"><xsl:value-of select="IDENTIFICADOR"/></xsl:when><xsl:otherwise><xsl:value-of select="EMAIL"/></xsl:otherwise></xsl:choose></xsl:variable>
									<td style="padding-left:1cm;"><a href="javascript:suplanta('{$ids}');"><xsl:value-of select="EMAIL"/></a></td>
									<td><a href="javascript:suplanta('{$ids}');"><xsl:value-of select="APELLIDOS"/>,&#160;<xsl:value-of select="NOMBRE"/></a></td>
								</tr>
								</xsl:otherwise>
							</xsl:choose>
						</xsl:for-each>
						<tr><td colspan="3">&#160;</td></tr>
					</xsl:if>
				</xsl:for-each>
			</xsl:if>
			</xsl:otherwise>
			</xsl:choose>
			</xsl:otherwise>
		</xsl:choose>
		</table>
	</td>
</tr>
</table>
</form>
</xsl:template>

</xsl:stylesheet>
