<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet version="1.0" 
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:xforms="http://www.w3.org/2002/xforms">
	
<xsl:param name="servlet"/>	
<xsl:param name="menu"/>
<xsl:param name="selected"/>
<xsl:param name="separator" select="'|'"/>

<xsl:include href="dumbo7/utils/xsl/utils.xsl"/>
<xsl:include href="atica/frameweb/xml/templates/paginable.xsl"/>

<xsl:template match="XMLROOT">

<html lang="es">

	<xsl:call-template name="headComun">
		<xsl:with-param name="calendar" select="true()"/>
		<xsl:with-param name="jscript">
			<SCRIPT LANGUAGE="JavaScript">
				function gestiona(cod,sec) {
					document.gest.infname.value = cod+'<xsl:value-of select="$separator"/>'+sec;
					document.gest.submit();
				}
				var http_req = false;
				var idInput = '';
				var objInput = null;
				
				function findRequest(obj,val) {
					var elements = document.getElementsByTagName("tr");
					for (i=0; i&lt;elements.length; i++) {
						if (elements[i].name &amp;&amp; elements[i].name.trim()!='' &amp;&amp; obj.value.trim()!='' &amp;&amp; !isInElement(elements[i],obj.value)) {
							elements[i].style.display = 'none';
						} else elements[i].style.display = '';
					}
				}
				
				function isInElement(ele,txt) {
					if (ele.name.indexOf(txt.toLowerCase())>=0) return true;
					if (ele.innerHTML.indexOf(txt.toUpperCase())>=0) return true;
					return false;
				}
				function iSubmitEnter(oEvento, oValor){ 
				     var iAscii; 
				
				     if (oEvento.keyCode) 
				         iAscii = oEvento.keyCode; 
				     else if (oEvento.which) 
				         iAscii = oEvento.which; 
				     else 
				         return false; 
				
				     if (iAscii == 13) findRequest(oValor,'infname'); 
				
				     return true; 
				} 
				
			</SCRIPT>
		</xsl:with-param>
	</xsl:call-template>

<body>
<xsl:call-template name="menuComun">
	<xsl:with-param name="HELP" select="'gestion.xml#1.4.3'"/>
	<xsl:with-param name="MENU" select="DATA/MENU"/>
	<xsl:with-param name="SELECT" select="$menu"/>
	<xsl:with-param name="NAME" select="concat(DATA/GESTION/USER/@NAME,concat(' (',concat(DATA/GESTION/USER/@LOGIN,')')))"/>
</xsl:call-template>
<xsl:call-template name="pieComun"/>
</body>
</html>
</xsl:template>

<xsl:template name="cuerpo">
<form name="gest" action="{$servlet}" method="post">
	<input type="hidden" name="module" value="dumbo7/gestion/dumbos.listAtender"/>
	<input type="hidden" name="infname" value=""/>
</form>
<br/>
<form name="f1" action="{$servlet}" method="post" onsubmit="return false;">
<table class="contout">
<tr class="peticion">
	<td colspan="2"><strong>Gestin Global de Dumbos Por <xsl:call-template name="traduce"><xsl:with-param name="id" select="'Informaticos'"/></xsl:call-template></strong></td>
</tr>
<tr>
	<td colspan="2">
		<table cellpadding="0" cellspacing="0" width="100%">
		<tr><td colspan="3"><b><xsl:call-template name="traduce"><xsl:with-param name="id" select="'INFORMATICOS'"/></xsl:call-template>&#160;QUE PUEDE GESTIONAR</b></td></tr>
		<tr><td colspan="3">&#160;</td></tr>
		<tr><td colspan="3">Filtro: <input type="text" name="usucod" value="" size="25" OnChange="findRequest(this,'infname');" onkeypress="iSubmitEnter(event, this)"/>&#160;</td>
		</tr>
		<tr><td colspan="3">&#160;</td></tr>
		<xsl:choose>
			<xsl:when test="count(DATA/SECURITY[@MODULE='dumbo7/gestion']/ACTION[@NAME='suplantarACualquiera'])>0">
			<tr class="peticion"><td colspan="3"><b><xsl:call-template name="traduce"><xsl:with-param name="id" select="'Informaticos'"/></xsl:call-template>&#160;Por Secciones</b></td></tr>
			<tr><td colspan="3">&#160;</td></tr>
			<xsl:for-each select="DATA/GESTION/INFORMSEC">
				<xsl:sort select="key"/>
				<xsl:if test="count(./value)>0">
					<tr><td colspan="3"><strong>SECCIN:</strong><xsl:value-of select="./key"/></td></tr>
					<xsl:variable name="scod" select="substring-after(substring-before(./key,']'),'[')"/>
					<xsl:for-each select="./value">
						<xsl:sort select="./APELLIDOS"/>
						<xsl:choose>
							<xsl:when test="/XMLROOT/DATA/GESTION/USER/@ID=./IDENTIFICADOR">
							<tr name="{./EMAIL}" class="incidencia">
								<td>&#160;</td>
								<td>&#160;<xsl:value-of select="./EMAIL"/></td>
								<td>&#160;<xsl:value-of select="APELLIDOS"/>, <xsl:value-of select="NOMBRE"/>
									<xsl:if test="count(./RESP[.=$scod])>0">
										(Responsable)
									</xsl:if>
								</td>
							</tr>
							</xsl:when>
							<xsl:otherwise>
							<tr name="{./EMAIL}" class="incidencia">
								<td>&#160;</td>
								<td>&#160;<a href="javascript:gestiona('{./IDENTIFICADOR}','{./EMAIL}');"><xsl:value-of select="./EMAIL"/></a></td>
								<td>&#160;<a href="javascript:gestiona('{./IDENTIFICADOR}','{./EMAIL}');"><xsl:value-of select="APELLIDOS"/>, <xsl:value-of select="NOMBRE"/></a>
									<xsl:if test="count(./RESP[.=$scod])>0">
										(Responsable)
									</xsl:if>
								</td>
							</tr>
							</xsl:otherwise>
						</xsl:choose>
					</xsl:for-each>
					<tr><td colspan="3">&#160;</td></tr>
				</xsl:if>
			</xsl:for-each>
			<tr><td colspan="3">&#160;</td></tr>
			<tr class="peticion"><td colspan="3"><b><xsl:call-template name="traduce"><xsl:with-param name="id" select="'Informaticos'"/></xsl:call-template>&#160;Por Aplicaciones</b></td></tr>
			<tr><td colspan="3">&#160;</td></tr>
			<xsl:for-each select="DATA/GESTION/INFORMAPL">
				<xsl:sort select="key"/>
				<xsl:if test="count(./value)>0">
					<tr><td colspan="3"><strong>APLICACIN:</strong><xsl:value-of select="./key"/></td></tr>
					<xsl:variable name="acod" select="substring-after(substring-before(./key,']'),'[')"/>
					<xsl:for-each select="./value">
						<xsl:sort select="./APELLIDOS"/>
						<xsl:choose>
							<xsl:when test="/XMLROOT/DATA/GESTION/USER/@ID=./IDENTIFICADOR">
							<tr name="{./EMAIL}" class="incidencia">
								<td>&#160;</td>
								<td>&#160;<xsl:value-of select="./EMAIL"/></td>
								<td>&#160;<xsl:value-of select="APELLIDOS"/>, <xsl:value-of select="NOMBRE"/>
									<xsl:if test="count(./RESP[.=$acod])>0">
										(Responsable)
									</xsl:if>
								</td>
							</tr>
							</xsl:when>
							<xsl:otherwise>
							<tr name="{./EMAIL}" class="incidencia">
								<td>&#160;</td>
								<td>&#160;<a href="javascript:gestiona('{./IDENTIFICADOR}','{./EMAIL}');"><xsl:value-of select="./EMAIL"/></a></td>
								<td>&#160;<a href="javascript:gestiona('{./IDENTIFICADOR}','{./EMAIL}');"><xsl:value-of select="APELLIDOS"/>, <xsl:value-of select="NOMBRE"/></a>
									<xsl:if test="count(./RESP[.=$acod])>0">
										(Responsable)
									</xsl:if>
								</td>
							</tr>
							</xsl:otherwise>
						</xsl:choose>
					</xsl:for-each>
					<tr><td colspan="3">&#160;</td></tr>
				</xsl:if>
			</xsl:for-each>
			</xsl:when>
			<xsl:otherwise>
			<tr class="peticion"><td colspan="3"><b><xsl:call-template name="traduce"><xsl:with-param name="id" select="'Informaticos'"/></xsl:call-template>&#160;Por Secciones</b></td></tr>
			<tr><td colspan="3">&#160;</td></tr>
			<xsl:for-each select="DATA/GESTION/INFORMSEC">
				<xsl:sort select="key"/>
				<xsl:if test="count(./value)>0">
					<tr><td colspan="3"><strong>SECCIN:</strong><xsl:value-of select="./key"/></td></tr>
					<xsl:for-each select="./value">
						<xsl:sort select="./APELLIDOS"/>
						<xsl:choose>
							<xsl:when test="/XMLROOT/DATA/GESTION/USER/@ID=./IDENTIFICADOR">
							<tr name="{./EMAIL}" class="incidencia">
								<td>&#160;</td>
								<td>&#160;<xsl:value-of select="./EMAIL"/></td>
								<td>&#160;<xsl:value-of select="APELLIDOS"/>, <xsl:value-of select="NOMBRE"/></td>
							</tr>
							</xsl:when>
							<xsl:otherwise>
							<tr name="{./EMAIL}" class="incidencia">
								<td>&#160;</td>
								<td>&#160;<a href="javascript:gestiona('{./IDENTIFICADOR}','{./EMAIL}');"><xsl:value-of select="./EMAIL"/></a></td>
								<td>&#160;<a href="javascript:gestiona('{./IDENTIFICADOR}','{./EMAIL}');"><xsl:value-of select="APELLIDOS"/>, <xsl:value-of select="NOMBRE"/></a></td>
							</tr>
							</xsl:otherwise>
						</xsl:choose>
					</xsl:for-each>
					<tr><td colspan="3">&#160;</td></tr>
				</xsl:if>
			</xsl:for-each>
			<tr><td colspan="3">&#160;</td></tr>
			<tr><td colspan="3"><b><xsl:call-template name="traduce"><xsl:with-param name="id" select="'Informaticos'"/></xsl:call-template>&#160;Por Aplicaciones</b></td></tr>
			<tr><td colspan="3">&#160;</td></tr>
			<xsl:for-each select="DATA/GESTION/INFORMAPL">
				<xsl:sort select="key"/>
				<xsl:if test="count(./value)>0">
					<tr><td colspan="3"><strong>APLICACIN:</strong><xsl:value-of select="./key"/></td></tr>
					<xsl:for-each select="./value">
						<xsl:sort select="./APELLIDOS"/>
						<xsl:choose>
							<xsl:when test="/XMLROOT/DATA/GESTION/USER/@ID=./IDENTIFICADOR">
							<tr name="{./EMAIL}" class="incidencia">
								<td>&#160;</td>
								<td>&#160;<xsl:value-of select="./EMAIL"/></td>
								<td>&#160;<xsl:value-of select="APELLIDOS"/>, <xsl:value-of select="NOMBRE"/></td>
							</tr>
							</xsl:when>
							<xsl:otherwise>
							<tr name="{./EMAIL}" class="incidencia">
								<td>&#160;</td>
								<td>&#160;<a href="javascript:gestiona('{./IDENTIFICADOR}','{./EMAIL}');"><xsl:value-of select="./EMAIL"/></a></td>
								<td>&#160;<a href="javascript:gestiona('{./IDENTIFICADOR}','{./EMAIL}');"><xsl:value-of select="APELLIDOS"/>, <xsl:value-of select="NOMBRE"/></a></td>
							</tr>
							</xsl:otherwise>
						</xsl:choose>
					</xsl:for-each>
					<tr><td colspan="3">&#160;</td></tr>
				</xsl:if>
			</xsl:for-each>
			</xsl:otherwise>
		</xsl:choose>
		</table>
	</td>
</tr>
</table>
</form>
</xsl:template>

</xsl:stylesheet>
