package dumbo7.gestion.usuarios;

import dumbo7.utils.*;
import dumbo7.utils.ldap.LDAPUser;
import dumbo7.utils.ldap.LDAPUtil;
import dumbo7.administracion.*;
import org.hibernate.*;
import org.hibernate.criterion.Expression;
import org.hibernate.exception.ConstraintViolationException;
import org.hibernate.type.Type;
import atica.frameweb.query.*;

import java.math.BigDecimal;
import java.sql.*;

import java.util.*;

/**
 * @author prc
 *
 * Gestor de Administracin de Categorias
 * 
 */


public class GestorUsuarios extends GestorAdministracion {
	
	public GestorUsuarios() {}
		
	protected List usuarios = null;
	protected List cargos = null;
	private String patron ="";
	protected List ips = null;
	protected List correos = null;
	protected List datosRed = null;
	protected List tareas = null;
	private String seccion ="";
	
	private D7LdapDatosPersonales usuario;
	private D7DatosCorreo correo;
	private D7DatosIp ip;
	
	public String Usu = null;
	
	public String Sincroniza = null;
	public String Notas = null;
	public String Cargo = null;
	public java.util.Date FechaBaja = null;
	
	public String Correo = null;
	public String Cuenta = null;
	
	public String Ip = null;
	public String Campus = null;
	public String Host = null;
	public String Roseta = null;
	public String Mac = null;
	public java.util.Date FechaSolicitud = null;
	
	//Metodos get() para el mapeo
	public List getUsuarios() { return usuarios; }
	public List getCargos() { return cargos; }
	public String getPatron() {return patron;}
	public List getIps() { return ips; }
	public List getCorreos() { return correos; }
	public List getDatosRed() { return datosRed; }
	public List getTareas(){return tareas;}
	public String getSeccion() {return seccion;}
	
	public void setUsuario(String text){
		if(text != ""){
			this.Usu = text;
		}
		else{
			this.Usu = null;
		}
	}
	
	public void setNotas(String text){
		if(text != ""){
			this.Notas = text;
		}
		else{
			this.Notas = null;
		}
	}
	public void setCargo(String text){
		if(text != ""){
			this.Cargo = text;
		}
		else{
			this.Cargo = null;
		}
	}
	public void setFechaBaja(java.util.Date fecha){
		if(fecha != null){
			this.FechaBaja = fecha;
		}
		else{
			this.FechaBaja = null;
		}
	}
	
	
	public void setIp(String text){
		this.Ip = text;
	}
	public void setCampus(String text){
		this.Campus = text;
	}
	public void setHost(String text){
		this.Host = text;
	}
	public void setRoseta(String text){
		this.Roseta = text;
	}
	public void setMac(String text){
		this.Mac = text;
	}
	public void setFechaSolicitud(java.util.Date fecha){
		this.FechaSolicitud = fecha;
	}
	
	
	public void setCorreo(String text){
		this.Correo = text;
	}
	public void setCuenta(String text){
		this.Cuenta = text;
	}

	
	/**LISTA DE UN ELEMENTO*/
	public void ObtenerIp(Session conn,String ip) {
		try {
			if (ip != null){
				Query q = null;
				q = conn.createQuery(getQuery("ObtenerIp"));
				q.setString("id",this.Usu);
				q.setString("direccion",ip);
				this.ips = q.list();
			}
		} catch (Exception ex) {
			setErrorMessage("GestorUsuarios[BuscaConfiguracionDeRed]: "+ex);
		}
	}
	public void ObtenerCorreo(Session conn,String correo) {
		try {
			if (correo != null){
				Query q = null;
				q = conn.createQuery(getQuery("ObtenerCorreo"));
				q.setString("id",this.Usu);
				q.setString("correo",correo);
				this.correos = q.list();
			}
		} catch (Exception ex) {
			setErrorMessage("GestorUsuarios[BuscaConfiguracionDeRed]: "+ex);
		}
	}
	public void SincronizaUsuario(Session conn,String dni) {
		PreparedStatement pstmt;
		
		try{
			if(dni != null){
				String ResultadoQuery = getQuery("SincronizaUsuarios");
				ResultadoQuery = ResultadoQuery.replaceAll(":DNI",dni);
				pstmt = conn.connection().prepareStatement(ResultadoQuery);
				boolean result = pstmt.execute();
				
				conn.flush();
				conn.connection().commit();
			 	pstmt.close();
			}
		} catch (Exception ex) {
			System.out.println(ex);
			setErrorMessage("GestorUsuarios[Actualizacin de Usuarios]: ");
		}
	}
	
	/**DATOS ASOCIADOS A UN PAR @IP/CAMPUS**/
	public void ConfiguracionDeRed(Session conn) {
		try {
			Query q = null;
			q = conn.createQuery(getQuery("ObtenerConfigRed"));
			q.setString("ip",this.Ip);
			q.setString("campus",this.Campus);
			datosRed = q.list();
		} catch (Exception ex) {
			setErrorMessage("GestorUsuarios[BuscaConfiguracionDeRed]: "+ex);
		}
	}
	public void ConfiguracionesDeRed(Session conn, String code) {
		try {
			Query q = null;
			q = conn.createQuery(getQuery("ObtenerConfigsRed"));
			q.setString("id",code);
			datosRed = q.list();
		} catch (Exception ex) {
			setErrorMessage("GestorUsuarios[BuscaConfiguracionesDeRed]: "+ex);
		}
	}
	
	/**LISTA TODOS LOS CARGOS**/
	public void listaCargos(Session conn) {
		try {
			Query q = null;
			q = conn.createQuery(getQuery("listaAllCargos"));
			cargos = q.list();
		} catch (Exception ex) {
			setErrorMessage("GestorUsuarios[ListaCargos]: "+ex);
		}
	}
	
	/**BUSQUEDAS DE USUARIO*/
	public void buscaUsuario(Session conn,String ptr) {
		patron = ptr;
		try {
			Query q = null;
			if (patron.indexOf("@")>0) {
				q = conn.createQuery(getQuery("UsuariosCorreo"));
				q.setString("correo",patron+"%");
				usuarios = q.list();
			} else {
				q = conn.createQuery(getQuery("UsuariosApellidos"));
				q.setString("apellidos","%"+patron+"%");
				usuarios = q.list();
			}
		} catch (Exception ex) {
			setErrorMessage("GestorUsuarios[BuscaUsuario]: "+ex);
		}
	}
	
	/**BUSQUEDAS DE USUARIO*/
	public void buscaUsuarioDNI(Session conn,String dni) {
		try {
			Query q = null;
			q = conn.createQuery(getQuery("UsuarioId"));
			q.setString("id",dni);
			usuarios = q.list();
		} catch (Exception ex) {
			setErrorMessage("GestorUsuarios[BuscaUsuarioDNI]: "+ex);
		}
	}
	
	/**MUESTRA DATOS DEL USUARIO IDENTIFICADO POR CODE*/
	public void DatosUsuario(Session conn,String code) {
		try {
			if ((code==null) || code.equals("")) return;
			/**Se obtiene la informacin relativa al usuario dado por el id*/
			Query q = null;
			q = conn.createQuery(getQuery("CountUsuarioId"));
			q.setString("id",code);
			List aux = q.list();
			Integer Usuario = new Integer(aux.get(0).toString());
			
			if (Usuario.intValue() >0){
				/**Si encontramos el usuario en la BBDD entonces antes de mostar la informacin lo actualizamos
				 * y despues de actualizarlo entonces buscamos sus datos(por si el procemiento ha actualizado algo)*/
				SincronizaUsuario(conn,code);
				q = conn.createQuery(getQuery("UsuarioId"));
				q.setString("id",code);
				usuarios = q.list();
			}
			else{
				setErrorMessage("Usuario Incorrecto!");
			}
						
			/**Se obtienen las ip asociadas al usuario dado por el id*/
			Query q2 = null;
			q2 = conn.createQuery(getQuery("IPsUsuarioId"));
			q2.setString("id",code);
			ips = q2.list();
			
			/**Se obtienen los correos asociados al usuario dado por el id*/
			Query q3 = null;
			q3 = conn.createQuery(getQuery("CorreosUsuarioId"));
			q3.setString("id",code);
			correos = q3.list();
			
		} catch (Exception ex) {
			setErrorMessage("GestorUsuarios[DatosUsuario]: "+ex);
		}
	}
	
	public void DatosUsuarioIp(Session conn,String ip) {
		try {
			if ((ip==null) || ip.equals("")) return;
			/**Obtenemos a traves de la ip cual es el usuario asociado a esta y guardamos su id en code*/
			String code = "";
			Query q = null;
			q = conn.createQuery(getQuery("ObtenerUsuId_porIp"));
			q.setString("direccion",ip);
			usuarios = q.list();
			if(!usuarios.isEmpty()){
				usuario = (D7LdapDatosPersonales)usuarios.get(0);
				code = usuario.getDatIdentificador();
				usuario = null;
				usuarios = null;
				
				/**Se obtiene la informacin relativa al usuario dado por el id*/
				Query q1 = null;
				q1 = conn.createQuery(getQuery("UsuarioId"));
				q1.setString("id",code);
				usuarios = q1.list();
				
				/**Se obtienen las ip asociadas al usuario dado por el id*/
				Query q2 = null;
				q2 = conn.createQuery(getQuery("IPsUsuarioId"));
				q2.setString("id",code);
				ips = q2.list();
				
				/**Se obtienen los correos asociados al usuario dado por el id*/
				Query q3 = null;
				q3 = conn.createQuery(getQuery("CorreosUsuarioId"));
				q3.setString("id",code);
				correos = q3.list();
			}
		} catch (Exception ex) {
			setErrorMessage("GestorUsuarios[DatosUsuario_BusquedaPorIp]: "+ex);
		}
	}
	
	public void DatosUsuarioHost(Session conn,String host) {
		try {
			if ((host==null) || host.equals("")) return;
			/**Obtenemos a traves del host cual es el usuario asociado a esta y guardamos su id en code*/
			String code = "";
			Query q = null;
			q = conn.createQuery(getQuery("ObtenerUsuId_porHost"));
			q.setString("host",host);
			usuarios = q.list();
			if(!usuarios.isEmpty()){
				usuario = (D7LdapDatosPersonales)usuarios.get(0);
				code = usuario.getDatIdentificador();
				usuario = null;
				usuarios = null;
				
				/**Se obtiene la informacin relativa al usuario dado por el id*/
				Query q1 = null;
				q1 = conn.createQuery(getQuery("UsuarioId"));
				q1.setString("id",code);
				usuarios = q1.list();
				
				/**Se obtienen las ip asociadas al usuario dado por el id*/
				Query q2 = null;
				q2 = conn.createQuery(getQuery("IPsUsuarioId"));
				q2.setString("id",code);
				ips = q2.list();
				
				/**Se obtienen los correos asociados al usuario dado por el id*/
				Query q3 = null;
				q3 = conn.createQuery(getQuery("CorreosUsuarioId"));
				q3.setString("id",code);
				correos = q3.list();
			}
		} catch (Exception ex) {
			setErrorMessage("GestorUsuarios[DatosUsuario_BusquedaPorHost]: "+ex);
		}
	}
	
	/**OBTIENE LAS TAREAS DEL USUARIOS IDENTIFICADO POR CODE*/
	public void TareasUsuario(Session conn, String code){
	    try {
	        if ((code==null) || code.equals("")) return;
	        Query q = null;
			q = conn.createQuery(getQuery("TareasUsuario"));
			q.setString("sist",user.getDatosMenu().idSelected());
			q.setString("id",code);
			q.setString("anulada",D7Tareas.ANULADA);
			q.setString("finalizada",D7Tareas.FINALIZADA);
			q.setString("rechazada",D7Tareas.RECHAZADA);
			q.setString("incidencia",D7TiposTareas.INCIDENCIA);
			q.setString("peticion",D7TiposTareas.PETICION);
			tareas = q.list();
			
			Query q2 = null;
			q2 = conn.createQuery(getQuery("TareasUsuarioSinApl"));
			q2.setString("sist",user.getDatosMenu().idSelected());
			q2.setString("id",code);
			q2.setString("anulada",D7Tareas.ANULADA);
			q2.setString("finalizada",D7Tareas.FINALIZADA);
			q2.setString("rechazada",D7Tareas.RECHAZADA);
			q2.setString("incidencia",D7TiposTareas.INCIDENCIA);
			q2.setString("peticion",D7TiposTareas.PETICION);
			tareas.add(q2.list());
		} catch (Exception ex) {
			setErrorMessage("GestorUsuarios[ListaTareasAsociadas]: "+ex);
		}
	}
	
	public void ConsultarHistorico(Session conn, String dni){
		Query q = null;
		try{
			q = conn.createQuery(getQuery("HistoricoTareas"));
			q.setString("sist",user.getDatosMenu().idSelected());
			q.setString("id",dni);
			q.setString("anulada",D7Tareas.ANULADA);
			q.setString("finalizada",D7Tareas.FINALIZADA);
			q.setString("rechazada",D7Tareas.RECHAZADA);
			q.setString("incidencia",D7TiposTareas.INCIDENCIA);
			q.setString("peticion",D7TiposTareas.PETICION);
			tareas = q.list();
		}
		catch(Exception ex){
			setErrorMessage("GestorUsuarios[HistoricoTareas]: "+ex);
		}
		
	}
	
	/**MUESTRA DATOS DEL USUARIO IDENTIFICADO POR CODE PARA LOS PDF*/
	public void DatosUsuarioPDF(Session conn,String code) {
		try {
			if ((code==null) || code.equals("")) return;
			/**Se obtiene la informacin relativa al usuario dado por el id*/
			Query q = null;
			q = conn.createQuery(getQuery("UsuarioId"));
			q.setString("id",code);
			usuarios = q.list();
			
			/**Se obtienen los correos asociados al usuario dado por el id*/
			Query q3 = null;
			q3 = conn.createQuery(getQuery("CorreosUsuarioId"));
			q3.setString("id",code);
			correos = q3.list();
			
		} catch (Exception ex) {
			setErrorMessage("GestorUsuarios[DatosUsuarioPDF]: "+ex);
		}
	}
	
	/***/
	public void ModificaUsuario(Session conn){
		try 
		{
			Query q = null;
			q = conn.createQuery(getQuery("UsuarioId"));
			q.setString("id",this.Usu);
			usuarios = q.list();
			
			usuario = (D7LdapDatosPersonales) usuarios.get(0);
			
			if(this.Notas!= null)usuario.setDatNotas(this.Notas);
			if(this.Cargo!= null)usuario.setDatCargo(this.Cargo);
			if(this.FechaBaja!= null)usuario.setDatFechaBaja(this.FechaBaja);
			conn.update(usuario);
			conn.flush();
			conn.connection().commit();
			usuarios.remove(usuario);
		} catch (Exception ex) {
			setErrorMessage("GestorUsuarios[ModificarUsuario]: "+ex);
		}
	}
	
	public void EliminaCorreo(Session conn,String cor){
		try 
		{
			Query q = null;
			q = conn.createQuery(getQuery("ObtenerCorreo"));
			q.setString("id",this.Usu);
			q.setString("correo",cor);
			this.correos = q.list();
			
			correo = (D7DatosCorreo) correos.get(0);
			
			conn.delete(correo);
			conn.flush();
			conn.connection().commit();
			correos.remove(correo);
		} catch (Exception ex) {
			setErrorMessage("GestorUsuarios[EliminarCorreo]: "+ex);
		}
	}
	public void NuevoCorreo(Session conn){
		try 
		{
			D7DatosCorreo corr = new D7DatosCorreo();
			corr.setIdentificador(this.Usu);
			corr.setCorreo(this.Correo);
			corr.setCuenta(this.Cuenta);
			
			conn.save(corr);
			conn.flush();
			conn.connection().commit();
			corr = null;
		} catch (Exception ex) {
			setErrorMessage("GestorUsuarios[InsertarCorreo]: "+ex);
		}
	}
	public void ActualizarCorreo(Session conn,String corr){
		Transaction tx = null;
		try 
		{	
			/**Realizamos una query con el correo antiguo(que es el id), y lo recuperamos*/
			Query q = null;
			q = conn.createQuery(getQuery("ObtenerCorreo"));
			q.setString("id",this.Usu);
			q.setString("correo",corr);
			correos = q.list();
			
			correo = (D7DatosCorreo) correos.get(0);
			
			/**Si no ha cambiado el correo(primary key) simplemente actualizo la cuenta*/
			if (this.Correo.equals(corr)){
				correo.setCuenta(this.Cuenta);
				conn.update(correo);
				conn.flush();
				conn.connection().commit();
				correos =null;
			}
			else{
				/**Si se pretente modificar el correo(primary key) entonces tengo que eliminarlo y crear 
				 * uno nuevo con otro correo*/
				
				//Creamos transaccin para poder hacer revert si sucede algn error
				tx = conn.beginTransaction();
				conn.delete(correo);
				
				D7DatosCorreo NuevoCorreo = new D7DatosCorreo(this.Usu);
				NuevoCorreo.setCorreo(this.Correo);
				NuevoCorreo.setCuenta(this.Cuenta);
				
				conn.save(NuevoCorreo);
				tx.commit();
			}
			correos =null;
		}
		catch(ConstraintViolationException Cve){
			correos = null;
			tx.rollback();
			setErrorMessage("Correo duplicado!");
		} 
		catch (Exception ex) {
			correos = null;
			tx.rollback();
			setErrorMessage("GestorUsuarios[ActualizarCorreo]: "+ex);
		}
		
	}
	
	public void EliminaIp(Session conn,String direccion){
		try 
		{
			Query q = null;
			q = conn.createQuery(getQuery("ObtenerIp"));
			q.setString("id",this.Usu);
			q.setString("direccion",direccion);
			this.ips = q.list();
			
			ip = (D7DatosIp) ips.get(0);
			
			conn.delete(ip);
			conn.flush();
			conn.connection().commit();
			ips.remove(ip);
		} catch (Exception ex) {
			setErrorMessage("GestorUsuarios[EliminarIp]: "+ex);
		}
	}
	public void NuevaIp(Session conn){
		try 
		{
			D7DatosIp ip = new D7DatosIp();
			ip.setIdentificador(this.Usu);
			ip.setIp(this.Ip);
			ip.setHost(this.Host);
			ip.setMac(this.Mac);
			ip.setRoseta(this.Roseta);
			ip.setCampus(this.Campus);
			ip.setFechaSolicitud(this.FechaSolicitud);
			
			conn.save(ip);
			conn.flush();
			conn.connection().commit();
			ip = null;
		} catch (Exception ex) {
			setErrorMessage("GestorUsuarios[InsertarIp]: "+ex);
		}
	}
	public void ActualizarIp(Session conn, String direccion){
		Transaction tx = null;
		try 
		{	
			Query q = null;
			q = conn.createQuery(getQuery("ObtenerIp"));
			q.setString("id",this.Usu);
			q.setString("direccion",direccion);
			this.ips = q.list();
			
			ip = (D7DatosIp) ips.get(0);
			
			/**Si no ha cambiado la ip(primary key) actualizo todos los campos excepto ese*/
			if (this.Ip.equals(direccion)){
				ip.setHost(this.Host);
				ip.setMac(this.Mac);
				ip.setRoseta(this.Roseta);
				ip.setCampus(this.Campus);
				ip.setFechaSolicitud(this.FechaSolicitud);
			
				conn.update(ip);
				conn.flush();
				conn.connection().commit();
			}
			else{
				/**Si se pretente modificar la ip(primary key) entonces tengo que eliminarla y crear 
				 * una nueva con otra ip*/
				
				//Creamos transaccin para poder hacer revert si sucede algn error
				tx = conn.beginTransaction();
				conn.delete(ip);
				
				D7DatosIp NuevaIp = new D7DatosIp(this.Usu,this.Ip);
				NuevaIp.setHost(this.Host);
				NuevaIp.setMac(this.Mac);
				NuevaIp.setRoseta(this.Roseta);
				NuevaIp.setCampus(this.Campus);
				NuevaIp.setFechaSolicitud(this.FechaSolicitud);
				
				conn.save(NuevaIp);
				tx.commit();
			}
			ips = null;
		}
		catch(ConstraintViolationException Cve){
			ips = null;
			tx.rollback();
			setErrorMessage("Direccin Ip duplicada!");
		}
		catch (Exception ex) {
			ips = null;
			tx.rollback();
			setErrorMessage("GestorUsuarios[ActualizarIp]: "+ex);
		}
	}

}
