<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet version="1.0"
     xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	 xmlns:xforms="http://www.w3.org/2002/xforms" 
     xmlns:fo="http://www.w3.org/1999/XSL/Format" >

<xsl:param name="servlet"/>
<xsl:param name="menu"/>

<!--Codigo del usuario-->
<xsl:param name="id"/>
	
<xsl:include href="dumbo7/utils/xsl/utils.xsl"/>

<xsl:template match="XMLROOT">
	<fo:root>
		<fo:layout-master-set >

			<fo:simple-page-master master-name="simple"
					page-height="29.7cm"
					page-width="21cm"
					margin-top="0.5cm" 
					margin-bottom="1.5cm" 
					margin-left="2cm" 
					margin-right="2cm">
				<fo:region-body border="0.25pt solid silver" margin-top="1cm" margin-bottom="0.5cm"/>
				<fo:region-before border="0.25pt solid silver" />
				<fo:region-after extent="0.5cm"/>
			</fo:simple-page-master>
		</fo:layout-master-set>

<fo:page-sequence master-reference="simple" >
				
		<fo:static-content flow-name="xsl-region-before">
    <fo:block background-color="#000000">
	<!--CABECERA DUMBO-->
    </fo:block>
  </fo:static-content>
		
		<!--PIE DUMBO-->
		<fo:static-content flow-name="xsl-region-after">
			<fo:table>
				<fo:table-column column-number="1"/>
				<fo:table-column column-number="2"/>
				<fo:table-column column-number="3"/>
		
				<fo:table-body>
					<fo:table-row>
						<!--Pie de pgina-->
						<fo:table-cell number-columns-spanned="2">
							<!--Lo pone en la primera pgina-->
							 <fo:block text-align="left" font-size="8pt">
								<!--(C) 2005. ATICA. Vicerrectorado de Investigacin y Nuevas Tecnologas-->
								<xsl:value-of select="DATA/ALERTAS/PARAMETRO[@PARAMETRO='PAR_PIE_NOTIF']/@VALOR"/>
							</fo:block>
							<!--Lo pone en las siguientes-->
							 <fo:block text-align="left" font-size="8pt"  break-before="page">
								<xsl:value-of select="DATA/ALERTAS/PARAMETRO[@PARAMETRO='PAR_PIE_NOTIF']/@VALOR"/>
							</fo:block>
						</fo:table-cell>
						
						<!--Numeracin del pie-->
						<fo:table-cell>
							<!--Lo pone en la primera pgina-->
			               <fo:block text-align="right" font-size="8pt">
					          <fo:page-number/>
			               </fo:block>
						   <!--Lo pone en las siguientes-->
						   <fo:block text-align="right" font-size="8pt" break-before="page"> 
		                     <fo:page-number/>
					       </fo:block>
						</fo:table-cell>
					</fo:table-row>
				</fo:table-body>
			</fo:table>
          </fo:static-content>
		<fo:flow flow-name="xsl-region-body">
			<xsl:apply-templates/>
		</fo:flow>
</fo:page-sequence>
	</fo:root>	
</xsl:template>

<!--CUERPO PDF-->
<xsl:template match="DATA">
	<fo:block text-align="right"><fo:external-graphic src="/www/dumbo/web_dumbo/graficos/dumboD7.jpg" width="6cm" height="2cm"/></fo:block>
	<fo:block text-align="center" font-size="16">&#160;</fo:block>
	<fo:block text-align="center" font-size="22" color="#000000" text-decoration="underline">DATOS DEL SOLICITANTE
	</fo:block>	
	<fo:block text-align="center" font-size="16">&#160;</fo:block>
	<fo:block text-align="center" font-size="16">&#160;</fo:block>
	<xsl:apply-templates/>
</xsl:template>

<xsl:template match="DATOS_USUARIOS">
		<!--Tabla para los datos personales-->
		<fo:table border="0.25pt solid silver">
			<fo:table-column column-number="1" column-width="25mm"/>
			<fo:table-column column-number="2" column-width="85mm"/>
			<fo:table-column column-number="3" column-width="25mm"/>
			<fo:table-column column-number="4"/>
			
			<fo:table-header background-color="#000000">
				<fo:table-row>
					<fo:table-cell number-columns-spanned="2">
						<fo:block font-weight="bold" color="#FFFFFF" 
							font-size="12pt">Datos personales LDAP
						</fo:block>
					</fo:table-cell>
				</fo:table-row>
			</fo:table-header>
			<fo:table-body text-align="left" start-indent="3pt">
				<fo:table-row>
					<fo:table-cell>
						<fo:block font-size="9pt" 
							start-indent="10pt"		 
							font-family="sans-serif" 
							line-height="20pt"
							space-after.optimum="0pt"
							font-weight="bold"
							text-align="right">
							Nombre:
						</fo:block>
					</fo:table-cell>
					<fo:table-cell>
						<fo:block font-size="9pt" 
							start-indent="10pt"		 
							font-family="sans-serif" 
							line-height="20pt"
							space-after.optimum="0pt"
							text-align="left">
							<xsl:value-of select="USUARIO/@NOMBRE"/>&#160;<xsl:value-of select="USUARIO/@APELLIDOS"/>
						</fo:block>
					</fo:table-cell>
					<fo:table-cell>
						<fo:block font-size="9pt" 
							start-indent="10pt"		 
							font-family="sans-serif" 
							line-height="20pt"
							space-after.optimum="0pt"
							font-weight="bold"
							text-align="right">
							Tipo:&#160;
						</fo:block>
					</fo:table-cell>
					<fo:table-cell>
						<fo:block font-size="9pt" 
							start-indent="10pt"		 
							font-family="sans-serif" 
							line-height="20pt"
							space-after.optimum="0pt"
							text-align="left">
							<xsl:if test="count(USUARIO/@TIPO)!=0">
								<xsl:value-of select="USUARIO/@TIPO"/>
							</xsl:if>
							<xsl:if test="count(USUARIO/@TIPO)=0">
								-Sin introducir.-
							</xsl:if>
						</fo:block>
					</fo:table-cell>
				</fo:table-row>
				<fo:table-row>
					<fo:table-cell>
						<fo:block font-size="9pt" 
							start-indent="10pt"		 
							font-family="sans-serif" 
							line-height="20pt"
							font-weight="bold"
							space-after.optimum="0pt"
							text-align="right">
								Departamento:&#160;
						</fo:block>
					</fo:table-cell>
					<fo:table-cell>
						<fo:block font-size="9pt" 
							start-indent="10pt"		 
							font-family="sans-serif" 
							line-height="20pt"
							space-after.optimum="0pt"
							text-align="left">
							<xsl:if test="count(USUARIO/@DEPTO)!=0">
								<xsl:value-of select="USUARIO/@DEPTO"/>
							</xsl:if>
							<xsl:if test="count(USUARIO/@DEPTO)=0">
								-Sin introducir.-
							</xsl:if>
						</fo:block>
					</fo:table-cell>
					<fo:table-cell>
						<fo:block font-size="9pt" 
							start-indent="10pt"		 
							font-family="sans-serif" 
							font-weight="bold"
							line-height="20pt"
							space-after.optimum="0pt"
							text-align="right">
								Telfono:&#160;
						</fo:block>
					</fo:table-cell>
					<fo:table-cell>
						<fo:block font-size="9pt" 
							start-indent="10pt"		 
							font-family="sans-serif" 
							line-height="20pt"
							space-after.optimum="0pt"
							text-align="left">
							<xsl:if test="count(USUARIO/@TELEFONO)!=0">
								<xsl:value-of select="USUARIO/@TELEFONO"/>
							</xsl:if>
							<xsl:if test="count(USUARIO/@TELEFONO)=0">
								-Sin introducir.-
							</xsl:if>
						</fo:block>
					</fo:table-cell>
				</fo:table-row>
				<fo:table-row>
					<fo:table-cell>
						<fo:block font-size="9pt" 
							start-indent="10pt"		 
							font-family="sans-serif" 
							line-height="20pt"
							font-weight="bold"
							space-after.optimum="0pt"
							text-align="right">
								rea:&#160;
						</fo:block>
					</fo:table-cell>
					<fo:table-cell number-columns-spanned="2">
						<fo:block font-size="9pt" 
							start-indent="10pt"		 
							font-family="sans-serif" 
							line-height="20pt"
							space-after.optimum="0pt"
							text-align="left">
							<xsl:if test="count(USUARIO/@AREA)!=0">
								<xsl:value-of select="USUARIO/@AREA"/>
							</xsl:if>
							<xsl:if test="count(USUARIO/@AREA)=0">
								-Sin introducir.-
							</xsl:if>
						</fo:block>
					</fo:table-cell>
				</fo:table-row>
				<fo:table-row>
					<fo:table-cell>
						<fo:block font-size="9pt" 
							start-indent="10pt"		 
							font-family="sans-serif" 
							line-height="20pt"
							font-weight="bold"
							space-after.optimum="0pt"
							text-align="right">
								Ubicacin:&#160;
						</fo:block>
					</fo:table-cell>
					<fo:table-cell number-columns-spanned="5">
						<fo:block font-size="9pt" 
							start-indent="10pt"		 
							font-family="sans-serif" 
							line-height="20pt"
							space-after.optimum="0pt"
							text-align="left">
							<xsl:if test="count(USUARIO/@CENTRO)!=0">
								<xsl:value-of select="USUARIO/@CENTRO"/>
							</xsl:if>
							<xsl:if test="count(USUARIO/@CENTRO)=0">
								-Sin introducir.-
							</xsl:if>
						</fo:block>
					</fo:table-cell>
				</fo:table-row>
				<fo:table-row>
					<fo:table-cell>
						<fo:block font-size="9pt" 
							start-indent="10pt"		 
							font-family="sans-serif" 
							line-height="20pt"
							font-weight="bold"
							space-after.optimum="0pt"
							text-align="right">
								Correo ppal:&#160;
						</fo:block>
					</fo:table-cell>
					<fo:table-cell number-columns-spanned="5">
						<fo:block font-size="9pt" 
							start-indent="10pt"		 
							font-family="sans-serif" 
							line-height="20pt"
							space-after.optimum="0pt"
							text-align="left">
							<xsl:if test="count(USUARIO/@EMAIL)!=0">
								<xsl:value-of select="USUARIO/@EMAIL"/>
							</xsl:if>
							<xsl:if test="count(USUARIO/@EMAIL)=0">
								-Sin introducir.-
							</xsl:if>
						</fo:block>
					</fo:table-cell>
				</fo:table-row>
			</fo:table-body>
		</fo:table>
		<fo:block text-align="center" font-size="16">&#160;</fo:block>
		<!--Tabla para los correos-->
		<fo:table border="0.25pt solid silver">
			<fo:table-column column-number="1"/>
			<fo:table-column column-number="2"/>
			<fo:table-column column-number="3"/>
			
			<fo:table-header background-color="#000000">
				<fo:table-row>
					<fo:table-cell>
						<fo:block font-weight="bold" color="#FFFFFF" font-size="12pt">
							Datos de la cuenta
						</fo:block>
					</fo:table-cell>
				</fo:table-row>
			</fo:table-header>
			<fo:table-body text-align="left" start-indent="3pt">
				<xsl:if test="count(CORREO)=0">
					<fo:table-row>
						<fo:table-cell>
							<fo:block font-size="9pt" 
								start-indent="10pt"		 
								font-family="sans-serif" 
								line-height="20pt"
								space-after.optimum="0pt"
								text-align="center">
								No hay datos disponibles							
							</fo:block>
						</fo:table-cell>
					</fo:table-row>
				</xsl:if>
				<xsl:if test="count(CORREO)!=0">
					<fo:table-row>
						<fo:table-cell>
							<fo:block font-size="9pt" 
								start-indent="10pt"		 
								font-family="sans-serif" 
								line-height="20pt"
								space-after.optimum="0pt"
								font-weight="bold"
								text-align="left">
								e-mail
							</fo:block>
						</fo:table-cell>
						<fo:table-cell>
							<fo:block font-size="9pt" 
								start-indent="10pt"		 
								font-family="sans-serif" 
								line-height="20pt"
								space-after.optimum="0pt"
								font-weight="bold"
								text-align="left">
								Cuenta
							</fo:block>
						</fo:table-cell>
						<fo:table-cell>
							<fo:block font-size="9pt" 
								start-indent="10pt"		 
								font-family="sans-serif" 
								line-height="20pt"
								space-after.optimum="0pt"
								font-weight="bold"
								text-align="left">
								Servidor correo entrante
							</fo:block>
						</fo:table-cell>
					</fo:table-row>
					<xsl:for-each select="CORREO">
						<fo:table-row>
						<fo:table-cell>
							<fo:block font-size="9pt" 
								start-indent="10pt"		 
								font-family="sans-serif" 
								line-height="20pt"
								space-after.optimum="0pt"
								text-align="left">
								<xsl:value-of select="@CORREO"/>
							</fo:block>
						</fo:table-cell>
						<fo:table-cell>
							<fo:block font-size="9pt" 
								start-indent="10pt"		 
								font-family="sans-serif" 
								line-height="20pt"
								space-after.optimum="0pt"
								text-align="left">
								<xsl:value-of select="@CUENTA"/>
							</fo:block>
						</fo:table-cell>
						<fo:table-cell>
							<fo:block font-size="9pt" 
								start-indent="10pt"		 
								font-family="sans-serif" 
								line-height="20pt"
								space-after.optimum="0pt"
								text-align="left">
								<xsl:choose>
									<xsl:when test="substring-after(@CORREO,@CUENTA)='@alu.upct.es'">
										imap.alu.upct.es
									</xsl:when>
									<xsl:when test="substring-before(substring-after(@CORREO,@CUENTA),'upct.es')!='@alu.' and substring(@CORREO,string-length(@CORREO)-6, string-length(@CORREO))='upct.es'">
										imap.upct.es									
									</xsl:when>
									<xsl:otherwise>
										-
									</xsl:otherwise>
								</xsl:choose>
							</fo:block>
						</fo:table-cell>
					</fo:table-row>
				</xsl:for-each>
				<fo:table-row>
					<fo:table-cell>
						<fo:block>&#160;</fo:block>
					</fo:table-cell>
				</fo:table-row>
				<fo:table-row>
					<fo:table-cell>
						<fo:block font-size="9pt" 
							start-indent="10pt"		 
							font-family="sans-serif" 
							line-height="20pt"
							space-after.optimum="0pt"
							font-weight="bold"
							text-align="left">
							Servidor de correo saliente:
						</fo:block>
					</fo:table-cell>
					<fo:table-cell>
						<fo:block font-size="9pt" 
							start-indent="10pt"		 
							font-family="sans-serif" 
							line-height="20pt"
							space-after.optimum="0pt"
							text-align="left">
							mail.upct.es
						</fo:block>
					</fo:table-cell>
				</fo:table-row>
				
				</xsl:if>
			</fo:table-body>
		</fo:table>
		<fo:block text-align="center" font-size="16">&#160;</fo:block>
		<!--Tabla para los datos de red-->
		<fo:table border="0.25pt solid silver">
			<fo:table-column column-number="1" column-width="30mm"/>
			<fo:table-column column-number="2"/>
			<fo:table-column column-number="3" column-width="35mm"/>
			<fo:table-column column-number="4"/>
			<fo:table-column column-number="5" column-width="20mm"/>
			<fo:table-column column-number="6"/>
			
			<fo:table-header background-color="#000000">
				<fo:table-row>
					<fo:table-cell number-columns-spanned="6">
						<fo:block font-weight="bold" color="#FFFFFF" font-size="12pt">
							Datos de red
						</fo:block>
					</fo:table-cell>
				</fo:table-row>
			</fo:table-header>
			<fo:table-body text-align="left" start-indent="3pt">
				<xsl:if test="count(DATOS_RED)=0">
					<fo:table-row>
						<fo:table-cell>
							<fo:block font-size="9pt" 
								start-indent="10pt"		 
								font-family="sans-serif" 
								line-height="20pt"
								space-after.optimum="0pt"
								text-align="center">
								No hay datos disponibles							
							</fo:block>
						</fo:table-cell>
					</fo:table-row>
				</xsl:if>
				<xsl:for-each select="DATOS_RED">
					<xsl:if test="position()!=1">
						<fo:table-row>
							<fo:table-cell number-columns-spanned="6">
								<fo:block border-bottom="1pt solid #808080"/>
							</fo:table-cell>
						</fo:table-row>
					</xsl:if>
					<fo:table-row>
						<fo:table-cell>
							<fo:block font-size="9pt" 
								start-indent="10pt"		 
								font-family="sans-serif" 
								line-height="20pt"
								space-after.optimum="0pt"
								font-weight="bold"
								text-align="right">
								Fecha solicitud:
							</fo:block>
						</fo:table-cell>
						<fo:table-cell>
							<fo:block font-size="9pt" 
								start-indent="10pt"		 
								font-family="sans-serif" 
								line-height="20pt"
								space-after.optimum="0pt"
								text-align="left">
								<xsl:call-template name="date2String2"><xsl:with-param name="fecha" select="DATOS_IP/@FECHA_SOLICITUD"/></xsl:call-template>
							</fo:block>
						</fo:table-cell>
					</fo:table-row>
					<fo:table-row>
						<fo:table-cell>
							<fo:block font-size="9pt" 
								start-indent="10pt"		 
								font-family="sans-serif" 
								line-height="20pt"
								space-after.optimum="0pt"
								font-weight="bold"
								text-align="right">
								Host:&#160;
							</fo:block>
						</fo:table-cell>
						<fo:table-cell>
							<fo:block font-size="9pt" 
								start-indent="10pt"		 
								font-family="sans-serif" 
								line-height="20pt"
								space-after.optimum="0pt"
								text-align="left">
								<xsl:value-of select="DATOS_IP/@HOST"/>
							</fo:block>
						</fo:table-cell>
						<fo:table-cell>
							<fo:block font-size="9pt" 
								start-indent="10pt"		 
								font-family="sans-serif" 
								line-height="20pt"
								space-after.optimum="0pt"
								font-weight="bold"
								text-align="right">
								Router en:&#160;
							</fo:block>
						</fo:table-cell>
						<fo:table-cell>
							<fo:block font-size="9pt" 
								start-indent="10pt"		 
								font-family="sans-serif" 
								line-height="20pt"
								space-after.optimum="0pt"
								text-align="left">
								<xsl:value-of select="DATOS_RED/@CAMPUS"/>
							</fo:block>
						</fo:table-cell>
						<fo:table-cell>
							<fo:block font-size="9pt" 
								start-indent="10pt"		 
								font-family="sans-serif" 
								line-height="20pt"
								space-after.optimum="0pt"
								font-weight="bold"
								text-align="right">
								Roseta:&#160;
							</fo:block>
						</fo:table-cell>
						<fo:table-cell>
							<fo:block font-size="9pt" 
								start-indent="10pt"		 
								font-family="sans-serif" 
								line-height="20pt"
								space-after.optimum="0pt"
								text-align="left">
								<xsl:value-of select="DATOS_IP/@ROSETA"/>
							</fo:block>
						</fo:table-cell>
					</fo:table-row>
					<fo:table-row>
						<fo:table-cell>
							<fo:block font-size="9pt" 
								start-indent="10pt"		 
								font-family="sans-serif" 
								line-height="20pt"
								space-after.optimum="0pt"
								font-weight="bold"
								text-align="right">
								Direccin IP:&#160;
							</fo:block>
						</fo:table-cell>
						<fo:table-cell>
							<fo:block font-size="9pt" 
								start-indent="10pt"		 
								font-family="sans-serif" 
								line-height="20pt"
								space-after.optimum="0pt"
								text-align="left">
								<xsl:value-of select="DATOS_IP/@IP"/>
							</fo:block>
						</fo:table-cell>
						<fo:table-cell>
							<fo:block font-size="9pt" 
								start-indent="10pt"		 
								font-family="sans-serif" 
								line-height="20pt"
								space-after.optimum="0pt"
								font-weight="bold"
								text-align="right">
								Puerta enlace:&#160;
							</fo:block>
						</fo:table-cell>
						<fo:table-cell>
							<fo:block font-size="9pt" 
								start-indent="10pt"		 
								font-family="sans-serif" 
								line-height="20pt"
								space-after.optimum="0pt"
								text-align="left">
								<xsl:value-of select="DATOS_RED/@PUERTA"/>
							</fo:block>
						</fo:table-cell>
						<fo:table-cell>
							<fo:block font-size="9pt" 
								start-indent="10pt"		 
								font-family="sans-serif" 
								line-height="20pt"
								space-after.optimum="0pt"
								font-weight="bold"
								text-align="right">
								Mscara:&#160;
							</fo:block>
						</fo:table-cell>
						<fo:table-cell>
							<fo:block font-size="9pt" 
								start-indent="10pt"		 
								font-family="sans-serif" 
								line-height="20pt"
								space-after.optimum="0pt"
								text-align="left">
								<xsl:value-of select="DATOS_RED/@MASCARA"/>
							</fo:block>
						</fo:table-cell>
						</fo:table-row>
						<fo:table-row>
						<fo:table-cell>
							<fo:block font-size="9pt" 
								start-indent="10pt"		 
								font-family="sans-serif" 
								line-height="20pt"
								space-after.optimum="0pt"
								font-weight="bold"
								text-align="right">
								DNS primario:&#160;
							</fo:block>
						</fo:table-cell>
						<fo:table-cell>
							<fo:block font-size="9pt" 
								start-indent="10pt"		 
								font-family="sans-serif" 
								line-height="20pt"
								space-after.optimum="0pt"
								text-align="left">
								<xsl:value-of select="DATOS_RED/@DNS1"/>
							</fo:block>
						</fo:table-cell>
						<fo:table-cell>
							<fo:block font-size="9pt" 
								start-indent="10pt"		 
								font-family="sans-serif" 
								line-height="20pt"
								space-after.optimum="0pt"
								font-weight="bold"
								text-align="right">
								DNS secundario:&#160;
							</fo:block>
						</fo:table-cell>
						<fo:table-cell>
							<fo:block font-size="9pt" 
								start-indent="10pt"		 
								font-family="sans-serif" 
								line-height="20pt"
								space-after.optimum="0pt"
								text-align="left">
								<xsl:value-of select="DATOS_RED/@DNS2"/>
							</fo:block>
						</fo:table-cell>
						<fo:table-cell>
							<fo:block font-size="9pt" 
								start-indent="10pt"		 
								font-family="sans-serif" 
								line-height="20pt"
								space-after.optimum="0pt"
								font-weight="bold"
								text-align="right">
								WINS:&#160;
							</fo:block>
						</fo:table-cell>
						<fo:table-cell>
							<fo:block font-size="9pt" 
								start-indent="10pt"		 
								font-family="sans-serif" 
								line-height="20pt"
								space-after.optimum="0pt"
								text-align="left">
								<xsl:value-of select="DATOS_RED/@WINS"/>
							</fo:block>
						</fo:table-cell>
					</fo:table-row>
				</xsl:for-each>
			</fo:table-body>
		</fo:table>
</xsl:template>

<xsl:template name="cuerpo"/>

</xsl:stylesheet>

