<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet version="1.0" 
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:xforms="http://www.w3.org/2002/xforms">

<xsl:output method="html"/>

<xsl:param name="servlet"/>	
<xsl:param name="menu"/>
<xsl:param name="ip"/>
<xsl:param name="host"/>
<xsl:param name="ajx"/>


<xsl:include href="dumbo7/utils/xsl/utils.xsl"/>
<xsl:include href="dumbo7/gestion/usuarios/html/detalleUser.xsl"/>

<xsl:template match="XMLROOT">
		<html lang="es">
			<xsl:call-template name="headComun">
				<xsl:with-param name="calendar" select="true()"/>
				<xsl:with-param name="ERROR" select="DATA/DATOS_USUARIOS/@ERROR"/>
				 <xsl:with-param name="jscript">
					<script LANGUAJE="JavaScript">
						function mostrarError(error){
							alert(error);
						}
						<!--Javascript para PDF-->
						function abre_PDF(url)
						{
							url = url.concat("&amp;id=");
							url = url.concat(<xsl:value-of select="DATA/DATOS_USUARIOS/USUARIO/@IDENTIFICADOR"/>);
							newWindow = window.open(url,'_blanck');
						}
						<!---->
						
						function selectDateBaja(calendar, date){
						if (calendar.dateClicked){
							if (document.ModificaUsuario.fechaBaja.value == date) document.ModificaUsuario.fechaBaja.value = '';
								else document.ModificaUsuario.fechaBaja.value = date;
								calendar.hide();
							}
						}
						
						function selectDateSolicitud(calendar, date){
						if (calendar.dateClicked){
							if (document.ModificaUsuario.NuevaFechaSolicitud.value == date) document.NuevaFechaSolicitud.value = '';
								else document.ModificaUsuario.NuevaFechaSolicitud.value = date;
								calendar.hide();
							}
						}
						
						function clearUsuario(){
							document.ConsultaIpHost.ajx.value = '';
							document.ConsultaIpHost.submit();
						}
						function ConfigRed(ip,campus){
							var url = '?module=dumbo7/gestion/usuarios.index.ConfigRed';
							url = url.concat("&amp;ip="+ip);
							url = url.concat("&amp;campus="+campus);
							newWindow = window.open(url,'_blanck',"width=700,height=150,left=100,top=100,status=no,toolbar=no,menubar=no,location=no");
						}
						function buscarIp(){
							document.ConsultaIpHost.ajx.value = 1;
							document.ConsultaIpHost.submit();
						}
						function buscarHost(){
							document.ConsultaIpHost.ajx.value = 1;
							document.ConsultaIpHost.submit();
						}
						function marca(obj,chk,objb){
							obj.disabled = !chk.checked;
							objb.disabled = chk.checked;
							document.getElementById(obj.name).disabled = !chk.checked;
							document.getElementById(objb.name).disabled = chk.checked;
							if (!obj.disabled) obj.focus();
							if (!objb.disabled) objb.focus();
						}
						function ConsultarHistorico(){
							var url = '?module=dumbo7/gestion/usuarios.indexIp.HistoricoTareas';
							url = url.concat("&amp;selected=");
							url = url.concat('<xsl:value-of select="DATA/DATOS_USUARIOS/USUARIO/@IDENTIFICADOR"/>');
							newWindow = window.open(url,'_blanck',"width=750,height=600,left=100,top=100,status=no,toolbar=no,menubar=no,location=no,scrollbars=yes");
						}
					</script>
				<script LANGUAJE="JavaScript" src="../js/OnMouse.js"></script>
				<script LANGUAJE="JavaScript" src="../js/metricas/Calendario.js"></script>
				</xsl:with-param>
			 </xsl:call-template>
			
			<body>
				<xsl:call-template name="menuComun">
					<xsl:with-param name="NAME" select="concat(DATA/DATOS_USUARIOS/USER/@NAME,concat('(',concat(DATA/DATOS_USUARIOS/USER/@LOGIN,')')))"/>
					<xsl:with-param name="MENU" select="DATA/MENU"/>
					<xsl:with-param name="SELECT" select="$menu"/>
				</xsl:call-template>
				
				<xsl:call-template name="pieComun"/>
			</body>
		</html>
</xsl:template>

<xsl:template name="cuerpo">
		<xsl:for-each select="DATA/DATOS_USUARIOS">
			<xsl:if test="not(@ERROR='')">
				<script>mostrarError('<xsl:value-of select="@ERROR"/>')</script>
				</xsl:if>
		</xsl:for-each>
	<table border="0" cellpadding="5" align="center" cellspacing="5" width="780" summary="Esta tabla contiene la gestion de usuarios">
	<tr>
		<td width="650" class="cab1">&#187;Bsqueda de Ip-Host</td>
		<xsl:if test="$ajx = 1">
			<xsl:if test="DATA/DATOS_USUARIOS/USUARIO">
				<td width="10" align="center"><b><a href="javascript:abre_PDF('?module=dumbo7/gestion/usuarios.index.informePDF');"><img border="0" src="../graficos/iconos/ico_impresora.gif" alt="Imprimir"/></a></b></td>
			</xsl:if>
		</xsl:if>
	</tr>
	<tr><td colspan="2">
		<form action="{$servlet}" METHOD="POST" name="ConsultaIpHost">
			<input type="hidden" name="module" value="dumbo7/gestion/usuarios.indexIp"/>
			<input type="hidden" name="ajx"/>
			<table class="cont" id="usuarios" border="0" cellpadding="3" cellspacing="1" width="100%" summary="Esta tabla contiene usuarios">
				<tr class="administracion">
					<xsl:if test="$ajx != 1">
						<td width="5"><input type="radio" name="criterio" checked="true" onclick="marca(document.ConsultaIpHost.Ip,this,document.ConsultaIpHost.Host);"/></td>
						<td width="80">Direccin&#160;Ip:</td>
						<td><input type="text" name="Ip" size="20" maxlength="15" value="{$ip}" onChange="javascript:buscarIp();"/></td>
					</xsl:if>
					<xsl:if test="$ajx = 1">
						<xsl:if test="DATA/DATOS_USUARIOS/USUARIO">
							<td width="5"><input type="radio" name="criterio" checked="true" onclick="marca(document.ConsultaIpHost.Ip,this,document.ConsultaIpHost.Host);" disabled="true"/></td>
							<td width="80">Direccin&#160;Ip:</td>
							<td><input type="text" name="Ip" size="20" maxlength="15" value="{$ip}" onChange="javascript:buscarIp();" disabled="true"/></td>
						</xsl:if>
						<xsl:if test="not(DATA/DATOS_USUARIOS/USUARIO)">
							<td width="5"><input type="radio" name="criterio" checked="true" onclick="marca(document.ConsultaIpHost.Ip,this,document.ConsultaIpHost.Host);"/></td>
							<td width="80">Direccin&#160;Ip:</td>
							<td><input type="text" name="Ip" size="20" maxlength="15" value="{$ip}" onChange="javascript:buscarIp();"/></td>
						</xsl:if>
					</xsl:if>
					<!--<td rowspan="2">
						<input class="boton" type="button" value="Buscar" onclick="buscar();"/>&#160;
					</td>-->
				</tr>
				<xsl:if test="$ajx != 1">
					<tr class="administracion">
						<td width="5"><input type="radio" name="criterio" onclick="marca(document.ConsultaIpHost.Host,this,document.ConsultaIpHost.Ip);"/></td>
						<td width="80">Host:</td>
						<td><input type="text" name="Host" size="20" value="{$host}" onChange="javascript:buscarHost();" disabled="true"/></td>
					</tr>
				</xsl:if>
				<xsl:if test="$ajx = 1">
					<xsl:if test="DATA/DATOS_USUARIOS/USUARIO">
						<tr class="administracion">
							<td width="5"><input type="radio" name="criterio" onclick="marca(document.ConsultaIpHost.Host,this,document.ConsultaIpHost.Ip);" disabled="true"/></td>
							<td width="80">Host:</td>
							<td><input type="text" name="Host" size="20" value="{$host}" onChange="javascript:buscarHost();" disabled="true"/></td>
						</tr>
					</xsl:if>
					<xsl:if test="not(DATA/DATOS_USUARIOS/USUARIO)">
						<tr class="administracion">
							<td width="5"><input type="radio" name="criterio" onclick="marca(document.ConsultaIpHost.Host,this,document.ConsultaIpHost.Ip);"/></td>
							<td width="80">Host:</td>
							<td><input type="text" name="Host" size="20" value="{$host}" onChange="javascript:buscarHost();" disabled="true"/></td>
						</tr>
						<tr class="administracion"><td colspan="3"><font size="2" color="red">No se han encontrado Resultados!</font></td></tr>
					</xsl:if>
				</xsl:if>
			</table>
		</form>
		<xsl:call-template name="Detalle"/>
	</td></tr>
	</table>
	
</xsl:template>

<xsl:template name="Detalle">
	<xsl:if test="$ajx = '1'">
		<xsl:if test="DATA/DATOS_USUARIOS/USUARIO">
			<xsl:call-template name="detail">
				<xsl:with-param name="selected" select="$ip"/>
				<xsl:with-param name="busquedaIp" select="true"/>
			</xsl:call-template>
		</xsl:if>
	</xsl:if>
</xsl:template>

</xsl:stylesheet>