/*
 * 
 *
 */
package dumbo7.informacion;

import java.util.*;
import org.apache.log4j.*;
import org.hibernate.*;
import dumbo7.user.*;
import dumbo7.utils.*;
import atica.frameweb.utils.*;

/**
 * @author Universidad de Murcia - ATICA
 *
 */

public class GestorInformacion extends GeneralManager {
	
	static Logger logger = Logger.getLogger(GestorInformacion.class);
	static String SEPARATOR_CHAR = "|";
	public List aplicaciones = null, secciones = null;
	public FiltroUsuario filtro = null;
	public String tipoFiltro = "";
	public Hashtable filtros = null;
	public String aplname = "";
	public String secname = "";
	public String infname = "";
	
	public GestorInformacion() {}

	public void setAplicacionName(String s) { if (s!=null) aplname = s; }
	public void setSeccionName(String s) { if (s!=null) secname = s; }
	public void setInformaticoName(String s) { if (s!=null) infname = s; }
	
	public List getSecciones() { return secciones; }
	
	public List getAplicaciones() { return aplicaciones; }
	
	public void listadoAplicaciones(Session conn) {
		try {
			// Obtiene las aplicaciones ligadas al informatico !!
			Query q = null;
			if (aplname.equals("") && secname.equals("") && infname.equals("")) {
				q = conn.createQuery(getQuery("Aplicaciones_"+tipoFiltro));
				q = q.setString("sist",user.getDatosMenu().idSelected());
				if (useInform(tipoFiltro)) q = q.setString("info",user.getIdentificador());
			} else {
				String code = "";
				String tipo = "";
				if (!aplname.equals("")) { tipo = "apl"; code = aplname.substring(0,aplname.indexOf(SEPARATOR_CHAR)); }
				if (!secname.equals("")) { tipo = "sec"; code = secname.substring(0,secname.indexOf(SEPARATOR_CHAR)); }
				if (!infname.equals("")) { tipo = "inf"; code = infname.substring(0,infname.indexOf(SEPARATOR_CHAR)); }
				if (tipoFiltro.startsWith("global") && tipo.equals("sec")) {
					q = conn.createSQLQuery(getQuery("Aplicaciones_"+tipoFiltro+"_"+tipo)).addEntity("aplicacion",D7Aplicaciones.class);
				} else {
					q = conn.createQuery(getQuery("Aplicaciones_"+tipoFiltro+"_"+tipo));
				}
				q = q.setString("sist",user.getDatosMenu().idSelected());
				q = q.setString("code",code);
			}
			aplicaciones = q.list();
		} catch (Exception ex) {
			setErrorMessage("GestorInformacion[listAplicaciones]: "+ex);
		}
	}

	public void listadoSecciones(Session conn) {
		try {
			// Obtiene las aplicaciones ligadas al informatico !!
			Query q = conn.createQuery(getQuery("Secciones"));
			q = q.setString("sist",user.getDatosMenu().idSelected());
			secciones = q.list();
		} catch (Exception ex) {
			setErrorMessage("GestorInformacion[listSecciones]: "+ex);
		}
	}

	public boolean useInform(String tipo) {
		if (tipo.equals(FiltroUsuario.LISTA_ATENDER)) return true;
		if (tipo.equals(FiltroUsuario.LISTA_ATENDIDAS)) return true;
		if (tipo.equals(FiltroUsuario.LISTA_PENDIENTES)) return true;
		if (tipo.equals(FiltroUsuario.LISTA_RESUELTAS)) return true;
		if (tipo.equals(FiltroUsuario.LISTA_PROGRAMADAS)) return true;
		if (tipo.equals(FiltroUsuario.LISTA_APLICACION)) return true;
		return false;
	}

	public FiltroUsuario getFiltro() { return filtro; }
	
	public void setFiltro() {
		filtro = ((DumboUser)user).getFiltroUsuario(tipoFiltro);
		if (filtro==null) {
			filtro = new FiltroUsuario(tipoFiltro);
			((DumboUser)user).setFiltroUsuario(tipoFiltro,filtro);
		}
	}
	
	public void setTipoFiltro(String t) {
		tipoFiltro = t;
	}

	public void setNewFiltro(FiltroUsuario f) {
		FiltroUsuario act = ((DumboUser)user).getFiltroUsuario(tipoFiltro);
		if (f!=null) filtro = f;
		if (act!=null) filtro.copiaPersonal(act);
	}

	public void setNewPersonal(FiltroUsuario f) {
		FiltroUsuario act = ((DumboUser)user).getFiltroUsuario(tipoFiltro);
		if (f!=null) filtro = f;
		if (act!=null) filtro.copiaFiltro(act);
	}

	public void saveFiltro(Session conn,String save) {
		((DumboUser)user).setFiltroUsuario(tipoFiltro,filtro);
		if ((save!=null) && save.equals("1")) {
			try {
				// Guardo el filtro en BBDD !!
				Transaction tx = conn.beginTransaction();
				D7FiltrosUsuario nuevoFiltro = null;
				int code = FiltroUsuario.filterCode(tipoFiltro);
				Query q = conn.createQuery(getQuery("FiltrosUserCode"));
				q = q.setString("sist",user.getDatosMenu().idSelected());
				q = q.setString("usu",user.getIdentificador());
				q = q.setString("code",""+code);
				List l = q.list();
				if ((l!=null) && l.size()>0) nuevoFiltro = (D7FiltrosUsuario)l.get(0);
				if (nuevoFiltro==null) {
					if (!filtro.getEmpty() || !filtro.getFormat()) {
						nuevoFiltro = new D7FiltrosUsuario();
						nuevoFiltro.setFilSisCod(user.getDatosMenu().idSelected());
						nuevoFiltro.setFilUsuCod(user.getIdentificador());
						nuevoFiltro.setFilCod(new Integer(code));
						nuevoFiltro.setFilFiltro(java.net.URLEncoder.encode(filtro.exportFiltro()));
						conn.save(nuevoFiltro);
					}
				} else {
					if (!filtro.getEmpty() || !filtro.getFormat()) {
						nuevoFiltro.setFilFiltro(java.net.URLEncoder.encode(filtro.exportFiltro()));
						conn.saveOrUpdate(nuevoFiltro);
					} else conn.delete(nuevoFiltro);
				}
				tx.commit();
			} catch (Exception ex) {
				setErrorMessage("GestorInformacion[saveFiltro]: "+((ex.getCause()!=null)?ex.getCause():ex));
			}
		}
			
	}

	public void defaultFiltro(Session conn,String save) {
		FiltroUsuario fil = new FiltroUsuario(tipoFiltro);
		FiltroUsuario act = ((DumboUser)user).getFiltroUsuario(tipoFiltro);
		if (act!=null) fil.copiaPersonal(act);
		((DumboUser)user).setFiltroUsuario(tipoFiltro,fil);
		if ((save!=null) && save.equals("1")) {
			try {
				// Borro el filtro de BBDD !!
				Transaction tx = conn.beginTransaction();
				D7FiltrosUsuario nuevoFiltro = null;
				int code = FiltroUsuario.filterCode(tipoFiltro);
				Query q = conn.createQuery(getQuery("FiltrosUserCode"));
				q = q.setString("sist",user.getDatosMenu().idSelected());
				q = q.setString("usu",user.getIdentificador());
				q = q.setString("code",""+code);
				List l = q.list();
				if ((l!=null) && l.size()>0) nuevoFiltro = (D7FiltrosUsuario)l.get(0);
				if (nuevoFiltro!=null) {
					if (!fil.getFormat()) {
						nuevoFiltro.setFilFiltro(java.net.URLEncoder.encode(fil.exportFiltro()));
						conn.saveOrUpdate(nuevoFiltro);
					} else conn.delete(nuevoFiltro);
				}
				tx.commit();
			} catch (Exception ex) {
				setErrorMessage("GestorInformacion[defaultFiltro]: "+((ex.getCause()!=null)?ex.getCause():ex));
			}
		}
	}

	public void defaultCustom(Session conn,String save) {
		FiltroUsuario fil = new FiltroUsuario(tipoFiltro);
		FiltroUsuario act = ((DumboUser)user).getFiltroUsuario(tipoFiltro);
		if (act!=null) fil.copiaFiltro(act);
		((DumboUser)user).setFiltroUsuario(tipoFiltro,fil);
		if ((save!=null) && save.equals("1")) {
			try {
				// Borro el filtro de BBDD !!
				Transaction tx = conn.beginTransaction();
				D7FiltrosUsuario nuevoFiltro = null;
				int code = FiltroUsuario.filterCode(tipoFiltro);
				Query q = conn.createQuery(getQuery("FiltrosUserCode"));
				q = q.setString("sist",user.getDatosMenu().idSelected());
				q = q.setString("usu",user.getIdentificador());
				q = q.setString("code",""+code);
				List l = q.list();
				if ((l!=null) && l.size()>0) nuevoFiltro = (D7FiltrosUsuario)l.get(0);
				if (nuevoFiltro!=null) {
					if (!fil.getEmpty()) {
						nuevoFiltro.setFilFiltro(java.net.URLEncoder.encode(fil.exportFiltro()));
						conn.saveOrUpdate(nuevoFiltro);
					} else conn.delete(nuevoFiltro);
				}
				tx.commit();
			} catch (Exception ex) {
				setErrorMessage("GestorInformacion[defaultCustom]: "+((ex.getCause()!=null)?ex.getCause():ex));
			}
		}
	}
	
}
