<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet version="1.0" 
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:xforms="http://www.w3.org/2002/xforms">
	
<xsl:param name="servlet"/>	
<xsl:param name="menu"/>
<xsl:param name="listado"/>

<xsl:include href="dumbo7/utils/xsl/utils.xsl"/>
	
<xsl:template match="XMLROOT">

<html lang="es">

	<xsl:call-template name="headComun">
		<xsl:with-param name="calendar" select="true()"/>
		<xsl:with-param name="jscript">
			<SCRIPT LANGUAGE="JavaScript" SRC="../js/utils/filtrarInformacion.js"></SCRIPT>
			<SCRIPT LANGUAGE="JavaScript" SRC="/forja/jquery/jquery.js"></SCRIPT>
			<SCRIPT LANGUAGE="JavaScript">
				var srvName = '<xsl:value-of select="$servlet"/>';
				var userDom = '<xsl:value-of select="DATA/INFORMACION/USER/@DOMINIO"/>';
				var menu= '<xsl:value-of select="$menu"/>'; 
				var listado = '<xsl:value-of select="$listado"/>'; 
				
				$(document).ready(function(){
            		cargaCriterio('A');
            	});
            	
				function cargaCriterio(valor){
					if (valor=='A'){
   						$("td#asunto").show();
   						$("td#texto").hide();
   						$("td#codigo").hide();
					}
					else{
						if (valor=='T'){
   							$("td#asunto").hide();
   							$("td#texto").show();
   							$("td#codigo").hide();
						}
						else{
							$("td#asunto").hide();
   							$("td#texto").hide();
   							$("td#codigo").show();
						}
					}
				}
			</SCRIPT>
		</xsl:with-param>
	</xsl:call-template>

<body>
<br/>
<form name="buscador" action="{$servlet}" method="post">
	<input type="hidden" name="module" value=""/>
	<input type="hidden" name="patron" value=""/>
	<input type="hidden" name="aplcod" value=""/>
</form>
<form name="defecto" action="{$servlet}" method="post">
	<input type="hidden" name="module" value="dumbo7/informacion.filtrarInformacion.defaultFiltroRapido"/>
	<input type="hidden" name="listado" value="{$listado}"/>
	<input type="hidden" name="save" value=""/>
</form>
<form name="f1" action="{$servlet}" method="post">
<input type="hidden" name="module" value="dumbo7/informacion.filtrarInformacion.saveFiltroRapido"/>
<input type="hidden" name="listado" value="{$listado}"/>
<input type="hidden" name="save" value=""/>
<table class="contout" border="0">
<tr class="peticion" colspan="2"><td colspan="2">
	<table>
		<tr id="fechaInicio">
			<td><b>Fecha Creacin:</b></td>
			<td colspan="3">
				Desde&#160;<input type="text" name="inicioDesde" size="12" id="ini_desde" onChange="changeDate(this)"><xsl:attribute name="value"><xsl:call-template name="date2String2"><xsl:with-param name="fecha"><xsl:value-of select="DATA/INFORMACION/FILTRO/@INICIO_DESDE"/></xsl:with-param></xsl:call-template></xsl:attribute></input>&#160;
				<img src="../dumbo7/utils/jscalendar/img.gif" id="trigger_ini_desde"
				style="cursor: pointer; border: 1px solid red;"
			    title="Selecciona Fecha"
				onmouseover="this.style.background='red';"
				onmouseout="this.style.background=''"/>
				<script type="text/javascript">
					Calendar.setup({
						inputField     :    "ini_desde",
						ifFormat       :    "%d/%m/%Y",
						button         :    "trigger_ini_desde",
						align          :    "Tl",
						onSelect       :    selectDateIniDesde,
						singleClick    :    false
					});
				</script>
				&#160;Hasta&#160;<input type="text" name="inicioHasta" size="12" id="ini_hasta" onChange="changeDate(this)"><xsl:attribute name="value"><xsl:call-template name="date2String2"><xsl:with-param name="fecha"><xsl:value-of select="DATA/INFORMACION/FILTRO/@INICIO_HASTA"/></xsl:with-param></xsl:call-template></xsl:attribute></input>&#160;
				<img src="../dumbo7/utils/jscalendar/img.gif" id="trigger_ini_hasta"
				style="cursor: pointer; border: 1px solid red;"
			    title="Selecciona Fecha"
				onmouseover="this.style.background='red';"
				onmouseout="this.style.background=''"/>
				<script type="text/javascript">
					Calendar.setup({
						inputField     :    "ini_hasta",
						ifFormat       :    "%d/%m/%Y",
						button         :    "trigger_ini_hasta",
						align          :    "Tl",
						onSelect       :    selectDateIniHasta,
						singleClick    :    false
					});
				</script>
			</td>
		</tr>
		<xsl:if test="not($listado='pendientes') and not($listado='atender') and not($listado='aplicacion') and not($listado='generica')">
			<tr id="fechaFin">
				<td><b>Fecha Resolucin:</b></td>
				<td colspan="3">
					Desde&#160;<input type="text" name="finDesde" size="12" id="fin_desde" onChange="changeDate(this)"><xsl:attribute name="value"><xsl:call-template name="date2String2"><xsl:with-param name="fecha"><xsl:value-of select="DATA/INFORMACION/FILTRO/@FIN_DESDE"/></xsl:with-param></xsl:call-template></xsl:attribute></input>&#160;
					<img src="../dumbo7/utils/jscalendar/img.gif" id="trigger_fin_desde"
					style="cursor: pointer; border: 1px solid red;"
				    title="Selecciona Fecha"
					onmouseover="this.style.background='red';"
					onmouseout="this.style.background=''"/>
					<script type="text/javascript">
						Calendar.setup({
							inputField     :    "fin_desde",
							ifFormat       :    "%d/%m/%Y",
							button         :    "trigger_fin_desde",
							align          :    "Tl",
							onSelect       :    selectDateFinDesde,
							singleClick    :    false
						});
					</script>
					&#160;Hasta&#160;<input type="text" name="finHasta" size="12" id="fin_hasta" onChange="changeDate(this)"><xsl:attribute name="value"><xsl:call-template name="date2String2"><xsl:with-param name="fecha"><xsl:value-of select="DATA/INFORMACION/FILTRO/@FIN_HASTA"/></xsl:with-param></xsl:call-template></xsl:attribute></input>&#160;
					<img src="../dumbo7/utils/jscalendar/img.gif" id="trigger_fin_hasta"
					style="cursor: pointer; border: 1px solid red;"
				    title="Selecciona Fecha"
					onmouseover="this.style.background='red';"
					onmouseout="this.style.background=''"/>
					<script type="text/javascript">
						Calendar.setup({
							inputField     :    "fin_hasta",
							ifFormat       :    "%d/%m/%Y",
							button         :    "trigger_fin_hasta",
							align          :    "Tl",
							onSelect       :    selectDateFinHasta,
							singleClick    :    false
						});
					</script>
				</td>
			</tr>
		</xsl:if>
		<xsl:if test="not($listado='pendientes') and not($listado='resueltas')">
			<tr id="usuario">
				<td><b>Usuario:</b></td>
				<td colspan="2">
					<input type="text" name="solicitante" size="25" value="{DATA/INFORMACION/FILTRO/@SOLICITANTE}" OnChange="findRequest(this,'solname',true);"/>&#160;
					<a href="javascript:buscaSolicitante();"><img title="Buscar" src="../graficos/iconos/ampliar.gif" border="0"/></a>
				</td>
				<td id="solname"></td>
			</tr>
		</xsl:if>
		<xsl:if test="not($listado='atender') and not($listado='atendidas') and not($listado='aplicacion') and not($listado='generica')">
			<tr id="informatico">
				<td><b><xsl:call-template name="traduce"><xsl:with-param name="id" select="'Informatico'"/></xsl:call-template>:</b></td>
				<td colspan="2">
					<input type="text" name="informatico" size="25" value="{DATA/INFORMACION/FILTRO/@INFORMATICO}" OnChange="findRequest(this,'infname',true);"/>&#160;
					<a href="javascript:buscaInformatico();"><img title="Buscar" src="../graficos/iconos/ampliar.gif" border="0"/></a>
				</td>
				<td id="infname"></td>
			</tr>
		</xsl:if>
		<tr>
			<td width="15%"><b>Buscar por:</b></td>
			<td width="15%">
				<select name="busq" onchange="cargaCriterio(this.options[this.selectedIndex].value);" size="1">
					<option value="A">Asunto</option>
					<option value="T">Texto</option>
					<option value="C">Cdigo</option>
				</select>
			</td>
			<td id="asunto" colspan="3" align="left"><input type="text" name="asunto" size="60" value="{DATA/INFORMACION/FILTRO/@ASUNTO}"/></td>
			<td id="texto" style="display:none;" colspan="3" align="left"><input type="text" name="texto" size="60" value="{DATA/INFORMACION/FILTRO/@TEXTO}"/></td>
			<td id="codigo" style="display:none;" colspan="3" align="left"><input type="text" name="codigo" size="60" value="{DATA/INFORMACION/FILTRO/@CODIGO}"/></td>
		</tr>
	</table>
</td>
<td><table width="150" border="0" align="center">
  <tr><td><input type="submit" style="width: 80px" class="boton" value="Aplicar"/></td></tr>
  <tr><td><input type="button" style="width: 80px" class="boton" onclick="salvar();" value="Guardar"/></td></tr>
  <tr><td><input type="button" style="width: 80px" class="boton" value="Por Defecto" onclick="porDefecto();"/></td></tr>
</table> 
</td>
</tr>
</table>
<br/>
<center>
</center>
<br/><br/>
</form>
</body>
</html>
</xsl:template>

<xsl:template name="cuerpo">
</xsl:template>
</xsl:stylesheet>
	