<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet version="1.0" 
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:xforms="http://www.w3.org/2002/xforms">
	
<xsl:param name="servlet"/>	
<xsl:param name="menu"/>
<xsl:param name="listado"/>

<xsl:include href="dumbo7/utils/xsl/utils.xsl"/>
	
<xsl:template match="XMLROOT">

<html lang="es">

	<xsl:call-template name="headComun">
		<xsl:with-param name="calendar" select="true()"/>
		<xsl:with-param name="jscript">
			<SCRIPT LANGUAGE="JavaScript" SRC="../js/utils/filtrarInformacion.js"></SCRIPT>
			<SCRIPT LANGUAGE="JavaScript">
				var srvName = '<xsl:value-of select="$servlet"/>';
				var userDom = '<xsl:value-of select="DATA/INFORMACION/USER/@DOMINIO"/>';
				var menu= '<xsl:value-of select="$menu"/>'; 
				var listado = '<xsl:value-of select="$listado"/>'; 
				
				var secciones = new Array();
				var s0,a;
				
				<xsl:for-each select="DATA/INFORMACION/SECCION[@PADRE=@CODIGO or not(@PADRE)]">
					<xsl:sort select="@DESCRIPCION"/>
					s0 = new Seccion('<xsl:value-of select="@CODIGO"/>','[Seccin: <xsl:value-of select="@DESCRIPCION"/>]');
					<xsl:variable name="secc" select="@CODIGO"/>
					<xsl:for-each select="../APLICACION[@SECCION=$secc]">
						<xsl:sort select="@DESCRIPCION"/>
						a = new Aplicacion('<xsl:value-of select="@CODIGO"/>',<xsl:call-template name="entrecomillaDescripcion"><xsl:with-param name="descripcion" select="@DESCRIPCION"/></xsl:call-template>,'<xsl:value-of select="@CARACTER"/>');
						s0.addAplicacion(a);
					</xsl:for-each>
					secciones[secciones.length] = s0;
					<xsl:call-template name="cargaSeccion"><xsl:with-param name="raiz" select=".."/><xsl:with-param name="sec" select="@CODIGO"/></xsl:call-template>
				</xsl:for-each>
				
				function deshabilitaAplicaciones(chk){
					if (chk.checked) {
						document.getElementById('misAplicaciones').style.display = 'none';
						document.getElementById('icofi').style.display = 'none';
					}
					else {
						document.getElementById('misAplicaciones').style.display = '';
						document.getElementById('icofi').style.display = '';	
					}	
				}
				
			</SCRIPT>
		</xsl:with-param>
	</xsl:call-template>

<body onload="deshabilitaAplicaciones(document.getElementById('todos'))">
<br/>
<form name="buscador" action="{$servlet}" method="post">
	<input type="hidden" name="module" value=""/>
	<input type="hidden" name="patron" value=""/>
	<input type="hidden" name="aplcod" value=""/>
</form>
<form name="defecto" action="{$servlet}" method="post">
	<input type="hidden" name="module" value="dumbo7/informacion.filtrarInformacion.defaultFiltro"/>
	<input type="hidden" name="listado" value="{$listado}"/>
	<input type="hidden" name="save" value=""/>
</form>
<form name="f1" action="{$servlet}" method="post">
<input type="hidden" name="module" value="dumbo7/informacion.filtrarInformacion.saveFiltro"/>
<input type="hidden" name="listado" value="{$listado}"/>
<input type="hidden" name="save" value=""/>
<table class="cab1">
<tr><td>Filtro de Informacin: Listado <xsl:value-of select="$listado"/></td></tr>
</table>
<table class="contout">
<tr class="peticion"><td colspan="2">
	<table>
		<tr>
			<td><b>Tipo Tarea:</b></td>
			<td colspan="2">
				<xsl:choose>
					<xsl:when test="($listado='atender') or ($listado='pendientes') or ($listado='generica') or ($listado='aplicacion') or ($listado='globalAtender')">
						<input type="checkbox" name="tipoTarea" value="P"><xsl:if test="(DATA/INFORMACION/FILTRO/TIPO_TAREA/.='P') or count(DATA/INFORMACION/FILTRO/TIPO_TAREA)=0"><xsl:attribute name="checked">true</xsl:attribute></xsl:if></input>Peticin&#160;&#160;
						<input type="checkbox" name="tipoTarea" value="I"><xsl:if test="(DATA/INFORMACION/FILTRO/TIPO_TAREA/.='I') or count(DATA/INFORMACION/FILTRO/TIPO_TAREA)=0"><xsl:attribute name="checked">true</xsl:attribute></xsl:if></input>Incidencia&#160;&#160;
						<!-- input type="checkbox" name="tipoTarea" value="R"><xsl:if test="(DATA/INFORMACION/FILTRO/TIPO_TAREA/.='R') or count(DATA/INFORMACION/FILTRO/TIPO_TAREA)=0"><xsl:attribute name="checked">true</xsl:attribute></xsl:if></input>Dumbo Rpido&#160;&#160; -->
					</xsl:when>
					<xsl:when test="($listado='atendidas') or ($listado='resueltas') or ($listado='globalAtendidas')">
						<input type="checkbox" name="tipoTarea" value="P"><xsl:if test="(DATA/INFORMACION/FILTRO/TIPO_TAREA/.='P') or count(DATA/INFORMACION/FILTRO/TIPO_TAREA)=0"><xsl:attribute name="checked">true</xsl:attribute></xsl:if></input>Peticin&#160;&#160;
						<input type="checkbox" name="tipoTarea" value="I"><xsl:if test="(DATA/INFORMACION/FILTRO/TIPO_TAREA/.='I') or count(DATA/INFORMACION/FILTRO/TIPO_TAREA)=0"><xsl:attribute name="checked">true</xsl:attribute></xsl:if></input>Incidencia&#160;&#160;
						<!-- input type="checkbox" name="tipoTarea" value="R"><xsl:if test="(DATA/INFORMACION/FILTRO/TIPO_TAREA/.='R') or count(DATA/INFORMACION/FILTRO/TIPO_TAREA)=0"><xsl:attribute name="checked">true</xsl:attribute></xsl:if></input>Dumbo Rpido&#160;&#160; -->
					</xsl:when>
					<xsl:when test="($listado='problemas')">
						<input type="checkbox" name="tipoTarea" value="B"><xsl:if test="(DATA/INFORMACION/FILTRO/TIPO_TAREA/.='B') or count(DATA/INFORMACION/FILTRO/TIPO_TAREA)=0"><xsl:attribute name="checked">true</xsl:attribute></xsl:if></input>Problema&#160;&#160;
					</xsl:when>
					<xsl:when test="($listado='programadas')">
						<input type="checkbox" name="tipoTarea" value="A"><xsl:if test="(DATA/INFORMACION/FILTRO/TIPO_TAREA/.='A') or count(DATA/INFORMACION/FILTRO/TIPO_TAREA)=0"><xsl:attribute name="checked">true</xsl:attribute></xsl:if></input>Peticin Programada&#160;&#160;
					</xsl:when>
					<xsl:when test="($listado='vinculadas')">
						<input type="checkbox" name="tipoTarea" value="P"><xsl:if test="(DATA/INFORMACION/FILTRO/TIPO_TAREA/.='P') or count(DATA/INFORMACION/FILTRO/TIPO_TAREA)=0"><xsl:attribute name="checked">true</xsl:attribute></xsl:if></input>Peticin&#160;&#160;
						<input type="checkbox" name="tipoTarea" value="I"><xsl:if test="(DATA/INFORMACION/FILTRO/TIPO_TAREA/.='I') or count(DATA/INFORMACION/FILTRO/TIPO_TAREA)=0"><xsl:attribute name="checked">true</xsl:attribute></xsl:if></input>Incidencia&#160;&#160;
						<!-- input type="checkbox" name="tipoTarea" value="R"><xsl:if test="(DATA/INFORMACION/FILTRO/TIPO_TAREA/.='R') or count(DATA/INFORMACION/FILTRO/TIPO_TAREA)=0"><xsl:attribute name="checked">true</xsl:attribute></xsl:if></input>Dumbo Rpido&#160;&#160; -->
						<!-- input type="checkbox" name="tipoTarea" value="A"><xsl:if test="(DATA/INFORMACION/FILTRO/TIPO_TAREA/.='A') or count(DATA/INFORMACION/FILTRO/TIPO_TAREA)=0"><xsl:attribute name="checked">true</xsl:attribute></xsl:if></input>Peticin Programada&#160;&#160; -->
					</xsl:when>
					<xsl:otherwise>
						<input type="checkbox" name="tipoTarea" value="P"><xsl:if test="(DATA/INFORMACION/FILTRO/TIPO_TAREA/.='P') or count(DATA/INFORMACION/FILTRO/TIPO_TAREA)=0"><xsl:attribute name="checked">true</xsl:attribute></xsl:if></input>Peticin&#160;&#160;
						<input type="checkbox" name="tipoTarea" value="I"><xsl:if test="(DATA/INFORMACION/FILTRO/TIPO_TAREA/.='I') or count(DATA/INFORMACION/FILTRO/TIPO_TAREA)=0"><xsl:attribute name="checked">true</xsl:attribute></xsl:if></input>Incidencia&#160;&#160;
						<input type="checkbox" name="tipoTarea" value="A"><xsl:if test="(DATA/INFORMACION/FILTRO/TIPO_TAREA/.='A') or count(DATA/INFORMACION/FILTRO/TIPO_TAREA)=0"><xsl:attribute name="checked">true</xsl:attribute></xsl:if></input>Peticin Programada&#160;&#160;
						<!-- input type="checkbox" name="tipoTarea" value="R"><xsl:if test="(DATA/INFORMACION/FILTRO/TIPO_TAREA/.='R') or count(DATA/INFORMACION/FILTRO/TIPO_TAREA)=0"><xsl:attribute name="checked">true</xsl:attribute></xsl:if></input>Dumbo Rpido&#160;&#160; -->
						<input type="checkbox" name="tipoTarea" value="B"><xsl:if test="(DATA/INFORMACION/FILTRO/TIPO_TAREA/.='B') or count(DATA/INFORMACION/FILTRO/TIPO_TAREA)=0"><xsl:attribute name="checked">true</xsl:attribute></xsl:if></input>Problema&#160;&#160;
					</xsl:otherwise>
				</xsl:choose>
			</td>
			<td>
				<xsl:choose>
				<xsl:when test="($listado='atendidas') or ($listado='resueltas')">
				<input type="checkbox" name="soloDumboRapido" value="S"><xsl:if test="(DATA/INFORMACION/FILTRO/@SOLO_DUMBO_RAPIDO/.='S')"><xsl:attribute name="checked">true</xsl:attribute></xsl:if></input><b>Slo Dumbos Rpidos</b>
				</xsl:when>
				<xsl:otherwise>&#160;</xsl:otherwise>
				</xsl:choose>
			</td>
		</tr>
		<tr>
			<td><b>Estado Tarea:</b></td>
			<td colspan="3">
				<xsl:choose>
					<xsl:when test="($listado='atender') or ($listado='globalAtender')">
						<input type="checkbox" name="estadoTarea" value="A"><xsl:if test="(DATA/INFORMACION/FILTRO/ESTADO_TAREA/.='A') or count(DATA/INFORMACION/FILTRO/ESTADO_TAREA)=0"><xsl:attribute name="checked">true</xsl:attribute></xsl:if></input>Asignada&#160;
						<input type="checkbox" name="estadoTarea" value="W"><xsl:if test="(DATA/INFORMACION/FILTRO/ESTADO_TAREA/.='W') or count(DATA/INFORMACION/FILTRO/ESTADO_TAREA)=0"><xsl:attribute name="checked">true</xsl:attribute></xsl:if></input>En Espera&#160;
						<input type="checkbox" name="estadoTarea" value="X"><xsl:if test="(DATA/INFORMACION/FILTRO/ESTADO_TAREA/.='X') or count(DATA/INFORMACION/FILTRO/ESTADO_TAREA)=0"><xsl:attribute name="checked">true</xsl:attribute></xsl:if></input>Rechazada&#160;
						<input type="checkbox" name="estadoTarea" value="N"><xsl:if test="(DATA/INFORMACION/FILTRO/ESTADO_TAREA/.='N')"><xsl:attribute name="checked">true</xsl:attribute></xsl:if></input>Anulada<br/>
					</xsl:when>
					<xsl:when test="$listado='pendientes'">
						<input type="checkbox" name="estadoTarea" value="P"><xsl:if test="(DATA/INFORMACION/FILTRO/ESTADO_TAREA/.='P') or count(DATA/INFORMACION/FILTRO/ESTADO_TAREA)=0"><xsl:attribute name="checked">true</xsl:attribute></xsl:if></input>Pendiente Asignacin&#160;
						<input type="checkbox" name="estadoTarea" value="A"><xsl:if test="(DATA/INFORMACION/FILTRO/ESTADO_TAREA/.='A') or count(DATA/INFORMACION/FILTRO/ESTADO_TAREA)=0"><xsl:attribute name="checked">true</xsl:attribute></xsl:if></input>Asignada&#160;
						<input type="checkbox" name="estadoTarea" value="W"><xsl:if test="(DATA/INFORMACION/FILTRO/ESTADO_TAREA/.='W') or count(DATA/INFORMACION/FILTRO/ESTADO_TAREA)=0"><xsl:attribute name="checked">true</xsl:attribute></xsl:if></input>En Espera&#160;
						<input type="checkbox" name="estadoTarea" value="X"><xsl:if test="(DATA/INFORMACION/FILTRO/ESTADO_TAREA/.='X') or count(DATA/INFORMACION/FILTRO/ESTADO_TAREA)=0"><xsl:attribute name="checked">true</xsl:attribute></xsl:if></input>Rechazada&#160;
						<input type="checkbox" name="estadoTarea" value="N"><xsl:if test="(DATA/INFORMACION/FILTRO/ESTADO_TAREA/.='N')"><xsl:attribute name="checked">true</xsl:attribute></xsl:if></input>Anulada<br/>
					</xsl:when>
					<xsl:when test="($listado='atendidas') or ($listado='resueltas') or ($listado='globalAtendidas')">
						<input type="checkbox" name="estadoTarea" value="R"><xsl:if test="(DATA/INFORMACION/FILTRO/ESTADO_TAREA/.='R') or count(DATA/INFORMACION/FILTRO/ESTADO_TAREA)=0"><xsl:attribute name="checked">true</xsl:attribute></xsl:if></input>Resuelta&#160;
						<input type="checkbox" name="estadoTarea" value="N"><xsl:if test="(DATA/INFORMACION/FILTRO/ESTADO_TAREA/.='N')"><xsl:attribute name="checked">true</xsl:attribute></xsl:if></input>Anulada<br/>
					</xsl:when>
					<xsl:when test="$listado='generica'">
						<input type="checkbox" name="estadoTarea" value="P"><xsl:if test="(DATA/INFORMACION/FILTRO/ESTADO_TAREA/.='P') or count(DATA/INFORMACION/FILTRO/ESTADO_TAREA)=0"><xsl:attribute name="checked">true</xsl:attribute></xsl:if></input>Pendiente Asignacin&#160;
						<input type="checkbox" name="estadoTarea" value="N"><xsl:if test="(DATA/INFORMACION/FILTRO/ESTADO_TAREA/.='N')"><xsl:attribute name="checked">true</xsl:attribute></xsl:if></input>Anulada<br/>
					</xsl:when>
					<xsl:when test="$listado='aplicacion'">
						<input type="checkbox" name="estadoTarea" value="P"><xsl:if test="(DATA/INFORMACION/FILTRO/ESTADO_TAREA/.='P') or count(DATA/INFORMACION/FILTRO/ESTADO_TAREA)=0"><xsl:attribute name="checked">true</xsl:attribute></xsl:if></input>Pendiente Asignacin&#160;
						<input type="checkbox" name="estadoTarea" value="N"><xsl:if test="(DATA/INFORMACION/FILTRO/ESTADO_TAREA/.='N')"><xsl:attribute name="checked">true</xsl:attribute></xsl:if></input>Anulada<br/>
					</xsl:when>
					<xsl:when test="$listado='problemas'">
						<input type="checkbox" name="estadoTarea" value="P"><xsl:if test="(DATA/INFORMACION/FILTRO/ESTADO_TAREA/.='P') or count(DATA/INFORMACION/FILTRO/ESTADO_TAREA)=0"><xsl:attribute name="checked">true</xsl:attribute></xsl:if></input>Pendiente Asignacin&#160;
						<input type="checkbox" name="estadoTarea" value="A"><xsl:if test="(DATA/INFORMACION/FILTRO/ESTADO_TAREA/.='A') or count(DATA/INFORMACION/FILTRO/ESTADO_TAREA)=0"><xsl:attribute name="checked">true</xsl:attribute></xsl:if></input>Asignada&#160;
						<input type="checkbox" name="estadoTarea" value="W"><xsl:if test="(DATA/INFORMACION/FILTRO/ESTADO_TAREA/.='W') or count(DATA/INFORMACION/FILTRO/ESTADO_TAREA)=0"><xsl:attribute name="checked">true</xsl:attribute></xsl:if></input>En Espera&#160;
						<input type="checkbox" name="estadoTarea" value="X"><xsl:if test="(DATA/INFORMACION/FILTRO/ESTADO_TAREA/.='X') or count(DATA/INFORMACION/FILTRO/ESTADO_TAREA)=0"><xsl:attribute name="checked">true</xsl:attribute></xsl:if></input>Rechazada&#160;<br/>
						<input type="checkbox" name="estadoTarea" value="N"><xsl:if test="(DATA/INFORMACION/FILTRO/ESTADO_TAREA/.='N')"><xsl:attribute name="checked">true</xsl:attribute></xsl:if></input>Anulado&#160;
						<input type="checkbox" name="estadoTarea" value="R"><xsl:if test="(DATA/INFORMACION/FILTRO/ESTADO_TAREA/.='F')"><xsl:attribute name="checked">true</xsl:attribute></xsl:if></input>Resuelta&#160;
					</xsl:when>
					<xsl:when test="$listado='programadas'">
						<input type="checkbox" name="estadoTarea" value="P"><xsl:if test="(DATA/INFORMACION/FILTRO/ESTADO_TAREA/.='P') or count(DATA/INFORMACION/FILTRO/ESTADO_TAREA)=0"><xsl:attribute name="checked">true</xsl:attribute></xsl:if></input>Pendiente Asignacin&#160;
						<input type="checkbox" name="estadoTarea" value="A"><xsl:if test="(DATA/INFORMACION/FILTRO/ESTADO_TAREA/.='A') or count(DATA/INFORMACION/FILTRO/ESTADO_TAREA)=0"><xsl:attribute name="checked">true</xsl:attribute></xsl:if></input>Asignada&#160;
						<input type="checkbox" name="estadoTarea" value="W"><xsl:if test="(DATA/INFORMACION/FILTRO/ESTADO_TAREA/.='W') or count(DATA/INFORMACION/FILTRO/ESTADO_TAREA)=0"><xsl:attribute name="checked">true</xsl:attribute></xsl:if></input>En Espera&#160;
						<input type="checkbox" name="estadoTarea" value="X"><xsl:if test="(DATA/INFORMACION/FILTRO/ESTADO_TAREA/.='X') or count(DATA/INFORMACION/FILTRO/ESTADO_TAREA)=0"><xsl:attribute name="checked">true</xsl:attribute></xsl:if></input>Rechazada&#160;<br/>
						<input type="checkbox" name="estadoTarea" value="N"><xsl:if test="(DATA/INFORMACION/FILTRO/ESTADO_TAREA/.='N')"><xsl:attribute name="checked">true</xsl:attribute></xsl:if></input>Anulado&#160;
						<input type="checkbox" name="estadoTarea" value="R"><xsl:if test="(DATA/INFORMACION/FILTRO/ESTADO_TAREA/.='F')"><xsl:attribute name="checked">true</xsl:attribute></xsl:if></input>Resuelta&#160;
					</xsl:when>
					<xsl:when test="$listado='vinculadas'">
						<input type="checkbox" name="estadoTarea" value="P"><xsl:if test="(DATA/INFORMACION/FILTRO/ESTADO_TAREA/.='P') or count(DATA/INFORMACION/FILTRO/ESTADO_TAREA)=0"><xsl:attribute name="checked">true</xsl:attribute></xsl:if></input>Pendiente Asignacin&#160;
						<input type="checkbox" name="estadoTarea" value="A"><xsl:if test="(DATA/INFORMACION/FILTRO/ESTADO_TAREA/.='A') or count(DATA/INFORMACION/FILTRO/ESTADO_TAREA)=0"><xsl:attribute name="checked">true</xsl:attribute></xsl:if></input>Asignada&#160;
						<input type="checkbox" name="estadoTarea" value="W"><xsl:if test="(DATA/INFORMACION/FILTRO/ESTADO_TAREA/.='W') or count(DATA/INFORMACION/FILTRO/ESTADO_TAREA)=0"><xsl:attribute name="checked">true</xsl:attribute></xsl:if></input>En Espera&#160;
						<input type="checkbox" name="estadoTarea" value="X"><xsl:if test="(DATA/INFORMACION/FILTRO/ESTADO_TAREA/.='X') or count(DATA/INFORMACION/FILTRO/ESTADO_TAREA)=0"><xsl:attribute name="checked">true</xsl:attribute></xsl:if></input>Rechazada&#160;
						<input type="checkbox" name="estadoTarea" value="R"><xsl:if test="(DATA/INFORMACION/FILTRO/ESTADO_TAREA/.='R')"><xsl:attribute name="checked">true</xsl:attribute></xsl:if></input>Resuelta&#160;
						<input type="checkbox" name="estadoTarea" value="N"><xsl:if test="(DATA/INFORMACION/FILTRO/ESTADO_TAREA/.='N')"><xsl:attribute name="checked">true</xsl:attribute></xsl:if></input>Anulada<br/>
					</xsl:when>
					<xsl:otherwise>
						<input type="checkbox" name="estadoTarea" value="A"><xsl:if test="(DATA/INFORMACION/FILTRO/ESTADO_TAREA/.='A') or count(DATA/INFORMACION/FILTRO/ESTADO_TAREA)=0"><xsl:attribute name="checked">true</xsl:attribute></xsl:if></input>Asignada&#160;
						<input type="checkbox" name="estadoTarea" value="W"><xsl:if test="(DATA/INFORMACION/FILTRO/ESTADO_TAREA/.='W') or count(DATA/INFORMACION/FILTRO/ESTADO_TAREA)=0"><xsl:attribute name="checked">true</xsl:attribute></xsl:if></input>En Espera&#160;
						<input type="checkbox" name="estadoTarea" value="X"><xsl:if test="(DATA/INFORMACION/FILTRO/ESTADO_TAREA/.='X') or count(DATA/INFORMACION/FILTRO/ESTADO_TAREA)=0"><xsl:attribute name="checked">true</xsl:attribute></xsl:if></input>Rechazada&#160;
						<input type="checkbox" name="estadoTarea" value="N"><xsl:if test="(DATA/INFORMACION/FILTRO/ESTADO_TAREA/.='N') or count(DATA/INFORMACION/FILTRO/ESTADO_TAREA)=0"><xsl:attribute name="checked">true</xsl:attribute></xsl:if></input>Anulada<br/>
						<input type="checkbox" name="estadoTarea" value="R"><xsl:if test="(DATA/INFORMACION/FILTRO/ESTADO_TAREA/.='R') or count(DATA/INFORMACION/FILTRO/ESTADO_TAREA)=0"><xsl:attribute name="checked">true</xsl:attribute></xsl:if></input>Resuelta&#160;
					</xsl:otherwise>
				</xsl:choose>
			</td>
		</tr>
		<tr>
			<td><b>Aplicacin:</b></td>
			<td colspan="2">
				<br/>
					<xsl:if test="$listado='aplicacion'">
						<input type="hidden" name="notAplicaciones" value="N"/>
					</xsl:if>
					<xsl:choose>
						<xsl:when test="not($listado='aplicacion') and not($listado='generica')">
							<input type="checkbox" name="aplicaciones" value="N"><xsl:if test="(DATA/INFORMACION/FILTRO/APLICACIONES/.='N') or count(/XMLROOT/DATA/INFORMACION/FILTRO/APLICACIONES)=0"><xsl:attribute name="checked">true</xsl:attribute></xsl:if></input>Sin Aplicacin Asignada
						</xsl:when>
					<xsl:otherwise>
						<input type="hidden" name="aplicaciones"><xsl:if test="(DATA/INFORMACION/FILTRO/APLICACIONES/.='N') or count(/XMLROOT/DATA/INFORMACION/FILTRO/APLICACIONES)=0"><xsl:attribute name="value">N</xsl:attribute></xsl:if></input>			
					</xsl:otherwise>
					</xsl:choose>
					<input type="checkbox" id="todos" name="aplicaciones" value="S" OnClick="deshabilitaAplicaciones(this);"><xsl:if test="(DATA/INFORMACION/FILTRO/APLICACIONES/.='S')"><xsl:attribute name="checked">true</xsl:attribute></xsl:if></input>Todas
					<xsl:if test="count(/XMLROOT/DATA/SECURITY/ACTION[@NAME='informatico']/PROFILE)>0">
					&#160;&#160;<a href="javascript:showFiltro();"><img id="icofi" src="../graficos/iconos/filtrar_ico.gif" title="Filtrar Aplicaciones" border="0"/></a>
					</xsl:if>
				<br/>
				<div id="misAplicaciones">
				<xsl:choose>
					<xsl:when test="count(/XMLROOT/DATA/SECURITY/ACTION[@NAME='informatico']/PROFILE)>0">
					<select name="aplicaciones" size="8" multiple="true" onChange="cambiaApl(this);">
						<xsl:for-each select="DATA/INFORMACION/SECCION[(@PADRE=@CODIGO) or not(@PADRE)]">
							<xsl:sort select="@DESCRIPCION"/>
							<xsl:variable name="secc" select="@CODIGO"/>
							<xsl:variable name="subsecc"><xsl:call-template name="optionAplicacion"><xsl:with-param name="raiz" select=".."/><xsl:with-param name="sec" select="@CODIGO"/></xsl:call-template></xsl:variable>
							<xsl:if test="count(../APLICACION[@SECCION=$secc])>0 or string-length($subsecc)>0">
								<option class="listas" value="-1">[Seccin: <xsl:value-of select="@DESCRIPCION"/>]</option>
								<xsl:call-template name="optionAplicacion">
									<xsl:with-param name="raiz" select=".."/>
									<xsl:with-param name="sec" select="@CODIGO"/>
								</xsl:call-template>
							</xsl:if>
						</xsl:for-each>
					</select>
					</xsl:when>
					<xsl:otherwise>
					<select size="8" name="aplicaciones" multiple="true">
						<xsl:for-each select="DATA/INFORMACION/APLICACION">
							<xsl:sort select="@DESCRIPCION"/>
							<option value="{@CODIGO}"><xsl:if test="(/XMLROOT/DATA/INFORMACION/FILTRO/APLICACIONES=@CODIGO) or count(/XMLROOT/DATA/INFORMACION/FILTRO/APLICACIONES)=0"><xsl:attribute name="selected">true</xsl:attribute></xsl:if><xsl:value-of select="@DESCRIPCION"/></option>
						</xsl:for-each>
					</select>
					</xsl:otherwise>
				</xsl:choose>
				</div>
			</td>
			<td id="filt" style="display:none;">
				<xsl:if test="count(/XMLROOT/DATA/SECURITY/ACTION[@NAME='informatico']/PROFILE)>0">
				<table cellpadding="0" cellspacing="0">
				<tr class="peticion"><td><strong>Filtro Aplicaciones</strong></td></tr>
				<tr class="incidencia">
					<td>
						<input type="radio" name="internas" onclick="cambiaFoco()" onchange="cambiaSeccion(document.f1.seccionCod,document.f1.aplicaciones[1])"/>Todas&#160;<input type="radio" name="internas" checked="true" onclick="cambiaFoco()" onchange="cambiaSeccion(document.f1.seccionCod,document.f1.aplicaciones[1])"/>Slo Externas
						&#160;Filtro:&#160;<input type="text" name="filtro" onchange="cambiaSeccion(document.f1.seccionCod,document.f1.aplicaciones[1])" size="12"/><br/>
						Seccin:&#160;
						<select name="seccionCod" size="1" onChange="cambiaSeccion(this,document.f1.aplicaciones[1])">
							<option value="-1" selected="true">&lt;-- Filtro Seccin --></option>
							<xsl:for-each select="DATA/INFORMACION/SECCION[(@PADRE=@CODIGO) or not(@PADRE)]">
								<xsl:sort select="@DESCRIPCION"/>
								<xsl:variable name="secc" select="@CODIGO"/>
								<xsl:variable name="subsecc"><xsl:call-template name="optionSeccion"><xsl:with-param name="raiz" select=".."/><xsl:with-param name="sec" select="@CODIGO"/></xsl:call-template></xsl:variable>
								<xsl:if test="count(../APLICACION[@SECCION=$secc])>0 or string-length($subsecc)>0">
									<option value="{@CODIGO}"><xsl:value-of select="@DESCRIPCION"/></option>
									<xsl:call-template name="optionSeccion">
										<xsl:with-param name="raiz" select=".."/>
										<xsl:with-param name="sec" select="@CODIGO"/>
									</xsl:call-template>
								</xsl:if>
							</xsl:for-each>
						</select>
					</td>
				</tr>			
				</table>
				</xsl:if>
			</td>
		</tr>
		<tr>
			<td><b>Urgencia:</b></td>
			<td>
				<input type="checkbox" name="urgencia" value="U"><xsl:if test="(DATA/INFORMACION/FILTRO/URGENCIA/.='U') or count(DATA/INFORMACION/FILTRO/URGENCIA)=0"><xsl:attribute name="checked">true</xsl:attribute></xsl:if></input>Urgente<br/>
				<input type="checkbox" name="urgencia" value="N"><xsl:if test="(DATA/INFORMACION/FILTRO/URGENCIA/.='N') or count(DATA/INFORMACION/FILTRO/URGENCIA)=0"><xsl:attribute name="checked">true</xsl:attribute></xsl:if></input>No Urgente<br/>
				<input type="checkbox" name="urgencia" value="S"><xsl:if test="(DATA/INFORMACION/FILTRO/URGENCIA/.='S') or count(DATA/INFORMACION/FILTRO/URGENCIA)=0"><xsl:attribute name="checked">true</xsl:attribute></xsl:if></input>Sin Urgencia
			</td>
			<xsl:choose>
			<xsl:when test="count(/XMLROOT/DATA/SECURITY/ACTION[@NAME='informatico']/PROFILE)>0 and not($listado='aplicacion') and not($listado='generica')">
			<td><b>Prioridad:</b></td>
			<td>
				<input type="checkbox" name="prioridad" value="A"><xsl:if test="(DATA/INFORMACION/FILTRO/PRIORIDAD/.='A') or count(DATA/INFORMACION/FILTRO/PRIORIDAD)=0"><xsl:attribute name="checked">true</xsl:attribute></xsl:if></input>Alta&#160;
				<input type="checkbox" name="prioridad" value="M"><xsl:if test="(DATA/INFORMACION/FILTRO/PRIORIDAD/.='M') or count(DATA/INFORMACION/FILTRO/PRIORIDAD)=0"><xsl:attribute name="checked">true</xsl:attribute></xsl:if></input>Media&#160;
				<input type="checkbox" name="prioridad" value="B"><xsl:if test="(DATA/INFORMACION/FILTRO/PRIORIDAD/.='B') or count(DATA/INFORMACION/FILTRO/PRIORIDAD)=0"><xsl:attribute name="checked">true</xsl:attribute></xsl:if></input>Baja&#160;<br/>
				<input type="checkbox" name="prioridad" value="C"><xsl:if test="(DATA/INFORMACION/FILTRO/PRIORIDAD/.='C') or count(DATA/INFORMACION/FILTRO/PRIORIDAD)=0"><xsl:attribute name="checked">true</xsl:attribute></xsl:if></input>Crtica&#160;
				<input type="checkbox" name="prioridad" value="P"><xsl:if test="(DATA/INFORMACION/FILTRO/PRIORIDAD/.='P') or count(DATA/INFORMACION/FILTRO/PRIORIDAD)=0"><xsl:attribute name="checked">true</xsl:attribute></xsl:if></input>Planificada&#160;
				<input type="checkbox" name="prioridad" value="N"><xsl:if test="(DATA/INFORMACION/FILTRO/PRIORIDAD/.='N') or count(DATA/INFORMACION/FILTRO/PRIORIDAD)=0"><xsl:attribute name="checked">true</xsl:attribute></xsl:if></input>Sin Prioridad&#160;
			</td>
			</xsl:when>
			<xsl:otherwise>
			<td colspan="2">&#160;</td>
			</xsl:otherwise>
			</xsl:choose>
		</tr>
		<tr>
			<td><b>Fecha Inicio:</b></td>
			<td colspan="3">
				Desde&#160;<input type="text" name="inicioDesde" size="12" id="ini_desde" onChange="changeDate(this)"><xsl:attribute name="value"><xsl:call-template name="date2String2"><xsl:with-param name="fecha"><xsl:value-of select="DATA/INFORMACION/FILTRO/@INICIO_DESDE"/></xsl:with-param></xsl:call-template></xsl:attribute></input>&#160;
				<img src="../dumbo7/utils/jscalendar/img.gif" id="trigger_ini_desde"
				style="cursor: pointer; border: 1px solid red;"
			    title="Selecciona Fecha"
				onmouseover="this.style.background='red';"
				onmouseout="this.style.background=''"/>
				<script type="text/javascript">
					Calendar.setup({
						inputField     :    "ini_desde",
						ifFormat       :    "%d/%m/%Y",
						button         :    "trigger_ini_desde",
						align          :    "Tl",
						onSelect       :    selectDateIniDesde,
						singleClick    :    false
					});
				</script>
				&#160;Hasta&#160;<input type="text" name="inicioHasta" size="12" id="ini_hasta" onChange="changeDate(this)"><xsl:attribute name="value"><xsl:call-template name="date2String2"><xsl:with-param name="fecha"><xsl:value-of select="DATA/INFORMACION/FILTRO/@INICIO_HASTA"/></xsl:with-param></xsl:call-template></xsl:attribute></input>&#160;
				<img src="../dumbo7/utils/jscalendar/img.gif" id="trigger_ini_hasta"
				style="cursor: pointer; border: 1px solid red;"
			    title="Selecciona Fecha"
				onmouseover="this.style.background='red';"
				onmouseout="this.style.background=''"/>
				<script type="text/javascript">
					Calendar.setup({
						inputField     :    "ini_hasta",
						ifFormat       :    "%d/%m/%Y",
						button         :    "trigger_ini_hasta",
						align          :    "Tl",
						onSelect       :    selectDateIniHasta,
						singleClick    :    false
					});
				</script>
			</td>
		</tr>
		<xsl:if test="not($listado='pendientes') and not($listado='atender') and not($listado='aplicacion') and not($listado='generica')">
		<tr>
			<td><b>Fecha Fin:</b></td>
			<td colspan="3">
				Desde&#160;<input type="text" name="finDesde" size="12" id="fin_desde" onChange="changeDate(this)"><xsl:attribute name="value"><xsl:call-template name="date2String2"><xsl:with-param name="fecha"><xsl:value-of select="DATA/INFORMACION/FILTRO/@FIN_DESDE"/></xsl:with-param></xsl:call-template></xsl:attribute></input>&#160;
				<img src="../dumbo7/utils/jscalendar/img.gif" id="trigger_fin_desde"
				style="cursor: pointer; border: 1px solid red;"
			    title="Selecciona Fecha"
				onmouseover="this.style.background='red';"
				onmouseout="this.style.background=''"/>
				<script type="text/javascript">
					Calendar.setup({
						inputField     :    "fin_desde",
						ifFormat       :    "%d/%m/%Y",
						button         :    "trigger_fin_desde",
						align          :    "Tl",
						onSelect       :    selectDateFinDesde,
						singleClick    :    false
					});
				</script>
				&#160;Hasta&#160;<input type="text" name="finHasta" size="12" id="fin_hasta" onChange="changeDate(this)"><xsl:attribute name="value"><xsl:call-template name="date2String2"><xsl:with-param name="fecha"><xsl:value-of select="DATA/INFORMACION/FILTRO/@FIN_HASTA"/></xsl:with-param></xsl:call-template></xsl:attribute></input>&#160;
				<img src="../dumbo7/utils/jscalendar/img.gif" id="trigger_fin_hasta"
				style="cursor: pointer; border: 1px solid red;"
			    title="Selecciona Fecha"
				onmouseover="this.style.background='red';"
				onmouseout="this.style.background=''"/>
				<script type="text/javascript">
					Calendar.setup({
						inputField     :    "fin_hasta",
						ifFormat       :    "%d/%m/%Y",
						button         :    "trigger_fin_hasta",
						align          :    "Tl",
						onSelect       :    selectDateFinHasta,
						singleClick    :    false
					});
				</script>
			</td>
		</tr>
		</xsl:if>
		<xsl:if test="not($listado='pendientes') and not($listado='resueltas')">
		<tr>
			<td><b>Usuario:</b></td>
			<td colspan="2">
				<input type="text" name="solicitante" size="25" value="{DATA/INFORMACION/FILTRO/@SOLICITANTE}" OnChange="findRequest(this,'solname',true);"/>&#160;
				<a href="javascript:buscaSolicitante();"><img title="Buscar" src="../graficos/iconos/ampliar.gif" border="0"/></a>
			</td>
			<td id="solname"></td>
		</tr>
		</xsl:if>
		<xsl:if test="not($listado='atender') and not($listado='atendidas') and not($listado='aplicacion') and not($listado='generica')">
		<tr>
			<td><b><xsl:call-template name="traduce"><xsl:with-param name="id" select="'Informatico'"/></xsl:call-template>:</b></td>
			<td colspan="2">
				<input type="text" name="informatico" size="25" value="{DATA/INFORMACION/FILTRO/@INFORMATICO}" OnChange="findRequest(this,'infname',true);"/>&#160;
				<a href="javascript:buscaInformatico();"><img title="Buscar" src="../graficos/iconos/ampliar.gif" border="0"/></a>
			</td>
			<td id="infname"></td>
		</tr>
		</xsl:if>
		<tr>
			<td><b>Asunto:</b></td>
			<td colspan="3"><input type="text" name="asunto" size="60" value="{DATA/INFORMACION/FILTRO/@ASUNTO}"/></td>
		</tr>
		<tr>
			<td><b>Texto:</b></td>
			<td colspan="3"><input type="text" name="texto" size="60" value="{DATA/INFORMACION/FILTRO/@TEXTO}"/></td>
		</tr>
		<tr>
			<td><b>Cdigo:</b></td>
			<td colspan="3"><input type="text" name="codigo" size="25" value="{DATA/INFORMACION/FILTRO/@CODIGO}"/></td>
		</tr>
	</table>
</td></tr>
</table>
<br/>
<center>
<input type="submit" class="boton" value="Aplicar"/>&#160;&#160;
<input type="button" class="boton" onclick="salvar();" value="Guardar"/>&#160;&#160;
<input type="button" class="boton" value="Por Defecto" onclick="porDefecto();"/>&#160;&#160;
<input type="button" class="boton" onclick="top.close();" value="Cancelar"/>
<!-- <input type="button" class="boton" onclick="esconder();" value="Ocultar Filtro"/>&#160;&#160;
<input type="button" class="boton" onclick="abreSencillo('{$listado}');" value="Abrir filtro sencillo"/> -->
</center>
<br/><br/>
</form>
</body>
</html>
</xsl:template>

<xsl:template name="cuerpo">
</xsl:template>

<xsl:template name="optionSeccion">
<xsl:param name="raiz"/>
<xsl:param name="sec"/>
<xsl:param name="padd" select="'&#160;'"/>
	<xsl:for-each select="$raiz/SECCION[(@PADRE=$sec) and not(@CODIGO=@PADRE)]">
		<xsl:sort select="@DESCRIPCION"/>
		<xsl:variable name="secc" select="@CODIGO"/>
		<xsl:variable name="subsecc"><xsl:call-template name="optionSeccion"><xsl:with-param name="raiz" select="$raiz"/><xsl:with-param name="sec" select="@CODIGO"/></xsl:call-template></xsl:variable>
		<xsl:if test="count($raiz/APLICACION[@SECCION=$secc])>0 or string-length($subsecc)>0">
			<option value="{@CODIGO}"><xsl:value-of select="$padd"/><xsl:value-of select="@DESCRIPCION"/></option>
			<xsl:call-template name="optionSeccion">
				<xsl:with-param name="raiz" select="$raiz"/>
				<xsl:with-param name="sec" select="@CODIGO"/>
				<xsl:with-param name="padd" select="concat($padd,'&#160;')"/>
			</xsl:call-template>
		</xsl:if>
	</xsl:for-each>
</xsl:template>

<xsl:template name="optionAplicacion">
<xsl:param name="raiz"/>
<xsl:param name="sec"/>
<xsl:param name="padd" select="'&#160;&#160;'"/>
	<xsl:for-each select="$raiz/APLICACION[(@SECCION=$sec) and @ESTADO='V']">
		<xsl:sort select="@DESCRIPCION"/>
		<option value="{@CODIGO}"><xsl:if test="(/XMLROOT/DATA/INFORMACION/FILTRO/APLICACIONES=@CODIGO) or count(/XMLROOT/DATA/INFORMACION/FILTRO/APLICACIONES)=0"><xsl:attribute name="selected">true</xsl:attribute></xsl:if><xsl:value-of select="$padd"/><xsl:value-of select="@DESCRIPCION"/></option>
	</xsl:for-each>
	<xsl:for-each select="$raiz/SECCION[(@PADRE=$sec) and not(@CODIGO=$sec)]">
		<xsl:sort select="@DESCRIPCION"/>
		<xsl:variable name="secc" select="@CODIGO"/>
		<xsl:variable name="subsecc"><xsl:call-template name="optionAplicacion"><xsl:with-param name="raiz" select="$raiz"/><xsl:with-param name="sec" select="@CODIGO"/></xsl:call-template></xsl:variable>
		<xsl:if test="count(../APLICACION[@SECCION=$secc])>0 or string-length($subsecc)>0">
			<option class="listas" value="-1"><xsl:value-of select="$padd"/>[Seccin:<xsl:value-of select="@DESCRIPCION"/>]</option>
			<xsl:call-template name="optionAplicacion">
				<xsl:with-param name="raiz" select="$raiz"/>
				<xsl:with-param name="sec" select="@CODIGO"/>
				<xsl:with-param name="padd" select="concat($padd,'&#160;&#160;')"/>
			</xsl:call-template>
		</xsl:if>
	</xsl:for-each>
</xsl:template>

<xsl:template name="cargaSeccion">
<xsl:param name="raiz"/>
<xsl:param name="sec"/>
<xsl:param name="par" select="1"/>
<xsl:param name="padd" select="'&#160;&#160;'"/>
	<xsl:for-each select="$raiz/SECCION[(@PADRE=$sec) and not(@CODIGO=$sec)]">
		<xsl:sort select="@DESCRIPCION"/>
		s<xsl:value-of select="$par"/> = new Seccion('<xsl:value-of select="@CODIGO"/>','[Seccin: <xsl:value-of select="@DESCRIPCION"/>]');
		<xsl:variable name="secc" select="@CODIGO"/>
		<xsl:for-each select="$raiz/APLICACION[@SECCION=$secc]">
			<xsl:sort select="@DESCRIPCION"/>
			a = new Aplicacion('<xsl:value-of select="@CODIGO"/>',<xsl:call-template name="entrecomillaDescripcion"><xsl:with-param name="descripcion" select="@DESCRIPCION"/></xsl:call-template>,'<xsl:value-of select="@CARACTER"/>');
			s<xsl:value-of select="$par"/>.addAplicacion(a);
		</xsl:for-each>
		s<xsl:value-of select="number($par)-1"/>.addSubSeccion(s<xsl:value-of select="$par"/>);
		<xsl:call-template name="cargaSeccion">
			<xsl:with-param name="raiz" select="$raiz"/>
			<xsl:with-param name="sec" select="@CODIGO"/>
			<xsl:with-param name="par" select="number($par)+1"/>
		</xsl:call-template>
	</xsl:for-each>
</xsl:template>

</xsl:stylesheet>
	