/*
 * 
 *
 */
package dumbo7.inicio;

import org.apache.log4j.*;
import atica.frameweb.utils.*;
import dumbo7.user.*;
import dumbo7.utils.ldap.*;
import dumbo7.utils.*;
import dumbo7.*;

import java.sql.*;
import java.util.*;
import java.util.regex.*;

import org.hibernate.*;
import org.hibernate.criterion.*;

import com.sun.syndication.feed.synd.*;
import com.sun.syndication.io.*;

import dumbo7.solicitudes.*;

/**
 * @author Universidad de Murcia - ATICA
 *
 */

public class GestorInicio extends GeneralManager {
	
	static int TOPE = 500;
	static Logger logger = Logger.getLogger(GestorInicio.class);
	public static Properties authProp = null;
	
	public GestorInicio() {}
	
	public String login = "", passwd = "", codigoAplicacion = "", patron = "", operacion = "";
	public List sistemas = null, noticias = null, importantes = null;
	public LDAPUser ldapUser = null;
	public D7DatosPersonales datPers = new D7DatosPersonales();
	public List usuarios = null;
	public Vector informaticos = new Vector();
	public String par= null;
	public List plantillas = null;

	public void setLogin(String l) { login = l.toLowerCase(); }
	public void setPassword(String p) { passwd = p; }
	public D7DatosPersonales getDatPers() { return datPers; }
	
	public void startDB(Session conn) {}
	
	public void getAuthProperties() throws Exception {
		if (authProp==null) {
			try {
				authProp = new Properties();
				authProp.load(getClass().getResource("auth.properties").openStream());
			} catch (Exception ex) {
				System.out.println("AuthProperties: "+ex);
				throw ex;
			}
		}
	}
	
	private boolean autentica(String usu,String pwd) throws Exception {
		getAuthProperties();
		if (authProp.getProperty("AUTH_TYPE").equals("RADIUS")) return net.sourceforge.jradiusclient.RadiusIdent.autentica(usu,pwd,"DUMBO");
		if (authProp.getProperty("AUTH_TYPE").equals("LDAP")) return LDAPUtil.autentica(usu,pwd);
		return true;
	}
	
	public void loginDumbo(Session conn) {
		try
		{
			if (autentica(login,passwd)) {
				String midni = D7Conversor.convierteMail(conn,login);
				setUser(new DumboUser(conn,login,passwd));
				// Este control lo hace la estafeta.
				/*String mimail = D7Conversor.convierteIdentificador(conn,midni);
				if (mimail.toLowerCase().equals(login.toLowerCase()))
					setUser(new DumboUser(conn,login,passwd));
				else errorMessage = "Error: Debe acceder a DUMBO con la cuenta principal asociada a su DNI.";*/
			} else {
				errorMessage = "Error: El usuario o la clave son incorrectos.";
			}
		}
		catch (Exception ex)
		{
			errorMessage = ex.getMessage();
			logger.error(ex.getMessage());
		}
	}

	public void anonymousLoginDumbo(Session conn,String clave) {
		
		PreparedStatement pstmt = null;
		ResultSet rs = null;
		try{
			pstmt = conn.connection().prepareStatement(getQuery("Claves"));
			pstmt.setString(1,clave.substring(0,clave.indexOf(".")));
			rs = pstmt.executeQuery();
			
			String usuario=null;
			String sist=null;
		 	while (rs.next()) {
	 	    	sist=rs.getString(1);
	 	    	usuario=rs.getString(2);
	 	    	operacion=rs.getString(3);
	 	    }   
	 	    //Si existe una fila en BBDD es correcto
	 	    if (usuario==null) errorMessage = "Error: El usuario o la clave son incorrectos.";
			else {
				DumboUser newuser = new DumboUser(conn,usuario,"",sist);
		 	    setLogin(usuario);
		 	    setPassword("");
				setUser(newuser);
				patron = clave.substring(clave.indexOf(".")+1);
			}
		}
		catch (Exception ex)
		{
			errorMessage = ex.getMessage().trim();
			logger.error(ex.getMessage());
			
		} finally {
			try {
				if (rs!=null) rs.close();
				if (pstmt!=null) pstmt.close();
			} catch (Exception ex) {}
		}
	}
	
	public void setServerSite(javax.servlet.http.HttpServlet srv,javax.servlet.http.HttpServletRequest req,javax.servlet.http.HttpServletResponse res) {
		if (user!=null)	((DumboUser)user).setServletUrl(req.getRequestURL().toString());
	}
	
	/**
	 * Obtiene la lista de Sistema para el Men.
	 * @param conn
	 */
	public void listSistemas(Session conn) {
		try {
			sistemas = conn.createQuery(getQuery("ListaSistemas")).list();
		} catch (Exception ex) {
			logger.error(ex.getMessage());
		}
	}

	public List getSistemas() {
		return sistemas;
	}
	
	public void setSistemas(List l) {
		sistemas = l;
	}
	
	/**
	 * Obtiene las Noticias de Inters de Dumbo en el sistema adecuado
	 * @param conn
	 */
	public void listNoticias(Session conn) {
		try {
			String sist = user.getDatosMenu().idSelected();
			if ((sist==null) || sist.equals(""))
				noticias = (conn.createQuery(getQuery("ListaNoticias"))).list();
			else {
				if (user.permitidoPerfiles(sist,"dumbo7/inicio","viewNoticiasInternas"))
					noticias = (conn.createQuery(getQuery("ListaNoticiasSistemaPrivadas")).setString("sist",sist)).list();
				else noticias = (conn.createQuery(getQuery("ListaNoticiasSistema")).setString("sist",sist)).list();
			}
		} catch (Exception ex) {
			logger.error(ex.getMessage());
		}
	}

	/**
	 * Obtiene las Noticias de Inters de Dumbo en el sistema dado
	 * @param conn
	 */
	public void listNoticiasSistema(Session conn,String sist) {
		try {
			if (user.permitidoPerfiles(sist,"dumbo7/inicio","viewNoticiasInternas"))
				noticias = (conn.createQuery(getQuery("ListaNoticiasSistemaPrivadas")).setString("sist",sist)).list();
			else noticias = (conn.createQuery(getQuery("ListaNoticiasSistema")).setString("sist",sist)).list();
		} catch (Exception ex) {
			logger.error(ex.getMessage());
		}
	}

	public List getNoticias() {
		return noticias;
	}
	
	public void setNoticias(List l) {
		noticias = l;
	}
	
	public void noticiasImportantes(Session conn) {
		try {
			// Compruebo si hay noticias importantes para cada sistema.
			List s = getSistemas();
			if (s==null) listSistemas(conn);
			importantes = new ArrayList();
			Iterator it = s.iterator();
			while (it.hasNext()) {
				D7Sistemas st = (D7Sistemas)it.next();
				List nimp = null;
				if (st.getSisIndInt().equals(D7Sistemas.INTERNO)) {
					if (user.permitidoPerfiles(st.getSisCod(),"dumbo7/inicio","viewNoticiasInternas"))
						nimp = (conn.createQuery(getQuery("ListaNoticiasSistemaPrivadasImportantes")).setString("sist",st.getSisCod())).list();
					else nimp = (conn.createQuery(getQuery("ListaNoticiasSistemaImportantes")).setString("sist",st.getSisCod())).list();
					if ((nimp!=null) && (nimp.size()>0)) importantes.add(st.getSisCod());
				}
			}
		} catch (Exception ex) {
			logger.error(ex.getMessage());
		}
	}
	
	public List getImportantes() { return importantes; }
	
	/*
	public void listAniversario(Session conn) {
		try {
			String sist = user.getDatosMenu().idSelected();
			if ((sist==null) || sist.equals(""))
				aniversarios = (conn.createQuery(getQuery("ListaAniversarios"))).list();
			else aniversarios = (conn.createQuery(getQuery("ListaAniversariosSistema")).setString("sist",sist)).list();
		} catch (Exception ex) {
			logger.error(ex.getMessage());
		}
	}
	
	public List getAniversarios() {
		return aniversarios;
	}
	
	public void setAniversarios(List l) {
		aniversarios = l;
	}
	*/
	public void detalleUsuario(Session conn,String usr) {
		String id = null;
		try {
			if (usr.indexOf("@")>0) {
				ldapUser = LDAPUtil.findUserByMail(usr);
				id = D7Conversor.convierteMail(conn,usr);
			} else {
				//ldapUser = LDAPUtil.findUserByDni(usr);
				id = usr;
			}
			D7DatosTrabajador dp = (D7DatosTrabajador)conn.load(D7DatosTrabajador.class,id);
			datPers.setDatCentro(dp.getDatCentro());
			datPers.setDatApellidos(dp.getDatApellidos());
			datPers.setDatDepartamento(dp.getDatDepartamento());
			datPers.setDatEmail(dp.getDatEmail());
			datPers.setDatIdentificador(dp.getDatIdentificador());
			datPers.setDatLetra(dp.getDatLetra());
			datPers.setDatNombre(dp.getDatNombre());
			datPers.setDatTelefono(dp.getDatTelefono());
			datPers.setDatTipo(dp.getDatTipo());
		} catch (Exception ex) {
			setErrorMessage("GestorInicio[detalleUser]: "+ex);
		}
	}
	
	public LDAPUser getLdapUser() { return ldapUser; }
	
	public void filtra(String filtro){
		try{
			
			//	filtro de PDI
		if (filtro.equals("1")){
			par = "07,08";
		}else{
			//filtro de PAS
			if (filtro.equals("2")){
				par = "05,06";
			}else{
				//filtro de alumnos
				if (filtro.equals("3")){
					par = "01,03";
				}else{
					//sin filtro
					par="";
				}
			}
		}
		} catch (Exception ex) {
			setErrorMessage("GestorInicio[filtra]: "+ex);
		}
	}
	
	public void RecorreResultSet(ResultSet rs){
		try{
			int numRows = 0;
			while (rs.next() && numRows < TOPE) {
				D7DatosPersonales dp = new D7DatosPersonales();
				dp.setDatIdentificador(rs.getString(1));
				dp.setDatNombre(rs.getString(2));
				dp.setDatApellidos(rs.getString(3));
				dp.setDatEmail(rs.getString(4));
			
				usuarios.add(dp);
				numRows++;
			}
			if (numRows==TOPE) {
				setErrorMessage("Demasiados Resultados: Afine la bsqueda. Slo se muestran los "+TOPE+" primeros resultados.");
			}		
		} catch (Exception ex) {
			setErrorMessage("GestorInicio[RecorreResultSet]: "+ex);
		}
	}
		
	public void buscaUsuario(Session conn,String ptr) {
		PreparedStatement pstmt = null;
		ResultSet rs = null;
		String myQuery = null;
		String filtro= null;
		String [] params = null;
		patron = ptr;
		
		try {
			//Busqueda por correo
			if (patron.indexOf("@")>0) {
				usuarios = new ArrayList();
				filtro= patron.substring(patron.length()-1, patron.length());
				patron = patron.substring(0,patron.length()-1);
				if (patron.endsWith("@")) patron = patron.substring(0,patron.length()-1);
				Vector v = LDAPUtil.findUsersByMail(patron+"*");
				Enumeration en = v.elements();
				while (en.hasMoreElements()) {
					LDAPUser ldu = (LDAPUser)en.nextElement();
					String dni=ldu.getDni();
					filtra(filtro);
					myQuery = getQuery("BuscaUsuariosConDNI");
//					Si hay filtro aadimos a la query la comprobacion
					if (!filtro.equals("4")) {
						params = par.split(",");
						String interrog = "";
						for (int k=0; k<params.length; k++) interrog += "?,";
						myQuery += "and relc_trel_codigo in (#)";
						myQuery = myQuery.replaceFirst("#",interrog.substring(0,interrog.length()-1));
					}
					pstmt = conn.connection().prepareStatement(myQuery);
					pstmt.setString(1,dni);
					
					int j = 2;
					if (!filtro.equals("4")) {
						for (int k=0; k<params.length; k++) pstmt.setString(j+k,params[k]);
					}	
					
					rs = pstmt.executeQuery();		
					RecorreResultSet(rs);	
					/*
					Criteria ct = conn.createCriteria(D7DatosPersonales.class);
					ct = ct.add(Expression.idEq(ldu.getDni()));
					D7DatosPersonales dp = (D7DatosPersonales)ct.list().get(0);
					String em = D7Conversor.convierteIdentificador(conn,dp.getDatIdentificador());
					if (em!=null && !em.trim().equals("")) dp.setDatEmail(em);
					*/
				}
			}else{
				//Busqueda por extension
				if (patron.indexOf("#")>0) {
					usuarios = new ArrayList();
					filtro= patron.substring(patron.length()-1, patron.length());
					patron = patron.substring(0,patron.length()-1);
					if (patron.endsWith("#")) patron = patron.substring(0,patron.length()-1);
					
					filtra(filtro);
					myQuery = getQuery("BuscaUsuariosPorExtension");
					
//					Si hay filtro aadimos a la query la comprobacion
					if (!filtro.equals("4")) {
						params = par.split(",");
						String interrog = "";
						for (int k=0; k<params.length; k++) interrog += "?,";
						myQuery += "and relc_trel_codigo in (#)";
						myQuery = myQuery.replaceFirst("#",interrog.substring(0,interrog.length()-1));
					}
				
					pstmt = conn.connection().prepareStatement(myQuery);
					pstmt.setString(1,"%"+patron);
					
					int j = 2;
					if (!filtro.equals("4")) {
						for (int k=0; k<params.length; k++) pstmt.setString(j+k,params[k]);
					}		
				
					rs = pstmt.executeQuery();
					RecorreResultSet(rs);
				
				} else {
					//Busqueda por apellidos (y nombre)
					usuarios = new ArrayList();
					String nombre = patron.substring(0, patron.indexOf("/"));
					String apellido = patron.substring(patron.indexOf("/")+1, patron.length());
					patron = patron.substring(0,patron.length()-1);
					filtro= apellido.substring(apellido.indexOf("/")+1, apellido.length());
					apellido = apellido.substring(0, apellido.indexOf("/"));
				
					filtra(filtro);
				
					myQuery = getQuery("BuscaUsuariosConRelacion");

					//Si hay filtro aadimos a la query la comprobacion
					if (!filtro.equals("4")) {
						params = par.split(",");
						String interrog = "";
						for (int k=0; k<params.length; k++) interrog += "?,";
						myQuery += "and relc_trel_codigo in (#)";
						myQuery = myQuery.replaceFirst("#",interrog.substring(0,interrog.length()-1));
					}
				
				
					pstmt = conn.connection().prepareStatement(myQuery);
					pstmt.setString(1,"%"+apellido.replace(' ','%')+"%");
					if (nombre.equals(null)) {
						pstmt.setString(2,"%");
					}	
					else{
						pstmt.setString(2,"%"+nombre.replace(' ','%')+"%");		
					}
					
					int j = 3;
					if (!filtro.equals("4")) {
						for (int k=0; k<params.length; k++) pstmt.setString(j+k,params[k]);
					}		
				
					rs = pstmt.executeQuery();
					RecorreResultSet(rs);
				}
			/*
			Vector v = convierteCadena(patron);
			if (v!=null && v.size()>0) myQuery += " "+condicionHQL(v.size());
			q = conn.createQuery(myQuery);
			q.setString("ape",patron.replace(' ','%')+"%");
			if (v!=null && v.size()>0) {
				for (int k=0; k<v.size(); k++) {
					String patron2 = (String)v.elementAt(k);
					q.setString("ape"+k,patron2.replace(' ','%')+"%");
				}
			}
			*/
			/*
			q = conn.createQuery(myQuery);
			q.setString("ape","%"+patron.replace(' ','%')+"%");
			q.setMaxResults(TOPE);
			List l = q.list();
			if (l.size()>=TOPE) {
				setErrorMessage("Demasiados Resultados: Afine la bsqueda. Slo se muestran los "+TOPE+" primeros resultados.");
				usuarios = new ArrayList();
				for (int k=0; k<TOPE; k++) {
					D7DatosPersonales dp = (D7DatosPersonales)l.get(k);
					String em = D7Conversor.convierteIdentificador(conn,dp.getDatIdentificador());
					if (em!=null && !em.trim().equals("")) dp.setDatEmail(em);
					usuarios.add(dp);
				}
			} else {
				usuarios = new ArrayList();
				for (int k=0; k<l.size(); k++) {
					D7DatosPersonales dp = (D7DatosPersonales)l.get(k);
					String em = D7Conversor.convierteIdentificador(conn,dp.getDatIdentificador());
					if (em!=null && !em.trim().equals("")) dp.setDatEmail(em);
					usuarios.add(dp);
				}
			}
			*/
			}
		} catch (Exception ex) {
			setErrorMessage("GestorInicio[BuscaUsuario]: "+ex);
		} finally {
			try {
				if (rs!=null) rs.close();
				if (pstmt!=null) pstmt.close();
			} catch (Exception exx) {}
		}
	}
	
	private String condicionHQL(int patrones) {
		String base = "or users.DatApellidos like UPPER(:ape) or users.DatApellidos like :ape ";
		String condicion="";
		for (int k=0; k<patrones; k++) {
			condicion += base.replaceAll(":ape",":ape"+k);
		}
		return condicion;
	}
	
	private boolean notAcentuada(String p) {
		return (p.indexOf("")<0 && p.indexOf("")<0 && p.indexOf("")<0 && p.indexOf("")<0 && p.indexOf("")<0);
	}
	
	private Vector convierteCadena(String patron,int n) {
		Vector listapatrones = new Vector();
		// Incluyo patrones aadiendo acentos (uno por palabra)
		int npatrones = 0;
		Vector patrones = new Vector();
		Hashtable palabras = new Hashtable();
		char [][] vocales = new char[][]{{'a',''},{'e',''},{'i',''},{'o',''},{'u',''}};
		int npalabras = 0;
		StringTokenizer st = new StringTokenizer(patron.toLowerCase());
		while (st.hasMoreTokens() && npalabras<4) {
			npalabras++;
			String palabra1 = st.nextToken(" ");
			if (notAcentuada(palabra1)) {
				for (int k=0; k<vocales.length; k++) {
					int m = palabra1.indexOf(vocales[k][0]);
					if (m<0) continue;
					while (m>=0) {
						String palabra2 = palabra1.substring(0,m)+vocales[k][1]+palabra1.substring(m+1);
						Vector v = (Vector)palabras.get(palabra1);
						if (v==null) v = new Vector();
						v.addElement(palabra2);
						palabras.put(palabra1,v);
						m = palabra1.indexOf(vocales[k][0],m+1);
					}
				}
			} else {
				Vector v = (Vector)palabras.get(palabra1);
				if (v==null) v = new Vector();
				v.addElement(palabra1.replace('','a').replace('','e').replace('','i').replace('','o').replace('','u'));
				palabras.put(palabra1,v);
			}
			Vector v = (Vector)palabras.get(palabra1);
			if (v==null) { v = new Vector(); palabras.put(palabra1,v); }
		}
		int nt = 0;
		st = new StringTokenizer(patron.toLowerCase());
		String [] tokens = new String[st.countTokens()];
		while (st.hasMoreTokens()) {
			tokens[nt] = st.nextToken(" "); nt++;
		}
		for (int k=0; k<nt; k++) {
			patrones(listapatrones,palabras,patron.toLowerCase(),tokens,k);
		}
		return listapatrones;
	}
	
	private void patrones(Vector lp,Hashtable palabras,String patron,String [] t,int i) {
		Vector v = (Vector)palabras.get(t[i]);
		if (v==null) return;
		for (int k=0; k<v.size(); k++) {
			String nuevoPatron = patron.replaceFirst(t[i],(String)v.elementAt(k));
			if (!lp.contains(nuevoPatron) && !notAcentuada(nuevoPatron))
				lp.addElement(nuevoPatron);
			for (int j=i+1; j<t.length; j++) {
				patrones(lp,palabras,nuevoPatron,t,j);
			}
		}
	}
	
	public void buscaNombreUsuario(Session conn,String ptr) {
		patron = ptr;
		try {
	
			if (Pattern.matches("([0-9]{8}|[X,U][0-9]{7})",patron)) {
				// Es un DNI
				Query q = conn.createQuery(getQuery("BuscaUsuarioDNI"));
				q.setString("dni",patron);
				usuarios = q.list();
			} else if (patron.indexOf("@")>0) {
				// Es un correo
				Query q = conn.createQuery(getQuery("BuscaUsuarioDNI"));
				q.setString("dni",D7Conversor.convierteMail(conn,patron));
				usuarios = q.list();
			} else {
				// Es un apellido
				String myQuery = getQuery("BuscaUsuarios");
				/*
				Vector v = convierteCadena(patron);
				if (v!=null && v.size()>0) myQuery += " "+condicionHQL(v.size());
				Query q = conn.createQuery(myQuery);
				q.setString("ape",patron.replace(' ','%')+"%");
				if (v!=null && v.size()>0) {
					for (int k=0; k<v.size(); k++) {
						String patron2 = (String)v.elementAt(k);
						q.setString("ape"+k,patron2.replace(' ','%')+"%");
					}
				}
				*/
				Query q = conn.createQuery(myQuery);
				q.setString("ape",patron.replace(' ','%')+"%");
				usuarios = new ArrayList();
				usuarios.add(q.list().get(0));
			}
			
		} catch (Exception ex) {
			setErrorMessage("GestorInicio[BuscaNombreUsuario]: "+ex);
		}
	}

	public void buscaDatosUsuario(Session conn,String ubica) {
		if (ubica==null || !ubica.equals("1")) return;
		CallableStatement cstmt = null;
		try {
			D7DatosPersonales dp = (D7DatosPersonales)usuarios.get(0);
			cstmt = conn.connection().prepareCall(getQuery("UbicacionTlfnoProc"));
			cstmt.setString(1,dp.getDatIdentificador());
			cstmt.registerOutParameter(2,Types.VARCHAR);
			cstmt.registerOutParameter(3,Types.VARCHAR);
			cstmt.registerOutParameter(4,Types.VARCHAR);
			cstmt.execute();
			dp.setDatDepartamento(cstmt.getString(2));
			dp.setDatTelefono(cstmt.getString(3));
			dp.setDatCentro(cstmt.getString(4));
		} catch (Exception ex) {
			setErrorMessage("GestorInicio[BuscaDatosUsuario]: "+ex);
		} finally {
			try {
				if (cstmt!=null) cstmt.close();
			} catch (Exception ex) {}
		}
	
	/*
		PreparedStatement pstmt = null;
		ResultSet rs = null;
		if (ubica==null || !ubica.equals("1")) return;
		try {
			D7DatosPersonales dp = (D7DatosPersonales)usuarios.get(0);
			pstmt = conn.connection().prepareStatement(getQuery("UbicacionTlfno"));
			pstmt.setString(1,dp.getDatIdentificador());
			rs = pstmt.executeQuery();
			if (rs.next()) {
				dp.setDatDepartamento(rs.getString(1));
				dp.setDatTelefono(rs.getString(2));
				dp.setDatCentro(rs.getString(3));
			}
		} catch (Exception ex) {
			setErrorMessage("GestorInicio[BuscaDatosUsuario]: "+ex);
		} finally {
			try {
				if (rs!=null) rs.close();
				if (pstmt!=null) pstmt.close();
			} catch (Exception ex) {}
		}
		*/
	}
	
	public void buscaNombreInformatico(Session conn,String ptr) {
		patron = ptr;
		try {
			if (patron.indexOf("@")>0) patron = D7Conversor.convierteMail(conn,patron);
			Criteria ct = conn.createCriteria(D7AplicacionesInformaticos.class);
			ct = ct.add(Expression.eq("AinSisCod",user.getDatosMenu().idSelected()));
			ct = ct.add(Expression.eq("AinInfCod",patron));
			if ((codigoAplicacion!=null) && !codigoAplicacion.equals("") && !codigoAplicacion.equals("-1")) ct = ct.add(Expression.eq("AinAplCod",codigoAplicacion));
			List l = ct.list();
			Iterator it = l.iterator();
			while (it.hasNext()) {
				D7AplicacionesInformaticos ai = (D7AplicacionesInformaticos)it.next();
				D7DatosPersonales dp = ai.getDatosInform();
				informaticos.addElement(dp);
			}
			if (informaticos.size()>0) {
				PreparedStatement pstmt = null;
				ResultSet rs = null;
				try {
					pstmt = conn.connection().prepareStatement(getQuery("AusenteInfo"));
					pstmt.setString(1,((D7DatosPersonales)informaticos.get(0)).getDatIdentificador());
					rs = pstmt.executeQuery();
					if (rs.next()) {
						String ausente = rs.getString(1);
						if (ausente!=null && ausente.equals("S")) operacion = "$AUS$";
						else operacion = "";
					}
				} catch (Exception ex) {
					setErrorMessage("GestorInicio[BuscaNombreInformatico]: "+ex);
				} finally {
					if (rs!=null) rs.close();
					if (pstmt!=null) pstmt.close();
				}
			}
		} catch (Exception ex) {
			setErrorMessage("GestorInicio[BuscaNombreInformatico]: "+ex);
		}
	}

	public List getUsuarios() { return usuarios; }
	
	public void setAplicacion(String ap) {
		codigoAplicacion = ap;
	}
	
	public void buscaInformatico(Session conn,String ptr) {
		patron = ptr;
		try {
			boolean correo = false;
			if (patron.indexOf("@")>0) { patron = patron.substring(0,patron.length()-1); correo = true; }
			Criteria ct = conn.createCriteria(D7AplicacionesInformaticos.class);
			if ((codigoAplicacion==null) || codigoAplicacion.equals("") || codigoAplicacion.equals("-1")) ct = ct.add(Expression.eq("AinSisCod",user.getDatosMenu().idSelected()));
			else ct = ct.add(Expression.and(Expression.eq("AinSisCod",user.getDatosMenu().idSelected()),Expression.eq("AinAplCod",codigoAplicacion)));
			List l = ct.list();
			Iterator it = l.iterator();
			while (it.hasNext()) {
				D7AplicacionesInformaticos ai = (D7AplicacionesInformaticos)it.next();
				D7DatosPersonales dp = ai.getDatosInform();
				dp.setDatEmail(D7Conversor.convierteIdentificador(conn,dp.getDatIdentificador()));
				if (correo) {
					String mail = GestorGenerico.sinAcentos(dp.getDatEmail().toLowerCase());
					if ((mail.indexOf(GestorGenerico.sinAcentos(patron.toLowerCase()))>=0) && !informaticos.contains(dp)) {
						informaticos.addElement(dp);
					}
				} else {
					String nombreIntroducido = patron.substring(0, patron.indexOf("/"));
					String apellidoIntroducido = patron.substring(patron.indexOf("/")+1, patron.length());
					
					String nombreActual = GestorGenerico.sinAcentos(dp.getDatNombre().toLowerCase());
					String apellidoActual = GestorGenerico.sinAcentos(dp.getDatApellidos().toLowerCase());
					
					if (nombreIntroducido.equals(null)) {
						if ((apellidoActual.indexOf(GestorGenerico.sinAcentos(apellidoIntroducido.toLowerCase()))>=0) && !informaticos.contains(dp)) {
							informaticos.addElement(dp);
						}
					}
					else{
						if (apellidoIntroducido.equals(null)) {
							if ((nombreActual.indexOf(GestorGenerico.sinAcentos(nombreIntroducido.toLowerCase()))>=0) && !informaticos.contains(dp)) {
								informaticos.addElement(dp);
							}
						}
						else{
							if ((nombreActual.indexOf(GestorGenerico.sinAcentos(nombreIntroducido.toLowerCase()))>=0) && (apellidoActual.indexOf(GestorGenerico.sinAcentos(apellidoIntroducido.toLowerCase()))>=0) && !informaticos.contains(dp)) {
								informaticos.addElement(dp);
							}	
						}
					}
					
				}
			}
		} catch (Exception ex) {
			setErrorMessage("GestorInicio[BuscaInformatico]: "+ex);
		}
	}
	
	public Vector getInformaticos() { return informaticos; }

	public void listaInformaticos(Session conn,String ptr) {
		patron = ptr;
		try {
			Query q = conn.createQuery(getQuery("InformaticosAplicacion"));
			q.setString("sist",user.getDatosMenu().idSelected());
			q.setString("aplCod",codigoAplicacion);
			List l = q.list();
			Iterator it = l.iterator();
			while (it.hasNext()) {
				D7AplicacionesInformaticos ai = (D7AplicacionesInformaticos)it.next();
				ai.getDatosInform().setDatEmail(D7Conversor.convierteIdentificador(conn,ai.getAinInfCod()));
				informaticos.addElement(ai.getDatosInform());
				//LDAPUser usr = LDAPUtil.findUserByMail(ai.getAinInfEmail());
				//LDAPUser usr = getLDAPUser(ai.getAinInfEmail(),users);
				//if (usr!=null) informaticos.addElement(usr);
			}
			
		} catch (Exception ex) {
			setErrorMessage("GestorInicio[BuscaInformatico]: "+ex);
		}
	}
	
	private LDAPUser getLDAPUser(String email,Vector v) {
		Enumeration en = v.elements();
		while (en.hasMoreElements()) {
			LDAPUser lu = (LDAPUser)en.nextElement();
			String mail = lu.getMail();
			if (mail.equals(email)) return lu;
		}
		return null;
	}
	
	public String getPatron() { return patron; }
	public String getOperacion() { return operacion; }
	public String getCodigoTarea() { return codigoAplicacion; }
	
	public void doit(Session conn,String code) {
		try {
			patron = code;
			// Obtengo la clave.
			D7ClavesNotificaciones dc = (D7ClavesNotificaciones)conn.load(D7ClavesNotificaciones.class,code);
			// Obtengo el mximo permitido en das.
			Criteria ct = conn.createCriteria(D7Parametros.class);
			ct = ct.add(Expression.eq("ParSisCod",dc.getClnSisCod()));
			ct = ct.add(Expression.eq("ParParametro","PAR_TIEMPO_MAXIMO"));
			D7Parametros par = (D7Parametros)ct.list().get(0);
			// Compruebo si casa
			java.util.Date fini = dc.getClnFecha();
			GregorianCalendar gcini = new GregorianCalendar();
			gcini.setTime(fini);
			gcini.add(Calendar.DATE,Integer.parseInt(par.getParValor()));
			GregorianCalendar gchoy = new GregorianCalendar();
			if (gcini.before(gchoy)) {
				deleteTareaClave(conn,code);
				throw new Exception("Dispone de slo de "+par.getParValor()+" das desde que se gener el correo para usar el enlace.");
			}
			operacion = dc.getClnOperacion();
			codigoAplicacion = ""+dc.getClnTarCod();
		} catch (Exception ex) {
			setErrorMessage("Error: "+ex);
		}
		
	}

	public D7Tareas getTareaClave(Session conn,String code) {
		D7Tareas t = null;
		try {
			
			Query q = conn.createQuery(getQuery("GetClave"));
			q = q.setString("cadena",code);
			List l = q.list();
			if (l.size()==0) return null;
			D7ClavesNotificaciones cn = (D7ClavesNotificaciones)q.list().get(0);
			
			q = conn.createQuery(getQuery("GetTarea"));
			q = q.setString("sist",cn.getClnSisCod());
			q = q.setInteger("tarCod",cn.getClnTarCod().intValue());
			return (D7Tareas) q.list().get(0);
			
		} catch (Exception ex) {
			System.out.println("GetTareaClave: "+ex);
		}
		return t;
	}

	public void deleteTareaClave(Session conn,String code) {
		Transaction tx = null;
		D7Tareas t = null;
		try {
			
			tx = conn.beginTransaction();
			
			Query q = conn.createQuery(getQuery("GetClave"));
			q = q.setString("cadena",code);
			List l = q.list();
			if (l.size()==0) return;
			D7ClavesNotificaciones cn = (D7ClavesNotificaciones)q.list().get(0);
			
			conn.delete(cn);
			
			tx.commit();
			
		} catch (Exception ex) {
			System.out.println("DeleteTareaClave: "+ex);
		}
	}
	
	public void rechazarAnulacionTarea(Session conn,D7Tareas mitar) {
		try {
			D7Tareas tar = getTareaClave(conn,mitar.getTarUbicacion());
			if (tar==null) return;
			tar.setTarDescripSegui(mitar.getTarDescripSegui());
			GestorSolicitudes gsol = new GestorSolicitudes();
			DumboUser newuser = new DumboUser(conn,tar.getTarUsuCod(),"",tar.getTarSisCod());
			newuser.getDatosMenu().setOption(tar.getTarSisCod());
			setLogin(tar.getTarUsuCod());
			setPassword("");
			gsol.setUser(newuser);
			gsol.reactivarTarea(conn, tar);
			
			operacion = "Se ha rechazado la anulacin de la tarea correctamente.";
			
			deleteTareaClave(conn,mitar.getTarUbicacion());
			
		} catch (Exception ex) {
			setErrorMessage("rechazarAnulacionTarea: "+ex);
		}
	}

	public void rechazarEsperaTarea(Session conn,D7Tareas mitar) {
		try {
			D7Tareas tar = getTareaClave(conn,mitar.getTarUbicacion());
			if (tar==null) return;
			tar.setTarDescripSegui(mitar.getTarDescripSegui());
			GestorSolicitudes gsol = new GestorSolicitudes();
			DumboUser newuser = new DumboUser(conn,tar.getTarUsuCod(),"",tar.getTarSisCod());
			newuser.getDatosMenu().setOption(tar.getTarSisCod());
			setLogin(tar.getTarUsuCod());
			setPassword("");
			gsol.setUser(newuser);
			gsol.rechazarWaiting(conn, tar);
			
			operacion = "Se ha rechazado la puesta a espera de la tarea correctamente.";
			
			deleteTareaClave(conn,mitar.getTarUbicacion());
			
		} catch (Exception ex) {
			setErrorMessage("rechazarEsperaTarea: "+ex);
		}
	}
	
	public void rechazarResolucionTarea(Session conn,D7Tareas mitar) {
		try {
			D7Tareas tar = getTareaClave(conn,mitar.getTarUbicacion());
			if (tar==null) return;
			tar.setTarDescripSegui(mitar.getTarDescripSegui());
			GestorSolicitudes gsol = new GestorSolicitudes();
			DumboUser newuser = new DumboUser(conn,tar.getTarUsuCod(),"",tar.getTarSisCod());
			newuser.getDatosMenu().setOption(tar.getTarSisCod());
			setLogin(tar.getTarUsuCod());
			setPassword("");
			gsol.setUser(newuser);
			gsol.rechazarTarea(conn, tar);
			
			operacion = "Se ha rechazado la resolucin de la tarea correctamente.";
			
			deleteTareaClave(conn,mitar.getTarUbicacion());
			
		} catch (Exception ex) {
			setErrorMessage("rechazarResolucionTarea: "+ex);
		}
	}
	
	public void rechazarInformeTarea(Session conn,D7Tareas mitar) {
		try {
			D7Tareas tar = getTareaClave(conn,mitar.getTarUbicacion());
			if (tar==null) return;
			
			Transaction tx = conn.beginTransaction();
			D7UsuariosNotificaciones du = new D7UsuariosNotificaciones();
			du.setUnoSisCod(tar.getTarSisCod());
			String usu = tar.getTarUsuCod();
			if (usu.equals(DumboUser.CODIGO_EXTERNO)) {
				usu = tar.getTarEmailCopia();
				if ((usu!=null) && usu.indexOf(",")>0) usu = usu.substring(0,usu.indexOf(","));
			} 
			du.setUnoUser(usu);
			du.setUnoFecha(new java.util.Date());
			conn.saveOrUpdate(du);
			tx.commit();
			
			operacion = "Se ha rechazado la recepcin de informes de tareas correctamente.";
			
			deleteTareaClave(conn,mitar.getTarUbicacion());
			
		} catch (Exception ex) {
			setErrorMessage("rechazarInformeTarea: "+ex);
		}
	}

	public void rechazarPlanificacionTarea(Session conn,D7Tareas mitar) {
		try {
			D7Tareas tar = getTareaClave(conn,mitar.getTarUbicacion());
			if (tar==null) return;
			tar.setTarDescripSegui(mitar.getTarDescripSegui());
			
			Transaction tx = conn.beginTransaction();
			Query q = conn.createQuery(getQuery("GetTarea"));
			q.setString("tarCod",""+tar.getTarCod());
			q.setString("sist",tar.getTarSisCod());
			D7Tareas original = (D7Tareas)q.list().get(0);
			original.setTarDescripSegui(tar.getTarDescripSegui());
			tx.commit();
			
			// Mandar Correo An No Definido
			operacion = "Se ha rechazado la planificacin de la tarea correctamente.";
			
			deleteTareaClave(conn,mitar.getTarUbicacion());
			
		} catch (Exception ex) {
			setErrorMessage("rechazarPlanificacionTarea: "+ex);
		}
	}
	
	/* CODIGO PARA INCLUIR LA CITA DEL DIA */
	public static long inicioCita = System.currentTimeMillis();
	public static long REFRESCO_CITA = 3600000;
	public static String miCita = null;
	public static String miAutor = null;
	public static String errorCita = null;
	public static String enlaceAutor = null;
	public static Properties citaProp = null;
	public static void setMiAutor(String aut) { miAutor = aut;}
	public static void setMiCita(String cit) { miCita = cit; }
	public static void setMiEnlaceAutor(String enl) { enlaceAutor = enl; }
	
	public String getErrorCita() { return errorCita; }
	public String getEnlaceAutor() { return enlaceAutor; }
	public String getCitaDiaria() {	return miCita; }
	public String getAutorCitaDiaria() { return miAutor; }
	public void citaDelDia() {
		// Refresca la cita
		if (miCita==null || (System.currentTimeMillis()-inicioCita)>REFRESCO_CITA) {
			inicioCita = System.currentTimeMillis();
			if (miCita==null || errorCita!=null) {
				getCitaProperties();
				obtenerCitaDelDia();
			}
		}
	}
	
	public void getCitaProperties() {
		if (citaProp==null || errorCita!=null) {
			try {
				citaProp = new Properties();
				citaProp.load(getClass().getResource("cita.properties").openStream());
			} catch (Exception ex) {
				System.out.println("CitaProperties: "+ex);
			}
		}
	}
	
	public static void obtenerCitaDelDia() {

		String textoExc = "En desarrollo ests y tu cita no vers.";
		String autorExc = "Developer.";
		String textoErr = "Servicio de citas no disponible.";
		String autorErr = "Administrador.";
		String hostExc = "cpd";
		String URL_CITA = "http://www.proverbia.net/qotd.asp";
		if (citaProp!=null) {
			textoExc = citaProp.getProperty("EXCLUDE_CITA");
			autorExc = citaProp.getProperty("EXCLUDE_AUTOR");
			hostExc = citaProp.getProperty("EXCLUDE_HOST");
			URL_CITA = citaProp.getProperty("URL_CITA");
			textoErr = citaProp.getProperty("ERROR_CITA");
			autorErr = citaProp.getProperty("ERROR_AUTOR");
		}
		try {
			
			java.net.URL feedUrl = new java.net.URL(URL_CITA);
            SyndFeedInput input = new SyndFeedInput();
            SyndFeed feed = input.build(atica.frameweb.xml.XMLUtil.parse(feedUrl.openStream()));
            SyndEntry myEntry = (SyndEntry) feed.getEntries().get(0);
            
            setMiCita(myEntry.getDescription().getValue());
            setMiAutor(myEntry.getTitleEx().getValue());
            setMiEnlaceAutor(myEntry.getLink());
            errorCita = null;
            
		} catch (Exception ex) {
            setMiCita(textoErr);
            setMiAutor(autorErr);
            setMiEnlaceAutor("");
            errorCita = ""+ex;
		}		
		
	}
	public List getPlantillas() { return plantillas; }
	
	public void listPlantillas(Session conn) {
		try{
			Query q = conn.createQuery(getQuery("GetPlantillas"));
			q = q.setString("sist",user.getDatosMenu().idSelected());
			plantillas = (List)q.list();
		}
		catch (Exception ex)
		{
			setErrorMessage("Error al listar las plantillas.");
		} 
	}
}
