<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet version="1.0" 
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:xforms="http://www.w3.org/2002/xforms">
	
<xsl:param name="servlet"/>	
<xsl:param name="menu"/>

<xsl:include href="dumbo7/utils/xsl/utils.xsl"/>
	
<xsl:template match="XMLROOT">

<html lang="es">

	<xsl:call-template name="headComun">
		<xsl:with-param name="arbol" select="true()"/>
		<xsl:with-param name="ERROR" select="DATA/GESTION/@ERROR"/>
		<xsl:with-param name="jscript">
         	<SCRIPT LANGUAGE="JavaScript" SRC="/forja/jquery/jquery.js"></SCRIPT>
         	<SCRIPT LANGUAGE="JavaScript">
         		var srvName = "<xsl:value-of select="$servlet"/>";
            </SCRIPT>
        </xsl:with-param>
	</xsl:call-template>
	
<body>
		<xsl:call-template name="menuComun">
			<xsl:with-param name="NOTSHOW" select="string-length($menu)=0"/>
			<xsl:with-param name="MENU" select="DATA/MENU"/>
			<xsl:with-param name="SELECT" select="$menu"/>
			<xsl:with-param name="NAME" select="concat(DATA/INICIO/USER/@NAME,concat(' (',concat(DATA/INICIO/USER/@LOGIN,')')))"/>
		</xsl:call-template>
		<p>&#160;</p>
		<xsl:call-template name="pieComun"/>
</body>
</html>
</xsl:template>

<xsl:template name="cuerpo">
<br/>
<xsl:variable name="sistema">
	<xsl:choose>
		<xsl:when test="contains($menu,'/')">
			<xsl:value-of select="substring-before($menu,'/')"/>
		</xsl:when>
		<xsl:otherwise>
			<xsl:value-of select="$menu"/>
		</xsl:otherwise>
	</xsl:choose>
</xsl:variable>
<table align="center" width="80%" cellpadding="0" cellspacing="0">
<tr>
	<td colspan="2">&#160;</td>
</tr>
<tr>
	<td id="noticiasImportantes" style="display:none" colspan="2">Cargando Noticias Importantes del Sistema...</td> 
</tr>
<tr id="logos">
	<td valign="top">
		<table cellpadding="0" cellspacing="0">
			<xsl:choose>
				<xsl:when test="string-length($menu)=0">
					<xsl:for-each select="DATA/MENU/ITEM">
						<xsl:variable name="pos" select="position()"/>
						<xsl:if test="($pos mod 2)=1">
							<tr>
							<xsl:for-each select="../ITEM">
								<xsl:variable name="mid" select="@ID"/>
								<xsl:variable name="sacaNoticia"><xsl:if test="count(/XMLROOT/DATA/INICIO/IMPORTANTE[.=$mid])>0">S</xsl:if></xsl:variable>
								<xsl:variable name="grafico"><xsl:choose><xsl:when test="contains(@ID,'E-')"><xsl:value-of select="substring-after(@ID,'E-')"/></xsl:when><xsl:otherwise><xsl:value-of select="@ID"/></xsl:otherwise></xsl:choose></xsl:variable>
								<xsl:if test="(position()>=$pos) and (($pos+1)>=position())">
									<xsl:choose>
										<xsl:when test="count(.//ITEM[@AUTO])=0">
											<td><div align="center"><a href="javascript:goMenu('{@URL}','{@ID}','{$sacaNoticia}');"><img src="../graficos/dp{$grafico}2.gif" title="{@NAME}" width="155" height="100" border="0" /></a></div></td>
										</xsl:when>
										<xsl:otherwise>
											<xsl:for-each select=".//ITEM[@AUTO and /XMLROOT/DATA/SECURITY[@MODULE='dumbo7/inicio']/ACTION/@NAME=self::*/@AUTO]">
												<xsl:sort select="number(@AUTO)"/>
												<xsl:if test="position()=1">
													<td><div align="center"><a><xsl:attribute name="href">javascript:goMenu('<xsl:value-of select="@URL"/>','<xsl:call-template name="idMenu"><xsl:with-param name="menu" select="."/></xsl:call-template>','<xsl:value-of select="$sacaNoticia"/>');</xsl:attribute><img src="../graficos/dp{$grafico}2.gif" title="{../../@NAME}" width="155" height="100" border="0" /></a></div></td>
												</xsl:if>
											</xsl:for-each>
										</xsl:otherwise>
									</xsl:choose>
								</xsl:if>
							</xsl:for-each>
							</tr>
						</xsl:if>
					</xsl:for-each>
				</xsl:when>
				<xsl:otherwise>
					<xsl:for-each select="DATA/MENU/ITEM[starts-with($menu,@ID)]">
						<xsl:variable name="grafico"><xsl:choose><xsl:when test="contains(@ID,'E-')"><xsl:value-of select="substring-after(@ID,'E-')"/></xsl:when><xsl:otherwise><xsl:value-of select="@ID"/></xsl:otherwise></xsl:choose></xsl:variable>
						<tr>
							<td><div align="center" valign="top"><a href="javascript:goMenu('{@URL}','{@ID}');"><img src="../graficos/dp{$grafico}2.gif" title="{@NAME}" width="155" height="100" border="0" /></a></div></td>
						</tr>
					</xsl:for-each>
				</xsl:otherwise>
			</xsl:choose>
		</table>
	</td>
	<td valign="top">
	<xsl:if test="count(DATA/INICIO/NOTICIA[($sistema='') or (@SISTEMA=$sistema) or (@GENERAL='G')])=0">
		<xsl:choose>
			<xsl:when test="$sistema=''">
				<h1>Bienvenido a DUMBO!</h1>
				<center><h3>No hay noticias nuevas en DUMBO.</h3></center>
			</xsl:when>
			<xsl:otherwise>
				<h1>Bienvenido al Sistema!</h1>
				<center><h3>No hay noticias nuevas en el Sistema.</h3></center>
			</xsl:otherwise>
		</xsl:choose>
		<!-- Inserta una cita si no hay noticias -->
		<center>
		<iframe src="{$servlet}?module=dumbo7/inicio.cita" frameborder="0" height="100" width="450" scrolling="no"></iframe>
		</center>
	</xsl:if>
	<table class="contout">
		<xsl:for-each select="DATA/INICIO/NOTICIA[($sistema='') or (@SISTEMA=$sistema) or (@GENERAL='G')]">
			<tr class="peticion">
				<td><strong><xsl:value-of select="@ASUNTO"/></strong></td>
				<td align="right"><font size="-2">[<xsl:call-template name="date2String2"><xsl:with-param name="fecha" select="@FECHA"/></xsl:call-template>]</font></td>
			</tr>
			<tr>
				<td colspan="2">
					<xsl:value-of select="@TEXTO"/><br/>
					<xsl:if test="string-length(@URL)>0">
					<xsl:choose>
						<xsl:when test="starts-with(@URL,'http://')">
							<a href="{@URL}" target="newWindow_{@CODIGO}"><xsl:value-of select="@URL"/></a>
						</xsl:when>
						<xsl:otherwise>
							<a href="http://{@URL}/" target="newWindow_{@CODIGO}"><xsl:value-of select="@URL"/></a>
						</xsl:otherwise>
					</xsl:choose>
					</xsl:if>
				</td>
			</tr>
			<tr>
				<td colspan="2">&#160;</td>
			</tr>
		</xsl:for-each>
	</table>
	</td>
</tr>
</table>
</xsl:template>

<xsl:template name="idMenu">
<xsl:param name="menu"/>
<xsl:choose>
<xsl:when test="name($menu/..)='ITEM'"><xsl:call-template name="idMenu"><xsl:with-param name="menu" select="$menu/.."/></xsl:call-template>/<xsl:value-of select="$menu/@ID"/></xsl:when>
<xsl:otherwise><xsl:value-of select="$menu/@ID"/></xsl:otherwise>
</xsl:choose>
</xsl:template>

</xsl:stylesheet>
	