/*
 * 
 *
 */
package dumbo7.metricas;

import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.util.*;

import org.apache.log4j.*;
import org.hibernate.Criteria;
import org.hibernate.Query;
import org.hibernate.Session;
import org.hibernate.criterion.Expression;

import dumbo7.GestorGenerico;
import dumbo7.utils.*;
import dumbo7.utils.ldap.*;
import atica.frameweb.utils.*;

/**
 * @author Universidad de Murcia - ATICA
 *
 */

public class GestorMetricas extends GeneralManager {
	static Logger logger = Logger.getLogger(GestorMetricas.class);
	
	private List usuarios= new Vector();
	public List informaticos = new Vector();
	
	private String patron ="";
	private String aplicacion = "";
	private String seccion = "";
	
	public GestorMetricas() {}
	
	public void setAplicacion(String apl){this.aplicacion = apl;}
	public void setSeccion(String sec){this.seccion = sec;}
	
	/*Mtodos GET para el mapeo*/
	public List getUsuarios() {return usuarios;}
	public String getPatron() {return patron;}
	public List getInformaticos() { return informaticos; }
	
	/*BUSQUEDAS DE GESTOR*/
	public void buscaUsuarioGestor(Session conn,String ptr) {
		patron = ptr;
		try {
			Query q = null;
			if (patron.indexOf("@")>0) {
				usuarios = new ArrayList();
				patron = patron.substring(0,patron.length()-1);
				Vector v = LDAPUtil.findUsersByMail(patron+"*");
				Enumeration en = v.elements();
				while (en.hasMoreElements()) {
					LDAPUser ldu = (LDAPUser)en.nextElement();
			        
					q = conn.createQuery(getQuery("BuscaUsuariosGestorDNI"));
			        q = q.setString("sist",user.getDatosMenu().idSelected());
			        q = q.setString("gestor",user.getIdentificador());
			        q = q.setString("dni",ldu.getDni());
			        			       
			        if(!q.list().isEmpty()){
			        	usuarios.add(q.list().get(0));
			        }
				}
			} else {
				q = conn.createQuery(getQuery("BuscaUsuariosGestorAPE"));
				q = q.setString("sist",user.getDatosMenu().idSelected());
			    q = q.setString("gestor",user.getIdentificador());
				q.setString("ape","%"+patron+"%");
				usuarios = q.list();
			}
		} catch (Exception ex) {
			setErrorMessage("GestorMETRICAS[BuscaUsuario]: "+ex);
		}
	}
	public void buscaUsuarioGestorDNI(Session conn,String ptr){
		patron = ptr;
		try{
			Query q = conn.createQuery(getQuery("BuscaUsuariosGestorDNI"));
			q = q.setString("dni",this.patron);
			q = q.setString("sist",user.getDatosMenu().idSelected());
			q = q.setString("gestor",user.getIdentificador());
			this.usuarios  = (List)q.list();
		}catch (Exception ex){
			setErrorMessage("GestorMetricas[Lectura de BBDD]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
	}
	public void buscaInformaticoGestor(Session conn,String ptr) {
		patron = ptr;
		if (patron.indexOf("@")>0) {
			/**BUSCAMOS LOS INFORMATICOS CON EL PATRON DEL EMAIL EN LDAP*/
			//Elimino la @ del e-mail
			patron = patron.substring(0,patron.length()-1);
			Vector v = LDAPUtil.findUsersByMail(patron+"*");
			Enumeration informaticosLDAP = v.elements();
			
			/**BUSCAMOS TODOS LOS INFORMATICOS QUE PODRAN CUMPLIR LAS CONDICIONES IMPUESTAS*/
			PreparedStatement pstmt;
			List informaticosBBDD = new Vector();
			try{
				String ResultadoQuery = getQuery("BuscaInformaticosGestorDNI");
				ResultadoQuery = ResultadoQuery.replaceAll(":DNI", this.patron);
				ResultadoQuery = ResultadoQuery.replaceAll(":SISTEMA",user.getDatosMenu().idSelected());
				ResultadoQuery = ResultadoQuery.replaceAll(":GESTOR",user.getIdentificador());
				pstmt = conn.connection().prepareStatement(ResultadoQuery);
				ResultSet rs = pstmt.executeQuery();
				
			 	while (rs.next()) {
			 		D7DatosPersonales inf = new D7DatosPersonales();
		 	    	inf.setDatIdentificador(rs.getString(1));
		 	    	inf.setDatLetra(rs.getString(2));
		 	    	inf.setDatApellidos(rs.getString(3));
		 	    	inf.setDatNombre(rs.getString(4));
		 	    	inf.setDatEmail(rs.getString(5));
		 	    	inf.setDatDepartamento(rs.getString(6));
		 	    	inf.setDatCentro(rs.getString(7));
		 	    	inf.setDatTipo(rs.getString(8));
		 	    	inf.setDatTelefono(rs.getString(9));
		 	    	informaticosBBDD.add(inf);
		 	    }   
		 	    rs.close();
		 	    pstmt.close();
			} catch (Exception ex) {
				System.out.println(ex);
				setErrorMessage("GestorMetricas[Lectura de BBDD Informaticos]: "+((ex.getCause()!=null)?ex.getCause():ex));
			}
			
			/**DE LAS BUSQUEDAS ANTERIORES TOMAMOS LOS ELEMENTOS QUE SE ENCUENTRAN EN LAS DOS Y ESTOS SERAN LOS 
			 * QUE SE MOSTRARN COMO RESULTADO*/
			Iterator itBBDD = informaticosBBDD.iterator();
			while(itBBDD.hasNext()){
				D7DatosPersonales infor = (D7DatosPersonales)itBBDD.next();
				informaticosLDAP = v.elements();
				while (informaticosLDAP.hasMoreElements()) {
					LDAPUser ldu = (LDAPUser)informaticosLDAP.nextElement();
					if(infor.getDatIdentificador().equals(ldu.getDni())){
						informaticos.add(infor);
					}
				}
			}
			
		}
		else {
			PreparedStatement pstmt;
			try{
				String ResultadoQuery = getQuery("BuscaInformaticosGestorAPE");
				ResultadoQuery = ResultadoQuery.replaceAll(":SISTEMA",user.getDatosMenu().idSelected());
				ResultadoQuery = ResultadoQuery.replaceAll(":GESTOR",user.getIdentificador());
				ResultadoQuery = ResultadoQuery.replaceAll(":APELLIDO","%"+ptr+"%");
				pstmt = conn.connection().prepareStatement(ResultadoQuery);
				ResultSet rs = pstmt.executeQuery();
				
			 	while (rs.next()) {
		 	    	D7DatosPersonales inf = new D7DatosPersonales();
		 	    	inf.setDatIdentificador(rs.getString(1));
		 	    	inf.setDatLetra(rs.getString(2));
		 	    	inf.setDatApellidos(rs.getString(3));
		 	    	inf.setDatNombre(rs.getString(4));
		 	    	inf.setDatEmail(rs.getString(5));
		 	    	inf.setDatDepartamento(rs.getString(6));
		 	    	inf.setDatCentro(rs.getString(7));
		 	    	inf.setDatTipo(rs.getString(8));
		 	    	inf.setDatTelefono(rs.getString(9));
		 	    	this.informaticos.add(inf);
		 	    }   
		 	    rs.close();
		 	    pstmt.close();
			} catch (Exception ex) {
				System.out.println(ex);
				setErrorMessage("GestorMetricas[Lectura de BBDD Informaticos]: "+((ex.getCause()!=null)?ex.getCause():ex));
			}
		}
	}
	public void buscaInformaticoGestorDNI(Session conn,String ptr){
		patron = ptr;
		PreparedStatement pstmt;
		String ResultadoQuery = "";
		try{
			
			ResultadoQuery = getQuery("BuscaInformaticosGestorDNI");
			ResultadoQuery = ResultadoQuery.replaceAll(":DNI", this.patron);
			ResultadoQuery = ResultadoQuery.replaceAll(":SISTEMA",user.getDatosMenu().idSelected());
			ResultadoQuery = ResultadoQuery.replaceAll(":GESTOR",user.getIdentificador());
				
			pstmt = conn.connection().prepareStatement(ResultadoQuery);
			ResultSet rs = pstmt.executeQuery();
			
			while (rs.next()) {
	 	    	D7DatosPersonales inf = new D7DatosPersonales();
	 	    	inf.setDatIdentificador(rs.getString(1));
	 	    	inf.setDatLetra(rs.getString(2));
	 	    	inf.setDatApellidos(rs.getString(3));
	 	    	inf.setDatNombre(rs.getString(4));
	 	    	inf.setDatEmail(rs.getString(5));
	 	    	inf.setDatDepartamento(rs.getString(6));
	 	    	inf.setDatCentro(rs.getString(7));
	 	    	inf.setDatTipo(rs.getString(8));
	 	    	inf.setDatTelefono(rs.getString(9));
	 	    	/*Los metemos en usuarios para no tener que hacer otra pgina(POP-UP) con un mapeo en su interior
	 	    	  ademas no es relevante puesto que los informticos tambin son usuarios del sistema.*/
	 	       	this.usuarios.add(inf);
	 	    }   
	 	    rs.close();
	 	    pstmt.close();
		} catch (Exception ex) {
			System.out.println(ex);
			setErrorMessage("GestorMetricas[Lectura de BBDD Informaticos]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
	}
	
	/*BUSQUEDAS DE MAESTRO*/
	public void buscaUsuarioMaestro(Session conn,String ptr) {
		patron = ptr;
		try {
			Query q = null;
			if (patron.indexOf("@")>0) {
				usuarios = new ArrayList();
				patron = patron.substring(0,patron.length()-1);
				Vector v = LDAPUtil.findUsersByMail(patron+"*");
				Enumeration en = v.elements();
				while (en.hasMoreElements()) {
					LDAPUser ldu = (LDAPUser)en.nextElement();
					Criteria ct = conn.createCriteria(D7DatosPersonales.class);
					ct = ct.add(Expression.idEq(ldu.getDni()));
					usuarios.add(ct.list().get(0));
				}
			} else {
				q = conn.createQuery(getQuery("BuscaUsuariosMaestroAPE"));
				q = q.setString("sist",user.getDatosMenu().idSelected());
				q.setString("ape","%"+patron+"%");
				usuarios = q.list();
			}
		} catch (Exception ex) {
			setErrorMessage("GestorMETRICAS[BuscaUsuario]: "+ex);
		}
	}
	public void buscaUsuarioMaestroDNI(Session conn,String ptr){
		patron = ptr;
		try{
			Query q = conn.createQuery(getQuery("BuscaUsuariosMaestroDNI"));
			q = q.setString("dni",this.patron);
			q = q.setString("sist",user.getDatosMenu().idSelected());
			this.usuarios  = (List)q.list();
		}catch (Exception ex){
			setErrorMessage("GestorMetricas[Lectura de BBDD]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
	}
	public void buscaInformaticoMaestro(Session conn,String ptr) {
		patron = ptr;
		try {
			Query q = null;
			if (patron.indexOf("@")>0) {
				informaticos = new ArrayList();
				patron = patron.substring(0,patron.length()-1);
				Vector v = LDAPUtil.findUsersByMail(patron+"*");
				Enumeration en = v.elements();
				while (en.hasMoreElements()) {
					LDAPUser ldu = (LDAPUser)en.nextElement();
			        
					q = conn.createQuery(getQuery("BuscaInformaticosMaestroDNI"));
			        q = q.setString("sist",user.getDatosMenu().idSelected());
			        q = q.setString("sec",this.seccion);
				    q = q.setString("apl",this.aplicacion);
			        q = q.setString("dni",ldu.getDni());
			        			       
			        if(!q.list().isEmpty()){
			        	informaticos.add(q.list().get(0));
			        }
				}
			} else {
				q = conn.createQuery(getQuery("BuscaInformaticosMaestroAPE"));
				q = q.setString("sist",user.getDatosMenu().idSelected());
				q = q.setString("sec",this.seccion);
			    q = q.setString("apl",this.aplicacion);
				q.setString("ape","%"+patron+"%");
				informaticos = q.list();
			}
		} catch (Exception ex) {
			setErrorMessage("GestorMETRICAS[BuscaUsuario]: "+ex);
		}
	}
	public void buscaInformaticoMaestroDNI(Session conn,String ptr){
		patron = ptr;
		try{
			Query q = conn.createQuery(getQuery("BuscaInformaticosMaestroDNI"));
			q = q.setString("dni",this.patron);
			q = q.setString("sist",user.getDatosMenu().idSelected());
			q = q.setString("sec",this.seccion);
			q = q.setString("apl",this.aplicacion);
			this.usuarios  = (List)q.list();
		}catch (Exception ex){
			setErrorMessage("GestorMetricas[Lectura de BBDD]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
	}
	
	/*BUSQUEDAS DE INFORMATICO*/
	public void buscaUsuarioInformatico(Session conn,String ptr) {
		patron = ptr;
		try {
			Query q = null;
			if (patron.indexOf("@")>0) {
				usuarios = new ArrayList();
				patron = patron.substring(0,patron.length()-1);
				Vector v = LDAPUtil.findUsersByMail(patron+"*");
				Enumeration en = v.elements();
				while (en.hasMoreElements()) {
					LDAPUser ldu = (LDAPUser)en.nextElement();
			        
					q = conn.createQuery(getQuery("BuscaUsuariosInformaticoDNI"));
			        q = q.setString("sist",user.getDatosMenu().idSelected());
			        q = q.setString("informatico",user.getIdentificador());
			        q = q.setString("dni",ldu.getDni());
			        			       
			        if(!q.list().isEmpty()){
			        	usuarios.add(q.list().get(0));
			        }
				}
			} 
			else{
				q = conn.createQuery(getQuery("BuscaUsuariosInformaticoAPE"));
				q = q.setString("sist",user.getDatosMenu().idSelected());
				q = q.setString("informatico",user.getIdentificador());
				q.setString("ape","%"+patron+"%");
				usuarios = q.list();
			}
		
		} catch (Exception ex) {
			setErrorMessage("GestorMETRICAS[BuscaUsuario]: "+ex);
		}
	}
	public void buscaUsuarioInformaticoDNI(Session conn,String ptr){
		patron = ptr;
		try{
			Query q = conn.createQuery(getQuery("BuscaUsuariosInformaticoDNI"));
			q = q.setString("dni",this.patron);
			q = q.setString("sist",user.getDatosMenu().idSelected());
			q = q.setString("informatico",user.getIdentificador());
			this.usuarios  = (List)q.list();
		}catch (Exception ex){
			setErrorMessage("GestorMetricas[Lectura de BBDD]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
	}
}
