package dumbo7.metricas.atencion;

import dumbo7.metricas.*;

import java.sql.*;
import java.sql.ResultSet;
import java.util.*;

import dumbo7.utils.*;

import org.hibernate.Query;
import org.hibernate.Session;

import atica.frameweb.utils.*;

/**
 * @author Antonio
 *
 * Gestor de Metricas Atencin de Dumbo
 * 
 */
public class GestorAtencion extends GeneralManager {
	private List seccionesResponsable = new Vector();
	private List aplicaciones = new Vector();
	private List categorias= new Vector();
	private List grupoUsuarios= new Vector();
	private List usuarios= new Vector();
	private List secciones = new Vector();
	private List informaticos= new Vector();
	private List ModoDato;
	private Vector resultadoMetricas = new Vector();
	private Vector resultadoMetricas_tm = new Vector();
	private Vector resultadoMetricas_desglose_tm = new Vector();
	
	private String X1 = "";
	private String X2 = "";
	private String X3 = "";
	private String X4 = "";
	private String Aplicacion = "";
	private String Seccion = "";
	private String Categoria = "";
	private String Informatico = "";
	private String Usuario = "";
	private String GrupoUsuarios = "";
	private String Datos = "";
	private String Codigo = "";
	private String Sel = "";
	private String Patron = "";
	
	private String FechaDesde;
	private String FechaHasta;
	private String Desglose;/**Desglose que se puede hacer cuando estas en modo DATO*/
		
	public GestorAtencion() {}
	
	//Mtodos get() para el mapeo
	public List getAplicaciones() { return aplicaciones; }
	public List getCategorias() { return categorias; }
	public List getSeccionesResponsable() { return seccionesResponsable; }
	public List getSecciones() { return secciones; }
	public List getInformaticos() { return informaticos; }
	public List getGrupoUsuarios() { return grupoUsuarios; }
	public List getUsuarios() { return usuarios; }
	public List getModoDato(){return ModoDato;}
	public Vector getResultadoMetricas(){return this.resultadoMetricas;}
	public Vector getResultadoMetricas_tm(){return this.resultadoMetricas_tm;}
	public Vector getResultadoMetricas_desglose_tm(){return this.resultadoMetricas_desglose_tm;}
	
	//Mtodos set para recoger los datos del formulario
	/**Metdo set() para obtener las fechas de inicio y fin del histrico*/
	public void setFechaDesde(String FDesde){this.FechaDesde = FDesde;}
	public void setFechaHasta(String FHasta){this.FechaHasta = FHasta;}
	
	/**Metodos para obtener los tramos de encuadre de la mtrica*/
	public void setX1(String x){this.X1 = x;}
	public void setX2(String x){this.X2 = x;}
	public void setX3(String x){this.X3 = x;}
	public void setX4(String x){this.X4 = x;}
		
	/**Puede obtener los valores: 
	 * 		con(sin Desglose)
	 * 		apl(por Aplicacion)
	 * 		usu(por Usuario) 
	 * 		cat(por Categoria)
	 * 		gusu(por Grupousuario)
	 * */
	public void setDesglose(String D){this.Desglose = D;}
	public void setSeccion(String sec){this.Seccion = sec;}
	public void setUsuario(String U){
		if(U != null){
			this.Usuario = U;
		}
		else{
			this.Usuario = "";
		}
	}
	public void setGrupoUsuario(String Gu){
		if(Gu != null){
			this.GrupoUsuarios = Gu;
		}
		else{
			this.GrupoUsuarios = "";
		}
	}
	
	/**	Lista todas las secciones*/
	public void listaSecciones(Session conn){
		try{
			Query q = conn.createQuery(getQuery("AllSecciones"));
			q = q.setString("sist",user.getDatosMenu().idSelected());
			secciones  = (List)q.list();
		}
		catch (Exception ex){
			setErrorMessage("GestorMetricas[Lectura de BBDD]: Error al listar Seccines");
		}
	}
	
	public void setAplicacion(String Apl){this.Aplicacion = Apl;}
	public void setInformatico(String Inf){this.Informatico = Inf;}
	public void setCategoria(String cat){this.Categoria = cat;}
	
	/**Lista secciones con datos sin importar el estado, para el select inicial de secciones(no incluye estado finalizado)**/
	public void listaSeccionesConDatos(Session conn) {
		PreparedStatement pstmt;
		
		try{
			String ResultadoQuery = getQuery("SeccionesConDatos");
			ResultadoQuery = ResultadoQuery.replaceAll(":SISTEMA",user.getDatosMenu().idSelected());
			ResultadoQuery = ResultadoQuery.replaceAll(":GESTOR",user.getIdentificador());
			pstmt = conn.connection().prepareStatement(ResultadoQuery);
			ResultSet rs = pstmt.executeQuery();
			
		 	while (rs.next()) {
	 	    	D7Secciones sec = new D7Secciones();
	 	    	sec.setSecSisCod(rs.getString("Sec_Sis_Cod"));
	 	    	sec.setSecCod(rs.getString("Sec_Cod"));
	 	    	sec.setSecDescrip(rs.getString("Sec_Descrip"));
	 	    	sec.setSecIdRespon(rs.getString("Sec_Id_Respon"));
	 	    	sec.setSecSecCod(rs.getString("Sec_Sec_Cod"));
	 	    	sec.setSecEstado(rs.getString("Sec_Estado"));
	 	    	secciones.add(sec);
	 	    }
		 	rs.close();
	 	    pstmt.close();
		} catch (Exception ex) {
			System.out.println(ex);
			setErrorMessage("GestorMetricas[Lectura de BBDD]: Error al listar Seccines con Datos");
		}
	}
	
	/**-------------LISTADOS DE UN NICO ELEMENTO(COMPONENTE)-------------------*/
	public void QuerySeccion(Session conn, String SecCod){
		try{
			Query q = conn.createQuery(getQuery("ListaUnaSeccion"));
			q = q.setString("sist",user.getDatosMenu().idSelected());
			q = q.setString("cod",SecCod);
			secciones  = (List)q.list();		
		}catch (Exception ex){
			setErrorMessage("GestorMetricas[Lectura de BBDD]: Error al obtener la seccin");
		}
	}
	public void QueryAplicacion(Session conn, String AplCod){
		try{
			Query q = conn.createQuery(getQuery("ListaUnaAplicacion"));
			q = q.setString("sist",user.getDatosMenu().idSelected());
			q = q.setString("cod",AplCod);
			aplicaciones = (List)q.list();		
		}catch (Exception ex){
			setErrorMessage("GestorMetricas[Lectura de BBDD]: Error al obtener la aplicacin");
		}	
	}
	public void QueryInformatico(Session conn, String InfCod){
		try{
			Query q = conn.createQuery(getQuery("ListaUnInformatico/Usuario"));
			q = q.setString("cod",InfCod);
			informaticos  = (List)q.list();		
		}catch (Exception ex){
			setErrorMessage("GestorMetricas[Lectura de BBDD]: Error al obtener el informtico");
		}	
	}
	public void QueryUsuario(Session conn, String UsuCod){
		try{
			Query q = conn.createQuery(getQuery("ListaUnInformatico/Usuario"));
			q = q.setString("cod",UsuCod);
			usuarios  = (List)q.list();		
		}catch (Exception ex){
			setErrorMessage("GestorMetricas[Lectura de BBDD]: Error al obtener el usuario");
		}	
	}
	public void QueryCategoria(Session conn, String CatCod){
		try{
			Query q = conn.createQuery(getQuery("ListaUnaCategoria"));
			q = q.setString("sist",user.getDatosMenu().idSelected());
			q = q.setString("cod", CatCod);
			categorias  = (List)q.list();		
		}catch (Exception ex){
			setErrorMessage("GestorMetricas[Lectura de BBDD]: Error al obtener la categora");
		}	
	}
	public void QueryGrupoUsuario(Session conn, String GruCod){
		try{
			Query q = conn.createQuery(getQuery("ListaUnGrupoUsuarios"));
			q = q.setString("sist",user.getDatosMenu().idSelected());
			q = q.setString("cod",GruCod);
			grupoUsuarios  = (List)q.list();		
		}catch (Exception ex){
			setErrorMessage("GestorMetricas[Lectura de BBDD]: Error al obtener el grupo de usuario");
		}
	}
	
	/**Patron de las busquedas de secciones, categoras grupos usuarios...*/
	public void setPatron(String patron){this.Patron = patron;}
	
	/**-------------------INFORMATICO-------------------*/
	public void listaAplicacionesInformatico(Session conn){
		try{
			Query q = conn.createQuery(getQuery("AplicacionesInformaticoConAyuda"));
			q = q.setString("sist",user.getDatosMenu().idSelected());
			q = q.setString("informatico",user.getIdentificador());
			aplicaciones  = (List)q.list();		
		}catch (Exception ex){
			setErrorMessage("GestorMetricas[Lectura de BBDD]: Error al obtener las aplicaciones asociadas al informtico");
		}
	}
	public void listaGrupoUsuariosInformatico(Session conn) {
		PreparedStatement pstmt;
		try{
			Query q = conn.createQuery(getQuery("GruUsuInformaticoConAyuda"));
			q = q.setString("sist",user.getDatosMenu().idSelected());
			q = q.setString("informatico",user.getIdentificador());
			this.grupoUsuarios = (List)q.list();		
		}catch (Exception ex){
			setErrorMessage("GestorMetricas[Lectura de BBDD]: Error al obtener los grupos de usuarios asociados al informtico");
		}
	}
	public void listaUsuariosInformatico(Session conn) {
		try{
			Query q = conn.createQuery(getQuery("UsuariosInformaticoConAyuda"));
			q = q.setString("sist",user.getDatosMenu().idSelected());
			q = q.setString("informatico",user.getIdentificador());
			usuarios  = (List)q.list();		
		}catch (Exception ex){
			setErrorMessage("GestorMetricas[Lectura de BBDD]: Error al obtener los usuarios que han solicitado tareas al informtico");
		}
	}
	public void listaCategoriasInformatico(Session conn) {
		try{
			Query q = conn.createQuery(getQuery("CategoriasInformaticoConAyuda"));
			q = q.setString("sist",user.getDatosMenu().idSelected());
			q = q.setString("informatico",user.getIdentificador());
			categorias  = (List)q.list();		
		}catch (Exception ex){
			setErrorMessage("GestorMetricas[Lectura de BBDD]: Error al obtener la categoras asociadas al informtico");
		}
	}
	
	/**-------------------GESTOR-------------------*/
	public void listaAplicacionesGestor(Session conn){
		PreparedStatement pstmt;
		try{
			String ResultadoQuery = getQuery("AplicacionesGestorConAyuda");
			ResultadoQuery = ResultadoQuery.replaceAll(":SISTEMA",user.getDatosMenu().idSelected());
			ResultadoQuery = ResultadoQuery.replaceAll(":GESTOR",user.getIdentificador());
			pstmt = conn.connection().prepareStatement(ResultadoQuery);
			ResultSet rs = pstmt.executeQuery();
			
		 	while (rs.next()) {
	 	    	D7Aplicaciones apli = new D7Aplicaciones();
	 	    	apli.setAplSisCod(rs.getString("Apl_Sis_Cod"));
	 	    	apli.setAplCod(rs.getString("Apl_Cod"));
	 	    	apli.setAplDescrip(rs.getString("Apl_Descrip"));
	 	    	apli.setAplTipoAsig(rs.getString("Apl_Tipo_Asig"));
	 	    	apli.setAplSecCod(rs.getString("Apl_Sec_Cod"));
	 	    	apli.setAplEstado(rs.getString("Apl_Estado"));
	 	    	apli.setAplPadreAplCod(rs.getString("Apl_Padre_Apl_Cod"));
	 	    	aplicaciones.add(apli);
	 	    }   
	 	    rs.close();
	 	    pstmt.close();
		} catch (Exception ex) {
			System.out.println(ex);
			setErrorMessage("GestorMetricas[Lectura de BBDD]: Error al obtener las aplicaciones osociadas al Gestor");
		}
	}
	public void listaSeccionesGestorConDatos(Session conn) {
		PreparedStatement pstmt;
		
		try{
			String ResultadoQuery = getQuery("SeccionesConDatosGestor");
			ResultadoQuery = ResultadoQuery.replaceAll(":SISTEMA",user.getDatosMenu().idSelected());
			ResultadoQuery = ResultadoQuery.replaceAll(":GESTOR",user.getIdentificador());
			ResultadoQuery = ResultadoQuery.replaceAll(":FINALIZADA",D7Tareas.FINALIZADA);
			pstmt = conn.connection().prepareStatement(ResultadoQuery);
			ResultSet rs = pstmt.executeQuery();
			
		 	while (rs.next()) {
	 	    	D7Secciones sec = new D7Secciones();
	 	    	sec.setSecSisCod(rs.getString("Sec_Sis_Cod"));
	 	    	sec.setSecCod(rs.getString("Sec_Cod"));
	 	    	sec.setSecDescrip(rs.getString("Sec_Descrip"));
	 	    	sec.setSecIdRespon(rs.getString("Sec_Id_Respon"));
	 	    	sec.setSecSecCod(rs.getString("Sec_Sec_Cod"));
	 	    	sec.setSecEstado(rs.getString("Sec_Estado"));
	 	    	secciones.add(sec);
	 	    }
		 	rs.close();
	 	    pstmt.close();
		} catch (Exception ex) {
			System.out.println(ex);
			setErrorMessage("GestorMetricas[Lectura de BBDD]: Error al obtener las seccines con Datos asociadas al Gestor");
		}
	}
	public void listaSeccionesGestor(Session conn) {
		PreparedStatement pstmt;
		
		try{
			String ResultadoQuery = getQuery("SeccionesGestorConAyuda");
			ResultadoQuery = ResultadoQuery.replaceAll(":SISTEMA",user.getDatosMenu().idSelected());
			ResultadoQuery = ResultadoQuery.replaceAll(":GESTOR",user.getIdentificador());
			pstmt = conn.connection().prepareStatement(ResultadoQuery);
			ResultSet rs = pstmt.executeQuery();
			
		 	while (rs.next()) {
	 	    	D7Secciones sec = new D7Secciones();
	 	    	sec.setSecSisCod(rs.getString("Sec_Sis_Cod"));
	 	    	sec.setSecCod(rs.getString("Sec_Cod"));
	 	    	sec.setSecDescrip(rs.getString("Sec_Descrip"));
	 	    	sec.setSecIdRespon(rs.getString("Sec_Id_Respon"));
	 	    	sec.setSecSecCod(rs.getString("Sec_Sec_Cod"));
	 	    	sec.setSecEstado(rs.getString("Sec_Estado"));
	 	    	seccionesResponsable.add(sec);
	 	    }
		 	rs.close();
	 	    pstmt.close();
		} catch (Exception ex) {
			System.out.println(ex);
			setErrorMessage("GestorMetricas[Lectura de BBDD]: Error al obtener las seccines asociadas al Gestor");
		}
	}
	public void listaCategoriasGestor(Session conn, String SecCod) {
		PreparedStatement pstmt;
		try{
			String ResultadoQuery = getQuery("CategoriasGestorConAyuda");
			ResultadoQuery = ResultadoQuery.replaceAll(":SISTEMA",user.getDatosMenu().idSelected());
			ResultadoQuery = ResultadoQuery.replaceAll(":SECCION",SecCod);
			pstmt = conn.connection().prepareStatement(ResultadoQuery);
			ResultSet rs = pstmt.executeQuery();
			
		 	while (rs.next()) {
	 	    	D7Categorias cat = new D7Categorias();
	 	    	cat.setCatSisCod(rs.getString("Cat_Sis_Cod"));
	 	    	cat.setCatCod(new Integer(rs.getInt("Cat_Cod")));
	 	    	cat.setCatDescrip(rs.getString("Cat_Descrip"));
	 	    	cat.setCatEstado(rs.getString("Cat_Estado"));
	 	    	cat.setCatTipCod(rs.getString("Cat_Tip_Cod"));
	 	    	cat.setCatSecCod(rs.getString("Cat_Sec_Cod"));
	 	    	cat.setCatCatCod(new Integer(rs.getString("Cat_Cat_Cod")));
	 	    	cat.setCatTiempoEst(rs.getBigDecimal("Cat_Tiempo_Est"));
	 	    	categorias.add(cat);
	 	    }   
	 	    rs.close();
	 	    pstmt.close();
		} catch (Exception ex) {
			System.out.println(ex);
			setErrorMessage("GestorMetricas[Lectura de BBDD Usuarios]: Error al obtener las Categoras asociadas al Gestor");
		}
	}
	public void listaGrupoUsuariosGestor(Session conn) {
		PreparedStatement pstmt;
		try{
			Query q = conn.createQuery(getQuery("GruUsuGestorConAyuda"));
			q = q.setString("sist",user.getDatosMenu().idSelected());
			q = q.setString("gestor",user.getIdentificador());
			this.grupoUsuarios = (List)q.list();		
		}catch (Exception ex){
			setErrorMessage("GestorMetricas[Lectura de BBDD]: Error al obtener los grupos de usuarios asociados al Gestor");
		}
	}
	
	/**-------------------MAESTRO-------------------*/
	public void listaSeccionesMaestroConDatos(Session conn) {
		PreparedStatement pstmt;
		
		try{
			String ResultadoQuery = getQuery("SeccionesConDatosMaestro");
			ResultadoQuery = ResultadoQuery.replaceAll(":SISTEMA",user.getDatosMenu().idSelected());
			ResultadoQuery = ResultadoQuery.replaceAll(":FINALIZADA",D7Tareas.FINALIZADA);
			pstmt = conn.connection().prepareStatement(ResultadoQuery);
			ResultSet rs = pstmt.executeQuery();
			
		 	while (rs.next()) {
	 	    	D7Secciones sec = new D7Secciones();
	 	    	sec.setSecSisCod(rs.getString("Sec_Sis_Cod"));
	 	    	sec.setSecCod(rs.getString("Sec_Cod"));
	 	    	sec.setSecDescrip(rs.getString("Sec_Descrip"));
	 	    	sec.setSecIdRespon(rs.getString("Sec_Id_Respon"));
	 	    	sec.setSecSecCod(rs.getString("Sec_Sec_Cod"));
	 	    	sec.setSecEstado(rs.getString("Sec_Estado"));
	 	    	secciones.add(sec);
	 	    }
		 	rs.close();
	 	    pstmt.close();
		} catch (Exception ex) {
			System.out.println(ex);
			setErrorMessage("GestorMetricas[Lectura de BBDD]: Error al obtener las seccines con datos del MAESTRO");
		}
	}
	public void listaSeccionesMaestro(Session conn){
		try{
			Query q = conn.createQuery(getQuery("SeccionesMaestroConAyuda"));
			q = q.setString("sist",user.getDatosMenu().idSelected());
			secciones  = (List)q.list();
		} catch (Exception ex) {
			setErrorMessage("GestorMetricas[Lectura de BBDD]: Error al obtener las seccines del MAESTRO");
		}
	}
	public void listaAplicacionesMaestro(Session conn){
		try{
			Query q = conn.createQuery(getQuery("AplicacionesMaestroConAyuda"));
			q = q.setString("sist",user.getDatosMenu().idSelected());
			aplicaciones  = (List)q.list();
		} catch (Exception ex) {
			setErrorMessage("GestorMetricas[Lectura de BBDD]: Error al obtener las aplicacines del MAESTRO");
		}
	}
	public void listaGrupoUsuariosMaestro(Session conn){ 
		try{
			Query q = conn.createQuery(getQuery("GruUsuMaestroConAyuda"));
			q = q.setString("sist",user.getDatosMenu().idSelected());
			grupoUsuarios  = (List)q.list();		
		}catch (Exception ex){
			setErrorMessage("GestorMetricas[Lectura de BBDD]: Error al obtener los grupos de usuario asociados al MAESTRO");
		}
	}
	public void listaCategoriasMaestro(Session conn, String SecCod) {
		PreparedStatement pstmt;
		try{
			String ResultadoQuery = getQuery("CategoriasMaestroConAyuda");
			ResultadoQuery = ResultadoQuery.replaceAll(":SISTEMA",user.getDatosMenu().idSelected());
			ResultadoQuery = ResultadoQuery.replaceAll(":SECCION",SecCod);
			pstmt = conn.connection().prepareStatement(ResultadoQuery);
			ResultSet rs = pstmt.executeQuery();
			
		 	while (rs.next()) {
	 	    	D7Categorias cat = new D7Categorias();
	 	    	cat.setCatSisCod(rs.getString("Cat_Sis_Cod"));
	 	    	cat.setCatCod(new Integer(rs.getInt("Cat_Cod")));
	 	    	cat.setCatDescrip(rs.getString("Cat_Descrip"));
	 	    	cat.setCatEstado(rs.getString("Cat_Estado"));
	 	    	cat.setCatTipCod(rs.getString("Cat_Tip_Cod"));
	 	    	cat.setCatSecCod(rs.getString("Cat_Sec_Cod"));
	 	    	cat.setCatCatCod(new Integer(rs.getString("Cat_Cat_Cod")));
	 	    	cat.setCatTiempoEst(rs.getBigDecimal("Cat_Tiempo_Est"));
	 	    	categorias.add(cat);
	 	    }   
	 	    rs.close();
	 	    pstmt.close();
		} catch (Exception ex) {
			System.out.println(ex);
			setErrorMessage("GestorMetricas[Lectura de BBDD Categorias]: Error a obtener las categoras asociadas al MAESTRO");
		}
	}
	
		
	/** Mtodo para sustituir todos los parmetros de la query de ListaEnModoDato o ListaEnModoDatoDesglose
	* En este mtodo se elige cual de las 2 querys realizar en funcin de si se ha elegido desglose o no
	* Adems tambin se sustituyen los parmetros en funcin de si se ha introducido usuario, informatico, seccion...
	* */
	/**-------------------RESULTADOS de las mtricas para MAESTRO-------------------*/
	public void listaModoDatoMaestro(Session conn){
		PreparedStatement pstmt;
		PreparedStatement pstmt1;
		PreparedStatement pstmt2;
		/**String para construir la query de GESTOR*/
		String Query ="";
		/**String para construir la query de TIEMPOS MEDIOS DE GESTOR*/
		String Query_tm = "";
		/**String para construir la query de TIEMPOS MEDIOS(DESGLOSADOS) DE GESTOR*/
		String Query_desglose_tm = "";
		try{
			/**Inicio de la cuenta para la medicin del tiempo de ejecucin de la METRICA*/
			java.util.Date FechaInicio = new java.util.Date();
			int MinutosI = FechaInicio.getMinutes();
			int SegundosI = FechaInicio.getSeconds();
			
			Query_tm = getQuery("ListaTMGeneralEnModoDato");
			
			for(int i = 0; i<=4; i++){
				if(!Desglose.equals("con")){
					Query = getQuery("ListaGeneralEnModoDatoDesglose");
					Query_desglose_tm =  getQuery("ListaTMDesglosadaEnModoDato");
					if(Desglose.equals("sec")){
						Query = Query.replaceAll(":RESTRICCIONES",")");
						Query_desglose_tm = Query_desglose_tm.replaceAll(":RESTRICCIONES",")");
					}
					else{
						Query = Query.replaceAll(":RESTRICCIONES",getQuery("RestriccionDesglose"));
						Query_desglose_tm = Query_desglose_tm.replaceAll(":RESTRICCIONES",getQuery("RestriccionDesglose"));
						Query = Query.replaceAll(":CONDICION_GESTOR","");
						Query_desglose_tm = Query_desglose_tm.replaceAll(":CONDICION_GESTOR","");
					}
					if(Desglose.equals("apl")){
						/**SE EST REALIZANDO UN DESGLOSE POR APLICACIN*/
						Query = Query.replaceAll(":TIPODESGLOSE","A");					
						Query = Query.replaceAll(":CAMPODESGLOSE","apl_cod");
						Query = Query.replaceAll(":TSISTDESGLOSE","apl_sis_cod = " + "'"+user.getDatosMenu().idSelected()+"'");
						Query = Query.replaceAll(":TSIST","");
						Query = Query.replaceAll(":DESCRIPDESGLOSE",",apl_descrip");
						Query = Query.replaceAll(":TABLADESGLOSE","DUMBO.D7_APLICACIONES");
						Query = Query.replaceAll(":TABLA","");
						Query = Query.replaceAll(":RESTRICTAREA","tar_apl_cod = apl_cod");
						Query= Query.replaceAll(":JOIN_RESTRICCION"," ");
						/**/
						Query_desglose_tm = Query_desglose_tm.replaceAll(":TIPODESGLOSE","A");					
						Query_desglose_tm = Query_desglose_tm.replaceAll(":CAMPODESGLOSE","apl_cod");
						Query_desglose_tm = Query_desglose_tm.replaceAll(":TSISTDESGLOSE","apl_sis_cod = " + "'"+user.getDatosMenu().idSelected()+"'");
						Query_desglose_tm = Query_desglose_tm.replaceAll(":TSIST","");
						Query_desglose_tm = Query_desglose_tm.replaceAll(":DESCRIPDESGLOSE",",apl_descrip");
						Query_desglose_tm = Query_desglose_tm.replaceAll(":TABLADESGLOSE","DUMBO.D7_APLICACIONES");
						Query_desglose_tm = Query_desglose_tm.replaceAll(":TABLA","");
						Query_desglose_tm = Query_desglose_tm.replaceAll(":RESTRICTAREA","tar_apl_cod = apl_cod");
						Query_desglose_tm= Query_desglose_tm.replaceAll(":JOIN_RESTRICCION"," ");
					}else if(Desglose.equals("cat")){
						/**SE EST REALIZANDO UN DESGLOSE POR CATEGORA*/
						Query = Query.replaceAll(":TIPODESGLOSE","C");					
						Query = Query.replaceAll(":CAMPODESGLOSE","cat_cod");
						Query = Query.replaceAll(":TSISTDESGLOSE","cat_sis_cod = " + "'"+user.getDatosMenu().idSelected()+"'");
						Query = Query.replaceAll(":TSIST","");
						Query = Query.replaceAll(":DESCRIPDESGLOSE",",cat_descrip");
						Query = Query.replaceAll(":RESTRICTAREA","tar_cat_cod = cat_cod");
						Query = Query.replaceAll(":TABLADESGLOSE","DUMBO.D7_CATEGORIAS");
						Query = Query.replaceAll(":TABLA","");
						Query = Query.replaceAll(":JOIN_RESTRICCION"," ");
						/**/
						Query_desglose_tm = Query_desglose_tm.replaceAll(":TIPODESGLOSE","C");					
						Query_desglose_tm = Query_desglose_tm.replaceAll(":CAMPODESGLOSE","cat_cod");
						Query_desglose_tm = Query_desglose_tm.replaceAll(":TSISTDESGLOSE","cat_sis_cod = " + "'"+user.getDatosMenu().idSelected()+"'");
						Query_desglose_tm = Query_desglose_tm.replaceAll(":TSIST","");
						Query_desglose_tm = Query_desglose_tm.replaceAll(":DESCRIPDESGLOSE",",cat_descrip");
						Query_desglose_tm = Query_desglose_tm.replaceAll(":RESTRICTAREA","tar_cat_cod = cat_cod");
						Query_desglose_tm = Query_desglose_tm.replaceAll(":TABLADESGLOSE","DUMBO.D7_CATEGORIAS");
						Query_desglose_tm = Query_desglose_tm.replaceAll(":TABLA","");
						Query_desglose_tm = Query_desglose_tm.replaceAll(":JOIN_RESTRICCION"," ");
						}else if(Desglose.equals("usu")){
							/**SE EST REALIZANDO UN DESGLOSE POR USUARIO*/
							Query = Query.replaceAll(":TIPODESGLOSE","U");					
							Query = Query.replaceAll(":CAMPODESGLOSE","decode(dat_identificador,'EXTERNO',dat_email,dat_identificador)");
							Query = Query.replaceAll(":TSISTDESGLOSE","'NULL' = 'NULL'" );
							Query = Query.replaceAll(":TSIST","");
							Query = Query.replaceAll(":DESCRIPDESGLOSE",",decode(dat_identificador,'EXTERNO',dat_nombre||' '||dat_apellidos||'('||dat_email||')',dat_apellidos||','||dat_nombre)");
							Query = Query.replaceAll(":RESTRICTAREA","decode(dat_identificador,'EXTERNO',dat_email,dat_identificador) = decode(tar_usu_cod,'EXTERNO',tar_email_copia,tar_usu_cod)");
							Query = Query.replaceAll(":TABLADESGLOSE","DUMBO.D7_EXTERNO_DATOS_PERSONALES");
							Query = Query.replaceAll(":TABLA","");
							Query = Query.replaceAll(":JOIN_RESTRICCION"," ");
							/**/
							Query_desglose_tm = Query_desglose_tm.replaceAll(":TIPODESGLOSE","U");					
							Query_desglose_tm = Query_desglose_tm.replaceAll(":CAMPODESGLOSE","decode(dat_identificador,'EXTERNO',dat_email,dat_identificador)");
							Query_desglose_tm = Query_desglose_tm.replaceAll(":TSISTDESGLOSE","'NULL' = 'NULL'" );
							Query_desglose_tm = Query_desglose_tm.replaceAll(":TSIST","");
							Query_desglose_tm = Query_desglose_tm.replaceAll(":DESCRIPDESGLOSE",",decode(dat_identificador,'EXTERNO',dat_nombre||' '||dat_apellidos||'('||dat_email||')',dat_apellidos||','||dat_nombre)");
							Query_desglose_tm = Query_desglose_tm.replaceAll(":RESTRICTAREA","decode(dat_identificador,'EXTERNO',dat_email,dat_identificador) = decode(tar_usu_cod,'EXTERNO',tar_email_copia,tar_usu_cod)");
							Query_desglose_tm = Query_desglose_tm.replaceAll(":TABLADESGLOSE","DUMBO.D7_EXTERNO_DATOS_PERSONALES");
							Query_desglose_tm = Query_desglose_tm.replaceAll(":TABLA","");
							Query_desglose_tm = Query_desglose_tm.replaceAll(":JOIN_RESTRICCION"," ");
							}else if(Desglose.equals("inf")){
								/**SE EST REALIZANDO UN DESGLOSE POR INFORMTICO*/
								Query = Query.replaceAll(":TIPODESGLOSE","I");					
								Query = Query.replaceAll(":CAMPODESGLOSE","dat_identificador");
								Query = Query.replaceAll(":TSISTDESGLOSE","'MET' = 'MET'");
								Query = Query.replaceAll(":TSIST","AND inf_sis_cod = " + "'"+user.getDatosMenu().idSelected()+"'");
								Query = Query.replaceAll(":DESCRIPDESGLOSE",",dat_apellidos||','||dat_nombre");
								Query = Query.replaceAll(":RESTRICTAREA","tar_inf_cod = inf_cod");
								Query = Query.replaceAll(":TABLADESGLOSE","DUMBO.D7_EXTERNO_DATOS_PERSONALES");
								Query = Query.replaceAll(":TABLA",",DUMBO.D7_INFORMATICOS");
								Query = Query.replaceAll(":JOIN_RESTRICCION","AND inf_cod=dat_identificador");
								/**/
								Query_desglose_tm = Query_desglose_tm.replaceAll(":TIPODESGLOSE","I");					
								Query_desglose_tm = Query_desglose_tm.replaceAll(":CAMPODESGLOSE","dat_identificador");
								Query_desglose_tm = Query_desglose_tm.replaceAll(":TSISTDESGLOSE","'MET' = 'MET'");
								Query_desglose_tm = Query_desglose_tm.replaceAll(":TSIST","AND inf_sis_cod = " + "'"+user.getDatosMenu().idSelected()+"'");
								Query_desglose_tm = Query_desglose_tm.replaceAll(":DESCRIPDESGLOSE",",dat_apellidos||','||dat_nombre");
								Query_desglose_tm = Query_desglose_tm.replaceAll(":RESTRICTAREA","tar_inf_cod = inf_cod");
								Query_desglose_tm = Query_desglose_tm.replaceAll(":TABLADESGLOSE","DUMBO.D7_EXTERNO_DATOS_PERSONALES");
								Query_desglose_tm = Query_desglose_tm.replaceAll(":TABLA",",DUMBO.D7_INFORMATICOS");
								Query_desglose_tm = Query_desglose_tm.replaceAll(":JOIN_RESTRICCION","AND inf_cod=dat_identificador");
							}else if(Desglose.equals("gusu")){
								/**SE EST REALIZANDO UN DESGLOSE POR GRUPO DE USUARIOS*/
								Query = Query.replaceAll(":TIPODESGLOSE","G");					
								Query = Query.replaceAll(":CAMPODESGLOSE","gru_cod");
								Query = Query.replaceAll(":TSISTDESGLOSE"," gru_sis_cod = " + "'"+user.getDatosMenu().idSelected()+"'");
								Query = Query.replaceAll(":TSIST","AND ugr_sis_cod = " + "'"+user.getDatosMenu().idSelected()+"'");
								Query = Query.replaceAll(":DESCRIPDESGLOSE",",gru_descrip");
								Query = Query.replaceAll(":RESTRICTAREA","tar_usu_cod = ugr_usu_cod");
								Query = Query.replaceAll(":TABLADESGLOSE","DUMBO.D7_GRUPOS_USUARIOS");
								Query = Query.replaceAll(":TABLA",",DUMBO.D7_USUARIOS_GRUPOS");
								Query = Query.replaceAll(":JOIN_RESTRICCION","AND gru_cod=ugr_gru_cod ");
								/**/
								Query_desglose_tm = Query_desglose_tm.replaceAll(":TIPODESGLOSE","G");					
								Query_desglose_tm = Query_desglose_tm.replaceAll(":CAMPODESGLOSE","gru_cod");
								Query_desglose_tm = Query_desglose_tm.replaceAll(":TSISTDESGLOSE"," gru_sis_cod = " + "'"+user.getDatosMenu().idSelected()+"'");
								Query_desglose_tm = Query_desglose_tm.replaceAll(":TSIST","AND ugr_sis_cod = " + "'"+user.getDatosMenu().idSelected()+"'");
								Query_desglose_tm = Query_desglose_tm.replaceAll(":DESCRIPDESGLOSE",",gru_descrip");
								Query_desglose_tm = Query_desglose_tm.replaceAll(":RESTRICTAREA","tar_usu_cod = ugr_usu_cod");
								Query_desglose_tm = Query_desglose_tm.replaceAll(":TABLADESGLOSE","DUMBO.D7_GRUPOS_USUARIOS");
								Query_desglose_tm = Query_desglose_tm.replaceAll(":TABLA",",DUMBO.D7_USUARIOS_GRUPOS");
								Query_desglose_tm = Query_desglose_tm.replaceAll(":JOIN_RESTRICCION","AND gru_cod=ugr_gru_cod ");
								}else if(Desglose.equals("sec")){
									/**SE EST REALIZANDO UN DESGLOSE POR SECCIN*/
									Query = Query.replaceAll(":TIPODESGLOSE","S");					
									Query = Query.replaceAll(":CAMPODESGLOSE","sec_cod");
									Query = Query.replaceAll(":TSISTDESGLOSE","sec_sis_cod = " + "'"+user.getDatosMenu().idSelected()+"'");
									Query = Query.replaceAll(":TSIST","");
									Query = Query.replaceAll(":DESCRIPDESGLOSE",",sec_descrip");
									Query = Query.replaceAll(":RESTRICTAREA","'NULL' = 'NULL'");
									Query = Query.replaceAll(":TABLADESGLOSE"," DUMBO.D7_SECCIONES");
									Query = Query.replaceAll(":TABLA","");
									Query = Query.replaceAll(":JOIN_RESTRICCION","");
									/**/
									Query_desglose_tm = Query_desglose_tm.replaceAll(":TIPODESGLOSE","S");					
									Query_desglose_tm = Query_desglose_tm.replaceAll(":CAMPODESGLOSE","sec_cod");
									Query_desglose_tm = Query_desglose_tm.replaceAll(":TSISTDESGLOSE","sec_sis_cod = " + "'"+user.getDatosMenu().idSelected()+"'");
									Query_desglose_tm = Query_desglose_tm.replaceAll(":TSIST","");
									Query_desglose_tm = Query_desglose_tm.replaceAll(":DESCRIPDESGLOSE",",sec_descrip");
									Query_desglose_tm = Query_desglose_tm.replaceAll(":RESTRICTAREA","'NULL' = 'NULL'");
									Query_desglose_tm = Query_desglose_tm.replaceAll(":TABLADESGLOSE"," DUMBO.D7_SECCIONES");
									Query_desglose_tm = Query_desglose_tm.replaceAll(":TABLA","");
									Query_desglose_tm = Query_desglose_tm.replaceAll(":JOIN_RESTRICCION","");
									}
				}
				else{
					/**NO SE HA APLICADO DESGLOSE A LA METRICA*/
					Query = getQuery("ListaGeneralEnModoDato");
				}
							
				/**Construimos la query dependiendo del PERIODO introducido si no hay inicio = "DesdeInicio de tiempos"; si no hay fin = "HastaFin de tiempos*/
				if(!(this.FechaDesde.equals("DD/MM/AAAA")) & !(this.FechaHasta.equals("DD/MM/AAAA"))){
					Query = Query.replaceAll(":FINICIO",this.FechaDesde);
					Query = Query.replaceAll(":FFIN",this.FechaHasta);
					/*TIEMPOS MEDIOS*/Query_tm = Query_tm.replaceAll(":FINICIO",this.FechaDesde);
					/*TIEMPOS MEDIOS*/Query_tm = Query_tm.replaceAll(":FFIN",this.FechaHasta);
					/*TIEMPOS MEDIOS(DESGLOSADOS)*/Query_desglose_tm = Query_desglose_tm.replaceAll(":FINICIO",this.FechaDesde);
					/*TIEMPOS MEDIOS(DESGLOSADOS)*/Query_desglose_tm = Query_desglose_tm.replaceAll(":FFIN",this.FechaHasta);
				}else if(this.FechaDesde.equals("DD/MM/AAAA") & !(this.FechaHasta.equals("DD/MM/AAAA"))){
					Query = Query.replaceAll("':FINICIO'","NULL");
					Query = Query.replaceAll(":FFIN",this.FechaHasta);
					/*TIEMPOS MEDIOS*/Query_tm = Query_tm.replaceAll("':FINICIO'","NULL");
					/*TIEMPOS MEDIOS*/Query_tm = Query_tm.replaceAll(":FFIN",this.FechaHasta);
					/*TIEMPOS MEDIOS(DESGLOSADOS)*/Query_desglose_tm = Query_desglose_tm.replaceAll("':FINICIO'","NULL");
					/*TIEMPOS MEDIOS(DESGLOSADOS)*/Query_desglose_tm = Query_desglose_tm.replaceAll(":FFIN",this.FechaHasta);
					}else if(!(this.FechaDesde.equals("DD/MM/AAAA")) & this.FechaHasta.equals("DD/MM/AAAA")){
						Query = Query.replaceAll(":FINICIO",this.FechaDesde);
						Query = Query.replaceAll("':FFIN'","NULL");
						/*TIEMPOS MEDIOS*/Query_tm = Query_tm.replaceAll(":FINICIO",this.FechaDesde);
						/*TIEMPOS MEDIOS*/Query_tm = Query_tm.replaceAll("':FFIN'","NULL");
						/*TIEMPOS MEDIOS(DESGLOSADOS)*/Query_desglose_tm = Query_desglose_tm.replaceAll(":FINICIO",this.FechaDesde);
						/*TIEMPOS MEDIOS(DESGLOSADOS)*/Query_desglose_tm = Query_desglose_tm.replaceAll("':FFIN'","NULL");
						}else{
							Query = Query.replaceAll("':FINICIO'","NULL");
							Query = Query.replaceAll("':FFIN'","NULL");
							/*TIEMPOS MEDIOS*/Query_tm = Query_tm.replaceAll("':FINICIO'","NULL");
							/*TIEMPOS MEDIOS*/Query_tm = Query_tm.replaceAll("':FFIN'","NULL");
							/*TIEMPOS MEDIOS(DESGLOSADOS)*/Query_desglose_tm = Query_desglose_tm.replaceAll("':FINICIO'","NULL");
							/*TIEMPOS MEDIOS(DESGLOSADOS)*/Query_desglose_tm = Query_desglose_tm.replaceAll("':FFIN'","NULL");
							}
						 
				/**Si se introduce una APLICACIN por la que filtrar, sino el parmetro aplicacin ser NULL*/
				if(!this.Aplicacion.equals("")){ 
					Query = Query.replaceAll(":APL",this.Aplicacion);
					/*TIEMPOS MEDIOS*/Query_tm = Query_tm.replaceAll(":APL",this.Aplicacion);
					/*TIEMPOS MEDIOS(DESGLOSADOS)*/Query_desglose_tm = Query_desglose_tm.replaceAll(":APL",this.Aplicacion);
				}
				else{ 
					Query = Query.replaceAll("':APL'","NULL");
					/*TIEMPOS MEDIOS*/Query_tm = Query_tm.replaceAll("':APL'","NULL");
					/*TIEMPOS MEDIOS(DESGLOSADOS)*/Query_desglose_tm = Query_desglose_tm.replaceAll("':APL'","NULL");
				}
				
				/**Si se introduce una CATEGORA por la que filtrar, sino el parmetro categora ser NULL*/
				if(!this.Categoria.equals("")){	
					Query = Query.replaceAll(":CAT",this.Categoria);
					/*TIEMPOS MEDIOS*/Query_tm = Query_tm.replaceAll(":CAT",this.Categoria);
					/*TIEMPOS MEDIOS(DESGLOSADOS)*/Query_desglose_tm = Query_desglose_tm.replaceAll(":CAT",this.Categoria);
				}
				else{
					Query = Query.replaceAll("':CAT'","NULL");
					/*TIEMPOS MEDIOS*/Query_tm = Query_tm.replaceAll("':CAT'","NULL");
					/*TIEMPOS MEDIOS(DESGLOSADOS)*/Query_desglose_tm = Query_desglose_tm.replaceAll("':CAT'","NULL");
				}
				
				/**Si se introduce un INFORMTICO por el que filtrar, sino el parmetro informtico ser NULL*/
				if(!this.Informatico.equals("")){
					Query = Query.replaceAll(":INF",this.Informatico);
					/*TIEMPOS MEDIOS*/Query_tm = Query_tm.replaceAll(":INF",this.Informatico);
					/*TIEMPOS MEDIOS(DESGLOSADOS)*/Query_desglose_tm = Query_desglose_tm.replaceAll(":INF",this.Informatico);
				}
				else{
					Query = Query.replaceAll("':INF'","NULL");
					/*TIEMPOS MEDIOS*/Query_tm = Query_tm.replaceAll("':INF'","NULL");
					/*TIEMPOS MEDIOS(DESGLOSADOS)*/Query_desglose_tm = Query_desglose_tm.replaceAll("':INF'","NULL");
				}
				
				/**Si se introduce un GRUPO DE USUARIOS por el que filtrar, sino el parmetro grupos de usuarios ser NULL*/
				if(!this.GrupoUsuarios.equals("")){	
					Query = Query.replaceAll(":GRUSU",this.GrupoUsuarios);
					/*TIEMPOS MEDIOS*/Query_tm = Query_tm.replaceAll(":GRUSU",this.GrupoUsuarios);
					/*TIEMPOS MEDIOS(DESGLOSADOS)*/Query_desglose_tm = Query_desglose_tm.replaceAll(":GRUSU",this.GrupoUsuarios);
				}
				else{
					Query = Query.replaceAll("':GRUSU'","NULL");
					/*TIEMPOS MEDIOS*/Query_tm = Query_tm.replaceAll("':GRUSU'","NULL");
					/*TIEMPOS MEDIOS(DESGLOSADOS)*/Query_desglose_tm = Query_desglose_tm.replaceAll("':GRUSU'","NULL");
				}
				
				/**Si se introduce una SECCIN por la que filtrar, sino el parmetro seccin ser NULL*/
				if(!this.Seccion.equals("")){
					Query = Query.replaceAll(":SEC",this.Seccion);
					/*TIEMPOS MEDIOS*/Query_tm = Query_tm.replaceAll(":SEC",this.Seccion);
					/*TIEMPOS MEDIOS(DESGLOSADOS)*/Query_desglose_tm = Query_desglose_tm.replaceAll(":SEC",this.Seccion);
				}
				else{
					Query = Query.replaceAll("':SEC'","NULL");
					/*TIEMPOS MEDIOS*/Query_tm = Query_tm.replaceAll("':SEC'","NULL");
					/*TIEMPOS MEDIOS(DESGLOSADOS)*/Query_desglose_tm = Query_desglose_tm.replaceAll("':SEC'","NULL");
				}
				
				/**Si se introduce un USUARIO por el que filtrar, sino el parmetro usuario ser NULL*/
				if(!this.Usuario.equals("")){
					Query = Query.replaceAll(":USU",this.Usuario);
					/*TIEMPOS MEDIOS*/Query_tm = Query_tm.replaceAll(":USU",this.Usuario);
					/*TIEMPOS MEDIOS(DESGLOSADOS)*/Query_desglose_tm = Query_desglose_tm.replaceAll(":USU",this.Usuario);
				}
				else{
					Query = Query.replaceAll("':USU'","NULL");
					/*TIEMPOS MEDIOS*/Query_tm = Query_tm.replaceAll("':USU'","NULL");
					/*TIEMPOS MEDIOS(DESGLOSADOS)*/Query_desglose_tm = Query_desglose_tm.replaceAll("':USU'","NULL");
				}
				
				/**Sustitucin de TRAMOS*/
				if (i==0){
					Query = Query.replaceAll(":TRAMOS","T0");
					Query = Query.replaceAll(":TRAMO_BAJO","'X'");
					Query = Query.replaceAll(":TRAMO_ALTO",this.X1);
					Query = Query.replaceAll(":DIASTRAMOS","AND Fmetricas.Calcula_Dias(tar_feccrea,tar_fecfin) >= 0 AND Fmetricas.Calcula_Dias(tar_feccrea,tar_fecfin) <="+ this.X1);
				}
				if (i==1){
					Query = Query.replaceAll(":TRAMOS","T1");
					Query = Query.replaceAll(":TRAMO_BAJO",this.X1);
					Query = Query.replaceAll(":TRAMO_ALTO",this.X2);
					Query = Query.replaceAll(":DIASTRAMOS","AND Fmetricas.Calcula_Dias(tar_feccrea,tar_fecfin) >"+this.X1+"AND Fmetricas.Calcula_Dias(tar_feccrea,tar_fecfin) <="+this.X2);
				}
				if (i==2){
					Query = Query.replaceAll(":TRAMOS","T2");
					Query = Query.replaceAll(":TRAMO_BAJO",this.X2);
					Query = Query.replaceAll(":TRAMO_ALTO",this.X3);
					Query = Query.replaceAll(":DIASTRAMOS","AND Fmetricas.Calcula_Dias(tar_feccrea,tar_fecfin) >"+this.X2+ "AND Fmetricas.Calcula_Dias(tar_feccrea,tar_fecfin) <="+this.X3);
				}
				if (i==3){
					Query = Query.replaceAll(":TRAMOS","T3");
					Query = Query.replaceAll(":TRAMO_BAJO",this.X3);
					Query = Query.replaceAll(":TRAMO_ALTO",this.X4);
					Query = Query.replaceAll(":DIASTRAMOS","AND Fmetricas.Calcula_Dias(tar_feccrea,tar_fecfin) >"+this.X3+ "AND Fmetricas.Calcula_Dias(tar_feccrea,tar_fecfin) <="+this.X4);
				}
				if (i==4){
					Query = Query.replaceAll(":TRAMOS","T4");
					Query = Query.replaceAll(":TRAMO_BAJO",this.X4);
					Query = Query.replaceAll(":TRAMO_ALTO","'X'");
					Query = Query.replaceAll(":DIASTRAMOS","AND Fmetricas.Calcula_Dias(tar_feccrea,tar_fecfin) >"+this.X4);
				}			
				
				/**Sustitucin de TIPOS TAREAS*/
				Query = Query.replaceAll(":PETICION",D7TiposTareas.PETICION);
				Query = Query.replaceAll(":INCIDENCIA",D7TiposTareas.INCIDENCIA);
				/*TIEMPOS MEDIOS*/Query_tm = Query_tm.replaceAll(":PETICION",D7TiposTareas.PETICION);
				/*TIEMPOS MEDIOS*/Query_tm = Query_tm.replaceAll(":INCIDENCIA",D7TiposTareas.INCIDENCIA);
				/*TIEMPOS MEDIOS(DESGLOSADOS)*/Query_desglose_tm = Query_desglose_tm.replaceAll(":PETICION",D7TiposTareas.PETICION);
				/*TIEMPOS MEDIOS(DESGLOSADOS)*/Query_desglose_tm = Query_desglose_tm.replaceAll(":INCIDENCIA",D7TiposTareas.INCIDENCIA);
				
				/**Estado de Tarea = FINALIZADA*/
				Query = Query.replaceAll(":FINALIZADA",D7Tareas.FINALIZADA);
				
				/**SISTEMA*/
				Query = Query.replaceAll(":SISTEMA",user.getDatosMenu().idSelected());
				/*TIEMPOS MEDIOS*/Query_tm = Query_tm.replaceAll(":SISTEMA",user.getDatosMenu().idSelected());
				/*TIEMPOS MEDIOS(DESGLOSADOS)*/Query_desglose_tm = Query_desglose_tm.replaceAll(":SISTEMA",user.getDatosMenu().idSelected());
				
				/**El parmetro GESTOR se pone a NULL puesto que nos encontramos en MAESTRO*/
				Query = Query.replaceAll("':GESTOR'","NULL");
				/*TIEMPOS MEDIOS*/Query_tm = Query_tm.replaceAll("':GESTOR'","NULL");
				/*TIEMPOS MEDIOS(DESGLOSADOS)*/Query_desglose_tm = Query_desglose_tm.replaceAll("':GESTOR'","NULL");
				
				pstmt = conn.connection().prepareStatement(Query);
				ResultSet rs = pstmt.executeQuery();
			 	while (rs.next()) {
		 	    	/**RECOGIDA DE RESULTADOS Y MAPEO A TRAVS DE LA CLASE MTRICAS*/
			 		Metricas M = new Metricas();
		 	    	M.setTramo(rs.getString(1));
		 	    	M.setIncidencias(new Integer(rs.getInt(2)));
		 	    	M.setPeticiones(new Integer(rs.getInt(3)));
		 	       	M.setTmedioincidencias(new Double(rs.getDouble(4)));
		 	    	M.setTmediopeticiones(new Double(rs.getDouble(5)));
		 	    	M.setTmedio(new Double(rs.getDouble(6)));
		 	       	/**Dependiendo de si hay desglose o no lo mapeo en la mtrica*/
		 	    	if(!Desglose.equals("con")){
		 	    		M.setDesglose(rs.getString(7));
		 	    	}
		 	    	this.resultadoMetricas.add(M);
		 	    }   
		 	    rs.close();
		 	    pstmt.close();
			}
			
			/**Si hay desglose entonces ejecutamos la query de tiempos medios desglosados*/
			if(!Desglose.equals("con")){
				pstmt1 = conn.connection().prepareStatement(Query_desglose_tm);
				ResultSet rs1 = pstmt1.executeQuery();
				while (rs1.next()) {
					//RECOGIDA DE RESULTADOS DE TIEMPOS MEDIOS(DESGLOSADOS) Y MAPEO A TRAVS DE LA CLASE MTRICAS
					Metricas M = new Metricas();
				  	M.setTmedioincidencias(new Double(rs1.getDouble(1)));
				   	M.setTmediopeticiones(new Double(rs1.getDouble(2)));
				   	M.setTmedio(new Double(rs1.getDouble(3)));
				   	M.setDesglose(rs1.getString(4));
				   	this.resultadoMetricas_desglose_tm.add(M);
				}   
				rs1.close();
				pstmt1.close();
			}	
			else{
				/**Si no desglosamos entonces ejecutamos la query de tiempos medios*/
				pstmt2 = conn.connection().prepareStatement(Query_tm);
				ResultSet rs2 = pstmt2.executeQuery();
				while (rs2.next()) {
					/**RECOGIDA DE RESULTADOS DE TIEMPOS MEDIOS Y MAPEO A TRAVS DE LA CLASE MTRICAS*/
					Metricas M = new Metricas();
			 	  	M.setTmedioincidencias(new Double(rs2.getDouble(1)));
			 	   	M.setTmediopeticiones(new Double(rs2.getDouble(2)));
			 	   	M.setTmedio(new Double(rs2.getDouble(3)));
			 	   	this.resultadoMetricas_tm.add(M);
			 	}   
			 	rs2.close();
			 	pstmt2.close();
			}
		 	
	 	   /**FIN de la cuenta para la medicin del tiempo de ejecucin de la METRICA*/
	 	    java.util.Date FechaFin = new java.util.Date();
			int MinutosF = FechaFin.getMinutes();
			int SegundosF = FechaFin.getSeconds();
			/**Tenemos en cuenta si se ha cambiado de minuto mientras se realiza la mtrica*/
			if (SegundosI > SegundosF){
				SegundosF = 60 + SegundosF;
				MinutosF = MinutosF - 1;
			}
	 	    setErrorMessage("La mtica se ha realizado en: "+ new Integer(Math.abs(MinutosF-MinutosI)).toString() + " min. y " +new Integer(Math.abs(SegundosF-SegundosI)).toString() + " seg.");
	 	    
	 	   } catch (Exception ex) {
			System.out.println(ex);
			setErrorMessage("LISTADO Maestro: "+ex.toString().substring(0,ex.toString().length()-1));
		}
	}
	
	/**-------------------RESULTADOS de las mtricas para GESTOR-------------------*/
	public void listaModoDatoGestor(Session conn){
		PreparedStatement pstmt;
		PreparedStatement pstmt1;
		PreparedStatement pstmt2;
		/**String para construir la query de GESTOR*/
		String Query ="";
		/**String para construir la query de TIEMPOS MEDIOS DE GESTOR*/
		String Query_tm = "";
		/**String para construir la query de TIEMPOS MEDIOS(DESGLOSADOS) DE GESTOR*/
		String Query_desglose_tm = "";
		try{
			/**Inicio de la cuenta para la medicin del tiempo de ejecucin de la METRICA*/
			java.util.Date FechaInicio = new java.util.Date();
			int MinutosI = FechaInicio.getMinutes();
			int SegundosI = FechaInicio.getSeconds();
			
			Query_tm = getQuery("ListaTMGeneralEnModoDato");
			
			for(int i = 0; i<=4; i++){
				if(!Desglose.equals("con")){
					Query = getQuery("ListaGeneralEnModoDatoDesglose");
					Query_desglose_tm =  getQuery("ListaTMDesglosadaEnModoDato");
					if(Desglose.equals("sec")){
						Query = Query.replaceAll(":RESTRICCIONES",")");
						Query_desglose_tm = Query_desglose_tm.replaceAll(":RESTRICCIONES",")");
					}
					else{
						Query = Query.replaceAll(":RESTRICCIONES",getQuery("RestriccionDesglose"));
						Query_desglose_tm = Query_desglose_tm.replaceAll(":RESTRICCIONES",getQuery("RestriccionDesglose"));
						Query = Query.replaceAll(":CONDICION_GESTOR",getQuery("CondicionGestor"));
						Query_desglose_tm = Query_desglose_tm.replaceAll(":CONDICION_GESTOR",getQuery("CondicionGestor"));
					}
					if(Desglose.equals("apl")){
						/**SE EST REALIZANDO UN DESGLOSE POR APLICACIN*/
						Query = Query.replaceAll(":TIPODESGLOSE","A");					
						Query = Query.replaceAll(":CAMPODESGLOSE","apl_cod");
						Query = Query.replaceAll(":TSISTDESGLOSE","apl_sis_cod = " + "'"+user.getDatosMenu().idSelected()+"'");
						Query = Query.replaceAll(":TSIST","");
						Query = Query.replaceAll(":DESCRIPDESGLOSE",",apl_descrip");
						Query = Query.replaceAll(":TABLADESGLOSE","DUMBO.D7_APLICACIONES");
						Query = Query.replaceAll(":TABLA","");
						Query = Query.replaceAll(":RESTRICTAREA","tar_apl_cod = apl_cod");
						Query= Query.replaceAll(":JOIN_RESTRICCION"," ");
						/**/
						Query_desglose_tm = Query_desglose_tm.replaceAll(":TIPODESGLOSE","A");					
						Query_desglose_tm = Query_desglose_tm.replaceAll(":CAMPODESGLOSE","apl_cod");
						Query_desglose_tm = Query_desglose_tm.replaceAll(":TSISTDESGLOSE","apl_sis_cod = " + "'"+user.getDatosMenu().idSelected()+"'");
						Query_desglose_tm = Query_desglose_tm.replaceAll(":TSIST","");
						Query_desglose_tm = Query_desglose_tm.replaceAll(":DESCRIPDESGLOSE",",apl_descrip");
						Query_desglose_tm = Query_desglose_tm.replaceAll(":TABLADESGLOSE","DUMBO.D7_APLICACIONES");
						Query_desglose_tm = Query_desglose_tm.replaceAll(":TABLA","");
						Query_desglose_tm = Query_desglose_tm.replaceAll(":RESTRICTAREA","tar_apl_cod = apl_cod");
						Query_desglose_tm= Query_desglose_tm.replaceAll(":JOIN_RESTRICCION"," ");
					}else if(Desglose.equals("cat")){
						/**SE EST REALIZANDO UN DESGLOSE POR CATEGORA*/
						Query = Query.replaceAll(":TIPODESGLOSE","C");					
						Query = Query.replaceAll(":CAMPODESGLOSE","cat_cod");
						Query = Query.replaceAll(":TSISTDESGLOSE","cat_sis_cod = " + "'"+user.getDatosMenu().idSelected()+"'");
						Query = Query.replaceAll(":TSIST","");
						Query = Query.replaceAll(":DESCRIPDESGLOSE",",cat_descrip");
						Query = Query.replaceAll(":RESTRICTAREA","tar_cat_cod = cat_cod");
						Query = Query.replaceAll(":TABLADESGLOSE","DUMBO.D7_CATEGORIAS");
						Query = Query.replaceAll(":TABLA","");
						Query = Query.replaceAll(":JOIN_RESTRICCION"," ");
						/**/
						Query_desglose_tm = Query_desglose_tm.replaceAll(":TIPODESGLOSE","C");					
						Query_desglose_tm = Query_desglose_tm.replaceAll(":CAMPODESGLOSE","cat_cod");
						Query_desglose_tm = Query_desglose_tm.replaceAll(":TSISTDESGLOSE","cat_sis_cod = " + "'"+user.getDatosMenu().idSelected()+"'");
						Query_desglose_tm = Query_desglose_tm.replaceAll(":TSIST","");
						Query_desglose_tm = Query_desglose_tm.replaceAll(":DESCRIPDESGLOSE",",cat_descrip");
						Query_desglose_tm = Query_desglose_tm.replaceAll(":RESTRICTAREA","tar_cat_cod = cat_cod");
						Query_desglose_tm = Query_desglose_tm.replaceAll(":TABLADESGLOSE","DUMBO.D7_CATEGORIAS");
						Query_desglose_tm = Query_desglose_tm.replaceAll(":TABLA","");
						Query_desglose_tm = Query_desglose_tm.replaceAll(":JOIN_RESTRICCION"," ");
						}else if(Desglose.equals("usu")){
							/**SE EST REALIZANDO UN DESGLOSE POR USUARIO*/
							Query = Query.replaceAll(":TIPODESGLOSE","U");					
							Query = Query.replaceAll(":CAMPODESGLOSE","decode(dat_identificador,'EXTERNO',dat_email,dat_identificador)");
							Query = Query.replaceAll(":TSISTDESGLOSE","'NULL' = 'NULL'" );
							Query = Query.replaceAll(":TSIST","");
							Query = Query.replaceAll(":DESCRIPDESGLOSE",",decode(dat_identificador,'EXTERNO',dat_nombre||' '||dat_apellidos||'('||dat_email||')',dat_apellidos||','||dat_nombre)");
							Query = Query.replaceAll(":RESTRICTAREA","decode(dat_identificador,'EXTERNO',dat_email,dat_identificador) = decode(tar_usu_cod,'EXTERNO',tar_email_copia,tar_usu_cod)");
							Query = Query.replaceAll(":TABLADESGLOSE","DUMBO.D7_EXTERNO_DATOS_PERSONALES");
							Query = Query.replaceAll(":TABLA","");
							Query = Query.replaceAll(":JOIN_RESTRICCION"," ");
							/**/
							Query_desglose_tm = Query_desglose_tm.replaceAll(":TIPODESGLOSE","U");					
							Query_desglose_tm = Query_desglose_tm.replaceAll(":CAMPODESGLOSE","decode(dat_identificador,'EXTERNO',dat_email,dat_identificador)");
							Query_desglose_tm = Query_desglose_tm.replaceAll(":TSISTDESGLOSE","'NULL' = 'NULL'" );
							Query_desglose_tm = Query_desglose_tm.replaceAll(":TSIST","");
							Query_desglose_tm = Query_desglose_tm.replaceAll(":DESCRIPDESGLOSE",",decode(dat_identificador,'EXTERNO',dat_nombre||' '||dat_apellidos||'('||dat_email||')',dat_apellidos||','||dat_nombre)");
							Query_desglose_tm = Query_desglose_tm.replaceAll(":RESTRICTAREA","decode(dat_identificador,'EXTERNO',dat_email,dat_identificador) = decode(tar_usu_cod,'EXTERNO',tar_email_copia,tar_usu_cod)");
							Query_desglose_tm = Query_desglose_tm.replaceAll(":TABLADESGLOSE","DUMBO.D7_EXTERNO_DATOS_PERSONALES");
							Query_desglose_tm = Query_desglose_tm.replaceAll(":TABLA","");
							Query_desglose_tm = Query_desglose_tm.replaceAll(":JOIN_RESTRICCION"," ");
							}else if(Desglose.equals("inf")){
								/**SE EST REALIZANDO UN DESGLOSE POR INFORMTICO*/
								Query = Query.replaceAll(":TIPODESGLOSE","I");					
								Query = Query.replaceAll(":CAMPODESGLOSE","dat_identificador");
								Query = Query.replaceAll(":TSISTDESGLOSE","'MET' = 'MET'");
								Query = Query.replaceAll(":TSIST","AND inf_sis_cod = " + "'"+user.getDatosMenu().idSelected()+"'");
								Query = Query.replaceAll(":DESCRIPDESGLOSE",",dat_apellidos||','||dat_nombre");
								Query = Query.replaceAll(":RESTRICTAREA","tar_inf_cod = inf_cod");
								Query = Query.replaceAll(":TABLADESGLOSE","DUMBO.D7_EXTERNO_DATOS_PERSONALES");
								Query = Query.replaceAll(":TABLA",",DUMBO.D7_INFORMATICOS");
								Query = Query.replaceAll(":JOIN_RESTRICCION","AND inf_cod=dat_identificador");
								/**/
								Query_desglose_tm = Query_desglose_tm.replaceAll(":TIPODESGLOSE","I");					
								Query_desglose_tm = Query_desglose_tm.replaceAll(":CAMPODESGLOSE","dat_identificador");
								Query_desglose_tm = Query_desglose_tm.replaceAll(":TSISTDESGLOSE","'MET' = 'MET'");
								Query_desglose_tm = Query_desglose_tm.replaceAll(":TSIST","AND inf_sis_cod = " + "'"+user.getDatosMenu().idSelected()+"'");
								Query_desglose_tm = Query_desglose_tm.replaceAll(":DESCRIPDESGLOSE",",dat_apellidos||','||dat_nombre");
								Query_desglose_tm = Query_desglose_tm.replaceAll(":RESTRICTAREA","tar_inf_cod = inf_cod");
								Query_desglose_tm = Query_desglose_tm.replaceAll(":TABLADESGLOSE","DUMBO.D7_EXTERNO_DATOS_PERSONALES");
								Query_desglose_tm = Query_desglose_tm.replaceAll(":TABLA",",DUMBO.D7_INFORMATICOS");
								Query_desglose_tm = Query_desglose_tm.replaceAll(":JOIN_RESTRICCION","AND inf_cod=dat_identificador");
							}else if(Desglose.equals("gusu")){
								/**SE EST REALIZANDO UN DESGLOSE POR GRUPO DE USUARIOS*/
								Query = Query.replaceAll(":TIPODESGLOSE","G");					
								Query = Query.replaceAll(":CAMPODESGLOSE","gru_cod");
								Query = Query.replaceAll(":TSISTDESGLOSE"," gru_sis_cod = " + "'"+user.getDatosMenu().idSelected()+"'");
								Query = Query.replaceAll(":TSIST","AND ugr_sis_cod = " + "'"+user.getDatosMenu().idSelected()+"'");
								Query = Query.replaceAll(":DESCRIPDESGLOSE",",gru_descrip");
								Query = Query.replaceAll(":RESTRICTAREA","tar_usu_cod = ugr_usu_cod");
								Query = Query.replaceAll(":TABLADESGLOSE","DUMBO.D7_GRUPOS_USUARIOS");
								Query = Query.replaceAll(":TABLA",",DUMBO.D7_USUARIOS_GRUPOS");
								Query = Query.replaceAll(":JOIN_RESTRICCION","AND gru_cod=ugr_gru_cod ");
								/**/
								Query_desglose_tm = Query_desglose_tm.replaceAll(":TIPODESGLOSE","G");					
								Query_desglose_tm = Query_desglose_tm.replaceAll(":CAMPODESGLOSE","gru_cod");
								Query_desglose_tm = Query_desglose_tm.replaceAll(":TSISTDESGLOSE"," gru_sis_cod = " + "'"+user.getDatosMenu().idSelected()+"'");
								Query_desglose_tm = Query_desglose_tm.replaceAll(":TSIST","AND ugr_sis_cod = " + "'"+user.getDatosMenu().idSelected()+"'");
								Query_desglose_tm = Query_desglose_tm.replaceAll(":DESCRIPDESGLOSE",",gru_descrip");
								Query_desglose_tm = Query_desglose_tm.replaceAll(":RESTRICTAREA","tar_usu_cod = ugr_usu_cod");
								Query_desglose_tm = Query_desglose_tm.replaceAll(":TABLADESGLOSE","DUMBO.D7_GRUPOS_USUARIOS");
								Query_desglose_tm = Query_desglose_tm.replaceAll(":TABLA",",DUMBO.D7_USUARIOS_GRUPOS");
								Query_desglose_tm = Query_desglose_tm.replaceAll(":JOIN_RESTRICCION","AND gru_cod=ugr_gru_cod ");
								}else if(Desglose.equals("sec")){
									/**SE EST REALIZANDO UN DESGLOSE POR SECCIN*/
									Query = Query.replaceAll(":TIPODESGLOSE","S");					
									Query = Query.replaceAll(":CAMPODESGLOSE","sec_cod");
									Query = Query.replaceAll(":TSISTDESGLOSE","sec_sis_cod = " + "'"+user.getDatosMenu().idSelected()+"'");
									Query = Query.replaceAll(":TSIST","");
									Query = Query.replaceAll(":DESCRIPDESGLOSE",",sec_descrip");
									Query = Query.replaceAll(":RESTRICTAREA","'NULL' = 'NULL'");
									Query = Query.replaceAll(":TABLADESGLOSE"," DUMBO.D7_SECCIONES");
									Query = Query.replaceAll(":TABLA","");
									Query = Query.replaceAll(":JOIN_RESTRICCION","");
									/**/
									Query_desglose_tm = Query_desglose_tm.replaceAll(":TIPODESGLOSE","S");					
									Query_desglose_tm = Query_desglose_tm.replaceAll(":CAMPODESGLOSE","sec_cod");
									Query_desglose_tm = Query_desglose_tm.replaceAll(":TSISTDESGLOSE","sec_sis_cod = " + "'"+user.getDatosMenu().idSelected()+"'");
									Query_desglose_tm = Query_desglose_tm.replaceAll(":TSIST","");
									Query_desglose_tm = Query_desglose_tm.replaceAll(":DESCRIPDESGLOSE",",sec_descrip");
									Query_desglose_tm = Query_desglose_tm.replaceAll(":RESTRICTAREA","'NULL' = 'NULL'");
									Query_desglose_tm = Query_desglose_tm.replaceAll(":TABLADESGLOSE"," DUMBO.D7_SECCIONES");
									Query_desglose_tm = Query_desglose_tm.replaceAll(":TABLA","");
									Query_desglose_tm = Query_desglose_tm.replaceAll(":JOIN_RESTRICCION","");
									}
				}
				else{
					/**NO SE HA APLICADO DESGLOSE A LA METRICA*/
					Query = getQuery("ListaGeneralEnModoDato");
				}
						
				/**Construimos la query dependiendo del PERIODO introducido si no hay inicio = "DesdeInicio de tiempos"; si no hay fin = "HastaFin de tiempos*/
				if(!(this.FechaDesde.equals("DD/MM/AAAA")) & !(this.FechaHasta.equals("DD/MM/AAAA"))){
					Query = Query.replaceAll(":FINICIO",this.FechaDesde);
					Query = Query.replaceAll(":FFIN",this.FechaHasta);
					/*TIEMPOS MEDIOS*/Query_tm = Query_tm.replaceAll(":FINICIO",this.FechaDesde);
					/*TIEMPOS MEDIOS*/Query_tm = Query_tm.replaceAll(":FFIN",this.FechaHasta);
					/*TIEMPOS MEDIOS(DESGLOSADOS)*/Query_desglose_tm = Query_desglose_tm.replaceAll(":FINICIO",this.FechaDesde);
					/*TIEMPOS MEDIOS(DESGLOSADOS)*/Query_desglose_tm = Query_desglose_tm.replaceAll(":FFIN",this.FechaHasta);
				}else if(this.FechaDesde.equals("DD/MM/AAAA") & !(this.FechaHasta.equals("DD/MM/AAAA"))){
					Query = Query.replaceAll("':FINICIO'","NULL");
					Query = Query.replaceAll(":FFIN",this.FechaHasta);
					/*TIEMPOS MEDIOS*/Query_tm = Query_tm.replaceAll("':FINICIO'","NULL");
					/*TIEMPOS MEDIOS*/Query_tm = Query_tm.replaceAll(":FFIN",this.FechaHasta);
					/*TIEMPOS MEDIOS(DESGLOSADOS)*/Query_desglose_tm = Query_desglose_tm.replaceAll("':FINICIO'","NULL");
					/*TIEMPOS MEDIOS(DESGLOSADOS)*/Query_desglose_tm = Query_desglose_tm.replaceAll(":FFIN",this.FechaHasta);
					}else if(!(this.FechaDesde.equals("DD/MM/AAAA")) & this.FechaHasta.equals("DD/MM/AAAA")){
						Query = Query.replaceAll(":FINICIO",this.FechaDesde);
						Query = Query.replaceAll("':FFIN'","NULL");
						/*TIEMPOS MEDIOS*/Query_tm = Query_tm.replaceAll(":FINICIO",this.FechaDesde);
						/*TIEMPOS MEDIOS*/Query_tm = Query_tm.replaceAll("':FFIN'","NULL");
						/*TIEMPOS MEDIOS(DESGLOSADOS)*/Query_desglose_tm = Query_desglose_tm.replaceAll(":FINICIO",this.FechaDesde);
						/*TIEMPOS MEDIOS(DESGLOSADOS)*/Query_desglose_tm = Query_desglose_tm.replaceAll("':FFIN'","NULL");
						}else{
							Query = Query.replaceAll("':FINICIO'","NULL");
							Query = Query.replaceAll("':FFIN'","NULL");
							/*TIEMPOS MEDIOS*/Query_tm = Query_tm.replaceAll("':FINICIO'","NULL");
							/*TIEMPOS MEDIOS*/Query_tm = Query_tm.replaceAll("':FFIN'","NULL");
							/*TIEMPOS MEDIOS(DESGLOSADOS)*/Query_desglose_tm = Query_desglose_tm.replaceAll("':FINICIO'","NULL");
							/*TIEMPOS MEDIOS(DESGLOSADOS)*/Query_desglose_tm = Query_desglose_tm.replaceAll("':FFIN'","NULL");
							}
						 
				/**Si se introduce una APLICACIN por la que filtrar, sino el parmetro aplicacin ser NULL*/
				if(!this.Aplicacion.equals("")){ 
					Query = Query.replaceAll(":APL",this.Aplicacion);
					/*TIEMPOS MEDIOS*/Query_tm = Query_tm.replaceAll(":APL",this.Aplicacion);
					/*TIEMPOS MEDIOS(DESGLOSADOS)*/Query_desglose_tm = Query_desglose_tm.replaceAll(":APL",this.Aplicacion);
				}
				else{ 
					Query = Query.replaceAll("':APL'","NULL");
					/*TIEMPOS MEDIOS*/Query_tm = Query_tm.replaceAll("':APL'","NULL");
					/*TIEMPOS MEDIOS(DESGLOSADOS)*/Query_desglose_tm = Query_desglose_tm.replaceAll("':APL'","NULL");
				}
				
				/**Si se introduce una CATEGORA por la que filtrar, sino el parmetro categora ser NULL*/
				if(!this.Categoria.equals("")){	
					Query = Query.replaceAll(":CAT",this.Categoria);
					/*TIEMPOS MEDIOS*/Query_tm = Query_tm.replaceAll(":CAT",this.Categoria);
					/*TIEMPOS MEDIOS(DESGLOSADOS)*/Query_desglose_tm = Query_desglose_tm.replaceAll(":CAT",this.Categoria);
				}
				else{
					Query = Query.replaceAll("':CAT'","NULL");
					/*TIEMPOS MEDIOS*/Query_tm = Query_tm.replaceAll("':CAT'","NULL");
					/*TIEMPOS MEDIOS(DESGLOSADOS)*/Query_desglose_tm = Query_desglose_tm.replaceAll("':CAT'","NULL");
				}
				
				/**Si se introduce un INFORMTICO por el que filtrar, sino el parmetro informtico ser NULL*/
				if(!this.Informatico.equals("")){
					Query = Query.replaceAll(":INF",this.Informatico);
					/*TIEMPOS MEDIOS*/Query_tm = Query_tm.replaceAll(":INF",this.Informatico);
					/*TIEMPOS MEDIOS(DESGLOSADOS)*/Query_desglose_tm = Query_desglose_tm.replaceAll(":INF",this.Informatico);
				}
				else{
					Query = Query.replaceAll("':INF'","NULL");
					/*TIEMPOS MEDIOS*/Query_tm = Query_tm.replaceAll("':INF'","NULL");
					/*TIEMPOS MEDIOS(DESGLOSADOS)*/Query_desglose_tm = Query_desglose_tm.replaceAll("':INF'","NULL");
				}
				
				/**Si se introduce un GRUPO DE USUARIOS por el que filtrar, sino el parmetro grupos de usuarios ser NULL*/
				if(!this.GrupoUsuarios.equals("")){	
					Query = Query.replaceAll(":GRUSU",this.GrupoUsuarios);
					/*TIEMPOS MEDIOS*/Query_tm = Query_tm.replaceAll(":GRUSU",this.GrupoUsuarios);
					/*TIEMPOS MEDIOS(DESGLOSADOS)*/Query_desglose_tm = Query_desglose_tm.replaceAll(":GRUSU",this.GrupoUsuarios);
				}
				else{
					Query = Query.replaceAll("':GRUSU'","NULL");
					/*TIEMPOS MEDIOS*/Query_tm = Query_tm.replaceAll("':GRUSU'","NULL");
					/*TIEMPOS MEDIOS(DESGLOSADOS)*/Query_desglose_tm = Query_desglose_tm.replaceAll("':GRUSU'","NULL");
				}
				
				/**Si se introduce una SECCIN por la que filtrar, sino el parmetro seccin ser NULL*/
				if(!this.Seccion.equals("")){
					Query = Query.replaceAll(":SEC",this.Seccion);
					/*TIEMPOS MEDIOS*/Query_tm = Query_tm.replaceAll(":SEC",this.Seccion);
					/*TIEMPOS MEDIOS(DESGLOSADOS)*/Query_desglose_tm = Query_desglose_tm.replaceAll(":SEC",this.Seccion);
				}
				else{
					Query = Query.replaceAll("':SEC'","NULL");
					/*TIEMPOS MEDIOS*/Query_tm = Query_tm.replaceAll("':SEC'","NULL");
					/*TIEMPOS MEDIOS(DESGLOSADOS)*/Query_desglose_tm = Query_desglose_tm.replaceAll("':SEC'","NULL");
				}
				
				/**Si se introduce un USUARIO por el que filtrar, sino el parmetro usuario ser NULL*/
				if(!this.Usuario.equals("")){
					Query = Query.replaceAll(":USU",this.Usuario);
					/*TIEMPOS MEDIOS*/Query_tm = Query_tm.replaceAll(":USU",this.Usuario);
					/*TIEMPOS MEDIOS(DESGLOSADOS)*/Query_desglose_tm = Query_desglose_tm.replaceAll(":USU",this.Usuario);
				}
				else{
					Query = Query.replaceAll("':USU'","NULL");
					/*TIEMPOS MEDIOS*/Query_tm = Query_tm.replaceAll("':USU'","NULL");
					/*TIEMPOS MEDIOS(DESGLOSADOS)*/Query_desglose_tm = Query_desglose_tm.replaceAll("':USU'","NULL");
				}
				
				/**Sustitucin de TRAMOS*/
				if (i==0){
					Query = Query.replaceAll(":TRAMOS","T0");
					Query = Query.replaceAll(":TRAMO_BAJO","'X'");
					Query = Query.replaceAll(":TRAMO_ALTO",this.X1);
					Query = Query.replaceAll(":DIASTRAMOS","AND Fmetricas.Calcula_Dias(tar_feccrea,tar_fecfin) >= 0 AND Fmetricas.Calcula_Dias(tar_feccrea,tar_fecfin) <="+ this.X1);
				}
				if (i==1){
					Query = Query.replaceAll(":TRAMOS","T1");
					Query = Query.replaceAll(":TRAMO_BAJO",this.X1);
					Query = Query.replaceAll(":TRAMO_ALTO",this.X2);
					Query = Query.replaceAll(":DIASTRAMOS","AND Fmetricas.Calcula_Dias(tar_feccrea,tar_fecfin) >"+this.X1+"AND Fmetricas.Calcula_Dias(tar_feccrea,tar_fecfin) <="+this.X2);
				}
				if (i==2){
					Query = Query.replaceAll(":TRAMOS","T2");
					Query = Query.replaceAll(":TRAMO_BAJO",this.X2);
					Query = Query.replaceAll(":TRAMO_ALTO",this.X3);
					Query = Query.replaceAll(":DIASTRAMOS","AND Fmetricas.Calcula_Dias(tar_feccrea,tar_fecfin) >"+this.X2+ "AND Fmetricas.Calcula_Dias(tar_feccrea,tar_fecfin) <="+this.X3);
				}
				if (i==3){
					Query = Query.replaceAll(":TRAMOS","T3");
					Query = Query.replaceAll(":TRAMO_BAJO",this.X3);
					Query = Query.replaceAll(":TRAMO_ALTO",this.X4);
					Query = Query.replaceAll(":DIASTRAMOS","AND Fmetricas.Calcula_Dias(tar_feccrea,tar_fecfin) >"+this.X3+ "AND Fmetricas.Calcula_Dias(tar_feccrea,tar_fecfin) <="+this.X4);
				}
				if (i==4){
					Query = Query.replaceAll(":TRAMOS","T4");
					Query = Query.replaceAll(":TRAMO_BAJO",this.X4);
					Query = Query.replaceAll(":TRAMO_ALTO","'X'");
					Query = Query.replaceAll(":DIASTRAMOS","AND Fmetricas.Calcula_Dias(tar_feccrea,tar_fecfin) >"+this.X4);
				}			
								
				/**Sustitucin de TIPOS TAREAS*/
				Query = Query.replaceAll(":PETICION",D7TiposTareas.PETICION);
				Query = Query.replaceAll(":INCIDENCIA",D7TiposTareas.INCIDENCIA);
				/*TIEMPOS MEDIOS*/Query_tm = Query_tm.replaceAll(":PETICION",D7TiposTareas.PETICION);					
				/*TIEMPOS MEDIOS*/Query_tm = Query_tm.replaceAll(":INCIDENCIA",D7TiposTareas.INCIDENCIA);
				/*TIEMPOS MEDIOS(DESGLOSE)*/Query_desglose_tm = Query_desglose_tm.replaceAll(":PETICION",D7TiposTareas.PETICION);					
				/*TIEMPOS MEDIOS(DESGLOSE)*/Query_desglose_tm = Query_desglose_tm.replaceAll(":INCIDENCIA",D7TiposTareas.INCIDENCIA);
				
				/**Estado de Tarea = FINALIZADA*/
				Query = Query.replaceAll(":FINALIZADA",D7Tareas.FINALIZADA);
				
				/**SISTEMA*/
				Query = Query.replaceAll(":SISTEMA",user.getDatosMenu().idSelected());
				/*TIEMPOS MEDIOS*/Query_tm = Query_tm.replaceAll(":SISTEMA",user.getDatosMenu().idSelected());
				/*TIEMPOS MEDIOS(DESGLOSE)*/Query_desglose_tm = Query_desglose_tm.replaceAll(":SISTEMA",user.getDatosMenu().idSelected());
				
				/**En este caso se reemplaza en parmetro GESTOR, por el idetificador del GESTOR que est realizando 
				 * la mtrica puesto que hay una restriccin ms en las querys*/
				Query = Query.replaceAll(":GESTOR",user.getIdentificador());
				/*TIEMPOS MEDIOS*/Query_tm = Query_tm.replaceAll("':GESTOR'",user.getIdentificador());
				/*TIEMPOS MEDIOS(DESGLOSE)*/Query_desglose_tm = Query_desglose_tm.replaceAll("':GESTOR'",user.getIdentificador());
								
				pstmt = conn.connection().prepareStatement(Query);
				ResultSet rs = pstmt.executeQuery();
			 	while (rs.next()) {
			 		/**RECOGIDA DE RESULTADOS Y MAPEO A TRAVS DE LA CLASE MTRICAS*/
		 	    	Metricas M = new Metricas();
		 	    	M.setTramo(rs.getString(1));
		 	    	M.setIncidencias(new Integer(rs.getInt(2)));
		 	    	M.setPeticiones(new Integer(rs.getInt(3)));
		 	       	M.setTmedioincidencias(new Double(rs.getDouble(4)));
		 	    	M.setTmediopeticiones(new Double(rs.getDouble(5)));
		 	    	M.setTmedio(new Double(rs.getDouble(6)));
		 	       	/**Dependiendo de si hay desglose o no lo mapeo en la mtrica*/
		 	    	if(!Desglose.equals("con")){
		 	    		M.setDesglose(rs.getString(7));
		 	    	}
		 	    	this.resultadoMetricas.add(M);
		 	    }   
		 	    rs.close();
		 	    pstmt.close();
		 
			}//Fin del for para los tramos
	 	    
			/**Si hay desglose entonces ejecutamos la query de tiempos medios desglosados*/
			if(!Desglose.equals("con")){
				pstmt1 = conn.connection().prepareStatement(Query_desglose_tm);
				ResultSet rs1 = pstmt1.executeQuery();
				while (rs1.next()) {
					//RECOGIDA DE RESULTADOS DE TIEMPOS MEDIOS(DESGLOSADOS) Y MAPEO A TRAVS DE LA CLASE MTRICAS
					Metricas M = new Metricas();
				  	M.setTmedioincidencias(new Double(rs1.getDouble(1)));
				   	M.setTmediopeticiones(new Double(rs1.getDouble(2)));
				   	M.setTmedio(new Double(rs1.getDouble(3)));
				   	M.setDesglose(rs1.getString(4));
				   	this.resultadoMetricas_desglose_tm.add(M);
				}   
				rs1.close();
				pstmt1.close();
			}			
			else{
				/**Si no hay desglose entonces ejecutamos la query de tiempo medios totales*/
				pstmt2 = conn.connection().prepareStatement(Query_tm);
				ResultSet rs2 = pstmt2.executeQuery();
				while (rs2.next()) {
					/**RECOGIDA DE RESULTADOS DE TIEMPOS MEDIOS Y MAPEO A TRAVS DE LA CLASE MTRICAS*/
					Metricas M = new Metricas();
				  	M.setTmedioincidencias(new Double(rs2.getDouble(1)));
				   	M.setTmediopeticiones(new Double(rs2.getDouble(2)));
				   	M.setTmedio(new Double(rs2.getDouble(3)));
				   	this.resultadoMetricas_tm.add(M);
				}   
				rs2.close();
				pstmt2.close();
			}
			
	 	   /**FIN de la cuenta para la medicin del tiempo de ejecucin de la METRICA*/
	 	    java.util.Date FechaFin = new java.util.Date();
			int MinutosF = FechaFin.getMinutes();
			int SegundosF = FechaFin.getSeconds();
			/**Tenemos en cuenta si se ha cambiado de minuto mientras se realiza la mtrica*/
			if (SegundosI > SegundosF){
				SegundosF = 60 + SegundosF;
				MinutosF = MinutosF - 1;
			}
	 	    setErrorMessage("La mtica se ha realizado en: "+ new Integer(Math.abs(MinutosF-MinutosI)).toString() + " min. y " +new Integer(Math.abs(SegundosF-SegundosI)).toString() + " seg.");
	 	    
	 	   } catch (Exception ex) {
			System.out.println(ex);
			setErrorMessage("LISTADO Gestor: "+ex.toString().substring(0,ex.toString().length()-1));
		}
	}

	/**-------------------RESULTADOS de las mtricas para INFORMATICO-------------------*/
	public void listaModoDatoInformatico(Session conn){
		PreparedStatement pstmt;
		PreparedStatement pstmt1;
		PreparedStatement pstmt2;
		/**String para construir la query de GESTOR*/
		String Query ="";
		/**String para construir la query de TIEMPOS MEDIOS DE GESTOR*/
		String Query_tm = "";
		/**String para construir la query de TIEMPOS MEDIOS(DESGLOSADOS) DE GESTOR*/
		String Query_desglose_tm = "";
		try{
			/**Inicio de la cuenta para la medicin del tiempo de ejecucin de la METRICA*/
			java.util.Date FechaInicio = new java.util.Date();
			int MinutosI = FechaInicio.getMinutes();
			int SegundosI = FechaInicio.getSeconds();
			
			Query_tm = getQuery("ListaTMGeneralEnModoDato");
			
			for(int i = 0; i<=4; i++){
				if(!Desglose.equals("con")){
					Query = getQuery("ListaGeneralEnModoDatoDesglose");
					Query_desglose_tm =  getQuery("ListaTMDesglosadaEnModoDato");
					Query = Query.replaceAll(":RESTRICCIONES",getQuery("RestriccionDesglose"));
					Query_desglose_tm = Query_desglose_tm.replaceAll(":RESTRICCIONES",getQuery("RestriccionDesglose"));
					Query = Query.replaceAll(":CONDICION_GESTOR","");
					Query_desglose_tm = Query_desglose_tm.replaceAll(":CONDICION_GESTOR","");
					if(Desglose.equals("apl")){
						/**SE EST REALIZANDO UN DESGLOSE POR APLICACIN*/
						Query = Query.replaceAll(":TIPODESGLOSE","A");					
						Query = Query.replaceAll(":CAMPODESGLOSE","apl_cod");
						Query = Query.replaceAll(":TSISTDESGLOSE","apl_sis_cod = " + "'"+user.getDatosMenu().idSelected()+"'");
						Query = Query.replaceAll(":TSIST","");
						Query = Query.replaceAll(":DESCRIPDESGLOSE",",apl_descrip");
						Query = Query.replaceAll(":TABLADESGLOSE","DUMBO.D7_APLICACIONES");
						Query = Query.replaceAll(":TABLA","");
						Query = Query.replaceAll(":RESTRICTAREA","tar_apl_cod = apl_cod");
						Query= Query.replaceAll(":JOIN_RESTRICCION"," ");
						/**/
						Query_desglose_tm = Query_desglose_tm.replaceAll(":TIPODESGLOSE","A");					
						Query_desglose_tm = Query_desglose_tm.replaceAll(":CAMPODESGLOSE","apl_cod");
						Query_desglose_tm = Query_desglose_tm.replaceAll(":TSISTDESGLOSE","apl_sis_cod = " + "'"+user.getDatosMenu().idSelected()+"'");
						Query_desglose_tm = Query_desglose_tm.replaceAll(":TSIST","");
						Query_desglose_tm = Query_desglose_tm.replaceAll(":DESCRIPDESGLOSE",",apl_descrip");
						Query_desglose_tm = Query_desglose_tm.replaceAll(":TABLADESGLOSE","DUMBO.D7_APLICACIONES");
						Query_desglose_tm = Query_desglose_tm.replaceAll(":TABLA","");
						Query_desglose_tm = Query_desglose_tm.replaceAll(":RESTRICTAREA","tar_apl_cod = apl_cod");
						Query_desglose_tm= Query_desglose_tm.replaceAll(":JOIN_RESTRICCION"," ");
					}else if(Desglose.equals("cat")){
						/**SE EST REALIZANDO UN DESGLOSE POR CATEGORA*/
						Query = Query.replaceAll(":TIPODESGLOSE","C");					
						Query = Query.replaceAll(":CAMPODESGLOSE","cat_cod");
						Query = Query.replaceAll(":TSISTDESGLOSE","cat_sis_cod = " + "'"+user.getDatosMenu().idSelected()+"'");
						Query = Query.replaceAll(":TSIST","");
						Query = Query.replaceAll(":DESCRIPDESGLOSE",",cat_descrip");
						Query = Query.replaceAll(":RESTRICTAREA","tar_cat_cod = cat_cod");
						Query = Query.replaceAll(":TABLADESGLOSE","DUMBO.D7_CATEGORIAS");
						Query = Query.replaceAll(":TABLA","");
						Query = Query.replaceAll(":JOIN_RESTRICCION"," ");
						/**/
						Query_desglose_tm = Query_desglose_tm.replaceAll(":TIPODESGLOSE","C");					
						Query_desglose_tm = Query_desglose_tm.replaceAll(":CAMPODESGLOSE","cat_cod");
						Query_desglose_tm = Query_desglose_tm.replaceAll(":TSISTDESGLOSE","cat_sis_cod = " + "'"+user.getDatosMenu().idSelected()+"'");
						Query_desglose_tm = Query_desglose_tm.replaceAll(":TSIST","");
						Query_desglose_tm = Query_desglose_tm.replaceAll(":DESCRIPDESGLOSE",",cat_descrip");
						Query_desglose_tm = Query_desglose_tm.replaceAll(":RESTRICTAREA","tar_cat_cod = cat_cod");
						Query_desglose_tm = Query_desglose_tm.replaceAll(":TABLADESGLOSE","DUMBO.D7_CATEGORIAS");
						Query_desglose_tm = Query_desglose_tm.replaceAll(":TABLA","");
						Query_desglose_tm = Query_desglose_tm.replaceAll(":JOIN_RESTRICCION"," ");
						}else if(Desglose.equals("usu")){
							/**SE EST REALIZANDO UN DESGLOSE POR USUARIO*/
							Query = Query.replaceAll(":TIPODESGLOSE","U");					
							Query = Query.replaceAll(":CAMPODESGLOSE","decode(dat_identificador,'EXTERNO',dat_email,dat_identificador)");
							Query = Query.replaceAll(":TSISTDESGLOSE","'NULL' = 'NULL'" );
							Query = Query.replaceAll(":TSIST","");
							Query = Query.replaceAll(":DESCRIPDESGLOSE",",decode(dat_identificador,'EXTERNO',dat_nombre||' '||dat_apellidos||'('||dat_email||')',dat_apellidos||','||dat_nombre)");
							Query = Query.replaceAll(":RESTRICTAREA","decode(dat_identificador,'EXTERNO',dat_email,dat_identificador) = decode(tar_usu_cod,'EXTERNO',tar_email_copia,tar_usu_cod)");
							Query = Query.replaceAll(":TABLADESGLOSE","DUMBO.D7_EXTERNO_DATOS_PERSONALES");
							Query = Query.replaceAll(":TABLA","");
							Query = Query.replaceAll(":JOIN_RESTRICCION"," ");
							/**/
							Query_desglose_tm = Query_desglose_tm.replaceAll(":TIPODESGLOSE","U");					
							Query_desglose_tm = Query_desglose_tm.replaceAll(":CAMPODESGLOSE","decode(dat_identificador,'EXTERNO',dat_email,dat_identificador)");
							Query_desglose_tm = Query_desglose_tm.replaceAll(":TSISTDESGLOSE","'NULL' = 'NULL'" );
							Query_desglose_tm = Query_desglose_tm.replaceAll(":TSIST","");
							Query_desglose_tm = Query_desglose_tm.replaceAll(":DESCRIPDESGLOSE",",decode(dat_identificador,'EXTERNO',dat_nombre||' '||dat_apellidos||'('||dat_email||')',dat_apellidos||','||dat_nombre)");
							Query_desglose_tm = Query_desglose_tm.replaceAll(":RESTRICTAREA","decode(dat_identificador,'EXTERNO',dat_email,dat_identificador) = decode(tar_usu_cod,'EXTERNO',tar_email_copia,tar_usu_cod)");
							Query_desglose_tm = Query_desglose_tm.replaceAll(":TABLADESGLOSE","DUMBO.D7_EXTERNO_DATOS_PERSONALES");
							Query_desglose_tm = Query_desglose_tm.replaceAll(":TABLA","");
							Query_desglose_tm = Query_desglose_tm.replaceAll(":JOIN_RESTRICCION"," ");
							}else if(Desglose.equals("gusu")){
								/**SE EST REALIZANDO UN DESGLOSE POR GRUPO DE USUARIOS*/
								Query = Query.replaceAll(":TIPODESGLOSE","G");					
								Query = Query.replaceAll(":CAMPODESGLOSE","gru_cod");
								Query = Query.replaceAll(":TSISTDESGLOSE"," gru_sis_cod = " + "'"+user.getDatosMenu().idSelected()+"'");
								Query = Query.replaceAll(":TSIST","AND ugr_sis_cod = " + "'"+user.getDatosMenu().idSelected()+"'");
								Query = Query.replaceAll(":DESCRIPDESGLOSE",",gru_descrip");
								Query = Query.replaceAll(":RESTRICTAREA","tar_usu_cod = ugr_usu_cod");
								Query = Query.replaceAll(":TABLADESGLOSE","DUMBO.D7_GRUPOS_USUARIOS");
								Query = Query.replaceAll(":TABLA",",DUMBO.D7_USUARIOS_GRUPOS");
								Query = Query.replaceAll(":JOIN_RESTRICCION","AND gru_cod=ugr_gru_cod ");
								/**/
								Query_desglose_tm = Query_desglose_tm.replaceAll(":TIPODESGLOSE","G");					
								Query_desglose_tm = Query_desglose_tm.replaceAll(":CAMPODESGLOSE","gru_cod");
								Query_desglose_tm = Query_desglose_tm.replaceAll(":TSISTDESGLOSE"," gru_sis_cod = " + "'"+user.getDatosMenu().idSelected()+"'");
								Query_desglose_tm = Query_desglose_tm.replaceAll(":TSIST","AND ugr_sis_cod = " + "'"+user.getDatosMenu().idSelected()+"'");
								Query_desglose_tm = Query_desglose_tm.replaceAll(":DESCRIPDESGLOSE",",gru_descrip");
								Query_desglose_tm = Query_desglose_tm.replaceAll(":RESTRICTAREA","tar_usu_cod = ugr_usu_cod");
								Query_desglose_tm = Query_desglose_tm.replaceAll(":TABLADESGLOSE","DUMBO.D7_GRUPOS_USUARIOS");
								Query_desglose_tm = Query_desglose_tm.replaceAll(":TABLA",",DUMBO.D7_USUARIOS_GRUPOS");
								Query_desglose_tm = Query_desglose_tm.replaceAll(":JOIN_RESTRICCION","AND gru_cod=ugr_gru_cod ");
								}
				}
				else{
					/**NO SE HA APLICADO DESGLOSE A LA METRICA*/
					Query = getQuery("ListaGeneralEnModoDato");
				}
							
				/**Construimos la query dependiendo del PERIODO introducido si no hay inicio = "DesdeInicio de tiempos"; si no hay fin = "HastaFin de tiempos*/
				if(!(this.FechaDesde.equals("DD/MM/AAAA")) & !(this.FechaHasta.equals("DD/MM/AAAA"))){
					Query = Query.replaceAll(":FINICIO",this.FechaDesde);
					Query = Query.replaceAll(":FFIN",this.FechaHasta);
					/*TIEMPOS MEDIOS*/Query_tm = Query_tm.replaceAll(":FINICIO",this.FechaDesde);
					/*TIEMPOS MEDIOS*/Query_tm = Query_tm.replaceAll(":FFIN",this.FechaHasta);
					/*TIEMPOS MEDIOS(DESGLOSADOS)*/Query_desglose_tm = Query_desglose_tm.replaceAll(":FINICIO",this.FechaDesde);
					/*TIEMPOS MEDIOS(DESGLOSADOS)*/Query_desglose_tm = Query_desglose_tm.replaceAll(":FFIN",this.FechaHasta);
				}else if(this.FechaDesde.equals("DD/MM/AAAA") & !(this.FechaHasta.equals("DD/MM/AAAA"))){
					Query = Query.replaceAll("':FINICIO'","NULL");
					Query = Query.replaceAll(":FFIN",this.FechaHasta);
					/*TIEMPOS MEDIOS*/Query_tm = Query_tm.replaceAll("':FINICIO'","NULL");
					/*TIEMPOS MEDIOS*/Query_tm = Query_tm.replaceAll(":FFIN",this.FechaHasta);
					/*TIEMPOS MEDIOS(DESGLOSADOS)*/Query_desglose_tm = Query_desglose_tm.replaceAll("':FINICIO'","NULL");
					/*TIEMPOS MEDIOS(DESGLOSADOS)*/Query_desglose_tm = Query_desglose_tm.replaceAll(":FFIN",this.FechaHasta);
					}else if(!(this.FechaDesde.equals("DD/MM/AAAA")) & this.FechaHasta.equals("DD/MM/AAAA")){
						Query = Query.replaceAll(":FINICIO",this.FechaDesde);
						Query = Query.replaceAll("':FFIN'","NULL");
						/*TIEMPOS MEDIOS*/Query_tm = Query_tm.replaceAll(":FINICIO",this.FechaDesde);
						/*TIEMPOS MEDIOS*/Query_tm = Query_tm.replaceAll("':FFIN'","NULL");
						/*TIEMPOS MEDIOS(DESGLOSADOS)*/Query_desglose_tm = Query_desglose_tm.replaceAll(":FINICIO",this.FechaDesde);
						/*TIEMPOS MEDIOS(DESGLOSADOS)*/Query_desglose_tm = Query_desglose_tm.replaceAll("':FFIN'","NULL");
						}else{
							Query = Query.replaceAll("':FINICIO'","NULL");
							Query = Query.replaceAll("':FFIN'","NULL");
							/*TIEMPOS MEDIOS*/Query_tm = Query_tm.replaceAll("':FINICIO'","NULL");
							/*TIEMPOS MEDIOS*/Query_tm = Query_tm.replaceAll("':FFIN'","NULL");
							/*TIEMPOS MEDIOS(DESGLOSADOS)*/Query_desglose_tm = Query_desglose_tm.replaceAll("':FINICIO'","NULL");
							/*TIEMPOS MEDIOS(DESGLOSADOS)*/Query_desglose_tm = Query_desglose_tm.replaceAll("':FFIN'","NULL");
							}

				/**Si se introduce una APLICACIN por la que filtrar, sino el parmetro aplicacin ser NULL*/
				if(!this.Aplicacion.equals("")){ 
					Query = Query.replaceAll(":APL",this.Aplicacion);
					/*TIEMPOS MEDIOS*/Query_tm = Query_tm.replaceAll(":APL",this.Aplicacion);
					/*TIEMPOS MEDIOS(DESGLOSADOS)*/Query_desglose_tm = Query_desglose_tm.replaceAll(":APL",this.Aplicacion);
				}
				else{ 
					Query = Query.replaceAll("':APL'","NULL");
					/*TIEMPOS MEDIOS*/Query_tm = Query_tm.replaceAll("':APL'","NULL");
					/*TIEMPOS MEDIOS(DESGLOSADOS)*/Query_desglose_tm = Query_desglose_tm.replaceAll("':APL'","NULL");
				}
				
				/**Si se introduce una CATEGORA por la que filtrar, sino el parmetro categora ser NULL*/
				if(!this.Categoria.equals("")){	
					Query = Query.replaceAll(":CAT",this.Categoria);
					/*TIEMPOS MEDIOS*/Query_tm = Query_tm.replaceAll(":CAT",this.Categoria);
					/*TIEMPOS MEDIOS(DESGLOSADOS)*/Query_desglose_tm = Query_desglose_tm.replaceAll(":CAT",this.Categoria);
				}
				else{
					Query = Query.replaceAll("':CAT'","NULL");
					/*TIEMPOS MEDIOS*/Query_tm = Query_tm.replaceAll("':CAT'","NULL");
					/*TIEMPOS MEDIOS(DESGLOSADOS)*/Query_desglose_tm = Query_desglose_tm.replaceAll("':CAT'","NULL");
				}
				
				/**Si se introduce un GRUPO DE USUARIOS por el que filtrar, sino el parmetro grupos de usuarios ser NULL*/
				if(!this.GrupoUsuarios.equals("")){	
					Query = Query.replaceAll(":GRUSU",this.GrupoUsuarios);
					/*TIEMPOS MEDIOS*/Query_tm = Query_tm.replaceAll(":GRUSU",this.GrupoUsuarios);
					/*TIEMPOS MEDIOS(DESGLOSADOS)*/Query_desglose_tm = Query_desglose_tm.replaceAll(":GRUSU",this.GrupoUsuarios);
				}
				else{
					Query = Query.replaceAll("':GRUSU'","NULL");
					/*TIEMPOS MEDIOS*/Query_tm = Query_tm.replaceAll("':GRUSU'","NULL");
					/*TIEMPOS MEDIOS(DESGLOSADOS)*/Query_desglose_tm = Query_desglose_tm.replaceAll("':GRUSU'","NULL");
				}
				
				/**Si se introduce un USUARIO por el que filtrar, sino el parmetro usuario ser NULL*/
				if(!this.Usuario.equals("")){
					Query = Query.replaceAll(":USU",this.Usuario);
					/*TIEMPOS MEDIOS*/Query_tm = Query_tm.replaceAll(":USU",this.Usuario);
					/*TIEMPOS MEDIOS(DESGLOSADOS)*/Query_desglose_tm = Query_desglose_tm.replaceAll(":USU",this.Usuario);
				}
				else{
					Query = Query.replaceAll("':USU'","NULL");
					/*TIEMPOS MEDIOS*/Query_tm = Query_tm.replaceAll("':USU'","NULL");
					/*TIEMPOS MEDIOS(DESGLOSADOS)*/Query_desglose_tm = Query_desglose_tm.replaceAll("':USU'","NULL");
				}
				
				/**Un Informtico no puede realizar filtros en funcin de una determinada SECCION*/
				Query = Query.replaceAll("':SEC'","NULL");
				/*TIEMPOS MEDIOS*/Query_tm = Query_tm.replaceAll("':SEC'","NULL");
				/*TIEMPOS MEDIOS(DESGLOSADOS)*/Query_desglose_tm = Query_desglose_tm.replaceAll("':SEC'","NULL");
				
				/**Sustitucin de TRAMOS*/
				if (i==0){
					Query = Query.replaceAll(":TRAMOS","T0");
					Query = Query.replaceAll(":TRAMO_BAJO","'X'");
					Query = Query.replaceAll(":TRAMO_ALTO",this.X1);
					Query = Query.replaceAll(":DIASTRAMOS","AND Fmetricas.Calcula_Dias(tar_feccrea,tar_fecfin) >= 0 AND Fmetricas.Calcula_Dias(tar_feccrea,tar_fecfin) <="+ this.X1);
				}
				if (i==1){
					Query = Query.replaceAll(":TRAMOS","T1");
					Query = Query.replaceAll(":TRAMO_BAJO",this.X1);
					Query = Query.replaceAll(":TRAMO_ALTO",this.X2);
					Query = Query.replaceAll(":DIASTRAMOS","AND Fmetricas.Calcula_Dias(tar_feccrea,tar_fecfin) >"+this.X1+"AND Fmetricas.Calcula_Dias(tar_feccrea,tar_fecfin) <="+this.X2);
				}
				if (i==2){
					Query = Query.replaceAll(":TRAMOS","T2");
					Query = Query.replaceAll(":TRAMO_BAJO",this.X2);
					Query = Query.replaceAll(":TRAMO_ALTO",this.X3);
					Query = Query.replaceAll(":DIASTRAMOS","AND Fmetricas.Calcula_Dias(tar_feccrea,tar_fecfin) >"+this.X2+ "AND Fmetricas.Calcula_Dias(tar_feccrea,tar_fecfin) <="+this.X3);
				}
				if (i==3){
					Query = Query.replaceAll(":TRAMOS","T3");
					Query = Query.replaceAll(":TRAMO_BAJO",this.X3);
					Query = Query.replaceAll(":TRAMO_ALTO",this.X4);
					Query = Query.replaceAll(":DIASTRAMOS","AND Fmetricas.Calcula_Dias(tar_feccrea,tar_fecfin) >"+this.X3+ "AND Fmetricas.Calcula_Dias(tar_feccrea,tar_fecfin) <="+this.X4);
				}
				if (i==4){
					Query = Query.replaceAll(":TRAMOS","T4");
					Query = Query.replaceAll(":TRAMO_BAJO",this.X4);
					Query = Query.replaceAll(":TRAMO_ALTO","'X'");
					Query = Query.replaceAll(":DIASTRAMOS","AND Fmetricas.Calcula_Dias(tar_feccrea,tar_fecfin) >"+this.X4);
				}			
				
				/**Sustitucin de TIPOS TAREAS*/
				Query = Query.replaceAll(":PETICION",D7TiposTareas.PETICION);
				Query = Query.replaceAll(":INCIDENCIA",D7TiposTareas.INCIDENCIA);
				/*TIEMPOS MEDIOS*/Query_tm = Query_tm.replaceAll(":PETICION",D7TiposTareas.PETICION);					
				/*TIEMPOS MEDIOS*/Query_tm = Query_tm.replaceAll(":INCIDENCIA",D7TiposTareas.INCIDENCIA);
				/*TIEMPOS MEDIOS(DESGLOSADOS)*/Query_desglose_tm = Query_desglose_tm.replaceAll(":PETICION",D7TiposTareas.PETICION);					
				/*TIEMPOS MEDIOS(DESGLOSADOS)*/Query_desglose_tm = Query_desglose_tm.replaceAll(":INCIDENCIA",D7TiposTareas.INCIDENCIA);
				
				/**Estado de Tarea = FINALIZADA*/
				Query = Query.replaceAll(":FINALIZADA",D7Tareas.FINALIZADA);
				
				/**La mtrica est restringuida por las tareas asociadas al informtico que la genera*/
				Query = Query.replaceAll(":INF",user.getIdentificador());
				/*TIEMPOS MEDIOS*/Query_tm = Query_tm.replaceAll(":INF",user.getIdentificador());
				/*TIEMPOS MEDIOS(DESGLOSADOS)*/Query_desglose_tm = Query_desglose_tm.replaceAll(":INF",user.getIdentificador());
				
				/**El informtico siempre ser el que realiza la Mtrica, por lo tanto GESTOR = NULL*/
				Query = Query.replaceAll("':GESTOR'","NULL");
				/*TIEMPOS MEDIOS*/Query_tm = Query_tm.replaceAll("':GESTOR'","NULL");
				/*TIEMPOS MEDIOS(DESGLOSADOS)*/Query_desglose_tm = Query_desglose_tm.replaceAll("':GESTOR'","NULL");
				
				/**SISTEMA*/
				Query = Query.replaceAll(":SISTEMA",user.getDatosMenu().idSelected());
				/*TIEMPOS MEDIOS*/Query_tm = Query_tm.replaceAll(":SISTEMA",user.getDatosMenu().idSelected());
				/*TIEMPOS MEDIOS(DESGLOSADOS)*/Query_desglose_tm = Query_desglose_tm.replaceAll(":SISTEMA",user.getDatosMenu().idSelected());
				
				pstmt = conn.connection().prepareStatement(Query);
				ResultSet rs = pstmt.executeQuery();
			 	while (rs.next()) {
			 		/**RECOGIDA DE RESULTADOS Y MAPEO A TRAVS DE LA CLASE MTRICAS*/
		 	    	Metricas M = new Metricas();
		 	    	M.setTramo(rs.getString(1));
		 	    	M.setIncidencias(new Integer(rs.getInt(2)));
		 	    	M.setPeticiones(new Integer(rs.getInt(3)));
		 	    	M.setTmedioincidencias(new Double(rs.getDouble(4)));
		 	    	M.setTmediopeticiones(new Double(rs.getDouble(5)));
		 	    	M.setTmedio(new Double(rs.getDouble(6)));
		 	    	/**Dependiendo de si hay desglose o no lo mapeo en la mtrica*/
		 	    	if(!Desglose.equals("con")){
		 	    		M.setDesglose(rs.getString(7));
		 	    	}
		 	    	this.resultadoMetricas.add(M);
		 	    }   
		 	    rs.close();
		 	    pstmt.close();
			
			}//fin del for de los tramos
			
			/**Si hay desglose entonces ejecutamos la query de tiempos medios desglosados*/
			if(!Desglose.equals("con")){
				pstmt1 = conn.connection().prepareStatement(Query_desglose_tm);
				ResultSet rs1 = pstmt1.executeQuery();
				while (rs1.next()) {
					//RECOGIDA DE RESULTADOS DE TIEMPOS MEDIOS(DESGLOSADOS) Y MAPEO A TRAVS DE LA CLASE MTRICAS
					Metricas M = new Metricas();
				  	M.setTmedioincidencias(new Double(rs1.getDouble(1)));
				   	M.setTmediopeticiones(new Double(rs1.getDouble(2)));
				   	M.setTmedio(new Double(rs1.getDouble(3)));
				   	M.setDesglose(rs1.getString(4));
				   	this.resultadoMetricas_desglose_tm.add(M);
				}   
				rs1.close();
				pstmt1.close();
			}	
			else{			
				/**Si no desglosamos entonces ejecutamos la query de tiempos medios*/
				pstmt2 = conn.connection().prepareStatement(Query_tm);
				ResultSet rs2 = pstmt2.executeQuery();
				while (rs2.next()) {
					/**RECOGIDA DE RESULTADOS DE TIEMPOS MEDIOS Y MAPEO A TRAVS DE LA CLASE MTRICAS*/
					Metricas M = new Metricas();
			 	  	M.setTmedioincidencias(new Double(rs2.getDouble(1)));
			 	   	M.setTmediopeticiones(new Double(rs2.getDouble(2)));
			 	   	M.setTmedio(new Double(rs2.getDouble(3)));
			 	   	this.resultadoMetricas_tm.add(M);
			 	}   
			 	rs2.close();
			 	pstmt2.close();
			}
			
	 	   /**FIN de la cuenta para la medicin del tiempo de ejecucin de la METRICA*/
	 	    java.util.Date FechaFin = new java.util.Date();
			int MinutosF = FechaFin.getMinutes();
			int SegundosF = FechaFin.getSeconds();
			/**Tenemos en cuenta si se ha cambiado de minuto mientras se realiza la mtrica*/
			if (SegundosI > SegundosF){
				SegundosF = 60 + SegundosF;
				MinutosF = MinutosF - 1;
			}
	 	    setErrorMessage("La mtica se ha realizado en: "+ new Integer(Math.abs(MinutosF-MinutosI)).toString() + " min. y " +new Integer(Math.abs(SegundosF-SegundosI)).toString() + " seg.");
	 	    
	 	   } catch (Exception ex) {
			System.out.println(ex);
			setErrorMessage("LISTADO Informtico:"+ex.toString().substring(0,ex.toString().length()-1));
		}
	}
	
}
