<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet version="1.0" 
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:math="http://www.oracle.com/XSL/Transform/java/atica.frameweb.xml.XMLUtil">

<xsl:param name="X1"/>
<xsl:param name="X2"/>
<xsl:param name="X3"/>
<xsl:param name="X4"/>

<xsl:variable name="colorPeticion">#AABFD2</xsl:variable>
<xsl:variable name="colorIncidencia">#E6E87D</xsl:variable>

<xsl:template match="XMLROOT">
<svg width="350" height="400">
	<rect width="350" height="400" style="fill:#eef2f6"/>
	<!--Ttulo de la grfica-->
	<g style="fill:dodgerblue; font-size: 15; font-weight: bold; stroke: black; stroke-width: 0.6">
		<text x="30" y="30">Num. Incidencias/Peticiones por tramo</text>
	</g>
	
	<!--Permitimos que la grfica salga escalada-->
	<xsl:variable name="Y_MAX">
		<xsl:if test="math:max(DATA/METRICAS/RESULTADO_METRICAS/@PETICIONES) >= math:max(DATA/METRICAS/RESULTADO_METRICAS/@INCIDENCIAS)">
			<xsl:value-of select="math:max(DATA/METRICAS/RESULTADO_METRICAS/@PETICIONES)"/>
		</xsl:if>
		<xsl:if test="math:max(DATA/METRICAS/RESULTADO_METRICAS/@INCIDENCIAS) > math:max(DATA/METRICAS/RESULTADO_METRICAS/@PETICIONES)">
			<xsl:value-of select="math:max(DATA/METRICAS/RESULTADO_METRICAS/@INCIDENCIAS)"/>
		</xsl:if>
	</xsl:variable>
	
	<xsl:variable name="PASO">
		<xsl:choose>
			<xsl:when test="$Y_MAX >= 200">
				<xsl:value-of select="number(1)"/>
			</xsl:when>
			<xsl:when test="$Y_MAX &lt;= 0">
				<xsl:value-of select="number(1)"/>
			</xsl:when>
			<xsl:when test="$Y_MAX &lt;= 200 and $Y_MAX > 0">
				<xsl:value-of select="200 div $Y_MAX"/>
			</xsl:when>
		</xsl:choose>
	</xsl:variable>
	
	<!--LEYENDA-->
	<g style="fill:#000000; font-size:12; font-family:Arial">
		<rect x="50" y="360" style="fill:{$colorPeticion}; fill-opacity:0.7; stroke:black; stroke-width:0.1" width="15" height="15"/>
		<text x="80" y="370">Peticiones</text>
	</g>
	<g style="fill:#000000; font-size:12; font-family:Arial">
		<rect x="160" y="360" style="fill:{$colorIncidencia}; fill-opacity:0.7; stroke:black; stroke-width:0.1" width="15" height="15"/>
		<text x="190" y="370">Incidencias</text>
	</g>
	
	<!--EJE VERTICAL-->
	<line x1="50" y1="50" x2="50" y2="300" style="fill:black; stroke:black; stroke-width:0.5"/>
	
	<g style="fill:#000000; font-size:12; font-family:Arial; font-weight: bold">
		<text x="25" y="120" transform="translate(25,120) rotate(90) translate(-25,-120)">Num. Tareas</text>
	</g>
	
	<!--EJE HORIZONTAL-->
	<g style="fill:#000000; font-size:12; font-family:Arial; font-weight: bold">
		<text x="140" y="340">TRAMOS(dias)</text>
	</g>
	
	<line x1="50" y1="300" x2="300" y2="300" style="stroke:#000000; stroke-width:0.4"/>
	
	<g style="fill:#000000; font-size:12; font-family:Arial; font-weight: bold">
		<text x="51" y="320">0</text>
	</g>
	<g style="fill:#000000; font-size:12; font-family:Arial; font-weight: bold">
		<text x="87" y="320"><xsl:value-of select="$X1"/></text>
	</g>	
	<g style="fill:#000000; font-size:12; font-family:Arial; font-weight: bold">
		<text x="147" y="320"><xsl:value-of select="$X2"/></text>
	</g>
	<g style="fill:#000000; font-size:12; font-family:Arial; font-weight: bold">
		<text x="197" y="320"><xsl:value-of select="$X3"/></text>
	</g>
	<g style="fill:#000000; font-size:12; font-family:Arial; font-weight: bold">
		<text x="243" y="320"><xsl:value-of select="$X4"/></text>
	</g>
	
	<rect x="51" y="300" style="fill:green; fill-opacity:0.4; stroke:black; stroke-width:0.1" width="46" height="5"/>
	<rect x="98" y="300" style="fill:black; stroke:black; stroke-width:0.1" width="2" height="10"/>
		
	<rect x="100" y="300" style="fill:orange; fill-opacity:0.4; stroke:black; stroke-width:0.1" width="46" height="5"/>
	<rect x="148" y="300" style="fill:black; stroke:black; stroke-width:0.1" width="2" height="10"/>
	
	<rect x="150" y="300" style="fill:thistle; fill-opacity:0.4; stroke:black; stroke-width:0.1" width="46" height="5"/>
	<rect x="198" y="300" style="fill:black; stroke:black; stroke-width:0.1" width="2" height="10"/>

	<rect x="200" y="300" style="fill:brown; fill-opacity:0.4; stroke:black; stroke-width:0.1" width="48" height="5"/>
	<rect x="248" y="300" style="fill:black; stroke:black; stroke-width:0.1" width="2" height="10"/>
			
	<rect x="250" y="300" style="fill:cornflowerblue; fill-opacity:0.4; stroke:black; stroke-width:0.1" width="50" height="5"/>
	
	<xsl:if test="$Y_MAX > 250">
		<xsl:call-template name="RedimensionaDatos">
			<xsl:with-param name="Num" select="number(round($Y_MAX div 250))"/>
			<xsl:with-param name="PASO" select="number(round($PASO))"/>
		</xsl:call-template>
	</xsl:if>
	<xsl:if test="$Y_MAX &lt;= 250">
		<xsl:call-template name="RedimensionaDatos">
			<xsl:with-param name="Num" select="number(1)"/>
			<xsl:with-param name="PASO" select="number(round($PASO))"/>
		</xsl:call-template>
	</xsl:if>	
	
</svg>
</xsl:template>

<xsl:template name="RedimensionaDatos">
	<xsl:param name="Num"/>
	<xsl:param name="PASO"/>
	
	<!--DATOS DEL TRAMO 0-->
	<xsl:variable name="X0_PET">
		<xsl:value-of select="DATA/METRICAS/RESULTADO_METRICAS[@TRAMO = 'T0']/@PETICIONES div $Num"/>
	</xsl:variable>
	<xsl:variable name="X0_INC">
		<xsl:value-of select="DATA/METRICAS/RESULTADO_METRICAS[@TRAMO = 'T0']/@INCIDENCIAS div $Num"/>
	</xsl:variable>
	
	<xsl:if test="DATA/METRICAS/RESULTADO_METRICAS[@TRAMO = 'T0']/@PETICIONES > 0">
		<!--Representacin de la barra correspondiente al N de PETICIONES que se encuadran en este tramo-->
		<rect x="51" y="{300- round($X0_PET * $PASO)}" style="fill:{$colorPeticion}; fill-opacity:0.7; stroke:black; stroke-width:0.1" width="23" height="{round($X0_PET * $PASO)}"/>
		
		<!--Valor de la barra correspondiente dentro de un cuadro amarillo-->
		<rect x="51" y="{300- round($X0_PET* $PASO) -15}" style="fill:yellow; stroke:black; stroke-width:1.0; stroke-opacity:1.0" width="23" height="10"/>
		<g style="fill:#000000; font-size:8; font-family:Arial">
			<text x="53" y="{300- round($X0_PET* $PASO) -7}"><xsl:value-of select="$X0_PET * $Num"/></text>
		</g>
	</xsl:if>
	<xsl:if test="DATA/METRICAS/RESULTADO_METRICAS[@TRAMO = 'T0']/@INCIDENCIAS > 0">
		<!--Representacin de la barra correspondiente al N de INCIDENCIAS que se encuadran en este tramo-->
		<rect x="74" y="{300- round($X0_INC* $PASO)}" style="fill:{$colorIncidencia}; fill-opacity:0.7; stroke:black; stroke-width:0.1" width="23" height="{round($X0_INC * $PASO)}"/>
		
		<!--Valor de la barra correspondiente dentro de un cuadro amarillo-->
		<rect x="74" y="{300- ($X0_INC* $PASO) -15}" style="fill:yellow; stroke:#FF8888; stroke-width:1.0; stroke-opacity:1.0" width="23" height="10"/>
		<g style="fill:#000000; font-size:8; font-family:Arial">
			<text x="76" y="{300- round($X0_INC* $PASO) -7}"><xsl:value-of select="$X0_INC * $Num"/></text>
		</g>
	</xsl:if>	
	
		<!--DATOS DEL TRAMO 1-->
	<xsl:variable name="X1_PET">
		<xsl:value-of select="DATA/METRICAS/RESULTADO_METRICAS[@TRAMO = 'T1']/@PETICIONES div $Num"/>
	</xsl:variable>
	<xsl:variable name="X1_INC">
		<xsl:value-of select="DATA/METRICAS/RESULTADO_METRICAS[@TRAMO = 'T1']/@INCIDENCIAS div $Num"/>
	</xsl:variable>
	
	<xsl:if test="DATA/METRICAS/RESULTADO_METRICAS[@TRAMO = 'T1']/@PETICIONES > 0">
		<!--Representacin de la barra correspondiente al N de PETICIONES que se encuadran en este tramo-->
		<rect x="101" y="{300- round($X1_PET* $PASO)}" style="fill:{$colorPeticion}; fill-opacity:0.7; stroke:black; stroke-width:0.1" width="23" height="{round($X1_PET * $PASO)}"/>
		
		<!--Valor de la barra correspondiente dentro de un cuadro amarillo-->
		<rect x="101" y="{300- round($X1_PET* $PASO) -15}" style="fill:yellow; stroke:black; stroke-width:1.0; stroke-opacity:1.0" width="23" height="10"/>
		<g style="fill:#000000; font-size:8; font-family:Arial">
			<text x="103" y="{300- round($X1_PET* $PASO) -7}"><xsl:value-of select="$X1_PET * $Num"/></text>
		</g>
	</xsl:if>
	<xsl:if test="DATA/METRICAS/RESULTADO_METRICAS[@TRAMO = 'T1']/@INCIDENCIAS > 0">
		<!--Representacin de la barra correspondiente al N de INCIDENCIAS que se encuadran en este tramo-->
		<rect x="124" y="{300- round($X1_INC* $PASO)}" style="fill:{$colorIncidencia}; fill-opacity:0.7; stroke:black; stroke-width:0.1" width="23" height="{round($X1_INC * $PASO)}"/>
	
		<!--Valor de la barra correspondiente dentro de un cuadro amarillo-->
		<rect x="124" y="{300- round($X1_INC* $PASO) -15}" style="fill:yellow; stroke:#FF8888; stroke-width:1.0; stroke-opacity:1.0" width="23" height="10"/>
		<g style="fill:#000000; font-size:8; font-family:Arial">
			<text x="126" y="{300- round($X1_INC* $PASO) -7}"><xsl:value-of select="$X1_INC * $Num"/></text>
		</g>
	</xsl:if>

	<!--DATOS DEL TRAMO 2-->
	<xsl:variable name="X2_PET">
		<xsl:value-of select="DATA/METRICAS/RESULTADO_METRICAS[@TRAMO = 'T2']/@PETICIONES div $Num"/>
	</xsl:variable>
	<xsl:variable name="X2_INC">
		<xsl:value-of select="DATA/METRICAS/RESULTADO_METRICAS[@TRAMO = 'T2']/@INCIDENCIAS div $Num"/>
	</xsl:variable>
	
	<xsl:if test="DATA/METRICAS/RESULTADO_METRICAS[@TRAMO = 'T2']/@PETICIONES > 0">
		<!--Representacin de la barra correspondiente al N de PETICIONES que se encuadran en este tramo-->
		<rect x="152" y="{300- round($X2_PET* $PASO)}" style="fill:{$colorPeticion}; fill-opacity:0.7; stroke:black; stroke-width:0.1" width="23" height="{round($X2_PET * $PASO)}"/>
		
		<!--Valor de la barra correspondiente dentro de un cuadro amarillo-->
		<rect x="152" y="{300- round($X2_PET* $PASO) -15}" style="fill:yellow; stroke:black; stroke-width:1.0; stroke-opacity:1.0" width="23" height="10"/>
		<g style="fill:#000000; font-size:8; font-family:Arial">
			<text x="154" y="{300- round($X2_PET* $PASO) -7}"><xsl:value-of select="$X2_PET * $Num"/></text>
		</g>
	</xsl:if>
	<xsl:if test="DATA/METRICAS/RESULTADO_METRICAS[@TRAMO = 'T2']/@INCIDENCIAS > 0">
		<!--Representacin de la barra correspondiente al N de INCIDENCIAS que se encuadran en este tramo-->
		<rect x="175" y="{300- round($X2_INC* $PASO)}" style="fill:{$colorIncidencia}; fill-opacity:0.7; stroke:black; stroke-width:0.1" width="23" height="{round($X2_INC * $PASO)}"/>
		
		<!--Valor de la barra correspondiente dentro de un cuadro amarillo-->
		<rect x="175" y="{300- round($X2_INC* $PASO) -15}" style="fill:yellow; stroke:#FF8888; stroke-width:1.0; stroke-opacity:1.0" width="23" height="10"/>
		<g style="fill:#000000; font-size:8; font-family:Arial">
			<text x="177" y="{300- round($X2_INC* $PASO) -7}"><xsl:value-of select="$X2_INC * $Num"/></text>
		</g>
	</xsl:if>

	<!--DATOS DEL TRAMO 3-->
	<xsl:variable name="X3_PET">
		<xsl:value-of select="DATA/METRICAS/RESULTADO_METRICAS[@TRAMO = 'T3']/@PETICIONES div $Num"/>
	</xsl:variable>
	<xsl:variable name="X3_INC">
		<xsl:value-of select="DATA/METRICAS/RESULTADO_METRICAS[@TRAMO = 'T3']/@INCIDENCIAS div $Num"/>
	</xsl:variable>
	
	<xsl:if test="DATA/METRICAS/RESULTADO_METRICAS[@TRAMO = 'T3']/@PETICIONES > 0">	
		<!--Representacin de la barra correspondiente al N de PETICIONES que se encuadran en este tramo-->
		<rect x="203" y="{300- round($X3_PET* $PASO)}" style="fill:{$colorPeticion}; fill-opacity:0.7; stroke:black; stroke-width:0.1" width="23" height="{round($X3_PET * $PASO)}"/>
		
		<!--Valor de la barra correspondiente dentro de un cuadro amarillo-->
		<rect x="203" y="{300- round($X3_PET* $PASO) -15}" style="fill:yellow; stroke:black; stroke-width:1.0; stroke-opacity:1.0" width="23" height="10"/>
		<g style="fill:#000000; font-size:8; font-family:Arial">
			<text x="205" y="{300- round($X3_PET* $PASO) -7}"><xsl:value-of select="$X3_PET * $Num"/></text>
		</g>
	</xsl:if>
	<xsl:if test="DATA/METRICAS/RESULTADO_METRICAS[@TRAMO = 'T3']/@INCIDENCIAS > 0">
		<!--Representacin de la barra correspondiente al N de INCIDENCIAS que se encuadran en este tramo-->
		<rect x="226" y="{300- round($X3_INC* $PASO)}" style="fill:{$colorIncidencia}; fill-opacity:0.7; stroke:black; stroke-width:0.1" width="23" height="{round($X3_INC * $PASO)}"/>
		
		<!--Valor de la barra correspondiente dentro de un cuadro amarillo-->
		<rect x="226" y="{300- round($X3_INC* $PASO) -15}" style="fill:yellow; stroke:#FF8888; stroke-width:1.0; stroke-opacity:1.0" width="23" height="10"/>
		<g style="fill:#000000; font-size:8; font-family:Arial">
			<text x="228" y="{300- round($X3_INC* $PASO) -7}"><xsl:value-of select="$X3_INC * $Num"/></text>
		</g>
	</xsl:if>

	<!--DATOS DEL TRAMO 4-->
	<xsl:variable name="X4_PET">
		<xsl:value-of select="DATA/METRICAS/RESULTADO_METRICAS[@TRAMO = 'T4']/@PETICIONES div $Num"/>
	</xsl:variable>
	<xsl:variable name="X4_INC">
		<xsl:value-of select="DATA/METRICAS/RESULTADO_METRICAS[@TRAMO = 'T4']/@INCIDENCIAS div $Num"/>
	</xsl:variable>
	
	<xsl:if test="DATA/METRICAS/RESULTADO_METRICAS[@TRAMO = 'T4']/@PETICIONES > 0">	
		<!--Representacin de la barra correspondiente al N de PETICIONES que se encuadran en este tramo-->
		<rect x="254" y="{300- round($X4_PET* $PASO)}" style="fill:{$colorPeticion}; fill-opacity:0.7; stroke:black; stroke-width:0.1" width="23" height="{round($X4_PET * $PASO)}"/>
		
		<!--Valor de la barra correspondiente dentro de un cuadro amarillo-->
		<rect x="254" y="{300- round($X4_PET* $PASO) -15}" style="fill:yellow; stroke:black; stroke-width:1.0; stroke-opacity:1.0" width="23" height="10"/>
		<g style="fill:#000000; font-size:8; font-family:Arial">
			<text x="256" y="{300- round($X4_PET* $PASO) -7}"><xsl:value-of select="$X4_PET * $Num"/></text>
		</g>
	</xsl:if>
	<xsl:if test="DATA/METRICAS/RESULTADO_METRICAS[@TRAMO = 'T4']/@INCIDENCIAS > 0">
		<!--Representacin de la barra correspondiente al N de INCIDENCIAS que se encuadran en este tramo-->
		<rect x="277" y="{300- round($X4_INC* $PASO)}" style="fill:{$colorIncidencia}; fill-opacity:0.7; stroke:black; stroke-width:0.1" width="23" height="{round($X4_INC * $PASO)}"/>
		
		<!--Valor de la barra correspondiente dentro de un cuadro amarillo-->
		<rect x="277" y="{300- round($X4_INC* $PASO) -15}" style="fill:yellow; stroke:#FF8888; stroke-width:1.0; stroke-opacity:1.0" width="23" height="10"/>
		<g style="fill:#000000; font-size:8; font-family:Arial">
			<text x="279" y="{300- round($X4_INC* $PASO) -7}"><xsl:value-of select="$X4_INC * $Num"/></text>
		</g>
	</xsl:if>
</xsl:template>

</xsl:stylesheet>
	