<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet version="1.0" 
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:svg="http://www.w3.org/200/svg">
	
<xsl:param name="servlet"/>	
<xsl:param name="menu"/>
<xsl:param name="inicio"/>
<xsl:param name="fin"/>
<xsl:param name="UsuCod"/>
<xsl:param name="GruCod"/>
<xsl:param name="AplCod"/>
<xsl:param name="CatCod"/>
<xsl:param name="desgloseSel"/>
<xsl:param name="FechaDesde"/>
<xsl:param name="FechaHasta"/>
<xsl:param name="X1"/>
<xsl:param name="X2"/>
<xsl:param name="X3"/>
<xsl:param name="X4"/>

<xsl:variable name="desglose"/>

<xsl:include href="dumbo7/utils/xsl/utils.xsl"/>
<xsl:template match="XMLROOT">
	
	<html lang="es">
		<TITLE>DUMBO7: Resultado Mtrica 'Tiempo Medio De Atencin A Resolucin De Tarea'</TITLE>
		
		
    <xsl:call-template name="headComun">
         <xsl:with-param name="jscript">
            <SCRIPT LANGUAGE="JavaScript">
				function mostarError(error){
					alert(error);
				}
				funtion string construyeURL(url){
					url = url.concat('&amp;X1=');
					url = url.concat(document.metricas.X1.value);
					url = url.concat('&amp;X2=');
					url = url.concat(document.metricas.X2.value);
					url = url.concat('&amp;X3=');
					url = url.concat(document.metricas.X3.value);
					url = url.concat('&amp;X4=');
					url = url.concat(document.metricas.X4.value);
					
					return url;
				}
		    </SCRIPT>
         </xsl:with-param>
	</xsl:call-template>
	<body>

			
		<xsl:for-each select="DATA/METRICAS">
			<xsl:if test="not(@ERROR='')">
				<script>mostarError('<xsl:value-of select="@ERROR"/>')</script>
				</xsl:if>
		</xsl:for-each>

	<table border="0" align="center" cellpadding="3" cellspacing="1" width="750">
	<tr><td colspan="2">
		<form action="{$servlet}" METHOD="POST" name="metricas">
		<input type="hidden" name="module"/>
		<table class="cont" id="metricas" border="0" cellpadding="3" cellspacing="1" width="100%" summary="Esta tabla contiene las mtricas">
		<tr class="cab1">
			<td colspan="2">&#187;Resultado grfico: T. medio de atencin a resolucin de tarea (<xsl:call-template name="traduce"><xsl:with-param name="id" select="'Informtico'"/></xsl:call-template>)</td>
			<td width="10" align="center"><b><a href="javascript:window.print()"><img border="0" src="../graficos/iconos/ico_impresora.gif" alt="Imprimir"/></a></b></td>
			<td width="10" align="center"><b><a href="javascript:window.close()">Cerrar</a></b></td>
		</tr>
		<tr class="cabe">
			<td width="140"><b>Periodo</b></td>
			<td width="350"><b>Parmetros</b></td>
			<td colspan="2"></td>
		</tr>
		
		<tr class="administracion">
			<td width="160"><b>Desde:</b>&#160;&#160;
				<i><xsl:value-of select="$FechaDesde"/></i>
			</td>
			<td width="350" colspan="3">
				<b>Aplicacin:&#160;</b>
				<xsl:if test="$AplCod != ''">
					<!--Si la descripcin tiene menos de 30 caracteres-->
					<xsl:if test="30>string-length(DATA/METRICAS/APLICACION/@DESCRIPCION)">								
						<i><xsl:value-of select="DATA/METRICAS/APLICACION/@DESCRIPCION"/></i>
					</xsl:if>
					<!--Si la descripcin tiene ms de 30 caracteres-->
					<xsl:if test="string-length(DATA/METRICAS/APLICACION/@DESCRIPCION)>30">
						<xsl:value-of select="concat(substring(DATA/METRICAS/APLICACION/@DESCRIPCION,0,30),'...')"/>
					</xsl:if>
				</xsl:if>
				<xsl:if test="$AplCod = ''">
					<i>TODAS</i>	
				</xsl:if>
			</td>
		</tr>
		<tr class="administracion">
			<td width="160"><b>Hasta:</b>&#160;&#160;
				<i><xsl:value-of select="$FechaHasta"/></i>
			</td>
			<td width="350" colspan="3">
				<b>Categora&#160;Resolucin:&#160;</b>
				<xsl:if test="$CatCod != ''">
					<!--Si la descripcin tiene menos de 30 caracteres-->
					<xsl:if test="30>string-length(DATA/METRICAS/CATEGORIA/@DESCRIPCION)">								
						<i><xsl:value-of select="DATA/METRICAS/CATEGORIA/@DESCRIPCION"/></i>
					</xsl:if>
					<!--Si la descripcin tiene ms de 30 caracteres-->
					<xsl:if test="string-length(DATA/METRICAS/CATEGORIA/@DESCRIPCION)>30">
						<xsl:value-of select="concat(substring(DATA/METRICAS/CATEGORIA/@DESCRIPCION,0,30),'...')"/>
					</xsl:if>
				</xsl:if>
				<xsl:if test="$CatCod = ''">
					<i>TODAS</i>	
				</xsl:if>
			</td>
		</tr>
		<tr class="administracion">
			<td>&#160;</td>	
			<xsl:choose>
				<xsl:when test="$UsuCod = '' and $GruCod != ''">						
					<td width="350" colspan="3">
						<b>Grupo&#160;Usuarios:&#160;</b>
						<xsl:if test="$GruCod != ''">
							<i><xsl:value-of select="DATA/METRICAS/GRUPO_USUARIOS/@DESCRIPCION"/></i>	
						</xsl:if>
						<xsl:if test="$GruCod = ''">
							<i>TODOS</i>
						</xsl:if>
					</td>
				</xsl:when>
				<xsl:when test="$UsuCod != '' and $GruCod = ''">						
					<td width="350" colspan="3">
						<b>Usuario:&#160;</b>
						<xsl:if test="$UsuCod != ''">
							<i><xsl:value-of select="concat(concat(DATA/METRICAS/USUARIO/@APELLIDOS,', '),DATA/METRICAS/USUARIO/@NOMBRE)"/></i>	
						</xsl:if>
						<xsl:if test="$UsuCod = ''">
							<i>TODOS</i>
						</xsl:if>
					</td>
				</xsl:when>
				<xsl:otherwise>
					<td width="350" colspan="3">
						<b>Grupo&#160;Usuarios,&#160;Usuarios:&#160;</b>
						<i>TODOS</i>
					</td>
				</xsl:otherwise>
			</xsl:choose>
		</tr>
		<!--Seleccin del modo de representacin de datos-->
		<tr class="administracion"><td align="left" colspan="4"><b>Presentacin de datos --> Modo grfico</b></td></tr>
	</table>
	<table class="cont" border="0" cellpadding="3" cellspacing="1" width="100%" summary="Tabla para mostar los resultados">
		<tr class="cabe"><td colspan="10"><b>Resultados</b></td></tr>
						
		<tr class="administracion">
			<td colspan="5" align="center">
				<iframe scrolling="no" border="0" align="center" frameborder="no" framespacing="0" src="{$servlet}?module=dumbo7/metricas/atencion.Inform_svg_cantidades&amp;X1={$X1}&amp;X2={$X2}&amp;X3={$X3}&amp;X4={$X4}&amp;UsuCod={$UsuCod}&amp;GruCod={$GruCod}&amp;AplCod={$AplCod}&amp;CatCod={$CatCod}&amp;desgloseSel={$desgloseSel}&amp;FechaDesde={$FechaDesde}&amp;FechaHasta={$FechaHasta}" width="370" height="430"></iframe>
			</td>
			<td colspan="5" align="center">
				<iframe scrolling="no" border="0" align="center" frameborder="no" framespacing="0" src="{$servlet}?module=dumbo7/metricas/atencion.Inform_svg_Tmedios&amp;X1={$X1}&amp;X2={$X2}&amp;X3={$X3}&amp;X4={$X4}&amp;UsuCod={$UsuCod}&amp;GruCod={$GruCod}&amp;AplCod={$AplCod}&amp;CatCod={$CatCod}&amp;desgloseSel={$desgloseSel}&amp;FechaDesde={$FechaDesde}&amp;FechaHasta={$FechaHasta}" width="370" height="430"></iframe>
			</td>
		</tr>
				
		<tr class="administracion" align="center"><td colspan="10"><CENTER><input type="button" class="boton" value="Cerrar" onclick="javascript: window.close()" /></CENTER></td></tr>
	</table>
	</form>
	</td></tr>

	</table>
		
	</body>
	</html>	
</xsl:template>

<xsl:template name="cuerpo"/>
</xsl:stylesheet>
	