<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet version="1.0" 
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:xforms="http://www.w3.org/2002/xforms">

<!-- ELIMINA DUPLICADOS DE DESGLOSE -->
<xsl:key name="klave" match="DATA/METRICAS/RESULTADO_METRICAS" use="@DESGLOSE"/>

<xsl:param name="servlet"/>	
<xsl:param name="menu"/>
<xsl:param name="inicio"/>
<xsl:param name="fin"/>
<xsl:param name="UsuCod"/>
<xsl:param name="GruCod"/>
<xsl:param name="AplCod"/>
<xsl:param name="CatCod"/>
<xsl:param name="desgloseSel"/>
<xsl:param name="FechaDesde"/>
<xsl:param name="FechaHasta"/>
<xsl:param name="X1"/>
<xsl:param name="X2"/>
<xsl:param name="X3"/>
<xsl:param name="X4"/>

<xsl:include href="dumbo7/utils/xsl/utils.xsl"/>
	
<xsl:template match="XMLROOT">
	
	<html lang="es">
		<TITLE>DUMBO7: Resultado Mtrica 'Tiempo Medio De Dedicacin A Resolucin De Tarea'</TITLE>
		
		
    <xsl:call-template name="headComun">
         <xsl:with-param name="jscript">
            <SCRIPT LANGUAGE="JavaScript">
				function mostrarError(error){
					alert(error);
				}
			</SCRIPT>
			<script LANGUAJE="JavaScript" src="../js/OnMouse.js"></script>
         </xsl:with-param>
	</xsl:call-template>
	<body>

			
		<xsl:for-each select="DATA/METRICAS">
			<xsl:if test="not(@ERROR='')">
				<script>mostrarError('<xsl:value-of select="@ERROR"/>')</script>
				</xsl:if>
		</xsl:for-each>

	<table border="0" align="center" cellpadding="3" cellspacing="1" width="750" summary="Esta tabla contiene las mtricas de tareas segn DEDICACION (para nivel de informtico)">
	<tr><td colspan="2">
		<table class="cont" id="metricas" border="0" cellpadding="3" cellspacing="1" width="100%" summary="Esta tabla contiene las mtricas">
		<tr class="cab1">
			<td colspan="2">&#187;Resultado: T. medio de dedicacin a resolucin de tarea (<xsl:call-template name="traduce"><xsl:with-param name="id" select="'Informtico'"/></xsl:call-template>)</td>
			<td width="10" align="center"><b><a href="javascript:window.print()"><img border="0" src="../graficos/iconos/ico_impresora.gif" alt="Imprimir"/></a></b></td>
			<td width="10" align="center"><b><a href="javascript:window.close()">Cerrar</a></b></td>
		</tr>
		<tr class="cabe">
			<td width="140"><b>Periodo</b></td>
			<td width="350"><b>Parmetros</b></td>
			<td colspan="2"></td>
		</tr>
		
		<tr class="administracion">
			<td width="140"><b>Desde</b>&#160;&#160;
				<i><xsl:value-of select="$FechaDesde"/></i>
			</td>
			<td width="350" colspan="3">
				<b>Aplicacin:&#160;</b>
				<xsl:if test="$AplCod != ''">
					<i><xsl:value-of select="DATA/METRICAS/APLICACION/@DESCRIPCION"/></i>
				</xsl:if>
				<xsl:if test="$AplCod = ''">
					<i>TODAS</i>	
				</xsl:if>
			</td>
		</tr>
		<tr class="administracion">
			<td width="140"><b>Hasta</b>&#160;&#160;
				<i><xsl:value-of select="$FechaHasta"/></i>
			</td>
			<td width="350" colspan="3">
				<b>Categora&#160;Resolucin:&#160;</b>
				<xsl:if test="$CatCod != ''">
					<i><xsl:value-of select="DATA/METRICAS/CATEGORIA/@DESCRIPCION"/></i>
				</xsl:if>
				<xsl:if test="$CatCod = ''">
					<i>TODAS</i>	
				</xsl:if>
			</td>
		</tr>
		<tr class="administracion">
			<td width="140">&#160;</td>	
			<xsl:choose>
				<xsl:when test="$UsuCod = '' and $GruCod != ''">						
					<td width="350" colspan="4">
						<b>Grupo&#160;Usuarios:&#160;</b>
						<xsl:if test="$GruCod != ''">
							<i><xsl:value-of select="DATA/METRICAS/GRUPO_USUARIOS/@DESCRIPCION"/></i>	
						</xsl:if>
						<xsl:if test="$GruCod = ''">
							<i>TODOS</i>
						</xsl:if>
					</td>
				</xsl:when>
				<xsl:when test="$UsuCod != '' and $GruCod = ''">						
					<td width="350" colspan="4">
						<b>Usuario:&#160;</b>
						<xsl:if test="$UsuCod != ''">
							<i><xsl:value-of select="concat(concat(DATA/METRICAS/USUARIO/@APELLIDOS,', '),DATA/METRICAS/USUARIO/@NOMBRE)"/></i>	
						</xsl:if>
						<xsl:if test="$UsuCod = ''">
							<i>TODOS</i>
						</xsl:if>
					</td>
				</xsl:when>
				<xsl:otherwise>
					<td width="350" colspan="4">
						<b>Grupo&#160;Usuarios,&#160;Usuarios:&#160;</b>
						<i>TODOS</i>
					</td>
				</xsl:otherwise>
			</xsl:choose>
		</tr>
		<!--Seleccin del modo de representacin de datos-->
		<tr class="cabe"><td align="left" colspan="4"><b>Presentacin de datos</b></td></tr>
		<tr class="administracion">
			<td colspan="4">
				<b>Modo&#160;Dato</b>&#160;-->
				<xsl:choose>
					<xsl:when test="$desgloseSel = 'apl'">						
						&#160;Representacin&#160;Desglosada&#160;Por&#160;<i>Aplicacin</i>
					</xsl:when>
					<xsl:when test="$desgloseSel = 'cat'">						
						&#160;Representacin&#160;Desglosada&#160;Por&#160;<i>Categoria</i>
					</xsl:when>
					<xsl:when test="$desgloseSel = 'usu'">						
						&#160;Representacin&#160;Desglosada&#160;Por&#160;<i>Usuario</i>
					</xsl:when>
					<xsl:when test="$desgloseSel = 'gusu'">						
						&#160;Representacin&#160;Desglosada&#160;Por&#160;<i>Grupo Usuarios</i>
					</xsl:when>
					<xsl:otherwise>
						&#160;Representacin&#160;Conjunta
					</xsl:otherwise>
				</xsl:choose>
			</td>
		</tr>
	</table>
	<table class="cont" border="0" cellpadding="3" cellspacing="1" width="100%" summary="Tabla para mostar los resultados">
		<tr class="cabe"><td colspan="10"><b>Resultados</b></td></tr>
		<!--Si Existen en los resultados el parametro desglose la forma de mostrar los datos ser 
		anteponiendo este desglose a nivel de la cabecera de detalle-->
		<xsl:if test="count(DATA/METRICAS/RESULTADO_METRICAS/@DESGLOSE)>0">
			<xsl:for-each select="DATA/METRICAS/*[(generate-id()=generate-id(key('klave',@DESGLOSE)[1]))]">
				<xsl:sort select="@DESGLOSE"/>
		<!-- Esto se ejecuta una vez por cada desglose existente en orden alfabtico de desglose -->
			<xsl:variable name="miDesglose" select="@DESGLOSE"/>
			<tr class="cabeAlertas"><td colspan="10"><xsl:value-of select="$miDesglose"/></td></tr>
			<tr class="administracion">						
				<td colspan="3" width="150" align="center"><b></b></td>
				<td colspan="3" align="center"><b>Cantidad</b></td>
				<td colspan="3" align="center"><b>Tiempo&#160;Medio</b></td>
			</tr>
			<tr class="administracion">
				<td colspan="3" width="150" align="center"><b><u>T</u>ramo</b>(horas)</td>
				<td width="90" align="center"><b>Peticiones</b></td>
				<td width="90" align="center"><b>Incidencias</b></td>
				<td width="90" align="center"><b>Tareas</b></td>	
				<td width="90" align="center"><b>Peticiones</b></td>
				<td width="90" align="center"><b>Incidencias</b></td>
				<td width="90" align="center"><b>Tareas</b></td>				
			</tr>
		
			<xsl:for-each select="../RESULTADO_METRICAS[@DESGLOSE=$miDesglose]">
				<tr class="administracion" onmouseover="javascript:onMouse(this,'true');" onmouseout="javascript:onMouse(this,'false');">
					<!--Tramos-->	
					<xsl:choose>
						<xsl:when test="@TRAMO = 'T0'">						
							<td width="70" align="right"><xsl:value-of select="$X1"/>&#160;&lt;=</td>
							<td width="5"><b>T</b></td>
							<td width="30"></td>
						</xsl:when>
						<xsl:when test="@TRAMO = 'T1'">						
							<td width="70" align="right">&#160;<xsl:value-of select="$X1"/>&#160;&lt;</td>
							<td width="5"><b>T</b></td>
							<td width="30">&lt;=&#160;<xsl:value-of select="$X2"/></td>
						</xsl:when>
						<xsl:when test="@TRAMO = 'T2'">						
							<td width="70" align="right">&#160;&#160;&#160;&#160;<xsl:value-of select="$X2"/>&#160;&lt;</td>
							<td width="5"><b>T</b></td>
							<td width="30">&lt;=&#160;<xsl:value-of select="$X3"/></td>
						</xsl:when>
						<xsl:when test="@TRAMO = 'T3'">						
							<td width="70" align="right">&#160;&#160;&#160;&#160;<xsl:value-of select="$X3"/>&#160;&lt;</td>
							<td width="5"><b>T</b></td>
							<td width="30">&lt;=&#160;<xsl:value-of select="$X4"/></td>
						</xsl:when>
						<xsl:when test="@TRAMO = 'T4'">						
							<td width="70" align="right"></td>
							<td width="5"><b>T</b></td>
							<td width="30">&#160;>&#160;<xsl:value-of select="$X4"/></td>
						</xsl:when>
					</xsl:choose>

					
					<!--Peticiones-->
					<td width="90" align="right"><xsl:value-of select="@PETICIONES"/></td>
					
					<!---Incidencias-->
					<td width="90" align="right"><xsl:value-of select="@INCIDENCIAS"/></td>
					
					<!--Tareas = Peticiones + Incidencias-->
					<td width="90" align="right"><xsl:value-of select="@PETICIONES+@INCIDENCIAS"/></td>
					<!--Tiempos medios parciales-->
					<td width="90" align="right"><xsl:value-of select="@TMEDIOPETICIONES"/></td>
					<td width="90" align="right"><xsl:value-of select="@TMEDIOINCIDENCIAS"/></td>
					<td width="90" align="right"><xsl:value-of select="@TMEDIO"/></td>
				</tr>
			</xsl:for-each>
			<tr class="administracion">
					<td width="150" colspan="3" align="right"><b>Totales&#160;=&#160;</b></td>
						<td width="90" align="right"><b><xsl:value-of select="sum(../RESULTADO_METRICAS[@DESGLOSE=$miDesglose]/@PETICIONES)"/></b></td>
						<td width="90" align="right"><b><xsl:value-of select="sum(../RESULTADO_METRICAS[@DESGLOSE=$miDesglose]/@INCIDENCIAS)"/></b></td>
						<td width="90" align="right"><b><xsl:value-of select="sum(../RESULTADO_METRICAS[@DESGLOSE=$miDesglose]/@PETICIONES)  + sum(../RESULTADO_METRICAS[@DESGLOSE=$miDesglose]/@INCIDENCIAS)"/></b></td>
					<td align="right"><b><xsl:value-of select="../RESULTADO_METRICAS_DESGLOSE_TM[@DESGLOSE=$miDesglose]/@TMEDIOPETICIONES"/></b></td>
					<td align="right"><b><xsl:value-of select="../RESULTADO_METRICAS_DESGLOSE_TM[@DESGLOSE=$miDesglose]/@TMEDIOINCIDENCIAS"/></b></td>
					<td align="right"><b><xsl:value-of select="../RESULTADO_METRICAS_DESGLOSE_TM[@DESGLOSE=$miDesglose]/@TMEDIO"/></b></td>
				</tr>
		</xsl:for-each>
		</xsl:if>
		
		<!--Si no existe el parmetro desglose en los resultados se mostrar la informacin normalmente-->
		<xsl:if test="count(DATA/METRICAS/RESULTADO_METRICAS/@DESGLOSE)&lt;=0">
			<tr class="administracion">						
				<td colspan="3" width="150" align="center"></td>
				<td colspan="3" align="center"><b>Cantidad</b></td>
				<td colspan="3" align="center"><b>Tiempo&#160;Medio</b></td>
			</tr>
			<tr class="administracion">
				<td colspan="3" width="150" align="center"><b><u>T</u>ramo</b>(horas)</td>
				<td width="90" align="center"><b>Peticiones</b></td>
				<td width="90" align="center"><b>Incidencias</b></td>
				<td width="90" align="center"><b>Tareas</b></td>	
				<td width="90" align="center"><b>Peticiones</b></td>
				<td width="90" align="center"><b>Incidencias</b></td>
				<td width="90" align="center"><b>Tareas</b></td>				
			</tr>
			<xsl:for-each select="DATA/METRICAS/RESULTADO_METRICAS">
				<tr class="administracion" onmouseover="javascript:onMouse(this,'true');" onmouseout="javascript:onMouse(this,'false');">
					<!--Tramos-->	
					<xsl:choose>
						<xsl:when test="@TRAMO = 'T0'">						
							<td width="70" align="right"><xsl:value-of select="$X1"/>&#160;&lt;=</td>
							<td width="5"><b>T</b></td>
							<td width="30"></td>
						</xsl:when>
						<xsl:when test="@TRAMO = 'T1'">						
							<td width="70" align="right">&#160;<xsl:value-of select="$X1"/>&#160;&lt;</td>
							<td width="5"><b>T</b></td>
							<td width="30">&lt;=&#160;<xsl:value-of select="$X2"/></td>
						</xsl:when>
						<xsl:when test="@TRAMO = 'T2'">						
							<td width="70" align="right">&#160;&#160;&#160;&#160;<xsl:value-of select="$X2"/>&#160;&lt;</td>
							<td width="5"><b>T</b></td>
							<td width="30">&lt;=&#160;<xsl:value-of select="$X3"/></td>
						</xsl:when>
						<xsl:when test="@TRAMO = 'T3'">						
							<td width="70" align="right">&#160;&#160;&#160;&#160;<xsl:value-of select="$X3"/>&#160;&lt;</td>
							<td width="5"><b>T</b></td>
							<td width="30">&lt;=&#160;<xsl:value-of select="$X4"/></td>
						</xsl:when>
						<xsl:when test="@TRAMO = 'T4'">						
							<td width="70" align="right"></td>
							<td width="5"><b>T</b></td>
							<td width="30">&#160;>&#160;<xsl:value-of select="$X4"/></td>
						</xsl:when>
					</xsl:choose>
					
					<!--Peticiones-->
					<td width="90" align="right"><xsl:value-of select="@PETICIONES"/></td>
					
					<!---Incidencias-->
					<td width="90" align="right"><xsl:value-of select="@INCIDENCIAS"/></td>
					
					<!--Tareas = Peticiones + Incidencias-->
					<td width="90" align="right"><xsl:value-of select="@PETICIONES+@INCIDENCIAS"/></td>
					<!--Tiempos medios parciales-->
					<td width="90" align="right"><xsl:value-of select="@TMEDIOPETICIONES"/></td>
					<td width="90" align="right"><xsl:value-of select="@TMEDIOINCIDENCIAS"/></td>
					<td width="90" align="right"><xsl:value-of select="@TMEDIO"/></td>
				</tr>
			</xsl:for-each>
			<tr class="administracion">
				<td width="150" colspan="3" align="right"><b>Totales&#160;=&#160;</b></td>
				<td width="90" align="right"><b><xsl:value-of select="sum(DATA/METRICAS/RESULTADO_METRICAS/@PETICIONES)"/></b></td>
				<td width="90" align="right"><b><xsl:value-of select="sum(DATA/METRICAS/RESULTADO_METRICAS/@INCIDENCIAS)"/></b></td>
				<td width="90" align="right"><b><xsl:value-of select="sum(DATA/METRICAS/RESULTADO_METRICAS/@PETICIONES)  + sum(DATA/METRICAS/RESULTADO_METRICAS/@INCIDENCIAS)"/></b></td>
				<td width="90" align="right"><b><xsl:value-of select="DATA/METRICAS/RESULTADO_METRICAS_TM/@TMEDIOPETICIONES"/></b></td>
				<td width="90" align="right"><b><xsl:value-of select="DATA/METRICAS/RESULTADO_METRICAS_TM/@TMEDIOINCIDENCIAS"/></b></td>
				<td width="90" align="right"><b><xsl:value-of select="DATA/METRICAS/RESULTADO_METRICAS_TM/@TMEDIO"/></b></td>
			</tr>
		</xsl:if>
		<xsl:if test="count(DATA/METRICAS/RESULTADO_METRICAS)=0">
			<tr>
				<td align="center" colspan="9">* METRICAS sin datos.</td>
			</tr>
		</xsl:if>
				
		<tr  class="administracion" align="center"><td colspan="9"><CENTER><input type="button" class="boton" value="Cerrar" onclick="javascript: window.close()" /></CENTER>
		</td></tr>
	</table>
	</td></tr>
</table>
	
		
	</body>
	</html>
</xsl:template>

<xsl:template name="cuerpo"/>
</xsl:stylesheet>
	