 package dumbo7.metricas.desviacion;

import dumbo7.metricas.*;

import java.sql.*;
import java.sql.ResultSet;
import java.util.*;

import dumbo7.utils.*;

import org.hibernate.Query;
import org.hibernate.Session;

import atica.frameweb.utils.*;

/**
 * @author Antonio
 *
 * Gestor de Metricas Dedicacin de Dumbo
 * 
 */
public class GestorDesviacion extends GeneralManager {
	private List seccionesResponsable = new Vector();
	private List secciones = new Vector();
	private List prioridades = new Vector();
	private List tiposTareas = new Vector();
	private List tareasMov = new Vector();
	private List ModoDato;
	private Vector resultadoMetricas = new Vector();
	private Vector resultadoMetricas_tm = new Vector();
		
	private String Seccion = "";
	private String Datos = "";
	private String Codigo = "";
	private String Patron = "";
		
	private String FechaDesde;
	private String FechaHasta;
	private String NumDesv;
	private String Desglose = "";/**Desglose que se puede hacer cuando estas en modo DATO*/
		
	public GestorDesviacion() {}
	
	//Mtodos get() para el mapeo

	public List getSecciones() { return secciones; }
	public List getSeccionesResponsable() { return seccionesResponsable; }
	public List getPrioridades() { return prioridades; }
	public List getTiposTareas() { return tiposTareas; }
	public List getModoDato(){return ModoDato;}
	public Vector getResultadoMetricas(){return this.resultadoMetricas;}
	public Vector getResultadoMetricas_tm(){return this.resultadoMetricas_tm;}
	
	//Mtodos set para recoger los datos del formulario
	/**Metdo set() para obtener las fechas de inicio y fin del histrico*/
	public void setFechaDesde(String FDesde){this.FechaDesde = FDesde;}
	public void setFechaHasta(String FHasta){this.FechaHasta = FHasta;}
	
	public void setNumDesv(String N){this.NumDesv = N;}
	
	public void setSeccion(String sec){this.Seccion = sec;}
	public void setDesglose(String Des){this.Desglose = Des;}
	
	/**Patron de las busquedas de secciones, categoras grupos usuarios...*/
	public void setPatron(String patron){this.Patron = patron;}
	
	/**	Lista todas las secciones*/
	public void listaSecciones(Session conn){
		try{
			Query q = conn.createQuery(getQuery("AllSecciones"));
			q = q.setString("sist",user.getDatosMenu().idSelected());
			secciones  = (List)q.list();
		}
		catch (Exception ex){
			setErrorMessage("GestorMetricas[Lectura de BBDD]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
	}	
	/**-------------LISTADOS DE UN NICO ELEMENTO(COMPONENTE)-------------------*/
	public void QuerySeccion(Session conn, String SecCod){
		try{
			Query q = conn.createQuery(getQuery("ListaUnaSeccion"));
			q = q.setString("sist",user.getDatosMenu().idSelected());
			q = q.setString("cod",SecCod);
			secciones  = (List)q.list();		
		}catch (Exception ex){
			setErrorMessage("GestorMetricas[Lectura de BBDD]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
	}
	
	/**Lista secciones con datos sin importar el estado, para el select inicial de secciones(no incluye estado finalizado)**/
	public void listaSeccionesConDatos(Session conn) {
		PreparedStatement pstmt;
		
		try{
			String ResultadoQuery = getQuery("SeccionesConDatos");
			ResultadoQuery = ResultadoQuery.replaceAll(":SISTEMA",user.getDatosMenu().idSelected());
			ResultadoQuery = ResultadoQuery.replaceAll(":GESTOR",user.getIdentificador());
			pstmt = conn.connection().prepareStatement(ResultadoQuery);
			ResultSet rs = pstmt.executeQuery();
			
		 	while (rs.next()) {
	 	    	D7Secciones sec = new D7Secciones();
	 	    	sec.setSecSisCod(rs.getString("Sec_Sis_Cod"));
	 	    	sec.setSecCod(rs.getString("Sec_Cod"));
	 	    	sec.setSecDescrip(rs.getString("Sec_Descrip"));
	 	    	sec.setSecIdRespon(rs.getString("Sec_Id_Respon"));
	 	    	sec.setSecSecCod(rs.getString("Sec_Sec_Cod"));
	 	    	sec.setSecEstado(rs.getString("Sec_Estado"));
	 	    	secciones.add(sec);
	 	    }
		 	rs.close();
	 	    pstmt.close();
		} catch (Exception ex) {
			System.out.println(ex);
			setErrorMessage("GestorMetricas[Lectura de BBDD]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
	}
	
	//-------------------SECCIONES para el DESGLOSE-------------------
	public void listaSeccionesDesglose(Session conn){
		PreparedStatement pstmt;
		/**String para construir la query de MAESTRO para tareas en estado resuelto*/
		String Query ="";
		try{		 	 
			Query = getQuery("ListaDesglose");
			Query = Query.replaceAll(":SISTEMA",user.getDatosMenu().idSelected());
			pstmt = conn.connection().prepareStatement(Query);
			ResultSet rs = pstmt.executeQuery();
			while (rs.next()) {
				D7Secciones sec = new D7Secciones();
				sec.setSecSisCod(rs.getString("Sec_Sis_Cod"));
	 	    	sec.setSecCod(rs.getString("Sec_Cod"));
	 	    	sec.setSecDescrip(rs.getString("Sec_Descrip"));
	 	    	sec.setSecIdRespon(rs.getString("Sec_Id_Respon"));
	 	    	sec.setSecSecCod(rs.getString("Sec_Sec_Cod"));
	 	    	sec.setSecEstado(rs.getString("Sec_Estado"));
	 	    	this.secciones.add(sec);
			}   
		 rs.close();
		 pstmt.close();
		
		} catch (Exception ex) {
			System.out.println(ex);
			setErrorMessage("GestorMetricas [Lectura de BBDD]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
	}
	/**-------------LISTADOS DE PRIORIDADES(COMN PARA GESTOR Y PARA MAESTRO)-------------------*/
	public void listaPrioridades(Session conn){
		try{
			Query q = conn.createQuery(getQuery("ListaPrioridades"));
			q = q.setString("sist",user.getDatosMenu().idSelected());
			prioridades  = (List)q.list();
		} catch (Exception ex) {
			setErrorMessage("GestorMetricas[Lectura de BBDD]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
	}
	
	public void listaTiposTareas(Session conn){
		try{
			Query q = conn.createQuery(getQuery("ListaTiposTareas"));
			q = q.setString("sist",user.getDatosMenu().idSelected());
			tiposTareas  = (List)q.list();
		} catch (Exception ex) {
			setErrorMessage("GestorMetricas[Lectura de BBDD]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
	}
		
	/**-------------------GESTOR-------------------*/
	public void listaSeccionesGestor(Session conn) {
		PreparedStatement pstmt;
		
		try{
			String ResultadoQuery = getQuery("SeccionesGestorConAyuda");
			ResultadoQuery = ResultadoQuery.replaceAll(":SISTEMA",user.getDatosMenu().idSelected());
			ResultadoQuery = ResultadoQuery.replaceAll(":GESTOR",user.getIdentificador());
			pstmt = conn.connection().prepareStatement(ResultadoQuery);
			ResultSet rs = pstmt.executeQuery();
			
		 	while (rs.next()) {
	 	    	D7Secciones sec = new D7Secciones();
	 	    	sec.setSecSisCod(rs.getString("Sec_Sis_Cod"));
	 	    	sec.setSecCod(rs.getString("Sec_Cod"));
	 	    	sec.setSecDescrip(rs.getString("Sec_Descrip"));
	 	    	sec.setSecIdRespon(rs.getString("Sec_Id_Respon"));
	 	    	sec.setSecSecCod(rs.getString("Sec_Sec_Cod"));
	 	    	sec.setSecEstado(rs.getString("Sec_Estado"));
	 	    	seccionesResponsable.add(sec);
	 	    }
		 	rs.close();
	 	    pstmt.close();
		} catch (Exception ex) {
			System.out.println(ex);
			setErrorMessage("GestorMetricas[Lectura de BBDD]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
	}
	/**-------------------MAESTRO-------------------*/
	public void listaSeccionesMaestro(Session conn){
		try{
			Query q = conn.createQuery(getQuery("SeccionesMaestroConAyuda"));
			q = q.setString("sist",user.getDatosMenu().idSelected());
			secciones  = (List)q.list();
		} catch (Exception ex) {
			setErrorMessage("GestorMetricas[Lectura de BBDD]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
	}
		
	public java.util.Date FechaUltimaEspera(Session conn, String tarCod){
		try{
			Query q = conn.createQuery(getQuery("FechaUltimaEspera"));
			q = q.setString("sist",user.getDatosMenu().idSelected());
			q = q.setString("espera",dumbo7.utils.D7Tareas.EN_ESPERA);
			q = q.setString("cod",tarCod);
			tareasMov  = (List)q.list();
			
			return ((D7TareasMovimientos)tareasMov.get(0)).getTmoFechaMov();
		}catch (Exception ex){
			setErrorMessage("GestorMetricas[Lectura de BBDD]: "+((ex.getCause()!=null)?ex.getCause():ex));
			return null;
		}
	}
	
	/** Mtodo para sustituir todos los parmetros de la query de ListaEnModoDato o ListaEnModoDatoDesglose
	* En este mtodo se elige cual de las 2 querys realizar en funcin de si se ha elegido desglose o no
	* Adems tambin se sustituyen los parmetros en funcin de si se ha introducido usuario, informatico, seccion...
	* */
	/**-------------------RESULTADOS de las mtricas para MAESTRO-------------------*/
	public void listaModoDatoMaestro(Session conn){
		PreparedStatement pstmtT;
		PreparedStatement pstmtPrio;
		PreparedStatement pstmtDetalle;
		/**String para construir la query de MAESTRO para tareas en estado Pendientes y en estado de ESPERA*/
		String QueryT ="";
		/**String para construir la query de MAESTRO para tareas segun su Prioridad*/
		String QueryPrio ="";
		/**String para construir la query de MAESTRO para la informacin Detallada*/
		String QueryDetalle ="";
		try{
			/**Inicio de la cuenta para la medicin del tiempo de ejecucin de la METRICA*/
			java.util.Date FechaInicio = new java.util.Date();
			int MinutosI = FechaInicio.getMinutes();
			int SegundosI = FechaInicio.getSeconds();
			
			QueryT = getQuery("ListaTotales");
			QueryPrio = getQuery("ListaPorPrioridad");
			QueryDetalle = getQuery("ListaDetallada");
			/**Eliminamos las condiciones del gestor*/
			QueryDetalle = QueryDetalle.replaceAll(":CONDICION_GESTOR","");
			
			if(this.Desglose.equals("sec")){
				QueryT = QueryT.replaceAll(":CONDICION_DESGLOSE",getQuery("CondicionDesglose"));
				QueryPrio = QueryPrio.replaceAll(":CONDICION_DESGLOSE",getQuery("CondicionDesglose"));
			}
			else{
				QueryT = QueryT.replaceAll(":CONDICION_DESGLOSE","");
				QueryPrio = QueryPrio.replaceAll(":CONDICION_DESGLOSE","");
			}
			
			/**Construimos la query dependiendo del PERIODO introducido si no hay inicio = "DesdeInicio de tiempos"; si no hay fin = "HastaFin de tiempos*/
			if(!(this.FechaDesde.equals("DD/MM/AAAA")) & !(this.FechaHasta.equals("DD/MM/AAAA"))){
				QueryT = QueryT.replaceAll(":FINICIO",this.FechaDesde);
				QueryT = QueryT.replaceAll(":FFIN",this.FechaHasta);
				QueryPrio = QueryPrio.replaceAll(":FINICIO",this.FechaDesde);
				QueryPrio = QueryPrio.replaceAll(":FFIN",this.FechaHasta);
				QueryDetalle = QueryDetalle.replaceAll(":FINICIO",this.FechaDesde);
				QueryDetalle = QueryDetalle.replaceAll(":FFIN",this.FechaHasta);
			}else if(this.FechaDesde.equals("DD/MM/AAAA") & !(this.FechaHasta.equals("DD/MM/AAAA"))){
				QueryT = QueryT.replaceAll("':FINICIO'","NULL");
				QueryT = QueryT.replaceAll(":FFIN",this.FechaHasta);
				QueryPrio = QueryPrio.replaceAll("':FINICIO'","NULL");
				QueryPrio = QueryPrio.replaceAll(":FFIN",this.FechaHasta);
				QueryDetalle = QueryDetalle.replaceAll(":FINICIO","NULL");
				QueryDetalle = QueryDetalle.replaceAll(":FFIN",this.FechaHasta);
				
				}else if(!(this.FechaDesde.equals("DD/MM/AAAA")) & this.FechaHasta.equals("DD/MM/AAAA")){
					QueryT = QueryT.replaceAll(":FINICIO",this.FechaDesde);
					QueryT = QueryT.replaceAll("':FFIN'","NULL");
					QueryPrio = QueryPrio.replaceAll(":FINICIO",this.FechaDesde);
					QueryPrio = QueryPrio.replaceAll("':FFIN'","NULL");
					QueryDetalle = QueryDetalle.replaceAll(":FINICIO",this.FechaDesde);
					QueryDetalle = QueryDetalle.replaceAll(":FFIN","NULL");
					}else{
						QueryT = QueryT.replaceAll("':FINICIO'","NULL");
						QueryT = QueryT.replaceAll("':FFIN'","NULL");
						QueryPrio = QueryPrio.replaceAll("':FINICIO'","NULL");
						QueryPrio = QueryPrio.replaceAll("':FFIN'","NULL");
						QueryDetalle = QueryDetalle.replaceAll(":FINICIO","NULL");
						QueryDetalle = QueryDetalle.replaceAll(":FFIN","NULL");
						}
			
			/**Sustitucin de TIPOS TAREAS*/
			QueryT = QueryT.replaceAll(":PETICION",D7TiposTareas.PETICION);
			QueryT = QueryT.replaceAll(":INCIDENCIA",D7TiposTareas.INCIDENCIA);
			QueryPrio = QueryPrio.replaceAll(":PETICION",D7TiposTareas.PETICION);
			QueryPrio = QueryPrio.replaceAll(":INCIDENCIA",D7TiposTareas.INCIDENCIA);
			QueryDetalle = QueryDetalle.replaceAll(":PETICION",D7TiposTareas.PETICION);
			QueryDetalle = QueryDetalle.replaceAll(":INCIDENCIA",D7TiposTareas.INCIDENCIA);
			
			/**Si se introduce una SECCIN por la que filtrar, y teniendo en cuenta el desglose se
			 * sustituyen SEC y DESGLOSE_SEC*/
			if(!this.Seccion.equals("")){
				/**Si hay desglose y filtro por seccin*/
				if(this.Desglose.equals("sec")){
					QueryT = QueryT.replaceAll(":SEC",this.Seccion);
					QueryT = QueryT.replaceAll("':DESGLOSE_SEC'","sec_cod");
					QueryPrio = QueryPrio.replaceAll(":SEC",this.Seccion);
					QueryPrio = QueryPrio.replaceAll("':DESGLOSE_SEC'","sec_cod");
					QueryDetalle = QueryDetalle.replaceAll(":SEC",this.Seccion);
					QueryDetalle = QueryDetalle.replaceAll("':DESGLOSE_SEC'","sec_cod");
				}
				else{
					QueryT = QueryT.replaceAll(":DESGLOSE_SEC",this.Seccion);
					QueryPrio = QueryPrio.replaceAll(":DESGLOSE_SEC",this.Seccion);
					QueryDetalle = QueryDetalle.replaceAll(":DESGLOSE_SEC",this.Seccion);
					QueryDetalle = QueryDetalle.replaceAll("':SEC'","NULL");
				}
			}
			else{
				/**Si no hay filtro pero hay desglose*/
				if(this.Desglose.equals("sec")){
					QueryT = QueryT.replaceAll("':SEC'","NULL");
					QueryT = QueryT.replaceAll("':DESGLOSE_SEC'","sec_cod");
					QueryPrio = QueryPrio.replaceAll("':SEC'","NULL");
					QueryPrio = QueryPrio.replaceAll("':DESGLOSE_SEC'","sec_cod");
					QueryDetalle = QueryDetalle.replaceAll("':SEC'","NULL");
					QueryDetalle = QueryDetalle.replaceAll("':DESGLOSE_SEC'","sec_cod");
				}
				else{
					QueryT = QueryT.replaceAll("':DESGLOSE_SEC'","NULL");
					QueryPrio = QueryPrio.replaceAll("':DESGLOSE_SEC'","NULL");
					QueryDetalle = QueryDetalle.replaceAll("':DESGLOSE_SEC'","NULL");
					QueryDetalle = QueryDetalle.replaceAll("':SEC'","NULL");
				}
			}
			
			/**Sustitucin del DESGLOSE o no*/
			if(this.Desglose.equals("sec")){
				QueryT = QueryT.replaceAll(":TABLASISTEMAS"," WHERE sec_sis_cod = " + "'"+user.getDatosMenu().idSelected()+"'");
				QueryT = QueryT.replaceAll(":DESCRIPDESGLOSE",",sec_cod desglose");
				QueryT = QueryT.replaceAll(":TABLA"," DUMBO.D7_SECCIONES");
												
				QueryPrio = QueryPrio.replaceAll(":TABLASISTEMAS"," AND sec_sis_cod = " + "'"+user.getDatosMenu().idSelected()+"'");
				QueryPrio = QueryPrio.replaceAll(":DESCRIPDESGLOSE",",sec_cod desglose");
				QueryPrio = QueryPrio.replaceAll(":TABLA",", DUMBO.D7_SECCIONES");
											
				QueryDetalle = QueryDetalle.replaceAll(":TABLASISTEMAS"," AND apl_sis_cod = " + "'"+user.getDatosMenu().idSelected()+"'"+ " AND sec_sis_cod = " + "'"+user.getDatosMenu().idSelected()+"'");
				QueryDetalle = QueryDetalle.replaceAll(":DESCRIPDESGLOSE",",sec_cod desglose");
				QueryDetalle = QueryDetalle.replaceAll(":TABLA",", DUMBO.D7_APLICACIONES, DUMBO.D7_SECCIONES");
				QueryDetalle = QueryDetalle.replaceAll(":JOIN_RESTRICCION","and sec_cod=apl_sec_cod and apl_cod = tar_apl_cod");
				
			}
			else{
				QueryT = QueryT.replaceAll(":TABLASISTEMAS","");
				QueryT = QueryT.replaceAll(":DESCRIPDESGLOSE","");
				QueryT = QueryT.replaceAll(":TABLA","dual");
				QueryT = QueryT.replaceAll("':DESGLOSE_SEC'","NULL");
							
				QueryPrio = QueryPrio.replaceAll(":TABLASISTEMAS","");
				QueryPrio = QueryPrio.replaceAll(":DESCRIPDESGLOSE","");
				QueryPrio = QueryPrio.replaceAll(":TABLA","");
				QueryPrio = QueryPrio.replaceAll("':DESGLOSE_SEC'","NULL");
								
				QueryDetalle = QueryDetalle.replaceAll(":TABLASISTEMAS","");
				QueryDetalle = QueryDetalle.replaceAll(":DESCRIPDESGLOSE","");
				QueryDetalle = QueryDetalle.replaceAll(":TABLA","");
				QueryDetalle = QueryDetalle.replaceAll(":JOIN_RESTRICCION","");
				
			}
			
			/**Nmero de informticos a los que informar*/
			QueryT = QueryT.replaceAll(":DESV",NumDesv);
			QueryPrio = QueryPrio.replaceAll(":DESV",NumDesv);
			QueryDetalle = QueryDetalle.replaceAll(":DESV",NumDesv);
			
			/**El parmetro GESTOR se pone a NULL puesto que nos encontramos en MAESTRO*/
			QueryT = QueryT.replaceAll(":GESTOR","NULL");
			QueryPrio = QueryPrio.replaceAll(":GESTOR","NULL");
			QueryDetalle = QueryDetalle.replaceAll(":GESTOR","NULL");
				
			/**SISTEMA*/
			QueryT = QueryT.replaceAll(":SISTEMA",user.getDatosMenu().idSelected());
			QueryPrio = QueryPrio.replaceAll(":SISTEMA",user.getDatosMenu().idSelected());
			QueryDetalle = QueryDetalle.replaceAll(":SISTEMA",user.getDatosMenu().idSelected());
			
			pstmtT = conn.connection().prepareStatement(QueryT);
			ResultSet rsT = pstmtT.executeQuery();
			while (rsT.next()) {
				/**RECOGIDA DE RESULTADOS(de tareas pendientes y en espera) Y MAPEO A TRAVS DE LA CLASE MTRICAS*/
			   	Metricas M = new Metricas();
			   	M.setParams(rsT.getString(1));
			   	M.setIncidencias(new Integer(rsT.getInt(2)));
			   	M.setPeticiones(new Integer(rsT.getInt(3)));
			     //Dependiendo de si hay desglose o no lo mapeo en la mtrica
			   	if(Desglose.equals("sec")){
			   		M.setDesglose(rsT.getString(4));
			   	}
			   	this.resultadoMetricas.add(M);
			}   
			rsT.close();
			pstmtT.close();
			
			pstmtPrio = conn.connection().prepareStatement(QueryPrio);
			ResultSet rsPrio = pstmtPrio.executeQuery();
			while (rsPrio.next()) {
				/**RECOGIDA DE RESULTADOS(de tareas pendientes) Y MAPEO A TRAVS DE LA CLASE MTRICAS*/
				Metricas M = new Metricas();
			   	M.setParams(rsPrio.getString(1));
			   	M.setIncidencias(new Integer(rsPrio.getInt(2)));
			   	M.setPeticiones(new Integer(rsPrio.getInt(3)));
			     //Dependiendo de si hay desglose o no lo mapeo en la mtrica
			   	if(Desglose.equals("sec")){
			   		M.setDesglose(rsPrio.getString(4));
			   	}
			   	this.resultadoMetricas.add(M);
			}   
			rsPrio.close();
			pstmtPrio.close();
			
			pstmtDetalle = conn.connection().prepareStatement(QueryDetalle);
			ResultSet rsDetalle = pstmtDetalle.executeQuery();
			while (rsDetalle.next()) {
				/**RECOGIDA DE RESULTADOS(de tareas pendientes y en espera) Y MAPEO A TRAVS DE LA CLASE MTRICAS*/
				D7Tareas tar = new D7Tareas();
				   	tar.setTarCod(new Integer(rsDetalle.getInt(4)));
				   	tar.setTarInfCod(rsDetalle.getString(5));
				   	tar.setTarTipCod(rsDetalle.getString(6));
				   	tar.setTarPriCod(rsDetalle.getString(7));
				   	tar.setTarUrgencia(rsDetalle.getString(8));
				Metricas M = new Metricas();
					M.setDesv(new Double(rsDetalle.getString(1)));
					M.setTmedioresoTar(new Double(rsDetalle.getString(2)));
					M.setTmedioatenTar(new Double(rsDetalle.getString(3)));
					M.setTarea(tar);
			    //Dependiendo de si hay desglose o no lo mapeo en la mtrica
			   	if(Desglose.equals("sec")){
			   		M.setDesglose(rsDetalle.getString(9));
			   	}
			   	this.resultadoMetricas.add(M);
			}   
			rsDetalle.close();
			pstmtDetalle.close();
			
			/**FIN de la cuenta para la medicin del tiempo de ejecucin de la METRICA*/
			java.util.Date FechaFin = new java.util.Date();
			int MinutosF = FechaFin.getMinutes();
			int SegundosF = FechaFin.getSeconds();
			/**Tenemos en cuenta si se ha cambiado de minuto mientras se realiza la mtrica*/
			if (SegundosI > SegundosF){
				SegundosF = 60 + SegundosF;
				MinutosF = MinutosF - 1;
			}
		 	setErrorMessage("La mtica se ha realizado en: "+ new Integer(Math.abs(MinutosF-MinutosI)).toString() + " min. y " +new Integer(Math.abs(SegundosF-SegundosI)).toString() + " seg.");
		 	
	 	   } catch (Exception ex) {
			System.out.println(ex);
			setErrorMessage("LISTADO Maestro:"+ex.toString().substring(0,ex.toString().length()-1));
		}
	}
	
	
	/**-------------------RESULTADOS de las mtricas para GESTOR-------------------*/
	public void listaModoDatoGestor(Session conn){
		PreparedStatement pstmtT;
		PreparedStatement pstmtPrio;
		PreparedStatement pstmtDetalle;
		/**String para construir la query de GESTOR para tareas en estado Pendientes y en estado de ESPERA*/
		String QueryT ="";
		/**String para construir la query de GESTOR para tareas segun su Prioridad*/
		String QueryPrio ="";
		/**String para construir la query de GESTOR para la informacin Detallada*/
		String QueryDetalle ="";
		try{
			/**Inicio de la cuenta para la medicin del tiempo de ejecucin de la METRICA*/
			java.util.Date FechaInicio = new java.util.Date();
			int MinutosI = FechaInicio.getMinutes();
			int SegundosI = FechaInicio.getSeconds();
			
			QueryT = getQuery("ListaTotales");
			QueryPrio = getQuery("ListaPorPrioridad");
			QueryDetalle = getQuery("ListaDetallada");
			/**Aadimos las condiciones del GESTOR*/
			QueryDetalle = QueryDetalle.replaceAll(":CONDICION_GESTOR",getQuery("condicionesGestor"));
			
			if(this.Desglose.equals("sec")){
				QueryT = QueryT.replaceAll(":CONDICION_DESGLOSE",getQuery("CondicionDesglose"));
				QueryPrio = QueryPrio.replaceAll(":CONDICION_DESGLOSE",getQuery("CondicionDesglose"));
			}
			else{
				QueryT = QueryT.replaceAll(":CONDICION_DESGLOSE","");
				QueryPrio = QueryPrio.replaceAll(":CONDICION_DESGLOSE","");
			}
			
			/**Construimos la query dependiendo del PERIODO introducido si no hay inicio = "DesdeInicio de tiempos"; si no hay fin = "HastaFin de tiempos*/
			if(!(this.FechaDesde.equals("DD/MM/AAAA")) & !(this.FechaHasta.equals("DD/MM/AAAA"))){
				QueryT = QueryT.replaceAll(":FINICIO",this.FechaDesde);
				QueryT = QueryT.replaceAll(":FFIN",this.FechaHasta);
				QueryPrio = QueryPrio.replaceAll(":FINICIO",this.FechaDesde);
				QueryPrio = QueryPrio.replaceAll(":FFIN",this.FechaHasta);
				QueryDetalle = QueryDetalle.replaceAll(":FINICIO",this.FechaDesde);
				QueryDetalle = QueryDetalle.replaceAll(":FFIN",this.FechaHasta);
			}else if(this.FechaDesde.equals("DD/MM/AAAA") & !(this.FechaHasta.equals("DD/MM/AAAA"))){
				QueryT = QueryT.replaceAll("':FINICIO'","NULL");
				QueryT = QueryT.replaceAll(":FFIN",this.FechaHasta);
				QueryPrio = QueryPrio.replaceAll("':FINICIO'","NULL");
				QueryPrio = QueryPrio.replaceAll(":FFIN",this.FechaHasta);
				QueryDetalle = QueryDetalle.replaceAll(":FINICIO","NULL");
				QueryDetalle = QueryDetalle.replaceAll(":FFIN",this.FechaHasta);
				
				}else if(!(this.FechaDesde.equals("DD/MM/AAAA")) & this.FechaHasta.equals("DD/MM/AAAA")){
					QueryT = QueryT.replaceAll(":FINICIO",this.FechaDesde);
					QueryT = QueryT.replaceAll("':FFIN'","NULL");
					QueryPrio = QueryPrio.replaceAll(":FINICIO",this.FechaDesde);
					QueryPrio = QueryPrio.replaceAll("':FFIN'","NULL");
					QueryDetalle = QueryDetalle.replaceAll(":FINICIO",this.FechaDesde);
					QueryDetalle = QueryDetalle.replaceAll(":FFIN","NULL");
					}else{
						QueryT = QueryT.replaceAll("':FINICIO'","NULL");
						QueryT = QueryT.replaceAll("':FFIN'","NULL");
						QueryPrio = QueryPrio.replaceAll("':FINICIO'","NULL");
						QueryPrio = QueryPrio.replaceAll("':FFIN'","NULL");
						QueryDetalle = QueryDetalle.replaceAll(":FINICIO","NULL");
						QueryDetalle = QueryDetalle.replaceAll(":FFIN","NULL");
						}
			
			/**Si se introduce una SECCIN por la que filtrar, y teniendo en cuenta el desglose se
			 * sustituyen SEC y DESGLOSE_SEC*/
			if(!this.Seccion.equals("")){
				/**Si hay desglose y filtro por seccin*/
				if(this.Desglose.equals("sec")){
					QueryT = QueryT.replaceAll(":SEC",this.Seccion);
					QueryT = QueryT.replaceAll("':DESGLOSE_SEC'","sec_cod");
					QueryPrio = QueryPrio.replaceAll(":SEC",this.Seccion);
					QueryPrio = QueryPrio.replaceAll("':DESGLOSE_SEC'","sec_cod");
					QueryDetalle = QueryDetalle.replaceAll(":SEC",this.Seccion);
					QueryDetalle = QueryDetalle.replaceAll("':DESGLOSE_SEC'","sec_cod");
				}
				else{
					QueryT = QueryT.replaceAll(":DESGLOSE_SEC",this.Seccion);
					QueryPrio = QueryPrio.replaceAll(":DESGLOSE_SEC",this.Seccion);
					QueryDetalle = QueryDetalle.replaceAll(":DESGLOSE_SEC",this.Seccion);
					QueryDetalle = QueryDetalle.replaceAll("':SEC'","NULL");
				}
			}
			else{
				/**Si no hay filtro pero hay desglose*/
				if(this.Desglose.equals("sec")){
					QueryT = QueryT.replaceAll("':SEC'","NULL");
					QueryT = QueryT.replaceAll("':DESGLOSE_SEC'","sec_cod");
					QueryPrio = QueryPrio.replaceAll("':SEC'","NULL");
					QueryPrio = QueryPrio.replaceAll("':DESGLOSE_SEC'","sec_cod");
					QueryDetalle = QueryDetalle.replaceAll("':SEC'","NULL");
					QueryDetalle = QueryDetalle.replaceAll("':DESGLOSE_SEC'","sec_cod");
				}
				else{
					QueryT = QueryT.replaceAll("':DESGLOSE_SEC'","NULL");
					QueryPrio = QueryPrio.replaceAll("':DESGLOSE_SEC'","NULL");
					QueryDetalle = QueryDetalle.replaceAll("':DESGLOSE_SEC'","NULL");
					QueryDetalle = QueryDetalle.replaceAll("':SEC'","NULL");
				}
			}
			
			/**Sustitucin del DESGLOSE o no*/
			if(this.Desglose.equals("sec")){
				QueryT = QueryT.replaceAll(":TABLASISTEMAS"," WHERE sec_sis_cod = " + "'"+user.getDatosMenu().idSelected()+"'");
				QueryT = QueryT.replaceAll(":DESCRIPDESGLOSE",",sec_cod desglose");
				QueryT = QueryT.replaceAll(":TABLA"," DUMBO.D7_SECCIONES");
												
				QueryPrio = QueryPrio.replaceAll(":TABLASISTEMAS"," AND sec_sis_cod = " + "'"+user.getDatosMenu().idSelected()+"'");
				QueryPrio = QueryPrio.replaceAll(":DESCRIPDESGLOSE",",sec_cod desglose");
				QueryPrio = QueryPrio.replaceAll(":TABLA",", DUMBO.D7_SECCIONES");
											
				QueryDetalle = QueryDetalle.replaceAll(":TABLASISTEMAS"," AND apl_sis_cod = " + "'"+user.getDatosMenu().idSelected()+"'"+ " AND sec_sis_cod = " + "'"+user.getDatosMenu().idSelected()+"'");
				QueryDetalle = QueryDetalle.replaceAll(":DESCRIPDESGLOSE",",sec_cod desglose");
				QueryDetalle = QueryDetalle.replaceAll(":TABLA",", DUMBO.D7_APLICACIONES, DUMBO.D7_SECCIONES");
				QueryDetalle = QueryDetalle.replaceAll(":JOIN_RESTRICCION","and sec_cod=apl_sec_cod and apl_cod = tar_apl_cod");
				
			}
			else{
				QueryT = QueryT.replaceAll(":TABLASISTEMAS","");
				QueryT = QueryT.replaceAll(":DESCRIPDESGLOSE","");
				QueryT = QueryT.replaceAll(":TABLA","dual");
				QueryT = QueryT.replaceAll("':DESGLOSE_SEC'","NULL");
							
				QueryPrio = QueryPrio.replaceAll(":TABLASISTEMAS","");
				QueryPrio = QueryPrio.replaceAll(":DESCRIPDESGLOSE","");
				QueryPrio = QueryPrio.replaceAll(":TABLA","");
				QueryPrio = QueryPrio.replaceAll("':DESGLOSE_SEC'","NULL");
								
				QueryDetalle = QueryDetalle.replaceAll(":TABLASISTEMAS","");
				QueryDetalle = QueryDetalle.replaceAll(":DESCRIPDESGLOSE","");
				QueryDetalle = QueryDetalle.replaceAll(":TABLA","");
				QueryDetalle = QueryDetalle.replaceAll(":JOIN_RESTRICCION","");
				
			}
			
									
			/**Nmero de informticos a los que informar*/
			QueryT = QueryT.replaceAll(":DESV",NumDesv);
			QueryPrio = QueryPrio.replaceAll(":DESV",NumDesv);
			QueryDetalle = QueryDetalle.replaceAll(":DESV",NumDesv);
			
			/**El parmetro GESTOR se pone a NULL puesto que nos encontramos en MAESTRO*/
			QueryT = QueryT.replaceAll(":GESTOR",user.getIdentificador());
			QueryPrio = QueryPrio.replaceAll(":GESTOR",user.getIdentificador());
			QueryDetalle = QueryDetalle.replaceAll(":GESTOR",user.getIdentificador());
				
			/**SISTEMA*/
			QueryT = QueryT.replaceAll(":SISTEMA",user.getDatosMenu().idSelected());
			QueryPrio = QueryPrio.replaceAll(":SISTEMA",user.getDatosMenu().idSelected());
			QueryDetalle = QueryDetalle.replaceAll(":SISTEMA",user.getDatosMenu().idSelected());
			System.out.println(QueryT);
			pstmtT = conn.connection().prepareStatement(QueryT);
			ResultSet rsT = pstmtT.executeQuery();
			System.out.println(QueryT);
			while (rsT.next()) {
				/**RECOGIDA DE RESULTADOS(de tareas pendientes y en espera) Y MAPEO A TRAVS DE LA CLASE MTRICAS*/
			   	Metricas M = new Metricas();
			   	M.setParams(rsT.getString(1));
			   	M.setIncidencias(new Integer(rsT.getInt(2)));
			   	M.setPeticiones(new Integer(rsT.getInt(3)));
			    //Dependiendo de si hay desglose o no lo mapeo en la mtrica
			   	if(Desglose.equals("sec")){
			   		M.setDesglose(rsT.getString(4));
			   	}
			   	this.resultadoMetricas.add(M);
			}   
			rsT.close();
			pstmtT.close();
			
			pstmtPrio = conn.connection().prepareStatement(QueryPrio);
			ResultSet rsPrio = pstmtPrio.executeQuery();
			while (rsPrio.next()) {
				/**RECOGIDA DE RESULTADOS(de tareas pendientes) Y MAPEO A TRAVS DE LA CLASE MTRICAS*/
				Metricas M = new Metricas();
			   	M.setParams(rsPrio.getString(1));
			   	M.setIncidencias(new Integer(rsPrio.getInt(2)));
			   	M.setPeticiones(new Integer(rsPrio.getInt(3)));
			    //Dependiendo de si hay desglose o no lo mapeo en la mtrica
			   	if(Desglose.equals("sec")){
			   		M.setDesglose(rsPrio.getString(4));
			   	}
			   	this.resultadoMetricas.add(M);
			}   
			rsPrio.close();
			pstmtPrio.close();
			
			pstmtDetalle = conn.connection().prepareStatement(QueryDetalle);
			ResultSet rsDetalle = pstmtDetalle.executeQuery();
			while (rsDetalle.next()) {
				/**RECOGIDA DE RESULTADOS(de tareas pendientes y en espera) Y MAPEO A TRAVS DE LA CLASE MTRICAS*/
				D7Tareas tar = new D7Tareas();
				   	tar.setTarCod(new Integer(rsDetalle.getInt(4)));
				   	tar.setTarInfCod(rsDetalle.getString(5));
				   	tar.setTarTipCod(rsDetalle.getString(6));
				   	tar.setTarPriCod(rsDetalle.getString(7));
				   	tar.setTarUrgencia(rsDetalle.getString(8));
				/**Esto devuelve la ltima fecha de espera de cada tarea del resultado*/
				java.util.Date fecha = FechaUltimaEspera(conn,new String(new Integer(rsDetalle.getInt(2)).toString()));
				Metricas M = new Metricas();
					M.setDesv(new Double(rsDetalle.getString(1)));
					M.setTmedioresoTar(new Double(rsDetalle.getString(2)));
					M.setTmedioatenTar(new Double(rsDetalle.getString(3)));
					M.setDesv(new Double(rsDetalle.getString(1)));
					M.setUltimaEspera(fecha);
					M.setTarea(tar);
			    //Dependiendo de si hay desglose o no lo mapeo en la mtrica
			   	if(Desglose.equals("sec")){
			   		M.setDesglose(rsDetalle.getString(9));
			   	}
			   	this.resultadoMetricas.add(M);
			}   
			rsDetalle.close();
			pstmtDetalle.close();
			
			/**FIN de la cuenta para la medicin del tiempo de ejecucin de la METRICA*/
			java.util.Date FechaFin = new java.util.Date();
			int MinutosF = FechaFin.getMinutes();
			int SegundosF = FechaFin.getSeconds();
			/**Tenemos en cuenta si se ha cambiado de minuto mientras se realiza la mtrica*/
			if (SegundosI > SegundosF){
				SegundosF = 60 + SegundosF;
				MinutosF = MinutosF - 1;
			}
		 	setErrorMessage("La mtica se ha realizado en: "+ new Integer(Math.abs(MinutosF-MinutosI)).toString() + " min. y " +new Integer(Math.abs(SegundosF-SegundosI)).toString() + " seg.");
		 	
	 	   } catch (Exception ex) {
			System.out.println(ex);
			setErrorMessage("LISTADO Gestor:"+ex.toString().substring(0,ex.toString().length()-1));
		}
	}

	
}
