<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet version="1.0" 
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:xforms="http://www.w3.org/2002/xforms">
	
<xsl:param name="servlet"/>	
<xsl:param name="menu"/>
<xsl:param name="perfil"/>
<xsl:param name="inicio"/>
<xsl:param name="fin"/>
<xsl:param name="SecCod"/>
<xsl:param name="FechaDesde"/>
<xsl:param name="FechaHasta"/>
<xsl:param name="NumDesv"/>

<xsl:include href="dumbo7/utils/xsl/utils.xsl"/>
	
<xsl:template match="XMLROOT">
		
	<html lang="es">
		<TITLE>DUMBO7: Resultado Mtrica 'Desviacin'</TITLE>
		
    <xsl:call-template name="headComun">
         <xsl:with-param name="jscript">
            <SCRIPT LANGUAGE="JavaScript">
				function mostrarError(error){
					alert(error);
				}
			</SCRIPT>
			<script LANGUAJE="JavaScript" src="../js/OnMouse.js"></script>
         </xsl:with-param>
	</xsl:call-template>
	<body>
		<xsl:for-each select="DATA/METRICAS">
			<xsl:if test="not(@ERROR='')">
				<script>mostrarError('<xsl:value-of select="@ERROR"/>')</script>
				</xsl:if>
		</xsl:for-each>

	<table border="0" cellpadding="3" align="center" cellspacing="1" width="750" summary="Esta tabla contiene las mtricas de tareas segn DESVIACIN">
	<tr><td colspan="4">
		<table class="cont" id="metricas" border="0" cellpadding="3" cellspacing="1" width="100%" summary="Esta tabla contiene las mtricas">
			<tr class="cab1">
				<td colspan="2">&#187;Resultado: Tareas resueltas con desviacin (<xsl:value-of select="$perfil"/>)</td>
				<td width="10" align="center"><b><a href="javascript:window.print()"><img border="0" src="../graficos/iconos/ico_impresora.gif" alt="Imprimir"/></a></b></td>
				<td width="10" align="center"><b><a href="javascript:window.close()">Cerrar</a></b></td>
			</tr>
			<tr class="cabe">
				<td width="140"><b>Periodo</b></td>
				<td width="350"><b>Parmetros</b></td>
				<td colspan="2"></td>
			</tr>
			<tr class="administracion">
				<td width="90"><b>Desde:</b>&#160;&#160;<i>
					 <xsl:value-of select="$FechaDesde"/>
				</i></td>
				<td width="350" colspan="3">
					<b>Seccion:&#160;</b>
					<xsl:if test="$SecCod != ''">
						<i><xsl:value-of select="DATA/METRICAS/SECCION/@DESCRIPCION"/></i>
					</xsl:if>	
					<xsl:if test="$SecCod = ''">
						<i>TODAS</i>	
					</xsl:if>
				</td>
			</tr>
			<tr class="administracion">
				<td width="90"><b>Hasta:</b>&#160;&#160;<i>
					<xsl:value-of select="$FechaHasta"/>
				</i></td>
				<td colspan="3"></td>
			</tr>
			<!--Seleccin del modo de representacin de datos-->
			<tr class="cabe"><td align="left" colspan="4" ><b>Presentacin de datos</b></td></tr>
			<tr class="administracion">
				<td colspan="4">
					<b>Modo Dato</b>&#160;-->&#160;Representacin&#160;Conjunta
				</td>
			</tr>
		</table>
		<xsl:for-each select="DATA/METRICAS/SECCION">
		<xsl:variable name="SeccionActual"><xsl:value-of select="@CODIGO"/></xsl:variable>		
		<xsl:if test="count(../RESULTADO_METRICAS[@DESGLOSE = $SeccionActual]) != 0">
			<xsl:if test="(../RESULTADO_METRICAS[@PARAMS = 'total' and @DESGLOSE = $SeccionActual]/@INCIDENCIAS  + ../RESULTADO_METRICAS[@PARAMS = 'total'  and @DESGLOSE = $SeccionActual]/@PETICIONES) != 0">
				<table class="cont" border="0" cellpadding="3" cellspacing="1" width="100%" summary="Resultados Estadsticos">
					<tr class="cabe"><td colspan="10"><b>Informcin&#160;ESTADSTICA&#160;y&#160;DETALLADA&#160;de:&#160;"<xsl:value-of select="@DESCRIPCION"/>"</b></td></tr>
					<tr class="administracion">
						<td>
							<table class="cont" border="0" cellpadding="3" cellspacing="2">
							<tr class="cabeAlertas"><td colspan="4"><b>Tareas&#160;Resueltas&#160;con&#160;desviacin</b></td></tr>
								<tr class="cabeAlertas">
									<td>&#160;</td>
									<td align="center">Incidencias(I)</td>
									<td align="center">Peticiones(P)</td>
									<td align="center">Total(I+P)</td>
								</tr>
								<tr class="administracion">
									<!--INCIDENCIAS-->
									<td class="cabeAlertas">Resueltas</td>
									<td align="center" class="celdapaipucMet"><xsl:value-of select="../RESULTADO_METRICAS[@PARAMS = 'total' and @DESGLOSE = $SeccionActual]/@INCIDENCIAS"/></td>
									<td align="center" class="celdapaipucMet"><xsl:value-of select="../RESULTADO_METRICAS[@PARAMS = 'total' and @DESGLOSE = $SeccionActual]/@PETICIONES"/></td>
									<td align="center" class="celdapaipucMet"><xsl:value-of select="../RESULTADO_METRICAS[@PARAMS = 'total' and @DESGLOSE = $SeccionActual]/@INCIDENCIAS + ../RESULTADO_METRICAS[@PARAMS = 'total' and @DESGLOSE = $SeccionActual]/@PETICIONES"/></td>
								</tr>
							</table>
						</td>
						<td>
							<table class="cont" border="0" cellpadding="3" cellspacing="2">
							<xsl:variable name="NumPrio"><xsl:value-of select="count(../PRIORIDAD)"/></xsl:variable>
							<tr class="cabeAlertas"><td colspan="{$NumPrio+1}"><b>Tareas&#160;Resueltas&#160;mas&#160;del&#160;<xsl:value-of select="$NumDesv"/>%&#160;de&#160;Desviacin</b></td></tr>
								<tr class="cabeAlertas">
									<td>&#160;</td>
									<xsl:for-each select="../PRIORIDAD">
									<xsl:variable name="codigo"><xsl:value-of select="@CODIGO"/></xsl:variable>
										<td align="center"><xsl:value-of select="@DESCRIPCION"/></td>
									</xsl:for-each>
								</tr>
								<tr class="administracion">
									<!--INCIDENCIAS-->
									<td class="cabeAlertas">Incidencias</td>
									<xsl:for-each select="../PRIORIDAD">
									<xsl:variable name="codigo"><xsl:value-of select="@CODIGO"/></xsl:variable>
										<td class="celdapaipucMet" align="center">
											<xsl:value-of select="../RESULTADO_METRICAS[@PARAMS = concat('prio',$codigo) and @DESGLOSE = $SeccionActual]/@INCIDENCIAS"/>
										</td>
									</xsl:for-each>
								</tr>
								<tr class="administracion">
									<td class="cabeAlertas">Peticiones</td>
									<!--PETICIONES-->
									<xsl:for-each select="../PRIORIDAD">
									<xsl:variable name="codigo"><xsl:value-of select="@CODIGO"/></xsl:variable>
										<td align="center" class="celdapaipucMet">
											<xsl:value-of select="../RESULTADO_METRICAS[@PARAMS = concat('prio',$codigo) and @DESGLOSE = $SeccionActual]/@PETICIONES"/>
										</td>
									</xsl:for-each>
								</tr>
							</table>
						</td>
					</tr>
				</table>
				<table class="cont" border="0" cellpadding="3" cellspacing="1">
					<tr class="lineaResultados"><td><hr width="100%"></hr></td></tr>
				</table>
				<table class="cont" border="0" cellpadding="3" cellspacing="1" width="100%" summary="Informacin detallada">
					<tr class="administracion">
						<td align="center"><i><b>ID&#160;Tarea</b></i></td>
						<td colspan="2" align="center" width="50"><i><b><xsl:call-template name="traduce"><xsl:with-param name="id" select="'Informtico'"/></xsl:call-template></b></i></td>
						<td width="30" align="center"><i><b>Desviacin</b></i></td>
						<td width="30" align="center"><i><b>T.&#160;Resolucin</b></i></td>
						<td width="30" align="center"><i><b>T.&#160;Atencin</b></i></td>
						<td width="20" align="center"><i><b>Tipo&#160;Tarea</b></i></td>
						<td width="60" align="center"><i><b>Prioridad</b></i></td>
						<td width="60" align="center"><i><b>Urgencia</b></i></td>
					</tr>
					<xsl:for-each select="../RESULTADO_METRICAS[@DESGLOSE = $SeccionActual]/TAREA">
						<xsl:sort select="../@DESV" order="descending"/>
						<!--Esta separacin es para poder poner los colores a las lneas de incidencia y peticion-->
						<xsl:if test="@TIPO_TAREA = 'I'">
							<tr class="incidencia" onmouseover="javascript:onMouseInc(this,'true');" onmouseout="javascript:onMouseInc(this,'false');">
								<xsl:call-template name="muestraDatos"/>
							</tr>
						</xsl:if>
						<xsl:if test="@TIPO_TAREA = 'P'">
							<tr class="administracion" onmouseover="javascript:onMouse(this,'true');" onmouseout="javascript:onMouse(this,'false');">
								<xsl:call-template name="muestraDatos"/>
							</tr>
						</xsl:if>
					</xsl:for-each>
				</table>
			</xsl:if>
		</xsl:if>
		<!--For de las secciones para la repeticin de toda la informacin-->
		</xsl:for-each>
		
		<table class="cont" border="0" cellpadding="3" cellspacing="1" width="100%" summary="cerrar">
			<tr class="administracion" align="center"><td colspan="9"><CENTER><input type="button" class="boton" value="Cerrar" onclick="javascript:window.close()" /></CENTER></td></tr>
		</table>	
	</td></tr>
</table>
			
</body>
</html>
</xsl:template>

<xsl:template name="muestraDatos">
	<td width="40" class="celdapaipucMet" align="center"><xsl:value-of select="@CODIGO"/></td>
	<td class="celdapaipucMet" colspan="2" width="50" align="center"><xsl:value-of select="@INFORMATICO"/></td>
	<td class="celdapaipucMet" align="center"><xsl:value-of select="substring(../@DESV,0,7)"/></td>
	<td class="celdapaipucMet" align="center"><xsl:value-of select="../@RESOLUCION_TAR"/></td>
	<td class="celdapaipucMet" align="center"><xsl:value-of select="../@ATENCION_TAR"/></td>
	<xsl:variable name="tipotar"><xsl:value-of select="@TIPO_TAREA"/></xsl:variable>
	<td class="celdapaipucMet" width="20" align="center"><xsl:value-of select="../../TIPO_TAREA[@CODIGO= $tipotar]/@DESCRIPCION"/></td>
	<xsl:variable name="prio"><xsl:value-of select="@PRIORIDAD"/></xsl:variable>
	<td class="celdapaipucMet" width="60" align="center">
		<xsl:value-of select="../../PRIORIDAD[@CODIGO = $prio]/@DESCRIPCION"/>
	</td>
	<td class="celdapaipucMet" width="60" align="center">
		<xsl:if test="@URGENCIA = 'U'">
			Urgente
		</xsl:if>
		<xsl:if test="@URGENCIA = 'N'">
			No&#160;Urgente
		</xsl:if>
		<xsl:if test="not(@URGENCIA)">
			--
		</xsl:if>
	</td>
</xsl:template>

<xsl:template name="cuerpo"/>
</xsl:stylesheet>
	