package dumbo7.metricas.estado;

import dumbo7.metricas.*;

import java.sql.*;
import java.sql.ResultSet;
import java.util.*;

import dumbo7.utils.*;

import org.hibernate.Query;
import org.hibernate.Session;

import atica.frameweb.utils.*;

/**
 * @author Antonio
 *
 * Gestor de Metricas Estado de Dumbo
 * 
 */
public class GestorEstado extends GeneralManager {
	private List seccionesResponsable = new Vector();
	private List aplicaciones = new Vector();
	private List categorias= new Vector();
	private List grupoUsuarios= new Vector();
	private List usuarios= new Vector();
	private List secciones = new Vector();
	private List informaticos= new Vector();
	private List ModoDato;
	private Vector resultadoMetricas = new Vector();
	private Vector resultadoMetricas_tm = new Vector();
	
	private String Aplicacion = "";
	private String Seccion = "";
	private String Categoria = "";
	private String Informatico = "";
	private String Usuario = "";
	private String GrupoUsuarios = "";
	private String Datos = "";
	private String Codigo = "";
	private String Sel = "";
	private String Patron = "";
	
	private String FechaDesde;
	private String FechaHasta;
	private String Desglose;/**Desglose que se puede hacer cuando estas en modo DATO*/
		
	public GestorEstado() {}
	
	//Mtodos get() para el mapeo
	public List getAplicaciones() { return aplicaciones; }
	public List getCategorias() { return categorias; }
	public List getSecciones() { return secciones; }
	public List getSeccionesResponsable() { return seccionesResponsable; }
	public List getInformaticos() { return informaticos; }
	public List getGrupoUsuarios() { return grupoUsuarios; }
	public List getUsuarios() { return usuarios; }
	public List getModoDato(){return ModoDato;}
	public Vector getResultadoMetricas(){return this.resultadoMetricas;}
	public Vector getResultadoMetricas_tm(){return this.resultadoMetricas_tm;}
	
	//Mtodos set para recoger los datos del formulario
	/**Metdo set() para obtener las fechas de inicio y fin del histrico*/
	public void setFechaDesde(String FDesde){this.FechaDesde = FDesde;}
	public void setFechaHasta(String FHasta){this.FechaHasta = FHasta;}
		
	/**Puede obtener los valores: 
	 * 		con(sin Desglose)
	 * 		apl(por Aplicacion)
	 * 		usu(por Usuario) 
	 * 		cat(por Categoria)
	 * 		gusu(por Grupousuario)
	 * */
	public void setDesglose(String D){this.Desglose = D;}
	public void setSeccion(String sec){this.Seccion = sec;}
	public void setUsuario(String U){
		if(U != null){
			this.Usuario = U;
		}
		else{
			this.Usuario = "";
		}
	}
	public void setGrupoUsuario(String Gu){
		if(Gu != null){
			this.GrupoUsuarios = Gu;
		}
		else{
			this.GrupoUsuarios = "";
		}
	}
	public void setAplicacion(String Apl){this.Aplicacion = Apl;}
	public void setInformatico(String Inf){this.Informatico = Inf;}
	public void setCategoria(String cat){this.Categoria = cat;}
	
	/**	Lista todas las secciones*/
	public void listaSecciones(Session conn){
		try{
			Query q = conn.createQuery(getQuery("AllSecciones"));
			q = q.setString("sist",user.getDatosMenu().idSelected());
			secciones  = (List)q.list();
		}
		catch (Exception ex){
			setErrorMessage("GestorMetricas[Lectura de BBDD]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
	}
		
	/**-------------LISTADOS DE UN NICO ELEMENTO(COMPONENTE)-------------------*/
	public void QuerySeccion(Session conn, String SecCod){
		try{
			Query q = conn.createQuery(getQuery("ListaUnaSeccion"));
			q = q.setString("sist",user.getDatosMenu().idSelected());
			q = q.setString("cod",SecCod);
			secciones  = (List)q.list();		
		}catch (Exception ex){
			setErrorMessage("GestorMetricas[Lectura de BBDD]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
	}
	public void QueryAplicacion(Session conn, String AplCod){
		try{
			Query q = conn.createQuery(getQuery("ListaUnaAplicacion"));
			q = q.setString("sist",user.getDatosMenu().idSelected());
			q = q.setString("cod",AplCod);
			aplicaciones = (List)q.list();
		}catch (Exception ex){
			setErrorMessage("GestorMetricas[Lectura de BBDD]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}	
	}
	public void QueryInformatico(Session conn, String InfCod){
		try{
			Query q = conn.createQuery(getQuery("ListaUnInformatico/Usuario"));
			q = q.setString("cod",InfCod);
			informaticos  = (List)q.list();		
		}catch (Exception ex){
			setErrorMessage("GestorMetricas[Lectura de BBDD]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}	
	}
	public void QueryUsuario(Session conn, String UsuCod){
		try{
			Query q = conn.createQuery(getQuery("ListaUnInformatico/Usuario"));
			q = q.setString("cod",UsuCod);
			usuarios  = (List)q.list();		
		}catch (Exception ex){
			setErrorMessage("GestorMetricas[Lectura de BBDD]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}	
	}
	public void QueryCategoria(Session conn, String CatCod){
		try{
			Query q = conn.createQuery(getQuery("ListaUnaCategoria"));
			q = q.setString("sist",user.getDatosMenu().idSelected());
			q = q.setString("cod", CatCod);
			categorias  = (List)q.list();		
		}catch (Exception ex){
			setErrorMessage("GestorMetricas[Lectura de BBDD]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}	
	}
	public void QueryGrupoUsuario(Session conn, String GruCod){
		try{
			Query q = conn.createQuery(getQuery("ListaUnGrupoUsuarios"));
			q = q.setString("sist",user.getDatosMenu().idSelected());
			q = q.setString("cod",GruCod);
			grupoUsuarios  = (List)q.list();		
		}catch (Exception ex){
			setErrorMessage("GestorMetricas[Lectura de BBDD]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
	}
	
	/**Patron de las busquedas de secciones, categoras grupos usuarios...*/
	public void setPatron(String patron){this.Patron = patron;}
	
	
	/**-------------------INFORMATICO-------------------*/
	public void listaAplicacionesInformatico(Session conn){
		try{
			Query q = conn.createQuery(getQuery("AplicacionesInformaticoConAyuda"));
			q = q.setString("sist",user.getDatosMenu().idSelected());
			q = q.setString("informatico",user.getIdentificador());
			aplicaciones  = (List)q.list();		
		}catch (Exception ex){
			setErrorMessage("GestorMetricas[Lectura de BBDD]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
	}
	public void listaGrupoUsuariosInformatico(Session conn) {
		PreparedStatement pstmt;
		try{
			Query q = conn.createQuery(getQuery("GruUsuInformaticoConAyuda"));
			q = q.setString("sist",user.getDatosMenu().idSelected());
			q = q.setString("informatico",user.getIdentificador());
			this.grupoUsuarios = (List)q.list();		
		}catch (Exception ex){
			setErrorMessage("GestorMetricas[Lectura de BBDD]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
	}
	public void listaCategoriasInformatico(Session conn) {
		try{
			Query q = conn.createQuery(getQuery("CategoriasInformaticoConAyuda"));
			q = q.setString("sist",user.getDatosMenu().idSelected());
			q = q.setString("informatico",user.getIdentificador());
			categorias  = (List)q.list();		
		}catch (Exception ex){
			setErrorMessage("GestorMetricas[Lectura de BBDD]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
	}
	
	/**-------------------GESTOR-------------------*/
	public void listaAplicacionesGestor(Session conn){
		PreparedStatement pstmt;
		try{
			String ResultadoQuery = getQuery("AplicacionesGestorConAyuda");
			ResultadoQuery = ResultadoQuery.replaceAll(":SISTEMA",user.getDatosMenu().idSelected());
			ResultadoQuery = ResultadoQuery.replaceAll(":GESTOR",user.getIdentificador());
			pstmt = conn.connection().prepareStatement(ResultadoQuery);
			ResultSet rs = pstmt.executeQuery();
			
		 	while (rs.next()) {
	 	    	D7Aplicaciones apli = new D7Aplicaciones();
		 	   	apli.setAplSisCod(rs.getString("Apl_Sis_Cod"));
	 	    	apli.setAplCod(rs.getString("Apl_Cod"));
	 	    	apli.setAplDescrip(rs.getString("Apl_Descrip"));
	 	    	apli.setAplTipoAsig(rs.getString("Apl_Tipo_Asig"));
	 	    	apli.setAplSecCod(rs.getString("Apl_Sec_Cod"));
	 	    	apli.setAplEstado(rs.getString("Apl_Estado"));
	 	    	apli.setAplPadreAplCod(rs.getString("Apl_Padre_Apl_Cod"));
	 	    	aplicaciones.add(apli);
	 	    }   
	 	    rs.close();
	 	    pstmt.close();
		} catch (Exception ex) {
			System.out.println(ex);
			setErrorMessage("GestorMetricas[Lectura de BBDD]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
	}
	public void listaSeccionesGestorConDatos(Session conn) {
		PreparedStatement pstmt;
		
		try{
			String ResultadoQuery = getQuery("SeccionesConDatosGestor");
			ResultadoQuery = ResultadoQuery.replaceAll(":SISTEMA",user.getDatosMenu().idSelected());
			ResultadoQuery = ResultadoQuery.replaceAll(":GESTOR",user.getIdentificador());
			pstmt = conn.connection().prepareStatement(ResultadoQuery);
			ResultSet rs = pstmt.executeQuery();
			
		 	while (rs.next()) {
	 	    	D7Secciones sec = new D7Secciones();
	 	    	sec.setSecSisCod(rs.getString("Sec_Sis_Cod"));
	 	    	sec.setSecCod(rs.getString("Sec_Cod"));
	 	    	sec.setSecDescrip(rs.getString("Sec_Descrip"));
	 	    	sec.setSecIdRespon(rs.getString("Sec_Id_Respon"));
	 	    	sec.setSecSecCod(rs.getString("Sec_Sec_Cod"));
	 	    	sec.setSecEstado(rs.getString("Sec_Estado"));
	 	    	secciones.add(sec);
	 	    }
		 	rs.close();
	 	    pstmt.close();
		} catch (Exception ex) {
			System.out.println(ex);
			setErrorMessage("GestorMetricas[Lectura de BBDD]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
	}
	public void listaSeccionesGestor(Session conn) {
		PreparedStatement pstmt;
		
		try{
			String ResultadoQuery = getQuery("SeccionesGestorConAyuda");
			ResultadoQuery = ResultadoQuery.replaceAll(":SISTEMA",user.getDatosMenu().idSelected());
			ResultadoQuery = ResultadoQuery.replaceAll(":GESTOR",user.getIdentificador());
			pstmt = conn.connection().prepareStatement(ResultadoQuery);
			ResultSet rs = pstmt.executeQuery();
			
		 	while (rs.next()) {
	 	    	D7Secciones sec = new D7Secciones();
	 	    	sec.setSecSisCod(rs.getString("Sec_Sis_Cod"));
	 	    	sec.setSecCod(rs.getString("Sec_Cod"));
	 	    	sec.setSecDescrip(rs.getString("Sec_Descrip"));
	 	    	sec.setSecIdRespon(rs.getString("Sec_Id_Respon"));
	 	    	sec.setSecSecCod(rs.getString("Sec_Sec_Cod"));
	 	    	sec.setSecEstado(rs.getString("Sec_Estado"));
	 	    	seccionesResponsable.add(sec);
	 	    }
		 	rs.close();
	 	    pstmt.close();
		} catch (Exception ex) {
			System.out.println(ex);
			setErrorMessage("GestorMetricas[Lectura de BBDD]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
	}
	public void listaCategoriasGestor(Session conn, String SecCod) {
		PreparedStatement pstmt;
		try{
			String ResultadoQuery = getQuery("CategoriasGestorConAyuda");
			ResultadoQuery = ResultadoQuery.replaceAll(":SISTEMA",user.getDatosMenu().idSelected());
			ResultadoQuery = ResultadoQuery.replaceAll(":SECCION",SecCod);
			pstmt = conn.connection().prepareStatement(ResultadoQuery);
			ResultSet rs = pstmt.executeQuery();
			
		 	while (rs.next()) {
	 	    	D7Categorias cat = new D7Categorias();
	 	    	cat.setCatSisCod(rs.getString("Cat_Sis_Cod"));
	 	    	cat.setCatCod(new Integer(rs.getInt("Cat_Cod")));
	 	    	cat.setCatDescrip(rs.getString("Cat_Descrip"));
	 	    	cat.setCatEstado(rs.getString("Cat_Estado"));
	 	    	cat.setCatTipCod(rs.getString("Cat_Tip_Cod"));
	 	    	cat.setCatSecCod(rs.getString("Cat_Sec_Cod"));
	 	    	cat.setCatCatCod(new Integer(rs.getString("Cat_Cat_Cod")));
	 	    	cat.setCatTiempoEst(rs.getBigDecimal("Cat_Tiempo_Est"));
	 	    	categorias.add(cat);
	 	    }   
	 	    rs.close();
	 	    pstmt.close();
		} catch (Exception ex) {
			System.out.println(ex);
			setErrorMessage("GestorMetricas[Lectura de BBDD Usuarios]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
	}
	public void listaGrupoUsuariosGestor(Session conn) {
		PreparedStatement pstmt;
		try{
			Query q = conn.createQuery(getQuery("GruUsuGestorConAyuda"));
			q = q.setString("sist",user.getDatosMenu().idSelected());
			q = q.setString("gestor",user.getIdentificador());
			this.grupoUsuarios = (List)q.list();		
		}catch (Exception ex){
			setErrorMessage("GestorMetricas[Lectura de BBDD]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
	}
	
	/**-------------------MAESTRO-------------------*/
	public void listaSeccionesMaestroConDatos(Session conn) {
		PreparedStatement pstmt;
		
		try{
			String ResultadoQuery = getQuery("SeccionesConDatosMaestro");
			ResultadoQuery = ResultadoQuery.replaceAll(":SISTEMA",user.getDatosMenu().idSelected());
			pstmt = conn.connection().prepareStatement(ResultadoQuery);
			ResultSet rs = pstmt.executeQuery();
			
		 	while (rs.next()) {
	 	    	D7Secciones sec = new D7Secciones();
	 	    	sec.setSecSisCod(rs.getString("Sec_Sis_Cod"));
	 	    	sec.setSecCod(rs.getString("Sec_Cod"));
	 	    	sec.setSecDescrip(rs.getString("Sec_Descrip"));
	 	    	sec.setSecIdRespon(rs.getString("Sec_Id_Respon"));
	 	    	sec.setSecSecCod(rs.getString("Sec_Sec_Cod"));
	 	    	sec.setSecEstado(rs.getString("Sec_Estado"));
	 	    	secciones.add(sec);
	 	    }
		 	rs.close();
	 	    pstmt.close();
		} catch (Exception ex) {
			System.out.println(ex);
			setErrorMessage("GestorMetricas[Lectura de BBDD]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
	}
	public void listaSeccionesMaestro(Session conn){
		try{
			Query q = conn.createQuery(getQuery("SeccionesMaestroConAyuda"));
			q = q.setString("sist",user.getDatosMenu().idSelected());
			secciones  = (List)q.list();
		} catch (Exception ex) {
			setErrorMessage("GestorMetricas[Lectura de BBDD]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
	}
	public void listaAplicacionesMaestro(Session conn){
		try{
			Query q = conn.createQuery(getQuery("AplicacionesMaestroConAyuda"));
			q = q.setString("sist",user.getDatosMenu().idSelected());
			aplicaciones  = (List)q.list();
		} catch (Exception ex) {
			setErrorMessage("GestorMetricas[Lectura de BBDD]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
	}
	public void listaGrupoUsuariosMaestro(Session conn){ 
		try{
			Query q = conn.createQuery(getQuery("GruUsuMaestroConAyuda"));
			q = q.setString("sist",user.getDatosMenu().idSelected());
			grupoUsuarios  = (List)q.list();		
		}catch (Exception ex){
			setErrorMessage("GestorMetricas[Lectura de BBDD]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
	}
	public void listaCategoriasMaestro(Session conn, String SecCod) {
		PreparedStatement pstmt;
		try{
			String ResultadoQuery = getQuery("CategoriasMaestroConAyuda");
			ResultadoQuery = ResultadoQuery.replaceAll(":SISTEMA",user.getDatosMenu().idSelected());
			ResultadoQuery = ResultadoQuery.replaceAll(":SECCION",SecCod);
			pstmt = conn.connection().prepareStatement(ResultadoQuery);
			ResultSet rs = pstmt.executeQuery();
			
		 	while (rs.next()) {
	 	    	D7Categorias cat = new D7Categorias();
	 	    	cat.setCatSisCod(rs.getString("Cat_Sis_Cod"));
	 	    	cat.setCatCod(new Integer(rs.getInt("Cat_Cod")));
	 	    	cat.setCatDescrip(rs.getString("Cat_Descrip"));
	 	    	cat.setCatEstado(rs.getString("Cat_Estado"));
	 	    	cat.setCatTipCod(rs.getString("Cat_Tip_Cod"));
	 	    	cat.setCatSecCod(rs.getString("Cat_Sec_Cod"));
	 	    	cat.setCatCatCod(new Integer(rs.getString("Cat_Cat_Cod")));
	 	    	cat.setCatTiempoEst(rs.getBigDecimal("Cat_Tiempo_Est"));
	 	    	categorias.add(cat);
	 	    }   
	 	    rs.close();
	 	    pstmt.close();
		} catch (Exception ex) {
			System.out.println(ex);
			setErrorMessage("GestorMetricas[Lectura de BBDD Categorias]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
	}
	
	/** Mtodo para sustituir todos los parmetros de la query de ListaEnModoDato o ListaEnModoDatoDesglose
	* En este mtodo se elige cual de las 2 querys realizar en funcin de si se ha elegido desglose o no
	* Adems tambin se sustituyen los parmetros en funcin de si se ha introducido usuario, informatico, seccion...
	* */
	/**-------------------RESULTADOS de las mtricas para MAESTRO-------------------*/
	public void listaModoDatoMaestro(Session conn){
		PreparedStatement pstmt;
		/**String para construir la query de MAESTRO*/
		String Query ="";
		try{
			if(!Desglose.equals("con")){
				Query = getQuery("ListaGeneralEnModoDatoDesglose");
				/**Esta condicin es para que al hacer un desglose por seccin se llamen por cada seccin y aunque salgan
				 * datos a cero as despus en la pgina de salida se podr construir un arbol sino no se podra porque 
				 * podra ser inconsistente*/
				if(Desglose.equals("sec")){
					Query = Query.replaceAll(":RESTRICCIONES",")");
				}
				else{
					Query = Query.replaceAll(":RESTRICCIONES",getQuery("RestriccionDesglose"));
					Query = Query.replaceAll(":CONDICION_GESTOR","");
				}
				if(Desglose.equals("apl")){
					/**SE EST REALIZANDO UN DESGLOSE POR APLICACIN*/
					Query = Query.replaceAll(":TIPODESGLOSE","A");					
					Query = Query.replaceAll(":CAMPODESGLOSE","apl_cod");
					Query = Query.replaceAll(":TSISTDESGLOSE","apl_sis_cod = " + "'"+user.getDatosMenu().idSelected()+"'");
					Query = Query.replaceAll(":TSIST","");
					Query = Query.replaceAll(":DESCRIPDESGLOSE",",apl_descrip");
					Query = Query.replaceAll(":TABLADESGLOSE","DUMBO.D7_APLICACIONES");
					Query = Query.replaceAll(":TABLA","");
					Query = Query.replaceAll(":RESTRICTAREA","tar_apl_cod = apl_cod");
					Query= Query.replaceAll(":JOIN_RESTRICCION"," ");
				}else if(Desglose.equals("cat")){
					/**SE EST REALIZANDO UN DESGLOSE POR CATEGORA*/
					Query = Query.replaceAll(":TIPODESGLOSE","C");					
					Query = Query.replaceAll(":CAMPODESGLOSE","cat_cod");
					Query = Query.replaceAll(":TSISTDESGLOSE","cat_sis_cod = " + "'"+user.getDatosMenu().idSelected()+"'");
					Query = Query.replaceAll(":TSIST","");
					Query = Query.replaceAll(":DESCRIPDESGLOSE",",cat_descrip");
					Query = Query.replaceAll(":RESTRICTAREA","tar_cat_cod = cat_cod");
					Query = Query.replaceAll(":TABLADESGLOSE","DUMBO.D7_CATEGORIAS");
					Query = Query.replaceAll(":TABLA","");
					Query = Query.replaceAll(":JOIN_RESTRICCION"," ");
					}else if(Desglose.equals("usu")){
						/**SE EST REALIZANDO UN DESGLOSE POR USUARIO*/
						Query = Query.replaceAll(":TIPODESGLOSE","U");					
						Query = Query.replaceAll(":CAMPODESGLOSE","decode(dat_identificador,'EXTERNO',dat_email,dat_identificador)");
						Query = Query.replaceAll(":TSISTDESGLOSE","'NULL'='NULL'");
						Query = Query.replaceAll(":TSIST","");
						Query = Query.replaceAll(":DESCRIPDESGLOSE",",decode(dat_identificador,'EXTERNO',dat_nombre||' '||dat_apellidos||'('||dat_email||')',dat_apellidos||','||dat_nombre)");
						Query = Query.replaceAll(":RESTRICTAREA","decode(dat_identificador,'EXTERNO',dat_email,dat_identificador) = decode(tar_usu_cod,'EXTERNO',tar_email_copia,tar_usu_cod)");
						Query = Query.replaceAll(":TABLADESGLOSE","DUMBO.D7_EXTERNO_DATOS_PERSONALES");
						Query = Query.replaceAll(":TABLA","");
						Query = Query.replaceAll(":JOIN_RESTRICCION"," ");
						}else if(Desglose.equals("inf")){
							/**SE EST REALIZANDO UN DESGLOSE POR INFORMTICO*/
							Query = Query.replaceAll(":TIPODESGLOSE","I");					
							Query = Query.replaceAll(":CAMPODESGLOSE","dat_identificador");
							Query = Query.replaceAll(":TSISTDESGLOSE","'MET' = 'MET'");
							Query = Query.replaceAll(":TSIST","AND inf_sis_cod = " + "'"+user.getDatosMenu().idSelected()+"'");
							Query = Query.replaceAll(":DESCRIPDESGLOSE",",dat_apellidos||','||dat_nombre");
							Query = Query.replaceAll(":RESTRICTAREA","tar_inf_cod = inf_cod");
							Query = Query.replaceAll(":TABLADESGLOSE","DUMBO.D7_DATOS_PERSONALES");
							Query = Query.replaceAll(":TABLA",",DUMBO.D7_INFORMATICOS");
							Query = Query.replaceAll(":JOIN_RESTRICCION","AND inf_cod=dat_identificador");
						}else if(Desglose.equals("gusu")){
							/**SE EST REALIZANDO UN DESGLOSE POR GRUPO DE USUARIOS*/
							Query = Query.replaceAll(":TIPODESGLOSE","G");					
							Query = Query.replaceAll(":CAMPODESGLOSE","gru_cod");
							Query = Query.replaceAll(":TSISTDESGLOSE"," gru_sis_cod = " + "'"+user.getDatosMenu().idSelected()+"'");
							Query = Query.replaceAll(":TSIST","AND ugr_sis_cod = " + "'"+user.getDatosMenu().idSelected()+"'");
							Query = Query.replaceAll(":DESCRIPDESGLOSE",",gru_descrip");
							Query = Query.replaceAll(":RESTRICTAREA","tar_usu_cod = ugr_usu_cod");
							Query = Query.replaceAll(":TABLADESGLOSE","DUMBO.D7_GRUPOS_USUARIOS");
							Query = Query.replaceAll(":TABLA",",DUMBO.D7_USUARIOS_GRUPOS");
							Query = Query.replaceAll(":JOIN_RESTRICCION","AND gru_cod=ugr_gru_cod ");
							}else if(Desglose.equals("sec")){
								/**SE EST REALIZANDO UN DESGLOSE POR SECCIN(teniendo en cuenta que la salida tendr un arbol para mostrar jerarqua) */
								Query = Query.replaceAll(":TIPODESGLOSE","S");					
								Query = Query.replaceAll(":CAMPODESGLOSE","sec_cod");
								Query = Query.replaceAll(":TSISTDESGLOSE","sec_sis_cod = " + "'"+user.getDatosMenu().idSelected()+"'");
								Query = Query.replaceAll(":TSIST","");
								Query = Query.replaceAll(":DESCRIPDESGLOSE",",sec_descrip");
								Query = Query.replaceAll(":RESTRICTAREA","'NULL' = 'NULL'");
								Query = Query.replaceAll(":TABLADESGLOSE"," DUMBO.D7_SECCIONES");
								Query = Query.replaceAll(":TABLA","");
								Query = Query.replaceAll(":JOIN_RESTRICCION","");
								}
			}
			else{
				/**NO SE HA APLICADO DESGLOSE A LA METRICA*/
				Query = getQuery("ListaGeneralEnModoDato");
			}
						
			/**Construimos la query dependiendo del PERIODO introducido si no hay inicio = "DesdeInicio de tiempos"; si no hay fin = "HastaFin de tiempos*/
			if(!(this.FechaDesde.equals("DD/MM/AAAA")) & !(this.FechaHasta.equals("DD/MM/AAAA"))){
				Query = Query.replaceAll(":FINICIO",this.FechaDesde);
				Query = Query.replaceAll(":FFIN",this.FechaHasta);
			}else if(this.FechaDesde.equals("DD/MM/AAAA") & !(this.FechaHasta.equals("DD/MM/AAAA"))){
				Query = Query.replaceAll("':FINICIO'","NULL");
				Query = Query.replaceAll(":FFIN",this.FechaHasta);
				}else if(!(this.FechaDesde.equals("DD/MM/AAAA")) & this.FechaHasta.equals("DD/MM/AAAA")){
					Query = Query.replaceAll(":FINICIO",this.FechaDesde);
					Query = Query.replaceAll("':FFIN'","NULL");
					}else{
						Query = Query.replaceAll("':FINICIO'","NULL");
						Query = Query.replaceAll("':FFIN'","NULL");
						}
					 
				/**Si se introduce una APLICACIN por la que filtrar, sino el parmetro aplicacin ser NULL*/
			if(!this.Aplicacion.equals("")){Query = Query.replaceAll(":APL",this.Aplicacion);}
			else{Query = Query.replaceAll("':APL'","NULL");}
			
			/**Si se introduce una CATEGORA por la que filtrar, sino el parmetro categora ser NULL*/
			if(!this.Categoria.equals("")){Query = Query.replaceAll(":CAT",this.Categoria);}
			else{Query = Query.replaceAll("':CAT'","NULL");}
			
			/**Si se introduce un INFORMTICO por el que filtrar*/
			if(!this.Informatico.equals("")){Query = Query.replaceAll(":INF",this.Informatico);}
			else{Query = Query.replaceAll("':INF'","NULL");}
			
			/**Si se introduce un GRUPO DE USUARIOS por el que filtrar, sino el parmetro grupo de usuarios ser NULL*/
			if(!this.GrupoUsuarios.equals("")){Query = Query.replaceAll(":GRUSU",this.GrupoUsuarios);}
			else{Query = Query.replaceAll("':GRUSU'","NULL");}
			
			/**Si se introduce una SECCIN por la que filtrar, sino el parmetro seccin ser NULL*/
			if(!this.Seccion.equals("")){Query = Query.replaceAll(":SEC",this.Seccion);}
			else{Query = Query.replaceAll("':SEC'","NULL");}
			
			/**Si se introduce un USUARIO por el que filtrar, sino el parmetro usuario ser NULL*/
			if(!this.Usuario.equals("")){Query = Query.replaceAll(":USU",this.Usuario);}
			else{Query = Query.replaceAll("':USU'","NULL");}
			
			/**Sustitucin de ESTADOS*/
			Query = Query.replaceAll(":SOLICITADA","NULL");
			Query = Query.replaceAll(":FINALIZADA",D7Tareas.FINALIZADA);
			Query = Query.replaceAll(":ANULADA",D7Tareas.ANULADA);
			Query = Query.replaceAll(":EN_ESPERA",D7Tareas.EN_ESPERA);
			Query = Query.replaceAll(":RECHAZADA",D7Tareas.RECHAZADA);
			
			/**Sustitucin de TIPOS TAREAS*/
			Query = Query.replaceAll(":PETICION",D7TiposTareas.PETICION);
			Query = Query.replaceAll(":INCIDENCIA",D7TiposTareas.INCIDENCIA);
						
			/**Estado de Tarea = FINALIZADA*/
			Query = Query.replaceAll(":FINALIZADA",D7Tareas.FINALIZADA);
			
			/**SISTEMA*/
			Query = Query.replaceAll(":SISTEMA",user.getDatosMenu().idSelected());
						
			/**El parmetro GESTOR se pone a NULL puesto que nos encontramos en MAESTRO*/
			Query = Query.replaceAll("':GESTOR'","NULL");

			/**Inicio de la cuenta para la medicin del tiempo de ejecucin de la METRICA*/
			java.util.Date FechaInicio = new java.util.Date();
			int MinutosI = FechaInicio.getMinutes();
			int SegundosI = FechaInicio.getSeconds();
			
			pstmt = conn.connection().prepareStatement(Query);
			ResultSet rs = pstmt.executeQuery();
		 	while (rs.next()) {
	 	    	Metricas M = new Metricas();
	 	    	M.setTramo(rs.getString(1));
	 	    	M.setIncidencias(new Integer(rs.getInt(2)));
	 	    	M.setPeticiones(new Integer(rs.getInt(3)));
	 	       	/**Dependiendo de si hay desglose o no lo mapeo en la mtrica*/
	 	    	if(!Desglose.equals("con")){
	 	    		M.setDesglose(rs.getString(4));
	 	    	}
	 	    	this.resultadoMetricas.add(M);
	 	    }   
	 	    rs.close();
	 	    pstmt.close();
	 	    
	 	    /**FIN de la cuenta para la medicin del tiempo de ejecucin de la METRICA*/
	 	    java.util.Date FechaFin = new java.util.Date();
			int MinutosF = FechaFin.getMinutes();
			int SegundosF = FechaFin.getSeconds();
			/**Tenemos en cuenta si se ha cambiado de minuto mientras se realiza la mtrica*/
			if (SegundosI > SegundosF){
				SegundosF = 60 + SegundosF;
				MinutosF = MinutosF - 1;
			}
	 	    setErrorMessage("La mtica se ha realizado en: "+ new Integer(Math.abs(MinutosF-MinutosI)).toString() + " min. y " +new Integer(Math.abs(SegundosF-SegundosI)).toString() + " seg.");
	 	    
	 	    } catch (Exception ex) {
			System.out.println(ex);
			setErrorMessage("LISTADO Maestro:"+ex.toString().substring(0,ex.toString().length()-1));
		}
	}
	
	/**-------------------RESULTADOS de las mtricas para GESTOR-------------------*/
	public void listaModoDatoGestor(Session conn){
		PreparedStatement pstmt;
		/**String para construir la query de GESTOR*/
		String Query ="";
		try{
			if(!Desglose.equals("con")){
				Query = getQuery("ListaGeneralEnModoDatoDesglose");
				/**Esta condicin es para que al hacer un desglose por seccin se llamen por cada seccin y aunque salgan
				 * datos a cero as despus en la pgina de salida se podr construir un arbol sino no se podra porque 
				 * podra ser inconsistente*/
				if(Desglose.equals("sec")){
					Query = Query.replaceAll(":RESTRICCIONES",")");
				}
				else{
					Query = Query.replaceAll(":RESTRICCIONES",getQuery("RestriccionDesglose"));
					Query = Query.replaceAll(":CONDICION_GESTOR",getQuery("CondicionGestor"));
				}
				if(Desglose.equals("apl")){
					/**SE EST REALIZANDO UN DESGLOSE POR APLICACIN*/
					Query = Query.replaceAll(":TIPODESGLOSE","A");					
					Query = Query.replaceAll(":CAMPODESGLOSE","apl_cod");
					Query = Query.replaceAll(":TSISTDESGLOSE","apl_sis_cod = " + "'"+user.getDatosMenu().idSelected()+"'");
					Query = Query.replaceAll(":TSIST","");
					Query = Query.replaceAll(":DESCRIPDESGLOSE",",apl_descrip");
					Query = Query.replaceAll(":TABLADESGLOSE","DUMBO.D7_APLICACIONES");
					Query = Query.replaceAll(":TABLA","");
					Query = Query.replaceAll(":RESTRICTAREA","tar_apl_cod = apl_cod");
					Query= Query.replaceAll(":JOIN_RESTRICCION"," ");
				}else if(Desglose.equals("cat")){
					/**SE EST REALIZANDO UN DESGLOSE POR CATEGORA*/
					Query = Query.replaceAll(":TIPODESGLOSE","C");					
					Query = Query.replaceAll(":CAMPODESGLOSE","cat_cod");
					Query = Query.replaceAll(":TSISTDESGLOSE","cat_sis_cod = " + "'"+user.getDatosMenu().idSelected()+"'");
					Query = Query.replaceAll(":TSIST","");
					Query = Query.replaceAll(":DESCRIPDESGLOSE",",cat_descrip");
					Query = Query.replaceAll(":RESTRICTAREA","tar_cat_cod = cat_cod");
					Query = Query.replaceAll(":TABLADESGLOSE","DUMBO.D7_CATEGORIAS");
					Query = Query.replaceAll(":TABLA","");
					Query = Query.replaceAll(":JOIN_RESTRICCION"," ");
					}else if(Desglose.equals("usu")){
						/**SE EST REALIZANDO UN DESGLOSE POR USUARIO*/
						Query = Query.replaceAll(":TIPODESGLOSE","U");					
						Query = Query.replaceAll(":CAMPODESGLOSE","decode(dat_identificador,'EXTERNO',dat_email,dat_identificador)");
						Query = Query.replaceAll(":TSISTDESGLOSE","'NULL'='NULL'");
						Query = Query.replaceAll(":TSIST","");
						Query = Query.replaceAll(":DESCRIPDESGLOSE",",decode(dat_identificador,'EXTERNO',dat_nombre||' '||dat_apellidos||'('||dat_email||')',dat_apellidos||','||dat_nombre)");
						Query = Query.replaceAll(":RESTRICTAREA","decode(dat_identificador,'EXTERNO',dat_email,dat_identificador) = decode(tar_usu_cod,'EXTERNO',tar_email_copia,tar_usu_cod)");
						Query = Query.replaceAll(":TABLADESGLOSE","DUMBO.D7_EXTERNO_DATOS_PERSONALES");
						Query = Query.replaceAll(":TABLA","");
						Query = Query.replaceAll(":JOIN_RESTRICCION"," ");
						}else if(Desglose.equals("inf")){
							/**SE EST REALIZANDO UN DESGLOSE POR INFORMTICO*/
							Query = Query.replaceAll(":TIPODESGLOSE","I");					
							Query = Query.replaceAll(":CAMPODESGLOSE","dat_identificador");
							Query = Query.replaceAll(":TSISTDESGLOSE","'MET' = 'MET'");
							Query = Query.replaceAll(":TSIST","AND inf_sis_cod = " + "'"+user.getDatosMenu().idSelected()+"'");
							Query = Query.replaceAll(":DESCRIPDESGLOSE",",dat_apellidos||','||dat_nombre");
							Query = Query.replaceAll(":RESTRICTAREA","tar_inf_cod = inf_cod");
							Query = Query.replaceAll(":TABLADESGLOSE","DUMBO.D7_DATOS_PERSONALES");
							Query = Query.replaceAll(":TABLA",",DUMBO.D7_INFORMATICOS");
							Query = Query.replaceAll(":JOIN_RESTRICCION","AND inf_cod=dat_identificador");
						}else if(Desglose.equals("gusu")){
							/**SE EST REALIZANDO UN DESGLOSE POR GRUPO DE USUARIOS*/
							Query = Query.replaceAll(":TIPODESGLOSE","G");					
							Query = Query.replaceAll(":CAMPODESGLOSE","gru_cod");
							Query = Query.replaceAll(":TSISTDESGLOSE"," gru_sis_cod = " + "'"+user.getDatosMenu().idSelected()+"'");
							Query = Query.replaceAll(":TSIST","AND ugr_sis_cod = " + "'"+user.getDatosMenu().idSelected()+"'");
							Query = Query.replaceAll(":DESCRIPDESGLOSE",",gru_descrip");
							Query = Query.replaceAll(":RESTRICTAREA","tar_usu_cod = ugr_usu_cod");
							Query = Query.replaceAll(":TABLADESGLOSE","DUMBO.D7_GRUPOS_USUARIOS");
							Query = Query.replaceAll(":TABLA",",DUMBO.D7_USUARIOS_GRUPOS");
							Query = Query.replaceAll(":JOIN_RESTRICCION","AND gru_cod=ugr_gru_cod ");
							}else if(Desglose.equals("sec")){
								/**SE EST REALIZANDO UN DESGLOSE POR SECCIN(teniendo en cuenta que la salida tendr un arbol para mostrar jerarqua) */
								Query = Query.replaceAll(":TIPODESGLOSE","S");					
								Query = Query.replaceAll(":CAMPODESGLOSE","sec_cod");
								Query = Query.replaceAll(":TSISTDESGLOSE","sec_sis_cod = " + "'"+user.getDatosMenu().idSelected()+"'");
								Query = Query.replaceAll(":TSIST","");
								Query = Query.replaceAll(":DESCRIPDESGLOSE",",sec_descrip");
								Query = Query.replaceAll(":RESTRICTAREA","'NULL' = 'NULL'");
								Query = Query.replaceAll(":TABLADESGLOSE"," DUMBO.D7_SECCIONES");
								Query = Query.replaceAll(":TABLA","");
								Query = Query.replaceAll(":JOIN_RESTRICCION","");
								}
			}
			else{
				/**NO SE HA APLICADO DESGLOSE A LA METRICA*/
				Query = getQuery("ListaGeneralEnModoDato");
			}
					
			/**Construimos la query dependiendo del PERIODO introducido si no hay inicio = "DesdeInicio de tiempos"; si no hay fin = "HastaFin de tiempos*/
			if(!(this.FechaDesde.equals("DD/MM/AAAA")) & !(this.FechaHasta.equals("DD/MM/AAAA"))){
				Query = Query.replaceAll(":FINICIO",this.FechaDesde);
				Query = Query.replaceAll(":FFIN",this.FechaHasta);
			}else if(this.FechaDesde.equals("DD/MM/AAAA") & !(this.FechaHasta.equals("DD/MM/AAAA"))){
				Query = Query.replaceAll("':FINICIO'","NULL");
				Query = Query.replaceAll(":FFIN",this.FechaHasta);
				}else if(!(this.FechaDesde.equals("DD/MM/AAAA")) & this.FechaHasta.equals("DD/MM/AAAA")){
					Query = Query.replaceAll(":FINICIO",this.FechaDesde);
					Query = Query.replaceAll("':FFIN'","NULL");
					}else{
						Query = Query.replaceAll("':FINICIO'","NULL");
						Query = Query.replaceAll("':FFIN'","NULL");
						}
					 
			/**Si se introduce una APLICACIN por la que filtrar, sino el parmetro aplicacin ser NULL*/
			if(!this.Aplicacion.equals("")){Query = Query.replaceAll(":APL",this.Aplicacion);}
			else{Query = Query.replaceAll("':APL'","NULL");}
			
			/**Si se introduce una CATEGORA por la que filtrar, sino el parmetro categora ser NULL*/
			if(!this.Categoria.equals("")){Query = Query.replaceAll(":CAT",this.Categoria);}
			else{Query = Query.replaceAll("':CAT'","NULL");}
			
			/**Si se introduce un INFORMTICO por el que filtrar, sino el parmetro informtico ser NULL*/
			if(!this.Informatico.equals("")){Query = Query.replaceAll(":INF",this.Informatico);}
			else{Query = Query.replaceAll("':INF'","NULL");}
			
			/**Si se introduce un GRUPO DE USUARIOS por el que filtrar, sino el parmetro grupo de usuarios ser NULL*/
			if(!this.GrupoUsuarios.equals("")){Query = Query.replaceAll(":GRUSU",this.GrupoUsuarios);}
			else{Query = Query.replaceAll("':GRUSU'","NULL");}
			
			/**Si se introduce una SECCIN por la que filtrar, sino el parmetro seccin ser NULL*/
			if(!this.Seccion.equals("")){Query = Query.replaceAll(":SEC",this.Seccion);}
			else{Query = Query.replaceAll("':SEC'","NULL");}
			
			/**Si se introduce un USUARIO por el que filtrar, sino el parmetro usuario ser NULL*/
			if(!this.Usuario.equals("")){Query = Query.replaceAll(":USU",this.Usuario);}
			else{Query = Query.replaceAll("':USU'","NULL");}
			
			/**Sustitucin de ESTADOS*/
			Query = Query.replaceAll(":SOLICITADA","NULL");
			Query = Query.replaceAll(":FINALIZADA",D7Tareas.FINALIZADA);
			Query = Query.replaceAll(":ANULADA",D7Tareas.ANULADA);
			Query = Query.replaceAll(":EN_ESPERA",D7Tareas.EN_ESPERA);
			Query = Query.replaceAll(":RECHAZADA",D7Tareas.RECHAZADA);
			/**Sustitucin de TIPOS TAREAS*/
			Query = Query.replaceAll(":PETICION",D7TiposTareas.PETICION);
			Query = Query.replaceAll(":INCIDENCIA",D7TiposTareas.INCIDENCIA);
			
			/**Estado de Tarea = FINALIZADA*/
			Query = Query.replaceAll(":FINALIZADA",D7Tareas.FINALIZADA);
						
			/**SISTEMA*/
			Query = Query.replaceAll(":SISTEMA",user.getDatosMenu().idSelected());
						
			/**En este caso se reemplaza en parmetro GESTOR puesto que hay un restriccin ms en las querys*/
			Query = Query.replaceAll(":GESTOR",user.getIdentificador());

			/**Inicio de la cuenta para la medicin del tiempo de ejecucin de la METRICA*/
			java.util.Date FechaInicio = new java.util.Date();
			int MinutosI = FechaInicio.getMinutes();
			int SegundosI = FechaInicio.getSeconds();
			
			pstmt = conn.connection().prepareStatement(Query);
			ResultSet rs = pstmt.executeQuery();
		 	while (rs.next()) {
	 	    	Metricas M = new Metricas();
	 	    	M.setTramo(rs.getString(1));
	 	    	M.setIncidencias(new Integer(rs.getInt(2)));
	 	    	M.setPeticiones(new Integer(rs.getInt(3)));
	 	       	//Dependiendo de si hay desglose o no lo mapeo en la mtrica
	 	    	if(!Desglose.equals("con")){
	 	    		M.setDesglose(rs.getString(4));
	 	    	}
	 	    	this.resultadoMetricas.add(M);
	 	    }   
	 	    rs.close();
	 	    pstmt.close();
	 	    
	 	    /**FIN de la cuenta para la medicin del tiempo de ejecucin de la METRICA*/
	 	    java.util.Date FechaFin = new java.util.Date();
			int MinutosF = FechaFin.getMinutes();
			int SegundosF = FechaFin.getSeconds();
			/**Tenemos en cuenta si se ha cambiado de minuto mientras se realiza la mtrica*/
			if (SegundosI > SegundosF){
				SegundosF = 60 + SegundosF;
				MinutosF = MinutosF - 1;
			}
	 	    setErrorMessage("La mtica se ha realizado en: "+ new Integer(Math.abs(MinutosF-MinutosI)).toString() + " min. y " +new Integer(Math.abs(SegundosF-SegundosI)).toString() + " seg.");
	 	    
	 	    } catch (Exception ex) {
			System.out.println(ex);
			setErrorMessage("LISTADO Gestor:"+ex.toString().substring(0,ex.toString().length()-1));
		}
	}

	/**-------------------RESULTADOS de las mtricas para INFORMATICO-------------------*/
	public void listaModoDatoInformatico(Session conn){
		PreparedStatement pstmt;
		/**String para construir la query de INFORMTICO*/
		String Query ="";
		try{
			if(!Desglose.equals("con")){
				Query = getQuery("ListaGeneralEnModoDatoDesglose");
				Query = Query.replaceAll(":RESTRICCIONES",getQuery("RestriccionDesglose"));
				Query = Query.replaceAll(":CONDICION_GESTOR","");
				if(Desglose.equals("apl")){
					/**SE EST REALIZANDO UN DESGLOSE POR APLICACIN*/
					Query = Query.replaceAll(":TIPODESGLOSE","A");					
					Query = Query.replaceAll(":CAMPODESGLOSE","apl_cod");
					Query = Query.replaceAll(":TSISTDESGLOSE","apl_sis_cod = " + "'"+user.getDatosMenu().idSelected()+"'");
					Query = Query.replaceAll(":TSIST","");
					Query = Query.replaceAll(":DESCRIPDESGLOSE",",apl_descrip");
					Query = Query.replaceAll(":TABLADESGLOSE","DUMBO.D7_APLICACIONES");
					Query = Query.replaceAll(":TABLA","");
					Query = Query.replaceAll(":RESTRICTAREA","tar_apl_cod = apl_cod");
					Query= Query.replaceAll(":JOIN_RESTRICCION"," ");
				}else if(Desglose.equals("cat")){
					/**SE EST REALIZANDO UN DESGLOSE POR CATEGORA*/
					Query = Query.replaceAll(":TIPODESGLOSE","C");					
					Query = Query.replaceAll(":CAMPODESGLOSE","cat_cod");
					Query = Query.replaceAll(":TSISTDESGLOSE","cat_sis_cod = " + "'"+user.getDatosMenu().idSelected()+"'");
					Query = Query.replaceAll(":TSIST","");
					Query = Query.replaceAll(":DESCRIPDESGLOSE",",cat_descrip");
					Query = Query.replaceAll(":RESTRICTAREA","tar_cat_cod = cat_cod");
					Query = Query.replaceAll(":TABLADESGLOSE","DUMBO.D7_CATEGORIAS");
					Query = Query.replaceAll(":TABLA","");
					Query = Query.replaceAll(":JOIN_RESTRICCION"," ");
					}else if(Desglose.equals("usu")){
						/**SE EST REALIZANDO UN DESGLOSE POR USUARIO*/
						Query = Query.replaceAll(":TIPODESGLOSE","U");					
						Query = Query.replaceAll(":CAMPODESGLOSE","decode(dat_identificador,'EXTERNO',dat_email,dat_identificador)");
						Query = Query.replaceAll(":TSISTDESGLOSE","'NULL'='NULL'");
						Query = Query.replaceAll(":TSIST","");
						Query = Query.replaceAll(":DESCRIPDESGLOSE",",decode(dat_identificador,'EXTERNO',dat_nombre||' '||dat_apellidos||'('||dat_email||')',dat_apellidos||','||dat_nombre)");
						Query = Query.replaceAll(":RESTRICTAREA","decode(dat_identificador,'EXTERNO',dat_email,dat_identificador) = decode(tar_usu_cod,'EXTERNO',tar_email_copia,tar_usu_cod)");
						Query = Query.replaceAll(":TABLADESGLOSE","DUMBO.D7_EXTERNO_DATOS_PERSONALES");
						Query = Query.replaceAll(":TABLA","");
						Query = Query.replaceAll(":JOIN_RESTRICCION"," ");
						}else if(Desglose.equals("gusu")){
							/**SE EST REALIZANDO UN DESGLOSE POR GRUPO DE USUARIOS*/
							Query = Query.replaceAll(":TIPODESGLOSE","G");					
							Query = Query.replaceAll(":CAMPODESGLOSE","gru_cod");
							Query = Query.replaceAll(":TSISTDESGLOSE"," gru_sis_cod = " + "'"+user.getDatosMenu().idSelected()+"'");
							Query = Query.replaceAll(":TSIST","AND ugr_sis_cod = " + "'"+user.getDatosMenu().idSelected()+"'");
							Query = Query.replaceAll(":DESCRIPDESGLOSE",",gru_descrip");
							Query = Query.replaceAll(":RESTRICTAREA","tar_usu_cod = ugr_usu_cod");
							Query = Query.replaceAll(":TABLADESGLOSE","DUMBO.D7_GRUPOS_USUARIOS");
							Query = Query.replaceAll(":TABLA",",DUMBO.D7_USUARIOS_GRUPOS");
							Query = Query.replaceAll(":JOIN_RESTRICCION","AND gru_cod=ugr_gru_cod ");
							}
			}
			else{
				/**NO SE HA APLICADO DESGLOSE A LA METRICA*/
				Query = getQuery("ListaGeneralEnModoDato");
			}
						
			/**Construimos la query dependiendo del PERIODO introducido si no hay inicio = "DesdeInicio de tiempos"; si no hay fin = "HastaFin de tiempos*/
			if(!(this.FechaDesde.equals("DD/MM/AAAA")) & !(this.FechaHasta.equals("DD/MM/AAAA"))){
				Query = Query.replaceAll(":FINICIO",this.FechaDesde);
				Query = Query.replaceAll(":FFIN",this.FechaHasta);
			}else if(this.FechaDesde.equals("DD/MM/AAAA") & !(this.FechaHasta.equals("DD/MM/AAAA"))){
				Query = Query.replaceAll("':FINICIO'","NULL");
				Query = Query.replaceAll(":FFIN",this.FechaHasta);
				}else if(!(this.FechaDesde.equals("DD/MM/AAAA")) & this.FechaHasta.equals("DD/MM/AAAA")){
					Query = Query.replaceAll(":FINICIO",this.FechaDesde);
					Query = Query.replaceAll("':FFIN'","NULL");
					}else{
						Query = Query.replaceAll("':FINICIO'","NULL");
						Query = Query.replaceAll("':FFIN'","NULL");
						}
					 
			/**Si se introduce una APLICACIN por la que filtrar*/
			if(!this.Aplicacion.equals("")){Query = Query.replaceAll(":APL",this.Aplicacion);}
			else{Query = Query.replaceAll("':APL'","NULL");}
			
			/**Si se introduce una CATEGORA por la que filtrar*/
			if(!this.Categoria.equals("")){Query = Query.replaceAll(":CAT",this.Categoria);}
			else{Query = Query.replaceAll("':CAT'","NULL");}
						
			/**Si se introduce un USUARIO por el que filtrar*/
			if(!this.Usuario.equals("")){Query = Query.replaceAll(":USU",this.Usuario);}
			else{Query = Query.replaceAll("':USU'","NULL");}
			
			/**Si se introduce un GRUPO DE USUARIOS por el que filtrar*/
			if(!this.GrupoUsuarios.equals("")){Query = Query.replaceAll(":GRUSU",this.GrupoUsuarios);}
			else{Query = Query.replaceAll("':GRUSU'","NULL");}
			
			/**Un Informtico no puede realizar filtros en funcin de una determinada SECCION*/
			Query = Query.replaceAll("':SEC'","NULL");
						
			/**ESTADOS*/
			Query = Query.replaceAll(":SOLICITADA","NULL");
			Query = Query.replaceAll(":FINALIZADA",D7Tareas.FINALIZADA);
			Query = Query.replaceAll(":ANULADA",D7Tareas.ANULADA);
			Query = Query.replaceAll(":EN_ESPERA",D7Tareas.EN_ESPERA);
			Query = Query.replaceAll(":RECHAZADA",D7Tareas.RECHAZADA);
			/**TIPOS TAREAS*/
			Query = Query.replaceAll(":PETICION",D7TiposTareas.PETICION);
			Query = Query.replaceAll(":INCIDENCIA",D7TiposTareas.INCIDENCIA);
						
			/**El informtico siempre ser el que realiza la Mtrica, por lo tanto GESTOR = NULL*/
			Query = Query.replaceAll(":INF",user.getIdentificador());
			Query = Query.replaceAll("':GESTOR'","NULL");
						
			Query = Query.replaceAll(":SISTEMA",user.getDatosMenu().idSelected());

			/**Inicio de la cuenta para la medicin del tiempo de ejecucin de la METRICA*/
			java.util.Date FechaInicio = new java.util.Date();
			int MinutosI = FechaInicio.getMinutes();
			int SegundosI = FechaInicio.getSeconds();
			
			pstmt = conn.connection().prepareStatement(Query);
			ResultSet rs = pstmt.executeQuery();
			while (rs.next()) {
	 	    	Metricas M = new Metricas();
	 	    	M.setTramo(rs.getString(1));
	 	    	M.setIncidencias(new Integer(rs.getInt(2)));
	 	    	M.setPeticiones(new Integer(rs.getInt(3)));
	 	       	/**Dependiendo de si hay desglose o no lo mapeo en la mtrica*/
	 	    	if(!Desglose.equals("con")){
	 	    		M.setDesglose(rs.getString(4));
	 	    	}
	 	    	this.resultadoMetricas.add(M);
	 	    }   
	 	    rs.close();
	 	    pstmt.close();
		 	
	 	    /**FIN de la cuenta para la medicin del tiempo de ejecucin de la METRICA*/
	 	    java.util.Date FechaFin = new java.util.Date();
			int MinutosF = FechaFin.getMinutes();
			int SegundosF = FechaFin.getSeconds();
			/**Tenemos en cuenta si se ha cambiado de minuto mientras se realiza la mtrica*/
			if (SegundosI > SegundosF){
				SegundosF = 60 + SegundosF;
				MinutosF = MinutosF - 1;
			}
	 	    setErrorMessage("La mtica se ha realizado en: "+ new Integer(Math.abs(MinutosF-MinutosI)).toString() + " min. y " +new Integer(Math.abs(SegundosF-SegundosI)).toString() + " seg.");
	 	    
	 	    }catch (Exception ex) {
			System.out.println(ex);
			setErrorMessage("LISTADO Informtico:"+ex.toString().substring(0,ex.toString().length()-1));
		}
	}
}

