<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet version="1.0" 
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:svg="http://www.w3.org/200/svg">
	
<xsl:param name="servlet"/>	
<xsl:param name="menu"/>
<xsl:param name="inicio"/>
<xsl:param name="fin"/>
<xsl:param name="UsuCod"/>
<xsl:param name="InfCod"/>
<xsl:param name="SecCod"/>
<xsl:param name="CatCod"/>
<xsl:param name="GruCod"/>
<xsl:param name="AplCod"/>
<xsl:param name="desgloseSel"/>
<xsl:param name="FechaDesde"/>
<xsl:param name="FechaHasta"/>
<xsl:variable name="desglose"/>

<xsl:include href="dumbo7/utils/xsl/utils.xsl"/>
<xsl:template match="XMLROOT">
	
	<html lang="es">
		<TITLE>DUMBO7: Resultado Mtrica 'Tareas Segn Estado'</TITLE>
		
		
    <xsl:call-template name="headComun">
         <xsl:with-param name="jscript">
            <SCRIPT LANGUAGE="JavaScript">
				function mostarError(error){
					alert(error);
				}
			</SCRIPT>
         </xsl:with-param>
	</xsl:call-template>
	<body>

			
		<xsl:for-each select="DATA/METRICAS">
			<xsl:if test="not(@ERROR='')">
				<script>mostarError('<xsl:value-of select="@ERROR"/>')</script>
				</xsl:if>
		</xsl:for-each>

	<table border="0" align="center" cellpadding="3" cellspacing="1" width="750" summary="Esta tabla contiene las mtricas de tareas segn DEDICACION (para nivel de Maestro)">
	<tr><td colspan="2">
		<form action="{$servlet}" METHOD="POST" name="metricas">
		<input type="hidden" name="module"/>
		<table class="cont" id="metricas" border="0" cellpadding="3" cellspacing="1" width="100%" summary="Esta tabla contiene las mtricas">
		<tr class="cab1">
			<td colspan="2">&#187;Resultado grfico: Tareas segn estado (Maestro)</td>
			<td width="10" align="center"><b><a href="javascript:window.print()"><img border="0" src="../graficos/iconos/ico_impresora.gif" alt="Imprimir"/></a></b></td>
			<td width="10" align="center"><b><a href="javascript:window.close()">Cerrar</a></b></td>
		</tr>
		<tr class="cabe">
			<td width="140"><b>Periodo</b></td>
			<td width="350"><b>Parmetros</b></td>
			<td colspan="2"></td>
		</tr>
		
		<tr class="administracion">
			<td width="90"><b>Desde:</b>&#160;&#160;<i>
				 <xsl:value-of select="$FechaDesde"/>
			</i></td>
			<td width="350" colspan="3">
				<b>Aplicacin:&#160;</b>
				<xsl:if test="$AplCod != ''">
					<xsl:if test="$AplCod != ''">
					<!--Si la descripcin tiene menos de 30 caracteres-->
					<xsl:if test="30>string-length(DATA/METRICAS/APLICACION/@DESCRIPCION)">								
						<i><xsl:value-of select="DATA/METRICAS/APLICACION/@DESCRIPCION"/></i>
					</xsl:if>
					<!--Si la descripcin tiene ms de 30 caracteres-->
					<xsl:if test="string-length(DATA/METRICAS/APLICACION/@DESCRIPCION)>30">
						<xsl:value-of select="concat(substring(DATA/METRICAS/APLICACION/@DESCRIPCION,0,30),'...')"/>
					</xsl:if>
				</xsl:if>	
				</xsl:if>
				<xsl:if test="$AplCod = ''">
					<i>TODAS</i>	
				</xsl:if>
			</td>
		</tr>
		<tr class="administracion">
			<td width="90"><b>Hasta:</b>&#160;&#160;<i>
				<xsl:value-of select="$FechaHasta"/>
			</i></td>
			<td width="350" colspan="3">
				<b>Seccion:&#160;</b>
				<xsl:if test="$SecCod != ''">
					<!--Si la descripcin tiene menos de 30 caracteres-->
					<xsl:if test="30>string-length(DATA/METRICAS/SECCION/@DESCRIPCION)">								
						<i><xsl:value-of select="DATA/METRICAS/SECCION/@DESCRIPCION"/></i>
					</xsl:if>
					<!--Si la descripcin tiene ms de 30 caracteres-->
					<xsl:if test="string-length(DATA/METRICAS/SECCION/@DESCRIPCION)>30">
						<xsl:value-of select="concat(substring(DATA/METRICAS/SECCION/@DESCRIPCION,0,30),'...')"/>
					</xsl:if>	
				</xsl:if>
				<xsl:if test="$SecCod = ''">
					<i>TODAS</i>	
				</xsl:if>
			</td>
		</tr>
		<tr class="administracion">
			<td width="90"> &#160;&#160;</td>
			<td width="350" colspan="3">
				<b>Categora&#160;Resolucin:&#160;</b>
				<xsl:if test="$CatCod != ''">
					<!--Si la descripcin tiene menos de 30 caracteres-->
					<xsl:if test="30>string-length(DATA/METRICAS/CATEGORIA/@DESCRIPCION)">								
						<i><xsl:value-of select="DATA/METRICAS/CATEGORIA/@DESCRIPCION"/></i>
					</xsl:if>
					<!--Si la descripcin tiene ms de 30 caracteres-->
					<xsl:if test="string-length(DATA/METRICAS/CATEGORIA/@DESCRIPCION)>30">
						<xsl:value-of select="concat(substring(DATA/METRICAS/CATEGORIA/@DESCRIPCION,0,30),'...')"/>
					</xsl:if>	
				</xsl:if>
				<xsl:if test="$CatCod = ''">
					<i>TODAS</i>	
				</xsl:if>
			</td>
		</tr>
		<tr class="administracion">
			<td width="90"> &#160;&#160; </td>
			<td width="350" colspan="3">
				<b><xsl:call-template name="traduce"><xsl:with-param name="id" select="'Informticos'"/></xsl:call-template>:&#160;</b>
				<xsl:if test="$InfCod != ''">
					<i><xsl:value-of select="concat(concat(DATA/METRICAS/INFORMATICO/@APELLIDOS,', '),DATA/METRICAS/INFORMATICO/@NOMBRE)"/></i>	
				</xsl:if>
				<xsl:if test="$InfCod = ''">
					<i>TODOS</i>	
				</xsl:if>
			</td>
		</tr>
		<tr class="administracion">
			<td>&#160;</td>	
			<xsl:choose>
				<xsl:when test="$UsuCod = '' and $GruCod != ''">						
					<td width="350" colspan="3">
						<b>Grupo&#160;Usuarios:&#160;</b>
						<xsl:if test="$GruCod != ''">
							<i><xsl:value-of select="DATA/METRICAS/GRUPO_USUARIOS/@DESCRIPCION"/></i>	
						</xsl:if>
						<xsl:if test="$GruCod = ''">
							<i>TODOS</i>
						</xsl:if>
					</td>
				</xsl:when>
				<xsl:when test="$UsuCod != '' and $GruCod = ''">						
					<td width="350" colspan="3">
						<b>Usuario:&#160;</b>
						<xsl:if test="$UsuCod != ''">
							<i><xsl:value-of select="concat(concat(DATA/METRICAS/USUARIO/@APELLIDOS,', '),DATA/METRICAS/USUARIO/@NOMBRE)"/></i>	
						</xsl:if>
						<xsl:if test="$UsuCod = ''">
							<i>TODOS</i>
						</xsl:if>
					</td>
				</xsl:when>
				<xsl:otherwise>
					<td width="350" colspan="3">
						<b>Grupo&#160;Usuarios,&#160;Usuarios:&#160;</b>
							<i>TODOS</i>
					</td>
				</xsl:otherwise>
			</xsl:choose>
		</tr>
		<!--Seleccin del modo de representacin de datos-->
		<tr class="administracion"><td colspan="4"><b>Presentacin de datos --> Modo grfico</b></td></tr>
	</table>
	<table class="cont" border="0" cellpadding="3" cellspacing="1" width="100%" summary="Tabla para mostar los resultados">
		<tr class="cabe"><td colspan="10"><b>Resultados</b></td></tr>
						
		<tr class="administracion">
			<td colspan="10" align="center">
				<iframe scrolling="no" border="0" align="centrer" frameborder="no" framespacing="0" src="{$servlet}?module=dumbo7/metricas/estado.Maestro_svg_cantidades&amp;UsuCod={$UsuCod}&amp;InfCod={$InfCod}&amp;GruCod={$GruCod}&amp;AplCod={$AplCod}&amp;CatCod={$CatCod}&amp;SecCod={$SecCod}&amp;desgloseSel={$desgloseSel}&amp;FechaDesde={$FechaDesde}&amp;FechaHasta={$FechaHasta}" width="370" height="480"></iframe>
			</td>
		</tr>
				
		<tr class="administracion" align="center"><td colspan="10"><CENTER><input type="button" class="boton" value="Cerrar" onclick="javascript: window.close()" /></CENTER></td></tr>
	</table>
	</form>
	</td></tr>

	</table>
		
	</body>
	</html>	
</xsl:template>

<xsl:template name="cuerpo"/>
</xsl:stylesheet>
	