<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet version="1.0" 
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:xforms="http://www.w3.org/2002/xforms">

<!-- ELIMINA DUPLICADOS DE DESGLOSE -->
<xsl:key name="klave" match="DATA/METRICAS/RESULTADO_METRICAS" use="@DESGLOSE"/>
	
<xsl:param name="servlet"/>	
<xsl:param name="menu"/>
<xsl:param name="inicio"/>
<xsl:param name="fin"/>
<xsl:param name="UsuCod"/>
<xsl:param name="GruCod"/>
<xsl:param name="AplCod"/>
<xsl:param name="CatCod"/>
<xsl:param name="SecCod"/>
<xsl:param name="InfCod"/>
<xsl:param name="desgloseSel"/>
<xsl:param name="FechaDesde"/>
<xsl:param name="FechaHasta"/>


<xsl:include href="dumbo7/utils/xsl/utils.xsl"/>
	
<xsl:template match="XMLROOT">
	
	<html lang="es">
		<TITLE>DUMBO7: Resultado Mtrica 'Tareas Segn Estado'</TITLE>
		
    <xsl:call-template name="headComun">
		<xsl:with-param name="arbol" select="'EstadoMaestro'"/>
         <xsl:with-param name="jscript">
            <SCRIPT LANGUAGE="JavaScript">
				function mostrarError(error){
					alert(error);
				}
			</SCRIPT>
			<script LANGUAJE="JavaScript" src="../js/OnMouse.js"></script>
         </xsl:with-param>
	</xsl:call-template>
	<body>

	<xsl:for-each select="DATA/METRICAS">
			<xsl:if test="not(@ERROR='')">
				<script>mostrarError('<xsl:value-of select="@ERROR"/>')</script>
				</xsl:if>
		</xsl:for-each>

	<table border="0" align="center" cellpadding="3" cellspacing="1" width="750" summary="Esta tabla contiene las mtricas de tareas segn DEDICACION (para nivel de informtico)">
	<tr><td colspan="2">
		<table class="cont" id="metricas" border="0" cellpadding="3" cellspacing="1" width="100%" summary="Esta tabla contiene las mtricas">
		<tr class="cab1">
			<td colspan="2">&#187;Resultado: Tareas segn estado (Maestro)</td>
			<td width="10" align="center"><b><a href="javascript:window.print()"><img border="0" src="../graficos/iconos/ico_impresora.gif" alt="Imprimir"/></a></b></td>
			<td width="10" align="center"><b><a href="javascript:window.close()">Cerrar</a></b></td>
		</tr>
		<tr class="cabe">
			<td width="140"><b>Periodo</b></td>
			<td width="350"><b>Parmetros</b></td>
			<td colspan="2"></td>
		</tr>
		
		<tr class="administracion">
			<td width="90"><b>Desde:</b>&#160;&#160;<i>
				 <xsl:value-of select="$FechaDesde"/>
			</i></td>
			<td width="350" colspan="3">
				<b>Aplicacin:&#160;</b>
				<xsl:if test="$AplCod != ''">
					<xsl:if test="$AplCod != ''">
						<i><xsl:value-of select="DATA/METRICAS/APLICACION[@CODIGO = $AplCod]/@DESCRIPCION"/></i>
					</xsl:if>	
				</xsl:if>
				<xsl:if test="$AplCod = ''">
					<i>TODAS</i>	
				</xsl:if>
			</td>
		</tr>
		<tr class="administracion">
			<td width="90"><b>Hasta:</b>&#160;&#160;<i>
				<xsl:value-of select="$FechaHasta"/>
			</i></td>
			<td width="350" colspan="3">
				<b>Seccion:&#160;</b>
				<xsl:if test="$SecCod != ''">
					<i><xsl:value-of select="DATA/METRICAS/SECCION[@CODIGO = $SecCod]/@DESCRIPCION"/></i>
				</xsl:if>
				<xsl:if test="$SecCod = ''">
					<i>TODAS</i>	
				</xsl:if>
			</td>
		</tr>
		<tr class="administracion">
			<td width="90"> &#160;&#160;</td>
			<td width="350" colspan="3">
				<b>Categora&#160;Resolucin:&#160;</b>
				<xsl:if test="$CatCod != ''">
					<i><xsl:value-of select="DATA/METRICAS/CATEGORIA[@CODIGO = $CatCod]/@DESCRIPCION"/></i>	
				</xsl:if>
				<xsl:if test="$CatCod = ''">
					<i>TODAS</i>	
				</xsl:if>
			</td>
		</tr>
		<tr class="administracion">
			<td width="90"> &#160;&#160; </td>
			<td width="350" colspan="3">
				<b><xsl:call-template name="traduce"><xsl:with-param name="id" select="'Informticos'"/></xsl:call-template>:&#160;</b>
				<xsl:if test="$InfCod != ''">
					<i><xsl:value-of select="concat(concat(DATA/METRICAS/INFORMATICO/@APELLIDOS,', '),DATA/METRICAS/INFORMATICO/@NOMBRE)"/></i>	
				</xsl:if>
				<xsl:if test="$InfCod = ''">
					<i>TODOS</i>	
				</xsl:if>
			</td>
		</tr>
		<tr class="administracion">
			<td>&#160;</td>	
			<xsl:choose>
				<xsl:when test="$UsuCod = '' and $GruCod != ''">						
					<td width="350" colspan="3">
						<b>Grupo&#160;Usuarios:&#160;</b>
						<xsl:if test="$GruCod != ''">
							<i><xsl:value-of select="DATA/METRICAS/GRUPO_USUARIOS/@DESCRIPCION"/></i>	
						</xsl:if>
						<xsl:if test="$GruCod = ''">
							<i>TODOS</i>
						</xsl:if>
					</td>
				</xsl:when>
				<xsl:when test="$UsuCod != '' and $GruCod = ''">						
					<td width="350" colspan="3">
						<b>Usuario:&#160;</b>
						<xsl:if test="$UsuCod != ''">
							<i><xsl:value-of select="concat(concat(DATA/METRICAS/USUARIO/@APELLIDOS,', '),DATA/METRICAS/USUARIO/@NOMBRE)"/></i>	
						</xsl:if>
						<xsl:if test="$UsuCod = ''">
							<i>TODOS</i>
						</xsl:if>
					</td>
				</xsl:when>
				<xsl:otherwise>
					<td width="350" colspan="3">
						<b>Grupo&#160;Usuarios,&#160;Usuarios:&#160;</b>
							<i>TODOS</i>
					</td>
				</xsl:otherwise>
			</xsl:choose>
		</tr>
		<!--Seleccin del modo de representacin de datos-->
		<tr class="cabe"><td align="center" colspan="4"><b>Presentacin de datos</b></td></tr>
		<tr class="administracion">
			<td colspan="4">
				<b>Modo Dato</b>&#160;-->
				<xsl:choose>
					<xsl:when test="$desgloseSel = 'apl'">						
						&#160;Representacin&#160;Desglosada&#160;Por&#160;<i>Aplicacin</i>
					</xsl:when>
					<xsl:when test="$desgloseSel = 'cat'">						
						&#160;Representacin&#160;Desglosada&#160;Por&#160;<i>Categoria</i>
					</xsl:when>
					<xsl:when test="$desgloseSel = 'usu'">						
						&#160;Representacin&#160;Desglosada&#160;Por&#160;<i>Usuario</i>
					</xsl:when>
					<xsl:when test="$desgloseSel = 'gusu'">						
						&#160;Representacin&#160;Desglosada&#160;Por&#160;<i>Grupo&#160;Usuarios</i>
					</xsl:when>
					<xsl:when test="$desgloseSel = 'sec'">						
						&#160;Representacin&#160;Desglosada&#160;Por&#160;<i>Seccin</i>
					</xsl:when>
					<xsl:when test="$desgloseSel = 'inf'">						
						&#160;Representacin&#160;Desglosada&#160;Por&#160;<i>Informatico</i>
					</xsl:when>
					<xsl:otherwise>
						&#160;Representacin&#160;Conjunta
					</xsl:otherwise>
				</xsl:choose>
			</td>
		</tr>
	</table>
	<table class="cont" border="0" cellpadding="3" cellspacing="1" width="100%" summary="Tabla para mostar los resultados">
		<tr class="cabe"><td colspan="4"><b>Resultados</b></td></tr>
		
		<!--Se diferencia entre dos llamadas para as poder ponerle una clase distinta a un elemento
			que tenga hijos (este tendr clase switchcontent )
			y un elemento que no tenga hijos (Este elemento no tendr calse sera '')

			Esto es necesario para un buen funcionamiento del rbol.
		-->	
		<xsl:if test="$desgloseSel = 'sec'">	
			<xsl:for-each select="DATA/METRICAS/*[(generate-id()=generate-id(key('klave',@DESGLOSE)[1]))]">
			<xsl:variable name="descrip_desglose"><xsl:value-of select="@DESGLOSE"/></xsl:variable>
			<xsl:variable name="posicionPadre"><xsl:value-of select="position() + ((position() -1)*(count(../SECCION)))"/></xsl:variable>
				<xsl:for-each select="../SECCION[(@CODIGO=@PADRE) and (@DESCRIPCION = $descrip_desglose)]">
					<xsl:variable name="codigo2"><xsl:value-of select="@CODIGO"/></xsl:variable>
					<xsl:choose>
						<xsl:when test="(count(../SECCION[@PADRE = $codigo2 and @CODIGO != $codigo2])>0)">	
							<xsl:call-template name="muestraSeccion">
								<xsl:with-param name="position" select="$posicionPadre"/>
								<xsl:with-param name="code" select="@CODIGO"/>
								<xsl:with-param name="descrip" select="@DESCRIPCION"/>
								<xsl:with-param name="style" select="concat('arb.',position())"/>
								<xsl:with-param name="parent" select="@PADRE"/>
								<xsl:with-param name="respon" select="@RESPONSABLE"/>
							</xsl:call-template>					
						</xsl:when>
						<xsl:otherwise>
							<xsl:call-template name="muestraSeccion">
								<xsl:with-param name="position" select="$posicionPadre"/>
								<xsl:with-param name="code" select="@CODIGO"/>
								<xsl:with-param name="descrip" select="@DESCRIPCION"/>
								<xsl:with-param name="style" select="concat('arb.',position())"/>
								<xsl:with-param name="parent" select="@PADRE"/>
								<xsl:with-param name="respon" select="@RESPONSABLE"/>
							</xsl:call-template>
						</xsl:otherwise>
					</xsl:choose>
				</xsl:for-each>
			</xsl:for-each>
		</xsl:if>
		<xsl:if test="$desgloseSel != 'sec'">	
			<xsl:call-template name="muestraDatos"/>
		</xsl:if>
		<xsl:if test="count(DATA/METRICAS/RESULTADO_METRICAS)=0">
			<tr class="administracion">
				<td align="center" colspan="9">* METRICAS sin datos.</td>
			</tr>
		</xsl:if>
				
		<tr class="administracion" align="center"><td colspan="9"><CENTER><input type="button" class="boton" value="Cerrar" onclick="javascript: window.close()" /></CENTER></td></tr>
	</table>
	</td></tr>
	</table>
	</body>
</html>
</xsl:template>

<xsl:template name="muestraSeccion">
<xsl:param name="code"/>
<xsl:param name="position"/>
<xsl:param name="descrip"/>
<xsl:param name="parent"/>
<xsl:param name="respon"/>
<xsl:param name="style"/>	

		<xsl:variable name="nodoSOL" select="../RESULTADO_METRICAS[(@DESGLOSE=$descrip) and @TRAMO = 'SOL']"/>
		<xsl:variable name="nodoR" select="../RESULTADO_METRICAS[(@DESGLOSE=$descrip) and @TRAMO = 'R']"/>
		<xsl:variable name="nodoN" select="../RESULTADO_METRICAS[(@DESGLOSE=$descrip) and @TRAMO = 'N']"/>
		<xsl:variable name="nodoW" select="../RESULTADO_METRICAS[(@DESGLOSE=$descrip) and @TRAMO = 'W']"/>
		<xsl:variable name="nodoX" select="../RESULTADO_METRICAS[(@DESGLOSE=$descrip) and @TRAMO = 'X']"/>
			
		<xsl:choose>
			<!--Si la seccin actual tine todos los datos a cero-->
			<xsl:when test="$nodoSOL/@PETICIONES = 0 and $nodoSOL/@INCIDENCIAS = 0  and $nodoR/@PETICIONES = 0 and $nodoR/@INCIDENCIAS = 0	and $nodoN/@PETICIONES = 0 and $nodoN/@INCIDENCIAS = 0	
	    					and $nodoW/@PETICIONES = 0 and $nodoW/@INCIDENCIAS = 0	and $nodoX/@PETICIONES = 0 and $nodoX/@INCIDENCIAS = 0">
				<tr id="{concat('arb.',$position)}" class="switchcontent" bgcolor= "#F2F0E3" onMouseOver="javascript:onMouse(this,'true');" onMouseOut="javascript:onMouse(this,'false');">
					<!--Variable para a partir de la posicin en el arbol(1.1.1) insertar el nmero de espacios(0.25cm) correspondiente-->
					<xsl:variable name="estilo">
						<xsl:value-of select="concat(concat('padding-left:',(string-length(translate($style,'0123456789',''))-3)* 0.25),'cm')"/>
					</xsl:variable>
					<td colspan="4" style="{$estilo}" class="cabeAlertas"><xsl:value-of select="$descrip"/></td>	
				</tr>
			</xsl:when>
			<!--Si tiene datos pues los muestro normalmente-->
			<xsl:otherwise>
				<tr id="{concat('arb.',$position)}" class="switchcontent" bgcolor= "#F2F0E3" onMouseOver="javascript:onMouse(this,'true');" onMouseOut="javascript:onMouse(this,'false');">
					<!--Variable para a partir de la posicin en el arbol(1.1.1) insertar el nmero de espacios(0.25cm) correspondiente-->
					<xsl:variable name="estilo">
						<xsl:value-of select="concat(concat('padding-left:',(string-length(translate($style,'0123456789',''))-3)* 0.25),'cm')"/>
					</xsl:variable>
					<td colspan="4" style="{$estilo}" class="cabeAlertas">
						<img id="{concat('img.arb.',$position)}" class="showstate" border="0" src="../dumbo7/utils/table/minus.gif" onClick="expandcontent(this,'{concat('arb.',$position)}');"/>
						<xsl:value-of select="$descrip"/>
					</td>
					
					<tr id="{concat(concat('arb.',$position),'.1')}" class="switchcontent">
						<td width="250" align="center"><b>Estado&#160;Tarea</b></td>
						<td width="80" align="right" ><b>Peticiones</b></td>
						<td width="80" align="right"><b>Incidencias</b></td>
						<td width="80" align="right"><b>Tareas</b></td>	
					</tr>
					
					<xsl:for-each select="../RESULTADO_METRICAS[@DESGLOSE=$descrip]">
						<!--Tramos-->	
						<xsl:choose>
							<xsl:when test="@TRAMO = 'SOL'">
								<tr id="{concat(concat('arb.',$position),'.2')}" class="switchcontent" bgcolor= "#F2F0E3" onmouseover="javascript:onMouse(this,'true');" onmouseout="javascript:onMouse(this,'false');">
									<td width="250" align="center">Solicitadas</td>
									<td width="80" align="right"><xsl:value-of select="@PETICIONES"/></td>
									<td width="80" align="right"><xsl:value-of select="@INCIDENCIAS"/></td>
									<!--Tareas = Peticiones + Incidencias-->
									<td width="80" align="right"><xsl:value-of select="@PETICIONES+@INCIDENCIAS"/></td>
								</tr>
							</xsl:when>
							<xsl:when test="@TRAMO = 'R'">
								<tr id="{concat(concat('arb.',$position),'.3')}" class="switchcontent" bgcolor= "#F2F0E3" onmouseover="javascript:onMouse(this,'true');" onmouseout="javascript:onMouse(this,'false');">
									<td width="250" align="center">Finalizadas</td>
									<td width="80" align="right"><xsl:value-of select="@PETICIONES"/></td>
									<td width="80" align="right"><xsl:value-of select="@INCIDENCIAS"/></td>
									<!--Tareas = Peticiones + Incidencias-->
									<td width="80" align="right"><xsl:value-of select="@PETICIONES+@INCIDENCIAS"/></td>
								</tr>						
							</xsl:when>
							<xsl:when test="@TRAMO = 'N'">
								<tr id="{concat(concat('arb.',$position),'.4')}" class="switchcontent" bgcolor= "#F2F0E3" onmouseover="javascript:onMouse(this,'true');" onmouseout="javascript:onMouse(this,'false');">
									<td width="250" align="center">Anuladas</td>
									<td width="80" align="right"><xsl:value-of select="@PETICIONES"/></td>
									<td width="80" align="right"><xsl:value-of select="@INCIDENCIAS"/></td>
									<!--Tareas = Peticiones + Incidencias-->
									<td width="80" align="right"><xsl:value-of select="@PETICIONES+@INCIDENCIAS"/></td>
								</tr>						
							</xsl:when>
							<xsl:when test="@TRAMO = 'W'">
								<tr id="{concat(concat('arb.',$position),'.5')}" class="switchcontent" bgcolor= "#F2F0E3" onmouseover="javascript:onMouse(this,'true');" onmouseout="javascript:onMouse(this,'false');">
									<td width="250" align="center">En&#160;Espera</td>
									<td width="80" align="right"><xsl:value-of select="@PETICIONES"/></td>
									<td width="80" align="right"><xsl:value-of select="@INCIDENCIAS"/></td>
									<!--Tareas = Peticiones + Incidencias-->
									<td width="80" align="right"><xsl:value-of select="@PETICIONES+@INCIDENCIAS"/></td>
								</tr>						
							</xsl:when>
							<xsl:when test="@TRAMO = 'X'">
								<tr id="{concat(concat('arb.',$position),'.6')}" class="switchcontent" bgcolor= "#F2F0E3" onmouseover="javascript:onMouse(this,'true');" onmouseout="javascript:onMouse(this,'false');">
									<td width="250" align="center">Rechazadas</td>
									<td width="80" align="right"><xsl:value-of select="@PETICIONES"/></td>
									<td width="80" align="right"><xsl:value-of select="@INCIDENCIAS"/></td>
									<!--Tareas = Peticiones + Incidencias-->
									<td width="80" align="right"><xsl:value-of select="@PETICIONES+@INCIDENCIAS"/></td>
								</tr>						
							</xsl:when>
						</xsl:choose>
					</xsl:for-each>
				</tr>
			</xsl:otherwise>
		</xsl:choose>	
					
		<xsl:for-each select="../*[(generate-id()=generate-id(key('klave',@DESGLOSE)[1]))]">
		<xsl:variable name="descrip_desglose2"><xsl:value-of select="@DESGLOSE"/></xsl:variable>
		<xsl:variable name="posicionHijo"><xsl:value-of select="position()"/></xsl:variable>
			<xsl:for-each select="../SECCION[(@PADRE=$code) and not(@PADRE=@CODIGO) and (@DESCRIPCION = $descrip_desglose2)]">
			<xsl:sort select="@DESCRIPCION"/>
				<xsl:call-template name="muestraSeccion">
					<xsl:with-param name="code" select="@CODIGO"/>
					<xsl:with-param name="descrip" select="@DESCRIPCION"/>
					<xsl:with-param name="parent" select="@PADRE"/>
					<xsl:with-param name="respon" select="@RESPONSABLE"/>
					<xsl:with-param name="style" select="concat($style,concat('.',position()))"/>
					<xsl:with-param name="position" select="$posicionHijo + position()"/>
				</xsl:call-template>					
			</xsl:for-each>	
		</xsl:for-each>
		
</xsl:template>

<xsl:template name="muestraDatos">
	<!--Si Existen en los resultados el parametro desglose la forma de mostrar los datos ser 
			anteponiendo este desglose a nivel de la cabecera de detalle-->
		<xsl:if test="count(DATA/METRICAS/RESULTADO_METRICAS/@DESGLOSE)>0">
			<xsl:for-each select="DATA/METRICAS/*[(generate-id()=generate-id(key('klave',@DESGLOSE)[1]))]">
				<xsl:sort select="@DESGLOSE"/>
				<!-- Esto se ejecuta una vez por cada desglose existente en orden alfabtico de desglose -->
				<xsl:variable name="miDesglose" select="@DESGLOSE"/>
				<tr class="cabeAlertas"><td colspan="4"><xsl:value-of select="$miDesglose"/></td></tr>
				<tr class="administracion">
					<td width="250" align="center"><b>Estado&#160;Tarea</b></td>
								
					<td width="80" align="right"><b>Peticiones</b></td>
					<td width="80" align="right"><b>Incidencias</b></td>
					<td width="80" align="right"><b>Tareas</b></td>	
				</tr>
				<xsl:for-each select="../RESULTADO_METRICAS[@DESGLOSE=$miDesglose]">
					<tr class="administracion" onmouseover="javascript:onMouse(this,'true');" onmouseout="javascript:onMouse(this,'false');">
						<!--Tramos-->	
						<xsl:choose>
							<xsl:when test="@TRAMO = 'SOL'">						
								<td width="250" align="center">Solicitadas</td>
							</xsl:when>
							<xsl:when test="@TRAMO = 'R'">						
								<td width="250" align="center">Finalizadas</td>					
							</xsl:when>
							<xsl:when test="@TRAMO = 'N'">						
								<td width="250" align="center">Anuladas</td>
							</xsl:when>
							<xsl:when test="@TRAMO = 'W'">						
								<td width="250" align="center">En&#160;Espera</td>
							</xsl:when>
							<xsl:when test="@TRAMO = 'X'">						
								<td width="250" align="center">Rechazadas</td>				
							</xsl:when>
						</xsl:choose>
						
						<td width="80" align="right"><xsl:value-of select="@PETICIONES"/></td>
						<td width="80" align="right"><xsl:value-of select="@INCIDENCIAS"/></td>
						<!--Tareas = Peticiones + Incidencias-->
						<td width="80" align="right"><xsl:value-of select="@PETICIONES+@INCIDENCIAS"/></td>
					</tr>
				</xsl:for-each>
			</xsl:for-each>
		</xsl:if>

		<!--Si no existe el parmetro desglose en los resultados se mostrar la informacin normalmente-->
		<xsl:if test="count(DATA/METRICAS/RESULTADO_METRICAS/@DESGLOSE)&lt;=0">
			<tr class="administracion">
				<td width="250" align="center"><b>Estado&#160;Tarea</b></td>
				<td width="80" align="right"><b>Peticiones</b></td>
				<td width="80" align="right"><b>Incidencias</b></td>
				<td width="80" align="right"><b>Tareas</b></td>	
			</tr>
			<xsl:for-each select="DATA/METRICAS/RESULTADO_METRICAS">
				<tr class="administracion" onmouseover="javascript:onMouse(this,'true');" onmouseout="javascript:onMouse(this,'false');">
					<!--Tramos-->	
					<xsl:choose>
						<xsl:when test="@TRAMO = 'SOL'">						
							<td width="250" align="center">Solicitadas</td>
						</xsl:when>
						<xsl:when test="@TRAMO = 'R'">						
							<td width="250" align="center">Finalizadas</td>					
						</xsl:when>
						<xsl:when test="@TRAMO = 'N'">						
							<td width="250" align="center">Anuladas</td>
						</xsl:when>
						<xsl:when test="@TRAMO = 'W'">						
							<td width="250" align="center">En&#160;Espera</td>
						</xsl:when>
						<xsl:when test="@TRAMO = 'X'">						
							<td width="250" align="center">Rechazadas</td>				
						</xsl:when>
					</xsl:choose>
					
					<td width="80" align="right"><xsl:value-of select="@PETICIONES"/></td>
					<td width="80" align="right"><xsl:value-of select="@INCIDENCIAS"/></td>
					<!--Tareas = Peticiones + Incidencias-->
					<td width="80" align="right"><xsl:value-of select="@PETICIONES+@INCIDENCIAS"/></td>
				</tr>
			</xsl:for-each>
		</xsl:if>
</xsl:template>		


<xsl:template name="cuerpo"/>
</xsl:stylesheet>
	