package dumbo7.metricas.general;

import dumbo7.metricas.*;

import java.sql.*;
import java.sql.ResultSet;
import java.util.*;

import dumbo7.utils.*;

import org.hibernate.Criteria;
import org.hibernate.Query;
import org.hibernate.Session;
import org.hibernate.criterion.Expression;

import atica.frameweb.utils.*;

/**
 * @author Antonio
 *
 * Gestor de Metrica General de DUMBO
 * 
 */
public class GestorGeneral extends GeneralManager {
	private List seccionesResponsable = new Vector();
	private List aplicaciones = new Vector();
	private List secciones = new Vector();
	private List ModoDato;
	private Vector resultadoMetricas = new Vector();
		
	private String Aplicacion = "";
	private String Seccion = "";
	private String Datos = "";
	private String Codigo = "";
	private String Sel = "";
	private String Desglose = "";
	
	private String FechaDesde;
	private String FechaHasta;
		
	public GestorGeneral() {}
	
	//Mtodos get() para el mapeo
	public List getAplicaciones() { return aplicaciones; }
	public List getSeccionesResponsable() { return seccionesResponsable; }
	public List getSecciones() { return secciones; }
	public List getModoDato(){return ModoDato;}
	public Vector getResultadoMetricas(){return this.resultadoMetricas;}
		
	//Mtodos set para recoger los datos del formulario
	/**Metdo set() para obtener las fechas de inicio y fin del histrico*/
	public void setFechaDesde(String FDesde){this.FechaDesde = FDesde;}
	public void setFechaHasta(String FHasta){this.FechaHasta = FHasta;}
	
	public void setSeccion(String sec){this.Seccion = sec;}
	public void setAplicacion(String Apl){this.Aplicacion = Apl;}
	public void setDesglose(String Des){this.Desglose = Des;}
		
	/**	Lista todas las secciones*/
	public void listaSecciones(Session conn){
		try{
			Query q = conn.createQuery(getQuery("AllSecciones"));
			q = q.setString("sist",user.getDatosMenu().idSelected());
			secciones  = (List)q.list();
		}
		catch (Exception ex){
			setErrorMessage("GestorMetricas[Lectura de BBDD]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
	}
	
	/**Lista secciones con datos sin importar el estado, para el select inicial de secciones(no incluye estado finalizado)**/
	public void listaSeccionesConDatos(Session conn) {
		PreparedStatement pstmt;
		
		try{
			String ResultadoQuery = getQuery("SeccionesConDatos");
			ResultadoQuery = ResultadoQuery.replaceAll(":SISTEMA",user.getDatosMenu().idSelected());
			ResultadoQuery = ResultadoQuery.replaceAll(":GESTOR",user.getIdentificador());
			pstmt = conn.connection().prepareStatement(ResultadoQuery);
			ResultSet rs = pstmt.executeQuery();
			
		 	while (rs.next()) {
	 	    	D7Secciones sec = new D7Secciones();
	 	    	sec.setSecSisCod(rs.getString("Sec_Sis_Cod"));
	 	    	sec.setSecCod(rs.getString("Sec_Cod"));
	 	    	sec.setSecDescrip(rs.getString("Sec_Descrip"));
	 	    	sec.setSecIdRespon(rs.getString("Sec_Id_Respon"));
	 	    	sec.setSecSecCod(rs.getString("Sec_Sec_Cod"));
	 	    	sec.setSecEstado(rs.getString("Sec_Estado"));
	 	    	secciones.add(sec);
	 	    }
		 	rs.close();
	 	    pstmt.close();
		} catch (Exception ex) {
			System.out.println(ex);
			setErrorMessage("GestorMetricas[Lectura de BBDD]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
	}
	
	/**-------------------SECCIONES para la AGRUPACIN-------------------*/
	public void listaSeccionesAgrupacion(Session conn){
		PreparedStatement pstmt;
		String Query ="";
		try{		 	 
			Query = getQuery("ListaAgrupacionSecciones");
			Query = Query.replaceAll(":SISTEMA",user.getDatosMenu().idSelected());
			pstmt = conn.connection().prepareStatement(Query);
			ResultSet rs = pstmt.executeQuery();
			while (rs.next()) {
				D7Secciones sec = new D7Secciones();
				sec.setSecSisCod(rs.getString("Sec_Sis_Cod"));
	 	    	sec.setSecCod(rs.getString("Sec_Cod"));
	 	    	sec.setSecDescrip(rs.getString("Sec_Descrip"));
	 	    	sec.setSecIdRespon(rs.getString("Sec_Id_Respon"));
	 	    	sec.setSecSecCod(rs.getString("Sec_Sec_Cod"));
	 	    	sec.setSecEstado(rs.getString("Sec_Estado"));
	 	    	this.secciones.add(sec);
			}   
		 rs.close();
		 pstmt.close();
	  } catch (Exception ex) {
			System.out.println(ex);
			setErrorMessage("GestorMetricas [Lectura de BBDD]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
	}
	/**-------------------APLICACIONES para la AGRUPACIN-------------------*/
	public void listaAplicacionesAgrupacion(Session conn){
		PreparedStatement pstmt;
		String Query ="";
		try{		 	 
			Query = getQuery("ListaAgrupacionAplicaciones");
			Query = Query.replaceAll(":SISTEMA",user.getDatosMenu().idSelected());
			pstmt = conn.connection().prepareStatement(Query);
			ResultSet rs = pstmt.executeQuery();
			while (rs.next()) {
				D7Aplicaciones apli = new D7Aplicaciones();
				apli.setAplSisCod(rs.getString("Apl_Sis_Cod"));
	 	    	apli.setAplCod(rs.getString("Apl_Cod"));
	 	    	apli.setAplDescrip(rs.getString("Apl_Descrip"));
	 	    	apli.setAplTipoAsig(rs.getString("Apl_Tipo_Asig"));
	 	    	apli.setAplSecCod(rs.getString("Apl_Sec_Cod"));
	 	    	apli.setAplEstado(rs.getString("Apl_Estado"));
	 	    	apli.setAplPadreAplCod(rs.getString("Apl_Padre_Apl_Cod"));
	 	    	aplicaciones.add(apli);
			}   
		 rs.close();
		 pstmt.close();
	  } catch (Exception ex) {
			System.out.println(ex);
			setErrorMessage("GestorMetricas [Lectura de BBDD]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
	}
	
	/**-------------------GESTOR-------------------*/
	public void listaAplicacionesGestor(Session conn){
		PreparedStatement pstmt;
		try{
			String ResultadoQuery = getQuery("AplicacionesGestorConAyuda");
			ResultadoQuery = ResultadoQuery.replaceAll(":SISTEMA",user.getDatosMenu().idSelected());
			ResultadoQuery = ResultadoQuery.replaceAll(":GESTOR",user.getIdentificador());
			pstmt = conn.connection().prepareStatement(ResultadoQuery);
			ResultSet rs = pstmt.executeQuery();
			
		 	while (rs.next()) {
	 	    	D7Aplicaciones apli = new D7Aplicaciones();
		 	   	apli.setAplSisCod(rs.getString("Apl_Sis_Cod"));
	 	    	apli.setAplCod(rs.getString("Apl_Cod"));
	 	    	apli.setAplDescrip(rs.getString("Apl_Descrip"));
	 	    	apli.setAplTipoAsig(rs.getString("Apl_Tipo_Asig"));
	 	    	apli.setAplSecCod(rs.getString("Apl_Sec_Cod"));
	 	    	apli.setAplEstado(rs.getString("Apl_Estado"));
	 	    	apli.setAplPadreAplCod(rs.getString("Apl_Padre_Apl_Cod"));
	 	    	aplicaciones.add(apli);
	 	    }   
	 	    rs.close();
	 	    pstmt.close();
		} catch (Exception ex) {
			System.out.println(ex);
			setErrorMessage("GestorMetricas[Lectura de BBDD]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
	}
	public void listaSeccionesGestor(Session conn) {
		PreparedStatement pstmt;
		
		try{
			String ResultadoQuery = getQuery("SeccionesGestorConAyuda");
			ResultadoQuery = ResultadoQuery.replaceAll(":SISTEMA",user.getDatosMenu().idSelected());
			ResultadoQuery = ResultadoQuery.replaceAll(":GESTOR",user.getIdentificador());
			pstmt = conn.connection().prepareStatement(ResultadoQuery);
			ResultSet rs = pstmt.executeQuery();
			
		 	while (rs.next()) {
	 	    	D7Secciones sec = new D7Secciones();
	 	    	sec.setSecSisCod(rs.getString("Sec_Sis_Cod"));
	 	    	sec.setSecCod(rs.getString("Sec_Cod"));
	 	    	sec.setSecDescrip(rs.getString("Sec_Descrip"));
	 	    	sec.setSecIdRespon(rs.getString("Sec_Id_Respon"));
	 	    	sec.setSecSecCod(rs.getString("Sec_Sec_Cod"));
	 	    	sec.setSecEstado(rs.getString("Sec_Estado"));
	 	    	seccionesResponsable.add(sec);
	 	    }
		 	rs.close();
	 	    pstmt.close();
		} catch (Exception ex) {
			System.out.println(ex);
			setErrorMessage("GestorMetricas[Lectura de BBDD]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
	}
	
	/**-------------------MAESTRO-------------------*/
	public void listaSeccionesMaestro(Session conn){
		try{
			Query q = conn.createQuery(getQuery("SeccionesMaestroConAyuda"));
			q = q.setString("sist",user.getDatosMenu().idSelected());
			secciones  = (List)q.list();
		} catch (Exception ex) {
			setErrorMessage("GestorMetricas[Lectura de BBDD]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
	}
	public void listaAplicacionesMaestro(Session conn){
		try{
			Query q = conn.createQuery(getQuery("AplicacionesMaestroConAyuda"));
			q = q.setString("sist",user.getDatosMenu().idSelected());
			aplicaciones  = (List)q.list();
		} catch (Exception ex) {
			setErrorMessage("GestorMetricas[Lectura de BBDD]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
	}
		
	/** Mtodo para sustituir todos los parmetros de la query de ListaEnModoDato o ListaEnModoDatoDesglose
	* En este mtodo se elige cual de las 2 querys realizar en funcin de si se ha elegido desglose o no
	* Adems tambin se sustituyen los parmetros en funcin de si se ha introducido usuario, informatico, seccion...
	* */
	/**-------------------RESULTADOS de las mtricas para MAESTRO-------------------*/
	public void listaModoDatoMaestro(Session conn){
		PreparedStatement pstmt = null;
		ResultSet rs = null;
		try {
			String condiciones = ""; Vector pars = new Vector();
			if(!this.Aplicacion.equals("")) { condiciones += getQuery("AplCondition"); pars.add(this.Aplicacion); pars.add(this.Aplicacion); }
			if(!this.Seccion.equals("")) { condiciones += getQuery("SecCondition"); pars.add(this.Seccion); }
			if (!this.FechaDesde.equals("DD/MM/AAAA")) { condiciones += getQuery("FechaDesdeCondition"); pars.add(this.FechaDesde); }
			if (!this.FechaHasta.equals("DD/MM/AAAA")) { condiciones += getQuery("FechaHastaCondition"); pars.add(this.FechaHasta); }
			String desglose = "";
			if(this.Desglose.equals("apl")) { desglose = getQuery("AplGroup"); }
			if(this.Desglose.equals("sec")) {
				desglose = getQuery("SecGroup");
				pstmt = conn.connection().prepareStatement(getQuery("SecGroup"));
				pstmt.setString(1,user.getDatosMenu().idSelected());
				pstmt.setString(2,user.getDatosMenu().idSelected());
				rs = pstmt.executeQuery();
				if (rs.next()) {
					Clob cl = rs.getClob(1);
					int n = rs.getInt(2);
					desglose = cl.getSubString(1,n);
				}
				rs.close(); pstmt.close();
			}
			
			int max = Integer.parseInt(getQuery("ListaTotalN"));
			for (int lst=0; lst<max; lst++) {
				String query = getQuery("ListaTotal"+lst).replaceAll("-XX-",desglose);
				if (!condiciones.equals("")) query = query.replaceFirst("--",condiciones);
				pstmt = conn.connection().prepareStatement(query);
				pstmt.setString(1,user.getDatosMenu().idSelected());
				pstmt.setString(2,D7TiposTareas.INCIDENCIA);
				pstmt.setString(3,D7TiposTareas.PETICION);
				pstmt.setString(4,user.getDatosMenu().idSelected());
				for (int kp=0; kp<pars.size(); kp++) pstmt.setString(5+kp,(String)pars.elementAt(kp));
				rs = pstmt.executeQuery();
			 	while (rs.next()) {
			 		Metricas M = new Metricas();
		 	    	M.setParams(rs.getString(1)); //Recogida del tipo de tarea
		 	    	M.setDesglose(rs.getString(2)); // P, N y R
		 	    	M.setTareas(new Integer(rs.getInt(3)));	//Recogida del count(*)
		 	    	if (M.getDesglose().indexOf("-XX-")>0) {
		 	    		String desg = M.getDesglose();
						if(this.Desglose.equals("apl")) { M.setAplicacion(desg.substring(0,desg.indexOf("-XX-"))); }
		 				if(this.Desglose.equals("sec")) { M.setSeccion(desg.substring(0,desg.indexOf("-XX-"))); }
		 				M.setDesglose(desg.substring(desg.indexOf("-XX-")+4));
		 	    	}
		 	    	this.resultadoMetricas.add(M);
		 	    }   
		 	    rs.close();
		 	    pstmt.close();
			}
			
		} catch (Exception ex) {
			System.out.println("Error: "+ex);
			setErrorMessage("LISTADO Maestro:"+ex);
		} finally {
			try {
				if (rs!=null) rs.close();
				if (pstmt!=null) pstmt.close();
			} catch (Exception exx) {}
		}
	}
	/**-------------------RESULTADOS de las mtricas para GESTOR-------------------*/
	public void listaModoDatoGestor(Session conn){
		PreparedStatement pstmt = null;
		ResultSet rs = null;
		try {
			String condiciones = ""; Vector pars = new Vector();
			if(!this.Aplicacion.equals("")) { condiciones += getQuery("AplCondition"); pars.add(this.Aplicacion); pars.add(this.Aplicacion); }
			if(!this.Seccion.equals("")) { condiciones += getQuery("SecCondition"); pars.add(this.Seccion); }
			if (!this.FechaDesde.equals("DD/MM/AAAA")) { condiciones += getQuery("FechaDesdeCondition"); pars.add(this.FechaDesde); }
			if (!this.FechaHasta.equals("DD/MM/AAAA")) { condiciones += getQuery("FechaHastaCondition"); pars.add(this.FechaHasta); }
			String desglose = "";
			if(this.Desglose.equals("apl")) { desglose = getQuery("AplGroup"); }
			if(this.Desglose.equals("sec")) {
				desglose = getQuery("SecGroup");
				pstmt = conn.connection().prepareStatement(getQuery("SecGroup"));
				pstmt.setString(1,user.getDatosMenu().idSelected());
				pstmt.setString(2,user.getDatosMenu().idSelected());
				rs = pstmt.executeQuery();
				if (rs.next()) {
					Clob cl = rs.getClob(1);
					int n = rs.getInt(2);
					desglose = cl.getSubString(1,n);
				}
				rs.close(); pstmt.close();
			}
			condiciones += getQuery("CondicionGestor"); pars.add(user.getIdentificador()); pars.add(user.getIdentificador());
			int max = Integer.parseInt(getQuery("ListaTotalN"));
			for (int lst=0; lst<max; lst++) {
				String query = getQuery("ListaTotal"+lst).replaceAll("-XX-",desglose);
				if (!condiciones.equals("")) query = query.replaceFirst("--",condiciones);
				pstmt = conn.connection().prepareStatement(query);
				pstmt.setString(1,user.getDatosMenu().idSelected());
				pstmt.setString(2,D7TiposTareas.INCIDENCIA);
				pstmt.setString(3,D7TiposTareas.PETICION);
				pstmt.setString(4,user.getDatosMenu().idSelected());
				for (int kp=0; kp<pars.size(); kp++) pstmt.setString(5+kp,(String)pars.elementAt(kp));
				rs = pstmt.executeQuery();
			 	while (rs.next()) {
			 		Metricas M = new Metricas();
		 	    	M.setParams(rs.getString(1)); //Recogida del tipo de tarea
		 	    	M.setDesglose(rs.getString(2)); // P, N y R
		 	    	M.setTareas(new Integer(rs.getInt(3)));	//Recogida del count(*)
		 	    	if (M.getDesglose().indexOf("-XX-")>0) {
		 	    		String desg = M.getDesglose();
						if(this.Desglose.equals("apl")) { M.setAplicacion(desg.substring(0,desg.indexOf("-XX-"))); }
		 				if(this.Desglose.equals("sec")) { M.setSeccion(desg.substring(0,desg.indexOf("-XX-"))); }
		 				M.setDesglose(desg.substring(desg.indexOf("-XX-")+4));
		 	    	}
		 	    	this.resultadoMetricas.add(M);
		 	    }   
		 	    rs.close();
		 	    pstmt.close();
			}
			
		} catch (Exception ex) {
			System.out.println("Error: "+ex);
			setErrorMessage("LISTADO Gestor:"+ex);
		} finally {
			try {
				if (rs!=null) rs.close();
				if (pstmt!=null) pstmt.close();
			} catch (Exception exx) {}
		}
	}

	/**-------------------RESULTADOS de las mtricas para INFORMATICO -------------------*/
	public void listaModoDatoInformatico(Session conn){
		PreparedStatement pstmt = null;
		ResultSet rs = null;
		try {
			String condiciones = ""; Vector pars = new Vector();
			if(!this.Aplicacion.equals("")) { condiciones += getQuery("AplCondition"); pars.add(this.Aplicacion); pars.add(this.Aplicacion); }
			if(!this.Seccion.equals("")) { condiciones += getQuery("SecCondition"); pars.add(this.Seccion); }
			if (!this.FechaDesde.equals("DD/MM/AAAA")) { condiciones += getQuery("FechaDesdeCondition"); pars.add(this.FechaDesde); }
			if (!this.FechaHasta.equals("DD/MM/AAAA")) { condiciones += getQuery("FechaHastaCondition"); pars.add(this.FechaHasta); }
			String desglose = "";
			if(this.Desglose.equals("apl")) { desglose = getQuery("AplGroup"); }
			if(this.Desglose.equals("sec")) {
				desglose = getQuery("SecGroup");
				pstmt = conn.connection().prepareStatement(getQuery("SecGroup"));
				pstmt.setString(1,user.getDatosMenu().idSelected());
				pstmt.setString(2,user.getDatosMenu().idSelected());
				rs = pstmt.executeQuery();
				if (rs.next()) {
					Clob cl = rs.getClob(1);
					int n = rs.getInt(2);
					desglose = cl.getSubString(1,n);
				}
				rs.close(); pstmt.close();
			}
			condiciones += getQuery("CondicionInformatico"); pars.add(user.getIdentificador());
			int max = Integer.parseInt(getQuery("ListaTotalN"));
			for (int lst=0; lst<max; lst++) {
				String query = getQuery("ListaTotal"+lst).replaceAll("-XX-",desglose);
				if (!condiciones.equals("")) query = query.replaceFirst("--",condiciones);
				pstmt = conn.connection().prepareStatement(query);
				pstmt.setString(1,user.getDatosMenu().idSelected());
				pstmt.setString(2,D7TiposTareas.INCIDENCIA);
				pstmt.setString(3,D7TiposTareas.PETICION);
				pstmt.setString(4,user.getDatosMenu().idSelected());
				for (int kp=0; kp<pars.size(); kp++) pstmt.setString(5+kp,(String)pars.elementAt(kp));
				rs = pstmt.executeQuery();
			 	while (rs.next()) {
			 		Metricas M = new Metricas();
		 	    	M.setParams(rs.getString(1)); //Recogida del tipo de tarea
		 	    	M.setDesglose(rs.getString(2)); // P, N y R
		 	    	M.setTareas(new Integer(rs.getInt(3)));	//Recogida del count(*)
		 	    	if (M.getDesglose().indexOf("-XX-")>0) {
		 	    		String desg = M.getDesglose();
						if(this.Desglose.equals("apl")) { M.setAplicacion(desg.substring(0,desg.indexOf("-XX-"))); }
		 				if(this.Desglose.equals("sec")) { M.setSeccion(desg.substring(0,desg.indexOf("-XX-"))); }
		 				M.setDesglose(desg.substring(desg.indexOf("-XX-")+4));
		 	    	}
		 	    	this.resultadoMetricas.add(M);
		 	    }   
		 	    rs.close();
		 	    pstmt.close();
			}
			
		} catch (Exception ex) {
			System.out.println("Error: "+ex);
			setErrorMessage("LISTADO Informatico:"+ex);
		} finally {
			try {
				if (rs!=null) rs.close();
				if (pstmt!=null) pstmt.close();
			} catch (Exception exx) {}
		}
	}
	/**-------------------INFORMATICO-------------------*/
	public void listaAplicacionesInformatico(Session conn){
		try {
			
			Criteria ct = conn.createCriteria(D7Aplicaciones.class);
			ct = ct.add(Expression.eq("AplSisCod",user.getDatosMenu().idSelected())); // Fijo el Sistema
			ct = ct.createCriteria("informaticos"); // Hago la join con aplicaciones_informaticos
			ct = ct.add(Expression.eq("AinSisCod",user.getDatosMenu().idSelected()));
			ct = ct.add(Expression.eq("AinInfCod",user.getIdentificador()));
			aplicaciones = ct.list();
			
		} catch (Exception ex) {
			setErrorMessage("GestorMetricas[Lectura de BBDD]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
	}
	public void listaSeccionesInformatico(Session conn) {
		try{

			Criteria ct = conn.createCriteria(D7Secciones.class);
			ct = ct.add(Expression.eq("SecSisCod",user.getDatosMenu().idSelected())); // Fijo el Sistema
			ct = ct.createCriteria("aplicaciones"); // Hago la join con aplicaciones
			ct = ct.add(Expression.eq("AplSisCod",user.getDatosMenu().idSelected()));
			ct = ct.createCriteria("informaticos"); // Hago la join con aplicaciones_informaticos
			ct = ct.add(Expression.eq("AinSisCod",user.getDatosMenu().idSelected()));
			ct = ct.add(Expression.eq("AinInfCod",user.getIdentificador()));
			seccionesResponsable = ct.list();
			
		} catch (Exception ex) {
			setErrorMessage("GestorMetricas[Lectura de BBDD]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
	}
	
}


