<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet version="1.0" 
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:xforms="http://www.w3.org/2002/xforms">

<!-- ELIMINA DUPLICADOS DE DESGLOSE -->
<xsl:key name="klave" match="DATA/METRICAS/RESULTADO_METRICAS" use="@SECCION"/>
<xsl:key name="kdesg" match="DATA/METRICAS/RESULTADO_METRICAS" use="@DESGLOSE"/>

<xsl:param name="servlet"/>	
<xsl:param name="menu"/>
<xsl:param name="perfil"/>
<xsl:param name="inicio"/>
<xsl:param name="fin"/>
<xsl:param name="AplCod"/>
<xsl:param name="SecCod"/>
<xsl:param name="FechaDesde"/>
<xsl:param name="FechaHasta"/>
<xsl:param name="desgloseSel"/>
<xsl:param name="estadoSel"/>

<xsl:include href="dumbo7/utils/xsl/utils.xsl"/>
<xsl:include href="dumbo7/metricas/general/html/comun.xsl"/>

<xsl:template match="XMLROOT">
	
	<html lang="es">
	<head>
		<TITLE>DUMBO7: Resultado Mtrica 'General'</TITLE>
	</head>
	<body>
	<table id="metricas" border="0" cellpadding="3" cellspacing="1">
		<tr><td colspan="4">&#160;</td></tr>
		<tr>
			<td colspan="4"><font size="+2" color="red">Resultado: Mtrica General (<xsl:value-of select="$perfil"/>)</font></td>
		</tr>
		<tr><td colspan="4">&#160;</td></tr>
		<tr>
			<td><font size="+1"><b>Periodo</b></font></td>
			<td><font size="+1"><b>Parmetros</b></font></td>
			<td colspan="2">&#160;</td>
		</tr>
		
		<tr>
			<td><b>&#160;Desde:</b>&#160;&#160;<i><xsl:value-of select="$FechaDesde"/></i></td>
			<td colspan="3">
				<b>&#160;Seccion:&#160;</b>
				<xsl:if test="$SecCod != ''">
					<i><xsl:value-of select="DATA/METRICAS/SECCION[@CODIGO = $SecCod]/@DESCRIPCION"/></i>
				</xsl:if>
				<xsl:if test="$SecCod = ''">
					<i>TODAS</i>	
				</xsl:if>
			</td>
		</tr>
		<tr>
			<td><b>&#160;Hasta:</b>&#160;&#160;<i>
				<xsl:value-of select="$FechaHasta"/>
			</i></td>
			<td colspan="3">
				<b>&#160;Aplicacin:&#160;</b>
				<xsl:if test="$AplCod != ''">
					<i><xsl:value-of select="DATA/METRICAS/APLICACION[@CODIGO = $AplCod]/@DESCRIPCION"/></i>
				</xsl:if>
				<xsl:if test="$AplCod = ''">
					<i>TODAS</i>	
				</xsl:if>
			</td>
		</tr>
		<tr><td colspan="4">&#160;</td></tr>
		<!--Seleccin del modo de representacin de datos-->
		<tr><td align="left" colspan="4"><font size="+1"><b>Presentacin de Datos</b></font></td></tr>
		<tr>
			<td colspan="4">
				<b>&#160;Modo Dato</b>&#160;-->
				<xsl:choose>
					<xsl:when test="$desgloseSel = 'apl'">						
						&#160;Representacin&#160;Desglosada&#160;Por&#160;<i>Aplicacin</i> <xsl:if test="$estadoSel='est'">(Muestra Informacin Estado)</xsl:if>
					</xsl:when>
					<xsl:when test="$desgloseSel = 'sec'">						
						&#160;Representacin&#160;Desglosada&#160;Por&#160;<i>Seccin</i> <xsl:if test="$estadoSel='est'">(Muestra Informacin Estado)</xsl:if>
					</xsl:when>
					<xsl:otherwise>
						&#160;Representacin&#160;Conjunta <xsl:if test="$estadoSel='est'">(Muestra Informacin Estado)</xsl:if>
					</xsl:otherwise>
				</xsl:choose>
			</td>
		</tr>
		<tr><td colspan="4">&#160;</td></tr>
		<tr><td colspan="4"><font size="+1"><b>Resultados</b></font></td></tr>
	</table>
	
	<xsl:choose>
		<xsl:when test="$desgloseSel = 'apl'">
			<xsl:for-each select="DATA/METRICAS/APLICACION[not(@PADRE) and (/XMLROOT/DATA/METRICAS/RESULTADO_METRICAS/@APLICACION=@CODIGO)]">
			<table width="100%">
				<xsl:variable name="apcod"><xsl:value-of select="@CODIGO"/></xsl:variable>
				<xsl:variable name="apname"><xsl:value-of select="@DESCRIPCION"/></xsl:variable>
				<xsl:if test="position()=1">
					<xsl:call-template name="ColumnasDesglose">
						<xsl:with-param name="fila" select="'0'"/>
						<xsl:with-param name="txt" select="'Aplicacin'"/>
						<xsl:with-param name="tipo" select="$perfil"/>
					</xsl:call-template>
					<!--
					<xsl:call-template name="ColumnasDesglose">
						<xsl:with-param name="fila" select="'1'"/>
					</xsl:call-template>
					-->
					<xsl:call-template name="ColumnasDesglose">
						<xsl:with-param name="fila" select="'2'"/>
						<xsl:with-param name="tipo" select="$perfil"/>
					</xsl:call-template>
				</xsl:if>
				<tr class="administracion">
					<td><xsl:value-of select="$apname"/></td>
					<xsl:call-template name="ColumnasDesglose">
						<xsl:with-param name="fila" select="'N'"/>
						<xsl:with-param name="ruta" select="../RESULTADO_METRICAS[@APLICACION=$apcod]"/>
						<xsl:with-param name="desglo"><xsl:if test="$estadoSel = 'est'">ON</xsl:if></xsl:with-param>
						<xsl:with-param name="tipo" select="$perfil"/>
					</xsl:call-template>
				</tr>
			</table>
			</xsl:for-each>
		</xsl:when>
		<xsl:when test="$desgloseSel = 'sec'">
			<table width="100%" class="cont" border="0" cellpadding="3" cellspacing="1">
			<xsl:for-each select="DATA/METRICAS/SECCION[/XMLROOT/DATA/METRICAS/RESULTADO_METRICAS/@SECCION=@CODIGO]">
				<xsl:variable name="seccod"><xsl:value-of select="@CODIGO"/></xsl:variable>
				<xsl:variable name="secname"><xsl:value-of select="@DESCRIPCION"/></xsl:variable>
				<xsl:if test="position()=1">
					<xsl:call-template name="ColumnasDesglose">
						<xsl:with-param name="fila" select="'0'"/>
						<xsl:with-param name="txt" select="'Seccin'"/>
						<xsl:with-param name="tipo" select="$perfil"/>
					</xsl:call-template>
					<!--
					<xsl:call-template name="ColumnasDesglose">
						<xsl:with-param name="fila" select="'1'"/>
					</xsl:call-template>
					-->
					<xsl:call-template name="ColumnasDesglose">
						<xsl:with-param name="fila" select="'2'"/>
						<xsl:with-param name="tipo" select="$perfil"/>
					</xsl:call-template>
				</xsl:if>
				<tr class="administracion">
					<td><xsl:value-of select="$secname"/></td>
					<xsl:call-template name="ColumnasDesglose">
						<xsl:with-param name="fila" select="'N'"/>
						<xsl:with-param name="ruta" select="../RESULTADO_METRICAS[@SECCION=$seccod]"/>
						<xsl:with-param name="desglo"><xsl:if test="$estadoSel = 'est'">ON</xsl:if></xsl:with-param>
						<xsl:with-param name="tipo" select="$perfil"/>
					</xsl:call-template>
				</tr>
			</xsl:for-each>
			</table>
		</xsl:when>
		<xsl:otherwise>
			<xsl:call-template name="SinDesglose">
				<xsl:with-param name="desglo"><xsl:if test="$estadoSel = 'est'">ON</xsl:if></xsl:with-param>
			</xsl:call-template>
		</xsl:otherwise>
	</xsl:choose>
	
	<table class="cont" border="0" cellpadding="3" cellspacing="1" width="100%">
		<xsl:if test="count(DATA/METRICAS/RESULTADO_METRICAS)=0">
			<tr class="administracion">
				<td align="center" colspan="10">* METRICAS sin datos.</td>
			</tr>
		</xsl:if>
		<tr class="administracion" align="center"><td colspan="10"><CENTER><input type="button" class="boton" value="Cerrar" onclick="javascript:window.close()" /></CENTER></td></tr>
	</table>
		
</body>
</html>
</xsl:template>

</xsl:stylesheet>
