<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet version="1.0" 
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:xforms="http://www.w3.org/2002/xforms">

<xsl:param name="servlet"/>	
<xsl:param name="menu"/>

<xsl:include href="dumbo7/utils/xsl/utils.xsl"/>
<!--Include para los template que se encargan de jerarquizar el select de secciones-->
<xsl:include href="dumbo7/metricas/html/ArbolEnSelect.xsl"/>
	
<xsl:template match="XMLROOT">

<html lang="es">
	<xsl:call-template name="headComun">
		 <xsl:with-param name="calendar" select="not(contains($menu,'Inc'))"/>
		 <xsl:with-param name="jscript">
			<script LANGUAJE="JavaScript">
				var srvServlet = '<xsl:value-of select="$servlet"/>';	
			</script>
			<script LANGUAJE="JavaScript" src="../js/metricas/Calendario.js"></script>
			<script LANGUAJE="JavaScript" src="../js/CompruebaFecha.js"></script>
			<script LANGUAJE="JavaScript" src="../js/metricas/selectDisabled.js"></script>
			<script LANGUAJE="JavaScript" src="../js/metricas/generalGestor.js"></script>
		</xsl:with-param>
	 </xsl:call-template>

<body>

	<xsl:call-template name="menuComun">
		<xsl:with-param name="MENU" select="DATA/MENU"/>
		<xsl:with-param name="NAME" select="concat(DATA/METRICAS/USER/@NAME,concat('(',concat(DATA/METRICAS/USER/@LOGIN,')')))"/>
		<xsl:with-param name="SELECT" select="$menu"/>
				<xsl:with-param name="HELP">metricas.xml#1.2.9</xsl:with-param>
	</xsl:call-template>

<xsl:call-template name="pieComun"/>
	</body>
	</html>
</xsl:template>

<xsl:template name="cuerpo">
	
	<form name="rdos" action="{$servlet}" method="post">
		<input type="hidden" name="module" value=""/>
		<input type="hidden" name="estadoSel" value=""/>
		<input type="hidden" name="desgloseSel" value=""/>
		<input type="hidden" name="perfil"><xsl:attribute name="value"><xsl:call-template name="traduce"><xsl:with-param name="id" select="'Informatico'"/></xsl:call-template></xsl:attribute></input>
		<input type="hidden" name="FechaDesde" value=""/>
		<input type="hidden" name="FechaHasta" value=""/>
		<input type="hidden" name="AplCod" value=""/>
		<input type="hidden" name="SecCod" value=""/>
	</form>
	<xsl:if test="not(DATA/METRICAS/@ERROR='')">
		<script>mostrarError('<xsl:value-of select="@ERROR"/>')</script>
	</xsl:if>
	<table border="0" cellpadding="5" align="center" cellspacing="5" width="780" summary="Esta tabla contiene las mtricas de tareas Sin Prioridad Asignada">
	<tr><td width="650" class="cab1">&#187;Mtrica General (<xsl:call-template name="traduce"><xsl:with-param name="id" select="'Informatico'"/></xsl:call-template>)</td></tr>
	<tr><td colspan="2">
	<form action="{$servlet}" METHOD="POST" name="metricas">
		<input type="hidden" name="module" value = "dumbo7/metricas/general.formGeneralInformatico"/>
		<table class="cont" id="metricas" border="0" cellpadding="3" cellspacing="1" width="100%" summary="Esta tabla contiene las mtricas">
		<tr class="cabe">
			<td width="450" colspan="2"><b>Parmetros</b></td>
			<td width="150" colspan="2"><b>Periodo</b></td>
		</tr>
		<tr class="administracion">
			<!--Seleccin de categora Se podrn seleccionar o 'TODAS' o una categora en concreto (en este caso se filtra)-->
			<td width="18%">
				Seccin:
			</td>
			<td width="60%">
				<select tabindex="1" name="SecCod" size="1" style="width:270px;" onChange="javascript:CambiosEnSeccion(this.options[this.selectedIndex].value)">
					<option value=''>&lt;-- Sin Filtro --></option>
					<!--Llamamos a la plantilla para indexar las categoras.-->
					<xsl:call-template name="muestraSeccionGestor">
						<xsl:with-param name="nodo" select="DATA/METRICAS"/>
					</xsl:call-template>
				</select>
			</td>
			<!--Seleccin fecha de inicio de la mtrica-->
			<td width="7%">Desde:&#160;&#160;</td>
			<td width="15%">
			<input tabindex="7" type="text" onChange="changeDate(this)" name="Fechas" id="f_FecDesde" size="11" value=""/>
							<img src="../dumbo7/utils/jscalendar/img.gif" id="f_trigger_a"
								style="cursor: pointer; border: 1px solid red;"
								title="Selecciona Fecha"
								onmouseover="this.style.background='red';"
								onmouseout="this.style.background=''"  />
			</td>
								<script type="text/javascript">
									Calendar.setup({
										inputField     :    "f_FecDesde",
										ifFormat       :    "%d/%m/%Y",
										button         :    "f_trigger_a",
										align          :    "Tl",
										onSelect       :    selectDateDesde,
										singleClick    :    false
										});
								</script>
		</tr>
		<tr class="administracion">
			<!--Seleccin de aplicacin. Se podrn seleccionar o 'TODAS' o una aplicacin en concreto (en este caso se filtra)-->
			<td>
				Aplicacin:
			</td>
			<td>
				<select tabindex="2" name="AplCod" size="1" style="width:270px;" onChange="javascript:comprobarSeleccionApl();">
					<option value=''>&lt;-- Sin Filtro --></option>
					<xsl:call-template name="muestraAplicaciones">
						<xsl:with-param name="nodo" select="DATA/METRICAS"/>
						<xsl:with-param name="espacio" select="'&#160;'"/>
					</xsl:call-template>
				</select>
			</td>
			<!--Seleccin fecha de fin de la mtrica-->
			<td>Hasta:&#160;&#160;</td>
			<td>
				<input tabindex="8" type="text" onChange="changeDate(this)" name="Fechas" id="f_FecHasta" size="11" value = ""/>
						<img src="../dumbo7/utils/jscalendar/img.gif" id="f_trigger_b"
							style="cursor: pointer; border: 1px solid red;"
							title="Selecciona Fecha"
							onmouseover="this.style.background='red';"
							onmouseout="this.style.background=''"/>
			</td>
							<script type="text/javascript">
								Calendar.setup({
								inputField     :    "f_FecHasta",
								ifFormat       :    "%d/%m/%Y",
								button         :    "f_trigger_b",
								align          :    "Tl",
								onSelect       :    selectDateHasta,
								singleClick    :    false
								});
			</script>
		</tr>
		<table class="cont" id="metricas" border="0" cellpadding="3" cellspacing="1" width="100%" summary="Esta tabla contiene las mtricas">
			<!--Seleccin del modo de representacin de datos-->
			<tr class="cabe">
				<td colspan="7"><b>Presentacin de datos</b></td>
			</tr>
			<tr class="administracion">
				<td width="1%">
					<input name="desgloseSel" type="radio" value="con" checked="true"/>
				</td>
				<td colspan="6">
					Representacin Conjunta
				</td>
			</tr>
			<tr class="administracion">
				<td>&#160;</td>
				<td colspan="6">
					Representacin Desglosada
				</td>
			</tr>
			<tr class="administracion">
				<td>&#160;</td>
				<td colspan="6">
					<input name="desgloseSel" type="radio" value="sec"/>&#160;&#160;Seccin
				</td>
			</tr>
			<tr class="administracion">
				<td>&#160;</td>
				<td colspan="6">
					<input name="desgloseSel" type="radio" value="apl"/>&#160;&#160;Aplicacin
				</td>
			</tr>
			<tr class="administracion">
				<td width="1%">
					<input name="estadoSel" type="checkbox" value="est"/>
				</td>
				<td colspan="6">
					Mostrar Informacin Por Estados
				</td>
			</tr>
			<tr class="administracion">
			<td align="center" colspan="7">
				<input tabindex="5" type="button" class="boton" value="Resultados HTML" onclick="javascript:enviarResultados('dumbo7/metricas/general.formGeneralInformatico.Resultado');"/>
				&#160;&#160;&#160;&#160;
				<input tabindex="5" type="button" class="boton" value="Resultados XLS" onclick="javascript:enviarResultados('dumbo7/metricas/general.formGeneralInformatico.ResultadoXls','Xls');"/>
			</td>
			</tr>
		</table>
	</table>
	</form>
	</td></tr>
	</table>
	
</xsl:template>

</xsl:stylesheet>