<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet version="1.0" 
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:xforms="http://www.w3.org/2002/xforms">


<!--PANTILLA PARA SACAR LAS SECCIONES DEL GESTOR JERARQUIZADAS-->
<xsl:template name="muestraSeccionGestor">
<xsl:param name="nodo"/>
    <xsl:for-each select="$nodo/SECCION[@CODIGO=@PADRE]">
        <xsl:sort select="@DESCRIPCION"/>
		<xsl:if test="@ESTADO='V'">
			<xsl:variable name="sec_cod"><xsl:value-of select="@CODIGO"/></xsl:variable>
			<xsl:if test="count($nodo/SECCION_RESPONSABLE[@CODIGO=$sec_cod])=0">
				<!--Con la variable subsecc sabemos si la seccin que estamos tratando tiene hijos
					que puedan deban ser mostrados y por lo tanto haya que mostarla desactivada
					Si no tiene hijos para mostrar, no se mostrara-->
				<xsl:variable name="subsecc">
					<xsl:call-template name="sacaSubSeccionGestor"> 
						<xsl:with-param name="nodo" select="$nodo"/>
			            <xsl:with-param name="codigo_padre" select="@CODIGO"/>
						<xsl:with-param name="espacio" select="'&#160;&#160;'"/>
					</xsl:call-template>
				</xsl:variable>
				<xsl:if test="string-length($subsecc)>0">
					<option disabled="disabled"><xsl:value-of select="@DESCRIPCION"/></option>
				</xsl:if>
			</xsl:if>
			<!--Si existe la seccin como responsable entonces la muestro activa-->
			<xsl:if test="count($nodo/SECCION_RESPONSABLE[@CODIGO=$sec_cod])!=0">
				<option value="{@CODIGO}"><xsl:value-of select="@DESCRIPCION"/></option>
			</xsl:if>
		</xsl:if>
		<xsl:call-template name="sacaSubSeccionGestor">
            <xsl:with-param name="nodo" select="$nodo"/>
            <xsl:with-param name="codigo_padre" select="@CODIGO"/>
            <xsl:with-param name="espacio" select="'&#160;&#160;'"/>
        </xsl:call-template>
    </xsl:for-each>
</xsl:template>

<xsl:template name="sacaSubSeccionGestor">
<xsl:param name="nodo"/>
<xsl:param name="codigo_padre"/>
<xsl:param name="espacio"/>
    <xsl:for-each select="$nodo/SECCION[@PADRE=$codigo_padre and @PADRE!=@CODIGO]">
        <xsl:sort select="@DESCRIPCION"/>
		<xsl:if test="@ESTADO='V'">
			<xsl:variable name="sec_cod"><xsl:value-of select="@CODIGO"/></xsl:variable>
			<xsl:if test="count($nodo/SECCION_RESPONSABLE[@CODIGO=$sec_cod])=0">
				<!--Con la variable subsecc sabemos si la seccin que estamos tratando tiene hijos
					que puedan deban ser mostrados y por lo tanto haya que mostarla desactivada
					Si no tiene hijos para mostrar, no se mostrara-->
				<xsl:variable name="subsecc">
					<xsl:call-template name="sacaSubSeccionGestor"> 
						<xsl:with-param name="nodo" select="$nodo"/>
			            <xsl:with-param name="codigo_padre" select="@CODIGO"/>
						<xsl:with-param name="espacio" select="'&#160;&#160;'"/>
					</xsl:call-template>
				</xsl:variable>
				<xsl:if test="string-length($subsecc)>0">
					<option disabled="disabled"><xsl:value-of select="concat($espacio,@DESCRIPCION)"/></option>
				</xsl:if>
			</xsl:if>
			<!--Si existe la seccin como responsable entonces la muestro activa-->
			<xsl:if test="count($nodo/SECCION_RESPONSABLE[@CODIGO=$sec_cod])!=0">
				<option value="{@CODIGO}"><xsl:value-of select="concat($espacio,@DESCRIPCION)"/></option>
			</xsl:if>
		</xsl:if>
        <xsl:call-template name="sacaSubSeccionGestor">
            <xsl:with-param name="nodo" select="$nodo"/>
            <xsl:with-param name="codigo_padre" select="@CODIGO"/>
            <xsl:with-param name="espacio" select="concat($espacio,'&#160;&#160;')"/>
        </xsl:call-template>
    </xsl:for-each>
</xsl:template>



<!--PANTILLA PARA SACAR LAS SECCIONES DEL MAESTRO JERARQUIZADAS-->
<!--Plantillas para recorrer las diferentes secciones indexandolas-->
<xsl:template name="muestraSeccionMaestro">
<xsl:param name="nodo"/>
    <xsl:for-each select="$nodo/SECCION[@CODIGO=@PADRE]">
        <xsl:sort select="@DESCRIPCION"/>
		<xsl:if test="@ESTADO='V'">
	        <option value="{@CODIGO}"><xsl:value-of select="@DESCRIPCION"/></option>
		</xsl:if>
		<xsl:if test="@ESTADO='N'">
	        <option disabled="disabled" value="{@CODIGO}"><xsl:value-of select="@DESCRIPCION"/> [NV]</option>
		</xsl:if>
        <xsl:call-template name="sacaSubSeccionMaestro">
            <xsl:with-param name="seccion" select="$nodo"/>
            <xsl:with-param name="codigo_padre" select="@CODIGO"/>
            <xsl:with-param name="espacio" select="'&#160;&#160;'"/>
        </xsl:call-template>
    </xsl:for-each>
</xsl:template>

<xsl:template name="sacaSubSeccionMaestro">
<xsl:param name="seccion"/>
<xsl:param name="codigo_padre"/>
<xsl:param name="espacio"/>
    <xsl:for-each select="$seccion/SECCION[@PADRE=$codigo_padre and @PADRE!=@CODIGO]">
        <xsl:sort select="@DESCRIPCION"/>
		<xsl:if test="@ESTADO='V'">
	        <option value="{@CODIGO}"><xsl:value-of select="$espacio"/><xsl:value-of select="@DESCRIPCION"/></option>
		</xsl:if>
		<xsl:if test="@ESTADO='N'">
	        <option disabled="disabled" value="{@CODIGO}"><xsl:value-of select="$espacio"/><xsl:value-of select="@DESCRIPCION"/> [NV]</option>
		</xsl:if>
        <xsl:call-template name="sacaSubSeccionMaestro">
            <xsl:with-param name="seccion" select="$seccion"/>
            <xsl:with-param name="codigo_padre" select="@CODIGO"/>
            <xsl:with-param name="espacio" select="concat($espacio,'&#160;&#160;')"/>
        </xsl:call-template>
    </xsl:for-each>
</xsl:template>


<!--PLANTILLA PARA MOSTRAR LAS CATEGORAS JERARQUIZADAS, VALE PARA MAESTRO Y PARA GESTOR-->
<xsl:template name="muestraCategoria">
<xsl:param name="nodo"/>
 <xsl:for-each select="DATA/METRICAS/CATEGORIA[@CODIGO=@PADRE]">
		<xsl:sort select="@DESCRIPCION"/>
		<xsl:if test="@ESTADO='V'">
	        <option value="{@CODIGO}"><xsl:value-of select="@DESCRIPCION"/></option>
		</xsl:if>
		<xsl:call-template name="sacaSubCategoria">
			<xsl:with-param name="nodo" select="$nodo"/>
			<xsl:with-param name="codigo_padre" select="@CODIGO"/>
			<xsl:with-param name="espacio" select="'&#160;&#160;'"/>
		</xsl:call-template>
	</xsl:for-each>
</xsl:template>

<xsl:template name="sacaSubCategoria">
	<xsl:param name="nodo"/>
	<xsl:param name="codigo_padre"/>
	<xsl:param name="espacio"/>
		<xsl:for-each select="$nodo/CATEGORIA[@PADRE=$codigo_padre and @PADRE!=@CODIGO]">
			<xsl:sort select="@DESCRIPCION"/>
			<xsl:if test="@ESTADO='V'">
			    <option value="{@CODIGO}"><xsl:value-of select="$espacio"/><xsl:value-of select="@DESCRIPCION"/></option>
			</xsl:if>
			<xsl:call-template name="sacaSubCategoria">
				<xsl:with-param name="nodo" select="$nodo"/>
				<xsl:with-param name="codigo_padre" select="@CODIGO"/>
				<xsl:with-param name="espacio" select="concat($espacio,'&#160;&#160;')"/>
			</xsl:call-template>
		</xsl:for-each>
</xsl:template>

<!--PLANTILLA PARA MOSTRAR LAS APLICACONES DE "GESTOR" Y "MAESTRO" JERARQUIZADAS
	teniendo en cuenta que estn agrupadas por su seccin correspondiente la cual aparece en cabecera y con el fondo gris-->
<xsl:template name="muestraAplicaciones">
<xsl:param name="nodo"/>
<xsl:param name="espacio"/>
	<xsl:for-each select="$nodo/SECCION[@PADRE=@CODIGO]">
		<xsl:sort select="@DESCRIPCION"/>
		<xsl:variable name="secc" select="@CODIGO"/>
		<!--Si la seccin tiene aplicaciones, comenzamos el arbol recursivo directamente-->
		<xsl:if test="count(../APLICACION[@SECCION=$secc])>0">
			<option class="listas" value="-1"><xsl:value-of select="$espacio"/>[Seccin:<xsl:value-of select="@DESCRIPCION"/>]</option>	
			<!--Primeros las aplicaciones padres y dentro de estas sus hijos-->
			<xsl:for-each select="../APLICACION[@SECCION=$secc and not(@PADRE)]">
				<xsl:sort select="@DESCRIPCION"/>
				<xsl:if test="@ESTADO='V'">
					<option value="{@CODIGO}"><xsl:value-of select="$espacio"/><xsl:value-of select="@DESCRIPCION"/></option>
				</xsl:if>
				<xsl:if test="@ESTADO='N'">
					<option value="{@CODIGO}" disabled="disabled"><xsl:value-of select="$espacio"/><xsl:value-of select="@DESCRIPCION"/>[NV]</option>
				</xsl:if>
				<!--Ahora mostramos las aplicaciones hijas(si hay) de la padre anterior mostrada-->
				<xsl:variable name="aplPadre" select="@CODIGO"></xsl:variable>
				<xsl:for-each select="../APLICACION[@SECCION=$secc and @PADRE = $aplPadre]">
					<xsl:if test="@ESTADO='V'">
						<option value="{@CODIGO}"><xsl:value-of select="$espacio"/>&#160;&#160;&#160;<xsl:value-of select="@DESCRIPCION"/></option>
					</xsl:if>
					<xsl:if test="@ESTADO='N'">
						<option value="{@CODIGO}" disabled="disabled">&#160;&#160;&#160;<xsl:value-of select="$espacio"/><xsl:value-of select="@DESCRIPCION"/>[NV]</option>
					</xsl:if>
				</xsl:for-each>
			</xsl:for-each>
			<!--Si no hay aplicaciones padres pero si existen aplicaciones asociadas a esta seccin las mostramos-->
			<xsl:if test="count(../APLICACION[@SECCION=$secc and not(@PADRE)]) &lt;= 0">
				<xsl:for-each select="../APLICACION[@SECCION=$secc]">
					<xsl:if test="@ESTADO='V'">
						<option value="{@CODIGO}"><xsl:value-of select="$espacio"/><xsl:value-of select="@DESCRIPCION"/></option>
					</xsl:if>
					<xsl:if test="@ESTADO='N'">
						<option value="{@CODIGO}" disabled="disabled"><xsl:value-of select="$espacio"/><xsl:value-of select="@DESCRIPCION"/>[NV]</option>
					</xsl:if>
				</xsl:for-each>
			</xsl:if>
			<xsl:call-template name="sacaSubSeccionesAplicaciones">
				<xsl:with-param name="codigo_padre" select="$secc"/>
				<xsl:with-param name="espacio" select="concat($espacio,'&#160;&#160;')"/>
			</xsl:call-template>
		</xsl:if>
		<!--Se puede dar el caso de que el padre no posea aplicaciones pero alguno de sus hijos si-->
		<xsl:if test="count(../APLICACION[@SECCION=$secc])=0">
				<!--Con la variable subsecc sabemos si la seccin que estamos tratando tiene hijos
					que puedan deban ser mostrados y por lo tanto haya que mostarla desactivada
					Si no tiene hijos para mostrar, no se mostrara-->
				<xsl:variable name="subsecc">
					<xsl:call-template name="sacaSubSeccionesAplicaciones"> 
						<xsl:with-param name="codigo_padre" select="@CODIGO"/>
						<xsl:with-param name="espacio" select="'&#160;&#160;'"/>
					</xsl:call-template>
				</xsl:variable>
				<xsl:if test="string-length($subsecc)>0">
					<option class="listas" value="-1"><xsl:value-of select="$espacio"/>[Seccin:<xsl:value-of select="@DESCRIPCION"/>]</option>	
					<xsl:call-template name="sacaSubSeccionesAplicaciones">
						<xsl:with-param name="codigo_padre" select="@CODIGO"/>
						<xsl:with-param name="espacio" select="concat($espacio,'&#160;&#160;')"/>
					</xsl:call-template>
				</xsl:if>
		</xsl:if>
	</xsl:for-each>
</xsl:template>

<xsl:template name="sacaSubSeccionesAplicaciones">
	<xsl:param name="codigo_padre"/>
	<xsl:param name="espacio"/>
		<xsl:for-each select="../SECCION[@PADRE=$codigo_padre and @PADRE!=@CODIGO]">
			<xsl:sort select="@DESCRIPCION"/>
			<xsl:variable name="secc" select="@CODIGO"/>
			<!--Si la seccin tiene aplicaciones, comenzamos el arbol recursivo directamente-->
			<xsl:if test="count(../APLICACION[@SECCION=$secc])>0">
				<option class="listas" value="-1"><xsl:value-of select="$espacio"/>[Seccin:<xsl:value-of select="@DESCRIPCION"/>]</option>	
				<!--Primeros las aplicaciones padres y dentro de estas sus hijos-->
				<xsl:for-each select="../APLICACION[@SECCION=$secc and not(@PADRE)]">
					<xsl:sort select="@DESCRIPCION"/>
					<xsl:if test="@ESTADO='V'">
						<option value="{@CODIGO}"><xsl:value-of select="$espacio"/><xsl:value-of select="@DESCRIPCION"/></option>
					</xsl:if>
					<xsl:if test="@ESTADO='N'">
						<option value="{@CODIGO}" disabled="disabled"><xsl:value-of select="$espacio"/><xsl:value-of select="@DESCRIPCION"/>[NV]</option>
					</xsl:if>
					<!--Ahora mostramos las aplicaciones hijas(si hay) de la padre anterior mostrada-->
					<xsl:variable name="aplPadre" select="@CODIGO"></xsl:variable>
					<xsl:for-each select="../APLICACION[@SECCION=$secc and @PADRE = $aplPadre]">
						<xsl:if test="@ESTADO='V'">
							<option value="{@CODIGO}"><xsl:value-of select="$espacio"/>&#160;&#160;&#160;<xsl:value-of select="@DESCRIPCION"/></option>
						</xsl:if>
						<xsl:if test="@ESTADO='N'">
							<option value="{@CODIGO}" disabled="disabled">&#160;&#160;&#160;<xsl:value-of select="$espacio"/><xsl:value-of select="@DESCRIPCION"/>[NV]</option>
						</xsl:if>
					</xsl:for-each>
				</xsl:for-each>
				<!--Si no hay aplicaciones padres pero si existen aplicaciones asociadas a esta seccin las mostramos-->
				<xsl:if test="count(../APLICACION[@SECCION=$secc and not(@PADRE)]) &lt;= 0">
					<xsl:for-each select="../APLICACION[@SECCION=$secc]">
						<xsl:if test="@ESTADO='V'">
							<option value="{@CODIGO}"><xsl:value-of select="$espacio"/><xsl:value-of select="@DESCRIPCION"/></option>
						</xsl:if>
						<xsl:if test="@ESTADO='N'">
							<option value="{@CODIGO}" disabled="disabled"><xsl:value-of select="$espacio"/><xsl:value-of select="@DESCRIPCION"/>[NV]</option>
						</xsl:if>
					</xsl:for-each>
				</xsl:if>
				<xsl:call-template name="sacaSubSeccionesAplicaciones">
					<xsl:with-param name="codigo_padre" select="$secc"/>
					<xsl:with-param name="espacio" select="concat($espacio,'&#160;&#160;')"/>
				</xsl:call-template>
			</xsl:if>
			<!--Se puede dar el caso de que el padre no posea aplicaciones pero alguno de sus hijos si-->
			<xsl:if test="count(../APLICACION[@SECCION=$secc])=0">
				<!--Con la variable subsecc sabemos si la seccin que estamos tratando tiene hijos
					que puedan deban ser mostrados y por lo tanto haya que mostarla desactivada
					Si no tiene hijos para mostrar, no se mostrara-->
				<xsl:variable name="subsecc">
					<xsl:call-template name="sacaSubSeccionesAplicaciones"> 
						<xsl:with-param name="codigo_padre" select="@CODIGO"/>
						<xsl:with-param name="espacio" select="'&#160;&#160;'"/>
					</xsl:call-template>
				</xsl:variable>
				<xsl:if test="string-length($subsecc)>0">
					<option class="listas" value="-1"><xsl:value-of select="$espacio"/>[Seccin:<xsl:value-of select="@DESCRIPCION"/>]</option>	
					<xsl:call-template name="sacaSubSeccionesAplicaciones">
						<xsl:with-param name="codigo_padre" select="@CODIGO"/>
						<xsl:with-param name="espacio" select="concat($espacio,'&#160;&#160;')"/>
					</xsl:call-template>
				</xsl:if>
			</xsl:if>	
		</xsl:for-each>
</xsl:template>
</xsl:stylesheet>


	