<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet version="1.0" 
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:xforms="http://www.w3.org/2002/xforms">
	
<xsl:param name="servlet"/>
<xsl:param name="menu"/>	

<xsl:param name="tipo"/>

<xsl:include href="dumbo7/utils/xsl/utils.xsl"/>
	
<xsl:template match="XMLROOT">
	<xsl:if test="$tipo = 'usu'">
		<TITLE>DUMBO7: Busqueda de Usuarios</TITLE>
	</xsl:if>
	<xsl:if test="$tipo = 'inf'">
		<TITLE>DUMBO7: Busqueda de <xsl:call-template name="traduce"><xsl:with-param name="id" select="'Informticos'"/></xsl:call-template></TITLE>
	</xsl:if>
	
<html lang="es">
	<xsl:call-template name="headComun">
		 <xsl:with-param name="jscript">
			<script LANGUAJE="JavaScript">
				function mostarError(error){
					alert(error);
				}
				function enviarAMadre(id,nombre,apellidos,correo){
					if('<xsl:value-of select="$tipo"/>' == 'usu'){
						window.opener.document.metricas.UsuCod.value = id;
						window.opener.document.metricas.UsuId.value = id;
						window.opener.document.metricas.UsuNombre.value = nombre; 
						window.opener.document.metricas.UsuApe.value = apellidos; 
						window.opener.document.metricas.UsuCorreo.value = correo;
						}
					else{
						window.opener.document.metricas.InfCod.value = id;
						window.opener.document.metricas.InfId.value = id;
						window.opener.document.metricas.InfNombre.value = nombre; 
						window.opener.document.metricas.InfApe.value = apellidos; 
						window.opener.document.metricas.InfCorreo.value = correo; 
					}
					window.window.close();
				}
				function cerrar(){
					window.window.close();
				}
			</script>
		</xsl:with-param>
	 </xsl:call-template>
	
<body>
	
	<table border="0" cellpadding="3" cellspacing="3" width="500" summary="Tabla con resultado de bsqueda">
	<tr>
		<td width="5%" class="celdapaipuc">Id</td>
		<td width="20%" class="celdapaipuc">Correo</td>
		<td width="90%" class="celdapaipuc">Apellidos,Nombre</td>
		<td width="10%" class="celdapaipuc"><a href="javascript:cerrar()">Cerrar</a></td>
	</tr>
	<!--Para evitar error al usar el caracter ' y para que pase bien los acentos usamos arrays dentro
		de los tags SCRIPT para los nombres y apellidos (que son los campos que pueden contener
		acentos y tildes. Cada lnea queda indexada con el array a travs del identificador.-->
		<SCRIPT>
			var arrayNombres = new Array();
			var arrayApellidos = new Array();
		</SCRIPT>	
		
		<xsl:for-each select="DATA/METRICAS/USUARIO">
			<tr>
				<td>
					<xsl:value-of select="@IDENTIFICADOR"/>-<xsl:value-of select="@LETRA"/>
				</td>
				<td>
					<xsl:value-of select="@EMAIL"/>
				</td>
				<td colspan="2" align="left">
					<SCRIPT>
						arrayNombres['<xsl:value-of select="@IDENTIFICADOR"/>'] = "<xsl:value-of select="@NOMBRE"/>";
						arrayApellidos['<xsl:value-of select="@IDENTIFICADOR"/>'] = "<xsl:value-of select="@APELLIDOS"/>";
					</SCRIPT>
					<a href="JavaScript:enviarAMadre('{@IDENTIFICADOR}',arrayNombres['{@IDENTIFICADOR}'],arrayApellidos['{@IDENTIFICADOR}'],'{@EMAIL}')">
							<xsl:value-of select="@APELLIDOS"/>,<xsl:value-of select="@NOMBRE"/>
					</a>
				</td>
			</tr>
		</xsl:for-each>	
			
		<xsl:if test="count(DATA/METRICAS/USUARIO)=0">
			<tr>
				<td align="center">Sin&#160;Resultados</td>
			</tr>
		</xsl:if>
		<tr><td width="100%" colspan="4" class="celdapaipuc2">&#160;</td></tr>
	</table>
</body>
</html>
</xsl:template>

<xsl:template name ="cuerpo"/>
</xsl:stylesheet>
	