<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet version="1.0"
    xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
    xmlns:xforms="http://www.w3.org/2002/xforms">

<xsl:output method="text"/>

<xsl:param name="servlet"/>   
<xsl:param name="menu"/>
<xsl:param name="seccion"/>
<xsl:param name="maestro"/>

<xsl:include href="dumbo7/utils/xsl/utils.xsl"/>

<xsl:template match="XMLROOT">
	<xsl:if test="$maestro">
		<xsl:call-template name="muestraAplicacionesMaestro"/>
	</xsl:if>
	<xsl:if test="not($maestro)">
		<xsl:call-template name="muestraAplicacionesGestor"/>
	</xsl:if>
</xsl:template>

<!--******************************************************GESTOR************************************************-->
<xsl:template name="muestraAplicacionesGestor">
	var j = 1;
	<xsl:variable name="espacio" select="''"/>
	<!--Si se introduce una seccin se busca desde esa todo el rbol correspondiente para mostrarlo,
		en esta se parte de una SECCIONES_RESPONSABLE, que se ha seleccionado y a partir de hay se desciende
		en el bol si hay-->
	<xsl:if test="$seccion != ''">
		<xsl:for-each select="DATA/METRICAS/SECCION_RESPONSABLE[(@CODIGO=$seccion)]">
			 document.metricas.AplCod.options[j] = new Option(<xsl:call-template name="entrecomillaDescripcion"><xsl:with-param name="descripcion" select="concat(concat('[Seccin:',@DESCRIPCION),']')"/></xsl:call-template>,'-1');
			 document.metricas.AplCod.options[j].className = 'listas';
			 j = j+1;
			 <!--Primeros las aplicaciones que son padres-->	
			 <xsl:for-each select="../APLICACION[(@SECCION=$seccion) and not(@PADRE)]">
				<xsl:sort select="@DESCRIPCION"/>
				<xsl:if test="@ESTADO='V'">
					document.metricas.AplCod.options[j] = new Option(<xsl:call-template name="entrecomillaDescripcion"><xsl:with-param name="descripcion" select="concat('&#160;&#160;',@DESCRIPCION)"/></xsl:call-template>,'<xsl:value-of select="@CODIGO"/>');
				</xsl:if>
				<xsl:if test="@ESTADO='N'">
					document.metricas.AplCod.options[j] = new Option(<xsl:call-template name="entrecomillaDescripcion"><xsl:with-param name="descripcion" select="concat(concat('&#160;&#160;',@DESCRIPCION),'[NV]')"/></xsl:call-template>,'<xsl:value-of select="@CODIGO"/>');
					document.metricas.AplCod.options[j].disabled = true;
				</xsl:if>
				j = j+1;
				<!--Ahora mostramos las aplicaciones hijas(si hay) de la padre anterior mostrada-->
				<xsl:variable name="aplPadre" select="@CODIGO"></xsl:variable>
				<xsl:for-each select="../APLICACION[@SECCION=$seccion and @PADRE = $aplPadre]">
					<xsl:if test="@ESTADO='V'">
						document.metricas.AplCod.options[j] = new Option(<xsl:call-template name="entrecomillaDescripcion"><xsl:with-param name="descripcion" select="concat('&#160;&#160;&#160;&#160;&#160;',@DESCRIPCION)"/></xsl:call-template>,'<xsl:value-of select="@CODIGO"/>');
					</xsl:if>
					<xsl:if test="@ESTADO='N'">
						document.metricas.AplCod.options[j] = new Option(<xsl:call-template name="entrecomillaDescripcion"><xsl:with-param name="descripcion" select="concat(concat('&#160;&#160;&#160;&#160;&#160;',@DESCRIPCION),'[NV]')"/></xsl:call-template>,'<xsl:value-of select="@CODIGO"/>');
						document.metricas.AplCod.options[j].disabled = true;
					</xsl:if>
					j = j+1;
				</xsl:for-each>
			</xsl:for-each>
			<!--Si no hay aplicaciones padres pero si existen aplicaciones asociadas a esta seccin las mostramos-->
			<xsl:if test="count(../APLICACION[@SECCION=$seccion and not(@PADRE)]) &lt;= 0">
				<xsl:for-each select="../APLICACION[@SECCION=$seccion]">
					<xsl:if test="@ESTADO='V'">
						document.metricas.AplCod.options[j] = new Option(<xsl:call-template name="entrecomillaDescripcion"><xsl:with-param name="descripcion" select="concat('&#160;&#160;',@DESCRIPCION)"/></xsl:call-template>,'<xsl:value-of select="@CODIGO"/>');
					</xsl:if>
					<xsl:if test="@ESTADO='N'">
						document.metricas.AplCod.options[j] = new Option(<xsl:call-template name="entrecomillaDescripcion"><xsl:with-param name="descripcion" select="concat(concat('&#160;&#160;',@DESCRIPCION),'[NV]')"/></xsl:call-template>,'<xsl:value-of select="@CODIGO"/>');
						document.metricas.AplCod.options[j].disabled = true;
					</xsl:if>
					j = j+1;
				</xsl:for-each>
			</xsl:if>
		</xsl:for-each>
		
		<xsl:for-each select="DATA/METRICAS/SECCION[(@PADRE=$seccion) and not (@CODIGO=$seccion)]">
			<xsl:sort select="@DESCRIPCION"/>
			<xsl:call-template name="muestraAplicaciones">
				<xsl:with-param name="codigo_padre" select="@CODIGO"/>
				<xsl:with-param name="espacio" select="concat($espacio,'&#160;&#160;')"/>
			</xsl:call-template>
		</xsl:for-each>
	</xsl:if>
	<!--Si NO se introduce seccion es que el filtro debe reiniciarse teniendo en cuenta las aplicaciones asociadas 
		al gestor como responsable, en este caso no se tiene en cuenta solo SECCION_RESPONSABLE, porque puede ser
		que el gestor tenga aplicacines asociadas con seccines en las que no es responsable-->
	<xsl:if test="$seccion = ''">
		<xsl:for-each select="DATA/METRICAS/SECCION[@PADRE=@CODIGO]">
		<xsl:sort select="@DESCRIPCION"/>
		<xsl:variable name="secc" select="@CODIGO"/>
		<!--Si la seccin tiene aplicaciones, comenzamos el arbol recursivo directamente-->
		<xsl:if test="count(../APLICACION[@SECCION=$secc])>0">
			 document.metricas.AplCod.options[j] = new Option(<xsl:call-template name="entrecomillaDescripcion"><xsl:with-param name="descripcion" select="concat(concat('[Seccin:',@DESCRIPCION),']')"/></xsl:call-template>,'-1');
			 document.metricas.AplCod.options[j].className = 'listas';
			 j = j+1;
			 <!--Primeros las aplicaciones que son padres-->
			<xsl:for-each select="../APLICACION[(@SECCION=$secc) and not(@PADRE)]">
				<xsl:sort select="@DESCRIPCION"/>
				<xsl:if test="@ESTADO='V'">
					document.metricas.AplCod.options[j] = new Option(<xsl:call-template name="entrecomillaDescripcion"><xsl:with-param name="descripcion" select="concat('&#160;&#160;',@DESCRIPCION)"/></xsl:call-template>,'<xsl:value-of select="@CODIGO"/>');
				</xsl:if>
				<xsl:if test="@ESTADO='N'">
					document.metricas.AplCod.options[j] = new Option(<xsl:call-template name="entrecomillaDescripcion"><xsl:with-param name="descripcion" select="concat(concat('&#160;&#160;',@DESCRIPCION),'[NV]')"/></xsl:call-template>,'<xsl:value-of select="@CODIGO"/>');
					document.metricas.AplCod.options[j].disabled = true;
				</xsl:if>
				j = j+1;
				<!--Ahora mostramos las aplicaciones hijas(si hay) de la padre anterior mostrada-->
				<xsl:variable name="aplPadre" select="@CODIGO"></xsl:variable>
				<xsl:for-each select="../APLICACION[@SECCION=$secc and @PADRE = $aplPadre]">
					<xsl:if test="@ESTADO='V'">
						document.metricas.AplCod.options[j] = new Option(<xsl:call-template name="entrecomillaDescripcion"><xsl:with-param name="descripcion" select="concat('&#160;&#160;&#160;&#160;&#160;',@DESCRIPCION)"/></xsl:call-template>,'<xsl:value-of select="@CODIGO"/>');
					</xsl:if>
					<xsl:if test="@ESTADO='N'">
						document.metricas.AplCod.options[j] = new Option(<xsl:call-template name="entrecomillaDescripcion"><xsl:with-param name="descripcion" select="concat(concat('&#160;&#160;&#160;&#160;&#160;',@DESCRIPCION),'[NV]')"/></xsl:call-template>,'<xsl:value-of select="@CODIGO"/>');
						document.metricas.AplCod.options[j].disabled = true;
					</xsl:if>
					j = j+1;
				</xsl:for-each>	
			</xsl:for-each>
			<!--Si no hay aplicaciones padres pero si existen aplicaciones asociadas a esta seccin las mostramos-->
			<xsl:if test="count(../APLICACION[@SECCION=$secc and not(@PADRE)]) &lt;= 0">
				<xsl:for-each select="../APLICACION[@SECCION=$secc]">
					<xsl:if test="@ESTADO='V'">
						document.metricas.AplCod.options[j] = new Option(<xsl:call-template name="entrecomillaDescripcion"><xsl:with-param name="descripcion" select="concat('&#160;&#160;',@DESCRIPCION)"/></xsl:call-template>,'<xsl:value-of select="@CODIGO"/>');
					</xsl:if>
					<xsl:if test="@ESTADO='N'">
						document.metricas.AplCod.options[j] = new Option(<xsl:call-template name="entrecomillaDescripcion"><xsl:with-param name="descripcion" select="concat(concat('&#160;&#160;',@DESCRIPCION),'[NV]')"/></xsl:call-template>,'<xsl:value-of select="@CODIGO"/>');
						document.metricas.AplCod.options[j].disabled = true;
					</xsl:if>
					j = j+1;
				</xsl:for-each>
			</xsl:if>
			<xsl:call-template name="sacaSubSeccionesAplicaciones">
				<xsl:with-param name="codigo_padre" select="$secc"/>
				<xsl:with-param name="espacio" select="concat($espacio,'&#160;&#160;')"/>
			</xsl:call-template>
		</xsl:if>
		<!--Se puede dar el caso de que el padre no posea aplicaciones pero alguno de sus hijos si-->
		<xsl:if test="count(../APLICACION[@SECCION=$secc])=0">
				<!--Con la variable subsecc sabemos si la seccin que estamos tratando tiene hijos
					que puedan deban ser mostrados y por lo tanto haya que mostarla desactivada
					Si no tiene hijos para mostrar, no se mostrara-->
				<xsl:variable name="subsecc">
					<xsl:call-template name="sacaSubSeccionesAplicaciones"> 
						<xsl:with-param name="codigo_padre" select="@CODIGO"/>
						<xsl:with-param name="espacio" select="'&#160;&#160;'"/>
					</xsl:call-template>
				</xsl:variable>
				<xsl:if test="string-length($subsecc)>0">
					 document.metricas.AplCod.options[j] = new Option(<xsl:call-template name="entrecomillaDescripcion"><xsl:with-param name="descripcion" select="concat(concat('[Seccin:',@DESCRIPCION),']')"/></xsl:call-template>,'-1');
					 document.metricas.AplCod.options[j].className = 'listas';
					 j = j+1;
					<xsl:call-template name="sacaSubSeccionesAplicaciones">
						<xsl:with-param name="codigo_padre" select="@CODIGO"/>
						<xsl:with-param name="espacio" select="concat($espacio,'&#160;&#160;')"/>
					</xsl:call-template>
				</xsl:if>
			</xsl:if>
		</xsl:for-each>
	</xsl:if>
</xsl:template>

<!--Este template se encarga de mostrar las aplicaciones teniendo en cuenta la agrupacin por secciones y la seccin
	que se ha introducido como padre(en este caso tambin se mostrarn los hijos de esta seccion con sus aplicaciones)-->
<xsl:template name="muestraAplicaciones">
<xsl:param name="codigo_padre"/>
<xsl:param name="espacio"/>
		<xsl:if test="count(../APLICACION[@SECCION=$codigo_padre])>0">
			 document.metricas.AplCod.options[j] = new Option(<xsl:call-template name="entrecomillaDescripcion"><xsl:with-param name="descripcion" select="concat(concat('[Seccin:',@DESCRIPCION),']')"/></xsl:call-template>,'-1');
			document.metricas.AplCod.options[j].className = 'listas';
			j = j+1;
			<!--Primeros las aplicaciones que son padres-->	
			<xsl:for-each select="../APLICACION[(@SECCION=$codigo_padre) and not(@PADRE)]">
				<xsl:sort select="@DESCRIPCION"/>
				<xsl:if test="@ESTADO='V'">
					document.metricas.AplCod.options[j] = new Option(<xsl:call-template name="entrecomillaDescripcion"><xsl:with-param name="descripcion" select="concat('&#160;&#160;',@DESCRIPCION)"/></xsl:call-template>,'<xsl:value-of select="@CODIGO"/>');
				</xsl:if>
				<xsl:if test="@ESTADO='N'">
					document.metricas.AplCod.options[j] = new Option(<xsl:call-template name="entrecomillaDescripcion"><xsl:with-param name="descripcion" select="concat(concat('&#160;&#160;',@DESCRIPCION),'[NV]')"/></xsl:call-template>,'<xsl:value-of select="@CODIGO"/>');
					document.metricas.AplCod.options[j].disabled = true;
				</xsl:if>
				j = j+1;
				<!--Ahora mostramos las aplicaciones hijas(si hay) de la padre anterior mostrada-->
				<xsl:variable name="aplPadre" select="@CODIGO"></xsl:variable>
				<xsl:for-each select="../APLICACION[@SECCION=$codigo_padre and @PADRE = $aplPadre]">
					<xsl:if test="@ESTADO='V'">
						document.metricas.AplCod.options[j] = new Option(<xsl:call-template name="entrecomillaDescripcion"><xsl:with-param name="descripcion" select="concat('&#160;&#160;&#160;&#160;&#160;',@DESCRIPCION)"/></xsl:call-template>,'<xsl:value-of select="@CODIGO"/>');
					</xsl:if>
					<xsl:if test="@ESTADO='N'">
						document.metricas.AplCod.options[j] = new Option(<xsl:call-template name="entrecomillaDescripcion"><xsl:with-param name="descripcion" select="concat(concat('&#160;&#160;&#160;&#160;&#160;',@DESCRIPCION),'[NV]')"/></xsl:call-template>,'<xsl:value-of select="@CODIGO"/>');
						document.metricas.AplCod.options[j].disabled = true;
					</xsl:if>
					j = j+1;
				</xsl:for-each>
			</xsl:for-each>
			<!--Si no hay aplicaciones padres pero si existen aplicaciones asociadas a esta seccin las mostramos-->
			<xsl:if test="count(../APLICACION[@SECCION=$codigo_padre and not(@PADRE)]) &lt;= 0">
				<xsl:for-each select="../APLICACION[@SECCION=$codigo_padre]">
					<xsl:if test="@ESTADO='V'">
						document.metricas.AplCod.options[j] = new Option(<xsl:call-template name="entrecomillaDescripcion"><xsl:with-param name="descripcion" select="concat('&#160;&#160;',@DESCRIPCION)"/></xsl:call-template>,'<xsl:value-of select="@CODIGO"/>');
					</xsl:if>
					<xsl:if test="@ESTADO='N'">
						document.metricas.AplCod.options[j] = new Option(<xsl:call-template name="entrecomillaDescripcion"><xsl:with-param name="descripcion" select="concat(concat('&#160;&#160;',@DESCRIPCION),'[NV]')"/></xsl:call-template>,'<xsl:value-of select="@CODIGO"/>');
						document.metricas.AplCod.options[j].disabled = true;
					</xsl:if>
					j = j+1;
				</xsl:for-each>
			</xsl:if>
		</xsl:if>
		<xsl:for-each select="../SECCION[@PADRE=$codigo_padre]">
			<xsl:call-template name="muestraAplicaciones">
				<xsl:with-param name="codigo_padre" select="@CODIGO"/>
				<xsl:with-param name="espacio" select="concat($espacio,'&#160;&#160;')"/>
			</xsl:call-template>
		</xsl:for-each>
</xsl:template>


<!--Si NO se introduce seccion es que el filtro debe reiniciarse teniendo en cuenta las aplicaciones asociadas 
		al gestor como responsable-->
<xsl:template name="sacaSubSeccionesAplicaciones">
	<xsl:param name="codigo_padre"/>
	<xsl:param name="espacio"/>
		<xsl:for-each select="../SECCION[@PADRE=$codigo_padre and @PADRE!=@CODIGO]">
			<xsl:sort select="@DESCRIPCION"/>
			<xsl:variable name="secc" select="@CODIGO"/>
			<!--Si la seccin tiene aplicaciones, comenzamos el arbol recursivo directamente-->
			<xsl:if test="count(../APLICACION[@SECCION=$secc])>0">
				document.metricas.AplCod.options[j] = new Option(<xsl:call-template name="entrecomillaDescripcion"><xsl:with-param name="descripcion" select="concat(concat('[Seccin:',@DESCRIPCION),']')"/></xsl:call-template>,'-1');
				document.metricas.AplCod.options[j].className = 'listas';
				j = j+1;
				<!--Primeros las aplicaciones que son padres-->
				<xsl:for-each select="../APLICACION[(@SECCION=$secc) and not(@PADRE)]">
					<xsl:sort select="@DESCRIPCION"/>
					<xsl:if test="@ESTADO='V'">
						document.metricas.AplCod.options[j] = new Option(<xsl:call-template name="entrecomillaDescripcion"><xsl:with-param name="descripcion" select="concat('&#160;&#160;',@DESCRIPCION)"/></xsl:call-template>,'<xsl:value-of select="@CODIGO"/>');
					</xsl:if>
					<xsl:if test="@ESTADO='N'">
						document.metricas.AplCod.options[j] = new Option(<xsl:call-template name="entrecomillaDescripcion"><xsl:with-param name="descripcion" select="concat(concat('&#160;&#160;',@DESCRIPCION),'[NV]')"/></xsl:call-template>,'<xsl:value-of select="@CODIGO"/>');
						document.metricas.AplCod.options[j].disabled = true;
					</xsl:if>
					j = j+1;
					<!--Ahora mostramos las aplicaciones hijas(si hay) de la padre anterior mostrada-->
					<xsl:variable name="aplPadre" select="@CODIGO"></xsl:variable>
					<xsl:for-each select="../APLICACION[@SECCION=$secc and @PADRE = $aplPadre]">
						<xsl:if test="@ESTADO='V'">
							document.metricas.AplCod.options[j] = new Option(<xsl:call-template name="entrecomillaDescripcion"><xsl:with-param name="descripcion" select="concat('&#160;&#160;&#160;&#160;&#160;',@DESCRIPCION)"/></xsl:call-template>,'<xsl:value-of select="@CODIGO"/>');
						</xsl:if>
						<xsl:if test="@ESTADO='N'">
							document.metricas.AplCod.options[j] = new Option(<xsl:call-template name="entrecomillaDescripcion"><xsl:with-param name="descripcion" select="concat(concat('&#160;&#160;&#160;&#160;&#160;',@DESCRIPCION),'[NV]')"/></xsl:call-template>,'<xsl:value-of select="@CODIGO"/>');
							document.metricas.AplCod.options[j].disabled = true;
						</xsl:if>
						j = j+1;
					</xsl:for-each>
				</xsl:for-each>
				<!--Si no hay aplicaciones padres pero si existen aplicaciones asociadas a esta seccin las mostramos-->
				<xsl:if test="count(../APLICACION[@SECCION=$secc and not(@PADRE)]) &lt;= 0">
					<xsl:for-each select="../APLICACION[@SECCION=$secc]">
						<xsl:if test="@ESTADO='V'">
							document.metricas.AplCod.options[j] = new Option(<xsl:call-template name="entrecomillaDescripcion"><xsl:with-param name="descripcion" select="concat('&#160;&#160;',@DESCRIPCION)"/></xsl:call-template>,'<xsl:value-of select="@CODIGO"/>');
						</xsl:if>
						<xsl:if test="@ESTADO='N'">
							document.metricas.AplCod.options[j] = new Option(<xsl:call-template name="entrecomillaDescripcion"><xsl:with-param name="descripcion" select="concat(concat('&#160;&#160;',@DESCRIPCION),'[NV]')"/></xsl:call-template>,'<xsl:value-of select="@CODIGO"/>');
							document.metricas.AplCod.options[j].disabled = true;
						</xsl:if>
						j = j+1;
					</xsl:for-each>
				</xsl:if>
				<xsl:call-template name="sacaSubSeccionesAplicaciones">
					<xsl:with-param name="codigo_padre" select="$secc"/>
					<xsl:with-param name="espacio" select="concat($espacio,'&#160;&#160;')"/>
				</xsl:call-template>
			</xsl:if>
			<!--Se puede dar el caso de que el padre no posea aplicaciones pero alguno de sus hijos si-->
			<xsl:if test="count(../APLICACION[@SECCION=$secc])=0">
				<!--Con la variable subsecc sabemos si la seccin que estamos tratando tiene hijos
					que puedan deban ser mostrados y por lo tanto haya que mostarla desactivada
					Si no tiene hijos para mostrar, no se mostrara-->
				<xsl:variable name="subsecc">
					<xsl:call-template name="sacaSubSeccionesAplicaciones"> 
						<xsl:with-param name="codigo_padre" select="@CODIGO"/>
						<xsl:with-param name="espacio" select="'&#160;&#160;'"/>
					</xsl:call-template>
				</xsl:variable>
				<xsl:if test="string-length($subsecc)>0">
					document.metricas.AplCod.options[j] = new Option(<xsl:call-template name="entrecomillaDescripcion"><xsl:with-param name="descripcion" select="concat(concat('[Seccin:',@DESCRIPCION),']')"/></xsl:call-template>,'-1');
					document.metricas.AplCod.options[j].className = 'listas';
					j = j+1;
					<xsl:call-template name="sacaSubSeccionesAplicaciones">
						<xsl:with-param name="codigo_padre" select="@CODIGO"/>
						<xsl:with-param name="espacio" select="concat($espacio,'&#160;&#160;')"/>
					</xsl:call-template>
				</xsl:if>
			</xsl:if>	
		</xsl:for-each>
</xsl:template>



<!--******************************************************MAESTRO************************************************-->
<xsl:template name="muestraAplicacionesMaestro">
	var j = 1;
	<xsl:variable name="espacio" select="''"/>
	<!--Si se introduce una seccin se busca desde esa todo el rbol correspondiente para mostrarlo-->
	<xsl:if test="$seccion != ''">
		<xsl:for-each select="DATA/METRICAS/SECCION[(@CODIGO=$seccion)]">
			 document.metricas.AplCod.options[j] = new Option(<xsl:call-template name="entrecomillaDescripcion"><xsl:with-param name="descripcion" select="concat(concat('[Seccin:',@DESCRIPCION),']')"/></xsl:call-template>,'-1');
			 document.metricas.AplCod.options[j].className = 'listas';
			 j = j+1;	
			 <!--Primeros las aplicaciones que son padres-->
			 <xsl:for-each select="../APLICACION[(@SECCION=$seccion) and not(@PADRE)]">
				<xsl:sort select="@DESCRIPCION"/>
				<xsl:if test="@ESTADO='V'">
					document.metricas.AplCod.options[j] = new Option(<xsl:call-template name="entrecomillaDescripcion"><xsl:with-param name="descripcion" select="concat('&#160;&#160;',@DESCRIPCION)"/></xsl:call-template>,'<xsl:value-of select="@CODIGO"/>');
				</xsl:if>
				<xsl:if test="@ESTADO='N'">
					document.metricas.AplCod.options[j] = new Option(<xsl:call-template name="entrecomillaDescripcion"><xsl:with-param name="descripcion" select="concat(concat('&#160;&#160;',@DESCRIPCION),'[NV]')"/></xsl:call-template>,'<xsl:value-of select="@CODIGO"/>');
					document.metricas.AplCod.options[j].disabled = true;
				</xsl:if>
				j = j+1;
				<!--Ahora mostramos las aplicaciones hijas(si hay) de la padre anterior mostrada-->
				<xsl:variable name="aplPadre" select="@CODIGO"></xsl:variable>
				<xsl:for-each select="../APLICACION[@SECCION=$seccion and @PADRE = $aplPadre]">
					<xsl:if test="@ESTADO='V'">
						document.metricas.AplCod.options[j] = new Option(<xsl:call-template name="entrecomillaDescripcion"><xsl:with-param name="descripcion" select="concat('&#160;&#160;&#160;&#160;&#160;',@DESCRIPCION)"/></xsl:call-template>,'<xsl:value-of select="@CODIGO"/>');
					</xsl:if>
					<xsl:if test="@ESTADO='N'">
						document.metricas.AplCod.options[j] = new Option(<xsl:call-template name="entrecomillaDescripcion"><xsl:with-param name="descripcion" select="concat(concat('&#160;&#160;&#160;&#160;&#160;',@DESCRIPCION),'[NV]')"/></xsl:call-template>,'<xsl:value-of select="@CODIGO"/>');
						document.metricas.AplCod.options[j].disabled = true;
					</xsl:if>
					j = j+1;
				</xsl:for-each>
			</xsl:for-each>
			<!--Si no hay aplicaciones padres pero si existen aplicaciones asociadas a esta seccin las mostramos-->
			<xsl:if test="count(../APLICACION[@SECCION=$seccion and not(@PADRE)]) &lt;= 0">
				<xsl:for-each select="../APLICACION[@SECCION=$seccion]">
					<xsl:if test="@ESTADO='V'">
						document.metricas.AplCod.options[j] = new Option(<xsl:call-template name="entrecomillaDescripcion"><xsl:with-param name="descripcion" select="concat('&#160;&#160;',@DESCRIPCION)"/></xsl:call-template>,'<xsl:value-of select="@CODIGO"/>');
					</xsl:if>
					<xsl:if test="@ESTADO='N'">
						document.metricas.AplCod.options[j] = new Option(<xsl:call-template name="entrecomillaDescripcion"><xsl:with-param name="descripcion" select="concat(concat('&#160;&#160;',@DESCRIPCION),'[NV]')"/></xsl:call-template>,'<xsl:value-of select="@CODIGO"/>');
						document.metricas.AplCod.options[j].disabled = true;
					</xsl:if>
					j = j+1;
				</xsl:for-each>
			</xsl:if>
		</xsl:for-each>
		
		<xsl:for-each select="DATA/METRICAS/SECCION[(@PADRE=$seccion) and not (@CODIGO=$seccion)]">
			<xsl:sort select="@DESCRIPCION"/>
			<xsl:call-template name="muestraAplicaciones">
				<xsl:with-param name="codigo_padre" select="@CODIGO"/>
				<xsl:with-param name="espacio" select="concat($espacio,'&#160;&#160;')"/>
			</xsl:call-template>
		</xsl:for-each>
	</xsl:if>
	<!--Si no se introduce seccion es que el filtro debe reiniciarse teniendo en cuenta las aplicaciones asociadas 
		al gestor como responsable-->
	<xsl:if test="$seccion = ''">
		<xsl:for-each select="DATA/METRICAS/SECCION[@PADRE=@CODIGO]">
		<xsl:sort select="@DESCRIPCION"/>
		<xsl:variable name="secc" select="@CODIGO"/>
		<!--Si la seccin tiene aplicaciones, comenzamos el arbol recursivo directamente-->
		<xsl:if test="count(../APLICACION[@SECCION=$secc])>0">
			 document.metricas.AplCod.options[j] = new Option(<xsl:call-template name="entrecomillaDescripcion"><xsl:with-param name="descripcion" select="concat(concat('[Seccin:',@DESCRIPCION),']')"/></xsl:call-template>,'-1');
			 document.metricas.AplCod.options[j].className = 'listas';
			 j = j+1;
			 <!--Primeros las aplicaciones que son padres-->
			<xsl:for-each select="../APLICACION[@SECCION=$secc and not(@PADRE)]">
				<xsl:sort select="@DESCRIPCION"/>
				<xsl:if test="@ESTADO='V'">
					document.metricas.AplCod.options[j] = new Option(<xsl:call-template name="entrecomillaDescripcion"><xsl:with-param name="descripcion" select="concat('&#160;&#160;',@DESCRIPCION)"/></xsl:call-template>,'<xsl:value-of select="@CODIGO"/>');
				</xsl:if>
				<xsl:if test="@ESTADO='N'">
					document.metricas.AplCod.options[j] = new Option(<xsl:call-template name="entrecomillaDescripcion"><xsl:with-param name="descripcion" select="concat(concat('&#160;&#160;',@DESCRIPCION),'[NV]')"/></xsl:call-template>,'<xsl:value-of select="@CODIGO"/>');
					document.metricas.AplCod.options[j].disabled = true;
				</xsl:if>
				j = j+1;
				<!--Ahora mostramos las aplicaciones hijas(si hay) de la padre anterior mostrada-->
				<xsl:variable name="aplPadre" select="@CODIGO"></xsl:variable>
				<xsl:for-each select="../APLICACION[@SECCION=$secc and @PADRE = $aplPadre]">
					<xsl:if test="@ESTADO='V'">
						document.metricas.AplCod.options[j] = new Option(<xsl:call-template name="entrecomillaDescripcion"><xsl:with-param name="descripcion" select="concat('&#160;&#160;&#160;&#160;&#160;',@DESCRIPCION)"/></xsl:call-template>,'<xsl:value-of select="@CODIGO"/>');
					</xsl:if>
					<xsl:if test="@ESTADO='N'">
						document.metricas.AplCod.options[j] = new Option(<xsl:call-template name="entrecomillaDescripcion"><xsl:with-param name="descripcion" select="concat(concat('&#160;&#160;&#160;&#160;&#160;',@DESCRIPCION),'[NV]')"/></xsl:call-template>,'<xsl:value-of select="@CODIGO"/>');
						document.metricas.AplCod.options[j].disabled = true;
					</xsl:if>
					j = j+1;
				</xsl:for-each>
			</xsl:for-each>
			<!--Si no hay aplicaciones padres pero si existen aplicaciones asociadas a esta seccin las mostramos-->
				<xsl:if test="count(../APLICACION[@SECCION=$secc and not(@PADRE)]) &lt;= 0">
					<xsl:for-each select="../APLICACION[@SECCION=$secc]">
						<xsl:if test="@ESTADO='V'">
							document.metricas.AplCod.options[j] = new Option(<xsl:call-template name="entrecomillaDescripcion"><xsl:with-param name="descripcion" select="concat('&#160;&#160;',@DESCRIPCION)"/></xsl:call-template>,'<xsl:value-of select="@CODIGO"/>');
						</xsl:if>
						<xsl:if test="@ESTADO='N'">
							document.metricas.AplCod.options[j] = new Option(<xsl:call-template name="entrecomillaDescripcion"><xsl:with-param name="descripcion" select="concat(concat('&#160;&#160;',@DESCRIPCION),'[NV]')"/></xsl:call-template>,'<xsl:value-of select="@CODIGO"/>');
							document.metricas.AplCod.options[j].disabled = true;
						</xsl:if>
						j = j+1;
					</xsl:for-each>
				</xsl:if>
			<xsl:call-template name="sacaSubSeccionesAplicaciones">
				<xsl:with-param name="codigo_padre" select="$secc"/>
				<xsl:with-param name="espacio" select="concat($espacio,'&#160;&#160;')"/>
			</xsl:call-template>
		</xsl:if>
		<!--Se puede dar el caso de que el padre no posea aplicaciones pero alguno de sus hijos si-->
		<xsl:if test="count(../APLICACION[@SECCION=$secc])=0">
				<!--Con la variable subsecc sabemos si la seccin que estamos tratando tiene hijos
					que puedan deban ser mostrados y por lo tanto haya que mostarla desactivada
					Si no tiene hijos para mostrar, no se mostrara-->
				<xsl:variable name="subsecc">
					<xsl:call-template name="sacaSubSeccionesAplicaciones"> 
						<xsl:with-param name="codigo_padre" select="@CODIGO"/>
						<xsl:with-param name="espacio" select="'&#160;&#160;'"/>
					</xsl:call-template>
				</xsl:variable>
				<xsl:if test="string-length($subsecc)>0">
					 document.metricas.AplCod.options[j] = new Option(<xsl:call-template name="entrecomillaDescripcion"><xsl:with-param name="descripcion" select="concat(concat('[Seccin:',@DESCRIPCION),']')"/></xsl:call-template>,'-1');
					 document.metricas.AplCod.options[j].className = 'listas';
					 j = j+1;
					<xsl:call-template name="sacaSubSeccionesAplicaciones">
						<xsl:with-param name="codigo_padre" select="@CODIGO"/>
						<xsl:with-param name="espacio" select="concat($espacio,'&#160;&#160;')"/>
					</xsl:call-template>
				</xsl:if>
			</xsl:if>
		</xsl:for-each>
	</xsl:if>
</xsl:template>

<xsl:template name="cuerpo"/>
</xsl:stylesheet>



