<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet version="1.0" 
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:xforms="http://www.w3.org/2002/xforms">
	
<xsl:param name="servlet"/>
<xsl:param name="menu"/>	

<xsl:param name="estado"/>	

<xsl:include href="dumbo7/utils/xsl/utils.xsl"/>
	
<xsl:template match="XMLROOT">
	<TITLE>DUMBO7: Buscar Seccin</TITLE>

<html lang="es">
	<xsl:call-template name="headComun">
		 <xsl:with-param name="jscript">
			<script LANGUAJE="JavaScript">
				function mostarError(error){
					alert(error);
				}
				function enviarAMadre(id,descrip){
					window.opener.document.metricas.SecCod.value = id;
					
					window.opener.document.metricas.SecDescrip.value = descrip;
					window.window.close();
				}
				function cerrar(){
					window.window.close();
				}
			</script>
			<script LANGUAJE="JavaScript" src="../js/metricas/Filtrado.js"></script>
		</xsl:with-param>
	 </xsl:call-template>
	
<body onload="cargatabla()">
	<form action="{$servlet}" METHOD="POST" name="filtro">
	<table border="0" cellpadding="3" cellspacing="3" width="450" summary="Tabla con resultado de bsqueda">
		<tr>
			<td width="5%" class="celdapaipuc">Estado</td>
			<td width="5%" class="celdapaipuc">Cd</td>
			<td width="85%" class="celdapaipuc">Descripcin</td>
			<td width="10%" class="celdapaipuc"><a href="javascript:cerrar()">Cerrar</a></td>
		</tr>
			
		<!--Para evitar error al usar el caracter ' y para que pase bien los acentos usamos arrays dentro
			de los tags SCRIPT para los nombres y apellidos (que son los campos que pueden contener
			acentos y tildes. Cada lnea queda indexada con el array a travs del identificador.-->
		<SCRIPT>
			var arrayDescrip = new Array();
		</SCRIPT>
		
		<label class="celdapaipuc">Filtro:&#160;</label>
		<input type="text" name="textoFiltro" size="15"/>&#160;
		
		<a href="javascript:FiltroOn()"><img id="FiltroIcoOFF" style="display:inline" border="0" src="../graficos/iconos/ico_filtroOff.gif" alt="Aplicar Filtrado"/></a>
		<a href="javascript:FiltroOff()"><img id="FiltroIcoON" style="display:none" border="0" src="../graficos/iconos/ico_filtroOn.gif" alt="Desacer Filtrado"/></a>
		
		<xsl:for-each select="DATA/METRICAS/SECCION[@ESTADO = $estado]">
			<tr id="{@DESCRIPCION}" class="Filtrado">
				<td align="center">
					<xsl:if test="@ESTADO='V'">
				<img  border="0" src="../graficos/iconos/vigente.gif" alt="Vigente"/>
				</xsl:if>
				<xsl:if test="@ESTADO='N'">
					 <img border="0" src="../graficos/iconos/no_vigente.gif" alt="No Vigente"/>
				</xsl:if>
				</td>
				<td width="100">
					<xsl:value-of select="@CODIGO"/>
				</td>
				<td colspan="2">
					<SCRIPT>
						arrayDescrip['<xsl:value-of select="@CODIGO"/>'] = "<xsl:value-of select="@DESCRIPCION"/>";
					</SCRIPT>
					<a href="JavaScript:enviarAMadre('{@CODIGO}',arrayDescrip['{@CODIGO}'])"><xsl:value-of select="@DESCRIPCION"/></a>
				</td>
			</tr>
		</xsl:for-each>	
						
		<xsl:if test="count(DATA/METRICAS/SECCION[@ESTADO = $estado])=0">
			<tr>
				<td align="center">Sin&#160;Resultados</td>
			</tr>
		</xsl:if>
		<tr><td width="100%" colspan="4" class="celdapaipuc2">&#160;</td></tr>
	</table>
	</form>
</body>
</html>
</xsl:template>

<xsl:template name ="cuerpo"/>
</xsl:stylesheet>
	