package dumbo7.metricas.sinPrio;

import dumbo7.metricas.*;

import java.sql.*;
import java.sql.ResultSet;
import java.util.*;

import dumbo7.utils.*;

import org.hibernate.Query;
import org.hibernate.Session;

import atica.frameweb.utils.*;

/**
 * @author Antonio
 *
 * Gestor de Metricas Estado de Dumbo
 * 
 */
public class GestorSinPrio extends GeneralManager {
	private List seccionesResponsable = new Vector();
	private List aplicaciones = new Vector();
	private List grupoUsuarios= new Vector();
	private List usuarios= new Vector();
	private List secciones = new Vector();
	private List informaticos= new Vector();
	private List ModoDato;
	private Vector resultadoMetricas = new Vector();
	private Vector resultadoMetricas_tm = new Vector();
	
	private String Aplicacion = "";
	private String Seccion = "";
	private String Informatico = "";
	private String Usuario = "";
	private String GrupoUsuarios = "";
	private String Datos = "";
	private String Codigo = "";
	private String Sel = "";
	private String Patron = "";
	
	private String FechaDesde;
	private String FechaHasta;
		
	public GestorSinPrio() {}
	
	//Mtodos get() para el mapeo
	public List getAplicaciones() { return aplicaciones; }
	public List getSeccionesResponsable() { return seccionesResponsable; }
	public List getSecciones() { return secciones; }
	public List getInformaticos() { return informaticos; }
	public List getGrupoUsuarios() { return grupoUsuarios; }
	public List getUsuarios() { return usuarios; }
	public List getModoDato(){return ModoDato;}
	public Vector getResultadoMetricas(){return this.resultadoMetricas;}
	public Vector getResultadoMetricas_tm(){return this.resultadoMetricas_tm;}
	
	//Mtodos set para recoger los datos del formulario
	/**Metdo set() para obtener las fechas de inicio y fin del histrico*/
	public void setFechaDesde(String FDesde){this.FechaDesde = FDesde;}
	public void setFechaHasta(String FHasta){this.FechaHasta = FHasta;}
	
	public void setSeccion(String sec){this.Seccion = sec;}
	public void setUsuario(String U){
		if(U != null){
			this.Usuario = U;
		}
		else{
			this.Usuario = "";
		}
	}
	public void setGrupoUsuario(String Gu){
		if(Gu != null){
			this.GrupoUsuarios = Gu;
		}
		else{
			this.GrupoUsuarios = "";
		}
	}
	public void setAplicacion(String Apl){this.Aplicacion = Apl;}
	public void setInformatico(String Inf){this.Informatico = Inf;}
	
	
	/**	Lista todas las secciones*/
	public void listaSecciones(Session conn){
		try{
			Query q = conn.createQuery(getQuery("AllSecciones"));
			q = q.setString("sist",user.getDatosMenu().idSelected());
			secciones  = (List)q.list();
		}
		catch (Exception ex){
			setErrorMessage("GestorMetricas[Lectura de BBDD]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
	}
	
	/**-------------LISTADOS DE UN NICO ELEMENTO(COMPONENTE)-------------------*/
	public void QueryInformatico(Session conn, String InfCod){
		try{
			Query q = conn.createQuery(getQuery("ListaUnInformatico/Usuario"));
			q = q.setString("cod",InfCod);
			informaticos  = (List)q.list();		
		}catch (Exception ex){
			setErrorMessage("GestorMetricas[Lectura de BBDD]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}	
	}
	
	/**Lista secciones con datos sin importar el estado, para el select inicial de secciones(no incluye estado finalizado)**/
	public void listaSeccionesConDatos(Session conn) {
		PreparedStatement pstmt;
		
		try{
			String ResultadoQuery = getQuery("SeccionesConDatos");
			ResultadoQuery = ResultadoQuery.replaceAll(":SISTEMA",user.getDatosMenu().idSelected());
			ResultadoQuery = ResultadoQuery.replaceAll(":GESTOR",user.getIdentificador());
			pstmt = conn.connection().prepareStatement(ResultadoQuery);
			ResultSet rs = pstmt.executeQuery();
			
		 	while (rs.next()) {
	 	    	D7Secciones sec = new D7Secciones();
	 	    	sec.setSecSisCod(rs.getString("Sec_Sis_Cod"));
	 	    	sec.setSecCod(rs.getString("Sec_Cod"));
	 	    	sec.setSecDescrip(rs.getString("Sec_Descrip"));
	 	    	sec.setSecIdRespon(rs.getString("Sec_Id_Respon"));
	 	    	sec.setSecSecCod(rs.getString("Sec_Sec_Cod"));
	 	    	sec.setSecEstado(rs.getString("Sec_Estado"));
	 	    	secciones.add(sec);
	 	    }
		 	rs.close();
	 	    pstmt.close();
		} catch (Exception ex) {
			System.out.println(ex);
			setErrorMessage("GestorMetricas[Lectura de BBDD]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
	}
	
	public void QueryUsuario(Session conn, String UsuCod){
		try{
			Query q = conn.createQuery(getQuery("ListaUnInformatico/Usuario"));
			q = q.setString("cod",UsuCod);
			usuarios  = (List)q.list();		
		}catch (Exception ex){
			setErrorMessage("GestorMetricas[Lectura de BBDD]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}	
	}
	public void QueryGrupoUsuario(Session conn, String GruCod){
		try{
			Query q = conn.createQuery(getQuery("ListaUnGrupoUsuarios"));
			q = q.setString("sist",user.getDatosMenu().idSelected());
			q = q.setString("cod",GruCod);
			grupoUsuarios  = (List)q.list();		
		}catch (Exception ex){
			setErrorMessage("GestorMetricas[Lectura de BBDD]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
	}
	
	/**-------------------SECCIONES para la AGRUPACIN-------------------*/
	public void listaSeccionesAgrupacion(Session conn){
		PreparedStatement pstmt;
		String Query ="";
		try{		 	 
			Query = getQuery("ListaAgrupacionSecciones");
			Query = Query.replaceAll(":SISTEMA",user.getDatosMenu().idSelected());
			pstmt = conn.connection().prepareStatement(Query);
			ResultSet rs = pstmt.executeQuery();
			while (rs.next()) {
				D7Secciones sec = new D7Secciones();
				sec.setSecSisCod(rs.getString("Sec_Sis_Cod"));
	 	    	sec.setSecCod(rs.getString("Sec_Cod"));
	 	    	sec.setSecDescrip(rs.getString("Sec_Descrip"));
	 	    	sec.setSecIdRespon(rs.getString("Sec_Id_Respon"));
	 	    	sec.setSecSecCod(rs.getString("Sec_Sec_Cod"));
	 	    	sec.setSecEstado(rs.getString("Sec_Estado"));
	 	    	this.secciones.add(sec);
			}   
		 rs.close();
		 pstmt.close();
	  } catch (Exception ex) {
			System.out.println(ex);
			setErrorMessage("GestorMetricas [Lectura de BBDD]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
	}
	/**-------------------APLICACIONES para la AGRUPACIN-------------------*/
	public void listaAplicacionesAgrupacion(Session conn){
		PreparedStatement pstmt;
		String Query ="";
		try{		 	 
			Query = getQuery("ListaAgrupacionAplicaciones");
			Query = Query.replaceAll(":SISTEMA",user.getDatosMenu().idSelected());
			pstmt = conn.connection().prepareStatement(Query);
			ResultSet rs = pstmt.executeQuery();
			while (rs.next()) {
				D7Aplicaciones apli = new D7Aplicaciones();
				apli.setAplSisCod(rs.getString("Apl_Sis_Cod"));
	 	    	apli.setAplCod(rs.getString("Apl_Cod"));
	 	    	apli.setAplDescrip(rs.getString("Apl_Descrip"));
	 	    	apli.setAplTipoAsig(rs.getString("Apl_Tipo_Asig"));
	 	    	apli.setAplSecCod(rs.getString("Apl_Sec_Cod"));
	 	    	apli.setAplEstado(rs.getString("Apl_Estado"));
	 	    	apli.setAplPadreAplCod(rs.getString("Apl_Padre_Apl_Cod"));
	 	    	aplicaciones.add(apli);
			}   
		 rs.close();
		 pstmt.close();
	  } catch (Exception ex) {
			System.out.println(ex);
			setErrorMessage("GestorMetricas [Lectura de BBDD]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
	}
	
	/**Patron de las busquedas de secciones, categoras grupos usuarios...*/
	public void setPatron(String patron){this.Patron = patron;}
	
	/**-------------------GESTOR-------------------*/
	public void listaAplicacionesGestor(Session conn){
		PreparedStatement pstmt;
		try{
			String ResultadoQuery = getQuery("AplicacionesGestorConAyuda");
			ResultadoQuery = ResultadoQuery.replaceAll(":SISTEMA",user.getDatosMenu().idSelected());
			ResultadoQuery = ResultadoQuery.replaceAll(":GESTOR",user.getIdentificador());
			pstmt = conn.connection().prepareStatement(ResultadoQuery);
			ResultSet rs = pstmt.executeQuery();
			
		 	while (rs.next()) {
	 	    	D7Aplicaciones apli = new D7Aplicaciones();
		 	   	apli.setAplSisCod(rs.getString("Apl_Sis_Cod"));
	 	    	apli.setAplCod(rs.getString("Apl_Cod"));
	 	    	apli.setAplDescrip(rs.getString("Apl_Descrip"));
	 	    	apli.setAplTipoAsig(rs.getString("Apl_Tipo_Asig"));
	 	    	apli.setAplSecCod(rs.getString("Apl_Sec_Cod"));
	 	    	apli.setAplEstado(rs.getString("Apl_Estado"));
	 	    	apli.setAplPadreAplCod(rs.getString("Apl_Padre_Apl_Cod"));
	 	    	aplicaciones.add(apli);
	 	    }   
	 	    rs.close();
	 	    pstmt.close();
		} catch (Exception ex) {
			System.out.println(ex);
			setErrorMessage("GestorMetricas[Lectura de BBDD]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
	}
	public void listaSeccionesGestor(Session conn) {
		PreparedStatement pstmt;
		
		try{
			String ResultadoQuery = getQuery("SeccionesGestorConAyuda");
			ResultadoQuery = ResultadoQuery.replaceAll(":SISTEMA",user.getDatosMenu().idSelected());
			ResultadoQuery = ResultadoQuery.replaceAll(":GESTOR",user.getIdentificador());
			pstmt = conn.connection().prepareStatement(ResultadoQuery);
			ResultSet rs = pstmt.executeQuery();
			
		 	while (rs.next()) {
	 	    	D7Secciones sec = new D7Secciones();
	 	    	sec.setSecSisCod(rs.getString("Sec_Sis_Cod"));
	 	    	sec.setSecCod(rs.getString("Sec_Cod"));
	 	    	sec.setSecDescrip(rs.getString("Sec_Descrip"));
	 	    	sec.setSecIdRespon(rs.getString("Sec_Id_Respon"));
	 	    	sec.setSecSecCod(rs.getString("Sec_Sec_Cod"));
	 	    	sec.setSecEstado(rs.getString("Sec_Estado"));
	 	    	seccionesResponsable.add(sec);
	 	    }
		 	rs.close();
	 	    pstmt.close();
		} catch (Exception ex) {
			System.out.println(ex);
			setErrorMessage("GestorMetricas[Lectura de BBDD]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
	}
	public void listaGrupoUsuariosGestor(Session conn) {
		PreparedStatement pstmt;
		try{
			Query q = conn.createQuery(getQuery("GruUsuGestorConAyuda"));
			q = q.setString("sist",user.getDatosMenu().idSelected());
			q = q.setString("gestor",user.getIdentificador());
			this.grupoUsuarios = (List)q.list();		
		}catch (Exception ex){
			setErrorMessage("GestorMetricas[Lectura de BBDD]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
	}
	
	/**-------------------MAESTRO-------------------*/
	public void listaSeccionesMaestro(Session conn){
		try{
			Query q = conn.createQuery(getQuery("SeccionesMaestroConAyuda"));
			q = q.setString("sist",user.getDatosMenu().idSelected());
			secciones  = (List)q.list();
		} catch (Exception ex) {
			setErrorMessage("GestorMetricas[Lectura de BBDD]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
	}
	public void listaAplicacionesMaestro(Session conn){
		try{
			Query q = conn.createQuery(getQuery("AplicacionesMaestroConAyuda"));
			q = q.setString("sist",user.getDatosMenu().idSelected());
			aplicaciones  = (List)q.list();
		} catch (Exception ex) {
			setErrorMessage("GestorMetricas[Lectura de BBDD]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
	}
	public void listaGrupoUsuariosMaestro(Session conn){ 
		try{
			Query q = conn.createQuery(getQuery("GruUsuMaestroConAyuda"));
			q = q.setString("sist",user.getDatosMenu().idSelected());
			grupoUsuarios  = (List)q.list();		
		}catch (Exception ex){
			setErrorMessage("GestorMetricas[Lectura de BBDD]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
	}
	
	/** Mtodo para sustituir todos los parmetros de la query de ListaEnModoDato o ListaEnModoDatoDesglose
	* En este mtodo se elige cual de las 2 querys realizar en funcin de si se ha elegido desglose o no
	* Adems tambin se sustituyen los parmetros en funcin de si se ha introducido usuario, informatico, seccion...
	* */
	/**-------------------RESULTADOS de las mtricas para MAESTRO-------------------*/
	public void listaModoDatoMaestro(Session conn){
		PreparedStatement pstmt;
		String Query ="";
	
		try{
			/**Inicio de la cuenta para la medicin del tiempo de ejecucin de la METRICA*/
			java.util.Date FechaInicio = new java.util.Date();
			int MinutosI = FechaInicio.getMinutes();
			int SegundosI = FechaInicio.getSeconds();
			
			Query = getQuery("ListaSinPrioridad");
			Query = Query.replaceAll(":CONDICION_GESTOR","");
			
			/**Construimos la query dependiendo del PERIODO introducido si no hay inicio = "DesdeInicio de tiempos"; si no hay fin = "HastaFin de tiempos*/
			if(!(this.FechaDesde.equals("DD/MM/AAAA")) & !(this.FechaHasta.equals("DD/MM/AAAA"))){
				Query = Query.replaceAll(":FINICIO",this.FechaDesde);
				Query = Query.replaceAll(":FFIN",this.FechaHasta);
			}else if(this.FechaDesde.equals("DD/MM/AAAA") & !(this.FechaHasta.equals("DD/MM/AAAA"))){
				Query = Query.replaceAll("':FINICIO'","NULL");
				Query = Query.replaceAll(":FFIN",this.FechaHasta);
				}else if(!(this.FechaDesde.equals("DD/MM/AAAA")) & this.FechaHasta.equals("DD/MM/AAAA")){
					Query = Query.replaceAll(":FINICIO",this.FechaDesde);
					Query = Query.replaceAll("':FFIN'","NULL");
					}else{
						Query = Query.replaceAll("':FINICIO'","NULL");
						Query = Query.replaceAll("':FFIN'","NULL");
						}
					 
			/**Si se introduce una APLICACIN por la que filtrar, sino el parmetro aplicacin ser NULL*/
			if(!this.Aplicacion.equals("")){Query = Query.replaceAll(":APL",this.Aplicacion);}
			else{Query = Query.replaceAll("':APL'","NULL");}
			
			/**Si se introduce un INFORMTICO por el que filtrar, sino el parmetro INFORMTICO ser NULL*/
			if(!this.Informatico.equals("")){Query = Query.replaceAll(":INF",this.Informatico);}
			else{Query = Query.replaceAll("':INF'","NULL");}
			
			/**Si se introduce un GRUPO DE USUARIOS por el que filtrar, sino el parmetro GRUPO DE USUARIOS ser NULL*/
			if(!this.GrupoUsuarios.equals("")){Query = Query.replaceAll(":GRUSU",this.GrupoUsuarios);}
			else{Query = Query.replaceAll("':GRUSU'","NULL");}
			
			/**Si se introduce una SECCIN por la que filtrar, sino el parmetro SECCIN ser NULL*/
			if(!this.Seccion.equals("")){Query = Query.replaceAll(":SEC",this.Seccion);}
			else{Query = Query.replaceAll("':SEC'","NULL");}
			
			/**Si se introduce un USUARIO por el que filtrar, sino el parmetro USUARIO ser NULL*/
			if(!this.Usuario.equals("")){Query = Query.replaceAll(":USU",this.Usuario);}
			else{Query = Query.replaceAll("':USU'","NULL");}
			
			/**Sustitucin de TIPOS TAREAS*/
			Query = Query.replaceAll(":PETICION",D7TiposTareas.PETICION);
			Query = Query.replaceAll(":INCIDENCIA",D7TiposTareas.INCIDENCIA);
			
			/**SISTEMA*/
			Query = Query.replaceAll(":SISTEMA",user.getDatosMenu().idSelected());
			
			/**El parmetro GESTOR se pone a NULL puesto que nos encontramos en MAESTRO*/
			Query = Query.replaceAll("':GESTOR'","NULL");
			
			pstmt = conn.connection().prepareStatement(Query);
			ResultSet rs = pstmt.executeQuery();
		 	while (rs.next()) {
		 		/**RECOGIDA DE RESULTADOS Y MAPEO A TRAVS DE LA CLASE MTRICAS*/
		 		D7Tareas tar = new D7Tareas();
			   	tar.setTarCod(new Integer(rs.getInt(1)));
			   	tar.setTarTipCod(rs.getString(2));
				tar.setTarFeccrea(rs.getDate(3));
			   	tar.setTarInfCod(rs.getString(4));
			   	
			   	Metricas M = new Metricas();
	 	    	M.setTarea(tar);
	 	    	M.setFechaAsig(rs.getDate(5));
	 	    	M.setParams(rs.getString(6)); /**Recogida de la seccin*/
	 	    	M.setAplicacion(rs.getString(7));
	 	    		 	    	
	 	    	this.resultadoMetricas.add(M);
	 	    }   
	 	    rs.close();
	 	    pstmt.close();
						
	 	   /**FIN de la cuenta para la medicin del tiempo de ejecucin de la METRICA*/
	 	    java.util.Date FechaFin = new java.util.Date();
			int MinutosF = FechaFin.getMinutes();
			int SegundosF = FechaFin.getSeconds();
			/**Tenemos en cuenta si se ha cambiado de minuto mientras se realiza la mtrica*/
			if (SegundosI > SegundosF){
				SegundosF = 60 + SegundosF;
				MinutosF = MinutosF - 1;
			}
	 	    setErrorMessage("La mtica se ha realizado en: "+ new Integer(Math.abs(MinutosF-MinutosI)).toString() + " min. y " +new Integer(Math.abs(SegundosF-SegundosI)).toString() + " seg.");
	 	    
	 	   } catch (Exception ex) {
			System.out.println(ex);
			setErrorMessage("LISTADO Maestro:"+ex.toString().substring(0,ex.toString().length()-1));
		}
	}
	
	/**-------------------RESULTADOS de las mtricas para GESTOR-------------------*/
	public void listaModoDatoGestor(Session conn){
		PreparedStatement pstmt;
		/**String para construir la query de GESTOR*/
		String Query ="";
		
		try{
			/**Inicio de la cuenta para la medicin del tiempo de ejecucin de la METRICA*/
			java.util.Date FechaInicio = new java.util.Date();
			int MinutosI = FechaInicio.getMinutes();
			int SegundosI = FechaInicio.getSeconds();
			
			Query = getQuery("ListaSinPrioridad");
			Query = Query.replaceAll(":CONDICION_GESTOR",getQuery("CondicionGestor"));
								
			/**Construimos la query dependiendo del PERIODO introducido si no hay inicio = "DesdeInicio de tiempos"; si no hay fin = "HastaFin de tiempos*/
			if(!(this.FechaDesde.equals("DD/MM/AAAA")) & !(this.FechaHasta.equals("DD/MM/AAAA"))){
				Query = Query.replaceAll(":FINICIO",this.FechaDesde);
				Query = Query.replaceAll(":FFIN",this.FechaHasta);
			}else if(this.FechaDesde.equals("DD/MM/AAAA") & !(this.FechaHasta.equals("DD/MM/AAAA"))){
				Query = Query.replaceAll("':FINICIO'","NULL");
				Query = Query.replaceAll(":FFIN",this.FechaHasta);
				}else if(!(this.FechaDesde.equals("DD/MM/AAAA")) & this.FechaHasta.equals("DD/MM/AAAA")){
					Query = Query.replaceAll(":FINICIO",this.FechaDesde);
					Query = Query.replaceAll("':FFIN'","NULL");
					}else{
						Query = Query.replaceAll("':FINICIO'","NULL");
						Query = Query.replaceAll("':FFIN'","NULL");
						}
					 
			/**Si se introduce una APLICACIN por la que filtrar, sino el parmetro aplicacin ser NULL*/
			if(!this.Aplicacion.equals("")){Query = Query.replaceAll(":APL",this.Aplicacion);}
			else{Query = Query.replaceAll("':APL'","NULL");}
			
			/**Si se introduce un INFORMTICO por el que filtrar, sino el parmetro informtico ser NULL*/
			if(!this.Informatico.equals("")){Query = Query.replaceAll(":INF",this.Informatico);}
			else{Query = Query.replaceAll("':INF'","NULL");}
			
			/**Si se introduce un GRUPO DE USUARIOS por el que filtrar, sino el parmetro grupo de usuarios ser NULL*/
			if(!this.GrupoUsuarios.equals("")){Query = Query.replaceAll(":GRUSU",this.GrupoUsuarios);}
			else{Query = Query.replaceAll("':GRUSU'","NULL");}
			
			/**Si se introduce una SECCIN por la que filtrar, sino el parmetro seccin ser NULL*/
			if(!this.Seccion.equals("")){Query = Query.replaceAll(":SEC",this.Seccion);}
			else{Query = Query.replaceAll("':SEC'","NULL");}
			
			/**Si se introduce un USUARIO por el que filtrar, sino el parmetro usuario ser NULL*/
			if(!this.Usuario.equals("")){Query = Query.replaceAll(":USU",this.Usuario);}
			else{Query = Query.replaceAll("':USU'","NULL");}
			
			/**Sustitucin de TIPOS TAREAS*/
			Query = Query.replaceAll(":PETICION",D7TiposTareas.PETICION);
			Query = Query.replaceAll(":INCIDENCIA",D7TiposTareas.INCIDENCIA);
			
			/**SISTEMA*/
			Query = Query.replaceAll(":SISTEMA",user.getDatosMenu().idSelected());
			
			/**En este caso se reemplaza en parmetro GESTOR, por el idetificador del GESTOR que est realizando 
			 * la mtrica puesto que hay una restriccin ms en las querys*/
			Query = Query.replaceAll(":GESTOR",user.getIdentificador());
											
			pstmt = conn.connection().prepareStatement(Query);
			ResultSet rs = pstmt.executeQuery();
		 	while (rs.next()) {
		 		/**RECOGIDA DE RESULTADOS Y MAPEO A TRAVS DE LA CLASE MTRICAS*/
		 		D7Tareas tar = new D7Tareas();
			   	tar.setTarCod(new Integer(rs.getInt(1)));
			   	tar.setTarTipCod(rs.getString(2));
				tar.setTarFeccrea(rs.getDate(3));
			   	tar.setTarInfCod(rs.getString(4));
			   	
			   	Metricas M = new Metricas();
	 	    	M.setTarea(tar);
	 	    	M.setFechaAsig(rs.getDate(5));
	 	    	M.setParams(rs.getString(6)); /**Recogida de la seccin*/
	 	    	M.setAplicacion(rs.getString(7));
	 	    		 	    	
	 	    	this.resultadoMetricas.add(M);
	 	    }   
	 	    rs.close();
	 	    pstmt.close();
		 
		 	    
	 	    /**FIN de la cuenta para la medicin del tiempo de ejecucin de la METRICA*/
	 	    java.util.Date FechaFin = new java.util.Date();
			int MinutosF = FechaFin.getMinutes();
			int SegundosF = FechaFin.getSeconds();
			/**Tenemos en cuenta si se ha cambiado de minuto mientras se realiza la mtrica*/
			if (SegundosI > SegundosF){
				SegundosF = 60 + SegundosF;
				MinutosF = MinutosF - 1;
			}
	 	    setErrorMessage("La mtica se ha realizado en: "+ new Integer(Math.abs(MinutosF-MinutosI)).toString() + " min. y " +new Integer(Math.abs(SegundosF-SegundosI)).toString() + " seg.");
	 	    
	 	   } catch (Exception ex) {
			System.out.println(ex);
			setErrorMessage("LISTADO Gestor:"+ex.toString().substring(0,ex.toString().length()-1));
		}
	}
}//Fin del GestorSinPrio.java
