<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet version="1.0" 
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:xforms="http://www.w3.org/2002/xforms">
	
<xsl:param name="servlet"/>	
<xsl:param name="menu"/>
<xsl:param name="perfil"/>
<xsl:param name="inicio"/>
<xsl:param name="fin"/>
<xsl:param name="UsuCod"/>
<xsl:param name="GruCod"/>
<xsl:param name="AplCod"/>
<xsl:param name="SecCod"/>
<xsl:param name="InfCod"/>
<xsl:param name="FechaDesde"/>
<xsl:param name="FechaHasta"/>

<xsl:variable name="desglose"/>

<xsl:include href="dumbo7/utils/xsl/utils.xsl"/>
	
<xsl:template match="XMLROOT">
	
	<html lang="es">
		<TITLE>DUMBO7: Resultado Mtrica 'Tareas Asignadas Sin Prioridad Asignada'</TITLE>
		
    <xsl:call-template name="headComun">
         <xsl:with-param name="jscript">
            <SCRIPT LANGUAGE="JavaScript">
				function mostrarError(error){
					alert(error);
				}
			</SCRIPT>
			<script LANGUAJE="JavaScript" src="../js/OnMouse.js"></script>
         </xsl:with-param>
	</xsl:call-template>
	<body>

		
	<xsl:for-each select="DATA/METRICAS">
		<xsl:if test="not(@ERROR='')">
			<script>mostrarError('<xsl:value-of select="@ERROR"/>')</script>
		</xsl:if>
	</xsl:for-each>

	<table border="0" align="center" cellpadding="3" cellspacing="1" width="750" summary="Esta tabla contiene las mtricas de tareas Sin Prioridad Asignada">
	<tr><td colspan="2">
		<table class="cont" id="metricas" border="0" cellpadding="3" cellspacing="1" width="100%" summary="Esta tabla contiene las mtricas">
		<tr class="cab1">
			<td colspan="2">&#187;Resultado: Tareas asignadas sin prioridad asignada (<xsl:value-of select="$perfil"/>)</td>
			<td width="10" align="center"><b><a href="javascript:window.print()"><img border="0" src="../graficos/iconos/ico_impresora.gif" alt="Imprimir"/></a></b></td>
			<td width="10" align="center"><b><a href="javascript:window.close()">Cerrar</a></b></td>
		</tr>
		<tr class="cabe">
			<td width="140"><b>Periodo</b></td>
			<td width="350"><b>Parmetros</b></td>
			<td colspan="2"></td>
		</tr>
		
		<tr class="administracion">
			<td width="100"><b>Desde:</b>&#160;&#160;<i>
				 <xsl:value-of select="$FechaDesde"/>
			</i></td>
			<td width="350" colspan="3">
				<b>Aplicacin:&#160;</b>
				<xsl:if test="$AplCod != ''">
					<i><xsl:value-of select="DATA/METRICAS/APLICACION[@CODIGO = $AplCod]/@DESCRIPCION"/></i>
				</xsl:if>
				<xsl:if test="$AplCod = ''">
					<i>TODAS</i>	
				</xsl:if>
			</td>
		</tr>
		<tr class="administracion">
			<td width="100"><b>Hasta:</b>&#160;&#160;<i>
				<xsl:value-of select="$FechaHasta"/>
			</i></td>
			<td width="350" colspan="3">
				<b>Seccion:&#160;</b>
				<xsl:if test="$SecCod != ''">
					<i><xsl:value-of select="DATA/METRICAS/SECCION/@DESCRIPCION"/></i>
				</xsl:if>
				<xsl:if test="$SecCod = ''">
					<i>TODAS</i>	
				</xsl:if>
			</td>
		</tr>
		<tr class="administracion">
			<td>&#160;</td>
			<td width="350" colspan="3">
				<b><xsl:call-template name="traduce"><xsl:with-param name="id" select="'Informtico'"/></xsl:call-template>:&#160;</b>
				<xsl:if test="$InfCod != ''">
					<i><xsl:value-of select="concat(concat(DATA/METRICAS/INFORMATICO/@APELLIDOS,', '),DATA/METRICAS/INFORMATICO/@NOMBRE)"/></i>	
				</xsl:if>
				<xsl:if test="$InfCod = ''">
					<i>TODOS</i>	
				</xsl:if>
			</td>
		</tr>
		<tr class="administracion">
			<td>&#160;</td>	
			<xsl:choose>
				<xsl:when test="$UsuCod = '' and $GruCod != ''">						
					<td width="350" colspan="3">
						<b>Grupo&#160;Usuarios:&#160;</b>
						<xsl:if test="$GruCod != ''">
							<i><xsl:value-of select="DATA/METRICAS/GRUPO_USUARIOS/@DESCRIPCION"/></i>	
						</xsl:if>
						<xsl:if test="$GruCod = ''">
							<i>TODOS</i>
						</xsl:if>
					</td>
				</xsl:when>
				<xsl:when test="$UsuCod != '' and $GruCod = ''">						
					<td width="350" colspan="3">
						<b>Usuario:&#160;</b>
						<xsl:if test="$UsuCod != ''">
							<i><xsl:value-of select="concat(concat(DATA/METRICAS/USUARIO/@APELLIDOS,', '),DATA/METRICAS/USUARIO/@NOMBRE)"/></i>	
						</xsl:if>
						<xsl:if test="$UsuCod = ''">
							<i>TODOS</i>
						</xsl:if>
					</td>
				</xsl:when>
				<xsl:otherwise>
					<td width="350" colspan="3">
						<b>Grupo&#160;Usuarios,&#160;Usuarios:&#160;</b>
						<i>TODOS</i>
					</td>
				</xsl:otherwise>
			</xsl:choose>
		</tr>
	</table>
		<table class="cont" border="0" cellpadding="3" cellspacing="1" width="100%" summary="Informacin detallada">
			<tr class="cabe"><td colspan="9"><b>Resultados</b></td></tr>
			<xsl:for-each select="DATA/METRICAS/SECCION">
				<xsl:sort select="@DESCRIPCION"/>
				<xsl:variable name="SeccionActual"><xsl:value-of select="@CODIGO"/></xsl:variable>		
				<xsl:if test="count(../RESULTADO_METRICAS[@PARAMS = $SeccionActual]) !=0">
					<tr class="cabeAlertas"><td colspan="9" align="center"><b>Seccin:&#160;"<xsl:value-of select="@DESCRIPCION"/>"</b></td></tr>
					<xsl:for-each select="../APLICACION[@SECCION = $SeccionActual]">
						<xsl:sort select="@DESCRIPCION"/>
						<xsl:variable name="AplicacionActual"><xsl:value-of select="@CODIGO"/></xsl:variable>
						<xsl:if test="count(../RESULTADO_METRICAS[@APLICACION = $AplicacionActual]) !=0">
							<tr class="cabeAlertas"><td colspan="9"><b>Aplicacin:&#160;<xsl:value-of select="@DESCRIPCION"/></b></td></tr>		
							<tr  class="administracion">
								<td align="center" width="70"><i><b>ID&#160;Tarea</b></i></td>
								<td align="center" width="50"><i><b>Tipo&#160;Tarea</b></i></td>
								<td width="300" colspan="2" align="right"><i><b><xsl:call-template name="traduce"><xsl:with-param name="id" select="'Informtico'"/></xsl:call-template></b></i></td>
								<td width="100" align="center"><i><b>Fecha&#160;de&#160;alta</b></i></td>
								<td width="130" align="center"><i><b>Fecha&#160;de&#160;asignacin</b></i></td>
							</tr>
							<xsl:for-each select="../RESULTADO_METRICAS[@APLICACION = $AplicacionActual]">
								<xsl:if test="TAREA/@TIPO_TAREA = 'P'">
									<tr class="peticion" onmouseover="javascript:onMouse(this,'true');" onmouseout="javascript:onMouse(this,'false');">
										<td align="right" width="70"><xsl:value-of select="TAREA/@CODIGO"/></td>
										<td width="50" align="right">
											PETICIN
										</td>
										<td width="300" colspan="2" align="right"><xsl:value-of select="TAREA/@INFORMATICO"/></td>
										<td width="100" align="right"><xsl:call-template name="date2String2"><xsl:with-param name="fecha" select="TAREA/@FECHA_CREACION"/></xsl:call-template></td>
										<td width="130" align="right">
											<xsl:if test="not(@FECHA_ASIGNACION)">
												--/--/--
											</xsl:if>
											<xsl:if test="@FECHA_ASIGNACION">
												<xsl:call-template name="date2String2"><xsl:with-param name="fecha" select="@FECHA_ASIGNACION"/></xsl:call-template>
											</xsl:if>
										</td>
									</tr>
								</xsl:if>
								<xsl:if test="TAREA/@TIPO_TAREA = 'I'">
									<tr class="incidencia" onmouseover="javascript:onMouseInc(this,'true');" onmouseout="javascript:onMouseInc(this,'false');">
										<td align="right" width="70"><xsl:value-of select="TAREA/@CODIGO"/></td>
										<td width="50" align="right">
											INCIDENCIA
										</td>
										<td width="300" colspan="2" align="right"><xsl:value-of select="TAREA/@INFORMATICO"/></td>
										<td width="100" align="right"><xsl:call-template name="date2String2"><xsl:with-param name="fecha" select="TAREA/@FECHA_CREACION"/></xsl:call-template></td>
										<td width="130" align="right">
											<xsl:if test="not(@FECHA_ASIGNACION)">
												--/--/--
											</xsl:if>
											<xsl:if test="@FECHA_ASIGNACION">
												<xsl:call-template name="date2String2"><xsl:with-param name="fecha" select="@FECHA_ASIGNACION"/></xsl:call-template>
											</xsl:if>
										</td>
									</tr>
								</xsl:if>
							</xsl:for-each>
						</xsl:if>
					</xsl:for-each>
				</xsl:if>
			</xsl:for-each>
			</table>
			<table class="cont" border="0" cellpadding="3" cellspacing="1" width="100%">
				<xsl:if test="count(DATA/METRICAS/RESULTADO_METRICAS)=0">
					<tr class="administracion">
						<td align="center" colspan="10">* METRICAS sin datos.</td>
					</tr>
				</xsl:if>
				<tr class="administracion" align="center"><td colspan="10"><CENTER><input type="button" class="boton" value="Cerrar" onclick="javascript:window.close()" /></CENTER></td></tr>
			</table>
	</td></tr>
</table>
	
		
</body>
</html>
</xsl:template>
<xsl:template name="cuerpo"/>
</xsl:stylesheet>
	