<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet version="1.0" 
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:xforms="http://www.w3.org/2002/xforms">

<xsl:param name="servlet"/>	
<xsl:param name="menu"/>

<xsl:include href="dumbo7/utils/xsl/utils.xsl"/>
<!--Include para los template que se encargan de jerarquizar el select de secciones-->
<xsl:include href="dumbo7/metricas/html/ArbolEnSelect.xsl"/>
	
<xsl:template match="XMLROOT">

<html lang="es">
	<xsl:call-template name="headComun">
		 <xsl:with-param name="calendar" select="not(contains($menu,'Inc'))"/>
		 <xsl:with-param name="jscript">
			<script LANGUAJE="JavaScript">
				<!--Variables que indican si las busquedas por usuario o por informatico han dado un resultado incorrecto-->
				var DatosIncorrectosInf = false;
				var DatosIncorrectosUsu = false;
				
				var http_reqapl = false;
				var http_req = false;
				var buscaCampo ='';
				var idInput = '';
								
				function mostrarError(error){
					alert(error);
				}
				<!--Permite que el llegar el foco al final de la pgina vuelva al primer elemento de nuevo-->
				function renuevaTab(){
					document.metricas.SecCod.focus();
				}
				
				function busquedaGenerica(url,tipo){
					if(tipo == 'USR'){
						if(document.metricas.usuarioCheck[0].checked == true){
							buscaCampo = document.metricas.UsuCod;
							idInput = 'UsuApe';
							url = url.concat("&amp;modulo=BuscarUsuarioMaestro");
							url = url.concat("&amp;tipo="+tipo);
							newWindow = window.open(url,'_blanck',"width=620,height=400,left=100,top=100");
						}
					}
					else{
						buscaCampo = document.metricas.InfCod;
						idInput = 'InfApe';
						url = url.concat("&amp;modulo=BuscarInformaticoMaestro");
						url = url.concat("&amp;tipo="+tipo);
						url = url.concat("&amp;seccion="+document.metricas.SecCod.value);
						url = url.concat("&amp;aplicacion="+document.metricas.AplCod.value);
						newWindow = window.open(url,'_blanck',"width=620,height=400,left=100,top=100");
					}
				}
				
				function actualiza(v,doc) {
					if(idInput == 'InfApe'){
						DatosIncorrectosInf = false;
					}
					else{
						DatosIncorrectosUsu = false;
					}
					buscaCampo.value = v;
					var txt = doc.getElementById(v).innerHTML;
					var n = txt.indexOf('>');
					txt = txt.substring(n+1);
					n = txt.indexOf('&lt;');
					txt = txt.substring(0,n);
					document.getElementById(idInput).innerHTML = txt;
				}
				
				<!--buscaDNI(), resuelveDNI() son funciones para que al introducir un DNI de un usuario o informatico
					obtienen el nombre y apellidos de este.-->
				function buscaDNI(DNI,tipo,val){
					idInput = val;
					if (DNI == ""){
						document.getElementById(idInput).innerHTML = "";
						if(tipo == "USR"){
							DatosIncorrectosUsu = false;
						}
						else{
							DatosIncorrectosInf = false;
						}
					 }
					else{
						if(tipo == "USR"){
							var url = '<xsl:value-of select="$servlet"/>?module=dumbo7/metricas.BuscarUsuarioMaestroDNI&amp;patron='+DNI+'&amp;idInput='+val;				
						}
						else{
							var url = '<xsl:value-of select="$servlet"/>?module=dumbo7/metricas.BuscarInformaticoMaestroDNI&amp;patron='+DNI+'&amp;idInput='+val;
						}	
							
						if (window.XMLHttpRequest) { // Mozilla, Safari,...
						   http_req = new XMLHttpRequest();
						} 
						else if (window.ActiveXObject) { // IE
						   http_req = new ActiveXObject("Microsoft.XMLHTTP");
						}
						
						http_req.onreadystatechange = resuelveDNI;
						http_req.open('GET', url, true);
						http_req.send(null);
					}
				}
			
				function resuelveDNI(){
					if (http_req.readyState == 4){
						if (http_req.status == 200){
							var text = http_req.responseText;
							var n = text.indexOf('&lt;'+'!--');
							if (n>=0) text = text.substring(0,n);
							var m = text.indexOf('.dtd">');
							if (m>=0) text = text.substring(m+6,text.length);
							eval(text);
						}
						else{
							alert('Hubo problemas con la peticin.');
						}
					}
				}
				
				<!--buscaAplicacionesSeccion(), resuelveAplicacionesSeccion() son funciones para que al seleccionar una seccion 
					obtienen las aplicaciones asociadas a esa seccin y adems tambin las aplicaciones asociadas a las secciones hijas-->
				function buscaAplicacionesSeccion(SecCod){
					var url = '<xsl:value-of select="$servlet"/>?module=dumbo7/metricas/sinPrio.formSinPrioMaestro.buscarAplicaciones&amp;seccion='+SecCod+'&amp;maestro=1';
					
					http_reqapl = false;
					
					if (window.XMLHttpRequest){
						http_reqapl = new XMLHttpRequest();
						if (http_reqapl.overrideMimeType){
							http_reqapl.overrideMimeType('text/xml');
						}
					}
					else if (window.ActiveXObject){
						try{
							http_reqapl = new ActiveXObject("Msxml2.XMLHTTP");
						}catch (e){
							try{
								http_reqapl = new ActiveXObject("Microsoft.XMLHTTP");
							}catch (e){}
						}
					}
			
					if (!http_reqapl){
						alert('Falla: No es posible crear una instancia XMLHTTP');
						return false;
					}
										
					http_reqapl.onreadystatechange = resuelveAplicacionesSeccion;
					http_reqapl.open('GET', url, true);
					http_reqapl.send(null);
				}
			
				function resuelveAplicacionesSeccion(){
					if (http_reqapl.readyState == 4){
						if (http_reqapl.status == 200){
							var text2 = http_reqapl.responseText;
							var n = text2.indexOf('&lt;'+'!--');
							if (n>=0) text2 = text2.substring(0,n);
							var m = text2.indexOf('.dtd">');
							if (m>=0) text2 = text2.substring(m+6,text2.length);
							eval(text2);
						}
						else{
							alert('Hubo problemas con la peticin.');
						}
					}
				}
				
				<!--Inicio:Filtro de GRUPOS DE USUARIOS-->
					function GruUsuFiltroOn(){
						<!--Si el checkBox de grupos de usuarios esta marcado-->
						if(document.metricas.usuarioCheck[1].checked){
							if(document.metricas.GruDescrip.value != ""){
								document.metricas.GruDescrip.disabled = !document.metricas.GruDescrip.disabled;
								document.metricas.GruFiltroIcoOFF.style.display = "none";
								document.metricas.GruFiltroIcoON.style.display = "";
								<!--Elimino todo el contenido del select de grupos de usuarios-->
								for(i=0;i&lt;document.metricas.GruCod.length;i++){
									document.metricas.GruCod.remove(i);
								}
								document.metricas.GruCod.length = 0;
								<!--Siempre se aade la primera lnea de vaco por esto i empieza por 1-->
								document.metricas.GruCod.options[0] = new Option('&lt;-- Sin Filtro -->','')
								var i = 1;
								var string = document.metricas.GruDescrip.value;
								document.metricas.GruDescrip.value = string.toUpperCase();
								<xsl:for-each select="DATA/METRICAS/GRUPO_USUARIOS">
									<xsl:sort select="@DESCRIPCION"/>
									if('<xsl:value-of select="@DESCRIPCION"/>'.indexOf(string.toUpperCase()) >= 0){
										document.metricas.GruCod.options[i] = new Option('<xsl:value-of select="@DESCRIPCION"/>','<xsl:value-of select="@CODIGO"/>');
										i = i +1;	
									}
								</xsl:for-each>
							}
							else{
								alert("Debe introducir algn patron para el filtro");
							}
						}
					}
									
					function GruUsuFiltroOff(){
						<!--Si el checkBox de grupos de usuarios esta marcado-->
						if(document.metricas.usuarioCheck[1].checked){
							document.metricas.GruDescrip.disabled = !document.metricas.GruDescrip.disabled;
							document.metricas.GruDescrip.value= "";
							document.metricas.GruFiltroIcoOFF.style.display = "";
							document.metricas.GruFiltroIcoON.style.display = "none";
							//Estableces la longitud del select puesto que la conoces a priori
							<xsl:variable name="GRUcantidad" select="count(DATA/METRICAS/GRUPO_USUARIOS)"/>
							document.metricas.GruCod.length = <xsl:value-of select="$GRUcantidad +1"/>; 
							document.metricas.GruCod.options[0] = new Option('&lt;-- Sin Filtro -->','');
							var i = 1;
							<xsl:for-each select="DATA/METRICAS/GRUPO_USUARIOS">
								<xsl:sort select="@DESCRIPCION"/>
									document.metricas.GruCod.options[i] = new Option('<xsl:value-of select="@DESCRIPCION"/>','<xsl:value-of select="@CODIGO"/>');
									i = i+1;
								</xsl:for-each>
							}
					}
				<!--fin:Filtro de GRUPOS DE USUARIOS-->
				
				<!--Inicio:Filtro de SECCIONES-->
				function SecFiltroOn(){
					if(document.metricas.SecDescrip.value != ""){
						document.metricas.SecDescrip.disabled = !document.metricas.SecDescrip.disabled;
						document.metricas.EstadoSec.disabled = !document.metricas.EstadoSec.disabled;
						document.metricas.SecFiltroIcoOFF.style.display = "none";
						document.metricas.SecFiltroIcoON.style.display = "";
							
						var string = document.metricas.SecDescrip.value;
							
									
						for (var i=0, option; option = document.metricas.SecCod.options[i]; i++){
							if (option.text.indexOf(string.toUpperCase()) >= 0){
								option.disabled = false;
							}
							else{
								option.disabled = true;
							}
						}
						emulate(document.metricas.SecCod);
					}
					else{
						alert("Debe introducir algn patron para el filtro");
					}
				}
									
				function SecFiltroOff(){
					document.metricas.SecDescrip.disabled = !document.metricas.SecDescrip.disabled;
					document.metricas.EstadoSec.disabled = !document.metricas.EstadoSec.disabled;
					document.metricas.SecDescrip.value= "";
					document.metricas.SecFiltroIcoOFF.style.display = "";
					document.metricas.SecFiltroIcoON.style.display = "none";
						
					for (var i=0, option; option = document.metricas.SecCod.options[i]; i++){
						option.disabled = false;
					}
					//emulate(document.metricas.SecCod);
					if(document.metricas.EstadoSec.options[document.metricas.EstadoSec.selectedIndex].value == 'V'){
						ChangeEstateSec('V');
					}
					else{
						ChangeEstateSec('T');
					}
				}
				function ChangeEstateSec(estado){
					if(estado == 'V'){
						for (var i=0, option; option = document.metricas.SecCod.options[i]; i++){
							if (option.text.indexOf(" [NV]") >= 0){
								option.disabled = true;
							}
							else{
								option.disabled = false;
							}
						}
						emulate(document.metricas.SecCod);
					}
					else{
						for (var i=0, option; option = document.metricas.SecCod.options[i]; i++){
							option.disabled = false;
						}
						emulate(document.metricas.SecCod);
					}
				}
				<!--fin:Filtro de SECCIONES-->
				
			<!--Inicio:Filtro de APLICACIONES-->
					function AplFiltroOn(){
						if(document.metricas.AplDescrip.value != ""){
							document.metricas.AplDescrip.disabled = !document.metricas.AplDescrip.disabled;
							document.metricas.EstadoApl.disabled = !document.metricas.EstadoApl.disabled;
							document.metricas.AplFiltroIcoOFF.style.display = "none";
							document.metricas.AplFiltroIcoON.style.display = "";
							
							var string = document.metricas.AplDescrip.value;
																
							for (var i=0, option; option = document.metricas.AplCod.options[i]; i++){
								if (option.text.indexOf(string.toUpperCase()) >= 0){
									option.disabled = false;
								}
								else{
									if (option.value != '-1'){
										if(option.value != ''){
											option.disabled = true;
										}
									}
								}
							}
							emulate(document.metricas.AplCod);
						}
						else{
							alert("Debe introducir algn patron para el filtro");
						}
					}
									
					function AplFiltroOff(){
						document.metricas.AplDescrip.disabled = !document.metricas.AplDescrip.disabled;
						document.metricas.EstadoApl.disabled = !document.metricas.EstadoApl.disabled;
						document.metricas.AplDescrip.value= "";
						document.metricas.AplFiltroIcoOFF.style.display = "";
						document.metricas.AplFiltroIcoON.style.display = "none";
						
						for (var i=0, option; option = document.metricas.AplCod.options[i]; i++){
							option.disabled = false;
						}
					
						if(document.metricas.EstadoApl.options[document.metricas.EstadoApl.selectedIndex].value == 'V'){
							ChangeEstateApl('V');
						}
						else{
							ChangeEstateApl('T');
						}
					}
					function ChangeEstateApl(estado){
						if(estado == 'V'){
							for (var i=0, option; option = document.metricas.AplCod.options[i]; i++){
								if (option.text.indexOf("[NV]") >= 0){
									option.disabled = true;
								}
								else{
									option.disabled = false;
								}
							}
						}
						else{
							for (var i=0, option; option = document.metricas.AplCod.options[i]; i++){
								option.disabled = false;
							}
						}
						emulate(document.metricas.AplCod);
					}
				<!--fin:Filtro de APLICACIONES-->
				
				<!--Funcin para comprobar si se ha introducido una seccin o una aplicacin en el select de
					aplicaciones-->
				function comprobarSeleccionApl(){
					if (document.metricas.AplCod.options[document.metricas.AplCod.selectedIndex].value == -1){
							alert("Selecciona una aplicacin no una seccin");
							document.metricas.AplCod.selectedIndex = 0;
					}
				}
				
				<!--Se ejecuta cuando se selecciona una seccin y permite restringir las aplicaciones de la pgina a las
					asociadas a la seccin seleccionada y rellenar las categoras-->
				function CambiosEnSeccion(seccion){
					if(seccion != ''){
						<!--Restringes las APLICACIONES a slo las vinculadas a la seccin seleccionada-->
						for(i=0;document.metricas.AplCod.length>i; i++){
							document.metricas.AplCod.remove(i);
						}
						document.metricas.AplCod.length = 0;
						document.metricas.AplCod.options[0] = new Option('&lt;-- Sin Filtro -->','');
						
						buscaAplicacionesSeccion(seccion);
					}
					else{
						<!--Eliminas las restricciones de las aplicaciones-->
						buscaAplicacionesSeccion('');
					}
				}

				<!--Comprueba los campos antes de realizar la mtrica-->
				function enviarResultados(url){
					if(DatosIncorrectosInf){
						alert("El <xsl:call-template name="traduce"><xsl:with-param name="id" select="'Informtico'"/></xsl:call-template> introducido no es correcto");
						document.metricas.InfCod.focus();
						return 0;
					}
					if(DatosIncorrectosUsu){
						alert("El usuario introducido no es correcto");
						document.metricas.UsuCod.focus();
						return 0;
						
					}
					
					//Indicas el perfil del que ha generado la metrica (GESTOR O MAESTRO)
					url = url.concat("&amp;perfil=Maestro")
					
					if(document.metricas.usuarioCheck[0].checked == true){
						url = url.concat("&amp;UsuCod=");
						url = url.concat(document.metricas.UsuCod.value);
					}
					else {
						url = url.concat("&amp;GruCod=");
						url = url.concat(document.metricas.GruCod.value);
					}
					if(document.metricas.Fechas[0].value != ""){
						url = url.concat("&amp;FechaDesde=");
						url = url.concat(document.metricas.Fechas[0].value);
					}
					else{
						url = url.concat("&amp;FechaDesde=DD/MM/AAAA");
					}
					if(document.metricas.Fechas[1].value != ""){
						url = url.concat("&amp;FechaHasta=");
						url = url.concat(document.metricas.Fechas[1].value);
					}
					else{url = url.concat("&amp;FechaHasta=DD/MM/AAAA");}
					
					url = url.concat("&amp;AplCod=");
					url = url.concat(document.metricas.AplCod.value);
					url = url.concat("&amp;AplicacionFiltro=");
					url = url.concat(document.metricas.AplDescrip.value);
					url = url.concat("&amp;SecCod=");
					url = url.concat(document.metricas.SecCod.value);
					url = url.concat("&amp;SeccionFiltro=");
					url = url.concat(document.metricas.SecDescrip.value);
					url = url.concat("&amp;InfCod=");
					url = url.concat(document.metricas.InfCod.value);
							
					newWindow = window.open(url,'_blanck',"height=700,width=785,status=no,toolbar=no,menubar=no,location=no,scrollbars=1");
					newWindow.moveTo(50,0);
				}
			</script>
			<script LANGUAJE="JavaScript" src="../js/metricas/Calendario.js"></script>
			<script LANGUAJE="JavaScript" src="../js/CompruebaFecha.js"></script>
			<script LANGUAJE="JavaScript" src="../js/metricas/Usuario_GrupoUsu.js"></script>
			<script LANGUAJE="JavaScript" src="../js/metricas/selectDisabled.js"></script>
		</xsl:with-param>
	 </xsl:call-template>

<body>

	<xsl:call-template name="menuComun">
		<xsl:with-param name="MENU" select="DATA/MENU"/>
		<xsl:with-param name="NAME" select="concat(DATA/METRICAS/USER/@NAME,concat('(',concat(DATA/METRICAS/USER/@LOGIN,')')))"/>
		<xsl:with-param name="SELECT" select="$menu"/>
				<xsl:with-param name="HELP">metricas.xml#1.3.9</xsl:with-param>
	</xsl:call-template>

<xsl:call-template name="pieComun"/>
	</body>
	</html>
</xsl:template>

<xsl:template name="cuerpo">
			
		<xsl:for-each select="DATA/METRICAS">
			<xsl:if test="not(@ERROR='')">
				<script>mostarError('<xsl:value-of select="@ERROR"/>')</script>
				</xsl:if>
		</xsl:for-each>

	<table border="0" cellpadding="5" align="center" cellspacing="5" width="780" summary="Esta tabla contiene las mtricas de tareas Sin Prioridad Asignada">
	<tr><td width="650" class="cab1">&#187;Mtrica de tareas asignadas sin prioridad (Maestro)</td></tr>
	<tr><td colspan="2">
	<form action="{$servlet}" METHOD="POST" name="metricas">
		<input type="hidden" name="module" value = "dumbo7/metricas/sinPrio.formSinPrioMaestro"/>
		<table class="cont" id="metricas" border="0" cellpadding="3" cellspacing="1" width="100%" summary="Esta tabla contiene las mtricas">
		<tr class="cabe">
			<td width="450" colspan="2"><b>Parmetros</b></td>
			<td width="150" colspan="2"><b>Periodo</b></td>
		</tr>
		
		<tr class="administracion">
			<!--Seleccin de seccion. Se podrn seleccionar o 'TODAS' o una seccion en concreto (en este caso se filtra)-->
			<td width="80">
				Seccin:
			</td>
			<td width="640">
			<select tabindex="1" name="SecCod" size="1" style="width:280px;" onChange="javascript:CambiosEnSeccion(this.options[this.selectedIndex].value)">
					<option value=''>&lt;-- Sin Filtro --></option>
					<xsl:call-template name="muestraSeccionMaestro">
						<xsl:with-param name="nodo" select="DATA/METRICAS"/>
					</xsl:call-template>
				</select>
				&#160;&#160;
				<input tabindex="2" type="text" name="SecDescrip" size="10"/>
				&#160;
				<a href="javascript:SecFiltroOn()"><img id="SecFiltroIcoOFF" style="display:inline" border="0" src="../graficos/iconos/ico_filtroOff.gif" alt="Aplicar Filtrado"/></a>
				<a href="javascript:SecFiltroOff()"><img id="SecFiltroIcoON" style="display:none" border="0" src="../graficos/iconos/ico_filtroOn.gif" alt="Deshacer Filtrado"/></a>
				&#160;<select tabindex="3" name="EstadoSec" size="1" onChange="javascript:ChangeEstateSec(this.options[this.selectedIndex].value)">
						<option value='V' select = "true">Vigentes</option>
						<option value='T'>Todas</option>
					  </select>
			</td>
			<!--Seleccin fecha de inicio de la mtrica-->
			<td width="7%">Desde:&#160;</td>
			<td width="15%">
			<input tabindex="11" type="text" onChange="changeDate(this)" name="Fechas" id="f_FecDesde" size="11" value=""/>
							<img src="../dumbo7/utils/jscalendar/img.gif" id="f_trigger_a"
								style="cursor: pointer; border: 1px solid red;"
								title="Selecciona Fecha"
								onmouseover="this.style.background='red';"
								onmouseout="this.style.background=''"  />
			</td>
								<script type="text/javascript">
									Calendar.setup({
										inputField     :    "f_FecDesde",
										ifFormat       :    "%d/%m/%Y",
										button         :    "f_trigger_a",
										align          :    "Tl",
										onSelect       :    selectDateDesde,
										singleClick    :    false
										});
								</script>	
			
		</tr>
		<tr class="administracion">
			<!--Seleccin de aplicacion Se podrn seleccionar o 'TODAS' o una aplicacion en concreto (en este caso se filtra)-->
			<td width="80">
				Aplicacin:
			</td>
			<td width="640">
			<select tabindex="4" name="AplCod" size="1" style="width:280px;" onChange="javascript:comprobarSeleccionApl();">
					<option value=''>&lt;-- Sin Filtro --></option>
					<xsl:call-template name="muestraAplicaciones">
						<xsl:with-param name="nodo" select="DATA/METRICAS"/>
						<xsl:with-param name="espacio" select="'&#160;'"/>
					</xsl:call-template>
				</select>
				&#160;&#160;
				<input tabindex="5" type="text" name="AplDescrip" size="10"/>
				&#160;
				<a href="javascript:AplFiltroOn()"><img id="AplFiltroIcoOFF" style="display:inline" border="0" src="../graficos/iconos/ico_filtroOff.gif" alt="Aplicar Filtrado"/></a>
				<a href="javascript:AplFiltroOff()"><img id="AplFiltroIcoON" style="display:none" border="0" src="../graficos/iconos/ico_filtroOn.gif" alt="Deshacer Filtrado"/></a>
				&#160;<select tabindex="6" name="EstadoApl" size="1" onChange="javascript:ChangeEstateApl(this.options[this.selectedIndex].value)">
						<option value='V' select = "true">Vigentes</option>
						<option value='T'>Todas</option>
					  </select>
			</td>
			<!--Seleccin fecha de fin de la mtrica-->
			<td>Hasta:&#160;</td>
			<td>
				<input tabindex="12" type="text" onChange="changeDate(this)" name="Fechas" id="f_FecHasta" size="11" value = ""/>
						<img src="../dumbo7/utils/jscalendar/img.gif" id="f_trigger_b"
							style="cursor: pointer; border: 1px solid red;"
							title="Selecciona Fecha"
							onmouseover="this.style.background='red';"
							onmouseout="this.style.background=''"/>
			</td>
							<script type="text/javascript">
								Calendar.setup({
								inputField     :    "f_FecHasta",
								ifFormat       :    "%d/%m/%Y",
								button         :    "f_trigger_b",
								align          :    "Tl",
								onSelect       :    selectDateHasta,
								singleClick    :    false
								});
			</script>
		</tr>
		<!--**************************INFORMATICO*********************-->
		<tr class="administracion">
			<td width="80">
				<xsl:call-template name="traduce"><xsl:with-param name="id" select="'Informtico'"/></xsl:call-template>
			</td>
			<td colspan="3">
				Identificador:&#160;&#160;
				<input tabindex="7" type="text" name="InfCod" size="20" onChange="javascript:buscaDNI(this.value,'INF','InfApe');"/>
				&#160;
				<a href="javascript:busquedaGenerica('?module=dumbo7/metricas/estado.index.buscarGenerico','INF');">
					<img id="Busqueda" style="display:inline" border="0" src="../graficos/iconos/ampliar.gif" alt="Realizar Bsqueda"/>
				</a>
			</td>
		</tr>
		<tr class="administracion">
			<td>&#160;</td>
			<td colspan="3" id="InfApe"/>
		</tr>
		<!--**************************USUARIO*********************-->
		<tr class="administracion">
			<!--Seleccin del usuario. Solo se deber pasar el valor si su radiobutton se encuentra activo (usuario o grupo de usuarios)-->
			<!--An as, se deber elegir entre 'TODOS' y seleccionar uno-->
			<td width="80">
				<input type="radio" name="usuarioCheck" value="usu" checked="true" onClick="javascript:Usuario_GrupoUsu()"/>&#160;&#160;Usuario
			</td>
			<td colspan="3">
				Identificador:&#160;&#160;
				<input tabindex="8" type="text" name="UsuCod" size="20" onChange="javascript:buscaDNI(this.value,'USR','UsuApe');"/>
				&#160;
				<a href="javascript:busquedaGenerica('?module=dumbo7/metricas/estado.index.buscarGenerico','USR');">
					<img id="Busqueda" style="display:inline" border="0" src="../graficos/iconos/ampliar.gif" alt="Realizar Bsqueda"/>
				</a>
			</td>
		</tr>
		<tr class="administracion">
			<td>&#160;</td>
			<td colspan="3" id="UsuApe"/>
		</tr>
		
		<!--**************************GRUPO DE USUARIOS*********************-->
		<tr class="administracion">
			<td width="80">
				<input type="radio" name="usuarioCheck" value="gusu" onClick="javascript:Usuario_GrupoUsu()"/>&#160;Grupo Usuarios:
			</td>
			<td colspan="3">
			<select tabindex="9" name="GruCod" size="1" disabled="true" style="width:270px;">
					<option value=''>&lt;-- Sin Filtro --></option>
					<xsl:for-each select="DATA/METRICAS/GRUPO_USUARIOS">
						<xsl:sort select="@DESCRIPCION"/>
						<option value="{@CODIGO}"><xsl:value-of select="@DESCRIPCION"/></option>
					</xsl:for-each>
				</select>
				&#160;&#160;
				<input tabindex="10" type="text" name="GruDescrip" size="10" disabled="true"/>
				&#160;
				<a href="javascript:GruUsuFiltroOn()"><img id="GruFiltroIcoOFF" style="display:inline" border="0" src="../graficos/iconos/ico_filtroOff.gif" alt="Aplicar Filtrado"/></a>
				<a href="javascript:GruUsuFiltroOff()"><img id="GruFiltroIcoON" style="display:none" border="0" src="../graficos/iconos/ico_filtroOn.gif" alt="Deshacer Filtrado"/></a>
			</td>
		</tr>

		<tr class="administracion">
		<td colspan="7" align="center">
			<input tabindex="13" type="button" class="boton" value="Resultados" onclick="javascript:enviarResultados('?module=dumbo7/metricas/sinPrio.formSinPrioMaestro.Resultado');"/>
			&#160;&#160;&#160;&#160;
			<input tabindex="14" type="button" class="boton" value="Limpiar Formulario" onblur="renuevaTab()" onclick="javascript:document.metricas.submit();"/>
		</td>
		</tr>
	</table>
	</form>
	</td></tr>
	</table>
	
</xsl:template>

</xsl:stylesheet>