package dumbo7.metricas.topx;

import dumbo7.metricas.*;

import java.sql.*;
import java.sql.ResultSet;
import java.util.*;

import dumbo7.utils.*;

import org.hibernate.Query;
import org.hibernate.Session;

import atica.frameweb.utils.*;

/**
 * @author Antonio
 *
 * Gestor de Metricas TopX de Dumbo
 * 
 */
public class GestorTopX extends GeneralManager {
	private List seccionesResponsable = new Vector();
	private List secciones = new Vector();
	private List ModoDato;
	private Vector resultadoMetricas = new Vector();
	private Vector resultadoMetricas_tm = new Vector();
		
	private String Seccion = "";
	private String Datos = "";
	private String Codigo = "";
	private String Patron = "";
	
	private boolean masPen = false;
	private boolean menosPen = false;
	private boolean masResu = false;
	private boolean menosResu = false;
	private boolean dedicacion = false;
	private boolean atencion = false;
	
	private String FechaDesde;
	private String FechaHasta;
	private String NumInf;
	private String Desglose = "";/**Desglose que se puede hacer cuando estas en modo DATO*/
		
	public GestorTopX() {}
	
	//Mtodos get() para el mapeo
	public List getSeccionesResponsable() { return seccionesResponsable; }
	public List getSecciones() { return secciones; }
	public List getModoDato(){return ModoDato;}
	public Vector getResultadoMetricas(){return this.resultadoMetricas;}
	public Vector getResultadoMetricas_tm(){return this.resultadoMetricas_tm;}
	
	//Mtodos set para recoger los datos del formulario
	/**Metdo set() para obtener las fechas de inicio y fin del histrico*/
	public void setFechaDesde(String FDesde){this.FechaDesde = FDesde;}
	public void setFechaHasta(String FHasta){this.FechaHasta = FHasta;}
	
	/**Mtodo para recoger el nmero de informticos a tener en cuenta en la mtrica*/
	public void setNumInf(String N){this.NumInf = N;}
	
	/**Patron de las busquedas de secciones, categoras grupos usuarios...*/
	public void setPatron(String patron){this.Patron = patron;}
	
	/**Con esto sabemos las querys que de se debern ejecutar*/
	public void setMasPen(Boolean b){this.masPen = b.booleanValue();}
	public void setMenosPen(Boolean b){this.menosPen = b.booleanValue();}
	public void setMasResu(Boolean b){this.masResu = b.booleanValue();}
	public void setMenosResu(Boolean b){this.menosResu = b.booleanValue();}
	public void setDedicacion(Boolean b){this.dedicacion = b.booleanValue();}
	public void setAtencion(Boolean b){this.atencion = b.booleanValue();}
		
	public void setSeccion(String sec){this.Seccion = sec;}
	public void setDesglose(String Des){this.Desglose = Des;}
	
	/**	Lista todas las secciones*/
	public void listaSecciones(Session conn){
		try{
			Query q = conn.createQuery(getQuery("AllSecciones"));
			q = q.setString("sist",user.getDatosMenu().idSelected());
			secciones  = (List)q.list();
		}
		catch (Exception ex){
			setErrorMessage("GestorMetricas[Lectura de BBDD]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
	}
	/**-------------LISTADOS DE UN NICO ELEMENTO(COMPONENTE)-------------------*/
	public void QuerySeccion(Session conn, String SecCod){
		try{
			Query q = conn.createQuery(getQuery("ListaUnaSeccion"));
			q = q.setString("sist",user.getDatosMenu().idSelected());
			q = q.setString("cod",SecCod);
			secciones  = (List)q.list();		
		}catch (Exception ex){
			setErrorMessage("GestorMetricas[Lectura de BBDD]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
	}
	
	/**Lista secciones con datos sin importar el estado, para el select inicial de secciones(no incluye estado finalizado)**/
	public void listaSeccionesConDatos(Session conn) {
		PreparedStatement pstmt;
		
		try{
			String ResultadoQuery = getQuery("SeccionesConDatos");
			ResultadoQuery = ResultadoQuery.replaceAll(":SISTEMA",user.getDatosMenu().idSelected());
			ResultadoQuery = ResultadoQuery.replaceAll(":GESTOR",user.getIdentificador());
			pstmt = conn.connection().prepareStatement(ResultadoQuery);
			ResultSet rs = pstmt.executeQuery();
			
		 	while (rs.next()) {
	 	    	D7Secciones sec = new D7Secciones();
	 	    	sec.setSecSisCod(rs.getString("Sec_Sis_Cod"));
	 	    	sec.setSecCod(rs.getString("Sec_Cod"));
	 	    	sec.setSecDescrip(rs.getString("Sec_Descrip"));
	 	    	sec.setSecIdRespon(rs.getString("Sec_Id_Respon"));
	 	    	sec.setSecSecCod(rs.getString("Sec_Sec_Cod"));
	 	    	sec.setSecEstado(rs.getString("Sec_Estado"));
	 	    	secciones.add(sec);
	 	    }
		 	rs.close();
	 	    pstmt.close();
		} catch (Exception ex) {
			System.out.println(ex);
			setErrorMessage("GestorMetricas[Lectura de BBDD]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
	}
	
	//-------------------SECCIONES para el DESGLOSE-------------------
	public void listaSeccionesDesglose(Session conn){
		PreparedStatement pstmt;
		/**String para construir la query de MAESTRO para tareas en estado resuelto*/
		String Query ="";
		try{		 	 
			Query = getQuery("ListaDesglose");
			Query = Query.replaceAll(":SISTEMA",user.getDatosMenu().idSelected());
			pstmt = conn.connection().prepareStatement(Query);
			ResultSet rs = pstmt.executeQuery();
			while (rs.next()) {
				D7Secciones sec = new D7Secciones();
				sec.setSecSisCod(rs.getString("Sec_Sis_Cod"));
	 	    	sec.setSecCod(rs.getString("Sec_Cod"));
	 	    	sec.setSecDescrip(rs.getString("Sec_Descrip"));
	 	    	sec.setSecIdRespon(rs.getString("Sec_Id_Respon"));
	 	    	sec.setSecSecCod(rs.getString("Sec_Sec_Cod"));
	 	    	sec.setSecEstado(rs.getString("Sec_Estado"));
	 	    	this.secciones.add(sec);
			}   
		 rs.close();
		 pstmt.close();
		
		} catch (Exception ex) {
			System.out.println(ex);
			setErrorMessage("GestorMetricas [Lectura de BBDD]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
	}
	
	/**-------------------GESTOR-------------------*/
	public void listaSeccionesGestor(Session conn) {
		PreparedStatement pstmt;
		
		try{
			String ResultadoQuery = getQuery("SeccionesGestorConAyuda");
			ResultadoQuery = ResultadoQuery.replaceAll(":SISTEMA",user.getDatosMenu().idSelected());
			ResultadoQuery = ResultadoQuery.replaceAll(":GESTOR",user.getIdentificador());
			pstmt = conn.connection().prepareStatement(ResultadoQuery);
			ResultSet rs = pstmt.executeQuery();
			
		 	while (rs.next()) {
	 	    	D7Secciones sec = new D7Secciones();
	 	    	sec.setSecSisCod(rs.getString("Sec_Sis_Cod"));
	 	    	sec.setSecCod(rs.getString("Sec_Cod"));
	 	    	sec.setSecDescrip(rs.getString("Sec_Descrip"));
	 	    	sec.setSecIdRespon(rs.getString("Sec_Id_Respon"));
	 	    	sec.setSecSecCod(rs.getString("Sec_Sec_Cod"));
	 	    	sec.setSecEstado(rs.getString("Sec_Estado"));
	 	    	seccionesResponsable.add(sec);
	 	    }
		 	rs.close();
	 	    pstmt.close();
		} catch (Exception ex) {
			System.out.println(ex);
			setErrorMessage("GestorMetricas[Lectura de BBDD]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
	}
	/**-------------------MAESTRO-------------------*/
	public void listaSeccionesMaestro(Session conn){
		try{
			Query q = conn.createQuery(getQuery("SeccionesMaestroConAyuda"));
			q = q.setString("sist",user.getDatosMenu().idSelected());
			secciones  = (List)q.list();
		} catch (Exception ex) {
			setErrorMessage("GestorMetricas[Lectura de BBDD]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
	}
		
	
	/** Mtodo para sustituir todos los parmetros de la query de ListaEnModoDato o ListaEnModoDatoDesglose
	* En este mtodo se elige cual de las 2 querys realizar en funcin de si se ha elegido desglose o no
	* Adems tambin se sustituyen los parmetros en funcin de si se ha introducido usuario, informatico, seccion...
	* */
	/**-------------------RESULTADOS de las mtricas para MAESTRO-------------------*/
	public void listaModoDatoMaestro(Session conn){
		PreparedStatement pstmtF;
		PreparedStatement pstmtP;
		/**String para construir la query de MAESTRO para tareas en estado resuelto*/
		String QueryR ="";
		/**String para construir la query de MESTROS para tareas en estado pendiente*/
		String QueryP ="";
		try{
			/**Inicio de la cuenta para la medicin del tiempo de ejecucin de la METRICA*/
			java.util.Date FechaInicio = new java.util.Date();
			int MinutosI = FechaInicio.getMinutes();
			int SegundosI = FechaInicio.getSeconds();
			
			/**Con este bucle se construye las querys que se ejecutan:
			 * 		T> Tareas con mas pendientes/resueltas (dependiente de en que query te encuentes 'P o R')
			 * 		T< Tareas con menos pendientes/resueltas (dependiente de en que query te encuentes 'P o R')
			 * 		I> Incidencias con mas pendientes/resueltas (dependiente de en que query te encuentes 'P o R')
			 *	 	I< Incidencias con mas pendientes/resueltas (dependiente de en que query te encuentes 'P o R')
			 * 		P> Peticiones con mas pendientes/resueltas (dependiente de en que query te encuentes 'P o R')
			 * 		P< Peticiones con mas pendientes/resueltas (dependiente de en que query te encuentes 'P o R')
			 * */
			for(int i = 0; i<=2; i++){
				String tipo = null;
				
				if(i == 0){tipo = "T";}
				if(i == 1){tipo = "I";}
				if(i == 2){tipo = "P";}
			
				for (int j = 0 ; j<=1 ; j++){
					if(j ==0 & this.masResu == true || j ==1 & this.menosResu == true){
						QueryR = getQuery("ListaResueltas");
						QueryR = QueryR.replaceAll(":CONDICION_GESTOR","");
					}
					if(j ==0 & this.masPen == true || j ==1 & this.menosPen == true){
						QueryP = getQuery("ListaPendientes");
						QueryP = QueryP.replaceAll(":CONDICION_GESTOR","");
					}
					
					/**Permite llamar a las funciones de atencin o dedicacin con o sin desglose dependiendo
					 * de si la mtrica lo requiere o no*/
					if(Desglose.equals("sec")){
						if(this.atencion){
							QueryR = QueryR.replaceAll(":ATENCION",getQuery("AtencionDesglose"));
						}
						else{
							QueryR = QueryR.replaceAll(":ATENCION","");
						}
						if(this.dedicacion){
							QueryR = QueryR.replaceAll(":DEDICACION",getQuery("DedicacionDesglose"));
						}
						else{
							QueryR = QueryR.replaceAll(":DEDICACION","");
						}
					}
					else{
						if(this.atencion){ 
							QueryR = QueryR.replaceAll(":ATENCION",getQuery("Atencion"));
						}
						else{
							QueryR = QueryR.replaceAll(":ATENCION","");
						}
						if(this.dedicacion){
							QueryR = QueryR.replaceAll(":DEDICACION",getQuery("Dedicacion"));
						}else{
							QueryR = QueryR.replaceAll(":DEDICACION","");
						}
					}
					
					/**Estos sern los 3 tipos de tareas sobre los que se generar la metrica y para cada una
					 * de ellas se tomarn las X mayores y las X menores*/
					if(i == 0){
						QueryR = QueryR.replaceAll(":TIPO_TAR","INC+PET");
						QueryP = QueryP.replaceAll(":TIPO_TAR","INC+PET");
					}
					if(i == 1){
						QueryR = QueryR.replaceAll(":TIPO_TAR",D7TiposTareas.INCIDENCIA);
						QueryP = QueryP.replaceAll(":TIPO_TAR",D7TiposTareas.INCIDENCIA);
					}
					if(i == 2){
						QueryR = QueryR.replaceAll(":TIPO_TAR",D7TiposTareas.PETICION);
						QueryP = QueryP.replaceAll(":TIPO_TAR",D7TiposTareas.PETICION);
					}
					
					QueryR = QueryR.replaceAll(":TIPO",tipo);
					QueryP = QueryP.replaceAll(":TIPO",tipo);
					if(j == 0){
						QueryR = QueryR.replaceAll(":MAYORMENOR",">");
						QueryR = QueryR.replaceAll(":ORDEN","DESC");
						QueryP = QueryP.replaceAll(":MAYORMENOR",">");
						QueryP = QueryP.replaceAll(":ORDEN","DESC");
					}
					else{
						QueryR = QueryR.replaceAll(":MAYORMENOR","<");
						QueryR = QueryR.replaceAll(":ORDEN","");
						QueryP = QueryP.replaceAll(":MAYORMENOR","<");
						QueryP = QueryP.replaceAll(":ORDEN","");
					}
							
					/**Construimos la query dependiendo del PERIODO introducido si no hay inicio = "DesdeInicio de tiempos"; si no hay fin = "HastaFin de tiempos*/
					if(!(this.FechaDesde.equals("DD/MM/AAAA")) & !(this.FechaHasta.equals("DD/MM/AAAA"))){
						QueryR = QueryR.replaceAll(":FINICIO",this.FechaDesde);
						QueryR = QueryR.replaceAll(":FFIN",this.FechaHasta);
						QueryP = QueryP.replaceAll(":FINICIO",this.FechaDesde);
						QueryP = QueryP.replaceAll(":FFIN",this.FechaHasta);
					}else if(this.FechaDesde.equals("DD/MM/AAAA") & !(this.FechaHasta.equals("DD/MM/AAAA"))){
						QueryR = QueryR.replaceAll("':FINICIO'","NULL");
						QueryR = QueryR.replaceAll(":FFIN",this.FechaHasta);
						QueryP = QueryP.replaceAll("':FINICIO'","NULL");
						QueryP = QueryP.replaceAll(":FFIN",this.FechaHasta);
						}else if(!(this.FechaDesde.equals("DD/MM/AAAA")) & this.FechaHasta.equals("DD/MM/AAAA")){
							QueryR = QueryR.replaceAll(":FINICIO",this.FechaDesde);
							QueryR = QueryR.replaceAll("':FFIN'","NULL");
							QueryP = QueryP.replaceAll(":FINICIO",this.FechaDesde);
							QueryP = QueryP.replaceAll("':FFIN'","NULL");
							}else{
								QueryR = QueryR.replaceAll("':FINICIO'","NULL");
								QueryR = QueryR.replaceAll("':FFIN'","NULL");
								QueryP = QueryP.replaceAll("':FINICIO'","NULL");
								QueryP = QueryP.replaceAll("':FFIN'","NULL");
								}
					
					/**Si se introduce una SECCIN por la que filtrar, sino el parmetro seccin ser NULL*/
					if(!this.Seccion.equals("")){
						QueryR = QueryR.replaceAll(":SEC",this.Seccion);
						QueryP = QueryP.replaceAll(":SEC",this.Seccion);
					}
					else{
						QueryR = QueryR.replaceAll("':SEC'","NULL");
						QueryP = QueryP.replaceAll("':SEC'","NULL");
					}
					
					/**Sustitucin del DESGLOSE o no*/
					if(this.Desglose.equals("sec")){
						QueryR = QueryR.replaceAll(":DESGLOSE_COD","sec_cod");
						QueryR = QueryR.replaceAll(":TABLASISTEMAS"," AND sec_sis_cod = " + "'"+user.getDatosMenu().idSelected()+"'");
						QueryR = QueryR.replaceAll(":DESCRIPDESGLOSE",",sec_cod desglose");
						QueryR = QueryR.replaceAll(":DESGLOSE",",desglose");
						QueryR = QueryR.replaceAll(":TABLADESGLOSE",",DUMBO.D7_SECCIONES");
						QueryR = QueryR.replaceAll(":GROUP_DESGLOSE",",sec_cod");
						
						QueryP = QueryP.replaceAll(":DESGLOSE_COD","sec_cod");
						QueryP = QueryP.replaceAll(":TABLASISTEMAS","AND sec_sis_cod = " + "'"+user.getDatosMenu().idSelected()+"'");
						QueryP = QueryP.replaceAll(":DESCRIPDESGLOSE",",sec_cod desglose");
						QueryP = QueryP.replaceAll(":DESGLOSE",",desglose");
						QueryP = QueryP.replaceAll(":TABLADESGLOSE",",DUMBO.D7_SECCIONES");
						QueryP = QueryP.replaceAll(":GROUP_DESGLOSE",",sec_cod");
					}
					else{
						QueryR = QueryR.replaceAll(":DESGLOSE_COD","NULL");
						QueryR = QueryR.replaceAll(":TABLASISTEMAS","");
						QueryR = QueryR.replaceAll(":DESCRIPDESGLOSE","");
						QueryR = QueryR.replaceAll(":DESGLOSE","");
						QueryR = QueryR.replaceAll(":TABLADESGLOSE","");
						QueryR = QueryR.replaceAll(":GROUP_DESGLOSE","");
											
						QueryP = QueryP.replaceAll(":DESGLOSE_COD","NULL");
						QueryP = QueryP.replaceAll(":TABLASISTEMAS","");
						QueryP = QueryP.replaceAll(":DESCRIPDESGLOSE","");
						QueryP = QueryP.replaceAll(":DESGLOSE","");
						QueryP = QueryP.replaceAll(":TABLADESGLOSE","");
						QueryP = QueryP.replaceAll(":GROUP_DESGLOSE","");
					}
					
					/**Estado de Tarea = FINALIZADA*/
					QueryR = QueryR.replaceAll(":FINALIZADA",D7Tareas.FINALIZADA);
					
					/**Tipos de tareas*/
					QueryR = QueryR.replaceAll(":PETICION",D7TiposTareas.PETICION);
					QueryP = QueryP.replaceAll(":PETICION",D7TiposTareas.PETICION);
					QueryR = QueryR.replaceAll(":INCIDENCIA",D7TiposTareas.INCIDENCIA);
					QueryP = QueryP.replaceAll(":INCIDENCIA",D7TiposTareas.INCIDENCIA);
					
					
					/**Nmero de informticos a los que informar*/
					QueryR = QueryR.replaceAll(":X",NumInf);
					QueryP = QueryP.replaceAll(":X",NumInf);
					
					/**El parmetro GESTOR se pone a NULL puesto que nos encontramos en MAESTRO*/
					QueryR = QueryR.replaceAll("':GESTOR'","NULL");
					QueryP = QueryP.replaceAll("':GESTOR'","NULL");
					
					/**SISTEMA*/
					QueryR = QueryR.replaceAll(":SISTEMA",user.getDatosMenu().idSelected());
					QueryP = QueryP.replaceAll(":SISTEMA",user.getDatosMenu().idSelected());
					
					/**La query se ejecutar solo si se ha marcado la opcin y por lo tanto se ha activado el booleano*/
					if(j ==0 & this.masResu == true || j ==1 & this.menosResu == true){
						pstmtF = conn.connection().prepareStatement(QueryR);
						ResultSet rsF = pstmtF.executeQuery();
					 	while (rsF.next()) {
					 		/**RECOGIDA DE RESULTADOS(de tareas finalizadas) Y MAPEO A TRAVS DE LA CLASE MTRICAS*/
					 		Metricas M = new Metricas();
				 	    	M.setInformaticoID(rsF.getString(1));
				 	    	M.setInformatico(rsF.getString(2));
				 	    	M.setParams(rsF.getString(3));
				 	    	if(i == 0) M.setTareas(new Integer(rsF.getInt("cantidad")));
				 	    	if(i == 1) M.setIncidencias(new Integer(rsF.getInt("cantidad")));
				 	    	if(i == 2) M.setPeticiones(new Integer(rsF.getInt("cantidad")));
				 	    	if(this.atencion){
				 	    		if(i == 0) M.setTmedioatenTar(new Double(rsF.getDouble("TMA")));
					 	    	if(i == 1) M.setTmedioatenInc(new Double(rsF.getDouble("TMA")));
					 	    	if(i == 2) M.setTmedioatenPet(new Double(rsF.getDouble("TMA")));
				 	        }
				 	        if(this.dedicacion){
				 	        	if(i == 0) M.setTmedioresoTar(new Double(rsF.getDouble("TMD")));
					 	    	if(i == 1) M.setTmedioresoInc(new Double(rsF.getDouble("TMD")));
					 	    	if(i == 2) M.setTmedioresoPet(new Double(rsF.getDouble("TMD")));
				 	        }
				 	        //Dependiendo de si hay desglose o no lo mapeo en la mtrica
				 	    	if(Desglose.equals("sec")){
				 	    		M.setDesglose(rsF.getString("desglose"));
				 	    	}
				 	    	this.resultadoMetricas.add(M);
				 	    }   
				 	    rsF.close();
				 	    pstmtF.close();
					}
					
					/**La query se ejecutar solo si se ha marcado la opcin y por lo tanto se ha activado el booleano*/
					if(j ==0 & this.masPen == true || j ==1 & this.menosPen == true){
						pstmtP = conn.connection().prepareStatement(QueryP);
						ResultSet rsP = pstmtP.executeQuery();
					 	while (rsP.next()) {
					 		/**RECOGIDA DE RESULTADOS(de tareas pendientes) Y MAPEO A TRAVS DE LA CLASE MTRICAS*/
					 		Metricas M = new Metricas();
				 	    	M.setInformaticoID(rsP.getString(1));
				 	    	M.setInformatico(rsP.getString(2));
				 	    	M.setParams(rsP.getString(3));
				 	    	if(i == 0) M.setTareas(new Integer(rsP.getInt("cantidad")));
				 	    	if(i == 1) M.setIncidencias(new Integer(rsP.getInt("cantidad")));
				 	    	if(i == 2) M.setPeticiones(new Integer(rsP.getInt("cantidad")));
				 	       	//Dependiendo de si hay desglose o no lo mapeo en la mtrica
				 	    	if(Desglose.equals("sec")){
				 	    		M.setDesglose(rsP.getString("desglose"));
				 	    	}
				 	    	this.resultadoMetricas.add(M);
				 	    }   
				 	    rsP.close();
				 	    pstmtP.close();
					}
				}
			}
			
			/**FIN de la cuenta para la medicin del tiempo de ejecucin de la METRICA*/
			java.util.Date FechaFin = new java.util.Date();
			int MinutosF = FechaFin.getMinutes();
			int SegundosF = FechaFin.getSeconds();
			/**Tenemos en cuenta si se ha cambiado de minuto mientras se realiza la mtrica*/
			if (SegundosI > SegundosF){
				SegundosF = 60 + SegundosF;
				MinutosF = MinutosF - 1;
			}
		 	setErrorMessage("La mtica se ha realizado en: "+ new Integer(Math.abs(MinutosF-MinutosI)).toString() + " min. y " +new Integer(Math.abs(SegundosF-SegundosI)).toString() + " seg.");
		 	
	 	   } catch (Exception ex) {
			System.out.println(ex);
			setErrorMessage("LISTADO Maestro:"+ex.toString().substring(0,ex.toString().length()-1));
		}
	}
	
	/**-------------------RESULTADOS de las mtricas para GESTOR-------------------*/
	public void listaModoDatoGestor(Session conn){
		PreparedStatement pstmtF;
		PreparedStatement pstmtP;
		/**String para construir la query de MAESTRO para tareas en estado resuelto*/
		String QueryR ="";
		/**String para construir la query de MAESTRO para tareas en estado Pendientes*/
		String QueryP ="";
		try{
			/**Inicio de la cuenta para la medicin del tiempo de ejecucin de la METRICA*/
			java.util.Date FechaInicio = new java.util.Date();
			
			int MinutosI = FechaInicio.getMinutes();
			int SegundosI = FechaInicio.getSeconds();
			
			/**Con este bucle se construye las querys que se ejecutan:
			 * 		T> Tareas con mas pendientes/resueltas (dependiente de en que query te encuentes 'P o R')
			 * 		T< Tareas con menos pendientes/resueltas (dependiente de en que query te encuentes 'P o R')
			 * 		I> Incidencias con mas pendientes/resueltas (dependiente de en que query te encuentes 'P o R')
			 *	 	I< Incidencias con mas pendientes/resueltas (dependiente de en que query te encuentes 'P o R')
			 * 		P> Peticiones con mas pendientes/resueltas (dependiente de en que query te encuentes 'P o R')
			 * 		P< Peticiones con mas pendientes/resueltas (dependiente de en que query te encuentes 'P o R')
			 * */
			for(int i = 0; i<=2; i++){
				String tipo = null;
				
				/**Estos sern los 3 tipos de tareas sobre los que se generar la metrica y para cada una
				 * de ellas se tomarn las X mayores y las X menores*/
				if(i == 0){tipo = "T";}
				if(i == 1){tipo = "I";}
				if(i == 2){tipo = "P";}
			
				for (int j = 0 ; j<=1 ; j++){
					
					if(j ==0 & this.masResu == true || j ==1 & this.menosResu == true){
						QueryR = getQuery("ListaResueltas");
						QueryR = QueryR.replaceAll(":CONDICION_GESTOR",getQuery("CondicionGestor"));
					}
					if(j ==0 & this.masPen == true || j ==1 & this.menosPen == true){
						QueryP = getQuery("ListaPendientes");
						QueryP = QueryP.replaceAll(":CONDICION_GESTOR",getQuery("CondicionGestor"));
					}
					
					/**Permite llamar a las funciones de atencin o dedicacin con o sin desglose dependiendo
					 * de si la mtrica lo requiere o no*/
					if(Desglose.equals("sec")){
						if(this.atencion){
							QueryR = QueryR.replaceAll(":ATENCION",getQuery("AtencionDesglose"));
						}
						else{
							QueryR = QueryR.replaceAll(":ATENCION","");
						}
						if(this.dedicacion){
							QueryR = QueryR.replaceAll(":DEDICACION",getQuery("DedicacionDesglose"));
						}
						else{
							QueryR = QueryR.replaceAll(":DEDICACION","");
						}
					}
					else{
						if(this.atencion){ 
							QueryR = QueryR.replaceAll(":ATENCION",getQuery("Atencion"));
						}
						else{
							QueryR = QueryR.replaceAll(":ATENCION","");
						}
						if(this.dedicacion){
							QueryR = QueryR.replaceAll(":DEDICACION",getQuery("Dedicacion"));
						}else{
							QueryR = QueryR.replaceAll(":DEDICACION","");
						}
					}
					
					/**Estos sern los 3 tipos de tareas sobre los que se generar la metrica y para cada una
					 * de ellas se tomarn las X mayores y las X menores*/
					if(i == 0){
						QueryR = QueryR.replaceAll(":TIPO_TAR","INC+PET");
						QueryP = QueryP.replaceAll(":TIPO_TAR","INC+PET");
					}
					if(i == 1){
						QueryR = QueryR.replaceAll(":TIPO_TAR",D7TiposTareas.INCIDENCIA);
						QueryP = QueryP.replaceAll(":TIPO_TAR",D7TiposTareas.INCIDENCIA);
					}
					if(i == 2){
						QueryR = QueryR.replaceAll(":TIPO_TAR",D7TiposTareas.PETICION);
						QueryP = QueryP.replaceAll(":TIPO_TAR",D7TiposTareas.PETICION);
					}
					
					QueryR = QueryR.replaceAll(":TIPO",tipo);
					QueryP = QueryP.replaceAll(":TIPO",tipo);
					if(j == 0){
						QueryR = QueryR.replaceAll(":MAYORMENOR",">");
						QueryR = QueryR.replaceAll(":ORDEN","DESC");
						QueryP = QueryP.replaceAll(":MAYORMENOR",">");
						QueryP = QueryP.replaceAll(":ORDEN","DESC");
					}
					else{
						QueryR = QueryR.replaceAll(":MAYORMENOR","<");
						QueryR = QueryR.replaceAll(":ORDEN","");
						QueryP = QueryP.replaceAll(":MAYORMENOR","<");
						QueryP = QueryP.replaceAll(":ORDEN","");
					}
					
					/**Construimos la query dependiendo del PERIODO introducido si no hay inicio = "DesdeInicio de tiempos"; si no hay fin = "HastaFin de tiempos*/
					if(!(this.FechaDesde.equals("DD/MM/AAAA")) & !(this.FechaHasta.equals("DD/MM/AAAA"))){
						QueryR = QueryR.replaceAll(":FINICIO",this.FechaDesde);
						QueryR = QueryR.replaceAll(":FFIN",this.FechaHasta);
						QueryP = QueryP.replaceAll(":FINICIO",this.FechaDesde);
						QueryP = QueryP.replaceAll(":FFIN",this.FechaHasta);
					}else if(this.FechaDesde.equals("DD/MM/AAAA") & !(this.FechaHasta.equals("DD/MM/AAAA"))){
						QueryR = QueryR.replaceAll("':FINICIO'","NULL");
						QueryR = QueryR.replaceAll(":FFIN",this.FechaHasta);
						QueryP = QueryP.replaceAll("':FINICIO'","NULL");
						QueryP = QueryP.replaceAll(":FFIN",this.FechaHasta);
						}else if(!(this.FechaDesde.equals("DD/MM/AAAA")) & this.FechaHasta.equals("DD/MM/AAAA")){
							QueryR = QueryR.replaceAll(":FINICIO",this.FechaDesde);
							QueryR = QueryR.replaceAll("':FFIN'","NULL");
							QueryP = QueryP.replaceAll(":FINICIO",this.FechaDesde);
							QueryP = QueryP.replaceAll("':FFIN'","NULL");
						}else{
								QueryR = QueryR.replaceAll("':FINICIO'","NULL");
								QueryR = QueryR.replaceAll("':FFIN'","NULL");
								QueryP = QueryP.replaceAll("':FINICIO'","NULL");
								QueryP = QueryP.replaceAll("':FFIN'","NULL");
							}
					
					/**Si se introduce una SECCIN por la que filtrar, sino el parmetro seccin ser NULL*/
					if(!this.Seccion.equals("")){
						QueryR = QueryR.replaceAll(":SEC",this.Seccion);
						QueryP = QueryP.replaceAll(":SEC",this.Seccion);
						QueryP = QueryP.replaceAll(":SEC",this.Seccion);
					}
					else{
						QueryR = QueryR.replaceAll("':SEC'","NULL");
						QueryP = QueryP.replaceAll("':SEC'","NULL");
					}
					
					/**Sustitucin del DESGLOSE o no*/
					if(this.Desglose.equals("sec")){
						QueryR = QueryR.replaceAll(":DESGLOSE_COD","sec_cod");
						QueryR = QueryR.replaceAll(":TABLASISTEMAS"," AND sec_sis_cod = " + "'"+user.getDatosMenu().idSelected()+"'");
						QueryR = QueryR.replaceAll(":DESCRIPDESGLOSE",",sec_cod desglose");
						QueryR = QueryR.replaceAll(":DESGLOSE",",desglose");
						QueryR = QueryR.replaceAll(":TABLADESGLOSE",",DUMBO.D7_SECCIONES");
						QueryR = QueryR.replaceAll(":GROUP_DESGLOSE",",sec_cod");
						
						QueryP = QueryP.replaceAll(":DESGLOSE_COD","sec_cod");
						QueryP = QueryP.replaceAll(":TABLASISTEMAS","AND sec_sis_cod = " + "'"+user.getDatosMenu().idSelected()+"'");
						QueryP = QueryP.replaceAll(":DESCRIPDESGLOSE",",sec_cod desglose");
						QueryP = QueryP.replaceAll(":DESGLOSE",",desglose");
						QueryP = QueryP.replaceAll(":TABLADESGLOSE",",DUMBO.D7_SECCIONES");
						QueryP = QueryP.replaceAll(":GROUP_DESGLOSE",",sec_cod");
					}
					else{
						QueryR = QueryR.replaceAll(":DESGLOSE_COD","NULL");
						QueryR = QueryR.replaceAll(":TABLASISTEMAS","");
						QueryR = QueryR.replaceAll(":DESCRIPDESGLOSE","");
						QueryR = QueryR.replaceAll(":DESGLOSE","");
						QueryR = QueryR.replaceAll(":TABLADESGLOSE","");
						QueryR = QueryR.replaceAll(":GROUP_DESGLOSE","");
											
						QueryP = QueryP.replaceAll(":DESGLOSE_COD","NULL");
						QueryP = QueryP.replaceAll(":TABLASISTEMAS","");
						QueryP = QueryP.replaceAll(":DESCRIPDESGLOSE","");
						QueryP = QueryP.replaceAll(":DESGLOSE","");
						QueryP = QueryP.replaceAll(":TABLADESGLOSE","");
						QueryP = QueryP.replaceAll(":GROUP_DESGLOSE","");
					}
										
					/**Estado de Tarea = FINALIZADA*/
					QueryR = QueryR.replaceAll(":FINALIZADA",D7Tareas.FINALIZADA);
					
					/**Tipos de tareas*/
					QueryR = QueryR.replaceAll(":PETICION",D7TiposTareas.PETICION);
					QueryP = QueryP.replaceAll(":PETICION",D7TiposTareas.PETICION);
					QueryR = QueryR.replaceAll(":INCIDENCIA",D7TiposTareas.INCIDENCIA);
					QueryP = QueryP.replaceAll(":INCIDENCIA",D7TiposTareas.INCIDENCIA);
										
					/**Nmero de informticos a los que informar*/
					QueryR = QueryR.replaceAll(":X",NumInf);
					QueryP = QueryP.replaceAll(":X",NumInf);
					
					/**El parmetro GESTOR se pone a NULL puesto que nos encontramos en MAESTRO*/
					QueryR = QueryR.replaceAll(":GESTOR",user.getIdentificador());
					QueryP = QueryP.replaceAll(":GESTOR",user.getIdentificador());
					
					/**SISTEMA*/
					QueryR = QueryR.replaceAll(":SISTEMA",user.getDatosMenu().idSelected());
					QueryP = QueryP.replaceAll(":SISTEMA",user.getDatosMenu().idSelected());
					
					
					/**La query se ejecutar solo si se ha marcado la opcin y por lo tanto se ha activado el booleano*/
					if(j ==0 & this.masResu == true || j ==1 & this.menosResu == true){
						pstmtF = conn.connection().prepareStatement(QueryR);
						ResultSet rsF = pstmtF.executeQuery();
					 	while (rsF.next()) {
					 		/**RECOGIDA DE RESULTADOS(de tareas Resueltas) Y MAPEO A TRAVS DE LA CLASE MTRICAS*/
				 	    	Metricas M = new Metricas();
				 	    	M.setInformaticoID(rsF.getString(1));
				 	    	M.setInformatico(rsF.getString(2));
				 	    	M.setParams(rsF.getString(3));
				 	    	if(i == 0) M.setTareas(new Integer(rsF.getInt("cantidad")));
				 	    	if(i == 1) M.setIncidencias(new Integer(rsF.getInt("cantidad")));
				 	    	if(i == 2) M.setPeticiones(new Integer(rsF.getInt("cantidad")));
				 	    	if(this.atencion){
				 	    		if(i == 0) M.setTmedioatenTar(new Double(rsF.getDouble("TMA")));
					 	    	if(i == 1) M.setTmedioatenInc(new Double(rsF.getDouble("TMA")));
					 	    	if(i == 2) M.setTmedioatenPet(new Double(rsF.getDouble("TMA")));
				 	        }
				 	        if(this.dedicacion){
				 	        	if(i == 0) M.setTmedioresoTar(new Double(rsF.getDouble("TMD")));
					 	    	if(i == 1) M.setTmedioresoInc(new Double(rsF.getDouble("TMD")));
					 	    	if(i == 2) M.setTmedioresoPet(new Double(rsF.getDouble("TMD")));
				 	        }
				 	        //Dependiendo de si hay desglose o no lo mapeo en la mtrica
				 	    	if(Desglose.equals("sec")){
				 	    		M.setDesglose(rsF.getString("desglose"));
				 	    	}
				 	    	this.resultadoMetricas.add(M);
				 	    }   
				 	    rsF.close();
				 	    pstmtF.close();
					}
					/**La query se ejecutar solo si se ha marcado la opcin y por lo tanto se ha activado el booleano*/
					if(j ==0 & this.masPen == true || j ==1 & this.menosPen == true){
						pstmtP = conn.connection().prepareStatement(QueryP);
						ResultSet rsP = pstmtP.executeQuery();
					 	while (rsP.next()) {
					 		/**RECOGIDA DE RESULTADOS(de tareas pendientes) Y MAPEO A TRAVS DE LA CLASE MTRICAS*/
				 	    	Metricas M = new Metricas();
				 	    	M.setInformaticoID(rsP.getString(1));
				 	    	M.setInformatico(rsP.getString(2));
				 	    	M.setParams(rsP.getString(3));
				 	    	if(i == 0) M.setTareas(new Integer(rsP.getInt("cantidad")));
				 	    	if(i == 1) M.setIncidencias(new Integer(rsP.getInt("cantidad")));
				 	    	if(i == 2) M.setPeticiones(new Integer(rsP.getInt("cantidad")));
				 	        //Dependiendo de si hay desglose o no lo mapeo en la mtrica
				 	    	if(Desglose.equals("sec")){
				 	    		M.setDesglose(rsP.getString("desglose"));
				 	    	}
				 	    	this.resultadoMetricas.add(M);
				 	    }   
				 	    rsP.close();
				 	    pstmtP.close();
					}
				}
			}
			
			/**FIN de la cuenta para la medicin del tiempo de ejecucin de la METRICA*/
			java.util.Date FechaFin = new java.util.Date();
						
			int MinutosF = FechaFin.getMinutes();
			int SegundosF = FechaFin.getSeconds();
			/**Tenemos en cuenta si se ha cambiado de minuto mientras se realiza la mtrica*/
			if (SegundosI > SegundosF){
				SegundosF = 60 + SegundosF;
				MinutosF = MinutosF - 1;
			}
		 	setErrorMessage("La mtica se ha realizado en: "+ new Integer(Math.abs(MinutosF-MinutosI)).toString() + " min. y " +new Integer(Math.abs(SegundosF-SegundosI)).toString() + " seg.");
		 	
	 	   } catch (Exception ex) {
			System.out.println(ex);
			setErrorMessage("LISTADO Gestor:"+ex.toString().substring(0,ex.toString().length()-1));
		}
	}

	
}
