<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet version="1.0" 
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:xforms="http://www.w3.org/2002/xforms">
	
<xsl:param name="servlet"/>	
<xsl:param name="menu"/>
<xsl:param name="perfil"/>
<xsl:param name="inicio"/>
<xsl:param name="fin"/>
<xsl:param name="SecCod"/>
<xsl:param name="FechaDesde"/>
<xsl:param name="FechaHasta"/>
<xsl:variable name="desglose"/>

<xsl:include href="dumbo7/utils/xsl/utils.xsl"/>
	
<xsl:template match="XMLROOT">
		
	<html lang="es">
		<TITLE>DUMBO7: Resultado Mtrica 'TopX'</TITLE>
		
    <xsl:call-template name="headComun">
         <xsl:with-param name="jscript">
            <SCRIPT LANGUAGE="JavaScript">
				function mostrarError(error){
					alert(error);
				}
			</SCRIPT>
			<script LANGUAJE="JavaScript" src="../js/OnMouse.js"></script>
		 </xsl:with-param>
	</xsl:call-template>
	<body>
		<xsl:for-each select="DATA/METRICAS">
			<xsl:if test="not(@ERROR='')">
				<script>mostrarError('<xsl:value-of select="@ERROR"/>')</script>
				</xsl:if>
		</xsl:for-each>

	<table border="0" align="center" cellpadding="3" cellspacing="1" width="720" summary="Esta tabla contiene las mtricas de tareas TOPX">
	<tr><td colspan="2">
		<table class="cont" id="metricas" border="0" cellpadding="3" cellspacing="2" width="100%" summary="Esta tabla contiene las mtricas">
		<tr class="cab1">
			<td colspan="2">&#187;Resultado: TopX (<xsl:value-of select="$perfil"/>)</td>
			<td width="10" align="center"><b><a href="javascript:window.print()"><img border="0" src="../graficos/iconos/ico_impresora.gif" alt="Imprimir"/></a></b></td>
			<td width="10" align="center"><b><a href="javascript:window.close()">Cerrar</a></b></td>
		</tr>
		<tr class="cabe">
			<td width="140"><b>Periodo</b></td>
			<td width="350"><b>Parmetros</b></td>
			<td colspan="2"></td>
		</tr>
			
		<tr class="administracion">
			<td width="90"><b>Desde:</b>&#160;&#160;<i>
				 <xsl:value-of select="$FechaDesde"/>
			</i></td>
			<td width="350" colspan="3">
				<b>Seccion:&#160;</b>
				<xsl:if test="$SecCod != ''">
					<i><xsl:value-of select="DATA/METRICAS/SECCION[@CODIGO = $SecCod]/@DESCRIPCION"/></i>
				</xsl:if>	
				<xsl:if test="$SecCod = ''">
					<i>TODAS</i>	
				</xsl:if>
			</td>
		</tr>
		<tr class="administracion">
			<td width="90"><b>Hasta:</b>&#160;&#160;<i>
				<xsl:value-of select="$FechaHasta"/>
			</i></td>
			<td colspan="3"></td>
		</tr>
		<!--Seleccin del modo de representacin de datos-->
		<tr class="cabe"><td align="left" colspan="4" ><b>Presentacin de datos</b></td></tr>
		<tr class="administracion">
			<td colspan="4">
				<b>Modo Dato</b>&#160;-->&#160;Representacin&#160;Desglosada&#160;Por&#160;<i>Seccin</i>
			</td>
		</tr>
		<tr class="cabe"><td colspan="10"><b>Resultados</b></td></tr>
	</table>
	<table class="cont" border="0" cellpadding="3" cellspacing="1" width="100%" summary="Tabla para mostar los resultados">
		<xsl:for-each select="DATA/METRICAS/SECCION">
		<xsl:sort select="@DESCRIPCION"/>
		<xsl:variable name="SeccionActual"><xsl:value-of select="@CODIGO"/></xsl:variable>
		<xsl:if test="count(../RESULTADO_METRICAS[@DESGLOSE = $SeccionActual]) > 0">
			<tr class="cabeAlertas"><td colspan="10" align="center"><CENTER><b>Seccin:&#160;"<xsl:value-of select="@DESCRIPCION"/>"</b></CENTER></td></tr>
			<!--Si existen resultados para mas resueltas entonces mostramos el ttulo y estos-->
			<xsl:if test="count(../RESULTADO_METRICAS[@PARAMS='FIN_T>' and @DESGLOSE = $SeccionActual]) > 0">
				<tr class="cabeAlertas"><td colspan="6"><xsl:call-template name="traduce"><xsl:with-param name="id" select="'INFORMTICOS'"/></xsl:call-template>&#160;QUE&#160;MAS&#160;HAN&#160;RESUELTO</td></tr>
				<tr class="administracion">
					<td width="30"><i><b>ID</b></i></td>
					<xsl:choose>
						<xsl:when test="../RESULTADO_METRICAS/@RESOLUCION_TAR and ../RESULTADO_METRICAS/@ATENCION_TAR">
							<td width="250"><i><b>Apellidos/Nombre</b></i></td>
						</xsl:when>
						<xsl:when test="not(../RESULTADO_METRICAS/@ATENCION_TAR) and not(../RESULTADO_METRICAS/@RESOLUCION_TAR)">
							<td width="250" colspan="3"><i><b>Apellidos/Nombre</b></i></td>
						</xsl:when>
						<xsl:otherwise>
							<td width="250" colspan="2"><i><b>Apellidos/Nombre</b></i></td>
						</xsl:otherwise>
					</xsl:choose>
					<td width="50" align="center"><i><b>N-Tareas</b></i></td>
					<td width="50" align="center"><i><b>Tipo Tar.</b></i></td>
					<xsl:if test="../RESULTADO_METRICAS/@RESOLUCION_TAR">
						<td width="60" align="center"><i><b>T.Resolucin</b></i></td>
					</xsl:if>
					<xsl:if test="../RESULTADO_METRICAS/@ATENCION_TAR">
						<td width="60" align="center"><i><b>T.Atencin</b></i></td>
					</xsl:if>
				</tr>
					
					<xsl:for-each select="../RESULTADO_METRICAS[@DESGLOSE = $SeccionActual]">
					<xsl:choose>
						<xsl:when test="@PARAMS = 'FIN_I>'">
							<tr class="incidencia" onmouseover="javascript:onMouseInc(this,'true');" onmouseout="javascript:onMouseInc(this,'false');">
								<td width="30"><xsl:value-of select="@INFORMATICO_ID"/></td>
								<xsl:choose>
									<xsl:when test="@RESOLUCION_INC and @ATENCION_INC">
										<td width="250"><xsl:value-of select="@INFORMATICO"/></td>
									</xsl:when>
									<xsl:when test="not(@ATENCION_INC) and not(@RESOLUCION_INC)">
										<td width="250" colspan="3"><xsl:value-of select="@INFORMATICO"/></td>
									</xsl:when>
									<xsl:otherwise>
										<td width="250" colspan="2"><xsl:value-of select="@INFORMATICO"/></td>
									</xsl:otherwise>
								</xsl:choose>
								<td width="50" align="right"><xsl:value-of select="@INCIDENCIAS"/></td>
								<td width="50" align="right">INCIDENCIAS</td>
								<xsl:if test="@RESOLUCION_INC">
									<td width="60" align="right"><xsl:value-of select="@RESOLUCION_INC"/></td>
								</xsl:if>
								<xsl:if test="@ATENCION_INC">
									<td width="60" align="right"><xsl:value-of select="@ATENCION_INC"/></td>
								</xsl:if>
							</tr>	
						</xsl:when>
						<xsl:when test="@PARAMS = 'FIN_P>'">
							<tr class="peticion" onmouseover="javascript:onMouse(this,'true');" onmouseout="javascript:onMouse(this,'false');">		
								<td width="30"><xsl:value-of select="@INFORMATICO_ID"/></td>
								<xsl:choose>
									<xsl:when test="@RESOLUCION_PET and @ATENCION_PET">
										<td width="250"><xsl:value-of select="@INFORMATICO"/></td>
									</xsl:when>
									<xsl:when test="not(@ATENCION_PET) and not(@RESOLUCION_PET)">
										<td width="250" colspan="3"><xsl:value-of select="@INFORMATICO"/></td>
									</xsl:when>
									<xsl:otherwise>
										<td width="250" colspan="2"><xsl:value-of select="@INFORMATICO"/></td>
									</xsl:otherwise>
								</xsl:choose>
								<td width="50" align="right"><xsl:value-of select="@PETICIONES"/></td>
								<td width="50" align="right">PETICIONES</td>
								<xsl:if test="@RESOLUCION_PET">
									<td width="60" align="right"><xsl:value-of select="@RESOLUCION_PET"/></td>
								</xsl:if>
								<xsl:if test="@ATENCION_PET">
									<td width="60" align="right"><xsl:value-of select="@ATENCION_PET"/></td>
								</xsl:if>
							</tr>
						</xsl:when>
						<xsl:when test="@PARAMS = 'FIN_T>'">
							<tr class="tarea" onmouseover="javascript:onMouseTar(this,'true');" onmouseout="javascript:onMouseTar(this,'false');">
								<td width="30"><xsl:value-of select="@INFORMATICO_ID"/></td>
								<xsl:choose>
									<xsl:when test="@RESOLUCION_TAR and @ATENCION_TAR">
										<td width="250"><xsl:value-of select="@INFORMATICO"/></td>
									</xsl:when>
									<xsl:when test="not(@ATENCION_TAR) and not(@RESOLUCION_TAR)">
										<td width="250" colspan="3"><xsl:value-of select="@INFORMATICO"/></td>
									</xsl:when>
									<xsl:otherwise>
										<td width="250" colspan="2"><xsl:value-of select="@INFORMATICO"/></td>
									</xsl:otherwise>
								</xsl:choose>
								<td width="50" align="right"><xsl:value-of select="@TAREAS"/></td>
								<td width="50" align="right">TAREAS</td>
								<xsl:if test="@RESOLUCION_TAR">
									<td width="60" align="right"><xsl:value-of select="@RESOLUCION_TAR"/></td>
								</xsl:if>
								<xsl:if test="@ATENCION_TAR">
									<td width="60" align="right"><xsl:value-of select="@ATENCION_TAR"/></td>
								</xsl:if>
							</tr>			
						</xsl:when>
					</xsl:choose>		
					</xsl:for-each>
			</xsl:if>
			
			<!--Si existen resultados para menos resueltas entonces mostramos el ttulos y estos-->
			<xsl:if test="count(../RESULTADO_METRICAS[@PARAMS='FIN_T&lt;' and @DESGLOSE = $SeccionActual]) > 0">
				<tr class="cabeAlertas"><td colspan="6"><xsl:call-template name="traduce"><xsl:with-param name="id" select="'INFORMTICOS'"/></xsl:call-template>&#160;QUE&#160;MENOS&#160;HAN&#160;RESUELTO</td></tr>
					<tr class="administracion">
						<td width="30"><i><b>ID</b></i></td>
						<xsl:choose>
							<xsl:when test="../RESULTADO_METRICAS/@RESOLUCION_TAR and ../RESULTADO_METRICAS/@ATENCION_TAR">
								<td width="250"><i><b>Apellidos/Nombre</b></i></td>
							</xsl:when>
							<xsl:when test="not(../RESULTADO_METRICAS/@ATENCION_TAR) and not(../RESULTADO_METRICAS/@RESOLUCION_TAR)">
								<td width="250" colspan="3"><i><b>Apellidos/Nombre</b></i></td>
							</xsl:when>
							<xsl:otherwise>
								<td width="250" colspan="2"><i><b>Apellidos/Nombre</b></i></td>
							</xsl:otherwise>
						</xsl:choose>
						<td width="50" align="center"><i><b>N-Tareas</b></i></td>
						<td width="50" align="center"><i><b>Tipo Tar.</b></i></td>
						<xsl:if test="../RESULTADO_METRICAS/@RESOLUCION_TAR">
							<td width="60" align="center"><i><b>T.Resolucin</b></i></td>
						</xsl:if>
						<xsl:if test="../RESULTADO_METRICAS/@ATENCION_TAR">
							<td width="60" align="center"><i><b>T.Atencin</b></i></td>
						</xsl:if>
					</tr>
					
					<xsl:for-each select="../RESULTADO_METRICAS[@DESGLOSE = $SeccionActual]">
					<xsl:choose>
						<xsl:when test="@PARAMS = 'FIN_I&lt;'">
							<tr class="incidencia" onmouseover="javascript:onMouseInc(this,'true');" onmouseout="javascript:onMouseInc(this,'false');">
								<td width="30"><xsl:value-of select="@INFORMATICO_ID"/></td>
								<xsl:choose>
									<xsl:when test="@RESOLUCION_INC and @ATENCION_INC">
										<td width="250"><xsl:value-of select="@INFORMATICO"/></td>
									</xsl:when>
									<xsl:when test="not(@ATENCION_INC) and not(@RESOLUCION_INC)">
										<td width="250" colspan="3"><xsl:value-of select="@INFORMATICO"/></td>
									</xsl:when>
									<xsl:otherwise>
										<td width="250" colspan="2"><xsl:value-of select="@INFORMATICO"/></td>
									</xsl:otherwise>
								</xsl:choose>
								<td width="50" align="right"><xsl:value-of select="@INCIDENCIAS"/></td>
								<td width="50" align="right">INCIDENCIAS</td>
								<xsl:if test="@RESOLUCION_INC">
									<td width="60" align="right"><xsl:value-of select="@RESOLUCION_INC"/></td>
								</xsl:if>
								<xsl:if test="@ATENCION_INC">
									<td width="60" align="right"><xsl:value-of select="@ATENCION_INC"/></td>
								</xsl:if>
							</tr>	
						</xsl:when>
						<xsl:when test="@PARAMS = 'FIN_P&lt;'">
							<tr class="peticion" onmouseover="javascript:onMouse(this,'true');" onmouseout="javascript:onMouse(this,'false');">		
								<td width="30"><xsl:value-of select="@INFORMATICO_ID"/></td>
								<xsl:choose>
									<xsl:when test="@RESOLUCION_PET and @ATENCION_PET">
										<td width="250"><xsl:value-of select="@INFORMATICO"/></td>
									</xsl:when>
									<xsl:when test="not(@ATENCION_PET) and not(@RESOLUCION_PET)">
										<td width="250" colspan="3"><xsl:value-of select="@INFORMATICO"/></td>
									</xsl:when>
									<xsl:otherwise>
										<td width="250" colspan="2"><xsl:value-of select="@INFORMATICO"/></td>
									</xsl:otherwise>
								</xsl:choose>
								<td width="50" align="right"><xsl:value-of select="@PETICIONES"/></td>
								<td width="50" align="right">PETICIONES</td>
								<xsl:if test="@RESOLUCION_PET">							
									<td width="60" align="right"><xsl:value-of select="@RESOLUCION_PET"/></td>
								</xsl:if>
								<xsl:if test="@ATENCION_PET">
									<td width="60" align="right"><xsl:value-of select="@ATENCION_PET"/></td>
								</xsl:if>
							</tr>
						</xsl:when>
						<xsl:when test="@PARAMS = 'FIN_T&lt;'">
							<tr class="tarea" onmouseover="javascript:onMouseTar(this,'true');" onmouseout="javascript:onMouseTar(this,'false');">
								<td width="30"><xsl:value-of select="@INFORMATICO_ID"/></td>
								<xsl:choose>
									<xsl:when test="@RESOLUCION_TAR and @ATENCION_TAR">
										<td width="250"><xsl:value-of select="@INFORMATICO"/></td>
									</xsl:when>
									<xsl:when test="not(@ATENCION_TAR) and not(@RESOLUCION_TAR)">
										<td width="250" colspan="3"><xsl:value-of select="@INFORMATICO"/></td>
									</xsl:when>
									<xsl:otherwise>
										<td width="250" colspan="2"><xsl:value-of select="@INFORMATICO"/></td>
									</xsl:otherwise>
								</xsl:choose>
								<td width="50" align="right"><xsl:value-of select="@TAREAS"/></td>
								<td width="50" align="right">TAREAS</td>
								<xsl:if test="@RESOLUCION_TAR">
									<td width="60" align="right"><xsl:value-of select="@RESOLUCION_TAR"/></td>
								</xsl:if>
								<xsl:if test="@ATENCION_TAR">
									<td width="60" align="right"><xsl:value-of select="@ATENCION_TAR"/></td>
								</xsl:if>
							</tr>			
						</xsl:when>
					</xsl:choose>		
					</xsl:for-each>
			</xsl:if>
			<!--Si existen resultados para mas pendientes entonces mostramos el ttulos y estos-->
			<xsl:if test="count(../RESULTADO_METRICAS[@PARAMS='PEN_T>' and @DESGLOSE = $SeccionActual]) > 0">
				<tr class="cabeAlertas"><td colspan="6"><xsl:call-template name="traduce"><xsl:with-param name="id" select="'INFORMTICOS'"/></xsl:call-template>&#160;CON&#160;MAS&#160;PENDIENTES</td></tr>
					<tr class="administracion">
						<td width="30"><i><b>ID</b></i></td>
						<td colspan="3" width="350"><i><b>Apellidos/Nombre</b></i></td>
						<td width="50" align="center"><i><b>N-Tareas</b></i></td>
						<td width="50" align="center"><i><b>Tipo Tar.</b></i></td>
					</tr>
					
					<xsl:for-each select="../RESULTADO_METRICAS[@DESGLOSE = $SeccionActual]">
					<xsl:choose>
						<xsl:when test="@PARAMS = 'PEN_I>'">
							<tr class="incidencia" onmouseover="javascript:onMouseInc(this,'true');" onmouseout="javascript:onMouseInc(this,'false');">
								<td width="30"><xsl:value-of select="@INFORMATICO_ID"/></td>
								<td width="350" colspan="3"><xsl:value-of select="@INFORMATICO"/></td>
								<td width="50" align="right"><xsl:value-of select="@INCIDENCIAS"/></td>
								<td width="50" align="right">INCIDENCIAS</td>
							</tr>	
						</xsl:when>
						<xsl:when test="@PARAMS = 'PEN_P>'">
							<tr class="peticion" onmouseover="javascript:onMouse(this,'true');" onmouseout="javascript:onMouse(this,'false');">		
								<td width="30"><xsl:value-of select="@INFORMATICO_ID"/></td>
								<td width="350" colspan="3"><xsl:value-of select="@INFORMATICO"/></td>
								<td width="50" align="right"><xsl:value-of select="@PETICIONES"/></td>
								<td width="50" align="right">PETICIONES</td>
							</tr>
						</xsl:when>
						<xsl:when test="@PARAMS = 'PEN_T>'">
							<tr class="tarea" onmouseover="javascript:onMouseTar(this,'true');" onmouseout="javascript:onMouseTar(this,'false');">
								<td width="30"><xsl:value-of select="@INFORMATICO_ID"/></td>
								<td width="350" colspan="3"><xsl:value-of select="@INFORMATICO"/></td>
								<td width="50" align="right"><xsl:value-of select="@TAREAS"/></td>
								<td width="50" align="right">TAREAS</td>
							</tr>			
						</xsl:when>
					</xsl:choose>		
					</xsl:for-each>
			</xsl:if>
			<!--Si existen resultados para menos pendientes entonces mostramos el ttulos y estos-->
			<xsl:if test="count(../RESULTADO_METRICAS[@PARAMS='PEN_T&lt;' and @DESGLOSE = $SeccionActual]) > 0">		
				<tr class="cabeAlertas"><td colspan="6"><xsl:call-template name="traduce"><xsl:with-param name="id" select="'INFORMTICOS'"/></xsl:call-template>&#160;CON&#160;MENOS&#160;PENDIENTES</td></tr>
					<tr class="administracion">
						<td width="30"><i><b>ID</b></i></td>
						<td colspan="3" width="350"><i><b>Apellidos/Nombre</b></i></td>
						<td width="50" align="center"><i><b>N-Tareas</b></i></td>
						<td width="50" align="center"><i><b>Tipo Tar.</b></i></td>
					</tr>
					
					<xsl:for-each select="../RESULTADO_METRICAS[@DESGLOSE = $SeccionActual]">
					<xsl:choose>
						<xsl:when test="@PARAMS = 'PEN_I&lt;'">
							<tr class="incidencia" onmouseover="javascript:onMouseInc(this,'true');" onmouseout="javascript:onMouseInc(this,'false');">
								<td width="30"><xsl:value-of select="@INFORMATICO_ID"/></td>
								<td width="350" colspan="3"><xsl:value-of select="@INFORMATICO"/></td>
								<td width="50" align="right"><xsl:value-of select="@INCIDENCIAS"/></td>
								<td width="50" align="right">INCIDENCIAS</td>
							</tr>	
						</xsl:when>
						<xsl:when test="@PARAMS = 'PEN_P&lt;'">
							<tr class="peticion" onmouseover="javascript:onMouse(this,'true');" onmouseout="javascript:onMouse(this,'false');">		
								<td width="30"><xsl:value-of select="@INFORMATICO_ID"/></td>
								<td width="350" colspan="3"><xsl:value-of select="@INFORMATICO"/></td>
								<td width="50" align="right"><xsl:value-of select="@PETICIONES"/></td>
								<td width="50" align="right">PETICIONES</td>
							</tr>
						</xsl:when>
						<xsl:when test="@PARAMS = 'PEN_T&lt;'">
							<tr class="tarea" onmouseover="javascript:onMouseTar(this,'true');" onmouseout="javascript:onMouseTar(this,'false');">
								<td width="30"><xsl:value-of select="@INFORMATICO_ID"/></td>
								<td width="350" colspan="3"><xsl:value-of select="@INFORMATICO"/></td>
								<td width="50" align="right"><xsl:value-of select="@TAREAS"/></td>
								<td width="50" align="right">TAREAS</td>
							</tr>			
						</xsl:when>
					</xsl:choose>	
					</xsl:for-each>
			</xsl:if>
		</xsl:if>
		<!--For de las secciones para la repeticin de toda la informacin-->
		</xsl:for-each>		

		<xsl:if test="count(DATA/METRICAS/RESULTADO_METRICAS)=0">
			<tr class="administracion">
				<td align="center" colspan="10">* METRICAS sin datos.</td>
			</tr>
		</xsl:if>
			
		
		<tr align="center" class="administracion"><td colspan="10"><CENTER><input type="button" class="boton" value="Cerrar" onclick="javascript:window.close()" /></CENTER></td></tr>
	</table>
	</td></tr>
</table>
	
		
</body>
</html>
</xsl:template>
<xsl:template name="cuerpo"/>
</xsl:stylesheet>
	