package dumbo7.metricas.topxUsu;

import dumbo7.metricas.*;

import java.sql.*;
import java.sql.ResultSet;
import java.util.*;

import dumbo7.utils.*;

import org.hibernate.Query;
import org.hibernate.Session;

import atica.frameweb.utils.*;

/**
 * @author Antonio
 *
 * Gestor de Metricas TopX Usuarios de Dumbo
 * 
 */
public class GestorTopxUsu extends GeneralManager {
	private List seccionesResponsable = new Vector();
	private List secciones = new Vector();
	private List prioridades = new Vector();
	private List tiposTareas = new Vector();
	private List tareasMov = new Vector();
	private List ModoDato;
	private Vector resultadoMetricas = new Vector();
	private Vector resultadoMetricas_tm = new Vector();
		
	private String Modo = "";
	private String Seccion = "";
	private String Datos = "";
	private String Codigo = "";
	private String Patron = "";
		
	private String FechaDesde;
	private String FechaHasta;
	private String Num;
	private String Desglose = "";/**Desglose que se puede hacer cuando estas en modo DATO*/
		
	public GestorTopxUsu() {}
	
	//Mtodos get() para el mapeo
	public List getSeccionesResponsable() { return seccionesResponsable; }
	public List getSecciones() { return secciones; }
	public List getPrioridades() { return prioridades; }
	public List getTiposTareas() { return tiposTareas; }
	public List getModoDato(){return ModoDato;}
	public Vector getResultadoMetricas(){return this.resultadoMetricas;}
	public Vector getResultadoMetricas_tm(){return this.resultadoMetricas_tm;}
	
	//Mtodos set para recoger los datos del formulario
	/**Metdo set() para obtener las fechas de inicio y fin del histrico*/
	public void setFechaDesde(String FDesde){this.FechaDesde = FDesde;}
	public void setFechaHasta(String FHasta){this.FechaHasta = FHasta;}
	
	public void setNum(String N){this.Num = N;}
	
	/**Mtodo para recoger el modo: Usuarios(usu)  grupos de usuarios (gru)*/
	public void setModo(String M){this.Modo = M;}
	
	public void setSeccion(String sec){this.Seccion = sec;}
	public void setDesglose(String Des){this.Desglose = Des;}
	
	/**Patron de las busquedas de secciones, categoras grupos usuarios...*/
	public void setPatron(String patron){this.Patron = patron;}
	
	/**	Lista todas las secciones*/
	public void listaSecciones(Session conn){
		try{
			Query q = conn.createQuery(getQuery("AllSecciones"));
			q = q.setString("sist",user.getDatosMenu().idSelected());
			secciones  = (List)q.list();
		}
		catch (Exception ex){
			setErrorMessage("GestorMetricas[Lectura de BBDD]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
	}
	/**-------------LISTADOS DE UN NICO ELEMENTO(COMPONENTE)-------------------*/
	public void QuerySeccion(Session conn, String SecCod){
		try{
			Query q = conn.createQuery(getQuery("ListaUnaSeccion"));
			q = q.setString("sist",user.getDatosMenu().idSelected());
			q = q.setString("cod",SecCod);
			secciones  = (List)q.list();		
		}catch (Exception ex){
			setErrorMessage("GestorMetricas[Lectura de BBDD]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
	}
	
	/**Lista secciones con datos sin importar el estado, para el select inicial de secciones(no incluye estado finalizado)**/
	public void listaSeccionesConDatos(Session conn) {
		PreparedStatement pstmt;
		
		try{
			String ResultadoQuery = getQuery("SeccionesConDatos");
			ResultadoQuery = ResultadoQuery.replaceAll(":SISTEMA",user.getDatosMenu().idSelected());
			ResultadoQuery = ResultadoQuery.replaceAll(":GESTOR",user.getIdentificador());
			pstmt = conn.connection().prepareStatement(ResultadoQuery);
			ResultSet rs = pstmt.executeQuery();
			
		 	while (rs.next()) {
	 	    	D7Secciones sec = new D7Secciones();
	 	    	sec.setSecSisCod(rs.getString("Sec_Sis_Cod"));
	 	    	sec.setSecCod(rs.getString("Sec_Cod"));
	 	    	sec.setSecDescrip(rs.getString("Sec_Descrip"));
	 	    	sec.setSecIdRespon(rs.getString("Sec_Id_Respon"));
	 	    	sec.setSecSecCod(rs.getString("Sec_Sec_Cod"));
	 	    	sec.setSecEstado(rs.getString("Sec_Estado"));
	 	    	secciones.add(sec);
	 	    }
		 	rs.close();
	 	    pstmt.close();
		} catch (Exception ex) {
			System.out.println(ex);
			setErrorMessage("GestorMetricas[Lectura de BBDD]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
	}
	
	//-------------------SECCIONES para el DESGLOSE-------------------
	public void listaSeccionesDesglose(Session conn){
		PreparedStatement pstmt;
		/**String para construir la query de MAESTRO para tareas en estado resuelto*/
		String Query ="";
		try{		 	 
			Query = getQuery("ListaDesglose");
			Query = Query.replaceAll(":SISTEMA",user.getDatosMenu().idSelected());
			pstmt = conn.connection().prepareStatement(Query);
			ResultSet rs = pstmt.executeQuery();
			while (rs.next()) {
				D7Secciones sec = new D7Secciones();
				sec.setSecSisCod(rs.getString("Sec_Sis_Cod"));
	 	    	sec.setSecCod(rs.getString("Sec_Cod"));
	 	    	sec.setSecDescrip(rs.getString("Sec_Descrip"));
	 	    	sec.setSecIdRespon(rs.getString("Sec_Id_Respon"));
	 	    	sec.setSecSecCod(rs.getString("Sec_Sec_Cod"));
	 	    	sec.setSecEstado(rs.getString("Sec_Estado"));
	 	    	this.secciones.add(sec);
			}   
		 rs.close();
		 pstmt.close();
	  } catch (Exception ex) {
			System.out.println(ex);
			setErrorMessage("GestorMetricas [Lectura de BBDD]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
	}
	/**-------------LISTADOS DE PRIORIDADES(COMN PARA GESTOR Y PARA MAESTRO)-------------------*/
	public void listaPrioridades(Session conn){
		try{
			Query q = conn.createQuery(getQuery("ListaPrioridades"));
			q = q.setString("sist",user.getDatosMenu().idSelected());
			prioridades  = (List)q.list();
		} catch (Exception ex) {
			setErrorMessage("GestorMetricas[Lectura de BBDD]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
	}
	
	public void listaTiposTareas(Session conn){
		try{
			Query q = conn.createQuery(getQuery("ListaTiposTareas"));
			q = q.setString("sist",user.getDatosMenu().idSelected());
			tiposTareas  = (List)q.list();
		} catch (Exception ex) {
			setErrorMessage("GestorMetricas[Lectura de BBDD]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
	}
		
	/**-------------------GESTOR-------------------*/
	public void listaSeccionesGestor(Session conn) {
		PreparedStatement pstmt;
		
		try{
			String ResultadoQuery = getQuery("SeccionesGestorConAyuda");
			ResultadoQuery = ResultadoQuery.replaceAll(":SISTEMA",user.getDatosMenu().idSelected());
			ResultadoQuery = ResultadoQuery.replaceAll(":GESTOR",user.getIdentificador());
			pstmt = conn.connection().prepareStatement(ResultadoQuery);
			ResultSet rs = pstmt.executeQuery();
			
		 	while (rs.next()) {
	 	    	D7Secciones sec = new D7Secciones();
	 	    	sec.setSecSisCod(rs.getString("Sec_Sis_Cod"));
	 	    	sec.setSecCod(rs.getString("Sec_Cod"));
	 	    	sec.setSecDescrip(rs.getString("Sec_Descrip"));
	 	    	sec.setSecIdRespon(rs.getString("Sec_Id_Respon"));
	 	    	sec.setSecSecCod(rs.getString("Sec_Sec_Cod"));
	 	    	sec.setSecEstado(rs.getString("Sec_Estado"));
	 	    	seccionesResponsable.add(sec);
	 	    }
		 	rs.close();
	 	    pstmt.close();
		} catch (Exception ex) {
			System.out.println(ex);
			setErrorMessage("GestorMetricas[Lectura de BBDD]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
	}
	/**-------------------MAESTRO-------------------*/
	public void listaSeccionesMaestro(Session conn){
		try{
			Query q = conn.createQuery(getQuery("SeccionesMaestroConAyuda"));
			q = q.setString("sist",user.getDatosMenu().idSelected());
			secciones  = (List)q.list();
		} catch (Exception ex) {
			setErrorMessage("GestorMetricas[Lectura de BBDD]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
	}
		
	/** Mtodo para sustituir todos los parmetros de la query de ListaEnModoDato o ListaEnModoDatoDesglose
	* En este mtodo se elige cual de las 2 querys realizar en funcin de si se ha elegido desglose o no
	* Adems tambin se sustituyen los parmetros en funcin de si se ha introducido usuario, informatico, seccion...
	* */
	/**-------------------RESULTADOS de las mtricas para MAESTRO-------------------*/
	public void listaModoDatoMaestro(Session conn){
		PreparedStatement pstmtT;
		PreparedStatement pstmtPrio;
		PreparedStatement pstmtDetalle;
		/**String para construir la query de MAESTRO*/
		String QueryT ="";
		
		try{
			/**Inicio de la cuenta para la medicin del tiempo de ejecucin de la METRICA*/
			java.util.Date FechaInicio = new java.util.Date();
			int MinutosI = FechaInicio.getMinutes();
			int SegundosI = FechaInicio.getSeconds();
			
			if(Modo.equals("usu")){
				QueryT = getQuery("ListaUsuario");
			}
			else{
				QueryT = getQuery("ListaGrupoUsuario");
			}
			/**Eliminamos la condicin de Gestor para agilizar la query*/
			QueryT = QueryT.replaceAll(":CONDICION_GESTOR","");
							
			/**Construimos la query dependiendo del PERIODO introducido si no hay inicio = "DesdeInicio de tiempos"; si no hay fin = "HastaFin de tiempos*/
			if(!(this.FechaDesde.equals("DD/MM/AAAA")) & !(this.FechaHasta.equals("DD/MM/AAAA"))){
				QueryT = QueryT.replaceAll(":FINICIO",this.FechaDesde);
				QueryT = QueryT.replaceAll(":FFIN",this.FechaHasta);
				
			}else if(this.FechaDesde.equals("DD/MM/AAAA") & !(this.FechaHasta.equals("DD/MM/AAAA"))){
				QueryT = QueryT.replaceAll("':FINICIO'","NULL");
				QueryT = QueryT.replaceAll(":FFIN",this.FechaHasta);
				}else if(!(this.FechaDesde.equals("DD/MM/AAAA")) & this.FechaHasta.equals("DD/MM/AAAA")){
					QueryT = QueryT.replaceAll(":FINICIO",this.FechaDesde);
					QueryT = QueryT.replaceAll("':FFIN'","NULL");
					}else{
						QueryT = QueryT.replaceAll("':FINICIO'","NULL");
						QueryT = QueryT.replaceAll("':FFIN'","NULL");
					}
			
			/**Si se introduce una SECCIN por la que filtrar, sino el parmetro seccin ser NULL*/
			if(!this.Seccion.equals("")){QueryT = QueryT.replaceAll(":SEC",this.Seccion);}
			else{QueryT = QueryT.replaceAll("':SEC'","NULL");}
			
			/**Sustitucin de TIPOS TAREAS*/
			QueryT = QueryT.replaceAll(":PETICION",D7TiposTareas.PETICION);
			QueryT = QueryT.replaceAll(":INCIDENCIA",D7TiposTareas.INCIDENCIA);
					
			/**Sustitucin del DESGLOSE o no*/
			if(this.Desglose.equals("sec")){
				QueryT = QueryT.replaceAll(":DESGLOSE_COD","sec_cod");
				QueryT = QueryT.replaceAll(":DESGLOSE",",sec_cod desglose");
				QueryT = QueryT.replaceAll(":INDIC_DESGLOSE ",",desglose");
				QueryT = QueryT.replaceAll(":TABLASISTEMAS"," AND sec_sis_cod = " + "'"+user.getDatosMenu().idSelected()+"'");
				QueryT = QueryT.replaceAll(":TABLA",", DUMBO.D7_SECCIONES");
			}
			else{
				QueryT = QueryT.replaceAll(":DESGLOSE_COD","NULL");
				QueryT = QueryT.replaceAll(":INDIC_DESGLOSE "," ");
				QueryT = QueryT.replaceAll(":DESGLOSE","");		
				QueryT = QueryT.replaceAll(":TABLASISTEMAS","");
				QueryT = QueryT.replaceAll(":TABLA","");
			}
		
			/**Tipo de tareas*/
			QueryT = QueryT.replaceAll(":RESUELTA",D7Tareas.FINALIZADA);
						
			/**Nmero de informticos a los que informar*/
			QueryT = QueryT.replaceAll(":X",Num);
				
			/**El parmetro GESTOR se pone a NULL puesto que nos encontramos en MAESTRO*/
			QueryT = QueryT.replaceAll(":GESTOR","NULL");
						
			/**SISTEMA*/
			QueryT = QueryT.replaceAll(":SISTEMA",user.getDatosMenu().idSelected());
				
			pstmtT = conn.connection().prepareStatement(QueryT);
			ResultSet rsT = pstmtT.executeQuery();
			while (rsT.next()) {
				/**RECOGIDA DE RESULTADOS(de tareas pendientes y en espera) Y MAPEO A TRAVS DE LA CLASE MTRICAS*/
			  	Metricas M = new Metricas();
				M.setInformaticoID(rsT.getString("id"));
			   	M.setInformatico(rsT.getString("descripcion"));
				M.setTarSol(new Integer(rsT.getInt("inc_sol")+rsT.getInt("pet_sol")));
			   	M.setTarResu(new Integer(rsT.getInt("inc_resu")+rsT.getInt("pet_resu")));
			   	M.setIncSol(new Integer(rsT.getInt("inc_sol")));
			   	M.setIncResu(new Integer(rsT.getInt("inc_resu")));
				M.setPetSol(new Integer(rsT.getInt("pet_sol")));
			   	M.setPetResu(new Integer(rsT.getInt("pet_resu")));
			    //Dependiendo de si hay desglose o no lo mapeo en la mtrica
			   	if(Desglose.equals("sec")){
			   		M.setDesglose(rsT.getString("desglose"));
			   	}
			   	this.resultadoMetricas.add(M);
			}  
			rsT.close();
			pstmtT.close();
			
			/**FIN de la cuenta para la medicin del tiempo de ejecucin de la METRICA*/
			java.util.Date FechaFin = new java.util.Date();
			int MinutosF = FechaFin.getMinutes();
			int SegundosF = FechaFin.getSeconds();
			/**Tenemos en cuenta si se ha cambiado de minuto mientras se realiza la mtrica*/
			if (SegundosI > SegundosF){
				SegundosF = 60 + SegundosF;
				MinutosF = MinutosF - 1;
			}
		 	setErrorMessage("La mtica se ha realizado en: "+ new Integer(Math.abs(MinutosF-MinutosI)).toString() + " min. y " +new Integer(Math.abs(SegundosF-SegundosI)).toString() + " seg.");
		 	
	 	   } catch (Exception ex) {
			System.out.println(ex);
			setErrorMessage("LISTADO Maestro:"+ex.toString().substring(0,ex.toString().length()-1));
		}
	}
	
	
	/**-------------------RESULTADOS de las mtricas para GESTOR-------------------*/
	public void listaModoDatoGestor(Session conn){
		PreparedStatement pstmtT;
		PreparedStatement pstmtPrio;
		PreparedStatement pstmtDetalle;
		/**String para construir la query de GESTOR*/
		String QueryT ="";
		
		try{
			/**Inicio de la cuenta para la medicin del tiempo de ejecucin de la METRICA*/
			java.util.Date FechaInicio = new java.util.Date();
			int MinutosI = FechaInicio.getMinutes();
			int SegundosI = FechaInicio.getSeconds();
			
			if(Modo.equals("usu")){
				QueryT = getQuery("ListaUsuario");
			}
			else{
				QueryT = getQuery("ListaGrupoUsuario");
			}
			/**Condicion de GESTOR*/
			QueryT = QueryT.replaceAll(":CONDICION_GESTOR",getQuery("CondicionGestor"));
			
			/**Construimos la query dependiendo del PERIODO introducido si no hay inicio = "DesdeInicio de tiempos"; si no hay fin = "HastaFin de tiempos*/
			if(!(this.FechaDesde.equals("DD/MM/AAAA")) & !(this.FechaHasta.equals("DD/MM/AAAA"))){
				QueryT = QueryT.replaceAll(":FINICIO",this.FechaDesde);
				QueryT = QueryT.replaceAll(":FFIN",this.FechaHasta);
				
			}else if(this.FechaDesde.equals("DD/MM/AAAA") & !(this.FechaHasta.equals("DD/MM/AAAA"))){
				QueryT = QueryT.replaceAll("':FINICIO'","NULL");
				QueryT = QueryT.replaceAll(":FFIN",this.FechaHasta);
				}else if(!(this.FechaDesde.equals("DD/MM/AAAA")) & this.FechaHasta.equals("DD/MM/AAAA")){
					QueryT = QueryT.replaceAll(":FINICIO",this.FechaDesde);
					QueryT = QueryT.replaceAll("':FFIN'","NULL");
					}else{
						QueryT = QueryT.replaceAll("':FINICIO'","NULL");
						QueryT = QueryT.replaceAll("':FFIN'","NULL");
					}
			
			/**Si se introduce una SECCIN por la que filtrar, sino el parmetro seccin ser NULL*/
			if(!this.Seccion.equals("")){QueryT = QueryT.replaceAll(":SEC",this.Seccion);}
			else{QueryT = QueryT.replaceAll("':SEC'","NULL");}
			
			/**Sustitucin de TIPOS TAREAS*/
			QueryT = QueryT.replaceAll(":PETICION",D7TiposTareas.PETICION);
			QueryT = QueryT.replaceAll(":INCIDENCIA",D7TiposTareas.INCIDENCIA);
					
			/**Sustitucin del DESGLOSE o no*/
			if(this.Desglose.equals("sec")){
				QueryT = QueryT.replaceAll(":DESGLOSE_COD","sec_cod");
				QueryT = QueryT.replaceAll(":DESGLOSE",",sec_cod desglose");
				QueryT = QueryT.replaceAll(":INDIC_DESGLOSE ",",desglose");
				QueryT = QueryT.replaceAll(":TABLASISTEMAS"," AND sec_sis_cod = " + "'"+user.getDatosMenu().idSelected()+"'");
				QueryT = QueryT.replaceAll(":TABLA",", DUMBO.D7_SECCIONES");
			}
			else{
				QueryT = QueryT.replaceAll(":DESGLOSE_COD","NULL");
				QueryT = QueryT.replaceAll(":INDIC_DESGLOSE "," ");
				QueryT = QueryT.replaceAll(":DESGLOSE","");		
				QueryT = QueryT.replaceAll(":TABLASISTEMAS","");
				QueryT = QueryT.replaceAll(":TABLA","");
			}
		
			/**Tipo de tareas*/
			QueryT = QueryT.replaceAll(":RESUELTA",D7Tareas.FINALIZADA);
						
			/**Nmero de informticos a los que informar*/
			QueryT = QueryT.replaceAll(":X",Num);
				
			/**El parmetro GESTOR , se pone el identificador del gestor de realiza la metrica*/
			QueryT = QueryT.replaceAll(":GESTOR",user.getIdentificador());
						
			/**SISTEMA*/
			QueryT = QueryT.replaceAll(":SISTEMA",user.getDatosMenu().idSelected());
				
			pstmtT = conn.connection().prepareStatement(QueryT);
			ResultSet rsT = pstmtT.executeQuery();
			while (rsT.next()) {
				/**RECOGIDA DE RESULTADOS(de tareas pendientes y en espera) Y MAPEO A TRAVS DE LA CLASE MTRICAS*/
			  	Metricas M = new Metricas();
				M.setInformaticoID(rsT.getString("id"));
			   	M.setInformatico(rsT.getString("descripcion"));
				M.setTarSol(new Integer(rsT.getInt("inc_sol")+rsT.getInt("pet_sol")));
			   	M.setTarResu(new Integer(rsT.getInt("inc_resu")+rsT.getInt("pet_resu")));
			   	M.setIncSol(new Integer(rsT.getInt("inc_sol")));
			   	M.setIncResu(new Integer(rsT.getInt("inc_resu")));
				M.setPetSol(new Integer(rsT.getInt("pet_sol")));
			   	M.setPetResu(new Integer(rsT.getInt("pet_resu")));
			    //Dependiendo de si hay desglose o no lo mapeo en la mtrica
			   	if(Desglose.equals("sec")){
			   		M.setDesglose(rsT.getString("desglose"));
			   	}
			   	this.resultadoMetricas.add(M);
			}  
			rsT.close();
			pstmtT.close();
			
			/**FIN de la cuenta para la medicin del tiempo de ejecucin de la METRICA*/
			java.util.Date FechaFin = new java.util.Date();
			int MinutosF = FechaFin.getMinutes();
			int SegundosF = FechaFin.getSeconds();
			/**Tenemos en cuenta si se ha cambiado de minuto mientras se realiza la mtrica*/
			if (SegundosI > SegundosF){
				SegundosF = 60 + SegundosF;
				MinutosF = MinutosF - 1;
			}
		 	setErrorMessage("La mtica se ha realizado en: "+ new Integer(Math.abs(MinutosF-MinutosI)).toString() + " min. y " +new Integer(Math.abs(SegundosF-SegundosI)).toString() + " seg.");
		 	
	 	   } catch (Exception ex) {
			System.out.println(ex);
			setErrorMessage("LISTADO Gestor:"+ex.toString().substring(0,ex.toString().length()-1));
		}
	}

	
}
