<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet version="1.0" 
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:xforms="http://www.w3.org/2002/xforms">
	
<xsl:param name="servlet"/>	
<xsl:param name="menu"/>
<xsl:param name="perfil"/>
<xsl:param name="inicio"/>
<xsl:param name="fin"/>
<xsl:param name="SecCod"/>
<xsl:param name="FechaDesde"/>
<xsl:param name="FechaHasta"/>
<xsl:param name="Num"/>
<xsl:param name="Modo"/>

<xsl:include href="dumbo7/utils/xsl/utils.xsl"/>
	
<xsl:template match="XMLROOT">
		
	<html lang="es">
		<TITLE>DUMBO7: Resultado Mtrica 'TopX Usuarios'</TITLE>
		
    <xsl:call-template name="headComun">
         <xsl:with-param name="jscript">
            <SCRIPT LANGUAGE="JavaScript">
				function mostrarError(error){
					alert(error);
				}
			</SCRIPT>
			<script LANGUAJE="JavaScript" src="../js/OnMouse.js"></script>
         </xsl:with-param>
	</xsl:call-template>
	<body>
		<xsl:for-each select="DATA/METRICAS">
			<xsl:if test="not(@ERROR='')">
				<script>mostrarError('<xsl:value-of select="@ERROR"/>')</script>
				</xsl:if>
		</xsl:for-each>

	<table border="0" align="center" cellpadding="3" cellspacing="1" width="750">
	<tr><td colspan="4">
		<table class="cont" id="metricas" border="0" cellpadding="3" cellspacing="1" width="100%" summary="Esta tabla contiene las mtricas">
			<tr class="cab1">
				<td colspan="2">&#187;Resultado: TopX usuarios (<xsl:value-of select="$perfil"/>)</td>
				<td width="10" align="center"><b><a href="javascript:window.print()"><img border="0" src="../graficos/iconos/ico_impresora.gif" alt="Imprimir"/></a></b></td>
				<td width="10" align="center"><b><a href="javascript:window.close()">Cerrar</a></b></td>
			</tr>
			<tr class="cabe">
				<td width="140"><b>Periodo</b></td>
				<td width="350"><b>Parmetros</b></td>
				<td colspan="2"></td>
			</tr>
			<tr class="administracion">
				<td width="90"><b>Desde:</b>&#160;&#160;<i>
					 <xsl:value-of select="$FechaDesde"/>
				</i></td>
				<td width="350" colspan="3">
					<b>Seccion:&#160;</b>
					<xsl:if test="$SecCod != ''">
						<i><xsl:value-of select="DATA/METRICAS/SECCION/@DESCRIPCION"/></i>
					</xsl:if>	
					<xsl:if test="$SecCod = ''">
						<i>TODAS</i>	
					</xsl:if>
				</td>
			</tr>
			<tr class="administracion">
				<td width="90"><b>Hasta:</b>&#160;&#160;<i>
					<xsl:value-of select="$FechaHasta"/>
				</i></td>
				<td colspan="4"></td>
			</tr>
			<!--Seleccin del modo de representacin de datos-->
			<tr class="cabe"><td align="left" colspan="4" ><b>Presentacin de datos</b></td></tr>
			<tr class="administracion">
				<td colspan="4">
					<b>Modo Dato</b>&#160;-->&#160;Representacin&#160;Conjunta
				</td>
			</tr>
			<tr class="cabe"><td colspan="9"><b>Resultados</b></td></tr>
		</table>
		<xsl:for-each select="DATA/METRICAS/SECCION">
		<xsl:sort select="@DESCRIPCION"/>
		<xsl:variable name="SeccionActual"><xsl:value-of select="@CODIGO"/></xsl:variable>		
		<xsl:if test="count(../RESULTADO_METRICAS[@DESGLOSE = $SeccionActual]) !=0">
			<xsl:if test="(sum(../RESULTADO_METRICAS[@DESGLOSE = $SeccionActual]/@TAREAS_SOL) !=0) or (sum(../RESULTADO_METRICAS[@DESGLOSE = $SeccionActual]/@TAREAS_RESU) !=0) ">
				<table class="cont" border="0" cellpadding="3" cellspacing="1" width="100%" summary="Informacin detallada">
					<tr class="cabeAlertas"><td colspan="9"><b>Seccin:&#160;"<xsl:value-of select="@DESCRIPCION"/>"</b></td></tr>
					<tr class="administracion">
						<td align="center" width="70"></td>
						<td colspan="2" align="center" width="350"></td>
						<td colspan="3" width="200" align="center"><i><b>Solicitadas</b></i></td>
						<td colspan="3" width="200" align="center"><i><b>Resueltas</b></i></td>
					</tr>
					<tr class="administracion">
						<td align="center" width="70">
							<i><b>ID&#160;
								<xsl:if test="$Modo = 'usu'">
										Usuario
								</xsl:if>	
								<xsl:if test="$Modo = 'gru'">
										Grupo
								</xsl:if>	
							</b></i>
						</td>
						<td colspan="2" width="350">
							<i><b>
								<xsl:if test="$Modo = 'usu'">
										Apellidos, Nombre
								</xsl:if>	
								<xsl:if test="$Modo = 'gru'">
										Denominacin
								</xsl:if>	
							</b></i>
						</td>
						<td width="60" align="center"><i><b>Pet.</b></i></td>
						<td width="60" align="center"><i><b>Inc.</b></i></td>
						<td width="60" align="center"><i><b>Tar.</b></i></td>
						<td width="60" align="center"><i><b>Pet.</b></i></td>
						<td width="60" align="center"><i><b>Inc.</b></i></td>
						<td width="60" align="center"><i><b>Tar.</b></i></td>
					</tr>
					<xsl:for-each select="../RESULTADO_METRICAS[@DESGLOSE = $SeccionActual]">
						<tr class="administracion" onmouseover="javascript:onMouse(this,'true');" onmouseout="javascript:onMouse(this,'false');">
							<td width="70" align="right"><xsl:value-of select="@INFORMATICO_ID"/></td>
							<td colspan="2" width="350"><xsl:value-of select="@INFORMATICO"/></td>
							<!--solicitadas-->
							<td width="60" align="right"><xsl:value-of select="@PETICIONES_SOL"/></td>
							<td width="60" align="right"><xsl:value-of select="@INCIDENCIAS_SOL"/></td>
							<td width="60" align="right"><xsl:value-of select="@TAREAS_SOL"/></td>
							<!--Resueltas-->
							<td width="60" align="right"><xsl:value-of select="@PETICIONES_RESU"/></td>
							<td width="60" align="right"><xsl:value-of select="@INCIDENCIAS_RESU"/></td>
							<td width="60" align="right"><xsl:value-of select="@TAREAS_RESU"/></td>
						</tr>
					</xsl:for-each>
				</table>
			</xsl:if>
		</xsl:if>
		<!--For de las secciones para la repeticin de toda la informacin-->
		</xsl:for-each>
			
		<xsl:if test="count(DATA/METRICAS/RESULTADO_METRICAS)=0">
			<tr class="administracion">
				<td align="center" colspan="10">* METRICAS sin datos.</td>
			</tr>
		</xsl:if>
		
		<table class="cont" border="0" cellpadding="3" cellspacing="1" width="100%" summary="cerrar">
			<tr class="administracion" align="center"><td colspan="9"><CENTER><input type="button" class="boton" value="Cerrar" onclick="javascript:window.close()" /></CENTER></td></tr>
		</table>	
	</td></tr>
</table>
		
</body>
</html>
</xsl:template>
<xsl:template name="cuerpo"/>
</xsl:stylesheet>
	