<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet version="1.0" 
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:xforms="http://www.w3.org/2002/xforms">
	
<xsl:param name="servlet"/>	
<xsl:param name="menu"/>
<xsl:param name="perfil"/>
<xsl:param name="inicio"/>
<xsl:param name="fin"/>
<xsl:param name="SecCod"/>
<xsl:param name="FechaDesde"/>
<xsl:param name="FechaHasta"/>
<xsl:param name="NumDias"/>

<xsl:include href="dumbo7/utils/xsl/utils.xsl"/>
	
<xsl:template match="XMLROOT">
		
	<html lang="es">
		<TITLE>DUMBO7: Resultado Mtrica '+YDias'</TITLE>
		
    <xsl:call-template name="headComun">
         <xsl:with-param name="jscript">
            <SCRIPT LANGUAGE="JavaScript">
				function mostrarError(error){
					alert(error);
				}
			</SCRIPT>
			<script LANGUAJE="JavaScript" src="../js/OnMouse.js"></script>
         </xsl:with-param>
	</xsl:call-template>
	<body>
		<xsl:for-each select="DATA/METRICAS">
			<xsl:if test="not(@ERROR='')">
				<script>mostrarError('<xsl:value-of select="@ERROR"/>')</script>
				</xsl:if>
		</xsl:for-each>

	<table border="0" align="center" cellpadding="3" cellspacing="1" width="750">
	<tr><td colspan="4">
		<table class="cont" id="metricas" border="0" cellpadding="3" cellspacing="1" width="100%" summary="Esta tabla contiene las mtricas">
			<tr class="cab1">
				<td colspan="2">&#187;Resultado: Tareas pendientes con ms de Y das (<xsl:value-of select="$perfil"/>)</td>
				<td width="10" align="center"><b><a href="javascript:window.print()"><img border="0" src="../graficos/iconos/ico_impresora.gif" alt="Imprimir"/></a></b></td>
				<td width="10" align="center"><b><a href="javascript:window.close()">Cerrar</a></b></td>
			</tr>
			<tr class="cabe">
				<td width="140"><b>Periodo</b></td>
				<td width="350"><b>Parmetros</b></td>
				<td colspan="2"></td>
			</tr>
			
			<tr class="administracion">
				<td width="90"><b>Desde:</b>&#160;&#160;<i>
					 <xsl:value-of select="$FechaDesde"/>
				</i></td>
				<td width="350" colspan="3">
					<b>Seccion:&#160;</b>
					<xsl:if test="$SecCod != ''">
						<i><xsl:value-of select="DATA/METRICAS/SECCION/@DESCRIPCION"/></i>
					</xsl:if>	
					<xsl:if test="$SecCod = ''">
						<i>TODAS</i>	
					</xsl:if>
				</td>
			</tr>
			<tr class="administracion">
				<td width="90"><b>Hasta:</b>&#160;&#160;<i>
					<xsl:value-of select="$FechaHasta"/>
				</i></td>
				<td colspan="3"></td>
			</tr>
			<!--Seleccin del modo de representacin de datos-->
			<tr class="cabe"><td align="left" colspan="4" ><b>Presentacin de datos</b></td></tr>
			<tr class="administracion">
				<td colspan="4">
					<b>Modo Dato</b>&#160;-->&#160;Representacin&#160;Conjunta
				</td>
			</tr>
		</table>
		<table class="cont" border="0" cellpadding="3" cellspacing="1" width="100%" summary="Resultados Estadsticos">
			<tr class="cabe"><td colspan="10"><b>Informcin ESTADSTICA</b></td></tr>
			<tr class="administracion">
				<td>
					<table class="cont" border="0" cellpadding="3" cellspacing="2">
					<tr class="cabeAlertas"><td colspan="4"><b>Tareas&#160;Pendientes&#160;y&#160;en&#160;Espera&#160;ms&#160;de&#160;<xsl:value-of select="$NumDias"/>&#160;das</b></td></tr>
						<tr class="cabeAlertas">
							<td>&#160;</td>
							<td align="center">Incidencias(I)</td>
							<td align="center">Peticiones(P)</td>
							<td align="center">Total(I+P)</td>
						</tr>
						<tr class="administracion">
							<!--INCIDENCIAS-->
							<td class="cabeAlertas">Pendientes</td>
							<td align="center"><xsl:value-of select="DATA/METRICAS/RESULTADO_METRICAS[@PARAMS = 'pend']/@INCIDENCIAS"/></td>
							<td align="center"><xsl:value-of select="DATA/METRICAS/RESULTADO_METRICAS[@PARAMS = 'pend']/@PETICIONES"/></td>
							<td align="center"><xsl:value-of select="DATA/METRICAS/RESULTADO_METRICAS[@PARAMS = 'pend']/@PETICIONES + DATA/METRICAS/RESULTADO_METRICAS[@PARAMS = 'pend']/@INCIDENCIAS"/></td>
						</tr>
						<tr class="administracion">
							<td class="cabeAlertas">En&#160;Espera</td>
							<td align="center"><xsl:value-of select="DATA/METRICAS/RESULTADO_METRICAS[@PARAMS = 'esp']/@INCIDENCIAS"/></td>
							<td align="center"><xsl:value-of select="DATA/METRICAS/RESULTADO_METRICAS[@PARAMS = 'esp']/@PETICIONES"/></td>
							<td align="center"><xsl:value-of select="DATA/METRICAS/RESULTADO_METRICAS[@PARAMS = 'esp']/@PETICIONES + DATA/METRICAS/RESULTADO_METRICAS[@PARAMS = 'esp']/@INCIDENCIAS"/></td>
						</tr>
					</table>
				</td>
				<td>
					<table class="cont" border="0" cellpadding="3" cellspacing="2">
					<xsl:variable name="NumPrio"><xsl:value-of select="count(DATA/METRICAS/PRIORIDAD)"/></xsl:variable>
					<tr class="cabeAlertas"><td colspan="{$NumPrio+1}"><b>Tareas&#160;Pendientes&#160;ms&#160;de&#160;<xsl:value-of select="$NumDias"/>&#160;das&#160;Deglosadas&#160;por&#160;Prioridad</b></td></tr>
						<tr class="cabeAlertas">
							<td>&#160;</td>
							<xsl:for-each select="DATA/METRICAS/PRIORIDAD">
							<xsl:variable name="codigo"><xsl:value-of select="@CODIGO"/></xsl:variable>
								<td align="center"><xsl:value-of select="@DESCRIPCION"/></td>
							</xsl:for-each>
						</tr>
						<tr class="administracion">
							<!--INCIDENCIAS-->
							<td class="cabeAlertas">Incidencias</td>
							<xsl:for-each select="DATA/METRICAS/PRIORIDAD">
							<xsl:variable name="codigo"><xsl:value-of select="@CODIGO"/></xsl:variable>
								<td align="center">
									<xsl:value-of select="../RESULTADO_METRICAS[@PARAMS = concat('prio',$codigo)]/@INCIDENCIAS"/>
								</td>
							</xsl:for-each>
						</tr>
						<tr class="administracion">
							<td class="cabeAlertas">Peticiones</td>
							<!--PETICIONES-->
							<xsl:for-each select="DATA/METRICAS/PRIORIDAD">
							<xsl:variable name="codigo"><xsl:value-of select="@CODIGO"/></xsl:variable>
								<td align="center">
									<xsl:value-of select="../RESULTADO_METRICAS[@PARAMS = concat('prio',$codigo)]/@PETICIONES"/>
								</td>
							</xsl:for-each>
						</tr>
					</table>
				</td>
			</tr>
		</table>
		<table class="cont" border="0" cellpadding="3" cellspacing="1" width="100%" summary="Informacin detallada">
			<tr class="cabe"><td colspan="9"><b>Informcin DETALLADA</b></td></tr>
			<!--Si hay incidencias pendientes, las mostramos-->
			<xsl:if test="count(DATA/METRICAS/RESULTADO_METRICAS/TAREA[(@ESTADO = 'P' or @ESTADO = 'A' or @ESTADO = 'X' or @ESTADO = 'W') and @TIPO_TAREA = 'I'])>0">
				<tr class="cabeAlertas"><td colspan="9"><b>INCIDENCIAS&#160;PENDIENTES</b></td></tr>
				<tr class="administracion">
					<td width="20" align="center"><i><b>ID</b></i></td>
					<td colspan="4" align="center"><i><b><xsl:call-template name="traduce"><xsl:with-param name="id" select="'Informtico'"/></xsl:call-template></b></i></td>
					<td width="30"><i><b>Solicitud</b></i></td>
					<td width="20"><i><b>N&#160;Dias</b></i></td>
					<td width="60" align="center"><i><b>Prioridad</b></i></td>
					<td width="60" align="center"><i><b>Urgencia</b></i></td>
				</tr>
				<xsl:for-each select="DATA/METRICAS/RESULTADO_METRICAS/TAREA[(@ESTADO = 'P' or @ESTADO = 'A' or @ESTADO = 'X' or @ESTADO = 'W') and @TIPO_TAREA = 'I']">
					<tr class="incidencia">
						<td width="20" align="center"><xsl:value-of select="@CODIGO"/></td>
						<td colspan="4"><xsl:value-of select="@INFORMATICO"/></td>
						<td width="30" align="center"><xsl:call-template name="date2String2"><xsl:with-param name="fecha" select="@FECHA_CREACION"/></xsl:call-template></td>
						<td width="20" align="right"><xsl:value-of select="../@DIAS"/></td>
						<xsl:variable name="prio"><xsl:value-of select="@PRIORIDAD"/></xsl:variable>
						<td class="celdapaipucMet" width="60" align="center">
							<xsl:value-of select="../../PRIORIDAD[@CODIGO = $prio]/@DESCRIPCION"/>
							<xsl:if test="not(../../PRIORIDAD[@CODIGO = $prio]/@DESCRIPCION)">
								--
							</xsl:if>
						</td>
						<td class="celdapaipucMet" width="60" align="center">
							<xsl:if test="@URGENCIA = 'U'">
								Urgente
							</xsl:if>
							<xsl:if test="@URGENCIA = 'N'">
								No&#160;Urgente
							</xsl:if>
							<xsl:if test="not(@URGENCIA)">
								--
							</xsl:if>
						</td>
					</tr>
				</xsl:for-each>
			</xsl:if>
			<!--Si hay peticiones pendientes, las mostramos-->
			<xsl:if test="count(DATA/METRICAS/RESULTADO_METRICAS/TAREA[(@ESTADO = 'P' or @ESTADO = 'A' or @ESTADO = 'X' or @ESTADO = 'W') and @TIPO_TAREA = 'P']) >0">
				<tr class="cabeAlertas"><td colspan="9"><b>PETICIONES&#160;PENDIENTES</b></td></tr>
				<tr class="administracion">
					<td width="20" align="center"><i><b>ID</b></i></td>
					<td colspan="4" align="center"><i><b><xsl:call-template name="traduce"><xsl:with-param name="id" select="'Informtico'"/></xsl:call-template></b></i></td>
					<td width="30"><i><b>Solicitud</b></i></td>
					<td width="20"><i><b>N&#160;Dias</b></i></td>
					<td width="60" align="center"><i><b>Prioridad</b></i></td>
					<td width="60" align="center"><i><b>Urgencia</b></i></td>
				</tr>
				<xsl:for-each select="DATA/METRICAS/RESULTADO_METRICAS/TAREA[(@ESTADO = 'P' or @ESTADO = 'A' or @ESTADO = 'X' or @ESTADO = 'W') and @TIPO_TAREA = 'P']">
					<tr class="administracion">
						<td width="20" align="center"><xsl:value-of select="@CODIGO"/></td>
						<td colspan="4"><xsl:value-of select="@INFORMATICO"/></td>
						<td width="30" align="center"><xsl:call-template name="date2String2"><xsl:with-param name="fecha" select="@FECHA_CREACION"/></xsl:call-template></td>
						<td width="20" align="right"><xsl:value-of select="../@DIAS"/></td>
						<xsl:variable name="prio"><xsl:value-of select="@PRIORIDAD"/></xsl:variable>
						<td class="celdapaipucMet" width="60" align="center">
							<xsl:value-of select="../../PRIORIDAD[@CODIGO = $prio]/@DESCRIPCION"/>
							<xsl:if test="not(../../PRIORIDAD[@CODIGO = $prio]/@DESCRIPCION)">
								--
							</xsl:if>
						</td>
						<td class="celdapaipucMet" width="60" align="center">
							<xsl:if test="@URGENCIA = 'U'">
								Urgente
							</xsl:if>
							<xsl:if test="@URGENCIA = 'N'">
								No&#160;Urgente
							</xsl:if>
							<xsl:if test="not(@URGENCIA)">
								--
							</xsl:if>
						</td>
					</tr>
				</xsl:for-each>		
			</xsl:if>
			<!--Si hay tareas en estado de espera, las mostramos-->
			<xsl:if test="count(DATA/METRICAS/RESULTADO_METRICAS/TAREA[@ESTADO = 'W']) >0">
				<tr class="cabeAlertas"><td colspan="9"><b>TAREAS&#160;EN&#160;ESTADO&#160;DE&#160;ESPERA</b></td></tr>
				<tr class="administracion">
					<td width="20" align="center"><i><b>ID</b></i></td>
					<td colspan="2"><i><b><xsl:call-template name="traduce"><xsl:with-param name="id" select="'Informtico'"/></xsl:call-template></b></i></td>
					<td align="center"><i><b>Tipo.Tar</b></i></td>
					<td><i><b>ltima&#160;Espera</b></i></td>
					<td width="30"><i><b>Solicitud</b></i></td>
					<td width="20"><i><b>N&#160;Dias</b></i></td>
					<td width="60" align="center"><i><b>Prioridad</b></i></td>
					<td width="60" align="center"><i><b>Urgencia</b></i></td>
				</tr>
				<xsl:for-each select="DATA/METRICAS/RESULTADO_METRICAS/TAREA[@ESTADO = 'W']">
					<xsl:if test="@TIPO_TAREA = 'I'">
						<tr class="incidencia">
							<td width="20" align="center"><xsl:value-of select="@CODIGO"/></td>
							<td colspan="2"><xsl:value-of select="@INFORMATICO"/></td>
							<xsl:variable name="tiptar"><xsl:value-of select="@TIPO_TAREA"/></xsl:variable>
							<td align="center"><xsl:value-of select="../../TIPO_TAREA[@CODIGO = $tiptar]/@DESCRIPCION"/></td>
							<td align="center"><xsl:call-template name="date2String2"><xsl:with-param name="fecha" select="../@ULTIMA_ESPERA"/></xsl:call-template></td>
							<td width="30" align="center"><xsl:call-template name="date2String2"><xsl:with-param name="fecha" select="@FECHA_CREACION"/></xsl:call-template></td>
							<td width="20" align="right"><xsl:value-of select="../@DIAS"/></td>
							<xsl:variable name="prio"><xsl:value-of select="@PRIORIDAD"/></xsl:variable>
							<td class="celdapaipucMet" width="60" align="center">
								<xsl:value-of select="../../PRIORIDAD[@CODIGO = $prio]/@DESCRIPCION"/>
								<xsl:if test="not(../../PRIORIDAD[@CODIGO = $prio]/@DESCRIPCION)">
									--
								</xsl:if>
							</td>
							<td class="celdapaipucMet" width="60" align="center">
								<xsl:if test="@URGENCIA = 'U'">
									Urgente
								</xsl:if>
								<xsl:if test="@URGENCIA = 'N'">
									No&#160;Urgente
								</xsl:if>
								<xsl:if test="not(@URGENCIA)">
									--
								</xsl:if>
							</td>
						</tr>
					</xsl:if>
					<xsl:if test="@TIPO_TAREA != 'I'">
						<tr class="peticion">
							<td width="20" align="center"><xsl:value-of select="@CODIGO"/></td>
							<td colspan="2"><xsl:value-of select="@INFORMATICO"/></td>
							<xsl:variable name="tiptar"><xsl:value-of select="@TIPO_TAREA"/></xsl:variable>
							<td align="center"><xsl:value-of select="../../TIPO_TAREA[@CODIGO = $tiptar]/@DESCRIPCION"/></td>
							<td align="center"><xsl:call-template name="date2String2"><xsl:with-param name="fecha" select="../@ULTIMA_ESPERA"/></xsl:call-template></td>
							<td width="30" align="center"><xsl:call-template name="date2String2"><xsl:with-param name="fecha" select="@FECHA_CREACION"/></xsl:call-template></td>
							<td width="20" align="right"><xsl:value-of select="../@DIAS"/></td>
							<xsl:variable name="prio"><xsl:value-of select="@PRIORIDAD"/></xsl:variable>
							<td class="celdapaipucMet" width="60" align="center">
								<xsl:value-of select="../../PRIORIDAD[@CODIGO = $prio]/@DESCRIPCION"/>
								<xsl:if test="not(../../PRIORIDAD[@CODIGO = $prio]/@DESCRIPCION)">
									--
								</xsl:if>
							</td>
							<td class="celdapaipucMet" width="60" align="center">
								<xsl:if test="@URGENCIA = 'U'">
									Urgente
								</xsl:if>
								<xsl:if test="@URGENCIA = 'N'">
									No&#160;Urgente
								</xsl:if>
								<xsl:if test="not(@URGENCIA)">
									--
								</xsl:if>
							</td>
						</tr>
					</xsl:if>
				</xsl:for-each>
			</xsl:if>
			<!--Si hay tareas planificadas, las mostramos-->
			<xsl:if test="count(DATA/METRICAS/RESULTADO_METRICAS/TAREA[@PRIORIDAD = 'P'])>0">
				<tr class="cabeAlertas"><td colspan="9"><b>TAREAS&#160;PLANIFICADAS</b></td></tr>
				<tr class="administracion">
					<td width="20" align="center"><i><b>ID</b></i></td>
					<td colspan="3" align="center"><i><b><xsl:call-template name="traduce"><xsl:with-param name="id" select="'Informtico'"/></xsl:call-template></b></i></td>
					<td align="center"><i><b>Tipo.Tar</b></i></td>
					<td width="30"><i><b>Solicitud</b></i></td>
					<td width="30"><i><b>Fecha&#160;Mxima</b></i></td>
					<td width="20"><i><b>N&#160;Dias</b></i></td>
					<td width="60" align="center"><i><b>Urgencia</b></i></td>
				</tr>
				<xsl:for-each select="DATA/METRICAS/RESULTADO_METRICAS/TAREA[@PRIORIDAD = 'P']">
					<xsl:if test="@TIPO_TAREA = 'I'">
						<tr class="incidencia">
							<td width="20" align="center"><xsl:value-of select="@CODIGO"/></td>
							<td colspan="3"><xsl:value-of select="@INFORMATICO"/></td>
							<xsl:variable name="tiptar"><xsl:value-of select="@TIPO_TAREA"/></xsl:variable>
							<td align="center"><xsl:value-of select="../../TIPO_TAREA[@CODIGO = $tiptar]/@DESCRIPCION"/></td>
							<td width="30" align="center"><xsl:call-template name="date2String2"><xsl:with-param name="fecha" select="@FECHA_CREACION"/></xsl:call-template></td>				
							<td width="30" align="center"><xsl:call-template name="date2String2"><xsl:with-param name="fecha" select="@FECHA_MAX_RESOLUCION"/></xsl:call-template></td>
							<td width="20" align="right"><xsl:value-of select="../@DIAS"/></td>
							<td width="60" align="center">
								<xsl:if test="@URGENCIA = 'U'">
									Urgente
								</xsl:if>
								<xsl:if test="@URGENCIA = 'N'">
									No&#160;Urgente
								</xsl:if>
								<xsl:if test="not(@URGENCIA)">
									--
								</xsl:if>
							</td>
						</tr>
					</xsl:if>
					<xsl:if test="@TIPO_TAREA != 'I'">
						<tr class="peticion">
							<td width="20" align="center"><xsl:value-of select="@CODIGO"/></td>
							<td colspan="3"><xsl:value-of select="@INFORMATICO"/></td>
							<xsl:variable name="tiptar"><xsl:value-of select="@TIPO_TAREA"/></xsl:variable>
							<td align="center"><xsl:value-of select="../../TIPO_TAREA[@CODIGO = $tiptar]/@DESCRIPCION"/></td>
							<td width="30" align="center"><xsl:call-template name="date2String2"><xsl:with-param name="fecha" select="@FECHA_CREACION"/></xsl:call-template></td>				
							<td width="30" align="center"><xsl:call-template name="date2String2"><xsl:with-param name="fecha" select="@FECHA_MAX_RESOLUCION"/></xsl:call-template></td>
							<td width="20" align="right"><xsl:value-of select="../@DIAS"/></td>
							<td width="60" align="center">
								<xsl:if test="@URGENCIA = 'U'">
									Urgente
								</xsl:if>
								<xsl:if test="@URGENCIA = 'N'">
									No&#160;Urgente
								</xsl:if>
								<xsl:if test="not(@URGENCIA)">
									--
								</xsl:if>
							</td>
						</tr>
					</xsl:if>
				</xsl:for-each>
			</xsl:if>
			<xsl:if test="count(DATA/METRICAS/RESULTADO_METRICAS)=0">
				<tr class="administracion">
					<td align="center" colspan="10">* METRICAS sin datos.</td>
				</tr>
			</xsl:if>
				
			<tr class="administracion" align="center"><td colspan="9"><CENTER><input type="button" class="boton" value="Cerrar" onclick="javascript:window.close()" /></CENTER></td></tr>
		</table>
	</td></tr>
</table>
	
		
</body>
</html>
</xsl:template>
<xsl:template name="cuerpo"/>
</xsl:stylesheet>
	