/*
 * 
 *
 */
package dumbo7.notificaciones;

import org.apache.log4j.*;
import org.hibernate.Criteria;
import org.hibernate.Query;
import org.hibernate.Session;
import org.hibernate.Transaction;
import org.hibernate.criterion.Expression;

import atica.frameweb.utils.*;
import atica.frameweb.xml.XMLUtil;

import dumbo7.*;
import dumbo7.utils.*;

import javax.activation.DataHandler;
import javax.activation.DataSource;
import javax.activation.FileDataSource;
import javax.mail.*;
import javax.mail.internet.*;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import java.util.*;
import java.io.*;
import java.sql.PreparedStatement;
import java.sql.ResultSet;

/**
 * @author Universidad de Murcia - ATICA
 *
 */

public class GestorNotificaciones extends GeneralManager implements Runnable,FilenameFilter {
	
	public static long MAXIMO_POR_CORREO = 1024*1024*5; // Maximo 5Mb
	
	private D7PlantillasNotificaciones pn = null;
	private String findTarea = null;
	private String padreTarea = null;
	private File anxFile = null;
	//Variables para el mantenimiento de plantillas
	private String plnSisCod, plnNombre, plnTexto;
	
	public static String PAQ_ANULAR_TAREA = "dumbo7/inicio.rechazarAnulacionTarea";
	public static String PAQ_ESPERA_TAREA = "dumbo7/inicio.rechazarEsperaTarea";
	public static String PAQ_RESOLUCION_TAREA = "dumbo7/inicio.rechazarResolucionTarea";
	public static String PAQ_INFORME_TAREA = "dumbo7/inicio.rechazarInformeTarea";
	public static String PAQ_PLANIFICAR_TAREA = "dumbo7/inicio.rechazarPlanificacionTarea";
	
	private MimeMessage message1 = null;
	private BufferedReader in = null;
	private String OkMensaje = "Envio Correcto del e-mail!!";
	private String ErrorMensaje = "Error en el envio del e-mail, vuelva a intentarlo!!";
	
	private D7DatosTrabajador informatico=null;
	private D7DatosTrabajador usuario=null;
	//private String ListaTareas = "En este momento, el #WORDINF# #INFORMATICO# tiene previamente pendientes de atender/resolver #NUM-INC# #incidenciaPLURAL# y #NUM-PET# #peticionPLURAL#.";
	private String ListaTareas = "En este momento, este t&eacute;cnico tiene previamente pendientes de atender #NUM-INC# #incidenciaPLURAL# y #NUM-PET# #peticionPLURAL#.";
	private String Msj = "Le recordamos que en cualquier momento puede visualizar el n&uacute;mero de sus tareas pendientes, as&iacute; como modificarlas y dar otras nuevas de alta desde la direcci&oacute;n ";
	private String Color = "";
	private String Icono = "";
	private String str = "";
	private String Mensaje = "";
	private String Tareas = "";
	private String Coste = "";
	
	private String Pie ="";
	private String Pie1 ="";
	private String DirPlantillas = "";
	private String DirImagenes = "";
	private String IncPet = "";
	private String rutaAnexos = "";
	
	//private String host = "imap.upct.es";
	//private String correoRemitente = "paqui.rosique@si.upct.es";
	
	private String host = "";
	private String correoRemitente = "";
	
	private String de = "DE";
	private String para = "PARA";
	//private String correoDestinatario = "paqui.rosique@si.upct.es";
	private String comentario = "";
	
	private D7Aplicaciones Apli;
	private D7TiposTareas TipoTar;
	private D7Prioridades Prioridad;
	private D7TareasMovimientos tarMovE, tarMovI, tarMovU, tarMovEE;
	//private D7TareasSeguimientos tarSeg;
		
	private String [] datos = null;//Datos usados por ListaDatosPersonalesSeleccion
	private String [] Sel = null;
	private String [] DNI = null;
	
	private List Tar,Inf,PlantillasNotificaciones;
	//private List tarProg;
	private List Parametros;
	private Integer codigoTarea=null;
	private String nameAnexo = null;
	protected List datosPersonalesUsuario = null;
	protected List datosPersonalesInformatico = null;
	private List tarInforPendientes, tarInforEspera,tarInforPlanificadas=null;
	private boolean notUsu=false;

	private D7Categorias categorias=null;
	
	static Logger logger = Logger.getLogger(GestorNotificaciones.class);
	
	public GestorNotificaciones() {}
	
	public String getMensaje() { return Mensaje; }
	public List getTareas(){return Tar;}
	public List getInformatico(){return Inf;}
	public List getParametro(){return Parametros;}
	public List getPlantillas(){return PlantillasNotificaciones;}
	public boolean getNotUsu() {return notUsu;}
	
	public void setRutaAnexos(String r) { rutaAnexos = r; }
	public void setNotUsu(boolean notUsu) {this.notUsu = notUsu;}
	
	public static String resumenTarea(D7Tareas tar) {
		if (tar==null) return "";
		String cod = ""+tar.getTarCod();
		String asu =  tar.getTarAsunto();
		if (asu!=null && asu.length()>50) asu = asu.substring(0,50)+"...";
		return cod+": "+asu;
	}
	
	public static String codigoTarea(D7Tareas tar) {
		if (tar==null) return "";
		if (tar.getTarPadreTarCod()!=null) return tar.getTarCod().toString()+" (Tarea Padre "+tar.getTarPadreTarCod()+")"; 
		return tar.getTarCod().toString();
	}
	
	public void QueryTareas(Session conn){
		try{
			Query q = conn.createQuery(getQuery("AllTareas"));
			q = q.setString("sist",user.getDatosMenu().idSelected());
			Tar = (List)q.list();
		
		} catch (Exception ex) {
			setErrorMessage("GestorNotificaciones[Lectura de BBDD]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
	}
	
	public void QueryInformaticos(Session conn){
		try{
			Query q = conn.createQuery(getQuery("Informaticos"));
			q = q.setString("sist",user.getDatosMenu().idSelected());
			Inf = (List)q.list();
		
		} catch (Exception ex) {
			setErrorMessage("GestorNotificaciones[Lectura de BBDD]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
	}
	public void QueryParametros(Session conn){
		try{
			Query q = conn.createQuery(getQuery("Parametros"));
			q = q.setString("sist",user.getDatosMenu().idSelected());
			Parametros = (List)q.list();
		
		} catch (Exception ex) {
			setErrorMessage("GestorNotificaciones[Lectura de BBDD]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
	}
	public void listaParametroPie(Session conn)
	{
		try
		{
			Query q = conn.createQuery(getQuery("ParametroPie"));
			q = q.setString("sist",user.getDatosMenu().idSelected());
			Parametros  = (List)q.list();
		}
		catch (Exception ex)
		{
			setErrorMessage("GestorParametros[Lectura de BBDD]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
	}
	public void listaParametroPie1(Session conn)
	{
		try
		{
			Query q = conn.createQuery(getQuery("ParametroPie1"));
			q = q.setString("sist",user.getDatosMenu().idSelected());
			Parametros  = (List)q.list();
		}
		catch (Exception ex)
		{
			setErrorMessage("GestorParametros[Lectura de BBDD]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
	}
	public void ActualizaParametros(Session conn){
		/**Tomamos la lista de parmetros activa para configurar dinmicamente el e-mail*/
		
		//PAR_IND_COLOR--->S/N indica si se quiere o no mostrar colores en los e-mail
		//PAR_IND_ICONO--->S/N indica si se quiere o no mostrar iconos en los e-mail
		//PAR_IND_COSTE--->S/N indica si se quiere o no mostrar el coste estimado y tiempo de resolucin en los e-mail
		//PAR_IND_TAREAS--->S/N indica si se quiere o no mostrar las tareas pendientes en los e-mail		
		//PAR_DIR_PLANTILLAS--->@ donde se encuentran las plantillas		
		//PAR_URL_IMG_NOTIF--->@ donde se encuentran las imagenes de los iconos
		//PAR_PIE_NOTIF--->Texto a mostrar en el pie de los e-mail
		//PAR_HOST_EMAIL--->host
		//PAR_CORREO_DUMBO.--->correo remitente
		this.QueryParametros(conn);
				
		Iterator it = Parametros.iterator();
		while(it.hasNext()){
			D7Parametros par = ((D7Parametros)it.next());
			if((par.getParParametro().equals("PAR_IND_COLOR")) & (par.getParSisCod().equals(user.getDatosMenu().idSelected()))){Color = par.getParValor();}
				if((par.getParParametro().equals("PAR_IND_ICONO"))&  (par.getParSisCod().equals(user.getDatosMenu().idSelected()))){Icono = par.getParValor();}
	        	if((par.getParParametro().equals("PAR_DIR_PLANTILLAS"))& (par.getParSisCod().equals(user.getDatosMenu().idSelected()))){DirPlantillas = par.getParValor();}
	        	if((par.getParParametro().equals("PAR_URL_IMG_NOTIF"))& (par.getParSisCod().equals(user.getDatosMenu().idSelected()))){DirImagenes = par.getParValor();}
	        	if((par.getParParametro().equals("PAR_PIE_NOTIF"))& (par.getParSisCod().equals(user.getDatosMenu().idSelected()))){Pie = par.getParValor();}
	        	if((par.getParParametro().equals("PAR_IND_COSTE"))& (par.getParSisCod().equals(user.getDatosMenu().idSelected()))){Coste = par.getParValor();}
	        	if((par.getParParametro().equals("PAR_IND_TAREAS"))& (par.getParSisCod().equals(user.getDatosMenu().idSelected()))){Tareas = par.getParValor();}
	        	if((par.getParParametro().equals("PAR_HOST_MAIL"))&  (par.getParSisCod().equals(user.getDatosMenu().idSelected()))){host = par.getParValor();}
	        	if((par.getParParametro().equals("PAR_CORREO_DUMBO"))&  (par.getParSisCod().equals(user.getDatosMenu().idSelected()))){correoRemitente = par.getParValor();}
	        	if((par.getParParametro().equals("PAR_DIR_DUMBO"))& (par.getParSisCod().equals(user.getDatosMenu().idSelected()))){Pie1 = par.getParValor();}
		}
	}
	
	public void QueryTiposTareas(Session conn,D7Tareas tar){
		try{
			Query q = conn.createQuery(getQuery("TiposTareas"));
			q = q.setString("sist",user.getDatosMenu().idSelected());
			q = q.setString("code",tar.getTarTipCod());
			TipoTar = (D7TiposTareas)q.list().get(0);
		
		} catch (Exception ex) {
			setErrorMessage("GestorNotificaciones[Lectura de BBDD]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
	}
	public void QueryAplicaciones(Session conn,D7Tareas tar){
		try{
			Query q = conn.createQuery(getQuery("Aplicaciones"));
			q = q.setString("sist",user.getDatosMenu().idSelected());
			q = q.setString("code",tar.getTarAplCod());
			Apli = (D7Aplicaciones)q.list().get(0);
		
		} catch (Exception ex) {
			setErrorMessage("GestorNotificaciones[Lectura de BBDD]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
	}
	
	//	query que devuelve los datos personales del informatico asignado a la tarea
	public void QueryDatosInformatico(Session conn,D7Tareas tar){
		try{
			Query q = conn.createQuery(getQuery("DatosTrabajador"));
			q = q.setString("inf",tar.getTarInfCod());
			datosPersonalesInformatico  = (List)q.list();
			informatico=(D7DatosTrabajador)datosPersonalesInformatico.get(0);
		} catch (Exception ex) {
			setErrorMessage("GestorNotificaciones[Lectura de BBDD]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
	}
	//query que devuelve los datos personales del informatico asignado a la tarea
	public void QueryDatosInformaticosAplicacion(Session conn,D7Tareas tar){
		try{
			Query q = conn.createQuery(getQuery("AplicacionesInformaticosVigentes"));
			q = q.setString("sist",user.getDatosMenu().idSelected());
			q = q.setString("apl",tar.getTarAplCod());
			
			datosPersonalesInformatico  = (List)q.list();
		} catch (Exception ex) {
			setErrorMessage("GestorNotificaciones[Lectura de BBDD]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
	}
//	query que devuelve los datos personales del user 
	public void QueryDatosUsuario(Session conn,D7Tareas tar){
		try{
			Query q = conn.createQuery(getQuery("DatosTrabajador"));
			q = q.setString("inf",tar.getTarUsuCod());
			datosPersonalesUsuario  = (List)q.list();
			usuario=(D7DatosTrabajador)datosPersonalesUsuario.get(0);
		} catch (Exception ex) {
			setErrorMessage("GestorNotificaciones[Lectura de BBDD]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
	}
	
	public void QueryDatosUser(Session conn,D7Tareas tar){
		try{
			Query q = conn.createQuery(getQuery("DatosTrabajador"));
			q = q.setString("inf",user.getIdentificador());
			datosPersonalesInformatico  = (List)q.list();
			informatico=(D7DatosTrabajador)datosPersonalesInformatico.get(0);
		} catch (Exception ex) {
			setErrorMessage("GestorNotificaciones[Lectura de BBDD]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
	}
	
//	query que devuelve los datos personales del oreja que est cambiando la tarea
	public void QueryDatosOreja(Session conn,String dni,String usuOinf){
		try{
			Query q = conn.createQuery(getQuery("DatosTrabajador"));
			q = q.setString("inf",dni);
			if (usuOinf=="usu"){
				datosPersonalesUsuario  = (List)q.list();
				usuario=(D7DatosTrabajador)datosPersonalesUsuario.get(0);
			}
			else {
				datosPersonalesInformatico  = (List)q.list();
				informatico=(D7DatosTrabajador)datosPersonalesInformatico.get(0);
			}
		} catch (Exception ex) {
			setErrorMessage("GestorNotificaciones[Lectura de BBDD]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
	}
	//metodo que devuelve una categoria
	public void QueryCategoria(Session conn,D7Tareas tar){
		try{
			Query q = conn.createQuery(getQuery("Categorias"));
			q = q.setString("sist",user.getDatosMenu().idSelected());
			q = q.setString("cod",tar.getTarCatCod().toString());
			categorias = (D7Categorias)q.list().get(0);
		
			
		} catch (Exception ex) {
			setErrorMessage("GestorNotificaciones[Lectura de BBDD]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
	}
		
	public void QueryPrioridades(Session conn,D7Tareas tar){
		try{
			Query q = conn.createQuery(getQuery("Prioridades"));
			q = q.setString("sist",user.getDatosMenu().idSelected());
			q = q.setString("code",tar.getTarPriCod());
			Prioridad = (D7Prioridades)q.list().get(0);
		
		} catch (Exception ex) {
			setErrorMessage("GestorNotificaciones[Lectura de BBDD]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
	}
		
	/**	
	 * Posibles estados para los que se buscar el ultimo movimiento y as mostrara su descripcin en el e-mail
	 * ASIGNAR_TAREA = "U";
		ANULAR_TAREA = "A";
		DEVOLVER_TAREA = "V";
		FINALIZAR_TAREA = "F";
		PASAR_WAITING = "W";
		PASAR_NOWAITING = "N";
		REASIGNAR = "R";
		RECHAZAR = "X";
		REACTIVAR = "T";
		RECHAZAR_WAITING = "K";*/
	//query que devuelve los movimientos de una tarea producidos por cambio de estado
	public D7TareasMovimientos QueryTareasMovimientosEst(Session conn,D7Tareas tar, String estado){
		try{
			Query q = conn.createQuery(getQuery("TareasMov"));
			q = q.setString("sist",user.getDatosMenu().idSelected());
			q = q.setString("code",tar.getTarCod().toString());
			q = q.setString("estado",estado);
			tarMovE = (D7TareasMovimientos)(q.list().get(0));
			return tarMovE;	
		
		} catch (Exception ex) {
			setErrorMessage("GestorNotificaciones[Lectura de BBDD]: "+((ex.getCause()!=null)?ex.getCause():ex));
			return null;
		}
		
	}
	
	//query que devuelve los movimientos de una tarea producidos por cambio de estado la penultima
	public void QueryTareasMovimientosEst2(Session conn,D7Tareas tar, String estado){
		try{
			Query q = conn.createQuery(getQuery("TareasMov"));
			q = q.setString("sist",user.getDatosMenu().idSelected());
			q = q.setString("code",tar.getTarCod().toString());
			q = q.setString("estado",estado);
			tarMovEE = (D7TareasMovimientos)q.list().get(0);
		
		} catch (Exception ex) {
			setErrorMessage("GestorNotificaciones[Lectura de BBDD]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
	}

	//query que devuelve los movimientos de una tarea producidos por el informatico
	public void QueryTareasMovimientosInf(Session conn,D7Tareas tar){
		try{
			Query q = conn.createQuery(getQuery("TareasMov"));
			q = q.setString("sist",user.getDatosMenu().idSelected());
			q = q.setString("code",tar.getTarCod().toString());
			q = q.setString("estado","I");
			tarMovI = (D7TareasMovimientos)q.list().get(0);
		
		} catch (Exception ex) {
			setErrorMessage("GestorNotificaciones[Lectura de BBDD]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
	}
	
	//query que devuelve los movimientos de una tarea producidos por el usuario
	public void QueryTareasMovimientosUsu(Session conn,D7Tareas tar){
		try{
			Query q = conn.createQuery(getQuery("TareasMov"));
			q = q.setString("sist",user.getDatosMenu().idSelected());
			q = q.setString("code",tar.getTarCod().toString());
			q = q.setString("estado","U");
			tarMovU = (D7TareasMovimientos)q.list().get(0);
		
		} catch (Exception ex) {
			setErrorMessage("GestorNotificaciones[Lectura de BBDD]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
	}

	
//	query que devuelve las tareas pendientes de un informatico
	public void QueryTareasInformesPendientes(Session conn,D7Informaticos inf){
		try{
			//System.out.println("informatico:"+inf.getInfCod());
			Query q = conn.createQuery(getQuery("TareasInformes"));
			q = q.setString("sist",user.getDatosMenu().idSelected());
			q = q.setString("inf",inf.getInfCod());
			q = q.setString("estado","P");
			tarInforPendientes = q.list();
		
		} catch (Exception ex) {
			setErrorMessage("GestorNotificaciones[Lectura de BBDD]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
	}
	
//	query que devuelve las tareas en espera de un informatico
	public void QueryTareasInformesEspera(Session conn,D7Informaticos inf){
		try{
			Query q = conn.createQuery(getQuery("TareasInformes"));
			q = q.setString("sist",user.getDatosMenu().idSelected());
			q = q.setString("inf",inf.getInfCod());
			q = q.setString("estado","W");
			tarInforEspera = q.list();
		
		} catch (Exception ex) {
			setErrorMessage("GestorNotificaciones[Lectura de BBDD]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
	}
	
	
//	query que devuelve las tareas planificadas de un informatico
	public void QueryTareasInformesPlanificadas(Session conn,D7Informaticos inf){
		try{
			Query q = conn.createQuery(getQuery("TareasInformesPlanificadas"));
			q = q.setString("sist",user.getDatosMenu().idSelected());
			q = q.setString("inf",inf.getInfCod());
			q = q.setString("prioridad","P");
			tarInforPlanificadas = q.list();
		
		
		} catch (Exception ex) {
			setErrorMessage("GestorNotificaciones[Lectura de BBDD]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
	}
	
/*
	public Query QueryTareasSeguimientos(Session conn,D7Tareas tar){
		Query q=null;
		try{
			System.out.println("GN [QueryTareasSeguimientos]: antes de la query");
			q = conn.createQuery(getQuery("TareasSeg"));
		//	q = q.setString("sist",user.getDatosMenu().idSelected());
		//	q = q.setString("code",tar.getTarCod().toString());
			System.out.println("GN [QueryTareasSeguimientos]: despues de la query y antes de tarSeg=");
			//tarSeg = (D7TareasSeguimientos)q.list().get(0);
		} catch (Exception ex) {
			setErrorMessage("GestorNotificaciones[Lectura de BBDD]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
		//System.out.println(q);
		//System.out.println(tarSeg.getTseDescrip());
		return q;
	}
*/	
	/**Devulve una objeto QUERY con las tareas que estn asociadas al informtico
	 * asociado a la tarea que recibe de entrada*/
	/*
	public Query QueryTareasInformatico(Session conn,D7Tareas tar){
		Query q = null;
		try{
			q = conn.createQuery(getQuery("Tareas"));
			q = q.setString("sist",user.getDatosMenu().idSelected());
			q = q.setString("code",tar.getTarInfCod());
		} catch (Exception ex) {
			setErrorMessage("GestorNotificaciones[Lectura de BBDD]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
		return q;
	}
	*/
	public int QueryTareasInformatico(Session conn,D7Tareas tar,String tipo){
		int n = 0;
		try
		{
			Query q = conn.createQuery(getQuery("TareasTipo"));
			q = q.setString("sist",user.getDatosMenu().idSelected());
			q = q.setString("code",tar.getTarInfCod());
			q = q.setString("tipo",tipo);
			return new Integer(q.list().get(0).toString()).intValue();
		}
		catch (Exception ex)
		{
			setErrorMessage("GestorNotificaciones[Lectura de BBDD]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
		return new Integer(n).intValue();
	}
	public Query QueryIncidenciasInformatico(Session conn,D7Tareas tar){
		Query q = null;
		try{
			q = conn.createQuery(getQuery("TareasIncidencia"));
			q = q.setString("sist",user.getDatosMenu().idSelected());
			q = q.setString("code",tar.getTarInfCod());
		} catch (Exception ex) {
			setErrorMessage("GestorNotificaciones[Lectura de BBDD]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
		return q;
	}
	public String getNombreUsuario(D7Tareas tar,D7DatosTrabajador usu) {
		if (usu!=null) return usu.getDatNombre()+" "+usu.getDatApellidos();
		else return correosToArray(tar.getTarEmailCopia())[0];
	}
	
	private String [] copiaEspecial = null;
	private void setCopiaEspecial(String [] c) { copiaEspecial = c; }
	
	private String [] correosToArray(String correos) {
		StringTokenizer st = new StringTokenizer(correos,",");
		String [] array = new String[st.countTokens()+((copiaEspecial!=null)?copiaEspecial.length:0)];
		int k=0;
		while (st.hasMoreTokens()) {
			array[k] = (String)st.nextToken(); k++;
		}
		if (copiaEspecial!=null) {
			for (int j=0; j<copiaEspecial.length; j++)
				array[k+j] = copiaEspecial[j];
		}
		return array;
	}
	public String [] getCorreoUsuario(D7Tareas tar,D7DatosTrabajador usu) {
		String correos = "";
		if (usu!=null) correos = usu.getDatEmail();
		if (tar.getTarEmailCopia()!=null && !tar.getTarEmailCopia().equals("")) {
			if (correos.equals("")) correos = tar.getTarEmailCopia();
			else correos += ","+tar.getTarEmailCopia();
		}
		return correosToArray(correos);
	}
	/**Introduce en Subject del E-mail y indica el nombre del archivo(PLANTILLA) que hay que leer
	 * debe de encontrarse antes de los mtodos de las querys puesto que utiliza algunos datos que
	 * estos actualizan*/
	public void ConfiguraMailYFichero(String Subject,String Fichero,String correoDestinatario, Session conn)
	{
		ConfiguraMailYFichero(Subject,Fichero,new String [] {correoDestinatario}, conn);
	}
	public void ConfiguraMailYFichero(String Subject,String Fichero,String [] correoDestinatario, Session conn)
	{
		try
		{
			InternetAddress[] destinatarios=new InternetAddress[2];
			
			Properties props = System.getProperties();
	        props.put("mail.smtp.host", host);        
	        javax.mail.Session ses = javax.mail.Session.getDefaultInstance(props,null);               
	        this.message1 = new MimeMessage(ses);
	        
	        message1.setFrom(new InternetAddress("Sistema dumbo <"+correoRemitente+">"));
	        if (informatico!=null && getNotUsu()==true){ 
	        	destinatarios[0]=new InternetAddress(user.traduce("dumbo7/notificaciones","Informatico",user.getDatosMenu().idSelected())+" <"+informatico.getDatEmail()+">");
	        	destinatarios[1]=new InternetAddress("Sistema dumbo <"+correoRemitente+">");
	        	message1.setReplyTo(destinatarios);
	        	//message1.addRecipient(Message.RecipientType.CC, new InternetAddress("Sistema dumbo <"+correoRemitente+">")); 
	        	this.setNotUsu(false);
	        }
	        
	        //Metemos los destinatarios en una estructura sin repeticiones
	        Set correos = new HashSet();
	        for (int k=0; k<correoDestinatario.length; k++) {
	        	correos.add(correoDestinatario[k]);
	        }
	        //El primero tiene un tratamiento especial, se mete en el TO del mensaje
	        correos.remove(correoDestinatario[0]);
	        message1.addRecipient(Message.RecipientType.TO, new InternetAddress(correoDestinatario[0]));
	        
	        //Recorremos el resto, si los hay y los metemos en el CC
	        Iterator it= correos.iterator();
	        while (it.hasNext()){
	        	String correo = (String)it.next();
	        	message1.addRecipient(Message.RecipientType.CC, new InternetAddress(correo));
	        }
	        
	        /**for (int k=0; k<correoDestinatario.length; k++) {
	        	if (k==0) message1.addRecipient(Message.RecipientType.TO, new InternetAddress(correoDestinatario[k]));
	        	else message1.addRecipient(Message.RecipientType.CC, new InternetAddress(correoDestinatario[k]));
	        }**/
	        message1.setSubject(Subject);
	        
	        /**Abrir el archivo Dependiendo del parammetro Directorio sacado de BBDD*/
	        /*try {
	        	// Si no existe el directorio, lo calculo con resource !!
	        	File f = new File(DirPlantillas.concat(Fichero));
	        	if (!f.exists()) throw new Exception("");
	        } catch (Exception exx) {
		        String file = getClass().getResource("config.xml").getFile();
		        int n = file.indexOf("/WEB-INF/classes/dumbo7/notificaciones/config.xml");
		        DirPlantillas = file.substring(0,n+1)+"plantillas/";
	        }
	        this.in = new BufferedReader(new FileReader(DirPlantillas.concat(Fichero)));*/
	        /**Cargamos la plantilla desde BBDD*/
	        Query q = conn.createQuery(getQuery("UnaPlantilla"));
			q.setString("sist",user.getDatosMenu().idSelected());
			q.setString("nombre",Fichero);
			PlantillasNotificaciones = (List)q.list();
			
			str = ((D7PlantillasNotificaciones) PlantillasNotificaciones.get(0)).getPlnTexto();
      
		} catch(Exception e)
		{
			setErrorMessage(e.toString());
			e.printStackTrace();
		}
	}
	
	
	public static String generaID(int lon) {
		String t = "";
	    String cadena ="QWzaqwsnhyE0RTYUmjukilopIOP1A2S4DF6GHJ8Kxedcvfrtgb9LZ3XC5VB7NM";
	    Random r = new Random(System.currentTimeMillis());
	    for (int i=0; i<lon; i++) {
	    	int j = r.nextInt(cadena.length());
	        t += cadena.substring(j,j+1);
	    }
	    return t;
	  }
	
//	Mtodo para fijar el Codigo de la tarea
	public void setCodigoTarea(Integer tar){	
		codigoTarea=tar;
	}
	
	public void setNameAnexo(String nam) {
		nameAnexo=nam;
	}
	
	//metodo que devuelve la fecha en formato dd/mm/aaaa
	public String getFecha(Date t){
	
		int ano1,mes1,dia1;
	    GregorianCalendar gc1 = new GregorianCalendar();
	    gc1.setTime(t);
	    ano1 = gc1.get(Calendar.YEAR);
	    mes1 = gc1.get(Calendar.MONTH);
	    dia1 = gc1.get(Calendar.DAY_OF_MONTH);
	    String[] meses = {"01", "02", "03", "04", "05", "06","07", "08", "09","10", "11", "12"};
	    String[] dias = {"01", "02", "03", "04", "05", "06","07", "08", "09","10", "11", "12","13" ,"14", "15", "16", "17", "18", "19", "20", "21","22","23","24","25","26","27","28","29","30","31"};
	    return dias[dia1-1]+"/"+meses[mes1]+"/"+ano1;
	}
	
	/**NOTIFICACIONES A USUARIOS*/

	
	//Mtodo que guarda los datos necesarios para el "pincha aqu"
	//las claves para poder acceder sin sesion
	public String createUrlPincheAqui(Session conn,Integer tarea,String operacion) {
		String cadena = "";
		Transaction tx = null;
		try {
			
			tx = conn.beginTransaction();
			
			// Aprovecho y borro claves viejas
			conn.createQuery(getQuery("deleteClavesNotificaciones")).executeUpdate();
			
			/*
			PreparedStatement ps = conn.connection().prepareStatement(getQuery("deleteClavesNotificaciones"));
			ps.executeUpdate();
			ps.close();
			conn.connection().commit();
			*/
			// Escojo una clave que no est en uso !!
			D7ClavesNotificaciones dc = null;
			try {
				do {
					cadena = generaID(25);
					dc = (D7ClavesNotificaciones)conn.load(D7ClavesNotificaciones.class,cadena);
				} while (dc!=null && dc.getClnSisCod()!=null);
			} catch (Exception ex) {}
			
			/*
			ps = conn.connection().prepareStatement(getQuery("loadClaveNotificaciones"));
			ResultSet rs = null;
			do {
				if (rs!=null) rs.close();
				cadena = generaID(25);
				ps.setString(1,cadena);
				rs = ps.executeQuery();
			} while (rs.next());
			rs.close(); ps.close();
			*/

			dc = new D7ClavesNotificaciones();
			dc.setClnCadena(cadena);
			dc.setClnSisCod(user.getDatosMenu().idSelected());
			dc.setClnTarCod(tarea);
			dc.setClnOperacion(operacion);
			dc.setClnFecha(new Date());
			
			conn.save(dc);
			tx.commit();

		} catch (Exception ex) {
			System.out.println("Pinche Aqui: "+ex);
		}
		/*
		Transaction tx = null;
		try {
			
			tx = conn.beginTransaction();

			D7ClavesNotificaciones dc = new D7ClavesNotificaciones();
			dc.setClnCadena(cadena);
			dc.setClnSisCod(user.getDatosMenu().idSelected());
			dc.setClnTarCod(tarea);
			dc.setClnOperacion(operacion);
			dc.setClnFecha(new Date());
			
			conn.save(dc);
			
			tx.commit();
			
		} catch (Exception e) {
			System.out.println("Genera Pinche Aqui: "+e);
		}
		*/
		String url = ((dumbo7.user.DumboUser)user).getServletUrl()+"?module=dumbo7/inicio.doit&code="+cadena;
		return url;
	}
	
	
	//Notificacion de tareas que tiene un informatico
	//Cuidado que en este mtodo hay que pasar el codigo de un informatico, no una tarea
	public void NotificacionUsuarioInfor(Session conn,String infCod){
		
		this.ActualizaParametros(conn);
		try{
			
			//System.out.println(user.getDatosMenu().idSelected());
			//query que devuelve el informatico sobre el que queremos realizar el informe
			Query q1 = conn.createQuery(getQuery("InformaticoInforme"));
			//System.out.println(q1);
			q1 = q1.setString("sist",user.getDatosMenu().idSelected());
			q1 = q1.setString("cod",infCod);
			D7Informaticos informatico = (D7Informaticos)q1.list().get(0);
			
			//query que devuelve los datos personales del informatico
			Query q = conn.createQuery(getQuery("DatosPersonalesInformatico"));
			q = q.setString("inf",infCod);
			datosPersonalesInformatico  = (List)q.list();			
			D7DatosPersonales dinf=(D7DatosPersonales)datosPersonalesInformatico.get(0);
			
			this.QueryTareasInformesPendientes(conn,informatico);
			this.QueryTareasInformesEspera(conn,informatico);	
			this.QueryTareasInformesPlanificadas(conn,informatico);

			String tablaPendiente="<table border=\"1\" cellpadding=\"2\" cellspacing=\"0\" width=\"550\">"+
			"<tr><td width=\"50\"><b>Cdigo</b></td><td width=\"350\"><b>Descripcin</b></td><td width=\"50\"><b>Informtico</b></td><td width=\"50\"><b>Fecha</b></td></tr>"+
			"#FILA-PENDIENTE#</table>";
			
			String tablaEspera="<table border=\"1\" cellpadding=\"2\" cellspacing=\"0\" width=\"550\">"+
			"<tr><td width=\"50\"><b>Cdigo</b></td><td width=\"350\"><b>Descripcin</b></td><td width=\"50\"><b>Informtico</b></td><td width=\"50\"><b>Fecha</b></td></tr>"+
			"#FILA-ESPERA#</table>";
			
			String tablaPlanificada="<table border=\"1\" cellpadding=\"2\" cellspacing=\"0\" width=\"600\">"+
			"<tr><td width=\"50\"><b>Cdigo</b></td><td width=\"350\"><b>Descripcin</b></td><td width=\"50\"><b>Informtico</b></td><td width=\"50\"><b>Fecha</b></td><td width=\"100\"><b>Planificacin</b></td></tr>"+
			"#FILA-PLANIFICADA#</table>";
			
			
			String filaPendiente="";
			String filaEspera="";
			String filaPlanificada="";
			String filaPendientePlantilla = "<tr><td>#TAR-COD-PEND#</td><td>#TAR-DESCRIP#</td><td>#INFORMATICO#</td><td>#FECHA-PEND#</td></tr>";
			String filaEsperaPlantilla="<tr><td>#TAR-COD-ESP#</td><td>#TAR-DESCRIP#</td><td>#INFORMATICO#</td><td>#FECHA-ESP#</td></tr>";
	       	String filaPlanificadaPlantilla="<tr><td>#TAR-COD-PLAN#</td><td>#TAR-DESCRIP#</td><td>#INFORMATICO#</td><td>#FECHA-CREA#</td><td>#FECHA-PLAN#</td></tr>";
	       	
	       	str = str.replaceFirst("#PINCHE#",createUrlPincheAqui(conn,new Integer("0"),PAQ_INFORME_TAREA));
	       	
	       	if(tarInforPendientes==null)
				filaPendiente="<tr><td colspan=\"4\"><CENTER>Sin resultados</CENTER></td><tr>";
			else{
			
				for(int i=0;i<tarInforPendientes.size();i++)
				{
					D7Tareas t=(D7Tareas)tarInforPendientes.get(i);
					filaPendiente=filaPendiente.concat(filaPendientePlantilla);	
					Date d=t.getTarFeccrea();
					if(d!=null)
						filaPendiente = filaPendiente.replaceAll("#FECHA-PEND#",this.getFecha(d));
					else
						filaPendiente = filaPendiente.replaceAll("#FECHA-PEND#","");
					filaPendiente=filaPendiente.replaceAll("#TAR-COD-PEND#",t.getTarCod().toString());
				  	filaPendiente=filaPendiente.replaceAll("#TAR-DESCRIP#",t.getTarDescrip().replaceAll("<", "&lt;"));
				  	filaPendiente=filaPendiente.replaceAll("#INFORMATICO#",t.getTarInfCod());
				}
			}
			
			if(tarInforEspera==null)
				filaEspera="<tr><td colspan=\"4\"><CENTER>Sin resultados</CENTER></td><tr>";
			else{			
				for(int i=0;i<tarInforEspera.size();i++)
				{
					D7Tareas t=(D7Tareas)tarInforEspera.get(i);
					filaEspera=filaEspera.concat(filaEsperaPlantilla);	
					Date d=t.getTarFeccrea();
					if(d!=null)
						filaEspera = filaEspera.replaceAll("#FECHA-ESP#",this.getFecha(d));
					else
						filaEspera = filaEspera.replaceAll("#FECHA-ESP#","");
					filaEspera=filaEspera.replaceAll("#TAR-COD-ESP#",t.getTarCod().toString());
				  	filaEspera=filaEspera.replaceAll("#TAR-DESCRIP#",t.getTarDescrip().replaceAll("<", "&lt;"));
				  	filaEspera=filaEspera.replaceAll("#INFORMATICO#",t.getTarInfCod());
				  	
				}
			}
			
			if(tarInforPlanificadas==null)
				filaPlanificada="<tr><td colspan=\"5\"><CENTER>Sin resultados</CENTER></td><tr>";
			else{				
				for(int i=0;i<tarInforPlanificadas.size();i++)
				{					
					D7Tareas t=(D7Tareas)tarInforPlanificadas.get(i);				
					filaPlanificada=filaPlanificada.concat(filaPlanificadaPlantilla);	
					Date d=t.getTarFeccrea();
					
					Date dmax=t.getTarPlanif();
	        		if(d!=null)
	        			filaPlanificada = filaPlanificada.replaceAll("#FECHA-CREA#",this.getFecha(d));
	        		else
	        			filaPlanificada = filaPlanificada.replaceAll("#FECHA-CREA#","");
	        		if(dmax!=null)
	        			filaPlanificada = filaPlanificada.replaceAll("#FECHA-PLAN#",this.getFecha(dmax));
	        		else
	        			filaPlanificada = filaPlanificada.replaceAll("#FECHA-PLAN#","");
					filaPlanificada=filaPlanificada.replaceAll("#TAR-COD-PLAN#",t.getTarCod().toString());
				  	filaPlanificada=filaPlanificada.replaceAll("#TAR-DESCRIP#",t.getTarDescrip().replaceAll("<", "&lt;"));
				  	filaPlanificada=filaPlanificada.replaceAll("#INFORMATICO#",t.getTarInfCod());
				  	
				}
			}
			
			this.setNotUsu(true);
			
			/**Introduce en Subject del E-mail e indica el nombre del archivo(PLANTILLA) que hay que leer*/
			this.ConfiguraMailYFichero("[dumbo] Seccion de Atencion a USUARIOS","NotUsuInfor.html",dinf.getDatEmail(),conn);

       		tablaPendiente=tablaPendiente.replaceAll("#FILA-PENDIENTE#",filaPendiente);
       		tablaEspera=tablaEspera.replaceAll("#FILA-ESPERA#",filaEspera);
       		tablaPlanificada=tablaPlanificada.replaceAll("#FILA-PLANIFICADA#",filaPlanificada);
       
       		str = str.replaceFirst("#SISTEMA#","DUMBO");
		                	
       		str = str.replaceFirst("#TABLA-PENDIENTES#",tablaPendiente);
       		str = str.replaceFirst("#TABLA-ESPERA#",tablaEspera);
       		str = str.replaceFirst("#TABLA-PLANIFICADA#",tablaPlanificada);
       	
       		str = str.replaceFirst("#IMAGEN#",DirImagenes.concat("NotUsuInfor.gif"));
        	str = str.replaceFirst("#PIE#",Pie);
        	//sonia
        	str = str.replaceFirst("#DIR-PIE#",Pie1);
        	//fin sonia
        	if (Icono.equals("N")){str = str.replaceFirst("visibility: visible","visibility: hidden");}
        	if (Color.equals("N")){str = str.replaceFirst("background-color: #2D81B3","background-color: #FFFFFF");}
    	
        	Mensaje = Mensaje.concat(str);
        	str = "";
	        
	        message1.setContent(Mensaje,"text/html;charset=iso-8859-1");
	       
	        sendMessageThread();
	        setErrorMessage(OkMensaje);
	      }
			
	      catch (Exception e) {
	      	setErrorMessage(ErrorMensaje);
	      	System.out.println("error: "+e);
	      }
		
		
	}
	
	public void NotificacionUsuarioProblema(Session conn,D7Tareas tar){
		tar.setTarCod(codigoTarea);
		
		this.ActualizaParametros(conn);
		
		try{
			
			Query q = conn.createQuery(getQuery("TareasAux"));
			//System.out.println(q);
			q = q.setString("sist",user.getDatosMenu().idSelected());
			q = q.setString("cod",codigoTarea.toString());
			tar = (D7Tareas)q.list().get(0);
				
			this.QueryTiposTareas(conn,tar);
			this.QueryAplicaciones(conn,tar);
			this.QueryPrioridades(conn,tar);
			this.QueryDatosUsuario(conn,tar);
			
			this.setNotUsu(true);
			/**Introduce en Subject del E-mail e indica el nombre del archivo(PLANTILLA) que hay que leer*/
			this.ConfiguraMailYFichero("[dumbo] Notificacion de nuevo problema "+resumenTarea(tar),"NotUsuProb.html",getCorreoUsuario(tar,usuario), conn);
			
        	str = str.replaceFirst("#IMAGEN#",DirImagenes.concat("NotInfAsig.gif"));
        	str = str.replaceFirst("#PIE#",Pie);
//        	sonia
        	str = str.replaceFirst("#DIR-PIE#",Pie1);
        	//fin sonia
        	if (Icono.equals("N")){str = str.replaceFirst("visibility: visible","visibility: hidden");}
        	if (Color.equals("N")){str = str.replaceFirst("background-color: #FFFF00","background-color: #FFFFFF");}
        	
        	str = str.replaceAll("#INC-PET#",TipoTar.getTipDescrip().replaceAll("", "&oacute;"));
        	str = str.replaceAll("#NUM#",codigoTarea(tar));
        	str = str.replaceFirst("#USUARIO#",getNombreUsuario(tar,usuario));
        	str = str.replaceFirst("#APLICACION#",Apli.getAplDescrip());
        	str = str.replaceFirst("#ASUNTO#",tar.getTarAsunto());
           	str = str.replaceFirst("#TEXTO#","<PRE>"+tar.getTarDescrip().replaceAll("<", "&lt;")+"</PRE>");
        	if(Tareas.equals("N")){
        		str = str.replaceFirst("#TAR-PEN#"," ");
        	}
        	else{
        		String reemplazado = ListaTareas.replaceAll("#USUARIO#",getNombreUsuario(tar,usuario));
        		str = str.replaceFirst("#USUARIO#",getNombreUsuario(tar,usuario));
        		str = str.replaceFirst("#TAR-PEN#",reemplazado);
        	}
        	Mensaje = Mensaje.concat(str);
        	str = "";
	        
	        message1.setContent(Mensaje,"text/html;charset=iso-8859-1");
	       
	        sendMessageThread();
	        setErrorMessage(OkMensaje);
	      }
			
	      catch (Exception e) {
	      	setErrorMessage(ErrorMensaje);
	      	System.out.println("error:: "+e);
	      }
	      
	}/**Fin de NotificacionUsuarioAsignacion*/
	//movimiento cambio de estado de pendiente a asignado
	public void NotificacionUsuarioAsignacion(Session conn,D7Tareas tar){
		tar.setTarCod(codigoTarea);
		int numPeticiones = 0;
		int numIncidencias = 0;
		
		this.ActualizaParametros(conn);
		
		try{
			
			Query q = conn.createQuery(getQuery("TareasAux"));
			//System.out.println(q);
			q = q.setString("sist",user.getDatosMenu().idSelected());
			q = q.setString("cod",codigoTarea.toString());
			tar = (D7Tareas)q.list().get(0);
				
			this.QueryTiposTareas(conn,tar);
			this.QueryAplicaciones(conn,tar);
			this.QueryPrioridades(conn,tar);
			this.QueryDatosInformatico(conn,tar);
			this.QueryDatosUsuario(conn,tar);
			this.QueryTareasMovimientosEst(conn,tar,D7TareasMovimientos.ASIGNAR_TAREA);

			/**Conseguimos el numero de incidencias y peticiones pendientes asociadas a un informtico*/
			/*
			Iterator itt = this.QueryTareasInformatico(conn,tar).iterate();
			while(itt.hasNext()){
				D7Tareas aux = (D7Tareas)itt.next();
				if(aux.getTarTipCod().equals(D7TiposTareas.PETICION)){
					numPeticiones = new Integer(numPeticiones.intValue()+1);
				}
				if(aux.getTarTipCod().equals(D7TiposTareas.INCIDENCIA)){
					numIncidencias = new Integer(numIncidencias.intValue()+1);
				}
			}
			*/
			numPeticiones = this.QueryTareasInformatico(conn,tar,D7TiposTareas.PETICION);
			numIncidencias = this.QueryTareasInformatico(conn,tar,D7TiposTareas.INCIDENCIA);
			this.setNotUsu(true);
			/**Introduce en Subject del E-mail e indica el nombre del archivo(PLANTILLA) que hay que leer*/
			this.ConfiguraMailYFichero("[dumbo] Notificacion de asignacion de tarea "+resumenTarea(tar),"NotUsuAsig.html",getCorreoUsuario(tar,usuario), conn);
			
        	str = str.replaceFirst("#IMAGEN#",DirImagenes.concat("NotInfAsig.gif"));
        	str = str.replaceFirst("#PIE#",Pie);
//        	sonia
        	str = str.replaceFirst("#DIR-PIE#",Pie1);
        	//fin sonia
        	if (Icono.equals("N")){str = str.replaceFirst("visibility: visible","visibility: hidden");}
        	if (Color.equals("N")){str = str.replaceFirst("background-color: #FFFF00","background-color: #FFFFFF");}
        	
        	if(tar.getTarPriCod()!=null){
	        	if(tar.getTarPriCod().equals(D7Prioridades.PLANIFICACION)){
	        		str = str.replaceFirst("#TAREA#","Programada");
	        	}
	        	else{
	        		str = str.replaceFirst("#TAREA#"," ");
	        	}
        	}
        	else{
        		str = str.replaceFirst("#TAREA#"," ");
        	}
        	str = str.replaceAll("#INC-PET#",TipoTar.getTipDescrip().replaceAll("", "&oacute;"));
        	str = str.replaceAll("#NUM#",codigoTarea(tar));
        	str = str.replaceFirst("#USUARIO#",getNombreUsuario(tar,usuario));
        	str = str.replaceAll("#INFORMATICO#",(informatico.getDatNombre()+" "+informatico.getDatApellidos()));
        	str = str.replaceFirst("#APLICACION#",Apli.getAplDescrip());
        	str = str.replaceFirst("#ASUNTO#",tar.getTarAsunto());
           	str = str.replaceFirst("#TEXTO#","<PRE>"+tar.getTarDescrip().replaceAll("<", "&lt;")+"</PRE>");
        	if(Tareas.equals("N")){
        		str = str.replaceFirst("#TAR-PEN#"," ");
        	}
        	else{
        		//String reemplazado = ListaTareas.replaceFirst("#WORDINF#",user.traduce("dumbo7/administracion/aplicaciones","inform&aacute;tico",user.getDatosMenu().idSelected())); 
				//reemplazado = reemplazado.replaceAll("#NUM-PET#",new Integer(numPeticiones).toString());
        		//Aadido por Sonia
        		String reemplazado = ListaTareas.replaceAll("#NUM-PET#",new Integer(numPeticiones).toString());
        		//Fin de aadido por Sonia
        		reemplazado = reemplazado.replaceAll("#NUM-INC#",new Integer(numIncidencias).toString());
        		reemplazado = reemplazado.replaceAll("#INFORMATICO#",(informatico.getDatNombre()+" "+informatico.getDatApellidos()));
        		reemplazado = reemplazado.replaceAll("#USUARIO#",getNombreUsuario(tar,usuario));
        		if(numIncidencias == 1)
        		{
        			reemplazado = reemplazado.replaceAll("#incidenciaPLURAL#","incidencia");
        		}
        		else
        		{
        			reemplazado = reemplazado.replaceAll("#incidenciaPLURAL#","incidencias");
        		}
        		
        		if(numPeticiones == 1)
        		{
        			reemplazado = reemplazado.replaceAll("#peticionPLURAL#","petici&oacute;n");
        		}
        		else
        		{
        			reemplazado = reemplazado.replaceAll("#peticionPLURAL#","peticiones");
        		}
        		str = str.replaceFirst("#USUARIO#",getNombreUsuario(tar,usuario));
	        	str = str.replaceAll("#INFORMATICO#",(informatico.getDatNombre()+" "+informatico.getDatApellidos()));
        		str = str.replaceFirst("#TAR-PEN#",reemplazado);
        	}
        	Mensaje = Mensaje.concat(str);
        	str = "";
	        
	        message1.setContent(Mensaje,"text/html;charset=iso-8859-1");
	       
	        sendMessageThread();
	        setErrorMessage(OkMensaje);
	      }
			
	      catch (Exception e) {
	      	setErrorMessage(ErrorMensaje);
	      	System.out.println("error:: "+e);
	      }
	      
	}/**Fin de NotificacionUsuarioAsignacion*/
	//movimiento por cambio de estado
	public void NotificacionUsuarioEspera(Session conn,D7Tareas tar){
		
		this.ActualizaParametros(conn);
			
		try{
		Query q = conn.createQuery(getQuery("TareasAux"));
		q = q.setString("sist",user.getDatosMenu().idSelected());
		q = q.setString("cod",codigoTarea.toString());
		tar = (D7Tareas)q.list().get(0);
		
		
		
		this.QueryAplicaciones(conn,tar);
		this.QueryTiposTareas(conn,tar);
		this.QueryTareasMovimientosEst(conn,tar,D7TareasMovimientos.PASAR_WAITING); //movimiento por cambio de estado
		//this.QueryTareasMovimientosInf(conn,tar);
		//this.QueryTareasMovimientosUsu(conn,tar);
		//this.QueryTareasSeguimientos(conn,tar);
		this.QueryPrioridades(conn,tar);
		this.QueryDatosInformatico(conn,tar);
		this.QueryDatosUsuario(conn,tar);
	
		this.setNotUsu(true);
		/**Introduce en Subject del E-mail y indica el nombre del archivo(PLANTILLA) que hay que leer*/
		this.ConfiguraMailYFichero("[dumbo] Notificacion paso de tarea a espera. "+resumenTarea(tar),"NotUsuEsp.html",getCorreoUsuario(tar,usuario), conn);
		
		 String urlPinche = createUrlPincheAqui(conn,tar.getTarCod(),PAQ_ESPERA_TAREA);

        	str = str.replaceFirst("#IMAGEN#",DirImagenes.concat("NotUsuEsp.gif"));
        	str = str.replaceFirst("#PIE#",Pie);
//        	sonia
        	str = str.replaceFirst("#DIR-PIE#",Pie1);
        	//fin sonia
        	str = str.replaceFirst("#PINCHE#",urlPinche);
        	if (Icono.equals("N")){str = str.replaceFirst("visibility: visible","visibility: hidden");}
        	if (Color.equals("N")){str = str.replaceFirst("background-color: #FF0000","background-color: #FFFFFF");}
        	if(tar.getTarPriCod()!=null){
	        	if(tar.getTarPriCod().equals(D7Prioridades.PLANIFICACION)){
	        		str = str.replaceFirst("#TAREA#","Programada");
	        	}
        	
	        	else{
	        		str = str.replaceFirst("#TAREA#"," ");
	        	}
        	}	
        	else{
        		str = str.replaceFirst("#TAREA#"," ");
        	}
        	str = str.replaceAll("#INC-PET#",TipoTar.getTipDescrip().replaceAll("", "&oacute;"));
        	str = str.replaceAll("#NUM#",codigoTarea(tar));
        	str = str.replaceAll("#INFORMATICO#",(informatico.getDatNombre()+" "+informatico.getDatApellidos()));
        	//mostramos la fecha del ultimo movimiento
        	if(tarMovE!=null){
        		Date t=tarMovE.getTmoFechaMov();
        		str = str.replaceFirst("#FECHA-ESP#",this.getFecha(t));
        		str = str.replaceFirst("#TEX-ESP#","<PRE>"+tarMovE.getTmoDescripMov()+"</PRE>");
        	}
        	if(tarMovE==null){
	        	str = str.replaceFirst("#FECHA-ESP#","-");
	        	str = str.replaceFirst("#TEX-ESP#","-");
        	}
        	
        	str = str.replaceFirst("#APLICACION#",Apli.getAplDescrip());
        	str = str.replaceFirst("#ASUNTO#",tar.getTarAsunto());
        	str = str.replaceFirst("#TEXTO#","<PRE>"+tar.getTarDescrip().replaceAll("<", "&lt;")+"</PRE>");
        	//System.out.println(str);
        	Mensaje = Mensaje.concat(str);
        	str = "";
	        
        	message1.setContent(Mensaje,"text/html;charset=iso-8859-1");
	        sendMessageThread();
	        setErrorMessage(OkMensaje);
	      }
	      catch (Exception e) {
	      	setErrorMessage(ErrorMensaje);
	      	e.printStackTrace();
	     	System.out.println("error:::"+e);
	      }
	          
	}/**Fin de NotificacionUsuarioEspera*/
	//movimiento cambio de estado  a anulado
	public void NotificacionUsuarioAnulacion(Session conn,D7Tareas tar)
	{
		this.ActualizaParametros(conn);
		try
		{
			Query q = conn.createQuery(getQuery("TareasAux"));
			q = q.setString("sist",user.getDatosMenu().idSelected());
			q = q.setString("cod",codigoTarea.toString());
			tar = (D7Tareas)q.list().get(0);
			
			
			this.QueryAplicaciones(conn,tar);
			this.QueryTiposTareas(conn,tar);
			this.QueryDatosInformatico(conn,tar);
			this.QueryDatosUsuario(conn,tar);
			//this.QueryTareasSeguimientos(conn,tar);
			this.QueryTareasMovimientosEst(conn,tar,D7TareasMovimientos.ANULAR_TAREA);
			
			this.setNotUsu(true);
			/**Introduce en Subject del E-mail y indica el nombre del archivo(PLANTILLA) que hay que leer*/
			this.ConfiguraMailYFichero("[dumbo] Notificacion anulacion tarea "+resumenTarea(tar),"NotUsuAnu.html",getCorreoUsuario(tar,usuario), conn);
			String urlPinche = createUrlPincheAqui(conn,tar.getTarCod(),PAQ_ANULAR_TAREA);
			   
			str = str.replaceFirst("#IMAGEN#",DirImagenes.concat("NotUsuAnu.gif"));
			str = str.replaceFirst("#PIE#",Pie);
//			sonia
        	str = str.replaceFirst("#DIR-PIE#",Pie1);
        	//fin sonia
			if (Icono.equals("N")){str = str.replaceFirst("visibility: visible","visibility: hidden");}
			if (Color.equals("N")){str = str.replaceFirst("background-color: #832C83","background-color: #FFFFFF");}
			
			str = str.replaceAll("#INC-PET#",TipoTar.getTipDescrip().replaceAll("", "&oacute;"));
			str = str.replaceAll("#NUM#",codigoTarea(tar));
			str = str.replaceFirst("#APLICACION#",Apli.getAplDescrip());
			str = str.replaceAll("#INFORMATICO#",(informatico.getDatNombre()+" "+informatico.getDatApellidos()));
			str = str.replaceFirst("#ASUNTO#",tar.getTarAsunto());
			str = str.replaceFirst("#TEXTO#","<PRE>"+tar.getTarDescrip().replaceAll("<", "&lt;")+"</PRE>");
			str = str.replaceFirst("#PINCHE#",urlPinche);
			
			//mostramos la fecha del ultimo movimiento
			if(tarMovE!=null)
				str = str.replaceFirst("#TEX-ANU#","<PRE>"+tarMovE.getTmoDescripMov()+"</PRE>");
			if(tarMovE==null)
				str = str.replaceFirst("#TEX-ANU#","-"); 	
			
			Mensaje = Mensaje.concat(str);
			str = "";
	
			message1.setContent(Mensaje,"text/html;charset=iso-8859-1");
			sendMessageThread();
			setErrorMessage(OkMensaje);
		}
		catch (Exception e)
		{
			setErrorMessage(ErrorMensaje);
	      	System.out.println("error;"+e);
	    } 
	}/**Fin de NotificacionUsuarioAnulacion*/
 	//movimiento cambio informatico
	//movimiento cambio informatico
	public void NotificacionUsuarioReasignacion(Session conn,D7Tareas tar){	
		int numPeticiones = 0;
		int numIncidencias = 0;
		try{
			Query q = conn.createQuery(getQuery("TareasAux"));
			q = q.setString("sist",user.getDatosMenu().idSelected());
			q = q.setString("cod",codigoTarea.toString());
			tar = (D7Tareas)q.list().get(0);
			
		
		this.ActualizaParametros(conn);
		this.QueryTiposTareas(conn,tar);
		this.QueryAplicaciones(conn,tar);
		this.QueryPrioridades(conn,tar);
		this.QueryDatosInformatico(conn,tar);
		this.QueryDatosUsuario(conn,tar);
		this.QueryTareasMovimientosInf(conn,tar);

		/**Conseguimos el numero de incidencias y peticiones pendientes asociadas a un informtico*/
		/*
		Iterator itt = this.QueryTareasInformatico(conn,tar).iterate();
		while(itt.hasNext()){
			D7Tareas aux = (D7Tareas)itt.next();
			if(aux.getTarTipCod().equals(D7TiposTareas.PETICION)){
				numPeticiones = new Integer(numPeticiones.intValue()+1);
			}
			if(aux.getTarTipCod().equals(D7TiposTareas.INCIDENCIA)){
				numIncidencias = new Integer(numIncidencias.intValue()+1);
			}
		}
		*/
		numPeticiones = this.QueryTareasInformatico(conn,tar,D7TiposTareas.PETICION);
		numIncidencias = this.QueryTareasInformatico(conn,tar,D7TiposTareas.INCIDENCIA);

		this.setNotUsu(true);
		/**Introduce en Subject del E-mail y indica el nombre del archivo(PLANTILLA) que hay que leer*/
		this.ConfiguraMailYFichero("[dumbo] Reasignacion de tarea "+resumenTarea(tar),"NotUsuReas.html",getCorreoUsuario(tar,usuario), conn);
	      	      
        	str = str.replaceFirst("#IMAGEN#",DirImagenes.concat("NotUsuReas.gif"));
        	str = str.replaceFirst("#PIE#",Pie);
//        	sonia
        	str = str.replaceFirst("#DIR-PIE#",Pie1);
        	//fin sonia
        	if (Icono.equals("N")){str = str.replaceFirst("visibility: visible","visibility: hidden");}
        	if (Color.equals("N")){str = str.replaceFirst("background-color: #00FFFF","background-color: #FFFFFF");}
        	
        	
        	if(tar.getTarPriCod()!=null){
	        	if(tar.getTarPriCod().equals(D7Prioridades.PLANIFICACION)){
	        		str = str.replaceFirst("#TAREA#","Programada");
	        	}
        	
	        	else{
	        		str = str.replaceFirst("#TAREA#"," ");
	        	}
        	}
        	else{
        		str = str.replaceFirst("#TAREA#"," ");
        	}
        	str = str.replaceAll("#INC-PET#",TipoTar.getTipDescrip().replaceAll("", "&oacute;"));
        	str = str.replaceAll("#NUM#",codigoTarea(tar));
        	str = str.replaceAll("#USUARIO#",((dumbo7.user.DumboUser)user).getNombre()+" "+((dumbo7.user.DumboUser)user).getApellidos());
        	str = str.replaceAll("#INFORMATICO#",(informatico.getDatNombre()+" "+informatico.getDatApellidos()));
        	str = str.replaceFirst("#APLICACION#",Apli.getAplDescrip());
        	str = str.replaceFirst("#ASUNTO#",tar.getTarAsunto());
        	str = str.replaceFirst("#TEXTO#","<PRE>"+tar.getTarDescrip().replaceAll("<", "&lt;")+"</PRE>");
        	
        	if(Tareas.equals("N")){
        		str = str.replaceFirst("#TAR-PEN#"," ");
        	}
        	else{
        		String reemplazado = ListaTareas.replaceFirst("#WORDINF#",user.traduce("dumbo7/administracion/aplicaciones","inform&aacute;tico",user.getDatosMenu().idSelected())); 
				reemplazado = reemplazado.replaceAll("#NUM-PET#",new Integer(numPeticiones).toString());
        		reemplazado = reemplazado.replaceAll("#NUM-INC#",new Integer (numIncidencias).toString());
        		reemplazado = reemplazado.replaceAll("#INFORMATICO#",(informatico.getDatNombre()+" "+informatico.getDatApellidos()));
        		if(numIncidencias == 1)
        		{
        			reemplazado = reemplazado.replaceAll("#incidenciaPLURAL#","incidencia");
        		}
        		else
        		{
        			reemplazado = reemplazado.replaceAll("#incidenciaPLURAL#","incidencias");
        		}
        		
        		if(numPeticiones == 1)
        		{
        			reemplazado = reemplazado.replaceAll("#peticionPLURAL#","petici&oacute;n");
        		}
        		else
        		{
        			reemplazado = reemplazado.replaceAll("#peticionPLURAL#","peticiones");
        		}
        		str = str.replaceFirst("#TAR-PEN#",reemplazado);
        	}
        	//System.out.println(str);
           	Mensaje = Mensaje.concat(str);
        	str = "";
	        
        	message1.setContent(Mensaje,"text/html;charset=iso-8859-1");
	        sendMessageThread();
	        setErrorMessage(OkMensaje);
	      }
	      catch (Exception e) {
	      	setErrorMessage(ErrorMensaje);
	      }
	     
	      
	}/**Fin de NotificacionUsuarioReasignacion*/
	//movimiento cambio estado de espera a asignado
	//movimiento cambio estado 
	public void NotificacionUsuarioReactivacion(Session conn,D7Tareas tar){	
		int numPeticiones = 0;
		int numIncidencias = 0;
		try{
			Query q = conn.createQuery(getQuery("TareasAux"));
			q = q.setString("sist",user.getDatosMenu().idSelected());
			q = q.setString("cod",codigoTarea.toString());
			tar = (D7Tareas)q.list().get(0);
			
		this.ActualizaParametros(conn);
		this.QueryTiposTareas(conn,tar);
		this.QueryAplicaciones(conn,tar);
		this.QueryPrioridades(conn,tar);
		this.QueryDatosInformatico(conn,tar);
		this.QueryDatosUsuario(conn,tar);
		this.QueryTareasMovimientosEst(conn,tar,D7TareasMovimientos.PASAR_NOWAITING);

		/**Conseguimos el numero de incidencias y peticiones pendientes asociadas a un informtico*/
		/*
		Iterator itt = this.QueryTareasInformatico(conn,tar).iterate();
		while(itt.hasNext()){
			D7Tareas aux = (D7Tareas)itt.next();
			if(aux.getTarTipCod().equals(D7TiposTareas.PETICION)){
				numPeticiones = new Integer(numPeticiones.intValue()+1);
			}
			if(aux.getTarTipCod().equals(D7TiposTareas.INCIDENCIA)){
				numIncidencias = new Integer(numIncidencias.intValue()+1);
			}
		}
		*/
		numPeticiones = this.QueryTareasInformatico(conn,tar,D7TiposTareas.PETICION);
		numIncidencias = this.QueryTareasInformatico(conn,tar,D7TiposTareas.INCIDENCIA);
		
		this.setNotUsu(true);
		/**Introduce en Subject del E-mail y indica el nombre del archivo(PLANTILLA) que hay que leer*/
		this.ConfiguraMailYFichero("[dumbo] Notificacion de reactivacion de tarea en espera "+resumenTarea(tar),"NotUsuReac.html",getCorreoUsuario(tar,usuario), conn);
		 
	        	      	      

        	str = str.replaceFirst("#IMAGEN#",DirImagenes.concat("NotUsuReac.gif"));
        	str = str.replaceFirst("#PIE#",Pie);
//        	sonia
        	str = str.replaceFirst("#DIR-PIE#",Pie1);
        	//fin sonia
        	if (Icono.equals("N")){str = str.replaceFirst("visibility: visible","visibility: hidden");}
        	if (Color.equals("N")){str = str.replaceFirst("background-color: #FFFF00","background-color: #FFFFFF");}
        	if(tar.getTarPriCod()!=null){
	        	if(tar.getTarPriCod().equals(D7Prioridades.PLANIFICACION)){
	        		str = str.replaceFirst("#TAREA#","Programada");
	        	}
        	
	        	else{
	        		str = str.replaceFirst("#TAREA#"," ");
	        	}
        	}	
        	else{
        		str = str.replaceFirst("#TAREA#"," ");
        	}
        	str = str.replaceAll("#INC-PET#",TipoTar.getTipDescrip().replaceAll("", "&oacute;"));
        	str = str.replaceAll("#NUM#",codigoTarea(tar));
        	//texto del ultimo seguimiento
        	if(tarMovE!=null)
        		str = str.replaceAll("#TEX-REAC#","<PRE>"+tarMovE.getTmoDescripMov()+"</PRE>");
	        if(tarMovE==null)
	        	str = str.replaceAll("#TEX-REAC#","-");
        	
        	str = str.replaceAll("#INFORMATICO#",(informatico.getDatNombre()+" "+informatico.getDatApellidos()));
        	str = str.replaceFirst("#APLICACION#",Apli.getAplDescrip());
        	str = str.replaceFirst("#ASUNTO#",tar.getTarAsunto());
        	str = str.replaceFirst("#TEXTO#","<PRE>"+tar.getTarDescrip().replaceAll("<", "&lt;")+"</PRE>");
        	
        	if(Tareas.equals("N")){
        		str = str.replaceFirst("#TAR-PEN#"," ");
        	}
        	else{
        		String reemplazado = ListaTareas.replaceFirst("#WORDINF#",user.traduce("dumbo7/administracion/aplicaciones","inform&aacute;tico",user.getDatosMenu().idSelected()));
        		reemplazado = reemplazado.replaceAll("#NUM-PET#",new Integer(numPeticiones).toString());
        		reemplazado = reemplazado.replaceAll("#NUM-INC#",new Integer(numIncidencias).toString());
        		reemplazado = reemplazado.replaceAll("#INFORMATICO#",(informatico.getDatNombre()+" "+informatico.getDatApellidos()));
        		if(numIncidencias == 1)
        		{
        			reemplazado = reemplazado.replaceAll("#incidenciaPLURAL#","incidencia");
        		}
        		else
        		{
        			reemplazado = reemplazado.replaceAll("#incidenciaPLURAL#","incidencias");
        		}
        		
        		if(numPeticiones == 1)
        		{
        			reemplazado = reemplazado.replaceAll("#peticionPLURAL#","petici&oacute;n");
        		}
        		else
        		{
        			reemplazado = reemplazado.replaceAll("#peticionPLURAL#","peticiones");
        		}
        		str = str.replaceFirst("#TAR-PEN#",reemplazado);
        	}
        	//System.out.println(str);
           	Mensaje = Mensaje.concat(str);
        	str = "";

        	message1.setContent(Mensaje,"text/html;charset=iso-8859-1");
	        sendMessageThread();
	        setErrorMessage(OkMensaje);
	      }
	      catch (Exception e) {
	      	setErrorMessage(ErrorMensaje);
	      }
	     
	     
	}/**Fin de NotificacionUsuarioReactivacin*/
	//movimiento cambio de estado  a resuelto
	public void NotificacionUsuarioResolucion(Session conn,D7Tareas tar,String [] copia){
		setCopiaEspecial(copia);
		NotificacionUsuarioResolucion(conn,tar);
	}
	public void NotificacionUsuarioResolucion(Session conn,D7Tareas tar){
		
		
		this.ActualizaParametros(conn);
		try{
			Query q = conn.createQuery(getQuery("TareasAux"));
			q = q.setString("sist",user.getDatosMenu().idSelected());
			q = q.setString("cod",codigoTarea.toString());
			tar = (D7Tareas)q.list().get(0);

			this.QueryCategoria(conn,tar);
			this.QueryAplicaciones(conn,tar);
			this.QueryTiposTareas(conn,tar);
			this.QueryPrioridades(conn,tar);
			//this.QueryTareasSeguimientos(conn,tar);
			this.QueryDatosInformatico(conn,tar);
			this.QueryDatosUsuario(conn,tar);
			this.QueryTareasMovimientosEst(conn,tar,D7TareasMovimientos.FINALIZAR_TAREA);
			
			this.setNotUsu(true);
		
			/**Introduce en Subject del E-mail y indica el nombre del archivo(PLANTILLA) que hay que leer*/
			//this.ConfiguraMailYFichero("[dumbo] Resolucion de tarea "+resumenTarea(tar),"NotUsuReso.html",getCorreoUsuario(tar,usuario), conn);
			this.ConfiguraMailYFichero("[dumbo] Resolucion de tarea "+resumenTarea(tar),"NotUsuReso.html",getCorreoUsuario(tar,usuario), conn);
			if (Apli.getAplTipoAsig().equals("R") && (Apli.getAplCorreoResp()!=null && Apli.getAplCorreoResp().equals(D7Aplicaciones.CORREO_RESP))) {
				Iterator it = Apli.getInformaticos().iterator();
				D7AplicacionesInformaticos responsable = null;
				int i = 0;
				while (it.hasNext()) {
					D7AplicacionesInformaticos ain = (D7AplicacionesInformaticos)it.next();
					if (ain.getAinResponsable().equals(D7AplicacionesInformaticos.RESPONSABLE) && ain.getInformatico().getInfEstado().equals("V")){
						if (i==0){
							responsable = ain;//Para que la primera vez meta el primero
							i=i+1;
						}
						if (ain.getAinPrioridad().intValue() < responsable.getAinPrioridad().intValue())
							responsable = ain;
					}
				}
				if ((responsable!=null) && !responsable.getAinInfCod().equals(tar.getTarUsuCod()) && !responsable.getAinInfCod().equals(tar.getTarInfCod()))
					message1.addRecipient(Message.RecipientType.CC, new InternetAddress(D7Conversor.convierteIdentificador(conn,responsable.getAinInfCod())));
			}
			String urlPinche = createUrlPincheAqui(conn,tar.getTarCod(),PAQ_RESOLUCION_TAREA);
			
			str = str.replaceFirst("#INFORMATICO#",(informatico.getDatNombre()+" "+informatico.getDatApellidos()));
        	str = str.replaceFirst("#IMAGEN#",DirImagenes.concat("NotUsuReso.gif"));
        	str = str.replaceFirst("#PIE#",Pie);
//        	sonia
        	str = str.replaceFirst("#DIR-PIE#",Pie1);
        	//fin sonia
        	if (Icono.equals("N")){str = str.replaceFirst("visibility: visible","visibility: hidden");}
        	if (Color.equals("N")){str = str.replaceFirst("background-color: #00FF00","background-color: #FFFFFF");}
        	if(tar.getTarPriCod()!=null){
	        	if(tar.getTarPriCod().equals(D7Prioridades.PLANIFICACION)){
	        		str = str.replaceFirst("#TAREA#","Programada");
	        	}
        	
	        	else{
	        		str = str.replaceFirst("#TAREA#"," ");
	        	}
        	}	
        	else{
        		str = str.replaceFirst("#TAREA#"," ");
        	}
        	str = str.replaceAll("#INC-PET#",TipoTar.getTipDescrip().replaceAll("", "&oacute;"));
        	str = str.replaceAll("#NUM#",codigoTarea(tar));
        	str = str.replaceFirst("#APLICACION#",Apli.getAplDescrip());
        	str = str.replaceFirst("#ASUNTO#",tar.getTarAsunto());
        	str = str.replaceFirst("#TEXTO#","<PRE>"+tar.getTarDescrip().replaceAll("<", "&lt;")+"</PRE>");
        	str = str.replaceFirst("#CATEGORIA#",categorias.getCatDescrip());
        	str = str.replaceFirst("#PINCHE#",urlPinche);
        	//mostramos la fecha del ultimo movimiento
        	
        	if(tarMovE!=null)
        		str = str.replaceFirst("#TEX-RESOL#","<PRE>"+tarMovE.getTmoDescripMov()+"</PRE>");
	        if(tarMovE==null)
	        	str = str.replaceFirst("#TEX-RESOL#","-");
        	
	        
        	if(tar.getTarCosteEco()!=null) {
        		double f = (tar.getTarHorasRes().floatValue()-Math.floor(tar.getTarHorasRes().floatValue()))*6000;
        		str = str.replaceFirst("#HORAS#",Math.round(Math.floor(tar.getTarHorasRes().floatValue()))+" h y "+Math.round(f/100)+" m.");
        	}
        	if(tar.getTarCosteEco()== null)
        		str = str.replaceFirst("#HORAS#","-");
        	String txtCst = "";
        	if (Coste!=null && Coste.equals("S")) {
        		txtCst = "Teniendo un coste estimado de #COSTE# Euros.";
        		if(tar.getTarCosteEco()!=null)
        			txtCst = txtCst.replaceFirst("#COSTE#",tar.getTarCosteEco().toString());
        		if(tar.getTarCosteEco()==null)
        			txtCst = txtCst.replaceFirst("#COSTE#","-");
        		if(tar.getTarCosteMat()!=null)
        			txtCst += " Y un coste en materiales de "+tar.getTarCosteMat().toString()+" Euros.";
        	}
        	str = str.replaceFirst("#COSTE#",txtCst);
        	Mensaje = Mensaje.concat(str);
        	str = "";

        	File dir = new File(rutaAnexos);
        	findTarea = ""+tar.getTarCod();
        	padreTarea = ""+tar.getTarPadreTarCod();
        	File lista [] = dir.listFiles(this);
        	if (lista!=null && lista.length>0) {
        		String tarCode = ""+tar.getTarCod();
        		int lastMod = 0;
        		for (int k=0; k<lista.length; k++) {
        			if (lista[k].lastModified()>=lista[lastMod].lastModified()) {
        				if (lastMod!=0) lista[lastMod].delete();
        				lastMod = k;
        				tarCode = lista[k].getName().substring(lista[k].getName().indexOf(GestorGenerico.UPLOAD_SEPARATOR)+1,lista[k].getName().lastIndexOf(GestorGenerico.UPLOAD_SEPARATOR));
        				String realName = lista[k].getName().substring(lista[k].getName().lastIndexOf(GestorGenerico.UPLOAD_SEPARATOR)+1);
        				String newName = lista[k].getAbsolutePath().replaceFirst(AnexoTarea.FINALIZADO+GestorGenerico.UPLOAD_PREFIX,AnexoTarea.PUBLICO+GestorGenerico.UPLOAD_PREFIX);
        				File fnm = new File(newName);
        				int copia = 1;
        				while (fnm.exists()) {
        					if (copia>1) newName = newName.replaceFirst("Copia "+(copia-1)+" de","Copia "+copia+" de");
        					else newName = newName.replaceFirst(realName,"Copia "+copia+" de "+realName);
        					fnm = new File(newName); copia++;
        				}
        				lista[k].renameTo(fnm);
        			} else lista[k].delete();
        		}
	            anxFile = new File(rutaAnexos+GestorGenerico.getPrefijoZip(tarCode)+"Anexo.zip");
	            if (!anxFile.exists() || anxFile.length()>MAXIMO_POR_CORREO) message1.setContent(Mensaje,"text/html;charset=iso-8859-1");
	            else {
	    	        Multipart multipart = new MimeMultipart();
	    	        BodyPart messageBodyPart = new MimeBodyPart();
	    	        //messageBodyPart.setContent(Mensaje,"text/html;charset=ISO-8859-1;");
	    	        messageBodyPart.setContent(Mensaje,"text/html;charset=iso-8859-1");
	    	        multipart.addBodyPart(messageBodyPart);
	
	    	        messageBodyPart = new MimeBodyPart();
	    	        DataSource source = new FileDataSource(anxFile);
	    	        messageBodyPart.setDataHandler(new DataHandler(source));
	    	        messageBodyPart.setFileName(anxFile.getName());
	    	        multipart.addBodyPart(messageBodyPart);
	    	        message1.setContent(multipart);
	            }
        	} else message1.setContent(Mensaje,"text/html;charset=iso-8859-1"); 
	        
	        sendMessageThread();
	        
	        setErrorMessage(OkMensaje);
	      }
	      catch (Exception e) {
	      	setErrorMessage(ErrorMensaje);
	      	e.printStackTrace();
	      }
	         
	}/**Fin de NotificacionUsuarioResolucin*/
	//ok
	public void NotificacionUsuarioResolucionTelefonica(Session conn, D7Tareas tar)
	{
		  this.ActualizaParametros(conn);
		  try
		  {
			  Query q = conn.createQuery(getQuery("TareasAux"));
			  q = q.setString("sist",user.getDatosMenu().idSelected());
			  q = q.setString("cod",codigoTarea.toString());
			  tar = (D7Tareas)q.list().get(0);
			  
			  this.QueryAplicaciones(conn,tar);
			  this.QueryTiposTareas(conn,tar);
			  this.QueryDatosInformatico(conn,tar);
			  this.QueryDatosUsuario(conn,tar);
			  //this.QueryTareasSeguimientos(conn,tar);
			  this.QueryTareasMovimientosEst(conn,tar,D7TareasMovimientos.FINALIZAR_TAREA);
			  
			  this.setNotUsu(true);
			  /**Introduce en Subject del E-mail y indica el nombre del archivo(PLANTILLA) que hay que leer*/
			  this.ConfiguraMailYFichero("[dumbo] Resolucion dumbo telefonico "+resumenTarea(tar),"NotUsuResoTlf.html",getCorreoUsuario(tar,usuario), conn);
			  
			        
			  str = str.replaceFirst("#INFORMATICO#",(informatico.getDatNombre()+" "+informatico.getDatApellidos()));
	          str = str.replaceFirst("#IMAGEN#",DirImagenes.concat("NotUsuResoTlf.gif"));
	          str = str.replaceFirst("#PIE#",Pie);
	          // sonia
	          str = str.replaceFirst("#DIR-PIE#",Pie1);
	          //fin sonia
	          if (Icono.equals("N")){str = str.replaceFirst("visibility: visible","visibility: hidden");}
	          if (Color.equals("N")){str = str.replaceFirst("background-color: #00FF00","background-color: #FFFFFF");}
	          
	          str = str.replaceAll("#INC-PET#",TipoTar.getTipDescrip().replaceAll("", "&oacute;"));
	          str = str.replaceAll("#NUM#",codigoTarea(tar));
	          str = str.replaceFirst("#APLICACION#",Apli.getAplDescrip());
	          str = str.replaceFirst("#ASUNTO#",tar.getTarAsunto());
	          str = str.replaceFirst("#TEXTO#","<PRE>"+tar.getTarDescrip().replaceAll("<", "&lt;")+"</PRE>");
	 
	          //mostramos la resolucion de la tarea dumbo
	          if(tarMovE!=null)
	           str = str.replaceFirst("#TEX-RESOL#","<PRE>"+tarMovE.getTmoDescripMov()+"</PRE>");
	          if(tarMovE==null)
	           str = str.replaceFirst("#TEX-RESOL#","-");
	          
	          //System.out.println(str);
	          Mensaje = Mensaje.concat(str);
	          str = "";
	      
	          message1.setContent(Mensaje,"text/html;charset=iso-8859-1");
	         sendMessageThread();
	         setErrorMessage(OkMensaje);
		  }
		  catch (Exception e)
		  {
		  		setErrorMessage(ErrorMensaje);
		        e.printStackTrace();
		  }          
	}/**Fin de NotificacionUsuarioResolucinTelefonica*/

	//movimiento cambio informatico
	public void NotificacionUsuarioPlanificacion(Session conn,D7Tareas tar)
	{
		this.ActualizaParametros(conn);
		try
		{
			Query q = conn.createQuery(getQuery("TareasAux"));
			q = q.setString("sist",user.getDatosMenu().idSelected());
			q = q.setString("cod",codigoTarea.toString());
			tar = (D7Tareas)q.list().get(0);
			
			this.QueryAplicaciones(conn,tar);
			this.QueryTiposTareas(conn,tar);
			this.QueryPrioridades(conn,tar);
			this.QueryDatosInformatico(conn,tar);
			this.QueryDatosUsuario(conn,tar);
		
			this.setNotUsu(true);
		 	/**Introduce en Subject del E-mail e indica el nombre del archivo(PLANTILLA) que hay que leer*/
			this.ConfiguraMailYFichero("[dumbo] Notificacion de planificacion de tarea "+resumenTarea(tar),"NotUsuPlanif.html",getCorreoUsuario(tar,usuario), conn);
	    
		  	String urlPinche = createUrlPincheAqui(conn,tar.getTarCod(),PAQ_PLANIFICAR_TAREA);     
	        
        	str = str.replaceFirst("#IMAGEN#",DirImagenes.concat("NotUsuPlanif.gif"));
        	str = str.replaceFirst("#PIE#",Pie);
//        	sonia
        	str = str.replaceFirst("#DIR-PIE#",Pie1);
        	//fin sonia
        	if (Icono.equals("N")){str = str.replaceFirst("visibility: visible","visibility: hidden");}
        	if (Color.equals("N")){str = str.replaceFirst("background-color: #FF00FF","background-color: #FFFFFF");}
        	
        	str = str.replaceAll("#INC-PET#",TipoTar.getTipDescrip().replaceAll("", "&oacute;"));
        	str = str.replaceAll("#NUM#",codigoTarea(tar));
        	str = str.replaceFirst("#APLICACION#",Apli.getAplDescrip());
        	str = str.replaceFirst("#ASUNTO#",tar.getTarAsunto());
        	str = str.replaceFirst("#INFORMATICO#",(informatico.getDatNombre()+" "+informatico.getDatApellidos()));
        	str = str.replaceFirst("#TEXTO#","<PRE>"+tar.getTarDescrip().replaceAll("<", "&lt;")+"</PRE>");
        	str = str.replaceFirst("#PINCHE#",urlPinche);

        	Date t=tar.getTarPlanif();
        	if (t!=null) str = str.replaceFirst("#FECHA-PLANIF#",this.getFecha(t));
        	else str = str.replaceFirst("#FECHA-PLANIF#","Sin Planificar");

        	Mensaje = Mensaje.concat(str);
        	str = "";

        	message1.setContent(Mensaje,"text/html;charset=iso-8859-1");
	        sendMessageThread();
	        setErrorMessage(OkMensaje);
	      }
	      catch (Exception e)
		  {
	      	setErrorMessage(ErrorMensaje);
	      	e.printStackTrace();
	      }
	    
	        
	}/**Fin de NotificacionUsuarioPlanificacin*/	
	
	/**NOTIFICACIONES A INFORMTICOS*/
	//movimiento cambio de estado a rechazada
	public void NotificacionInformaticoRechazo(Session conn,D7Tareas tar){

		this.ActualizaParametros(conn);
			
		try
		{
			Query q = conn.createQuery(getQuery("TareasAux"));
			//System.out.println(q);
			q = q.setString("sist",user.getDatosMenu().idSelected());
			q = q.setString("cod",codigoTarea.toString());
			tar = (D7Tareas)q.list().get(0);
			
			this.QueryAplicaciones(conn,tar);
			this.QueryTiposTareas(conn,tar);
			this.QueryPrioridades(conn,tar);
			this.QueryDatosInformatico(conn,tar);
			this.QueryDatosUsuario(conn,tar);
			//this.QueryTareasSeguimientos(conn,tar);
			
			D7TareasMovimientos finalizada = this.QueryTareasMovimientosEst(conn,tar,D7TareasMovimientos.FINALIZAR_TAREA);
			D7TareasMovimientos rechazada = this.QueryTareasMovimientosEst(conn,tar,D7TareasMovimientos.RECHAZAR);
					
			/**Introduce en Subject del E-mail y indica el nombre del archivo(PLANTILLA) que hay que leer*/
			this.ConfiguraMailYFichero("[dumbo] Rechazo de tarea "+resumenTarea(tar),"NotInfRech.html",informatico.getDatEmail(), conn);		
		 
        	str = str.replaceAll("#IMAGEN#",DirImagenes.concat("NotInfRech.gif"));
        	str = str.replaceAll("#PIE#",Pie);
//        	sonia
        	str = str.replaceFirst("#DIR-PIE#",Pie1);
        	//fin sonia
        	if (Icono.equals("N")){str = str.replaceFirst("visibility: visible","visibility: hidden");}
        	if (Color.equals("N")){str = str.replaceFirst("background-color: #832C83","background-color: #FFFFFF");}
        	if(tar.getTarPriCod()!=null){
	        	if(tar.getTarPriCod().equals(D7Prioridades.PLANIFICACION)){
	        		str = str.replaceFirst("#TAREA#","Programada");
	        	}
        	
	        	else{
	        		str = str.replaceFirst("#TAREA#"," ");
	        	}
        	}	
        	else{
        		str = str.replaceFirst("#TAREA#"," ");
        	}
        	
        	str = str.replaceAll("#INC-PET#",TipoTar.getTipDescrip().replaceAll("", "&oacute;"));
        	str = str.replaceAll("#NUM#",codigoTarea(tar));
        	str = str.replaceAll("#USUARIO#",getNombreUsuario(tar,usuario));
        	str = str.replaceFirst("#APLICACION#",Apli.getAplDescrip());
        	str = str.replaceFirst("#ASUNTO#",tar.getTarAsunto());
        	str = str.replaceFirst("#TEXTO#","<PRE>"+tar.getTarDescrip().replaceAll("<", "&lt;")+"</PRE>");
        	/**Sustituimos el texto de RESOLUCIN de tareas que tomamos mediante la query a tareas_Movimientos*/
        	if(finalizada!=null){
        		str = str.replaceFirst("#TEX-RESOL#","<PRE>"+finalizada.getTmoDescripMov()+"</PRE>");
        	}
	        else{
	        	str = str.replaceFirst("#TEX-RESOL#","-");
	          }
        	/**Sustituimos el texto de RECHAZO de tareas que tomamos mediante la query a tareas_Movimientos*/
        	if(rechazada!=null){
        		str = str.replaceFirst("#TEX-RECH#","<PRE>"+rechazada.getTmoDescripMov()+"</PRE>");
        	}
	        else{
	        	str = str.replaceFirst("#TEX-RECH#","-");
	          }
        	Date dmax=tar.getTarPlanif();
    		if(dmax!=null)	str = str.replaceAll("#FECHA-PLANIF#",this.getFecha(dmax));
            //System.out.println(str);
        	Mensaje = Mensaje.concat(str);
        	str = "";
        	       	
        	message1.setContent(Mensaje,"text/html;charset=iso-8859-1");
	        sendMessageThread();
	        setErrorMessage(OkMensaje);
	      }
	      catch (Exception e)
		  {
	    	setErrorMessage(ErrorMensaje);
	      }  
	}/**Fin de NotificacionInformaticoRechazo*/
	/**NOTIFICACIONES A INFORMTICOS*/
	//movimiento cambio de estado a rechazada para tareas planificadas
	public void NotificacionInformaticoRechazoPlanificada(Session conn,D7Tareas tar){

		this.ActualizaParametros(conn);
			
		try
		{
			Query q = conn.createQuery(getQuery("TareasAux"));
			//System.out.println(q);
			q = q.setString("sist",user.getDatosMenu().idSelected());
			q = q.setString("cod",codigoTarea.toString());
			tar = (D7Tareas)q.list().get(0);
			
			this.QueryAplicaciones(conn,tar);
			this.QueryTiposTareas(conn,tar);
			this.QueryPrioridades(conn,tar);
			this.QueryDatosInformatico(conn,tar);
			this.QueryDatosUsuario(conn,tar);
			//this.QueryTareasSeguimientos(conn,tar);
			//D7TareasMovimientos finalizada = this.QueryTareasMovimientosEst(conn,tar,D7TareasMovimientos.FINALIZAR_TAREA);
			D7TareasMovimientos rechazada = this.QueryTareasMovimientosEst(conn,tar,D7TareasMovimientos.RECHAZAR);
					
			/**Introduce en Subject del E-mail y indica el nombre del archivo(PLANTILLA) que hay que leer*/
			this.ConfiguraMailYFichero("[dumbo] Rechazo de tarea planificada "+resumenTarea(tar),"NotInfRechPlanif.html",informatico.getDatEmail(), conn);		
		 
        	str = str.replaceAll("#IMAGEN#",DirImagenes.concat("NotInfRechPlanif.gif"));
        	str = str.replaceAll("#PIE#",Pie);
//        	sonia
        	str = str.replaceFirst("#DIR-PIE#",Pie1);
        	//fin sonia
        	if (Icono.equals("N")){str = str.replaceFirst("visibility: visible","visibility: hidden");}
        	if (Color.equals("N")){str = str.replaceFirst("background-color: #832C83","background-color: #FFFFFF");}
        	
        	str = str.replaceAll("#NUM#",codigoTarea(tar));
        	str = str.replaceAll("#USUARIO#",getNombreUsuario(tar,usuario));
        	str = str.replaceFirst("#APLICACION#",Apli.getAplDescrip());
        	str = str.replaceFirst("#ASUNTO#",tar.getTarAsunto());
        	str = str.replaceFirst("#TEXTO#","<PRE>"+tar.getTarDescrip().replaceAll("<", "&lt;")+"</PRE>");
        		       
        	/**Sustituimos el texto de RECHAZO de tareas que tomamos mediante la query a tareas_Movimientos*/
        	if(rechazada!=null){
        		str = str.replaceFirst("#TEX-RECH-PLANIF#","<PRE>"+rechazada.getTmoDescripMov()+"</PRE>");
        	}
	        else{
	        	str = str.replaceFirst("#TEX-RECH-PLANIF#","-");
	          }
            //System.out.println(str);
        	Mensaje = Mensaje.concat(str);
        	str = "";

        	message1.setContent(Mensaje,"text/html;charset=iso-8859-1");
	        sendMessageThread();
	        setErrorMessage(OkMensaje);
	      }
	      catch (Exception e)
		  {
	    	setErrorMessage(ErrorMensaje);
	      }  
	}/**Fin de NotificacionInformaticoRechazo*/
	//movimiento cambio de estado  a anulado
	public void NotificacionInformaticoAnulacion(Session conn,D7Tareas tar)
	{
		this.ActualizaParametros(conn);
		
		try
		{
			Query q = conn.createQuery(getQuery("TareasAux"));
			//System.out.println(q);
			q = q.setString("sist",user.getDatosMenu().idSelected());
			q = q.setString("cod",codigoTarea.toString());
			tar = (D7Tareas)q.list().get(0);
			
			this.QueryAplicaciones(conn,tar);
			this.QueryTiposTareas(conn,tar);
			this.QueryPrioridades(conn,tar);
			this.QueryDatosInformatico(conn,tar);
			this.QueryDatosUsuario(conn,tar);
			this.QueryTareasMovimientosEst(conn,tar,D7TareasMovimientos.ANULAR_TAREA);
					
			/**Introduce en Subject del E-mail y indica el nombre del archivo(PLANTILLA) que hay que leer*/
			this.ConfiguraMailYFichero("[dumbo] Anulacion de tarea "+resumenTarea(tar),"NotInfAnu.html",informatico.getDatEmail(), conn);		
		 
           	str = str.replaceFirst("#IMAGEN#",DirImagenes.concat("NotInfAnu.gif"));
        	str = str.replaceFirst("#PIE#",Pie);
//        	sonia
        	str = str.replaceFirst("#DIR-PIE#",Pie1);
        	//fin sonia
        	if (Icono.equals("N")){str = str.replaceFirst("visibility: visible","visibility: hidden");}
        	if (Color.equals("N")){str = str.replaceFirst("background-color: #832C83","background-color: #FFFFFF");}
        	
        	str = str.replaceAll("#INC-PET#",TipoTar.getTipDescrip().replaceAll("", "&oacute;"));
        	str = str.replaceAll("#NUM#",codigoTarea(tar));
        	str = str.replaceFirst("#USUARIO#",getNombreUsuario(tar,usuario));
        	str = str.replaceFirst("#APLICACION#",Apli.getAplDescrip());
        	str = str.replaceFirst("#ASUNTO#",tar.getTarAsunto());
        	str = str.replaceFirst("#TEXTO#","<PRE>"+tar.getTarDescrip().replaceAll("<", "&lt;")+"</PRE>");
        	
        	if(tarMovE!=null)
        		str = str.replaceFirst("#TEX-ANU#","<PRE>"+tarMovE.getTmoDescripMov()+"</PRE>");
	        if(tarMovE==null)
	        	str = str.replaceFirst("#TEX-ANU#","-");
	        
        	//System.out.println(str);
        	Mensaje = Mensaje.concat(str);
        	str = "";
	        
        	message1.setContent(Mensaje,"text/html;charset=iso-8859-1");
	        sendMessageThread();
	        setErrorMessage(OkMensaje);
	      }
	      catch (Exception e)
		  {
	    	setErrorMessage(ErrorMensaje);
	      }
	}/**Fin de NotificacionInformaticoAnulacion*/
	//movimiento cambio de estado de pendiente a asignado
	public void NotificacionInformaticoAsignacion(Session conn,D7Tareas tar)
	{
		this.ActualizaParametros(conn);
		
		try{
		Query q = conn.createQuery(getQuery("TareasAux"));
		//System.out.println(q);
		q = q.setString("sist",user.getDatosMenu().idSelected());
		q = q.setString("cod",codigoTarea.toString());
		tar = (D7Tareas)q.list().get(0);
		
		this.QueryAplicaciones(conn,tar);
		this.QueryTiposTareas(conn,tar);
		this.QueryPrioridades(conn,tar);
		this.QueryDatosInformatico(conn,tar);
		this.QueryDatosUsuario(conn,tar);
		this.QueryTareasMovimientosEst(conn,tar,D7TareasMovimientos.ASIGNAR_TAREA);
		//this.QueryTareasSeguimientos(conn,tar);
		
		/**Introduce en Subject del E-mail y indica el nombre del archivo(PLANTILLA) que hay que leer*/
		this.ConfiguraMailYFichero("[dumbo] Asignacion tarea "+resumenTarea(tar),"NotInfAsig.html",informatico.getDatEmail(), conn);
			
		//Composicin del mensaje a enviar
	      
    	str = str.replaceFirst("#IMAGEN#",DirImagenes.concat("NotInfAsig.gif"));
    	str = str.replaceFirst("#PIE#",Pie);
//    	sonia
    	str = str.replaceAll("#DIR-PIE#",Pie1);
    	//fin sonia
    	if (Icono.equals("N")){str = str.replaceFirst("visibility: visible","visibility: hidden");}
    	if (Color.equals("N")){str = str.replaceFirst("background-color: #FFFF00","background-color: #FFFFFF");}
    	
    	str = str.replaceAll("#INC-PET#",TipoTar.getTipDescrip().replaceAll("", "&oacute;"));
    	str = str.replaceAll("#NUM#",codigoTarea(tar));
    	str = str.replaceFirst("#USUARIO#",getNombreUsuario(tar,usuario));
    	str = str.replaceFirst("#APLICACION#",Apli.getAplDescrip());
    	str = str.replaceFirst("#ASUNTO#",tar.getTarAsunto());
    	str = str.replaceFirst("#TEXTO#","<PRE>"+tar.getTarDescrip().replaceAll("<", "&lt;")+"</PRE>");
    	str = str.replaceFirst("#TECNICO#",informatico.getDatNombre()+" "+informatico.getDatApellidos());
    	str = str.replaceFirst("#EXT#",tar.getTarTelefono());
    	str = str.replaceFirst("#UBICACION#",tar.getTarUbicacion());
    	str = str.replaceFirst("#REC#",Msj);

    	Mensaje = Mensaje.concat(str);
    	str = "";
        
        anxFile = new File(rutaAnexos+GestorGenerico.getPrefijoZip(""+tar.getTarCod())+".zip");
        if (!anxFile.exists() || anxFile.length()>MAXIMO_POR_CORREO) message1.setContent(Mensaje,"text/html;charset=iso-8859-1");
        else {
	        Multipart multipart = new MimeMultipart();
	        BodyPart messageBodyPart = new MimeBodyPart();
	        messageBodyPart.setContent(Mensaje,"text/html;charset=iso-8859-1");

	        multipart.addBodyPart(messageBodyPart);

	        messageBodyPart = new MimeBodyPart();
	        DataSource source = new FileDataSource(anxFile);
	        messageBodyPart.setDataHandler(new DataHandler(source));
	        messageBodyPart.setFileName(anxFile.getName());
	        multipart.addBodyPart(messageBodyPart);
	        message1.setContent(multipart);
        }
        
        sendMessageThread();
        setErrorMessage(OkMensaje);

		}
		catch (Exception e)
		{
			setErrorMessage(ErrorMensaje);
		}
 
	}/**Fin de NotificacionInformaticoAsignacion*/
	//movimiento asignar una tarea a la cola de la aplicacin
	public void NotificacionInformaticoAsignacionCola(Session conn,D7Tareas tar)
	{
		this.ActualizaParametros(conn);
		
		try{
		Query q = conn.createQuery(getQuery("TareasAux"));
		//System.out.println(q);
		q = q.setString("sist",user.getDatosMenu().idSelected());
		q = q.setString("cod",codigoTarea.toString());
		tar = (D7Tareas)q.list().get(0);
		
		this.QueryAplicaciones(conn,tar);
		//Si se ha dicho que no se mande correo a informaticos, debe salir de aqui
		if (Apli.getAplTipoAsig().equals("C") && Apli.getAplCorreoInf()!=null && !Apli.getAplCorreoInf().equals((D7Aplicaciones.CORREO_INF))) return;
		
		this.QueryTiposTareas(conn,tar);
		this.QueryPrioridades(conn,tar);
		//this.QueryDatosInformatico(conn,tar);
		this.QueryDatosInformaticosAplicacion(conn,tar);
		this.QueryDatosUsuario(conn,tar);
		this.QueryTareasMovimientosEst(conn,tar,D7TareasMovimientos.ASIGNAR_TAREA);
		//this.QueryTareasSeguimientos(conn,tar);
		
		String [] destinatarios = new String[datosPersonalesInformatico.size()];
		
		for(int i=0;i<datosPersonalesInformatico.size();i++)
		{
			String mail = ((D7DatosTrabajador) datosPersonalesInformatico.get(i)).getDatEmail();
			if (mail!=null && !mail.equals("")) destinatarios[i] = mail;
		}
		
		/**Introduce en Subject del E-mail y indica el nombre del archivo(PLANTILLA) que hay que leer*/
		this.ConfiguraMailYFichero("[dumbo] Asignacion a cola de aplicacion de tarea "+resumenTarea(tar),"NotInfAsigCola.html",destinatarios, conn);
			
		//Composicin del mensaje a enviar
	      
    	str = str.replaceFirst("#IMAGEN#",DirImagenes.concat("NotInfAsigCola.gif"));
    	str = str.replaceFirst("#PIE#",Pie);
//    	sonia
    	str = str.replaceFirst("#DIR-PIE#",Pie1);
    	//fin sonia
    	if (Icono.equals("N")){str = str.replaceFirst("visibility: visible","visibility: hidden");}
    	if (Color.equals("N")){str = str.replaceFirst("background-color: #FFFF00","background-color: #FFFFFF");}
    	
    	str = str.replaceAll("#INC-PET#",TipoTar.getTipDescrip().replaceAll("", "&oacute;"));
    	str = str.replaceAll("#NUM#",codigoTarea(tar));
    	str = str.replaceFirst("#USUARIO#",getNombreUsuario(tar,usuario));
    	str = str.replaceAll("#APLICACION#",Apli.getAplDescrip());
    	str = str.replaceFirst("#ASUNTO#",tar.getTarAsunto());
    	str = str.replaceFirst("#TEXTO#","<PRE>"+tar.getTarDescrip().replaceAll("<", "&lt;")+"</PRE>");
    	
    	Mensaje = Mensaje.concat(str);
    	str = "";
        
        anxFile = new File(rutaAnexos+GestorGenerico.getPrefijoZip(""+tar.getTarCod())+".zip");
        if (!anxFile.exists() || anxFile.length()>MAXIMO_POR_CORREO) message1.setContent(Mensaje,"text/html;charset=iso-8859-1");
        else {
	        Multipart multipart = new MimeMultipart();
	        BodyPart messageBodyPart = new MimeBodyPart();
	        messageBodyPart.setContent(Mensaje,"text/html;charset=iso-8859-1");

	        multipart.addBodyPart(messageBodyPart);

	        messageBodyPart = new MimeBodyPart();
	        DataSource source = new FileDataSource(anxFile);
	        messageBodyPart.setDataHandler(new DataHandler(source));
	        messageBodyPart.setFileName(anxFile.getName());
	        multipart.addBodyPart(messageBodyPart);
	        message1.setContent(multipart);
        }
        
        sendMessageThread();
        setErrorMessage(OkMensaje);

		}
		catch (Exception e)
		{
			setErrorMessage(ErrorMensaje);
		}
 
	}/**Fin de NotificacionInformaticoAsignacionCola*/
	//movimiento cambio usuario
	public void NotificacionInformaticoCambio(Session conn,D7Tareas tar)
	{
		this.ActualizaParametros(conn);
		
		try
		{
			Query q = conn.createQuery(getQuery("TareasAux"));
	
			q = q.setString("sist",user.getDatosMenu().idSelected());
			q = q.setString("cod",codigoTarea.toString());
			tar = (D7Tareas)q.list().get(0);
		
			String oreja="usuario";
			this.QueryAplicaciones(conn,tar);
			this.QueryTiposTareas(conn,tar);
			this.QueryPrioridades(conn,tar);
			this.QueryDatosInformatico(conn,tar);
			this.QueryDatosUsuario(conn,tar);
			this.QueryTareasMovimientosUsu(conn,tar);
			
			//Si es un oreja el que est haciendo los cambios, en usuario metemos los datos del oreja
			if (!tar.getTarInfCod().equals(user.getIdentificador())){
				this.QueryDatosOreja(conn,user.getIdentificador(),"usu");
				oreja="oreja";
			}
			
			/**Introduce en Subject del E-mail y indica el nombre del archivo(PLANTILLA) que hay que leer*/
			this.ConfiguraMailYFichero("[dumbo] Cambio en la tarea "+resumenTarea(tar),"NotInfCamb.html",informatico.getDatEmail(), conn);
			
			str = str.replaceFirst("#IMAGEN#",DirImagenes.concat("NotInfCamb.gif"));
			str = str.replaceFirst("#PIE#",Pie);
//			sonia
        	str = str.replaceFirst("#DIR-PIE#",Pie1);
        	//fin sonia
			if (Icono.equals("N")){str = str.replaceFirst("visibility: visible","visibility: hidden");}
			if (Color.equals("N")){str = str.replaceFirst("background-color: #FFCC66","background-color: #FFFFFF");}
			
			str = str.replaceAll("#INC-PET#",TipoTar.getTipDescrip().replaceAll("", "&oacute;"));
			str = str.replaceAll("#NUM#",codigoTarea(tar));
			str = str.replaceFirst("#USUARIO#",getNombreUsuario(tar,usuario));
			str = str.replaceFirst("#USU-OREJA#",oreja);
			str = str.replaceFirst("#APLICACION#",Apli.getAplDescrip());
			str = str.replaceFirst("#ASUNTO#",tar.getTarAsunto());
			str = str.replaceFirst("#TEXTO#","<PRE>"+tar.getTarDescrip().replaceAll("<", "&lt;")+"</PRE>");
			
			str = str.replaceAll("#TEX-URG#","Texto/Urgencia");
			
			Mensaje = Mensaje.concat(str);
			str = "";

			if (nameAnexo!=null) {
		        anxFile = new File(rutaAnexos+GestorGenerico.getPrefijoZip(""+tar.getTarCod())+"Anexo.zip");
		        if (!anxFile.exists() || anxFile.length()>MAXIMO_POR_CORREO) message1.setContent(Mensaje,"text/html;charset=iso-8859-1");
		        else {
			        Multipart multipart = new MimeMultipart();
			        BodyPart messageBodyPart = new MimeBodyPart();
			        messageBodyPart.setContent(Mensaje,"text/html;charset=iso-8859-1");
	
			        multipart.addBodyPart(messageBodyPart);
	
			        messageBodyPart = new MimeBodyPart();
			        DataSource source = new FileDataSource(anxFile);
			        messageBodyPart.setDataHandler(new DataHandler(source));
			        messageBodyPart.setFileName(anxFile.getName());
			        multipart.addBodyPart(messageBodyPart);
			        message1.setContent(multipart);
		        }
			} else message1.setContent(Mensaje,"text/html;charset=iso-8859-1");
			sendMessageThread();

		}
		catch (Exception e)
		{
			setErrorMessage(ErrorMensaje);
		}
		this.Mensaje = "";
		setErrorMessage(OkMensaje);
	}/**Fin de NotificacionInformaticoCambio*/
	
	//movimiento cambio usuario
	public void NotificacionUsuarioCambio(Session conn,D7Tareas tar)
	{
		this.ActualizaParametros(conn);
		
		try
		{
			Query q = conn.createQuery(getQuery("TareasAux"));
	
			q = q.setString("sist",user.getDatosMenu().idSelected());
			q = q.setString("cod",codigoTarea.toString());
			tar = (D7Tareas)q.list().get(0);
			
			this.QueryAplicaciones(conn,tar);
			this.QueryTiposTareas(conn,tar);
			this.QueryPrioridades(conn,tar);
			this.QueryDatosInformatico(conn,tar);
			this.QueryDatosUsuario(conn,tar);
			this.QueryTareasMovimientosUsu(conn,tar);
			
			//Si es un oreja el que est haciendo los cambios, en usuario metemos los datos del oreja
			if (!tar.getTarInfCod().equals(user.getIdentificador())){
				this.QueryDatosOreja(conn,user.getIdentificador(),"inf");
			}
			
			this.setNotUsu(true);
			/**Introduce en Subject del E-mail y indica el nombre del archivo(PLANTILLA) que hay que leer*/
			this.ConfiguraMailYFichero("[dumbo] Cambio en la tarea "+resumenTarea(tar),"NotUsuCamb.html",getCorreoUsuario(tar,usuario), conn);
			
			str = str.replaceFirst("#IMAGEN#",DirImagenes.concat("NotInfCamb.gif"));
			str = str.replaceFirst("#PIE#",Pie);
//			sonia
        	str = str.replaceFirst("#DIR-PIE#",Pie1);
        	//fin sonia
			if (Icono.equals("N")){str = str.replaceFirst("visibility: visible","visibility: hidden");}
			if (Color.equals("N")){str = str.replaceFirst("background-color: #FFCC66","background-color: #FFFFFF");}
			
			str = str.replaceAll("#INC-PET#",TipoTar.getTipDescrip().replaceAll("", "&oacute;"));
			str = str.replaceAll("#NUM#",codigoTarea(tar));
			str = str.replaceFirst("#USUARIO#",getNombreUsuario(tar,usuario));
			str = str.replaceFirst("#APLICACION#",Apli.getAplDescrip());
			str = str.replaceFirst("#ASUNTO#",tar.getTarAsunto());
			str = str.replaceAll("#INFORMATICO#",(informatico.getDatNombre()+" "+informatico.getDatApellidos()));
			str = str.replaceFirst("#TEXTO#","<PRE>"+tar.getTarDescrip().replaceAll("<", "&lt;")+"</PRE>");
			if (tar.getTarDescripSegui() != null) str = str.replaceFirst("#TEXTO_SEG#","<PRE>"+tar.getTarDescripSegui().replaceAll("<", "&lt;")+"</PRE>");
			else str = str.replaceFirst("#TEXTO_SEG#","No hay texto de seguimiento.");
			
			str = str.replaceAll("#TEX-URG#","Texto/Urgencia");
			
			Mensaje = Mensaje.concat(str);
			str = "";

			if (nameAnexo!=null) {
		        anxFile = new File(rutaAnexos+GestorGenerico.getPrefijoZip(""+tar.getTarCod())+"Anexo.zip");
		        if (!anxFile.exists() || anxFile.length()>MAXIMO_POR_CORREO) message1.setContent(Mensaje,"text/html;charset=iso-8859-1");
		        else {
			        Multipart multipart = new MimeMultipart();
			        BodyPart messageBodyPart = new MimeBodyPart();
			        messageBodyPart.setContent(Mensaje,"text/html;charset=iso-8859-1");
	
			        multipart.addBodyPart(messageBodyPart);
	
			        messageBodyPart = new MimeBodyPart();
			        DataSource source = new FileDataSource(anxFile);
			        messageBodyPart.setDataHandler(new DataHandler(source));
			        messageBodyPart.setFileName(anxFile.getName());
			        multipart.addBodyPart(messageBodyPart);
			        message1.setContent(multipart);
		        }
			} else message1.setContent(Mensaje,"text/html;charset=iso-8859-1");
			sendMessageThread();

		}
		catch (Exception e)
		{
			setErrorMessage(ErrorMensaje);
		}
		this.Mensaje = "";
		setErrorMessage(OkMensaje);
	}/**Fin de NotificacionUsuarioCambio*/
	
	public void NotificacionUsuarioDevolverCola(Session conn,D7Tareas tar)
	{
		this.ActualizaParametros(conn);
		
		try
		{	
			this.QueryAplicaciones(conn,tar);
			this.QueryTiposTareas(conn,tar);
			this.QueryPrioridades(conn,tar);
			this.QueryDatosUsuario(conn,tar);
			this.QueryTareasMovimientosUsu(conn,tar);
			
			
			this.setNotUsu(true);
			/**Introduce en Subject del E-mail y indica el nombre del archivo(PLANTILLA) que hay que leer*/
			this.ConfiguraMailYFichero("[dumbo] Tarea sin asignar "+resumenTarea(tar),"NotUsuCamb.html",getCorreoUsuario(tar,usuario), conn);
			
			this.QueryDatosUser(conn, tar);
			
			str = str.replaceFirst("#IMAGEN#",DirImagenes.concat("NotInfCamb.gif"));
			str = str.replaceFirst("#PIE#",Pie);
//			sonia
        	str = str.replaceFirst("#DIR-PIE#",Pie1);
        	//fin sonia
			if (Icono.equals("N")){str = str.replaceFirst("visibility: visible","visibility: hidden");}
			if (Color.equals("N")){str = str.replaceFirst("background-color: #FFCC66","background-color: #FFFFFF");}
			
			str = str.replaceAll("#INC-PET#",TipoTar.getTipDescrip().replaceAll("", "&oacute;"));
			str = str.replaceFirst("#APLICACION#","Aplicacin por determinar.");
			str = str.replaceAll("#NUM#",codigoTarea(tar));
			str = str.replaceAll("#INFORMATICO#",(informatico.getDatNombre()+" "+informatico.getDatApellidos()));
			str = str.replaceFirst("#USUARIO#",getNombreUsuario(tar,usuario));
			str = str.replaceFirst("#ASUNTO#",tar.getTarAsunto());
			str = str.replaceFirst("#TEXTO#","<PRE>"+tar.getTarDescrip().replaceAll("<", "&lt;")+"</PRE>");
			str = str.replaceFirst("#TEXTO_SEG#","Tarea sin asignar, bien por falta de informacin o bien porque hubo un error en la asignacin incial.");
			
			str = str.replaceAll("#TEX-URG#","Texto/Urgencia");
			
			Mensaje = Mensaje.concat(str);
			str = "";

			if (nameAnexo!=null) {
		        anxFile = new File(rutaAnexos+GestorGenerico.getPrefijoZip(""+tar.getTarCod())+"Anexo.zip");
		        if (!anxFile.exists() || anxFile.length()>MAXIMO_POR_CORREO) message1.setContent(Mensaje,"text/html;charset=iso-8859-1");
		        else {
			        Multipart multipart = new MimeMultipart();
			        BodyPart messageBodyPart = new MimeBodyPart();
			        messageBodyPart.setContent(Mensaje,"text/html;charset=iso-8859-1");
	
			        multipart.addBodyPart(messageBodyPart);
	
			        messageBodyPart = new MimeBodyPart();
			        DataSource source = new FileDataSource(anxFile);
			        messageBodyPart.setDataHandler(new DataHandler(source));
			        messageBodyPart.setFileName(anxFile.getName());
			        multipart.addBodyPart(messageBodyPart);
			        message1.setContent(multipart);
		        }
			} else message1.setContent(Mensaje,"text/html;charset=iso-8859-1");
			sendMessageThread();

		}
		catch (Exception e)
		{
			setErrorMessage(ErrorMensaje);
		}
		this.Mensaje = "";
		setErrorMessage(OkMensaje);
	}/**Fin de NotificacionUsuarioCambio*/
	
	//movimiento cambio informatico
	public void NotificacionInformaticoReasignacion(Session conn,D7Tareas tar)
	{	
		this.ActualizaParametros(conn);
		
		try
		{
			Query q = conn.createQuery(getQuery("TareasAux"));
			//System.out.println(q);
			q = q.setString("sist",user.getDatosMenu().idSelected());
			q = q.setString("cod",codigoTarea.toString());
			tar = (D7Tareas)q.list().get(0);
			
			this.QueryAplicaciones(conn,tar);
			this.QueryTiposTareas(conn,tar);
			this.QueryPrioridades(conn,tar);
			this.QueryDatosInformatico(conn,tar);
			this.QueryDatosUsuario(conn,tar);
			this.QueryTareasMovimientosEst(conn,tar,D7TareasMovimientos.REASIGNAR);
			//this.QueryTareasSeguimientos(conn,tar);
			
			/**Introduce en Subject del E-mail y indica el nombre del archivo(PLANTILLA) que hay que leer*/
			this.ConfiguraMailYFichero("[dumbo] Reasignacion de tarea "+resumenTarea(tar),"NotInfReas.html",informatico.getDatEmail(), conn);		

        	str = str.replaceFirst("#IMAGEN#",DirImagenes.concat("NotInfReas.gif"));
        	str = str.replaceFirst("#PIE#",Pie);
//        	sonia
        	str = str.replaceFirst("#DIR-PIE#",Pie1);
        	//fin sonia
        	if (Icono.equals("N")){str = str.replaceFirst("visibility: visible","visibility: hidden");}
        	if (Color.equals("N")){str = str.replaceFirst("background-color: #00FFFF","background-color: #FFFFFF");}
        	
        	str = str.replaceAll("#INC-PET#",TipoTar.getTipDescrip().replaceAll("", "&oacute;"));
        	str = str.replaceAll("#NUM#",codigoTarea(tar));
        	str = str.replaceFirst("#USUARIO#",getNombreUsuario(tar,usuario));
        	str = str.replaceAll("#INFORMATICO#",((dumbo7.user.DumboUser)user).getNombre()+" "+((dumbo7.user.DumboUser)user).getApellidos());
        	str = str.replaceFirst("#APLICACION#",Apli.getAplDescrip());
        	str = str.replaceFirst("#ASUNTO#",tar.getTarAsunto());
        	str = str.replaceFirst("#TEXTO#","<PRE>"+tar.getTarDescrip().replaceAll("<", "&lt;")+"</PRE>");
        	if(this.tarMovE!=null)
        		str = str.replaceFirst("#TEX-REAS#","<PRE>"+tarMovE.getTmoDescripMov()+"</PRE>");
	        else{
	        	str = str.replaceFirst("#TEX-REAS#","-");
	        }
        	//System.out.println(str);
        	Mensaje = Mensaje.concat(str);
        	str = "";

        	message1.setContent(Mensaje,"text/html;charset=iso-8859-1");
	        sendMessageThread();
	        setErrorMessage(OkMensaje);
	      }
	      catch (Exception e)
		  {
	      		setErrorMessage(ErrorMensaje);
	      }
	}/**Fin de NotificacionInformaticoReasignacion*/

	//movimiento cambio estado
	public void NotificacionInformaticoReactivacion(Session conn,D7Tareas tar)
	{
		this.ActualizaParametros(conn);
		
		try
		{
			Query q = conn.createQuery(getQuery("TareasAux"));
			q = q.setString("sist",user.getDatosMenu().idSelected());
			q = q.setString("cod",codigoTarea.toString());
			tar = (D7Tareas)q.list().get(0);
			
			this.QueryAplicaciones(conn,tar);
			this.QueryTiposTareas(conn,tar);
			this.QueryPrioridades(conn,tar);
			this.QueryDatosInformatico(conn,tar);
			this.QueryDatosUsuario(conn,tar);
			this.QueryTareasMovimientosEst(conn,tar,D7TareasMovimientos.PASAR_NOWAITING);

			/**Introduce en Subject del E-mail y indica el nombre del archivo(PLANTILLA) que hay que leer*/
			this.ConfiguraMailYFichero("[dumbo] Reactivacion de tarea en espera "+resumenTarea(tar),"NotInfReac.html",informatico.getDatEmail(), conn);	
				
			str = str.replaceFirst("#IMAGEN#",DirImagenes.concat("NotInfReac.gif"));
			str = str.replaceFirst("#PIE#",Pie);
//			sonia
        	str = str.replaceFirst("#DIR-PIE#",Pie1);
        	//fin sonia
			if (Icono.equals("N")){str = str.replaceFirst("visibility: visible","visibility: hidden");}
			if (Color.equals("N")){str = str.replaceFirst("background-color: #FFFF00","background-color: #FFFFFF");}
					      	
			//texto del ultimo seguimiento
			if(tarMovE!=null)
				str = str.replaceAll("#TEX-REAC#","<PRE>"+tarMovE.getTmoDescripMov()+"</PRE>");
			if(tarMovE==null)
				str = str.replaceAll("#TEX-REAC#","-");
			
			str = str.replaceAll("#INC-PET#",TipoTar.getTipDescrip().replaceAll("", "&oacute;"));
			str = str.replaceAll("#NUM#",codigoTarea(tar));
			str = str.replaceFirst("#USUARIO#",getNombreUsuario(tar,usuario));
			str = str.replaceFirst("#APLICACION#",Apli.getAplDescrip());
			str = str.replaceFirst("#ASUNTO#",tar.getTarAsunto());
			str = str.replaceFirst("#TEXTO#","<PRE>"+tar.getTarDescrip().replaceAll("<", "&lt;")+"</PRE>");
			
			Mensaje = Mensaje.concat(str);
			str = "";

			message1.setContent(Mensaje,"text/html;charset=iso-8859-1");
	        sendMessageThread();
	        setErrorMessage(OkMensaje);
	      }
	      catch (Exception e)
		  {
	      		setErrorMessage(ErrorMensaje);
	      }
  
	}/**Fin de NotificacionInformaticoReactivacion*/
	// falta saber el texto que hay que poner porque es espera y rechazo espera son los 2 ultimos seguimientos?
	//movimiento cambio estado
	public void NotificacionInformaticoRechazoPasoEspera(Session conn,D7Tareas tar){
		this.ActualizaParametros(conn);
		
		try
		{
			Query q = conn.createQuery(getQuery("TareasAux"));
			
			q = q.setString("sist",user.getDatosMenu().idSelected());
			q = q.setString("cod",codigoTarea.toString());
			tar = (D7Tareas)q.list().get(0);
			
			this.QueryAplicaciones(conn,tar);
			this.QueryTiposTareas(conn,tar);
			this.QueryPrioridades(conn,tar);
			this.QueryDatosInformatico(conn,tar);
			this.QueryDatosUsuario(conn,tar);
			this.QueryTareasMovimientosEst(conn,tar,D7TareasMovimientos.RECHAZAR_WAITING);//Saca el movimiento
			this.QueryTareasMovimientosEst2(conn,tar,D7TareasMovimientos.PASAR_WAITING);//Saca el movimiento anterior
			//this.QueryTareasSeguimientos(conn,tar);
			
			/**Introduce en Subject del E-mail y indica el nombre del archivo(PLANTILLA) que hay que leer*/
			this.ConfiguraMailYFichero("[dumbo] Rechazo de paso a espera tarea "+resumenTarea(tar),"NotInfRechPasoEspera.html",informatico.getDatEmail(), conn);	
		
		 

			str = str.replaceAll("#IMAGEN#",DirImagenes.concat("NotInfRechPasoEspera.gif"));
			str = str.replaceAll("#PIE#",Pie);
//			sonia
        	str = str.replaceFirst("#DIR-PIE#",Pie1);
        	//fin sonia
			if (Icono.equals("N")){str = str.replaceFirst("visibility: visible","visibility: hidden");}
			if (Color.equals("N")){str = str.replaceFirst("background-color: #CCCCCC","background-color: #FFFFFF");}
				        	
			str = str.replaceAll("#INC-PET#",TipoTar.getTipDescrip().replaceAll("", "&oacute;"));
			str = str.replaceAll("#NUM#",codigoTarea(tar));
			str = str.replaceFirst("#USUARIO#",getNombreUsuario(tar,usuario));
			str = str.replaceFirst("#APLICACION#",Apli.getAplDescrip());
			str = str.replaceFirst("#ASUNTO#",tar.getTarAsunto());
			str = str.replaceFirst("#TEXTO#","<PRE>"+tar.getTarDescrip().replaceAll("<", "&lt;")+"</PRE>");
			if(tarMovE!=null)
				str = str.replaceAll("#TEX-RECH-PASOESPERA#","<PRE>"+tarMovE.getTmoDescripMov()+"</PRE>");
			if(tarMovEE!=null)		
				str = str.replaceAll("#TEX-PASOESPERA#","<PRE>"+tarMovEE.getTmoDescripMov()+"</PRE>");
			
			if(tarMovE==null)
				str = str.replaceAll("#TEX-RECH-PASOESPERA#","-");
			if(tarMovEE==null)
				str = str.replaceAll("#TEX-PASOESPERA#","-");

			Mensaje = Mensaje.concat(str);
			str = "";

			message1.setContent(Mensaje,"text/html;charset=iso-8859-1");
	        sendMessageThread();
	        setErrorMessage(OkMensaje);
	      }
	      catch (Exception e)
		  {
	    	setErrorMessage(ErrorMensaje);
	      }
	      
	      
	}/**Fin de NotificacionInformaticoRechazoPasoEspera*/
	//	 falta saber el texto que hay que poner porque es espera y rechazo espera son los 2 ultimos seguimientos?
	public void NotificacionInformaticoReactivacionAnulada(Session conn,D7Tareas tar){
		this.ActualizaParametros(conn);
		
		try
		{
			Query q = conn.createQuery(getQuery("TareasAux"));
	
			q = q.setString("sist",user.getDatosMenu().idSelected());
			q = q.setString("cod",codigoTarea.toString());
			tar = (D7Tareas)q.list().get(0);
			
			this.QueryAplicaciones(conn,tar);
			this.QueryTiposTareas(conn,tar);
			this.QueryPrioridades(conn,tar);
			this.QueryDatosInformatico(conn,tar);
			this.QueryDatosUsuario(conn,tar);
			this.QueryTareasMovimientosEst(conn,tar,D7TareasMovimientos.REACTIVAR);//Saca el movimiento
			this.QueryTareasMovimientosEst2(conn,tar,D7TareasMovimientos.ANULAR_TAREA);//Saca el movimiento anterior
			//this.QueryTareasSeguimientos(conn,tar);
			
			/**Introduce en Subject del E-mail y indica el nombre del archivo(PLANTILLA) que hay que leer*/
			this.ConfiguraMailYFichero("[dumbo] Reactivacion de tarea anulada "+resumenTarea(tar),"NotInfReacAnu.html",informatico.getDatEmail(), conn);

           	str = str.replaceFirst("#IMAGEN#",DirImagenes.concat("NotInfReacAnu.gif"));
        	str = str.replaceFirst("#PIE#",Pie);
//        	sonia
        	str = str.replaceFirst("#DIR-PIE#",Pie1);
        	//fin sonia
        	if (Icono.equals("N")){str = str.replaceFirst("visibility: visible","visibility: hidden");}
        	if (Color.equals("N")){str = str.replaceFirst("background-color: #990033","background-color: #FFFFFF");}
        	
        	
        	str = str.replaceAll("#INC-PET#",TipoTar.getTipDescrip().replaceAll("", "&oacute;"));
        	str = str.replaceAll("#NUM#",codigoTarea(tar));
        	str = str.replaceFirst("#USUARIO#",getNombreUsuario(tar,usuario));
        	str = str.replaceFirst("#APLICACION#",Apli.getAplDescrip());
        	str = str.replaceFirst("#ASUNTO#",tar.getTarAsunto());
        	str = str.replaceFirst("#TEXTO#","<PRE>"+tar.getTarDescrip().replaceAll("<", "&lt;")+"</PRE>");
        	if(tarMovE!=null)
        		str = str.replaceAll("#TEX-REAC#","<PRE>"+tarMovE.getTmoDescripMov()+"</PRE>");
        	if(tarMovEE!=null)
        		str = str.replaceAll("#TEX-ANU#","<PRE>"+tarMovEE.getTmoDescripMov()+"</PRE>");
        	
	        if(tarMovE==null)
	        	str = str.replaceAll("#TEX-REAC#","-");
	        if(tarMovEE==null)
	        	str = str.replaceAll("#TEX-ANU#","-");
	        
            //System.out.println(str);
        	Mensaje = Mensaje.concat(str);
        	str = "";

        	message1.setContent(Mensaje,"text/html;charset=iso-8859-1");
	        sendMessageThread();
	        setErrorMessage(OkMensaje);
	      }
	      catch (Exception e) {
	      		setErrorMessage(ErrorMensaje);
	      }
	}/**Fin de NotificacionInformaticoReactivacionDeTareaAnulada*/
		
	private String readFile(File f) throws Exception {
		StringBuffer file = new StringBuffer();
		DataInputStream in = new DataInputStream(new FileInputStream(f));
		String linea = in.readLine();
		while (linea!=null) {
			file.append(linea+"\n");
			linea = in.readLine();
		}
		return file.toString();
	}
	
	public void loadPlantillas(java.sql.Connection conn) {
		java.sql.PreparedStatement pstmt = null;
		java.sql.ResultSet rs = null;
		try {
		
			String miruta = "";
			
			pstmt = conn.prepareStatement(getQuery("RutaPlantillas"));
			pstmt.setString(1,user.getDatosMenu().idSelected());
			rs = pstmt.executeQuery();
			while (rs.next()) {
				miruta = rs.getString(1);
			}
			rs.close(); pstmt.close();
	        /**Abrir el archivo Dependiendo del parammetro Directorio sacado de BBDD*/
	        try {
	        	// Si no existe el directorio, lo calculo con resource !!
	        	File f = new File(miruta);
	        	if (!f.exists()) throw new Exception("");
	        } catch (Exception exx) {
		        String file = getClass().getResource("config.xml").getFile();
		        int n = file.indexOf("/WEB-INF/classes/dumbo7/notificaciones/config.xml");
		        miruta = file.substring(0,n+1)+"plantillas/";
	        }
				
			pstmt = conn.prepareStatement(getQuery("DeletePlantillas"));
			pstmt.setString(1,user.getDatosMenu().idSelected());
			pstmt.executeUpdate();
			
			pstmt.close();
			
			pstmt = conn.prepareStatement(getQuery("InsertaPlantilla"));
			pstmt.setString(1,user.getDatosMenu().idSelected());
			
			StringBuffer mens = new StringBuffer();
			File [] files = (new File(miruta)).listFiles(this);
			if (files==null) throw new Exception("No existen plantillas en: "+miruta);
			for (int k=0; k<files.length; k++) {
				if (files[k].isFile()) {// && 
					//(files[k].getName().toLowerCase().endsWith("Asig.html") ||
					 //files[k].getName().toLowerCase().endsWith("Reso.html") ||
					 //files[k].getName().toLowerCase().equals("NotUsuInfor.html"))) {
					// Es una plantilla y se sube.
					mens.append("Cargando plantilla "+files[k].getName()+"...");
					pstmt.setString(2,files[k].getName());
					pstmt.setString(3,readFile(files[k]));
					pstmt.executeUpdate();
					mens.append("ok!\n");
				}
			}
			conn.commit();
			Mensaje = mens.toString();
		} catch (Exception ex) {
			setErrorMessage("Error Cargando Plantillas: "+ex);
		} finally {
			try {
				if (rs!=null) rs.close();
				if (pstmt!=null) pstmt.close();
			} catch (Exception ex) {}
		}
	}
	
	public void sendMessageThread() {
		Thread t = new Thread(this);
		t.start();
	}
	
	public void run() {
		try {
			Transport.send(message1);
			if (anxFile!=null && anxFile.exists()) anxFile.delete();
		} catch (Exception ex) {
			System.out.println("Error Enviando Mail: "+ex);
		}
	}

	public boolean accept(File f, String name) {
		if (findTarea==null) return name.endsWith(".html");
		if (padreTarea!=null && !padreTarea.trim().equals("")) return (name.startsWith("F") && (name.indexOf("_"+findTarea+"_")>0 || name.indexOf("_"+padreTarea+"_")>0));
		else return (name.startsWith("F") && name.indexOf("_"+findTarea+"_")>0);
	}
	
	
	/**MTODOS PARA EL MANTENIMIENTO DE PLANTILLAS DESDE DUMBO*/
	//Lista las plantillas desde BBDD.
	public void listaPlantillasNotificaciones(Session conn, Integer flagDefecto)
	{
		try
		{
			Query q = conn.createQuery(getQuery("AllPlantillas"));
			if(flagDefecto!=null)
			{
				if(flagDefecto.equals(new Integer(0)))
				{
					q = q.setString("sist",user.getDatosMenu().idSelected());
				}
				else
				{
					q = q.setString("sist","DEF");
				}
			}
			else{q = q.setString("sist",user.getDatosMenu().idSelected());}

			PlantillasNotificaciones = (List)q.list();		
		}
		catch(Exception ex)
		{
			System.out.println(ex);
		}
	}	
	public void ActualizaPlantilla(Session conn, D7PlantillasNotificaciones pn)
	{
		try
		{
			conn.saveOrUpdate(pn);
			conn.flush();
			conn.connection().commit();
			setErrorMessage("Actualizacin en BBDD realizada.");
		}
		catch(Exception ex)
		{
			setErrorMessage("Error al actualizar plantilla.");
		}
	}
	public void ActualizaPlantillayGuarda(Session conn, D7PlantillasNotificaciones pn)
	{
		D7PlantillasNotificaciones pnDEF = new D7PlantillasNotificaciones();
		pnDEF.setPlnNombre(pn.getPlnNombre());
		pnDEF.setPlnSisCod("DEF");
		pnDEF.setPlnTexto(pn.getPlnTexto());
		try 
		{	
			conn.saveOrUpdate(pnDEF);
			conn.flush();
			conn.connection().commit();
			
			setErrorMessage("Actualizacin en BBDD y fichero realizada.");
		}
		catch(Exception ex)
		{

			setErrorMessage("Error al actualizar plantilla.");
		}
	}

	public void rechazarInforme(Session conn,String inf)
	{
		try {	
			Criteria ct = conn.createCriteria(D7UsuariosNotificaciones.class);
			ct = ct.add(Expression.eq("UnoSisCod",user.getDatosMenu().idSelected()));
			ct = ct.add(Expression.eq("UnoUser",user.getIdentificador()));
			List l = ct.list();
			if (inf==null || inf.equals("")) {
				if (l!=null && l.size()==1) Mensaje = "S";
				else Mensaje = "N";
			} else {
				if (inf.equals("S")) {
					if (l!=null && l.size()==1) return;
					else {
						// Meto la fila.
						Transaction tx = conn.beginTransaction();
						D7UsuariosNotificaciones du = new D7UsuariosNotificaciones();
						du.setUnoSisCod(user.getDatosMenu().idSelected());
						du.setUnoUser(user.getIdentificador());
						du.setUnoFecha(new Date());
						conn.saveOrUpdate(du);
						tx.commit();
					}
					Mensaje = "S";
				} else if (inf.equals("N")) {
					if (l!=null && l.size()==1) {
						// Borro la fila.
						Transaction tx = conn.beginTransaction();
						conn.delete(l.get(0));
						tx.commit();
					} else return;
					Mensaje = "N";
				} else setErrorMessage("Indicador errneo.");
				
			}
		} catch(Exception ex) {
			setErrorMessage("Error al configurar informe: "+ex);
		}
	}
	
	/*public static String reemplaza(String cadena){
		try{
		cadena = cadena.replaceAll("", "A");
		cadena = cadena.replaceAll("", "E");
		cadena = cadena.replaceAll("", "I");
		cadena = cadena.replaceAll("", "O");
		cadena = cadena.replaceAll("", "U");
		cadena = cadena.replaceAll("", "a");
		cadena = cadena.replaceAll("", "e");
		cadena = cadena.replaceAll("", "i");
		cadena = cadena.replaceAll("", "o");
		cadena = cadena.replaceAll("", "u");
		cadena = cadena.replaceAll("", "N");
		cadena = cadena.replaceAll("", "n");
		cadena = cadena.replaceAll("", "U");
		cadena = cadena.replaceAll("", "u");
    
		return cadena;
		
		}catch(Exception ex) {
			return("Error en reemplaza: "+ex);
		}
	}*/

}
