<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet version="1.0" 
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:xforms="http://www.w3.org/2002/xforms">

<xsl:param name="servlet"/>	
<xsl:param name="menu"/>
<xsl:param name="codigoPlantilla"/>
<xsl:param name="previsualiza"/>

<xsl:include href="dumbo7/utils/xsl/utils.xsl"/>
	
<xsl:template match="XMLROOT">

<html lang="es">
	<xsl:call-template name="headComun">
		<xsl:with-param name="ERROR" select="DATA/NOTIFICACIONES/@ERROR"/>
		<xsl:with-param name="jscript">
		<script LANGUAJE="JavaScript">
			function mostrarError(error){
				alert(error);
			}
			function replaceAll(str, strFind, strReplace)
			{
				while (str.indexOf(strFind) > -1)
				{
					str = str.replace(strFind, strReplace);
				}
				return str;
			}
			function previsualizar(nombre)
			{
				var w = window.open('about:blank','Preview','height=500,width=700,status=no,toolbar=no,menubar=no,location=no,scrollbars=yes,resizable=yes');
				//var texto = document.GestionPlantillas.plnTexto.value;
				
				var texto = obtenerTexto();
				
				var URLTexto = window.location.href;
				var urlPos = window.location.href.lastIndexOf('/');
				if (urlPos>=0) URLTexto = URLTexto.substring(0,urlPos+1);
				
				var nombrePos = nombre.indexOf('.html');
				if (urlPos>=0) nombre = nombre.substring(0,nombrePos);
				
				texto = replaceAll(texto,"#IMAGEN#",URLTexto+"../plantillas/imagenes/"+nombre+".gif");
				
				texto = replaceAll(texto,"#INC-PET#","incidencia");
				texto = replaceAll(texto,"#NUM#","1");
				texto = replaceAll(texto,"#USUARIO#",<xsl:call-template name="entrecomillaDescripcion"><xsl:with-param name="descripcion" select="DATA/NOTIFICACIONES/USER/@NAME"/></xsl:call-template>);
				texto = replaceAll(texto,"#INFORMATICO#",<xsl:call-template name="entrecomillaDescripcion"><xsl:with-param name="descripcion" select="DATA/NOTIFICACIONES/USER/@NAME"/></xsl:call-template>);
				texto = replaceAll(texto,"#APLICACION#","Dumbo V.7");
				texto = replaceAll(texto,"#ASUNTO#","Prueba de previsualizacin");
				texto = replaceAll(texto,"#TEXTO#","Este es un texto de prueba para la previsualizacin de plantillas del sistema Dumbo V.7.");
				texto = replaceAll(texto,"#TEX-PASOESPERA#","Este es un texto de prueba para la previsualizacin de plantillas del sistema Dumbo V.7.");
				texto = replaceAll(texto,"#TEX-RECH-PASOESPERA#","Este es un texto de prueba para la previsualizacin de plantillas del sistema Dumbo V.7.");
				texto = replaceAll(texto,"#TEX-RECH-PLANIF#","Este es un texto de prueba para la previsualizacin de plantillas del sistema Dumbo V.7.");
				texto = replaceAll(texto,"#TEX-RESOL#","Este es un texto de prueba para la previsualizacin de plantillas del sistema Dumbo V.7.");
				texto = replaceAll(texto,"#TEX-RECH#","Este es un texto de prueba para la previsualizacin de plantillas del sistema Dumbo V.7.");
				texto = replaceAll(texto,"#TEX-ANU#","Este es un texto de prueba para la previsualizacin de plantillas del sistema Dumbo V.7.");
				texto = replaceAll(texto,"#TEX-REAS#","Este es un texto de prueba para la previsualizacin de plantillas del sistema Dumbo V.7.");
				texto = replaceAll(texto,"#TEX-REAC#","Este es un texto de prueba para la previsualizacin de plantillas del sistema Dumbo V.7.");
				texto = replaceAll(texto,"#TEX-ESP#","Este es un texto de prueba para la previsualizacin de plantillas del sistema Dumbo V.7.");
				texto = replaceAll(texto,"#FECHA-ESP#","20/11/2006");
				texto = replaceAll(texto,"#FECHA-PLANIF#","20/11/2006");
				texto = replaceAll(texto,"#TAR-PEN#","7");
				texto = replaceAll(texto,"#SISTEMA#","Dumbo");
				texto = replaceAll(texto,"#HORAS#","20");
				texto = replaceAll(texto,"#COSTE#","150");
				texto = replaceAll(texto,"#CATEGORIA#","Pruebas de software"); 
				texto = replaceAll(texto,"#CODIGO_TAREA#","1");
				texto = replaceAll(texto,"#TAR_ASUNTO#","Prueba de previsualizacin");
				texto = replaceAll(texto,"#FECHA_CREACION#","10/11/2006");
				texto = replaceAll(texto,"#FECHA_MOVIMIENTO#","15/11/2006");
				texto = replaceAll(texto,"#NIVEL#","1");
				texto = replaceAll(texto,"#TEXTO_TAREA#","Este es un texto de prueba para la previsualizacin de plantillas del sistema Dumbo V.7.");
				texto = replaceAll(texto,"#SOLICITANTE#",<xsl:call-template name="entrecomillaDescripcion"><xsl:with-param name="descripcion" select="DATA/NOTIFICACIONES/USER/@NAME"/></xsl:call-template>);
				texto = replaceAll(texto,"#EXCESO_DIAS#","10");
				texto = replaceAll(texto,"#TIPO_TAREA#","Incidencia");
				texto = replaceAll(texto,"#PRIORIDAD#","Media");
				texto = replaceAll(texto,"#FECHA_PLANIFICACION#","16/11/2006");
				<!--texto = replaceAll(texto,"#PIE#",'<xsl:value-of select="DATA/NOTIFICACIONES/PARAMETRO[@PARAMETRO='PAR_PIE_NOTIF']/@VALOR"/>');-->
				texto = replaceAll(texto,"#PIE#",<xsl:call-template name="entrecomillaDescripcion"><xsl:with-param name="descripcion" select="DATA/NOTIFICACIONES/PARAMETRO[@PARAMETRO='PAR_PIE_NOTIF']/@VALOR"/></xsl:call-template>);
				w.document.write(texto);
					
				/*Sin sustituir
				#TABLA-PENDIENTES#
				#TABLA-ESPERA#
				#TABLA-PLANIFICADA#
				*/
			}
			
			function abrePlantilla(codigo)
			{
				url='?module=dumbo7/notificaciones.GestPlantillas';
				url = url.concat("&amp;codigoPlantilla=");
				url = url.concat(codigo);
				url = url.concat("&amp;flagDefecto=0");
				window.location.href=url;
			}
	
			function ActualizaBBDD(Sistema,Nombre)
			{
				document.GestionPlantillas.plnTexto.value = obtenerTexto();
				
				if(document.GestionPlantillas.plnTexto.length>4000)
				{
					alert("La plantilla no puede superar los 4000 caracteres.");
				}
				else
				{
					document.GestionPlantillas.plnSisCod.value = Sistema;
					document.GestionPlantillas.plnNombre.value = Nombre;
					document.GestionPlantillas.module.value='dumbo7/notificaciones.GestPlantillas.actualiza';
					document.GestionPlantillas.submit();
				}
			}
			
			function GuardaDefecto(Sistema,Nombre)
			{
				document.GestionPlantillas.plnTexto.value = obtenerTexto();
				
				if(document.GestionPlantillas.plnTexto.length>4000)
				{
					alert("La plantilla no puede superar los 4000 caracteres.");
				}
				else
				{
					document.GestionPlantillas.plnSisCod.value = Sistema;
					document.GestionPlantillas.plnNombre.value = Nombre;
					document.GestionPlantillas.module.value='dumbo7/notificaciones.GestPlantillas.actualizaGuarda';
					document.GestionPlantillas.submit();
				}
			}
			
			function CargaDefecto(Nombre)
			{
				url='?module=dumbo7/notificaciones.GestPlantillas';
				url = url.concat("&amp;codigoPlantilla=");
				url = url.concat(Nombre);
				url = url.concat("&amp;flagDefecto=1");
				window.location.href=url;
			}
			
		</script>
		<script language="javascript1.2" src="../js/editorHTML/codethatsdk.js"></script>
		<script language="javascript1.2" src="../js/editorHTML/codethateditorstd.js"></script>
		<script language="javascript1.2" src="../js/editorHTML/style_ex.js"></script>
	</xsl:with-param>
	</xsl:call-template>
	
	<body>
		<xsl:call-template name="menuComun">
			<xsl:with-param name="NAME" select="concat(DATA/NOTIFICACIONES/USER/@NAME,concat('(',concat(DATA/NOTIFICACIONES/USER/@LOGIN,')')))"/>
			<xsl:with-param name="MENU" select="DATA/MENU"/>
			<xsl:with-param name="SELECT" select="$menu"/>
			<xsl:with-param name="HELP">notificaciones.xml#7.3</xsl:with-param>
		</xsl:call-template>
		<xsl:call-template name="pieComun"/>
	</body>
</html>
</xsl:template>

<xsl:template name="cuerpo">
	<xsl:for-each select="DATA/APLICACIONES">
		<xsl:if test="not(@ERROR='')">
			<script>mostrarError('<xsl:value-of select="@ERROR"/>')</script>
			</xsl:if>
	</xsl:for-each>
	<table border="0" cellpadding="5" align="center" cellspacing="5" width="780" summary="Esta tabla contiene la gestion de usuarios">
	<tr>
		<td width="650" class="cab1">&#187;Gestin de Plantillas</td>
	</tr>
	<tr><td colspan="2">
		<form action="{$servlet}" METHOD="POST" name="GestionPlantillas" ENCTYPE="multipart/form-data">
			<input type="hidden" name="module"/>
			<input type="hidden" name="codigoPlantilla" value="{$codigoPlantilla}"/>
			<input type="hidden" name="plnSisCod"/>
			<input type="hidden" name="plnNombre"/>
			<input type="hidden" name="previsualiza"/>
			<table class="cont" border="0" cellpadding="3" cellspacing="0" width="100%" summary="Esta tabla contiene usuarios">
				<tr class="cabe"><td colspan="4"><b>Gestor de plantillas</b></td></tr>
				<tr class="administracion">
					<td width="22%">
						<b>Seleccione una plantilla</b>
					</td>
					<td>
						<select name="PlantillasCod" size="1" onChange="javascript:abrePlantilla(this.value);">
							<!--Al entrar a la pgina no hay ninguna plantilla seleccionada.-->
							<xsl:if test="$codigoPlantilla=''">
								<option value="">-Sin introducir-</option>
								<xsl:for-each select="DATA/NOTIFICACIONES/PLANTILLAS_NOTIFICACIONES">
									<xsl:call-template name="muestraPlantillasSelect">
									<xsl:with-param name="codigoPlantilla" select="@NOMBRE"/>
									</xsl:call-template>
								</xsl:for-each>
							</xsl:if>
							<!--Una vez seleccionada la plantilla, al recargar la pgina debe de aparecer la plantilla que se seleccion.-->
							<xsl:if test="$codigoPlantilla!=''">
								<xsl:for-each select="DATA/NOTIFICACIONES/PLANTILLAS_NOTIFICACIONES[@NOMBRE=$codigoPlantilla]">
									<xsl:call-template name="muestraPlantillasSelect">
									<xsl:with-param name="codigoPlantilla" select="@NOMBRE"/>
									</xsl:call-template>
								</xsl:for-each>
								<xsl:for-each select="DATA/NOTIFICACIONES/PLANTILLAS_NOTIFICACIONES[@NOMBRE!=$codigoPlantilla]">
									<xsl:call-template name="muestraPlantillasSelect">
									<xsl:with-param name="codigoPlantilla" select="@NOMBRE"/>
									</xsl:call-template>
								</xsl:for-each>
							</xsl:if>
						</select>
					</td>
					<xsl:for-each select="DATA/NOTIFICACIONES/PLANTILLAS_NOTIFICACIONES[@NOMBRE=$codigoPlantilla]">
						<td align="right" width="3%"><a href="javascript:GuardaDefecto('{@SISTEMA}','{@NOMBRE}')"><img  border="0" src="../graficos/iconos/guardar.gif" alt="Guardar plantilla como plantilla por defecto"/></a></td>
						<td align="right" width="3%"><a href="javascript:CargaDefecto('{@NOMBRE}')"><img  border="0" src="../graficos/iconos/abrir.gif" alt="Cargar plantilla por defecto"/></a></td>
					</xsl:for-each>
				</tr>

			</table>
			<br/>
			<!--Al seleccionar una plantilla aparece otra tabla donde se puede editar el texto de la misma.-->
			<xsl:if test="$codigoPlantilla!=''">
				<xsl:for-each select="DATA/NOTIFICACIONES/PLANTILLAS_NOTIFICACIONES[@NOMBRE=$codigoPlantilla]">
					<table class="cont" border="0" cellpadding="3" cellspacing="1" width="100%" summary="Esta tabla contiene usuarios">
						<tr class="cabeAlertas">
							<td colspan="2"><b>Editor HTML modo vista</b></td>
						</tr>
						<tr class="administracion">
							<td>
								<input type="hidden" name="plnTexto" value="{@TEXTO}"/>
								<script>
									<!--Se le pasa a CreaEditor los tags permitidos para cada una de las plantillas-->
									switch(document.GestionPlantillas.PlantillasCod.value)
									{
										<!--Tags para notificacin de alertas pendientes de informatico-->
										case "AlertasPendientesInf.html":
											var tagArray = [{name : "#CODIGO_TAREA#" , text : "#CODIGO_TAREA#"},
															{name : "#EXCESO_DIAS#" , text : "#EXCESO_DIAS#"},
															{name : "#FECHA_CREACION#" , text : "#FECHA_CREACION#"},
															{name : "#FECHA_MOVIMIENTO#" , text : "#FECHA_MOVIMIENTO#"},
															{name : "#NIVEL#" , text : "#NIVEL#"},
															{name : "#PIE#" , text : "#PIE#"},
															{name : "#PRIORIDAD#" , text : "#PRIORIDAD#"},
															{name : "#SOLICITANTE#" , text : "#SOLICITANTE#"},
															{name : "#TAR_ASUNTO#" , text : "#TAR_ASUNTO#"},
															{name : "#TEXTO_TAREA#" , text : "#TEXTO_TAREA#"},
															{name : "#TIPO_TAREA#" , text : "#TIPO_TAREA#"}];
											break;
										<!--Tags para notificacin de alertas pendientes de responsable-->
										case "AlertasPendientesRespon.html":
											var tagArray = [{name : "#LISTADO_TAREAS#" , text : "#LISTADO_TAREAS#"},
															{name : "#NIVEL#" , text : "#NIVEL#"},
															{name : "#PIE#" , text : "#PIE#"}];
											break;
										<!--Tags para notificacin de alertas planificadas de informtico-->
										case "AlertasPlanificadasInf.html":
											var tagArray = [{name : "#CODIGO_TAREA#" , text : "#CODIGO_TAREA#"},
															{name : "#EXCESO_DIAS#" , text : "#EXCESO_DIAS#"},
															{name : "#FECHA_CREACION#" , text : "#FECHA_CREACION#"},
															{name : "#FECHA_MOVIMIENTO#" , text : "#FECHA_MOVIMIENTO#"},
															{name : "#FECHA_PLANIFICACION#" , text : "#FECHA_PLANIFICACION#"},
															{name : "#NIVEL#" , text : "#NIVEL#"},
															{name : "#PIE#" , text : "#PIE#"},
															{name : "#SOLICITANTE#" , text : "#SOLICITANTE#"},
															{name : "#TAR_ASUNTO#" , text : "#TAR_ASUNTO#"},
															{name : "#TEXTO_TAREA#" , text : "#TEXTO_TAREA#"},
															{name : "#TIPO_TAREA#" , text : "#TIPO_TAREA#"}];
											break;
										<!--Tags para notificacin de alertas planificadas de responsable-->
										case "AlertasPlanificadasRespon.html":
											var tagArray = [{name : "#LISTADO_TAREAS#" , text : "#LISTADO_TAREAS#"},
															{name : "#NIVEL#" , text : "#NIVEL#"},
															{name : "#PIE#" , text : "#PIE#"}];
											break;
										<!--Tags para notificacin para informtico de anulacin de tarea-->
										case "NotInfAnu.html":									
											var tagArray = [{name : "#APLICACION#" , text : "#APLICACION#"},
															{name : "#ASUNTO#" , text : "#ASUNTO#"},
															{name : "#IMAGEN#" , text : "#IMAGEN#"},
															{name : "#INC-PET#" , text : "#INC-PET#"},
															{name : "#NUM#" , text : "#NUM#"},
															{name : "#PIE#" , text : "#PIE#"},
															{name : "#TEXTO#" , text : "#TEXTO#"},
															{name : "#TEX-ANU#" , text : "#TEX-ANU#"},
															{name : "#USUARIO#" , text : "#USUARIO#"}];
											break;
										<!--Tags para notificacin para informtico de asignacin de tarea-->
										case "NotInfAsig.html":
											var tagArray = [{name : "#APLICACION#" , text : "#APLICACION#"},
															{name : "#ASUNTO#" , text : "#ASUNTO#"},
															{name : "#IMAGEN#" , text : "#IMAGEN#"},
															{name : "#INC-PET#" , text : "#INC-PET#"},
															{name : "#NUM#" , text : "#NUM#"},
															{name : "#PIE#" , text : "#PIE#"},
															{name : "#TEXTO#" , text : "#TEXTO#"},
															{name : "#USUARIO#" , text : "#USUARIO#"}];
											break;
										<!--Tags para notificacin para informtico de asignacin de tarea a cola-->
										case "NotInfAsigCola.html":
											var tagArray = [{name : "#APLICACION#" , text : "#APLICACION#"},
															{name : "#ASUNTO#" , text : "#ASUNTO#"},
															{name : "#IMAGEN#" , text : "#IMAGEN#"},
															{name : "#INC-PET#" , text : "#INC-PET#"},
															{name : "#NUM#" , text : "#NUM#"},
															{name : "#PIE#" , text : "#PIE#"},
															{name : "#TEXTO#" , text : "#TEXTO#"},
															{name : "#USUARIO#" , text : "#USUARIO#"}];
											break;
										<!--Tags para notificacin para informtico de cambio-->
										case "NotInfCamb.html":
											var tagArray = [{name : "#APLICACION#" , text : "#APLICACION#"},
															{name : "#ASUNTO#" , text : "#ASUNTO#"},
															{name : "#IMAGEN#" , text : "#IMAGEN#"},
															{name : "#INC-PET#" , text : "#INC-PET#"},
															{name : "#NUM#" , text : "#NUM#"},
															{name : "#PIE#" , text : "#PIE#"},
															{name : "#TEXTO#" , text : "#TEXTO#"}];
											break;
										<!--Tags para notificacin para informtico de reactivacin de tarea-->
										case "NotInfReac.html":
											var tagArray = [{name : "#APLICACION#" , text : "#APLICACION#"},
															{name : "#ASUNTO#" , text : "#ASUNTO#"},
															{name : "#IMAGEN#" , text : "#IMAGEN#"},
															{name : "#INC-PET#" , text : "#INC-PET#"},
															{name : "#NUM#" , text : "#NUM#"},
															{name : "#PIE#" , text : "#PIE#"},
															{name : "#TEXTO#" , text : "#TEXTO#"},
															{name : "#TEX-REAC#" , text : "#TEX-REAC#"},
															{name : "#USUARIO#" , text : "#USUARIO#"}];
											break;
										<!--Tags para notificacin para informtico de anulacin de reactivacin de tarea-->
										case "NotInfReacAnu.html":
											var tagArray = [{name : "#APLICACION#" , text : "#APLICACION#"},
															{name : "#ASUNTO#" , text : "#ASUNTO#"},
															{name : "#IMAGEN#" , text : "#IMAGEN#"},
															{name : "#INC-PET#" , text : "#INC-PET#"},
															{name : "#NUM#" , text : "#NUM#"},
															{name : "#PIE#" , text : "#PIE#"},
															{name : "#TEXTO#" , text : "#TEXTO#"},
															{name : "#TEX-ANU#" , text : "#TEX-ANU#"},
															{name : "#TEX-REAC#" , text : "#TEX-REAC#"},
															{name : "#USUARIO#" , text : "#USUARIO#"}];
											break;
										<!--Tags para notificacin para informtico de reasignacin de tarea-->
										case "NotInfReas.html":
											var tagArray = [{name : "#APLICACION#" , text : "#APLICACION#"},
															{name : "#ASUNTO#" , text : "#ASUNTO#"},
															{name : "#IMAGEN#" , text : "#IMAGEN#"},
															{name : "#INC-PET#" , text : "#INC-PET#"},
															{name : "#NUM#" , text : "#NUM#"},
															{name : "#PIE#" , text : "#PIE#"},
															{name : "#TEXTO#" , text : "#TEXTO#"},
															{name : "#TEX-REAS#" , text : "#TEX-REAS#"},
															{name : "#USUARIO#" , text : "#USUARIO#"}];
											break;
										<!--Tags para notificacin para informtico de rechazo de tarea-->
										case "NotInfRech.html":
											var tagArray = [{name : "#APLICACION#" , text : "#APLICACION#"},
															{name : "#ASUNTO#" , text : "#ASUNTO#"},
															{name : "#IMAGEN#" , text : "#IMAGEN#"},
															{name : "#INC-PET#" , text : "#INC-PET#"},
															{name : "#NUM#" , text : "#NUM#"},
															{name : "#PIE#" , text : "#PIE#"},
															{name : "#TEXTO#" , text : "#TEXTO#"},
															{name : "#TEX-RECH#" , text : "#TEX-RECH#"},
															{name : "#TEX-RESOL#" , text : "#TEX-RESOL#"},
															{name : "#USUARIO#" , text : "#USUARIO#"}];
											break;
										<!--Tags para notificacin para informtico de rechazo de tarea-->
										case "NotInfRechPlanif.html":
											var tagArray = [{name : "#APLICACION#" , text : "#APLICACION#"},
															{name : "#ASUNTO#" , text : "#ASUNTO#"},
															{name : "#IMAGEN#" , text : "#IMAGEN#"},
															{name : "#NUM#" , text : "#NUM#"},
															{name : "#PIE#" , text : "#PIE#"},
															{name : "#TEXTO#" , text : "#TEXTO#"},
															{name : "#TEX-RECH-PLANIF#" , text : "#TEX-RECH-PLANIF#"},
															{name : "#USUARIO#" , text : "#USUARIO#"}];
											break;
										<!--Tags para notificacin para informtico de rechazo de paso a espera-->
										case "NotInfRechPasoEspera.html":
											var tagArray = [{name : "#APLICACION#" , text : "#APLICACION#"},
															{name : "#ASUNTO#" , text : "#ASUNTO#"},
															{name : "#IMAGEN#" , text : "#IMAGEN#"},
															{name : "#INC-PET#" , text : "#INC-PET#"},
															{name : "#NUM#" , text : "#NUM#"},
															{name : "#PIE#" , text : "#PIE#"},
															{name : "#TEXTO#" , text : "#TEXTO#"},
															{name : "#TEX-PASOESPERA#" , text : "#TEX-PASOESPERA#"},
															{name : "#TEX-RECH-PASOESPERA#" , text : "#TEX-RECH-PASOESPERA#"},
															{name : "#USUARIO#" , text : "#USUARIO#"}];
											break;
										<!--Tags para notificacin para usuario de anulacin-->
										case "NotUsuAnu.html":
											var tagArray = [{name : "#APLICACION#" , text : "#APLICACION#"},
															{name : "#ASUNTO#" , text : "#ASUNTO#"},
															{name : "#IMAGEN#" , text : "#IMAGEN#"},
															{name : "#INC-PET#" , text : "#INC-PET#"},
															{name : "#INFORMATICO#" , text : "#INFORMATICO#"},
															{name : "#NUM#" , text : "#NUM#"},
															{name : "#PIE#" , text : "#PIE#"},
															{name : "#PINCHE#" , text : "#PINCHE#"},
															{name : "#TEXTO#" , text : "#TEXTO#"},
															{name : "#TEX-ANU#" , text : "#TEX-ANU#"}];
											break;
										<!--Tags para notificacin para usuario de asignacin-->
										case "NotUsuAsig.html":
											var tagArray = [{name : "#APLICACION#" , text : "#APLICACION#"},
															{name : "#ASUNTO#" , text : "#ASUNTO#"},
															{name : "#IMAGEN#" , text : "#IMAGEN#"},
															{name : "#INC-PET#" , text : "#INC-PET#"},
															{name : "#INFORMATICO#" , text : "#INFORMATICO#"},
															{name : "#NUM#" , text : "#NUM#"},
															{name : "#PIE#" , text : "#PIE#"},
															{name : "#TAR-PEN#" , text : "#TAR-PEN#"},
															{name : "#TEXTO#" , text : "#TEXTO#"}];
											break;
										<!--Tags para notificacin para usuario de espera-->
										case "NotUsuEsp.html":
											var tagArray = [{name : "#APLICACION#" , text : "#APLICACION#"},
															{name : "#ASUNTO#" , text : "#ASUNTO#"},
															{name : "#FECHA-ESP#" , text : "#FECHA-ESP#"},
															{name : "#IMAGEN#" , text : "#IMAGEN#"},
															{name : "#INC-PET#" , text : "#INC-PET#"},
															{name : "#NUM#" , text : "#NUM#"},
															{name : "#PIE#" , text : "#PIE#"},
															{name : "#PINCHE#" , text : "#PINCHE#"},
															{name : "#TEXTO#" , text : "#TEXTO#"},
															{name : "#TEX-ESP#" , text : "#TEX-ESP#"}];
											break;
										<!--Tags para notificacin para usuario de informe-->
										case "NotUsuInfor.html":
											var tagArray = [{name : "#IMAGEN#" , text : "#IMAGEN#"},
															{name : "#PIE#" , text : "#PIE#"},
															{name : "#PINCHE#" , text : "#PINCHE#"},
															{name : "#SISTEMA#" , text : "#SISTEMA#"},
															{name : "#TABLA-ESPERA#" , text : "#TABLA-ESPERA#"},
															{name : "#TABLA-PENDIENTES#" , text : "#TABLA-PENDIENTES#"},
															{name : "#TABLA-PLANIFICADA#" , text : "#TABLA-PLANIFICADA#"}];
											break;
										<!--Tags para notificacin para usuario de planficacin-->
										case "NotUsuPlanif.html":
											var tagArray = [{name : "#APLICACION#" , text : "#APLICACION#"},
															{name : "#ASUNTO#" , text : "#ASUNTO#"},
															{name : "#FECHA-PLANIF#" , text : "#FECHA-PLANIF#"},
															{name : "#IMAGEN#" , text : "#IMAGEN#"},
															{name : "#INC-PET#" , text : "#INC-PET#"},
															{name : "#NUM#" , text : "#NUM#"},
															{name : "#PIE#" , text : "#PIE#"},
															{name : "#PINCHE#" , text : "#PINCHE#"},
															{name : "#TEXTO#" , text : "#TEXTO#"}];
											break;
										<!--Tags para notificacin para usuario de reactivacin-->
										case "NotUsuReac.html":
											var tagArray = [{name : "#APLICACION#" , text : "#APLICACION#"},
															{name : "#ASUNTO#" , text : "#ASUNTO#"},
															{name : "#IMAGEN#" , text : "#IMAGEN#"},
															{name : "#INC-PET#" , text : "#INC-PET#"},
															{name : "#INFORMATICO#" , text : "#INFORMATICO#"},
															{name : "#NUM#" , text : "#NUM#"},
															{name : "#PIE#" , text : "#PIE#"},
															{name : "#TAR-PEN#" , text : "#TAR-PEN#"},
															{name : "#TEXTO#" , text : "#TEXTO#"},
															{name : "#TEX-REAC#" , text : "#TEX-REAC#"}];
											break;
										<!--Tags para notificacin para usuario de reasignacin-->
										case "NotUsuReas.html":
											var tagArray = [{name : "#APLICACION#" , text : "#APLICACION#"},
															{name : "#ASUNTO#" , text : "#ASUNTO#"},
															{name : "#IMAGEN#" , text : "#IMAGEN#"},
															{name : "#INC-PET#" , text : "#INC-PET#"},
															{name : "#INFORMATICO#" , text : "#INFORMATICO#"},
															{name : "#NUM#" , text : "#NUM#"},
															{name : "#PIE#" , text : "#PIE#"},
															{name : "#TAR-PEN#" , text : "#TAR-PEN#"},
															{name : "#TEXTO#" , text : "#TEXTO#"}];
											break;
										<!--Tags para notificacin para usuario de resolucin-->
										case "NotUsuReso.html":
											var tagArray = [{name : "#APLICACION#" , text : "#APLICACION#"},{name : "#ASUNTO#" , text : "#ASUNTO#"},
															{name : "#CATEGORIA#" , text : "#CATEGORIA#"},{name : "#COSTE#" , text : "#COSTE#"},
															{name : "#HORAS#" , text : "#HORAS#"},{name : "#IMAGEN#" , text : "#IMAGEN#"},
															{name : "#INC-PET#" , text : "#INC-PET#"},{name : "#NUM#" , text : "#NUM#"},
															{name : "#PIE#" , text : "#PIE#"},{name : "#PINCHE#" , text : "#PINCHE#"},
															{name : "#TEXTO#" , text : "#TEXTO#"},{name : "#TEX-RESOL#" , text : "#TEX-RESOL#"}];
											break;
										<!--Tags para notificacin para usuario de resolucin telefnica-->
										case "NotUsuResoTlf.html":
											var tagArray = [{name : "#APLICACION#" , text : "#APLICACION#"},{name : "#ASUNTO#" , text : "#ASUNTO#"},
															{name : "#IMAGEN#" , text : "#IMAGEN#"},{name : "#INC-PET#" , text : "#INC-PET#"},
															{name : "#NUM#" , text : "#NUM#"},{name : "#PIE#" , text : "#PIE#"},
															{name : "#TEXTO#" , text : "#TEXTO#"}];
											break;
										default: break;
									};
									
									creaEditor(document.GestionPlantillas.plnTexto.value, tagArray);
								</script>
							</td>
							<xsl:variable name="Traducido"><xsl:call-template name="traduce"><xsl:with-param name="id" select="'Informtico'"/></xsl:call-template></xsl:variable>
							<xsl:variable name="traducido"><xsl:call-template name="traduce"><xsl:with-param name="id" select="'informtico'"/></xsl:call-template></xsl:variable>
							<td>
								<b><u>Tags disponibles</u></b>
							<xsl:if test="@NOMBRE='NotInfAnu.html' or @NOMBRE='NotInfAsig.html' or 
										   @NOMBRE='NotInfCamb.html' or @NOMBRE='NotInfReac.html' or
										   @NOMBRE='NotInfReacAnu.html' or @NOMBRE='NotInfReas.html' or
										   @NOMBRE='NotInfRech.html' or @NOMBRE='NotInfRechPasoEspera.html' or
										   @NOMBRE='NotUsuAnu.html' or @NOMBRE='NotUsuAsig.html' or
										   @NOMBRE='NotUsuEsp.html' or @NOMBRE='NotUsuPlanif.html' or
										   @NOMBRE='NotUsuReac.html' or @NOMBRE='NotUsuReas.html' or
										   @NOMBRE='NotUsuReso.html' or @NOMBRE='NotUsuResoTlf.html' or
										   @NOMBRE='NotInfRechPlanif.html' or @NOMBRE='NotInfAsigCola.html'">
									<br/><label title="Indica si el nombre de la aplicacin vinculada a la tarea">#APLICACION#</label>
							</xsl:if>
							<xsl:if test="@NOMBRE='NotInfAnu.html' or @NOMBRE='NotInfAsig.html' or 
										   @NOMBRE='NotInfCamb.html' or @NOMBRE='NotInfReac.html' or
										   @NOMBRE='NotInfReacAnu.html' or @NOMBRE='NotInfReas.html' or
										   @NOMBRE='NotInfRech.html' or @NOMBRE='NotInfRechPasoEspera.html' or
										   @NOMBRE='NotUsuAnu.html' or @NOMBRE='NotUsuAsig.html' or
										   @NOMBRE='NotUsuEsp.html' or @NOMBRE='NotUsuPlanif.html' or
										   @NOMBRE='NotUsuReac.html' or @NOMBRE='NotUsuReas.html' or
										   @NOMBRE='NotUsuReso.html' or @NOMBRE='NotUsuResoTlf.html' or
										   @NOMBRE='NotInfRechPlanif.html' or @NOMBRE='NotInfAsigCola.html'">
									<br/><label title="Asunto de la tarea">#ASUNTO#</label>
							</xsl:if>
							<xsl:if test="@NOMBRE='NotUsuReso.html'">
								<br/><label title="Categora de resolucin de la tarea">#CATEGORIA#</label>
							</xsl:if>
							<xsl:if test="@NOMBRE='AlertasPendientesInf.html' or @NOMBRE='AlertasPlanificadasInf.html'">
								<br/><label title="Cdigo de la tarea que gener la alerta">#CODIGO_TAREA#</label>
							</xsl:if>
							<xsl:if test="@NOMBRE='NotUsuReso.html'">
								<br/><label title="Coste asociado a la resolucin de una tarea">#COSTE#</label>
							</xsl:if>
							<xsl:if test="@NOMBRE='AlertasPendientesInf.html' or @NOMBRE='AlertasPlanificadasInf.html'">
								<br/><label title="Nmero de das excedidos">#EXCESO_DIAS#</label>
							</xsl:if>
							<xsl:if test="@NOMBRE='AlertasPendientesInf.html' or @NOMBRE='AlertasPlanificadasInf.html'">
								<br/><label title="Fecha de creacin de la tarea que gener la alerta">#FECHA_CREACION#</label>
							</xsl:if>
							<xsl:if test="@NOMBRE='NotUsuEsp.html'">
								<br/><label title="Fecha del paso a espera">#FECHA-ESP#</label>
							</xsl:if>
							<xsl:if test="@NOMBRE='AlertasPendientesInf.html' or @NOMBRE='AlertasPlanificadasInf.html'">
								<br/><label title="Fecha del ltimo movimiento de la tarea que gener la alerta">#FECHA_MOVIMIENTO#</label>
							</xsl:if>
							<xsl:if test="@NOMBRE='AlertasPlanificadasInf.html'">
								<br/><label title="Fecha de planificacin de la tarea planificada que gener la alerta">#FECHA_PLANIFICACION#</label>
							</xsl:if>
							<xsl:if test="@NOMBRE='NotUsuPlanif.html'">
								<br/><label title="Fecha de planificacin de la tarea">#FECHA-PLANIF#</label>
							</xsl:if>
							<xsl:if test="@NOMBRE='NotUsuReso.html'">
								<br/><label title="Horas en resolver una tarea">#HORAS#</label>
							</xsl:if>
							<xsl:if test="@NOMBRE!='AlertasPendientesRespon.html' and @NOMBRE!='AlertasPlanificadasRespon.html'
										  and @NOMBRE!='AlertasPendientesInf.html' and @NOMBRE!='AlertasPlanificadasInf.html'">
								<br/><label title="Imagen a mostrar en el correo">#IMAGEN#</label>
							</xsl:if>
							<xsl:if test="@NOMBRE='NotInfAnu.html' or @NOMBRE='NotInfAsig.html' or 
										   @NOMBRE='NotInfCamb.html' or @NOMBRE='NotInfReac.html' or
										   @NOMBRE='NotInfReacAnu.html' or @NOMBRE='NotInfReas.html' or
										   @NOMBRE='NotInfRech.html' or @NOMBRE='NotInfRechPasoEspera.html' or
										   @NOMBRE='NotUsuAnu.html' or @NOMBRE='NotUsuAsig.html' or
										   @NOMBRE='NotUsuEsp.html' or @NOMBRE='NotUsuPlanif.html' or
										   @NOMBRE='NotUsuReac.html' or @NOMBRE='NotUsuReas.html' or
										   @NOMBRE='NotUsuReso.html' or @NOMBRE='NotUsuResoTlf.html' or
										   @NOMBRE='NotInfAsigCola.html'">
								<br/><label title="Indica si la tarea es incidencia o peticin">#INC-PET#</label>
							</xsl:if>
							<xsl:if test="@NOMBRE='NotUsuAnu.html' or @NOMBRE='NotUsuAsig.html' or
										  @NOMBRE='NotUsuReac.html' or @NOMBRE='NotUsuReas.html'">
								<br/><label title="{$Traducido} asignado a la tarea">#INFORMATICO#</label>
							</xsl:if>
							<xsl:if test="@NOMBRE='AlertasPendientesRespon.html' or @NOMBRE='AlertasPlanificadasRespon.html'">
								<br/><label title="Listado en forma de tabla de las tareas con alertas, que tienen relacin con el responsable">#LISTADO_TAREAS#</label>
							</xsl:if>
							<xsl:if test="@NOMBRE='AlertasPendientesInf.html' or @NOMBRE='AlertasPlanificadasInf.html' or
										  @NOMBRE='AlertasPendientesRespon.html' or @NOMBRE='AlertasPlanificadasRespon.html'">
								<br/><label title="Nivel de la alerta generada">#NIVEL#</label>
							</xsl:if>
							<xsl:if test="@NOMBRE='NotInfAnu.html' or @NOMBRE='NotInfAsig.html' or 
										   @NOMBRE='NotInfCamb.html' or @NOMBRE='NotInfReac.html' or
										   @NOMBRE='NotInfReacAnu.html' or @NOMBRE='NotInfReas.html' or
										   @NOMBRE='NotInfRech.html' or @NOMBRE='NotInfRechPasoEspera.html' or
										   @NOMBRE='NotUsuAnu.html' or @NOMBRE='NotUsuAsig.html' or
										   @NOMBRE='NotUsuEsp.html' or @NOMBRE='NotUsuPlanif.html' or
										   @NOMBRE='NotUsuReac.html' or @NOMBRE='NotUsuReas.html' or
										   @NOMBRE='NotUsuReso.html' or @NOMBRE='NotUsuResoTlf.html' or
										   @NOMBRE='NotInfRechPlanif.html' or @NOMBRE='NotInfAsigCola.html'">
								<br/><label title="Indica el cdigo de la tarea">#NUM#</label>
							</xsl:if>
							<br/><label title="Pie del correo">#PIE#</label>
							<xsl:if test="@NOMBRE='NotUsuAnu.html' or @NOMBRE='NotUsuEsp.html' or
										  @NOMBRE='NotUsuInfor.html' or @NOMBRE='NotUsuPlanif.html' or
										  @NOMBRE='NotUsuReso.html'">
								<br/><label title="Introduce una URL para cuando no exista conformidad con el correo recibido">#PINCHE#</label>
							</xsl:if>
							<xsl:if test="@NOMBRE='AlertasPendientesInf.html'">
								<br/><label title="Prioridad de la tarea">#PRIORIDAD#</label>
							</xsl:if>
							<xsl:if test="@NOMBRE='NotUsuInfor.html'">
								<br/><label title="Descripcin del sistema">#SISTEMA#</label>
							</xsl:if>
							<xsl:if test="@NOMBRE='AlertasPendientesInf.html' or @NOMBRE='AlertasPlanificadasInf.html'">
								<br/><label title="Solicitante de la tarea que gener la alerta">#SOLICITANTE#</label>
							</xsl:if>
							<xsl:if test="@NOMBRE='AlertasPendientesInf.html' or @NOMBRE='AlertasPlanificadasInf.html'">
								<br/><label title="Asunto de la tarea que gener la alerta">#TAR_ASUNTO#</label>
							</xsl:if>
							<xsl:if test="@NOMBRE='NotUsuInfor.html'">
								<br/><label title="Listado de las tareas en espera">#TABLA-ESPERA#</label>
							</xsl:if>
							<xsl:if test="@NOMBRE='NotUsuInfor.html'">
								<br/><label title="Listado de las tareas pendientes">#TABLA-PENDIENTES#</label>
							</xsl:if>
							<xsl:if test="@NOMBRE='NotUsuInfor.html'">
								<br/><label title="Listado de las tareas planificadas">#TABLA-PLANIFICADA#</label>
							</xsl:if>
							<xsl:if test="@NOMBRE='NotUsuAsig.html' or @NOMBRE='NotUsuReac.html' or
										  @NOMBRE='NotUsuReas.html'">
								<br/><label title="Texto que indica el nmero de tareas pendientes">#TAR-PEN#</label>
							</xsl:if>
							<xsl:if test="@NOMBRE='NotInfAnu.html' or @NOMBRE='NotInfAsig.html' or 
										   @NOMBRE='NotInfCamb.html' or @NOMBRE='NotInfReac.html' or
										   @NOMBRE='NotInfReacAnu.html' or @NOMBRE='NotInfReas.html' or
										   @NOMBRE='NotInfRech.html' or @NOMBRE='NotInfRechPasoEspera.html' or
										   @NOMBRE='NotUsuAnu.html' or @NOMBRE='NotUsuAsig.html' or
										   @NOMBRE='NotUsuEsp.html' or @NOMBRE='NotUsuPlanif.html' or
										   @NOMBRE='NotUsuReac.html' or @NOMBRE='NotUsuReas.html' or
										   @NOMBRE='NotUsuReso.html' or @NOMBRE='NotUsuResoTlf.html' or
										   @NOMBRE='NotInfRechPlanif.html' or @NOMBRE='NotInfAsigCola.html'">
								<br/><label title="Texto de la tarea">#TEXTO#</label>
							</xsl:if>
							<xsl:if test="@NOMBRE='AlertasPendientesInf.html' or @NOMBRE='AlertasPlanificadasInf.html'">
								<br/><label title="Texto de la tarea que gener la alerta">#TEXTO_TAREA#</label>
							</xsl:if>
							<xsl:if test="@NOMBRE='NotInfAnu.html' or @NOMBRE='NotInfReacAnu.html' or @NOMBRE='NotUsuAnu.html'">
								  <br/><label title="Texto de anulacin de tarea">#TEX-ANU#</label>
							</xsl:if>
							<xsl:if test="@NOMBRE='NotUsuEsp.html'">
								<br/><label title="Texto del motivo de paso a espera">#TEX-ESP#</label>
							</xsl:if>
							<xsl:if test="@NOMBRE='NotInfRechPasoEspera.html'">							
								<br/><label title="Texto introducido por el {$traducido} al pasar a espera">#TEX-PASOESPERA#</label>
							</xsl:if>
							<xsl:if test="@NOMBRE='NotInfReac.html' or @NOMBRE='NotInfReacAnu.html' or
										  @NOMBRE='NotUsuReac.html'">
								<br/><label title="Texto del motivo de reactivacin de la tarea">#TEX-REAC#</label>
							</xsl:if>
							<xsl:if test="@NOMBRE='NotInfReas.html'">
								<br/><label title="Texto introducido al reasignar tarea">#TEX-REAS#</label>
							</xsl:if>
							<xsl:if test="@NOMBRE='NotInfRech.html'">
								<br/><label title="Texto de rechazo de tarea">#TEX-RECH#</label>
							</xsl:if>
							<xsl:if test="@NOMBRE='NotInfRechPlanif.html'">
								<br/><label title="Texto de rechazo de tarea">#TEX-RECH-PLANIF#</label>
							</xsl:if>
							<xsl:if test="@NOMBRE='NotInfRechPasoEspera.html'">
								<br/><label title="Texto introducido por el usuario para rechazar el paso a espera">#TEX-RECH-PASOESPERA#</label>
							</xsl:if>
							<xsl:if test="@NOMBRE='NotInfRech.html' or @NOMBRE='NotUsuReso.html'">
								<br/><label title="Texto de resolucin de tarea">#TEX-RESOL#</label>
							</xsl:if>
							<xsl:if test="@NOMBRE='AlertasPendientesInf.html' or @NOMBRE='AlertasPlanificadasInf.html'">
								<br/><label title="Tipo de la tarea que gener la alerta">#TIPO_TAREA#</label>
							</xsl:if>
							<xsl:if test="@NOMBRE='NotInfAnu.html' or @NOMBRE='NotInfAsig.html' or 
										   @NOMBRE='NotInfReac.html' or @NOMBRE='NotInfReacAnu.html' or
										   @NOMBRE='NotInfReas.html' or @NOMBRE='NotInfRech.html' or
										   @NOMBRE='NotInfRechPasoEspera.html' or @NOMBRE='NotInfRechPlanif.html' or
										   @NOMBRE='NotInfAsigCola.html'">
								<br/><label title="Nombre del usuario que solicit la tarea">#USUARIO#</label>
							</xsl:if>
							</td>
						</tr>
						<tr class="cabeAlertas"><td colspan="2"><b>Editor HTML modo texto</b></td></tr>
						<tr class="administracion">
							<td>
								<TEXTAREA ROWS="10" COLS="122" NAME="plnTextoTA" wrap="VIRTUAL" onChange="introduceTexto(this.value)" onFocus="this.value = obtenerTexto();">
									<xsl:value-of select="@TEXTO"/>
								</TEXTAREA>
							</td>
							<td></td>
						</tr>
						<tr class="administracion">
							<td align="center" colspan="2">
								<!--<input type="button" class="boton" value="Guardar" onclick="javascript:ActualizaBBDD('{@SISTEMA}','{@NOMBRE}')" title="Guardar plantilla para sistema actual"/>&#160;-->
								<xsl:variable name="textoGuardar"><xsl:value-of select="concat('Guardar plantilla para sistema ',@SISTEMA)"/></xsl:variable> 
								<input type="button" class="boton" value="Guardar" onclick="javascript:ActualizaBBDD('{@SISTEMA}','{@NOMBRE}')" title='{$textoGuardar}'/>&#160;
								<input type="button" class="boton" value="Previsualizar" onclick="javascript:previsualizar('{@NOMBRE}')" title='Previsualizar plantilla'/>
							</td>
						</tr>
					</table>
				</xsl:for-each>
			</xsl:if>
		</form>
	</td>
	</tr>
	</table>
</xsl:template>
<!--Esta plantilla relaciona los nombres de fichero de las plantillas con un breve descripcin de la misma.
	Si se desean aadir nuevas plantillas en base de datos, y que estas se puedan editar, hay que modificar
	este template-->
<xsl:template name="muestraPlantillasSelect">
	<xsl:param name="codigoPlantilla"/>
	
	<xsl:if test="$codigoPlantilla = 'AlertasPendientesInf.html'">
		<option value="AlertasPendientesInf.html">Notificacin de alertas pendientes para <xsl:call-template name="traduce"><xsl:with-param name="id" select="'informticos'"/></xsl:call-template></option>
	</xsl:if>
	<xsl:if test="$codigoPlantilla = 'AlertasPendientesRespon.html'">
		<option value="AlertasPendientesRespon.html">Notificacin de alertas pendientes para responsables</option>
	</xsl:if>
	<xsl:if test="$codigoPlantilla = 'AlertasPlanificadasInf.html'">
		<option value="AlertasPlanificadasInf.html">Notificacin de alertas planificadas para <xsl:call-template name="traduce"><xsl:with-param name="id" select="'informticos'"/></xsl:call-template></option>
	</xsl:if>
	<xsl:if test="$codigoPlantilla = 'AlertasPlanificadasRespon.html'">
		<option value="AlertasPlanificadasRespon.html">Notificacin de alertas planificadas para responsables</option>
	</xsl:if>
	<xsl:if test="$codigoPlantilla = 'NotInfAnu.html'">
		<option value="NotInfAnu.html">Notificacin para <xsl:call-template name="traduce"><xsl:with-param name="id" select="'informtico'"/></xsl:call-template> de anulacin de tarea</option>
	</xsl:if>
	<xsl:if test="$codigoPlantilla = 'NotInfAsig.html'">	
		<option value="NotInfAsig.html">Notificacin para <xsl:call-template name="traduce"><xsl:with-param name="id" select="'informtico'"/></xsl:call-template> de asignacin de tarea</option>
	</xsl:if>
	<xsl:if test="$codigoPlantilla = 'NotInfCamb.html'">		
		<option value="NotInfCamb.html">Notificacin para <xsl:call-template name="traduce"><xsl:with-param name="id" select="'informtico'"/></xsl:call-template> de cambio de texto o urgencia</option>
	</xsl:if>
	<xsl:if test="$codigoPlantilla = 'NotInfReac.html'">		
		<option value="NotInfReac.html">Notificacin para <xsl:call-template name="traduce"><xsl:with-param name="id" select="'informtico'"/></xsl:call-template> de reactivacin de tarea</option>
	</xsl:if>
	<xsl:if test="$codigoPlantilla = 'NotInfReacAnu.html'">		
		<option value="NotInfReacAnu.html">Notificacin para <xsl:call-template name="traduce"><xsl:with-param name="id" select="'informtico'"/></xsl:call-template> de reactivacin de tarea anulada</option>
	</xsl:if>
	<xsl:if test="$codigoPlantilla = 'NotInfReas.html'">	
		<option value="NotInfReas.html">Notificacin para <xsl:call-template name="traduce"><xsl:with-param name="id" select="'informtico'"/></xsl:call-template> de reasignacin de tarea</option>
	</xsl:if>
	<xsl:if test="$codigoPlantilla = 'NotInfReach.html'">	
		<option value="NotInfReach.html">Notificacin para <xsl:call-template name="traduce"><xsl:with-param name="id" select="'informtico'"/></xsl:call-template> de rechazo de tarea</option>
	</xsl:if>
	<xsl:if test="$codigoPlantilla = 'NotInfReachPasoEspera.html'">		
		<option value="NotInfReachPasoEspera.html">Notificacin para <xsl:call-template name="traduce"><xsl:with-param name="id" select="'informtico'"/></xsl:call-template> de rechazo de paso a espera de tarea</option>
	</xsl:if>
		<xsl:if test="$codigoPlantilla = 'NotInfAsigCola.html'">	
		<option value="NotInfAsigCola.html">Notificacin para <xsl:call-template name="traduce"><xsl:with-param name="id" select="'informtico'"/></xsl:call-template> de asignacin de tare a cola de aplicacin</option>
	</xsl:if>
	<xsl:if test="$codigoPlantilla = 'NotInfRechPlanif.html'">		
		<option value="NotInfRechPlanif.html">Notificacin para <xsl:call-template name="traduce"><xsl:with-param name="id" select="'informtico'"/></xsl:call-template> de rechazo de planificacin de tarea</option>
	</xsl:if>
	<xsl:if test="$codigoPlantilla = 'NotUsuAnu.html'">	
		<option value="NotUsuAnu.html">Notificacin para usuario de anulacin de tarea</option>
	</xsl:if>
	<xsl:if test="$codigoPlantilla = 'NotUsuAsig.html'">		
		<option value="NotUsuAsig.html">Notificacin para usuario de asignacin de tarea</option>
	</xsl:if>
	<xsl:if test="$codigoPlantilla = 'NotUsuEsp.html'">		
		<option value="NotUsuEsp.html">Notificacin para usuario de tarea en espera</option>
	</xsl:if>
	<xsl:if test="$codigoPlantilla = 'NotUsuInfor.html'">		
		<option value="NotUsuInfor.html">Notificacin para usuario del informe peridico</option>
	</xsl:if>
	<xsl:if test="$codigoPlantilla = 'NotUsuPlanif.html'">	
		<option value="NotUsuPlanif.html">Notificacin para usuario de tarea planificada</option>
	</xsl:if>
	<xsl:if test="$codigoPlantilla = 'NotUsuReac.html'">		
		<option value="NotUsuReac.html">Notificacin para usuario de reactivacin de tarea</option>
	</xsl:if>
	<xsl:if test="$codigoPlantilla = 'NotUsuReas.html'">		
		<option value="NotUsuReas.html">Notificacin para usuario de reasignacin de tarea</option>
	</xsl:if>
	<xsl:if test="$codigoPlantilla = 'NotUsuReso.html'">	
		<option value="NotUsuReso.html">Notificacin para usuario de resolucin de tarea</option>
	</xsl:if>
	<xsl:if test="$codigoPlantilla = 'NotUsuResoTlf.html'">		
		<option value="NotUsuResoTlf.html">Notificacin para usuario de resolucin telefnica de tarea</option>
	</xsl:if>
</xsl:template>

</xsl:stylesheet>
