/*
 * 
 *
 */
package dumbo7.remote;

import org.apache.log4j.*;
import atica.frameweb.utils.*;
import dumbo7.GestorGenerico;
import dumbo7.user.*;
import dumbo7.utils.*;

import java.util.*;

import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.hibernate.*;
import org.hibernate.criterion.*;
import dumbo7.solicitudes.*;

/**
 * @author Universidad de Murcia - ATICA
 *
 */

public class GestorRemote extends GeneralManager {
	
	static Logger logger = Logger.getLogger(GestorRemote.class);
	
	private D7TareasExternas tarData = null;
	private String formId = null;
	private String formTitle = null;
	private List formularios = null;
	private String urlOk = null;
	private String urlNoOk = null;
	private boolean imgCodeOk = false;
	
	private GestorSolicitudes gestSol = null;
	
	public GestorRemote() {}
	
	public void datosSolicitudRemota(Session conn,String id) {
		try {
			setFormId(id);
			
			Criteria ct = conn.createCriteria(D7TareasExternas.class);
			ct = ct.add(Expression.eq("TarextId",id));
			List l = ct.list();
			if (l!=null && l.size()>0) {
				tarData = (D7TareasExternas)l.get(0);
				setFormTitle(tarData.getTarextTitulo());
			} else {
				setErrorMessage("La Solicitud indicada no est disponible.");
			}
			
		} catch (Exception ex) {
			setErrorMessage("Error Generando Solicitud: "+ex);
		}
	}
	
	public void createContextPath(HttpServlet servlet,HttpServletRequest req,HttpServletResponse res) {
		if (!imgCodeOk) return;
		gestSol.createContextPath(servlet,req,res);
	}
	public void readAnexo(Hashtable anexo) { if (!imgCodeOk) return; gestSol.readAnexo(anexo); }
	public void saveSolicitud(Session conn,dumbo7.utils.D7Tareas sol) {	if (!imgCodeOk) return; gestSol.saveSolicitud(conn,sol); }
	
	public void createTemporalUser(Session conn,String sist) {
		if (!imgCodeOk) return;
		try {
			// En este punto se crea un usuario ficticio.
			Properties prop = new Properties();
			prop.load(getClass().getResourceAsStream("user.properties"));
			String usuario = prop.getProperty("USER");
			DumboUser newuser = new DumboUser(conn,usuario,"",sist);
			newuser.getDatosMenu().idSelected = sist;
			// Inicio el Gestor de Solicitudes.
			gestSol = new GestorSolicitudes();
			gestSol.setUser(newuser);
		} catch (Exception ex) {
			setErrorMessage("Error Creando Usuario Temporal.");
		}
	}
	
	private boolean diferentes(String a,String b) {
		if (a==null || a.equals("")) {
			// Si no se especifica a se permite otro b
			return false;
		} else {
			if (b==null || b.equals("")) return true;
			else return !a.equals(b);
		}
	}
	
	public void verificaSolicitudRemota(Session conn,D7Tareas tar) throws Exception {
		if (!imgCodeOk) return;
		// Debo comprobar que lo que se enva cumple los requisitos
		// del formulario dado
		try {
			if (diferentes(tarData.getTarextAplCod(),tar.getTarAplCod())) throw new Exception("Peticin no permitida parmetros incorrectos. Aplicacin.");
			if (diferentes(tarData.getTarextUsuCod(),tar.getTarUsuCod())) throw new Exception("Peticin no permitida parmetros incorrectos. Solicitante.");
			if (diferentes(tarData.getTarextInfCod(),tar.getTarInfCod())) throw new Exception("Peticin no permitida parmetros incorrectos. Informtico.");
			if (diferentes(tarData.getTarextSisCod(),tar.getTarSisCod())) throw new Exception("Peticin no permitida parmetros incorrectos. Sistema.");
			if (diferentes(tarData.getTarextTipCod(),tar.getTarTipCod())) throw new Exception("Peticin no permitida parmetros incorrectos. Tipo Tarea.");
			if (diferentes(tarData.getTarextUrgencia(),tar.getTarUrgencia())) throw new Exception("Peticin no permitida parmetros incorrectos. Urgencia.");
			//if (diferentes(tarData.getTarextTelefono(),tar.getTarTelefono())) throw new Exception("Peticin no permitida parmetros incorrectos. Telfono.");
			//if (diferentes(tarData.getTarextUbicacion(),tar.getTarUbicacion())) throw new Exception("Peticin no permitida parmetros incorrectos. Ubicacin.");
			//if (diferentes(tarData.getTarextEmailCopia(),tar.getTarEmailCopia())) throw new Exception("Peticin no permitida parmetros incorrectos. Email Copia.");
		} catch (Exception ex) {
			setErrorMessage(ex.getMessage());
			imgCodeOk = false;
		}
	}
	
	public void readResult() { 
		if (!imgCodeOk) return;
		setErrorMessage(gestSol.getErrorMessage());
		if ((errorMessage==null || errorMessage.equals("")) && // No ha habido errores y 
				(getUrlOk()==null || getUrlOk().equals(""))) // No hay url especial de retorno
			setErrorMessage("La tarea ha sido generada con xito.");
	}
	
	public D7TareasExternas getDatosTarea() { return tarData; }
	
	public void redirect(Session conn,String id) {
		if (id==null || id.equals("")) {
			setErrorMessage("La Solicitud indicada no est disponible.");
			return;
		}
		// El identificador es todo sin barras inicial o final.
		if (id.startsWith("/")) id = id.substring(1);
		if (id.endsWith("/")) id = id.substring(0,id.length()-1);
		if (id==null || id.equals("")) {
			setErrorMessage("La Solicitud indicada no est disponible.");
			return;
		}
		try {
	
			Criteria ct = conn.createCriteria(D7TareasExternas.class);
			ct = ct.add(Expression.eq("TarextId",id));
			List l = ct.list();
			if (l!=null && l.size()>0) {
				setFormId(id);
			} else {
				setErrorMessage("La Solicitud indicada no est disponible.");
			}
			
		} catch (Exception ex) {
			setErrorMessage("Error Buscando Solicitud: "+ex);
		}
	}
	
	public String getFormId() { return formId; }
	public void setFormId(String formId) { this.formId = formId; }
	
	public String getFormTitle() { return formTitle; }
	public void setFormTitle(String formTitle) { this.formTitle = formTitle; }
	
	public void setUrlOk(String u) { urlOk = u; }
	public void setUrlNoOk(String u) { urlNoOk = u; }
	public String getUrlOk() { return urlOk; }
	public String getUrlNoOk() { return urlNoOk; }
	
	// Obtiene las url de retorno
	public void obtenerUrlsRetorno(HttpServlet servlet,HttpServletRequest req,HttpServletResponse res) throws Exception {
		String referer = req.getHeader("referer");
		if (!referer.endsWith("/servlet/dumbo7.Dumbo7")) {
			// No viene del formulario de Dumbo.
			String okpage = req.getParameter("ok");
			String nookpage = req.getParameter("nook");
			String baseUrl = referer.substring(0,referer.lastIndexOf("/")+1);
			if (okpage!=null && !okpage.equals("")) setUrlOk(baseUrl+okpage);
			else {
				if (referer.indexOf("?")>0)	setUrlOk(referer+"&ok=S");
				else setUrlOk(referer+"?ok=S");
			}
			if (nookpage!=null && !nookpage.equals("")) setUrlNoOk(baseUrl+nookpage);
			else {
				if (referer.indexOf("?")>0)	setUrlNoOk(referer+"&ok=N");
				else setUrlNoOk(referer+"?ok=N");
			}
		}
	}
	
	// Genera un Cdigo para la imagen.
	public String imageCode() { return dumbo7.notificaciones.GestorNotificaciones.generaID(6); }
	public void verificaImgCode(HttpServlet servlet,HttpServletRequest req,HttpServletResponse res,String reqCode) throws Exception {
		String code = (String)req.getSession(true).getValue("GestorRemote.imageCode");
		req.getSession(true).putValue("GestorRemote.imageCode",null);
		if (code==null || code.equals("")) { setErrorMessage("ERROR: Cdigo de Imagen Incorrecto."); return; }
		if (reqCode==null || reqCode.equals("")) { setErrorMessage("ERROR: Cdigo de Imagen Incorrecto."); return; }
		if (!reqCode.equals(code)) { setErrorMessage("ERROR: Cdigo de Imagen Incorrecto."); return; }
		obtenerUrlsRetorno(servlet,req,res);
		imgCodeOk = true;
	}
	
	/*
	 * PARTE PRIVADA DE GESTIN DE FORMULARIOS
	 *
	 */

	public List getFormularios() { return formularios; }
	
	public void listaFormularios(Session conn) {
		try {
			Criteria ct = conn.createCriteria(D7TareasExternas.class);
			ct = ct.add(Expression.eq("TarextSisCod",user.getDatosMenu().idSelected()));
			formularios = ct.list();
		} catch (Exception ex) {
			setErrorMessage("Error Buscando Solicitudes: "+ex);
		}
	}
	
	public void nuevoFormulario(Session conn,D7TareasExternas tarExt) {
		try {
			if (tarExt.getTarextSisCod().equals(user.getDatosMenu().idSelected())) {
				// ************************************************
				// Comprueba que Solicitante e Informtico Existen
				// ************************************************

				String cop = tarExt.getTarextEmailCopia();
				if ((cop!=null) && !cop.equals("") && !cop.equals("X")) {
					if (!GestorGenerico.isMailList(cop)) 
						throw new Exception("El Correo para copia, "+cop+" no es correcto.");
				}
				//Puede ser un email o un dni !!
				String mailUsu = tarExt.getTarextUsuCod().toLowerCase();
				if (!mailUsu.equals("")) {
					mailUsu = mailUsu.toLowerCase();
					tarExt.setTarextUsuCod(D7Conversor.convierteMailExterno(conn,mailUsu,GestorSolicitudes.IDENTIFICADOR_EXTERNO));
					if (tarExt.getTarextUsuCod().equals(GestorSolicitudes.IDENTIFICADOR_EXTERNO)) {
						if (cop!=null) {
							if (cop.equals("")) cop = mailUsu;
							else cop = mailUsu+","+cop;
						}
						tarExt.setTarextEmailCopia(cop);
					}
				}
				//Puede ser un email o un dni !!
				String mailInf = tarExt.getTarextInfCod().toLowerCase();
				if (!mailInf.equals("")) tarExt.setTarextInfCod(D7Conversor.convierteMail(conn,mailInf));

				// Comprueba que son Diferentes !!!
				if (!tarExt.getTarextInfCod().equals("") && tarExt.getTarextInfCod().equals(tarExt.getTarextUsuCod())) throw new Exception("No puede indicar el mismo solicitante que informtico.");
				
				Transaction tx = conn.beginTransaction();
				conn.saveOrUpdate(tarExt);
				tx.commit();
			} else throw new Exception("No puede crear formularios de otro Sistema.");
		} catch (Exception ex) {
			setErrorMessage("Error Creando Formulario: "+ex);
		}
		
	}

	public void borrarFormulario(Session conn,D7TareasExternas tarExt) {
		try {
			Criteria ct = conn.createCriteria(D7TareasExternas.class);
			ct = ct.add(Expression.eq("TarextId",tarExt.getTarextId()));
			List l = ct.list();
			if (l!=null && l.size()==1) {
				D7TareasExternas te = (D7TareasExternas)l.get(0);
				if (te.getTarextSisCod().equals(user.getDatosMenu().idSelected())) {
					Transaction tx = conn.beginTransaction();
					conn.delete(te);
					tx.commit();
				} else throw new Exception("No puede borrar formularios de otro Sistema.");
			}
		} catch (Exception ex) {
			setErrorMessage("Error Borrando Formulario: "+ex);
		}
		
	}

	public void datosFormulario(Session conn,D7TareasExternas tarExt) {
		try {
			Criteria ct = conn.createCriteria(D7TareasExternas.class);
			ct = ct.add(Expression.eq("TarextId",tarExt.getTarextId()));
			List l = ct.list();
			if (l!=null && l.size()>0) {
				tarData = (D7TareasExternas)l.get(0);
				D7DatosPersonales du = tarData.getDatosUser();
				if (du!=null) du.setDatEmail(D7Conversor.convierteIdentificador(conn,du.getDatIdentificador()));
			} else {
				setErrorMessage("El Formulario indicado no est disponible.");
			}
		} catch (Exception ex) {
			setErrorMessage("Error Modificando Formulario: "+ex);
		}
	}

	public void updateFormulario(Session conn,D7TareasExternas tarExt) {
		try {
			Criteria ct = conn.createCriteria(D7TareasExternas.class);
			ct = ct.add(Expression.eq("TarextId",tarExt.getTarextId()));
			List l = ct.list();
			if (l!=null && l.size()>0) {
				// ************************************************
				// Comprueba que Solicitante e Informtico Existen
				// ************************************************

				String cop = tarExt.getTarextEmailCopia();
				if ((cop!=null) && !cop.equals("") && !cop.equals("X")) {
					if (!GestorGenerico.isMailList(cop)) 
						throw new Exception("El Correo para copia, "+cop+" no es correcto.");
				}
				//Puede ser un email o un dni !!
				String mailUsu = tarExt.getTarextUsuCod().toLowerCase();
				if (!mailUsu.equals("")) {
					tarExt.setTarextUsuCod(D7Conversor.convierteMailExterno(conn,mailUsu,GestorSolicitudes.IDENTIFICADOR_EXTERNO));
					if (tarExt.getTarextUsuCod().equals(GestorSolicitudes.IDENTIFICADOR_EXTERNO)) {
						if (cop!=null) {
							if (cop.equals("")) cop = mailUsu;
							else cop = mailUsu+","+cop;
						}
						tarExt.setTarextEmailCopia(cop);
					}
				}
				//Puede ser un email o un dni !!
				String mailInf = tarExt.getTarextInfCod().toLowerCase();
				if (!mailInf.equals("")) tarExt.setTarextInfCod(D7Conversor.convierteMail(conn,mailInf));

				// Comprueba que son Diferentes !!!
				if (!tarExt.getTarextInfCod().equals("") && tarExt.getTarextInfCod().equals(tarExt.getTarextUsuCod())) throw new Exception("No puede indicar el mismo solicitante que informtico.");
				Transaction tx = conn.beginTransaction();
				D7TareasExternas te = (D7TareasExternas)l.get(0);
				copiaTareaExterna(tarExt,te);
				conn.saveOrUpdate(te);
				tx.commit();
				
			} else {
				setErrorMessage("El Formulario indicado no est disponible.");
			}
		} catch (Exception ex) {
			setErrorMessage("Error Modificando Formulario: "+ex);
		}
	}
	
	private void copiaTareaExterna(D7TareasExternas org,D7TareasExternas dest) {
		dest.setTarextTitulo(org.getTarextTitulo());
		dest.setTarextActivo(org.getTarextActivo());
		dest.setTarextTipCod(org.getTarextTipCod());
		dest.setTarextAsunto(org.getTarextAsunto());
		dest.setTarextUsuCod(org.getTarextUsuCod());
		dest.setTarextAplCod(org.getTarextAplCod());
		dest.setTarextInfCod(org.getTarextInfCod());
		dest.setTarextDescrip(org.getTarextDescrip());
		dest.setTarextUrgencia(org.getTarextUrgencia());
		dest.setTarextUbicacion(org.getTarextUbicacion());
		dest.setTarextEmailCopia(org.getTarextEmailCopia());
		dest.setTarextTelefono(org.getTarextTelefono());
		dest.setTarextAnexos(org.getTarextAnexos());
		dest.setTarextSubtitulo(org.getTarextSubtitulo());
	}
	
}
