<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet version="1.0" 
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:xforms="http://www.w3.org/2002/xforms">
	
<xsl:param name="servlet"/>	
<xsl:param name="menu"/>

<xsl:include href="dumbo7/utils/xsl/utils.xsl"/>
	
<xsl:template match="XMLROOT">

<html lang="es">
	<xsl:call-template name="headComun">
		<xsl:with-param name="jscript">
			<script language="JavaScript">
				function borrar(id) {
					if (confirm('Se va a eliminar el formulario: '+id+'.\nEst Seguro?')) {
						document.formDel.tarextId.value = id;
						document.formDel.submit();
					}
				}
				<xsl:if test="string-length(DATA/REMOTE/@ERROR)>0">
					alert('<xsl:value-of select="DATA/REMOTE/@ERROR"/>');
				</xsl:if>
			</script>
		</xsl:with-param>
	</xsl:call-template>
<body>
<xsl:call-template name="menuComun">
	<xsl:with-param name="MENU" select="DATA/MENU"/>
	<xsl:with-param name="SELECT" select="$menu"/>
	<xsl:with-param name="HELP">administracion.xml#1.11</xsl:with-param>
</xsl:call-template>
<p>&#160;</p>
<xsl:call-template name="pieComun"/>
</body>
</html>
</xsl:template>

<xsl:template name="cuerpo">
<form name="formDel" action="{$servlet}" method="post">
<input type="hidden" name="module" value="dumbo7/remote.borrarFormulario"/>
<input type="hidden" name="tarextId" value=""/>
</form>
<br/>
<table class="contout">
<tr class="peticion">
	<td><strong>Listado de Formularios Para Peticiones Remotas</strong></td>
	<td align="center"><a href="{$servlet}?module=dumbo7/remote.nuevoFormulario">Nuevo Formulario</a></td>
</tr>
<tr><td colspan="2">
<table>
<tr class="titulo">
	<td>Activo</td>
	<td>ID</td>
	<td>Ttulo</td>
	<td>Aplicacin</td>
	<td>Email</td>
	<td>Informtico</td>
	<td>Asunto</td>
	<td colspan="2">&#160;</td>
</tr>
<xsl:if test="count(DATA/REMOTE/TAREAS)=0">
	<tr><td colspan="6">No hay formularios disponibles.</td></tr>
</xsl:if>
<xsl:for-each select="DATA/REMOTE/TAREAS">
	<xsl:sort select="@ID"/>
	<tr>
		<xsl:choose>
			<xsl:when test="@ACTIVO='S'"><td><img src="../graficos/iconos/vigente.gif" alt="Activo"/></td></xsl:when>
			<xsl:otherwise><td><img src="../graficos/iconos/vigente_off.gif" alt="No Activo"/></td></xsl:otherwise>
		</xsl:choose>
		<td><a href="../solicita/{@ID}" target="TestForm"><xsl:value-of select="@ID"/></a></td>
		<td><xsl:value-of select="@TITULO"/></td>
		<td><xsl:value-of select="@APLICACION"/></td>
		<td><xsl:value-of select="@USUEMAIL"/></td>
		<td><xsl:value-of select="@INFEMAIL"/></td>
		<td><xsl:value-of select="substring(@ASUNTO,1,10)"/></td>
		<td>
			<form name="acDel" action="{$servlet}" method="post">
			<input type="hidden" name="module" value="dumbo7/remote.borrarFormulario"/>
			<input type="hidden" name="tarextId" value="{@ID}"/>
			&#160;<input type="button" class="boton" value="Eliminar" onclick="borrar('{@ID}')"/>
			</form>
		</td>
		<td>
			<form name="acUpd" action="{$servlet}" method="post">
			<input type="hidden" name="module" value="dumbo7/remote.modificarFormulario"/>
			<input type="hidden" name="tarextId" value="{@ID}"/>
			&#160;<input type="submit" class="boton" value="Modificar"/>
			</form>
		</td>
	</tr>
</xsl:for-each>
</table>
</td></tr>
</table>
</xsl:template>

</xsl:stylesheet>
