<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet version="1.0" 
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:xforms="http://www.w3.org/2002/xforms">
	
<xsl:param name="servlet"/>	
<xsl:param name="menu"/>

<xsl:include href="dumbo7/utils/xsl/utils.xsl"/>

	
<xsl:template match="XMLROOT">
<html lang="es">
<xsl:call-template name="headComun">
	<xsl:with-param name="jscript">
		<link REL="stylesheet" HREF="../js/solicitudes/ajax.css" TYPE="text/css"/>
		<SCRIPT LANGUAGE="JavaScript" SRC="../js/solicitudes/ajax.js"></SCRIPT>
		<SCRIPT LANGUAGE="JavaScript" SRC="../js/solicitudes/ajax-dynamic-list.js"></SCRIPT>
		<SCRIPT LANGUAGE="JavaScript" SRC="../js/solicitudes/solicitud.js"></SCRIPT>
		<SCRIPT LANGUAGE="JavaScript">
			var userDom = '<xsl:value-of select="DATA/REMOTE/USER/@DOMINIO"/>';
		</SCRIPT>
	</xsl:with-param>
</xsl:call-template>
<body>
<xsl:call-template name="menuComun">
	<xsl:with-param name="MENU" select="DATA/MENU"/>
	<xsl:with-param name="SELECT" select="$menu"/>
</xsl:call-template>
<p>&#160;</p>
<xsl:call-template name="pieComun"/>
</body>
</html>
</xsl:template>

<xsl:template name="cuerpo">
<br/>
<xsl:variable name="sistema">
	<xsl:choose>
		<xsl:when test="contains($menu,'/')">
			<xsl:value-of select="substring-before($menu,'/')"/>
		</xsl:when>
		<xsl:otherwise>
			<xsl:value-of select="$menu"/>
		</xsl:otherwise>
	</xsl:choose>
</xsl:variable>
<table align="center" width="80%" cellpadding="0" cellspacing="0">
<tr>
	<td colspan="2">
		<h1>Modificar Formulario de Tarea Externa DUMBO</h1>
	</td>
</tr>
<tr>
	<td valign="top">
	</td>
	<td valign="top">
	<table class="cab1">
	<tr><td>&#160;</td><td align="right"><font color="red" size="-1">(*) campos obligatorios.</font></td></tr>
	</table>
	<form method="POST" action="{$servlet}" name="newSol">
		<input type="hidden" name="module" value="dumbo7/remote.updateFormulario"/>
		<input type="hidden" name="tarextSisCod" value="{$sistema}"/>
		<input type="hidden" name="tarextId" value="{DATA/REMOTE/TAREA/@ID}"/>
		<table class="contdet">
		<tr>
			<td class="cabe"><strong>Datos Formulario</strong></td>
		</tr>
		<tr>
			<td class="cont">
			<table>
			<tr>
				<td><i>Id<font color="red" size="-1">(*)</font>:</i></td><td><xsl:value-of select="DATA/REMOTE/TAREA/@ID"/>&#160;<div id="urlF"><i><b>URL Formulario:</b></i> http://dumbo.um.es/dumbo/solicita/<xsl:value-of select="DATA/REMOTE/TAREA/@ID"/></div></td>
			</tr>
			<tr>
				<td><i>Ttulo<font color="red" size="-1">(*)</font>:</i></td><td><input type="text" name="tarextTitulo" value="{DATA/REMOTE/TAREA/@TITULO}" size="50" maxlength="200" /></td>
			</tr>
			<tr>
				<td><i>Subttulo<font color="red" size="-1">(*)</font>:</i></td><td><textarea name="tarextSubtitulo" rows="8" cols="98"><xsl:value-of select="DATA/REMOTE/TAREA/@SUBTITULO"/></textarea></td>
			</tr>
			<tr>
				<td><i>Activo<font color="red" size="-1">(*)</font>:</i></td><td><select name="tarextActivo" size="1"><option value="S" selected="true">Activado</option><option value="N">Desactivado</option></select></td>
			</tr>
			</table>
			</td>
		</tr>
		<tr>
			<td class="cabe"><strong>Datos Tarea</strong></td>
		</tr>
		<tr>
			<td class="cont">
			<table>
			<tr>
				<td><i>Email:</i></td>
				<td><input type="text" name="tarextUsuCod" value="{DATA/REMOTE/TAREA/@USUEMAIL}" size="20" maxlength="60" onChange="findRequest(this,'solname',true);"/></td>
				<td id="solname" width="70%"><xsl:value-of select="DATA/REMOTE/TAREA/@USUNOMBRE"/></td>
			</tr>
			<tr>
				<td><i>Informtico:</i></td>
				<td><input type="text" name="tarextInfCod" value="{DATA/REMOTE/TAREA/@INFEMAIL}" size="20" maxlength="60" OnChange="findRequest(this,'infname',false);"/></td>
				<td id="infname" width="70%"><xsl:value-of select="DATA/REMOTE/TAREA/@INFNOMBRE"/></td>
			</tr>
			<tr>
				<td><i>Aplicacin<font color="red" size="-1">(*)</font>:</i></td>
				<td colspan="2">
					<input type="hidden" name="tarextAplCod" value="{DATA/REMOTE/TAREA/@APLICACION}"/>
					<input type="hidden" id="desapl_hidden" name="desapl_ID" value=""/> 
					<input type="hidden" id="aplCodIn" name="aplCodIn" value=""/> 
					<input type="text" id="desapl" name="desapl" value="" onchange="CambiaDeApl(this,event)" size="60" maxlength="100"/>&#160;<a href="javascript:buscaAplicaciones();"><img title="Buscar Aplicaciones" src="../graficos/iconos/ampliar.gif" border="0"/></a>
					<div id="listaapls">
						<xsl:if test="string-length(DATA/REMOTE/TAREA/@APLICACION)>0">
							<a href="javascript:eliminaApp('{DATA/REMOTE/TAREA/@APLICACION}')"><xsl:value-of select="DATA/REMOTE/TAREA/@APLICACION"/></a>
						</xsl:if>
					</div>
				</td>
			</tr>
			<tr>
				<td><i>Asunto:</i></td>
				<td colspan="2"><input type="text" name="tarextAsunto" value="{DATA/REMOTE/TAREA/@ASUNTO}" size="100" maxlength="70" /></td>
			</tr>
			<tr>
				<td valign="top"><i>Texto Tarea:</i></td>
				<td colspan="2"><textarea rows="8" cols="98" name="tarextDescrip"><xsl:value-of select="DATA/REMOTE/TAREA/@DESCRIP"/></textarea></td>
			</tr>
			<tr>
				<td><i>Tipo de Tarea:</i></td>
				<td colspan="2"><select name="tarextTipCod" size="1">
					<option value=""><xsl:if test="not(DATA/REMOTE/TAREA/@TIPO_TAREA)"><xsl:attribute name="selected">true</xsl:attribute></xsl:if>Sin Asignar</option>
					<option value="P"><xsl:if test="DATA/REMOTE/TAREA/@TIPO_TAREA='P'"><xsl:attribute name="selected">true</xsl:attribute></xsl:if>Peticin</option>
					<option value="I"><xsl:if test="DATA/REMOTE/TAREA/@TIPO_TAREA='I'"><xsl:attribute name="selected">true</xsl:attribute></xsl:if>Incidencia</option>
					</select>
				</td>
			</tr>
			<tr>
				<td><i>Urgencia:</i></td>
				<td colspan="2">
				<SELECT NAME="tarextUrgencia" SIZE="1">
					<OPTION VALUE=""><xsl:if test="not(DATA/REMOTE/TAREA/@URGENCIA)"><xsl:attribute name="selected">true</xsl:attribute></xsl:if>Sin Asignar</OPTION>
					<OPTION VALUE="N"><xsl:if test="DATA/REMOTE/TAREA/@URGENCIA='N'"><xsl:attribute name="selected">true</xsl:attribute></xsl:if>No Urgente</OPTION>
					<OPTION VALUE="U"><xsl:if test="DATA/REMOTE/TAREA/@URGENCIA='U'"><xsl:attribute name="selected">true</xsl:attribute></xsl:if>Urgente</OPTION>
				</SELECT>
				</td>
			</tr>
			<xsl:variable name="copiam"><xsl:choose><xsl:when test="DATA/REMOTE/TAREA/@USUEMAIL!=DATA/REMOTE/TAREA/@EMAIL_COPIA"><xsl:value-of select="DATA/REMOTE/TAREA/@EMAIL_COPIA"/></xsl:when><xsl:otherwise></xsl:otherwise></xsl:choose></xsl:variable>
			<tr>
				<td><input name="sinem" type="checkbox" onclick="cambiaCheck(this,document.newSol.tarextEmailCopia)"><xsl:if test="not($copiam='X')"><xsl:attribute name="checked">true</xsl:attribute></xsl:if></input><i>Email Copia:</i></td>
				<td id="idtarextEmailCopia" colspan="2"><xsl:if test="$copiam='X'"><xsl:attribute name="style">display:none</xsl:attribute></xsl:if><INPUT TYPE="text" NAME="tarextEmailCopia" VALUE="" SIZE="30" onchange="cambEmailCop(this)" value="{$copiam}"/></td>
			</tr>
			<tr>
				<td><input name="sintl" type="checkbox" onclick="cambiaCheck(this,document.newSol.tarextTelefono)"><xsl:if test="not(DATA/REMOTE/TAREA/@TELEFONO='X')"><xsl:attribute name="checked">true</xsl:attribute></xsl:if></input><i>Tlfno. Contacto:</i></td>
				<td id="idtarextTelefono" colspan="2"><xsl:if test="DATA/REMOTE/TAREA/@TELEFONO='X'"><xsl:attribute name="style">display:none</xsl:attribute></xsl:if><input type="text" name="tarextTelefono" size="12" maxlength="20" value="{DATA/REMOTE/TAREA/@TELEFONO}"/></td>
			</tr>
			<tr>
				<td><input name="sinub" type="checkbox" onclick="cambiaCheck(this,document.newSol.tarextUbicacion)"><xsl:if test="not(DATA/REMOTE/TAREA/@UBICACION='X')"><xsl:attribute name="checked">true</xsl:attribute></xsl:if></input><i>Ubicacin Tarea:</i></td>
				<td id="idtarextUbicacion" colspan="2"><xsl:if test="DATA/REMOTE/TAREA/@UBICACION='X'"><xsl:attribute name="style">display:none</xsl:attribute></xsl:if><textarea rows="6" cols="98" name="tarextUbicacion"><xsl:value-of select="DATA/REMOTE/TAREA/@UBICACION"/></textarea></td>
			</tr>
			<tr>
				<td><i>Anexos:</i></td>
				<td colspan="2">
				<SELECT NAME="tarextAnexos" SIZE="1">
					<OPTION VALUE="N"><xsl:if test="not(DATA/REMOTE/TAREA/@ANEXOS='S')"><xsl:attribute name="selected">true</xsl:attribute></xsl:if>No Permitir</OPTION>
					<OPTION VALUE="S"><xsl:if test="DATA/REMOTE/TAREA/@ANEXOS='S'"><xsl:attribute name="selected">true</xsl:attribute></xsl:if>Permitir</OPTION>
				</SELECT>
				</td>
			</tr>
			</table>
			</td>
		</tr>
		<tr>
			<td class="cabe" align="center"><input type="button" class="boton" value="Enviar" onClick="enviar();"/></td>
		</tr>
		</table>
	</form>
	</td>
</tr>
</table>
</xsl:template>

</xsl:stylesheet>
	