<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet version="1.0" 
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:xforms="http://www.w3.org/2002/xforms">
	
<xsl:param name="servlet"/>	
<xsl:param name="menu"/>
<xsl:param name="tarUsuCod"/>
<xsl:param name="tarAsunto" select="/XMLROOT/DATA/REMOTE/TAREA/@ASUNTO"/>
<xsl:param name="tarDescrip" select="/XMLROOT/DATA/REMOTE/TAREA/@DESCRIPCION"/>
<xsl:param name="tarTipCod"/>
<xsl:param name="tarUrgencia"/>
<xsl:param name="tarEmailCopia" select="/XMLROOT/DATA/REMOTE/TAREA/@EMAIL_COPIA"/>
<xsl:param name="tarTelefono" select="/XMLROOT/DATA/REMOTE/TAREA/@TELEFONO"/>
<xsl:param name="tarUbicacion" select="/XMLROOT/DATA/REMOTE/TAREA/@UBICACION"/>
<xsl:param name="tarFecmaxResol" select="/XMLROOT/DATA/SOLICITUDES/SOLICITUD/@FECHA_MAX_RESOLUCION"/>

<xsl:include href="dumbo7/utils/xsl/utils.xsl"/>
	
<xsl:template match="XMLROOT">

<html lang="es">
<xsl:choose>
<xsl:when test="string-length(DATA/REMOTE/@URLOK)>0 and string-length(DATA/REMOTE/@ERROR)=0">
		<head>
			<script language="JavaScript">
				function cargar() {
					location.href = '<xsl:value-of select="DATA/REMOTE/@URLOK"/>';
				}
			</script>
		</head>
		<body onload="cargar();"></body>
</xsl:when>
<xsl:when test="string-length(DATA/REMOTE/@URLNOOK)>0 and string-length(DATA/REMOTE/@ERROR)>0">
		<head>
			<script language="JavaScript">
				function cargar() {
					location.href = '<xsl:value-of select="DATA/REMOTE/@URLNOOK"/>';
				}
			</script>
		</head>
		<body onload="cargar();"></body>
</xsl:when>
<xsl:otherwise>
<head>
	<META http-equiv="Content-Type" content="text/html; charset=ISO-8859-1"/>
	<meta content="rea de las Tecnologas de la Informacin y las Comunicaciones Aplicadas de la Universidad de Murcia" name="AUTHOR"/>
	<meta content="rea de las Tecnologas de la Informacin y las Comunicaciones Aplicadas. Vicerrectorado de Informacin, Comunicacin e Innovacin" name="DESCRIPTION"/>
	<meta content="es" http-equiv="Content-Language"/>
	<meta content="text/html; charset=iso-8859-1" http-equiv="Content-Type"/>
	<meta content="Universidad,Informtica,Tecnologas,University,Informatic,Technologies" name="KEYWORDS"/>
	<title>DUMBO7. rea de Tecnologas de la Informacin y las Comunicaciones Aplicadas de la Universidad de Murcia</title>
	<link TYPE="text/css" HREF="../estilosD.css" REL="stylesheet"/>
	<style type="text/css">@import url(../dumbo7/utils/jscalendar/calendar-win2k-1.css);</style>
	<script src="../dumbo7/utils/jscalendar/calendar.js" type="text/javascript"></script>
	<script src="../dumbo7/utils/jscalendar/lang/calendar-es.js" type="text/javascript"></script>
	<script src="../dumbo7/utils/jscalendar/calendar-setup.js" type="text/javascript"></script>
	<SCRIPT SRC="../js/solicitudes/solicita.js" LANGUAGE="JavaScript"></SCRIPT>
	<script language="JavaScript">
		String.prototype.trim = function() { return this.replace(/^\s+|\s+$/, ''); };
		function marcaPeticion() {
			document.getElementById('fmrr3').style.display = '';
		}
		function marcaIncidencia() {
			document.getElementById('fmrr3').style.display = 'none';				
			document.newSol.tarFecmaxResol.value='';
		}
		function validaMail(obj) {
			var escorreo  = /^([a-zA-Z0-9_\.\-])+\@(([a-zA-Z0-9\-])+\.)+([a-zA-Z0-9]{2,4})+$/;
			if (!escorreo.test(obj.value)) {
				alert('Introduzca su direccin de correo completa.');
				obj.value = '';
				return;
			}
		}
		function comprobarCampos() {
			if (incorrecto(document.newSol.tarUsuCod,60,true,'Solicitante')) return false;
			if (incorrecto(document.newSol.tarInfCod,60,false,'<xsl:call-template name="traduce"><xsl:with-param name="id" select="'Informatico'"/></xsl:call-template>')) return false;
			if (document.newSol.tarUsuCod.value==document.newSol.tarInfCod.value) {
				alert('No puede solicitarse tareas a uno mismo.');
				return false;
			}
			if (incorrecto(document.newSol.tarAsunto,70,true,'Asunto')) return false;
			if (incorrecto(document.newSol.tarDescrip,4000,true,'Texto Tarea')) return false;
			if (document.newSol.tarTipCod.length) {
				if (!document.newSol.tarTipCod[0].checked &amp;&amp; !document.newSol.tarTipCod[1].checked) {
					alert('Debe indicar el Tipo de Tarea que desea Solicitar.');
					return false;
				}
			}
			if ((document.newSol.tarInfCod.value!='') &amp;&amp; (document.newSol.tarAplCod.value=='-1')) { alert('Debe seleccionar una aplicacin para indicar un <xsl:call-template name="traduce"><xsl:with-param name="id" select="'informatico'"/></xsl:call-template>.'); return false; }
			if (incorrecto(document.newSol.tarUbicacion,500,false,'Ubicacin Tarea')) return false;
			if (incorrecto(document.newSol.tarEmailCopia,240,false,'Email Copia')) return false;
			if (!okEmails(document.newSol.tarEmailCopia,'Email Copia')) return false;
			if (document.newSol.tarFecmaxResol &amp;&amp; (document.newSol.tarFecmaxResol.value!='')) {
				if (!okDate(document.newSol.tarFecmaxResol.value,new Date(),'La Fecha Mxima de Resolucin')) return false;
			}
			if (document.newSol.tarAplCod.value!='-1' &amp;&amp; document.newSol.tarAplPadreAplCod) {
				if (document.newSol.tarAplPadreAplCod.value!='-1' &amp;&amp; document.newSol.tarAplPadreAplCod.value!='-2') {
					document.newSol.tarAplCod.value = document.newSol.tarAplPadreAplCod.value;
				} else {
					var s = document.newSol.tarAplCodSelect;
					var vl = s.options[s.selectedIndex].value;
					document.newSol.tarAplCod.value = vl.substring(0,vl.indexOf('-'));
				}
			}
			'<xsl:if test="string-length(DATA/REMOTE/TAREA/@USUARIO)=0">'
				if (document.newSol.UsuNombre.value=='') { alert('Debe introducir su nombre'); return false; }
			'</xsl:if>'

			return true;
		}
		function enviarRemote() {
			if (!comprobarCampos()) return;
			completaMail(document.newSol.tarUsuCod);
			completaMail(document.newSol.tarInfCod);
			'<xsl:if test="string-length(DATA/REMOTE/TAREA/@USUARIO)=0">'
				document.newSol.tarDescrip.value='NOMBRE: ' + document.newSol.UsuNombre.value + '\n' + document.newSol.tarDescrip.value;
			'</xsl:if>'
			document.newSol.submit();
		}
		<xsl:if test="string-length(DATA/REMOTE/@ERROR)>0">
			alert('<xsl:value-of select="DATA/REMOTE/@ERROR"/>');
		</xsl:if>
	</script>
</head>	
<body>
<br/>
<xsl:variable name="sistema">
	<xsl:choose>
		<xsl:when test="contains($menu,'/')">
			<xsl:value-of select="substring-before($menu,'/')"/>
		</xsl:when>
		<xsl:otherwise>
			<xsl:value-of select="$menu"/>
		</xsl:otherwise>
	</xsl:choose>
</xsl:variable>
<table align="center" width="80%" cellpadding="0" cellspacing="0">
<tr>
	<td colspan="2">
		<h1>Solicitud Externa de Tarea DUMBO</h1>
		<h2><b><xsl:value-of select="DATA/REMOTE/@FORMTITLE"/></b></h2>
		<xsl:choose>
			<xsl:when test="string-length(DATA/REMOTE/TAREA/@SUBTITULO)>0">
				<font size="-1"><xsl:call-template name="cambiaIntros"><xsl:with-param name="cad" select="translate(DATA/REMOTE/TAREA/@SUBTITULO,' ','&#160;')"/></xsl:call-template></font>
			</xsl:when>
			<xsl:otherwise>
				<xsl:if test="DATA/REMOTE/TAREA/@SISTEMA='SIU'">
					Puede consultar el Directorio telefnico de la Universidad de Murcia<br/>
         			<strong>Telfonos de Informacin:</strong>  902 32 16 00  //  968 367 888<br/>
     			</xsl:if>
         		Cumplimente todos los datos para que podamos atender de una forma ms efectiva la peticin de informacin: <br/>
         		<strong>NOMBRE:</strong> Indique su nombre y apellidos.<br/>
         		<strong>EMAIL:</strong> Direccin de correo electrnico donde desea recibir la respuesta.<br/>
         		<strong>ASUNTO:</strong> Indique de forma clara y breve la temtica de la informacin que solicita.<br/>
         		<strong>TEXTO DE LA SOLICITUD:</strong> Explique de forma detallada la naturaleza y objeto de su solicitud, as como cualquier otra informacin que nos pudiera ser de utilidad para responder a su peticin.<br/>		
         		<br/>
			</xsl:otherwise>
		</xsl:choose>
	</td>
</tr>
<tr>
	<td valign="top">
	</td>
	<td valign="top">
	<table class="cab1">
	<tr><td>&#160;</td><td align="right"><font color="red" size="-1">(*) campos obligatorios.</font></td></tr>
	</table>
	<form method="POST" action="{$servlet}" name="newSol" ENCTYPE="multipart/form-data">
		<input type="hidden" name="module" value="dumbo7/remote.insertarSolicitud"/>
		<input type="hidden" name="id" value="{DATA/REMOTE/@FORMID}"/>
		<input type="hidden" name="tarSisCod" value="{DATA/REMOTE/TAREA/@SISTEMA}"/>
		<input type="hidden" name="tarAplCod" value="{DATA/REMOTE/TAREA/@APLICACION}"/>
		<input type="hidden" name="tarInfCod" value="{DATA/REMOTE/TAREA/@INFORMATICO}"/>
		<table class="contdet">
		<tr>
			<td class="cabe"><strong>Datos Tarea</strong></td>
		</tr>
		<tr>
			<td class="cont">
			<table>
			<xsl:choose>
				<xsl:when test="string-length(DATA/REMOTE/TAREA/@USUARIO)>0">
					<input type="hidden" name="tarUsuCod" value="{DATA/REMOTE/TAREA/@USUARIO}"/>
				</xsl:when>
				<xsl:otherwise>
					<tr>
						<td><i>Nombre:<font color="red" size="-1">(*)</font>:</i></td>
						<td><input type="text" name="UsuNombre" size="50" maxlength="200"/></td>
					</tr>
					<tr>
						<td><i>Email:<font color="red" size="-1">(*)</font>:</i></td>
						<td><input type="text" name="tarUsuCod" value="{$tarUsuCod}" size="20" maxlength="100" onChange="validaMail(this);"/></td>
					</tr>
				</xsl:otherwise>
			</xsl:choose>
			<tr>
				<td><i>Asunto<font color="red" size="-1">(*)</font>:</i></td><td><input type="text" name="tarAsunto" value="{$tarAsunto}" size="100" maxlength="70" /></td>
			</tr>
			<tr>
				<td valign="top"><i>Texto Tarea<font color="red" size="-1">(*)</font>:</i></td>
				<td><textarea rows="8" cols="98" name="tarDescrip"><xsl:value-of select="$tarDescrip"/></textarea></td>
			</tr>
			<xsl:choose>
				<xsl:when test="string-length(DATA/REMOTE/TAREA/@TIPO_TAREA)>0">
					<input type="hidden" name="tarTipCod" value="{DATA/REMOTE/TAREA/@TIPO_TAREA}"/>
				</xsl:when>
				<xsl:otherwise>
					<tr>
						<td><i>Tipo de Tarea<font size="-1" color="red">(*)</font>:</i></td>
						<td><input type="radio" name="tarTipCod" value="P" onClick="marcaPeticion();"><xsl:if test="$tarTipCod='P'"><xsl:attribute name="checked">true</xsl:attribute></xsl:if></input>Se trata de una peticin, novedad, mejora o sugerencia.<br/>
							<input type="radio" name="tarTipCod" value="I" onClick="marcaIncidencia();"><xsl:if test="$tarTipCod='I'"><xsl:attribute name="checked">true</xsl:attribute></xsl:if></input>Se trata de una incidencia, error o fallo.
						</td>
					</tr>
				</xsl:otherwise>
			</xsl:choose>
			<xsl:variable name="fma"><xsl:call-template name="date2String2"><xsl:with-param name="fecha" select="$tarFecmaxResol"/></xsl:call-template></xsl:variable>
			<tr id="fmrr3" style="display:none;">
				<td><i>Fecha Max. Resol.:</i></td>
				<td><input type="text" name="tarFecmaxResol" id="f_tarFecmaxResol" onChange="changeDate(this)" value="{$fma}"/>
				<img src="../graficos/iconos/calendario_ico.gif" id="f_trigger_c"
				style="cursor: pointer; border: 1px solid red;"
				title="Selecciona Fecha"
				onmouseover="this.style.background='red';"
				onmouseout="this.style.background=''"/>
				<script type="text/javascript">
					Calendar.setup({
						inputField     :    "f_tarFecmaxResol",
						ifFormat       :    "%d/%m/%Y",
						button         :    "f_trigger_c",
						align          :    "Tl",
						onSelect       :    selectDate,
						singleClick    :    false
					});
				</script>
				</td>
			</tr>
			<xsl:choose>
				<xsl:when test="string-length(DATA/REMOTE/TAREA/@URGENCIA)>0">
					<input type="hidden" name="tarUrgencia" value="{DATA/REMOTE/TAREA/@URGENCIA}"/>
				</xsl:when>
				<xsl:otherwise>
					<tr>
						<td><i>Urgencia:</i></td>
						<td>
						<SELECT NAME="tarUrgencia" SIZE="1" OnChange="modificadaUrgencia()">
							<OPTION VALUE="V"><xsl:if test="$tarUrgencia='V'"><xsl:attribute name="selected">true</xsl:attribute></xsl:if>Sin Asignar</OPTION>
							<OPTION VALUE="N"><xsl:if test="$tarUrgencia='N'"><xsl:attribute name="selected">true</xsl:attribute></xsl:if>No Urgente</OPTION>
							<OPTION VALUE="U"><xsl:if test="$tarUrgencia='U'"><xsl:attribute name="selected">true</xsl:attribute></xsl:if>Urgente</OPTION>
						</SELECT>
						</td>
					</tr>
				</xsl:otherwise>
			</xsl:choose>
			<xsl:choose>
				<xsl:when test="($tarEmailCopia='X') or (/XMLROOT/DATA/REMOTE/TAREA/@EMAIL_COPIA='X')">
					<input type="hidden" name="tarEmailCopia" value=""/>
				</xsl:when>
				<xsl:otherwise>
				<tr>
					<td><i>Email Copia:</i></td>
					<td><INPUT TYPE="text" NAME="tarEmailCopia" VALUE="{$tarEmailCopia}" SIZE="30" onchange="cambEmailCop(this)"/></td>
				</tr>
				</xsl:otherwise>
			</xsl:choose>
			<xsl:choose>
				<xsl:when test="($tarTelefono='X') or (/XMLROOT/DATA/REMOTE/TAREA/@TELEFONO='X')">
					<input type="hidden" name="tarTelefono" value=""/>
				</xsl:when>
				<xsl:otherwise>
				<tr>
					<td><i>Tlfno. Contacto:</i></td>
					<td><input type="text" name="tarTelefono" size="12" maxlength="20" value="{$tarTelefono}"/></td>
				</tr>
				</xsl:otherwise>
			</xsl:choose>
			<xsl:choose>
				<xsl:when test="($tarUbicacion='X') or (/XMLROOT/DATA/REMOTE/TAREA/@UBICACION='X')">
					<input type="hidden" name="tarUbicacion" value=""/>
				</xsl:when>
				<xsl:otherwise>
				<tr>
					<td><i>Ubicacin Tarea:</i></td>
					<td><textarea rows="6" cols="98" name="tarUbicacion"><xsl:value-of select="$tarUbicacion"/></textarea></td>
				</tr>
				</xsl:otherwise>
			</xsl:choose>
			<xsl:if test="DATA/REMOTE/TAREA/@ANEXOS='S'">
			<tr>
				<td><i>Anexos:</i></td>
				<td>
					<INPUT TYPE="file" NAME="tarAnexo1" VALUE="" SIZE="30"/>&#160;
					<INPUT TYPE="file" NAME="tarAnexo2" VALUE="" SIZE="30"/><br/>
					<INPUT TYPE="file" NAME="tarAnexo3" VALUE="" SIZE="30"/>&#160;
					<INPUT TYPE="file" NAME="tarAnexo4" VALUE="" SIZE="30"/><br/>
					<INPUT TYPE="file" NAME="tarAnexo5" VALUE="" SIZE="30"/>&#160;
					<INPUT TYPE="file" NAME="tarAnexo6" VALUE="" SIZE="30"/>
				</td>
			</tr>
			</xsl:if>
			<tr>
				<td><i>Imagen:</i></td>
				<td>
					<table>
					<tr>
						<td><input type="text" name="imgCode" size="17" maxlength="6"/></td>
						<td><i>Introduzca aqu el texto que aparece en la imagen.</i></td>
					</tr>
					<tr>
						<td colspan="2"><img id="imgcod" src="{$servlet}?module=dumbo7/remote.imagen" border="0"/></td>
					</tr>
					</table>
				</td>
			</tr>
			</table>
			</td>
		</tr>
		<tr>
			<td class="cabe" align="center"><input type="button" class="boton" value="Enviar" onClick="enviarRemote();"/></td>
		</tr>
		</table>
	</form>
	</td>
</tr>
</table>
<p>&#160;</p>
<xsl:call-template name="pieComun"/>
</body>
</xsl:otherwise>
</xsl:choose>
</html>
</xsl:template>

<xsl:template name="cuerpo">
</xsl:template>

<xsl:template name="cambiaIntros">
	<xsl:param name="cad"/>
	<xsl:choose>
		<xsl:when test="contains($cad,'&#13;')">
			<xsl:call-template name="cambiaIntros">
				<xsl:with-param name="cad"><xsl:value-of select="substring($cad,1,string-length(substring-before($cad,'&#13;')))"/></xsl:with-param>
			</xsl:call-template>
			<br/>
			<xsl:call-template name="cambiaIntros">
				<xsl:with-param name="cad"><xsl:value-of select="substring($cad,string-length(substring-before($cad,'&#13;'))+3)"/></xsl:with-param>
			</xsl:call-template>
		</xsl:when>
		<xsl:otherwise><xsl:value-of select="$cad"/></xsl:otherwise>
	</xsl:choose>
</xsl:template>

</xsl:stylesheet>
	