/*
 * 
 *
 */
package dumbo7.solicitudes;

import org.apache.log4j.*;
import atica.frameweb.utils.*;
import java.util.*;
import java.util.zip.ZipEntry;
import java.util.zip.ZipOutputStream;
import dumbo7.user.DumboUser;
import dumbo7.user.FiltroUsuario;
import org.hibernate.*;
import org.hibernate.criterion.*;

import um.curie.webcomun.HttpUtilCurie;
import um.curie.webcomun.modulos.EnlaceConGeneralServlet;

import java.sql.*;

import dumbo7.utils.*;
import dumbo7.*;

import javax.servlet.http.*;

import java.io.*;
import java.math.*;

import dumbo7.administracion.zonas.Espacio;
import dumbo7.administracion.zonas.Zona;
import dumbo7.atencion.GestorAuxiliar;

/**
 * @author Universidad de Murcia - ATICA
 *
 */

public class GestorSolicitudes extends GeneralManager {
	
	static Logger logger = Logger.getLogger(GestorSolicitudes.class);
	static String VIGENTE = "V";
	public static String IDENTIFICADOR_EXTERNO = "EXTERNO";
	public List aplicaciones = null, prioridades = null, categorias = null, secciones = null, espacios = null, zonasReales = null;
	public String message = "";
	public D7Tareas solicitud = null;
	public D7TareasProgramadas temporizacion = null;
	public Vector anexos = new Vector();
	public String rutaAnexos = "";
	public Vector vinculadas = new Vector();
	//public List tareasHijas = null;
	public FiltroUsuario filtro = null;
	public String minimoDumboRapido = "", maximoDumboRapido = "";
	public List movimientos = null;
	public Espacio ubicSoli=null;
	public String tipoAsignacion ="";
	public List plantillas = null;
	public int tareaActual=-2;
	public String miAplicacion="";
	public D7DatosTrabajador datosTrabajador = null;
	
	public GestorSolicitudes() {}
	
	public void setDetalle(String ajx) {
		if (ajx!=null && ajx.equals("1")) solicitud = new D7Tareas();
	}
	
	public void listSecciones(Session conn) {
		try {
			if (user.permitidoPerfiles(user.getDatosMenu().idSelected(),"dumbo7/solicitudes","informatico")) {
				secciones = GestorAuxiliar.getListaSecciones(user,conn);
			}
		} catch (Exception ex) {
			setErrorMessage("GestorSolicitudes[listSecciones]: "+ex);
		}
	}
	public List getSecciones() {
		return secciones;
	}
	
	public D7DatosTrabajador getDatosTrabajador() { return datosTrabajador; }
	
	public List getEspacios() {
		return espacios;
	}
	
	public List getZonasReales(){return zonasReales;}
	
	public void listAplicaciones(Session conn,String patron) {
		PreparedStatement pstmt = null;
		ResultSet rs = null;
		try {
			
			boolean interno = user.permitidoPerfiles(user.getDatosMenu().idSelected(),"dumbo7/solicitudes","informatico");
			// Es externo le saco las aplicaciones externas.
			Query q = conn.createQuery(getQuery("listadoAplicaciones"));
			q.setString("sist",user.getDatosMenu().idSelected());
			q.setString("est",VIGENTE);
			q.setString("car1",D7Aplicaciones.EXTERNA);
			if (interno) q.setString("car2",D7Aplicaciones.INTERNA);
			else q.setString("car2",D7Aplicaciones.EXTERNA);
			q.setString("ptr","%"+patron.toUpperCase()+"%");
			aplicaciones = q.list();
			Iterator it = aplicaciones.iterator();
			String systemUg = "V";
			Criteria ct2 = conn.createCriteria(D7Parametros.class);
			ct2 = ct2.add(Expression.and(Expression.eq("ParSisCod",user.getDatosMenu().idSelected()),Expression.eq("ParParametro","PAR_URGENCIA")));
			List l = ct2.list();
			if (l!=null && l.size()>0) systemUg = ((D7Parametros)l.get(0)).getParValor();
			// Cojo los parmetros asociados a las aplicaciones !!
			for (int k=0; k<aplicaciones.size(); k++) {
				D7Aplicaciones apl = (D7Aplicaciones)aplicaciones.get(k);
				Set s = apl.getAplicaciones_param();
				Iterator it2 = s.iterator();
				while (it2.hasNext()) {
					D7AplicacionesParametros dap = (D7AplicacionesParametros)it2.next();
					String ug = dap.getApaUrgencia();
					if (ug==null && systemUg!=null) dap.setApaUrgencia(systemUg);
				}
			}
			
		} catch (Exception ex) {
			setErrorMessage("GestorSolicitudes[listAplicacionesPatron]: "+ex);
		} finally {
			try {
				if (rs!=null) rs.close();
				if (pstmt!=null) pstmt.close();
			} catch (Exception exx) {}
		}
	}
	
	public void listEdificios(Session conn,String patron) {
		PreparedStatement pstmt = null;
		ResultSet rs = null;
		String myQuery = null;
		espacios = new ArrayList();
		try{
			myQuery = getQuery("listZonaPorLetra");
			pstmt = conn.connection().prepareStatement(myQuery);
			pstmt.setString(1,'%'+patron.toUpperCase()+'%');
			rs = pstmt.executeQuery();
			while (rs.next()) {
				espacios.add(new Espacio(rs.getString(1),rs.getString(2)));
			}
		}
		catch (Exception ex)
		{
			System.out.println("2"+ex);
			setErrorMessage("Error al listar espacios.");
		} finally {
			try {
				if (rs!=null) rs.close();
				if (pstmt!=null) pstmt.close();
			} catch (Exception exx) {}
		}
	}

	public void listAplicaciones(Session conn) {
		try {
			
			if (user.permitidoPerfiles(user.getDatosMenu().idSelected(),"dumbo7/solicitudes","informatico")) {
				String systemUg = "V";
				Criteria ct = conn.createCriteria(D7Parametros.class);
				ct = ct.add(Expression.and(Expression.eq("ParSisCod",user.getDatosMenu().idSelected()),Expression.eq("ParParametro","PAR_URGENCIA")));
				List l = ct.list();
				if (l!=null && l.size()>0) systemUg = ((D7Parametros)l.get(0)).getParValor();
				aplicaciones = GestorAuxiliar.getListaAplicaciones(user,conn);
				// Cojo los parmetros asociados a las aplicaciones !!
				for (int k=0; k<aplicaciones.size(); k++) {
					Set s = ((D7Aplicaciones)aplicaciones.get(k)).getAplicaciones_param();
					Iterator it = s.iterator();
					while (it.hasNext()) {
						D7AplicacionesParametros dap = (D7AplicacionesParametros)it.next();
						String ug = dap.getApaUrgencia();
						if (ug==null && systemUg!=null) dap.setApaUrgencia(systemUg);
					}
				}
			} else {
				// Es externo le saco las aplicaciones externas.
				Criteria ct = conn.createCriteria(D7Aplicaciones.class);
				ct = ct.add(Expression.eq("AplSisCod",user.getDatosMenu().idSelected()));
				ct = ct.add(Expression.eq("AplCaracter",D7Aplicaciones.EXTERNA));
				aplicaciones = ct.list();
				Iterator it = aplicaciones.iterator();
				while (it.hasNext()) ((D7Aplicaciones)it.next()).getAplicaciones_param().size();
			}
		} catch (Exception ex) {
			setErrorMessage("GestorSolicitudes[listAplicaciones]: "+ex);
		}
	}
	
	public void listEdificios(Session conn) {
		PreparedStatement pstmt = null;
		ResultSet rs = null;
		String myQuery = null;
		espacios = new ArrayList();
		try{
			myQuery = getQuery("UbicacionesSinZona");
			pstmt = conn.connection().prepareStatement(myQuery);
			rs = pstmt.executeQuery();
			while (rs.next()) {
				espacios.add(new Espacio(rs.getString(1),rs.getString(2)));
			}
		}
		catch (Exception ex)
		{
			System.out.println("2"+ex);
			setErrorMessage("Error al listar espacios.");
		} finally {
			try {
				if (rs!=null) rs.close();
				if (pstmt!=null) pstmt.close();
			} catch (Exception exx) {}
		}
	}

	public void listAplicacion(Session conn) {
		try {
			if (solicitud!=null && solicitud.getTarAplCod()!=null) {
				Criteria ct = conn.createCriteria(D7Aplicaciones.class);
				ct = ct.add(Expression.eq("AplSisCod",user.getDatosMenu().idSelected()));
				ct = ct.add(Expression.eq("AplCod",solicitud.getTarAplCod()));
				aplicaciones = ct.list();
				Set s = ((D7Aplicaciones)aplicaciones.get(0)).getAplicaciones_param();
				s.size();
			}
		} catch (Exception ex) {
			setErrorMessage("GestorSolicitudes[listAplicacion]: "+ex);
		}
	}

	public List getAplicaciones() {
		return aplicaciones;
	}

	public String getMaximoDumboRapido() { return maximoDumboRapido; }
	public String getMinimoDumboRapido() { return minimoDumboRapido; }
	public List getMovimientos() { return movimientos; }
	public List getPlantillas() { return plantillas; }
	
	public void listPlantillas(Session conn) {
		try{
			Query q = conn.createQuery(getQuery("GetPlantillas"));
			q = q.setString("sist",user.getDatosMenu().idSelected());
			plantillas = (List)q.list();
		}
		catch (Exception ex)
		{
			setErrorMessage("Error al listar las plantillas.");
		} 
	}
	
	public void limitesDumboRapido(Session conn) {
		try {
			Criteria ct = conn.createCriteria(D7Parametros.class);
			ct = ct.add(Expression.and(Expression.eq("ParSisCod",user.getDatosMenu().idSelected()),Expression.in("ParParametro",new String[]{"PAR_HRS_MAX_RAPIDO","PAR_HRS_MIN_RAPIDO"})));
			List l = ct.list();
			if (l!=null && l.size()>0) {
				for (int k=0; k<l.size(); k++) {
					D7Parametros dp = (D7Parametros)l.get(k);
					if (dp.getParParametro().equals("PAR_HRS_MAX_RAPIDO")) maximoDumboRapido = dp.getParValor();
					if (dp.getParParametro().equals("PAR_HRS_MIN_RAPIDO")) minimoDumboRapido = dp.getParValor();
				}
			}
		} catch (Exception ex) {
			setErrorMessage("GestorSolicitudes[limitesDumboRapido]: "+ex);
		}
	}

	public void detalleTareaPadre(Session conn,String tar) {
		try {
			
			if (tar!=null && !tar.equals("")) {
				Query q = conn.createQuery(getQuery("GetTarea"));
				q = q.setString("sist",user.getDatosMenu().idSelected());
				q = q.setString("tarCod",tar);
				solicitud = (D7Tareas)q.list().get(0);
				solicitud.setSubtareas(null);
			}
			
		} catch (Exception ex) {
			setErrorMessage("GestorSolicitudes[detalleTareaPadre]: "+ex);
		}
	}
	
	public void listPrioridades(Session conn) {
		try {
			prioridades = GestorAuxiliar.getListaPrioridades(user,conn);
		} catch (Exception ex) {
			setErrorMessage("GestorSolicitudes[listPrioridades]: "+ex);
		}
	}
	
	public void listPrioridad(Session conn) {
		try {
			if (solicitud!=null && solicitud.getTarPriCod()!=null) {
				Criteria ct = conn.createCriteria(D7Prioridades.class);
				ct = ct.add(Expression.eq("PriSisCod",user.getDatosMenu().idSelected()));
				ct = ct.add(Expression.eq("PriCod",solicitud.getTarPriCod()));
				prioridades = ct.list();
			}
		} catch (Exception ex) {
			setErrorMessage("GestorSolicitudes[listPrioridad]: "+ex);
		}
	}
	
	public List getPrioridades() {
		return prioridades;
	}

	public void listCategorias(Session conn) {
		try {
			categorias = GestorAuxiliar.getListaCategorias(user,conn);
		} catch (Exception ex) {
			setErrorMessage("GestorSolicitudes[listCategorias]: "+ex);
		}
	}
	public void listCategoria(Session conn) {
		try {
			if (solicitud!=null && solicitud.getTarCatCod()!=null) {
				Criteria ct = conn.createCriteria(D7Categorias.class);
				ct = ct.add(Expression.eq("PriCatCod",user.getDatosMenu().idSelected()));
				ct = ct.add(Expression.eq("CatCod",solicitud.getTarCatCod()));
				categorias = ct.list();
			}
		} catch (Exception ex) {
			setErrorMessage("GestorSolicitudes[listCategoria]: "+ex);
		}
	}
	
	public List getCategorias() {
		return categorias;
	}
	
	public void obtenListadoAplicaciones(Session conn,String code) {
		if ((code==null) || code.equals("")) return;
		listAplicaciones(conn);
	}
	public void obtenListadoPrioridades(Session conn,String code) {
		if ((code==null) || code.equals("")) return;
		listPrioridades(conn);
	}
	public void obtenListadoCategorias(Session conn,String code) {
		if ((code==null) || code.equals("")) return;
		listCategorias(conn);
	}

	public void obtenListadoAplicacion(Session conn,String code) {
		if ((code==null) || code.equals("")) return;
		listAplicacion(conn);
	}
	public void obtenListadoPrioridad(Session conn,String code) {
		if ((code==null) || code.equals("")) return;
		listPrioridad(conn);
	}
	public void obtenListadoCategoria(Session conn,String code) {
		if ((code==null) || code.equals("")) return;
		listCategoria(conn);
	}
	
	public FiltroUsuario getFiltro() { return filtro; }
	public Espacio getUbicSoli() { return ubicSoli; }
	
	//public List getTareasHijas() { return tareasHijas; }
	
	public void setVinculadas(String vic) {
		if ((vic==null) || vic.equals("")) return;
		String txt = vic;
		int n = txt.indexOf(":");
		while (n>0) {
			D7TareasVinculadas tv = new D7TareasVinculadas();
			tv.setTviSisCod(user.getDatosMenu().idSelected());
			tv.setTviVincTarCod(new Integer(txt.substring(0,n)));
			vinculadas.addElement(tv);
			txt = txt.substring(n+1);
			n = txt.indexOf(":");
		}
		D7TareasVinculadas tv = new D7TareasVinculadas();
		tv.setTviSisCod(user.getDatosMenu().idSelected());
		tv.setTviVincTarCod(new Integer(txt));
		vinculadas.addElement(tv);
	}
	
	public String getMessage() { return message; }
	
	public void createContextPath(HttpServlet servlet,HttpServletRequest req,HttpServletResponse res) {
		try {
			rutaAnexos = GestorGenerico.createContextPath(user,servlet);
		} catch (Exception ex) {
			setErrorMessage("GestorSolicitudes[createContextPath]: "+((ex.getCause()!=null)?ex.getCause().getMessage():ex.getMessage()));
		}
	}

	public void setContextPath(HttpServlet servlet,HttpServletRequest req,HttpServletResponse res) {
		try {
			rutaAnexos = GestorGenerico.getContextPath(user,servlet,false);
		} catch (Exception ex) {
			setErrorMessage("GestorSolicitudes[setContextPath]: "+((ex.getCause()!=null)?ex.getCause().getMessage():ex.getMessage()));
		}
	}

	public void readAnexo(Hashtable anexo) {
		if (anexo!=null) {
			String name = (String) anexo.get("filename");
			if ((name!=null) && !name.equals("")) {
				int n = name.lastIndexOf("/");
				if (n<0) n = name.lastIndexOf("\\");
				name = name.substring(n+1);
				anexo.put("filename",name);
				anexos.addElement(anexo);
			}
		}
	}
	
	public void borroAnexosTarea(int tar) {
		GestorGenerico.deleteAnexosTarea(rutaAnexos,""+tar);
	}
	
	public static boolean estaAusente(Session conn,String cod,DumboUser du) {
		GestorSolicitudes gs = new GestorSolicitudes();
		gs.setUser(du);
		return gs.isAusente(conn,cod);
	}
	
	public boolean isAusente(Session conn,String cod) {
		PreparedStatement pstmt = null;
		ResultSet rs = null;
		try {
			Query q = conn.createQuery(getQuery("Parametros"));
			q = q.setString("sist",user.getDatosMenu().idSelected());
			List l = (List)q.list();
			Iterator it = l.iterator();
			while (it.hasNext()) {
				D7Parametros par = (D7Parametros)it.next();
				if (par.getParParametro().equals("PAR_CONTROL_AUSENCIAS")) {
					if (par.getParValor().equals("N")) return false;
				}
			}
			pstmt = conn.connection().prepareStatement(getQuery("EstaAusente"));
			pstmt.setString(1,cod);
			rs = pstmt.executeQuery();
			while (rs.next()) {
				String ausente = rs.getString(1);
				if (ausente.equals("S")) return true;
				else return false;
			}
		} catch (Exception ex) {
			try {
				if (rs!=null) rs.close();
				if (pstmt!=null) pstmt.close();
			} catch (Exception exx) {}
		}
		return false;
	}
	
	
	public String asignarInformaticoAplicacion(Session conn,String aplCod,String ed, String usuario) {
		PreparedStatement pstmt = null;
		ResultSet rs = null;
		try {
			Query q = conn.createQuery(getQuery("GetAplicacion"));
			q = q.setString("sist",user.getDatosMenu().idSelected());
			q = q.setString("cod",aplCod);
			List l = q.list();
			D7Aplicaciones apl = (D7Aplicaciones)l.get(0);
			tipoAsignacion=apl.getAplTipoAsig();
			
			if (apl.getSubaplicaciones()==null || apl.getSubaplicaciones().size()==0) {
				// Es una aplicacin de segundo nivel...
				if (apl.getAplTipoAsig().equals(D7Aplicaciones.POR_PESOS)) {
					// Asignacin por Pesos
					// Busco el informtico de la aplicacin que tenga menos tareas
					String primero = "";

					pstmt = conn.connection().prepareStatement(getQuery("BuscaInformaticoAplicacion"));
					pstmt.setString(1,user.getDatosMenu().idSelected());
					pstmt.setString(2,apl.getAplCod());
					rs = pstmt.executeQuery();
					while (rs.next()) {
						String infoCod = rs.getString(1);
						if (!usuario.equals(infoCod)){
							// Veo si est Ausente, si no est ausente, es el indicado !!
							if (!isAusente(conn,infoCod)) return infoCod;
							if (primero.equals("")) primero = infoCod;
						}
					}
					// Si todos estn ausentes se pone al primero !!
					if (!primero.equals("")) return primero;
					else{
						//Esto significa que en esta aplicacion solo hay un informatico, y es el que est solicitando la tarea
						//en este caso hay que cambiar el solicitante por el jefe del user
						return "cambiaSolicitante";
					}
				} else if (apl.getAplTipoAsig().equals(D7Aplicaciones.POR_RESPONSABLE) ||
						apl.getAplTipoAsig().equals(D7Aplicaciones.POR_UBICACION)) {
					// Asignacin por Responsable o Ubicacin/Responsable
					// Busco el responsable menos atareado de la aplicacin y se la endoso
					// Si no hay responsable (o est ausente) al menos atareado no responsable
					String primero = "";

					if (apl.getAplTipoAsig().equals(D7Aplicaciones.POR_UBICACION))
						pstmt = conn.connection().prepareStatement(getQuery("ResponsableUbicacionInformaticoAplicacion"));
					else pstmt = conn.connection().prepareStatement(getQuery("ResponsableInformaticoAplicacion"));
					pstmt.setString(1,user.getDatosMenu().idSelected());
					pstmt.setString(2,apl.getAplCod());
					if (apl.getAplTipoAsig().equals(D7Aplicaciones.POR_UBICACION))
						pstmt.setString(3,ed);
					rs = pstmt.executeQuery();
					while (rs.next()) {
						String infoCod = rs.getString(1);
						if (!usuario.equals(infoCod)){
							// Veo si est Ausente, si no est ausente, es el indicado !!
							if (!isAusente(conn,infoCod)) return infoCod;
						}
					}
					// No hay informtico en la ubicacin dada
					if (apl.getAplTipoAsig().equals(D7Aplicaciones.POR_UBICACION)) {
						// Se asigna al primer responsable de aplicacin no ausente
						rs.close(); pstmt.close();
						pstmt = conn.connection().prepareStatement(getQuery("ResponsableInformaticoAplicacion"));
						pstmt.setString(1,user.getDatosMenu().idSelected());
						pstmt.setString(2,apl.getAplCod());
						rs = pstmt.executeQuery();
						while (rs.next()) {
							String infoCod = rs.getString(1);
							if (!usuario.equals(infoCod)){
								// Veo si est Ausente, si no est ausente, es el indicado !!
								if (!isAusente(conn,infoCod)) return infoCod;
								if (primero.equals("")) primero = infoCod;
							}
						}
					}
					if (!primero.equals("")) return primero;
					else{
						//Esto significa que en esta aplicacion solo hay un informatico, y es el que est solicitando la tarea
						//en este caso hay que cambiar el solicitante por el jefe del user
						return "cambiaSolicitante";
					}
				} else if (apl.getAplTipoAsig().equals(D7Aplicaciones.POR_COLA)) {
					// Asignacin por cola, basta con poner la aplicacin pero no el informtico.
					return "";
				}
			} else {
				// Se trata de una aplicacin de primer nivel con hijos
				return "";
			}
		} catch (Exception ex) {
			setErrorMessage("GestorSolicitudes[asignarInformaticoAplicacion]: "+((ex.getCause()!=null)?ex.getCause().getMessage():ex.getMessage()));
		} finally {
			try {
				if (rs!=null) rs.close();
				if (pstmt!=null) pstmt.close();
			} catch (Exception exx) {}
		}
		return null;
	}
	
	public void setTemporizacion(dumbo7.utils.D7TareasProgramadas program) {
		temporizacion = program;
	}

	
	public int saveSolicitudBD(Session conn,dumbo7.utils.D7Tareas sol) {
		int tarCod = 0;
		try {
			// ************************************************
			// Comprueba que Solicitante e Informtico Existen
			// ************************************************

			String cop = sol.getTarEmailCopia();
			if ((cop!=null) && !cop.equals("")) {
				if (!GestorGenerico.isMailList(cop)) throw new Exception("El Correo para copia, "+cop+" no es correcto.");
			}
			//Puede ser un email o un dni !!
			String mailUsu = sol.getTarUsuCod().toLowerCase();
			sol.setTarUsuCod(D7Conversor.convierteMailExterno(conn,mailUsu,IDENTIFICADOR_EXTERNO));
			if (sol.getTarUsuCod().equals(IDENTIFICADOR_EXTERNO)) {
				if (cop!=null) {
					if (cop.equals("")) cop = mailUsu;
					else cop = mailUsu+","+cop;
				}
				sol.setTarEmailCopia(cop);
			}
			//Puede ser un email o un dni !!
			String mailInf = sol.getTarInfCod().toLowerCase();
			if (!mailInf.equals("")) sol.setTarInfCod(D7Conversor.convierteMail(conn,mailInf));

			// Comprueba que son Diferentes !!!
			if (sol.getTarInfCod().equals(sol.getTarUsuCod())) throw new Exception("No puede solicitarse tareas a uno mismo.");
			
			
			// **************************************************************
			// Comprueba la Aplicacin si no est seleccionada no la incluye
			// **************************************************************
			
			sol.setTarEstado(D7Tareas.PENDIENTE); // Tarea Pendiente de Asignacin, sin informtico 

			if ((sol.getTarAplCod()!=null) && sol.getTarAplCod().equals("-1")) sol.setTarAplCod(null);
			else  {
				// Si es un problema no se asigna !!
				if (!sol.getTarTipCod().equals(D7TiposTareas.PROBLEMA)) {
					// Busco el Informtico para Asignar 
					// Si ya tengo miro que est ligado a la aplicacin dada !!
					// Puede ser un DNI o Mail.
					if ((sol.getTarInfCod()!=null) && !sol.getTarInfCod().equals("")) {
						Query q = conn.createQuery(getQuery("esInformatico"));
						q = q.setString("sist",user.getDatosMenu().idSelected());
						q = q.setString("info",sol.getTarInfCod());
						//q = q.setString("apl",sol.getTarAplCod());
						List inf = q.list();
						if (inf.size()!=1) throw new Exception("El Usuario "+sol.getTarInfCod()+" no es Informtico.");
						if (sol.getTarInfCod().indexOf("@")>0) sol.setTarInfCod(D7Conversor.convierteMail(conn,sol.getTarInfCod().toLowerCase()));
						//else sol.setTarInfCod(sol.getTarInfCod());
						// El Informtico es correcto el estado de la solicitud ser Asignada !!
						sol.setTarEstado(D7Tareas.ASIGNADA);
					} else if (!sol.getTarTipCod().equals(D7TiposTareas.PROGRAMADA)) {
						// Si no hay informtico pero si aplicacin asigno uno automticamente
						// Si es programada se asigna cuando se genere la subtarea !!
						String infCod = asignarInformaticoAplicacion(conn,sol.getTarAplCod(),sol.getTarEDUbicacion(),sol.getTarUsuCod());
						if (infCod.equals("cambiaSolicitante")){
							//Debemos buscar el responsable de la seccion a la que pertenece el user y ponerle de solicitante de la tarea
							Query q = conn.createQuery(getQuery("responsableSeccionUser"));
							q = q.setString("sist",user.getDatosMenu().idSelected());
							q = q.setString("info",sol.getTarUsuCod());
							String resp=((D7Secciones)q.list().get(0)).getSecIdRespon();
							sol.setTarInfCod(sol.getTarUsuCod());
							sol.setTarUsuCod(resp);
							sol.setTarEstado(D7Tareas.ASIGNADA);
						}else if (infCod!=null) {
							// El Informtico es correcto el estado de la solicitud ser Asignada !!
							if (!infCod.equals("")) {
								sol.setTarInfCod(infCod);
								sol.setTarEstado(D7Tareas.ASIGNADA);
							}
						} else {
							// No se ha podido asignar la tarea !!
							sol.setTarInfCod(null);
							sol.setTarAplCod(null);
							sol.setTarEstado(D7Tareas.PENDIENTE);
						}
						
						
					}
				}
			}
			
			// ************************************************
			// Comprueba la fecha mxima posterior o igual a hoy.
			// ************************************************
			/* Se controla en JavaScript
			if ((sol.getTarFecmaxResol()!=null) && !sol.getTarFecmaxResol().equals("")) {
				if (sol.getTarFecmaxResol().compareTo(new java.util.Date())<0)
					throw new Exception("La Fecha Mxima de Resolucin debe ser Posterior a la Fecha Actual.");
			}
			*/
			
			PreparedStatement pstmt = null;
			ResultSet rs = null;
			try {
				String qry = getQuery("NextCodigoTarea");
				qry = qry.replaceFirst("sistema",user.getDatosMenu().idSelected());
				pstmt = conn.connection().prepareStatement(qry);
				rs = pstmt.executeQuery();
				if (rs.next()) {
					tarCod = rs.getInt(1);
				}
			} catch (Exception ex) {
				throw ex;
			} finally {
				if (pstmt!=null) pstmt.close();
				if (rs!=null) rs.close();
			}
			
			// ************************************************
			// Tratamiento de Anexos !!
			// ************************************************
			FileOutputStream stream = null;
			ZipOutputStream out = null;
			if (anexos.size()>0) {
		        stream = new FileOutputStream(rutaAnexos+GestorGenerico.getPrefijoZip(""+tarCod)+".zip");
			    out = new ZipOutputStream(stream);
			}
			Enumeration en = anexos.elements();
			while (en.hasMoreElements()) {
				Hashtable file = (Hashtable) en.nextElement();
				File fforg = new File((String)file.get("content"));
				if (!fforg.exists()) throw new Exception("El fichero "+(String)file.get("filename")+" excede el tamao mximo permitido 15MB.");
				FileInputStream forigen = new FileInputStream(fforg);
				String nombreAnexo = GestorGenerico.getNameAnexoSolicitud(rutaAnexos,""+tarCod,(String)file.get("filename"));
				FileOutputStream fdestino = new FileOutputStream(nombreAnexo);
				
		        // Add archive entry
		        ZipEntry zipAdd = new ZipEntry((String)file.get("filename"));
		        zipAdd.setTime(fforg.lastModified());
		        out.putNextEntry(zipAdd);
				
				byte [] bytes = new byte[4096];
				int leido = forigen.read(bytes,0,4096);
				while (leido!=-1) {
					fdestino.write(bytes,0,leido);
					out.write(bytes,0,leido);
					leido = forigen.read(bytes,0,4096);
				}
				forigen.close(); fdestino.close();
				fforg.delete();
			}
			// Comprimo los anexos en un nico Zip !!
			if (anexos.size()>0) {
		        out.close();
				stream.close();
			}
			sol.setTarCod(new Integer(tarCod));
			sol.setTarSisCod(user.getDatosMenu().idSelected());
			sol.setTarFeccrea(new java.util.Date());
			if (sol.getTarUrgencia()!=null && !sol.getTarUrgencia().equals(D7Tareas.URGENTE) && !sol.getTarUrgencia().equals(D7Tareas.NO_URGENTE)) sol.setTarUrgencia(null);
			if (sol.getTarAplCod()!=null && (sol.getTarPriCod()==null || sol.getTarPriCod().equals(""))) sol.setTarPriCod(getPrioridadAplicacion(conn,(DumboUser)user,sol.getTarAplCod(),sol.getTarTipCod()));
			conn.save(sol);
			
			message = "La tarea "+tarCod+" ha sido generada.";
			
			return tarCod;
			
		} catch (Exception ex) {
			borroAnexosTarea(tarCod);
			setErrorMessage("GestorSolicitudes[saveSolicitudBD]: "+((ex.getCause()!=null)?ex.getCause().getMessage():ex.getMessage()));
			return -1;
		}
	}
	
	public static String getPrioridadAplicacion(Session conn,DumboUser user,String aplCod,String tipoTarea) throws Exception {
		try {
			String systemPr = null;
			Criteria ct = conn.createCriteria(D7Parametros.class);
			ct = ct.add(Expression.and(Expression.eq("ParSisCod",user.getDatosMenu().idSelected()),Expression.eq("ParParametro","PAR_PRIORIDAD")));
			List l = ct.list();
			if (l!=null && l.size()>0) systemPr = ((D7Parametros)l.get(0)).getParValor();
			ct = conn.createCriteria(D7AplicacionesParametros.class);
			ct = ct.add(Expression.eq("ApaSisCod",user.getDatosMenu().idSelected()));
			ct = ct.add(Expression.eq("ApaAplCod",aplCod));
			ct = ct.add(Expression.eq("ApaTipCod",(tipoTarea==null || tipoTarea.equals(""))?D7TiposTareas.PETICION:tipoTarea));
			l = ct.list();
			if (l!=null && l.size()>0) {
				String pr = ((D7AplicacionesParametros)l.get(0)).getApaPrioridad();
				if (pr!=null) systemPr = pr;
			}
			return systemPr;
		} catch (Exception ex) { throw ex; }
	}
	
	private void asignarProblema(Session conn,D7Tareas tar) throws Exception {
		try {
			Query q = conn.createQuery(getQuery("DetalleTarea"));
			q = q.setString("sist",user.getDatosMenu().idSelected());
			q = q.setString("code",""+tar.getTarPadreTarCod());
			D7Tareas tp = (D7Tareas) q.list().get(0);
			if (tp.getTarEstado().equals(D7Tareas.PENDIENTE) && tp.getTarTipCod().equals(D7TiposTareas.PROBLEMA)) {
				// Asigno el problema al usuario que pone la primera subtarea !!
				String textoActual = "Estado: "+tp.getTarEstado()+" "+user.traduce("dumbo7/user","Informtico",user.getDatosMenu().idSelected())+": "+tp.getTarUsuEmail();
				tp.setTarEstado(D7Tareas.ASIGNADA);
				tp.setTarInfCod(tar.getTarUsuCod());
				String textoNuevo = "Estado: "+tp.getTarEstado()+" "+user.traduce("dumbo7/user","Informtico",user.getDatosMenu().idSelected())+": "+tp.getTarUsuEmail();
				
				GestorGenerico.registrarMovimiento(conn,user,""+tar.getTarPadreTarCod(),GestorGenerico.ASIGNACION_PROBLEMA,D7TareasMovimientos.ASIGNAR_DIRECTA,textoActual,textoNuevo);
				
				conn.saveOrUpdate(tp);
				
			}
		} catch (Exception ex) { throw ex; }
	}
	
	private boolean isPorCola(Session conn,String aplCod) {
		Criteria ct = conn.createCriteria(D7Aplicaciones.class);
		ct = ct.add(Expression.eq("AplSisCod",user.getDatosMenu().idSelected()));
		ct = ct.add(Expression.eq("AplCod",aplCod));
		ct = ct.add(Expression.eq("AplTipoAsig",D7Aplicaciones.POR_COLA));
		List l = ct.list();
		return (l.size()==1);
	}
	
	public void saveSolicitud(Session conn,dumbo7.utils.D7Tareas sol) {
		String tipoAsignacion="";
		if ((sol.getTarInfCod()==null) || sol.getTarInfCod().equals(""))  tipoAsignacion=D7TareasMovimientos.ASIGNAR_DIRECTA;
		else tipoAsignacion= D7TareasMovimientos.ASIGNAR_DIRECTA_COMPLETA;
		if (sol.getTarAplCod()!=null && sol.getTarAplCod().indexOf(",")>0) {
			// Subtarea a varias aplicaciones !!
			// Inicio la transaccin.
			String tarCods = "";D7Tareas miTar = null;
			int tarCod = -1;
			Transaction tx = conn.beginTransaction();
			try {
				String txt = sol.getTarAplCod();
				int n = 0;
				do {
					n = txt.indexOf(",");
					miTar = sol.cloneTarea();
					if (n>=0) miTar.setTarAplCod(txt.substring(0,n));
					else miTar.setTarAplCod(txt);
					tarCod = saveSolicitudBD(conn,miTar);
					if (tarCod!=-1) {
						if (miTar.getTarEstado().equals(D7Tareas.ASIGNADA)) {
							/*
							if (user.getPasswd()==null || user.getPasswd().equals("")) {
								DumboUser newuser = new DumboUser(conn,miTar.getTarInfCod(),"",user.getDatosMenu().idSelected());
								newuser.getDatosMenu().idSelected = user.getDatosMenu().idSelected();
								// Modifico el Usuario del Gestor de Solicitudes.
								setUser(newuser);
							}
							*/
							GestorGenerico.registrarMovimiento(conn,user,""+tarCod,GestorGenerico.SOLICITUD_TAREA,D7TareasMovimientos.SOLICITAR_TAREA,"","");
							GestorGenerico.registrarMovimiento(conn,user,""+tarCod,GestorGenerico.ASIGNACION_TAREA,tipoAsignacion,"",miTar.getTarInfEmail().toLowerCase());
							GestorGenerico.enviarNotificacion(conn,user,miTar,new String[]{GestorGenerico.NotificacionInformaticoAsignacion,GestorGenerico.NotificacionUsuarioAsignacion},rutaAnexos);
						} else if (miTar.getTarAplCod()!=null && isPorCola(conn,miTar.getTarAplCod())) {
							// Tarea Pendiente de Asignar y por cola
							GestorGenerico.registrarMovimiento(conn,user,""+tarCod,GestorGenerico.SOLICITUD_TAREA,D7TareasMovimientos.SOLICITAR_TAREA,"","");
							GestorGenerico.enviarNotificacion(conn,user,miTar,new String[]{GestorGenerico.NotificacionInformaticoAsignacionCola},rutaAnexos);
						} else {
							// La tarea queda en la cola genrica
							GestorGenerico.registrarMovimiento(conn,user,""+tarCod,GestorGenerico.SOLICITUD_TAREA,D7TareasMovimientos.SOLICITAR_TAREA,"","");
						}
						tarCods += tarCods.equals("")?""+tarCod:","+tarCod;
					}
					if (n>=0) txt = txt.substring(n+1);
				} while (n>=0);
				tareaActual=tarCod;
				tx.commit();
				message = "Las tareas "+tarCods+" han sido generadas con xito.";
			} catch(Exception ex) {
				if (tarCod!=-1) borroAnexosTarea(tarCod);
				setErrorMessage("GestorSolicitudes[saveSolicitud]: "+((ex.getCause()!=null)?ex.getCause().getMessage():ex.getMessage()));
				tx.rollback();
			}
		} else {
			// Inicio la transaccin.
			Transaction tx = conn.beginTransaction();
			int tarCod = saveSolicitudBD(conn,sol);
			try {
				if (tarCod!=-1) {
					if ((sol.getTarPadreTarCod()!=null) && (!sol.getTarPadreTarCod().equals(""))) {
						// Asignar el problema si no est asignado !!
						asignarProblema(conn,sol);
					}
					if (sol.getTarEstado().equals(D7Tareas.ASIGNADA)) {
						if (user.getPasswd()==null || user.getPasswd().equals("")) {
							DumboUser newuser = new DumboUser(conn,sol.getTarInfCod(),"",user.getDatosMenu().idSelected());
							newuser.getDatosMenu().idSelected = user.getDatosMenu().idSelected();
							// Modifico el Usuario del Gestor de Solicitudes.
							setUser(newuser);
						}
						String textoNuevo = D7Conversor.convierteIdentificador(conn,sol.getTarInfCod().toLowerCase());
						
						GestorGenerico.registrarMovimiento(conn,user,""+tarCod,GestorGenerico.SOLICITUD_TAREA,D7TareasMovimientos.SOLICITAR_TAREA,"","");
						GestorGenerico.registrarMovimiento(conn,user,""+tarCod,GestorGenerico.ASIGNACION_TAREA,tipoAsignacion,"",textoNuevo);
						GestorGenerico.enviarNotificacion(conn,user,sol,new String[]{GestorGenerico.NotificacionInformaticoAsignacion,GestorGenerico.NotificacionUsuarioAsignacion},rutaAnexos);
					} else if (sol.getTarAplCod()!=null && isPorCola(conn,sol.getTarAplCod())) {
						// Tarea Pendiente de Asignar y por cola
						GestorGenerico.registrarMovimiento(conn,user,""+tarCod,GestorGenerico.SOLICITUD_TAREA,D7TareasMovimientos.SOLICITAR_TAREA,"","");
						GestorGenerico.enviarNotificacion(conn,user,sol,new String[]{GestorGenerico.NotificacionInformaticoAsignacionCola},rutaAnexos);
					} else {
						// La tarea queda en la cola genrica
						GestorGenerico.registrarMovimiento(conn,user,""+tarCod,GestorGenerico.SOLICITUD_TAREA,D7TareasMovimientos.SOLICITAR_TAREA,"","");
					}
					tareaActual=tarCod;
					tx.commit();
				} else tx.rollback();
			} catch (Exception ex) {
				borroAnexosTarea(tarCod);
				setErrorMessage("GestorSolicitudes[saveSolicitud]: "+((ex.getCause()!=null)?ex.getCause().getMessage():ex.getMessage()));
				tx.rollback();
			}
		}		
	}

	public void saveSolicitudProgramada(Session conn,dumbo7.utils.D7Tareas sol) {
		// Inicio la transaccin.
		Transaction tx = conn.beginTransaction();
		int tarCod = saveSolicitudBD(conn,sol);
		try {
			if (tarCod!=-1) {
				// Establece el cdigo de tarea y sistema y guarda la temporizacin.
				temporizacion.setTprSisCod(user.getDatosMenu().idSelected());
				temporizacion.setTprTarCod(new Integer(tarCod));
				conn.save(temporizacion);
				// Todo Correcto !!
				tx.commit();
			} else tx.rollback();
		} catch (Exception ex) {
			borroAnexosTarea(tarCod);
			setErrorMessage("GestorSolicitudes[saveSolicitudProgramada]: "+((ex.getCause()!=null)?ex.getCause().getMessage():ex.getMessage()));
			tx.rollback();
		}
	}

	public void saveSolicitudProblema(Session conn,dumbo7.utils.D7Tareas sol) {
		// Inicio la transaccin.
		Transaction tx = conn.beginTransaction();
		int tarCod = saveSolicitudBD(conn,sol);
		try {
			if (tarCod!=-1) {
				// Establece las tareas vinculadas al problema.
				Enumeration en = vinculadas.elements(); 
				while (en.hasMoreElements()) {
					D7TareasVinculadas tp = (D7TareasVinculadas)en.nextElement();
					tp.setTviTarCod(new Integer(tarCod));
					conn.save(tp);
				}
				GestorGenerico.enviarNotificacion(conn,user,sol,new String[]{GestorGenerico.NotificacionUsuarioProblema},rutaAnexos);
				// Todo Correcto !!
				tx.commit();
			} else tx.rollback();
		} catch (Exception ex) {
			borroAnexosTarea(tarCod);
			setErrorMessage("GestorSolicitudes[saveSolicitudProgramada]: "+((ex.getCause()!=null)?ex.getCause().getMessage():ex.getMessage()));
			tx.rollback();
		}
	}

	public BigDecimal calculaCoste(Session conn,BigDecimal hrs,String info,String apl) {
		try {
			
			Criteria ct = conn.createCriteria(D7Informaticos.class);
			ct = ct.add(Expression.eq("InfSisCod",user.getDatosMenu().idSelected()));
			ct = ct.add(Expression.eq("InfCod",info));
			
			D7Informaticos inf = (D7Informaticos)ct.list().get(0);
			
			ct = conn.createCriteria(D7GruposCostes.class);
			ct = ct.add(Expression.eq("GcoSisCod",user.getDatosMenu().idSelected()));
			ct = ct.add(Expression.eq("GcoCod",inf.getInfGcoCod()));
			
			D7GruposCostes gc = (D7GruposCostes)ct.list().get(0);
			return gc.getGcoCoste().multiply(hrs);
			
		} catch (Exception ex) {}
		return new BigDecimal(0);
	}
	
	private void copiarDatosTarea(D7Tareas destino,D7Tareas origen) {
		destino.setTarEmailCopia(origen.getTarEmailCopia());
		destino.setTarInfCod(origen.getTarInfCod());
		destino.setTarUsuCod(origen.getTarUsuCod());
		destino.setTarAsunto(origen.getTarAsunto());
		destino.setTarDescrip(origen.getTarDescrip());
		destino.setTarDescripSegui(origen.getTarDescripSegui());
		destino.setTarAplCod(origen.getTarAplCod());
		destino.setTarHorasRes(origen.getTarHorasRes());
		destino.setTarTipCod(origen.getTarTipCod());
		destino.setTarUrgencia(origen.getTarUrgencia());
		destino.setTarPriCod(origen.getTarPriCod());
	}
	
	public D7Tareas updateSolicitudBD(Session conn,dumbo7.utils.D7Tareas solpar) {
		int tarCod = solpar.getTarCod().intValue();
		try {
			
			// Extrae la tarea de BBDD
			Query qa = conn.createQuery(getQuery("DetalleTarea"));
			qa = qa.setString("sist",user.getDatosMenu().idSelected());
			qa = qa.setString("code",""+tarCod);
			D7Tareas sol = (D7Tareas) qa.list().get(0);
			copiarDatosTarea(sol,solpar);
			
			// ************************************************
			// Comprueba que Solicitante e Informtico Existen
			// ************************************************

			String cop = sol.getTarEmailCopia();
			if ((cop!=null) && !cop.equals("")) {
				if (!GestorGenerico.isMailString(cop)) throw new Exception("El Correo para copia, "+cop+" no es correcto.");
				sol.setTarEmailCopia(sol.getTarEmailCopia());
			}
			//Puede ser un email o un dni !!
			String mailUsu = sol.getTarUsuCod().toLowerCase();
			sol.setTarUsuCod(D7Conversor.convierteMailExterno(conn,mailUsu,IDENTIFICADOR_EXTERNO));
			if (sol.getTarUsuCod().equals(IDENTIFICADOR_EXTERNO)) {
				if (cop!=null) {
					if (cop.equals("")) cop = mailUsu;
					else cop = mailUsu+","+cop;
				}
				sol.setTarEmailCopia(cop);
			}
			//Puede ser un email o un dni !!
			String mailInf = sol.getTarInfCod().toLowerCase();
			if (!mailInf.equals("")) sol.setTarInfCod(D7Conversor.convierteMail(conn,mailInf));

			// **************************************************************
			// Comprueba la Aplicacin si no est seleccionada no la incluye
			// **************************************************************
			
			if ((sol.getTarAplCod()!=null) && sol.getTarAplCod().equals("-1")) sol.setTarAplCod(null);
			else  {
				// Si es un problema no se asigna !!
				if (!sol.getTarTipCod().equals(D7TiposTareas.PROBLEMA)) {
					// Busco el Informtico para Asignar 
					// Si ya tengo miro que est ligado a la aplicacin dada !!
					// Puede ser un DNI o Mail.
					if ((sol.getTarInfCod()!=null) && !sol.getTarInfCod().equals("")) {
						Query q = conn.createQuery(getQuery("esInformatico"));
						q = q.setString("sist",user.getDatosMenu().idSelected());
						q = q.setString("info",sol.getTarInfCod());
						//q = q.setString("apl",sol.getTarAplCod());
						List inf = q.list();
						if (inf.size()!=1) throw new Exception("El Usuario "+sol.getTarInfCod()+" no es Informtico.");
						if (sol.getTarInfCod().indexOf("@")>0) sol.setTarInfCod(D7Conversor.convierteMail(conn,sol.getTarInfCod().toLowerCase()));
						//else sol.setTarInfCod(sol.getTarInfCod());
						// El Informtico es correcto el estado de la solicitud ser Asignada !!
						sol.setTarEstado(D7Tareas.ASIGNADA);
					} else if (!sol.getTarTipCod().equals(D7TiposTareas.PROGRAMADA)) {
						// Si no hay informtico pero si aplicacin asigno uno automticamente
						// Si es programada se asigna cuando se genere la subtarea !!
						String infCod = asignarInformaticoAplicacion(conn,sol.getTarAplCod(),sol.getTarEDUbicacion(),sol.getTarUsuCod());
						if (infCod.equals("cambiaSolicitante")){
							//Debemos buscar el responsable de la seccion a la que pertenece el user y ponerle de solicitante de la tarea
							Query q = conn.createQuery(getQuery("responsableSeccionUser"));
							q = q.setString("sist",user.getDatosMenu().idSelected());
							q = q.setString("info",sol.getTarUsuCod());
							String resp=((D7Secciones)q.list().get(0)).getSecIdRespon();
							sol.setTarInfCod(sol.getTarUsuCod());
							sol.setTarUsuCod(resp);
							sol.setTarEstado(D7Tareas.ASIGNADA);
						}else if (infCod!=null) {
							// El Informtico es correcto el estado de la solicitud ser Asignada !!
							if (!infCod.equals("")) {
								sol.setTarInfCod(infCod);
								sol.setTarEstado(D7Tareas.ASIGNADA);
							}
						} else {
							// No se ha podido asignar la tarea !!
							sol.setTarInfCod(null);
							sol.setTarAplCod(null);
							sol.setTarEstado(D7Tareas.PENDIENTE);
						}
						
						
					}
				}
			}
			
			// ************************************************
			// Comprueba la fecha mxima posterior o igual a hoy.
			// ************************************************
			/* Se controla en JavaScript
			if ((sol.getTarFecmaxResol()!=null) && !sol.getTarFecmaxResol().equals("")) {
				if (sol.getTarFecmaxResol().compareTo(new java.util.Date())<0)
					throw new Exception("La Fecha Mxima de Resolucin debe ser Posterior a la Fecha Actual.");
			}
			*/
			
			sol.setTarSisCod(user.getDatosMenu().idSelected());
			sol.setTarFeccrea(new java.util.Date());
			if (sol.getTarUrgencia()!=null && !sol.getTarUrgencia().equals(D7Tareas.URGENTE) && !sol.getTarUrgencia().equals(D7Tareas.NO_URGENTE)) sol.setTarUrgencia(null);
			if (sol.getTarAplCod()!=null && (sol.getTarPriCod()==null || sol.getTarPriCod().equals(""))) sol.setTarPriCod(getPrioridadAplicacion(conn,(DumboUser)user,sol.getTarAplCod(),sol.getTarTipCod()));
			
			message = "La tarea "+tarCod+" ha sido modificada.";
			
			return sol;
			
		} catch (Exception ex) {
			borroAnexosTarea(tarCod);
			setErrorMessage("GestorSolicitudes[updateSolicitudBD]: "+((ex.getCause()!=null)?ex.getCause().getMessage():ex.getMessage()));
			return null;
		}
	}
	
	public void saveSolicitudRapida(Session conn,dumbo7.utils.D7Tareas sol) {
		// Inicio la transaccin.
		D7Tareas newsol = sol;
		Transaction tx = conn.beginTransaction();
		int tarCod = -1;
		if (sol.getTarCod()==null) tarCod = saveSolicitudBD(conn,sol);
		else {
			// Falta asignar ciertos datos a la tarea
			newsol = updateSolicitudBD(conn,sol);
			tarCod = newsol.getTarCod().intValue();
		}
		try {
			if (tarCod!=-1) {
				// Todo Correcto
				// Finalizo el Dumbo !!
				newsol.setTarEstado(D7Tareas.FINALIZADA);
				newsol.setTarFecfin(new java.util.Date());
				newsol.setTarCosteEco(calculaCoste(conn,sol.getTarHorasRes(),sol.getTarInfCod(),sol.getTarAplCod()));
				if (newsol.getTarTipCod().equals(D7TiposTareas.INCIDENCIA)) newsol.setTarCatCod(D7Categorias.CAT_DUMBO_RAPIDO_INC);
				else newsol.setTarCatCod(D7Categorias.CAT_DUMBO_RAPIDO_PET);
				conn.saveOrUpdate(newsol);
				tx.commit();

				GestorGenerico.registrarMovimiento(conn,user,""+tarCod,GestorGenerico.ASIGNACION_TAREA,D7TareasMovimientos.ASIGNAR_DIRECTA,"",sol.getTarInfEmail());
				GestorGenerico.registrarMovimiento(conn,user,""+tarCod,sol.getTarDescripSegui(),D7TareasMovimientos.FINALIZAR_TAREA,"","");
				GestorGenerico.enviarNotificacion(conn,user,sol,new String[]{GestorGenerico.NotificacionUsuarioResolucionTelefonica});
				
				message += " Y ha sido resuelta."; 
				
			} else tx.rollback();
		} catch (Exception ex) {
			borroAnexosTarea(tarCod);
			setErrorMessage("GestorSolicitudes[saveSolicitudRapida]: "+((ex.getCause()!=null)?ex.getCause().getMessage():ex.getMessage()));
			tx.rollback();
		}
	}
	
	public void detalleSolicitud(Session conn,String code) {
		try {
			if ((code==null) || code.equals("")) return;
			Query q = conn.createQuery(getQuery("DetalleTarea"));
			q = q.setString("sist",user.getDatosMenu().idSelected());
			q = q.setString("code",code);
			solicitud = (D7Tareas)q.list().get(0);
			if (!solicitud.getTarUsuCod().equals(DumboUser.CODIGO_EXTERNO)) solicitud.getDatosUser().setDatEmail(D7Conversor.convierteIdentificador(conn,solicitud.getTarUsuCod()));
			solicitud.tieneSubtareasNoFinalizadas();
			solicitud.setSubtareas(new HashSet());

			// Veo si la tarea se puede rechazar !!
			java.sql.PreparedStatement pstmt = null;
			java.sql.ResultSet rs = null;
			
			try {

				pstmt = conn.connection().prepareStatement(getQuery("tareaRechazable"));
				pstmt.setString(1,user.getDatosMenu().idSelected());
				pstmt.setString(2,code);
				pstmt.setString(3,user.getDatosMenu().idSelected());
				rs = pstmt.executeQuery();
				if (rs.next()) {
					if (Integer.parseInt(rs.getString(1))<0) solicitud.setTarRechazar("S");
					else solicitud.setTarRechazar("N");
				} else solicitud.setTarRechazar("N");
				
				if (solicitud.getTarEstado().equals(D7Tareas.FINALIZADA) || solicitud.getTarEstado().equals(D7Tareas.RECHAZADA)) {
					// Si es el detalle de una tarea finalizada o rechazada incluye el texto de fin.
					Criteria ct = conn.createCriteria(D7TareasMovimientos.class);
					ct = ct.add(Expression.eq("TmoSisCod",user.getDatosMenu().idSelected()));
					ct = ct.add(Expression.eq("TmoTarCod",solicitud.getTarCod()));
					ct = ct.add(Expression.eq("TmoTipoMov",D7TareasMovimientos.FINALIZAR_TAREA));
					movimientos = ct.list();
				}
				
			} catch (Exception ex) {
				throw ex;
			} finally {
				try {
					if (rs!=null) rs.close();
					if (pstmt!=null) pstmt.close();
				} catch (Exception exc) {}
			}

			
			anexos = GestorGenerico.getAnexosTarea(rutaAnexos,solicitud);
			
		} catch (Exception ex) {
			setErrorMessage("GestorSolicitudes[detalleSolicitudPendiente]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
	}

	public D7TareasProgramadas getTemporizacion() { return temporizacion; }
	
	public void detalleProgramacion(Session conn,String code) {
		try {
			
			if ((code==null) || code.equals("")) return;
			Query q = conn.createQuery(getQuery("DetalleTareaProgramada"));
			q = q.setString("sist",user.getDatosMenu().idSelected());
			q = q.setString("code",code);
			List l = q.list();
			if ((l==null) || (l.size()==0)) return;
			temporizacion = (D7TareasProgramadas)l.get(0);
			
		} catch (Exception ex) {
			setErrorMessage("GestorSolicitudes[detalleProgramacion]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
	}

	public void filtroListaPendientes(Session conn) {
		setPageSize(new Integer(filtro.getTamPag()).intValue());
		if (filtro.getFormato().equals(FiltroUsuario.FORMATO_LISTA) && solicitud==null) listSolicitudesPendientes(conn);
		solicitud = null;
	}
	
	public void listSolicitudesPendientes(Session conn) {
		try {
			/*
			Query q = aplicaFiltro(conn,"TareasUsuarioPendientes",FiltroUsuario.LISTA_PENDIENTES);
			q = q.setString("sist",user.getDatosMenu().idSelected());
			q = q.setString("usu",user.getIdentificador());
			List l = q.list();

			for (int k=0; k<l.size(); k++) {
				D7Tareas tar = (D7Tareas)l.get(k);
				//tar.getAplicacionDesc();
				if ((filtro.getSubtareas()==null) || filtro.getSubtareas().equals("S")) 
					tar.setSubtareas(exploraSubtareas(conn,tar,false));
				else tar.setSubtareas(null);
			}
			setCollection(l);
			*/
			Hashtable params = new Hashtable();
			params.put("1",user.getDatosMenu().idSelected());
			params.put("2",user.getIdentificador());
			boolean subtareas = false;
			if (filtro.getVerSubtareas((DumboUser)user)) {
				if ((filtro.getSubtareas()==null) || filtro.getSubtareas().equals("S")) {
					subtareas = true;
				}
			}
			filtro.setTipo(FiltroUsuario.LISTA_PENDIENTES);
			List l = aplicaFiltroSQL(conn,"TareasUsuarioPendientesSQL",subtareas,FiltroUsuario.LISTA_PENDIENTES,params);
			/*
			if (filtro.getVerSubtareas((DumboUser)user)) {
			if ((filtro.getSubtareas()==null) || filtro.getSubtareas().equals("S")) {
				for (int k=0; k<l.size(); k++) {
					D7Tareas tar = (D7Tareas)l.get(k);
					tar.setSubtareas(GestorGenerico.exploraSubtareas(conn,user,tar,getQuery("SubTareasSQL"),filtro.getSubtareas().equals("S")));
				}
			}
			}
			*/
			setCollection(l);
			
		} catch (Exception ex) {
			setErrorMessage("GestorSolicitudes[listSolicitudesPendientes]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
	}
	
	public void filtroListaResueltas(Session conn) {
		setPageSize(new Integer(filtro.getTamPag()).intValue());
		if (filtro.getFormato().equals(FiltroUsuario.FORMATO_LISTA) && solicitud==null) listSolicitudesResueltas(conn);
		solicitud = null;
	}
	
	public void listSolicitudesResueltas(Session conn) {
		try {
			/*
			Query q = aplicaFiltro(conn,"TareasUsuarioResueltas",FiltroUsuario.LISTA_RESUELTAS);
			q = q.setString("sist",user.getDatosMenu().idSelected());
			q = q.setString("usu",user.getIdentificador());
			List l = q.list();

			for (int k=0; k<l.size(); k++) {
				D7Tareas tar = (D7Tareas)l.get(k);
				//tar.getAplicacionDesc();
				if ((filtro.getSubtareas()==null) || filtro.getSubtareas().equals("S")) 
					tar.setSubtareas(exploraSubtareas(conn,tar,false));
				else tar.setSubtareas(null);
			}
			setCollection(l);
			*/
			Hashtable params = new Hashtable();
			params.put("1",user.getDatosMenu().idSelected());
			params.put("2",user.getIdentificador());
			boolean subtareas = false;
			if (filtro.getVerSubtareas((DumboUser)user)) {
				if ((filtro.getSubtareas()==null) || filtro.getSubtareas().equals("S")) {
					subtareas = true;
				}
			}
			filtro.setTipo(FiltroUsuario.LISTA_RESUELTAS);
			List l = aplicaFiltroSQL(conn,"TareasUsuarioResueltasSQL",subtareas,FiltroUsuario.LISTA_RESUELTAS,params);
			/*
			if (filtro.getVerSubtareas((DumboUser)user)) {
			if ((filtro.getSubtareas()==null) || filtro.getSubtareas().equals("S")) {
				for (int k=0; k<l.size(); k++) {
					D7Tareas tar = (D7Tareas)l.get(k);
					tar.setSubtareas(GestorGenerico.exploraSubtareas(conn,user,tar,getQuery("SubTareasSQL"),filtro.getSubtareas().equals("S")));
				}
			}
			}
			*/
			setCollection(l);
			
		} catch (Exception ex) {
			setErrorMessage("GestorSolicitudes[listSolicitudesResueltas]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
	}

	public void filtroListaProgramadas(Session conn) {
		setPageSize(new Integer(filtro.getTamPag()).intValue());
		if (filtro.getFormato().equals(FiltroUsuario.FORMATO_LISTA) && solicitud==null) listSolicitudesProgramadas(conn);
		solicitud = null;
	}
	
	public void listSolicitudesProgramadas(Session conn) {
		try {
			/*
			Query q = aplicaFiltro(conn,"TareasUsuarioProgramadas",FiltroUsuario.LISTA_PROGRAMADAS);
			q = q.setString("sist",user.getDatosMenu().idSelected());
			q = q.setString("usu",user.getIdentificador());
			List l = q.list();

			for (int k=0; k<l.size(); k++) {
				D7Tareas tar = (D7Tareas)l.get(k);
				//tar.getAplicacionDesc();
				if ((filtro.getSubtareas()==null) || filtro.getSubtareas().equals("S")) 
					tar.setSubtareas(exploraSubtareas(conn,tar,false));
				else tar.setSubtareas(null);
			}
			setCollection(l);
			*/
			Hashtable params = new Hashtable();
			params.put("1",user.getDatosMenu().idSelected());
			params.put("2",user.getIdentificador());
			boolean subtareas = false;
			if (filtro.getVerSubtareas((DumboUser)user)) {
				if ((filtro.getSubtareas()==null) || filtro.getSubtareas().equals("S")) {
					subtareas = true;
				}
			}
			filtro.setTipo(FiltroUsuario.LISTA_PROGRAMADAS);
			List l = aplicaFiltroSQL(conn,"TareasUsuarioProgramadasSQL",subtareas,FiltroUsuario.LISTA_PROGRAMADAS,params);
			/*
			if (filtro.getVerSubtareas((DumboUser)user)) {
			if ((filtro.getSubtareas()==null) || filtro.getSubtareas().equals("S")) {
				for (int k=0; k<l.size(); k++) {
					D7Tareas tar = (D7Tareas)l.get(k);
					tar.setSubtareas(GestorGenerico.exploraSubtareas(conn,user,tar,getQuery("SubTareasSQL"),filtro.getSubtareas().equals("S")));
				}
			}
			}
			*/
			setCollection(l);
			
		} catch (Exception ex) {
			setErrorMessage("GestorSolicitudes[listSolicitudesProgramadas]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
	}

	public void filtroListaVinculadas(Session conn,String aplCod) {
		setPageSize(new Integer(filtro.getTamPag()).intValue());
		if (aplCod!=null && !aplCod.equals("") && filtro.getAplicaciones()==null) filtro.setAplicaciones(new String[]{aplCod});
		if (filtro.getFormato().equals(FiltroUsuario.FORMATO_LISTA) && solicitud==null) listSolicitudesVinculadas(conn);
		solicitud = null;
	}
	
	public void listSolicitudesVinculadas(Session conn) {
		try {
			/*
			Query q = aplicaFiltro(conn,"TareasUsuarioVinculadas",FiltroUsuario.LISTA_VINCULADAS);
			q = q.setString("sist",user.getDatosMenu().idSelected());
			List l = q.list();
			
			for (int k=0; k<l.size(); k++) {
				D7Tareas tar = (D7Tareas)l.get(k);
				//tar.getAplicacionDesc();
				if ((filtro.getSubtareas()==null) || filtro.getSubtareas().equals("S")) 
					tar.setSubtareas(exploraSubtareas(conn,tar,false));
				else tar.setSubtareas(null);
			}
			setCollection(l);
			*/
			Hashtable params = new Hashtable();
			params.put("1",user.getDatosMenu().idSelected());
			boolean subtareas = false;
			if (filtro.getVerSubtareas((DumboUser)user)) {
				if ((filtro.getSubtareas()==null) || filtro.getSubtareas().equals("S")) {
					subtareas = true;
				}
			}
			List l = null;
			// Si se establece aplicacin en el filtro bien, si no nada.
			if (filtro.getAplicaciones()!=null && filtro.getAplicaciones().length>0) {
				filtro.setTipo(FiltroUsuario.LISTA_VINCULADAS);
				if (user.permitidoPerfiles(user.getDatosMenu().idSelected(),"dumbo7/solicitudes","vincularMaestro"))
					l = aplicaFiltroSQL(conn,"TareasUsuarioVinculadasMaestroSQL",subtareas,FiltroUsuario.LISTA_VINCULADAS,params);
				else if (user.permitidoPerfiles(user.getDatosMenu().idSelected(),"dumbo7/solicitudes","vincularGestor")) {
					params.put("2",user.getIdentificador());
					params.put("3",user.getIdentificador());
					params.put("4",user.getIdentificador());
					l = aplicaFiltroSQL(conn,"TareasUsuarioVinculadasGestorSQL",subtareas,FiltroUsuario.LISTA_VINCULADAS,params);
				} else {
					params.put("2",user.getIdentificador());
					params.put("3",user.getIdentificador());
					l = aplicaFiltroSQL(conn,"TareasUsuarioVinculadasInformaticoSQL",subtareas,FiltroUsuario.LISTA_VINCULADAS,params);
				}
			}
			/*
			if (filtro.getVerSubtareas((DumboUser)user)) {
			if ((filtro.getSubtareas()==null) || filtro.getSubtareas().equals("S")) {
				for (int k=0; k<l.size(); k++) {
					D7Tareas tar = (D7Tareas)l.get(k);
					tar.setSubtareas(GestorGenerico.exploraSubtareas(conn,user,tar,getQuery("SubTareasSQL"),filtro.getSubtareas().equals("S")));
				}
			}
			}
			*/
			setCollection(l);

		} catch (Exception ex) {
			setErrorMessage("GestorSolicitudes[listSolicitudesVinculadas]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
	}

	public void subTareasSolicitud(Session conn,String code) {
		try {
			if ((code==null) || code.equals("")) return;
			Query q = conn.createQuery(getQuery("DetalleTarea"));
			q = q.setString("sist",user.getDatosMenu().idSelected());
			q = q.setString("code",code);
			solicitud = (D7Tareas)q.list().get(0);
			//solicitud.getAplicacionDesc();
			solicitud.setSubtareas(exploraSubtareas(conn,solicitud,true));
		} catch (Exception ex) {
			setErrorMessage("GestorSolicitudes[subTareasSolicitud]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
	}
	
	public void addAnexoSolicitud(Session conn,D7Tareas tar) {
		try {
			Query q = conn.createQuery(getQuery("GetTarea"));
			q.setString("tarCod",""+tar.getTarCod());
			q.setString("sist",user.getDatosMenu().idSelected());
			D7Tareas original = (D7Tareas)q.list().get(0);
			// ************************************************
			// Tratamiento de Anexos !!
			// ************************************************
			
			// Hay que corregir la ruta, debe ser de la fecha de la tarea
			String fechaRuta = rutaAnexos.substring(rutaAnexos.length()-8,rutaAnexos.length()-1);
			String newFechaRuta = GestorGenerico.getMesActual(original.getTarFeccrea());
			rutaAnexos = rutaAnexos.replaceFirst(fechaRuta,newFechaRuta);
			File mfil = new File(rutaAnexos);
			if (!mfil.exists()) mfil.mkdir();
			String nombreAnexo = "";
			
			FileOutputStream stream = null;
			ZipOutputStream out = null;
			if (anexos.size()>0) {
				stream = new FileOutputStream(rutaAnexos+GestorGenerico.getPrefijoZip(""+tar.getTarCod())+"Anexo.zip");
				out = new ZipOutputStream(stream);
			}
			Enumeration en = anexos.elements();
			while (en.hasMoreElements()) {
				Hashtable file = (Hashtable) en.nextElement();
				File fforg = new File((String)file.get("content"));
				if (!fforg.exists()) throw new Exception("El fichero "+(String)file.get("filename")+" excede el tamao mximo permitido 15MB.");
				FileInputStream forigen = new FileInputStream(fforg);
				nombreAnexo = GestorGenerico.getNameAnexo(rutaAnexos,""+tar.getTarCod(),(String)file.get("filename"),tar.getTarTipCod());
				File fd = new File(nombreAnexo);
				int copia = 1;
				while (fd.exists()) {
					if (copia>1) nombreAnexo = nombreAnexo.replaceFirst("Copia "+(copia-1)+" de","Copia "+copia+" de");
					else nombreAnexo = nombreAnexo.replaceFirst((String)file.get("filename"),"Copia "+copia+" de "+(String)file.get("filename"));
					fd = new File(nombreAnexo); copia++;
				}
				FileOutputStream fdestino = new FileOutputStream(fd);

		        // Add archive entry
		        ZipEntry zipAdd = new ZipEntry((String)file.get("filename"));
		        zipAdd.setTime(fforg.lastModified());
		        out.putNextEntry(zipAdd);

				byte [] bytes = new byte[4096];
				int leido = forigen.read(bytes,0,4096);
				while (leido!=-1) {
					fdestino.write(bytes,0,leido);
			        out.write(bytes,0,leido);
					leido = forigen.read(bytes,0,4096);
				}
				forigen.close(); fdestino.close();
				fforg.delete();
			}
			// Comprimo los anexos en un nico Zip !!
			if (anexos.size()>0) {
		        out.close();
				stream.close();
			}
			
			solicitud = tar;
			
			if (tar.getTarTipCod().equals(AnexoTarea.SOLICITUD)) {
				GestorGenerico.registrarMovimiento(conn,user,""+tar.getTarCod(),GestorGenerico.MODIFICA_TAREA,D7TareasMovimientos.MODIFICAR_TAREA,"Incluye Anexo","Anexo incluido");
				GestorGenerico.enviarNotificacion(conn,user,original,new String[]{GestorGenerico.NotificacionInformaticoCambio},rutaAnexos,nombreAnexo);
			} else if (tar.getTarTipCod().equals(AnexoTarea.PUBLICO)) {
				GestorGenerico.registrarMovimiento(conn,user,""+tar.getTarCod(),GestorGenerico.MODIFICA_TAREA,D7TareasMovimientos.MODIFICAR_TAREA,"Incluye Anexo","Anexo incluido");
				GestorGenerico.enviarNotificacion(conn,user,original,new String[]{GestorGenerico.NotificacionUsuarioCambio},rutaAnexos,nombreAnexo);
			}
			
		} catch (Exception ex) {
			setErrorMessage("GestorSolicitudes[addAnexoSolicitud]: "+ex);
		}
	}
	
	public void delAnexoSolicitud(Session conn,D7Tareas tar) {
		try {
			Query q = conn.createQuery(getQuery("GetTarea"));
			q.setString("tarCod",""+tar.getTarCod());
			q.setString("sist",user.getDatosMenu().idSelected());
			D7Tareas original = (D7Tareas)q.list().get(0);
			// ************************************************
			// Borramos los Anexos !!
			// ************************************************
			
			// Hay que corregir la ruta, debe ser de la fecha de la tarea
			String fechaRuta = rutaAnexos.substring(rutaAnexos.length()-8,rutaAnexos.length()-1);
			String newFechaRuta = GestorGenerico.getMesActual(original.getTarFeccrea());
			rutaAnexos = rutaAnexos.replaceFirst(fechaRuta,newFechaRuta);
			String nombreAnexo = tar.getTarDescrip();
			String tipoAnexo=tar.getTarDescripSegui();
						
			GestorGenerico.deleteMiAnexoTarea(rutaAnexos,""+original.getTarCod(),tipoAnexo,nombreAnexo);
			
		} catch (Exception ex) {
			setErrorMessage("GestorSolicitudes[delAnexoSolicitud]: "+ex);
		}
	}

	
	public D7Tareas getSolicitud() { return solicitud; }

	private boolean sonIguales(Object a,Object b) {
		if (a!=null && b!=null) return a.equals(b);
		if (a==null && b!=null) return false;
		if (b==null && a!=null) return false;
		return true;
	}
	
	public void updateSolicitud(Session conn,D7Tareas sol) {
		try {
			Transaction tx = conn.beginTransaction();
			Query q = conn.createQuery(getQuery("GetTarea"));
			q.setString("tarCod",""+sol.getTarCod());
			q.setString("sist",user.getDatosMenu().idSelected());
			D7Tareas original = (D7Tareas)q.list().get(0);
			String textoActual = "";
			String textoNuevo = "";
			if (!sonIguales(original.getTarDescrip(),sol.getTarDescrip())) {
				textoActual += " Texto Tarea: "+original.getTarDescrip();
				original.setTarDescrip(sol.getTarDescrip());
				textoNuevo += " Texto Tarea: "+original.getTarDescrip();
			}
			if (!sonIguales(original.getTarUrgencia(),sol.getTarUrgencia())) {
				textoActual += " Urgencia: "+original.getTarUrgencia();
				original.setTarUrgencia(sol.getTarUrgencia());
				textoNuevo += " Urgencia: "+original.getTarUrgencia();
			}
			if (!sonIguales(original.getTarFecmaxResol(),sol.getTarFecmaxResol())) {
				textoActual += " Fecha Max. Resol: "+GestorGenerico.getFechaString(original.getTarFecmaxResol());
				original.setTarFecmaxResol(sol.getTarFecmaxResol());
				textoNuevo += " Fecha Max. Resol: "+GestorGenerico.getFechaString(original.getTarFecmaxResol());
			}
			conn.saveOrUpdate(original);
			tx.commit();
			
			GestorGenerico.registrarMovimiento(conn,user,""+sol.getTarCod(),GestorGenerico.MODIFICA_TAREA,D7TareasMovimientos.MODIFICAR_TAREA,textoActual,textoNuevo);
			GestorGenerico.enviarNotificacion(conn,user,original,new String[]{GestorGenerico.NotificacionInformaticoCambio});
			
			setErrorMessage("La Tarea ha sido actualizada con xito.");
		} catch (Exception ex) {
			setErrorMessage("GestorSolicitudes[updateSolicitud]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
	}

	public void pasarNoWaiting(Session conn,D7Tareas tar) {
		Transaction tx = null;
		try {

			tx = conn.beginTransaction();
			Query q = conn.createQuery(getQuery("GetTarea"));
			q.setString("tarCod",""+tar.getTarCod());
			q.setString("sist",user.getDatosMenu().idSelected());
			D7Tareas original = (D7Tareas)q.list().get(0);
			if (!original.getTarEstado().equals(D7Tareas.EN_ESPERA)) throw new Exception("La tarea no est en espera.");
			String textoActual = "Estado: "+original.getTarEstado();
			original.setTarEstado(GestorGenerico.estadoPrevio(conn,user,tar.getTarCod()));
			String textoNuevo = "Estado: "+original.getTarEstado();
			conn.saveOrUpdate(original);
			tx.commit();
			
			GestorGenerico.registrarMovimiento(conn,user,""+tar.getTarCod(),tar.getTarDescripSegui(),D7TareasMovimientos.PASAR_NOWAITING,textoActual,textoNuevo);
			GestorGenerico.enviarNotificacion(conn,user,original,new String[]{GestorGenerico.NotificacionInformaticoReactivacion});
			
		} catch (Exception ex) {
			if (tx!=null) tx.rollback();
			setErrorMessage("GestorSolicitudes[pasarNoWaiting]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
	}

	public void rechazarWaiting(Session conn,D7Tareas tar) {
		Transaction tx = null;
		try {

			tx = conn.beginTransaction();
			Query q = conn.createQuery(getQuery("GetTarea"));
			q.setString("tarCod",""+tar.getTarCod());
			q.setString("sist",user.getDatosMenu().idSelected());
			D7Tareas original = (D7Tareas)q.list().get(0);
			if (!original.getTarEstado().equals(D7Tareas.EN_ESPERA)) throw new Exception("El paso a espera de la tarea ya ha sido rechazado.");
			String textoActual = "Estado: "+original.getTarEstado();
			original.setTarEstado(D7Tareas.ASIGNADA);
			String textoNuevo = "Estado: "+original.getTarEstado();
			conn.saveOrUpdate(original);
			tx.commit();
		
			GestorGenerico.registrarMovimiento(conn,user,""+tar.getTarCod(),tar.getTarDescripSegui(),D7TareasMovimientos.RECHAZAR_WAITING,textoActual,textoNuevo);
			GestorGenerico.enviarNotificacion(conn,user,original,new String[]{GestorGenerico.NotificacionInformaticoRechazoPasoEspera});
			
		} catch (Exception ex) {
			if (tx!=null) tx.rollback();
			setErrorMessage("GestorSolicitudes[rechazarWaiting]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
	}
	
	private int getDiasHabiles(Session conn,int dias) {
		PreparedStatement pstmt = null;
		ResultSet rs = null;
		try {
			int dh = 0;
			pstmt = conn.connection().prepareStatement(getQuery("DiasHabiles"));
			pstmt.setInt(1,dias);
			rs = pstmt.executeQuery();
			if (rs.next()) dh = rs.getInt(1);
			return dh;
		} catch (Exception ex) { return 0; }
		  finally {
		  	try {
		  		if (rs!=null) rs.close();
		  		if (pstmt!=null) pstmt.close();
		  	} catch (Exception exx) {}
		  }
	}
	
	public void rechazarTarea(Session conn,D7Tareas tar) {
		Transaction tx = null;
		try {

			tx = conn.beginTransaction();
			Query q = conn.createQuery(getQuery("GetTarea"));
			q.setString("tarCod",""+tar.getTarCod());
			q.setString("sist",user.getDatosMenu().idSelected());
			D7Tareas original = (D7Tareas)q.list().get(0);
			if (original.getTarEstado().equals(D7Tareas.RECHAZADA)) throw new Exception("La tarea ya est rechazada.");
			String textoActual = "Estado: "+original.getTarEstado();
			original.setTarEstado(D7Tareas.RECHAZADA);
			String textoNuevo = "Estado: "+original.getTarEstado();
			original.setTarDescripSegui(tar.getTarDescripSegui());
			// Y Se Planifica dos das hbiles despus !!
			original.setTarPriCod(D7Prioridades.PLANIFICACION);
			Calendar hoy = Calendar.getInstance();
			hoy.add(Calendar.DATE,getDiasHabiles(conn,2));
			original.setTarPlanif(hoy.getTime());
			conn.saveOrUpdate(original);
			tx.commit();
			
			GestorGenerico.registrarMovimiento(conn,user,""+tar.getTarCod(),tar.getTarDescripSegui(),D7TareasMovimientos.RECHAZAR,textoActual,textoNuevo);
			//GestorGenerico.registrarSoloSeguimiento(conn,user,""+tar.getTarCod(),tar.getTarDescripSegui());
			GestorGenerico.enviarNotificacion(conn,user,original,new String[]{GestorGenerico.NotificacionInformaticoRechazo});
			

		} catch (Exception ex) {
			if (tx!=null) tx.rollback();
			setErrorMessage("GestorSolicitudes[rechazarTarea]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
	}

	public void anularTarea(Session conn,D7Tareas tar) {
		Transaction tx = null;
		try {

			tx = conn.beginTransaction();
			Query q = conn.createQuery(getQuery("GetTarea"));
			q.setString("tarCod",""+tar.getTarCod());
			q.setString("sist",user.getDatosMenu().idSelected());
			D7Tareas original = (D7Tareas)q.list().get(0);
			if (original.getTarEstado().equals(D7Tareas.ANULADA)) throw new Exception("La tarea ya est anulada.");
			String textoActual = "Estado: "+original.getTarEstado();
			original.setTarEstado(D7Tareas.ANULADA);
			String textoNuevo = "Estado: "+original.getTarEstado();
			original.setTarDescripSegui(tar.getTarDescripSegui());
			conn.saveOrUpdate(original);
		
			anularSubTareas(conn,original);
			tx.commit();
			
			GestorGenerico.registrarMovimiento(conn,user,""+tar.getTarCod(),tar.getTarDescripSegui(),D7TareasMovimientos.ANULAR_TAREA,textoActual,textoNuevo);
			//GestorGenerico.registrarSoloSeguimiento(conn,user,""+tar.getTarCod(),tar.getTarDescripSegui());
			GestorGenerico.enviarNotificacion(conn,user,original,new String[]{GestorGenerico.NotificacionInformaticoAnulacion});

		} catch (Exception ex) {
			if (tx!=null) tx.rollback();
			setErrorMessage("GestorSolicitudes[anularTarea]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
	}

	public void reactivarTarea(Session conn,D7Tareas tar) {
		Transaction tx = null;
		try {

			tx = conn.beginTransaction();
			Query q = conn.createQuery(getQuery("GetTarea"));
			q.setString("tarCod",""+tar.getTarCod());
			q.setString("sist",user.getDatosMenu().idSelected());
			D7Tareas original = (D7Tareas)q.list().get(0);
			if (!original.getTarEstado().equals(D7Tareas.ANULADA)) throw new Exception("La tarea ya estaba reactivada.");
			String textoActual = "Estado: "+original.getTarEstado();
			String inform = original.getTarInfCod();
			String textoNuevo = "Estado: "+original.getTarEstado();
			if (inform==null || inform.equals("")) original.setTarEstado(D7Tareas.PENDIENTE);
			else original.setTarEstado(D7Tareas.ASIGNADA);
			original.setTarDescripSegui(tar.getTarDescripSegui());
			conn.saveOrUpdate(original);
			tx.commit();
			
			GestorGenerico.registrarMovimiento(conn,user,""+tar.getTarCod(),tar.getTarDescripSegui(),D7TareasMovimientos.REACTIVAR,textoActual,textoNuevo);
			//GestorGenerico.registrarSoloSeguimiento(conn,user,""+tar.getTarCod(),tar.getTarDescripSegui());
			GestorGenerico.enviarNotificacion(conn,user,original,new String[]{GestorGenerico.NotificacionInformaticoReactivacionAnulada});

		} catch (Exception ex) {
			if (tx!=null) tx.rollback();
			setErrorMessage("GestorSolicitudes[reactivarTarea]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
	}
	
	private void anularSubTareas(Session conn,D7Tareas tar) throws Exception {
		Set s = tar.getSubtareas();
		if (s==null) return;
		Iterator it = s.iterator();
		while (it.hasNext()) {
			D7Tareas t = (D7Tareas)it.next();
			if (!t.getTarEstado().equals(D7Tareas.FINALIZADA)) {
				String textoActual = "Estado: "+t.getTarEstado();
				t.setTarEstado(D7Tareas.ANULADA);
				String textoNuevo = "Estado: "+t.getTarEstado();
				GestorGenerico.registrarMovimiento(conn,user,""+t.getTarCod(),t.getTarDescripSegui(),D7TareasMovimientos.ANULAR_TAREA,textoActual,textoNuevo);
				conn.saveOrUpdate(t);
				GestorGenerico.enviarNotificacion(conn,user,t,new String[]{GestorGenerico.NotificacionUsuarioAnulacion});
				anularSubTareas(conn,t);
			}
		}
	}
	
	public void setFiltro(HttpServlet servlet,HttpServletRequest req,HttpServletResponse res,String tipo) {
		try {
			filtro = ((DumboUser)user).getFiltroUsuario(tipo);
			if (filtro==null) {
				filtro = new FiltroUsuario(tipo);
				((DumboUser)user).setFiltroUsuario(tipo,filtro);
			}
		} catch (Exception ex) {
			setErrorMessage("GestorSolicitudes[setFiltro]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
	}

	private Set exploraSubtareas(Session conn,D7Tareas t,boolean deep) throws Exception {
		HashSet s = new HashSet();
		Query sq = conn.createQuery(getQuery("SubTareas"));
		sq = sq.setString("sist",user.getDatosMenu().idSelected());
		sq = sq.setString("padre",""+t.getTarCod());
		List st = sq.list();
		for (int k=0; k<st.size(); k++) {
			D7Tareas tar = (D7Tareas)st.get(k);
			D7Tareas nt = tar.cloneTarea();
			//nt.getAplicacionDesc();
			if (deep) nt.setSubtareas(exploraSubtareas(conn,nt,deep));
			s.add(nt);
		}
		return s;
	}
	
	public List aplicaFiltroSQL(Session conn,String nombre,boolean sbQry,String filt,Hashtable params) throws Exception {
		setFiltro(null,null,null,filt);
		return GestorGenerico.aplicaFiltroSQL(conn,user,getQuery(nombre),sbQry,filtro,filt,params,params.size());
	}

	/*
	public Query aplicaFiltro(Session conn,String nombre,String filt) throws Exception {
		setFiltro(filt);
		return GestorGenerico.aplicaFiltro(conn,user,getQuery(nombre),filtro,filt);
	}
	*/
	
	public void listaUbicaciones(Connection conn,String dni) {
		PreparedStatement pstmt = null;
		ResultSet rs = null;
		try {
			secciones = new ArrayList();
			aplicaciones = new ArrayList();
			pstmt = conn.prepareStatement(getQuery("UbicacionesSinZona"));
			rs = pstmt.executeQuery();
			while (rs.next()) {
				String ec = rs.getString(1);
				String ed = rs.getString(2);
				D7Aplicaciones apl = new D7Aplicaciones();
				apl.setAplCod(ec);
				apl.setAplDescrip(ed);
				aplicaciones.add(apl);
			}
			
			if (dni!=null && !dni.equals("")) {
				// Miro el Edificio en el que se Ubica este DNI
				rs.close();	pstmt.close();
				pstmt = conn.prepareStatement(getQuery("UbicacionDni"));
				pstmt.setString(1,dni);
				rs = pstmt.executeQuery();
				if (rs.next()) minimoDumboRapido = rs.getString(1);
			}
			
		} catch (Exception ex) {
			System.out.println("GestorSolicitudes[listaUbicaciones]: "+ex);
		} finally {
			try {
				if (rs!=null) rs.close();
				if (pstmt!=null) pstmt.close();
			} catch (Exception exx) {}
		}
	}
	
	public void recargaLista(HttpServlet servlet,HttpServletRequest req,HttpServletResponse res) {
		// Me cepillo el Gestor Atencin existente.
		req.getSession(true).removeAttribute("dumbo7.solicitudes.GestorSolicitudes");
	}
	public void listaZonasReales(Session conn){
		PreparedStatement pstmt = null;
		ResultSet rs = null;
		String myQuery = null;
		zonasReales = new ArrayList();
		try{
			myQuery = getQuery("AllZonasReales");
			pstmt = conn.connection().prepareStatement(myQuery);
			rs = pstmt.executeQuery();
			while (rs.next()) {
				zonasReales.add(new Zona(rs.getString(1),rs.getString(2)));
			}
		}
		catch (Exception ex)
		{
			setErrorMessage("Error al listar zonas reales.");
		} finally {
			try {
				if (rs!=null) rs.close();
				if (pstmt!=null) pstmt.close();
			} catch (Exception exx) {}
		}
	}
	
	public void QueryEspaciosZona(Session conn,String code)
	{
		PreparedStatement pstmt = null;
		ResultSet rs = null;
		String myQuery = null;
		espacios = new ArrayList();
		try{
			myQuery = getQuery("EspaciosZona");
			pstmt = conn.connection().prepareStatement(myQuery);
			pstmt.setString(1,code);
			rs = pstmt.executeQuery();
			while (rs.next()) {
				espacios.add(new Espacio(rs.getString(1),rs.getString(2)));
			}
			
		}
		catch (Exception ex)
		{
			setErrorMessage("Error al listar espacios.");
		} finally {
			try {
				if (rs!=null) rs.close();
				if (pstmt!=null) pstmt.close();
			} catch (Exception exx) {}
		}
	}
	
	public void ubicacionSolicitante(Session conn,String dni) {
		PreparedStatement pstmt = null;
		ResultSet rs = null;
		String myQuery = null;
		try {
			
			if (dni!=null && !dni.equals("")) {
				// Miro el Edificio en el que se Ubica este DNI
				myQuery = getQuery("UbicacionDni2");
				pstmt = conn.connection().prepareStatement(myQuery);
				pstmt.setString(1,dni);
				rs = pstmt.executeQuery();
				if (rs.next()) ubicSoli = new Espacio(rs.getString(1),rs.getString(2));
			}
			
		} catch (Exception ex) {
			System.out.println("GestorSolicitudes[ubicacionSolicitante]: "+ex);
		} finally {
			try {
				if (rs!=null) rs.close();
				if (pstmt!=null) pstmt.close();
			} catch (Exception exx) {}
		}
	}
	
	public void listaDatosSolicitante(Session conn, String code){
		Query q;
		try {
			if ((code==null) || code.equals("")) return;
			if (solicitud==null) detalleSolicitud(conn,code);
			q = conn.createQuery(getQuery("DatosSolicitante2"));
			q = q.setString("code",solicitud.getTarUsuCod());
			datosTrabajador  = (D7DatosTrabajador)q.list().get(0);
			
			ubicacionSolicitante(conn,datosTrabajador.getDatIdentificador());
			
		}catch (Exception ex) {
			setErrorMessage("GestorAtencion[listaDatosSolicitante]: "+((ex.getCause()!=null)?ex.getCause():ex));
		}
	}
	
	public void setBitacora(Session conn,String bitacora) {
		try{
			if (tareaActual<0 || bitacora.equals("")) return;
			java.math.BigDecimal dedicacion=null;
			String usuario=user.getIdentificador();
			if (((DumboUser)user).getUsuarioOriginal()!=null) usuario=((DumboUser)user).getUsuarioOriginal().getDataIdentifier(conn);
			Transaction tx = conn.beginTransaction();
			GestorGenerico.registrarSoloSeguimiento(conn,user,""+tareaActual,bitacora,dedicacion,usuario);
			tx.commit();
		} catch (Exception ex) {
			System.out.println("GestorSolicitudes[setBitacora]: "+ex);
		} 
	}
	
	public void setAplicacion(String aplicacion){
		try{
			miAplicacion=aplicacion;
		} catch (Exception ex) {
			System.out.println("GestorSolicitudes[setAplicacion]: "+ex);
		} 
	}
	
	public void enviaFormularioExterno(HttpServlet servlet,HttpServletRequest req,HttpServletResponse res){
		try{
			
			java.util.Date fecha = new java.util.Date();

			int miCursoAcademico=fecha.getYear()+1899;
			
			//String parametros ="aplicacion=DOCTORPC&dni="+user.getIdentificador()+"&identificador="+user.getIdentificador()+"&caca="+miCursoAcademico+"&paramid=dni&url_retorno_guardar=dumbo7/solicitudes.solicita";
			//EnlaceConGeneralServlet.process_autocitas_nueva_autocita(req,res,null,parametros,null,"dumbo7/solicitudes.solicita");
			EnlaceConGeneralServlet.process_autocitas_nueva_usuario(req,res,null,"DOCTORPC", ""+miCursoAcademico, user.getIdentificador(), null,java.net.URLEncoder.encode("../servlet/dumbo7.Dumbo7?module=dumbo7/solicitudes.solicita"));
		} catch (Exception ex) {
			System.out.println("GestorSolicitudes[enviaFormularioExterno]: "+ex);
		} 
	}
}
