<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet version="1.0" 
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:xforms="http://www.w3.org/2002/xforms">
	
<xsl:param name="servlet"/>	
<xsl:param name="menu"/>
<xsl:param name="selected"/>
<xsl:param name="caduca" select="'S'"/>
<xsl:param name="tarea"/>

<xsl:include href="dumbo7/utils/xsl/utils.xsl"/>
<xsl:include href="atica/frameweb/xml/templates/paginable.xsl"/>

<xsl:template name="optionSeccion">
<xsl:param name="sec"/>
<xsl:param name="padd" select="'&#160;'"/>
	<xsl:for-each select="/XMLROOT/DATA/SOLICITUDES/SECCION[(@PADRE=$sec) and not(@CODIGO=@PADRE)]">
		<xsl:sort select="@DESCRIPCION"/>
		<xsl:variable name="secc" select="@CODIGO"/>
		<xsl:variable name="subsecc"><xsl:call-template name="optionSeccion"><xsl:with-param name="sec" select="@CODIGO"/></xsl:call-template></xsl:variable>
		<xsl:if test="count(../APLICACION[@SECCION=$secc])>0 or string-length($subsecc)>0">
			<option value="{@CODIGO}"><xsl:value-of select="$padd"/><xsl:value-of select="@DESCRIPCION"/></option>
			<xsl:call-template name="optionSeccion">
				<xsl:with-param name="sec" select="@CODIGO"/>
				<xsl:with-param name="padd" select="concat($padd,'&#160;')"/>
			</xsl:call-template>
		</xsl:if>
	</xsl:for-each>
</xsl:template>

<xsl:template name="cargaSeccion">
<xsl:param name="sec"/>
<xsl:param name="par" select="1"/>
<xsl:param name="padd" select="'&#160;&#160;'"/>
	<xsl:for-each select="/XMLROOT/DATA/SOLICITUDES/SECCION[(@PADRE=$sec) and not(@CODIGO=$sec)]">
		<xsl:sort select="@DESCRIPCION"/>
		s<xsl:value-of select="$par"/> = new Seccion('<xsl:value-of select="@CODIGO"/>','[Seccin: <xsl:value-of select="@DESCRIPCION"/>]');
		<xsl:variable name="secc" select="@CODIGO"/>
		<xsl:for-each select="/XMLROOT/DATA/SOLICITUDES/APLICACION[@SECCION=$secc]">
			<xsl:sort select="@DESCRIPCION"/>
			a = new Aplicacion('<xsl:value-of select="@CODIGO"/><xsl:value-of select="@TIPO_ASIGNACION"/>',<xsl:call-template name="entrecomillaDescripcion"><xsl:with-param name="descripcion" select="@DESCRIPCION"/></xsl:call-template>,'<xsl:value-of select="@CARACTER"/>','<xsl:value-of select="@PADRE"/>','<xsl:value-of select="concat(PARAMETRO[@TIPO_TAREA='P']/@URGENCIA,':',PARAMETRO[@TIPO_TAREA='I']/@URGENCIA)"/>');
			s<xsl:value-of select="$par"/>.addAplicacion(a);
		</xsl:for-each>
		s<xsl:value-of select="number($par)-1"/>.addSubSeccion(s<xsl:value-of select="$par"/>);
		<xsl:call-template name="cargaSeccion">
			<xsl:with-param name="sec" select="@CODIGO"/>
			<xsl:with-param name="par" select="number($par)+1"/>
		</xsl:call-template>
	</xsl:for-each>
</xsl:template>

<xsl:template match="XMLROOT">
<html lang="es">

	<xsl:call-template name="headComun">
		<xsl:with-param name="arbol" select="true()"/>
		<xsl:with-param name="calendar" select="true()"/>
		<xsl:with-param name="jscript">
			<SCRIPT LANGUAGE="JavaScript" SRC="../js/solicitudes/aplSolicitaUsu.js"></SCRIPT>
			<SCRIPT LANGUAGE="JavaScript">
				var srvName = '<xsl:value-of select="$servlet"/>';
				var inf = '<xsl:call-template name="traduce"><xsl:with-param name="id" select="'informatico'"/></xsl:call-template>';
				var infs = '<xsl:call-template name="traduce"><xsl:with-param name="id" select="'informaticos'"/></xsl:call-template>';
				var userDom = '<xsl:value-of select="DATA/SOLICITUDES/USER/@DOMINIO"/>';
				var aplicaciones = new Array();
				<xsl:for-each select="DATA/SOLICITUDES/APLICACION[@ESTADO='V']">
					<xsl:sort select="@DESCRIPCION"/>
					var	a = new Aplicacion('<xsl:value-of select="@CODIGO"/><xsl:value-of select="@TIPO_ASIGNACION"/>',<xsl:call-template name="entrecomillaDescripcion"><xsl:with-param name="descripcion" select="@DESCRIPCION"/></xsl:call-template>,'<xsl:value-of select="@CARACTER"/>','<xsl:value-of select="@PADRE"/>','<xsl:value-of select="concat(PARAMETRO[@TIPO_TAREA='P']/@URGENCIA,':',PARAMETRO[@TIPO_TAREA='I']/@URGENCIA)"/>');
					aplicaciones[aplicaciones.length] = a;
				</xsl:for-each>
			</SCRIPT>
		</xsl:with-param>
	</xsl:call-template>

<body onload="muestraAplicaciones()">
	<form name="newSol" action="{$servlet}" method="post">
	<table class="contout">
		<tr class="peticion">
			<td colspan="2"><b>Seleccione una Aplicacin</b></td>
		</tr>
		<tr>
		<td>
		<table>
		<tr>
		<td id="listaApl">&#160;</td>
		</tr>
		</table>
		</td>
		</tr>
		<tr>
			<td colspan="2">&#160;</td>
		</tr>
		<tr class="peticion">
			<td colspan="2">&#160;</td>
		</tr>
	</table>
	</form>
</body>
</html>
</xsl:template>
<xsl:template name="cuerpo"></xsl:template>
</xsl:stylesheet>
