<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet version="1.0" 
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:xforms="http://www.w3.org/2002/xforms">
	
<xsl:param name="servlet"/>	
<xsl:param name="menu"/>
<xsl:param name="selected"/>
<xsl:param name="page"/>
<xsl:param name="ajx"/>
<xsl:param name="numItem"/>

<xsl:include href="dumbo7/utils/xsl/utils.xsl"/>
<xsl:include href="dumbo7/utils/xsl/detail.xsl"/>
<xsl:include href="atica/frameweb/xml/templates/paginable.xsl"/>
<xsl:include href="dumbo7/solicitudes/html/inConsultar.xsl"/>

<xsl:template match="XMLROOT">
<xsl:choose>
<xsl:when test="string-length($ajx)=0">
<html lang="es">

	<xsl:call-template name="headComun">
		<xsl:with-param name="ERROR" select="DATA/SOLICITUDES/@ERROR"/>
		<xsl:with-param name="arbol" select="true()"/>
		<xsl:with-param name="calendar" select="true()"/>
		<xsl:with-param name="jscript">
			<SCRIPT LANGUAGE="JavaScript">
				function cambiaPagina(p) { top.recargarPage(p); }
				function hideDetail(p) { top.hideDetail(p); }
			</SCRIPT>
		</xsl:with-param>
	</xsl:call-template>

<body>
	<xsl:call-template name="showDetalleTarea">
		<xsl:with-param name="pagesize" select="/XMLROOT/DATA/SOLICITUDES/FILTRO/@TAMPAG"/>
		<xsl:with-param name="baseList" select="'dumbo7/solicitudes.listaResueltas'"/>
		<xsl:with-param name="printList" select="'dumbo7/solicitudes.printResueltas'"/>
	</xsl:call-template>
	<xsl:call-template name="filtrarListado">
		<xsl:with-param name="pagesize" select="/XMLROOT/DATA/SOLICITUDES/FILTRO/@TAMPAG"/>
		<xsl:with-param name="list" select="'resueltas'"/>
		<xsl:with-param name="reload" select="'dumbo7/solicitudes.listaResueltas'"/>
	</xsl:call-template>
	<xsl:call-template name="showManageTarea">
		<xsl:with-param name="GRUPOS" select="DATA/SOLICITUDES"/>
		<xsl:with-param name="SOLICITUD" select="DATA/SOLICITUDES/SOLICITUD[1]"/>
		<xsl:with-param name="listado" select="'dumbo7/solicitudes.listaResueltas'"/>
	</xsl:call-template>
	<xsl:call-template name="menuComun">
		<xsl:with-param name="HELP" select="'consultas.xml#1.2.2'"/>
		<xsl:with-param name="MENU" select="DATA/MENU"/>
		<xsl:with-param name="SELECT" select="$menu"/>
		<xsl:with-param name="NAME" select="concat(DATA/SOLICITUDES/USER/@NAME,concat(' (',concat(DATA/SOLICITUDES/USER/@LOGIN,')')))"/>
	</xsl:call-template>
	<xsl:call-template name="pieComun"/>
	<xsl:if test="not($selected='')"><script language="JavaScript">testDetailExists();</script></xsl:if>
</body>
</html>
</xsl:when>
<xsl:otherwise>
	<xsl:call-template name="tablaDetalle"/>
</xsl:otherwise>
</xsl:choose>
</xsl:template>

<xsl:template name="cuerpo">
<xsl:call-template name="showCabecera">
	<xsl:with-param name="titulo" select="'Solicitadas finalizadas'"/>
	<xsl:with-param name="filtro" select="DATA/SOLICITUDES/FILTRO"/>
</xsl:call-template>
<xsl:choose>
	<xsl:when test="DATA/SOLICITUDES/FILTRO/@FORMATO='L'">
			<xsl:call-template name="inConsultar"/>
			<xsl:call-template name="showPieCabecera">
				<xsl:with-param name="titulo" select="'Solicitadas finalizadas'"/>
			</xsl:call-template>
			<a name="detalle">&#160;</a>
			<div id="tabDet">
			<xsl:if test="not($selected='')">
				<xsl:call-template name="detailTarea">
					<xsl:with-param name="nodo" select="DATA/SOLICITUDES"/>
					<xsl:with-param name="tipoDetalle" select="'resueltas'"/>
				</xsl:call-template>
				<script language="JavaScript">
					cargadoTextoDetalle(document.getElementById('tabDet').innerHTML.toLowerCase());
				</script>
			</xsl:if>
			</div>
	</xsl:when>
	<xsl:otherwise>
		<center>
		<iframe name="listado" id="listado" src="{$servlet}?module=dumbo7/solicitudes.listaResueltas.resueltas&amp;selected={$selected}&amp;page={$page}&amp;pagesize={/XMLROOT/DATA/SOLICITUDES/FILTRO/@TAMPAG}#{$selected}" width="90%" height="150" frameborder="0"></iframe>
		</center>
		<xsl:call-template name="showPieCabecera">
			<xsl:with-param name="titulo" select="'Solicitadas finalizadas'"/>
		</xsl:call-template>
		<br/>&#160;<br/>
		<a name="detalle">&#160;</a>
		<div id="tabDet">
		<xsl:if test="not($selected='')">
			<xsl:call-template name="detailTarea">
				<xsl:with-param name="nodo" select="DATA/SOLICITUDES"/>
				<xsl:with-param name="tipoDetalle" select="'resueltas'"/>
			</xsl:call-template>
			<script language="JavaScript">
				cargadoTextoDetalle(document.getElementById('tabDet').innerHTML.toLowerCase());
			</script>
		</xsl:if>
		</div>
	</xsl:otherwise>
</xsl:choose>
</xsl:template>

<xsl:template name="tablaDetalle">
<table class="contdet" border="0" cellpadding="1" cellspacing="1" width="100%">
	<xsl:call-template name="detailTarea">
		<xsl:with-param name="nodo" select="DATA/SOLICITUDES"/>
		<xsl:with-param name="tipoDetalle" select="'resueltas'"/>
	</xsl:call-template>
</table>
</xsl:template>

</xsl:stylesheet>
	