<?xml version="1.0" encoding="ISO-8859-1"?>

<xsl:stylesheet version="1.0"
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
  xmlns:fo="http://www.w3.org/1999/XSL/Format"
  xmlns:str="http://xsltsl.org/string">

<xsl:param name="servlet"/>	
<xsl:param name="menu"/>
<xsl:param name="selected"/>
<xsl:param name="page"/>

<xsl:include href="dumbo7/utils/xsl/printUtils.xsl"/>
<xsl:include href="dumbo7/utils/xsl/printDetail.xsl"/>
	
<xsl:template match="XMLROOT">
<xsl:variable name="tableWidth"><xsl:call-template name="calculateWidth"><xsl:with-param name="filtro" select="DATA/SOLICITUDES/FILTRO"/></xsl:call-template></xsl:variable>
<xsl:variable name="miPageWidth"><xsl:call-template name="pageWidth"><xsl:with-param name="lon" select="$tableWidth"/></xsl:call-template></xsl:variable>
<xsl:variable name="miPageHeight"><xsl:call-template name="pageHeight"><xsl:with-param name="lon" select="$tableWidth"/></xsl:call-template></xsl:variable>
  <fo:root xmlns:fo="http://www.w3.org/1999/XSL/Format">
    <fo:layout-master-set>
      <fo:simple-page-master master-name="simple"
                             margin-top="1cm" 
                             margin-bottom="1cm" 
                             margin-left="1.5cm" 
                             margin-right="1.5cm">
		<xsl:attribute name="page-height"><xsl:value-of select="$miPageHeight"/>cm</xsl:attribute>
		<xsl:attribute name="page-width"><xsl:value-of select="$miPageWidth"/>cm</xsl:attribute>
        <fo:region-before extent="1cm"/>
        <fo:region-after extent="1cm"/>
        <fo:region-body margin-top="1cm"
                        margin-bottom="1.5cm"/>
      </fo:simple-page-master>
    </fo:layout-master-set>

    <fo:page-sequence master-reference="simple">
      <!-- cabecera -->
	  <xsl:call-template name="headComun">
		<xsl:with-param name="title" select="'DUMBO: Listado de Solicitudes Programadas'"/>
	  </xsl:call-template>
      <!-- pie de pgina -->
	  <xsl:call-template name="pieComun">
		<xsl:with-param name="title" select="'DUMBO: Listado de Solicitudes Programadas'"/>
	  </xsl:call-template>

      <fo:flow flow-name="xsl-region-body">
		<xsl:choose>
		<xsl:when test="count(DATA/SOLICITUDES/PAGINAS/ITEM)=0">
			<fo:block font-size="12pt"
				  font-family="sans-serif"
				  line-height="12pt"
				  text-align="center">
				  La lista de Tareas est Vaca.
			</fo:block>
		</xsl:when>
		<xsl:otherwise>
  		<fo:table border-width="0pt" space-before.optimum="2pt">
		  <!-- EL ANCHO DE LAS COLUMNAS DEBE SUMA 17.5cm -->
		  <fo:table-column column-width="0.8cm"/>
		  <xsl:for-each select="DATA/SOLICITUDES/FILTRO/CAMPOS">
			<xsl:call-template name="definePrintColumn">
				<xsl:with-param name="columna" select="."/>
			</xsl:call-template>
		  </xsl:for-each>
		  <xsl:call-template name="printTableHeader">
			<xsl:with-param name="campos" select="DATA/SOLICITUDES/FILTRO"/>
		  </xsl:call-template>
			<fo:table-body>
				<xsl:for-each select="DATA/SOLICITUDES/PAGINAS/ITEM">
					<xsl:variable name="miItem" select="."/>
					<xsl:call-template name="printRow">
						<xsl:with-param name="row" select="$miItem"/>
						<xsl:with-param name="item" select="position()"/>
						<xsl:with-param name="numitem" select="position()+((number($page)-1)*number(/XMLROOT/DATA/GESTION/FILTRO/@TAMPAG))"/>
						<xsl:with-param name="campos" select="/XMLROOT/DATA/GESTION/FILTRO"/>
					</xsl:call-template>
				</xsl:for-each>
			</fo:table-body>
		</fo:table>
		</xsl:otherwise>
		</xsl:choose>
      </fo:flow>
    </fo:page-sequence>
  </fo:root>
</xsl:template>

</xsl:stylesheet>
