<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet version="1.0" 
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:xforms="http://www.w3.org/2002/xforms">
	
<xsl:param name="servlet"/>	
<xsl:param name="menu"/>
<xsl:param name="subtarea"/>
<xsl:param name="tipTarea"/>
<xsl:param name="moduleInicial"/>
<xsl:param name="page"/>
<xsl:param name="pagesize"/>
<xsl:param name="usrtar"/>
<xsl:param name="usrlog"/>
<xsl:param name="asuntotar" select="/XMLROOT/DATA/SOLICITUDES/SOLICITUD/@ASUNTO"/>
<xsl:param name="textotar" select="/XMLROOT/DATA/SOLICITUDES/SOLICITUD/@DESCRIPCION"/>
<xsl:param name="apltar"/>
<xsl:param name="apltipoasg" select="/XMLROOT/DATA/SOLICITUDES/SOLICITUD/@APLICACIONTIPOASIG"/>

<xsl:key name="aplPorGrupos" match="APLICACION" use="@PADRE"/>

<xsl:include href="dumbo7/utils/xsl/utils.xsl"/>

<xsl:variable name="tipotarea">
<xsl:choose>
<xsl:when test="contains($menu,'Soli/Tar')">T</xsl:when>
<xsl:when test="contains($menu,'Soli/Inc')">I</xsl:when>
<xsl:when test="contains($menu,'Soli/Pet')">P</xsl:when>
<xsl:when test="contains($menu,'Soli/Prob')">B</xsl:when>
<xsl:when test="contains($menu,'Soli/Prog')">A</xsl:when>
<xsl:when test="contains($menu,'Soli/Rap')">R</xsl:when>
<xsl:otherwise><xsl:value-of select="$tipTarea"/></xsl:otherwise>
</xsl:choose>
</xsl:variable>

<xsl:template name="cargaSeccion">
<xsl:param name="sec"/>
<xsl:param name="par" select="1"/>
<xsl:param name="padd" select="'&#160;&#160;'"/>
	<xsl:for-each select="/XMLROOT/DATA/SOLICITUDES/SECCION[(@PADRE=$sec) and not(@CODIGO=$sec)]">
		<xsl:sort select="@DESCRIPCION"/>
		s<xsl:value-of select="$par"/> = new Seccion('<xsl:value-of select="@CODIGO"/>','[Seccin: <xsl:value-of select="@DESCRIPCION"/>]');
		<xsl:variable name="secc" select="@CODIGO"/>
		<xsl:for-each select="/XMLROOT/DATA/SOLICITUDES/APLICACION[@SECCION=$secc]">
			<xsl:sort select="@DESCRIPCION"/>
			<xsl:variable name="pu"><xsl:choose><xsl:when test="$tipotarea='T'"><xsl:value-of select="./PARAMETRO[@TIPO_TAREA='P']/@URGENCIA"/>:<xsl:value-of select="./PARAMETRO[@TIPO_TAREA='I']/@URGENCIA"/></xsl:when><xsl:otherwise><xsl:value-of select="./PARAMETRO[@TIPO_TAREA=$tipotarea or ($tipotarea='A' and @TIPO_TAREA='P')]/@URGENCIA"/></xsl:otherwise></xsl:choose></xsl:variable>
			a = new Aplicacion('<xsl:value-of select="@CODIGO"/>-<xsl:value-of select="$pu"/>',<xsl:call-template name="entrecomillaDescripcion"><xsl:with-param name="descripcion" select="@DESCRIPCION"/></xsl:call-template>,'<xsl:value-of select="@CARACTER"/>','<xsl:value-of select="@PADRE"/>');
			s<xsl:value-of select="$par"/>.addAplicacion(a);
		</xsl:for-each>
		s<xsl:value-of select="number($par)-1"/>.addSubSeccion(s<xsl:value-of select="$par"/>);
		<xsl:call-template name="cargaSeccion">
			<xsl:with-param name="sec" select="@CODIGO"/>
			<xsl:with-param name="par" select="number($par)+1"/>
		</xsl:call-template>
	</xsl:for-each>
</xsl:template>


<xsl:template match="XMLROOT">

<html lang="es">

	<xsl:call-template name="headComun">
		<xsl:with-param name="ERROR" select="DATA/SOLICITUDES/@ERROR"/>
		<xsl:with-param name="calendar" select="not(contains($menu,'Inc'))"/>
		<xsl:with-param name="jscript">
			<link REL="stylesheet" HREF="../js/solicitudes/ajax.css" TYPE="text/css"/>
			<link REL="stylesheet" HREF="../css/general_dumbo.css" TYPE="text/css"/>
			<SCRIPT LANGUAGE="JavaScript" SRC="../js/solicitudes/ajax.js"></SCRIPT>
			<SCRIPT LANGUAGE="JavaScript" SRC="../js/solicitudes/ajax-dynamic-list.js"></SCRIPT>
			<SCRIPT LANGUAGE="JavaScript" SRC="../js/solicitudes/solicita.js"></SCRIPT>
			<SCRIPT LANGUAGE="JavaScript">
				var srvName = '<xsl:value-of select="$servlet"/>';
				var informText = '<xsl:call-template name="traduce"><xsl:with-param name="id" select="'informatico'"/></xsl:call-template>';
				var tipoTarea = '<xsl:value-of select="$tipotarea"/>';
				var isInform = 0;
				<xsl:if test="count(DATA/SECURITY[@MODULE='dumbo7/solicitudes']/ACTION[@NAME='informatico'])>0 and (count(DATA/SECURITY[@MODULE='dumbo7/solicitudes']/ACTION[@NAME='oreja'])=0 or $tipotarea='R')">
					isInform = 1;
				</xsl:if>
				var pageName = '<xsl:value-of select="$page"/>';
				var pagesizeName = '<xsl:value-of select="/XMLROOT/DATA/SOLICITUDES/FILTRO/@TAMPAG"/>';
				
				var maximoTotal = 0;
				var maxDumbo = '<xsl:value-of select="DATA/SOLICITUDES/@DR_MAXIMO"/>';
				if (maxDumbo=='') maxDumbo = -1;
				else maxDumbo = maxDumbo-0;
				var minDumbo = '<xsl:value-of select="DATA/SOLICITUDES/@DR_MINIMO"/>';
				if (minDumbo=='') minDumbo = -1;
				else minDumbo = minDumbo-0;
				var userDom = '<xsl:value-of select="DATA/SOLICITUDES/USER/@DOMINIO"/>';

				var secciones = new Array();
				var s0,a;
				<xsl:for-each select="DATA/SOLICITUDES/SECCION[@PADRE=@CODIGO or not(@PADRE)]">
					<xsl:sort select="@DESCRIPCION"/>
					s0 = new Seccion('<xsl:value-of select="@CODIGO"/>','[Seccin: <xsl:value-of select="@DESCRIPCION"/>]');
					<xsl:variable name="secc" select="@CODIGO"/>
					<xsl:for-each select="/XMLROOT/DATA/SOLICITUDES/APLICACION[@SECCION=$secc]">
						<xsl:sort select="@DESCRIPCION"/>
						<xsl:variable name="pu"><xsl:choose><xsl:when test="$tipotarea='T'"><xsl:value-of select="./PARAMETRO[@TIPO_TAREA='P']/@URGENCIA"/>:<xsl:value-of select="./PARAMETRO[@TIPO_TAREA='I']/@URGENCIA"/></xsl:when><xsl:otherwise><xsl:value-of select="./PARAMETRO[@TIPO_TAREA=$tipotarea or ($tipotarea='A' and @TIPO_TAREA='P')]/@URGENCIA"/></xsl:otherwise></xsl:choose></xsl:variable>
						a = new Aplicacion('<xsl:value-of select="@CODIGO"/>-<xsl:value-of select="$pu"/>',<xsl:call-template name="entrecomillaDescripcion"><xsl:with-param name="descripcion" select="@DESCRIPCION"/></xsl:call-template>,'<xsl:value-of select="@CARACTER"/>','<xsl:value-of select="@PADRE"/>');
						s0.addAplicacion(a);
					</xsl:for-each>
					secciones[secciones.length] = s0;
					<xsl:call-template name="cargaSeccion"><xsl:with-param name="sec" select="@CODIGO"/></xsl:call-template>
				</xsl:for-each>
				var permiteMultiple = false;<xsl:if test="string-length($subtarea)>0">permiteMultiple=true;</xsl:if>
				function reescribe() {
					document.newSol.tarAsunto.value = unescape(document.newSol.tarAsunto.value);
					document.newSol.tarDescrip.value = unescape(document.newSol.tarDescrip.value);
				}
			</SCRIPT>
		</xsl:with-param>
	</xsl:call-template>

<body><xsl:attribute name="OnLoad"><xsl:if test="contains($menu,'Soli/Rap')">tiempoMinimo();</xsl:if></xsl:attribute>
<SCRIPT LANGUAGE="JavaScript" SRC="/forja/jquery/jquery.js"></SCRIPT>
<SCRIPT LANGUAGE="JavaScript">
	var codigoDumbo=0;
	var seleccionado = codigoDumbo;
		$(document).ready(function(){
			marcaMe('<xsl:value-of select="DATA/SOLICITUDES/USER/@LOGIN"/>');
			reescribe();
		});
	function detalleUser(usr) {
		var w = window.open('about:blank','UserDetail','width=400,height=300,left=100,top=100,scrollbars=yes');
		document.detalleUsr.target = w.name;
		document.detalleUsr.user.value = usr;
		document.detalleUsr.submit();
	}
</SCRIPT>
<form name="detalleUsr" action="{$servlet}" method="post">
	<input type="hidden" name="module" value="dumbo7/atencion.atender.detalleUser"/>
	<input type="hidden" name="user" value=""/>
</form>
<form name="formFilt" action="{$servlet}" method="post">
	<input type="hidden" name="module" value="dumbo7/informacion.filtrarInformacion"/>
	<input type="hidden" name="listado" value="vinculadas"/>
</form>	
<form name="formPer" action="{$servlet}" method="post">
	<input type="hidden" name="module" value="dumbo7/informacion.personalizarInformacion"/>
	<input type="hidden" name="listado" value="vinculadas"/>
</form>	
<form name="buscador" action="{$servlet}" method="post">
	<input type="hidden" name="module" value=""/>
	<input type="hidden" name="patron" value=""/>
	<input type="hidden" name="aplcod" value=""/>
</form>
<xsl:call-template name="menuComun">
	<xsl:with-param name="HELP">
	<xsl:choose>
	<xsl:when test="contains($menu,'Soli/Tar')">solicitudes.xml#1.2.1</xsl:when>
	<xsl:when test="contains($menu,'Soli/Pet')">solicitudes.xml#1.2.1</xsl:when>
	<xsl:when test="contains($menu,'Soli/Inc')">solicitudes.xml#1.2.1</xsl:when>
	<xsl:when test="contains($menu,'Soli/Prob')">solicitudes.xml#1.2.2</xsl:when>
	<xsl:when test="contains($menu,'Soli/Prog')">solicitudes.xml#1.2.3</xsl:when>
	<xsl:when test="contains($menu,'Soli/Rap')">solicitudes.xml#1.2.4</xsl:when>
	<xsl:otherwise>solicitudes.xml</xsl:otherwise>
	</xsl:choose>
	</xsl:with-param>
	<xsl:with-param name="MENU" select="DATA/MENU"/>
	<xsl:with-param name="SELECT" select="$menu"/>
	<xsl:with-param name="NAME" select="concat(DATA/SOLICITUDES/USER/@NAME,concat(' (',concat(DATA/SOLICITUDES/USER/@LOGIN,')')))"/>
</xsl:call-template>
<xsl:call-template name="pieComun"/>
</body>
</html>
</xsl:template>

<xsl:template name="cuerpo">
<br/>
<!--
<table class="cab1">
</table>
-->
<FORM NAME="newSol" ACTION="{$servlet}" METHOD="POST" ENCTYPE="multipart/form-data">
<INPUT TYPE="hidden" NAME="moduleInicial" VALUE="{$moduleInicial}"/>
<INPUT TYPE="hidden" NAME="page" VALUE="{$page}"/>
<INPUT TYPE="hidden" NAME="pagesize" VALUE="{$pagesize}"/>
<INPUT TYPE="hidden" NAME="module" VALUE="dumbo7/solicitudes.solicita.nueva"/>
<INPUT TYPE="hidden" NAME="menu" VALUE="{$menu}"/>
<xsl:if test="not($tipotarea='R') and not($tipotarea='T')">
<INPUT TYPE="hidden" NAME="tarTipCod" VALUE="{$tipotarea}"/>
</xsl:if>
<INPUT TYPE="hidden" NAME="vinculadas" VALUE=""/>
<xsl:if test="string-length($subtarea)>0">
<INPUT TYPE="hidden" NAME="tarPadreTarCod" VALUE="{$subtarea}"/>
</xsl:if>
<xsl:if test="string-length($usrtar)>0">
<INPUT TYPE="hidden" NAME="tarCod" VALUE="{$usrtar}"/>
</xsl:if>
<!-- 
<table cellpadding="0" cellspacing="0" border="2">
<tr>
	<td width="100">&#160;</td>
	<td width="800">
 -->
 <!-- <center> -->
<!--  <table border="1" align="center" width="80%"><tr width="80%"><td width="80%">-->
	<xsl:variable name="volver">
		<xsl:choose>
			<xsl:when test="contains($menu,'Ges/GestGlob')">dumbo7/gestion/dumbos.listAtender','D7/Ges/GestGlob/GestUsers</xsl:when>
			<xsl:when test="contains($menu,'Ges/ColaProb')">dumbo7/gestion.problemas','D7/Ges/ColaProb</xsl:when>
			<xsl:otherwise>dumbo7/atencion.listAtender','D7/Aten/Pend</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
		<table id="solicitud" name="solicitud" class="contdet" border="1">
			<xsl:if test="count(DATA/SOLICITUDES/PLANTILLAS)>0">
				<tr id="avisa">
					<td colspan="2"><font size="-1"> Si desea cumplimentar una solicitud distinta a la que le aparece por defecto, seleccinela de la lista de abajo a la izquierda.</font></td>
				</tr>
			</xsl:if>
			<tr>
			  	<td colspan="2">
			  	<span class="izquierda">
			  	&#187;
					<xsl:choose>
						<xsl:when test="contains($menu,'Soli/Tar')">Nueva Tarea</xsl:when>
						<xsl:when test="contains($menu,'Soli/Inc')">Nueva Incidencia</xsl:when>
						<xsl:when test="contains($menu,'Soli/Pet')">Nueva Peticin</xsl:when>
						<xsl:when test="contains($menu,'Soli/Prob')">Nuevo Problema</xsl:when>
						<xsl:when test="contains($menu,'Soli/Prog')">Nueva Peticin Programada</xsl:when>
						<xsl:when test="contains(substring-before($menu,'/Soli/Rap'),'/')">Resolver Como Dumbo Rpido</xsl:when>
						<xsl:when test="contains($menu,'Soli/Rap')">Nuevo Dumbo Rpido</xsl:when>
						<xsl:otherwise>Nueva Subtarea:&#160;<i><xsl:choose><xsl:when test="$tipTarea='I'">Incidencia</xsl:when><xsl:when test="$tipTarea='P'">Peticin</xsl:when><xsl:otherwise></xsl:otherwise></xsl:choose></i></xsl:otherwise>
					</xsl:choose>
				</span>
				<span class="derecha">
						<font size="-1" color="red">(*) campos obligatorios.</font>
				</span>
				</td>
			</tr>
			<xsl:choose>
				<xsl:when test="count(DATA/SECURITY[@MODULE='dumbo7/solicitudes']/ACTION[@NAME='informatico'])>0">
					<tr>
						<xsl:if test="count(DATA/SOLICITUDES/PLANTILLAS)>0">
							<td rowspan="5" valign="top" width="20%" class="solicitudes">
								<xsl:if test="count(DATA/SOLICITUDES/PLANTILLAS)>0">
									<div id="td0" class="cabe1"><a href="javascript:cargaMe('','0');"><br/>General</a></div>
								</xsl:if>
								<xsl:for-each select="DATA/SOLICITUDES/PLANTILLAS">
									 <div id="td{@CODIGO}" class="cont1"><a href="javascript:cargaMe('{@URL}','{@CODIGO}');"><br/><xsl:value-of select="@NOMBRE"/></a></div> 
								</xsl:for-each>
							</td>
						</xsl:if>
						<td class="cabe"><strong>Origen/Destino</strong></td>
					</tr>
					<tr><td class="cont">
					<table>
					<tr>
					<td><i>Solicitante<font size="-1" color="red">(*)</font>:</i></td>
					<td>
					<table>
						<xsl:choose>
							<xsl:when test="string-length($subtarea)>0">
								<xsl:if test="not(DATA/SOLICITUDES/USER/@LOGIN=$usrlog)">
									<tr>
										<td><input type="radio" name="radioTarUsuCod" checked="true" onChange="marcaMe('{DATA/SOLICITUDES/USER/@LOGIN}');cargaDatos('{substring(DATA/SOLICITUDES/USER/@TELEFONO,6)}','{DATA/SOLICITUDES/USER/@UBICACION}','{DATA/SOLICITUDES/USER/@EDUBICACION}')"/><xsl:value-of select="DATA/SOLICITUDES/USER/@LOGIN"/></td>
										<td>(<xsl:value-of select="DATA/SOLICITUDES/USER/@NAME"/>)</td>
									</tr>
									<tr>
										<td><input type="radio" name="radioTarUsuCod" onChange="marcaMe('{$usrlog}');cargaDatos('{substring(DATA/SOLICITUDES/DATOSTRABAJADOR/@TELEFONO,6,4)}','{concat(DATA/SOLICITUDES/DATOSTRABAJADOR/@DEPTO,', ',DATA/SOLICITUDES/UBICSOLI/@NOMBRE)}','{DATA/SOLICITUDES/UBICSOLI/@CODIGO}')"/><xsl:value-of select="$usrlog"/></td>
										<td>(<xsl:value-of select="DATA/SOLICITUDES/SOLICITUD/@USUNOMBRE"/>)</td>
									</tr>
									<INPUT TYPE="hidden" NAME="tarUsuCod" VALUE=""/>	
								</xsl:if>
								<xsl:if test="DATA/SOLICITUDES/USER/@LOGIN=$usrlog">
									<tr><td><xsl:value-of select="DATA/SOLICITUDES/USER/@LOGIN"/><INPUT TYPE="hidden" NAME="tarUsuCod" VALUE="{DATA/SOLICITUDES/USER/@LOGIN}"/></td></tr>
									<tr><td id="solname"><xsl:value-of select="DATA/SOLICITUDES/USER/@NAME"/></td></tr>
								</xsl:if>
							</xsl:when>
							<xsl:when test="string-length($usrlog)>0">
								<tr><td><xsl:value-of select="$usrlog"/><INPUT TYPE="hidden" NAME="tarUsuCod" VALUE="{$usrlog}"/></td></tr>
								<tr><td id="solname">&#160;</td></tr>
							</xsl:when>
							<xsl:otherwise>
								<xsl:choose>
								<xsl:when test="count(DATA/SECURITY[@MODULE='dumbo7/solicitudes']/ACTION[@NAME='oreja'])=0">
									<tr><td><INPUT TYPE="text" NAME="tarUsuCod" VALUE="{DATA/SOLICITUDES/USER/@LOGIN}" SIZE="25" OnChange="findRequest(this,'solname',true);"/>&#160;<a href="javascript:buscaSolicitante();"><img title="Buscar" src="../graficos/iconos/ampliar.gif" border="0"/></a></td></tr>
									<tr><td id="solname"><xsl:value-of select="DATA/SOLICITUDES/USER/@NAME"/></td></tr>
								</xsl:when>
								<xsl:otherwise>
									<tr><td><INPUT TYPE="text" NAME="tarUsuCod" VALUE="" SIZE="25" OnChange="findRequest(this,'solname',true);"/>&#160;<a href="javascript:buscaSolicitante();"><img title="Buscar" src="../graficos/iconos/ampliar.gif" border="0"/></a></td></tr>
									<tr><td id="solname">&#160;</td></tr>
								</xsl:otherwise>
								</xsl:choose>
							</xsl:otherwise>
						</xsl:choose>
					</table>
					</td>
					<xsl:choose>
					<xsl:when test="$tipotarea='B'">
						<td><INPUT TYPE="hidden" NAME="tarInfCod" VALUE=""/></td>
						<td></td>
					</xsl:when>
					<xsl:when test="$tipotarea='R'">
						<td><i><xsl:call-template name="traduce"><xsl:with-param name="id" select="'Informatico'"/></xsl:call-template>:</i></td>
						<td>
							<table>
								<tr><td><xsl:value-of select="DATA/SOLICITUDES/USER/@LOGIN"/><INPUT TYPE="hidden" NAME="tarInfCod" VALUE="{DATA/SOLICITUDES/USER/@LOGIN}"/></td></tr>
								<tr><td id="infname">&#160;</td></tr>
							</table>
						</td>
					</xsl:when>
					<xsl:otherwise>
						<td><i><xsl:call-template name="traduce"><xsl:with-param name="id" select="'Informatico'"/></xsl:call-template>:</i></td>
						<td>
							<table>
								<tr>
									<td><INPUT TYPE="text" NAME="tarInfCod" VALUE="" SIZE="25" OnChange="findRequest(this,'infname',false);"/>&#160;<a href="javascript:buscaInformatico();"><img title="Buscar" src="../graficos/iconos/ampliar.gif" border="0"/></a></td>
								</tr>
								<tr>
									<td id="infname">&#160;</td>
								</tr>
							</table>
						</td>
					</xsl:otherwise>
					</xsl:choose>
					</tr>
					</table>
					</td></tr>
				</xsl:when>
				<xsl:otherwise>
					<INPUT TYPE="hidden" NAME="tarUsuCod" VALUE="{DATA/SOLICITUDES/USER/@LOGIN}"/>
					<INPUT TYPE="hidden" NAME="tarInfCod" VALUE=""/>
					<tr>
						<xsl:if test="count(DATA/SOLICITUDES/PLANTILLAS)>0">
							<td rowspan="5" valign="top" width="20%" class="solicitudes">
								<xsl:for-each select="DATA/SOLICITUDES/PLANTILLAS">
									 <div id="td{@CODIGO}" class="cont1"><a href="javascript:cargaMe('{@URL}','{@CODIGO}');"><br/><xsl:value-of select="@NOMBRE"/></a></div> 
								</xsl:for-each>
								<xsl:if test="count(DATA/SOLICITUDES/PLANTILLAS)>0">
									<div id="td0" class="cabe1"><a href="javascript:cargaMe('','0');"><br/>Otra</a></div>
								</xsl:if>
							</td>
						</xsl:if>
					</tr>
				</xsl:otherwise>
			</xsl:choose>
			<tr><td class="cabe"><strong>Datos Tarea</strong></td></tr>
			<tr><td class="cont">
				<table>
					<tr><td><i>Asunto<font size="-1" color="red">(*)</font>:</i></td><td><INPUT TYPE="text" NAME="tarAsunto" VALUE="{$asuntotar}" SIZE="100" MAXLENGTH="70"/></td></tr>
					<tr><td valign="top"><i>Texto Tarea<font size="-1" color="red">(*)</font>:</i></td><td><TEXTAREA NAME="tarDescrip" COLS="98" ROWS="6"><xsl:value-of select="$textotar"/></TEXTAREA></td></tr>
					<xsl:if test="count(DATA/SECURITY[@MODULE='dumbo7/solicitudes']/ACTION[@NAME='informatico'])>0 and (contains($menu,'Soli/Tar') or contains($menu,'Soli/Inc') or contains($menu,'Soli/Pet') or string-length($subtarea)>0)">
						<tr><td valign="top" title="Este texto slo lo ver el informtico de la tarea."><i>Texto Bitcora:</i></td><td><TEXTAREA NAME="tarBit" COLS="98" ROWS="4"></TEXTAREA></td></tr>
					</xsl:if>
					<xsl:if test="$tipotarea='R'">
						<tr><td valign="top"><i>Texto Solucin<font size="-1" color="red">(*)</font>:</i></td><td><TEXTAREA NAME="tarDescripSegui" COLS="98" ROWS="6"></TEXTAREA></td></tr>
					</xsl:if>
					<xsl:if test="$tipotarea='T'">
						<tr>
							<td><i>Tipo de Tarea<font size="-1" color="red">(*)</font>:</i></td>
							<td><input type="radio" name="tarTipCod" value="P" onClick="marcaPeticion();"/>Se trata de una peticin, novedad, mejora o sugerencia.<br/>
								<input type="radio" name="tarTipCod" value="I" onClick="marcaIncidencia();"/>Se trata de una incidencia, error o fallo.
							</td>
						</tr>
					</xsl:if>
					<xsl:if test="not(contains($menu,'Inc')) and not($tipotarea='R')">
					<xsl:variable name="fma"><xsl:call-template name="date2String2"><xsl:with-param name="fecha" select="DATA/SOLICITUDES/SOLICITUD/@FECHA_MAX_RESOLUCION"/></xsl:call-template></xsl:variable>
					<tr id="fmrr3"><xsl:attribute name="style"><xsl:if test="$tipotarea='T'">display:none;</xsl:if></xsl:attribute>
						<td><i>Fecha Max. Resol.:</i></td>
						<td><input type="text" name="tarFecmaxResol" id="f_tarFecmaxResol" onChange="changeDate(this)" value="{$fma}"/>
						<img src="../graficos/iconos/calendario_ico.gif" id="f_trigger_c"
						style="cursor: pointer; border: 1px solid red;"
						title="Selecciona Fecha"
						onmouseover="this.style.background='red';"
						onmouseout="this.style.background=''"/>
						<script type="text/javascript">
							Calendar.setup({
								inputField     :    "f_tarFecmaxResol",
								ifFormat       :    "%d/%m/%Y",
								button         :    "f_trigger_c",
								align          :    "Tl",
								onSelect       :    selectDate,
								singleClick    :    false
							});
						</script>
						</td>
					</tr>
					</xsl:if>
					<tr id="fmrr1">
					<td valign="bottom"><i>Aplicacin<xsl:if test="count(DATA/SECURITY[@MODULE='dumbo7/solicitudes']/ACTION[@NAME='informatico'])>0 and (count(DATA/SECURITY[@MODULE='dumbo7/solicitudes']/ACTION[@NAME='oreja'])=0 or $tipotarea='R')"><font size="-1" color="red">(*)</font></xsl:if>:</i></td>
					<td>
							<INPUT TYPE="hidden" NAME="tarAplTAsg" VALUE="-1"/>
							<INPUT TYPE="hidden" NAME="tarAplCod" VALUE="-1"/>
							<xsl:choose>
							<xsl:when test="count(DATA/SECURITY[@MODULE='dumbo7/solicitudes']/ACTION[@NAME='informatico'])>0">
								<input type="hidden" id="desapl_hidden" name="desapl_ID" value=""/> 
								<input type="hidden" id="aplCodIn" name="aplCodIn" value=""/> 
								<input type="text" id="desapl" name="desapl" value="" onchange="CambiaDeApl(this,event)" size="60" maxlength="100"/>&#160;<a href="javascript:buscaAplicaciones();"><img title="Buscar Aplicaciones" src="../graficos/iconos/ampliar.gif" border="0"/></a>
								<div id="listaapls"></div>
							</xsl:when>
							<xsl:otherwise>
								<input type="hidden" id="desapl_hidden" name="desapl_ID" value=""/> 
								<input type="hidden" id="aplCodIn" name="aplCodIn" value=""/> 
								<input type="text" id="desapl" name="desapl" value="" onchange="CambiaDeApl(this,event)" size="60" maxlength="100"/>&#160;<a href="javascript:buscaAplicacionesNiveles();"><img title="Buscar Aplicaciones" src="../graficos/iconos/ampliar.gif" border="0"/></a>
								<div id="listaapls"></div>
								<div id="listaaplsnivel"></div>
							</xsl:otherwise>
							</xsl:choose>
					</td>
					</tr>
					<xsl:choose>
						<xsl:when test="not($tipotarea='R')">
						<tr id="fmrr2"><!-- xsl:attribute name="style"><xsl:if test="$tipotarea='T'">display:none;</xsl:if></xsl:attribute -->
							<td><i>Urgencia:</i></td>
							<td>
							<SELECT NAME="tarUrgencia" SIZE="1" OnChange="modificadaUrgencia()">
								<OPTION VALUE="V">Sin Asignar</OPTION>
								<OPTION VALUE="N">No Urgente</OPTION>
								<OPTION VALUE="U">Urgente</OPTION>
							</SELECT>
							</td>
						</tr>
						</xsl:when>
						<xsl:otherwise>
						<tr>
							<td><i>Tiempo Empleado:</i></td>
							<td>
							<input type="text" name="hrs" value="0" size="3" onchange="cambiaHoras();" onfocus="saveValor(this);"/>&#160;Horas&#160;&#160;&#160;
								<select name="mins" size="1">
									<!-- <option value="0">00</option>
									<option value="5" selected="true">05</option> 
									<option value="10">10</option>-->
									<option value="15" selected="true">15</option>
									<option value="20">20</option>
									<option value="25">25</option>
									<option value="30">30</option>
									<option value="35">35</option>
									<option value="40">40</option>
									<option value="45">45</option>
									<option value="50">50</option>
									<option value="55">55</option>
								</select>&#160;Minutos
								<INPUT TYPE="hidden" name="tarUrgencia" value="U"/>
								<INPUT TYPE="hidden" name="tarPriCod" value="A"/>
								<INPUT TYPE="hidden" name="tarHorasRes" value=""/>
							</td>
						</tr>
						</xsl:otherwise>
					</xsl:choose>
					<tr>
						<td><i>Email Copia:</i></td><td><INPUT TYPE="text" NAME="tarEmailCopia" VALUE="" SIZE="30" onchange="cambEmailCop(this)"/></td>
					</tr>
						<xsl:choose>
						<xsl:when test="not($tipotarea='R')">
						<tr>
							<td><i>Ext.Contacto<font size="-1" color="red">(*)</font>:</i></td>
							<td>
								<INPUT TYPE="text" NAME="tarTelefono" SIZE="12" VALUE="{substring(DATA/SOLICITUDES/USER/@TELEFONO,6)}">
									<xsl:attribute name="MAXLENGTH"><xsl:choose><xsl:when test="not(contains(DATA/SOLICITUDES/USER/@LOGIN,'@um.es')) or count(DATA/SECURITY[@MODULE='dumbo7/solicitudes']/ACTION[@NAME='informatico'])>0">9</xsl:when><xsl:otherwise>4</xsl:otherwise></xsl:choose></xsl:attribute>
								</INPUT>
							</td>
						</tr>
						<tr>
							<td valign="top">
								<i>Ubicacin Tarea:</i>
								<INPUT TYPE="hidden" NAME="tarEDUbicacion" VALUE="{DATA/SOLICITUDES/USER/@EDUBICACION}"/>
							</td>
							<td>
								<xsl:if test="not($tipotarea='R') and not($tipotarea='B')">
								<DIV id="ubid" style="display:none"></DIV>
								</xsl:if>
									<TEXTAREA NAME="tarUbicacion" COLS="90" ROWS="3">
									<xsl:value-of select="DATA/SOLICITUDES/USER/@UBICACION"/>
								</TEXTAREA>
								</td>
						</tr>
						</xsl:when>
						<xsl:otherwise>
						<tr>
							<td><i>Tipo Tarea:</i></td>
							<td>
								<SELECT name="tarTipCod" SIZE="1">
									<OPTION VALUE="I">Incidencia</OPTION>
									<OPTION VALUE="P">Peticin</OPTION>
								</SELECT>
							</td>
						</tr>
						</xsl:otherwise>
						</xsl:choose>
						<xsl:if test="not($tipotarea='R')">
						<tr>
							<td><i>Anexos:</i></td>
							<td>
								<INPUT TYPE="file" NAME="tarAnexo1" VALUE="" SIZE="30"/>&#160;
								<INPUT TYPE="file" NAME="tarAnexo2" VALUE="" SIZE="30"/><br/>
								<INPUT TYPE="file" NAME="tarAnexo3" VALUE="" SIZE="30"/>&#160;
								<INPUT TYPE="file" NAME="tarAnexo4" VALUE="" SIZE="30"/><br/>
								<INPUT TYPE="file" NAME="tarAnexo5" VALUE="" SIZE="30"/>&#160;
								<INPUT TYPE="file" NAME="tarAnexo6" VALUE="" SIZE="30"/>
							</td>
						</tr>
						</xsl:if>
					</table>
				</td></tr>
				<xsl:if test="$tipotarea='A'">
				<tr><td class="cabe">Temporizacin</td></tr>
				<tr>
					<xsl:if test="count(DATA/SOLICITUDES/PLANTILLAS)>0">
						<td class="sol1">&#160;</td>
					</xsl:if>
					<td class="cont">
					<table>
					<tr>
						<td><i>Fecha/Hora Inicio<font size="-1" color="red">(*)</font>:</i></td>
						<td><input type="text" name="tprFechaInicio" id="f_tprFechaInicio" onChange="changeDate(this,true)" size="25"/>
							<img src="../dumbo7/utils/jscalendar/img.gif" id="f_trigger_fi"
								style="cursor: pointer; border: 1px solid red;"
								title="Selecciona Fecha y Hora"
								onmouseover="this.style.background='red';"
								onmouseout="this.style.background=''"/>
								<script type="text/javascript">
									Calendar.setup({
										inputField     :    "f_tprFechaInicio",
										ifFormat       :    "%d/%m/%Y %H:%M",
										button         :    "f_trigger_fi",
										align          :    "Tl",
										onSelect       :    selectDateInitHour,
										singleClick    :    false,
										showsTime      :    true
									});
								</script>
						</td>
						<td><i>Fecha/Hora Fin<font size="-1" color="red">(*)</font>:</i></td>
						<td><input type="text" name="tprFechaFin" id="f_tprFechaFin" onChange="changeDate(this,true)" size="25"/>
							<img src="../dumbo7/utils/jscalendar/img.gif" id="f_trigger_ff"
								style="cursor: pointer; border: 1px solid red;"
								title="Selecciona Fecha y Hora"
								onmouseover="this.style.background='red';"
								onmouseout="this.style.background=''"/>
								<script type="text/javascript">
									Calendar.setup({
										inputField     :    "f_tprFechaInicio",
										ifFormat       :    "%d/%m/%Y %H:%M",
										button         :    "f_trigger_ff",
										align          :    "Tl",
										onSelect       :    selectDateEndHour,
										singleClick    :    false,
										showsTime      :    true
									});
								</script>
						</td>
					</tr>
					<tr>
						<td><i>Intervalo<font size="-1" color="red">(*)</font>:</i></td>
						<td><input type="text" name="tprIntervaloHoras" value="" size="5" maxlength="5"/>&#160;Horas</td>
						<td><i>Fin de Semana<font size="-1" color="red">(*)</font>:</i></td>
						<td>
							<select size="1" name="tprFindesemana">
								<option value="N">No Crear Tareas</option>
								<option value="S">Crear Tareas</option>
							</select>
						</td>
					</tr>
					</table>
				</td></tr>
				</xsl:if>
				<xsl:if test="$tipotarea='B'">
				<tr>
					<td class="cabe"><strong>Tareas Vinculadas</strong></td>
				</tr>
				<tr id="trvinc" style="display:none;">
					<xsl:if test="count(DATA/SOLICITUDES/PLANTILLAS)>0">
						<td class="sol1">&#160;</td>
					</xsl:if>
					<td class="cont" width="100%">
					<script language="JavaScript">
						var arrayVinculadas = new Array();
						var indice = 0;
						
						function esVinculada(n) {
							for (k=0; k&lt;indice; k++) {
								if (arrayVinculadas[k]==n) return k;
							}
							return -1;
						}
						function addVinculada(n) {
							arrayVinculadas[indice] = n;
							indice = indice+1;
						}
						function dropVinculada(n) {
							var ind = esVinculada(n);
							if (ind&lt;0) return;
							for (k=ind; k&lt;indice-1; k++) {
								arrayVinculadas[k] = arrayVinculadas[k+1];
							}
							indice = indice-1;
						}
						function getAllVinculadas() {
							var txt = '';
							for (k=0; k&lt;indice; k++) {
								if (txt!='') txt = txt+':'+arrayVinculadas[k];
								else txt = arrayVinculadas[k];
							}
							return txt;
						}
						function getCountVinculadas() { return indice; }
						function marcaVinculadas(obj) {
							for (k=0; k&lt;indice; k++) {
								eval('var chk = obj.chk'+arrayVinculadas[k]);
								if (chk!=null) chk.checked = true;
							}
						}
					</script>
					<table  width="100%">
					<tr>
						<td align="right">
							<a href="javascript:filtrar();"><img name="filt" src="../graficos/iconos/filtrar_ico.gif" border="0" title="Filtrar Informacin (Filtro No Activo)"/></a>&#160;
							<a href="javascript:personalizar();"><img name="pers" src="../graficos/iconos/personalizar_ico.gif" border="0" title="Personalizar Informacin Mostrada (No Activo)"/></a>&#160;
						</td>
					</tr>
					<tr>	
						<td>
							<iframe name="listado" id="listado" src="../vacia.html" width="100%" height="150" frameborder="0"></iframe>
						</td>
					</tr>
					</table>
				</td></tr>
				</xsl:if>
				<xsl:choose>
					<xsl:when test="$tipotarea='A'">
						<tr>
							<xsl:if test="count(DATA/SOLICITUDES/PLANTILLAS)>0">
								<td class="sol2">&#160;</td>
							</xsl:if>
							<td class="cabe" align="center"><INPUT CLASS="boton" TYPE="button" VALUE="Enviar" OnClick="enviarProgramada();"/>&#160;
							<input type="button" class="boton" value="Cancelar" onclick="javascript:goMenu('{$volver}');"/></td>
						</tr>
					</xsl:when>
					<xsl:when test="$tipotarea='B'">
						<tr>
							<xsl:if test="count(DATA/SOLICITUDES/PLANTILLAS)>0">
								<td class="sol2">&#160;</td>
							</xsl:if>
							<td class="cabe" align="center"><INPUT CLASS="boton" TYPE="button" VALUE="Enviar" OnClick="enviarProblema();"/>&#160;
							<!--  <input type="button" class="boton" value="Cancelar" onclick="javascript:history.back();"/></td>-->
							<input type="button" class="boton" value="Cancelar" onclick="javascript:goMenu('{$volver}');"/></td>
						</tr>
					</xsl:when>
					<xsl:when test="$tipotarea='R'">
						<tr>
							<td class="cabe" align="center"><INPUT CLASS="boton" TYPE="button" VALUE="Enviar" OnClick="enviarRapida();"/>&#160;
							<!--  <input type="button" class="boton" value="Cancelar" onclick="javascript:history.back();"/></td>-->
							<input type="button" class="boton" value="Cancelar" onclick="javascript:goMenu('{$volver}');"/></td>
						</tr>
					</xsl:when>
					<xsl:otherwise>
						<tr>
							<td class="cabe" align="center"><INPUT CLASS="boton" TYPE="button" VALUE="Enviar" OnClick="enviar();"/>&#160;
							<!--  <input type="button" class="boton" value="Cancelar" onclick="javascript:history.back();"/></td>-->
							<input type="button" class="boton" value="Cancelar" onclick="javascript:goMenu('{$volver}');"/></td>
						</tr>
					</xsl:otherwise>
			</xsl:choose>
		</table>
		<!-- </td></tr></table> -->
	<!-- </center> -->
<!-- 
	</td></tr>
</table>
 -->
</FORM>
<xsl:if test="string-length(DATA/SOLICITUDES/SOLICITUD/@APLICACION)>0">
<script language="JavaScript">
	CambiaMiApl('<xsl:value-of select="DATA/SOLICITUDES/SOLICITUD/@APLICACION"/><xsl:value-of select="$apltipoasg"/>-<xsl:value-of select="DATA/SOLICITUDES/SOLICITUD/@URGENCIA"/>:<xsl:value-of select="DATA/SOLICITUDES/SOLICITUD/@URGENCIA"/>###<xsl:value-of select="DATA/SOLICITUDES/SOLICITUD/@APLICACIONDESC"/>','<xsl:value-of select="DATA/SOLICITUDES/SOLICITUD/@APLICACIONDESC"/>');
	document.newSol.tarAsunto.focus();
</script>
</xsl:if>
</xsl:template>

</xsl:stylesheet>
	