<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet version="1.0" 
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:xforms="http://www.w3.org/2002/xforms">
	
<xsl:param name="servlet"/>	
<xsl:param name="menu"/>
<xsl:param name="selected"/>
<xsl:param name="page"/>
<xsl:param name="numItem"/>  

<xsl:include href="dumbo7/utils/xsl/utils.xsl"/>
<xsl:include href="dumbo7/utils/xsl/detail.xsl"/>
<xsl:include href="atica/frameweb/xml/templates/paginable.xsl"/>

<xsl:template match="XMLROOT">

<html lang="es">

	<xsl:call-template name="headComun">
		<xsl:with-param name="arbol" select="true()"/>
		<xsl:with-param name="calendar" select="true()"/>
		<xsl:with-param name="jscript">
			<SCRIPT LANGUAGE="JavaScript">
				function select(cod) {
					document.formDetail.selected.value=cod;
					document.formDetail.submit();
				}
			</SCRIPT>
		</xsl:with-param>
	</xsl:call-template>

<body>
	<form name="formDetail" action="{$servlet}" method="post">
		<input type="hidden" name="module" value="dumbo7/solicitudes.detalle"/>
		<input type="hidden" name="menu" value="{$menu}"/>
		<input type="hidden" name="selected" value=""/>
		<input type="hidden" name="padre" value="{$selected}"/>
	</form>
	<xsl:call-template name="detailUser">
		<xsl:with-param name="filt" select="DATA/SOLICITUDES/FILTRO"/>
		<xsl:with-param name="target" select="'dumbo7/atencion.atender.detalleUser'"/>
	</xsl:call-template>
	<center>
	<br/><div class="titulo">Lista de Subtareas</div><br/>
	<table border="0" cellpadding="1" cellspacing="1" width="100%">
		<tr>
			<td width="1%">&#160;</td>
			<td>Estado</td>
			<td>Cdigo</td>
			<td>Aplicacin</td>
			<td>Asunto</td>
			<td><xsl:call-template name="traduce"><xsl:with-param name="id" select="'Informatico'"/></xsl:call-template></td>
			<td>Fecha</td>
		</tr>
		<xsl:choose>
			<xsl:when test="DATA/SOLICITUDES/@ERROR=''">
				<xsl:call-template name="sacaTarea"/>
				<xsl:if test="count(DATA/SOLICITUDES/SOLICITUD/SUBTAREA)=0">
					<tr><td>&#160;</td><td colspan="4">No tiene subtareas asociadas</td></tr>
				</xsl:if>
			</xsl:when>
			<xsl:otherwise>
				Ocurri un error:<br/>
				<xsl:value-of select="DATA/SOLICITUDES/@ERROR"/>	
			</xsl:otherwise>
		</xsl:choose>
		<tr>
			<td colspan="7" align="center"><br/>
				<input class="boton" type="button" onclick="top.close();" value="Cerrar"/>
			</td>
		</tr>
		
	</table>
</center>
</body>
</html>
</xsl:template>

<xsl:template name="sacaTarea">
	<xsl:for-each select="/XMLROOT/DATA/SOLICITUDES/SOLICITUD">
		<tr>
		<td width="1%"><a name="{@CODIGO}"><img src="../graficos/img/select.gif" border="0"/></a></td>
			<xsl:call-template name="showColumn">
				<xsl:with-param name="columna" select="'ESTADO'"/>
				<xsl:with-param name="fila" select="."/>
				<xsl:with-param name="name"><xsl:if test="count(./SUBTAREA)>0"><xsl:value-of select="position()"/></xsl:if></xsl:with-param>
			</xsl:call-template>
			<xsl:call-template name="showColumn">
				<xsl:with-param name="columna" select="'CODIGO'"/>
				<xsl:with-param name="fila" select="."/>
			</xsl:call-template>
			<xsl:call-template name="showColumn">
				<xsl:with-param name="columna" select="'APLICACIONDESC'"/>
				<xsl:with-param name="fila" select="."/>
			</xsl:call-template>
			<xsl:call-template name="showColumn">
				<xsl:with-param name="columna" select="'ASUNTO'"/>
				<xsl:with-param name="fila" select="."/>
			</xsl:call-template>
			<xsl:call-template name="showColumn">
				<xsl:with-param name="columna" select="'INFEMAIL'"/>
				<xsl:with-param name="fila" select="."/>
			</xsl:call-template>
			<xsl:call-template name="showColumn">
				<xsl:with-param name="columna" select="'FECHA_CREACION'"/>
				<xsl:with-param name="fila" select="."/>
			</xsl:call-template>
		</tr>
		<xsl:call-template name="sacaSubTarea">
			<xsl:with-param name="padre" select="."/>
			<xsl:with-param name="guion" select="'-'"/>
			<xsl:with-param name="posic" select="position()"/>
		</xsl:call-template>
	</xsl:for-each>
</xsl:template>

<xsl:template name="sacaSubTarea">
<xsl:param name="padre"/>
<xsl:param name="guion"/>
<xsl:param name="posic"/>
	<xsl:for-each select="$padre/SUBTAREA">
		<xsl:variable name="posicion" select="concat(concat($posic,'.'),position())"/>
		<tr id="arb.{concat(concat($posic,'.'),position())}" class="switchcontent">
		<td width="1%">&#160;</td>
			<xsl:call-template name="showColumn">
				<xsl:with-param name="columna" select="'ESTADO'"/>
				<xsl:with-param name="fila" select="."/>
				<xsl:with-param name="guion" select="$guion"/>
				<xsl:with-param name="name"><xsl:if test="count(./SUBTAREA)>0"><xsl:value-of select="$posicion"/></xsl:if></xsl:with-param>
			</xsl:call-template>
			<xsl:call-template name="showColumn">
				<xsl:with-param name="columna" select="'CODIGO'"/>
				<xsl:with-param name="fila" select="."/>
				<xsl:with-param name="guion" select="$guion"/>
			</xsl:call-template>
			<xsl:call-template name="showColumn">
				<xsl:with-param name="columna" select="'APLICACIONDESC'"/>
				<xsl:with-param name="fila" select="."/>
				<xsl:with-param name="guion" select="$guion"/>
			</xsl:call-template>
			<xsl:call-template name="showColumn">
				<xsl:with-param name="columna" select="'ASUNTO'"/>
				<xsl:with-param name="fila" select="."/>
				<xsl:with-param name="guion" select="$guion"/>
			</xsl:call-template>
			<xsl:call-template name="showColumn">
				<xsl:with-param name="columna" select="'INFEMAIL'"/>
				<xsl:with-param name="fila" select="."/>
				<xsl:with-param name="guion" select="$guion"/>
			</xsl:call-template>
			<xsl:call-template name="showColumn">
				<xsl:with-param name="columna" select="'FECHA_CREACION'"/>
				<xsl:with-param name="fila" select="."/>
				<xsl:with-param name="guion" select="$guion"/>
			</xsl:call-template>
		</tr>
		<xsl:call-template name="sacaSubTarea">
			<xsl:with-param name="padre" select="."/>
			<xsl:with-param name="guion" select="concat($guion,'-')"/>
			<xsl:with-param name="posic" select="concat(concat($posic,'.'),position())"/>
		</xsl:call-template>
	</xsl:for-each>
</xsl:template>

<xsl:template name="cuerpo"></xsl:template>

</xsl:stylesheet>
