<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet version="1.0" 
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:xforms="http://www.w3.org/2002/xforms">
	
<xsl:param name="servlet"/>	
<xsl:param name="menu"/>
<xsl:param name="selected"/>
<xsl:param name="page"/>
<xsl:param name="numItem"/>

<xsl:include href="dumbo7/utils/xsl/utils.xsl"/>
<xsl:include href="dumbo7/utils/xsl/detail.xsl"/>
<xsl:include href="atica/frameweb/xml/templates/paginable.xsl"/>

<xsl:key name="miClave" match="SUBTAREA" use="@CODIGO"/>

<xsl:template match="XMLROOT">

<html lang="es">

	<xsl:call-template name="headComun">
		<xsl:with-param name="arbol" select="true()"/>
		<xsl:with-param name="calendar" select="true()"/>
		<xsl:with-param name="jscript">
			<SCRIPT LANGUAGE="JavaScript">
				function select(cod,pg,tt) {
					eval('var obj = document.f1.chk'+cod+';');
					obj.checked = !obj.checked;
					clickCheck(obj);
				}
				function detalleUser(usr) {
					var w = window.open('about:blank','UserDetail','width=400,height=300,left=100,top=100,scrollbars=yes');
					document.detalleUsr.target = w.name;
					document.detalleUsr.user.value = usr;
					document.detalleUsr.submit();
				}
				
				function clickCheck(obj) {
					if (obj.checked) top.addVinculada(obj.name.substring(3));
					else top.dropVinculada(obj.name.substring(3));
				}
				function clickLink(cod) {
					eval('var ob = document.f1.chk'+cod);
					ob.checked = !ob.checked;
					clickCheck(ob);
				}
				function marcaChecks() {
					top.marcaVinculadas(document.f1);
				}
				
				<xsl:choose>
					<xsl:when test="DATA/SOLICITUDES/FILTRO/@EMPTY='true'">
						top.document.filt.src='../graficos/iconos/filtrar_ico.gif';
						top.document.filt.title='Filtrar Informacin (Filtro No Activo)';
					</xsl:when>
					<xsl:otherwise>
						top.document.filt.src='../graficos/iconos/filtrar_icon.gif';
						top.document.filt.title='Filtrar Informacin (Filtro Activo)';
					</xsl:otherwise>
				</xsl:choose>
				<xsl:choose>
					<xsl:when test="DATA/SOLICITUDES/FILTRO/@FORMAT='true'">
						top.document.pers.src='../graficos/iconos/personalizar_ico.gif';
						top.document.pers.title='Personalizar Informacin (Filtro No Activo)';
					</xsl:when>
					<xsl:otherwise>
						top.document.pers.src='../graficos/iconos/personalizar_icon.gif';
						top.document.pers.title='Personalizar Informacin (Filtro Activo)';
					</xsl:otherwise>
				</xsl:choose>
				
			</SCRIPT>
		</xsl:with-param>
	</xsl:call-template>

<body class="littlebody" OnLoad="marcaChecks();">
<form name="recarga" action="{$servlet}" method="post">
	<input type="hidden" name="module" value="dumbo7/solicitudes.vinculadas"/>
	<input type="hidden" name="menu" value="{$menu}"/>
</form>
<form name="detalleUsr" action="{$servlet}" method="post">
	<input type="hidden" name="module" value="dumbo7/atencion.atender.detalleUser"/>
	<input type="hidden" name="user" value=""/>
</form>
	<table border="0" class="cont" cellpadding="1" cellspacing="1" width="100%">
		<tr class="cabe">
			<td width="1%">&#160;</td>
			<td width="1%">&#160;</td>
			<xsl:for-each select="DATA/SOLICITUDES/FILTRO/CAMPOS">
				<xsl:variable name="co" select="."/>
				<td><xsl:value-of select="/XMLROOT/DATA/SOLICITUDES/FILTRO/CAMPOSFILTRO[key=$co]/value"/></td>
			</xsl:for-each>
			<td width="1%">&#160;</td>
		</tr>
		<xsl:choose>
			<xsl:when test="DATA/SOLICITUDES/@ERROR=''">
				<form name="f1">
					<xsl:call-template name="sacaTarea"/>
				</form>
				<xsl:if test="count(DATA/SOLICITUDES/PAGINAS/ITEM)>0">
				<center>
			  	<xsl:call-template name="PIE-LISTA">
			  		<xsl:with-param name="DATOS" select="DATA/SOLICITUDES/PAGINAS"/>
			  		<xsl:with-param name="SIZE" select="DATA/SOLICITUDES/FILTRO/@TAMPAG"/>
			  		<!-- <xsl:with-param name="SIZE" select="20"/> -->
			  	</xsl:call-template>
				</center>
				</xsl:if>
				<xsl:if test="count(DATA/SOLICITUDES/PAGINAS/ITEM)=0">
					<tr><td>&#160;</td><td colspan="4">La lista de tareas est vaca</td></tr>
				</xsl:if>
				<!--
			  	<xsl:call-template name="PIE-SGTE">
			  		<xsl:with-param name="DATOS" select="DATA/SOLICITUDES/PAGINAS"/>
			  		<xsl:with-param name="IMAGE-NEXT" select="'../graficos/img/next.gif'"/>
			  		<xsl:with-param name="IMAGE-PREVIOUS" select="'../graficos/img/previous.gif'"/>
			  	</xsl:call-template>
				-->
			</xsl:when>
			<xsl:otherwise>
				Ocurri un error:<br/>
				<xsl:value-of select="DATA/SOLICITUDES/@ERROR"/>	
			</xsl:otherwise>
		</xsl:choose>
	</table>
</body>
</html>
</xsl:template>

<xsl:template name="sacaTarea">
	<xsl:for-each select="/XMLROOT/DATA/SOLICITUDES/PAGINAS/ITEM[count(key('miClave',@CODIGO))=0 or count(/XMLROOT/DATA/SOLICITUDES/FILTRO[@SUBTAREAS='N'])>0]">
	  <xsl:variable name="micode" select="@CODIGO"/>
	  <xsl:variable name="posicion" select="position()"/>
		<xsl:variable name="estilo">
		<xsl:choose>
		<xsl:when test="./@TIPO_TAREA='B'">problema</xsl:when>
		<xsl:when test="./@TIPO_TAREA='I'">incidencia</xsl:when>
		<xsl:when test="./@TIPO_TAREA='A'">programada</xsl:when>
		<xsl:otherwise>peticion</xsl:otherwise>
		</xsl:choose>
		</xsl:variable>
		<tr><xsl:if test="(count(./SUBTAREA)>0)"><xsl:attribute name="id">arb.<xsl:value-of select="$posicion"/></xsl:attribute><xsl:attribute name="class">switchcontent</xsl:attribute></xsl:if>
		<td class="{$estilo}" width="1%"><input type="checkbox" name="chk{@CODIGO}" OnClick="clickCheck(this);"/></td>
		<td class="{$estilo}" width="1%"><font size="-2">[<xsl:value-of select="((number(../PAGE)-1)*number(/XMLROOT/DATA/SOLICITUDES/FILTRO/@TAMPAG))+position()"/>]</font></td>
		<xsl:variable name="fila" select="."/>
		<xsl:for-each select="/XMLROOT/DATA/SOLICITUDES/FILTRO/CAMPOS">
			<xsl:call-template name="showColumn">
				<xsl:with-param name="columna" select="."/>
				<xsl:with-param name="fila" select="$fila"/>
				<xsl:with-param name="name"><xsl:if test="(count($fila/SUBTAREA)>0) and (position()=1)"><xsl:value-of select="$posicion"/></xsl:if></xsl:with-param>
				<xsl:with-param name="estilo"><xsl:value-of select="$estilo"/></xsl:with-param>
			</xsl:call-template>
		</xsl:for-each>
		<td class="{$estilo}" width="1%">&#160;</td>
		</tr>
		
		<xsl:if test="count(/XMLROOT/DATA/SOLICITUDES/FILTRO[not(@SUBTAREAS='N')])>0">
			<xsl:call-template name="sacaSubTarea">
				<xsl:with-param name="padre" select="."/>
				<xsl:with-param name="guion" select="'-'"/>
				<xsl:with-param name="posic" select="position()"/>
			</xsl:call-template>
		</xsl:if>
	</xsl:for-each>
</xsl:template>

<xsl:template name="sacaSubTarea">
<xsl:param name="padre"/>
<xsl:param name="guion"/>
<xsl:param name="posic"/>

	<xsl:for-each select="$padre/SUBTAREA">
		<xsl:variable name="posicion" select="concat(concat($posic,'.'),position())"/>
		<xsl:variable name="estilo">
		<xsl:choose>
		<xsl:when test="./@TIPO_TAREA='B'">problema</xsl:when>
		<xsl:when test="./@TIPO_TAREA='I'">incidencia</xsl:when>
		<xsl:when test="./@TIPO_TAREA='A'">programada</xsl:when>
		<xsl:otherwise>peticion</xsl:otherwise>
		</xsl:choose>
		</xsl:variable>
		<tr id="arb.{concat(concat($posic,'.'),position())}"><xsl:if test="(count(./SUBTAREA)>0)"><xsl:attribute name="class">switchcontent</xsl:attribute></xsl:if>
		<td width="1%" class="{$estilo}"><input type="checkbox" name="chk{@CODIGO}" OnClick="clickCheck(this);"/></td>
		<td width="1%" class="{$estilo}" id="img{@CODIGO}">&#160;</td>
		<xsl:variable name="fila" select="."/>
		<xsl:for-each select="/XMLROOT/DATA/SOLICITUDES/FILTRO/CAMPOS">
			<xsl:call-template name="showColumn">
				<xsl:with-param name="guion" select="$guion"/>
				<xsl:with-param name="columna" select="."/>
				<xsl:with-param name="fila" select="$fila"/>
				<xsl:with-param name="name"><xsl:if test="(count($fila/SUBTAREA)>0) and (position()=1)"><xsl:value-of select="$posicion"/></xsl:if></xsl:with-param>
				<xsl:with-param name="estilo" select="$estilo"/>
			</xsl:call-template>
		</xsl:for-each>
		<td width="1%" class="{$estilo}">&#160;</td>
		</tr>
		
		<xsl:call-template name="sacaSubTarea">
			<xsl:with-param name="padre" select="."/>
			<xsl:with-param name="guion" select="concat($guion,'-')"/>
			<xsl:with-param name="posic" select="concat(concat($posic,'.'),position())"/>
		</xsl:call-template>
		
	</xsl:for-each>
		
</xsl:template>

<xsl:template name="cuerpo"></xsl:template>

</xsl:stylesheet>
	