/*
 */
package dumbo7.user;

import java.io.*;
import java.util.*;
import dumbo7.user.*;
import dumbo7.utils.*;

/**
 * @author Universidad de Murcia - ATICA
 *
 */

public class FiltroUsuario implements Serializable {

	public static String FORMATO_TABLA = "T";
	public static String FORMATO_LISTA = "L";
	public static String miTipo="";
	
	public static String LISTA_ATENDER = "atender";
	public static String LISTA_ATENDIDAS = "atendidas";
	public static String LISTA_PENDIENTES = "pendientes";
	public static String LISTA_RESUELTAS = "resueltas";
	public static String LISTA_PROGRAMADAS = "programadas";
	public static String LISTA_PROBLEMAS = "problemas";
	public static String LISTA_VINCULADAS = "vinculadas";
	public static String LISTA_GENERICA = "generica";
	public static String LISTA_GLOBAL_ATENDER = "globalAtender";
	public static String LISTA_GLOBAL_ATENDIDAS = "globalAtendidas";
	public static String LISTA_APLICACION = "aplicacion";
	
	public static Hashtable camposFiltro = new Hashtable();
	public static Hashtable camposFiltroProtegidos = new Hashtable();

	static {
		camposFiltro.put(FiltroColumnas.ESTADO,"Estado");
		camposFiltro.put(FiltroColumnas.CODIGO,"Tarea");
		camposFiltro.put(FiltroColumnas.APLICACIONDESC,"Aplicacin");
		camposFiltro.put(FiltroColumnas.ASUNTO,"Asunto");
		camposFiltro.put(FiltroColumnas.USUEMAIL,"Usuario");
		camposFiltro.put(FiltroColumnas.INFEMAIL,"Informtico");
		camposFiltro.put(FiltroColumnas.FECHA_CREACION,"Creada");
		camposFiltro.put(FiltroColumnas.CATEGORIA,"Categora");
		camposFiltro.put(FiltroColumnas.PRIORIDAD,"Prioridad");
		camposFiltro.put(FiltroColumnas.FECHA_ALERTA,"F.Alerta");
		camposFiltro.put(FiltroColumnas.DESCRIPCION,"Texto");
		camposFiltro.put(FiltroColumnas.URGENCIA,"Urgencia");
		camposFiltro.put(FiltroColumnas.FECHA_MAX_RESOLUCION,"F.Max.Resol.");
		camposFiltro.put(FiltroColumnas.UBICACION,"Ubicacin");
		camposFiltro.put(FiltroColumnas.EMAIL_COPIA,"Copia");
		camposFiltro.put(FiltroColumnas.FECHA_FIN,"Resuelta");
		camposFiltro.put(FiltroColumnas.PLANIFICACION,"Prevista");
		camposFiltro.put(FiltroColumnas.DESCRIPCION_SEGUIMIENTO,"Seguimiento");
		camposFiltro.put(FiltroColumnas.HORAS_RESOLUCION,"Horas");
		camposFiltro.put(FiltroColumnas.COSTE_ECONOMICO,"Coste");
		camposFiltro.put(FiltroColumnas.COSTE_MATERIALES,"Materiales");
		camposFiltro.put(FiltroColumnas.SOLUCION,"Solucin");

		camposFiltroProtegidos.put(FiltroColumnas.CATEGORIA,"Categora");
		camposFiltroProtegidos.put(FiltroColumnas.PRIORIDAD,"Prioridad");
		camposFiltroProtegidos.put(FiltroColumnas.DESCRIPCION_SEGUIMIENTO,"Seguimiento");
		camposFiltroProtegidos.put(FiltroColumnas.HORAS_RESOLUCION,"Horas");
		camposFiltroProtegidos.put(FiltroColumnas.COSTE_ECONOMICO,"Coste");
		camposFiltroProtegidos.put(FiltroColumnas.COSTE_MATERIALES,"Materiales");
		
	}
	
	public static String decode(String c) {
		if (c==null) return null;
		if (c.equals(FiltroColumnas.ESTADO)) return "TarEstado";
		if (c.equals(FiltroColumnas.CODIGO)) return "TarCod";
		if (c.equals(FiltroColumnas.APLICACIONDESC)) return "TarAplCod";
		if (c.equals(FiltroColumnas.ASUNTO)) return "TarAsunto";
		if (c.equals(FiltroColumnas.USUEMAIL)) return "datosUser.DatEmail";
		if (c.equals(FiltroColumnas.INFEMAIL)) return "datosInform.DatEmail";
		if (c.equals(FiltroColumnas.FECHA_CREACION)) return "TarFeccrea";
		if (c.equals(FiltroColumnas.CATEGORIA)) return "categoria.CatDescrip";
		if (c.equals(FiltroColumnas.PRIORIDAD)) return "prioridad.PriDescrip";
		if (c.equals(FiltroColumnas.DESCRIPCION)) return "TarDescrip";
		if (c.equals(FiltroColumnas.URGENCIA)) return "TarUrgencia";
		if (c.equals(FiltroColumnas.FECHA_MAX_RESOLUCION)) return "TarFecmaxResol";
		if (c.equals(FiltroColumnas.UBICACION)) return "TarUbicacion";
		if (c.equals(FiltroColumnas.EMAIL_COPIA)) return "TarEmailCopia";
		if (c.equals(FiltroColumnas.FECHA_FIN)) return "TarFecfin";
		if (c.equals(FiltroColumnas.PLANIFICACION)) return "TarPlanif";
		if (c.equals(FiltroColumnas.DESCRIPCION_SEGUIMIENTO)) return "TarDescripSegui";
		if (c.equals(FiltroColumnas.HORAS_RESOLUCION)) return "TarHorasRes";
		if (c.equals(FiltroColumnas.COSTE_ECONOMICO)) return "TarCosteEco";
		if (c.equals(FiltroColumnas.COSTE_MATERIALES)) return "TarCosteMat";
		return "";
	}
	
	public static String decodeSQL(String c) {
		if (c==null) return null;
		if (c.equals(FiltroColumnas.ESTADO)) return "solicitud.Tar_Estado";
		if (c.equals(FiltroColumnas.CODIGO)) return "solicitud.Tar_Cod";
		if (c.equals(FiltroColumnas.APLICACIONDESC)) return "aplicacion.Apl_Descrip";
		if (c.equals(FiltroColumnas.ASUNTO)) return "solicitud.Tar_Asunto";
		if (c.equals(FiltroColumnas.USUEMAIL)) return "USUEMAIL";
		if (c.equals(FiltroColumnas.INFEMAIL)) return "INFEMAIL";
		if (c.equals(FiltroColumnas.FECHA_CREACION)) return "solicitud.Tar_Feccrea";
		if (c.equals(FiltroColumnas.CATEGORIA)) return "categoria.Cat_Descrip";
		if (c.equals(FiltroColumnas.PRIORIDAD)) return "decode(solicitud.Tar_Pri_Cod,'C',5,'A',4,'M',3,'B',2,'P',1,6)";
		if (c.equals(FiltroColumnas.DESCRIPCION)) return "solicitud.Tar_Descrip";
		if (c.equals(FiltroColumnas.URGENCIA)) return "solicitud.Tar_Urgencia";
		if (c.equals(FiltroColumnas.FECHA_MAX_RESOLUCION)) return "solicitud.Tar_Fecmax_Resol";
		if (c.equals(FiltroColumnas.UBICACION)) return "solicitud.Tar_Ubicacion";
		if (c.equals(FiltroColumnas.EMAIL_COPIA)) return "solicitud.Tar_Email_Copia";
		if (c.equals(FiltroColumnas.FECHA_FIN)) return "solicitud.Tar_Fecfin";
		if (c.equals(FiltroColumnas.PLANIFICACION)) return "solicitud.Tar_Planif";
		if (c.equals(FiltroColumnas.DESCRIPCION_SEGUIMIENTO)) return "solicitud.Tar_Descrip_Segui";
		if (c.equals(FiltroColumnas.HORAS_RESOLUCION)) return "solicitud.Tar_Horas_Res";
		if (c.equals(FiltroColumnas.COSTE_ECONOMICO)) return "solicitud.Tar_Coste_Eco";
		if (c.equals(FiltroColumnas.COSTE_MATERIALES)) return "solicitud.Tar_Coste_Mat";
		if (c.equals(FiltroColumnas.FECHA_ALERTA)) return "dumbo.pkd7_tareas.fechaAlerta(solicitud.tar_sis_cod,solicitud.Tar_Cod)";
		if (c.equals(FiltroColumnas.SOLUCION)) return "(select tmo_descrip_mov from dumbo.d7_tareas_movimientos where tmo_sis_cod=tar_sis_cod and tmo_tar_cod=tar_cod and tmo_tipo_mov='F' and tmo_cod = (select max(tmo_cod) from dumbo.d7_tareas_movimientos where tmo_sis_cod=tar_sis_cod and tmo_tar_cod=tar_cod and tmo_tipo_mov='F'))";
		return "";
	}
	
	public String getShowSQLColumns() {
		int miOrden = 0;
		int defOrden = 0;
		String show = showStaticSQLColumns();
		for (int k=0; k<campos.length; k++) {
			show += ","+showSQLColumn(campos[k]);
			if (campos[k].equals(camposOrden[0])) miOrden++;
			if (campos[k].equals(FiltroColumnas.DEFAULT_ORDER)) defOrden++;
		}
		if (getAlertas().equals("S")) show += ","+showSQLColumn(FiltroColumnas.ALERTAS);
		if (getSubtareas().equals("S")) show += ","+showSQLColumn(FiltroColumnas.SUBTAREAS);
		if (miOrden==0) {
			show += ","+showSQLColumn(camposOrden[0]);
		}
		if (defOrden==0 && !camposOrden[0].equals(FiltroColumnas.DEFAULT_ORDER)) {
			show += ","+showSQLColumn(FiltroColumnas.DEFAULT_ORDER);
		}
		return show;
	}
	
	public static String showStaticSQLColumns() {
		String show = "";
		for (int k=0; k<FiltroColumnas.COLUMNAS_FIJAS.length; k++) {
			if (show.equals("")) show = showSQLColumn(FiltroColumnas.COLUMNAS_FIJAS[k]);
			else show += ","+showSQLColumn(FiltroColumnas.COLUMNAS_FIJAS[k]);
		}
		return show;
	}
	
	public String [] getShowColumns() {
		String sh = getShowSQLColumns();
		return sh.split(",");
	}
	
	public boolean hasColumnSQL(String col) {
		for (int k=0; k<FiltroColumnas.COLUMNAS_FIJAS.length; k++) {
			if (FiltroColumnas.COLUMNAS_FIJAS[k].equals(col)) return true;
		}
		for (int k=0; k<campos.length; k++) {
			if (campos[k].equals(col)) return true;
		}
		if (col.equals(FiltroColumnas.ALERTAS) && getAlertas().equals("S")) return true;
		if (col.equals(FiltroColumnas.SUBTAREAS) && getSubtareas().equals("S")) return true;
		if (col.equals(FiltroColumnas.DESPLIEGUE) && getDespliegue().equals("S")) return true;
		if (col.equals(FiltroColumnas.BUSCADOR) && getBuscador().equals("S")) return true;
		if (col.equals(camposOrden[0])) return true;
		if (col.equals(FiltroColumnas.DEFAULT_ORDER) && !col.equals(camposOrden[0])) return true;
		return false;
	}
	
	public static String showSQLColumn(String c) {
		if (c==null) return null;
		if (c.equals(FiltroColumnas.SISTEMA)) return "solicitud.Tar_Sis_Cod as "+FiltroColumnas.SISTEMA;
		if (c.equals(FiltroColumnas.TIPO)) return "solicitud.Tar_Tip_Cod as "+FiltroColumnas.TIPO;
		if (c.equals(FiltroColumnas.ESTADO)) return "solicitud.Tar_Estado as "+FiltroColumnas.ESTADO;
		if (c.equals(FiltroColumnas.CODIGO)) return "solicitud.Tar_Cod as "+FiltroColumnas.CODIGO;
		if (c.equals(FiltroColumnas.ASUNTO)) 
			if (miTipo.equals(LISTA_ATENDIDAS) || miTipo.equals(LISTA_RESUELTAS))
				return "solicitud.Tar_Descrip as "+FiltroColumnas.DESCRIPCION+",solicitud.Tar_Asunto as "+FiltroColumnas.ASUNTO+",(select tmo_descrip_mov from dumbo.d7_tareas_movimientos where tmo_sis_cod=tar_sis_cod and tmo_tar_cod=tar_cod and tmo_tipo_mov='F' and tmo_cod = (select max(tmo_cod) from dumbo.d7_tareas_movimientos where tmo_sis_cod=tar_sis_cod and tmo_tar_cod=tar_cod and tmo_tipo_mov='F')) as " +FiltroColumnas.SOLUCION;
			else return "solicitud.Tar_Descrip as "+FiltroColumnas.DESCRIPCION+",solicitud.Tar_Asunto as "+FiltroColumnas.ASUNTO;
		if (c.equals(FiltroColumnas.SOLUCION)) return "(select tmo_descrip_mov from dumbo.d7_tareas_movimientos where tmo_sis_cod=tar_sis_cod and tmo_tar_cod=tar_cod and tmo_tipo_mov='F' and tmo_cod = (select max(tmo_cod) from dumbo.d7_tareas_movimientos where tmo_sis_cod=tar_sis_cod and tmo_tar_cod=tar_cod and tmo_tipo_mov='F')) as " +FiltroColumnas.SOLUCION;
		if (c.equals(FiltroColumnas.FECHA_CREACION)) return "solicitud.Tar_Feccrea as "+FiltroColumnas.FECHA_CREACION;
		if (!c.equals(FiltroColumnas.ASUNTO) && c.equals(FiltroColumnas.DESCRIPCION)) return "solicitud.Tar_Descrip as "+FiltroColumnas.DESCRIPCION;
		if (c.equals(FiltroColumnas.URGENCIA)) return "solicitud.Tar_Urgencia as "+FiltroColumnas.URGENCIA;
		if (c.equals(FiltroColumnas.FECHA_MAX_RESOLUCION)) return "solicitud.Tar_Fecmax_Resol as "+FiltroColumnas.FECHA_MAX_RESOLUCION;
		if (c.equals(FiltroColumnas.UBICACION)) return "solicitud.Tar_Ubicacion as "+FiltroColumnas.UBICACION;
		if (c.equals(FiltroColumnas.EMAIL_COPIA)) return "solicitud.Tar_Email_Copia as "+FiltroColumnas.EMAIL_COPIA;
		if (c.equals(FiltroColumnas.FECHA_FIN)) return "solicitud.Tar_Fecfin as "+FiltroColumnas.FECHA_FIN;
		if (c.equals(FiltroColumnas.PLANIFICACION)) return "solicitud.Tar_Planif as "+FiltroColumnas.PLANIFICACION;
		if (c.equals(FiltroColumnas.DESCRIPCION_SEGUIMIENTO)) return "solicitud.Tar_Descrip_Segui as "+FiltroColumnas.DESCRIPCION_SEGUIMIENTO;
		if (c.equals(FiltroColumnas.HORAS_RESOLUCION)) return "solicitud.Tar_Horas_Res as "+FiltroColumnas.HORAS_RESOLUCION;
		if (c.equals(FiltroColumnas.COSTE_ECONOMICO)) return "solicitud.Tar_Coste_Eco as "+FiltroColumnas.COSTE_ECONOMICO;
		if (c.equals(FiltroColumnas.COSTE_MATERIALES)) return "solicitud.Tar_Coste_Mat as "+FiltroColumnas.COSTE_MATERIALES;
		if (c.equals(FiltroColumnas.TARPADRE)) return "solicitud.Tar_Padre_Tar_Cod as "+FiltroColumnas.TARPADRE;
		if (c.equals(FiltroColumnas.APLICACIONDESC)) return "solicitud.Tar_Apl_Cod as "+FiltroColumnas.APLCOD+",aplicacion.APL_DESCRIP as "+FiltroColumnas.APLICACIONDESC;
		if (c.equals(FiltroColumnas.USUEMAIL)) return "solicitud.Tar_Usu_Cod as "+FiltroColumnas.USUCOD+",tar_usu_cod as "+FiltroColumnas.USUEMAIL+",solicitud.Tar_Email_Copia as "+FiltroColumnas.EMAIL_COPIA;
		if (c.equals(FiltroColumnas.INFEMAIL)) return "solicitud.Tar_Inf_Cod as "+FiltroColumnas.INFCOD+",tar_inf_cod as "+FiltroColumnas.INFEMAIL;
		if (c.equals(FiltroColumnas.CATEGORIA)) return "solicitud.Tar_Cat_Cod as "+FiltroColumnas.CATCOD+",categoria.Cat_Descrip as "+FiltroColumnas.CATEGORIA;
		if (c.equals(FiltroColumnas.PRIORIDAD)) return "solicitud.Tar_Pri_Cod as "+FiltroColumnas.PRICOD+",prioridad.Pri_Descrip as "+FiltroColumnas.PRIORIDAD;
		if (c.equals(FiltroColumnas.SUBTAREAS)) return "(select count(*) from dumbo.d7_tareas where tar_sis_cod = solicitud.tar_sis_cod and tar_padre_tar_cod=solicitud.tar_cod) as "+FiltroColumnas.SUBTAREAS;
		if (c.equals(FiltroColumnas.ALERTAS)) return "(select count(*) from dumbo.d7_tareas_alertas where tal_sis_cod=solicitud.tar_sis_cod and tal_tar_cod=solicitud.tar_cod) as "+FiltroColumnas.ALERTAS;
		if (c.equals(FiltroColumnas.FECHA_ALERTA)) return "dumbo.pkd7_tareas.fechaAlerta(solicitud.tar_sis_cod,solicitud.Tar_Cod) as "+FiltroColumnas.FECHA_ALERTA;
		return c;
	}
	
	public FiltroUsuario() { super(); }
	public FiltroUsuario(String tipo) {
		super();
		if ((tipo!=null) && (tipo.equals(LISTA_ATENDIDAS) || tipo.equals(LISTA_RESUELTAS) || tipo.equals(LISTA_GLOBAL_ATENDIDAS))) {
			GregorianCalendar gc = new GregorianCalendar();
			gc.add(Calendar.DATE,-30);
			if (getFinDesde()==null) setFinDesde(gc.getTime());
		}
		if ((tipo!=null) && (tipo.equals(LISTA_VINCULADAS))) {
			GregorianCalendar gc = new GregorianCalendar();
			gc.add(Calendar.DATE,-60);
			if (getFinDesde()==null) setInicioDesde(gc.getTime());
		}
		if ((tipo!=null) && (tipo.equals(LISTA_GENERICA))) {
			this.setAplicaciones(new String[]{"N"});
		}
		if ((tipo!=null) && (tipo.equals(LISTA_APLICACION))) {
			this.setNotAplicaciones(new String[]{"N"});
		}
	}
	
	// Campos de Filtro
	public String [] tipoTarea = null;
	public String [] estadoTarea = null;
	public String [] aplicaciones = null;
	public String [] notAplicaciones = null;
	public String [] urgencia = null;
	public String [] prioridad = null;
	public Date inicioDesde = null;
	public Date inicioHasta = null;
	public Date finDesde = null;
	public Date finHasta = null;
	public String solicitante = null;
	public String informatico = null;
	public String asunto = null;
	public String codigo = null;
	public String texto = null;
	public String soloDumboRapido = null;
	
	// Campos de Formato 
	public String formato = "T";
	public String subtareas = "S";
	public String despliegue = "N";
	public String buscador = "N";
	public String alertas = "S";
	public String [] campos = new String[]{FiltroColumnas.ESTADO,FiltroColumnas.CODIGO,FiltroColumnas.APLICACIONDESC,FiltroColumnas.ASUNTO,FiltroColumnas.USUEMAIL,FiltroColumnas.INFEMAIL,FiltroColumnas.FECHA_CREACION};
	public String orden = "D";
	public String [] camposOrden = new String[]{FiltroColumnas.FECHA_CREACION};
	public String tamPag = "20";
	
	public String [] getTipoTarea() { return tipoTarea; }
	public String [] getEstadoTarea() { return estadoTarea; }
	public String [] getAplicaciones() { return aplicaciones; }
	public String [] getNotAplicaciones() { return notAplicaciones; }
	public String [] getUrgencia() { return urgencia; }
	public String [] getPrioridad() { return prioridad; }
	public Date getInicioDesde() { return inicioDesde; }
	public Date getInicioHasta() { return inicioHasta; }
	public Date getFinDesde() { return finDesde; }
	public Date getFinHasta() { return finHasta; }
	public String getFormato() { return formato; }
	public String getSubtareas() { return subtareas; }
	public String getDespliegue() { return despliegue; }
	public String getBuscador() { return buscador; }
	public boolean getVerSubtareas(DumboUser user) {
		try {
			if (user.permitidoPerfiles(user.getDatosMenu().idSelected(),"dumbo7/informacion","verSubtareas")) return true;
		} catch (Exception ex) {}
		return false;
	}
	public String getAlertas() { return alertas; }
	public String [] getCampos() { return campos; }
	public String getOrden() { return orden; }
	public String [] getCamposOrden() { return camposOrden; }
	public String getSolicitante() { return solicitante; }
	public String getInformatico() { return informatico; }
	public String getAsunto() { return asunto; }
	public String getCodigo() { return codigo; }
	public String getTexto() { return texto; }
	public String getSoloDumboRapido() { return soloDumboRapido; }
	public Hashtable getCamposFiltro() { return camposFiltro; }
	public Hashtable getCamposFiltroProtegidos() { return camposFiltroProtegidos; }
	public String getTamPag() { return tamPag; }
	
	public void setTipoTarea(String [] v) { tipoTarea = v; }
	public void setEstadoTarea(String [] v) { estadoTarea = v; }
	public void setAplicaciones(String [] v) { aplicaciones = v; }
	public void setNotAplicaciones(String [] v) { notAplicaciones = v; }
	public void setUrgencia(String [] v) { urgencia = v; }
	public void setPrioridad(String [] v) { prioridad = v; }
	public void setInicioDesde(Date d) { inicioDesde = d; }
	public void setInicioHasta(Date d) { inicioHasta = d; }
	public void setFinDesde(Date d) { finDesde = d; }
	public void setFinHasta(Date d) { finHasta = d; }
	public void setFormato(String s) { formato = s; }
	public void setSubtareas(String s) { subtareas = s; }
	public void setAlertas(String s) { alertas = s; }
	public void setCampos(String [] v) { campos = v; }
	public void setCamposOrden(String [] v) { camposOrden = v; }
	public void setOrden(String v) { orden = v; }
	public void setSolicitante(String s) { solicitante = s; }
	public void setInformatico(String s) { informatico = s; }
	public void setAsunto(String s) { asunto = s; }
	public void setCodigo(String s) { codigo = s; }
	public void setTexto(String s) { texto = s; }
	public void setTamPag(String s) { tamPag = s; }
	public void setSoloDumboRapido(String s) { soloDumboRapido = s; }
	public void setTipo(String s) {miTipo=s;}
	public void setDespliegue(String s) {despliegue=s;}
	public void setBuscador(String s) {buscador=s;}

	private void writeObject(java.io.ObjectOutputStream out) throws IOException {
		out.writeObject(tipoTarea);
		out.writeObject(estadoTarea);
		out.writeObject(aplicaciones);
		out.writeObject(notAplicaciones);
		out.writeObject(urgencia);
		out.writeObject(prioridad);
		out.writeObject(inicioDesde);
		out.writeObject(inicioHasta);
		out.writeObject(finDesde);
		out.writeObject(finHasta);
		out.writeObject(solicitante);
		out.writeObject(informatico);
		out.writeObject(asunto);
		out.writeObject(codigo);
		out.writeObject(texto);
		out.writeObject(soloDumboRapido);
		out.writeObject(formato);
		out.writeObject(subtareas);
		out.writeObject(alertas);
		out.writeObject(campos);
		out.writeObject(orden);
		out.writeObject(camposOrden);
		out.writeObject(tamPag);
		out.writeObject(despliegue);
		out.writeObject(buscador);
	}
	
	private void readObject(java.io.ObjectInputStream in) throws IOException, ClassNotFoundException {
		tipoTarea = (String[])in.readObject();
		estadoTarea = (String[])in.readObject();
		aplicaciones = (String[])in.readObject();
		notAplicaciones = (String[])in.readObject();
		urgencia = (String[])in.readObject();
		prioridad = (String[])in.readObject();
		inicioDesde = (Date)in.readObject();
		inicioHasta = (Date)in.readObject();
		finDesde = (Date)in.readObject();
		finHasta = (Date)in.readObject();
		solicitante = (String)in.readObject();
		informatico = (String)in.readObject();
		asunto = (String)in.readObject();
		codigo = (String)in.readObject();
		texto = (String)in.readObject();
		soloDumboRapido = (String)in.readObject();
		formato = (String)in.readObject();
		subtareas = (String)in.readObject();
		alertas = (String)in.readObject();
		campos = (String[])in.readObject();
		orden = (String)in.readObject();
		camposOrden = (String[])in.readObject();
		tamPag = (String)in.readObject();
		despliegue = (String)in.readObject();
		try {
			buscador = (String)in.readObject();
		} catch (Exception exx) {
			buscador = "N";
		}
	}
	
	
	public boolean getEmpty() { 
		return (tipoTarea == null) && (estadoTarea == null) &&
		(aplicaciones == null) && (notAplicaciones == null) && (urgencia == null) && (prioridad == null) &&
		(inicioDesde == null) && (inicioHasta == null) && (finDesde == null) &&
		(finHasta == null) && (solicitante == null) && (asunto == null) &&
		(texto == null) && (soloDumboRapido ==null);
	}
	
	public boolean getFormat() { 
		return (formato.equals("T")) && (subtareas.equals("S")) && (alertas.equals("S")) && (despliegue.equals("N")) &&
		(orden.equals("D")) && (camposOrden!=null) && (camposOrden[0].equals(FiltroColumnas.FECHA_CREACION)) &&
		(campos != null) && (campos.length==7) && (campos[0].equals(FiltroColumnas.ESTADO)) && (campos[1].equals(FiltroColumnas.CODIGO)) && 
		(campos[2].equals(FiltroColumnas.APLICACIONDESC)) && (campos[3].equals(FiltroColumnas.ASUNTO)) && (campos[4].equals(FiltroColumnas.USUEMAIL)) && 
		(campos[5].equals(FiltroColumnas.INFEMAIL)) && (campos[6].equals(FiltroColumnas.FECHA_CREACION)) && (tamPag.equals("20") && (buscador.equals("N")));
	}

	public void copiaPersonal(FiltroUsuario f) {
		this.setFormato(f.getFormato());
		this.setSubtareas(f.getSubtareas());
		this.setDespliegue(f.getDespliegue());
		this.setAlertas(f.getAlertas());
		this.setCampos(f.getCampos());
		this.setOrden(f.getOrden());
		this.setCamposOrden(f.getCamposOrden());
		this.setTamPag(f.getTamPag());
		this.setBuscador(f.getBuscador());
	}
	
	public void copiaFiltro(FiltroUsuario f) {
		this.setTipoTarea(f.getTipoTarea());		
		this.setEstadoTarea(f.getEstadoTarea());
		this.setAplicaciones(f.getAplicaciones());
		this.setUrgencia(f.getUrgencia());
		this.setPrioridad(f.getPrioridad());
		this.setInicioDesde(f.getInicioDesde());
		this.setInicioHasta(f.getInicioHasta());
		this.setFinDesde(f.getFinDesde());
		this.setFinHasta(f.getFinHasta());
		this.setSolicitante(f.getSolicitante());
		this.setInformatico(f.getInformatico());
		this.setTexto(f.getTexto());
		this.setAsunto(f.getAsunto());
		this.setCodigo(f.getCodigo());
		this.setSoloDumboRapido(f.getSoloDumboRapido());
	}
	
	public String exportFiltro() {
		try {
			ByteArrayOutputStream bout = new ByteArrayOutputStream();
			ObjectOutputStream out = new ObjectOutputStream(bout);
			writeObject(out);
			return bout.toString();
		} catch (Exception ex) {}
		return null;
	}
	
	public static FiltroUsuario importFiltro(String s) {
		if (s==null) return null;
		try {
			ByteArrayInputStream bin = new ByteArrayInputStream(s.getBytes());
			ObjectInputStream in = new ObjectInputStream(bin);
			FiltroUsuario fu = new FiltroUsuario();
			fu.readObject(in);
			return fu;
		} catch (Exception ex) {}
		return null;
	}
	
	public static int filterCode(String tipo) {
		if (tipo.equals(LISTA_ATENDER)) return 1;
		if (tipo.equals(LISTA_ATENDIDAS)) return 2;
		if (tipo.equals(LISTA_PENDIENTES)) return 3;
		if (tipo.equals(LISTA_RESUELTAS)) return 4;
		if (tipo.equals(LISTA_PROGRAMADAS)) return 5;
		if (tipo.equals(LISTA_PROBLEMAS)) return 6;
		if (tipo.equals(LISTA_GENERICA)) return 7;
		if (tipo.equals(LISTA_GLOBAL_ATENDER)) return 8;
		if (tipo.equals(LISTA_GLOBAL_ATENDIDAS)) return 9;
		if (tipo.equals(LISTA_VINCULADAS)) return 10;
		if (tipo.equals(LISTA_APLICACION)) return 11;
		return 0;
	}

	public static String filterName(int code) {
		if (code==1) return LISTA_ATENDER;
		if (code==2) return LISTA_ATENDIDAS;
		if (code==3) return LISTA_PENDIENTES;
		if (code==4) return LISTA_RESUELTAS;
		if (code==5) return LISTA_PROGRAMADAS;
		if (code==6) return LISTA_PROBLEMAS;
		if (code==7) return LISTA_GENERICA;
		if (code==8) return LISTA_GLOBAL_ATENDER;
		if (code==9) return LISTA_GLOBAL_ATENDIDAS;
		if (code==10) return LISTA_VINCULADAS;
		if (code==11) return LISTA_APLICACION;
		return "";
	}

	public static String [] defaultFilterStatus(String tipo) {
		if (tipo.equals(LISTA_ATENDER)) return new String[]{D7Tareas.ASIGNADA,D7Tareas.EN_ESPERA,D7Tareas.RECHAZADA};
		if (tipo.equals(LISTA_ATENDIDAS)) return new String[]{D7Tareas.FINALIZADA};
		if (tipo.equals(LISTA_PENDIENTES)) return new String[]{D7Tareas.PENDIENTE,D7Tareas.ASIGNADA,D7Tareas.EN_ESPERA,D7Tareas.RECHAZADA};
		if (tipo.equals(LISTA_RESUELTAS)) return new String[]{D7Tareas.FINALIZADA};
		if (tipo.equals(LISTA_PROGRAMADAS)) return new String[]{D7Tareas.PENDIENTE,D7Tareas.ASIGNADA,D7Tareas.EN_ESPERA,D7Tareas.RECHAZADA};
		if (tipo.equals(LISTA_VINCULADAS)) return new String[]{D7Tareas.ASIGNADA,D7Tareas.EN_ESPERA,D7Tareas.RECHAZADA};
		if (tipo.equals(LISTA_PROBLEMAS)) return new String[]{D7Tareas.PENDIENTE,D7Tareas.ASIGNADA,D7Tareas.EN_ESPERA,D7Tareas.RECHAZADA};
		if (tipo.equals(LISTA_GENERICA)) return new String[]{D7Tareas.PENDIENTE};
		if (tipo.equals(LISTA_GLOBAL_ATENDER)) return new String[]{D7Tareas.ASIGNADA,D7Tareas.EN_ESPERA,D7Tareas.RECHAZADA};
		if (tipo.equals(LISTA_GLOBAL_ATENDIDAS)) return new String[]{D7Tareas.FINALIZADA};
		if (tipo.equals(LISTA_APLICACION)) return new String[]{D7Tareas.PENDIENTE};
		return null;
	}

	public static String [] defaultFilterType(String tipo) {
		if (tipo.equals(LISTA_ATENDER)) return new String[]{D7TiposTareas.DUMBO_RAPIDO,D7TiposTareas.INCIDENCIA,D7TiposTareas.PETICION};
		if (tipo.equals(LISTA_ATENDIDAS)) return new String[]{D7TiposTareas.DUMBO_RAPIDO,D7TiposTareas.INCIDENCIA,D7TiposTareas.PETICION};
		if (tipo.equals(LISTA_PENDIENTES)) return new String[]{D7TiposTareas.DUMBO_RAPIDO,D7TiposTareas.INCIDENCIA,D7TiposTareas.PETICION};
		if (tipo.equals(LISTA_RESUELTAS)) return new String[]{D7TiposTareas.DUMBO_RAPIDO,D7TiposTareas.INCIDENCIA,D7TiposTareas.PETICION};
		if (tipo.equals(LISTA_PROGRAMADAS)) return new String[]{D7TiposTareas.PROGRAMADA};
		if (tipo.equals(LISTA_VINCULADAS)) return new String[]{D7TiposTareas.INCIDENCIA,D7TiposTareas.PETICION};
		if (tipo.equals(LISTA_PROBLEMAS)) return new String[]{D7TiposTareas.PROBLEMA};
		if (tipo.equals(LISTA_GENERICA)) return new String[]{D7TiposTareas.INCIDENCIA,D7TiposTareas.PETICION};
		if (tipo.equals(LISTA_GLOBAL_ATENDER)) return new String[]{D7TiposTareas.DUMBO_RAPIDO,D7TiposTareas.INCIDENCIA,D7TiposTareas.PETICION};
		if (tipo.equals(LISTA_GLOBAL_ATENDIDAS)) return new String[]{D7TiposTareas.DUMBO_RAPIDO,D7TiposTareas.INCIDENCIA,D7TiposTareas.PETICION};
		if (tipo.equals(LISTA_APLICACION)) return new String[]{D7TiposTareas.INCIDENCIA,D7TiposTareas.PETICION};
		return null;
	}
	
}
