package dumbo7.utils;

import dumbo7.utils.base.BaseD7AplicacionesInformaticos;

/**
 * This is the object class that relates to the DUMBO.D7_APLICACIONES_INFORMATICOS table.
 * Any customizations belong here.
 */
public class D7AplicacionesInformaticos extends BaseD7AplicacionesInformaticos {

	public static String RESPONSABLE = "Y";
	
/*[CONSTRUCTOR MARKER BEGIN]*/
	public D7AplicacionesInformaticos () {
		super();
	}

	/**
	 * Constructor for primary key
	 */
	public D7AplicacionesInformaticos (
		java.lang.String _ainSisCod,
		java.lang.String _ainAplCod,
		java.lang.String _ainInfCod) {

		super (
			_ainSisCod,
			_ainAplCod,
			_ainInfCod);
	}

	/**
	 * Constructor for required fields
	 */
	public D7AplicacionesInformaticos (
		java.lang.String _ainSisCod,
		java.lang.String _ainAplCod,
		java.lang.String _ainInfCod,
		dumbo7.utils.D7Sistemas _sistema,
		dumbo7.utils.D7Informaticos _informatico,
		dumbo7.utils.D7Aplicaciones _aplicacion) {

		super (
			_ainSisCod,
			_ainAplCod,
			_ainInfCod,
			_sistema,
			_informatico,
			_aplicacion);
	}
/*[CONSTRUCTOR MARKER END]*/
	
	public String getAinInfEmail() {
		if (getDatosInform()==null) return "";
		return getDatosInform().getDatEmail(); 
	}

	public String getAinInfNombre() {
		if (getDatosInform()==null) return "";
		return getDatosInform().getDatApellidos()+", "+getDatosInform().getDatNombre(); 
	}
	
}