package dumbo7.utils;

import dumbo7.utils.base.BaseD7EmpresasInformaticos;

/**
 * This is the object class that relates to the DUMBO.D7_APLICACIONES_INFORMATICOS table.
 * Any customizations belong here.
 */
public class D7EmpresasInformaticos extends BaseD7EmpresasInformaticos {

/*[CONSTRUCTOR MARKER BEGIN]*/
	public D7EmpresasInformaticos () {
		super();
	}

	/**
	 * Constructor for primary key
	 */
	public D7EmpresasInformaticos (
		java.lang.String _einSisCod,
		java.lang.String _einEmpCod,
		java.lang.String _einInfCod) {

		super (
			_einSisCod,
			_einEmpCod,
			_einInfCod);
	}

	/**
	 * Constructor for required fields
	 */
	public D7EmpresasInformaticos (
		java.lang.String _einSisCod,
		java.lang.String _einEmpCod,
		java.lang.String _einInfCod,
		dumbo7.utils.D7Sistemas _sistema,
		dumbo7.utils.D7Informaticos _informatico,
		dumbo7.utils.D7Empresas _empresa) {

		super (
			_einSisCod,
			_einEmpCod,
			_einInfCod,
			_sistema,
			_informatico,
			_empresa);
	}
/*[CONSTRUCTOR MARKER END]*/
	
	public String getEinInfEmail() {
		if (getDatosInform()==null) return "";
		return getDatosInform().getDatEmail(); 
	}

	public String getEinInfNombre() {
		if (getDatosInform()==null) return "";
		return getDatosInform().getDatApellidos()+", "+getDatosInform().getDatNombre(); 
	}
	
}