package dumbo7.utils;

import dumbo7.utils.base.BaseD7Informaticos;

/**
 * This is the object class that relates to the DUMBO.D7_INFORMATICOS table.
 * Any customizations belong here.
 */
public class D7Informaticos extends BaseD7Informaticos {

/*[CONSTRUCTOR MARKER BEGIN]*/
	public D7Informaticos () {
		super();
	}

	/**
	 * Constructor for primary key
	 */
	public D7Informaticos (
		java.lang.String _infSisCod,
		java.lang.String _infCod) {

		super (
			_infSisCod,
			_infCod);
	}

	/**
	 * Constructor for required fields
	 */
	public D7Informaticos (
		java.lang.String _infSisCod,
		java.lang.String _infCod,
		dumbo7.utils.D7Sistemas _sistema,
		dumbo7.utils.D7GruposCostes _grupoCoste,
		dumbo7.utils.D7Secciones _seccion,
		java.lang.String _infEstado,
		java.lang.String _infGcoCod,
		java.lang.String _infSecCod) {

		super (
			_infSisCod,
			_infCod,
			_sistema,
			_grupoCoste,
			_seccion,
			_infEstado,
			_infGcoCod,
			_infSecCod);
	}
/*[CONSTRUCTOR MARKER END]*/
	
	public String getInfEmail() {
		if (getDatosInform()==null) return "";
		return getDatosInform().getDatEmail(); 
	}
	
	public String getInfNombre() {
		if (getDatosInform()==null) return "";
		return getDatosInform().getDatApellidos()+", "+getDatosInform().getDatNombre(); 
	}
	
	public boolean equals(Object obj) {
		return this.getInfCod().equals(((D7DatosPersonales)obj).getDatIdentificador());
	}
	
}