package dumbo7.utils;

import java.util.Calendar;

import dumbo7.solicitudes.GestorSolicitudes;
import dumbo7.utils.base.BaseD7TareasExternas;

/**
 * This is the object class that relates to the DUMBO.D7_TAREAS table.
 * Any customizations belong here.
 */
public class D7TareasExternas extends BaseD7TareasExternas {

/*[CONSTRUCTOR MARKER BEGIN]*/
	public D7TareasExternas () {
		super();
	}

	/**
	 * Constructor for primary key
	 */
	public D7TareasExternas (java.lang.String _tarextId) {

		super (_tarextId);
	}

	/**
	 * Constructor for required fields
	 */
	public D7TareasExternas (
			java.lang.String _tarextId,
			java.lang.String _tarextTitulo,
			java.lang.String _tarextActivo,
			java.lang.String _tarextSisCod,
			java.lang.String _tarextAplCod) {

		super (
			_tarextId,
			_tarextTitulo,
			_tarextActivo,
			_tarextSisCod,
			_tarextAplCod);
	}
/*[CONSTRUCTOR MARKER END]*/
	
	public String getTarextInfEmail() {
		if (getDatosInform()==null) return "";
		return getDatosInform().getDatEmail(); 
	}
	public String getTarextInfNombre() {
		if (getDatosInform()==null) return "Desconocido";
		return getDatosInform().getDatApellidos()+", "+getDatosInform().getDatNombre(); 
	}

	public String getTarextUsuEmail() { 
		if (getDatosUser()==null) {
			if (getTarextUsuCod()!=null && getTarextUsuCod().equals(GestorSolicitudes.IDENTIFICADOR_EXTERNO)) {
				String copi = getTarextEmailCopia();
				if ((copi!=null) && copi.indexOf(",")>0) copi = copi.substring(0,copi.indexOf(","));
				return copi;
			} else return ""; 
		}
		return getDatosUser().getDatEmail(); 
	}
	public String getTarextUsuNombre() { 
		if (getDatosUser()==null) {
			if (getTarextUsuCod()!=null && getTarextUsuCod().equals(GestorSolicitudes.IDENTIFICADOR_EXTERNO)) return "Usuario Externo";
			else return "";
		}
		return getDatosUser().getDatApellidos()+", "+getDatosUser().getDatNombre(); 
	}

	public String getAplicacionDesc() {
		if (getAplicacion()==null) return "";
		return getAplicacion().getAplDescrip();
	}
	
}
