package dumbo7.utils;

import dumbo7.utils.base.BaseD7TareasMovimientos;

/**
 * This is the object class that relates to the DUMBO.D7_TAREAS_MOVIMIENTOS table.
 * Any customizations belong here.
 */
public class D7TareasMovimientos extends BaseD7TareasMovimientos {

	public static final String ASIGNAR_TAREA = "U";
	public static final String ANULAR_TAREA = "A";
	public static final String CAMBIAR_CATEGORIA = "C";
	public static final String CAMBIAR_PRIORIDAD = "D";
	public static final String CAMBIAR_APLICACION = "O";
	public static final String CAMBIAR_FECHA_PLANIF = "L";
	public static final String DEVOLVER_TAREA = "V";
	public static final String FINALIZAR_TAREA = "F";
	public static final String PASAR_INCIDENCIA = "I";
	public static final String PASAR_PETICION = "P";
	public static final String PASAR_WAITING = "W";
	public static final String PASAR_NOWAITING = "N";
	public static final String REASIGNAR = "R";
	public static final String RECHAZAR = "X";
	public static final String MODIFICAR_TAREA = "M";
	public static final String REACTIVAR = "T";
	public static final String RECHAZAR_WAITING = "K";
	public static final String SOLICITAR_TAREA = "S";
	public static final String ASIGNAR_DIRECTA = "UD"; //El usuario pone la aplicacin a la que le quiere asignar la tarea, y la aplicacin asigna informtico
	public static final String ASIGNAR_DIRECTA_COMPLETA = "UI"; //El usuario pone la aplicacin a la que le quiere asignar la tarea y el informtico 
	public static final String ASIGNAR_GENERICA_DIRECTA = "UGD";//De cola genrica a informatico
	public static final String ASIGNAR_GENERICA_APLICACIONES = "UGA";//De cola genrica a cola de aplicaciones	
	public static final String ASIGNAR_APLICACIONES_DIRECTA = "UAD"; //De cola de aplicaciones a informtico	
	public static final String REASIGNAR_DIRECTA = "RD"; //El informtico pone la aplicacin a la que le quiere reasignar la tarea, y la aplicacin asigna informtico
	public static final String REASIGNAR_DIRECTA_COMPLETA = "RI"; //El informtico pone la aplicacin a la que le quiere reasignar la tarea y el informtico 
	public static final String REASIGNAR_APLICACIONES = "RA"; //De informtico a cola de problemas
	public static final String REASIGNAR_DIRECTA_GENERICA = "RDG"; //De informtico a cola genrica
	public static final String REASIGNAR_APLICACIONES_GENERICA = "RAG"; //De cola de aplicaciones a cola genrica 
	public static final String CAMBIAR_SISTEMA = "XS"; //Cambio de sistema
	
	
	/*[CONSTRUCTOR MARKER BEGIN]*/
	public D7TareasMovimientos () {
		super();
	}

	/**
	 * Constructor for primary key
	 */
	public D7TareasMovimientos (
		java.lang.String _tmoSisCod,
		java.lang.Integer _tmoTarCod,
		java.lang.Integer _tmoCod) {

		super (
			_tmoSisCod,
			_tmoTarCod,
			_tmoCod);
	}

	/**
	 * Constructor for required fields
	 */
	public D7TareasMovimientos (
		java.lang.String _tmoSisCod,
		java.lang.Integer _tmoTarCod,
		java.lang.Integer _tmoCod,
		dumbo7.utils.D7Sistemas _sistema,
		java.lang.String _tmoDescripMov,
		java.lang.String _tmoTipoMov,
		java.util.Date _tmoFechaMov) {

		super (
			_tmoSisCod,
			_tmoTarCod,
			_tmoCod,
			_sistema,
			_tmoDescripMov,
			_tmoTipoMov,
			_tmoFechaMov);
	}
/*[CONSTRUCTOR MARKER END]*/
	
	public String getTmoInfEmail() {
		if (getDatosInform()==null) return "";
		return getDatosInform().getDatEmail(); 
	}
	
}