package dumbo7.utils;

import dumbo7.utils.base.BaseD7ZonasInformaticos;

/**
 * This is the object class that relates to the DUMBO.D7_ZONAS_INFORMATICOS table.
 * Any customizations belong here.
 */
public class D7ZonasInformaticos extends BaseD7ZonasInformaticos {

/*[CONSTRUCTOR MARKER BEGIN]*/
	public D7ZonasInformaticos () {
		super();
	}

	/**
	 * Constructor for primary key
	 */
	public D7ZonasInformaticos (
		java.lang.String zoninfSisCod,
		java.lang.Integer zoninfZonCodigo,
		java.lang.String zoninfInfCod){

		super (
			zoninfSisCod,
			zoninfZonCodigo,
			zoninfInfCod);
	}

	/**
	 * Constructor for required fields
	 */
	public D7ZonasInformaticos (
		java.lang.String zoninfSisCod,
		java.lang.Integer zoninfZonCodigo,
		java.lang.String zoninfInfCod,
		dumbo7.utils.D7Sistemas _sistema,
		dumbo7.utils.D7Informaticos informatico,
		dumbo7.utils.D7Zonas zona) {

		super (
			zoninfSisCod,
			zoninfZonCodigo,
			zoninfInfCod,
			_sistema,
			informatico,
			zona);
	}
/*[CONSTRUCTOR MARKER END]*/
	
	public String getZinfInfEmail() {
		if (getDatosInform()==null) return "";
		return getDatosInform().getDatEmail(); 
	}

	public String getZinInfNombre() {
		if (getDatosInform()==null) return "";
		return getDatosInform().getDatApellidos()+", "+getDatosInform().getDatNombre(); 
	}
}