/*
 * Created on 18-jul-2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package dumbo7.utils.ldap;

import java.util.*; 
import dumbo7.utils.*;
import atica.frameweb.utils.*;
import javax.naming.*; 
import javax.naming.directory.*; 
import org.hibernate.*;

/**
 * @author Universidad de Murcia - ATICA
 *
 */
public class LDAPUtil {
	
	public static String LDAP_PROTOCOL = "";
	public static String LDAP_SERVER = "";
	public static String LDAP_PORT = "";
	public static Vector LDAP_CONTEXT = null;
	public static String LDAP_PWD = "";
	public static String LDAP_USER = "";
	public static String LDAP_MAIL_ATTRIBUTE = "";
	public static String LDAP_NAME_ATTRIBUTE = "";
	public static String LDAP_DNI_ATTRIBUTE = "";
	public static String LDAP_AUTH_ATTRIBUTE = "";
	public static Vector dominios = new Vector();

	static {
		// Carga de las propiedades necesarias para conexin LDAP.
		try {
			LDAPUtil lu = new LDAPUtil();
			java.net.URL file = lu.getClass().getResource("ldap.properties");
			Properties p = new Properties();
			p.load(file.openStream());
			
			LDAP_PROTOCOL = p.getProperty("LDAP_PROTOCOL");
			LDAP_SERVER = p.getProperty("LDAP_SERVER");
			LDAP_PORT = p.getProperty("LDAP_PORT");
			LDAP_PWD = p.getProperty("LDAP_PWD");
			LDAP_USER = p.getProperty("LDAP_USER");
			LDAP_MAIL_ATTRIBUTE = p.getProperty("LDAP_MAIL_ATTRIBUTE");
			LDAP_NAME_ATTRIBUTE = p.getProperty("LDAP_NAME_ATTRIBUTE");
			LDAP_DNI_ATTRIBUTE = p.getProperty("LDAP_DNI_ATTRIBUTE");
			LDAP_AUTH_ATTRIBUTE = p.getProperty("LDAP_AUTH_ATTRIBUTE");

			dominios.addElement(p.getProperty("LDAP_DOMAIN_1"));
			
			Vector contextos = new Vector();
			Enumeration en = p.propertyNames();
			while (en.hasMoreElements()) {
				String nameId = (String) en.nextElement();
				if (nameId.startsWith("LDAP_CONTEXT"))
					contextos.addElement(p.getProperty(nameId));
				if (nameId.startsWith("LDAP_DOMAIN")) {
					if (!dominios.contains(p.getProperty(nameId))) dominios.addElement(p.getProperty(nameId));
				}
			}
			LDAP_CONTEXT = contextos;
			
		} catch (Exception ex) {
			System.out.println("Load LDAP Properties: "+ex);
		}
	}
	
	public static String getDominio() {
		//return LDAP_SERVER.substring(LDAP_SERVER.indexOf(".")+1);
		return ((String)dominios.get(0)).substring(1);
	}
	
	private static Hashtable getDefaultEnvironment(int n) {
        // Set up the environment for creating the initial context 
        Hashtable env = new Hashtable();
        // Entramos Con el Usuario de Consulta !!
        if (LDAP_USER.equals("")) {
        	// Conecto como annimo
        	env.put(Context.SECURITY_AUTHENTICATION,"none");
        } else {
        	// Conecto con usuario genrico
            env.put(Context.SECURITY_AUTHENTICATION,"simple");
            env.put(Context.SECURITY_PRINCIPAL,LDAP_USER);
            env.put(Context.SECURITY_CREDENTIALS,LDAP_PWD);
        }
        if (LDAP_PROTOCOL.equals("ldaps")) {
        	env.put(Context.SECURITY_PROTOCOL, "ssl");
            env.put("java.naming.ldap.factory.socket", "dumbo7.utils.ldap.ssl.LDAPSocketFactory");
        }
        env.put(Context.INITIAL_CONTEXT_FACTORY,"com.sun.jndi.ldap.LdapCtxFactory"); 
        env.put(Context.PROVIDER_URL, "ldap://"+LDAP_SERVER+":"+LDAP_PORT+"/"+LDAP_CONTEXT.elementAt(n));
        return env;
	}
	
	
	private static DirContext getContext(int n) {
		DirContext ctx = null; 
        try { 
            // Connect to server 
            ctx = new InitialDirContext(getDefaultEnvironment(n)); 
        } catch (Exception ex) {
        	System.out.println("getContext: "+ex);
        }
        return ctx;
	}

	private static Hashtable getUserEnvironment(int n,String dn,String pwd) {
        Hashtable env = new Hashtable();
        // Entramos Autenticandonos !!
        if (LDAP_PROTOCOL.equals("ldaps")) {
        	env.put(Context.SECURITY_PROTOCOL, "ssl");
            env.put("java.naming.ldap.factory.socket", "dumbo7.utils.ldap.ssl.LDAPSocketFactory");
        }
        env.put(Context.SECURITY_AUTHENTICATION,"simple");
        env.put(Context.SECURITY_PRINCIPAL,dn);
        env.put(Context.SECURITY_CREDENTIALS,pwd);
        env.put(Context.INITIAL_CONTEXT_FACTORY,"com.sun.jndi.ldap.LdapCtxFactory"); 
        env.put(Context.PROVIDER_URL, "ldap://"+LDAP_SERVER+":"+LDAP_PORT+"/"+dn);
        return env;
	}
	
	private static DirContext getUserContext(String user,String pwd) throws Exception {
		DirContext ctx = null; 
        try { 
            // Me conecto y busco al usuario en todos los contextos !!
        	String miDn = "";
        	int k = 0; boolean notfound = true;
        	while (k<LDAP_CONTEXT.size() && notfound) {
        		DirContext dc = getContext(k);
        		Attributes matchAttrs = new BasicAttributes(true); // ignore attribute name case
        		matchAttrs.put(new BasicAttribute(LDAP_AUTH_ATTRIBUTE,user));
        		// Search for objects with those matching attributes
        		NamingEnumeration answer = dc.search("", matchAttrs);
        		// Si funciona el usuario existe
        		while (answer.hasMore()) {
        			// Consigo su dn.
        			NameClassPair item = (NameClassPair)answer.next();
        			miDn = item.getName();
        			notfound = false;
        		}
        		if (notfound) k++;
        		try { if (dc!=null) dc.close(); } catch (Exception ex) {}
        	}
            // Set up the environment for creating the initial context 
            if (!notfound) ctx = new InitialDirContext(getUserEnvironment(k,miDn+","+LDAP_CONTEXT.elementAt(k),pwd));
            else throw new Exception("User Not Found.");
        } catch (Exception ex) {
        	throw ex;
        }
        return ctx;
	}
	
	/**
	 * Recibe un usuario y un password y lo valida contra LDAP !!
	 * @param user El usuario de correo, user@um.es, user@alu.um.es.
	 * @param pwd El password de correo.
	 * @return Retorna true si la autenticacin es correcta.
	 */
	public static boolean autentica(String user,String pwd) {
		DirContext ctx = null;
		try {
			ctx = getUserContext(user,pwd);
			return true;
        } catch (Exception e) {
        	// Si hay un error
        	System.out.println("Autentica: "+e);        	
        	return false;
        } finally {
        	try { if (ctx!=null) ctx.close(); } catch (Exception ex) {}
        }
	}
	
	public static Vector findUsersByMail(String value) {
		DirContext ctx = null; 
		Vector completeUsers = new Vector();
        try {
        	int k = 0;
        	while (k<LDAP_CONTEXT.size()) {
	        	ctx = getContext(k);
	            SearchControls ctrl = new SearchControls();
	            ctrl.setSearchScope(SearchControls.SUBTREE_SCOPE);
	        	// Search for objects with those matching attributes
	        	NamingEnumeration answer = ctx.search("","("+LDAP_MAIL_ATTRIBUTE+"="+value+")",ctrl);
	        	// Si funciona la bsqueda todo es correcto.
	        	if (answer.hasMore()) {
		        	Vector v = getUsersFrom(answer);
		        	Enumeration en = v.elements();
		        	while (en.hasMoreElements()) completeUsers.addElement(en.nextElement());
	        	}
	        	try { if (ctx!=null) ctx.close(); } catch (Exception ex) {}
	        	k++;
        	}
        	return completeUsers;
        } catch (Exception e) {
        	// Si hay un error
        	return null;
        } finally {
        	try { if (ctx!=null) ctx.close(); } catch (Exception ex) {}
        }
	}

	public static Vector findUsersByName(String value) {
		DirContext ctx = null;
		Vector completeUsers = new Vector();
        try {
        	int k = 0;
        	while (k<LDAP_CONTEXT.size()) {
	        	ctx = getContext(k);
	            SearchControls ctrl = new SearchControls();
	            ctrl.setSearchScope(SearchControls.SUBTREE_SCOPE);
	        	// Search for objects with those matching attributes
	        	NamingEnumeration answer = ctx.search("","("+LDAP_NAME_ATTRIBUTE+"="+value+")",ctrl);
	        	// Si funciona la bsqueda todo es correcto.
	        	if (answer.hasMore()) {
		        	Vector v = getUsersFrom(answer);
		        	Enumeration en = v.elements();
		        	while (en.hasMoreElements()) completeUsers.addElement(en.nextElement());
	        	}
	        	try { if (ctx!=null) ctx.close(); } catch (Exception ex) {}
	        	k++;
        	}
	        return completeUsers;	
        } catch (Exception e) {
        	// Si hay un error
        	return null;
        } finally {
        	try { if (ctx!=null) ctx.close(); } catch (Exception ex) {}
        }
	}
	
	public static LDAPUser findUserByMail(String value) {
		DirContext ctx = null;
        try { 
        	int k = 0;
        	while (k<LDAP_CONTEXT.size()) {
	        	ctx = getContext(k);
	        	Attributes matchAttrs = new BasicAttributes(true); // ignore attribute name case
	        	matchAttrs.put(new BasicAttribute(LDAP_MAIL_ATTRIBUTE,value));
	        	// Search for objects with those matching attributes
	        	NamingEnumeration answer = ctx.search("", matchAttrs);
	        	if (answer.hasMore()) return (LDAPUser)getUsersFrom(answer).elementAt(0);
	        	try { if (ctx!=null) ctx.close(); } catch (Exception ex) {}
	        	k++;
        	}
        	return null;
        } catch (Exception e) {
        	// Si hay un error
        	return null;
        } finally {
        	try { if (ctx!=null) ctx.close(); } catch (Exception ex) {}
        }
	}

	public static LDAPUser findUserByName(String value) {
		DirContext ctx = null;
        try { 

        	int k = 0;
        	while (k<LDAP_CONTEXT.size()) {
	        	ctx = getContext(k);
	        	Attributes matchAttrs = new BasicAttributes(true); // ignore attribute name case
	        	matchAttrs.put(new BasicAttribute(LDAP_NAME_ATTRIBUTE,value));
	        	// Search for objects with those matching attributes
	        	NamingEnumeration answer = ctx.search("", matchAttrs);
	        	if (answer.hasMore()) return (LDAPUser)getUsersFrom(answer).elementAt(0);
	        	try { if (ctx!=null) ctx.close(); } catch (Exception ex) {}
	        	k++;
        	}
        	return null;
        } catch (Exception e) {
        	// Si hay un error
        	return null;
        } finally {
        	try { if (ctx!=null) ctx.close(); } catch (Exception ex) {}
        }
	}

	public static LDAPUser findUserByDni(String value) {
		DirContext ctx = null;
        try { 

        	int k = 0;
        	while (k<LDAP_CONTEXT.size()) {
	        	ctx = getContext(k);
	        	Attributes matchAttrs = new BasicAttributes(true); // ignore attribute name case
	        	matchAttrs.put(new BasicAttribute(LDAP_DNI_ATTRIBUTE,value));
	        	// Search for objects with those matching attributes
	        	NamingEnumeration answer = ctx.search("", matchAttrs);
	        	if (answer.hasMore()) return (LDAPUser)getUsersFrom(answer).elementAt(0);
	        	try { if (ctx!=null) ctx.close(); } catch (Exception ex) {}
	        	k++;
        	}
        	return null;
        } catch (Exception e) {
        	// Si hay un error
        	return null;
        } finally {
        	try { if (ctx!=null) ctx.close(); } catch (Exception ex) {}
        }
	}
	
	private static Vector getUsersFrom(NamingEnumeration answer) {
		Vector users = new Vector();
		try {
			while (answer.hasMore()) {
				LDAPUser luser = new LDAPUser();
    			SearchResult sr = (SearchResult)answer.next();
    			Attributes attr = sr.getAttributes();
    			try {
    				if (attr==null) continue;
    				for (NamingEnumeration enume = attr.getAll(); enume.hasMore();) {
    					Attribute attrib = (Attribute)enume.next();
   						for (NamingEnumeration e = attrib.getAll();e.hasMore();)
   							luser.setAttribute(attrib.getID(),""+e.next());
    				}
    				users.addElement(luser);
    			} catch (NamingException e) { e.printStackTrace(); }
			}
    	} catch (Exception ex) {
    		// Puede tener lmite en consultas
    	}
    	return users;
	}

	private static LDAPUser getUserFrom(DirContext ctx) {
		LDAPUser luser = new LDAPUser();
		try {
   			Attributes attr = ctx.getAttributes("");
   			try {
				if (attr==null) return null;
				for (NamingEnumeration enume = attr.getAll(); enume.hasMore();) {
					Attribute attrib = (Attribute)enume.next();
					for (NamingEnumeration e = attrib.getAll();e.hasMore();)
						luser.setAttribute(attrib.getID(),""+e.next());
				}
			} catch (NamingException e) { e.printStackTrace(); }
    	} catch (Exception ex) {
    		// Error Obteniendo Datos Usuario
    	}
    	return luser;
	}

	public static LDAPUser findUserData(String login,String pwd) {
		DirContext ctx = null;
		LDAPUser user = new LDAPUser();
        try {
        	ctx = getUserContext(login,pwd);
        	return getUserFrom(ctx);
        } catch (Exception e) {
        	// Si hay un error
        	return null;
        } finally {
        	try { if (ctx!=null) ctx.close(); } catch (Exception ex) {}
        }
	}
	
	public static boolean isInternalDomain(String domain) {
		return dominios.contains(domain);
	}
	
}
