<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet version="1.0" 
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:fo="http://www.w3.org/1999/XSL/Format">

<xsl:template name="pageWidth">
<xsl:param name="lon"/>
<xsl:choose><xsl:when test="number($lon)>18">29.7</xsl:when><xsl:otherwise>21</xsl:otherwise></xsl:choose>
</xsl:template>

<xsl:template name="pageHeight">
<xsl:param name="lon"/>
<xsl:choose><xsl:when test="number($lon)>18">21</xsl:when><xsl:otherwise>29.7</xsl:otherwise></xsl:choose>
</xsl:template>

<xsl:template name="calculateWidth">
<xsl:param name="filtro"/>
<xsl:param name="posic" select="'1'"/>
<xsl:variable name="mio"><xsl:call-template name="columnWidth"><xsl:with-param name="columna" select="$filtro/CAMPOS[position()=number($posic)]/."/></xsl:call-template></xsl:variable>
<xsl:variable name="resto">
<xsl:choose>
<xsl:when test="count($filtro/CAMPOS)>=(number($posic)+1)"><xsl:call-template name="calculateWidth"><xsl:with-param name="filtro" select="$filtro"/><xsl:with-param name="posic" select="number($posic)+1"/></xsl:call-template></xsl:when>	
<xsl:otherwise>0</xsl:otherwise>
</xsl:choose>
</xsl:variable>
<xsl:value-of select="number($mio)+number($resto)"/>
</xsl:template>

<xsl:template name="isLongColumn">
<xsl:param name="colum"/>
<xsl:choose><xsl:when test="$colum='ASUNTO' or $colum='DESCRIPCION' or $colum='UBICACION' or $colum='DESCRIPCION_SEGUIMIENTO'">S</xsl:when><xsl:otherwise>N</xsl:otherwise></xsl:choose>
</xsl:template>

<xsl:template name="hasLongColumns">
<xsl:param name="campos"/>
<xsl:choose><xsl:when test="count($campos[CAMPOS='ASUNTO' or CAMPOS='DESCRIPCION' or CAMPOS='UBICACION' or CAMPOS='DESCRIPCION_SEGUIMIENTO'])>0">S</xsl:when><xsl:otherwise>N</xsl:otherwise></xsl:choose>
</xsl:template>

<xsl:template name="columnWidth">
<xsl:param name="columna"/>
<xsl:if test="$columna='ESTADO'">0.8</xsl:if>
<xsl:if test="$columna='CODIGO'">1.3</xsl:if>
<xsl:if test="$columna='APLICACIONDESC'">4</xsl:if>
<xsl:if test="$columna='ASUNTO'">6</xsl:if>
<xsl:if test="$columna='USUEMAIL'">4</xsl:if>
<xsl:if test="$columna='INFEMAIL'">4</xsl:if>
<xsl:if test="$columna='FECHA_CREACION'">4</xsl:if>	
<xsl:if test="$columna='URGENCIA'">1</xsl:if>
<xsl:if test="$columna='CATEGORIA'">2</xsl:if>
<xsl:if test="$columna='PRIORIDAD'">2</xsl:if>
<xsl:if test="$columna='EMAIL_COPIA'">4</xsl:if>
<xsl:if test="$columna='DESCRIPCION'">7</xsl:if>
<xsl:if test="$columna='FECHA_MAX_RESOLUCION'">3</xsl:if>
<xsl:if test="$columna='UBICACION'">4</xsl:if>
<xsl:if test="$columna='FECHA_FIN'">3</xsl:if>
<xsl:if test="$columna='PLANIFICACION'">3</xsl:if>
<xsl:if test="$columna='DESCRIPCION_SEGUIMIENTO'">6</xsl:if>
<xsl:if test="$columna='HORAS_RESOLUCION'">2</xsl:if>
<xsl:if test="$columna='COSTE_ECONOMICO'">2</xsl:if>
<xsl:if test="$columna='COSTE_MATERIALES'">2</xsl:if>
<xsl:if test="$columna='FECHA_ALERTA'">3</xsl:if>
</xsl:template>

<xsl:template name="printTableHeader">
<xsl:param name="campos"/>
<fo:table-header>
  <fo:table-row>
	<fo:table-cell border-width="0pt" border-style="solid" padding="0pt">
		<fo:block font-size="10pt"
			  font-family="sans-serif"
			  line-height="10pt"
			  text-align="center" background-color="lightgray">
			  <fo:inline font-weight="bold">N</fo:inline>
		</fo:block>
	</fo:table-cell>
	<xsl:for-each select="$campos/CAMPOS">
		<xsl:variable name="co" select="."/>
		<xsl:variable name="anc"><xsl:call-template name="columnWidth"><xsl:with-param name="columna" select="$co"/></xsl:call-template></xsl:variable>
		<xsl:call-template name="printColumnName">
			<xsl:with-param name="columna" select="$co"/>
			<xsl:with-param name="nombre" select="$campos/CAMPOSFILTRO[key=$co]/value"/>
			<xsl:with-param name="ancho" select="$anc"/>
		</xsl:call-template>
	</xsl:for-each>
	</fo:table-row>
</fo:table-header>
</xsl:template>

<xsl:template name="printColumnName">
<xsl:param name="columna"/>
<xsl:param name="nombre"/>
<xsl:param name="ancho"/>
<xsl:variable name="isLC"><xsl:call-template name="isLongColumn"><xsl:with-param name="colum" select="$columna"/></xsl:call-template></xsl:variable>
<xsl:if test="$isLC='N'">
<fo:table-cell border-width="0pt" border-style="solid" padding="2pt">
	<fo:block font-size="10pt"
		  font-family="sans-serif"
		  line-height="10pt"
		  text-align="center" background-color="lightgray">
		<fo:inline font-weight="bold"><xsl:call-template name="columnName"><xsl:with-param name="nombre" select="$nombre"/><xsl:with-param name="ancho" select="$ancho"/></xsl:call-template></fo:inline>
	</fo:block>
</fo:table-cell>
</xsl:if>
</xsl:template>

<xsl:template name="columnName">
<xsl:param name="nombre"/>
<xsl:param name="ancho"/>
<xsl:variable name="chars" select="round(number($ancho)*5)"/>
<xsl:choose>
<xsl:when test="number($chars)>=string-length($nombre)"><xsl:value-of select="$nombre"/></xsl:when>
<xsl:otherwise><xsl:value-of select="concat(substring($nombre,0,$chars),'.')"/></xsl:otherwise>
</xsl:choose>
</xsl:template>

<xsl:template name="definePrintColumn">
<xsl:param name="columna"/>
<xsl:variable name="isLC"><xsl:call-template name="isLongColumn"><xsl:with-param name="colum" select="$columna"/></xsl:call-template></xsl:variable>
<xsl:if test="$isLC='N'">
   <!--fo:table-column><xsl:attribute name="column-width"><xsl:call-template name="columnWidth"><xsl:with-param name="columna" select="$columna"/></xsl:call-template>cm</xsl:attribute></fo:table-column-->
   <fo:table-column/>
</xsl:if>   
</xsl:template>

<xsl:template name="printRow">
<xsl:param name="row"/>
<xsl:param name="item"/>
<xsl:param name="numitem"/>
<xsl:param name="campos"/>
<fo:table-row>
	<xsl:if test="($item mod 2)=0"><xsl:attribute name="background-color">lightgray</xsl:attribute></xsl:if>
	<fo:table-cell border-width="0pt" border-style="solid" padding="2pt">
		<fo:block font-size="10pt"
			  font-family="sans-serif"
			  line-height="10pt"
			  text-align="center">
			  <fo:inline font-weight="bold"><xsl:value-of select="$numitem"/></fo:inline>
		</fo:block>
	</fo:table-cell>
	<xsl:for-each select="$campos/CAMPOS">
		<xsl:variable name="mycol" select="."/>
		<xsl:variable name="isLC"><xsl:call-template name="isLongColumn"><xsl:with-param name="colum" select="$mycol"/></xsl:call-template></xsl:variable>
		<xsl:if test="$isLC='N'">
		<fo:table-cell border-width="0pt" border-style="solid" padding="2pt">
			<fo:block font-size="10pt"
				  font-family="sans-serif"
				  line-height="10pt"
				  text-align="center">
			  <xsl:call-template name="printColumn">
				<xsl:with-param name="columna" select="."/>
				<xsl:with-param name="fila" select="$row"/>
			  </xsl:call-template>
			</fo:block>
		</fo:table-cell>
		</xsl:if>
	</xsl:for-each>
</fo:table-row>
<xsl:variable name="hasLC"><xsl:call-template name="hasLongColumns"><xsl:with-param name="campos" select="$campos"/></xsl:call-template></xsl:variable>
<xsl:if test="$hasLC='S'">
<xsl:variable name="cols" select="count($campos/CAMPOS)"/>
<xsl:for-each select="$campos/CAMPOS">
	<xsl:variable name="mycol" select="."/>
	<xsl:variable name="isLC"><xsl:call-template name="isLongColumn"><xsl:with-param name="colum" select="$mycol"/></xsl:call-template></xsl:variable>
	<xsl:if test="$isLC='S'">
	<fo:table-row><xsl:if test="($item mod 2)=0"><xsl:attribute name="background-color">lightgray</xsl:attribute></xsl:if>
		<fo:table-cell border-width="0pt" border-style="solid" padding="2pt">
			<fo:block font-size="10pt"
				  font-family="sans-serif"
				  line-height="10pt"
				  text-align="center">
				  &#160;
			</fo:block>
		</fo:table-cell>
		<fo:table-cell border-width="0pt" border-style="solid" padding="2pt" number-columns-spanned="{number($cols)-1}">
		  <xsl:call-template name="printColumn">
			<xsl:with-param name="prefijo"><xsl:value-of select="$campos/CAMPOSFILTRO[key=$mycol]/value"/>:</xsl:with-param>
			<xsl:with-param name="columna" select="."/>
			<xsl:with-param name="fila" select="$row"/>
		  </xsl:call-template>
		</fo:table-cell>
	</fo:table-row>
	</xsl:if>
</xsl:for-each>
</xsl:if>
</xsl:template>

<xsl:template name="printColumn">
<xsl:param name="prefijo" select="''"/>
<xsl:param name="columna"/>
<xsl:param name="fila"/>
<xsl:param name="guion"/>
<xsl:variable name="ancho"><xsl:call-template name="columnWidth"><xsl:with-param name="columna" select="$columna"/></xsl:call-template></xsl:variable>
<xsl:variable name="chars" select="round(number($ancho)*5)"/>
<xsl:if test="$columna='ESTADO'">
	<fo:block font-size="10pt"
			  font-family="sans-serif"
			  line-height="10pt"
			  text-align="center">
		  <xsl:attribute name="padding-left"><xsl:value-of select="string-length($guion) div 4"/>cm</xsl:attribute>
		  <fo:external-graphic src="/www/dumbo/web_dumbo/graficos/iconos/{$fila/@ESTADO}.gif" width="0.7cm" height="0.7cm"/>
	</fo:block>
</xsl:if>
<xsl:if test="$columna='CODIGO'">
	<fo:block font-size="10pt"
			  font-family="sans-serif"
			  line-height="10pt"
			  text-align="center">
		  <xsl:attribute name="padding-left"><xsl:value-of select="string-length($guion) div 4"/>cm</xsl:attribute>
			<xsl:choose>
				<xsl:when test="number($chars)>=string-length($fila/@CODIGO)"><xsl:value-of select="$fila/@CODIGO"/></xsl:when>
				<xsl:otherwise><xsl:value-of select="concat(substring($fila/@CODIGO,0,$chars),'...')"/></xsl:otherwise>
			</xsl:choose>
	</fo:block>
</xsl:if>
<xsl:if test="$columna='APLICACIONDESC'">
	<fo:block font-size="10pt"
			  font-family="sans-serif"
			  line-height="10pt"
			  text-align="left">
		  <xsl:attribute name="padding-left"><xsl:value-of select="string-length($guion) div 4"/>cm</xsl:attribute>
		  <xsl:value-of select="$fila/@APLICACIONDESC"/>
	</fo:block>
</xsl:if>
<xsl:if test="$columna='ASUNTO'">
	<fo:block font-size="10pt"
			  font-family="sans-serif"
			  line-height="10pt"
			  text-align="left">
		  <xsl:attribute name="padding-left"><xsl:value-of select="string-length($guion) div 4"/>cm</xsl:attribute>
		  <fo:inline font-weight="bold"><xsl:value-of select="$prefijo"/></fo:inline>&#160;
		  <xsl:value-of select="$fila/@ASUNTO"/>
	</fo:block>
</xsl:if>
<xsl:if test="$columna='USUEMAIL'">
	<fo:block font-size="10pt"
			  font-family="sans-serif"
			  line-height="10pt"
			  text-align="center">
		  <xsl:attribute name="padding-left"><xsl:value-of select="string-length($guion) div 4"/>cm</xsl:attribute>
			<xsl:choose>
				<xsl:when test="number($chars)>=string-length($fila/@USUEMAIL)"><xsl:value-of select="$fila/@USUEMAIL"/></xsl:when>
				<xsl:otherwise><xsl:value-of select="concat(substring($fila/@USUEMAIL,0,$chars),'...')"/></xsl:otherwise>
			</xsl:choose>
	</fo:block>
</xsl:if>
<xsl:if test="$columna='INFEMAIL'">
	<fo:block font-size="10pt"
			  font-family="sans-serif"
			  line-height="10pt"
			  text-align="center">
		  <xsl:attribute name="padding-left"><xsl:value-of select="string-length($guion) div 4"/>cm</xsl:attribute>
		  <xsl:variable name="nombre"><xsl:choose><xsl:when test="string-length($fila/@INFORMATICO)=0">Por Asignar</xsl:when><xsl:otherwise><xsl:value-of select="$fila/@INFEMAIL"/></xsl:otherwise></xsl:choose></xsl:variable>
			<xsl:choose>
				<xsl:when test="number($chars)>=string-length($nombre)"><xsl:value-of select="$nombre"/></xsl:when>
				<xsl:otherwise><xsl:value-of select="concat(substring($nombre,0,$chars),'...')"/></xsl:otherwise>
			</xsl:choose>
	</fo:block>
</xsl:if>
<xsl:if test="$columna='FECHA_CREACION'">
	<fo:block font-size="10pt"
			  font-family="sans-serif"
			  line-height="10pt"
			  text-align="center">
		  <xsl:attribute name="padding-left"><xsl:value-of select="string-length($guion) div 4"/>cm</xsl:attribute>
		  <xsl:variable name="nombre"><xsl:call-template name="date2String2"><xsl:with-param name="fecha"><xsl:value-of select="$fila/@FECHA_CREACION"/></xsl:with-param></xsl:call-template></xsl:variable>
			<xsl:choose>
				<xsl:when test="number($chars)>=string-length($nombre)"><xsl:value-of select="$nombre"/></xsl:when>
				<xsl:otherwise><xsl:value-of select="concat(substring($nombre,0,$chars),'...')"/></xsl:otherwise>
			</xsl:choose>
	</fo:block>
</xsl:if>	
<xsl:if test="$columna='URGENCIA'">
	<fo:block font-size="10pt"
			  font-family="sans-serif"
			  line-height="10pt"
			  text-align="center">
		  <xsl:attribute name="padding-left"><xsl:value-of select="string-length($guion) div 4"/>cm</xsl:attribute>
		  <xsl:variable name="nombre"><xsl:choose><xsl:when test="$fila/@URGENCIA='U'">Urgente</xsl:when><xsl:otherwise>No Urgente</xsl:otherwise></xsl:choose></xsl:variable>
			<xsl:choose>
				<xsl:when test="number($chars)>=string-length($nombre)"><xsl:value-of select="$nombre"/></xsl:when>
				<xsl:otherwise><xsl:value-of select="concat(substring($nombre,0,$chars),'...')"/></xsl:otherwise>
			</xsl:choose>
	</fo:block>
</xsl:if>
<xsl:if test="$columna='CATEGORIA'">
	<fo:block font-size="10pt"
			  font-family="sans-serif"
			  line-height="10pt"
			  text-align="center">
		  <xsl:attribute name="padding-left"><xsl:value-of select="string-length($guion) div 4"/>cm</xsl:attribute>
			<xsl:choose>
				<xsl:when test="number($chars)>=string-length($fila/@CATEGORIADESC)"><xsl:value-of select="$fila/@CATEGORIADESC"/></xsl:when>
				<xsl:otherwise><xsl:value-of select="concat(substring($fila/@CATEGORIADESC,0,$chars),'...')"/></xsl:otherwise>
			</xsl:choose>
	</fo:block>
</xsl:if>
<xsl:if test="$columna='PRIORIDAD'">
	<fo:block font-size="10pt"
			  font-family="sans-serif"
			  line-height="10pt"
			  text-align="center">
		  <xsl:attribute name="padding-left"><xsl:value-of select="string-length($guion) div 4"/>cm</xsl:attribute>
			<xsl:choose>
				<xsl:when test="number($chars)>=string-length($fila/@PRIORIDADDESC)"><xsl:value-of select="$fila/@PRIORIDADDESC"/></xsl:when>
				<xsl:otherwise><xsl:value-of select="concat(substring($fila/@PRIORIDADDESC,0,$chars),'...')"/></xsl:otherwise>
			</xsl:choose>
	</fo:block>
</xsl:if>
<xsl:if test="$columna='EMAIL_COPIA'">
	<fo:block font-size="10pt"
			  font-family="sans-serif"
			  line-height="10pt"
			  text-align="center">
		  <xsl:attribute name="padding-left"><xsl:value-of select="string-length($guion) div 4"/>cm</xsl:attribute>
		  <xsl:variable name="nombre"><xsl:choose><xsl:when test="string-length($fila/@EMAIL_COPIA)>30"><xsl:value-of select="substring($fila/@EMAIL_COPIA,1,30)"/>...</xsl:when><xsl:otherwise><xsl:value-of select="$fila/@EMAIL_COPIA"/></xsl:otherwise></xsl:choose></xsl:variable>
			<xsl:choose>
				<xsl:when test="number($chars)>=string-length($nombre)"><xsl:value-of select="$nombre"/></xsl:when>
				<xsl:otherwise><xsl:value-of select="concat(substring($nombre,0,$chars),'...')"/></xsl:otherwise>
			</xsl:choose>
	</fo:block>
</xsl:if>
<xsl:if test="$columna='DESCRIPCION'">
	<fo:block font-size="10pt"
			  font-family="sans-serif"
			  line-height="10pt"
			  text-align="left" white-space-treatment="preserve">
		  <xsl:attribute name="padding-left"><xsl:value-of select="string-length($guion) div 4"/>cm</xsl:attribute>
		  <fo:inline font-weight="bold"><xsl:value-of select="$prefijo"/></fo:inline>&#160;
		  <xsl:value-of select="$fila/@DESCRIPCION"/>
	</fo:block>
</xsl:if>
<xsl:if test="$columna='FECHA_MAX_RESOLUCION'">
	<fo:block font-size="10pt"
			  font-family="sans-serif"
			  line-height="10pt"
			  text-align="center">
		  <xsl:attribute name="padding-left"><xsl:value-of select="string-length($guion) div 4"/>cm</xsl:attribute>
		  <xsl:variable name="nombre"><xsl:call-template name="date2String2"><xsl:with-param name="fecha"><xsl:value-of select="$fila/@FECHA_MAX_RESOLUCION"/></xsl:with-param></xsl:call-template></xsl:variable>
			<xsl:choose>
				<xsl:when test="number($chars)>=string-length($nombre)"><xsl:value-of select="$nombre"/></xsl:when>
				<xsl:otherwise><xsl:value-of select="concat(substring($nombre,0,$chars),'...')"/></xsl:otherwise>
			</xsl:choose>
	</fo:block>
</xsl:if>
<xsl:if test="$columna='UBICACION'">
	<fo:block font-size="10pt"
			  font-family="sans-serif"
			  line-height="10pt"
			  text-align="left">
		  <xsl:attribute name="padding-left"><xsl:value-of select="string-length($guion) div 4"/>cm</xsl:attribute>
		  <fo:inline font-weight="bold"><xsl:value-of select="$prefijo"/></fo:inline>&#160;
		  <xsl:value-of select="$fila/@UBICACION"/>
	</fo:block>
</xsl:if>
<xsl:if test="$columna='FECHA_FIN'">
	<fo:block font-size="10pt"
			  font-family="sans-serif"
			  line-height="10pt"
			  text-align="center">
		  <xsl:attribute name="padding-left"><xsl:value-of select="string-length($guion) div 4"/>cm</xsl:attribute>
		  <xsl:variable name="nombre"><xsl:call-template name="date2String"><xsl:with-param name="fecha"><xsl:value-of select="$fila/@FECHA_FIN"/></xsl:with-param></xsl:call-template></xsl:variable>
			<xsl:choose>
				<xsl:when test="number($chars)>=string-length($nombre)"><xsl:value-of select="$nombre"/></xsl:when>
				<xsl:otherwise><xsl:value-of select="concat(substring($nombre,0,$chars),'...')"/></xsl:otherwise>
			</xsl:choose>
	</fo:block>
</xsl:if>
<xsl:if test="$columna='PLANIFICACION'">
	<fo:block font-size="10pt"
			  font-family="sans-serif"
			  line-height="10pt"
			  text-align="center">
		  <xsl:attribute name="padding-left"><xsl:value-of select="string-length($guion) div 4"/>cm</xsl:attribute>
		  <xsl:variable name="nombre"><xsl:call-template name="date2String2"><xsl:with-param name="fecha"><xsl:value-of select="$fila/@PLANIFICACION"/></xsl:with-param></xsl:call-template></xsl:variable>
			<xsl:choose>
				<xsl:when test="number($chars)>=string-length($nombre)"><xsl:value-of select="$nombre"/></xsl:when>
				<xsl:otherwise><xsl:value-of select="concat(substring($nombre,0,$chars),'...')"/></xsl:otherwise>
			</xsl:choose>
	</fo:block>
</xsl:if>
<xsl:if test="$columna='DESCRIPCION_SEGUIMIENTO'">
	<fo:block font-size="10pt"
			  font-family="sans-serif"
			  line-height="10pt"
			  text-align="left">
		  <xsl:attribute name="padding-left"><xsl:value-of select="string-length($guion) div 4"/>cm</xsl:attribute>
		  <fo:inline font-weight="bold"><xsl:value-of select="$prefijo"/></fo:inline>&#160;
		  <xsl:value-of select="$fila/@DESCRIPCION_SEGUIMIENTO"/>
	</fo:block>
</xsl:if>
<xsl:if test="$columna='HORAS_RESOLUCION'">
	<fo:block font-size="10pt"
			  font-family="sans-serif"
			  line-height="10pt"
			  text-align="center">
		  <xsl:attribute name="padding-left"><xsl:value-of select="string-length($guion) div 4"/>cm</xsl:attribute>
		  <xsl:variable name="nombre"><xsl:call-template name="floatToHours"><xsl:with-param name="float" select="$fila/@HORAS_RESOLUCION"/></xsl:call-template></xsl:variable>
			<xsl:choose>
				<xsl:when test="number($chars)>=string-length($nombre)"><xsl:value-of select="$nombre"/></xsl:when>
				<xsl:otherwise><xsl:value-of select="concat(substring($nombre,0,$chars),'...')"/></xsl:otherwise>
			</xsl:choose>
	</fo:block>
</xsl:if>
<xsl:if test="$columna='COSTE_ECONOMICO'">
	<fo:block font-size="10pt"
			  font-family="sans-serif"
			  line-height="10pt"
			  text-align="center">
		  <xsl:attribute name="padding-left"><xsl:value-of select="string-length($guion) div 4"/>cm</xsl:attribute>
		  <xsl:variable name="nombre"><xsl:value-of select="$fila/@COSTE_ECONOMICO"/>Eur.</xsl:variable>
			<xsl:choose>
				<xsl:when test="number($chars)>=string-length($nombre)"><xsl:value-of select="$nombre"/></xsl:when>
				<xsl:otherwise><xsl:value-of select="concat(substring($nombre,0,$chars),'...')"/></xsl:otherwise>
			</xsl:choose>
	</fo:block>
</xsl:if>
<xsl:if test="$columna='COSTE_MATERIALES'">
	<fo:block font-size="10pt"
			  font-family="sans-serif"
			  line-height="10pt"
			  text-align="center">
		  <xsl:attribute name="padding-left"><xsl:value-of select="string-length($guion) div 4"/>cm</xsl:attribute>
		  <xsl:variable name="nombre"><xsl:value-of select="$fila/@COSTE_MATERIALES"/>Eur.</xsl:variable>
			<xsl:choose>
				<xsl:when test="number($chars)>=string-length($nombre)"><xsl:value-of select="$nombre"/></xsl:when>
				<xsl:otherwise><xsl:value-of select="concat(substring($nombre,0,$chars),'...')"/></xsl:otherwise>
			</xsl:choose>
	</fo:block>
</xsl:if>
<xsl:if test="$columna='FECHA_ALERTA'">
	<fo:block font-size="10pt"
			  font-family="sans-serif"
			  line-height="10pt"
			  text-align="center">
		  <xsl:attribute name="padding-left"><xsl:value-of select="string-length($guion) div 4"/>cm</xsl:attribute>
		  <xsl:variable name="nombre"><xsl:call-template name="date2String2"><xsl:with-param name="fecha"><xsl:value-of select="$fila/@FECHA_ALERTA"/></xsl:with-param></xsl:call-template></xsl:variable>
			<xsl:choose>
				<xsl:when test="number($chars)>=string-length($nombre)"><xsl:value-of select="$nombre"/></xsl:when>
				<xsl:otherwise><xsl:value-of select="concat(substring($nombre,0,$chars),'...')"/></xsl:otherwise>
			</xsl:choose>
	</fo:block>
</xsl:if>	
</xsl:template>

<xsl:template name="detailPrint">
<xsl:param name="solicitudes"/>
<fo:table border-width="0pt" space-before.optimum="2pt">
<fo:table-column column-width="19cm"/>
<fo:table-body>

<xsl:if test="count($solicitudes/SOLICITANTE)>0">
<fo:table-row>
<fo:table-cell border-width="1pt" border-style="solid" padding="2pt">
<fo:block font-size="12pt" 
		  font-family="sans-serif"
		  space-after.optimum="2pt"
		  text-align="left">
  <fo:inline font-weight="bold">DATOS DEL SOLICITANTE</fo:inline>
</fo:block>
</fo:table-cell>
</fo:table-row>
<fo:table-row>
<fo:table-cell border-width="1pt" border-style="solid" padding="2pt">
<!-- Datos Generales del Solicitante -->
<fo:table border-width="0pt" space-before.optimum="2pt">
  <fo:table-column column-width="9cm"/>
  <fo:table-column column-width="6cm"/>
  <fo:table-column column-width="3cm"/>
	<fo:table-body>
		<xsl:for-each select="$solicitudes/SOLICITANTE">
			<fo:table-row>
				<fo:table-cell border-width="0pt" border-style="solid" padding="0pt">
					<fo:block font-size="10pt" 
							  font-family="sans-serif"
							  space-after.optimum="8pt"
							  text-align="left">
					  <fo:inline font-weight="bold">Nombre:</fo:inline>&#160;<xsl:value-of select="APELLIDOS"/>, <xsl:value-of select="NOMBRE"/>
					</fo:block>
				</fo:table-cell>
				<fo:table-cell border-width="0pt" border-style="solid" padding="0pt">
					<fo:block font-size="10pt" 
							  font-family="sans-serif"
							  space-after.optimum="8pt"
							  text-align="left">
					  <fo:inline font-weight="bold">Email:</fo:inline>&#160;<xsl:value-of select="EMAIL"/>
					</fo:block>
				</fo:table-cell>
				<fo:table-cell border-width="0pt" border-style="solid" padding="0pt">
					<fo:block font-size="10pt" 
							  font-family="sans-serif"
							  space-after.optimum="8pt"
							  text-align="left">
					  <fo:inline font-weight="bold">Telefono:</fo:inline>&#160;<xsl:value-of select="TELEFONO"/>
					</fo:block>
				</fo:table-cell>
			</fo:table-row>
			<fo:table-row>
				<fo:table-cell border-width="0pt" border-style="solid" padding="0pt" number-columns-spanned="3">
					<fo:block font-size="10pt" 
							  font-family="sans-serif"
							  space-after.optimum="8pt"
							  text-align="left">
					  <fo:inline font-weight="bold">Ubicacin:</fo:inline>&#160;<xsl:value-of select="DEPTO"/>
					</fo:block>
				</fo:table-cell>
			</fo:table-row>
		  </xsl:for-each>
		</fo:table-body>
	</fo:table>
</fo:table-cell>
</fo:table-row>
</xsl:if>

<fo:table-row>
<fo:table-cell border-width="1pt" border-style="solid" padding="2pt">
<fo:block font-size="12pt" 
		  font-family="sans-serif"
		  space-after.optimum="2pt"
		  text-align="left">
  <fo:inline font-weight="bold">DATOS DE TAREA</fo:inline>
</fo:block>
</fo:table-cell>
</fo:table-row>
<fo:table-row>
<fo:table-cell border-width="1pt" border-style="solid" padding="2pt">
<!-- Datos Generales Tarea	-->
<fo:table border-width="0pt" space-before.optimum="2pt">
  <fo:table-column column-width="7cm"/>
  <fo:table-column column-width="7cm"/>
  <fo:table-column column-width="4cm"/>
	<fo:table-body>
		<xsl:for-each select="$solicitudes/SOLICITUD">
			<fo:table-row>
				<fo:table-cell border-width="0pt" border-style="solid" padding="0pt">
					<fo:block font-size="10pt" 
							  font-family="sans-serif"
							  space-after.optimum="8pt"
							  text-align="left">
					  <fo:inline font-weight="bold">Cdigo Tarea:</fo:inline>&#160;<xsl:value-of select="@CODIGO"/>&#160;<xsl:if test="string-length(@PADRE)>0">(<xsl:value-of select="@PADRE"/>)</xsl:if>
					</fo:block>
				</fo:table-cell>
				<fo:table-cell border-width="0pt" border-style="solid" padding="0pt">
					<fo:block font-size="10pt" 
							  font-family="sans-serif"
							  space-after.optimum="8pt"
							  text-align="left">
					  <fo:inline font-weight="bold">Fecha:</fo:inline>&#160;<xsl:call-template name="date2String"><xsl:with-param name="fecha" select="@FECHA_CREACION"/></xsl:call-template>
					</fo:block>
				</fo:table-cell>
				<fo:table-cell border-width="0pt" border-style="solid" padding="0pt">
					<fo:block font-size="10pt" 
							  font-family="sans-serif"
							  space-after.optimum="8pt"
							  text-align="left">
					  <fo:inline font-weight="bold">Tipo:</fo:inline>&#160;<xsl:choose><xsl:when test="@TIPO_TAREA='I'">INCIDENCIA</xsl:when><xsl:when test="@TIPO_TAREA='P'">PETICIN</xsl:when><xsl:when test="@TIPO_TAREA='B'">PROBLEMA</xsl:when><xsl:when test="@TIPO_TAREA='A'">PROGRAMADA</xsl:when><xsl:otherwise>DESCONOCIDO</xsl:otherwise></xsl:choose>
					</fo:block>
				</fo:table-cell>
			</fo:table-row>
			<fo:table-row>
				<fo:table-cell border-width="0pt" border-style="solid" padding="0pt">
					<fo:block font-size="10pt" 
							  font-family="sans-serif"
							  space-after.optimum="8pt"
							  text-align="left">
					  <fo:inline font-weight="bold">Solicitante:</fo:inline>&#160;<xsl:value-of select="@USUEMAIL"/>
					</fo:block>
				</fo:table-cell>
				<fo:table-cell border-width="0pt" border-style="solid" padding="0pt">
					<fo:block font-size="10pt" 
							  font-family="sans-serif"
							  space-after.optimum="8pt"
							  text-align="left">
					  <fo:inline font-weight="bold"><xsl:call-template name="traduce"><xsl:with-param name="id" select="'Informtico'"/></xsl:call-template>:</fo:inline>&#160;<xsl:value-of select="@INFEMAIL"/>
					</fo:block>
				</fo:table-cell>
				<fo:table-cell border-width="0pt" border-style="solid" padding="0pt">
					<fo:block font-size="10pt" 
							  font-family="sans-serif"
							  space-after.optimum="8pt"
							  text-align="left" wrap-option="wrap">
					  <fo:inline font-weight="bold">Copia:</fo:inline>&#160;
					  <xsl:variable name="mailCopia">
						<xsl:if test="string-length(@EMAIL_COPIA)>0">
							<xsl:choose>
								<xsl:when test="starts-with(@EMAIL_COPIA,@USUEMAIL)">
									<xsl:value-of select="translate(substring-after(@EMAIL_COPIA,concat(@USUEMAIL,',')),',',' ')"/>
								</xsl:when>	
								<xsl:otherwise>
									<xsl:value-of select="translate(@EMAIL_COPIA,',',' ')"/>
								</xsl:otherwise>
							</xsl:choose>
						</xsl:if>
					  </xsl:variable>
						<xsl:value-of select="$mailCopia"/>						
					</fo:block>
				</fo:table-cell>
			</fo:table-row>
			<fo:table-row>
				<fo:table-cell border-width="0pt" border-style="solid" padding="0pt">
					<fo:block font-size="10pt" 
							  font-family="sans-serif"
							  space-after.optimum="8pt"
							  text-align="left">
					  <fo:inline font-weight="bold">Urgente:</fo:inline>&#160;
						<xsl:choose>
							<xsl:when test="@URGENCIA='N'">No</xsl:when>
							<xsl:otherwise>Si</xsl:otherwise>
						</xsl:choose>&#160;&#160;
					  <fo:inline font-weight="bold">Prioridad:</fo:inline>&#160;<xsl:value-of select="@PRIORIDADDESC"/>
					</fo:block>
				</fo:table-cell>
				<fo:table-cell border-width="0pt" border-style="solid" padding="0pt" number-columns-spanned="2">
					<fo:block font-size="10pt" 
							  font-family="sans-serif"
							  space-after.optimum="8pt"
							  text-align="left">
					  <fo:inline font-weight="bold">Aplicacin:</fo:inline>&#160;<xsl:value-of select="@APLICACIONDESC"/>
					</fo:block>
				</fo:table-cell>
			</fo:table-row>
			<fo:table-row>
				<fo:table-cell border-width="0pt" border-style="solid" padding="0pt">
					<fo:block font-size="10pt" 
							  font-family="sans-serif"
							  space-after.optimum="8pt"
							  text-align="left">
					  <fo:inline font-weight="bold">Categora:</fo:inline>&#160;<xsl:value-of select="@CATEGORIADESC"/>
					</fo:block>
				</fo:table-cell>
				<fo:table-cell border-width="0pt" border-style="solid" padding="0pt">
					<fo:block font-size="10pt" 
							  font-family="sans-serif"
							  space-after.optimum="8pt"
							  text-align="left">
					  <fo:inline font-weight="bold">Fec. Prevista:</fo:inline>&#160;<xsl:call-template name="date2String2"><xsl:with-param name="fecha" select="@PLANIFICACION"/></xsl:call-template>
					</fo:block>
				</fo:table-cell>
				<fo:table-cell border-width="0pt" border-style="solid" padding="0pt" number-columns-spanned="2">
					<fo:block font-size="10pt" 
							  font-family="sans-serif"
							  space-after.optimum="8pt"
							  text-align="left">
					  <fo:inline font-weight="bold">Fec.Max.Resol:</fo:inline>&#160;<xsl:call-template name="date2String2"><xsl:with-param name="fecha" select="@FECHA_MAX_RESOLUCION"/></xsl:call-template>
					</fo:block>
				</fo:table-cell>
			</fo:table-row>
			<fo:table-row>
				<fo:table-cell border-width="0pt" border-style="solid" padding="0pt" number-columns-spanned="3">
					<fo:block font-size="10pt" 
							  font-family="sans-serif"
							  space-after.optimum="8pt"
							  text-align="left">
					  <fo:inline font-weight="bold">Ubicacin:</fo:inline>&#160;<xsl:value-of select="@UBICACION"/>
					</fo:block>
				</fo:table-cell>
			</fo:table-row>
		  </xsl:for-each>
		</fo:table-body>
	</fo:table>
</fo:table-cell>
</fo:table-row>
<!-- ASUNTO Tarea	-->
<fo:table-row>
<fo:table-cell border-width="0pt" border-style="solid" padding="2pt">
<fo:block font-size="12pt" 
		  font-family="sans-serif"
		  space-after.optimum="2pt"
		  text-align="left">
		  &#160;
</fo:block>
</fo:table-cell>
</fo:table-row>
<fo:table-row>
<fo:table-cell border-width="1pt" border-style="solid" padding="2pt">
<fo:block font-size="12pt" 
		  font-family="sans-serif"
		  space-after.optimum="2pt"
		  text-align="left">
  <fo:inline font-weight="bold">ASUNTO:</fo:inline>&#160;<fo:inline font-weight="plain"><xsl:value-of select="$solicitudes/SOLICITUD/@ASUNTO"/></fo:inline>
</fo:block>
</fo:table-cell>
</fo:table-row>
<!-- Pego asunto a descripcin
<fo:table-row>
<fo:table-cell border-width="0pt" border-style="solid" padding="2pt">
<fo:block font-size="12pt" 
		  font-family="sans-serif"
		  space-after.optimum="2pt"
		  text-align="left">
		  &#160;
</fo:block>
</fo:table-cell>
</fo:table-row>
-->
<!-- DESCRIPCION Tarea	-->
<fo:table-row>
<fo:table-cell border-width="1pt" border-style="solid" padding="2pt">
<fo:block font-size="12pt" 
		  font-family="sans-serif"
		  space-after.optimum="2pt"
		  text-align="left">
  <fo:inline font-weight="bold">DESCRIPCIN</fo:inline>
</fo:block>
</fo:table-cell>
</fo:table-row>
<fo:table-row>
<fo:table-cell border-width="1pt" border-style="solid" padding="2pt">
	<fo:block font-size="10pt" 
			  font-family="sans-serif"
			  space-after.optimum="10pt"
			  text-align="left"
				linefeed-treatment="preserve"
				white-space-collapse="false"
				white-space-treatment="preserve"><xsl:value-of select="$solicitudes/SOLICITUD/@DESCRIPCION"/></fo:block>
</fo:table-cell>
</fo:table-row>
<!-- Ubicacin Tarea	-->
<xsl:if test="string-length(@UBICACION)">
<fo:table-row>
<fo:table-cell border-width="0pt" border-style="solid" padding="2pt">
<fo:block font-size="12pt" 
		  font-family="sans-serif"
		  space-after.optimum="2pt"
		  text-align="left">
		  &#160;
</fo:block>
</fo:table-cell>
</fo:table-row>
<fo:table-row>
<fo:table-cell border-width="1pt" border-style="solid" padding="2pt">
<fo:block font-size="12pt" 
		  font-family="sans-serif"
		  space-after.optimum="2pt"
		  text-align="left">
  <fo:inline font-weight="bold">UBICACIN</fo:inline>
</fo:block>
</fo:table-cell>
</fo:table-row>
<fo:table-row>
<fo:table-cell border-width="1pt" border-style="solid" padding="2pt">
	<fo:block font-size="10pt" 
			  font-family="sans-serif"
			  space-after.optimum="10pt"
			  text-align="left">
	  <xsl:value-of select="$solicitudes/SOLICITUD/@UBICACION"/>
</fo:block>
</fo:table-cell>
</fo:table-row>
</xsl:if>
<!-- Anexos Tarea	-->
<xsl:if test="count($solicitudes/ANEXOS)>0">
<fo:table-row>
<fo:table-cell border-width="0pt" border-style="solid" padding="2pt">
<fo:block font-size="12pt" 
		  font-family="sans-serif"
		  space-after.optimum="2pt"
		  text-align="left">
		  &#160;
</fo:block>
</fo:table-cell>
</fo:table-row>
<fo:table-row>
<fo:table-cell border-width="1pt" border-style="solid" padding="2pt">
<fo:block font-size="12pt" 
		  font-family="sans-serif"
		  space-after.optimum="2pt"
		  text-align="left">
  <fo:inline font-weight="bold">ANEXOS</fo:inline>
</fo:block>
</fo:table-cell>
</fo:table-row>
<fo:table-row>
<fo:table-cell border-width="1pt" border-style="solid" padding="2pt">
<xsl:if test="count($solicitudes/ANEXOS[@CODIGO=$solicitudes/SOLICITUD/@CODIGO and @TIPO='S'])>0">
<fo:block font-size="10pt" 
		  font-family="sans-serif"
		  space-after.optimum="8pt"
		  text-align="left">
		<fo:inline font-weight="bold">Anexos</fo:inline>
</fo:block>
</xsl:if>
<xsl:for-each select="$solicitudes/ANEXOS[@CODIGO=$solicitudes/SOLICITUD/@CODIGO and @TIPO='S']">
	<fo:block font-size="8pt" 
			  font-family="sans-serif"
			  space-after.optimum="8pt"
			  text-align="left">
			<xsl:value-of select="@NOMBRE"/>&#160;<xsl:value-of select="@SIZE"/>
	</fo:block>
</xsl:for-each>
<xsl:if test="count($solicitudes/ANEXOS[@CODIGO!=$solicitudes/SOLICITUD/@CODIGO and @TIPO='S'])>0">
<fo:block font-size="10pt" 
		  font-family="sans-serif"
		  space-after.optimum="8pt"
		  text-align="left">
		<fo:inline font-weight="bold">Anexos Tarea Padre</fo:inline>
</fo:block>
</xsl:if>
<xsl:for-each select="$solicitudes/ANEXOS[@CODIGO!=$solicitudes/SOLICITUD/@CODIGO and @TIPO='S']">
	<fo:block font-size="8pt" 
			  font-family="sans-serif"
			  space-after.optimum="8pt"
			  text-align="left">
			<xsl:value-of select="@NOMBRE"/>&#160;<xsl:value-of select="@SIZE"/>
	</fo:block>
</xsl:for-each>
<xsl:if test="count($solicitudes/ANEXOS[@CODIGO=$solicitudes/SOLICITUD/@CODIGO and @TIPO='P'])>0">
<fo:block font-size="10pt" 
		  font-family="sans-serif"
		  space-after.optimum="8pt"
		  text-align="left">
		<fo:inline font-weight="bold">Anexos Pblicos</fo:inline>
</fo:block>
</xsl:if>
<xsl:for-each select="$solicitudes/ANEXOS[@CODIGO=$solicitudes/SOLICITUD/@CODIGO and @TIPO='P']">
	<fo:block font-size="8pt" 
			  font-family="sans-serif"
			  space-after.optimum="8pt"
			  text-align="left">
			<xsl:value-of select="@NOMBRE"/>&#160;<xsl:value-of select="@SIZE"/>
	</fo:block>
</xsl:for-each>
<xsl:if test="count($solicitudes/ANEXOS[@CODIGO!=$solicitudes/SOLICITUD/@CODIGO and @TIPO='S'])>0">
<fo:block font-size="10pt" 
		  font-family="sans-serif"
		  space-after.optimum="8pt"
		  text-align="left">
		<fo:inline font-weight="bold">Anexos Pblicos Tarea Padre</fo:inline>
</fo:block>
</xsl:if>
<xsl:for-each select="$solicitudes/ANEXOS[@CODIGO!=$solicitudes/SOLICITUD/@CODIGO and @TIPO='P']">
	<fo:block font-size="8pt" 
			  font-family="sans-serif"
			  space-after.optimum="8pt"
			  text-align="left">
			<xsl:value-of select="@NOMBRE"/>&#160;<xsl:value-of select="@SIZE"/>
	</fo:block>
</xsl:for-each>
</fo:table-cell>
</fo:table-row>
</xsl:if>
<!-- Seguimiento Tarea	-->
<xsl:if test="count($solicitudes/SEGUIMIENTO)>0 and $solicitudes/SOLICITUD/@INFORMATICO=$solicitudes/USER/@ID">
<fo:table-row>
<fo:table-cell border-width="0pt" border-style="solid" padding="2pt">
	<fo:block font-size="12pt" 
		  font-family="sans-serif"
		  space-after.optimum="2pt"
		  text-align="left">
		  &#160;
</fo:block>
</fo:table-cell>
</fo:table-row>
<fo:table-row>
<fo:table-cell border-width="1pt" border-style="solid" padding="2pt">
	<fo:block font-size="12pt" 
		  font-family="sans-serif"
		  space-after.optimum="2pt"
		  text-align="left">
  <fo:inline font-weight="bold">SEGUIMIENTO</fo:inline>
</fo:block>
</fo:table-cell>
</fo:table-row>
<fo:table-row>
<fo:table-cell border-width="1pt" border-style="solid" padding="2pt">
<fo:table border-width="0pt" space-before.optimum="2pt">
  <fo:table-column column-width="2cm"/>
  <fo:table-column column-width="13cm"/>
	<fo:table-body>
		<fo:table-row>
			<fo:table-cell border-width="0pt" border-style="solid" padding="0pt">
				<fo:block font-size="10pt" 
						  font-family="sans-serif"
						  space-after.optimum="8pt"
						  text-align="left">
						<fo:inline font-weight="bold">Fecha</fo:inline>
				</fo:block>
			</fo:table-cell>
			<fo:table-cell border-width="0pt" border-style="solid" padding="0pt">
				<fo:block font-size="10pt" 
						  font-family="sans-serif"
						  space-after.optimum="8pt"
						  text-align="left">
						<fo:inline font-weight="bold">Descripcin</fo:inline>
				</fo:block>
			</fo:table-cell>
		</fo:table-row>
	<xsl:for-each select="$solicitudes/SEGUIMIENTO">
	<xsl:sort select="number(@CODIGO)" data-type="number"/>
		<xsl:variable name="mcod" select="@CODIGO"/>
		<fo:table-row>
			<fo:table-cell border-width="0pt" border-style="solid" padding="0pt">
				<fo:block font-size="8pt" 
						  font-family="sans-serif"
						  space-after.optimum="8pt"
						  text-align="left">
						<xsl:call-template name="date2String2"><xsl:with-param name="fecha"><xsl:value-of select="@FECHA_ALTA"/></xsl:with-param></xsl:call-template>
				</fo:block>
			</fo:table-cell>
			<fo:table-cell border-width="0pt" border-style="solid" padding="0pt">
				<fo:block font-size="8pt" 
						  font-family="sans-serif"
						  space-after.optimum="8pt"
						  text-align="left">
						<xsl:value-of select="@DESCRIPCION"/>
				</fo:block>
			</fo:table-cell>
		</fo:table-row>
		<xsl:if test="count($solicitudes/ANEXOS[@CODE=$mcod and @TIPO='O'])>0">
		<fo:table-row>
			<fo:table-cell border-width="0pt" border-style="solid" padding="0pt">
				<fo:block font-size="8pt" 
						  font-family="sans-serif"
						  space-after.optimum="8pt"
						  text-align="left">
						&#160;
				</fo:block>
			</fo:table-cell>
			<fo:table-cell border-width="0pt" border-style="solid" padding="0pt">
				<fo:block font-size="8pt" 
						  font-family="sans-serif"
						  space-after.optimum="8pt"
						  text-align="left">
						<xsl:value-of select="$solicitudes/ANEXOS[@CODE=$mcod and @TIPO='O']/@NOMBRE"/>&#160;<xsl:value-of select="$solicitudes/ANEXOS[@CODE=$mcod and @TIPO='O']/@SIZE"/>
				</fo:block>
			</fo:table-cell>
		</fo:table-row>
		</xsl:if>
	</xsl:for-each>
	</fo:table-body>
</fo:table>
</fo:table-cell>
</fo:table-row>
</xsl:if>
<!-- Historial Tarea	-->
<xsl:if test="count($solicitudes/MOVIMIENTO)>0">
<!-- Pego seguimiento e historial
<fo:table-row>
<fo:table-cell border-width="0pt" border-style="solid" padding="2pt">
<fo:block font-size="12pt" 
		  font-family="sans-serif"
		  space-after.optimum="2pt"
		  text-align="left">
		  &#160;
</fo:block>
</fo:table-cell>
</fo:table-row>
-->
<fo:table-row>
<fo:table-cell border-width="1pt" border-style="solid" padding="2pt">
	<fo:block font-size="12pt" 
		  font-family="sans-serif"
		  space-after.optimum="2pt"
		  text-align="left">
  <fo:inline font-weight="bold">HISTORIAL TAREA</fo:inline>
</fo:block>
</fo:table-cell>
</fo:table-row>
<fo:table-row>
<fo:table-cell border-width="1pt" border-style="solid" padding="2pt">
<fo:table border-width="0pt" space-before.optimum="2pt">
  <fo:table-column column-width="1cm"/>
  <fo:table-column column-width="3.5cm"/>
  <fo:table-column column-width="2cm"/>
  <fo:table-column column-width="3cm"/>
  <fo:table-column column-width="9cm"/>
	<fo:table-body>
		<!--
		<fo:table-row>
			<fo:table-cell border-width="0pt" border-style="solid" padding="2pt">
				<fo:block font-size="8pt" 
						  font-family="sans-serif"
						  space-after.optimum="8pt"
						  text-align="left">
						&#160;
				</fo:block>
			</fo:table-cell>
			<fo:table-cell border-width="0pt" border-style="solid" padding="2pt">
				<fo:block font-size="10pt" 
						  font-family="sans-serif"
						  space-after.optimum="10pt"
						  text-align="left">
						<fo:inline font-weight="bold">Inform.</fo:inline>
				</fo:block>
			</fo:table-cell>
			<fo:table-cell border-width="0pt" border-style="solid" padding="2pt">
				<fo:block font-size="10pt" 
						  font-family="sans-serif"
						  space-after.optimum="10pt"
						  text-align="left">
						<fo:inline font-weight="bold">Fecha</fo:inline>
				</fo:block>
			</fo:table-cell>
			<fo:table-cell border-width="0pt" border-style="solid" padding="2pt">
				<fo:block font-size="10pt" 
						  font-family="sans-serif"
						  space-after.optimum="10pt"
						  text-align="left">
						<fo:inline font-weight="bold">Tipo</fo:inline>
				</fo:block>
			</fo:table-cell>
			<fo:table-cell border-width="0pt" border-style="solid" padding="2pt">
				<fo:block font-size="10pt" 
						  font-family="sans-serif"
						  space-after.optimum="10pt"
						  text-align="left">
						<fo:inline font-weight="bold">Valor Ant.</fo:inline>
				</fo:block>
			</fo:table-cell>
		</fo:table-row>
		-->
	<xsl:for-each select="$solicitudes/MOVIMIENTO[@TIPO_MOVIMIENTO='U' or @TIPO_MOVIMIENTO='R' or @TIPO_MOVIMIENTO='A' or @TIPO_MOVIMIENTO='M' or count(/XMLROOT/DATA/SECURITY/ACTION[@NAME='historialCompleto']/PROFILE)>0]">
	<xsl:sort select="@CODIGO"/>
		<fo:table-row>
			<fo:table-cell border-width="0pt" border-style="solid" padding="2pt">
				<fo:block font-size="8pt" 
						  font-family="sans-serif"
						  space-after.optimum="8pt"
						  text-align="left">
						[<xsl:value-of select="position()"/>]
				</fo:block>
			</fo:table-cell>
			<fo:table-cell border-width="0pt" border-style="solid" padding="2pt">
				<fo:block font-size="8pt" 
						  font-family="sans-serif"
						  space-after.optimum="8pt"
						  text-align="left">
						<xsl:value-of select="@EMAIL"/>
				</fo:block>
			</fo:table-cell>
			<fo:table-cell border-width="0pt" border-style="solid" padding="2pt">
				<fo:block font-size="8pt" 
						  font-family="sans-serif"
						  space-after.optimum="8pt"
						  text-align="left">
						<xsl:call-template name="date2String2"><xsl:with-param name="fecha"><xsl:value-of select="@FECHA"/></xsl:with-param></xsl:call-template>
				</fo:block>
			</fo:table-cell>
			<fo:table-cell border-width="0pt" border-style="solid" padding="2pt">
				<fo:block font-size="8pt" 
						  font-family="sans-serif"
						  space-after.optimum="8pt"
						  text-align="left">
						<xsl:choose>
							<xsl:when test="@TIPO_MOVIMIENTO='U'">Asig. Tarea</xsl:when>
							<xsl:when test="@TIPO_MOVIMIENTO='A'">Anul. Tarea</xsl:when>
							<xsl:when test="@TIPO_MOVIMIENTO='C'">Camb. Cat.</xsl:when>
							<xsl:when test="@TIPO_MOVIMIENTO='D'">Camb. Pri.</xsl:when>
							<xsl:when test="@TIPO_MOVIMIENTO='L'">Camb. Fec. Planif.</xsl:when>
							<xsl:when test="@TIPO_MOVIMIENTO='V'">Devol. Tarea</xsl:when>
							<xsl:when test="@TIPO_MOVIMIENTO='F'">Fin Tarea</xsl:when>
							<xsl:when test="@TIPO_MOVIMIENTO='I'">Camb. a Inc.</xsl:when>
							<xsl:when test="@TIPO_MOVIMIENTO='P'">Camb. a Pet.</xsl:when>
							<xsl:when test="@TIPO_MOVIMIENTO='W'">Inic. Espera</xsl:when>
							<xsl:when test="@TIPO_MOVIMIENTO='N'">Fin Espera</xsl:when>
							<xsl:when test="@TIPO_MOVIMIENTO='R'">Reasig. Tarea</xsl:when>
							<xsl:when test="@TIPO_MOVIMIENTO='X'">Rech. Tarea</xsl:when>
							<xsl:when test="@TIPO_MOVIMIENTO='M'">Modif. Tarea</xsl:when>
							<xsl:when test="@TIPO_MOVIMIENTO='T'">React. Tarea</xsl:when>
							<xsl:when test="@TIPO_MOVIMIENTO='K'">Rech. Paso Espera</xsl:when>
							<xsl:otherwise>Otro(<xsl:value-of select="@TIPO_MOVIMIENTO"/>)</xsl:otherwise>
						</xsl:choose>
				</fo:block>
			</fo:table-cell>
			<fo:table-cell border-width="0pt" border-style="solid" padding="2pt">
				<fo:block font-size="8pt" 
						  font-family="sans-serif"
						  space-after.optimum="8pt"
						  text-align="left">
						<xsl:value-of select="@VALOR_ANTERIOR"/>
				</fo:block>
			</fo:table-cell>
		</fo:table-row>
		<fo:table-row>
			<fo:table-cell border-width="0pt" border-style="solid" padding="2pt">
				<fo:block font-size="8pt" 
						  font-family="sans-serif"
						  space-after.optimum="8pt"
						  text-align="left">
						&#160;
				</fo:block>
			</fo:table-cell>
			<fo:table-cell border-width="0pt" border-style="solid" padding="2pt" number-columns-spanned="3">
				<fo:block font-size="8pt" 
						  font-family="sans-serif"
						  space-after.optimum="8pt"
						  text-align="left">
						<xsl:value-of select="@DESCRIPCION_MOVIMIENTO"/>
				</fo:block>
			</fo:table-cell>
		</fo:table-row>
	</xsl:for-each>
	</fo:table-body>
</fo:table>
</fo:table-cell>
</fo:table-row>
</xsl:if>
<fo:table-row>
	<fo:table-cell border-width="0pt" border-style="solid" padding="2pt">
	<fo:table border-width="0pt" space-before.optimum="2pt">
	  <fo:table-column column-width="8cm"/>
	  <fo:table-column column-width="8cm"/>
		<fo:table-body>
			<fo:table-row>
				<fo:table-cell border-width="0pt" border-style="solid" padding="2pt">
					<fo:block font-size="10pt" 
							  font-family="sans-serif"
							  space-after.optimum="16pt"
							  space-before.optimum="16pt"
							  text-align="center">
							Firma del Solicitante
					</fo:block>
				</fo:table-cell>
				<fo:table-cell border-width="0pt" border-style="solid" padding="2pt">
					<fo:block font-size="10pt" 
							  font-family="sans-serif"
							  space-after.optimum="16pt"
							  space-before.optimum="16pt"
							  text-align="center">
							Firma del <xsl:call-template name="traduce"><xsl:with-param name="id" select="'Informtico'"/></xsl:call-template>
					</fo:block>
				</fo:table-cell>
			</fo:table-row>
			<fo:table-row>
				<fo:table-cell border-width="0pt" border-style="solid" padding="2pt">
					<fo:block font-size="10pt" 
							  font-family="sans-serif"
							  space-before.optimum="16pt"
							  text-align="center">
							<fo:inline font-weight="bold"><xsl:value-of select="$solicitudes/SOLICITUD/@USUEMAIL"/></fo:inline>
					</fo:block>
				</fo:table-cell>
				<fo:table-cell border-width="0pt" border-style="solid" padding="2pt">
					<fo:block font-size="10pt" 
							  font-family="sans-serif"
							  space-before.optimum="16pt"
							  text-align="center">
							<fo:inline font-weight="bold"><xsl:value-of select="$solicitudes/SOLICITUD/@INFEMAIL"/></fo:inline>
					</fo:block>
				</fo:table-cell>
			</fo:table-row>
		</fo:table-body>
	</fo:table>
	</fo:table-cell>
</fo:table-row>

</fo:table-body>
</fo:table>
</xsl:template>

</xsl:stylesheet>


