<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet version="1.0" 
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:fo="http://www.w3.org/1999/XSL/Format">

<xsl:template name="headComun">
<xsl:param name="title"/>
      <fo:static-content flow-name="xsl-region-before">
        <fo:block font-size="14pt" text-align="center" background-color="lightgray" color="darkblue">
			<xsl:value-of select="$title"/>
		</fo:block>
      </fo:static-content>
</xsl:template>

<xsl:template name="pieComun">
<xsl:param name="title"/>
      <fo:static-content flow-name="xsl-region-after">
		<fo:block font-size="10pt" text-align="end">Pag.<fo:page-number/></fo:block>
			<!-- fo:inline text-align="left"><xsl:value-of select="$title"/></fo:inline -->
      </fo:static-content>
</xsl:template>

<xsl:template name="date2String">
<xsl:param name="fecha"/>
<xsl:if test="string-length($fecha)>0">
<xsl:variable name="date" select="substring-before($fecha,'T')"/>
<xsl:variable name="hora" select="substring-after(substring-before($fecha,'.'),'T')"/>
<xsl:variable name="anyo" select="substring-before($date,'-')"/>
<xsl:variable name="mes" select="substring-before(substring-after($date,'-'),'-')"/>
<xsl:variable name="dia" select="substring-after(substring-after($date,'-'),'-')"/>
<xsl:value-of select="$dia"/>/<xsl:value-of select="$mes"/>/<xsl:value-of select="$anyo"/>&#160;<xsl:value-of select="$hora"/>
</xsl:if>
</xsl:template>

<xsl:template name="date2String2">
<xsl:param name="fecha"/>
<xsl:if test="string-length($fecha)>0">
<xsl:variable name="date" select="substring-before($fecha,'T')"/>
<xsl:variable name="hora" select="substring-after(substring-before($fecha,'.'),'T')"/>
<xsl:variable name="anyo" select="substring-before($date,'-')"/>
<xsl:variable name="mes" select="substring-before(substring-after($date,'-'),'-')"/>
<xsl:variable name="dia" select="substring-after(substring-after($date,'-'),'-')"/>
<xsl:value-of select="$dia"/>/<xsl:value-of select="$mes"/>/<xsl:value-of select="$anyo"/>
</xsl:if>
</xsl:template>

<xsl:template name="floatToHours">
<xsl:param name="float"/>
<xsl:choose><xsl:when test="string-length($float)>0"><xsl:value-of select="floor(number($float))"/>:<xsl:value-of select="(number($float)-floor(number($float)))*60"/></xsl:when><xsl:otherwise><xsl:value-of select="$float"/></xsl:otherwise></xsl:choose>
</xsl:template>

<xsl:template name="traduce">
<xsl:param name="id"/>
<xsl:choose>
	<xsl:when test="count(/XMLROOT/DICTIONARY[contains(@LANGUAGE,concat('_',substring-before($menu,'/')))]/KEY[@NAME=$id])>0">
		<xsl:value-of select="/XMLROOT/DICTIONARY[contains(@LANGUAGE,'_SIU')]/KEY[@NAME=$id]/@VALUE"/>
	</xsl:when>
	<xsl:when test="count(/XMLROOT/DICTIONARY[not(contains(@LANGUAGE,'_'))]/KEY[@NAME=$id])>0">
		<xsl:value-of select="/XMLROOT/DICTIONARY[not(contains(@LANGUAGE,'_'))]/KEY[@NAME=$id]/@VALUE"/>
	</xsl:when>
	<xsl:otherwise>
		<xsl:value-of select="$id"/>
	</xsl:otherwise>
</xsl:choose>
</xsl:template>

</xsl:stylesheet>


