/**
 * funciones de validacion para formularios
 * Basadas en "Validador Javascript Extension" para "Struts validation"
 * http://niallp.pwp.blueyonder.co.uk/validatorjs.html
 */
 
var general_base_jquery_id = 'div#general_base '; 
 
//comprueba si el elemento es un array
function general_is_array(elemento) {
    return elemento && !(elemento.propertyIsEnumerable('length')) && typeof elemento === 'object' && typeof elemento.length === 'number';
} 
 
//comprueba si es una cadena
function general_typeof_string(elemento) {
	var tipo = typeof elemento;
	return "string" == tipo;
}
function general_typeof_number(elemento) {
	var tipo = typeof elemento;
	return "number" == tipo;
}

//busca el elemento_id, si se le pasa una cadena lo busca con jquery 
function general_get_element(elemento_id) {
	var elem = null;
	if (general_typeof_string(elemento_id)) {
		elem = $(general_base_jquery_id+elemento_id)[0];
		if (elem == undefined)
			elem = $(elemento_id)[0];
	}
	else
		elem = elemento_id;
	return elem;
}

//busca el elemento_id, si se le pasa una cadena lo busca con jquery 
function general_get_element2(elemento_id) {
	var elem = null;
	if (general_typeof_string(elemento_id)) {
		elem = $(elemento_id)[0];
	}
	else
		elem = elemento_id;
	return elem;
}

 
//comprueba si un elemento ya existe en los options del select
function general_select_exits(select_id, option_value) {
	var select = general_get_element(select_id);
    for (i=0; i < select.length; i++) {
        if (select.options[i].value == option_value) {
            return true;
        }
    }
    return false;
}

//aade al select el elemento de posicion selectedIndex del select_dispo si no existe
function general_select_add(select_id, select_disp_id, selectedIndex) {
	var select = general_get_element(select_id);
	var select_disp = general_get_element(select_disp_id);
	var valor = select_disp.options[selectedIndex].value;
	if (!general_select_exits(select, valor)) {
		var texto = select_disp.options[selectedIndex].text;
		var opt = new Option(texto, valor, false, false);
		select.options[select.length] = opt;
	}
}

//retorna el value del option seleccionado 
function general_select_get_option_value_selected(select_id) {
	var select = general_get_element(select_id);
	if(select.selectedIndex >= 0)
		return select.options[select.selectedIndex].value;
	else
		return '';
}

//retorna el texto del option seleccionado 
function general_select_get_option_text_selected(select_id) {
	var select = general_get_element(select_id);
	if(select.selectedIndex >= 0)
		return select.options[select.selectedIndex].text;
	else
		return '';
}


//aade a un select un option con los valores por parametro
function general_select_add_option(select_id, value, texto) {
	var select = general_get_element(select_id);
	var opt = new Option(texto, value, false, false);
	select.options[select.length] = opt;
}

//aade al select todos los elementos seleccionados del select_dispo
function general_select_swap_sel(select_disp_id, select_id) {
	var select = general_get_element(select_id);
	var select_disp = general_get_element(select_disp_id);
	for(var i=0; i<select_disp.length; i++) {
		if (select_disp.options[i].selected) {
			general_select_add(select, select_disp, i);
		}
	}
}

//aade al select todos los elementos del select_dispo
function general_select_swap_sel_all(select_disp_id, select_id) {
	var select = general_get_element(select_id);
	var select_disp = general_get_element(select_disp_id);
	for(var i=0; i<select_disp.length; i++) {
		general_select_add(select, select_disp, i);
	}
}


//borra del select el elemento de posicion selectedIndex
function general_select_del(select_id, selectedIndex) {
	var select = general_get_element(select_id);
	if ((select.length > selectedIndex) && (selectedIndex>=0)) {
		select.options[selectedIndex] = null;
	}
}



//marca todos los selementos como seleccionados
function general_select_swap_selectAll(select_id) {
	var select = general_get_element(select_id);
	if (select!=null) {
		for(var i=0; i<select.length; i++) {
			select.options[i].selected = true;
		}
	}
}


//localiza la posicion del option con value tal en un select
function general_select_indexof_value(select_id, option_value) {
	var select = general_get_element(select_id);
	for(var i=0; i<select.length; i++) {
		if (select.options[i].value == option_value) {
			return i;
			general_select_add(select, select_disp, i);
		}
	}
	return -1;
}

//selecciona en el select aquel opcion con el value por parametro
//retorna el index del elemento seleccionado
function general_select_seleccionar_value(select_id, option_value) {
	var select = general_get_element(select_id);
	if (general_strIsEmpty(option_value) || select == null)
		return -1;
	var i = general_select_indexof_value(select, option_value);
	if (i>=0) {
		select.selectedIndex = i;
	}
	return i;
}


//borra del select todos los elementos seleccionados <option selected="selected">
function general_select_del_selected(select_id) {
	var select = general_get_element(select_id);
	for(var i=select.length-1; i>=0; i--) {
		if (select.options[i].selected) {
			select.options[i] = null;
		}
	}
}

//borra del select todos los elementos
function general_select_del_all(select_id) {
	var select = general_get_element(select_id);
	for(var i=select.length-1; i>=0; i--) {
		select.options[i] = null;
	}
}


function general_getAlgunInputConContenido(form_id) {
	var form = general_get_element(form_id);
	for(var i=0; i<form.length; i++) {
		var field = form.elements[i];
		if(field.type == 'text' || field.type == 'select-one')
			if (general_getValueFromField(field) != '')
				return true;
	}
	return false;
}

function general_trim(s) {
	return s.replace( /^\s*/, "" ).replace( /\s*$/, "" );
}

//retorna el valor de un campo
function general_getValueFromField(field_id) {
	var field = general_get_element(field_id);
    var fieldValue = '';
    if (field != null && field.length > 0 && field[0].type == 'radio') {
        for (var x=0; x < field.length; x++) {
            if (field[x].disabled == false && field[x].checked) {
                fieldValue = field[x].value;
                break;
            }
        }
    } else if (field != null && field.disabled == false) {
        if (field.type == 'hidden' || field.type == 'password' ||
            field.type == 'text'   || field.type == 'textarea' ||
            field.type == 'radio'  || field.type == 'file') {
            fieldValue = field.value;
        }
        if (field.type == 'select-one' || field.type == 'select-multiple') {
            var si = field.selectedIndex;
            if (si >= 0) {
                fieldValue = field.options[si].value;
            }
        }
    }
    return fieldValue == null ? '' : fieldValue;
}

//comprueba si el campo tiene valor y da mensaje de error
function general_check_field_required(field_id, nombre_field) {
	var field = general_get_element(field_id);
	if (nombre_field==null)	nombre_field = '';
	var valor = general_getValueFromField(field);
	if (valor == '') {
		alert('El campo '+nombre_field+' es requerido.');
		field.focus();
		return false;
	}
	return true;
}

//
function general_chequear_field_required(field_id, nombre_field) {
	var field = general_get_element(field_id);
	if (nombre_field==null)	nombre_field = '';
	var valor = general_getValueFromField(field);
	if (valor == '') {
		return field.id + '|El campo '+nombre_field+' es requerido.'
	}
	return null;
}	

//comprueba la longitud maxima del campo
function general_check_field_maxlength(field_id, maxlength, nombre_field) {
	var field = general_get_element(field_id);
	if (nombre_field==null)	nombre_field = '';
	var valor = general_getValueFromField(field);
	if (valor.length > maxlength) {
		alert('En campo '+nombre_field+' ha introducido '+valor.length+' carctes y no debe sobrepasar los '+maxlength+ ' carctes.');
		field.focus();
		return false;
	}
	return true;
}

//comprueba la longitud maxima del campo
function general_chequear_field_maxlength(field_id, maxlength, nombre_field) {
	var field = general_get_element(field_id);
	if (nombre_field==null)	nombre_field = '';
	var valor = general_getValueFromField(field);
	if (valor.length > maxlength) {
		return field.id + '|En campo '+nombre_field+' ha introducido '+valor.length+' carctes y no debe sobrepasar los '+maxlength+ ' carctes.';
	}
	return null;
}


//comprueba la longitud minima del campo
function general_check_field_minlength(field_id, minlength, nombre_field) {
	var field = general_get_element(field_id);
	if (nombre_field==null)	nombre_field = '';
	var valor = general_getValueFromField(field);
	if (valor.length < minlength) {
		alert('En campo '+nombre_field+' ha introducido '+valor.length+' carctes y debe tener como minimo  '+minlength+ ' carctes.');
		field.focus();
		return false;
	}
	return true;
}

//comprueba la longitud minima del campo
function general_chequear_field_minlength(field_id, minlength, nombre_field) {
	var field = general_get_element(field_id);
	if (nombre_field==null)	nombre_field = '';
	var valor = general_getValueFromField(field);
	if (valor.length < minlength) {
		return field.id + '|En campo '+nombre_field+' ha introducido '+valor.length+' carctes y debe tener como minimo  '+minlength+ ' carctes.';
	}
	return null;
}

//comprueba si el campo tiene valor y da mensaje de error
function general_check_field_email(field_id, nombre_field) {
	var field = general_get_element(field_id);
	if (nombre_field==null)	nombre_field = '';
	var valor = general_getValueFromField(field);
	if (valor != '') {
		if (!general_checkEmail(valor)) {
			alert('El campo '+nombre_field+' debe ser una email vlido.');
			field.focus();
			return false;
		}
	}
	return true;
}	

//comprueba si el campo tiene valor y da mensaje de error
function general_chequear_field_email(field_id, nombre_field) {
	var field = general_get_element(field_id);
	if (nombre_field==null)	nombre_field = '';
	var valor = general_getValueFromField(field);
	if (valor != '') {
		if (!general_checkEmail(valor)) {
			return field.id +'|El campo '+nombre_field+' debe ser una email vlido.';
		}
	}
	return null;
}	

function general_check_field_CIF(field_id, nombre_field) {
	var field = general_get_element(field_id);
	if (nombre_field==null)	nombre_field = '';
	var valor = general_getValueFromField(field);
	if (valor != '') {
		if (!general_checkCIF(valor)) {
			alert('El campo '+nombre_field+' debe ser un CIF vlido.');
			field.focus();
			return false;
		}
	}
	return true;
}	

function general_chequear_field_CIF(field_id, nombre_field) {
	var field = general_get_element(field_id);
	if (nombre_field==null)	nombre_field = '';
	var valor = general_getValueFromField(field);
	if (valor != '') {
		if (!general_checkCIF(valor)) {
			return field.id +'|El campo '+nombre_field+' debe ser un CIF vlido.';
		}
	}
	return null;
}	

function general_check_field_DNI(field_id, nombre_field) {
	var field = general_get_element(field_id);
	if (nombre_field==null)	nombre_field = '';
	var valor = general_getValueFromField(field);
	if (valor != '') {
		if (!general_checkDNI(valor)) {
			alert('El campo '+nombre_field+' debe ser un DNI vlido.');
			field.focus();
			return false;
		}
	}
	return true;
}	

function general_chequear_field_DNI(field_id, nombre_field) {
	var field = general_get_element(field_id);
	if (nombre_field==null)	nombre_field = '';
	var valor = general_getValueFromField(field);
	if (valor != '') {
		if (!general_checkDNI(valor)) {
			return field.id +'|El campo '+nombre_field+' debe ser un DNI vlido.';
		}
	}
	return null;
}	

//retorna si la cadena es vacia o nula
function general_strIsEmpty(str) {
	return (str == null) || (str=='')
}
/**
 * Funciones para el formateado de fechas
 */
//valida que el campo tiene una fecha valida
function general_check_date(field_id) {
	var field = general_get_element(field_id);
	if (!general_validateDate(field, 'dd/mm/yyyy', true)) {
		alert('Debe indicar una fecha vlida con el formato dd/mm/yyyy.');
		field.focus();
		return false;
	}
	return true;
}
function general_chequear_date(field_id) {
	var field = general_get_element(field_id);
	if (!general_validateDate(field, 'dd/mm/yyyy', true)) {
		return field.id + '|Debe indicar una fecha vlida con el formato dd/mm/yyyy.';
	}
	return null;
}

//valida que el campo tiene una fecha valida
function general_check_datetime(field_id) {
	var field = general_get_element(field_id);
	if (!general_validateDate(field, 'dd/mm/yyyy', true)) {
		alert('Debe indicar una fecha vlida con el formato dd/mm/yyyy.');
		field.focus();
		return false;
	}
	return true;
}

//valida que el campo tiene una fecha valida
function general_chequear_datetime(field_id) {
	var field = general_get_element(field_id);
	if (!general_validateDate(field, 'dd/mm/yyyy', true)) {
		return field.id + '|Debe indicar una fecha vlida con el formato dd/mm/yyyy.';
	}
	return null;
}

//valida que el campo tiene una fecha valida
function general_chequear_datetime2(field_id) {
	var field = general_get_element(field_id);
	alert('Field:'+field)
	if (!general_validateDate(field, 'dd/mm/yyyy', true) && !general_validateHora(field)) {
		return field.id + '|Debe indicar una fecha vlida con el formato dd/mm/yyyy hh:mm.';
	}
	return null;
}

//valida que el campo tiene una fecha valida
function general_check_hora(field_id) {
	var field = general_get_element(field_id);
	if (!general_validateHora(field)) {
		alert('Debe indicar una hora vlida con el formato hh:mm.');
		field.focus();
		return false;
	}
	return true;
}

//valida que el campo tiene una fecha valida
function general_chequear_hora(field_id) {
	var field = general_get_element(field_id);
	if (!general_validateHora(field)) {
		return field.id + '|Debe indicar una hora vlida con el formato hh:mm.';
	}
	return null;
}

//valida que el campo tiene una fecha valida
function general_check_email(field_id) {
	var field = general_get_element(field_id);
	if (!general_validateEmail(field)) {
		alert('Debe indicar una email vlido.');
		field.focus();
		return false;
	}
	return true;
}


//intenta poner la fecha en formato dd/mm/yyyy correcto
function general_input_date_onblur(field_id) {
	var field = general_get_element(field_id);
	var valor = general_getValueFromField(field);

	valor = general_trim(valor);

	if (valor != null && valor!='') {
		var dateArray = general_get_date_elem(valor);

		var new_valor = dateArray[0]+'/'+dateArray[1]+'/'+dateArray[2];
		if (new_valor != valor)
			field.value = new_valor;
	}
}

//intenta poner la fecha-hora  en formato dd/mm/yyyy hh:nn correcto
function general_input_datetime_onblur(field_id) {
	var field = general_get_element(field_id);
	var valor = getValueFromField(field);

	valor = general_trim(valor);

	if (valor != null && valor!='') {
		var dateArray = general_get_datetime_elem(valor);

		var new_valor = dateArray[0]+'/'+dateArray[1]+'/'+dateArray[2]+' '+dateArray[3]+':'+dateArray[4];
		if (new_valor != valor)
			field.value = new_valor;
	}
}

//intenta poner la fecha-hora  en formato dd/mm/yyyy hh:nn correcto
function general_input_hora_onblur(field_id) {
	var field = general_get_element(field_id);
	var valor = general_getValueFromField(field);

	valor = general_trim(valor);

	if (valor != null && valor!='') {
		var dateArray = general_get_hora_elem(valor);

		var new_valor = dateArray[0]+':'+dateArray[1];
		if (new_valor != valor)
			field.value = new_valor;
	}
}

function general_get_date_elem(fecha_str) {
    var dateArray = new Array('','','');
    
    if (fecha_str != null && fecha_str != '') {
	    var elemento = 0;
	    
		for (var i=0; i <fecha_str.length; i++) {
			var ch = fecha_str.charAt(i);
		    if ( (ch >= '0') && (ch <= '9') ) {
		    	if (elemento<3)
		    		dateArray[elemento] += ch;
		    }
		    else {
		    	elemento++;
		    }
	    }
	    if (general_strIsEmpty(dateArray[1])) {
			var strDate = dateArray[0];
			
			if(strDate.substr(0, 2) > 31) {
				dateArray[0] = strDate.substr(0, 1);
				if(strDate.substr(1, 2) > 12) {
					dateArray[1] = strDate.substr(1, 1);		
					dateArray[2] = strDate.substr(2, 4);		
				} else {
					dateArray[1] = strDate.substr(1, 2);		
					dateArray[2] = strDate.substr(3, 4);		
				}
			} else {
				dateArray[0] = strDate.substr(0, 2);
				if(strDate.substr(2, 2) > 12) {
					dateArray[1] = strDate.substr(2, 1);		
					dateArray[2] = strDate.substr(3, 4);		
				} else {
					dateArray[1] = strDate.substr(2, 2);		
					dateArray[2] = strDate.substr(4, 4);		
				}
			}
	    }
		
		//FORMATEAR
	    var hoy = new Date();
	    if (general_strIsEmpty(dateArray[1]))
	    	dateArray[1] = ""+(hoy.getMonth()+1);
	    if (general_strIsEmpty(dateArray[2]))
	    	dateArray[2] = ""+hoy.getFullYear();

		//DIA	
	    if (dateArray[0].length==1)
	    	dateArray[0] = '0'+dateArray[0];
	    if (dateArray[0].length>2)
	    	dateArray[0] = dateArray[0].substr(0,2);

		//MES
	    if (dateArray[1].length==1)
	    	dateArray[1] = '0'+dateArray[1];
	    if (dateArray[1].length>2)
	    	dateArray[1] = dateArray[1].substr(0,2);

		//AO
	    if (dateArray[2].length==1)
	    	dateArray[2] = '200'+dateArray[2];
	    if (dateArray[2].length==2)
	    	dateArray[2] = '20'+dateArray[2];
	    if (dateArray[2].length>4)
	    	dateArray[2] = dateArray[1].substr(0,4);
			
		//MAXIMO DIA MES
		//Aos bisiestos
		if(dateArray[1] == 2) {
			if(dateArray[2]%4 == 0) {
				if(dateArray[0] > 29)
					dateArray[0] = 29
			} else if (dateArray[0]>28) {
				dateArray[0] = 28
			}
		}

		if ((dateArray[1] == 4 || dateArray[1] == 6 || dateArray[1] == 9 || dateArray[1]==11) && dateArray[0]>30)
			dateArray[0] = 30
		
    }
    
    return dateArray;
}

function general_get_datetime_elem(fecha_str) {
    var dateArray = new Array('','','','','');
    
    if (fecha_str != null && fecha_str != '') {
	    var elemento = 0;
	    
		for (var i=0; i <fecha_str.length; i++) {
			var ch = fecha_str.charAt(i);
		    if ( (ch >= '0') && (ch <= '9') ) {
	    		dateArray[elemento] += ch;
		    }
		    else {
		    	elemento++;
		    }
	    }
	    if (general_strIsEmpty(dateArray[1])) {
			var strDate = dateArray[0];
			
			if(strDate.substr(0, 2) > 31) {
				dateArray[0] = strDate.substr(0, 1);
				if(strDate.substr(1, 2) > 12) {
					dateArray[1] = strDate.substr(1, 1);		
					dateArray[2] = strDate.substr(2, 4);		
				} else {
					dateArray[1] = strDate.substr(1, 2);		
					dateArray[2] = strDate.substr(3, 4);		
				}
			} else {
				dateArray[0] = strDate.substr(0, 2);
				if(strDate.substr(2, 2) > 12) {
					dateArray[1] = strDate.substr(2, 1);		
					dateArray[2] = strDate.substr(3, 4);		
				} else {
					dateArray[1] = strDate.substr(2, 2);		
					dateArray[2] = strDate.substr(4, 4);		
				}
			}
	    }
		
		//FORMATEAR
	    var hoy = new Date();
	    if (general_strIsEmpty(dateArray[1]))
	    	dateArray[1] = ""+(hoy.getMonth()+1);
	    if (general_strIsEmpty(dateArray[2]))
	    	dateArray[2] = ""+hoy.getFullYear();

		//DIA	
	    if (dateArray[0].length==1)
	    	dateArray[0] = '0'+dateArray[0];
	    if (dateArray[0].length>2)
	    	dateArray[0] = dateArray[0].substr(0,2);

		//MES
	    if (dateArray[1].length==1)
	    	dateArray[1] = '0'+dateArray[1];
	    if (dateArray[1].length>2)
	    	dateArray[1] = dateArray[1].substr(0,2);

		//AO
	    if (dateArray[2].length==1)
	    	dateArray[2] = '200'+dateArray[2];
	    if (dateArray[2].length==2)
	    	dateArray[2] = '20'+dateArray[2];
	    if (dateArray[2].length>4)
	    	dateArray[2] = dateArray[1].substr(0,4);
	    	
	    //HORA
	    if (general_strIsEmpty(dateArray[3]))
	    	dateArray[3] = hoy.getHours();
	    	
	    //MINUTOS
	    if (strIsEmpty(dateArray[4]))
	    	dateArray[4] = hoy.getMinutes();
			
		//MAXIMO DIA MES
		//Aos bisiestos
		if(dateArray[1] == 2) {
			if(dateArray[2]%4 == 0) {
				if(dateArray[0] > 29)
					dateArray[0] = 29
			} else if (dateArray[0]>28) {
				dateArray[0] = 28
			}
		}

		if ((dateArray[1] == 4 || dateArray[1] == 6 || dateArray[1] == 9 || dateArray[1]==11) && dateArray[0]>30)
			dateArray[0] = 30
		
    }
    
    return dateArray;
}

function general_get_hora_elem(fecha_str) {
    var dateArray = new Array('','');
    
    if (fecha_str != null && fecha_str != '') {
	    var elemento = 0;
	    
		for (var i=0; i <fecha_str.length; i++) {
			var ch = fecha_str.charAt(i);
		    if ( (ch >= '0') && (ch <= '9') ) {
		    	if (elemento<2)
	    			dateArray[elemento] += ch;
		    }
		    else {
		    	elemento++;
		    }
	    }
	    if (general_strIsEmpty(dateArray[1])) {
			var strDate = dateArray[0];
			dateArray[0] = strDate.substr(0, 2);
			dateArray[1] = strDate.substr(2, 4);		
	    }
		
		//FORMATEAR
	    var hoy = new Date();
	    //MINUTOS
	    if (general_strIsEmpty(dateArray[1]))
	    	dateArray[1] = hoy.getMinutes();
    }
    
    return dateArray;
}

/**
* Check to see if the field is a valid date.
*/
function general_validateDate(field_id, datePattern, isStrict) {
	var field = general_get_element(field_id);
    var fieldValue = general_getValueFromField(field);

    if (fieldValue.length > 0 &&
        datePattern != null && datePattern.length > 0) {

        if (isStrict && datePattern.length != fieldValue.length) {
            return false;
        }
        var dateArray = general_parseDatePattern(datePattern);
        regExprValue = dateArray[0];
        dateRegExp = new RegExp(regExprValue);
        var matched = dateRegExp.exec(fieldValue);
        if (matched == null) {
            return false;
        }
        var day   = (dateArray[1] < 0) ? 1    : matched[dateArray[1]];
        var month = (dateArray[2] < 0) ? 1    : matched[dateArray[2]];
        var year  = (dateArray[3] < 0) ? 2004 : matched[dateArray[3]];
        
        return general_isValidDate(day, month, year);
    }
    return true;
}

function general_validateDatetime(field_id, datePattern, isStrict) {
	var field = general_get_element(field_id);
    var fieldValue = general_getValueFromField(field);

    if (fieldValue.length > 0 &&
        datePattern != null && datePattern.length > 0) {

        if (isStrict && datePattern.length != fieldValue.length) {
            return false;
        }
        var dateArray = general_parseDateTimePattern(datePattern);
        regExprValue = dateArray[0];
        dateRegExp = new RegExp(regExprValue);
        var matched = dateRegExp.exec(fieldValue);
        if (matched == null) {
            return false;
        }
        var day   = (dateArray[1] < 0) ? 1    : matched[dateArray[1]];
        var month = (dateArray[2] < 0) ? 1    : matched[dateArray[2]];
        var year  = (dateArray[3] < 0) ? 2004 : matched[dateArray[3]];
        var hora  = (dateArray[4] < 0) ? 1    : matched[dateArray[4]];
        var min   = (dateArray[5] < 0) ? 1    : matched[dateArray[5]];
        
        return general_isValidDate(day, month, year);
    }
    return true;
}

function general_validateHora(field_id) {
	var field = general_get_element(field_id);
    var fieldValue = general_getValueFromField(field);

    if (fieldValue.length > 0) {

        var exp = new RegExp('^(0[1-9]|1[0-9]|2[0-3]):([0-5][0-9])$');
        return exp.test(fieldValue);
    }
    return true;
}

/**
* Parse a Date Pattern.
* Returns an Array containing a RegExp to parse
* the date and information about positions of day, month and year.
*/
function general_parseDatePattern(datePattern) {
    dateArray = new Array();
    dateArray[0] = "^";
    dateArray[1] = -1;
    dateArray[2] = -1;
    dateArray[3] = -1;
    var currPos = 1;
    var x = 0;

    while (x < datePattern.length) {
        var currChar = datePattern.charAt(x);
        if ((currChar == 'd' && dateArray[1] < 0) || 
            (currChar == 'm' && dateArray[2] < 0) ||
            (currChar == 'y' && dateArray[3] < 0)) {
            var start = x;
            while (x < datePattern.length && currChar == datePattern.charAt(x)) {
                x++;
            }
            var lth = x - start;
            if (currChar == 'd') {
                dateArray[1] = currPos++;
                dateArray[0] = dateArray[0] + "(\\d{1,2})";
            } else if (currChar == 'm') {
                dateArray[2] = currPos++;
                dateArray[0] = dateArray[0] + "(\\d{1,2})";
            } else {
                dateArray[3] = currPos++;
                dateArray[0] = dateArray[0] + ((lth > 2) ?  "(\\d{4})" : "(\\d{1,2})");
            }
        } else {
            dateArray[0] = dateArray[0] + "[" + currChar + "]";
            x++;
        }
    }
    dateArray[0] = dateArray[0] + "$";
    return dateArray;
}

function general_parseDateTimePattern(datePattern) {
    dateArray = new Array();
    dateArray[0] = "^";
    dateArray[1] = -1;
    dateArray[2] = -1;
    dateArray[3] = -1;
    dateArray[4] = -1;
    dateArray[5] = -1;
    var currPos = 1;
    var x = 0;

    while (x < datePattern.length) {
        var currChar = datePattern.charAt(x);
        if ((currChar == 'd' && dateArray[1] < 0) || 
            (currChar == 'm' && dateArray[2] < 0) ||
            (currChar == 'y' && dateArray[3] < 0) ||
            (currChar == 'n' && dateArray[4] < 0) ||
            (currChar == 's' && dateArray[5] < 0)
            ) {
            var start = x;
            while (x < datePattern.length && currChar == datePattern.charAt(x)) {
                x++;
            }
            var lth = x - start;
            if (currChar == 'd') {
                dateArray[1] = currPos++;
                dateArray[0] = dateArray[0] + "(\\d{1,2})";
            } else if (currChar == 'm') {
                dateArray[2] = currPos++;
                dateArray[0] = dateArray[0] + "(\\d{1,2})";
            } else if (currChar == 'y') {
                dateArray[3] = currPos++;
                dateArray[0] = dateArray[0] + ((lth > 2) ?  "(\\d{4})" : "(\\d{1,2})");
            } else if (currChar == 'n') {
                dateArray[4] = currPos++;
                dateArray[0] = dateArray[0] + "(\\d{1,2})";
            } else if (currChar == 's') {
                dateArray[5] = currPos++;
                dateArray[0] = dateArray[0] + "(\\d{1,2})";
            }
        } else {
            dateArray[0] = dateArray[0] + "[" + currChar + "]";
            x++;
        }
    }
    dateArray[0] = dateArray[0] + "$";
    return dateArray;
}


/**
* Validate the day, month & year
*/
function general_isValidDate(day, month, year) {
    if (month < 1 || month > 12) {
        return false;
    }
    if (day < 1 || day > 31) {
        return false;
    }
    if ((month == 4 || month == 6 || month == 9 || month == 11) &&
        (day == 31)) {
        return false;
    }
    if (month == 2) {
        var leap = (year % 4 == 0 &&
           (year % 100 != 0 || year % 400 == 0));
        if (day>29 || (day == 29 && !leap)) {
            return false;
        }
    }
    return true;
}   

function general_isValidDateTime(day, month, year, hora, min) {
    if (month < 1 || month > 12) {
        return false;
    }
    if (day < 1 || day > 31) {
        return false;
    }
    if ((month == 4 || month == 6 || month == 9 || month == 11) &&
        (day == 31)) {
        return false;
    }
    if (month == 2) {
        var leap = (year % 4 == 0 &&
           (year % 100 != 0 || year % 400 == 0));
        if (day>29 || (day == 29 && !leap)) {
            return false;
        }
    }
    if (hora < 1 || hora > 24) {
    	return false;
    }
    if (min < 0 || min > 59) {
    	return false;
    }
    return true;
}   


//valida que el campo tiene un valor entero valido
function general_check_field_integer(field_id, mensaje) {
	var field = general_get_element(field_id);
	if(mensaje==null) mensaje = '';
	if (!general_validateInteger(field)) {
		alert('Debe indicar valor entero vlido para el campo '+mensaje+'.');
		field.focus();
		return false;
	}
	return true;
}
//valida que el campo tiene un valor entero valido
function general_chequear_field_integer(field_id, mensaje) {
	var field = general_get_element(field_id);
	if(mensaje==null) mensaje = '';
	if (!general_validateInteger(field)) {
		return field.id + '|Debe indicar valor entero vlido para el campo '+mensaje+'.';
	}
	return null;
}

/**
* Check to see if the field is a valid integer.
*/
function general_validateInteger(field_id) {
	var field = general_get_element(field_id);
    var fieldValue = general_getValueFromField(field);
    if (fieldValue.length > 0) {
        var iValue = parseInt(fieldValue);
        return (!isNaN(iValue) && iValue == fieldValue && iValue >= -2147483648 && iValue <= 2147483647);
    }
    return true;
}

//valida que el campo tiene un valor double valido
function general_check_field_double(field_id, mensaje) {
	var field = general_get_element(field_id);
	if(mensaje==null) mensaje = '';
	if (!general_validateInteger(field)) {
		alert('Debe indicar valor numrico vlido para el campo '+mensaje+'.');
		field.focus();
		return false;
	}
	return true;
}
//valida que el campo tiene un valor double valido
function general_chequear_field_double(field_id, mensaje) {
	var field = general_get_element(field_id);
	if(mensaje==null) mensaje = '';
	if (!general_validateInteger(field)) {
		return field.id + 'Debe indicar valor numrico vlido para el campo '+mensaje+'.';
	}
	return null;
}


/**
* Check to see if the field is a valid double.
*/
function general_validateDouble(field_id) {
	var field = general_get_element(field_id);
    var fieldValue = general_getValueFromField(field);
    if (fieldValue.length > 0) {
        var fValue = parseFloat(fieldValue);
        return (!isNaN(fValue) && fValue == fieldValue);
    }
    return true;
}

/**
* Check to see if the field is a valid email address.
*/
function general_validateEmail(field_id) {
	var field = general_get_element(field_id);
    var fieldValue = general_getValueFromField(field);
    if (fieldValue.length > 0) {
        return general_checkEmail(fieldValue);
    }
    return true;
}

/**
 * Reference: Sandeep V. Tamhankar (stamhankar@hotmail.com),
 * http://javascript.internet.com
 */
function general_checkEmail(emailStr) {
    if (emailStr.length == 0) {
        return true;
    }
    // TLD checking turned off by default
    var checkTLD=0;
    var knownDomsPat=/^(com|net|org|edu|int|mil|gov|arpa|biz|aero|name|coop|info|pro|museum|es)$/;
    var emailPat=/^(.+)@(.+)$/;
    var specialChars="\\(\\)><@,;:\\\\\\\"\\.\\[\\]";
    var validChars="\[^\\s" + specialChars + "\]";
    var quotedUser="(\"[^\"]*\")";
    var ipDomainPat=/^\[(\d{1,3})\.(\d{1,3})\.(\d{1,3})\.(\d{1,3})\]$/;
    var atom=validChars + '+';
    var word="(" + atom + "|" + quotedUser + ")";
    var userPat=new RegExp("^" + word + "(\\." + word + ")*$");
    var domainPat=new RegExp("^" + atom + "(\\." + atom +")*$");
    var matchArray=emailStr.match(emailPat);
    if (matchArray==null) {
        return false;
    }
    var user=matchArray[1];
    var domain=matchArray[2];
    for (i=0; i<user.length; i++) {
        if (user.charCodeAt(i)>127) {
            return false;
        }
    }
    for (i=0; i<domain.length; i++) {
        if (domain.charCodeAt(i)>127) {
            return false;
        }
    }
    if (user.match(userPat)==null) {
        return false;
    }
    var IPArray=domain.match(ipDomainPat);
    if (IPArray!=null) {
        for (var i=1;i<=4;i++) {
            if (IPArray[i]>255) {
                return false;
            }
        }
        return true;
    }
    var atomPat=new RegExp("^" + atom + "$");
    var domArr=domain.split(".");
    var len=domArr.length;
    for (i=0;i<len;i++) {
        if (domArr[i].search(atomPat)==-1) {
            return false;
        }
    }
    if (checkTLD && domArr[domArr.length-1].length!=2 && 
        domArr[domArr.length-1].search(knownDomsPat)==-1) {
        return false;
    }
    if (len<2) {
        return false;
    }
    return true;
}

function general_checkCIF(texto) {
	var pares = 0;
	var impares = 0;
	var suma;
	var ultima;
	var unumero;
	var uletra = new Array("J", "A", "B", "C", "D", "E", "F", "G", "H", "I");
	var xxx;
    
    texto = texto.toUpperCase();
    
    var regular =/^[ABCDEFGHKLMNPQS]\d\d\d\d\d\d\d[0-9,A-J]$/g;
    if (!regular.exec(texto)) return false;
         
     ultima = texto.substr(8,1);

     for (var cont = 1 ; cont < 7 ; cont ++){
     	xxx = (2 * parseInt(texto.substr(cont++,1))).toString() + "0";
        impares += parseInt(xxx.substr(0,1)) + parseInt(xxx.substr(1,1));
        pares += parseInt(texto.substr(cont,1));
     }
     xxx = (2 * parseInt(texto.substr(cont,1))).toString() + "0";
     impares += parseInt(xxx.substr(0,1)) + parseInt(xxx.substr(1,1));
     
     suma = (pares + impares).toString();
     unumero = parseInt(suma.substr(suma.length - 1, 1));
     unumero = (10 - unumero).toString();
     if(unumero == 10) unumero = 0;
     
     if ((ultima == unumero) || (ultima == uletra[unumero]))
         return true;
     else
         return false; 
}

function general_checkDNI(texto) {
	return /^\d{8}$/.test(texto);
}

//validacion tinymce
function general_myCustomURLConverter(url, node, on_save) {
	// Return URL
	return url;
}


//dada una url del tipo /algo?param1=value1&param2=value2 retorna el valor de un parametro
function general_getURLParamValue(url, param) {
	var resultado = "";
	var url_pos = url.indexOf("?");
	if (url_pos >= 0) {
		var new_url = url.substring(url_pos+1);
		var params = new_url.split("&"); 
		for (var i=0; i<params.length; i++) {
			var pair = params[i].split("=");
			if (pair[0] == param) {
				resultado = pair[1];
			}
		}
	}
	return resultado;	 
}

function general_textareaTextCounter(field_id,counter,maxlimit) {
	try {
		var field = general_get_element(field_id);
		//ajusta el limite
		var new_maxlimit = maxlimit-10;
		// text width//
		var fieldWidth =  parseInt(field.offsetWidth);
		var charcnt = field.value.length;        
	
		// trim the extra text
		if (charcnt > new_maxlimit) { 
			field.value = field.value.substring(0, new_maxlimit);
		}
	
		else { 
			// progress bar percentage
			var percentage = parseInt(100 - (( new_maxlimit - charcnt) * 100)/new_maxlimit) ;
			$('#'+counter).width(parseInt((fieldWidth*percentage)/100));
			$('#'+counter).html("L&iacute;mite: "+percentage+"%");
			//document.getElementById(counter).style.width =  ;
			//document.getElementById(counter).innerHTML="L&iacute;mite: "+percentage+"%"
			// color correction on style from CCFFF -> CC0000
			general_textareaSetcolor('#'+counter,percentage,"background-color");
		}
	}
	catch(exception) {
		general_msg_error("general_textareaTextCounter:"+exception);
	}
}

function general_textareaSetcolor(obj_id,percentage,prop){
	try{
		var color = "rgb(80%,"+(100-percentage)+"%,"+(100-percentage)+"%)";
		$(obj_id).css(prop, color);
	}
	catch(exception) {
		general_msg_error("general_textareaSetcolor:"+exception);
	}
}


//hace un submit de un formulario con el action por parametro 
function general_submit_formid(formid, action) {
	$("div#general_base form#"+formid+":eq(0)").each(function(){
		this.action = action;
		this.submit(); 
	});
}

//transforma los <div id="..."> <ul>...  en pestanas
function general_tab_convert(div_id_contenedor) {
try {
	$(general_base_jquery_id+div_id_contenedor+' > ul').tabs({
		show: function() {
        	general_tab_cambio(div_id_contenedor, general_tab_get_selected(div_id_contenedor)  );
    	}	
	});
}
catch(err) {
	$(general_base_jquery_id+'#general_js_errores').append('<br>ERROR general_tab_convert('+div_id_contenedor+'):'+err);
	$(general_base_jquery_id+'#general_js_errores').show();
}
	
	/*
	$(div_id_contenedor+' > ul').tabs({
		click: function() {
        	alert('click callback');
    	},
    	hide: function() {
        	alert('hide callback');
    	},
    	show: function() {
        	alert('show callback');
    	}	
	});
	*/
}


function general_tab_cambio(div_id_contenedor, new_posicion) {
}


//retorna el numero de pestaa activa
function general_tab_get_selected(div_id_contenedor) {
	return $(general_base_jquery_id+div_id_contenedor+' ul').tabsSelected();
}

//fuerza a seleccionar una pestaa
function general_tab_select(div_id_contenedor, posicion) {
	return $(general_base_jquery_id+div_id_contenedor+' ul').tabsClick( posicion );
}


//pone todas las pestaas desactivadas
function general_tab_disable_all(div_id_contenedor) {
	var arr = $(general_base_jquery_id+div_id_contenedor+' > ul li');
	for(var posicion=1; posicion<= arr.length; posicion++)
		general_tab_disable_number(div_id_contenedor, posicion);
}

//pone todas las pestaas desactivadas menos las actual
function general_tab_disable_others(div_id_contenedor) {
	var arr = $(general_base_jquery_id+div_id_contenedor+' > ul li');
	var pos_enabled = general_tab_get_selected(div_id_contenedor);
	for(var posicion=1; posicion<= arr.length; posicion++) {
		if (pos_enabled != posicion) { 
			general_tab_disable_number(div_id_contenedor, posicion);
		}
	}
}


//pone todas las pestaas desactivadas
function general_tab_disable_number(div_id_contenedor, posicion) {
	$(general_base_jquery_id+div_id_contenedor+' ul').tabsDisable(posicion); 
}

//pone todas las pestaas activadas
function general_tab_enable_all(div_id_contenedor) {
	var arr = $(general_base_jquery_id+div_id_contenedor+' > ul li');
	for(var posicion=1; posicion<= arr.length; posicion++)
		general_tab_enable_number(div_id_contenedor, posicion);
}

function general_tab_enable_number(div_id_contenedor, posicion) {
	$(div_id_contenedor+' ul').tabsEnable(posicion); 
}

function general_form_input_change(form_id, elem_id) {
	//alert("form:"+form_id+" elem:"+elem_id);
}

function general_boton_volver(){}
function general_boton_insertar() {}
function general_boton_guardar() {}
function general_boton_cancelar(){}
function general_boton_borrar() {}
function general_boton_ayuda(){}


function general_imagen_filename_to_disabled(src) {
	var pos = src.indexOf('_disabled.', 0);
	if (pos==-1)
		return src;
	else {
		pos = src.indexOf('.', 0);
		return src.substring(0, pos) + '_disabled ' + src.substring(pos);
	}
}
function general_imagen_filename_to_enabled(src) {
	var pos = src.indexOf('_disabled.', 0);
	if (pos==-1)
		return src;
	else
		return src.substring(0, pos) + src.substring(pos+9);
}


function general_boton_vacio() {}

function general_carga_boton(boton_id) {
  try {
	var boton = general_get_element(boton_id);
	var href_old = $(boton).attr('href');
	var onclick_old = $(boton).attr('onclick');
	$('img.general_img_boton', boton).each(function(){
		this.gen_img_disabled = new Image();
		this.gen_img = new Image();

		this.gen_img_disabled.src = $(this).attr('src_old_disabled');
		this.gen_img.src =  $(this).attr('src_old');
	});
	$(boton).attr('href_old', href_old);
	$(boton).attr('onclick_old', onclick_old);
  } catch(err) {
  	general_msg_error(err);
  	throw(err);
  }
}

//pone un boton como activo
function general_boton_enabled(boton_id) {
  try {
	var boton = general_get_element(boton_id);
	var href_old = $(boton).attr('href_old');
	var onclick_old = $(boton).attr('onclick_old');
	if (!general_strIsEmpty(href_old))
		boton.href = href_old;
	else
		boton.href = '#'; 
	if (!general_strIsEmpty(onclick_old))
		boton.onclick = click_old;
	else
		boton.onclick = null;
	general_get_element(boton_id+' img.general_img_boton').src = 
		general_get_element(boton_id+' img.general_img_boton').gen_img.src;
  } catch(err) {
  	general_msg_error(err);
  	throw(err);
  }
}

//pone un boton como no activo
function general_boton_disabled(boton_id) {
  try {
	var boton = general_get_element(boton_id);
	general_get_element(boton).href = '#';
	general_get_element(boton).onclick = null;
	general_get_element(boton_id+' img.general_img_boton').src = 
		general_get_element(boton_id+' img.general_img_boton').gen_img_disabled.src;
  } catch(err) {
  	general_msg_error(err);
  	throw(err);
  }
}

function general_msg_error(cadena) {
	$('div#general_js_errores').append(cadena+"<br>");
	$('div#general_js_errores').show();
}

function general_get_boolean(valor) {
	//si es cadena lo tratamos como tal
	if (general_typeof_string(valor)) {
		return 
			("true" == valor) || 
			("t" == valor) ||
			("si" == valor) ||
			("s" == valor) ||
			("1" == valor);
	}
	else
		return valor;
}

//pone el estado del boton segun parametros
// activo debe ser un parametro boolean, o una cadena 'true'|'t'|'si'|'s'|'1' para true
function general_boton_change_state(boton_id, activo) {
	if (general_get_boolean(activo))
		general_boton_enabled(boton_id);
	else
		general_boton_disabled(boton_id);
}

function general_tiny_mce_convert_word(type, content) {
	switch (type) {
		// Gets executed before the built in logic performes it's cleanups
		case "before":
			content = content.toLowerCase(); // Some dummy logic
			break;

		// Gets executed after the built in logic performes it's cleanups
		case "after":
			content = content.toLowerCase(); // Some dummy logic
			break;
	}

	return content;
}


function general_ahrefmodulo_params(modulo, accion, tipollamada, parametros) {
	var url = modulo+'.'+accion+'.'+tipollamada;
	if (!general_strIsEmpty(parametros)) {
		if ( parametros.substr(0, 1) != '?') {
			url += '?';
		}
		url += parametros;
	}
	general_ahrefmodulo(url);
}

function general_ahrefmodulo(url) {
	location.href = url;
}


function general_get_anchor(){
     
     var direccion = location.href;
     var final = direccion.length;
     var indice_anchor = direccion.indexOf('#');
     if (-1 != indice_anchor)
     return direccion.substring(indice_anchor+1,final)
     else return null;
}

//aade al array el error si no es vacio
function general_array_add_if_not_empty(array, cadena) {
	if (!general_strIsEmpty(cadena)) {
		array[array.length] = cadena;
	}
}    

function general_form_error_clear(form_name) {
	$(form_name+' div.general_div_form_error').html('').removeClass('general_error');
}
function general_form_aviso_clear(form_name) {
	$(form_name+' div.general_div_form_aviso').html('').removeClass('general_info');
}


function general_form_error_show(form_name, error) {
	if (!general_strIsEmpty(error)) {
		var posicion = error.indexOf('|');
		if (posicion>=0) {
			var name = error.substring(0, posicion);
			var cadena = error.substring(posicion+1);
			var val_antes = $(form_name+' div#'+name+'_error').html();
			var div_error = $(form_name+' div#'+name+'_error');
			if (!general_strIsEmpty(val_antes))
				$(div_error).append("<br>");
			if (!$(div_error).hasClass('general_error'))
				$(div_error).addClass('general_error');
			$(div_error).append(cadena);
			
			var div_form_error = $(form_name + ' div:eq(0)');
			if (!$(div_form_error).hasClass('general_error'))
				$(div_form_error).addClass('general_error');
			var val_form_antes = $(div_form_error).html();
			if (general_strIsEmpty(val_form_antes)) {
				$(div_form_error).append("<strong>Debe corregir los siguientes errores antes de continuar:</strong><br>");
			}
			$(div_form_error).append(cadena+"<br>");
		}
	}
}

function general_form_aviso_show(form_name, error) {
	if (!general_strIsEmpty(error)) {
		var posicion = error.indexOf('|');
		if (posicion>=0) {
			var name = error.substring(0, posicion);
			var cadena = error.substring(posicion+1);
			var val_antes = $(form_name+' div#'+name+'_aviso').html();
			var div_error = $(form_name+' div#'+name+'_aviso');
			if (!general_strIsEmpty(val_antes))
				$(div_error).append("<br>");
			if (!$(div_error).hasClass('general_info'))
				$(div_error).addClass('general_info');
			$(div_error).append(cadena);
			
			var div_form_error = $(form_name + ' div:eq(1)');
			if (!$(div_form_error).hasClass('general_info'))
				$(div_form_error).addClass('general_info');
			var val_form_antes = $(div_form_error).html();
			if (general_strIsEmpty(val_form_antes)) {
				$(div_form_error).append("<strong>Debe comprobar la correcin de los siguientes avisos:</strong><br>");
			}
			$(div_form_error).append(cadena+"<br>");
		}
	}
}
     
function general_form_error_focus(form_name, error) {
	try {
		if (!general_strIsEmpty(error)) {
			var posicion = error.indexOf('|');
			if (posicion>=0) {
				var name = error.substring(0, posicion);
				var div_focus = $(form_name+' #'+name+':eq(0)');
				if (div_focus != undefined)
					div_focus.focus();
			}
		}
	}
	catch(e) {
	}
}

//Muestra/Oculta #general_[id_hide]_hide segun [select_cambio] si coincide con [valor_cambio_S]
function general_toggle_hide(id_select_cambio, valor_cambio_S, id_hide) {
	if(general_select_get_option_value_selected(id_select_cambio) == valor_cambio_S) {
		$("#general_" + id_hide + "_hide").show();
	} else {
		$("#general_" + id_hide + "_hide").hide();
	}
}


function general_abrir_popup(theURL, winName, features, width, height) {
  var left = (screen.availWidth - width) / 2;
  var top = (screen.availHeight - height) / 2;
  var caracteristicas = features + ",width=" + width + ",height=" + height + ",left=" + left + ",top=" + top;
  return window.open(theURL, winName, caracteristicas);
}

function general_abrir_popup_div(theURL, titulo) {
	tb_show(titulo, theURL, false);
}


// abre una ventana centrada
function general_abrir_ventana_centrada(theURL, winName, features, width, height) {
	var left = (screen.availWidth - width) / 2;
	var top = (screen.availHeight - height) / 2;
	if(features == "") {
		features = "scrollbars=yes,statusbar=yes,resizable=yes";
	}
	if(width == "" || height == "") {
		features = features + ",fullscreen=true"
	}
	var caracteristicas = features + ",width=" + width + ",height=" + height + ",left=" + left + ",top=" + top;
	
  	window.open(theURL, winName, caracteristicas);
}

// retorna true si el dominio parece valido
// info obtenida de http://es.wikipedia.org/wiki/Anexo:Lista_de_dominios_de_Internet
function general_valid_domain(email) {
	if (general_strIsEmpty(email))
		return false;
		
	var sdom = email.toLowerCase();
	var dom7 = sdom.substring(sdom.length - 7); 
	var dom5 = sdom.substring(sdom.length - 5); 
	var dom4 = sdom.substring(sdom.length - 4); 
	var dom3 = sdom.substring(sdom.length - 3); 
	var dom2 = sdom.substring(sdom.length - 2); 

	if(dom7=='.museum') return true;
	if(dom7=='.travel') return true;

	if (dom5=='.aero') return true;
	if (dom5=='.asia') return true;
	if (dom5=='.coop') return true;
	if (dom5=='.info') return true;
	if (dom5=='.jobs') return true;
	if (dom5=='.mobi') return true;
	if (dom5=='.name') return true;
	if (dom5=='.root') return true;

	if (dom4=='.biz') return true;
	if (dom4=='.cat') return true;
	if (dom4=='.com') return true;
	if (dom4=='.edu') return true;
	if (dom4=='.gov') return true;
	if (dom4=='.int') return true;
	if (dom4=='.mil') return true;
	if (dom4=='.net') return true;
	if (dom4=='.org') return true;
	if (dom4=='.pro') return true;
	if (dom4=='.tel') return true;

	if (dom3=='.ac') return true;
	if (dom3=='.ad') return true;
	if (dom3=='.ae') return true;
	if (dom3=='.af') return true;
	if (dom3=='.ag') return true;
	if (dom3=='.ai') return true;
	if (dom3=='.al') return true;
	if (dom3=='.am') return true;
	if (dom3=='.an') return true;
	if (dom3=='.ao') return true;
	if (dom3=='.aq') return true;
	if (dom3=='.ar') return true;
	if (dom3=='.as') return true;
	if (dom3=='.at') return true;
	if (dom3=='.au') return true;
	if (dom3=='.aw') return true;
	if (dom3=='.ax') return true;
	if (dom3=='.az') return true;
	if (dom3=='.ba') return true;
	if (dom3=='.bb') return true;
	if (dom3=='.bd') return true;
	if (dom3=='.be') return true;
	if (dom3=='.bf') return true;
	if (dom3=='.bg') return true;
	if (dom3=='.bh') return true;
	if (dom3=='.bi') return true;
	if (dom3=='.bj') return true;
	if (dom3=='.bm') return true;
	if (dom3=='.bn') return true;
	if (dom3=='.bo') return true;
	if (dom3=='.br') return true;
	if (dom3=='.bs') return true;
	if (dom3=='.bt') return true;
	if (dom3=='.bw') return true;
	if (dom3=='.by') return true;
	if (dom3=='.bz') return true;
	if (dom3=='.ca') return true;
	if (dom3=='.cc') return true;
	if (dom3=='.cd') return true;
	if (dom3=='.cf') return true;
	if (dom3=='.cg') return true;
	if (dom3=='.ch') return true;
	if (dom3=='.ci') return true;
	if (dom3=='.ck') return true;
	if (dom3=='.cl') return true;
	if (dom3=='.cm') return true;
	if (dom3=='.cn') return true;
	if (dom3=='.co') return true;
	if (dom3=='.cr') return true;
	if (dom3=='.cu') return true;
	if (dom3=='.cv') return true;
	if (dom3=='.cx') return true;
	if (dom3=='.cy') return true;
	if (dom3=='.cz') return true;
	if (dom3=='.de') return true;
	if (dom3=='.dj') return true;
	if (dom3=='.dk') return true;
	if (dom3=='.dm') return true;
	if (dom3=='.do') return true;
	if (dom3=='.dz') return true;
	if (dom3=='.ec') return true;
	if (dom3=='.ee') return true;
	if (dom3=='.eg') return true;
	if (dom3=='.er') return true;
	if (dom3=='.es') return true;
	if (dom3=='.et') return true;
	if (dom3=='.eu') return true;
	if (dom3=='.fi') return true;
	if (dom3=='.fj') return true;
	if (dom3=='.fk') return true;
	if (dom3=='.fm') return true;
	if (dom3=='.fo') return true;
	if (dom3=='.fr') return true;
	if (dom3=='.ga') return true;
	if (dom3=='.gd') return true;
	if (dom3=='.ge') return true;
	if (dom3=='.gf') return true;
	if (dom3=='.gg') return true;
	if (dom3=='.gh') return true;
	if (dom3=='.gi') return true;
	if (dom3=='.gl') return true;
	if (dom3=='.gm') return true;
	if (dom3=='.gn') return true;
	if (dom3=='.gp') return true;
	if (dom3=='.gq') return true;
	if (dom3=='.gr') return true;
	if (dom3=='.gs') return true;
	if (dom3=='.gt') return true;
	if (dom3=='.gu') return true;
	if (dom3=='.gw') return true;
	if (dom3=='.gy') return true;
	if (dom3=='.hk') return true;
	if (dom3=='.hm') return true;
	if (dom3=='.hn') return true;
	if (dom3=='.hr') return true;
	if (dom3=='.ht') return true;
	if (dom3=='.hu') return true;
	if (dom3=='.id') return true;
	if (dom3=='.ie') return true;
	if (dom3=='.il') return true;
	if (dom3=='.im') return true;
	if (dom3=='.in') return true;
	if (dom3=='.io') return true;
	if (dom3=='.iq') return true;
	if (dom3=='.ir') return true;
	if (dom3=='.is') return true;
	if (dom3=='.it') return true;
	if (dom3=='.je') return true;
	if (dom3=='.jm') return true;
	if (dom3=='.jo') return true;
	if (dom3=='.jp') return true;
	if (dom3=='.ke') return true;
	if (dom3=='.kg') return true;
	if (dom3=='.kh') return true;
	if (dom3=='.ki') return true;
	if (dom3=='.km') return true;
	if (dom3=='.kn') return true;
	if (dom3=='.kp') return true;
	if (dom3=='.kr') return true;
	if (dom3=='.kw') return true;
	if (dom3=='.ky') return true;
	if (dom3=='.kz') return true;
	if (dom3=='.la') return true;
	if (dom3=='.lb') return true;
	if (dom3=='.lc') return true;
	if (dom3=='.li') return true;
	if (dom3=='.lk') return true;
	if (dom3=='.lr') return true;
	if (dom3=='.ls') return true;
	if (dom3=='.lt') return true;
	if (dom3=='.lu') return true;
	if (dom3=='.lv') return true;
	if (dom3=='.ly') return true;
	if (dom3=='.ma') return true;
	if (dom3=='.mc') return true;
	if (dom3=='.md') return true;
	if (dom3=='.me') return true;
	if (dom3=='.mg') return true;
	if (dom3=='.mh') return true;
	if (dom3=='.mk') return true;
	if (dom3=='.ml') return true;
	if (dom3=='.mm') return true;
	if (dom3=='.mn') return true;
	if (dom3=='.mo') return true;
	if (dom3=='.mp') return true;
	if (dom3=='.mq') return true;
	if (dom3=='.mr') return true;
	if (dom3=='.ms') return true;
	if (dom3=='.mt') return true;
	if (dom3=='.mu') return true;
	if (dom3=='.mv') return true;
	if (dom3=='.mw') return true;
	if (dom3=='.mx') return true;
	if (dom3=='.my') return true;
	if (dom3=='.mz') return true;
	if (dom3=='.na') return true;
	if (dom3=='.nc') return true;
	if (dom3=='.ne') return true;
	if (dom3=='.nf') return true;
	if (dom3=='.ng') return true;
	if (dom3=='.ni') return true;
	if (dom3=='.nl') return true;
	if (dom3=='.no') return true;
	if (dom3=='.np') return true;
	if (dom3=='.nr') return true;
	if (dom3=='.ni') return true;
	if (dom3=='.nu') return true;
	if (dom3=='.nz') return true;
	if (dom3=='.om') return true;
	if (dom3=='.pa') return true;
	if (dom3=='.pe') return true;
	if (dom3=='.pf') return true;
	if (dom3=='.pg') return true;
	if (dom3=='.ph') return true;
	if (dom3=='.pk') return true;
	if (dom3=='.pl') return true;
	if (dom3=='.pm') return true;
	if (dom3=='.pn') return true;
	if (dom3=='.pr') return true;
	if (dom3=='.ps') return true;
	if (dom3=='.pt') return true;
	if (dom3=='.pw') return true;
	if (dom3=='.py') return true;
	if (dom3=='.qa') return true;
	if (dom3=='.re') return true;
	if (dom3=='.ro') return true;
	if (dom3=='.rs') return true;
	if (dom3=='.ru') return true;
	if (dom3=='.rw') return true;
	if (dom3=='.sa') return true;
	if (dom3=='.sb') return true;
	if (dom3=='.sc') return true;
	if (dom3=='.sd') return true;
	if (dom3=='.se') return true;
	if (dom3=='.sg') return true;
	if (dom3=='.sh') return true;
	if (dom3=='.si') return true;
	if (dom3=='.sk') return true;
	if (dom3=='.sl') return true;
	if (dom3=='.sm') return true;
	if (dom3=='.sn') return true;
	if (dom3=='.so') return true;
	if (dom3=='.sr') return true;
	if (dom3=='.st') return true;
	if (dom3=='.su') return true;
	if (dom3=='.sv') return true;
	if (dom3=='.sy') return true;
	if (dom3=='.sz') return true;
	if (dom3=='.tc') return true;
	if (dom3=='.td') return true;
	if (dom3=='.tf') return true;
	if (dom3=='.tg') return true;
	if (dom3=='.th') return true;
	if (dom3=='.tj') return true;
	if (dom3=='.tk') return true;
	if (dom3=='.tl') return true;
	if (dom3=='.tm') return true;
	if (dom3=='.tn') return true;
	if (dom3=='.to') return true;
	if (dom3=='.tr') return true;
	if (dom3=='.tt') return true;
	if (dom3=='.tv') return true;
	if (dom3=='.tw') return true;
	if (dom3=='.tz') return true;
	if (dom3=='.ua') return true;
	if (dom3=='.ug') return true;
	if (dom3=='.uk') return true;
	if (dom3=='.um') return true;
	if (dom3=='.us') return true;
	if (dom3=='.uy') return true;
	if (dom3=='.uz') return true;
	if (dom3=='.va') return true;
	if (dom3=='.vc') return true;
	if (dom3=='.ve') return true;
	if (dom3=='.vg') return true;
	if (dom3=='.vi') return true;
	if (dom3=='.vn') return true;
	if (dom3=='.vu') return true;
	if (dom3=='.wf') return true;
	if (dom3=='.ws') return true;
	if (dom3=='.ye') return true;
	if (dom3=='.yt') return true;
	if (dom3=='.yu') return true;
	if (dom3=='.za') return true;
	if (dom3=='.zm') return true;
	if (dom3=='.zw') return true;
	if (dom3=='.bv') return true;
	if (dom3=='.gb') return true;
	if (dom3=='.sj') return true;
	if (dom3=='.cs') return true;
	if (dom3=='.eh') return true;
	if (dom3=='.ic') return true;
	if (dom3=='.kp') return true;
	
	return false;
}

//asigna el campo hidden el valor por parametro (si es necesario crea el input) 
function general_create_input_hidden(form_id, input_name, input_value) {
    var array_input = $(form_id).find(':hidden[@name=' + input_name + ']');
    if (array_input.length == 0) {
    	$(form_id).append('<input type="hidden" name="' + input_name + '" value="' + input_value + '"/>');
    }
    else {
	    $(input_name).val(input_value);
    }
}

//localida el form (lo sea si es necesario)
function general_find_or_create_form(form_id) {
	var form = general_get_element2(form_id);
	if (form==null) {
		var lform_id = form_id;
		//si es cadena..
		if (general_typeof_string(form_id)) {
			//..comprueba si lleva # (selector css)
			var posicion = form_id.indexOf('#');
			if (posicion > 0) {
				lform_id = form_id.substring(posicion+1);
			}
		}
		$('body').append("<form name='"+lform_id+"' id='"+lform_id+"' method='post'></form>");
		form = general_get_element2(form_id);
	}
	return form;
}

//asigna el form "general_form_accion" los parametros
function general_ir_url(url, params) {
	var form = general_find_or_create_form('form#general_form_accion');
	var lparams = params.split("&"); 
	for (var i=0; i<lparams.length; i++) {
		var pair = lparams[i].split("=");
		general_create_input_hidden(form, pair[0], pair[1]);
	}
	form.action = url;
	form.submit();
}

function general_div_avisos_clear() {
  try {
    $('div.general_div_for_error').html('').removeClass('general_error');
    $('div.general_div_for_exito').html('').removeClass('general_exito');
  }catch(e) {
    general_msg_error('Se ha producido un error en la funcin general_div_avisos_clear');
  }
}


//dada una cadena de texto (parametro xml) extrae primer valor de la etiqueta 
function general_xml_value(xml, etiqueta) {
  try {
    if (general_strIsEmpty(xml))
    	return null;
    var pos1 = xml.indexOf("<"+etiqueta+">");
    var pos2 = xml.indexOf("</"+etiqueta+">");
    if (pos1>=0 && pos2>=0) {
      return xml.substring(pos1+etiqueta.length+2, pos2);
    }
    return null;
  } catch(e) {
  	general_msg_error('Se ha producido un error en la funcion general_xml_value');
  }
}