
// jQuery_Auto 0.9
// Automatic functions for webpages (using the wonderful jQuery library)

// Copyright: (c) 2006, Michal Tatarynowicz (tatarynowicz@gmail.com)
// Licenced as Public Domain (http://creativecommons.org/licenses/publicdomain/)
// $Id: jquery_auto.js 426 2006-05-06 19:54:39Z Michał $


// Initialization
$.auto = {
	init: function() {
		for (module in $.auto) {
			if ($.auto[module].init)
				$.auto[module].init();
		}
	}
};

$(document).ready($.auto.init);


// Auto-hidden elements
$.auto.hide = {
	init: function() {
		$('.Hide').hide();
	}
};


// Mouse hover
$.auto.hover = {

	init: function() {
		$('IMG.Hover')
			.bind('mouseover', this.enter)
			.bind('mouseout', this.exit)
			.each(this.preload);
		$('.Hover tbody tr')
			.bind('mouseover', this.enterTR)
			.bind('mouseout', this.exitTR);
		$('INPUT.fecha')
			.bind('blur', this.input_date_onblur);
	},

	preload: function() {
		this.preloaded = new Image;
		this.preloaded.src = this.src.replace(/^(.+)(\.[a-z]+)$/, "$1_over$2");
	},

	enter: function() {
		this.src = this.src.replace(/^(.+)(\.[a-z]+)$/, "$1_over$2");
	},

	exit: function() {
		this.src = this.src.replace(/^(.+)_over(\.[a-z]+)$/, "$1$2");
	},
	enterTR: function() {
		$(this).addClass("over");
	},

	exitTR: function() {
		$(this).removeClass("over");
	},
	input_date_onblur: function() {
		input_date_onblur(this);
	}
};

// Auto-selected text in text fields after a label click
$.auto.select = {
	init: function() {
		$('LABEL.select').each(this.label_action);
		$('INPUT.select').bind('click', function(){ this.select(); });
	},

	label_action: function() {
		var field = $('#'+this.htmlFor).get(0);
		if (field && field.focus && field.select) {
			$(this).bind('click', function(){ field.focus(); field.select(); });
		}
	}
};





// Auto-Alt-Tooltip
// Muestra un tooltip de forma automatica
$.auto.alt = {
	init: function() {
		$('a.general_alt, input.general_alt, img.general_alt, tr.general_alt, td.general_alt').tooltip({ 
		    track: true, 
		    delay: 0,
		    showURL: false, 
		    showBody: " - ", 
		    opacity: 0.85,
		    id: "general_tooltip" 
		});
	}
};