package atica.database.servlet;

/**
*
*	Clase Ejemplo que sirve para visualizar el nmero de getConnections y freeConnections
*	realizados por una aplicacin en concreto sobre una fuente de datos en concreto.
*
*	@author Juan Jos Meroo Snchez
*	@version 1.0
*
*/
public class SnoopServletBD extends atica.database.util.obj.HttpServletBD {

	static org.apache.log4j.Logger logger = org.apache.log4j.Logger.getLogger(SnoopServletBD.class);
	/**
	*
	*	Muestra el nmero de getConnections y freeConnections realizados por una aplicacin sobre
	*	el DataSource pasado como parmetro.
	*
	*	@param dsname Nombre de la fuente de datos de la que se quiere informacin, p.e. "jdbc/Dumbo%20DataSource".
	*
	*/
	public void service(javax.servlet.http.HttpServletRequest req,
											javax.servlet.http.HttpServletResponse res) 
											throws javax.servlet.ServletException {

			
			try {
			
				atica.database.util.obj.ObjectBD objBD = null;
				javax.servlet.ServletOutputStream out = res.getOutputStream();
				res.setContentType("text/html");
				
				out.println("<html>");
				out.println("<head><title>SnoopServlet DataSource</title></head>");
				out.println("<body bgcolor=\"#FFFFFF\">");
				
				String dsname = req.getParameter("dsname");
				if (dsname==null) {
					out.println("<b>Debe incluir el parmetro dsname en la llamada.</b>");
				} else {
					createDataSource(dsname);
					objBD = new atica.database.util.obj.ObjectBD(dsname);
				}
				
				if (dsname!=null) {
					
					out.println("<table border=\"1\">");
					out.println("<tr bgcolor=\"#EEEEEE\"><td colspan=\"2\"><b>Informe de Servlets</b>&nbsp;&nbsp;"+idOfDataSource()+"</td></tr>");
					//out.println("<tr><td colspan=\"2\">&nbsp;</td></tr>");
					out.println("<tr><td><b>GetConnections:</b></td><td align=\"right\">"+getConnectionCount()+"</td></tr>");
					out.println("<tr><td><b>FreeConnections:</b></td><td align=\"right\">"+freeConnectionCount()+"</td></tr>");
					out.println("<tr><td><b>ActiveConnections:</b></td><td align=\"right\">"+activeConnectionCount()+"</td></tr>");
					//out.println("<tr><td colspan=\"2\">&nbsp;</td></tr>");
					out.println("<tr bgcolor=\"#EEEEEE\"><td colspan=\"2\"><b>Informe de Objetos</b>&nbsp;&nbsp;"+objBD.idOfDataSource()+"</td></tr>");
					out.println("<tr><td><b>GetConnections:</b></td><td align=\"right\">"+objBD.getConnectionCount()+"</td></tr>");
					out.println("<tr><td><b>FreeConnections:</b></td><td align=\"right\">"+objBD.freeConnectionCount()+"</td></tr>");
					out.println("<tr><td><b>ActiveConnections:</b></td><td align=\"right\">"+objBD.activeConnectionCount()+"</td></tr>");
					out.println("<tr bgcolor=\"#EEEEEE\"><td colspan=\"2\">&nbsp;</td></tr>");
					out.println("</table>");
					
				}
				
				out.println("</body>");
				out.println("</html>");
				
			} catch (Exception ex) {
				logger.fatal("SnoopServletServlet: "+ex);
			}
												
	}
	
}
