/**
*
*
*/

package atica.frameweb.broker;

import java.util.*;
import atica.frameweb.utils.*;
import atica.frameweb.manager.*;
import atica.frameweb.broker.datasource.*;
import org.apache.log4j.*;

public class BrokerTable implements IMetaObject {
	
	static Logger logger = HttpServletManager.logger;
	private Hashtable brokers = new Hashtable(10);
	private Properties prop = null;
	protected String className = "";
	protected HttpServletManager initSrv = null;
	
	public IBroker getBroker(String id) {
		synchronized (brokers) {
			IBroker ib = (IBroker) brokers.get(id);
			if (ib==null) {
			// Busca el Broker en el Archivo
				try {
					String idd = prop.getProperty(id);
					if (idd==null) idd = id;
					ib = (IBroker) new BrokerDataSource(initSrv,id,idd);
					brokers.put(id,ib);
				} catch (Exception ex) {
					logger.fatal("BrokerTable: No se pudo Crear el Broker "+ex);
				}
			}
			return ib;
		}
	}
	
	public BrokerTable() {}
	public BrokerTable(HttpServletManager ini,String cn) {
		initSrv = ini;
		className = cn; 
	}
	
	public String getClassName() { return className; }
	public void setProperties(Properties p) { prop = p; }
	
	/**
	**
	**	MTODOS DE VISUALIZACIN Y MODIFICACIN WEB
	**
	***/
	
	// Todos los Brokers
	public Vector activos = null;
	public String userOk = "NO";
	// Usuario y Clave para WEB
	
	private String usuario = "";
	private String clave = "";
	
	public void show() {
		activos = new Vector();
		
		try {
			Enumeration en = brokers.elements();
			while (en.hasMoreElements()) {
				IBroker ib = (IBroker) en.nextElement();
				BrokerData el = new BrokerData();
				el.setNombre(ib.getNombre());
				el.setDBName(ib.getDBName());
				activos.addElement(el);
			}
		} catch (Exception ex) {
			logger.error("SHOW: "+ex);
		}
		
	}
	
	public void setUser(String usr) { usuario = usr; }
	
	public void setPwd(String pwd) { clave = pwd; }
	
	public atica.frameweb.manager.IManagerAccessControl getUser() {
		boolean okTodo = initSrv.isAdministrador(usuario,clave);
		if (okTodo) userOk = "SI";
		return new BrokerAccessManager(okTodo);
	}
}
