package atica.frameweb.broker.datasource;

import atica.frameweb.broker.*;

import java.io.*;
import java.sql.*;

//import net.sf.hibernate.*;
//import net.sf.hibernate.cfg.*;
import org.hibernate.*;
import org.hibernate.cfg.*;
import org.apache.log4j.*;

import atica.frameweb.utils.*;
import atica.frameweb.manager.*;

public class BrokerDataSource implements IBroker,Serializable {

	static Logger logger = HttpServletManager.logger;
	
	protected String dbDataSource = "", dsName = "";
	protected ConectionSource poolDs = null;
	protected SessionFactory sessionFactory = null; 
	protected HttpServletManager initSrv = null;
	
	public String getClase() { return getClass().getName(); }
	
	public BrokerDataSource(HttpServletManager init,String dsn,String ds) {
		dbDataSource = ds; initSrv = init; dsName = dsn;
		poolDs = new ConectionSource(dbDataSource);
	}

	public Connection getConnection() throws SQLException {
		Connection conn = poolDs.getConnection();
		return conn;
	}
	
	public void freeConnection(Connection conn) {
		if (conn!=null) poolDs.freeConnection(conn);
	}
	
	public Session getSession() {
		try {
			if (sessionFactory==null) {
				Configuration cfg = new Configuration();
				cfg.setEntityResolver(new ManagerResolver(this.getClass().getClassLoader()));
				org.w3c.dom.Document doc = atica.frameweb.xml.XMLUtil.parse(initSrv.getClass().getResource(dsName+".hibernate.cfg.xml").openStream(),new ManagerResolver(initSrv.getClass().getClassLoader())); 
				sessionFactory = cfg.configure(doc).buildSessionFactory();
				//sessionFactory = cfg.configure(initSrv.getClass().getResource(dsName+".hibernate.cfg.xml")).buildSessionFactory();
			}
			return sessionFactory.openSession();
		} catch (Exception ex) {
			logger.fatal("Hibernate: "+ex);
			ex.printStackTrace(System.out);
		}
		return null;
		
	}
	
	public void freeSession(Session s) {
		if (s==null) return;
		try {
			// Es posible hacer free y luego close
			Connection conn = s.close();
			freeConnection(conn);
		} catch (Exception ex) {}
		
	}
	
	public String getNombre() {
		return dbDataSource;
	}

	public String getDBName() {
		//return dbName;
		return poolDs.getDataSourceName();
	}

}
