package atica.frameweb.broker.datasource;

import java.sql.*;
import org.apache.log4j.*;
import atica.frameweb.manager.*;
//import net.sf.hibernate.*;
import org.hibernate.*;

public class ConectionSource implements javax.sql.DataSource {

	static Logger logger = HttpServletManager.logger;
	
    private atica.database.util.obj.ObjectBD jndiDS = null;
    private String jndiDSName = "";
    
	public ConectionSource(String dbName) { 
        try {
        	jndiDSName = dbName;
        	jndiDS=new atica.database.util.obj.ObjectBD(jndiDSName);
        } catch (Exception e) {
            logger.fatal("ConexionBD:" + e);
        }
	}

	public java.sql.Connection getConnection() throws java.sql.SQLException {
		Connection con=null;
		try {
			con=jndiDS.getConnection();
		} catch (Exception e)	{
			logger.fatal("BrokerDataSource[GetConnection]:"+e);
		}		
		return con;	
	}

	public java.sql.Connection getConnection(String arg1, String arg2) throws java.sql.SQLException {
		return null;
	}
		
	public void freeConnection(java.sql.Connection conn) {
		try {
			jndiDS.freeConnection(conn);
		} catch (Exception exx) {
			logger.error("BrokerDataSource[FreeConnection]: "+exx);
		}
	}

	public Session getSession() {
		Session con=null;
		try {
			con=jndiDS.getSession();
		} catch (Exception e)	{
			logger.fatal("BrokerDataSource[GetConnection]:"+e);
		}		
		return con;	
	}
		
	public void freeSession(Session conn) {
		try {
			jndiDS.freeSession(conn);
		} catch (Exception exx) {
			logger.error("BrokerDataSource[FreeConnection]: "+exx);
		}
	}
	
	public int getLoginTimeout() throws java.sql.SQLException {
		return 0;
	}
		
	public java.io.PrintWriter getLogWriter() throws java.sql.SQLException {
		return null;
	}

	public void setLoginTimeout(int arg1) throws java.sql.SQLException {}

	public void setLogWriter(java.io.PrintWriter arg1) throws java.sql.SQLException {}

	public String getDataSourceName() {
		return jndiDSName;
	}
		
}

