package atica.frameweb.documentacion;

import java.io.*;
import java.net.*;
import java.util.*;
import org.w3c.dom.*;
import javax.servlet.http.*;
import org.apache.log4j.*;
import atica.frameweb.xml.*;
import atica.frameweb.manager.*;
import atica.frameweb.utils.*;

public class GestorDocumentacion implements IMetaObject {

	static Logger logger = HttpServletManager.logger;
	
	public Document xml = null;
	public String action = "";
	public URL file = null;
	public ClassLoader classLoader = null;
	public String className = "";
	
	public GestorDocumentacion(ClassLoader cl,String cn) {
		classLoader = cl; className = cn;
	}

	public String getClassName() { return className; }
	
	public void setAction(String ac) { action = ac; }
	
	private Document emptyDocument(String root) throws Exception {
		Document d = XMLUtil.createDocument();
		Element el = d.createElement(root);
		d.appendChild(el);
		return d;
	}
	
	public void getModules(String mod) throws Exception {
		if ((mod==null)||(mod.equals(""))) xml = emptyDocument(ManagerTags.MODULES);
		xml = ManagerReader.readFileModules(classLoader,mod.replace('.','/'));
	}
	
	public void showModule(String mod) throws Exception {
		if ((mod==null)||(mod.equals(""))) xml = emptyDocument(ManagerTags.MODULE);
		xml = ManagerReader.readFileModule(classLoader,mod);
	}
	
	
	public void showSQL(String mod) throws Exception {
		if ((mod==null)||(mod.equals(""))) xml = emptyDocument(ManagerTags.QUERYS);
		try {
			xml = ManagerReader.readQueryModule(classLoader,mod);
		} catch (Exception ex) {
			xml = emptyDocument(ManagerTags.QUERYS);
		}
	}
	
	
	public void showAccess(String mod) throws Exception {
		if ((mod==null)||(mod.equals(""))) xml = emptyDocument(ManagerTags.MODULE);
		try {
			xml = ManagerReader.readAccessModule(classLoader,mod);
		} catch (Exception ex) {
			xml = emptyDocument(ManagerTags.MODULE);
		}
	}
	
	public void showData(HttpServlet srv,HttpServletRequest req,HttpServletResponse res,String name) throws Exception {
		OutputStream out = res.getOutputStream();
		res.setContentType("text/html");
		Hashtable h = null;
		if (action!=null) {
			h = new Hashtable();
			h.put("action",action);
			h.put("servlet",className);
		}
		XMLUtil.mezclaDoc(classLoader,xml,name,h,out);
		out.flush(); out.close();
	}
	
	public void showClass(String fil) {
		file = classLoader.getResource("../src/"+fil);
	}

	public void showXsl(String fil) {
		file = classLoader.getResource(fil);
	}
	
	
	public void showFile(HttpServlet srv,HttpServletRequest req,HttpServletResponse res,String name) throws Exception {
		
		OutputStream out = res.getOutputStream();
		res.setContentType("text/html");

		StringBuffer stb = new StringBuffer();
			
		BufferedReader in = new BufferedReader(new InputStreamReader(file.openStream()));
		String lin = in.readLine();
		while (lin!=null) {
			stb.append(lin+"\n");
			lin = in.readLine();
		}
			
		xml = emptyDocument(ManagerTags.XML_FILE);
		Element e = xml.getDocumentElement();
		e.setAttribute(ManagerTags.XML_FILE_NAME,file.getFile());
		e.appendChild(xml.createTextNode(stb.toString()));
		Hashtable h = new Hashtable();
		h.put("servlet",className);
		
		XMLUtil.mezclaDoc(classLoader,xml,name,null,out);
		out.flush(); out.close();
	}
		
}
