package atica.frameweb.estadisticas;

import java.util.*;

public class Estadistica {

	public String modulo = "";

	public Hashtable numLlamadas = new Hashtable(50);
	public Hashtable tiempoMedio = new Hashtable(50);
	public Hashtable tiempoMaximo = new Hashtable(50);
	public Hashtable tiempoMinimo = new Hashtable(50);
  
	public Estadistica() {}

	public Estadistica(String mod) {
		modulo = mod;
	}

	public void add(long time,String operacion) {
		String medio = (String) tiempoMedio.get(operacion);
		if (medio==null) {
			// Primera llamada
			tiempoMedio.put(operacion,""+time);
			tiempoMinimo.put(operacion,""+time);
			tiempoMaximo.put(operacion,""+time);
			numLlamadas.put(operacion,""+1);
		} else {
			// El Resto de Llamadas
			float med = Float.parseFloat(medio);
			float min = Float.parseFloat((String)tiempoMinimo.get(operacion));
			float max = Float.parseFloat((String)tiempoMaximo.get(operacion));
			float num = Float.parseFloat((String)numLlamadas.get(operacion));
			if (time>max) tiempoMaximo.put(operacion,""+time);
			if (time<min) tiempoMinimo.put(operacion,""+time);
			tiempoMedio.put(operacion,""+(((med*num)+time)/(num+1)));
			numLlamadas.put(operacion,""+(long)(num+1));
		}
	}
	
	public String getLlamadas(String oper) {
		String st = (String) numLlamadas.get(oper);
		if (st==null) st = "0";
		return st;
	}

	public String getMinimo(String oper) {
		String st = (String) tiempoMinimo.get(oper);
		if (st==null) st = "0";
		return st;
	}

	public String getMaximo(String oper) {
		String st = (String) tiempoMaximo.get(oper);
		if (st==null) st = "0";
		return st;
	}

	public String getTiempoMedio(String oper) {
		String st = (String) tiempoMedio.get(oper);
		if (st==null) st = "0";
		return st;
	}

	public Enumeration getOperaciones() {
		return numLlamadas.keys();
	}
	
	public String getModulo() {
		return modulo;
	}
	
	public Vector getOper() {
		Vector operaciones = new Vector();
		Enumeration en = numLlamadas.keys();
		while (en.hasMoreElements()) {
			String key = (String) en.nextElement();
			EstadisticaOper eo = new EstadisticaOper();
			eo.setOper(key);
			eo.setLlamadas((String)numLlamadas.get(key));
			eo.setMinimo((String)tiempoMinimo.get(key));
			eo.setMaximo((String)tiempoMaximo.get(key));
			eo.setMedio((String)tiempoMedio.get(key));
			operaciones.addElement(eo);
		}
		return operaciones;
	}
	
}