/*
 * Created on 12-feb-2005
 *
 */
package atica.frameweb.manager;

import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.stream.StreamResult;
import javax.xml.transform.OutputKeys;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.sax.SAXSource;
import javax.xml.transform.sax.SAXTransformerFactory;

import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.xml.sax.InputSource;

import atica.frameweb.xml.XMLUtil;

/**
 * @author Juan Jos Meroo Snchez
 *
 * Manejador de Todas las Excepciones
 * 
 */
public class ManagerException extends Exception {
	
	private String excMessage = "",excTitulo="";
	private Throwable exx = null;
	
	public ManagerException(Exception ex) { excMessage = ""+ex; excTitulo = ex.getMessage(); exx = ex; }
	public ManagerException(String t,String m) { excMessage = m; excTitulo = t; }
	public ManagerException(Object t,String m) { excMessage = m; excTitulo = t.getClass().getName(); }
	public ManagerException(String t,String m,Throwable ex) { excMessage = m; excTitulo = t; exx = ex; }

	public void sendErrorPage(ClassLoader cl,ServletContext srvCtx,HttpServletRequest req,HttpServletResponse res,String urlError) {
		try {
			
			if ((urlError==null) || (urlError.equals(""))) {
				
				res.setContentType("text/html");
				ServletOutputStream out = res.getOutputStream();
				out.println("<html>");
				out.println("<head><title>"+excTitulo+"</title></head>");
				out.println("<body bgcolor='#FFFFFF'>");
				out.println("<table width='100%'>");
				out.println("<tr><td bgcolor='#AAAAAA'><font color='white' size='+1'>"+excTitulo+"</font></td></tr>");
				out.println("<tr><td bgcolor='#FFFFFF'><font color='red'>"+excMessage+"</font></td></tr>");
				out.println("<tr><td bgcolor='#FFFFFF'><hr width='70%'></td></tr>");
				out.println("<tr><td bgcolor='#FFFFFF'><pre>");
				if (exx!=null) {
					if (exx.getCause()!=null) exx.getCause().printStackTrace(new PrintStream(out));
					else exx.printStackTrace(new PrintStream(out)); 
				} else this.printStackTrace(new PrintStream(out));
				out.println("</pre></td></tr>");
				out.println("<tr><td bgcolor='#AAAAAA'>&nbsp;</td></tr>");
				out.println("</table>");
				out.println("</body>");
				out.println("</html>");
				out.flush(); out.close();
				
			} else if (urlError.toLowerCase().endsWith(".jsp")) {
				
				if (exx!=null) {
					if (exx.getCause()!=null) req.setAttribute("EXCEPTION_OBJECT",exx.getCause());
					else req.setAttribute("EXCEPTION_OBJECT",exx);
				} else req.setAttribute("EXCEPTION_OBJECT",this);
				req.setAttribute("EXCEPTION_TITLE",excTitulo);
				req.setAttribute("EXCEPTION_MESSAGE",excMessage);
				srvCtx.getRequestDispatcher(urlError).forward(req,res);
				
			} else if (urlError.toLowerCase().endsWith(".xsl")) {
				
				TransformerFactory tfactory = SAXTransformerFactory.newInstance();
				tfactory.setURIResolver(new ManagerResolver(cl));
				
				SAXSource xslSource = new SAXSource(new InputSource(cl.getResource(urlError).openStream()));
				Transformer transformer = tfactory.newTransformer(xslSource);
				transformer.setOutputProperty(OutputKeys.ENCODING,atica.frameweb.output.GeneralOutput.ENCODING);
				
				// Por defecto se mandan unos parametros de utilidad
				transformer.setParameter(ManagerUtilities.ORG_MODULE_PARAMETER,ManagerUtilities.getOrgModuleParameter(req));
				transformer.setParameter(ManagerUtilities.ORG_ACTION_PARAMETER,ManagerUtilities.getOrgActionParameter(req));
				transformer.setParameter(ManagerUtilities.MODULE_PARAMETER,ManagerUtilities.getModuleParameter(req));
				transformer.setParameter(ManagerUtilities.ACTION_PARAMETER,ManagerUtilities.getActionParameter(req));
				transformer.setParameter(ManagerUtilities.SRV_CONTROL_PARAMETER,req.getContextPath()+req.getServletPath());
				
				Document doc = XMLUtil.createDocument(); 
	    		Element el = doc.createElement(ManagerTags.XMLROOT);
	    		doc.appendChild(el);
	    		Element el2 = doc.createElement(ManagerTags.XMLERROR);
	    		el.appendChild(el2);
	    		el2.setAttribute(ManagerTags.ERROR_TITLE,excTitulo);
	    		el2.setAttribute(ManagerTags.ERROR_MESSAGE,excMessage);
	    		ByteArrayOutputStream byteOut = new ByteArrayOutputStream();
	    		if (exx!=null) {
	    			if (exx.getCause()!=null) exx.getCause().printStackTrace(new PrintStream(byteOut));
	    			else exx.printStackTrace(new PrintStream(byteOut));
	    		} else this.printStackTrace(new PrintStream(byteOut));
	    		el2.appendChild(doc.createTextNode(byteOut.toString()));
				
				DOMSource xmlSource = new DOMSource(doc);
				StreamResult result = new StreamResult(res.getOutputStream());
				transformer.transform(xmlSource,result);
				
			}
			
		} catch (Exception ex) { HttpServletManager.logger.error("ManagerException: "+ex); }
		
	}

	public String getError() { return excTitulo+": "+excMessage; }
	
}
