/*
 * Created on 21-feb-2005
 *
 */
package atica.frameweb.manager;

import java.io.*;
import org.xml.sax.*;
import javax.xml.transform.*;
import javax.xml.transform.stream.*;

/**
 * @author Universidad de Murcia
 *
 * Resolver para includes
 * 
 */
public class ManagerResolver implements URIResolver,EntityResolver {

	public ClassLoader classLoader = null;
	
	public ManagerResolver(ClassLoader cl) { classLoader = cl; }
	
	public Source resolve(String href,String base) throws TransformerException {
		try {
			return new StreamSource(classLoader.getResource(href).openStream()); 
		} catch (Throwable t) { /* do nothing */ }
		return null;
	}
	
	public InputSource resolveEntity(String href,String base) throws SAXException,IOException {
		try {
			InputSource is = null;
			if (base!=null && base.startsWith("http")) {
				is = new InputSource(classLoader.getResource("atica/frameweb/xml/schemas"+base.substring(base.lastIndexOf("/"))).openStream());
			} else is = new InputSource(classLoader.getResource(base).openStream());
			if (is!=null) is.setEncoding(atica.frameweb.xml.XMLUtil.ENCODING);
			return is;
		} catch (Throwable t) { /* do nothing */ }
		return null;
	}
	
}

