/*
 * Created on 19-feb-2005
 *
 */
package atica.frameweb.manager;

import org.w3c.dom.*;

import java.io.PrintStream;
import java.util.*;

import javax.servlet.ServletOutputStream;
import javax.servlet.http.*;
import atica.frameweb.xml.*;

/**
 * @author Juan Jos Meroo Snchez
 *
 */
public class ManagerSendResponse {
	
	public static final String ENCODING = "ISO-8859-1";
	
	private static String getHeaderValue(HttpServletRequest request,String valor) {
		String acepta = "";
		Enumeration names = request.getHeaderNames();
		while ((names.hasMoreElements()) && (acepta.equals(""))) {
			String name = (String)names.nextElement();
			if (name.toUpperCase().equals(valor.toUpperCase())) acepta = name;
		}
		return request.getHeader(acepta);
	}

	public static String obtenerFileId(Node modulo,HttpServletRequest request) throws Exception {
		// Obtiene el Primer FILE-ID que le coincide.
		String typeAccept = getHeaderValue(request,"accept");
		String userAgent = getHeaderValue(request,"user-agent");
		
		String fileId = "";
		
		Node out = XMLUtil.selectSingleNode(modulo,ManagerTags.OUTPUT_DEVICES);
		if (out==null) throw new Exception("No hay un dispositivo de salida definido.");
		NodeList mimes = XMLUtil.selectNodes(out,ManagerTags.MIME);
		if (mimes==null) throw new Exception("No hay un dispositivo de salida definido.");
		for (int k=0; k<mimes.getLength(); k++) {
			Node mime = mimes.item(k);
			String type = XMLUtil.getAttributeValue(mime,ManagerTags.MIME_TYPE);
			if (typeAccept.toUpperCase().indexOf(type)!=-1) {
				// De momento este es mi ID.
				fileId = XMLUtil.getAttributeValue(mime,ManagerTags.MIME_ID);
				NodeList brows = XMLUtil.selectNodes(mime,ManagerTags.BROWSER);
				if (brows==null) return fileId;
				for (int j=0; j<brows.getLength(); j++) {
					Node brow = brows.item(j);
					String like = XMLUtil.getAttributeValue(brow,ManagerTags.BROWSER_LIKE);
					if (userAgent.toUpperCase().indexOf(like)!=-1) {
						// Me coincide el Browser, cambio id.
						fileId = fileId+ManagerUtilities.FILE_SEPARATOR+XMLUtil.getAttributeValue(brow,ManagerTags.BROWSER_ID);
						return fileId;
					}
				}
				return fileId;
			}
		}
		
		return fileId;
		
	}
	
	public static Node obtenerFileNode(Node action,String id) throws Exception {
		return XMLUtil.selectSingleNode(action,ManagerTags.FILE,ManagerTags.FILE_ID,id);
	}
	
	public static Node createFileNode(String modulo,String action) throws Exception {
		Document doc = XMLUtil.createDocument();
		Element el = doc.createElement(ManagerTags.FILE);
		el.setAttribute(ManagerTags.FILE_MOD,modulo);
		el.setAttribute(ManagerTags.FILE_ACT,action);
		return el;
	}
	
	public static void translateParam(HttpServletRequest req,Hashtable params) {
		Enumeration en = params.keys();
		while (en.hasMoreElements()) {
			String k = (String) en.nextElement();
			req.setAttribute(k,params.get(k));
		}
	}
	
}
