/*
 * Created on 23-feb-2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package atica.frameweb.output;

import java.io.File;
import java.util.*;

import javax.servlet.*;
import javax.servlet.http.*;
import javax.xml.transform.*;
import javax.xml.transform.dom.*;
import javax.xml.transform.sax.*;

import org.exolab.castor.mapping.*;
import org.exolab.castor.xml.*;
import org.w3c.dom.*;
import org.xml.sax.*;

import atica.frameweb.manager.*;
import atica.frameweb.xml.*;

import org.apache.fop.apps.*;
import org.apache.avalon.framework.logger.*;

/**
 * @author Universidad de Murcia
 *
 * Manejador de Salida Para XSL
 * 
 */
public class FOPOutput extends GeneralOutput {

	public void sendResponse(ClassLoader cl,String logLevel,ServletContext srvCtx,HttpServletRequest request,HttpServletResponse response) throws ManagerException {
		
		response.setContentType(contentType);
		String ficheroXsl = "";
		
		try {
			
			String oput = ManagerUtilities.getParameter(request,ManagerUtilities.OUTPUT_PARAMETER);
			if (oput==null) oput = (String)request.getSession().getAttribute(ManagerUtilities.OUTPUT_PARAMETER);
			if (oput==null) oput = "";
			else oput = ManagerUtilities.FILE_SEPARATOR+oput;
			
			String impFileName = ManagerUtilities.getActionParameter(request);
			ficheroXsl = ManagerUtilities.getModuleParameter(request)+ManagerUtilities.FILE_SEPARATOR+fileId+oput+ManagerUtilities.FILE_SEPARATOR+impFileName+".xsl";
			File f = new File(ficheroXsl);
			if (!f.exists()) ficheroXsl = ManagerUtilities.getModuleParameter(request)+ManagerUtilities.FILE_SEPARATOR+fileId+ManagerUtilities.FILE_SEPARATOR+ManagerUtilities.getActionParameter(request)+".xsl";
			
			ManagerResolver mngRes = new ManagerResolver(cl);
			TransformerFactory tfactory = SAXTransformerFactory.newInstance();
			tfactory.setURIResolver(mngRes);
			
			SAXSource xslSource = new SAXSource(new InputSource(cl.getResource(ficheroXsl).openStream()));
			Transformer transformer = tfactory.newTransformer(xslSource);
			transformer.setOutputProperty(OutputKeys.ENCODING,ENCODING);
			
			// Por defecto se mandan unos parametros de utilidad
			transformer.setParameter(ManagerUtilities.ORG_MODULE_PARAMETER,ManagerUtilities.getOrgModuleParameter(request));
			transformer.setParameter(ManagerUtilities.ORG_ACTION_PARAMETER,ManagerUtilities.getOrgActionParameter(request));
			transformer.setParameter(ManagerUtilities.MODULE_PARAMETER,ManagerUtilities.getModuleParameter(request));
			transformer.setParameter(ManagerUtilities.ACTION_PARAMETER,ManagerUtilities.getActionParameter(request));
						
			NodeList params = XMLUtil.selectNodes(file,ManagerTags.PARAM);
			if (params!=null) {
				for (int k=0; k<params.getLength(); k++) {
					Node par = params.item(k);
					String key = XMLUtil.getAttributeValue(par,ManagerTags.PARAM_NAME);
					String from = XMLUtil.getAttributeValue(par,ManagerTags.PARAM_FROM);
					String value = "";
					if (from==null) value = XMLUtil.getAttributeValue(par,ManagerTags.PARAM_VALUE);
					else if (from.equals(ManagerTags.REQUEST)) {
						value = ManagerUtilities.getParameter(request,key);
						if (value==null) value = XMLUtil.getAttributeValue(par,ManagerTags.PARAM_VALUE);
					}
					else if (from.equals(ManagerTags.SESSION)) {
						value = (String)request.getSession().getAttribute(key);
						if (value==null) value = XMLUtil.getAttributeValue(par,ManagerTags.PARAM_VALUE);
					}
					else if (from.equals(ManagerTags.REQ_SESSION)) {
						value = ManagerUtilities.getParameter(request,key);
						if (value==null) value = (String)request.getSession().getAttribute(key);
						if (value==null) value = XMLUtil.getAttributeValue(par,ManagerTags.PARAM_VALUE);
					}
					else if (from.equals(ManagerTags.SESSION_REQ)) {
						value = (String)request.getSession().getAttribute(key);
						if (value==null) value = ManagerUtilities.getParameter(request,key);
						if (value==null) value = XMLUtil.getAttributeValue(par,ManagerTags.PARAM_VALUE);
					}
					else value = XMLUtil.getAttributeValue(par,ManagerTags.PARAM_VALUE);
					if (value!=null) transformer.setParameter(key,value);
				}
			}
			if (parameters!=null) {
				Enumeration en = parameters.keys();
				while (en.hasMoreElements()) {
					String key = (String) en.nextElement(); 
					String value = (String) parameters.get(key);
					if (value!=null) transformer.setParameter(key,value);
				}
			}
			
			Document doc = null;
			if (dic!=null) ManagerReader.readDictionaryModule(cl,request,dic.getLanguage());
			else {
    			doc = XMLUtil.createDocument(); 
    			Element el = doc.createElement(ManagerTags.XMLROOT);
    			doc.appendChild(el);
			}
			int contk = 0;			
			Enumeration en = objetosEjecutados.elements();
			while (en.hasMoreElements()) {
				Object obj = (Object)en.nextElement();
				String modObj = (String)modulosEjecutados.elementAt(contk);
				doc = getXMLFrom(cl,mngRes,modObj,obj,doc);
				contk++;
			}

			// Incluye los datos del menu
			if ((dataMenu!=null) && (dataMenu.getDatosMenu()!=null)) {
				doc = getXMLFrom(cl,mngRes,ManagerUtilities.getModuleParameter(request),dataMenu.getDatosMenu(),doc);
				String value = ManagerUtilities.getParameter(request,ManagerTags.MENU.toLowerCase());
				if (value!=null) {
					transformer.setParameter(ManagerTags.MENU.toLowerCase(),value);
					dataMenu.getDatosMenu().setOption(value);
				} else {
					value = dataMenu.getDatosMenu().getOption();
					transformer.setParameter(ManagerTags.MENU.toLowerCase(),value);
				}
			}

			DOMSource xmlSource = new DOMSource(doc);
			DOMResult result = new DOMResult();
			transformer.transform(xmlSource,result);
			
			int render = Driver.RENDER_PDF;
			String contentDisposition = null;
			if (contentType.equals("application/pdf")) {
				render = Driver.RENDER_PDF;
				contentDisposition = "attachment; filename="+impFileName+".pdf";
			} else if (contentType.equals("application/postscript")) {
				render = Driver.RENDER_PS;
				contentDisposition = "attachment; filename="+impFileName+".ps";
			} else if (contentType.equals("image/svg")) {
				render = Driver.RENDER_SVG;
				contentDisposition = "attachment; filename="+impFileName+".svg";
			} else if (contentType.equals("text/plain")) {
				render = Driver.RENDER_TXT;
				contentDisposition = "attachment; filename="+impFileName+".txt";
			}
			
			if (contentDisposition!=null) response.setHeader("Content-Disposition", contentDisposition);
			
			Driver driver = new Driver();
			driver.setLogger(new ConsoleLogger(ConsoleLogger.LEVEL_DISABLED));
			driver.setRenderer(render);
			driver.setOutputStream(response.getOutputStream());
			driver.render((Document)result.getNode());
			
		} catch (ManagerException ex) {
			throw ex;
		} catch (Exception ex) {
			throw new ManagerException("FOPOutput","El fichero xsl ["+ficheroXsl+"] no existe, o contiene errores.",ex);
		}			

	}

	public Mapping getMapping(ClassLoader cl,ManagerResolver mngRes,String module,Object obj) throws Exception {
		try {
			Mapping m = new Mapping(cl);
			m.setEntityResolver(mngRes);
			m.loadMapping(ManagerReader.getMappingResource(cl,module));
			return m;
		} catch (Exception ex) { 
			throw ex; 
		}
	}

	// Obtener XML de un Objeto
	
	public Document getXMLFrom(ClassLoader cl,ManagerResolver mngRes,String module,Object obj,Document doc) throws Exception {
		// Convierte a XML un Objeto
		try {
    		Node node = null;
    		if (doc==null) { 
    			doc = XMLUtil.createDocument(); 
    			Element el = doc.createElement(ManagerTags.XMLROOT);
    			doc.appendChild(el);
    			node = doc.createElement(ManagerTags.DATA);
    			el.appendChild(node);
    		} else {
    			Node raiz = XMLUtil.selectSingleNode(doc,ManagerTags.XMLROOT);
    			if (raiz!=null) {
    				node = XMLUtil.selectSingleNode(raiz,ManagerTags.DATA);
					if (node==null) {
						node = doc.createElement(ManagerTags.DATA);
						raiz.appendChild(node);
    				}
    			} else {
					raiz = doc.createElement(ManagerTags.XMLROOT);
	  				doc.appendChild(raiz);
	  				node = doc.createElement(ManagerTags.DATA);
	  				raiz.appendChild(node);
    			}
    		}
    		Marshaller marshaller = new Marshaller(node);
    		marshaller.setMapping(getMapping(cl,mngRes,module,obj));
    		marshaller.setMarshalAsDocument(true);
    		marshaller.marshal(obj);
    		
		} catch (Exception e) {
			throw new Exception("CastorXML: "+e);
		}
    		
		return doc;
	}
	
}
