/*
 * Created on 23-feb-2005
 *
 */
package atica.frameweb.output;

import javax.servlet.ServletContext;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import atica.frameweb.manager.ManagerException;
import atica.frameweb.manager.ManagerTags;
import atica.frameweb.manager.ManagerUtilities;
import atica.frameweb.xml.XMLUtil;
import org.w3c.dom.*;

/**
 * @author Universidad de Murcia
 *
 * Salida Redirigida a otra action.
 * 
 */
public class FWDOutput extends GeneralOutput {

	public void sendResponse(ClassLoader cl,String logLevel,ServletContext srvCtx, HttpServletRequest request,	HttpServletResponse response) throws ManagerException {
		
		String newModule = XMLUtil.getAttributeValue(file,ManagerTags.FILE_MOD);
		if (newModule==null) newModule = ManagerUtilities.getModuleParameter(request);
		String newAction = XMLUtil.getAttributeValue(file,ManagerTags.FILE_ACT);
		if (newAction==null) throw new ManagerException("FWDOutput","Debe indicar el nombre de la accin para hacer el forward.");
		
		if (manager.sinCiclos(newModule,newAction,"")) {
			ManagerUtilities.setModuleParameter(request,newModule);
			ManagerUtilities.setActionParameter(request,newAction);
			//ManagerUtilities.setNextParameter(request,"");
			NodeList params = XMLUtil.selectNodes(file,ManagerTags.PARAM);
			if (params!=null) {
				for (int k=0; k<params.getLength(); k++) {
					Node par = params.item(k);
					String key = XMLUtil.getAttributeValue(par,ManagerTags.PARAM_NAME);
					String from = XMLUtil.getAttributeValue(par,ManagerTags.PARAM_FROM);
					String value = "";
					if (from==null) value = XMLUtil.getAttributeValue(par,ManagerTags.PARAM_VALUE);
					else if (from.equals(ManagerTags.REQUEST)) {
						value = ManagerUtilities.getParameter(request,key);
						if (value==null) value = XMLUtil.getAttributeValue(par,ManagerTags.PARAM_VALUE);
					}
					else if (from.equals(ManagerTags.SESSION)) {
						value = (String)request.getSession().getAttribute(key);
						if (value==null) value = XMLUtil.getAttributeValue(par,ManagerTags.PARAM_VALUE);
					}
					else if (from.equals(ManagerTags.REQ_SESSION)) {
						value = ManagerUtilities.getParameter(request,key);
						if (value==null) value = (String)request.getSession().getAttribute(key);
						if (value==null) value = XMLUtil.getAttributeValue(par,ManagerTags.PARAM_VALUE);
					}
					else if (from.equals(ManagerTags.SESSION_REQ)) {
						value = (String)request.getSession().getAttribute(key);
						if (value==null) value = ManagerUtilities.getParameter(request,key);
						if (value==null) value = XMLUtil.getAttributeValue(par,ManagerTags.PARAM_VALUE);
					}
					else value = XMLUtil.getAttributeValue(par,ManagerTags.PARAM_VALUE);
					if (value!=null) manager.addOutParameter(key,value);
				}
			}
			manager.setNewLocation(newModule,newAction);
			manager.doActions();
			manager.sendResponse(srvCtx);
		} else throw new ManagerException("FWDOutput","Se ha provocado una llamada ciclo de Forward: ["+newModule+"."+newAction+"].");
	}

}
