/*
 * Created on 23-feb-2005
 *
 */
package atica.frameweb.output;

import org.w3c.dom.*;
import java.util.*;
import atica.frameweb.manager.ManagerModule;
import atica.frameweb.manager.ManagerTags;
import atica.frameweb.xml.XMLUtil;
import atica.frameweb.utils.IDictionary;
import atica.frameweb.user.menu.IDataMenu;
import java.util.Vector;

/**
 * @author Universidad de Murcia
 *
 * Clase de Salida General
 * 
 */
public abstract class GeneralOutput implements IOutput {

	public static final String ENCODING = "ISO-8859-1";
	public static final String METHOD = "html";
	public static final String METHOD_XML = "xml";
	public static final String PUBLIC_ID = "-//W3C//DTD XHTML 1.0 Transitional//EN\" \"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd";
	public static final String SVG_CONTENT_TYPE = "image/svg+xml";
	public static final String JPG_CONTENT_TYPE = "image/jpg";
	public static final String PNG_CONTENT_TYPE = "image/png";
	public static final String TIFF_CONTENT_TYPE = "image/tiff";
	
	protected String contentType = "";
	protected Node file = null;
	protected String fileId = "";
	protected IDictionary dic = null;
	protected Vector objetosEjecutados = null;
	protected Vector modulosEjecutados = null;
	protected ManagerModule manager = null;
	protected Hashtable parameters = null;
	protected IDataMenu dataMenu = null;
	
	public void setContentType(String c) { contentType = c; }
	public void setFileNode(Node n) { 
		file = n;
		fileId = XMLUtil.getAttributeValue(file,ManagerTags.FILE_ID);
	}
	public void setDictionary(IDictionary d) { dic = d; }
	public void setEjecutedObjects(Vector v) { objetosEjecutados = v; }
	public void setEjecutedModules(Vector v) { modulosEjecutados = v; }
	public void setManagerModule(ManagerModule m) { manager = m; }
	public void setParameters(Hashtable h) { parameters = h; }
	public void setDataMenu(IDataMenu d) { dataMenu = d; }
}
