/*
 * Created on 23-feb-2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package atica.frameweb.output;

import java.io.File;
import java.util.Enumeration;

import javax.servlet.ServletContext;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.xml.transform.OutputKeys;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.sax.SAXSource;
import javax.xml.transform.sax.SAXTransformerFactory;
import javax.xml.transform.stream.StreamResult;
import javax.xml.transform.dom.DOMResult;

import org.exolab.castor.mapping.Mapping;
import org.exolab.castor.xml.Marshaller;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.xml.sax.InputSource;

import atica.frameweb.manager.ManagerException;
import atica.frameweb.manager.ManagerReader;
import atica.frameweb.manager.ManagerResolver;
import atica.frameweb.manager.ManagerTags;
import atica.frameweb.manager.ManagerUtilities;
import atica.frameweb.xml.XMLUtil;

/**
 * @author Universidad de Murcia
 *
 * Manejador de Salida Para XSL
 * 
 */
public class XFORMSOutput extends GeneralOutput {

	public static String XFORMS_XSL = "atica/frameweb/xml/templates/xforms.xsl";
	
	public void sendResponse(ClassLoader cl,String logLevel,ServletContext srvCtx,HttpServletRequest request,HttpServletResponse response) throws ManagerException {
		
		response.setContentType(contentType);
		String ficheroXsl = "", ficheroXForms = "";
		
		try {
			String oput = ManagerUtilities.getParameter(request,ManagerUtilities.OUTPUT_PARAMETER);
			if (oput==null) oput = (String)request.getSession().getAttribute(ManagerUtilities.OUTPUT_PARAMETER);
			if (oput==null) oput = "";
			else oput = ManagerUtilities.FILE_SEPARATOR+oput;
			
			ficheroXsl = ManagerUtilities.getModuleParameter(request)+ManagerUtilities.FILE_SEPARATOR+fileId+oput+ManagerUtilities.FILE_SEPARATOR+ManagerUtilities.getActionParameter(request)+".xsl";
			ficheroXForms = ManagerUtilities.getModuleParameter(request)+ManagerUtilities.FILE_SEPARATOR+fileId+oput+ManagerUtilities.FILE_SEPARATOR+ManagerUtilities.getActionParameter(request)+".xform";
			File f = new File(ficheroXsl);
			if (!f.exists()) {
				ficheroXsl = ManagerUtilities.getModuleParameter(request)+ManagerUtilities.FILE_SEPARATOR+fileId+ManagerUtilities.FILE_SEPARATOR+ManagerUtilities.getActionParameter(request)+".xsl";
				ficheroXForms = ManagerUtilities.getModuleParameter(request)+ManagerUtilities.FILE_SEPARATOR+fileId+ManagerUtilities.FILE_SEPARATOR+ManagerUtilities.getActionParameter(request)+".xform";
			}
			
			TransformerFactory tfactory = SAXTransformerFactory.newInstance();
			tfactory.setURIResolver(new ManagerResolver(cl));
			
			SAXSource xslSource = new SAXSource(new InputSource(cl.getResource(ficheroXsl).openStream()));
			Transformer transformer = tfactory.newTransformer(xslSource);
			transformer.setOutputProperty(OutputKeys.ENCODING,ENCODING);
			
			// Por defecto se mandan unos parametros de utilidad
			transformer.setParameter(ManagerUtilities.ORG_MODULE_PARAMETER,ManagerUtilities.getOrgModuleParameter(request));
			transformer.setParameter(ManagerUtilities.ORG_ACTION_PARAMETER,ManagerUtilities.getOrgActionParameter(request));
			transformer.setParameter(ManagerUtilities.MODULE_PARAMETER,ManagerUtilities.getModuleParameter(request));
			transformer.setParameter(ManagerUtilities.ACTION_PARAMETER,ManagerUtilities.getActionParameter(request));
			transformer.setParameter(ManagerUtilities.SRV_CONTROL_PARAMETER,request.getServletPath());
						
			NodeList params = XMLUtil.selectNodes(file,ManagerTags.PARAM);
			if (params!=null) {
				for (int k=0; k<params.getLength(); k++) {
					Node par = params.item(k);
					String key = XMLUtil.getAttributeValue(par,ManagerTags.PARAM_NAME);
					String from = XMLUtil.getAttributeValue(par,ManagerTags.PARAM_FROM);
					String value = "";
					if (from==null) value = XMLUtil.getAttributeValue(par,ManagerTags.PARAM_VALUE);
					else if (from.equals(ManagerTags.REQUEST)) {
						value = ManagerUtilities.getParameter(request,key);
						if (value==null) value = XMLUtil.getAttributeValue(par,ManagerTags.PARAM_VALUE);
					}
					else if (from.equals(ManagerTags.SESSION)) {
						value = (String)request.getSession().getAttribute(key);
						if (value==null) value = XMLUtil.getAttributeValue(par,ManagerTags.PARAM_VALUE);
					}
					else if (from.equals(ManagerTags.REQ_SESSION)) {
						value = ManagerUtilities.getParameter(request,key);
						if (value==null) value = (String)request.getSession().getAttribute(key);
						if (value==null) value = XMLUtil.getAttributeValue(par,ManagerTags.PARAM_VALUE);
					}
					else if (from.equals(ManagerTags.SESSION_REQ)) {
						value = (String)request.getSession().getAttribute(key);
						if (value==null) value = ManagerUtilities.getParameter(request,key);
						if (value==null) value = XMLUtil.getAttributeValue(par,ManagerTags.PARAM_VALUE);
					}
					else value = XMLUtil.getAttributeValue(par,ManagerTags.PARAM_VALUE);
					if (value!=null) transformer.setParameter(key,value);
				}
			}
			if (parameters!=null) {
				Enumeration en = parameters.keys();
				while (en.hasMoreElements()) {
					String key = (String) en.nextElement(); 
					String value = (String) parameters.get(key);
					if (value!=null) transformer.setParameter(key,value);
				}
			}
			
			Document doc = null;
			if (dic!=null) doc = ManagerReader.readDictionaryModule(cl,request,dic.getLanguage());
			else {
    			doc = XMLUtil.createDocument(); 
    			Element el = doc.createElement(ManagerTags.XMLROOT);
    			doc.appendChild(el);
			}

			Enumeration en = objetosEjecutados.elements();
			while (en.hasMoreElements()) {
				Object obj = (Object)en.nextElement();
				doc = getXMLFrom(cl,ManagerUtilities.getModuleParameter(request),obj,doc);
			}

			// Incluye los datos del menu
			if (dataMenu!=null) doc = getXMLFrom(cl,ManagerUtilities.getModuleParameter(request),dataMenu.getDatosMenu(),doc);

			// Primera transformacin
			DOMSource xmlSource = new DOMSource(doc);
			DOMResult result = new DOMResult();
			transformer.transform(xmlSource,result);
			
			// Segunda Transformacin
			SAXSource xslSource2 = new SAXSource(new InputSource(cl.getResource(XFORMS_XSL).openStream()));
			Transformer transformer2 = tfactory.newTransformer(xslSource2);
			transformer.setOutputProperty(OutputKeys.ENCODING,ENCODING);
			StreamResult result2 = new StreamResult(response.getOutputStream());
			
			// Por defecto se mandan unos parametros de utilidad
			transformer2.setParameter(ManagerUtilities.ORG_MODULE_PARAMETER,ManagerUtilities.getOrgModuleParameter(request));
			transformer2.setParameter(ManagerUtilities.ORG_ACTION_PARAMETER,ManagerUtilities.getOrgActionParameter(request));
			transformer2.setParameter(ManagerUtilities.MODULE_PARAMETER,ManagerUtilities.getModuleParameter(request));
			transformer2.setParameter(ManagerUtilities.ACTION_PARAMETER,ManagerUtilities.getActionParameter(request));
			transformer2.setParameter(ManagerUtilities.SRV_CONTROL_PARAMETER,request.getServletPath());
			
			transformer2.transform(new DOMSource(result.getNode().getFirstChild()),result2);
			
		} catch (ManagerException ex) {
			throw ex;
		} catch (Exception ex) {
			throw new ManagerException("XFORMSOutput","El fichero xsl ["+ficheroXsl+"] no existe, o contiene errores.",ex);
		}			

	}

	public Mapping getMapping(ClassLoader cl,String module,Object obj) throws Exception {
		try {
			Mapping m = new Mapping(cl);
			m.setEntityResolver(new ManagerResolver(cl));
			m.loadMapping(ManagerReader.getMappingResource(cl,module));
			return m;
		} catch (Exception ex) { 
			throw ex; 
		}
	}

	// Obtener XML de un Objeto
	
	public Document getXMLFrom(ClassLoader cl,String module,Object obj,Document doc) throws Exception {
		// Convierte a XML un Objeto
		try {
    		Node node = null;
    		if (doc==null) { 
    			doc = XMLUtil.createDocument(); 
    			Element el = doc.createElement(ManagerTags.XMLROOT);
    			doc.appendChild(el);
    			node = doc.createElement(ManagerTags.DATA);
    			el.appendChild(node);
    		} else {
    			Node raiz = XMLUtil.selectSingleNode(doc,ManagerTags.XMLROOT);
    			if (raiz!=null) {
    				node = XMLUtil.selectSingleNode(raiz,ManagerTags.DATA);
					if (node==null) {
						node = doc.createElement(ManagerTags.DATA);
						raiz.appendChild(node);
    				}
    			} else {
					raiz = doc.createElement(ManagerTags.XMLROOT);
	  				doc.appendChild(raiz);
	  				node = doc.createElement(ManagerTags.DATA);
	  				raiz.appendChild(node);
    			}
    		}
    		Marshaller marshaller = new Marshaller(node);
    		marshaller.setMapping(getMapping(cl,module,obj));
    		marshaller.setMarshalAsDocument(true);
    		marshaller.marshal(obj);
    		
		} catch (Exception e) {
			throw new Exception("CastorXML: "+e);
		}
    		
		return doc;
	}
	
}
