/*
 * Created on 23-feb-2005
 *
 */
package atica.frameweb.output;

import java.util.Enumeration;
import javax.servlet.ServletContext;
import javax.xml.transform.*;
import javax.xml.transform.dom.*;
import javax.xml.transform.sax.*;
import javax.xml.transform.stream.*;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.xml.serialize.*;

import org.exolab.castor.mapping.Mapping;
import org.exolab.castor.xml.Marshaller;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.w3c.dom.ProcessingInstruction;

import atica.frameweb.manager.*;
import atica.frameweb.xml.XMLUtil;

/**
 * @author Universidad de Murcia
 *
 * Manejador de Salida Para XSL
 * 
 */
public class XMLOutput extends GeneralOutput {

	private Node createNode(Document doc,String name,String value) {
		Element el = doc.createElement(name);
		el.appendChild(doc.createTextNode(value));
		return el;
	}
	
	public void sendResponse(ClassLoader cl,String logLevel,ServletContext srvCtx,HttpServletRequest request,HttpServletResponse response) throws ManagerException {
		
		response.setContentType(contentType);
		String ficheroXsl = "";
		
		try {
			
			String oput = ManagerUtilities.getParameter(request,ManagerUtilities.OUTPUT_PARAMETER);
			if (oput==null) oput = (String)request.getSession().getAttribute(ManagerUtilities.OUTPUT_PARAMETER);
			if (oput==null) oput = "";
			else oput = ManagerUtilities.FILE_SEPARATOR+oput;
			
			ficheroXsl = ManagerUtilities.getModuleParameter(request)+ManagerUtilities.FILE_SEPARATOR+fileId+oput+ManagerUtilities.FILE_SEPARATOR+ManagerUtilities.getActionParameter(request)+".xsl";
			ficheroXsl = "../"+ficheroXsl;
			
			// NO TRANSFORMO EL XML !!!
			TransformerFactory tfactory = SAXTransformerFactory.newInstance();
			tfactory.setURIResolver(new ManagerResolver(cl));
			
			//SAXSource xslSource = new SAXSource(new InputSource(cl.getResource(ficheroXsl).openStream()));
			Transformer transformer = tfactory.newTransformer();
			transformer.setOutputProperty(OutputKeys.ENCODING,ENCODING);
			transformer.setOutputProperty(OutputKeys.METHOD,METHOD_XML);
			
			Document doc = null;
			if (dic!=null) doc = ManagerReader.readDictionaryModule(cl,request,dic.getLanguage());
			else {
    			doc = XMLUtil.createDocument();
    			Element el = doc.createElement(ManagerTags.XMLROOT);
    			doc.appendChild(el);
			}
			
			Node miNode = doc.getDocumentElement();
			ProcessingInstruction pi = doc.createProcessingInstruction("xml-stylesheet","type=\"text/xsl\" href=\""+ficheroXsl+"\"");
			doc.appendChild(pi);
			doc.removeChild(miNode);
			doc.appendChild(miNode);
			
			// Por defecto se mandan unos parametros de utilidad
			Element el = doc.createElement(ManagerTags.PARAM);
			doc.getDocumentElement().appendChild(el);
			el.appendChild(createNode(doc,ManagerUtilities.ORG_MODULE_PARAMETER,ManagerUtilities.getOrgModuleParameter(request)));
			el.appendChild(createNode(doc,ManagerUtilities.ORG_ACTION_PARAMETER,ManagerUtilities.getOrgActionParameter(request)));
			el.appendChild(createNode(doc,ManagerUtilities.ORG_ACTION_PARAMETER,ManagerUtilities.getOrgActionParameter(request)));
			el.appendChild(createNode(doc,ManagerUtilities.MODULE_PARAMETER,ManagerUtilities.getModuleParameter(request)));
			el.appendChild(createNode(doc,ManagerUtilities.ACTION_PARAMETER,ManagerUtilities.getActionParameter(request)));
			el.appendChild(createNode(doc,ManagerUtilities.SRV_CONTROL_PARAMETER,request.getContextPath()+request.getServletPath()));
						
			NodeList params = XMLUtil.selectNodes(file,ManagerTags.PARAM);
			if (params!=null) {
				for (int k=0; k<params.getLength(); k++) {
					Node par = params.item(k);
					String key = XMLUtil.getAttributeValue(par,ManagerTags.PARAM_NAME);
					String from = XMLUtil.getAttributeValue(par,ManagerTags.PARAM_FROM);
					String value = "";
					if (from==null) value = XMLUtil.getAttributeValue(par,ManagerTags.PARAM_VALUE);
					else if (from.equals(ManagerTags.REQUEST)) {
						value = ManagerUtilities.getParameter(request,key);
						if (value==null) value = XMLUtil.getAttributeValue(par,ManagerTags.PARAM_VALUE);
					}
					else if (from.equals(ManagerTags.SESSION)) {
						value = (String)request.getSession().getAttribute(key);
						if (value==null) value = XMLUtil.getAttributeValue(par,ManagerTags.PARAM_VALUE);
					}
					else if (from.equals(ManagerTags.REQ_SESSION)) {
						value = ManagerUtilities.getParameter(request,key);
						if (value==null) value = (String)request.getSession().getAttribute(key);
						if (value==null) value = XMLUtil.getAttributeValue(par,ManagerTags.PARAM_VALUE);
					}
					else if (from.equals(ManagerTags.SESSION_REQ)) {
						value = (String)request.getSession().getAttribute(key);
						if (value==null) value = ManagerUtilities.getParameter(request,key);
						if (value==null) value = XMLUtil.getAttributeValue(par,ManagerTags.PARAM_VALUE);
					}
					else value = XMLUtil.getAttributeValue(par,ManagerTags.PARAM_VALUE);
					if (value!=null) el.appendChild(createNode(doc,key,value));
				}
			}
			if (parameters!=null) {
				Enumeration en = parameters.keys();
				while (en.hasMoreElements()) {
					String key = (String) en.nextElement(); 
					String value = (String) parameters.get(key);
					if (value!=null) el.appendChild(createNode(doc,key,value));
				}
			}
			
			int contk = 0;
			Enumeration en = objetosEjecutados.elements();
			while (en.hasMoreElements()) {
				Object obj = (Object)en.nextElement();
				String modObj = (String)modulosEjecutados.elementAt(contk);
				doc = getXMLFrom(cl,modObj,obj,doc);
				contk++;
			}
			
			// Incluye los datos del menu, lo hago al final !!
			if ((dataMenu!=null) && (dataMenu.getDatosMenu()!=null)) {
				doc = getXMLFrom(cl,ManagerUtilities.getModuleParameter(request),dataMenu.getDatosMenu(),doc);
				String value = ManagerUtilities.getParameter(request,ManagerTags.MENU.toLowerCase());
				if (value!=null) {
					transformer.setParameter(ManagerTags.MENU.toLowerCase(),value);
					dataMenu.getDatosMenu().setOption(value);
				} else {
					value = dataMenu.getDatosMenu().getOption();
					transformer.setParameter(ManagerTags.MENU.toLowerCase(),value);
				}
			}

			
			DOMSource xmlSource = new DOMSource(doc);
			StreamResult result = new StreamResult(response.getOutputStream());
			transformer.transform(xmlSource,result);
			
			//XMLUtil.printDocument(doc,response.getOutputStream());
			
		} catch (ManagerException ex) {
			throw ex;
		} catch (Exception ex) {
			throw new ManagerException("XMLOutput","Error en salida XML: ",ex);
		}			

	}

	public Mapping getMapping(ClassLoader cl,String module,Object obj) throws Exception {
		try {
			Mapping m = new Mapping(cl);
			m.setEntityResolver(new ManagerResolver(cl));
			m.loadMapping(ManagerReader.getMappingResource(cl,module));
			return m;
		} catch (Exception ex) { 
			throw ex; 
		}
	}

	// Obtener XML de un Objeto
	
	public Document getXMLFrom(ClassLoader cl,String module,Object obj,Document doc) throws Exception {
		// Convierte a XML un Objeto
		try {
			
    		Node node = null;
    		if (doc==null) { 
    			doc = XMLUtil.createDocument(); 
    			Element el = doc.createElement(ManagerTags.XMLROOT);
    			doc.appendChild(el);
    			node = doc.createElement(ManagerTags.DATA);
    			el.appendChild(node);
    		} else {
    			Node raiz = XMLUtil.selectSingleNode(doc,ManagerTags.XMLROOT);
    			if (raiz!=null) {
    				node = XMLUtil.selectSingleNode(raiz,ManagerTags.DATA);
					if (node==null) {
						node = doc.createElement(ManagerTags.DATA);
						raiz.appendChild(node);
    				}
    			} else {
					raiz = doc.createElement(ManagerTags.XMLROOT);
	  				doc.appendChild(raiz);
	  				node = doc.createElement(ManagerTags.DATA);
	  				raiz.appendChild(node);
    			}
    		}
    		Marshaller marshaller = new Marshaller(node);
    		marshaller.setMapping(getMapping(cl,module,obj));
    		marshaller.setMarshalAsDocument(true);
    		marshaller.marshal(obj);
    		
		} catch (Exception e) {
			throw new ManagerException(new Exception("CastorXML: Error en el mapping "+e));
		}
    		
		return doc;
	}
	
}
