/*
 * Created on 02-mar-2005
 *
 */
package atica.frameweb.query;

import java.sql.*;
/**
 * @author Universidad de Murcia
 *
 */
public class FrameWebQuery {

	public static final String IN_CHAR = "#";
	public static final String PAR_CHAR = "?";
	public static final String COMA = ",";
	
	protected String query = "";
	protected PreparedStatement ps = null;
	protected int [] cnt = null;
	protected int [] beforeIn = null;
	
	public FrameWebQuery() {}
	
	public FrameWebQuery(Connection conn,String qry,int [] inCnt) throws SQLException {
		query = qry; cnt = inCnt;
		if ((cnt==null) || (cnt.length==0)) {
			// Es una query tradicional.
			if (query.indexOf(IN_CHAR)>=0) throw new SQLException("La query contiene # que no han sido declarados.");
		} else {
			// Es una query con in's !!
			beforeIn = new int[cnt.length];
			for (int k=0; k<cnt.length; k++) {
				int base = query.indexOf(IN_CHAR);
				beforeIn[k] = numberOf(query,base);
				query = replaceQuery(query,base,cnt[k]);
			}
		}
		createQuery(conn);
	}
	
	protected void createQuery(Connection conn) throws SQLException { ps = conn.prepareStatement(query); }
	
	protected String replaceQuery(String q,int base,int n) {
		String s = q;
		if (base>=0) {
			String prev = s.substring(0,base);
			String cadena = "";
			for (int k=0; k<n; k++) {
				if (cadena.equals("")) cadena = PAR_CHAR;
				else cadena += COMA+PAR_CHAR;
			}
			String post = s.substring(base+1);
			return prev+cadena+post;
		}
		return s;
	}
	
	protected int numberOf(String s,int base) {
		int count = 0;
		int i = s.indexOf(PAR_CHAR);
		while ((i>=0) && (i<base)) {
			count++;
			i = s.indexOf(PAR_CHAR,i+1);
		}
		return count;
	}
	
	public int realNumber(int n) {
		if ((cnt==null) || (cnt.length==0)) return n;
		int cont = 0;
		for (int k=0; k<cnt.length; k++) {
			if (n<=(beforeIn[k]+1-cont)) {
				if (k==0) return n;
				else return n+cont; 
			} else if ((k+1)==cnt.length) {
				return n+cont+cnt[k]-1;
			}
			cont += cnt[k]-1;
		}
		return n;
	}
	
	public void setNull(int n,int s) throws SQLException {
		ps.setNull(realNumber(n),s); 
	}

	public void setString(int n,String s) throws SQLException {
		ps.setString(realNumber(n),s); 
	}
	
	public void setFloat(int n,float s) throws SQLException {
		ps.setFloat(realNumber(n),s); 
	}
	
	public void setInt(int n,int s) throws SQLException {
		ps.setInt(realNumber(n),s); 
	}

	public void setBlob(int n,Blob s) throws SQLException {
		ps.setBlob(realNumber(n),s); 
	}
	
	public void setString(int n,String [] s) throws SQLException {
		int m = realNumber(n);
		for (int k=0; k<s.length; k++) {
			ps.setString(m+k,s[k]);
		}
	}
	
	public void setFloat(int n,float [] s) throws SQLException {
		int m = realNumber(n);
		for (int k=0; k<s.length; k++) {
			ps.setFloat(m+k,s[k]);
		}
	}
	
	public void setInt(int n,int [] s) throws SQLException {
		int m = realNumber(n);
		for (int k=0; k<s.length; k++) {
			ps.setInt(m+k,s[k]);
		}
	}
	
	public ResultSet executeQuery() throws SQLException { return ps.executeQuery(); }
	
	public int executeUpdate() throws SQLException { return ps.executeUpdate(); }
	
	public boolean execute() throws SQLException { return ps.execute(); }
	
	public void close() throws SQLException { if (ps!=null) ps.close(); }
	
	public String getQuery() { return query; }
}
