/*
 * Created on 19-feb-2005
 *
 */
package atica.frameweb.user;

import java.io.*;

/**
 * @author Juan Jos Meroo Snchez
 *
 * Define un perfil para el usuario
 * 
 */
public class Profile implements Serializable {
	
	protected String profileCode = "";
	protected String profileDesc = "";
	
	public Profile(String code) { if (code!=null) profileCode = code; }
	public Profile(String code,String desc) { 
		if (code!=null) profileCode = code; 
		if (desc!=null) profileDesc = desc; 
	}
	
 	private void writeObject(java.io.ObjectOutputStream out) throws IOException {
 		out.writeObject(profileCode);
 		out.writeObject(profileDesc);
 	}
	
 	private void readObject(java.io.ObjectInputStream in) throws IOException, ClassNotFoundException {
 		profileCode = (String)in.readObject();
 		profileDesc = (String)in.readObject();
 	}
	
	public String getCode() { return profileCode; }
	public String getName() { return profileDesc; }
	
	public void setCode(String c) { profileCode = c; }
	public void setName(String d) { profileDesc = d; }
	
	public boolean equals(Object obj) {
		Profile p = (Profile)obj;
		return p.getCode().equals(profileCode); 
	}
	
	public String toString() {
		StringBuffer sb = new StringBuffer();
		sb.append(super.toString()+"\n");
		sb.append(profileCode+":"+profileDesc+"\n");
		return sb.toString();
	}
	
}
