/*
 * Created on 19-feb-2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
package atica.frameweb.user;

import java.io.IOException;
import java.util.*;

import java.io.*;

/**
 * @author Administrador
 *
 * Define a un Rol
 * 
 */
public class Role implements Serializable {
	
	protected String rolCode = "";
	protected String rolName = "";
	protected String rolDesc = "";
	protected Vector profiles = new Vector();
	protected Vector hijos = new Vector();
	protected Role rolPadre = null;
	
	public Role(String code) { if (code!=null) rolCode = code; }
	public Role(String code,String name,String desc) { 
		if (code!=null) rolCode = code; 
		if (name!=null) rolName = name; 
		if (desc!=null) rolDesc = desc; 
	}

 	private void writeObject(java.io.ObjectOutputStream out) throws IOException {
 		out.writeObject(profiles);
 		out.writeObject(hijos);
 		out.writeObject(rolPadre);
 		out.writeObject(rolCode);
 		out.writeObject(rolName);
 		out.writeObject(rolDesc);
 	}
	
 	private void readObject(java.io.ObjectInputStream in) throws IOException, ClassNotFoundException {
 		profiles = (Vector)in.readObject();
 		hijos = (Vector)in.readObject();
 		rolPadre = (Role)in.readObject();
 		rolCode = (String)in.readObject();
 		rolName = (String)in.readObject();
 		rolDesc = (String)in.readObject();
 	}
	
	public String getCode() { return rolCode; }
	public String getName() { return rolName; }
	public String getDesc() { return rolDesc; }
	public void setCode(String c) { rolCode = c; }
	public void setName(String n) { rolName = n; }
	public void setDescription(String d) { rolDesc = d; }
	
	public boolean equals(Object obj) {
		Role r = (Role)obj;
		if (rolCode.equals("")) return r.getName().equals(rolName);
		return (r.getCode().equals(rolCode) || r.getName().equals(rolName)); 
	}
	
	protected void addProfile(Profile p) {
		if (!profiles.contains(p)) {
			profiles.addElement(p);
			// Tambin lo aado a todos los roles descendientes y ascendientes !!
			Enumeration en = hijos.elements();
			while (en.hasMoreElements()) {
				((Role)en.nextElement()).addProfile(p);
			}
			if (rolPadre!=null) rolPadre.addProfilePadre(p);
		}
	}
	
	protected void addProfilePadre(Profile p) {
		// No llama a los hijos porque la llamada viene de un hijo !!
		if (!profiles.contains(p)) {
			profiles.addElement(p);
			if (rolPadre!=null) rolPadre.addProfilePadre(p);
		}
	}

	protected void cargaPerfilesRolHijos(User user) {
		Enumeration en = hijos.elements();
		while (en.hasMoreElements()) {
			Role rolHijo = (Role)en.nextElement();
			if (rolHijo.isNodoHoja()) user.cargarPerfilesRol(rolHijo);
			else rolHijo.cargaPerfilesRolHijos(user);
		}
	}
	
	protected void setRolePadre(Role r) { if (r!=null) rolPadre = r; }
	
	protected void addRoleHijo(Role r) { 
		if (r!=null) {
			hijos.addElement(r);
			r.setRolePadre(this);
		}
	}
	
	protected boolean hasProfiles(String [] prf) {
		int contador = 0;
		for (int k=0; k<prf.length; k++) {
			if (profiles.contains(new Profile(prf[k]))) contador++;
		}
		return (contador==prf.length);
	}
	
	public String toString() {
		StringBuffer sb = new StringBuffer();
		sb.append(super.toString()+"\n");
		sb.append(rolCode+":"+rolName+":"+rolDesc+"\n");
		Enumeration en = profiles.elements();
		while (en.hasMoreElements()) {
			Profile r = (Profile)en.nextElement();
			sb.append(r.toString());
		}
		return sb.toString();
	}
	
	public boolean isNodoHoja() { return hijos.size()==0; }
	
}
