/*
 * Created on 07-abr-2005
 *
 */
package atica.frameweb.user;

import java.util.*;
import atica.frameweb.utils.*;
import atica.frameweb.manager.*;

/**
 * @author Universidad de Murcia
 *
 * Permite reflejar accesos en XML
 * 
 */

public class Security extends GeneralManager {
	
	protected String modulo = "";
	protected Hashtable actions = new Hashtable();
	
	public void setModulo(String m) { modulo = m; }
	public String getModulo() { return modulo; }
	
	public Collection getActions() { return actions.values(); }
	
	public void addAction(String a) {
		SecurityAction sa = new SecurityAction();
		sa.setName(a);
		actions.put(a,sa); 
	}
	
	public void permitido() {
		try {
			Enumeration keys = actions.keys();
			while (keys.hasMoreElements()) {
				String clave = (String)keys.nextElement();
				try {
					if ((user==null) || !user.permitido(modulo,clave)) actions.remove(clave);
				} catch (ManagerException ex) {}
			}
		} catch (Exception ex) {
			setErrorMessage("Security[permitido]: "+ex);
		}
	}
	
	public void permitidoPerfiles(String perfil) {
		try {
			permitidoPerfiles(new String[]{perfil});
		} catch (Exception ex) {
			setErrorMessage("Security[permitidoPerfiles]: "+ex);
		}
	}
	
	public void permitidoPerfiles(String [] perfiles) {
		try {
			Enumeration keys = actions.keys();
			while (keys.hasMoreElements()) {
				String clave = (String)keys.nextElement();
				SecurityAction sa = (SecurityAction)actions.get(clave);
				if (perfiles!=null) {
				  for (int k=0; k<perfiles.length; k++) {
					try {
						if ((user!=null) && user.permitidoPerfiles(perfiles[k],modulo,clave)) {
							sa.addProfile(perfiles[k]);
						}
					} catch (ManagerException ex) {}
				  }
				}
				if (sa.getProfiles().size()==0) actions.remove(clave);
			}
		} catch (Exception ex) {
			setErrorMessage("Security[permitidoPerfiles]: "+ex);
		}
	}
	
	public void permitidoMenu(String menu) {
		try {
			permitidoPerfiles(user.getDatosMenu().idSelected());
		} catch (Exception ex) {
			setErrorMessage("Security[permitidoMenu]: "+ex);
		}
	}
	
}
