/*
 * 
 *
 */
package atica.frameweb.user.menu;

import java.io.*;
import java.util.*;
import atica.frameweb.manager.*;
import atica.frameweb.user.*;
import org.w3c.dom.*;

/**
 * @author Universidad de Murcia
 *
 */
public class DatosMenu implements Serializable {

	public Vector items = new Vector();
	public String name = "";
	public String url = "";
	public String id = "";
	public String idSelected = "";
	public String option = "";
	public String auto;

	public void setName(String n) { name = n; }
	public String getName() { return name; }

	public void setURL(String n) { url = n; }
	public String getURL() { return url; }
	
	public void setID(String n) { id = n; }
	public String getID() { return id; }

	public void setAuto(String n) { auto = n; }
	public String getAuto() { return auto; }

	public String idSelected() { return idSelected; }
	public void setOption(String opc) {
		option = opc;
		if ((option==null) || option.equals("")) { idSelected = ""; return; }
		Enumeration en = items.elements();
		while (en.hasMoreElements()) {
			DatosMenu dm = (DatosMenu)en.nextElement();
			if (option.startsWith(dm.getID())) {
				idSelected = dm.getID();
				return;
			}
		}
	}
	public String getOption() { return option; }
	public void addItem(DatosMenu op) {
		items.addElement(op);
	}
	
	public void delItem(DatosMenu op) {
		items.remove(op);
	}

	public Vector getItems() { return items; }
	public void setItems(Vector v) { items = v; }

 	private void writeObject(java.io.ObjectOutputStream out) throws IOException {
 		out.writeObject(items);
 		out.writeObject(name);
 		out.writeObject(url);
 		out.writeObject(id);
 		out.writeObject(auto);
 		out.writeObject(idSelected);
 		out.writeObject(option);
 	}
	
 	private void readObject(java.io.ObjectInputStream in) throws IOException, ClassNotFoundException {
 		items = (Vector)in.readObject();
 		name = (String)in.readObject();
 		url = (String)in.readObject();
 		id = (String)in.readObject();
 		auto = (String)in.readObject();
 		idSelected = (String)in.readObject();
 		option = (String)in.readObject();
 	}
	
 	public DatosMenu clonar()
 	{
 	    DatosMenu clone = null;
        clone = new DatosMenu();
        clone.id = this.id;
        clone.auto = this.auto;
		clone.idSelected = this.idSelected;
		clone.items = new Vector();
		clone.name = this.name;
		clone.option = this.option;
		clone.url = this.url;
		Enumeration en = items.elements();
		while (en.hasMoreElements()) {
			clone.addItem(((DatosMenu)en.nextElement()).clonar());
		}
 	    return clone;
 	} 	
 	
 	public boolean isPermitedItem(IUser user,String module) throws ManagerException {
 		if (name.equals("") || user.permitido(module,name)) {
 			Vector d = new Vector();
 			Enumeration en = items.elements();
 			while (en.hasMoreElements()) {
 				DatosMenu dm = (DatosMenu)en.nextElement();
 				if (!dm.isPermitedItem(user,module)) d.addElement(dm);
 			}
 			removeFrom(items,d);
 			return true;
 		} else return false;
 	}

 	public boolean isPermitedItem(IUser user,String module,String [] profile) throws ManagerException {
 		if (name.equals("") || user.permitidoPerfiles(profile,module,name)) {
 			Vector d = new Vector();
 			Enumeration en = items.elements();
 			while (en.hasMoreElements()) {
 				DatosMenu dm = (DatosMenu)en.nextElement();
 				if (!dm.isPermitedItem(user,module,profile)) d.addElement(dm);
 			}
 			removeFrom(items,d);
 			return true;
 		} else return false;
 	}

 	public void removeNotPermited(IUser user) throws ManagerException {
 		String paquete = user.getClass().getName().substring(0,user.getClass().getName().lastIndexOf("."));
 		if (!this.isPermitedItem(user,paquete.replace('.','/'))) {
 			this.setItems(new Vector());
 			this.setName(""); this.setURL("");
 		}
 	}
 	
 	public void removeNotPermited(IUser user,String [] prf) throws ManagerException {
 		String paquete = user.getClass().getName().substring(0,user.getClass().getName().lastIndexOf("."));
 		if (!this.isPermitedItem(user,paquete.replace('.','/'),prf)) {
 			this.setItems(new Vector());
 			this.setName(""); this.setURL("");
 		}
 	}

 	public void removeNotNamed() throws ManagerException {
 		Vector d = new Vector();
 		Enumeration en = items.elements();
 		while (en.hasMoreElements()) {
 			DatosMenu dm = (DatosMenu)en.nextElement();
 			if ((dm.getName()==null) || dm.getName().equals("")) d.addElement(dm);
 		}
 		removeFrom(items,d);
 	}
 	
 	public void traduceItems(Document dic,IUser user,String d) {
 		Document doc = dic;
 		try {
 			if (doc==null) doc = user.readDictionary(null);
 			setName(user.traduce(doc,name,d));
 			Enumeration en = items.elements();
 			String sist = d;
 			if (d==null && this.getID()!=null && !this.getID().equals("")) sist = this.getID();
 			while (en.hasMoreElements()) {
 				((DatosMenu)en.nextElement()).traduceItems(doc,user,sist);
 			}
 		} catch (Exception ex) {}
 	}
 	
 	public static void removeFrom(Vector v,Vector d) {
 		Enumeration en = d.elements();
 		while (en.hasMoreElements()) {
 			v.remove(en.nextElement());
 		}
 	}
 	
}
