/*
 * Created on 20-feb-2005
 *
 */
package atica.frameweb.utils;

import java.sql.*;
import java.util.*;
import org.w3c.dom.*;

import atica.frameweb.xml.*;
import atica.frameweb.user.*;
import atica.frameweb.query.*;
import atica.frameweb.manager.*;
/**
 * @author Administrador
 *
 */
public abstract class GeneralManager implements IPaginable {
	
	protected IPaginable gralPag = new GeneralPaginator();
	protected IUser user = null;
	protected String errorMessage = "";

	// Mtodos Para la Paginacin
	public final boolean setPageParameters(String p,String s) { return gralPag.setPageParameters(p,s); }
	public final String getPage() { return gralPag.getPage(); }
	public final Vector getPageList() { return gralPag.getPageList();	}
	public final Vector getCollection() {	return gralPag.getCollection();	}
	public final void setCollection(Vector v) { gralPag.setCollection(v); }
	public final void setCollection(Collection v) { gralPag.setCollection(v); }
	public final void setCollection(Iterator v) { gralPag.setCollection(v); }
	public final IPaginable getPaginable() { return gralPag; }
	public final void setPageSize(int n) { gralPag.setPageSize(n); }
	
	public final IUser getUser() { return user; }
	public final void setUser(IUser u) { user = u; }
	
	public Document readDictionary() throws ManagerException {
		return user.readDictionary(getClass().getName().substring(0,getClass().getName().lastIndexOf(".")));
	}

	public String traduce(Document doc,String id,String dia) {
		return user.traduce(doc,id,dia);
	}

	public final String getErrorMessage() { return errorMessage; }
	public void setErrorMessage(String message) { errorMessage = message; }
	
	public final FrameWebQuery getQuery(Connection conn,String id,int [] cnt) throws ManagerException,SQLException {
		String name = getClass().getName();
		int ind = name.lastIndexOf(".");
		name = name.substring(0,ind).replace('.','/');
		Document qry = ManagerReader.readQueryModule(getClass().getClassLoader(),name);
		Node n = XMLUtil.selectSingleNode(qry,ManagerTags.QUERY,ManagerTags.QUERY_NAME,id);
		if (n==null) throw new ManagerException("GeneralManager","La Consulta de BBDD ["+id+"] no existe en el fichero de querys.");
		Node nsql = XMLUtil.selectSingleNode(n,ManagerTags.SQL);
		return new FrameWebQuery(conn,nsql.getFirstChild().getNodeValue(),cnt);
	}

	public final FrameWebQuery getQuery(Connection conn,String id) throws ManagerException,SQLException {
		String name = getClass().getName();
		int ind = name.lastIndexOf(".");
		name = name.substring(0,ind).replace('.','/');
		Document qry = ManagerReader.readQueryModule(getClass().getClassLoader(),name);
		Node n = XMLUtil.selectSingleNode(qry,ManagerTags.QUERY,ManagerTags.QUERY_NAME,id);
		if (n==null) throw new ManagerException("GeneralManager","La Consulta de BBDD ["+id+"] no existe en el fichero de querys.");
		Node nsql = XMLUtil.selectSingleNode(n,ManagerTags.SQL);
		return new FrameWebQuery(conn,nsql.getFirstChild().getNodeValue(),null);
	}

	public final FrameWebCallable getCallable(Connection conn,String id,int [] cnt) throws ManagerException,SQLException {
		String name = getClass().getName();
		int ind = name.lastIndexOf(".");
		name = name.substring(0,ind).replace('.','/');
		Document qry = ManagerReader.readQueryModule(getClass().getClassLoader(),name);
		Node n = XMLUtil.selectSingleNode(qry,ManagerTags.QUERY,ManagerTags.QUERY_NAME,id);
		if (n==null) throw new ManagerException("GeneralManager","La Consulta de BBDD ["+id+"] no existe en el fichero de querys.");
		Node nsql = XMLUtil.selectSingleNode(n,ManagerTags.SQL);
		return new FrameWebCallable(conn,nsql.getFirstChild().getNodeValue(),cnt);
	}

	public final FrameWebCallable getCallable(Connection conn,String id) throws ManagerException,SQLException {
		String name = getClass().getName();
		int ind = name.lastIndexOf(".");
		name = name.substring(0,ind).replace('.','/');
		Document qry = ManagerReader.readQueryModule(getClass().getClassLoader(),name);
		Node n = XMLUtil.selectSingleNode(qry,ManagerTags.QUERY,ManagerTags.QUERY_NAME,id);
		if (n==null) throw new ManagerException("GeneralManager","La Consulta de BBDD ["+id+"] no existe en el fichero de querys.");
		Node nsql = XMLUtil.selectSingleNode(n,ManagerTags.SQL);
		return new FrameWebCallable(conn,nsql.getFirstChild().getNodeValue(),null);
	}

	public final String getQuery(String id) throws ManagerException {
		String name = getClass().getName();
		int ind = name.lastIndexOf(".");
		name = name.substring(0,ind).replace('.','/');
		Document qry = ManagerReader.readQueryModule(getClass().getClassLoader(),name);
		Node n = XMLUtil.selectSingleNode(qry,ManagerTags.QUERY,ManagerTags.QUERY_NAME,id);
		if (n==null) throw new ManagerException("GeneralManager","La Consulta de BBDD ["+id+"] no existe en el fichero de querys.");
		Node nsql = XMLUtil.selectSingleNode(n,ManagerTags.SQL);
		return nsql.getFirstChild().getNodeValue();
	}
	
}
