/*
 * Created on 20-feb-2005
 *
 */
package atica.frameweb.utils;

import java.util.*;

/**
 * @author Juan Jos Meroo Snchez
 *
 */
public class GeneralPaginator implements IPaginable {
	
	public static final String FIRST_PAGE = "FIRST";
	public static final String LAST_PAGE = "LAST";
	public static final String SET_PAGE_PARAMETERS = "setPageParameters";
	public static final String PAGE_PARAMETER = "page";
	public static final String PAGE_RANGE_PARAMETER = "pagesize";
	
	private String pagAct = "1";
	protected int pagActual = 0;
	protected int tamPag = 0;
	protected Vector completeCollection = new Vector();
	
	public final String getPageSize() { return ""+tamPag; }
	
	public final void setPageSize(int n) { tamPag = n; }
	
	public final boolean setPageParameters(String pag,String s) {
		try {
			tamPag = Integer.parseInt(s);
		} catch (Exception ex) {
			tamPag = 0;
		}
		if (pag!=null) {
			if (pag.equals(FIRST_PAGE) || pag.equals(LAST_PAGE)) {
				pagAct = pag;
				pag = "1";
			} else pagAct = pag;
		} else pag = "1";
		return (pag.equals("1"));
	}

	public final String getPage() {
		if (pagAct.equals(FIRST_PAGE) || pagAct.equals(LAST_PAGE)) return ""+pagActual;
		return pagAct; 
	}
	
	private void setPaginaActual() {
		try {
			if (pagAct.equals(LAST_PAGE) && (tamPag!=0)) {
				int top = completeCollection.size()/tamPag;
				if ((completeCollection.size()%tamPag)!=0) top++;
				pagAct = ""+top;
			}
			pagActual = Integer.parseInt(pagAct);
		} catch (Exception ex) {
			pagActual = 1;
		}
	}
	
	public final Vector getPageList() {
		Vector pages = new Vector();
		if (tamPag==0) return pages;
		int top = completeCollection.size()/tamPag;
		if ((completeCollection.size()%tamPag)!=0) top++;
		for (int k=1; k<=top; k++) {
			pages.addElement(""+k);
		}
		return pages;
	}
	
	public final void setCollection(Vector v) {
		completeCollection = (v==null)?new Vector():v;
		if (tamPag>completeCollection.size()) tamPag = completeCollection.size(); 
	}

	private Vector getCollectionFrom(Iterator it) {
		Vector v = new Vector();
		if (it==null) return v;
		while (it.hasNext()) {
			Object ob = it.next();
			v.addElement(ob);
		}
		return v;
	}
	
	public final void setCollection(Collection col) {
		completeCollection = (col==null)?new Vector():getCollectionFrom(col.iterator());
		if ((completeCollection.size()>0) && (tamPag>completeCollection.size())) tamPag = completeCollection.size(); 
	}

	public final void setCollection(Iterator it) {
		completeCollection = (it==null)?new Vector():getCollectionFrom(it);
		if ((completeCollection.size()>0) && (tamPag>completeCollection.size())) tamPag = completeCollection.size(); 
	}
	
	public final Vector getCollection() {
		Vector v = new Vector();
		setPaginaActual();
		int itemInicial = (pagActual-1)*tamPag;
		if (itemInicial>completeCollection.size()) { 
			itemInicial = completeCollection.size()-tamPag; 
			pagActual = (tamPag==0)?1:(completeCollection.size()/tamPag); 
		}
		if (itemInicial<0) { itemInicial = 0; pagActual = 1; }
		int itemFinal = (pagActual*tamPag);
		if (itemFinal>completeCollection.size()) itemFinal = completeCollection.size();
		for (int k=itemInicial; k<itemFinal; k++) {
			Object obj = completeCollection.elementAt(k);
			v.addElement(obj);
		}
		return v;
	}
	
	public IPaginable getPaginable() { return this; }
}
