/*
 * Created on 20-feb-2005
 *
 */
package atica.frameweb.utils;

import java.sql.*;
import java.util.*;
import org.w3c.dom.*;
import atica.frameweb.xml.*;
import atica.frameweb.user.*;
import atica.frameweb.query.*;
import atica.frameweb.manager.*;
/**
 * @author Administrador
 *
 */
public abstract class HBGeneralManager implements IPaginable {
	
	protected IPaginable gralPag = new GeneralPaginator();
	protected IUser user = null;

	// Mtodos Para la Paginacin
	public final boolean setPageParameters(String p,String s) { return gralPag.setPageParameters(p,s); }
	public final String getPage() { return gralPag.getPage(); }
	public final Vector getPageList() { return gralPag.getPageList();	}
	public final Vector getCollection() {	return gralPag.getCollection();	}
	public final void setCollection(Vector v) { gralPag.setCollection(v); }
	public final void setCollection(Collection v) { gralPag.setCollection(v); }
	public final void setCollection(Iterator v) { gralPag.setCollection(v); }
	public final IPaginable getPaginable() { return gralPag; }
	
	public final IUser getUser() { return user; }
	public final void setUser(IUser u) { user = u; }
	
	public final FrameWebQuery getQuery(Connection conn,String id,int [] cnt) throws ManagerException,SQLException {
		String name = getClass().getName();
		int ind = name.lastIndexOf(".");
		name = name.substring(0,ind).replace('.','/');
		Document qry = ManagerReader.readQueryModule(getClass().getClassLoader(),name);
		Node n = XMLUtil.selectSingleNode(qry,ManagerTags.QUERY,ManagerTags.QUERY_NAME,id);
		if (n==null) throw new ManagerException("GeneralManager","La Consulta de BBDD ["+id+"] no existe en el fichero de querys.");
		Node nsql = XMLUtil.selectSingleNode(n,ManagerTags.SQL);
		return new FrameWebQuery(conn,nsql.getFirstChild().getNodeValue(),cnt);
	}

	public final FrameWebQuery getQuery(Connection conn,String id) throws ManagerException,SQLException {
		String name = getClass().getName();
		int ind = name.lastIndexOf(".");
		name = name.substring(0,ind).replace('.','/');
		Document qry = ManagerReader.readQueryModule(getClass().getClassLoader(),name);
		Node n = XMLUtil.selectSingleNode(qry,ManagerTags.QUERY,ManagerTags.QUERY_NAME,id);
		if (n==null) throw new ManagerException("GeneralManager","La Consulta de BBDD ["+id+"] no existe en el fichero de querys.");
		Node nsql = XMLUtil.selectSingleNode(n,ManagerTags.SQL);
		return new FrameWebQuery(conn,nsql.getFirstChild().getNodeValue(),null);
	}
	
}
