package framewebsample.user;

import java.io.IOException;
import java.sql.Connection;
import org.hibernate.Session;

import atica.frameweb.user.User;
import atica.frameweb.user.Role;

public class FrameWebUser extends User {

	public static String ADMIN_CODE = "01";
	public static String GEST_CODE = "02";
	public static String USER_CODE = "00";
	
	public String name = "";
	
	// Constructores de cada uno se pasa al correspondiente
	// crearUsuario, cargarPerfilesRol y crearDatosMenu
	public FrameWebUser() { super(); }
	public FrameWebUser(Session s,String l,String p) { super(s,l,p); }
	public FrameWebUser(Connection c,String l,String p) { super(c,l,p); }
	public FrameWebUser(String l,String p) { super(l,p); setName("Usuario de Ejemplo ("+l.toLowerCase()+")"); }
	
	// El objeto Usuario debe ser serializable !!!
	private void writeObject(java.io.ObjectOutputStream out) throws IOException {
		super.overwriteObject(out);
		out.writeObject(name);
	}
	
	private void readObject(java.io.ObjectInputStream in) throws IOException, ClassNotFoundException {
		super.overreadObject(in);
		name = (String) in.readObject();
	}

	// Mtodos aadidos para gestionar el nombre
	public String getName() { return name; }
	public void setName(String n) { name = n; }
	
	// Con uno de estos mtodos creo el usuario
	public void crearUsuario(Session s) { super.crearUsuario(s); }
	public void crearUsuario(Connection c) { super.crearUsuario(c); }
	public void crearUsuario() {
		// Sirve para aadir roles al usuario.
		if (login.toLowerCase().equals("administrador")) { this.addStaticRole(ADMIN_CODE); }
		if (login.toLowerCase().equals("gestor")) {	this.addStaticRole(GEST_CODE); }
		this.addStaticRole(USER_CODE);
	}
	
	// Con estos incluyo los perfiles en el rol
	public void cargarPerfilesRol(Role r,Session s) { super.cargarPerfilesRol(r,s); }
	public void cargarPerfilesRol(Role r,Connection c) { super.cargarPerfilesRol(r,c); }
	public void cargarPerfilesRol(Role r) {
		if (r.getCode().equals(ADMIN_CODE)) { this.addProfileToRol(r,"ADM","Perfil Administrador");	}
		if (r.getCode().equals(GEST_CODE)) { this.addProfileToRol(r,"GST","Perfil Gestores"); }
		if (r.getCode().equals(USER_CODE)) {
			this.addProfileToRol(r,"ADM","Perfil Administrador");
			this.addProfileToRol(r,"GST","Perfil Gestores");
		}
	}
	
	// Con esto creo el menu
	public void crearDatosMenu(Session s) { super.crearDatosMenu(s); }
	public void crearDatosMenu(Connection c) { super.crearDatosMenu(c); }
	public void crearDatosMenu() { super.crearDatosMenu(); }
	
}
