<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:param name="servlet"/>
<xsl:param name="maximo" select="3000"/>

<xsl:key name="groupBy" match="OPER" use="substring-before(@NAME,'.')" />

<xsl:template match="XMLROOT/DATA/ESTADISTICAS">
<HTML>
  <HEAD>
    <META HTTP-EQUIV="expires" CONTENT="01 01 1900 GMT"/>
    <META HTTP-EQUIV="Pragma" CONTENT="NO-CACHE"/>
    <TITLE>Estadistica de Operaciones</TITLE>
	<STYLE TYPE="text/css">
		.rojo { background:white; color:red; font-face: Verdana; font-weight: bold; font-size:12pt; }
		.negrita { background:white; color:black; font-face: Verdana; font-weight: bold; font-size:12pt; }
		.normal { background:white; color:black; font-face: Verdana; font-weight: plain; font-size:12pt; }
		.cabecera { background:#DDDDDD; color:darkblue; font-face: Verdana; font-weight: bold; font-size:14pt; }
		.subcabecera { background:#EEEEEE; color:darkblue; font-face: Verdana; font-weight: bold; font-size:12pt; }
	</STYLE>
  </HEAD>
  <BODY>
  <FORM NAME="bck" ACTION="{$servlet}" METHOD="POST"><INPUT TYPE="hidden" NAME="module" VALUE="atica/frameweb/estadisticas.show.back"/></FORM>
  <FORM NAME="rec" ACTION="{$servlet}" METHOD="POST"><INPUT TYPE="hidden" NAME="module" VALUE="atica/frameweb/estadisticas.show"/></FORM>
  <A HREF="javascript:document.bck.submit();">Volver</A>&#160;&#160;
  <A HREF="javascript:document.rec.submit();">Recargar</A>&#160;&#160;
  <TABLE border="0" width="100%">
  <TR bgcolor="#AAAAAA" align="center"><TD><B>MDULOS SOLICITADOS</B></TD></TR>
  <xsl:for-each select="ESTADISTICA/value[not(starts-with(@MODULO,'atica'))]">
  <TR>
  <xsl:choose>
  	<xsl:when test="position() mod 2 = 0">
    	<xsl:attribute name="BGCOLOR">#CCCCCC</xsl:attribute>
    </xsl:when>
    <xsl:otherwise>
    	<xsl:attribute name="BGCOLOR">#EEEEEE</xsl:attribute>
    </xsl:otherwise>
  </xsl:choose>
  <TD align="left">
  <B>MDULO:&#160;<I><xsl:value-of select="@MODULO"/></I></B>
  </TD>
  </TR>
  <TR>
  <TD>
  	<TABLE border="0" width="100%">
  	<TR>
		<TD><B>Operacin</B></TD>
		<TD><B>Tipo</B></TD>
		<TD><B>Peticiones</B></TD>
		<TD><B>Mximo</B></TD>
		<TD><B>Mnimo</B></TD>
		<TD><B>Medio</B></TD>
  	</TR>
  	<xsl:for-each select="./*[generate-id() = generate-id(key('groupBy',substring-before(@NAME,'.'))[1])]">
	<xsl:variable name="miNombre" select="substring-before(@NAME,'.')"/>
  	<TR><TD COLSPAN="6" CLASS="cabecera">[<xsl:value-of select="$miNombre"/>]</TD></TR>
  	<TR CLASS="negrita">
	<TD>&#160;</TD>
	<TD>[DBTotal]</TD>
  	<TD><xsl:value-of select="../OPER[(substring-before(@NAME,'.')=$miNombre) and contains(@NAME,'[DB]')]/@NUMLLAMADAS"/></TD>
  	<TD><xsl:value-of select="sum(../OPER[(substring-before(@NAME,'.')=$miNombre) and contains(@NAME,'[DB]')]/@TIEMPOMAXIMO)"/>ms.</TD>
  	<TD><xsl:value-of select="sum(../OPER[(substring-before(@NAME,'.')=$miNombre) and contains(@NAME,'[DB]')]/@TIEMPOMINIMO)"/>ms.</TD>
  	<TD><xsl:value-of select="sum(../OPER[(substring-before(@NAME,'.')=$miNombre) and contains(@NAME,'[DB]')]/@TIEMPOMEDIO)"/>ms.</TD>
  	</TR>
	<xsl:for-each select="../OPER[substring-before(@NAME,'.')=$miNombre and contains(@NAME,'[DB]')]">
	<xsl:sort select="@NAME"/>
		<xsl:apply-templates select=".">
			<xsl:with-param name="ident" select="'&#160;&#160;&#160;&#160;'"/>
		</xsl:apply-templates>
	</xsl:for-each>
	<xsl:for-each select="../OPER[substring-before(@NAME,'.')=$miNombre and not(contains(@NAME,'[DB]')) and not(contains(substring-after(@NAME,'.'),'.'))]">
	<xsl:sort select="@NAME"/>
		<xsl:apply-templates select="."/>
	</xsl:for-each>
	<xsl:if test="count(../OPER[substring-before(@NAME,'.')=$miNombre and not(contains(@NAME,'[DB]')) and contains(substring-after(@NAME,'.'),'.')])>0">
	<TR><TD COLSPAN="6" CLASS="subcabecera">&#160;&#160;&#160;[<xsl:value-of select="$miNombre"/>.next]</TD></TR>
	<xsl:for-each select="../OPER[substring-before(@NAME,'.')=$miNombre and not(contains(@NAME,'[DB]')) and contains(substring-after(@NAME,'.'),'.')]">
	<xsl:sort select="@NAME"/>
		<xsl:apply-templates select="."/>
	</xsl:for-each>
	</xsl:if>
  	</xsl:for-each>
	<TR><TD COLSPAN="6" align="right"><hr width="100%"/></TD></TR>
	<xsl:call-template name="totales">
		<xsl:with-param name="tipo" select="'[DB]'"/>
	</xsl:call-template>
	<xsl:call-template name="totales">
		<xsl:with-param name="tipo" select="'[OUT]'"/>
	</xsl:call-template>
	<xsl:call-template name="totales">
		<xsl:with-param name="tipo" select="'[Total]'"/>
	</xsl:call-template>
	<TR><TD COLSPAN="6" align="right"><hr width="100%"/></TD></TR>
	<TR><TD COLSPAN="6" align="right">&#160;</TD></TR>
  	</TABLE>
	</TD>
  </TR>
  </xsl:for-each>
  <TR bgcolor="#AAAAAA"><TD>&#160;</TD></TR>
  </TABLE>
</BODY>
</HTML>
</xsl:template>

<xsl:template match="OPER">
<xsl:param name="ident"/>
	<xsl:variable name="estilo"><xsl:choose><xsl:when test="(number(@TIEMPOMAXIMO)>=$maximo) or (number(@TIEMPOMEDIO)>=$maximo)">rojo</xsl:when><xsl:when test="contains(@NAME,'[DB]')">normal</xsl:when><xsl:otherwise>negrita</xsl:otherwise></xsl:choose></xsl:variable>
  	<TR CLASS="{$estilo}">
	<TD>&#160;</TD>
	<TD><xsl:value-of select="$ident"/><xsl:value-of select="substring-after(@NAME,'.')"/></TD>
  	<TD><xsl:value-of select="@NUMLLAMADAS"/></TD>
  	<TD><xsl:value-of select="@TIEMPOMAXIMO"/>ms.</TD>
  	<TD><xsl:value-of select="@TIEMPOMINIMO"/>ms.</TD>
  	<TD><xsl:value-of select="@TIEMPOMEDIO"/>ms.</TD>
  	</TR>
</xsl:template>


<xsl:template name="totales">
<xsl:param name="tipo"/>
	<xsl:variable name="estilo"><xsl:choose><xsl:when test="(round(sum(OPER[contains(@NAME,$tipo)]/@TIEMPOMAXIMO) div count(OPER[contains(@NAME,$tipo)]))>=$maximo) or (round(sum(OPER[contains(@NAME,$tipo)]/@TIEMPOMEDIO) div count(OPER[contains(@NAME,$tipo)]))>=$maximo)">rojo</xsl:when><xsl:otherwise>negrita</xsl:otherwise></xsl:choose></xsl:variable>
  	<TR CLASS="{$estilo}">
	<TD>TOTALES <xsl:value-of select="$tipo"/></TD>
	<TD>&#160;</TD>
  	<TD><xsl:value-of select="sum(OPER[contains(@NAME,$tipo)]/@NUMLLAMADAS)"/></TD>
  	<TD><xsl:value-of select="round(sum(OPER[contains(@NAME,$tipo)]/@TIEMPOMAXIMO) div count(OPER[contains(@NAME,$tipo)]))"/>ms.</TD>
  	<TD><xsl:value-of select="round(sum(OPER[contains(@NAME,$tipo)]/@TIEMPOMINIMO) div count(OPER[contains(@NAME,$tipo)]))"/>ms.</TD>
  	<TD><xsl:value-of select="round(sum(OPER[contains(@NAME,$tipo)]/@TIEMPOMEDIO) div count(OPER[contains(@NAME,$tipo)]))"/>ms.</TD>
  	</TR>
</xsl:template>

</xsl:stylesheet>
	