<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

<xsl:param name="module"/>
<xsl:param name="action"/>
<xsl:param name="servlet"/>

<xsl:template name="PIE-LISTA">
<xsl:param name="SIZE"/>
<xsl:param name="DATOS"/>
<xsl:param name="function"/>
<xsl:param name="altfunction"/>
<xsl:param name="DATA"/>

<xsl:variable name="mensajePage">
	<xsl:choose>
		<xsl:when test="count(/XMLROOT/DICTIONARY/KEY[@NAME='Page'])>0">
			<xsl:value-of select="/XMLROOT/DICTIONARY/KEY[@NAME='Page']/@VALUE"/>
		</xsl:when>
		<xsl:otherwise>
			Pgina
		</xsl:otherwise>
	</xsl:choose>
</xsl:variable>

<xsl:variable name="mensaje">
	<xsl:choose>
		<xsl:when test="count(/XMLROOT/DICTIONARY/KEY[@NAME='GoToPage'])>0">
			<xsl:value-of select="/XMLROOT/DICTIONARY/KEY[@NAME='GoToPage']/@VALUE"/>
		</xsl:when>
		<xsl:otherwise>
			Ir a Pgina
		</xsl:otherwise>
	</xsl:choose>
</xsl:variable>
<xsl:if test="string-length($function)=0">
	<FORM NAME="paginableFormList" ACTION="{$servlet}" METHOD="POST">
	<INPUT TYPE="hidden" NAME="module" VALUE="{$module}"/>
	<INPUT TYPE="hidden" NAME="action" VALUE="{$action}"/>
	<INPUT TYPE="hidden" NAME="page" VALUE=""/>
	<xsl:if test="$SIZE!=''">
		<INPUT TYPE="hidden" NAME="pagesize" VALUE="{$SIZE}"/>
	</xsl:if>
	<xsl:if test="string-length($DATA)!=''">
		<xsl:copy-of select="$DATA"/>
	</xsl:if>
	</FORM>
</xsl:if>
	<div class="PiePaginable">
	<table>
	<tr><td><xsl:value-of select="normalize-space($mensajePage)"/>:
	<xsl:for-each select="$DATOS/PAGELIST">
		<xsl:choose>
			<xsl:when test=".=../PAGE">
				<xsl:value-of select="."/>&#160;
			</xsl:when>
			<xsl:otherwise>
				<xsl:choose>
				<xsl:when test="string-length($function)>0">
				<A OnMouseOver="window.status='{normalize-space($mensaje)} {.}';return true;" HREF="javascript:{$function}('{.}');"><xsl:value-of select="."/></A>&#160;
				</xsl:when>
				<xsl:when test="string-length($altfunction)>0">
				<A OnMouseOver="window.status='{normalize-space($mensaje)} {.}';return true;" HREF="javascript:{$altfunction}('{.}');document.paginableFormList.page.value='{.}';document.paginableFormList.submit();"><xsl:value-of select="."/></A>&#160;
				</xsl:when>
				<xsl:otherwise>
				<A OnMouseOver="window.status='{normalize-space($mensaje)} {.}';return true;" HREF="javascript:document.paginableFormList.page.value='{.}';document.paginableFormList.submit();"><xsl:value-of select="."/></A>&#160;
				</xsl:otherwise>
				</xsl:choose>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:for-each>
	</td>
	</tr>
	</table>
	</div>
</xsl:template>

<xsl:template name="PIE-SGTE">
<xsl:param name="SIZE"/>
<xsl:param name="DATOS"/>
<xsl:param name="IMAGE-NEXT"/>
<xsl:param name="IMAGE-PREVIOUS"/>
<xsl:param name="function"/>
<xsl:param name="altfunction"/>

<xsl:variable name="mensajePage">
	<xsl:choose>
		<xsl:when test="count(/XMLROOT/DICTIONARY/KEY[@NAME='Page'])>0">
			<xsl:value-of select="/XMLROOT/DICTIONARY/KEY[@NAME='Page']/@VALUE"/>
		</xsl:when>
		<xsl:otherwise>
			Pgina
		</xsl:otherwise>
	</xsl:choose>
</xsl:variable>
	
<xsl:variable name="mensajePrev">
	<xsl:choose>
		<xsl:when test="count(/XMLROOT/DICTIONARY/KEY[@NAME='GoToPreviousPage'])>0">
			<xsl:value-of select="/XMLROOT/DICTIONARY/KEY[@NAME='GoToPreviousPage']/@VALUE"/>
		</xsl:when>
		<xsl:otherwise>
			Pgina Anterior
		</xsl:otherwise>
	</xsl:choose>
</xsl:variable>

<xsl:variable name="mensajeNext">
	<xsl:choose>
		<xsl:when test="count(/XMLROOT/DICTIONARY/KEY[@NAME='GoToNextPage'])>0">
			<xsl:value-of select="/XMLROOT/DICTIONARY/KEY[@NAME='GoToNextPage']/@VALUE"/>
		</xsl:when>
		<xsl:otherwise>
			Pgina Siguiente
		</xsl:otherwise>
	</xsl:choose>
</xsl:variable>
<xsl:if test="string-length($function)=0">
	<FORM NAME="paginableFormSgte" ACTION="{$servlet}" METHOD="POST">
	<INPUT TYPE="hidden" NAME="module" VALUE="{$module}"/>
	<INPUT TYPE="hidden" NAME="action" VALUE="{$action}"/>
	<INPUT TYPE="hidden" NAME="page" VALUE=""/>
	<xsl:if test="$SIZE!=''">
		<INPUT TYPE="hidden" NAME="pagesize" VALUE="{$SIZE}"/>
	</xsl:if>
	</FORM>
</xsl:if>
	<div class="PiePaginable">
	<table>
	<tr>
	<xsl:if test="number($DATOS/PAGE/.)>1">
		<xsl:choose>
		<xsl:when test="string-length($function)>0">
		<td><A OnMouseOver="window.status='{normalize-space($mensajePrev)}';return true;" HREF="javascript:{$function}('{number($DATOS/PAGE/.)-1}');">
			<xsl:choose>
			<xsl:when test="$IMAGE-PREVIOUS=''"><xsl:value-of select="normalize-space($mensajePrev)"/></xsl:when>
			<xsl:otherwise><img border="0" src="{$IMAGE-PREVIOUS}" title="{normalize-space($mensajePrev)}"/></xsl:otherwise>
			</xsl:choose>
		</A></td>
		</xsl:when>
		<xsl:when test="string-length($function)>0">
		<td><A OnMouseOver="window.status='{normalize-space($mensajePrev)}';return true;" HREF="javascript:{$altfunction}('{number($DATOS/PAGE/.)-1}');document.paginableFormSgte.page.value='{number($DATOS/PAGE/.)-1}';document.paginableFormSgte.submit();">
			<xsl:choose>
			<xsl:when test="$IMAGE-PREVIOUS=''"><xsl:value-of select="normalize-space($mensajePrev)"/></xsl:when>
			<xsl:otherwise><img border="0" src="{$IMAGE-PREVIOUS}" title="{normalize-space($mensajePrev)}"/></xsl:otherwise>
			</xsl:choose>
		</A></td>
		</xsl:when>
		<xsl:otherwise>
		<td><A OnMouseOver="window.status='{normalize-space($mensajePrev)}';return true;" HREF="javascript:document.paginableFormSgte.page.value='{number($DATOS/PAGE/.)-1}';document.paginableFormSgte.submit();">
			<xsl:choose>
			<xsl:when test="$IMAGE-PREVIOUS=''"><xsl:value-of select="normalize-space($mensajePrev)"/></xsl:when>
			<xsl:otherwise><img border="0" src="{$IMAGE-PREVIOUS}" title="{normalize-space($mensajePrev)}"/></xsl:otherwise>
			</xsl:choose>
		</A></td>
		</xsl:otherwise>
		</xsl:choose>
	</xsl:if>
	<td><xsl:value-of select="normalize-space($mensajePage)"/>: <xsl:value-of select="$DATOS/PAGE"/>/<xsl:value-of select="count($DATOS/PAGELIST)"/></td>
	<xsl:if test="number($DATOS/PAGE/.)&lt;count($DATOS/PAGELIST)">
		<xsl:choose>
		<xsl:when test="string-length($function)>0">
		<td><A OnMouseOver="window.status='{normalize-space($mensajeNext)}';return true;" HREF="javascript:{$function}('{number($DATOS/PAGE/.)+1}');">
			<xsl:choose>
			<xsl:when test="$IMAGE-NEXT=''"><xsl:value-of select="normalize-space($mensajeNext)"/></xsl:when>
			<xsl:otherwise><img border="0" src="{$IMAGE-NEXT}" title="{normalize-space($mensajeNext)}"/></xsl:otherwise>
			</xsl:choose>
		</A></td>
		</xsl:when>
		<xsl:when test="string-length($altfunction)>0">
		<td><A OnMouseOver="window.status='{normalize-space($mensajeNext)}';return true;" HREF="javascript:{$function}('{number($DATOS/PAGE/.)+1}');document.paginableFormSgte.page.value='{number($DATOS/PAGE/.)+1}';document.paginableFormSgte.submit();">
			<xsl:choose>
			<xsl:when test="$IMAGE-NEXT=''"><xsl:value-of select="normalize-space($mensajeNext)"/></xsl:when>
			<xsl:otherwise><img border="0" src="{$IMAGE-NEXT}" title="{normalize-space($mensajeNext)}"/></xsl:otherwise>
			</xsl:choose>
		</A></td>
		</xsl:when>
		<xsl:otherwise>
		<td><A OnMouseOver="window.status='{normalize-space($mensajeNext)}';return true;" HREF="javascript:document.paginableFormSgte.page.value='{number($DATOS/PAGE/.)+1}';document.paginableFormSgte.submit();">
			<xsl:choose>
			<xsl:when test="$IMAGE-NEXT=''"><xsl:value-of select="normalize-space($mensajeNext)"/></xsl:when>
			<xsl:otherwise><img border="0" src="{$IMAGE-NEXT}" title="{normalize-space($mensajeNext)}"/></xsl:otherwise>
			</xsl:choose>
		</A></td>
		</xsl:otherwise>
		</xsl:choose>
	</xsl:if>
	</tr>
	</table>
	</div>
</xsl:template>

<xsl:template name="PIE-LISTA-SIMPLE">
<xsl:param name="SIZE"/>
<xsl:param name="DATOS"/>
<xsl:param name="function"/>
<xsl:param name="altfunction"/>

<xsl:variable name="mensajePage">
	<xsl:choose>
		<xsl:when test="count(/XMLROOT/DICTIONARY/KEY[@NAME='Page'])>0">
			<xsl:value-of select="/XMLROOT/DICTIONARY/KEY[@NAME='Page']/@VALUE"/>
		</xsl:when>
		<xsl:otherwise>
			Pgina
		</xsl:otherwise>
	</xsl:choose>
</xsl:variable>

<xsl:variable name="mensaje">
	<xsl:choose>
		<xsl:when test="count(/XMLROOT/DICTIONARY/KEY[@NAME='GoToPage'])>0">
			<xsl:value-of select="/XMLROOT/DICTIONARY/KEY[@NAME='GoToPage']/@VALUE"/>
		</xsl:when>
		<xsl:otherwise>
			Ir a Pgina
		</xsl:otherwise>
	</xsl:choose>
</xsl:variable>
<xsl:if test="string-length($function)=0">
	<FORM NAME="paginableFormList" ACTION="{$servlet}" METHOD="POST">
	<INPUT TYPE="hidden" NAME="module" VALUE="{$module}"/>
	<INPUT TYPE="hidden" NAME="action" VALUE="{$action}"/>
	<INPUT TYPE="hidden" NAME="page" VALUE=""/>
	<xsl:if test="$SIZE!=''">
		<INPUT TYPE="hidden" NAME="pagesize" VALUE="{$SIZE}"/>
	</xsl:if>
	</FORM>
</xsl:if>
	<xsl:value-of select="normalize-space($mensajePage)"/>:
	<xsl:for-each select="$DATOS/PAGELIST">
		<xsl:choose>
			<xsl:when test=".=../PAGE">
				<xsl:value-of select="."/>&#160;
			</xsl:when>
			<xsl:otherwise>
				<xsl:choose>
				<xsl:when test="string-length($function)>0">
				<A OnMouseOver="window.status='{normalize-space($mensaje)} {.}';return true;" HREF="javascript:{$function}('{.}');"><xsl:value-of select="."/></A>&#160;
				</xsl:when>
				<xsl:when test="string-length($altfunction)>0">
				<A OnMouseOver="window.status='{normalize-space($mensaje)} {.}';return true;" HREF="javascript:{$function}('{.}');document.paginableFormList.page.value='{.}';document.paginableFormList.submit();"><xsl:value-of select="."/></A>&#160;
				</xsl:when>
				<xsl:otherwise>
				<A OnMouseOver="window.status='{normalize-space($mensaje)} {.}';return true;" HREF="javascript:document.paginableFormList.page.value='{.}';document.paginableFormList.submit();"><xsl:value-of select="."/></A>&#160;
				</xsl:otherwise>
				</xsl:choose>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:for-each>
</xsl:template>

</xsl:stylesheet>
