<?xml version="1.0" encoding="utf-8" ?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:xforms="http://www.w3.org/2002/xforms" xmlns:docbook="http://www.docbook.org/xml/4.4CR1/" xmlns:ev="http://www.w3.org/2001/xml-events" xmlns="http://www.w3.org/1999/xhtml" exclude-result-prefixes="xforms xsd ev docbook xsl">
<!-- strict xhtml1.1 not supported in Internet Explorer
<xsl:output method="xml" version="1.0" encoding="utf-8" indent="yes" omit-xml-declaration="yes" doctype-system="http://www.w3.org/TR/xhtml1/DTD/xhtml11.dtd" doctype-public="-//W3//DTD XHTML 1.1 Strict//EN" />
-->
<xsl:output method="html" version="1.0" encoding="iso-8859-1" indent="yes" omit-xml-declaration="yes" doctype-system="http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd" doctype-public="-//W3//DTD XHTML 1.0 Strict//EN" />
<xsl:include href="atica/frameweb/xml/templates/xform.xsl" />
<xsl:strip-space elements="*" />

<!-- main template -->
<xsl:template match="HTML">
<html>
<head>
<title>XForms Demo</title>
<link type="text/css" rel="StyleSheet" href="/xforms/css/styles.css" />
<link type="text/css" rel="StyleSheet" href="/xforms/css/xforms.css" />
<script type="text/javascript" src="/xforms/js/xform.js"></script>
<script type="text/javascript">
function onLoadHandler() {
	<xsl:call-template name="xforms" />
}

window.addEventListener('load',onLoadHandler,false);
</script>
</head>
<body>
<div id="main">
	<xsl:apply-templates />
</div>
</body>
</html>
</xsl:template>

<xsl:template match="*">
	<xsl:choose>
	<xsl:when test="(substring-after(name(.),'xforms:')='')">
	  <xsl:copy>
		<xsl:copy-of select="@*"/>
		<xsl:apply-templates/>
	  </xsl:copy>
	</xsl:when>
	<xsl:when test="(name(.)='xforms:xforms')">
		<xsl:apply-templates select="xforms:model"/>
	</xsl:when>
	</xsl:choose>
</xsl:template>

</xsl:stylesheet> 
